/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/

// DAKOTA COUNTRY:
// CREATED BY DANY:
// OCTOBER 2007:

/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDON MAP SCRIPT: ************************************ //
/*================================================================================================================*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ************************************ CHOOSE THE NATIVE TRIBES FOR THE MAP: *********************************** //
/*================================================================================================================*/
        
		int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/		
   
        int nativeMix=rmRandInt(0,1);
   
/*----------------------------------------------------------------------------------------------------------------*/   
   
            if (rmAllocateSubCivs(4) == true)
{
	
		    if (nativeMix <= 0.5)
	{
   
			// COMANCHE OUTSIDE, LAKOTA INSIDE:
			subCiv0=rmGetCivID("Comanche");
			if (subCiv0 >= 0)
			rmSetSubCiv(0, "Comanche");

			//subCiv3=rmGetCivID("Comanche");
			//if (subCiv3 >= 0)
			//rmSetSubCiv(3, "Comanche");

			subCiv1=rmGetCivID("Lakota");
			if (subCiv1 >= 0)
			rmSetSubCiv(1, "Lakota");

			subCiv2=rmGetCivID("Lakota");
			if (subCiv2 >= 0)
			rmSetSubCiv(2, "Lakota");
			
			subCiv3=rmGetCivID("Comanche");
			if (subCiv3 >= 0)
			rmSetSubCiv(3, "Comanche");
	}
		    else
	{
			// LAKOTA OUTSIDE, COMANCHE INSIDE:
			subCiv0=rmGetCivID("Lakota");
			if (subCiv0 >= 0)
			rmSetSubCiv(0, "Lakota");

			//subCiv3=rmGetCivID("Lakota");
			//if (subCiv3 >= 0)
			//rmSetSubCiv(3, "Lakota");

			subCiv1=rmGetCivID("Comanche");
			if (subCiv1 >= 0)
			rmSetSubCiv(1, "Comanche");

			subCiv2=rmGetCivID("Comanche");
			if (subCiv2 >= 0)
			rmSetSubCiv(2, "Comanche");
			
			subCiv3=rmGetCivID("Lakota");
			if (subCiv3 >= 0)
			rmSetSubCiv(3, "Lakota");

	}

}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/

	    int playerTiles = 22500;
	    
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(600, 600);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** PICKS THE MAP PARAMETERS: ******************************************* //
/*================================================================================================================*/

	    // SET MAP ELEVATION PARAMETERS:
		// rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	    rmSetMapElevationParameters(cElevTurbulence, 0.02, 5, 0.7, 8.0);
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(4.0);

        // PICKS DEFAULT TERRAIN AND WATER:
	    rmSetSeaType("Amazon River");


	    // SET BASE TERRAIN MIX:
		float terrainPicker = rmRandFloat(0.0, 1.0);
	    if (terrainPicker <= 0.5)
    {
		rmSetBaseTerrainMix("texas_dirt");
	}
	    else
	{
	    rmSetBaseTerrainMix("texas_dirt");
		//rmSetBaseTerrainMix("texas_grass");
	}

	    // TERRAIN INITIALIZATION:
		rmTerrainInitialize("texas\ground1_tex", 5.0);
			    
		// SET MAP TYPE:
		rmSetMapType("Texas");
	    rmSetMapType("desert");
	    rmSetMapType("land");
	    
		// SET LIGHTING: 
		rmSetLightingSet("Texas");

	    // CHOOSE MERCS:
	    chooseMercs();

	    // CORNERC CONSTRAINT:
	    rmSetWorldCircleConstraint(true);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("classHill");
	    rmDefineClass("classPatch");
	    rmDefineClass("starting settlement");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("natives");
	    rmDefineClass("classCliff");
	    rmDefineClass("secrets");
	    rmDefineClass("classNugget");
	    rmDefineClass("center");
		rmDefineClass("tribe");
	    int canyon=rmDefineClass("canyon");
		rmDefineClass("classTrees");
	
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ******************************************* DEFINE THE CONSTRAINTS: ****************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHERS: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	// MAP EDGE CONSTRAINTS:
    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
        	
	// VULTURES AVOIDANCE: 
	int avoidVultures=rmCreateTypeDistanceConstraint("stuff avoids Vultures", "PropVulturePerching", 15.0);
	int avoidCloseVultures=rmCreateTypeDistanceConstraint("close avoids Vultures", "PropVulturePerching", 8.0);
	int avoidVeryCloseVultures=rmCreateTypeDistanceConstraint("very close avoids Vultures", "PropVulturePerching", 3.0);
	int avoidMediumVultures=rmCreateTypeDistanceConstraint("medium avoids Vultures", "PropVulturePerching", 25.0);
	int avoidFarVultures=rmCreateTypeDistanceConstraint("far avoids Vultures", "PropVulturePerching", 50.0);
	int avoidVeryFarVultures=rmCreateTypeDistanceConstraint("very far avoids Vultures", "PropVulturePerching", 75.0);
	int avoidSuperFarVultures=rmCreateTypeDistanceConstraint("super far avoids Vultures", "PropVulturePerching", 100.0);
		
	// CANYONS AVOIDANCE:
	int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 15.0);
	int avoidCloseCanyons=rmCreateClassDistanceConstraint("close avoid canyons", rmClassID("canyon"), 8.0);
	int avoidMediumCanyons=rmCreateClassDistanceConstraint("medium avoid canyons", rmClassID("canyon"), 25.0);
	
	int shortAvoidCanyons=rmCreateClassDistanceConstraint("short avoid canyons", rmClassID("canyon"), 15.0);
	int canyonConstraint=rmCreateClassDistanceConstraint("canyons start away from each other", canyon, 5.0);
	
	// CARDINAL DIRECTIONS:
	int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
 	
	// FISHES AVOIDANCE:
	int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
    int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
    	
	// NATIVES AVOIDANCE:
	int avoidNatives=rmCreateClassDistanceConstraint("stuff avoid natives", rmClassID("natives"), 15.0);
	int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoid natives", rmClassID("natives"), 8.0);
	
	// TRIBE AVOIDANCE:
	int avoidTribe=rmCreateClassDistanceConstraint("stuff avoid tribe", rmClassID("tribe"), 15.0);
	int avoidCloseTribe=rmCreateClassDistanceConstraint("close avoid tribe", rmClassID("tribe"), 8.0);
	int avoidMediumTribe=rmCreateClassDistanceConstraint("medium avoid tribe", rmClassID("tribe"), 25.0);
	
	// BERRYBUSH AVOIDANCE:
	int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids berrybush", "BerryBush", 25.0);
	int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids berrybush", "BerryBush", 15.0);
	int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoids berrybush", "BerryBush", 8.0);
	int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoids berrybush", "BerryBush", 35.0);
	int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoids berrybush", "BerryBush", 60.0);
	int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoids berrybush", "BerryBush", 90.0);
	
	// TREES AVOIDANCE:
	int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 15.0);
	int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 8.0);
	int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 3.0);
	int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
	int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
	int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);
		
	// COW AVOIDANCE:
	int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 15.0);
	int avoidCloseCow=rmCreateTypeDistanceConstraint("close avoids cow", "cow", 8.0);
	int avoidVeryCloseCow=rmCreateTypeDistanceConstraint("very close avoids cow", "cow", 3.0);
	int avoidMediumCow=rmCreateTypeDistanceConstraint("medium avoids cow", "cow", 30.0);
	int avoidFarCow=rmCreateTypeDistanceConstraint("far avoids cow", "cow", 60.0);
	int avoidVeryFarCow=rmCreateTypeDistanceConstraint("very far avoids cow", "cow", 90.0);
	int avoidSuperFarCow=rmCreateTypeDistanceConstraint("super far avoids cow", "cow", 120.0);
		
	// SILVER AVOIDANCE:
	int avoidSilver=rmCreateTypeDistanceConstraint("stuff avoid gold", "Mine", 15.0);
	int avoidCloseSilver=rmCreateTypeDistanceConstraint("close avoid gold", "Mine", 8.0);
    int avoidVeryCloseSilver=rmCreateTypeDistanceConstraint("very close avoid gold", "Mine", 3.0);
    int avoidMediumSilver=rmCreateTypeDistanceConstraint("medium avoid gold", "Mine", 25.0);
    int avoidFarSilver=rmCreateTypeDistanceConstraint("far avoid gold", "Mine", 50.0);
	int avoidVeryFarSilver=rmCreateTypeDistanceConstraint("very far avoid gold", "Mine", 75.0);
    int avoidSuperFarSilver=rmCreateTypeDistanceConstraint("super far avoid gold", "Mine", 100.0);

	int shortAvoidSilver=rmCreateTypeDistanceConstraint("short gold avoid gold", "Mine", 20.0);
	
	// IMPASSABLE LAND AVOIDANCE:
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
	int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 4.0);
	
	// CENTER AVOIDANCE:
	int centerConstraintFar=rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), rmXFractionToMeters(0.23));
	int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), rmXFractionToMeters(0.10));
	
	// FOREST AVOIDANCE:
	int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 15.0);
	int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 8.0);
	int forestVeryCloseConstraint=rmCreateClassDistanceConstraint("very close vs. forest", rmClassID("classForest"), 3.0);
	int forestMediumConstraint=rmCreateClassDistanceConstraint("medium close vs. forest", rmClassID("classForest"), 35.0);
	int forestFarConstraint=rmCreateClassDistanceConstraint("far vs. forest", rmClassID("classForest"), 60.0);
	int forestVeryFarConstraint=rmCreateClassDistanceConstraint("very far vs. forest", rmClassID("classForest"), 80.0);
	int forestSuperFarConstraint=rmCreateClassDistanceConstraint("super far vs. forest", rmClassID("classForest"), 100.0);
	
	int shortForestConstraint=rmCreateClassDistanceConstraint("short forest vs. forest", rmClassID("classForest"), 10.0);
	int mediumForestConstraint=rmCreateClassDistanceConstraint("medium forest vs. forest", rmClassID("classForest"), 25.0);
	
	// IMPORTANT ITEM AVOIDANCE:
	int shortAvoidImportantItem=rmCreateClassDistanceConstraint("short avoid important", rmClassID("importantItem"), 5.0);
    int avoidImportantItem=rmCreateClassDistanceConstraint("stuff avoid important", rmClassID("importantItem"), 15.0);

	// DECORATION AVOIDANCE:
	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

	// RESOURCE AVOIDANCE:
	int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
	
	// BUZZARDS AVOIDANCE:
	int avoidBuzzards=rmCreateTypeDistanceConstraint("buzzard avoid buzzard", "BuzzardFlock", 70.0);
	
	// DEER AVOIDANCE:
	int avoidBison=rmCreateTypeDistanceConstraint("stuff avoids bison", "bison", 15.0);
	int avoidCloseBison=rmCreateTypeDistanceConstraint("close avoids bison", "bison", 8.0);
	int avoidVeryCloseBison=rmCreateTypeDistanceConstraint("very close avoids bison", "bison", 3.0);
	int avoidMediumBison=rmCreateTypeDistanceConstraint("medium avoids bison", "bison", 30.0);
	int avoidFarBison=rmCreateTypeDistanceConstraint("far avoids bison", "bison", 60.0);
	int avoidVeryFarBison=rmCreateTypeDistanceConstraint("very far avoids bison", "bison", 90.0);
	int avoidSuperFarBison=rmCreateTypeDistanceConstraint("super far avoids bison", "bison", 120.0);
	
	// PRONGHORN AVOIDANCE:
	int avoidPronghorn=rmCreateTypeDistanceConstraint("stuff avoids pronghorn", "pronghorn", 15.0);
	int avoidClosePronghorn=rmCreateTypeDistanceConstraint("close avoids pronghorn", "pronghorn", 8.0);
	int avoidVeryClosePronghorn=rmCreateTypeDistanceConstraint("very close avoids pronghorn", "pronghorn", 3.0);
	int avoidMediumPronghorn=rmCreateTypeDistanceConstraint("medium avoids pronghorn", "pronghorn", 30.0);
	int avoidFarPronghorn=rmCreateTypeDistanceConstraint("far avoids pronghorn", "pronghorn", 60.0);
	int avoidVeryFarPronghorn=rmCreateTypeDistanceConstraint("very far avoids pronghorn", "pronghorn", 90.0);
	int avoidSuperFarPronghorn=rmCreateTypeDistanceConstraint("super far avoids pronghorn", "pronghorn", 120.0);
	
	// TRADE ROUTE AVOIDANCE:
	int avoidTradeRoute=rmCreateTradeRouteDistanceConstraint("trade route", 5.0);
	
	// PLAYER AVOIDANCE:
	int longPlayerConstraint=rmCreateClassDistanceConstraint("long stay away from players", classPlayer, 40.0);
	int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 15.0);
	int playerCloseConstraint=rmCreateClassDistanceConstraint("close avoids players", classPlayer, 8.0);
	
	int mediumPlayerConstraint=rmCreateClassDistanceConstraint("medium stay away from players", classPlayer, 20.0);
	int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players short", classPlayer, 8.0);
	
	// NUGGET AVOIDANCE:
	//int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 15.0);
	//int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 8.0);
	//int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 3.0);
	//int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 25.0);
	//int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 50.0);
	//int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 75.0);
	//int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 100.0);
	
	// NUGGET AVOIDANCE:
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 20.0);
    int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 10.0);
    int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium avoid nugget", "AbstractNugget", 40.0);
    int avoidFarNugget=rmCreateTypeDistanceConstraint("far avoid nugget", "AbstractNugget", 80.0);
	int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far avoid nugget", "AbstractNugget", 100.0);
	int avoidSuperFarNugget=rmCreateTypeDistanceConstraint("super far avoid nugget", "AbstractNugget", 120.0);
	
	int shortAvoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget short", rmClassID("classNugget"), 8.0);
	
	// SOCKET AVOIDANCE:
	int avoidTradeRouteSockets=rmCreateTypeDistanceConstraint("avoid Trade Socket", "sockettraderoute", 10);
	
	// STARTING UNITS AVOIDANCE:
	int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 8.0);
	
	// CIRCLE CONSTRAINT:
	int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
	
	// PATCH AVOIDANCE:
	int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
	
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ************************* DEFINE THE TCID AND THE STARTING UNITS AND PLAYER RESOURCES: *********************** //
/*================================================================================================================*/
		
	    // DEFINE THE TCID:
		int TCID = rmCreateObjectDef("player TC");
	    if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(TCID, "townCenter", 1, 0);
	}
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 10.0);
	    rmAddObjectDefConstraint(TCID, avoidTradeRoute);
	    rmAddObjectDefToClass(TCID, rmClassID("player"));
	    rmAddObjectDefToClass(TCID, rmClassID("startingUnit"));

	    // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 8.0);
	    rmSetObjectDefMaxDistance(startingUnits, 12.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidStartingUnits);
		
/*----------------------------------------------------------------------------------------------------------------*/

	    // DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	    rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	    rmSetObjectDefMinDistance(playerSilverID, 20.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 25.0);
	    //rmAddObjectDefConstraint(playerSilverID, avoidAll);
	    rmAddObjectDefToClass(playerSilverID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);
	    rmAddObjectDefConstraint(playerSilverID, avoidStartingUnits);

	    // DEFINE THE STARTING TREE:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeTexasDirt", rmRandInt(9,10), 6.0);
	    // rmAddObjectDefItem(StartAreaTreeID, "UnderbrushDesert", rmRandInt(4,6), 4.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 20);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 35);
	    rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidImpassableLand);
	    //rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	    rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidSilver);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnits);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidResource);
		
		// DEFINE THE STARTING BISON:
		int startBisonID = rmCreateObjectDef("starting bison");
	    rmAddObjectDefItem(startBisonID, "bison", rmRandInt(7,9), 8.0);
	    rmSetObjectDefCreateHerd(startBisonID, true);
	    rmSetObjectDefMinDistance(startBisonID, 16);
	    rmSetObjectDefMaxDistance(startBisonID, 20);
	    rmAddObjectDefToClass(startBisonID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startBisonID, avoidImpassableLand);
	    rmAddObjectDefConstraint(startBisonID, shortAvoidImportantItem);
	    // rmAddObjectDefConstraint(startBisonID, avoidTradeRoute);
	    rmAddObjectDefConstraint(startBisonID, avoidStartingUnits);
	    rmAddObjectDefConstraint(startBisonID, avoidResource);
		
		// DEFINE THE PLAYER BERRYBUSH:
		int playerBerryID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerBerryID, "berrybush", rmRandInt(3,5), 5.0);
		rmAddObjectDefToClass(playerBerryID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerBerryID, 20);
        rmSetObjectDefMaxDistance(playerBerryID, 25);
	    rmAddObjectDefConstraint(playerBerryID, avoidAll);
		rmAddObjectDefConstraint(playerBerryID, avoidMediumFruits);
        rmAddObjectDefConstraint(playerBerryID, avoidStartingUnits);
        rmSetObjectDefCreateHerd(playerBerryID, true);


        // INFORMATIONS:
		// --> TCID, startingUnits, playerSilverID, StartAreaTreeID 
		// AND StartBisonID ALL ADDED TO: rmClassID("startingUnit")
		
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************************** SET UP THE PLAYER LOCATIONS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
		
		// PLAYER PLACEMENT IN LINE:
		
		int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	    int teamOneCount = rmGetNumberPlayersOnTeam(1);
		
		if ( cNumberTeams == 2 && teamZeroCount == teamOneCount )
	{

		rmSetPlacementTeam(0);
		rmSetTeamSpacingModifier(0.50);
		rmPlacePlayersLine(0.15, 0.35, 0.35, 0.15, 0, 0.0);

		rmSetPlacementTeam(1);
		rmSetTeamSpacingModifier(0.50);
		rmPlacePlayersLine(0.85, 0.65, 0.65, 0.85, 0, 0.0);
	
	}
	
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ****************************************** SET UP THE PLAYER AREAS: ****************************************** // 
/*================================================================================================================*/

	    float playerFraction=rmAreaTilesToFraction(2250);   
	    
		for(i=1; <cNumberPlayers)
	{
		// CREATE THE AREA:
		int id=rmCreateArea("Player"+i);
		
		// ASSIGN TO THE PLAYER:
		rmSetPlayerArea(i, id);
		
		// SET THE SIZE:
		rmSetAreaSize(id, playerFraction, playerFraction);
		
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
		
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
		rmSetAreaMaxBlobs(id, 1);
		
		// ADD AREA CONSTRAINT:
		//  rmAddAreaConstraint(id, playerConstraint); 
		//  rmAddAreaConstraint(id, playerEdgeConstraint); 
		
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");

		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA BASE HEIGHT:
		//rmSetAreaBaseHeight(id, 6.0);
		
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
	}
	    // BUILD THE AREAS:
        rmBuildAllAreas();

/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ***************************************** PLACE THE NATIVE TRIBES: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    if (subCiv0 == rmGetCivID("Comanche"))
	{  
		int comancheVillageID = -1;
		int comancheVillageType = rmRandInt(1,5);
		int randomPlacement = rmRandInt(1,10);
		comancheVillageID = rmCreateGrouping("comanche village", "native comanche village "+comancheVillageType);
		rmSetGroupingMinDistance(comancheVillageID, 0.0);
		rmSetGroupingMaxDistance(comancheVillageID, 0.0);
		rmAddGroupingConstraint(comancheVillageID, avoidImpassableLand);
		rmAddGroupingToClass(comancheVillageID, rmClassID("natives"));
		rmAddGroupingToClass(comancheVillageID, rmClassID("importantItem"));
				
		if (randomPlacement <= 2)
		rmPlaceGroupingAtLoc(comancheVillageID, 0, 0.2, 0.8);  
		else
    	rmPlaceGroupingAtLoc(comancheVillageID, 0, 0.2, 0.8);
		
	}
	
	    // CREATE A TRIBE AREA 1:
        int tribeID=rmCreateArea("tribe 1");
        rmSetAreaSize(tribeID, 0.0075, 0.0075);
        rmAddAreaToClass(tribeID, rmClassID("tribe"));
		rmSetAreaCoherence(tribeID, 1.0);
        //rmSetAreaMix(tribeID, "rockies_snow");

        if (randomPlacement <= 2)
		rmSetAreaLocation(tribeID, 0.2, 0.8);
		else
		rmSetAreaLocation(tribeID, 0.2, 0.8);
		
		rmBuildArea(tribeID);

/*----------------------------------------------------------------------------------------------------------------*/	
	
	    if (subCiv0 == rmGetCivID("Lakota"))
	{  
		int lakotaVillageID = -1;
		int lakotaVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		lakotaVillageID = rmCreateGrouping("lakota village", "native lakota village "+lakotaVillageType);
		rmSetGroupingMinDistance(lakotaVillageID, 0.0);
		rmSetGroupingMaxDistance(lakotaVillageID, 0.0);
		rmAddGroupingConstraint(lakotaVillageID, avoidImpassableLand);
		rmAddGroupingToClass(lakotaVillageID, rmClassID("natives"));
		rmAddGroupingToClass(lakotaVillageID, rmClassID("importantItem"));
		
		if (randomPlacement <= 2)
		rmPlaceGroupingAtLoc(lakotaVillageID, 0, 0.2, 0.8);  
		else
		rmPlaceGroupingAtLoc(lakotaVillageID, 0, 0.2, 0.8);
		
	}
	
/*----------------------------------------------------------------------------------------------------------------*/

	    if (subCiv1 == rmGetCivID("Lakota"))
	{
		lakotaVillageID = -1;
		lakotaVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		lakotaVillageID = rmCreateGrouping("lakota village", "native lakota village "+lakotaVillageType);
		rmSetGroupingMinDistance(lakotaVillageID, 0.0);
		rmSetGroupingMaxDistance(lakotaVillageID, 0.0);
		rmAddGroupingConstraint(lakotaVillageID, avoidImpassableLand);
		rmAddGroupingToClass(lakotaVillageID, rmClassID("natives"));
		
		if (randomPlacement <= 2)
			rmPlaceGroupingAtLoc(lakotaVillageID, 0, 0.35, 0.65);
		else
			rmPlaceGroupingAtLoc(lakotaVillageID, 0, 0.35, 0.65);
		
	}
	
	    // CREATE A TRIBE AREA 2:
        int tribe2ID=rmCreateArea("tribe 2");
        rmSetAreaSize(tribe2ID, 0.0075, 0.0075);
        rmAddAreaToClass(tribe2ID, rmClassID("tribe"));
		rmSetAreaCoherence(tribe2ID, 1.0);
        //rmSetAreaMix(tribe2ID, "rockies_snow");

        if (randomPlacement <= 2)
		rmSetAreaLocation(tribe2ID, 0.35, 0.65);
		else
		rmSetAreaLocation(tribe2ID, 0.35, 0.65);
		
		rmBuildArea(tribe2ID);
	
/*---------------------------------------------------------------------------------------------------------------*/

	    if (subCiv1 == rmGetCivID("Comanche"))
	{
		comancheVillageID = -1;
		comancheVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		comancheVillageID = rmCreateGrouping("comanche village", "native comanche village "+comancheVillageType);
		rmSetGroupingMinDistance(comancheVillageID, 0.0);
		rmSetGroupingMaxDistance(comancheVillageID, 0.0);
		rmAddGroupingConstraint(comancheVillageID, avoidImpassableLand);
		rmAddGroupingToClass(comancheVillageID, rmClassID("natives"));
		
		if (randomPlacement <= 2)
			rmPlaceGroupingAtLoc(comancheVillageID, 0, 0.35, 0.65);
		else
			rmPlaceGroupingAtLoc(comancheVillageID, 0, 0.35, 0.65);
		
	}
    
/*---------------------------------------------------------------------------------------------------------------*/

	    if (subCiv2 == rmGetCivID("Lakota"))
	{
		lakotaVillageID = -1;
		lakotaVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		lakotaVillageID = rmCreateGrouping("lakota village2", "native lakota village "+lakotaVillageType);
		rmSetGroupingMinDistance(lakotaVillageID, 0.0);
		rmSetGroupingMaxDistance(lakotaVillageID, 0.0);
		rmAddGroupingConstraint(lakotaVillageID, avoidImpassableLand);
		rmAddGroupingToClass(lakotaVillageID, rmClassID("natives"));
		
		if (randomPlacement <= 2)
			rmPlaceGroupingAtLoc(lakotaVillageID, 0, 0.65, 0.35);
		else
			rmPlaceGroupingAtLoc(lakotaVillageID, 0, 0.65, 0.35);
	}
	
	    // CREATE A TRIBE AREA 3:
        int tribe3ID=rmCreateArea("tribe 3");
        rmSetAreaSize(tribe3ID, 0.0075, 0.0075);
        rmAddAreaToClass(tribe3ID, rmClassID("tribe"));
		rmSetAreaCoherence(tribe3ID, 1.0);
        //rmSetAreaMix(tribe3ID, "rockies_snow");

        if (randomPlacement <= 2)
		rmSetAreaLocation(tribe3ID, 0.65, 0.35);
		else
		rmSetAreaLocation(tribe3ID, 0.65, 0.35);
		
		rmBuildArea(tribe3ID); 
	
/*----------------------------------------------------------------------------------------------------------------*/

	    if (subCiv2 == rmGetCivID("Comanche"))
	{
		comancheVillageID = -1;
		comancheVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		comancheVillageID = rmCreateGrouping("comanche village2", "native comanche village "+comancheVillageType);
		rmSetGroupingMinDistance(comancheVillageID, 0.0);
		rmSetGroupingMaxDistance(comancheVillageID, 0.0);
		rmAddGroupingConstraint(comancheVillageID, avoidImpassableLand);
		rmAddGroupingToClass(comancheVillageID, rmClassID("natives"));
		
		if (randomPlacement <= 2)
			rmPlaceGroupingAtLoc(comancheVillageID, 0, 0.65, 0.35);
		else
			rmPlaceGroupingAtLoc(comancheVillageID, 0, 0.65, 0.35);
	}
	    
/*----------------------------------------------------------------------------------------------------------------*/
	
	    if (subCiv3 == rmGetCivID("Comanche"))
	{
		comancheVillageID = -1;
		comancheVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		comancheVillageID = rmCreateGrouping("comanche village2", "native comanche village "+comancheVillageType);
		rmSetGroupingMinDistance(comancheVillageID, 0.0);
		rmSetGroupingMaxDistance(comancheVillageID, 0.0);
		rmAddGroupingConstraint(comancheVillageID, avoidImpassableLand);
		rmAddGroupingToClass(comancheVillageID, rmClassID("natives"));
		
		if (randomPlacement <= 2)
			rmPlaceGroupingAtLoc(comancheVillageID, 0, 0.8, 0.2);
		else
			rmPlaceGroupingAtLoc(comancheVillageID, 0, 0.8, 0.2);
		
	}
		
	    // CREATE A TRIBE AREA 4:
        int tribe4ID=rmCreateArea("tribe 4");
        rmSetAreaSize(tribe4ID, 0.0075, 0.0075);
        rmAddAreaToClass(tribe4ID, rmClassID("tribe"));
		rmSetAreaCoherence(tribe4ID, 1.0);
        //rmSetAreaMix(tribe4ID, "rockies_snow");

        if (randomPlacement <= 2)
		rmSetAreaLocation(tribe4ID, 0.8, 0.2);
		else
		rmSetAreaLocation(tribe4ID, 0.8, 0.2);
		
		rmBuildArea(tribe4ID);  
	
/*----------------------------------------------------------------------------------------------------------------*/

	    if (subCiv3 == rmGetCivID("Lakota"))
	{
		lakotaVillageID = -1;
		lakotaVillageType = rmRandInt(1,5);
		randomPlacement = rmRandInt(1,10);
		lakotaVillageID = rmCreateGrouping("lakota village2", "native lakota village "+lakotaVillageType);
		rmSetGroupingMinDistance(lakotaVillageID, 0.0);
		rmSetGroupingMaxDistance(lakotaVillageID, 0.0);
		rmAddGroupingConstraint(lakotaVillageID, avoidImpassableLand);
		rmAddGroupingToClass(lakotaVillageID, rmClassID("natives"));
		
		if (randomPlacement <= 2)
			rmPlaceGroupingAtLoc(lakotaVillageID, 0, 0.8, 0.2);
		else
			rmPlaceGroupingAtLoc(lakotaVillageID, 0, 0.8, 0.2);
		
	}
	
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE CENTRAL POND: ************************************** //
/*================================================================================================================*/

	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 15.0);
        int pondCloseConstraint=rmCreateClassDistanceConstraint("close avoid the pond", rmClassID("pond"), 8.0);
       
		int smallPondID=rmCreateArea("small pond");
	
	
		rmSetAreaSize(smallPondID, rmAreaTilesToFraction(3000), rmAreaTilesToFraction(3000));
		rmSetAreaWaterType(smallPondID, "texas pond");
		rmSetAreaBaseHeight(smallPondID, 6);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1.0);
		rmSetAreaMaxBlobDistance(smallPondID, 1.0);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.65);
		rmSetAreaSmoothDistance(smallPondID, 5);
		
		//rmAddAreaConstraint(smallPondID, playerConstraint);
		
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.5, 0.5); 
		rmBuildArea(smallPondID);
		
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FISHSALMON: *************************************** //
/*================================================================================================================*/
   
        // THE NORTHERN FISHES:
		int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
				
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*10.0);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*5.0);		

/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE CLIFF EMBELLISHMENTS: *********************************** //
/*================================================================================================================*/
	
	    int failCount=0;
	    if (cNumberNonGaiaPlayers <= 2)
        int numTries=6*cNumberNonGaiaPlayers;
	    else
	    numTries=3*cNumberNonGaiaPlayers;
		
		for(i=0; <numTries)
	{
		int cliffHeight=rmRandInt(3,6);     
		int mesaID=rmCreateArea("mesa"+i);
		rmSetAreaSize(mesaID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(250));  
		rmSetAreaWarnFailure(mesaID, false);
		rmSetAreaCliffType(mesaID, "Texas");
		rmAddAreaToClass(mesaID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(mesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(mesaID, rmRandInt(6,8), 1.0, 1.0);  
		//rmSetAreaMinBlobs(mesaID, 3);
		//rmSetAreaMaxBlobs(mesaID, 5);
		//rmSetAreaMinBlobDistance(mesaID, 3.0);
		//rmSetAreaMaxBlobDistance(mesaID, 5.0);
		rmSetAreaCoherence(mesaID, 0.5);
		
		rmAddAreaConstraint(mesaID, playerConstraint); 
		rmAddAreaConstraint(mesaID, playerEdgeConstraint);
        rmAddAreaConstraint(mesaID, avoidCanyons);
		rmAddAreaConstraint(mesaID, avoidTribe);		
		rmAddAreaConstraint(mesaID, pondConstraint); 
	    
		if(rmBuildArea(mesaID)==false)
		{
			// Stop trying once we fail 2 times in a row.
			failCount++;
			if(failCount==2)
				break;
		}
		else
			failCount=0;
	}

/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE SMALL CLIFFS: ************************************* //
/*================================================================================================================*/

	    for(i=0; <numTries)
	{
		int smallCliffHeight=rmRandInt(0,5);
		int smallMesaID=rmCreateArea("small mesa"+i);
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(75));  
		rmSetAreaWarnFailure(smallMesaID, false);
		rmSetAreaCliffType(smallMesaID, "Texas");
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID, rmRandInt(6,8), 1.0, 1.0);
		//rmSetAreaMinBlobs(smallMesaID, 3);
		//rmSetAreaMaxBlobs(smallMesaID, 5);
		//rmSetAreaMinBlobDistance(smallMesaID, 3.0);
		//rmSetAreaMaxBlobDistance(smallMesaID, 5.0);
		rmSetAreaCoherence(smallMesaID, 0.6);
		
		rmAddAreaConstraint (smallMesaID, avoidCanyons);
		rmAddAreaConstraint(smallMesaID, playerCloseConstraint); 
		rmAddAreaConstraint(smallMesaID, playerEdgeConstraint); 
		rmAddAreaConstraint(smallMesaID, pondConstraint); 
		rmAddAreaConstraint(smallMesaID, avoidTribe); 
		
		if(rmBuildArea(smallMesaID)==false)
		{
			// Stop trying once we fail 10 times in a row.
			failCount++;
			if(failCount==6)   //KSW ---> Was 20
				break;
		}
		else
			failCount=0;
	}
	
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// *********************** PLACE THE TCID AND THE STARTING UNITS AND THE PLAYER RESOURCES: ********************** //
/*================================================================================================================*/
        
		// TEST OF MARCIN'S STARTING UNITS STUFF:
	    
		for(i=1; <cNumberPlayers)
		
	{
		// PLACE THE TCID:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE PLAYER SILVER:
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING TREE:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
						
		// PLACE THE STARTING BISON:
		rmPlaceObjectDefAtLoc(startBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE PLAYER BERRYBUSH:
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		
	}

/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FORESTS: **************************************** //
/*================================================================================================================*/
	
	    // THE NORTHERN FOREST:
		for(i=0; <cNumberNonGaiaPlayers*8)
{
		int northForestID=rmCreateArea("northForest"+i);
		rmSetAreaWarnFailure(northForestID, false);
		rmSetAreaSize(northForestID, rmAreaTilesToFraction(175), rmAreaTilesToFraction(250));  
		rmSetAreaForestType(northForestID, "texas forest dirt");
		rmSetAreaForestDensity(northForestID, 20.0);                         
		rmSetAreaForestClumpiness(northForestID, 3.0);		
		rmSetAreaForestUnderbrush(northForestID, 0.0);
		rmAddAreaToClass(northForestID, rmClassID("classForest"));
		rmSetAreaMinBlobs(northForestID, 1);
		rmSetAreaMaxBlobs(northForestID, 3);					
		rmSetAreaMinBlobDistance(northForestID, 16.0);
		rmSetAreaMaxBlobDistance(northForestID, 30.0);
		rmSetAreaCoherence(northForestID, 0.4);
		rmSetAreaSmoothDistance(northForestID, 8);
		
		rmAddAreaConstraint(northForestID, playerCloseConstraint);
		rmAddAreaConstraint(northForestID, playerEdgeConstraint);
		rmAddAreaConstraint(northForestID, forestMediumConstraint); 
		rmAddAreaConstraint(northForestID, avoidCanyons); 
	    rmAddAreaConstraint(northForestID, avoidTribe);
		rmAddAreaConstraint(northForestID, Northward);
		rmAddAreaConstraint(northForestID, pondCloseConstraint);  
		
		if(rmBuildArea(northForestID)==false)
	{
		// Stop trying once we fail 10 times in a row.  
		failCount++;
		if(failCount==24)
		break;
	}
		else
		failCount=0; 
}
	
/*----------------------------------------------------------------------------------------------------------------*/	
	    
		// THE SOUTHERN FOREST:
		for(i=0; <cNumberNonGaiaPlayers*8)
{
		int southForestID=rmCreateArea("southForest"+i);
		rmSetAreaWarnFailure(southForestID, false);
		rmSetAreaSize(southForestID, rmAreaTilesToFraction(175), rmAreaTilesToFraction(250));  
		rmSetAreaForestType(southForestID, "texas forest dirt");
		rmSetAreaForestDensity(southForestID, 20.0);                         
		rmSetAreaForestClumpiness(southForestID, 3.0);		
		rmSetAreaForestUnderbrush(southForestID, 0.0);
		rmAddAreaToClass(southForestID, rmClassID("classForest"));
		rmSetAreaMinBlobs(southForestID, 1);
		rmSetAreaMaxBlobs(southForestID, 3);					
		rmSetAreaMinBlobDistance(southForestID, 16.0);
		rmSetAreaMaxBlobDistance(southForestID, 30.0);
		rmSetAreaCoherence(southForestID, 0.4);
		rmSetAreaSmoothDistance(southForestID, 8);
		
		rmAddAreaConstraint(southForestID, playerCloseConstraint);
		rmAddAreaConstraint(southForestID, playerEdgeConstraint);
		rmAddAreaConstraint(southForestID, forestMediumConstraint); 
		rmAddAreaConstraint(southForestID, avoidCanyons); 
	    rmAddAreaConstraint(southForestID, avoidTribe);
		rmAddAreaConstraint(southForestID, pondCloseConstraint);
		rmAddAreaConstraint(southForestID, Southward);
		
		if(rmBuildArea(southForestID)==false)
	{
		// Stop trying once we fail 10 times in a row.  
		failCount++;
		if(failCount==24)
		break;
	}
		else
		failCount=0; 
}
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE COIN RESOURCES: ************************************* //
/*================================================================================================================*/

	    // COIN RESOURCES:

	    int silverType = rmRandInt(1,10);   
	    int silverID = -1;
		
		if (cNumberNonGaiaPlayers <= 2)
        int silverCount = cNumberNonGaiaPlayers*6;	
		else
		silverCount = cNumberNonGaiaPlayers*3;	
	    
		rmEchoInfo("silver count = "+silverCount);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // THE NORTHERN SILVER:
		for(i=0; < silverCount)
	{
		silverID = rmCreateObjectDef("silver 1"+i);
		rmAddObjectDefItem(silverID, "mine", 1, 0);
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.45));
		
		rmAddObjectDefConstraint(silverID, avoidCanyons);
		rmAddObjectDefConstraint(silverID, avoidFarSilver);
		rmAddObjectDefConstraint(silverID, pondCloseConstraint);
		rmAddObjectDefConstraint(silverID, playerCloseConstraint);
		rmAddObjectDefConstraint(silverID, playerEdgeConstraint);
		rmAddObjectDefConstraint(silverID, forestCloseConstraint);
		rmAddObjectDefConstraint(silverID, avoidTribe);
		rmAddObjectDefConstraint(silverID, Northward);
		
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
	}
	
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN SILVER:
		for(i=0; < silverCount)
	{
		int silver2ID = rmCreateObjectDef("silver 2"+i);
		rmAddObjectDefItem(silver2ID, "mine", 1, 0);
		rmSetObjectDefMinDistance(silver2ID, 0.0);
		rmSetObjectDefMaxDistance(silver2ID, rmXFractionToMeters(0.45));
		
		rmAddObjectDefConstraint(silver2ID, avoidCanyons);
		rmAddObjectDefConstraint(silver2ID, avoidFarSilver);
		rmAddObjectDefConstraint(silver2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(silver2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(silver2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(silver2ID, avoidTribe);
		rmAddObjectDefConstraint(silver2ID, Southward);
		rmAddObjectDefConstraint(silver2ID, pondCloseConstraint);          
		
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.5, 0.5);
	}	
	
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE NUGGETS: *************************************** //
/*================================================================================================================*/

        // THE NORTHERN NUGGET:
		int nuggetID= rmCreateObjectDef("nugget"); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nuggetID, avoidFarNugget);
		rmAddObjectDefConstraint(nuggetID, avoidCanyons);
  	    rmAddObjectDefConstraint(nuggetID, forestCloseConstraint);
		rmAddObjectDefConstraint(nuggetID, Northward);
		rmAddObjectDefConstraint(nuggetID, avoidMediumSilver);
		rmAddObjectDefConstraint(nuggetID, avoidMediumTribe);
		rmAddObjectDefConstraint(nuggetID, pondCloseConstraint);
		rmAddObjectDefConstraint(nuggetID, playerEdgeConstraint);
		rmAddObjectDefConstraint(nuggetID, playerCloseConstraint);
	    	    
		rmSetNuggetDifficulty(1, 3);
	    if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4.0);
		else
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
	    
        // THE SOUTHERN NUGGET:
		int nugget2ID= rmCreateObjectDef("The Southern Nugget"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nugget2ID, avoidFarNugget);
		rmAddObjectDefConstraint(nugget2ID, avoidCanyons);
  	    rmAddObjectDefConstraint(nugget2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(nugget2ID, Southward);
		rmAddObjectDefConstraint(nugget2ID, avoidMediumSilver);
		rmAddObjectDefConstraint(nugget2ID, avoidMediumTribe);
		rmAddObjectDefConstraint(nugget2ID, pondCloseConstraint);
		rmAddObjectDefConstraint(nugget2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(nugget2ID, playerCloseConstraint);
	    	    
		rmSetNuggetDifficulty(1, 3);
	    if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4.0);
		else
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE COW HERDS: **************************************** //
/*================================================================================================================*/

        // THE NORTHERN COW HERDS:
		int cowID=rmCreateObjectDef("The Northern Cow");
        rmAddObjectDefItem(cowID, "cow", 2, 3.0);
        rmSetObjectDefMinDistance(cowID, 0.0);
        rmSetObjectDefMaxDistance(cowID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(cowID, avoidFarCow);
		rmAddObjectDefConstraint(cowID, avoidCanyons);
        rmAddObjectDefConstraint(cowID, avoidCloseSilver);
		rmAddObjectDefConstraint(cowID, avoidCloseNugget);
		rmAddObjectDefConstraint(cowID, avoidCloseTribe);
		rmAddObjectDefConstraint(cowID, pondCloseConstraint);
		rmAddObjectDefConstraint(cowID, forestCloseConstraint);
		rmAddObjectDefConstraint(cowID, Northward);
		rmAddObjectDefConstraint(cowID, playerCloseConstraint);
		rmAddObjectDefConstraint(cowID, playerEdgeConstraint);
		
		rmSetObjectDefCreateHerd(cowID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(cowID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(cowID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);    
		
/*----------------------------------------------------------------------------------------------------------------*/
        
		// THE SOUTHERN COW HERDS:
		int cow2ID=rmCreateObjectDef("The Southern Cow");
        rmAddObjectDefItem(cow2ID, "cow", 2, 3.0);
        rmSetObjectDefMinDistance(cow2ID, 0.0);
        rmSetObjectDefMaxDistance(cow2ID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(cow2ID, avoidFarCow);
		rmAddObjectDefConstraint(cow2ID, avoidCanyons);
        rmAddObjectDefConstraint(cow2ID, avoidCloseSilver);
		rmAddObjectDefConstraint(cow2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(cow2ID, avoidCloseTribe);
		rmAddObjectDefConstraint(cow2ID, pondCloseConstraint);
		rmAddObjectDefConstraint(cow2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(cow2ID, Southward);
		rmAddObjectDefConstraint(cow2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(cow2ID, playerEdgeConstraint);
		
		rmSetObjectDefCreateHerd(cow2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);

/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.875);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE BISON HERDS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*================================================================================================================*/

        // THE NORTHERN BISON HERDS:
		int bisonID=rmCreateObjectDef("The Northern Bison Herds");
	    rmAddObjectDefItem(bisonID, "bison", rmRandInt(7,8), 6.0);
        rmSetObjectDefMinDistance(bisonID, 0.0);
        rmSetObjectDefMaxDistance(bisonID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(bisonID, avoidFarBison);
		rmAddObjectDefConstraint(bisonID, avoidFarCow);
        rmAddObjectDefConstraint(bisonID, forestCloseConstraint);
	    rmAddObjectDefConstraint(bisonID, Northward);
		rmAddObjectDefConstraint(bisonID, avoidCanyons);
		rmAddObjectDefConstraint(bisonID, avoidCloseSilver);
		rmAddObjectDefConstraint(bisonID, avoidCloseNugget);
		rmAddObjectDefConstraint(bisonID, avoidCloseTribe);
        rmAddObjectDefConstraint(bisonID, pondCloseConstraint);
		rmAddObjectDefConstraint(bisonID, playerCloseConstraint);
		rmAddObjectDefConstraint(bisonID, playerEdgeConstraint);

        rmSetObjectDefCreateHerd(bisonID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(bisonID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(bisonID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN BISON HERDS:
		int bison2ID=rmCreateObjectDef("The Southern Bison Herds");
	    rmAddObjectDefItem(bison2ID, "bison", rmRandInt(7,8), 6.0);
        rmSetObjectDefMinDistance(bison2ID, 0.0);
        rmSetObjectDefMaxDistance(bison2ID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(bison2ID, avoidFarBison);
		rmAddObjectDefConstraint(bison2ID, avoidFarCow);
        rmAddObjectDefConstraint(bison2ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(bison2ID, Southward);
		rmAddObjectDefConstraint(bison2ID, avoidCanyons);
		rmAddObjectDefConstraint(bison2ID, avoidCloseSilver);
		rmAddObjectDefConstraint(bison2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(bison2ID, avoidCloseTribe);
        rmAddObjectDefConstraint(bison2ID, pondCloseConstraint);
		rmAddObjectDefConstraint(bison2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(bison2ID, playerEdgeConstraint);

        rmSetObjectDefCreateHerd(bison2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(bison2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(bison2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE PRONGHORN HERDS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*================================================================================================================*/

        // THE NORTHERN PRONGHORN HERDS:
		int pronghornID=rmCreateObjectDef("The Northern Pronghorn Herds");
	    rmAddObjectDefItem(pronghornID, "pronghorn", rmRandInt(7,8), 6.0);
        rmSetObjectDefMinDistance(pronghornID, 0.0);
        rmSetObjectDefMaxDistance(pronghornID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(pronghornID, avoidFarPronghorn);
		rmAddObjectDefConstraint(pronghornID, avoidFarBison);
		rmAddObjectDefConstraint(pronghornID, avoidFarCow);
        rmAddObjectDefConstraint(pronghornID, forestCloseConstraint);
	    rmAddObjectDefConstraint(pronghornID, Northward);
		rmAddObjectDefConstraint(pronghornID, avoidCanyons);
		rmAddObjectDefConstraint(pronghornID, avoidCloseSilver);
		rmAddObjectDefConstraint(pronghornID, avoidCloseNugget);
		rmAddObjectDefConstraint(pronghornID, avoidCloseTribe);
        rmAddObjectDefConstraint(pronghornID, pondCloseConstraint);
		rmAddObjectDefConstraint(pronghornID, playerCloseConstraint);
		rmAddObjectDefConstraint(pronghornID, playerEdgeConstraint);

        rmSetObjectDefCreateHerd(pronghornID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(pronghornID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(pronghornID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN PRONGHORN HERDS:
		int pronghorn2ID=rmCreateObjectDef("The Southern Pronghorn Herds");
	    rmAddObjectDefItem(pronghorn2ID, "pronghorn", rmRandInt(7,8), 6.0);
        rmSetObjectDefMinDistance(pronghorn2ID, 0.0);
        rmSetObjectDefMaxDistance(pronghorn2ID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(pronghorn2ID, avoidFarPronghorn);
		rmAddObjectDefConstraint(pronghorn2ID, avoidFarBison);
		rmAddObjectDefConstraint(pronghorn2ID, avoidFarCow);
        rmAddObjectDefConstraint(pronghorn2ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(pronghorn2ID, Southward);
		rmAddObjectDefConstraint(pronghorn2ID, avoidCanyons);
		rmAddObjectDefConstraint(pronghorn2ID, avoidCloseSilver);
		rmAddObjectDefConstraint(pronghorn2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(pronghorn2ID, avoidCloseTribe);
        rmAddObjectDefConstraint(pronghorn2ID, pondCloseConstraint);
		rmAddObjectDefConstraint(pronghorn2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(pronghorn2ID, playerEdgeConstraint);

        rmSetObjectDefCreateHerd(pronghorn2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(pronghorn2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(pronghorn2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);

/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.925);
/*================================================================================================================*/
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE RANDOM NORTHERN TREES:
		int randomTreeID=rmCreateObjectDef("The Random Northern Trees");
		rmAddObjectDefItem(randomTreeID, "TreeTexasDirt", 1, 0.0);
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, avoidClosePronghorn);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseBison);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCow);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCanyons);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTribe);
		rmAddObjectDefConstraint(randomTreeID, Northward);
		rmAddObjectDefConstraint(randomTreeID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, pondCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint); 
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSilver);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);  

/*----------------------------------------------------------------------------------------------------------------*/

        // THE RANDOM SOUTHERN TREES:
		int randomTree2ID=rmCreateObjectDef("The Random Southern Trees");
		rmAddObjectDefItem(randomTree2ID, "TreeTexasDirt", 1, 0.0);
		rmAddObjectDefToClass(randomTree2ID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTree2ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTree2ID, avoidClosePronghorn);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseBison);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseCow);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseCanyons);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseTribe);
		rmAddObjectDefConstraint(randomTree2ID, Southward);
		rmAddObjectDefConstraint(randomTree2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, pondCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, playerEdgeConstraint); 
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseSilver);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);

/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //		
/*================================================================================================================*/

        // THE NORTHERN BERRYBUSH:
		int BerriesID=rmCreateObjectDef("The Northern Berrybush");
        rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(BerriesID, 0.0);
        rmSetObjectDefMaxDistance(BerriesID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(BerriesID, avoidVeryFarFruits);
		rmAddObjectDefConstraint(BerriesID, Northward);
        rmAddObjectDefConstraint(BerriesID, avoidCloseTrees);
		rmAddObjectDefConstraint(BerriesID, avoidCloseTribe);
		rmAddObjectDefConstraint(BerriesID, avoidMediumPronghorn);
		rmAddObjectDefConstraint(BerriesID, avoidMediumBison);
		rmAddObjectDefConstraint(BerriesID, forestCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, playerCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidCloseSilver);
		rmAddObjectDefConstraint(BerriesID, avoidCloseNugget);
		rmAddObjectDefConstraint(BerriesID, playerEdgeConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCanyons);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCow);
		rmAddObjectDefConstraint(BerriesID, pondCloseConstraint);
		        
		rmSetObjectDefCreateHerd(BerriesID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN BERRYBUSH:
		int Berries2ID=rmCreateObjectDef("The Southern Berrybush");
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(Berries2ID, 0.0);
        rmSetObjectDefMaxDistance(Berries2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(Berries2ID, avoidVeryFarFruits);
		rmAddObjectDefConstraint(Berries2ID, Southward);
        rmAddObjectDefConstraint(Berries2ID, avoidCloseTrees);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseTribe);
		rmAddObjectDefConstraint(Berries2ID, avoidMediumPronghorn);
		rmAddObjectDefConstraint(Berries2ID, avoidMediumBison);
		rmAddObjectDefConstraint(Berries2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseSilver);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Berries2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCanyons);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCow);
		rmAddObjectDefConstraint(Berries2ID, pondCloseConstraint);
		        
		rmSetObjectDefCreateHerd(Berries2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.975);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE RANDOM VULTURE TREE: *********************************** //		
/*================================================================================================================*/
	
        // THE NORTHERN RANDOM VULTURE TREE:
		int randomVultureTreeID=rmCreateObjectDef("The Northern Random Vulture Tree");
	    rmAddObjectDefItem(randomVultureTreeID, "PropVulturePerching", 1, 3.0);
	    rmAddObjectDefItem(randomVultureTreeID, "UnderbrushPampas", rmRandInt(4,6), 3.0);
	    rmSetObjectDefMinDistance(randomVultureTreeID, 0.0);
	    rmSetObjectDefMaxDistance(randomVultureTreeID, rmXFractionToMeters(0.50));
        
		rmAddObjectDefConstraint(randomVultureTreeID, avoidVeryFarFruits);
	    rmAddObjectDefConstraint(randomVultureTreeID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomVultureTreeID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(randomVultureTreeID, pondCloseConstraint);
	    rmAddObjectDefConstraint(randomVultureTreeID, avoidTribe);
	    rmAddObjectDefConstraint(randomVultureTreeID, avoidSuperFarVultures);
	    rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseSilver);
		rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseBison);
		rmAddObjectDefConstraint(randomVultureTreeID, avoidClosePronghorn);
		rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseCow);
		rmAddObjectDefConstraint(randomVultureTreeID, forestCloseConstraint);
	    rmAddObjectDefConstraint(randomVultureTreeID, Northward);
		rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseCanyons);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomVultureTreeID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomVultureTreeID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/

        // THE SOUTHERN RANDOM VULTURE TREE:
		int randomVultureTree2ID=rmCreateObjectDef("The Southern Random Vulture Tree");
	    rmAddObjectDefItem(randomVultureTree2ID, "PropVulturePerching", 1, 3.0);
	    rmAddObjectDefItem(randomVultureTree2ID, "UnderbrushPampas", rmRandInt(4,6), 3.0);
	    rmSetObjectDefMinDistance(randomVultureTree2ID, 0.0);
	    rmSetObjectDefMaxDistance(randomVultureTree2ID, rmXFractionToMeters(0.50));
        
		rmAddObjectDefConstraint(randomVultureTree2ID, avoidVeryFarFruits);
	    rmAddObjectDefConstraint(randomVultureTree2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomVultureTree2ID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(randomVultureTree2ID, pondCloseConstraint);
	    rmAddObjectDefConstraint(randomVultureTree2ID, avoidTribe);
	    rmAddObjectDefConstraint(randomVultureTree2ID, avoidSuperFarVultures);
	    rmAddObjectDefConstraint(randomVultureTree2ID, avoidCloseSilver);
		rmAddObjectDefConstraint(randomVultureTree2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomVultureTree2ID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomVultureTree2ID, avoidCloseBison);
		rmAddObjectDefConstraint(randomVultureTree2ID, avoidClosePronghorn);
		rmAddObjectDefConstraint(randomVultureTree2ID, avoidCloseCow);
		rmAddObjectDefConstraint(randomVultureTree2ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(randomVultureTree2ID, Southward);
		rmAddObjectDefConstraint(randomVultureTree2ID, avoidCloseCanyons);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomVultureTree2ID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomVultureTree2ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/


