/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/
// ANALYZED BY DANY:
// DECEMBER 2006:
// CARIBBEAN BY ENSEMBLE:
// JUNE 2003
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ***************************************** CHOOSES THE NATIVES TRIBES: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int subCiv0=-1;
      int subCiv1=-1;
      

      if (rmAllocateSubCivs(2) == true)
   {
	  subCiv0=rmGetCivID("Caribs");
      if (subCiv0 >= 0)
      rmSetSubCiv(0, "Caribs"); 

      subCiv1=rmGetCivID("Caribs");
      if (subCiv1 >= 0)
      rmSetSubCiv(1, "Caribs");	
	  
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/

/*================================================================================================================*/   
/*================================================================================================================*/
// **************************************** PICKS THE SIZE OF THE MAP: ****************************************** //
/*================================================================================================================*/
      int playerTiles=24000;
	  
	  if (cNumberNonGaiaPlayers >4)
		  playerTiles = 17000;
	  if (cNumberNonGaiaPlayers >7)
		  playerTiles = 19000;			
      
	  int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
      rmEchoInfo("Map size="+size+"m x "+size+"m");
      rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** DEFINE THE MAP PARAMETERS: ***************************************** //
/*================================================================================================================*/
      // SET UP THE DEFAULT WATER:
      rmSetSeaLevel(2.0);
      rmSetSeaType("caribbean coast");
 	  
	  // SET BASE TERRAIN MIX:
	  rmSetBaseTerrainMix("caribbean grass");
	  
	  // SET THE MAP TYPE:
	  rmSetMapType("caribbean");
	  rmSetMapType("grass");
	  rmSetMapType("water");
      
	  // SET THE LIGHTING:
	  rmSetLightingSet("caribbean");

      //INITIALISATION OF THE MAP:
      rmTerrainInitialize("water");
	  
	  // CHOOSE THE MERCS: 
	  chooseMercs();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ******************************************** DEFINE SOME CLASSES: ******************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int classPlayer=rmDefineClass("player");
	  int classIsland=rmDefineClass("island");
	  int classBonusIsland=rmDefineClass("bonusIsland");
      int classTeamIsland=rmDefineClass("teamIsland");
	  rmDefineClass("classForest");
      rmDefineClass("importantItem");
      rmDefineClass("natives");
	  rmDefineClass("classSocket");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// **************************************** DEFINE THE CONSTRAINTS: ********************************************* //    
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      // CREATE A EDGE OF MAP CONSTRAINT:
      int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.45), rmDegreesToRadians(0), rmDegreesToRadians(360));
      	  
	  // PLAYER AREA CONSTRAINT:
      int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 20.0);
	  int avoidTC=rmCreateTypeDistanceConstraint("stay away from TC", "TownCenter", 10.0);
	  //int tcAvoidTC=rmCreateTypeDistanceConstraint("TC avoids TC", "TownCenter", 40.0);
	  int avoidCW=rmCreateTypeDistanceConstraint("stay away from CW", "CoveredWagon", 10.0);
	  	  
	  // BONUS AREA CONSTRAINT:
      //int islandConstraint=rmCreateClassDistanceConstraint("islands avoid each other", classIsland, 65.0);
	  
	  // FRUITS AVOIDANCE:
	  int avoidFruits=rmCreateTypeDistanceConstraint("stuffs avoids berries", "berrybush", 12.0);
	  int fruitsAvoidFruits=rmCreateTypeDistanceConstraint("berries avoids berries", "berrybush", 30.0);
	 	  
	  // SHEEP AVOIDANCE:
	  int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 10.0);
	  int sheepAvoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 40.0);
	 
	  // DEER AVOIDANCE:
	  int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
	  int deerAvoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 40.0);
	  	  
	  // BONUS AREA CONSTRAINT:
      int islandConstraint=rmCreateClassDistanceConstraint("islands avoid each other", classIsland, 55.0);
      
      // RESOURCE CONSTRAINT:
	  int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fishSalmon", 20.0);
      int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
      int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "HumpbackWhale", 50.0);
      int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 25.0);
      
      // NATIVES AVOIDANCE:	  
      int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 10.0);
	  
	  // FOREST AVOIDANCE:
	  int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
      int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 40.0);
    
	  // COIN AVOIDANCE:
	  int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "mine", 30.0);
      	  
	  // DECORATION AVOIDANCE:
	  int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

	  // NUGGET AVOIDANCE:
	  int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "abstractNugget", 50.0);
	  
	  // AVOID IMPASSABLE LAND:
      int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
      int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);

	  // FLAG AVOIDANCE:
      int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 10.0);
      int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 25);
      int flagEdgeConstraint = rmCreatePieConstraint("flags away from edge of map", 0.5, 0.5, rmGetMapXSize()-200, rmGetMapXSize()-100, 0, 0, 0);
     
	  // IMPORTANT ITEM AVOIDANCE:
	  int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 50.0);
     	  
	  // TRADE ROUTE AND SOCKET AVOIDANCE:
	  int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
	  
	  // CONSTRAINT TO AVOID WATER:
      int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water short", "Land", false, 8.0);
	  int avoidWater12 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 12.0);
	  int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water large", "Land", false, 20.0);

     
      
/*================================================================================================================*/
// **************************************** DONE DEFINING THE OBJECTS: ****************************************** //
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ******************************************** DEFINE THE AREAS: *********************************************** //
/*================================================================================================================*/
      // DEFINE THE NORTHERN ISLAND:
	  int IslandID=rmCreateArea("Northern island");
      rmSetAreaSize(IslandID, 0.25, 0.25);
	  
	  rmAddAreaToClass(IslandID, classIsland);
      rmAddAreaConstraint(IslandID, islandConstraint);
      
	  //rmSetAreaMinBlobs(IslandID, 10);
      //rmSetAreaMaxBlobs(IslandID, 15);
      //rmSetAreaMinBlobDistance(IslandID, 8.0);
      //rmSetAreaMaxBlobDistance(IslandID, 10.0);
	  
	  rmSetAreaMix(IslandID, "caribbean grass");
      
	  rmSetAreaBaseHeight(IslandID, 2.0);
	  rmSetAreaElevationType(IslandID, cElevTurbulence);
	  rmSetAreaElevationVariation(IslandID, 4.0);
	  rmSetAreaElevationMinFrequency(IslandID, 0.09);
	  rmSetAreaElevationOctaves(IslandID, 3);
	  rmSetAreaElevationPersistence(IslandID, 0.2);
	  rmSetAreaElevationNoiseBias(IslandID, 1);
	  
	  rmSetAreaSmoothDistance(IslandID, 20);
	  rmSetAreaCoherence(IslandID, 0.55);
	  rmSetAreaEdgeFilling(IslandID, 0); // test
      rmSetAreaWarnFailure(IslandID, false);
	  rmSetAreaObeyWorldCircleConstraint(IslandID, false);
	 
	  rmSetAreaLocation(IslandID, 1.0, 1.0);
	  rmBuildArea(IslandID);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  // DEFINE THE SOUTHERN ISLAND:
	  int Island2ID=rmCreateArea("Southern island");
      rmSetAreaSize(Island2ID, 0.25, 0.25);
	  
	  rmAddAreaToClass(Island2ID, classIsland);
      rmAddAreaConstraint(Island2ID, islandConstraint);
      
	  //rmSetAreaMinBlobs(Island2ID, 10);
      //rmSetAreaMaxBlobs(Island2ID, 15);
      //rmSetAreaMinBlobDistance(Island2ID, 8.0);
      //rmSetAreaMaxBlobDistance(Island2ID, 10.0);
	 
      rmSetAreaMix(Island2ID, "caribbean grass");
      
	  rmSetAreaBaseHeight(Island2ID, 2.0);
	  rmSetAreaElevationType(Island2ID, cElevTurbulence);
	  rmSetAreaElevationVariation(Island2ID, 4.0);
	  rmSetAreaElevationMinFrequency(Island2ID, 0.09);
	  rmSetAreaElevationOctaves(Island2ID, 3);
	  rmSetAreaElevationPersistence(Island2ID, 0.2);
	  rmSetAreaElevationNoiseBias(Island2ID, 1);
	  
	  rmSetAreaSmoothDistance(Island2ID, 20);
	  rmSetAreaCoherence(Island2ID, 0.55);
	  rmSetAreaEdgeFilling(Island2ID, 0); // test
	  rmSetAreaWarnFailure(Island2ID, false);
	  rmSetAreaObeyWorldCircleConstraint(Island2ID, false);
      
	  rmSetAreaLocation(Island2ID, 0.0, 0.0);
	  rmBuildArea(Island2ID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ******************************************* SET UP THE TEAMS AREAS: ****************************************** //
/*================================================================================================================*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ********************************** SET UP THE PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
	    if ( cNumberTeams == 2 )
	{
		rmSetPlacementTeam(0);
		//rmSetPlacementSection(0.15, 0.35);
		rmSetPlacementSection(0.10, 0.20);
				
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.13, 0.37);
		}
		//rmPlacePlayersCircular(0.35, 0.40, 0.0);
		rmPlacePlayersCircular(0.35, 0.36, 0.0);
		   


		rmSetPlacementTeam(1);
		//rmSetPlacementSection(0.65, 0.85);
		rmSetPlacementSection(0.60, 0.70);
		
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.63, 0.87);
		}
		//rmPlacePlayersCircular(0.35, 0.40, 0.0);
		rmPlacePlayersCircular(0.35, 0.36, 0.0);
		   
	}
	else
	{
  		rmSetPlacementSection(0.0, 0.95);
		//rmPlacePlayersCircular(0.40, 0.42, 0.0);
		rmPlacePlayersCircular(0.35, 0.36, 0.0);
	}   
/*================================================================================================================*/
// ***************************************** SET UP PLAYER AREAS: *********************************************** //
/*================================================================================================================*/
      //float playerFraction=rmAreaTilesToFraction(1000);
	  float playerFraction=rmAreaTilesToFraction(120);
	     

      for(i=1; <cNumberPlayers)

   {
   
      // CREATE THE AREA:
	  int id=rmCreateArea("Player"+i);
	        
	  // ASSIGN TO THE PLAYER:
	  rmSetPlayerArea(i, id);
	  
	  // SET THE SIZE:
	  rmSetAreaSize(id, playerFraction, playerFraction);
	  
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD AREA CONSTRAINTS:
	  rmAddAreaConstraint(id, playerConstraint);
	  rmAddAreaConstraint(id, avoidWater8);
	  rmAddAreaConstraint(id, avoidNatives);
	  rmAddAreaConstraint(id, avoidCW);
      
	  // SET AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
	  
	  // SET AREA MIX:
	  rmSetAreaMix(id, "caribbean grass");
	  
	  // SET AREA TERRAIN TYPE:
	  // rmSetAreaTerrainType(id, "texas\ground2");
	  
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
	  
	  // SET AREA COHERENCE:
	  rmSetAreaCoherence(id, 0.9);
		
   }
   
   // BUILD THE AREAS:
   rmBuildAllAreas();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
      // CLEAR OUT CONSTRAINTS FOR GOOD MEASURE:
      rmClearClosestPointConstraints(); 
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE TRADE ROUTE AND SOCKETS: ******************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NATIVES: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if (cNumberTeams == 2)
  {
	   
	    if (subCiv0 == rmGetCivID("caribs"))
	{  
		int caribsVillage1ID = -1;
		caribsVillage1ID = rmCreateGrouping("caribs village 1", "native carib village 1");
		rmSetGroupingMinDistance(caribsVillage1ID, 0.0);
		rmSetGroupingMaxDistance(caribsVillage1ID, rmXFractionToMeters(0.5));
		//rmSetGroupingMaxDistance(caribsVillage1ID, 0.0);
		rmAddGroupingConstraint(caribsVillage1ID, avoidImpassableLand);
		rmAddGroupingToClass(caribsVillage1ID, rmClassID("natives"));
		rmAddGroupingConstraint(caribsVillage1ID, avoidNatives);
		rmAddGroupingConstraint(caribsVillage1ID, avoidWater20);
		rmAddGroupingConstraint(caribsVillage1ID, avoidCW);
		rmAddGroupingConstraint(caribsVillage1ID, avoidImportantItem);
		//rmAddGroupingConstraint(caribsVillage1ID, insideCircleConstraint);
		//rmPlaceGroupingAtLoc(caribsVillage1ID, 0, 0.60, 0.80);
		rmPlaceGroupingInArea(caribsVillage1ID, 0, IslandID);
	} 

        if (subCiv1 == rmGetCivID("caribs"))
	{  
		int caribsVillage2ID = -1;
		caribsVillage2ID = rmCreateGrouping("caribs village 2", "native carib village 1");
		rmSetGroupingMinDistance(caribsVillage2ID, 0.0);
		rmSetGroupingMaxDistance(caribsVillage2ID, rmXFractionToMeters(0.5));
		   //rmSetGroupingMaxDistance(caribsVillage2ID, 0.0);
		rmAddGroupingConstraint(caribsVillage2ID, avoidImpassableLand);
		rmAddGroupingToClass(caribsVillage2ID, rmClassID("natives"));
		rmAddGroupingConstraint(caribsVillage2ID, avoidNatives);
		rmAddGroupingConstraint(caribsVillage2ID, avoidWater20);
		rmAddGroupingConstraint(caribsVillage2ID, avoidCW);
		rmAddGroupingConstraint(caribsVillage2ID, avoidImportantItem);
		//rmAddGroupingConstraint(caribsVillage2ID, insideCircleConstraint);
		//rmPlaceGroupingAtLoc(caribsVillage2ID, 0, 0.85, 0.525);
		rmPlaceGroupingInArea(caribsVillage2ID, 0, Island2ID);
	} 

  }	
/*================================================================================================================*/
rmClearClosestPointConstraints();		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ************************************ DEFINE THE STARTING TCID AND UNITS: ************************************* //
/*================================================================================================================*/
	  int TCID = rmCreateObjectDef("player TC");
	    if ( rmGetNomadStart())
		rmAddObjectDefItem(TCID, "coveredWagon", 1, 0);
	  else
	    // rmAddObjectDefItem(TCID, "townCenter", 1, 0);
		   rmAddObjectDefItem(TCID, "coveredWagon", 1, 0);
		
	  rmSetObjectDefMinDistance(TCID, 2.0);
	  rmSetObjectDefMaxDistance(TCID, 12.0);
	  rmAddObjectDefConstraint(TCID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(TCID, avoidTC);
	  rmAddObjectDefConstraint(TCID, avoidCW);
	  rmAddObjectDefConstraint(TCID, avoidNatives);
	  rmAddObjectDefConstraint(TCID, avoidWater8);
	
	  int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	  rmSetObjectDefMinDistance(startingUnits, 5.0);
	  rmSetObjectDefMaxDistance(startingUnits, 18.0);
	  rmAddObjectDefConstraint(startingUnits, avoidAll);
	  rmAddObjectDefConstraint(startingUnits, avoidCW);
	  rmAddObjectDefConstraint(startingUnits, avoidWater8);
	  rmAddObjectDefConstraint(startingUnits, avoidImpassableLand);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************* DEFINING THE STARTING RESOURCES: *************************************** //
/*================================================================================================================*/
	  int playerSilverID = rmCreateObjectDef("player silver");
	  rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	  rmAddObjectDefConstraint(playerSilverID, avoidCW);
	  rmSetObjectDefMinDistance(playerSilverID, 10.0);
	  rmSetObjectDefMaxDistance(playerSilverID, 30.0);
	  rmAddObjectDefConstraint(playerSilverID, avoidAll);
      rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);

	  int playerDeerID=rmCreateObjectDef("player deer");
      rmAddObjectDefItem(playerDeerID, "deer", rmRandInt(10,15), 10.0);
      rmSetObjectDefMinDistance(playerDeerID, 12);
      rmSetObjectDefMaxDistance(playerDeerID, 50);
	  rmAddObjectDefConstraint(playerDeerID, avoidAll);
	  rmAddObjectDefConstraint(playerDeerID, avoidCW);
      rmAddObjectDefConstraint(playerDeerID, avoidImpassableLand);
      rmSetObjectDefCreateHerd(playerDeerID, true);
	
	  int berryNum = rmRandInt(2,5);
	  int StartBerriesID=rmCreateObjectDef("starting berries");
	  rmAddObjectDefItem(StartBerriesID, "berrybush", berryNum, 4.0);
	  rmSetObjectDefMinDistance(StartBerriesID, 10);
	  rmSetObjectDefMaxDistance(StartBerriesID, 15);
	  //rmAddObjectDefToClass(StartBerriesID, rmClassID("startingUnit"));
	  rmAddObjectDefConstraint(StartBerriesID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(StartBerriesID, avoidStartingUnits);
	  rmAddObjectDefConstraint(StartBerriesID, avoidAll);
	  rmAddObjectDefConstraint(StartBerriesID, avoidCW);

	  int colonyShipID = 0;
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ****************************** PLACE THE STARTING TCID AND UNITS AND RESOURCES: ****************************** //  
/*================================================================================================================*/
	for(i=1; <cNumberPlayers)
   {
	// PLACING THE STARTING TCID:
	rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));

	// PLACING THE FLAGS:	
	colonyShipID=rmCreateObjectDef("colony ship "+i);
	rmAddObjectDefItem(colonyShipID, "HomeCityWaterSpawnFlag", 1, 1.0);
	if ( rmGetNomadStart())
	{
		if(rmGetPlayerCiv(i) == rmGetCivID("Ottomans"))
			rmAddObjectDefItem(colonyShipID, "Galley", 1, 10.0);
		else
			rmAddObjectDefItem(colonyShipID, "caravel", 1, 10.0);
	}
	rmAddClosestPointConstraint(flagEdgeConstraint);
	rmAddClosestPointConstraint(flagVsFlag);
	rmAddClosestPointConstraint(flagLand);
	vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	rmPlaceObjectDefAtLoc(colonyShipID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
	
	// PLACING THE STARTING BERRIES:
	rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
	// PLACING THE STARTING UNITS:
	rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	
	// PLACING THE PLAYER SILVER:
	rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	
	// PLACING THE PLAYER DEER:
	rmPlaceObjectDefAtLoc(playerDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	
   }
/*================================================================================================================*/   
      // CLEAR CLOSEST POINT CONSTRAINT: (IT IS PERMITING TO SEE THE FLAGS ON THE MAP:)
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE RANDOM SILVER MINES: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int silverID = rmCreateObjectDef("random silver");
	  rmAddObjectDefItem(silverID, "mine", 1, 0);
	  rmSetObjectDefMinDistance(silverID, 0.0);
	  rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
	  //rmAddObjectDefConstraint(silverID, avoidTC);
	  rmAddObjectDefConstraint(silverID, avoidCW);
	  rmAddObjectDefConstraint(silverID, avoidAll);
	  rmAddObjectDefConstraint(silverID, avoidCoin);
      rmAddObjectDefConstraint(silverID, avoidImpassableLand);
	  rmPlaceObjectDefInArea(silverID, true, 2);
	  //rmPlaceObjectDefInArea(silverID, 0, bigIslandID, cNumberNonGaiaPlayers*rmRandInt(1,1.25));
	  for (i=0; <cNumberTeams)
	{
	  rmPlaceObjectDefInArea(silverID, 0, IslandID, cNumberNonGaiaPlayers*0.75);
	  rmPlaceObjectDefInArea(silverID, 0, Island2ID, cNumberNonGaiaPlayers*0.75);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FORESTS: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
         int forestTreeID = 0;
         int numTries=10*cNumberNonGaiaPlayers;
         int failCount=0;
         for (i=0; <numTries)
      {   
         int forest=rmCreateArea("forest "+i);
         rmSetAreaWarnFailure(forest, false);
         rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(400));
         rmSetAreaForestType(forest, "caribbean palm forest");
         rmSetAreaForestDensity(forest, 0.6);
         rmSetAreaForestClumpiness(forest, 0.4);
         rmSetAreaForestUnderbrush(forest, 0.0);
         rmSetAreaMinBlobs(forest, 1);
         rmSetAreaMaxBlobs(forest, 5);
         rmSetAreaMinBlobDistance(forest, 16.0);
         rmSetAreaMaxBlobDistance(forest, 40.0);
         rmSetAreaCoherence(forest, 0.4);
         rmSetAreaSmoothDistance(forest, 10);
         rmAddAreaToClass(forest, rmClassID("classForest")); 
         rmAddAreaConstraint(forest, forestConstraint);
         rmAddAreaConstraint(forest, avoidAll);
		 rmAddAreaConstraint(forest, avoidCW);
		 //rmAddAreaConstraint(forest, avoidNugget);
		 //rmAddAreaConstraint(forest, avoidFruits);
		 rmAddAreaConstraint(forest, playerEdgeConstraint);
         rmAddAreaConstraint(forest, shortAvoidImpassableLand);
         rmAddAreaConstraint(forest, avoidTradeRoute); 
         if(rmBuildArea(forest)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
      } 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	  // DEFINE AND PLACE THE NUGGET EASY:
	  int nugget1= rmCreateObjectDef("nugget easy"); 
	  rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget1, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmSetObjectDefMaxDistance(nugget1, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(nugget1, shortAvoidImpassableLand);
  	  rmAddObjectDefConstraint(nugget1, avoidNugget);
  	  rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
  	  rmAddObjectDefConstraint(nugget1, avoidAll);
	  rmAddObjectDefConstraint(nugget1, avoidCoin);
	  rmAddObjectDefConstraint(nugget1, avoidCW);
	  //rmAddObjectDefConstraint(nugget1, avoidTC);
  	  rmAddObjectDefConstraint(nugget1, avoidWater20);
	  rmAddObjectDefConstraint(nugget1, playerEdgeConstraint);
	  //rmPlaceObjectDefInArea(nugget1, 0, bigIslandID, cNumberNonGaiaPlayers*rmRandInt(1,2));
	    for (i=0; <cNumberTeams)
	{
	    rmPlaceObjectDefInArea(nugget1, 0, IslandID, cNumberNonGaiaPlayers*0.5);
	    rmPlaceObjectDefInArea(nugget1, 0, Island2ID, cNumberNonGaiaPlayers*0.5);
	  
	}

	  // DEFINE AND PLACE THE NUGGET HARD:
	  int nugget2= rmCreateObjectDef("nugget hard"); 
	  rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget2, 0.0);
	  rmSetNuggetDifficulty(3, 3);
	  rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(nugget2, shortAvoidImpassableLand);
  	  rmAddObjectDefConstraint(nugget2, avoidNugget);
  	  rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
  	  rmAddObjectDefConstraint(nugget2, avoidAll);
	  rmAddObjectDefConstraint(nugget2, avoidCoin);
	  rmAddObjectDefConstraint(nugget2, avoidCW);
	  //rmAddObjectDefConstraint(nugget2, avoidTC);
  	  rmAddObjectDefConstraint(nugget2, avoidWater20);
	  rmAddObjectDefConstraint(nugget2, playerEdgeConstraint);
	  //rmPlaceObjectDefInArea(nugget2, 0, bigIslandID, cNumberNonGaiaPlayers);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE SHEEPS: ****************************************** //
/*================================================================================================================*/
      int sheepID=rmCreateObjectDef("sheep");
	  rmAddObjectDefItem(sheepID, "sheep", rmRandInt(4,6), 10.0);
	  rmSetObjectDefMinDistance(sheepID, 0.0);
	  rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(sheepID, avoidSheep);
	  rmAddObjectDefConstraint(sheepID, sheepAvoidSheep);
	  rmAddObjectDefConstraint(sheepID, avoidAll);
	  rmAddObjectDefConstraint(sheepID, avoidCoin);
	  rmAddObjectDefConstraint(sheepID, avoidNugget);
      rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
      //rmAddObjectDefConstraint(sheepID, avoidTC);
	  rmAddObjectDefConstraint(sheepID, avoidWater12);
	  rmAddObjectDefConstraint(sheepID, avoidCW);
	  rmAddObjectDefConstraint(sheepID, playerEdgeConstraint);
	  
	  //rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	  
	  rmPlaceObjectDefInArea(sheepID, 0, IslandID, cNumberNonGaiaPlayers);
	  rmPlaceObjectDefInArea(sheepID, 0, Island2ID, cNumberNonGaiaPlayers);
/*================================================================================================================*/	  
	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE DEERS: ***************************************** //
/*================================================================================================================*/	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int deerID=rmCreateObjectDef("deer herd");
	  int bonusChance=rmRandFloat(0, 1);
      if(bonusChance<0.5)   
      rmAddObjectDefItem(deerID, "deer", rmRandInt(4,6), 10.0);
      else
      rmAddObjectDefItem(deerID, "deer", rmRandInt(8,10), 10.0);
      rmSetObjectDefMinDistance(deerID, 0.0);
      rmSetObjectDefMaxDistance(deerID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(deerID, avoidAll);
	  rmAddObjectDefConstraint(deerID, avoidCoin);
	  rmAddObjectDefConstraint(deerID, avoidNugget);
	  rmAddObjectDefConstraint(deerID, avoidCW);
	  //rmAddObjectDefConstraint(deerID, avoidTC);
	  rmAddObjectDefConstraint(deerID, avoidDeer);
	  rmAddObjectDefConstraint(deerID, deerAvoidDeer);
	  rmAddObjectDefConstraint(deerID, avoidWater12);
      rmAddObjectDefConstraint(deerID, avoidImpassableLand);
	  rmAddObjectDefConstraint(deerID, playerEdgeConstraint);
      rmSetObjectDefCreateHerd(deerID, true);
      //rmPlaceObjectDefAtLoc(deerID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
	  for (i=0; <cNumberTeams)
	{
	  rmPlaceObjectDefInArea(deerID, 0, Island2ID, cNumberNonGaiaPlayers*0.5);
	  rmPlaceObjectDefInArea(deerID, 0, IslandID, cNumberNonGaiaPlayers*0.5);
	}
/*================================================================================================================*/		
// ********************************** DEFINE AND PLACE THE BERRY BUSHES: **************************************** //
/*================================================================================================================*/
      int RandomBerriesID=rmCreateObjectDef("Random Berries");
      rmAddObjectDefItem(RandomBerriesID, "berrybush", rmRandInt(3,5), 6.0);
      rmSetObjectDefMinDistance(RandomBerriesID, 0.0);
      rmSetObjectDefMaxDistance(RandomBerriesID, rmXFractionToMeters(0.5));
	  //rmAddObjectDefConstraint(RandomBerriesID, avoidDeer);
      //rmAddObjectDefConstraint(RandomBerriesID, avoidSheep);
	  rmAddObjectDefConstraint(RandomBerriesID, avoidAll);
	  rmAddObjectDefConstraint(RandomBerriesID, avoidFruits);
	  rmAddObjectDefConstraint(RandomBerriesID, fruitsAvoidFruits);
	  //rmAddObjectDefConstraint(RandomBerriesID, edgeConstraint);
	  rmAddObjectDefConstraint(RandomBerriesID, avoidCoin);
	  rmAddObjectDefConstraint(RandomBerriesID, avoidNugget);
	  rmAddObjectDefConstraint(RandomBerriesID, avoidCW);
	  //rmAddObjectDefConstraint(RandomBerriesID, avoidTC);
      rmAddObjectDefConstraint(RandomBerriesID, avoidImpassableLand);
	  // rmPlaceObjectDefAtLoc(RandomBerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6); 
         rmPlaceObjectDefInArea(RandomBerriesID, 0, Island2ID, cNumberNonGaiaPlayers);
	     rmPlaceObjectDefInArea(RandomBerriesID, 0, IslandID, cNumberNonGaiaPlayers);	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE FISHES AND WHALES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      // DEFINE AND PLACE THE FISHMAHI:
	  int fishID=rmCreateObjectDef("fish Mahi");
      rmAddObjectDefItem(fishID, "FishMahi", 3, 6.0);
      rmSetObjectDefMinDistance(fishID, 0.0);
      rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(fishID, fishVsFishID);
      rmAddObjectDefConstraint(fishID, fishLand);
      rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);

      // DEFINE AND PLACE THE FISHTARPON:
	  int fish2ID=rmCreateObjectDef("fish Tarpon");
      rmAddObjectDefItem(fish2ID, "FishTarpon", 3, 6.0);
      rmSetObjectDefMinDistance(fish2ID, 0.0);
      rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(fish2ID, fishVsFishID);
      rmAddObjectDefConstraint(fish2ID, fishLand);
      rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);

      // DEFINE AND PLACE THE HUMPBACKWHALE:
	  int whaleID=rmCreateObjectDef("whale");
      rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 0.0);
      rmSetObjectDefMinDistance(whaleID, 0.0);
      rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
      rmAddObjectDefConstraint(whaleID, whaleLand);
      rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE RANDOM TREES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int randomTreeID=rmCreateObjectDef("random tree");
      rmAddObjectDefItem(randomTreeID, "treeCaribbean", 1, 0.0);
      rmSetObjectDefMinDistance(randomTreeID, 0.0);
      rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
      rmAddObjectDefConstraint(randomTreeID, avoidTradeRoute);
      rmAddObjectDefConstraint(randomTreeID, avoidAll); 
	  rmAddObjectDefConstraint(randomTreeID, avoidNugget); 
	  rmAddObjectDefConstraint(randomTreeID, avoidDeer); 
	  rmAddObjectDefConstraint(randomTreeID, avoidSheep); 
	  rmAddObjectDefConstraint(randomTreeID, avoidCoin); 
	  rmAddObjectDefConstraint(randomTreeID, avoidCW); 
	  //rmAddObjectDefConstraint(randomTreeID, avoidTC); 
      rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
} 
/*================================================================================================================*/
// ************************************* THIS IS THE END OF THE MAP: ******************************************** //
/*================================================================================================================*/
	  