/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATION OF THE MAP: ************************************* //
/*================================================================================================================*/
// ANALYZED BY DANY:
// JANUARY 2007:
// GREAT LAKES
// March 2004 - JG
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";

void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// *********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int subCiv0=-1;
      int subCiv1=-1;
      int subCiv2=-1;
      int subCiv3=-1; 
	  
	  if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Iroquois");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Iroquois");
   		 

		subCiv1=rmGetCivID("Iroquois");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Iroquois"); 

		subCiv2=rmGetCivID("Iroquois");
      if (subCiv2 >= 0)
         rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
      if (subCiv3 >= 0)
         rmSetSubCiv(3, "Iroquois");
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
      // int playerTiles = 10000;
	     int playerTiles = 25000;
	
	  int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	  rmEchoInfo("Map size="+size+"m x "+size+"m");
	  rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// ***************************************** SET THE MAP PARAMETERS: ******************************************** //
/*================================================================================================================*/
	  // SET THE MAP ELEVATION PARAMETERS:	
	  // rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	
	  // SET MAP ELEVATION HEIGHT BLEND:
	  rmSetMapElevationHeightBlend(1);
	
	  // PICKS A DEFAULT WATER HEIGHT:
	  rmSetSeaLevel(6.0);
   
	  // CHOOSE SUMMER OR WINTER: 
	  float seasonPicker = rmRandFloat(0,1);//rmRandFloat(0,1); //high # is snow, low is spring

      // THE LIGHT SETTING:

	  if (seasonPicker < 0.5)
		  rmSetLightingSet("Great Lakes");
	  else
		  // rmSetLightingSet("Great Lakes Winter");
		     rmSetLightingSet("saguenay"); // FROM SAGUENAY:


	  // PICKS DEFAULT TERRAIN AND WATER:
	  
	  if (seasonPicker < 0.5)
	{
	  rmSetMapElevationParameters(cElevTurbulence, 0.05, 6, 0.7, 8.0);
	  rmSetSeaType("great lakes");
	  rmEnableLocalWater(false);
	  rmSetBaseTerrainMix("greatlakes_grass");
	  rmTerrainInitialize("great_lakes\ground_grass1_gl", 1.0);
	  rmSetMapType("greatlakes");
	  rmSetMapType("grass");
	  rmSetMapType("water");
	}
	  else
	{
	  rmSetMapElevationParameters(cElevTurbulence, 0.02, 4, 0.7, 8.0);
	  // rmSetSeaType("great lakes");
	     rmSetSeaType("hudson bay"); // FROM SAGUENAY:
	  rmEnableLocalWater(false);
	  // rmSetBaseTerrainMix("greatlakes_snow");
	     rmSetBaseTerrainMix("saguenay tundra"); // FROM SAGUENAY:
	  // rmTerrainInitialize("great_lakes\ground_ice1_gl", 1.0);
	     rmTerrainInitialize("saguenay\ground1_sag",1.0); // FROM SAGUENAY:
	  // rmSetMapType("greatlakes");
	     rmSetMapType("saguenay"); // FROM SAGUENAY:
	  // rmSetMapType("snow");
	     rmSetMapType("grass"); // FROM SAGUENAY:
	  rmSetMapType("water");
	  // rmSetGlobalSnow( 1.0 ); // REMOVED BY ME:
	}

	  // CHOOSE THE MERCS:
	  chooseMercs();

	  // THE CORNER CONSTRAINT:
	  rmSetWorldCircleConstraint(true);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/   
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
      int classPlayer=rmDefineClass("player");
	  rmDefineClass("startingUnit");
	  int classGreatLake=rmDefineClass("great lake");
	  rmDefineClass("nuggets");
	  rmDefineClass("importantItem");
	  rmDefineClass("classForest");
	  rmDefineClass("natives");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ******************************************* DEFINE THE CONSTRAINTS: ****************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
      // MAP EDGE CONSTRAINTS:
	  int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10), 0.01);
	  
	  // WATER AVOIDANCE:
	  int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
	  int avoidWater10 = rmCreateTerrainDistanceConstraint("stuffs avoid water", "Land", false, 10.0);
	  int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
	  
      // CIRCLE CONSTRAINT:
	  int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
	
      // CARDINAL DIRECTIONS:
	  int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	  int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	  int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	  int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

	
      // PLAYER CONSTRAINTS:
	  int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 10.0);
	  int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 45.0);
	  int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players short", classPlayer, 20.0);
	 	  
	  // NATURE AVOIDANCE:
	  int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
	  
	  // FOREST AVOIDANCE:
	  int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
	  int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 40.0);
		  
	  // IMPORTANT AVOIDANCE:
	  int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
	  	  
	  // RESOURCE AVOIDANCE:
	  int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
	  int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 10.0);
	  
	  // COIN AVOIDANCE:
	  int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "Mine", 40.0);
	  int shortAvoidCoin=rmCreateTypeDistanceConstraint("short avoid coin", "gold", 10.0);
	
	  // NATIVES AVOIDANCE:
	  int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
	  
	  // UNITS AVOIDANCE:
	  int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 45.0);
	  int shortAvoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units short", rmClassID("startingUnit"), 10.0);
	
	  
	  // AVOID IMPASSABLE LAND:
	  int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
	  int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	  int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
		  
	  // TRADE ROUTE AVOIDANCE:
	  int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 5.0);
	  
	  // NATIVES AVOIDANCE:
	  //int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 30.0);
	  
	  // FOOD AVOIDANCE:
	  int deerConstraint=rmCreateTypeDistanceConstraint("avoid the deer", "deer", 40.0);
	  int shortDeerConstraint=rmCreateTypeDistanceConstraint("short avoid the deer", "deer", 20.0);
	  int mooseConstraint=rmCreateTypeDistanceConstraint("avoid the moose", "moose", 40.0);
	  int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 40.0);
	  
	  // NUGGETS AVOIDANCE:
	  int avoidNuggets=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("nuggets"), 10.0);
	  int nuggetsAvoidNuggets=rmCreateClassDistanceConstraint("nuggets avoids nuggets", rmClassID("nuggets"), 40.0);
	  int shortNuggetConstraint=rmCreateTypeDistanceConstraint("avoid nugget objects", "AbstractNugget", 7.0);
	
	  
	  // DECORATION AVOIDANCE:
	  int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

	  
	  // HCSPAWN LAND AVOIDANCE:
	  int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
	  int HCspawnLand = rmCreateTerrainDistanceConstraint("HC spawn away from land", "land", true, 12.0);
	  
	  // LAKE CONSTRAINTS:
	  int greatLakesConstraint=rmCreateClassDistanceConstraint("avoid the great lakes", classGreatLake, 5.0);
	  int farGreatLakesConstraint=rmCreateClassDistanceConstraint("far avoid the great lakes", classGreatLake, 20.0);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// ******************************************** DEFINE THE OBJECTS: ********************************************* //
// ************************* THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ***************************************** DONE DEFINING OBJECTS: ********************************************* //
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// **************************************** DEFINE AND PLACE THE AREAS: ***************************************** //
/*================================================================================================================*/	  	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE LAKE MICHIGAN: ************************************* //
/*================================================================================================================*/
	int michiganID=rmCreateArea("Lake Michigan 1");
      // 0.37, 0.47
	if (seasonPicker < 0.5)
	{
	rmSetAreaWaterType(michiganID, "great lakes");
	rmSetAreaSize(michiganID, 0.15, 0.15);
		if (cNumberNonGaiaPlayers >= 4)
			rmSetAreaCoherence(michiganID, 0.8);
		else
			rmSetAreaCoherence(michiganID, 0.9);
	rmSetAreaLocation(michiganID, 0.47, 0.52);
	//rmAddAreaInfluencePoint(michiganID, 0.55, 0.48); // CHANGED BY ME:
	rmAddAreaInfluencePoint(michiganID, 0.6, 0.4); // ADDED BY ME:
	rmAddAreaInfluencePoint(michiganID, 0.4, 0.6); // ADDED BY ME:
	}
	else
	{
	// rmSetAreaSize(michiganID, 0.025, 0.03);
	   rmSetAreaSize(michiganID, 0.15, 0.15); // CHANGED BY ME:
	// rmSetAreaWaterType(michiganID, "great lakes ice");
	   rmSetAreaWaterType(michiganID, "saguenay lake"); // FROM SAGUENAY:
	      // rmSetAreaWaterType(michiganID, "new england lake"); // FROM NEW ENGLANG:
	rmSetAreaCoherence(michiganID, 0.90);
	rmSetAreaLocation(michiganID, 0.50, 0.50);
	rmAddAreaInfluencePoint(michiganID, 0.6, 0.4); // ADDED BY ME:
	rmAddAreaInfluencePoint(michiganID, 0.4, 0.6); // ADDED BY ME:
	}
	rmAddAreaToClass(michiganID, classGreatLake);
	rmSetAreaBaseHeight(michiganID, 0.0);
	rmSetAreaObeyWorldCircleConstraint(michiganID, false);
	rmSetAreaMinBlobs(michiganID, 2);
	rmSetAreaMaxBlobs(michiganID, 4);
	rmSetAreaMinBlobDistance(michiganID, 5);
	rmSetAreaMaxBlobDistance(michiganID, 8);
	rmSetAreaSmoothDistance(michiganID, 0);
	rmBuildArea(michiganID); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// ****************************** DEFINE AND PLACE THE TRADE ROUTE AND SOCKETS:********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// **************************************** SET UP THE PLAYER LOCATIONS: **************************************** //
/*================================================================================================================*/ 
	  int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	  int teamOneCount = rmGetNumberPlayersOnTeam(1);

	  if ( cNumberTeams <= 2 && teamZeroCount <= 4 && teamOneCount <= 4)
	{
		  rmSetPlacementTeam(0);
		  rmSetPlacementSection(0.7, 0.9); // 0.5
		  rmSetTeamSpacingModifier(0.25);
		  //rmPlacePlayersCircular(0.30, 0.32, 0);
		  rmPlacePlayersCircular(0.34, 0.35, 0);
			
		  rmSetPlacementTeam(1);
		  rmSetPlacementSection(0.2, 0.4); // 0.5
		  rmSetTeamSpacingModifier(0.25);
		  //rmPlacePlayersCircular(0.30, 0.32, 0);
		  rmPlacePlayersCircular(0.34, 0.35, 0);
	}
	  else
	{
		  rmSetTeamSpacingModifier(0.7);
		  //rmPlacePlayersCircular(0.32, 0.34, 0.0);
		  rmPlacePlayersCircular(0.34, 0.35, 0.0);
	}
	
/*================================================================================================================*/
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
	  float playerFraction=rmAreaTilesToFraction(100);
/*----------------------------------------------------------------------------------------------------------------*/   
	  for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
   {
/*----------------------------------------------------------------------------------------------------------------*/   
      // CREATE THE AREA:
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
      
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD AREA CONSTRAINT:
	  rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, playerEdgeConstraint); 
      rmAddAreaConstraint(id, longAvoidImpassableLand);
	 
      // SET AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
	  
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
/*----------------------------------------------------------------------------------------------------------------*/	  
   }
/*----------------------------------------------------------------------------------------------------------------*/
	  // BUILD THE AREAS:
	  rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// ****************************** DEFINE THE STARTING TCID AND THE STARTING UNITS: ****************************** //
/*================================================================================================================*/
	  // DEFINE THE STARTING TCID:
	  int startingTCID= rmCreateObjectDef("startingTC");
	  if (rmGetNomadStart())
		  {
			  rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 5.0);
		  }
		  else
		  {
              rmAddObjectDefItem(startingTCID, "townCenter", 1, 5.0);
		  }
	  rmAddObjectDefConstraint(startingTCID, avoidImpassableLand);
	  rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
	  rmAddObjectDefToClass(startingTCID, rmClassID("player"));

	  //rmPlaceObjectDefPerPlayer(startingTCID, true);

	  // DEFINE THE STARTING UNITS:
	  int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	  rmSetObjectDefMinDistance(startingUnits, 10.0);
	  rmSetObjectDefMaxDistance(startingUnits, 12.0);
	  rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
/*================================================================================================================*/
// *************************************** DEFINE THE STARTING RESOURCES: *************************************** //
/*================================================================================================================*/
	  // DEFINE THE STARTING TREE:
	  int StartAreaTreeID=rmCreateObjectDef("starting trees");
	  if (seasonPicker < 0.5)
		  rmAddObjectDefItem(StartAreaTreeID, "TreeGreatLakes", 3, 4.0);
	  else
		  // rmAddObjectDefItem(StartAreaTreeID, "TreeGreatLakesSnow", 3, 4.0);
		     rmAddObjectDefItem(StartAreaTreeID, "TreeSaguenay", 3, 4.0);
	  rmSetObjectDefMinDistance(StartAreaTreeID, 12);
	  rmSetObjectDefMaxDistance(StartAreaTreeID, 16);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
	  rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidImpassableLand);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidNatives);
	  rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidStartingUnits);

	  // DEFINE THE STARTING MOOSE:
	  int StartElkID=rmCreateObjectDef("starting moose");
	  if (seasonPicker < 0.5)
		  rmAddObjectDefItem(StartElkID, "berrybush", 4, 4.0);
	  else
	  {
		  rmAddObjectDefItem(StartElkID, "moose", 3, 4.0);
		  rmSetObjectDefCreateHerd(StartElkID, true);
	  }
	  rmSetObjectDefCreateHerd(StartElkID, true);
	  rmSetObjectDefMinDistance(StartElkID, 13);
	  rmSetObjectDefMaxDistance(StartElkID, 22);
	  rmAddObjectDefConstraint(StartElkID, avoidStartResource);
	  rmAddObjectDefConstraint(StartElkID, shortAvoidImpassableLand);
	  rmAddObjectDefConstraint(StartElkID, avoidNatives);
	  
	  // DEFINE THE STARTING SILVER MINES:
	  int startSilverID = rmCreateObjectDef("player silver");
	  rmAddObjectDefItem(startSilverID, "mine", 1, 5.0);
	  rmAddObjectDefConstraint(startSilverID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(startSilverID, greatLakesConstraint);
	  rmSetObjectDefMinDistance(startSilverID, 12.0);
	  rmSetObjectDefMaxDistance(startSilverID, 18.0);
	  rmAddObjectDefConstraint(startSilverID, avoidStartResource);
	  rmAddObjectDefConstraint(startSilverID, avoidImpassableLand);

	  // DEFINE THE WATER SPAWN FLAG:
	  int waterSpawnFlagID = rmCreateObjectDef("water spawn flag");
	  rmAddObjectDefItem(waterSpawnFlagID, "HomeCityWaterSpawnFlag", 1, 0);
	  rmSetObjectDefMinDistance(waterSpawnFlagID, rmXFractionToMeters(0.10));
	  rmSetObjectDefMaxDistance(waterSpawnFlagID, rmXFractionToMeters(0.19));
	  rmAddObjectDefConstraint(waterSpawnFlagID, HCspawnLand);
	
      // SET UP FOR FINDING CLOSEST LAND POINTS:
	  int avoidHCFlags=rmCreateHCGPConstraint("avoid HC flags", 20);
	  rmAddClosestPointConstraint(avoidImpassableLand);
	  //rmAddClosestPointConstraint(avoidTradeIslands);
	  rmAddClosestPointConstraint(avoidHCFlags);
/*================================================================================================================*/
// ********************* PLACING THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************* //
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
	{
	    int colonyShipID=rmCreateObjectDef("colony ship "+i);
	    if(rmGetPlayerCiv(i) == rmGetCivID("Ottomans"))
        rmAddObjectDefItem(colonyShipID, "Galley", 1, 0.0);
        else
        rmAddObjectDefItem(colonyShipID, "Caravel", 1, 0.0);
	    rmSetObjectDefGarrisonStartingUnits(colonyShipID, true);
	    rmSetObjectDefMinDistance(colonyShipID, 0.0);
	    rmSetObjectDefMaxDistance(colonyShipID, 10.0);
/*================================================================================================================*/
// *********************************** TEST OF MARCIN'S STARTING UNITS STUFF: *********************************** //
/*================================================================================================================*/
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartElkID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		if (seasonPicker < 0.5)
		{
		rmPlaceObjectDefAtLoc(waterSpawnFlagID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		}
	}
        // Clear out constraints for good measure.
        //rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/   
// ********************************** DEFINE SOME VARIABLES NEEDED LATER: *************************************** //
/*================================================================================================================*/ 	  
	  int numTries = -1;
	  int failCount = -1;
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// *********************** DEFINE AND PLACE THE NATIVES VILLAGES AND SECRETS OF THE WORLD: ********************** //
/*================================================================================================================*/	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois1VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.4, 0.15);
	} 
	
	    if (subCiv1 == rmGetCivID("iroquois"))
	{  
		int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.2, 0.8);
	} 
	
	    if (subCiv2 == rmGetCivID("iroquois"))
	{  
		int iroquois3VillageID = -1;
		iroquois3VillageID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois3VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois3VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.8, 0.2);
	} 
	
	if (subCiv3 == rmGetCivID("iroquois"))
	{  
		int iroquois4VillageID = -1;
		iroquois4VillageID = rmCreateGrouping("iroquois village 4", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois4VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois4VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois4VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois4VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.6, 0.85);
	} 
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE SILVER MINES: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    int mineType = -1;
    int mineID = -1;
	int silverTries=3*cNumberNonGaiaPlayers;

	int silverMineID = rmCreateObjectDef("silver mines 1");
	rmAddObjectDefItem(silverMineID, "mine", rmRandInt(1,1), 5.0);
	rmSetObjectDefMinDistance(silverMineID, 0.0);
	rmSetObjectDefMaxDistance(silverMineID, rmXFractionToMeters(0.44));
	rmAddObjectDefConstraint(silverMineID, avoidImpassableLand);
	rmAddObjectDefConstraint(silverMineID, greatLakesConstraint);
	rmAddObjectDefConstraint(silverMineID, avoidCoin);
	rmAddObjectDefConstraint(silverMineID, playerConstraint);
	rmAddObjectDefConstraint(silverMineID, avoidAll);
	rmAddObjectDefConstraint(silverMineID, Northward);
	rmAddObjectDefConstraint(silverMineID, avoidWater10);
	//rmAddObjectDefConstraint(silverMineID, avoidTradeSockets);
    
	for(i=0; <silverTries)
   {
	rmPlaceObjectDefAtLoc(silverMineID, 0, 0.5, 0.5);
   }
   
    int silver2MineID = rmCreateObjectDef("silver mines 2");
	rmAddObjectDefItem(silver2MineID, "mine", rmRandInt(1,1), 5.0);
	rmSetObjectDefMinDistance(silver2MineID, 0.0);
	rmSetObjectDefMaxDistance(silver2MineID, rmXFractionToMeters(0.44));
	rmAddObjectDefConstraint(silver2MineID, avoidImpassableLand);
	rmAddObjectDefConstraint(silver2MineID, greatLakesConstraint);
	rmAddObjectDefConstraint(silver2MineID, avoidCoin);
	rmAddObjectDefConstraint(silver2MineID, playerConstraint);
	rmAddObjectDefConstraint(silver2MineID, avoidAll);
	rmAddObjectDefConstraint(silver2MineID, Southward);
	rmAddObjectDefConstraint(silver2MineID, avoidWater10);
	//rmAddObjectDefConstraint(silver2MineID, avoidTradeSockets);
    
	for(i=0; <silverTries)
   {
	rmPlaceObjectDefAtLoc(silver2MineID, 0, 0.5, 0.5);
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/   
// ******************************** DEFINE AND PLACE FORESTS - NORTH AND SOUTH: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	        int forestTreeID = 0;
	
	        numTries=5*cNumberNonGaiaPlayers;  // DAL - 4 here, 4 below
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int northForest=rmCreateArea("northforest"+i);
			rmSetAreaWarnFailure(northForest, false);
			rmSetAreaSize(northForest, rmAreaTilesToFraction(200), rmAreaTilesToFraction(400));
			if (seasonPicker < 0.5)
				rmSetAreaForestType(northForest, "great lakes forest");
			else
				// rmSetAreaForestType(northForest, "great lakes forest snow");
				   rmSetAreaForestType(northForest, "saguenay forest");
			rmSetAreaForestDensity(northForest, 1.0);
			rmAddAreaToClass(northForest, rmClassID("classForest"));
			rmSetAreaForestClumpiness(northForest, 0.0);		
			rmSetAreaForestUnderbrush(northForest, 0.0);
			rmSetAreaBaseHeight(northForest, 2.0);
			rmSetAreaMinBlobs(northForest, 1);
			rmSetAreaMaxBlobs(northForest, 3);					
			rmSetAreaMinBlobDistance(northForest, 16.0);
			rmSetAreaMaxBlobDistance(northForest, 30.0);
			rmSetAreaCoherence(northForest, 0.4);
			rmSetAreaSmoothDistance(northForest, 1);
			rmAddAreaConstraint(northForest, avoidImportantItem);
			rmAddAreaConstraint(northForest, avoidNatives);
			//rmAddAreaConstraint(northForest, avoidTradeSockets);
			rmAddAreaConstraint(northForest, greatLakesConstraint);
			rmAddAreaConstraint(northForest, playerConstraintForest);
			rmAddAreaConstraint(northForest, forestConstraint);  
			rmAddAreaConstraint(northForest, Northward);				
			if(rmBuildArea(northForest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}
/*================================================================================================================*/
        	numTries=5*cNumberNonGaiaPlayers;  // DAL - 4 here, 4 above.
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int southForest=rmCreateArea("southforest"+i);
			rmSetAreaWarnFailure(southForest, false);
			rmSetAreaSize(southForest, rmAreaTilesToFraction(200), rmAreaTilesToFraction(300));
			if (seasonPicker < 0.5)
				rmSetAreaForestType(southForest, "great lakes forest");
			else
				// rmSetAreaForestType(southForest, "great lakes forest snow");
				   rmSetAreaForestType(southForest, "saguenay forest");
			rmSetAreaForestDensity(southForest, 1.0);
			rmAddAreaToClass(southForest, rmClassID("classForest"));
			rmSetAreaForestClumpiness(southForest, 0.0);		
			rmSetAreaForestUnderbrush(southForest, 0.0);
			rmSetAreaBaseHeight(southForest, 2.0);
			rmSetAreaMinBlobs(southForest, 1);
			rmSetAreaMaxBlobs(southForest, 3);						
			rmSetAreaMinBlobDistance(southForest, 16.0);
			rmSetAreaMaxBlobDistance(southForest, 30.0);
			rmSetAreaCoherence(southForest, 0.4);
			rmSetAreaSmoothDistance(southForest, 1);
			rmAddAreaConstraint(southForest, avoidImportantItem); 
			rmAddAreaConstraint(southForest, avoidNatives);
			//rmAddAreaConstraint(southForest, avoidTradeSockets);
			rmAddAreaConstraint(southForest, greatLakesConstraint);
			rmAddAreaConstraint(southForest, playerConstraintForest);   
			rmAddAreaConstraint(southForest, forestConstraint);   
			rmAddAreaConstraint(southForest, Southward);				
			if(rmBuildArea(southForest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		} 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.66);
/*================================================================================================================*/   
// ***************************** DEFINE AND PLACE SOME EXTRA NORTHERN DEER HERDS: ******************************* //
/*================================================================================================================*/  
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int deerHerdID=rmCreateObjectDef("northern deer herd");
	rmAddObjectDefItem(deerHerdID, "deer", rmRandInt(7,9), 6.0);
	rmSetObjectDefCreateHerd(deerHerdID, true);
	rmSetObjectDefMinDistance(deerHerdID, 0.0);
	rmSetObjectDefMaxDistance(deerHerdID, rmXFractionToMeters(0.50));
	rmAddObjectDefConstraint(deerHerdID, shortAvoidCoin);
	//rmAddObjectDefConstraint(deerHerdID, avoidTradeRoute);
	rmAddObjectDefConstraint(deerHerdID, shortPlayerConstraint);
	
	if (seasonPicker < 0.5)
	rmAddObjectDefConstraint(deerHerdID, greatLakesConstraint);
	rmAddObjectDefConstraint(deerHerdID, avoidAll);
	rmAddObjectDefConstraint(deerHerdID, avoidNatives);
	rmAddObjectDefConstraint(deerHerdID, avoidImpassableLand);
	rmAddObjectDefConstraint(deerHerdID, deerConstraint);
	rmAddObjectDefConstraint(deerHerdID, Northward);
	
	numTries=3*cNumberNonGaiaPlayers;
	for (i=0; <numTries)
	{
		rmPlaceObjectDefAtLoc(deerHerdID, 0, 0.5, 0.5);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.69);
/*================================================================================================================*/   
// ****************************** DEFINE AND PLACE SOME EXTRA SOUTHERN DEER HERDS: ****************************** // 
/*================================================================================================================*/              
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    int deerHerdID2=rmCreateObjectDef("southern deer herd");
	rmAddObjectDefItem(deerHerdID2, "deer", rmRandInt(7,9), 6.0);
	rmSetObjectDefCreateHerd(deerHerdID2, true);
	rmSetObjectDefMinDistance(deerHerdID2, 0.0);
	rmSetObjectDefMaxDistance(deerHerdID2, rmXFractionToMeters(0.50));
	rmAddObjectDefConstraint(deerHerdID2, shortAvoidCoin);
	rmAddObjectDefConstraint(deerHerdID2, shortPlayerConstraint);
	//rmAddObjectDefConstraint(deerHerdID2, avoidTradeRoute);
	
	if (seasonPicker < 0.5)
	rmAddObjectDefConstraint(deerHerdID2, greatLakesConstraint);
	rmAddObjectDefConstraint(deerHerdID2, avoidAll);
	rmAddObjectDefConstraint(deerHerdID2, avoidNatives);
	rmAddObjectDefConstraint(deerHerdID2, avoidImpassableLand);
	rmAddObjectDefConstraint(deerHerdID2, deerConstraint);
	rmAddObjectDefConstraint(deerHerdID2, Southward);
	
	numTries=3*cNumberNonGaiaPlayers;
	for (i=0; <numTries)
	{
		rmPlaceObjectDefAtLoc(deerHerdID2, 0, 0.5, 0.5);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// *************************************** PLACE SOME EXTRA MOOSE HERDS: **************************************** //
/*================================================================================================================*/  
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    int mooseHerdID=rmCreateObjectDef("moose herd");
	rmAddObjectDefItem(mooseHerdID, "moose", rmRandInt(2,3), 6.0);
	rmSetObjectDefCreateHerd(mooseHerdID, true);
	rmSetObjectDefMinDistance(mooseHerdID, 0.0);
	rmSetObjectDefMaxDistance(mooseHerdID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(mooseHerdID, shortAvoidCoin);
	
	if (seasonPicker < 0.5)
	
	rmAddObjectDefConstraint(mooseHerdID, greatLakesConstraint);
	rmAddObjectDefConstraint(mooseHerdID, avoidAll);
	rmAddObjectDefConstraint(mooseHerdID, avoidNatives);
	rmAddObjectDefConstraint(mooseHerdID, shortPlayerConstraint);
	//rmAddObjectDefConstraint(mooseHerdID, avoidTradeRoute);
	rmAddObjectDefConstraint(mooseHerdID, avoidImpassableLand);
    rmAddObjectDefConstraint(mooseHerdID, mooseConstraint);
	rmAddObjectDefConstraint(mooseHerdID, shortDeerConstraint);
	
	numTries=3*cNumberNonGaiaPlayers;
	for (i=0; <numTries)
	{
		rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.5, 0.5);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/   
// **************************************** DEFINE AND PLACE THE FISHES: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    // int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);

	int fishID=rmCreateObjectDef("fish");
	rmAddObjectDefItem(fishID, "FishBass", 5, 8.0);
	rmSetObjectDefMinDistance(fishID, 0.0);
	rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(fishID, fishVsFishID);
	rmAddObjectDefConstraint(fishID, fishLand);
   	
	if (seasonPicker < 0.5)
	rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
	else
	rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// ************************* DEFINE AND PLACE DECORATIONS: ROCKS AND GRASS AND STUFF: *************************** // 
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      // DEFINE NUGGET HARD:
		int nugget3= rmCreateObjectDef("nugget hard"); 
		rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(1, 3);
		rmAddObjectDefToClass(nugget3, rmClassID("nuggets"));
		rmSetObjectDefMinDistance(nugget3, 0.15);
		rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.45));
		rmAddObjectDefConstraint(nugget3, shortPlayerConstraint);
		rmAddObjectDefConstraint(nugget3, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget3, avoidNuggets);
		rmAddObjectDefConstraint(nugget3, nuggetsAvoidNuggets);
		//rmAddObjectDefConstraint(nugget3, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget3, circleConstraint);
		rmAddObjectDefConstraint(nugget3, avoidAll);
		rmAddObjectDefConstraint(nugget3, avoidNatives);
		rmAddObjectDefConstraint(nugget3, greatLakesConstraint);
		rmPlaceObjectDefAtLoc(nugget3, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE SHEEPS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      // SHEEP FOR THE NORTHERN:
	  int sheep1ID=rmCreateObjectDef("sheep 1");
	  rmAddObjectDefItem(sheep1ID, "sheep", 2, 4.0);
	  rmSetObjectDefMinDistance(sheep1ID, 0.0);
	  rmSetObjectDefMaxDistance(sheep1ID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(sheep1ID, avoidSheep);
	  rmAddObjectDefConstraint(sheep1ID, avoidAll);
	  rmAddObjectDefConstraint(sheep1ID, avoidWater10);
	  rmAddObjectDefConstraint(sheep1ID, avoidNatives);
	  rmAddObjectDefConstraint(sheep1ID, playerConstraint);
      rmAddObjectDefConstraint(sheep1ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
	  
	  // SHEEP FOR THE SOUTHERN:
	  int sheep2ID=rmCreateObjectDef("sheep 2");
	  rmAddObjectDefItem(sheep2ID, "sheep", 2, 4.0);
	  rmSetObjectDefMinDistance(sheep2ID, 0.0);
	  rmSetObjectDefMaxDistance(sheep2ID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(sheep2ID, avoidSheep);
	  rmAddObjectDefConstraint(sheep2ID, avoidAll);
	  rmAddObjectDefConstraint(sheep2ID, avoidWater10);
	  rmAddObjectDefConstraint(sheep2ID, avoidNatives);
	  rmAddObjectDefConstraint(sheep2ID, playerConstraint);
      rmAddObjectDefConstraint(sheep2ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE RANDOM TREES: ************************************* //
/*================================================================================================================*/
    int randomTrees=rmCreateObjectDef("random trees");
	
	if (seasonPicker < 0.5)
		  //rmAddObjectDefItem(randomTrees, "TreeGreatLakes", 3, 4.0);
		  rmAddObjectDefItem(randomTrees, "TreeGreatLakes", rmRandInt(1,3), 4.0);
	  else
		  // rmAddObjectDefItem(randomTrees, "TreeGreatLakesSnow", 3, 4.0);
		     rmAddObjectDefItem(randomTrees, "TreeSaguenay", 3, 4.0);
	         
	rmSetObjectDefMinDistance(randomTrees, 0.0);
	rmSetObjectDefMaxDistance(randomTrees, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(randomTrees, avoidAll);
	rmAddObjectDefConstraint(randomTrees, playerConstraint);
	rmAddObjectDefConstraint(randomTrees, farGreatLakesConstraint);
	rmAddObjectDefConstraint(randomTrees, avoidImpassableLand);
	rmAddObjectDefConstraint(randomTrees, avoidNatives);
	
	rmPlaceObjectDefAtLoc(randomTrees, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);   	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}  
}
/*================================================================================================================*/
// **************************************** THIS IS THE END OF THE MAP: ***************************************** //  
/*================================================================================================================*/
		