/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //  
/*================================================================================================================*/
// LAKE THOMPSON:
// CREATED BY DANY:
// DECEMBRE 2006:
/*================================================================================================================*/
// *********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ****************************************** CHOOSE THE NATIVE TRIBES:****************************************** //
/*================================================================================================================*/
      int subCiv0=-1;
      int subCiv1=-1;
      int subCiv2=-1;
      int subCiv3=-1;
      int subCiv4=-1;
      int subCiv5=-1;
      int subCiv6=-1;
	  
	    if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Iroquois");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Iroquois");

		subCiv1=rmGetCivID("Iroquois");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Iroquois"); 

		subCiv2=rmGetCivID("Iroquois");
      if (subCiv2 >= 0)
         rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
      if (subCiv3 >= 0)
         rmSetSubCiv(3, "Iroquois");
		 
		 subCiv4=rmGetCivID("Iroquois");
      if (subCiv4 >= 0)
         rmSetSubCiv(4, "Iroquois");

		subCiv5=rmGetCivID("Iroquois");
      if (subCiv5 >= 0)
         rmSetSubCiv(5, "Iroquois");
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// ******************************************* DEFINE THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
      int playerTiles = 30000;
	  	   	
	  int size=1.7*sqrt(cNumberNonGaiaPlayers*playerTiles);
	  int longSide=1.4*size;      // 'Longside' is used to make the map rectangular
	  rmEchoInfo("Map size="+size+"m x "+longSide+"m");
	  rmSetMapSize(longSide, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// ***************************************** PICKS THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
	  // SET THE MAP ELEVATION PARAMETERS:
	  // rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	  //rmSetMapElevationParameters(cElevTurbulence, 0.05, 10, 0.4, 7.0);
	  //rmSetMapElevationHeightBlend(1);
	  // rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation) // FROM SAGUENAY:
	  rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.3, 2.0); // FROM SAGUENAY:
	
	  // PICKS A DEFAULT WATER HEIGHT:
	  //rmSetSeaLevel(5.0);
	  rmSetSeaLevel(5.0); // FROM SAGUENAY:
	  
	  // SET THE LIGHTING:
	  //rmSetLightingSet("Pampas");
	  rmSetLightingSet("saguenay"); // FROM SAGUENAY:

      // PICKS THE DEFAULT TERRAIN AND WATER:
	  //rmSetSeaType("Pampas River");
	  rmSetSeaType("hudson bay"); // FROM SAGUENAY:
	  
	  // SET THE BASE TERRAIN MIX:
	  //rmSetBaseTerrainMix("pampas_dirt");
	  rmSetBaseTerrainMix("saguenay tundra"); // FROM SAGUENAY:
	  
	  // TERRAIN INITIALIZATION:
	  //rmTerrainInitialize("pampas\ground5_pam", 6.0);
	  //rmTerrainInitialize("saguenay\ground1_sag",10); // FROM SAGUENAY:
	  rmTerrainInitialize("saguenay\ground1_sag",6.0); // FROM SAGUENAY:
	  	  
	  // ENABLE LOCAL WATER:
	  //rmEnableLocalWater(false);
	  rmEnableLocalWater(false); // FROM SAGUENAY:
	  
	  // SET THE MAP TYPES:
	  //rmSetMapType("grass");
	  rmSetMapType("grass"); // FROM SAGUENAY:
	  //rmSetMapType("land");
	  rmSetMapType("water"); // FROM SAGUENAY:
	  //rmSetMapType("pampas");
	  rmSetMapType("saguenay"); // FROM SAGUENAY:
	  
	  // SET THE WORLD CIRCLE CONSTRAINT:
	  rmSetWorldCircleConstraint(true);
	  
	  // SET THE WIND MAGNITUDE:
	  rmSetWindMagnitude(2.0);

	  // CHOOSE THE MERCS:
	  chooseMercs();
		
      // REMOVED BY ENSEMBLE:
	  //rmSetLightingSet("alfheim");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/   
// ******************************************** DEFINE THE CLASSES: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int classPlayer=rmDefineClass("player");
	  rmDefineClass("startingUnit");
	  rmDefineClass("classForest");
	  rmDefineClass("natives");
	  rmDefineClass("classSocket");
	  rmDefineClass("bay");
	  rmDefineClass("nuggets");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ******************************************* DEFINE THE CONSTRAINTS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      // MAP EDGE CONSTRAINTS:
	  int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(25), rmZTilesToFraction(25), 1.0-rmXTilesToFraction(25), 1.0-rmZTilesToFraction(25), 0.01);
	  int longplayerEdgeConstraint=rmCreateBoxConstraint("long player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
	
	  // CARDINAL DIRECTIONS:
	  int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	  int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	  int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	  int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
	
	  // PLAYER CONSTRAINTS:
	  int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
	  int closePlayerConstraint=rmCreateClassDistanceConstraint("close stay away from players", classPlayer, 15.0);
	  int mediumPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players medium", classPlayer, 15.0);
	  int shortPlayerConstraint=rmCreateClassDistanceConstraint("short stay away from players", classPlayer, 5.0);
	  int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
      
	  // FOREST AVOIDANCE:
	  int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
	  int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 60.0);
	  
	  int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
	  int shortAvoidResource=rmCreateTypeDistanceConstraint("resource avoid resource short", "resource", 5.0);
	  //int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 30.0);
	  int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 10.0);
	
      // SHIPS VS. SHIPS:
      int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 5.0);
	  
	  // NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
	  int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	  int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	  int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
 	  		
	  // AVOID IMPASSABLE LAND:
	  int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
	  int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	  int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
		
	   // COIN AVOIDANCE:
	  int avoidCoin=rmCreateTypeDistanceConstraint("stuffs avoid coin", "minegold", 8.0);
      int closeAvoidCoin=rmCreateTypeDistanceConstraint("close stuffs avoid coin", "minegold", 2.0);	  
	  int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoid coin", "minegold", 20.0);
	  
	  // DEER AVOIDANCE:
	  int avoidDeer=rmCreateTypeDistanceConstraint("stuffs avoid deer", "deer", 12.0);	
	  int closeAvoidDeer=rmCreateTypeDistanceConstraint("close stuffs avoid deer", "deer", 2.0);	
	  int deerAvoidDeer=rmCreateTypeDistanceConstraint("deer avoid deer", "deer", 20.0);
	  
	  // SHEEP AVOIDANCE:
	  int avoidSheep=rmCreateTypeDistanceConstraint("stuffs avoid sheep", "sheep", 8.0);
      int closeAvoidSheep=rmCreateTypeDistanceConstraint("close stuffs avoid sheep", "sheep", 2.0);	  
	  int sheepAvoidSheep=rmCreateTypeDistanceConstraint("sheep avoid sheep", "sheep", 20.0);
	  
	  // TREE AVOIDANCE:
	  int avoidTree=rmCreateTypeDistanceConstraint("stuffs avoid tree", "TreeSaguenay", 5.0);	
	  int treeAvoidTree=rmCreateTypeDistanceConstraint("tree avoid tree", "TreeSaguenay", 20.0);
	  
	  // NUGGETS AVOIDANCE:
	  int avoidNugget=rmCreateClassDistanceConstraint("stuff avoids nugget", rmClassID("nuggets"), 10.0);
	  int closeAvoidNugget=rmCreateClassDistanceConstraint("close stuff avoids nugget", rmClassID("nuggets"), 2.0);
	  int nuggetAvoidNugget=rmCreateClassDistanceConstraint("nugget avoids nugget", rmClassID("nuggets"), 20.0);
	 
		
	  // SEAFOOD AVOIDANCE:
	  int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 15.0);
      int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 18.0);
      int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
      int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
		  
	  // UNIT AVOIDANCE:
	  int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
	  int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
	
	  // NATIVES AVOIDANCE:
	  int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
	  int closeAvoidNatives=rmCreateClassDistanceConstraint("close stuff avoids natives", rmClassID("natives"), 2.0);
      int avoidCloseNatives=rmCreateClassDistanceConstraint("Gift avoids natives", rmClassID("natives"), 1.0);
 
	  // DECORATION AVOIDANCE:
	  int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 7.0);

	  // VP AVOIDANCE:
      //int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
      
	  // SOCKET AVOIDANCE:
	  int avoidSocket=rmCreateClassDistanceConstraint("stuffs avoid socket", rmClassID("classSocket"), 10.0);
	  int closeAvoidSocket=rmCreateClassDistanceConstraint("close stuffs avoid socket", rmClassID("classSocket"), 4.0);
	
	  
	  // TRADE ROUTE AVOIDANCE:
	  int shortAvoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route short", 5.0);
	  int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
	  int closeAvoidTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 2.0);
	  int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);
	  int avoidTradeRouteSockets=rmCreateTypeDistanceConstraint("avoid trade route sockets", "sockettraderoute", 15.0);
	  int avoidTradeRouteSocketsFar=rmCreateTypeDistanceConstraint("avoid trade route sockets far", "sockettraderoute", 40.0);
	  int avoidMineSockets=rmCreateTypeDistanceConstraint("avoid mine sockets", "mine", 10.0);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// ********************************** DEFINE AND PLACE THE 2 TRADE ROUTES: ************************************** //
/*================================================================================================================*/ 
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	  int tradeRouteID = rmCreateTradeRoute();
      int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRouteID, 0.25, 0.75);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.25, 0.25);
	  //rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.2, 0.3, 10, 4);

      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  //socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
      //rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 1.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 2:
	  int tradeRoute2ID = rmCreateTradeRoute();
      socketID=rmCreateObjectDef("sockets to dock Trade Posts north");
      rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.75, 0.75);
	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.75, 0.25);
	  //rmAddRandomTradeRouteWaypoints(tradeRoute2ID, 0.2, 0.7, 10, 4);

      placedTradeRoute = rmBuildTradeRoute(tradeRoute2ID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 2:
      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  //socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.5);
      //rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 1.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ******************** SET UP PLAYER STARTING LOCATIONS: RECTANGULAR AT FAR ENDS OF THE MAP: ******************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if ( cNumberTeams == 2 )
	{
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.865,0.50);
				
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.105,0.50);
   	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ****************************************** SET UP THE PLAYER AREAS: ****************************************** //
/*================================================================================================================*/
     float playerFraction=rmAreaTilesToFraction(100);
/*----------------------------------------------------------------------------------------------------------------*/	  
      for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
   {
      // CREATE THE AREA:
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
      
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
	  
	  // SET THE AREA MIX:
	  //rmSetAreaMix(id, "pampas_grass");
	  rmSetAreaMix(id, "saguenay grass"); // FROM SAGUENAY:
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD AREA CONSTRAINT:
	  rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, playerEdgeConstraint); 
	  rmSetAreaCoherence(id, 1.0);
      //rmAddAreaConstraint(id, avoidWater);
	  rmAddAreaConstraint(id, longAvoidImpassableLand);
	  
	  // SET AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
	  
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
   }
/*----------------------------------------------------------------------------------------------------------------*/
	  // BUILD THE AREAS:
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ************************************** DEFINE THE ANDES CLIFFS 1: ******************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
         int andesCliffs = rmCreateArea("The Andes Cliffs 1");
         rmAddAreaInfluenceSegment(andesCliffs, 0.0, 1.0, 1.0, 1.0);   
         rmSetAreaLocation(andesCliffs, 0.5, 1.0);
         rmSetAreaSize(andesCliffs, 0.025, 0.025);
         //rmSetAreaMix(andesCliffs, "texas_dirt");
		 rmSetAreaMix(andesCliffs, "saguenay grass"); // FROM SAGUENAY:

         rmSetAreaCoherence(andesCliffs, 0.75);
         rmSetAreaEdgeFilling(andesCliffs, 1.0);
         rmSetAreaSmoothDistance(andesCliffs, 10.0);
         rmSetAreaHeightBlend(andesCliffs, 6.0);
   
         // SPECIFIC CLIFF STUFF:
         rmSetAreaCliffHeight(andesCliffs, 8.0, 2.0, 0.0);
         rmSetAreaCliffType(andesCliffs, "New England");
         rmSetAreaCliffEdge(andesCliffs, 1.0, 1.0, 0.0, 1.0, 0);
         rmSetAreaCliffPainting(andesCliffs, true, true, true, 1.0, true);

         rmSetAreaWarnFailure(andesCliffs, false);
         rmBuildArea(andesCliffs);
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************** DEFINE THE ANDES CLIFFS 2: ******************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
         int andes2Cliffs = rmCreateArea("The Andes Cliffs 2");
         rmAddAreaInfluenceSegment(andes2Cliffs, 0.0, 0.0, 1.0, 0.0);   
         rmSetAreaLocation(andes2Cliffs, 0.5, 0.0);
         rmSetAreaSize(andes2Cliffs, 0.025, 0.025);
         //rmSetAreaMix(andes2Cliffs, "texas_dirt");
		 rmSetAreaMix(andes2Cliffs, "saguenay grass"); // FROM SAGUENAY:

         rmSetAreaCoherence(andes2Cliffs, 0.75);
         rmSetAreaEdgeFilling(andes2Cliffs, 1.0);
         rmSetAreaSmoothDistance(andes2Cliffs, 10.0);
         rmSetAreaHeightBlend(andes2Cliffs, 6.0);
   
         // SPECIFIC CLIFF STUFF:
         rmSetAreaCliffHeight(andes2Cliffs, 8.0, 2.0, 0.0);
         rmSetAreaCliffType(andes2Cliffs, "New England");
	   
         rmSetAreaCliffEdge(andes2Cliffs, 1.0, 1.0, 0.0, 1.0, 0);
         rmSetAreaCliffPainting(andes2Cliffs, true, true, true, 1.0, true);

         rmSetAreaWarnFailure(andes2Cliffs, false);
         rmBuildArea(andes2Cliffs); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// **************************************** CREATE THE BAY S AREAS: ********************************************* //
/*================================================================================================================*/
	  int bay1ID=rmCreateArea("Bay 1");
      rmSetAreaSize(bay1ID, 0.09, 0.09);
	  rmSetAreaLocation(bay1ID, 0.5, 0.5);
	  rmSetAreaWaterType(bay1ID, "saguenay lake");
	  rmSetAreaBaseHeight(bay1ID, 6.0); // Was 10
      rmSetAreaMinBlobs(bay1ID, 1);
      rmSetAreaMaxBlobs(bay1ID, 1);
      rmSetAreaMinBlobDistance(bay1ID, 1);
      rmSetAreaMaxBlobDistance(bay1ID, 1);
      rmSetAreaSmoothDistance(bay1ID, 50);
      rmSetAreaCoherence(bay1ID, 0.4);
	  rmAddAreaToClass(bay1ID, rmClassID("bay"));
      rmSetAreaObeyWorldCircleConstraint(bay1ID, false);
	  rmAddAreaConstraint(bay1ID, avoidNatives);
	  rmAddAreaConstraint(bay1ID, avoidTradeRoute);
	  rmAddAreaConstraint(bay1ID, avoidSocket);
	  rmAddAreaConstraint(bay1ID, avoidDeer);
	  rmBuildArea(bay1ID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ******************************** DEFINE THE STARTING TCID AND STARTING UNITS: ******************************** //
/*================================================================================================================*/
      // DEFINE THE STARTING TCID:
	  int startingTCID= rmCreateObjectDef("startingTC");
	  if (rmGetNomadStart())
		{
			rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 5.0);
		}
		else
		{
            rmAddObjectDefItem(startingTCID, "townCenter", 1, 5.0);
		}
	  rmSetObjectDefMinDistance(startingTCID, 0);
	  rmSetObjectDefMaxDistance(startingTCID, 0);
	  rmAddObjectDefConstraint(startingTCID, avoidImpassableLand);
	  rmAddObjectDefConstraint(startingTCID, shortAvoidTradeRoute);
	  rmAddObjectDefConstraint(startingTCID, avoidTradeRouteSockets);
	  rmAddObjectDefToClass(startingTCID, rmClassID("player"));
	  rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	  	  
	  // DEFINE THE STARTING UNITS:
	  int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	  rmSetObjectDefMinDistance(startingUnits, 5.0);
      rmSetObjectDefMaxDistance(startingUnits, 10.0);
	  rmAddObjectDefConstraint(startingUnits, avoidAll);
	  rmAddObjectDefConstraint(startingUnits, avoidResource);
	  rmAddObjectDefConstraint(startingUnits, avoidImpassableLand);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ************************************** DEFINE THE STARTING RESOURCES: **************************************** //
/*================================================================================================================*/
      // DEFINE THE STARTING TREES:
	  int StartAreaTreeID=rmCreateObjectDef("starting trees");
	  //rmAddObjectDefItem(StartAreaTreeID, "TreePampas", 3, 6.0);
	  rmAddObjectDefItem(StartAreaTreeID, "TreeSaguenay", rmRandInt(9,15), 10.0); // FROM SAGUENAY:
	  rmSetObjectDefMinDistance(StartAreaTreeID, 18);
	  rmSetObjectDefMaxDistance(StartAreaTreeID, 24);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
	  rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidImpassableLand);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidNatives);
      //rmAddObjectDefConstraint(StartAreaTreeID, playerConstraint);
	  //rmPlaceObjectDefPerPlayer(StartAreaTreeID, true);

	  // DEFINE THE STARTING BERRIES:
	  int StartBerriesID=rmCreateObjectDef("starting berries");
	  rmAddObjectDefItem(StartBerriesID, "berrybush", 3, 5.0);
	  rmSetObjectDefMinDistance(StartBerriesID, 12);
	  rmSetObjectDefMaxDistance(StartBerriesID, 20);
	  rmAddObjectDefConstraint(StartBerriesID, avoidStartResource);
	  rmAddObjectDefConstraint(StartBerriesID, shortAvoidImpassableLand);
	  rmAddObjectDefConstraint(StartBerriesID, avoidNatives);
	  rmAddObjectDefConstraint(StartBerriesID, shortPlayerConstraint);
  
   	  // DEFINE THE STARTING SILVER MINES:
	  int startSilverID = rmCreateObjectDef("player silver");
	  rmAddObjectDefItem(startSilverID, "mine", 1, 0);
	  rmAddObjectDefConstraint(startSilverID, shortAvoidTradeRoute);
	  rmSetObjectDefMinDistance(startSilverID, 12.0);
	  rmSetObjectDefMaxDistance(startSilverID, 20.0);
	  rmAddObjectDefConstraint(startSilverID, avoidAll);
	  rmAddObjectDefConstraint(startSilverID, avoidImpassableLand);
	  
	  // DEFINE THE PLAYER NUGGET:
	  int playerNuggetID=rmCreateObjectDef("player nugget");
	  rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	  rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
      rmSetObjectDefMinDistance(playerNuggetID, 30.0);
      rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	  rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	  rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ******************************************* JOHN'S SWEET SOLUTION: ******************************************* //
// ************ TO PLACING STUFF AROUND THE TC REGARDLESS OF WHERE THE PLAYER START AREA ACTUALLY IS: *********** //
/*================================================================================================================*/
        for(i=1; <cNumberPlayers)
	{
	    rmClearClosestPointConstraints();
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLocation=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		// PLACING THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
    }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
       if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois1VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois1VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.5, 0.9);
	} 

	if (subCiv1 == rmGetCivID("iroquois"))
	{  
		int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois2VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.8, 0.9);
	} 

	if (subCiv2 == rmGetCivID("iroquois"))
	{  
		int iroquois3VillageID = -1;
		iroquois3VillageID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois3VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois3VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois3VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.2, 0.9);
	}

	if (subCiv3 == rmGetCivID("iroquois"))
	{  
		int iroquois4VillageID = -1;
		iroquois4VillageID = rmCreateGrouping("iroquois village 4", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois4VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois4VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois4VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois4VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois4VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.5, 0.1);
	} 
	
	    if (subCiv4 == rmGetCivID("iroquois"))
	{  
		int iroquois5VillageID = -1;
		iroquois5VillageID = rmCreateGrouping("iroquois village 5", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois5VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois5VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois5VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois5VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois5VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois5VillageID, avoidSocket);
		rmPlaceGroupingAtLoc(iroquois5VillageID, 0, 0.8, 0.1);
	} 

	    if (subCiv5 == rmGetCivID("iroquois"))
	{  
		int iroquois6VillageID = -1;
		iroquois6VillageID = rmCreateGrouping("iroquois village 6", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois6VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois6VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois6VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois6VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois6VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois6VillageID, avoidSocket);
		rmPlaceGroupingAtLoc(iroquois6VillageID, 0, 0.2, 0.1);
	} 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE TERRAIN PATCHES: ************************************ //
/*================================================================================================================*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE WACKY SILVER MINES: ************************************ //
/*================================================================================================================*/
   // Scattered MINES
	int goldID = rmCreateObjectDef("random gold 1");
	rmAddObjectDefItem(goldID, "minegold", 1, 9);
	//rmAddObjectDefItem(goldID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(goldID, 0.0);
	//rmSetObjectDefMaxDistance(goldID, rmXFractionToMeters(0.5));
	rmSetObjectDefMaxDistance(goldID, 0.0);
	//rmAddObjectDefConstraint(goldID, edgeConstraint);
	//rmAddObjectDefConstraint(goldID, North2ward);
	//rmAddObjectDefConstraint(goldID, avoidCaribou);
	//rmAddObjectDefConstraint(goldID, avoidFruits);
	//rmAddObjectDefConstraint(goldID, avoidAll);
	rmAddObjectDefConstraint(goldID, avoidTradeRoute);
	rmAddObjectDefConstraint(goldID, avoidSocket);
	rmAddObjectDefConstraint(goldID, avoidCoin);
	//rmAddObjectDefConstraint(goldID, avoidForest);
	rmAddObjectDefConstraint(goldID, coinAvoidCoin);
    //rmAddObjectDefConstraint(goldID, avoidImpassableLand);
	//rmAddObjectDefConstraint(goldID, canyonConstraint);
	rmPlaceObjectDefAtLoc(goldID, 0, 0.40, 0.9);
	
	// Scattered MINES
	int gold2ID = rmCreateObjectDef("random gold 2");
	rmAddObjectDefItem(gold2ID, "minegold", 1, 9);
	//rmAddObjectDefItem(gold2ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold2ID, 0.0);
	rmSetObjectDefMaxDistance(gold2ID, 0.0);
	//rmSetObjectDefMaxDistance(gold2ID, rmXFractionToMeters(0.5));
	//rmAddObjectDefConstraint(gold2ID, edgeConstraint);
	//rmAddObjectDefConstraint(gold2ID, South2ward);
	//rmAddObjectDefConstraint(gold2ID, avoidAll);
	//rmAddObjectDefConstraint(gold2ID, avoidCaribou);
	//rmAddObjectDefConstraint(gold2ID, avoidFruits);
	//rmAddObjectDefConstraint(gold2ID, avoidForest);
	rmAddObjectDefConstraint(gold2ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold2ID, avoidSocket);
	rmAddObjectDefConstraint(gold2ID, avoidCoin);
	rmAddObjectDefConstraint(gold2ID, coinAvoidCoin);
    //rmAddObjectDefConstraint(gold2ID, avoidImpassableLand);
	//rmAddObjectDefConstraint(gold2ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold2ID, 0, 0.30, 0.9);
	
	// Scattered MINES
	int gold3ID = rmCreateObjectDef("random gold 3");
	rmAddObjectDefItem(gold3ID, "minegold", 1, 9);
	//rmAddObjectDefItem(gold3ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold3ID, 0.0);
	rmSetObjectDefMaxDistance(gold3ID, 0.0);
	//rmSetObjectDefMaxDistance(gold3ID, rmXFractionToMeters(0.5));
	//rmAddObjectDefConstraint(gold3ID, edgeConstraint);
	//rmAddObjectDefConstraint(gold3ID, East2ward);
	//rmAddObjectDefConstraint(gold3ID, avoidAll);
	//rmAddObjectDefConstraint(gold3ID, avoidCaribou);
	//rmAddObjectDefConstraint(gold3ID, avoidFruits);
	//rmAddObjectDefConstraint(gold3ID, avoidForest);
	rmAddObjectDefConstraint(gold3ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold3ID, avoidSocket);
	rmAddObjectDefConstraint(gold3ID, avoidCoin);
	rmAddObjectDefConstraint(gold3ID, coinAvoidCoin);
    //rmAddObjectDefConstraint(gold3ID, avoidImpassableLand);
	//rmAddObjectDefConstraint(gold3ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold3ID, 0, 0.7, 0.9);
	
	// Scattered MINES
	int gold4ID = rmCreateObjectDef("random gold 4");
	rmAddObjectDefItem(gold4ID, "minegold", 1, 9);
	//rmAddObjectDefItem(gold4ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold4ID, 0.0);
	rmSetObjectDefMaxDistance(gold4ID, 0.0);
	//rmSetObjectDefMaxDistance(gold4ID, rmXFractionToMeters(0.5));
	//rmAddObjectDefConstraint(gold4ID, edgeConstraint);
	//rmAddObjectDefConstraint(gold4ID, West2ward);
	//rmAddObjectDefConstraint(gold4ID, avoidAll);
	//rmAddObjectDefConstraint(gold4ID, avoidCaribou);
	//rmAddObjectDefConstraint(gold4ID, avoidFruits);
	//rmAddObjectDefConstraint(gold4ID, avoidForest);
	rmAddObjectDefConstraint(gold4ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold4ID, avoidSocket);
	rmAddObjectDefConstraint(gold4ID, avoidCoin);
	rmAddObjectDefConstraint(gold4ID, coinAvoidCoin);
    //rmAddObjectDefConstraint(gold4ID, avoidImpassableLand);
	//rmAddObjectDefConstraint(gold4ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold4ID, 0, 0.6, 0.9);
	
		// Scattered MINES
	int gold5ID = rmCreateObjectDef("random gold 5");
	rmAddObjectDefItem(gold5ID, "minegold", 1, 9);
	//rmAddObjectDefItem(gold5ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold5ID, 0.0);
	rmSetObjectDefMaxDistance(gold5ID, 0.0);
	//rmSetObjectDefMaxDistance(gold5ID, rmXFractionToMeters(0.5));
	//rmAddObjectDefConstraint(gold5ID, edgeConstraint);
	//rmAddObjectDefConstraint(gold5ID, North5ward);
	//rmAddObjectDefConstraint(gold5ID, avoidAll);
	//rmAddObjectDefConstraint(gold5ID, avoidCaribou);
	//rmAddObjectDefConstraint(gold5ID, avoidFruits);
	//rmAddObjectDefConstraint(gold5ID, avoidForest);
	rmAddObjectDefConstraint(gold5ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold5ID, avoidSocket);
	rmAddObjectDefConstraint(gold5ID, avoidCoin);
	rmAddObjectDefConstraint(gold5ID, coinAvoidCoin);
    //rmAddObjectDefConstraint(gold5ID, avoidImpassableLand);
	//rmAddObjectDefConstraint(gold5ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold5ID, 0, 0.3, 0.1);
	
	// Scattered MINES
	int gold6ID = rmCreateObjectDef("random gold 6");
	rmAddObjectDefItem(gold6ID, "minegold", 1, 9);
	//rmAddObjectDefItem(gold6ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold6ID, 0.0);
	rmSetObjectDefMaxDistance(gold6ID, 0.0);
	//rmSetObjectDefMaxDistance(gold6ID, rmXFractionToMeters(0.5));
	//rmAddObjectDefConstraint(gold6ID, edgeConstraint);
	//rmAddObjectDefConstraint(gold6ID, South5ward);
	//rmAddObjectDefConstraint(gold6ID, avoidAll);
	//rmAddObjectDefConstraint(gold6ID, avoidCaribou);
	//rmAddObjectDefConstraint(gold6ID, avoidFruits);
	//rmAddObjectDefConstraint(gold6ID, avoidForest);
	rmAddObjectDefConstraint(gold6ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold6ID, avoidSocket);
	rmAddObjectDefConstraint(gold6ID, avoidCoin);
	rmAddObjectDefConstraint(gold6ID, coinAvoidCoin);
    //rmAddObjectDefConstraint(gold6ID, avoidImpassableLand);
	//rmAddObjectDefConstraint(gold6ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold6ID, 0, 0.4, 0.1);
	
	// Scattered MINES
	int gold7ID = rmCreateObjectDef("random gold 7");
	rmAddObjectDefItem(gold7ID, "minegold", 1, 9);
	//rmAddObjectDefItem(gold7ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold7ID, 0.0);
	rmSetObjectDefMaxDistance(gold7ID, 0.0);
	//rmSetObjectDefMaxDistance(gold7ID, rmXFractionToMeters(0.5));
	//rmAddObjectDefConstraint(gold7ID, edgeConstraint);
	//rmAddObjectDefConstraint(gold7ID, East5ward);
	//rmAddObjectDefConstraint(gold7ID, avoidAll);
	//rmAddObjectDefConstraint(gold7ID, avoidCaribou);
	//rmAddObjectDefConstraint(gold7ID, avoidFruits);
	//rmAddObjectDefConstraint(gold7ID, avoidForest);
	rmAddObjectDefConstraint(gold7ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold7ID, avoidSocket);
	rmAddObjectDefConstraint(gold7ID, avoidCoin);
	rmAddObjectDefConstraint(gold7ID, coinAvoidCoin);
    //rmAddObjectDefConstraint(gold7ID, avoidImpassableLand);
	//rmAddObjectDefConstraint(gold7ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold7ID, 0, 0.6, 0.1);
	
	// Scattered MINES
	int gold8ID = rmCreateObjectDef("random gold 8");
	rmAddObjectDefItem(gold8ID, "minegold", 1, 9);
	//rmAddObjectDefItem(gold8ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold8ID, 0.0);
	rmSetObjectDefMaxDistance(gold8ID, 0.0);
	//rmSetObjectDefMaxDistance(gold8ID, rmXFractionToMeters(0.5));
	//rmAddObjectDefConstraint(gold8ID, edgeConstraint);
	//rmAddObjectDefConstraint(gold8ID, West5ward);
	//rmAddObjectDefConstraint(gold8ID, avoidAll);
	//rmAddObjectDefConstraint(gold8ID, avoidCaribou);
	//rmAddObjectDefConstraint(gold8ID, avoidFruits);
	//rmAddObjectDefConstraint(gold8ID, avoidForest);
	rmAddObjectDefConstraint(gold8ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold8ID, avoidSocket);
	rmAddObjectDefConstraint(gold8ID, avoidCoin);
	rmAddObjectDefConstraint(gold8ID, coinAvoidCoin);
    //rmAddObjectDefConstraint(gold8ID, avoidImpassableLand);
	//rmAddObjectDefConstraint(gold8ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold8ID, 0, 0.7, 0.1);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FORESTS NUMBER 1: ************************************ //
/*================================================================================================================*/
      int forestTreeID = 0;
      int numTries=0.5*cNumberNonGaiaPlayers;
      int failCount=0;

      for (i=0; <numTries)
   {   
      int forest=rmCreateArea("forest "+i);
	  rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
      //rmSetAreaForestType(forest, "new england forest");
	  rmSetAreaForestType(forest, "saguenay forest");
      rmSetAreaForestDensity(forest, 1.0);
      rmSetAreaForestClumpiness(forest, 1.0);
      rmSetAreaForestUnderbrush(forest, 0.0);
      rmSetAreaCoherence(forest, 0.4);
      rmSetAreaSmoothDistance(forest, 10);
      rmAddAreaToClass(forest, rmClassID("classForest")); 
      rmAddAreaConstraint(forest, forestConstraint);
      rmAddAreaConstraint(forest, avoidAll);
      rmAddAreaConstraint(forest, avoidImpassableLand); 
      rmAddAreaConstraint(forest, avoidTradeRoute);
	  rmAddAreaConstraint(forest, avoidStartingUnits);
	  rmAddAreaConstraint(forest, avoidSocket);
	  rmAddAreaConstraint(forest, avoidCoin);
	  rmAddAreaConstraint(forest, avoidNatives);
	  rmAddAreaConstraint(forest, avoidSheep);
	  rmSetAreaLocation(forest, 0.15, 0.25); 
	  if(rmBuildArea(forest)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
      }
         else
         failCount=0; 
   } 
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FORESTS NUMBER 2: ************************************ //
/*================================================================================================================*/
      //int forestTreeID = 0;
      //int numTries=6*cNumberNonGaiaPlayers;
      failCount=0;

      for (i=0; <numTries)
   {   
      int forest2=rmCreateArea("forest 2"+i);
      rmSetAreaWarnFailure(forest2, false);
      rmSetAreaSize(forest2, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
      //rmSetAreaForestType(forest2, "new england forest");
	  rmSetAreaForestType(forest2, "saguenay forest");
      rmSetAreaForestDensity(forest2, 1.0);
      rmSetAreaForestClumpiness(forest2, 1.0);
      rmSetAreaForestUnderbrush(forest2, 0.0);
      rmSetAreaCoherence(forest2, 0.4);
      rmSetAreaSmoothDistance(forest2, 10);
      rmAddAreaToClass(forest2, rmClassID("classForest")); 
      rmAddAreaConstraint(forest2, forestConstraint);
      rmAddAreaConstraint(forest2, avoidAll);
      rmAddAreaConstraint(forest2, avoidImpassableLand); 
      rmAddAreaConstraint(forest2, avoidTradeRoute);
	  rmAddAreaConstraint(forest2, avoidStartingUnits);
	  rmAddAreaConstraint(forest2, avoidSocket);
	  rmAddAreaConstraint(forest2, avoidCoin);
	  rmAddAreaConstraint(forest2, avoidNatives);
	  rmAddAreaConstraint(forest2, avoidSheep);
	  rmSetAreaLocation(forest2, 0.15, 0.75); 
	  if(rmBuildArea(forest2)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
      }
         else
         failCount=0; 
   } 
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FORESTS NUMBER 3: ************************************ //
/*================================================================================================================*/
      //int forestTreeID = 0;
      //int numTries=6*cNumberNonGaiaPlayers;
      failCount=0;

      for (i=0; <numTries)
   {   
      int forest3=rmCreateArea("forest 3"+i);
      rmSetAreaWarnFailure(forest3, false);
      rmSetAreaSize(forest3, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
      //rmSetAreaForestType(forest3, "new england forest");
	  rmSetAreaForestType(forest3, "saguenay forest");
      rmSetAreaForestDensity(forest3, 1.0);
      rmSetAreaForestClumpiness(forest3, 1.0);
      rmSetAreaForestUnderbrush(forest3, 0.0);
      rmSetAreaCoherence(forest3, 0.4);
      rmSetAreaSmoothDistance(forest3, 10);
      rmAddAreaToClass(forest3, rmClassID("classForest")); 
      rmAddAreaConstraint(forest3, forestConstraint);
      rmAddAreaConstraint(forest3, avoidAll);
      rmAddAreaConstraint(forest3, avoidImpassableLand); 
      rmAddAreaConstraint(forest3, avoidTradeRoute);
	  rmAddAreaConstraint(forest3, avoidStartingUnits);
	  rmAddAreaConstraint(forest3, avoidSocket);
	  rmAddAreaConstraint(forest3, avoidCoin);
	  rmAddAreaConstraint(forest3, avoidNatives);
	  rmAddAreaConstraint(forest3, avoidSheep);
	  rmSetAreaLocation(forest3, 0.85, 0.25); 
	  if(rmBuildArea(forest3)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
      }
         else
         failCount=0; 
   } 
   
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FORESTS NUMBER 4: ************************************ //
/*================================================================================================================*/
      //int forestTreeID = 0;
      //int numTries=6*cNumberNonGaiaPlayers;
      failCount=0;

      for (i=0; <numTries)
   {   
      int forest4=rmCreateArea("forest 4"+i);
      rmSetAreaWarnFailure(forest4, false);
      rmSetAreaSize(forest4, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
      //rmSetAreaForestType(forest4, "new england forest");
	  rmSetAreaForestType(forest4, "saguenay forest");
      rmSetAreaForestDensity(forest4, 1.0);
      rmSetAreaForestClumpiness(forest4, 1.0);
      rmSetAreaForestUnderbrush(forest4, 0.0);
      rmSetAreaCoherence(forest4, 0.4);
      rmSetAreaSmoothDistance(forest4, 10);
      rmAddAreaToClass(forest4, rmClassID("classForest")); 
      rmAddAreaConstraint(forest4, forestConstraint);
      rmAddAreaConstraint(forest4, avoidAll);
      rmAddAreaConstraint(forest4, avoidImpassableLand); 
      rmAddAreaConstraint(forest4, avoidTradeRoute);
	  rmAddAreaConstraint(forest4, avoidStartingUnits);
	  rmAddAreaConstraint(forest4, avoidSocket);
	  rmAddAreaConstraint(forest4, avoidCoin);
	  rmAddAreaConstraint(forest4, avoidNatives);
	  rmAddAreaConstraint(forest4, avoidSheep);
	  rmSetAreaLocation(forest4, 0.85, 0.75); 
	  if(rmBuildArea(forest4)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
      }
         else
         failCount=0; 
   } 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE TREASURES: *************************************** //
/*================================================================================================================*/
        int nugget1ID= rmCreateObjectDef("nugget easy 1"); 
		rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
		//rmSetObjectDefMaxDistance(nugget1ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget1ID, rmClassID("nuggets"));
		//rmAddObjectDefConstraint(nugget1ID, avoidCaribou);
		//rmAddObjectDefConstraint(nugget1ID, avoidImpassableLand);
		//rmAddObjectDefConstraint(nugget1ID, avoidSocket);
		//rmAddObjectDefConstraint(nugget1ID, avoidTradeRoute);
		//rmAddObjectDefConstraint(nugget1ID, avoidCoin);
		//rmAddObjectDefConstraint(nugget1ID, avoidForest);
		//rmAddObjectDefConstraint(nugget1ID, smallMesaConstraint);
		//rmAddObjectDefConstraint(nugget1ID, North1ward);
		//rmAddObjectDefConstraint(nugget1ID, avoidFruits);
		rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		//rmAddObjectDefConstraint(nugget1ID, nuggetAvoidNugget);
		//rmAddObjectDefConstraint(nugget1ID, avoidNatives);
		//rmAddObjectDefConstraint(nugget1ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.65, 0.90);
		
		int nugget2ID= rmCreateObjectDef("nugget easy 2"); 
		rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
		//rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget2ID, rmClassID("nuggets"));
		//rmAddObjectDefConstraint(nugget2ID, avoidCaribou);
		//rmAddObjectDefConstraint(nugget2ID, avoidImpassableLand);
		//rmAddObjectDefConstraint(nugget2ID, avoidSocket);
		//rmAddObjectDefConstraint(nugget2ID, avoidTradeRoute);
		//rmAddObjectDefConstraint(nugget2ID, avoidCoin);
		//rmAddObjectDefConstraint(nugget2ID, avoidForest);
		//rmAddObjectDefConstraint(nugget2ID, smallMesaConstraint);
		//rmAddObjectDefConstraint(nugget2ID, West1ward);
		//rmAddObjectDefConstraint(nugget2ID, avoidFruits);
		rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmAddObjectDefConstraint(nugget2ID, nuggetAvoidNugget);
		//rmAddObjectDefConstraint(nugget2ID, avoidNatives);
		//rmAddObjectDefConstraint(nugget2ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.55, 0.90);
		
		int nugget3ID= rmCreateObjectDef("nugget easy 3"); 
		rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
		//rmSetObjectDefMaxDistance(nugget3ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget3ID, rmClassID("nuggets"));
		//rmAddObjectDefConstraint(nugget3ID, avoidCaribou);
		//rmAddObjectDefConstraint(nugget3ID, avoidImpassableLand);
		//rmAddObjectDefConstraint(nugget3ID, avoidSocket);
		//rmAddObjectDefConstraint(nugget3ID, avoidTradeRoute);
		//rmAddObjectDefConstraint(nugget3ID, avoidCoin);
		//rmAddObjectDefConstraint(nugget3ID, avoidForest);
		//rmAddObjectDefConstraint(nugget3ID, smallMesaConstraint);
		//rmAddObjectDefConstraint(nugget3ID, East1ward);
		//rmAddObjectDefConstraint(nugget3ID, avoidFruits);
		rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmAddObjectDefConstraint(nugget3ID, nuggetAvoidNugget);
		//rmAddObjectDefConstraint(nugget3ID, avoidNatives);
		//rmAddObjectDefConstraint(nugget3ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.35, 0.90);
		
		int nugget4ID= rmCreateObjectDef("nugget easy 4"); 
		rmAddObjectDefItem(nugget4ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget4ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget4ID, 0.0);
		//rmSetObjectDefMaxDistance(nugget4ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget4ID, rmClassID("nuggets"));
		//rmAddObjectDefConstraint(nugget4ID, avoidCaribou);
		//rmAddObjectDefConstraint(nugget4ID, avoidImpassableLand);
		//rmAddObjectDefConstraint(nugget4ID, avoidSocket);
		//rmAddObjectDefConstraint(nugget4ID, avoidTradeRoute);
		//rmAddObjectDefConstraint(nugget4ID, avoidCoin);
		//rmAddObjectDefConstraint(nugget4ID, avoidForest);
		//rmAddObjectDefConstraint(nugget4ID, smallMesaConstraint);
		//rmAddObjectDefConstraint(nugget4ID, South1ward);
		//rmAddObjectDefConstraint(nugget4ID, avoidFruits);
		rmAddObjectDefConstraint(nugget4ID, avoidNugget);
		rmAddObjectDefConstraint(nugget4ID, nuggetAvoidNugget);
		//rmAddObjectDefConstraint(nugget4ID, avoidNatives);
		//rmAddObjectDefConstraint(nugget4ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.45, 0.90);
		
		int nugget5ID= rmCreateObjectDef("nugget easy 5"); 
		rmAddObjectDefItem(nugget5ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget5ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget5ID, 0.0);
		//rmSetObjectDefMaxDistance(nugget5ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget5ID, rmClassID("nuggets"));
		//rmAddObjectDefConstraint(nugget5ID, avoidCaribou);
		//rmAddObjectDefConstraint(nugget5ID, avoidImpassableLand);
		//rmAddObjectDefConstraint(nugget5ID, avoidSocket);
		//rmAddObjectDefConstraint(nugget5ID, avoidTradeRoute);
		//rmAddObjectDefConstraint(nugget5ID, avoidCoin);
		//rmAddObjectDefConstraint(nugget5ID, avoidForest);
		//rmAddObjectDefConstraint(nugget5ID, smallMesaConstraint);
		//rmAddObjectDefConstraint(nugget5ID, East6ward);
		//rmAddObjectDefConstraint(nugget5ID, avoidFruits);
		rmAddObjectDefConstraint(nugget5ID, avoidNugget);
		rmAddObjectDefConstraint(nugget5ID, nuggetAvoidNugget);
		//rmAddObjectDefConstraint(nugget5ID, avoidNatives);
		//rmAddObjectDefConstraint(nugget5ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.35, 0.1);
		
		int nugget6ID= rmCreateObjectDef("nugget easy 6"); 
		rmAddObjectDefItem(nugget6ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget6ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget6ID, 0.0);
		//rmSetObjectDefMaxDistance(nugget6ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget6ID, rmClassID("nuggets"));
		//rmAddObjectDefConstraint(nugget6ID, avoidCaribou);
		//rmAddObjectDefConstraint(nugget6ID, avoidImpassableLand);
		//rmAddObjectDefConstraint(nugget6ID, avoidSocket);
		//rmAddObjectDefConstraint(nugget6ID, avoidTradeRoute);
		//rmAddObjectDefConstraint(nugget6ID, avoidCoin);
		//rmAddObjectDefConstraint(nugget6ID, avoidForest);
		//rmAddObjectDefConstraint(nugget6ID, smallMesaConstraint);
		//rmAddObjectDefConstraint(nugget6ID, West6ward);
		//rmAddObjectDefConstraint(nugget6ID, avoidFruits);
		rmAddObjectDefConstraint(nugget6ID, avoidNugget);
		rmAddObjectDefConstraint(nugget6ID, nuggetAvoidNugget);
		//rmAddObjectDefConstraint(nugget6ID, avoidNatives);
		//rmAddObjectDefConstraint(nugget6ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget6ID, 0, 0.45, 0.1);
		
		int nugget7ID= rmCreateObjectDef("nugget easy 7"); 
		rmAddObjectDefItem(nugget7ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget7ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget7ID, 0.0);
		//rmSetObjectDefMaxDistance(nugget7ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget7ID, rmClassID("nuggets"));
		//rmAddObjectDefConstraint(nugget7ID, avoidCaribou);
		//rmAddObjectDefConstraint(nugget7ID, avoidImpassableLand);
		//rmAddObjectDefConstraint(nugget7ID, avoidSocket);
		//rmAddObjectDefConstraint(nugget7ID, avoidTradeRoute);
		//rmAddObjectDefConstraint(nugget7ID, avoidCoin);
		//rmAddObjectDefConstraint(nugget7ID, avoidForest);
		//rmAddObjectDefConstraint(nugget7ID, smallMesaConstraint);
		//rmAddObjectDefConstraint(nugget7ID, North6ward);
		//rmAddObjectDefConstraint(nugget7ID, avoidFruits);
		rmAddObjectDefConstraint(nugget7ID, avoidNugget);
		rmAddObjectDefConstraint(nugget7ID, nuggetAvoidNugget);
		//rmAddObjectDefConstraint(nugget7ID, avoidNatives);
		//rmAddObjectDefConstraint(nugget7ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget7ID, 0, 0.55, 0.1);
		
		int nugget8ID= rmCreateObjectDef("nugget easy 8"); 
		rmAddObjectDefItem(nugget8ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget8ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget8ID, 0.0);
		//rmSetObjectDefMaxDistance(nugget8ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget8ID, rmClassID("nuggets"));
		//rmAddObjectDefConstraint(nugget8ID, avoidCaribou);
		//rmAddObjectDefConstraint(nugget8ID, avoidImpassableLand);
		//rmAddObjectDefConstraint(nugget8ID, avoidSocket);
		//rmAddObjectDefConstraint(nugget8ID, avoidTradeRoute);
		//rmAddObjectDefConstraint(nugget8ID, avoidCoin);
		//rmAddObjectDefConstraint(nugget8ID, avoidForest);
		//rmAddObjectDefConstraint(nugget8ID, smallMesaConstraint);
		//rmAddObjectDefConstraint(nugget8ID, South6ward);
		//rmAddObjectDefConstraint(nugget8ID, avoidFruits);
		rmAddObjectDefConstraint(nugget8ID, avoidNugget);
		rmAddObjectDefConstraint(nugget8ID, nuggetAvoidNugget);
		//rmAddObjectDefConstraint(nugget8ID, avoidNatives);
		//rmAddObjectDefConstraint(nugget8ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget8ID, 0, 0.65, 0.1);
		
		int nugget9ID= rmCreateObjectDef("nugget easy 9"); 
		rmAddObjectDefItem(nugget9ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget9ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget9ID, 0.0);
		//rmSetObjectDefMaxDistance(nugget9ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget9ID, rmClassID("nuggets"));
		//rmAddObjectDefConstraint(nugget9ID, avoidCaribou);
		//rmAddObjectDefConstraint(nugget9ID, avoidImpassableLand);
		//rmAddObjectDefConstraint(nugget9ID, avoidSocket);
		//rmAddObjectDefConstraint(nugget9ID, avoidTradeRoute);
		//rmAddObjectDefConstraint(nugget9ID, avoidCoin);
		//rmAddObjectDefConstraint(nugget9ID, avoidForest);
		//rmAddObjectDefConstraint(nugget9ID, smallMesaConstraint);
		//rmAddObjectDefConstraint(nugget9ID, North1ward);
		//rmAddObjectDefConstraint(nugget9ID, avoidFruits);
		rmAddObjectDefConstraint(nugget9ID, avoidNugget);
		//rmAddObjectDefConstraint(nugget9ID, nuggetAvoidNugget);
		//rmAddObjectDefConstraint(nugget9ID, avoidNatives);
		//rmAddObjectDefConstraint(nugget9ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget9ID, 0, 0.725, 0.65);
		
		int nugget10ID= rmCreateObjectDef("nugget easy 10"); 
		rmAddObjectDefItem(nugget10ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget10ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget10ID, 0.0);
		//rmSetObjectDefMaxDistance(nugget10ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget10ID, rmClassID("nuggets"));
		//rmAddObjectDefConstraint(nugget10ID, avoidCaribou);
		//rmAddObjectDefConstraint(nugget10ID, avoidImpassableLand);
		//rmAddObjectDefConstraint(nugget10ID, avoidSocket);
		//rmAddObjectDefConstraint(nugget10ID, avoidTradeRoute);
		//rmAddObjectDefConstraint(nugget10ID, avoidCoin);
		//rmAddObjectDefConstraint(nugget10ID, avoidForest);
		//rmAddObjectDefConstraint(nugget10ID, smallMesaConstraint);
		//rmAddObjectDefConstraint(nugget10ID, North1ward);
		//rmAddObjectDefConstraint(nugget10ID, avoidFruits);
		rmAddObjectDefConstraint(nugget10ID, avoidNugget);
		//rmAddObjectDefConstraint(nugget10ID, nuggetAvoidNugget);
		//rmAddObjectDefConstraint(nugget10ID, avoidNatives);
		//rmAddObjectDefConstraint(nugget10ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget10ID, 0, 0.725, 0.35);
		
		int nugget11ID= rmCreateObjectDef("nugget easy 11"); 
		rmAddObjectDefItem(nugget11ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget11ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget11ID, 0.0);
		//rmSetObjectDefMaxDistance(nugget11ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget11ID, rmClassID("nuggets"));
		//rmAddObjectDefConstraint(nugget11ID, avoidCaribou);
		//rmAddObjectDefConstraint(nugget11ID, avoidImpassableLand);
		//rmAddObjectDefConstraint(nugget11ID, avoidSocket);
		//rmAddObjectDefConstraint(nugget11ID, avoidTradeRoute);
		//rmAddObjectDefConstraint(nugget11ID, avoidCoin);
		//rmAddObjectDefConstraint(nugget11ID, avoidForest);
		//rmAddObjectDefConstraint(nugget11ID, smallMesaConstraint);
		//rmAddObjectDefConstraint(nugget11ID, North1ward);
		//rmAddObjectDefConstraint(nugget11ID, avoidFruits);
		rmAddObjectDefConstraint(nugget11ID, avoidNugget);
		//rmAddObjectDefConstraint(nugget11ID, nuggetAvoidNugget);
		//rmAddObjectDefConstraint(nugget11ID, avoidNatives);
		//rmAddObjectDefConstraint(nugget11ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget11ID, 0, 0.3, 0.35);
		
		int nugget12ID= rmCreateObjectDef("nugget easy 12"); 
		rmAddObjectDefItem(nugget12ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget12ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget12ID, 0.0);
		//rmSetObjectDefMaxDistance(nugget12ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget12ID, rmClassID("nuggets"));
		//rmAddObjectDefConstraint(nugget12ID, avoidCaribou);
		//rmAddObjectDefConstraint(nugget12ID, avoidImpassableLand);
		//rmAddObjectDefConstraint(nugget12ID, avoidSocket);
		//rmAddObjectDefConstraint(nugget12ID, avoidTradeRoute);
		//rmAddObjectDefConstraint(nugget12ID, avoidCoin);
		//rmAddObjectDefConstraint(nugget12ID, avoidForest);
		//rmAddObjectDefConstraint(nugget12ID, smallMesaConstraint);
		//rmAddObjectDefConstraint(nugget12ID, North1ward);
		//rmAddObjectDefConstraint(nugget12ID, avoidFruits);
		rmAddObjectDefConstraint(nugget12ID, avoidNugget);
		//rmAddObjectDefConstraint(nugget12ID, nuggetAvoidNugget);
		//rmAddObjectDefConstraint(nugget12ID, avoidNatives);
		//rmAddObjectDefConstraint(nugget12ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget12ID, 0, 0.3, 0.65);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE FISHES AND THE WHALES: ********************************** //
/*================================================================================================================*/
   int fishID=rmCreateObjectDef("fish");
   rmAddObjectDefItem(fishID, "FishSalmon", 3, 6.0);
   rmSetObjectDefMinDistance(fishID, 0.0);
   rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fishID, fishVsFishID);
   rmAddObjectDefConstraint(fishID, fishLand);
   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

   // FAST COIN -- WHALES (reasonable in Patagonia, right?)
   int whaleID=rmCreateObjectDef("whale");
   rmAddObjectDefItem(whaleID, "beluga", 1, 9.0);
   rmSetObjectDefMinDistance(whaleID, 0.0);
   rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
   rmAddObjectDefConstraint(whaleID, whaleLand);
   rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 1*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE LLAMA: ***************************************** //
/*================================================================================================================*/
    // DEER HERD 1:
	int deerID=rmCreateObjectDef("deer herd 1");
	rmAddObjectDefItem(deerID, "deer", rmRandInt(7,12), 8);
	rmSetObjectDefMinDistance(deerID, 0.0);
	rmSetObjectDefMaxDistance(deerID, 0.0);
	//rmSetObjectDefMaxDistance(deerID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(deerID, avoidDeer);
	rmAddObjectDefConstraint(deerID, deerAvoidDeer);
	//rmAddObjectDefConstraint(deerID, avoidAll);
	//rmAddObjectDefConstraint(deerID, avoidSocket);
	//rmAddObjectDefConstraint(deerID, avoidTradeRoute); 
	//rmAddObjectDefConstraint(deerID, avoidNatives);
	//rmAddObjectDefConstraint(deerID, North1ward);
	//rmAddObjectDefConstraint(deerID, avoidImpassableLand);
	//rmAddObjectDefConstraint(deerID, canyonConstraint);
	//rmAddObjectDefConstraint(deerID, avoidForest);
	//rmAddObjectDefConstraint(deerID, smallMesaConstraint);
	rmSetObjectDefCreateHerd(deerID, true);
	rmPlaceObjectDefAtLoc(deerID, 0, 0.35, 0.80);
	
	// DEER HERD 2:
	int deer2ID=rmCreateObjectDef("deer herd 2");
	rmAddObjectDefItem(deer2ID, "deer", rmRandInt(7,12), 8);
	rmSetObjectDefMinDistance(deer2ID, 0.0);
	rmSetObjectDefMaxDistance(deer2ID, 0.0);
	//rmSetObjectDefMaxDistance(deer2ID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(deer2ID, avoidDeer);
	rmAddObjectDefConstraint(deer2ID, deerAvoidDeer);
	//rmAddObjectDefConstraint(deer2ID, avoidAll);
	//rmAddObjectDefConstraint(deer2ID, avoidSocket);
	//rmAddObjectDefConstraint(deer2ID, avoidTradeRoute); 
	//rmAddObjectDefConstraint(deer2ID, avoidNatives);
	//rmAddObjectDefConstraint(deer2ID, North1ward);
	//rmAddObjectDefConstraint(deer2ID, avoidImpassableLand);
	//rmAddObjectDefConstraint(deer2ID, canyonConstraint);
	//rmAddObjectDefConstraint(deer2ID, avoidForest);
	//rmAddObjectDefConstraint(deer2ID, smallMesaConstraint);
	rmSetObjectDefCreateHerd(deer2ID, true);
	rmPlaceObjectDefAtLoc(deer2ID, 0, 0.35, 0.20);
	
	// DEER HERD 3:
	int deer3ID=rmCreateObjectDef("deer herd 3");
	rmAddObjectDefItem(deer3ID, "deer", rmRandInt(7,12), 8);
	rmSetObjectDefMinDistance(deer3ID, 0.0);
	rmSetObjectDefMaxDistance(deer3ID, 0.0);
	//rmSetObjectDefMaxDistance(deer3ID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(deer3ID, avoidDeer);
	rmAddObjectDefConstraint(deer3ID, deerAvoidDeer);
	//rmAddObjectDefConstraint(deer3ID, avoidAll);
	//rmAddObjectDefConstraint(deer3ID, avoidSocket);
	//rmAddObjectDefConstraint(deer3ID, avoidTradeRoute); 
	//rmAddObjectDefConstraint(deer3ID, avoidNatives);
	//rmAddObjectDefConstraint(deer3ID, North1ward);
	//rmAddObjectDefConstraint(deer3ID, avoidImpassableLand);
	//rmAddObjectDefConstraint(deer3ID, canyonConstraint);
	//rmAddObjectDefConstraint(deer3ID, avoidForest);
	//rmAddObjectDefConstraint(deer3ID, smallMesaConstraint);
	rmSetObjectDefCreateHerd(deer3ID, true);
	rmPlaceObjectDefAtLoc(deer3ID, 0, 0.65, 0.75);
	
	// DEER HERD 4:
	int deer4ID=rmCreateObjectDef("deer herd 4");
	rmAddObjectDefItem(deer4ID, "deer", rmRandInt(7,12), 8);
	rmSetObjectDefMinDistance(deer4ID, 0.0);
	rmSetObjectDefMaxDistance(deer4ID, 0.0);
	//rmSetObjectDefMaxDistance(deer4ID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(deer4ID, avoidDeer);
	rmAddObjectDefConstraint(deer4ID, deerAvoidDeer);
	//rmAddObjectDefConstraint(deer4ID, avoidAll);
	//rmAddObjectDefConstraint(deer4ID, avoidSocket);
	//rmAddObjectDefConstraint(deer4ID, avoidTradeRoute); 
	//rmAddObjectDefConstraint(deer4ID, avoidNatives);
	//rmAddObjectDefConstraint(deer4ID, North1ward);
	//rmAddObjectDefConstraint(deer4ID, avoidImpassableLand);
	//rmAddObjectDefConstraint(deer4ID, canyonConstraint);
	//rmAddObjectDefConstraint(deer4ID, avoidForest);
	//rmAddObjectDefConstraint(deer4ID, smallMesaConstraint);
	rmSetObjectDefCreateHerd(deer4ID, true);
	rmPlaceObjectDefAtLoc(deer4ID, 0, 0.65, 0.20);
	
	// DEER HERD 5:
	int deer5ID=rmCreateObjectDef("deer herd 5");
	rmAddObjectDefItem(deer5ID, "deer", rmRandInt(7,12), 8);
	rmSetObjectDefMinDistance(deer5ID, 0.0);
	rmSetObjectDefMaxDistance(deer5ID, 0.0);
	//rmSetObjectDefMaxDistance(deer5ID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(deer5ID, avoidDeer);
	rmAddObjectDefConstraint(deer5ID, deerAvoidDeer);
	//rmAddObjectDefConstraint(deer5ID, avoidAll);
	//rmAddObjectDefConstraint(deer5ID, avoidSocket);
	//rmAddObjectDefConstraint(deer5ID, avoidBay);
	//rmAddObjectDefConstraint(deer5ID, avoidTradeRoute); 
	//rmAddObjectDefConstraint(deer5ID, avoidNatives);
	//rmAddObjectDefConstraint(deer5ID, North1ward);
	//rmAddObjectDefConstraint(deer5ID, avoidImpassableLand);
	//rmAddObjectDefConstraint(deer5ID, canyonConstraint);
	//rmAddObjectDefConstraint(deer5ID, avoidForest);
	//rmAddObjectDefConstraint(deer5ID, smallMesaConstraint);
	rmSetObjectDefCreateHerd(deer5ID, true);
	rmPlaceObjectDefAtLoc(deer5ID, 0, 0.295, 0.50);
	
	// DEER HERD 6:
	int deer6ID=rmCreateObjectDef("deer herd 6");
	rmAddObjectDefItem(deer6ID, "deer", rmRandInt(7,12), 8);
	rmSetObjectDefMinDistance(deer6ID, 0.0);
	rmSetObjectDefMaxDistance(deer6ID, 0.0);
	//rmSetObjectDefMaxDistance(deer6ID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(deer6ID, avoidDeer);
	rmAddObjectDefConstraint(deer6ID, deerAvoidDeer);
	//rmAddObjectDefConstraint(deer6ID, avoidAll);
	//rmAddObjectDefConstraint(deer6ID, avoidSocket);
	//rmAddObjectDefConstraint(deer6ID, avoidBay);
	//rmAddObjectDefConstraint(deer6ID, avoidTradeRoute); 
	//rmAddObjectDefConstraint(deer6ID, avoidNatives);
	//rmAddObjectDefConstraint(deer6ID, North1ward);
	//rmAddObjectDefConstraint(deer6ID, avoidImpassableLand);
	//rmAddObjectDefConstraint(deer6ID, canyonConstraint);
	//rmAddObjectDefConstraint(deer6ID, avoidForest);
	//rmAddObjectDefConstraint(deer6ID, smallMesaConstraint);
	rmSetObjectDefCreateHerd(deer6ID, true);
	rmPlaceObjectDefAtLoc(deer6ID, 0, 0.735, 0.50);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.96);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE SHEEPS: **************************************** //
/*================================================================================================================*/
      // SHEEP HERD 1:
	  int sheepID=rmCreateObjectDef("sheep herd 1");
	  rmAddObjectDefItem(sheepID, "sheep", rmRandInt(7,12), 7);
	  rmSetObjectDefMinDistance(sheepID, 0.0);
	  rmSetObjectDefMaxDistance(sheepID, 0.0);
	  //rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.3));
	  rmAddObjectDefConstraint(sheepID, avoidSheep);
	  rmAddObjectDefConstraint(sheepID, sheepAvoidSheep);
	  //rmAddObjectDefConstraint(sheepID, avoidAll);
	  //rmAddObjectDefConstraint(sheepID, avoidSocket);
	  //rmAddObjectDefConstraint(sheepID, avoidTradeRoute); 
	  rmAddObjectDefConstraint(sheepID, avoidNatives);
	  //rmAddObjectDefConstraint(sheepID, North1ward);
	  //rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(sheepID, canyonConstraint);
	  //rmAddObjectDefConstraint(sheepID, avoidForest);
	  //rmAddObjectDefConstraint(sheepID, smallMesaConstraint);
	  rmSetObjectDefCreateHerd(sheepID, true);
	  rmPlaceObjectDefAtLoc(sheepID, 0, 0.15, 0.90);
	  
	  // SHEEP HERD 2:
	  int sheep2ID=rmCreateObjectDef("sheep herd 2");
	  rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(7,12), 7);
	  rmSetObjectDefMinDistance(sheep2ID, 0.0);
	  rmSetObjectDefMaxDistance(sheep2ID, 0.0);
	  //rmSetObjectDefMaxDistance(sheep2ID, rmXFractionToMeters(0.3));
	  rmAddObjectDefConstraint(sheep2ID, avoidSheep);
	  rmAddObjectDefConstraint(sheep2ID, sheepAvoidSheep);
	  //rmAddObjectDefConstraint(sheep2ID, avoidAll);
	  //rmAddObjectDefConstraint(sheep2ID, avoidSocket);
	  //rmAddObjectDefConstraint(sheep2ID, avoidTradeRoute); 
	  rmAddObjectDefConstraint(sheep2ID, avoidNatives);
	  //rmAddObjectDefConstraint(sheep2ID, North1ward);
	  //rmAddObjectDefConstraint(sheep2ID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(sheep2ID, canyonConstraint);
	  //rmAddObjectDefConstraint(sheep2ID, avoidForest);
	  //rmAddObjectDefConstraint(sheep2ID, smallMesaConstraint);
	  rmSetObjectDefCreateHerd(sheep2ID, true);
	  rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.85, 0.90);
	  
	  // SHEEP HERD 3:
	  int sheep3ID=rmCreateObjectDef("sheep herd 3");
	  rmAddObjectDefItem(sheep3ID, "sheep", rmRandInt(7,12), 7);
	  rmSetObjectDefMinDistance(sheep3ID, 0.0);
	  rmSetObjectDefMaxDistance(sheep3ID, 0.0);
	  //rmSetObjectDefMaxDistance(sheep3ID, rmXFractionToMeters(0.3));
	  rmAddObjectDefConstraint(sheep3ID, avoidSheep);
	  rmAddObjectDefConstraint(sheep3ID, sheepAvoidSheep);
	  //rmAddObjectDefConstraint(sheep3ID, avoidAll);
	  //rmAddObjectDefConstraint(sheep3ID, avoidSocket);
	  //rmAddObjectDefConstraint(sheep3ID, avoidTradeRoute); 
	  rmAddObjectDefConstraint(sheep3ID, avoidNatives);
	  //rmAddObjectDefConstraint(sheep3ID, North1ward);
	  //rmAddObjectDefConstraint(sheep3ID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(sheep3ID, canyonConstraint);
	  //rmAddObjectDefConstraint(sheep3ID, avoidForest);
	  //rmAddObjectDefConstraint(sheep3ID, smallMesaConstraint);
	  rmSetObjectDefCreateHerd(sheep3ID, true);
	  rmPlaceObjectDefAtLoc(sheep3ID, 0, 0.15, 0.10);
	  
	  // SHEEP HERD 4:
	  int sheep4ID=rmCreateObjectDef("sheep herd 4");
	  rmAddObjectDefItem(sheep4ID, "sheep", rmRandInt(7,12), 7);
	  rmSetObjectDefMinDistance(sheep4ID, 0.0);
	  rmSetObjectDefMaxDistance(sheep4ID, 0.0);
	  //rmSetObjectDefMaxDistance(sheep4ID, rmXFractionToMeters(0.3));
	  rmAddObjectDefConstraint(sheep4ID, avoidSheep);
	  rmAddObjectDefConstraint(sheep4ID, sheepAvoidSheep);
	  //rmAddObjectDefConstraint(sheep4ID, avoidAll);
	  //rmAddObjectDefConstraint(sheep4ID, avoidSocket);
	  //rmAddObjectDefConstraint(sheep4ID, avoidTradeRoute); 
	  rmAddObjectDefConstraint(sheep4ID, avoidNatives);
	  //rmAddObjectDefConstraint(sheep4ID, North1ward);
	  //rmAddObjectDefConstraint(sheep4ID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(sheep4ID, canyonConstraint);
	  //rmAddObjectDefConstraint(sheep4ID, avoidForest);
	  //rmAddObjectDefConstraint(sheep4ID, smallMesaConstraint);
	  rmSetObjectDefCreateHerd(sheep4ID, true);
	  rmPlaceObjectDefAtLoc(sheep4ID, 0, 0.85, 0.10);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.99);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE RANDOM TREES: ************************************* //
/*================================================================================================================*/
      int TreeID=rmCreateObjectDef("Random Tree");
      rmAddObjectDefItem(TreeID, "TreeSaguenay", rmRandInt(5,9), 5.0);
	  rmSetObjectDefMinDistance(TreeID, 0.0);
      rmSetObjectDefMaxDistance(TreeID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(TreeID, avoidTree);
	  rmAddObjectDefConstraint(TreeID, treeAvoidTree);
	  rmAddObjectDefConstraint(TreeID, closeAvoidSocket);
	  rmAddObjectDefConstraint(TreeID, closeAvoidTradeRoute);
	  rmAddObjectDefConstraint(TreeID, closeAvoidDeer);
	  rmAddObjectDefConstraint(TreeID, closeAvoidSheep);
	  //rmAddObjectDefConstraint(TreeID, avoidAll);
	  //rmAddObjectDefConstraint(TreeID, East6ward);
	  rmAddObjectDefConstraint(TreeID, closeAvoidNugget);
	  rmAddObjectDefConstraint(TreeID, closeAvoidCoin);
	  //rmAddObjectDefConstraint(TreeID, avoidForest);
	  rmAddObjectDefConstraint(TreeID, closePlayerConstraint);
	  rmAddObjectDefConstraint(TreeID, playerEdgeConstraint);
	  //rmAddObjectDefConstraint(TreeID, smallMesaConstraint);
	  rmAddObjectDefConstraint(TreeID, closeAvoidNatives);
      //rmAddObjectDefConstraint(TreeID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(TreeID, 0, 0.5, 0.5, 15);	  	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
// **************************************** THIS IS THE END OF THE MAP: ***************************************** //
/*================================================================================================================*/
} 
/*================================================================================================================*/
 
