/*================================================================================================================*/
// ********************************* THESE ARE THE INFORMATIONS OF THE MAP: ************************************* //
/*================================================================================================================*/
// NUGGET COUNTRY:
// CREATED BY DANY:
// MARCH 2007:
/*================================================================================================================*/
// ******************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************* //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// Which map - four possible variations (excluding which end the players start on, which is a separate thing)
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
        int playerTiles=25000;		
   
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
	    // SET MAP ELEVATION PARAMETERS:
		rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
		
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);
		
		// PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(4.0);	// this is height of river surface compared to surrounding land. River depth is in the river XML.

	    // ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
		
		// SET THE BASE TERRAIN MIX:
	    rmSetBaseTerrainMix("newengland_grass");
	   
	    // SET THE TERRAIN INITIALIZATION:
	    rmTerrainInitialize("new_england\ground1_ne", 4.0);
	    
		// SET THE MAP TYPE:
		rmSetMapType("newEngland");
		rmSetMapType("water");
	    rmSetMapType("grass");
	    
        // SET THE LIGHTING:
        rmSetLightingSet("new england");

	    // MAKE THE CORNERS:
	    rmSetWorldCircleConstraint(true);

	    // CHOOSE THE MERCS:
	    chooseMercs();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// ******************************************* SET UP THE NATIVES: ********************************************** //
/*================================================================================================================*/

        int whichNative = rmRandInt(1,6);
       
	    int subCiv0 = -1;
        int subCiv1 = -1;
        string nativeName = "";

	    if (whichNative < 3)
	{
        subCiv0 = rmGetCivID("Comanche");
        rmEchoInfo("subCiv0 is Comanche "+subCiv0);
        subCiv1 = rmGetCivID("Comanche");
        rmEchoInfo("subCiv1 is Comanche "+subCiv1);
        rmSetSubCiv(0, "Comanche", true);
        rmSetSubCiv(1, "Comanche", true);
        nativeName = "native Comanche village ";
	}
	    else if (whichNative == 3)
	{
        subCiv0 = rmGetCivID("Iroquois");
        rmEchoInfo("subCiv0 is Iroquois "+subCiv0);
        subCiv1 = rmGetCivID("Iroquois");
        rmEchoInfo("subCiv1 is Iroquois "+subCiv1);
        rmSetSubCiv(0, "Iroquois", true);
        rmSetSubCiv(1, "Iroquois", true);
        nativeName = "native Iroquois village ";
   }
        else
   {
        subCiv0 = rmGetCivID("Cherokee");
        rmEchoInfo("subCiv0 is Cherokee "+subCiv0);
        subCiv1 = rmGetCivID("Cherokee");
        rmEchoInfo("subCiv1 is Cherokee "+subCiv1);
        rmSetSubCiv(0, "Cherokee", true);
        rmSetSubCiv(1, "Cherokee", true);
        nativeName = "native Cherokee village ";
   }
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/   
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*================================================================================================================*/
        int classPlayer=rmDefineClass("player");
        rmDefineClass("classHill");
        rmDefineClass("classPatch");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
	    rmDefineClass("classCliff");
	    rmDefineClass("classMountain");
		rmDefineClass("socketClass");
		
		int classCliff = rmDefineClass("Cliffs");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
        // MAP EDGE CONSTRAINTS:
        //int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
	    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.43), rmDegreesToRadians(0), rmDegreesToRadians(360));
	    int coinEdgeConstraint=rmCreateBoxConstraint("coin edge of map", rmXTilesToFraction(19), rmZTilesToFraction(19), 1.0-rmXTilesToFraction(19), 1.0-rmZTilesToFraction(19), 2.0);

        // CARDINAL DIRECTIONS:

	    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	    int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
	    int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	    int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));

	    // PLAYER CONSTRAINTS:
	    int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 20.0);
	    int longPlayerConstraint=rmCreateClassDistanceConstraint("stay far away from players", classPlayer, 50.0);
		
		// SEAFOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 10.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
         
        // NATURE AVOIDANCE:
	    int avoidForest=rmCreateClassDistanceConstraint("forest avoids forest", rmClassID("classForest"), 10.0);
	    int avoidForestFar=rmCreateClassDistanceConstraint("forest avoids forest far", rmClassID("classForest"), 40.0);
	    int avoidturkey=rmCreateTypeDistanceConstraint("avoids turkey", "turkey", 45.0);
	    int avoiddeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 45.0);
		int avoidMoose=rmCreateTypeDistanceConstraint("stuff avoids moose", "moose", 10.0);
		int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 10.0);
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoids gold", "minegold", 10.0);
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids fruits", "berrybush", 10.0);
		int avoidVulture=rmCreateTypeDistanceConstraint("stuff avoids vulture", "PropVulturePerching", 10.0);
		int avoidHorse=rmCreateTypeDistanceConstraint("stuff avoids horse", "Horse", 10.0);
		int avoidDeco1=rmCreateTypeDistanceConstraint("stuff avoids deco1", "PropEaglesRocks", 10.0);
		int avoidDeco2=rmCreateTypeDistanceConstraint("stuff avoids deco2", "Wolf", 10.0);
		int avoiddeerFar=rmCreateTypeDistanceConstraint("deer avoids deer Far", "deer", 65.0);
	    int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 30.0);
	    int avoidCoinFar=rmCreateTypeDistanceConstraint("avoid coin far", "gold", 60.0);
   
        // AVOID IMPASSABLE LAND:
	    int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
	    int avoidCliff = rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 20.0);
	    int cliffAvoidCliff = rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 30.0);
	    int mediumShortAvoidImpassableLand = rmCreateTerrainDistanceConstraint("mediumshort avoid impassable land", "Land", false, 10.0);
	    int shortAvoidImpassableLand = rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	    int mediumAvoidImpassableLand = rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 12.0);
	    int longAvoidImpassableLand = rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 20.0);

        // UNIT AVOIDANCE:
	    int avoidHuari=rmCreateTypeDistanceConstraint("avoid Huari", "huariStronghold", 20.0);
	    int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 20.0);
	    int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 40.0);
	    int avoidTownCenterSupaFar=rmCreateTypeDistanceConstraint("avoid Town Center Supa Far", "townCenter", 50.0);
        int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 60.0);
        int shortAvoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other by a bit", rmClassID("importantItem"), 10.0);
        int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 10.0);
        int avoidNativesFar=rmCreateClassDistanceConstraint("stuff avoids natives far", rmClassID("natives"), 45.0);
	    int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 25.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "AbstractNugget", 15.0);
	
	    // TRADE ROUTE AVOIDANCE:
        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 20.0);
	    int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 20.0);
	    	
        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// ******************************************* DEFINE THE OBJECTS: ********************************************** //
// ************************ THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER: ************************** //
/*================================================================================================================*/
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// *************************************** SET UP THE PLAYER LOCATIONS: ***************************************** //
/*================================================================================================================*/
         //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(0);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(1,0.75,0.75);

        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(1);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(2,0.250,0.250); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// ******************************************* BUILD A NORTH AREA: ********************************************** //
/*================================================================================================================*/
	    int eastIslandID = rmCreateArea("east island");
	    rmSetAreaLocation(eastIslandID, 0.15, 0.85); 
	    rmSetAreaWarnFailure(eastIslandID, false);
	    rmSetAreaSize(eastIslandID, 0.60, 0.60);
	    rmSetAreaCoherence(eastIslandID, 1.0);

	    rmSetAreaElevationType(eastIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(eastIslandID, 5.0);
	    rmSetAreaBaseHeight(eastIslandID, 0.0);
	    rmSetAreaElevationMinFrequency(eastIslandID, 0.07);
	    rmSetAreaElevationOctaves(eastIslandID, 4);
	    rmSetAreaElevationPersistence(eastIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(eastIslandID, 1);
		//rmAddAreaTerrainLayer(eastIslandID, "new_england\ground4_ne", 0, 2);
   
	    rmSetAreaObeyWorldCircleConstraint(eastIslandID, false);
	    rmSetAreaMix(eastIslandID, "newengland_grass");
/*================================================================================================================*/
// ******************************************* BUILD A SOUTH AREA: ********************************************** //
/*================================================================================================================*/
	    int westIslandID = rmCreateArea("west island");
	    rmSetAreaLocation(westIslandID, 0.75, 0.25);
	    rmSetAreaWarnFailure(westIslandID, false);
	    rmSetAreaSize(westIslandID, 0.60, 0.60);
	    rmSetAreaCoherence(westIslandID, 1.0);

	    rmSetAreaElevationType(westIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(westIslandID, 5.0);
	    rmSetAreaBaseHeight(westIslandID, 0.0);
	    rmSetAreaElevationMinFrequency(westIslandID, 0.07);
	    rmSetAreaElevationOctaves(westIslandID, 4);
	    rmSetAreaElevationPersistence(westIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(westIslandID, 1); 
	    //rmAddAreaTerrainLayer(westIslandID, "new_england\ground4_ne", 0, 2);
   
	    rmSetAreaObeyWorldCircleConstraint(westIslandID, false);
	    rmSetAreaMix(westIslandID, "newengland_grass");
	
        rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
        float playerFraction = rmAreaTilesToFraction(100);
        
		for(i = 0; < cNumberNonGaiaPlayers)
   {
        // CREATE THE AREA:
        int id = rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
	    rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
	    rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint);
	   
	    // SET AREA TERRAIN TYPE:
		rmSetAreaTerrainType(id, "new_england\ground1_ne");
	    
		// SET AREA MIX:
		//rmSetAreaMix(id, "newengland_grass"); // ADDED BY ME AS A POSSIBILITY:
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD THE AREAS:
        rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// ********************************** THESE ARE SOME VARIABLES NEEDED LATER: ************************************ //
/*================================================================================================================*/
        int failCount = -1;
        int numTries = cNumberNonGaiaPlayers+2;
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// ******************************************** PLACE THE NATIVES: ********************************************** //
/*================================================================================================================*/
      int nativeVillageA = 0;
      int nativeVillageTypeA = rmRandInt(1,5);
      
      nativeVillageA = rmCreateGrouping("Native village A "+i, nativeName+nativeVillageTypeA);
      rmSetGroupingMinDistance(nativeVillageA, 0.0);
      rmSetGroupingMaxDistance(nativeVillageA, 20.0);
      rmAddGroupingConstraint(nativeVillageA, avoidImpassableLand);
      rmAddGroupingToClass(nativeVillageA, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillageA, rmClassID("importantItem"));
    
      rmPlaceGroupingAtLoc(nativeVillageA, 0, 0.5, 0.1);
	  rmPlaceGroupingAtLoc(nativeVillageA, 0, 0.1, 0.5);
/*----------------------------------------------------------------------------------------------------------------*/
      int nativeVillageB = 0;
      int nativeVillageTypeB = rmRandInt(1,5);

      nativeVillageB = rmCreateGrouping("Native village B "+i, nativeName+nativeVillageTypeB);
      rmSetGroupingMinDistance(nativeVillageB, 0.0);
      rmSetGroupingMaxDistance(nativeVillageB, 20.0);
      rmAddGroupingConstraint(nativeVillageB, avoidImpassableLand);
      rmAddGroupingToClass(nativeVillageB, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillageB, rmClassID("importantItem"));
      
      rmPlaceGroupingAtLoc(nativeVillageB, 0, 0.5, 0.9);
      rmPlaceGroupingAtLoc(nativeVillageB, 0, 0.9, 0.5);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/   
// *********************************** DEFINE THE PLAYER STARTING RESOURCES: ************************************ //
/*================================================================================================================*/
        // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
        
		// DEFINE THE TCID:
		int TCfloat = 10;
   
	    int TCID = rmCreateObjectDef("Player TC");

	    if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	}
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, TCfloat);
/*----------------------------------------------------------------------------------------------------------------*/
	    // DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player mine");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	    rmAddObjectDefConstraint(playerSilverID, avoidTownCenter);
	    rmSetObjectDefMinDistance(playerSilverID, 15.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 20.0);
        rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);
        rmAddObjectDefConstraint(playerSilverID, coinEdgeConstraint);

	    // DEFINE THE PLAYER TURKEY:
		int playerturkeyID=rmCreateObjectDef("player turkey");
        rmAddObjectDefItem(playerturkeyID, "turkey", rmRandInt(8,10), 10.0);
        rmSetObjectDefMinDistance(playerturkeyID, 10);
        rmSetObjectDefMaxDistance(playerturkeyID, 18);
        rmAddObjectDefConstraint(playerturkeyID, avoidAll);
        rmAddObjectDefConstraint(playerturkeyID, avoidImpassableLand);
        rmAddObjectDefConstraint(playerturkeyID, avoidCliff);
        rmSetObjectDefCreateHerd(playerturkeyID, true);
		
		// DEFINE THE PLAYER BERRYBUSH:
		int playerberriesID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerberriesID, "berrybush", rmRandInt(3,5), 4.0);
        rmSetObjectDefMinDistance(playerberriesID, 10);
        rmSetObjectDefMaxDistance(playerberriesID, 18);
        rmAddObjectDefConstraint(playerberriesID, avoidAll);
        rmAddObjectDefConstraint(playerberriesID, avoidImpassableLand);
        rmAddObjectDefConstraint(playerberriesID, avoidCliff);
        rmSetObjectDefCreateHerd(playerberriesID, true);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID= rmCreateObjectDef("player nugget"); 
	    rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidAll);
	    rmAddObjectDefConstraint(playerNuggetID, avoidCliff);
	    rmAddObjectDefConstraint(playerNuggetID, playerEdgeConstraint);
	    rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	    rmSetObjectDefMaxDistance(playerNuggetID, 30.0);

	    // DEFINE THE PLAYER TREE:
		int playerTreeID = rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, "TreeNewEngland", rmRandInt(5,10), 8.0);
        rmSetObjectDefMinDistance(playerTreeID, 15);
        rmSetObjectDefMaxDistance(playerTreeID, 20);
        rmAddObjectDefConstraint(playerTreeID, avoidAll);
        rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
/*================================================================================================================*/
// *********************************** PLACE THE PLAYER STARTING RESOURCES: ************************************* //
/*================================================================================================================*/
	    for(i = 1; < cNumberPlayers)
   {
	    // PLACE THE TCID:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
	    
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
		// PLACE THE PLAYER SILVER:
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
		// PLACE THE PLAYER TREE:
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
		// PLACE THE PLAYER TURKEY:
		rmPlaceObjectDefAtLoc(playerturkeyID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
		// PLACE THE PLAYER BERRYBUSH:
		rmPlaceObjectDefAtLoc(playerberriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        //rmPlaceObjectDefAtLoc(playerberriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    		
		// PLACE THE PLAYER NUGGET:
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        
		// CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// ********************************* DEFINE AND PLACE THE CLIFFS AND A POND: ************************************ //
/*================================================================================================================*/
	    // DEFINE AND PLACE A CENTER POND:
		int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 10.0);
		int avoidPond=rmCreateClassDistanceConstraint("stuff avoid ponds", rmClassID("pond"), 10.0);

        int numPonds=cNumberNonGaiaPlayers;
	    for(i=0; <numPonds)
   
        int smallPondID=rmCreateArea("small pond"+i);
        rmSetAreaSize(smallPondID, rmAreaTilesToFraction(1750), rmAreaTilesToFraction(1750));
        rmSetAreaWaterType(smallPondID, "saguenay lake");
        rmSetAreaBaseHeight(smallPondID, 4);
        rmAddAreaToClass(smallPondID, pondClass);
        rmSetAreaCoherence(smallPondID, 0.4);
        rmSetAreaSmoothDistance(smallPondID, 5);
        rmAddAreaConstraint(smallPondID, pondConstraint);
        rmAddAreaConstraint(smallPondID, avoidTradeRoute);
        //rmAddAreaConstraint(smallPondID, avoidImportantItem);
        rmAddAreaConstraint(smallPondID, avoidSocket);
	    rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.475, 0.475); 
        rmBuildArea(smallPondID);
/*----------------------------------------------------------------------------------------------------------------*/
		// DEFINE AND PLACE THE LEFT CLIFF:
		int smallCliffHeight2=rmRandInt(0,6);
		int smallMesaID2=rmCreateArea("small mesa2"+i);
		if ( cNumberNonGaiaPlayers < 6 )
		{
			rmSetAreaSize(smallMesaID2, rmAreaTilesToFraction(400), rmAreaTilesToFraction(400));  //First # is minimum square meters of material it will use to build.  Second # is maximum.  Currently I have them both set to the same because I want a certain size mountain every time.
		}
		else if ( cNumberNonGaiaPlayers < 8 )
		{
			rmSetAreaSize(smallMesaID2, rmAreaTilesToFraction(1400), rmAreaTilesToFraction(1400));  //First # is minimum square meters of material it will use to build.  Second # is maximum.  Currently I have them both set to the same because I want a certain size mountain every time.
		}
		else
		{
			rmSetAreaSize(smallMesaID2, rmAreaTilesToFraction(1600), rmAreaTilesToFraction(1600));  //First # is minimum square meters of material it will use to build.  Second # is maximum.  Currently I have them both set to the same because I want a certain size mountain every time.
		}

  		rmSetAreaCliffType(smallMesaID2, "New England");
		//rmAddAreaToClass(centerCliffs, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		rmSetAreaCliffEdge(smallMesaID2, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID2, rmRandInt(4, 6), 1.0, 1.0);  //was rmRandInt(6, 8)
		rmSetAreaCoherence(smallMesaID2, 0.88);
		rmSetAreaLocation(smallMesaID2, 0.25, 0.75); 
		rmAddAreaInfluenceSegment(smallMesaID2, 0.48, 0.43, 0.5, 0.40);  //Bottom - Original segment
		rmAddAreaInfluenceSegment(smallMesaID2, 0.46, 0.40, 0.53, 0.38); //Right
		rmAddAreaInfluenceSegment(smallMesaID2, 0.53, 0.45, 0.53, 0.38); //Top - Original segment
		rmAddAreaInfluenceSegment(smallMesaID2, 0.53, 0.45, 0.48, 0.43); //Left
		rmBuildArea(smallMesaID2);
/*----------------------------------------------------------------------------------------------------------------*/
		// DEFINE AND PLACE THE RIGHT CLIFF:
		int smallCliffHeight3=rmRandInt(0,6);
		int smallMesaID3=rmCreateArea("small mesa3"+i);
		if ( cNumberNonGaiaPlayers < 6 )
		{
			rmSetAreaSize(smallMesaID3, rmAreaTilesToFraction(400), rmAreaTilesToFraction(400));  //First # is minimum square meters of material it will use to build.  Second # is maximum.  Currently I have them both set to the same because I want a certain size mountain every time.
		}
		else if ( cNumberNonGaiaPlayers < 8 )
		{
			rmSetAreaSize(smallMesaID3, rmAreaTilesToFraction(1400), rmAreaTilesToFraction(1400));  //First # is minimum square meters of material it will use to build.  Second # is maximum.  Currently I have them both set to the same because I want a certain size mountain every time.
		}
		else
		{
			rmSetAreaSize(smallMesaID3, rmAreaTilesToFraction(1600), rmAreaTilesToFraction(1600));  //First # is minimum square meters of material it will use to build.  Second # is maximum.  Currently I have them both set to the same because I want a certain size mountain every time.
		}

  		rmSetAreaCliffType(smallMesaID3, "New England");
		//rmAddAreaToClass(centerCliffs, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		rmSetAreaCliffEdge(smallMesaID3, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID3, rmRandInt(4, 6), 1.0, 1.0);  //was rmRandInt(6, 8)
		rmSetAreaCoherence(smallMesaID3, 0.88);
		rmSetAreaLocation(smallMesaID3, 0.75, 0.25); 
		rmAddAreaInfluenceSegment(smallMesaID3, 0.48, 0.43, 0.5, 0.40);  //Bottom - Original segment
		rmAddAreaInfluenceSegment(smallMesaID3, 0.46, 0.40, 0.53, 0.38); //Right
		rmAddAreaInfluenceSegment(smallMesaID3, 0.53, 0.45, 0.53, 0.38); //Top - Original segment
		rmAddAreaInfluenceSegment(smallMesaID3, 0.53, 0.45, 0.48, 0.43); //Left
		rmBuildArea(smallMesaID3);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE TRADE ROUTE **************************************** //
/*================================================================================================================*/
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 6.0);

	    int tradeRouteID = rmCreateTradeRoute();
	    rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.0, 1.0);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.35, 0.65);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.70);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.70, 0.50);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.65, 0.35);
		rmAddTradeRouteWaypoint(tradeRouteID, 1.0, 0.0);

	    bool placedTradeRouteA = rmBuildTradeRoute(tradeRouteID, "dirt");
	    if(placedTradeRouteA == false)
		rmEchoError("Failed to place trade route 1");

	    rmPlaceObjectDefAtLoc(socketID, 0, 0.25, 0.75);
		rmPlaceObjectDefAtLoc(socketID, 0, 0.6, 0.6);
		rmPlaceObjectDefAtLoc(socketID, 0, 0.75, 0.25);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE THE MOOSES: ***************************************** //
/*================================================================================================================*/
        int moose1ID=rmCreateObjectDef("Moose Herds 1");
        rmAddObjectDefItem(moose1ID, "moose", rmRandInt(8,10), 8.0);
        rmSetObjectDefMinDistance(moose1ID, 0.0);
        rmSetObjectDefMaxDistance(moose1ID, 0.0);
	    rmAddObjectDefConstraint(moose1ID, avoidMoose);
	    rmSetObjectDefCreateHerd(moose1ID, true);
	    rmPlaceObjectDefAtLoc(moose1ID, 0, 0.15, 0.55); 
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.55, 0.15); 
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.45, 0.85); 
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.85, 0.45);

        int moose2ID=rmCreateObjectDef("Moose Herds 2");
        rmAddObjectDefItem(moose2ID, "moose", rmRandInt(8,10), 8.0);
        rmSetObjectDefMinDistance(moose2ID, 0.0);
        rmSetObjectDefMaxDistance(moose2ID, 0.0);
	    rmAddObjectDefConstraint(moose2ID, avoidMoose);
	    rmSetObjectDefCreateHerd(moose2ID, true);
	    rmPlaceObjectDefAtLoc(moose2ID, 0, 0.65, 0.65); 
		rmPlaceObjectDefAtLoc(moose2ID, 0, 0.325, 0.325); 
		//rmPlaceObjectDefAtLoc(moose2ID, 0, 0.45, 0.85); 
		//rmPlaceObjectDefAtLoc(moose2ID, 0, 0.85, 0.45);		
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE COWS: ******************************************* //
/*================================================================================================================*/
        int cow1ID=rmCreateObjectDef("The Cows 1");
        rmAddObjectDefItem(cow1ID, "cow", rmRandInt(6,8), 6.0);
        rmSetObjectDefMinDistance(cow1ID, 0.0);
        rmSetObjectDefMaxDistance(cow1ID, 0.0);
	    rmAddObjectDefConstraint(cow1ID, avoidCow);
	    rmSetObjectDefCreateHerd(cow1ID, true);
	    rmPlaceObjectDefAtLoc(cow1ID, 0, 0.05, 0.45); 
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.45, 0.05); 
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.55, 0.95); 
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.95, 0.55);  
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FRUITS: ***************************************** //
/*================================================================================================================*/
        int fruits1ID=rmCreateObjectDef("The Fruits 1");
        rmAddObjectDefItem(fruits1ID, "berrybush", rmRandInt(3,5), 6.0);
        rmSetObjectDefMinDistance(fruits1ID, 0.0);
        rmSetObjectDefMaxDistance(fruits1ID, 0.0);
	    rmAddObjectDefConstraint(fruits1ID, avoidFruits);
	    rmSetObjectDefCreateHerd(fruits1ID, true);
	    rmPlaceObjectDefAtLoc(fruits1ID, 0, 0.10, 0.30); 
		rmPlaceObjectDefAtLoc(fruits1ID, 0, 0.30, 0.10); 
		rmPlaceObjectDefAtLoc(fruits1ID, 0, 0.70, 0.90); 
		rmPlaceObjectDefAtLoc(fruits1ID, 0, 0.90, 0.70); 

        int fruits2ID=rmCreateObjectDef("The Fruits 2");
        rmAddObjectDefItem(fruits2ID, "berrybush", rmRandInt(3,5), 6.0);
        rmSetObjectDefMinDistance(fruits2ID, 0.0);
        rmSetObjectDefMaxDistance(fruits2ID, 0.0);
	    rmAddObjectDefConstraint(fruits2ID, avoidFruits);
	    rmSetObjectDefCreateHerd(fruits2ID, true);
	    rmPlaceObjectDefAtLoc(fruits2ID, 0, 0.15, 0.65); 
		rmPlaceObjectDefAtLoc(fruits2ID, 0, 0.65, 0.15); 
		rmPlaceObjectDefAtLoc(fruits2ID, 0, 0.35, 0.85); 
		rmPlaceObjectDefAtLoc(fruits2ID, 0, 0.85, 0.35);    			
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE GOLD MINES: *************************************** //
/*================================================================================================================*/
        int gold1ID=rmCreateObjectDef("The Gold Mines 1");
        rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(gold1ID, 0.0);
        rmSetObjectDefMaxDistance(gold1ID, 0.0);
	    rmAddObjectDefConstraint(gold1ID, avoidGold);
	    rmSetObjectDefCreateHerd(gold1ID, true);
	    rmPlaceObjectDefAtLoc(gold1ID, 0, 0.05, 0.55); 
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.55, 0.05); 
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.45, 0.95); 
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.95, 0.45);
		
		int gold2ID=rmCreateObjectDef("The Gold Mines 2");
        rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(gold2ID, 0.0);
        rmSetObjectDefMaxDistance(gold2ID, 0.0);
	    rmAddObjectDefConstraint(gold2ID, avoidGold);
	    rmSetObjectDefCreateHerd(gold2ID, true);
	    rmPlaceObjectDefAtLoc(gold2ID, 0, 0.35, 0.95); 
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.95, 0.35); 
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.05, 0.65); 
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.65, 0.05);
		
		int gold3ID=rmCreateObjectDef("The Gold Mines 3");
        rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(gold3ID, 0.0);
        rmSetObjectDefMaxDistance(gold3ID, 0.0);
	    rmAddObjectDefConstraint(gold3ID, avoidGold);
	    rmSetObjectDefCreateHerd(gold3ID, true);
	    rmPlaceObjectDefAtLoc(gold3ID, 0, 0.25, 0.55); 
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.55, 0.25); 
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.75, 0.45); 
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.45, 0.75);
		
		int gold4ID=rmCreateObjectDef("The Gold Mines 4");
        rmAddObjectDefItem(gold4ID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(gold4ID, 0.0);
        rmSetObjectDefMaxDistance(gold4ID, 0.0);
	    rmAddObjectDefConstraint(gold4ID, avoidGold);
	    rmSetObjectDefCreateHerd(gold4ID, true);
	    rmPlaceObjectDefAtLoc(gold4ID, 0, 0.175, 0.175); 
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.825, 0.825); 
		//rmPlaceObjectDefAtLoc(gold4ID, 0, 0.05, 0.65); 
		//rmPlaceObjectDefAtLoc(gold4ID, 0, 0.65, 0.05);
/*================================================================================================================*/
        int nugget1ID= rmCreateObjectDef("The Nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
  	    rmAddObjectDefConstraint(nugget1ID, avoidCloseNugget);
  	    rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.15, 0.45);
        rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.45, 0.15);   
        rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.55, 0.85);   
        rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.85, 0.55); 

        int nugget2ID= rmCreateObjectDef("The Nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
  	    rmAddObjectDefConstraint(nugget2ID, avoidCloseNugget);
  	    rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.25, 0.45);
        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.45, 0.25);   
        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.55, 0.75);   
        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.75, 0.55); 

        int nugget3ID= rmCreateObjectDef("The Nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
  	    rmAddObjectDefConstraint(nugget3ID, avoidCloseNugget);
  	    rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.30, 0.60);
        rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.60, 0.30);   
        rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.40, 0.70);   
        rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.70, 0.40);

        int nugget4ID= rmCreateObjectDef("The Nugget 4"); 
	    rmAddObjectDefItem(nugget4ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget4ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget4ID, 0.0);
  	    rmAddObjectDefConstraint(nugget4ID, avoidCloseNugget);
  	    rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.025, 0.50);
        rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.50, 0.025);   
        rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.975, 0.50);   
        rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.50, 0.975);

        int nugget5ID= rmCreateObjectDef("The Nugget 5"); 
	    rmAddObjectDefItem(nugget5ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget5ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget5ID, 0.0);
  	    rmAddObjectDefConstraint(nugget5ID, avoidCloseNugget);
  	    rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.125, 0.225);
        rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.225, 0.125);   
        rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.875, 0.775);   
        rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.775, 0.875);

        int nugget6ID= rmCreateObjectDef("The Nugget 6"); 
	    rmAddObjectDefItem(nugget6ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget6ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget6ID, 0.0);
  	    rmAddObjectDefConstraint(nugget6ID, avoidCloseNugget);
  	    rmPlaceObjectDefAtLoc(nugget6ID, 0, 0.10, 0.75);
        rmPlaceObjectDefAtLoc(nugget6ID, 0, 0.75, 0.10);   
        rmPlaceObjectDefAtLoc(nugget6ID, 0, 0.25, 0.90);   
        rmPlaceObjectDefAtLoc(nugget6ID, 0, 0.90, 0.25);			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE FORESTS AREAS: ************************************* //
/*================================================================================================================*/

	        if (cNumberNonGaiaPlayers > 4)
		    numTries=3*cNumberNonGaiaPlayers;
	        else
		    numTries=5*cNumberNonGaiaPlayers;
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int forestID=rmCreateArea("forestID"+i, westIslandID);
			rmSetAreaWarnFailure(forestID, false);
			rmSetAreaSize(forestID, rmAreaTilesToFraction(180), rmAreaTilesToFraction(210));
			// rmSetAreaForestType(forestID, "NW Territory Birch Forest");
			   rmSetAreaForestType(forestID, "new england forest");
			rmSetAreaForestDensity(forestID, 0.7);
			rmSetAreaForestClumpiness(forestID, 0.6);		
			rmSetAreaForestUnderbrush(forestID, 0.6);
			rmSetAreaMinBlobs(forestID, 1);
			rmSetAreaMaxBlobs(forestID, 10);						
			rmSetAreaMinBlobDistance(forestID, 5.0);
			rmSetAreaMaxBlobDistance(forestID, 20.0);
			rmSetAreaCoherence(forestID, 0.4);
			rmSetAreaSmoothDistance(forestID, 10);
			rmAddAreaToClass(forestID, rmClassID("classForest"));
			rmAddAreaConstraint(forestID, avoidForest);  
			rmAddAreaConstraint(forestID, shortAvoidImportantItem);
			rmAddAreaConstraint(forestID, playerConstraint);
			rmAddAreaConstraint(forestID, avoidCliff);
			rmAddAreaConstraint(forestID, avoidSocket);
			rmAddAreaConstraint(forestID, avoidPond);
			rmAddAreaConstraint(forestID, avoidAll);
			rmAddAreaConstraint(forestID, avoidMoose);
			rmAddAreaConstraint(forestID, avoidCow);
			rmAddAreaConstraint(forestID, avoidGold);
			rmAddAreaConstraint(forestID, avoidFruits);
			rmAddAreaConstraint(forestID, avoidCloseNugget);
			if(rmBuildArea(forestID)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==10)
					break;
			}
			else
				failCount=0; 
		}
		
/*----------------------------------------------------------------------------------------------------------------*/

	        if (cNumberNonGaiaPlayers > 4)
		    numTries=3*cNumberNonGaiaPlayers;
	        else
		    numTries=5*cNumberNonGaiaPlayers; 
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int forestEastID=rmCreateArea("forestEastID"+i, eastIslandID);
			rmSetAreaWarnFailure(forestEastID, false);
			rmSetAreaSize(forestEastID, rmAreaTilesToFraction(180), rmAreaTilesToFraction(210));
			// rmSetAreaForestType(forestEastID, "NW Territory Birch Forest");
			   rmSetAreaForestType(forestEastID, "new england forest");
			rmSetAreaForestDensity(forestEastID, 0.7);
			rmSetAreaForestClumpiness(forestEastID, 0.6);		
			rmSetAreaForestUnderbrush(forestEastID, 0.6);
			rmSetAreaMinBlobs(forestEastID, 2);
			rmSetAreaMaxBlobs(forestEastID, 10);						
			rmSetAreaMinBlobDistance(forestEastID, 5.0);
			rmSetAreaMaxBlobDistance(forestEastID, 20.0);
			rmSetAreaCoherence(forestEastID, 0.4);
			rmSetAreaSmoothDistance(forestEastID, 10);
			rmAddAreaToClass(forestEastID, rmClassID("classForest"));
			rmAddAreaConstraint(forestEastID, avoidForest);  
			rmAddAreaConstraint(forestEastID, shortAvoidImportantItem);
			rmAddAreaConstraint(forestEastID, playerConstraint);
			rmAddAreaConstraint(forestEastID, avoidCliff);
			rmAddAreaConstraint(forestEastID, avoidSocket);
			rmAddAreaConstraint(forestEastID, avoidPond);
			rmAddAreaConstraint(forestEastID, avoidAll);
			rmAddAreaConstraint(forestEastID, avoidMoose);
			rmAddAreaConstraint(forestEastID, avoidCow);
			rmAddAreaConstraint(forestEastID, avoidGold);
			rmAddAreaConstraint(forestEastID, avoidFruits);
			rmAddAreaConstraint(forestEastID, avoidCloseNugget);
			if(rmBuildArea(forestEastID)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==10)
					break;
			}
			else
				failCount=0; 
		}
		
/*----------------------------------------------------------------------------------------------------------------*/

	        numTries=6*cNumberNonGaiaPlayers;  
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int forestRandomID=rmCreateArea("forestRandomID"+i);
			rmSetAreaWarnFailure(forestRandomID, false);
			rmSetAreaSize(forestRandomID, rmAreaTilesToFraction(70), rmAreaTilesToFraction(120));
			// rmSetAreaForestType(forestRandomID, "NW Territory Birch Forest");
			   rmSetAreaForestType(forestRandomID, "new england forest");
			rmSetAreaForestDensity(forestRandomID, 0.6);
			rmSetAreaForestClumpiness(forestRandomID, 0.5);		
			rmSetAreaForestUnderbrush(forestRandomID, 0.4);
			rmSetAreaMinBlobs(forestRandomID, 2);
			rmSetAreaMaxBlobs(forestRandomID, 6);						
			rmSetAreaMinBlobDistance(forestRandomID, 5.0);
			rmSetAreaMaxBlobDistance(forestRandomID, 15.0);
			rmSetAreaCoherence(forestRandomID, 0.4);
			rmSetAreaSmoothDistance(forestRandomID, 10);
			rmAddAreaToClass(forestRandomID, rmClassID("classForest"));
			rmAddAreaConstraint(forestRandomID, avoidForestFar); 
			rmAddAreaConstraint(forestRandomID, shortAvoidImportantItem);
			rmAddAreaConstraint(forestRandomID, playerConstraint);
			rmAddAreaConstraint(forestRandomID, avoidCliff);
			rmAddAreaConstraint(forestRandomID, avoidSocket);
			rmAddAreaConstraint(forestRandomID, avoidPond);
			rmAddAreaConstraint(forestRandomID, avoidMoose);
			rmAddAreaConstraint(forestRandomID, avoidCow);
			rmAddAreaConstraint(forestRandomID, avoidGold);
			rmAddAreaConstraint(forestRandomID, avoidFruits);
			rmAddAreaConstraint(forestRandomID, avoidCloseNugget);
			rmAddAreaConstraint(forestRandomID, avoidAll);
			if(rmBuildArea(forestRandomID)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==10)
					break;
			}
			else
				failCount=0; 
		}
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/   
	// Text
	

	// Resources that can be placed after forests


	// Text
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE FISHBASS: **************************************** //
/*================================================================================================================*/
        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishBass", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers); 
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE SOME PERCHING VULTURES: ********************************* //
/*================================================================================================================*/
	    int vultureID=rmCreateObjectDef("perching vultures");
	    rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, 0.0);
	    rmAddObjectDefConstraint(vultureID, avoidVulture);
        rmPlaceObjectDefAtLoc(vultureID, 0, 0.2, 0.5);
        rmPlaceObjectDefAtLoc(vultureID, 0, 0.5, 0.2);	
        rmPlaceObjectDefAtLoc(vultureID, 0, 0.8, 0.5);	
        rmPlaceObjectDefAtLoc(vultureID, 0, 0.5, 0.8);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE SOME HORSES: ****************************************** //
/*================================================================================================================*/
        int horse1ID=rmCreateObjectDef("The Horses 1");
	    rmAddObjectDefItem(horse1ID, "Horse", rmRandInt(5,9), 8);
		rmSetObjectDefCreateHerd(horse1ID, true);
	    rmSetObjectDefMinDistance(horse1ID, 0.0);
	    rmSetObjectDefMaxDistance(horse1ID, 0.0);
	    rmAddObjectDefConstraint(horse1ID, avoidHorse);
        rmPlaceObjectDefAtLoc(horse1ID, 0, 0.4, 0.9);
        rmPlaceObjectDefAtLoc(horse1ID, 0, 0.9, 0.4);	
        rmPlaceObjectDefAtLoc(horse1ID, 0, 0.10, 0.60);	
        rmPlaceObjectDefAtLoc(horse1ID, 0, 0.60, 0.10);	
/*================================================================================================================*/		
// ********************************* DEFINE AND PLACE SOME PROPEAGLESROCKS: ************************************* //
/*================================================================================================================*/
        int deco1ID=rmCreateObjectDef("The ProEaglesRocks 1");
	    rmAddObjectDefItem(deco1ID, "PropEaglesRocks", 1.0, 0.0);
		rmSetObjectDefMinDistance(deco1ID, 0.0);
	    rmSetObjectDefMaxDistance(deco1ID, 0.0);
	    rmAddObjectDefConstraint(deco1ID, avoidDeco1);
        rmPlaceObjectDefAtLoc(deco1ID, 0, 0.10, 0.70);
        rmPlaceObjectDefAtLoc(deco1ID, 0, 0.70, 0.10);	
        rmPlaceObjectDefAtLoc(deco1ID, 0, 0.30, 0.90);	
        rmPlaceObjectDefAtLoc(deco1ID, 0, 0.90, 0.30);	
/*================================================================================================================*/		
// ************************************** DEFINE AND PLACE SOME WOLFS: ****************************************** //
/*================================================================================================================*/
        int deco2ID=rmCreateObjectDef("The Wolf 1");
	    rmAddObjectDefItem(deco2ID, "Wolf", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(deco2ID, 0.0);
	    rmSetObjectDefMaxDistance(deco2ID, 0.0);
	    rmAddObjectDefConstraint(deco2ID, avoidDeco2);
        rmPlaceObjectDefAtLoc(deco2ID, 0, 0.40, 0.80);
        rmPlaceObjectDefAtLoc(deco2ID, 0, 0.80, 0.40);	
        rmPlaceObjectDefAtLoc(deco2ID, 0, 0.20, 0.60);	
        rmPlaceObjectDefAtLoc(deco2ID, 0, 0.60, 0.20);			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}  
/*================================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*================================================================================================================*/
