/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/
// RIO GRANDE:
// CREATED BY DANY:
// MARCH 2007:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// **************************************** CHOOSE THE NATIVE TRIBES: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int whichNative = rmRandInt(1,6);
       
	    int subCiv0 = -1;
        int subCiv1 = -1;
        string nativeName = "";

	    if (whichNative < 5)
	{
        subCiv0 = rmGetCivID("Cree");
        rmEchoInfo("subCiv0 is Cree "+subCiv0);
        subCiv1 = rmGetCivID("Cree");
        rmEchoInfo("subCiv1 is Cree "+subCiv1);
        rmSetSubCiv(0, "Cree", true);
        rmSetSubCiv(1, "Cree", true);
        nativeName = "native Cree village ";
	}
	        else
    {
        subCiv0 = rmGetCivID("Cherokee");
        rmEchoInfo("subCiv0 is Cherokee "+subCiv0);
        subCiv1 = rmGetCivID("Cherokee");
        rmEchoInfo("subCiv1 is Cherokee "+subCiv1);
        rmSetSubCiv(0, "Cherokee", true);
        rmSetSubCiv(1, "Cherokee", true);
        nativeName = "native Cherokee village ";
   }	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************* DEFINE THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
	    int playerTiles = 25000;
	    
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// *************************************** DEFINE THE MAP PARAMETERS: ******************************************* //
/*================================================================================================================*/
	    // SET THE MAP ELEVATION PARAMETERS:
		// rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	    rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.3, 2.0); // FROM SAGUENAY: -- ground is almost flat...
		
		// SET THE MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(4.0);

        // PICKS DEFAULT WATER:
	    // rmSetSeaType("Amazon River");
		   rmSetSeaType("Texas Pond");
	    
		// SET THE BASE TERRAIN MIX:
		rmSetBaseTerrainMix("texas_dirt");
	
	    // SET THE TERRAIN INITIALIZATION:
		rmTerrainInitialize("texas\ground4_tex", 4.0);
	
	    // SET THE MAP TYPE:
		rmSetMapType("Texas");
	    rmSetMapType("grass");
	    rmSetMapType("land"); // there is no water on this map...except river...
	
	    // SET THE LIGHTING:
		rmSetLightingSet("Texas");
	
	    // SET THE CORNER CONSTRAINT:
	    rmSetWorldCircleConstraint(false);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int classPlayer=rmDefineClass("player"); // this line is always there... 
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("natives");
	    rmDefineClass("classNugget");
		
		rmDefineClass("center");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE SOME CONSTRAINTS: ******************************************* //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHERS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    // PLAYER AVOIDANCE:
	int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
	int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players short", classPlayer, 8.0);
		
	// CENTER MAP AVOIDANCE:
	int centerConstraintFar=rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), rmXFractionToMeters(0.23));
	int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), rmXFractionToMeters(0.10));
	
    // SEA FOOD AVOIDANCE:
	int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
    int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
   	
	// IMPASSABLE LAND AVOIDANCE:
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
	
	// FOREST AVOIDANCE:
    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 15.0);
	int shortForestConstraint=rmCreateClassDistanceConstraint("short forest vs. forest", rmClassID("classForest"), 10.0);

	
	// RESOURCE AVOIDANCE:
	int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
	
	// TREES AVOIDANCE:
	int avoidTrees=rmCreateTypeDistanceConstraint("stuff avoid trees", "TreeTexasDirt", 5.0);
	
	// GOLD MINES AVOIDANCE:
	int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold mines", "minegold", 5.0);
	
	// DEER AVOIDANCE:
	int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoid deers", "deer", 5.0);
	
	// COW AVOIDANCE:
	int avoidCow=rmCreateTypeDistanceConstraint("stuff avoid cows", "cow", 5.0);
	
	// BERRYBUSH AVOIDANCE:
	int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid berries", "berrybush", 5.0);
	
	// NATIVES AVOIDANCE:
	int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 10.0);
    int avoidNativesFar=rmCreateClassDistanceConstraint("stuff avoids natives far", rmClassID("natives"), 45.0);
	
	// NUGGET AVOIDANCE:
	int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 15.0);
	int shortAvoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget short", rmClassID("classNugget"), 5.0);
	    
		   	   
	// V.P. AVOIDANCE:
	int avoidTradeRoute=rmCreateTradeRouteDistanceConstraint("trade route", 5.0);
	int avoidTradeRouteSockets=rmCreateTypeDistanceConstraint("avoid Trade Socket", "sockettraderoute", 10);
	
	// UNITS AVOIDANCE:
	int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 8.0);
	    
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ********************************* DEFINE THE STARTING TCID AND STARTING UNITS: ******************************* //
/*================================================================================================================*/
	    // DEFINE THE TCID:
		int TCID = rmCreateObjectDef("player TC");
		if (rmGetNomadStart())
		{
			rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
		}
		else
		{
            rmAddObjectDefItem(TCID, "townCenter", 1, 0);
		}
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 0.0);
	    rmAddObjectDefConstraint(TCID, avoidTradeRoute); 
	    rmAddObjectDefToClass(TCID, rmClassID("player"));
	    rmAddObjectDefToClass(TCID, rmClassID("startingUnit"));

	    // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 8.0);
	    rmSetObjectDefMaxDistance(startingUnits, 12.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidStartingUnits);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************************** DEFINE THE STARTING RESOURCES: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	    rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	    rmSetObjectDefMinDistance(playerSilverID, 19.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 24.0);
	    //rmAddObjectDefConstraint(playerSilverID, avoidAll);
	    rmAddObjectDefToClass(playerSilverID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);
	    rmAddObjectDefConstraint(playerSilverID, avoidStartingUnits);

	    // DEFINE THE STARTING TREE:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeTexasDirt", rmRandInt(7,10), 8.0);
	    rmAddObjectDefItem(StartAreaTreeID, "UnderbrushDesert", rmRandInt(4,6), 8.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 20);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 25);
	    rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidImpassableLand);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidGold);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnits);
	    //rmAddObjectDefConstraint(StartAreaTreeID, avoidResource);

	    // DEFINE THE STARTING TURKEY:
		int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", 4, 4.0);
	    //rmSetObjectDefCreateHerd(StartBerriesID, true);
	    rmSetObjectDefMinDistance(StartBerriesID, 10);
	    rmSetObjectDefMaxDistance(StartBerriesID, 18);
	    rmAddObjectDefToClass(StartBerriesID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(StartBerriesID, avoidImpassableLand);
	    rmAddObjectDefConstraint(StartBerriesID, avoidTradeRoute);
	    rmAddObjectDefConstraint(StartBerriesID, avoidStartingUnits);
	    rmAddObjectDefConstraint(StartBerriesID, avoidResource);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE TRADE ROUTE: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ******************************************* CREATE A CENTER AREA: ******************************************** //
/*================================================================================================================*/
	    // THIS FORMULA CREATES A PERFECT CIRCLE:
		// SO YOU GET AN AREA IN A PERFECT CIRCULAR SHAPE:
		// THIS AREA CAN BE USED TO CONFINE A FOREST OR A LAKE OR A MOUNTAIN:
		int centerID=rmCreateArea("center");
	    rmSetAreaSize(centerID, 0.05, 0.05);
	    rmSetAreaLocation(centerID, 0.5, 0.5);
	    rmSetAreaCoherence(centerID, 1.0);
		//rmSetAreaMix(centerID, "rockies_grass"); // added by me to see it ...
	    rmAddAreaToClass(centerID, rmClassID("center"));
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/		
// ************************************* SET UP PLAYER STARTING LOCATIONS: ************************************** //
/*================================================================================================================*/
        // ONLY 2 PLAYERS:
		// ONE TO THE NORTH:
		// ONE TO THE SOUTH:
		
		//rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(0);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(1,0.775,0.775);

        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(1);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(2,0.225,0.225);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
        float playerFraction = rmAreaTilesToFraction(100);
        
		for(i = 0; < cNumberNonGaiaPlayers)
   {
        // CREATE THE AREA:
        int id = rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
	    rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
	    rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); // in Sonora, it was disable by ensemble...
        //rmAddAreaConstraint(id, playerEdgeConstraint);// in Sonora, it was disable by ensemble... 
	   
	    // SET AREA TERRAIN TYPE:
		rmSetAreaTerrainType(id, "texas\ground4_tex");
			    
		// SET AREA MIX:
		//rmSetAreaMix(id, "texas_dirt"); // added by me as a possibility:
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD THE AREAS:
        rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/		  
// ********************************* DEFINE AND PLACE THE UBER MINE AT CENTER *********************************** //
/*================================================================================================================*/
        // THIS OFFERS 2 POSSIBILITIES: 
		// FIRST ONE: THE UBER MINE:
		// SECOND ONE: THE NATIVE TRIBE:
		// SO KEEPING THE FRAME OF THE MENU:
		// THE UBER MINE AND THE NATIVE TRIBE COULD BE REPLACED BY ANYTHING:
/*----------------------------------------------------------------------------------------------------------------*/		
/*
	    float centerType = rmRandFloat(0.0, 1.0);
	    if (centerType <= 0.5)
	{
	    int uberMineType = rmRandInt(1,3);
	    int uberMineID = -1;
	    uberMineID = rmCreateGrouping("ubermine","sonoramegamine_0"+uberMineType);
	    rmSetGroupingMinDistance(uberMineID, 0.0);
	    rmSetGroupingMaxDistance(uberMineID, 0.0);
	    rmAddGroupingToClass(uberMineID, rmClassID("canyon"));
	    rmPlaceGroupingAtLoc(uberMineID, 0, 0.55, 0.50);
	}
	    else if (centerType <= 0.8)
	{
		if (subCiv2 == rmGetCivID("aztecs")) // RANDOM CENTER NATIVES
	 {   
		int aztecVillage2ID = -1;
		int aztecVillage2Type = rmRandInt(1,3); //rmRandInt(1,9);
		aztecVillage2ID = rmCreateGrouping("aztec village2", "native aztec village "+aztecVillage2Type);
		rmSetGroupingMinDistance(aztecVillage2ID, 0.0);
		rmSetGroupingMaxDistance(aztecVillage2ID, 0.0);
		rmAddGroupingToClass(aztecVillage2ID, rmClassID("natives"));
		rmAddGroupingToClass(aztecVillage2ID, rmClassID("canyon"));
		rmAddGroupingToClass(aztecVillage2ID, rmClassID("importantItem"));
		rmPlaceGroupingAtLoc(aztecVillage2ID, 0, 0.55, 0.55);
	 }
	}
*/	
/*================================================================================================================*/
//  *************************************** DEFINE AND PLACE THE RIVER: ***************************************** //
/*================================================================================================================*/
/*
    // FOR THE INT AREAID: IT SEEMS THAT YOU CAN NAME IT WITH THE LAKE NAMES AND ALSO THE POND NAMES:
	// FOR THE NUMBERS: 1 ,1: THE SMALLER THE NUMBERS THE MORE LINEAR THE RIVER BECOMES:
	// FOR THE NUMBERS: 20 ,20: THE BIGGER THE NUMBERS THE LARGER THE RIVER BECOMES:
	int AmazonRiver = rmRiverCreate(-1, "texas pond", 1, 1, 20, 20); // SINGLE WIDE RIVER
	
	rmRiverSetConnections(AmazonRiver, 0.0, 1.0, 1.0, 0.0); // it define the start and the end of the river:
	
	rmRiverSetShallowRadius(AmazonRiver, rmRandInt(10, 12));
	rmRiverAddShallow(AmazonRiver, 0.3); // Begin defining shallows in the river

	rmRiverSetShallowRadius(AmazonRiver, rmRandInt(10, 12));
	rmRiverAddShallow(AmazonRiver, 0.7);

	rmRiverSetBankNoiseParams(AmazonRiver, 0.07, 2, 1.5, 10.0, 0.667, 3.0);

	rmRiverBuild(AmazonRiver);
	rmRiverReveal(AmazonRiver, 0);
*/ 
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE RIVER: ***************************************** //
/*================================================================================================================*/
    // FOR INT TEXASPOND: IT SEEMS THAT YOU CAN NAMED IT THE WAY YOU WANT IT:
	// FOR THE INT AREAID: IT SEEMS THAT YOU CAN NAME IT WITH THE LAKE NAMES AND ALSO THE POND NAMES:
	// FOR THE NUMBERS: 1 ,1: THE SMALLER THE NUMBERS THE MORE LINEAR THE RIVER BECOMES:
	// FOR THE NUMBERS: 20 ,20: THE BIGGER THE NUMBERS THE LARGER THE RIVER BECOMES:
	int TexasPond = rmRiverCreate(-1, "texas pond", 1, 1, 12, 12); // SINGLE WIDE POND:
	
	rmRiverSetConnections(TexasPond, 0.0, 1.0, 1.0, 0.0); // it define the start and the end of the pond:
	
	rmRiverSetShallowRadius(TexasPond, rmRandInt(10, 12));
	rmRiverAddShallow(TexasPond, 0.3); // Begin defining shallows in the pond

	rmRiverSetShallowRadius(TexasPond, rmRandInt(10, 12));
	rmRiverAddShallow(TexasPond, 0.7);

	rmRiverSetBankNoiseParams(TexasPond, 0.07, 2, 1.5, 10.0, 0.667, 3.0);

	rmRiverBuild(TexasPond);
	//rmRiverReveal(TexasPond, 0);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.58);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int nativeVillageA = 0;
      int nativeVillageTypeA = rmRandInt(1,5);
      
      nativeVillageA = rmCreateGrouping("Native village A "+i, nativeName+nativeVillageTypeA);
      rmSetGroupingMinDistance(nativeVillageA, 0.0);
      rmSetGroupingMaxDistance(nativeVillageA, 0.0);
      rmAddGroupingConstraint(nativeVillageA, avoidImpassableLand);
      rmAddGroupingToClass(nativeVillageA, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillageA, rmClassID("importantItem"));
    
      rmPlaceGroupingAtLoc(nativeVillageA, 0, 0.10, 0.40);
	  rmPlaceGroupingAtLoc(nativeVillageA, 0, 0.40, 0.10);
/*----------------------------------------------------------------------------------------------------------------*/
      int nativeVillageB = 0;
      int nativeVillageTypeB = rmRandInt(1,5);

      nativeVillageB = rmCreateGrouping("Native village B "+i, nativeName+nativeVillageTypeB);
      rmSetGroupingMinDistance(nativeVillageB, 0.0);
      rmSetGroupingMaxDistance(nativeVillageB, 0.0);
      rmAddGroupingConstraint(nativeVillageB, avoidImpassableLand);
      rmAddGroupingToClass(nativeVillageB, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillageB, rmClassID("importantItem"));
      
      rmPlaceGroupingAtLoc(nativeVillageB, 0, 0.60, 0.90);
      rmPlaceGroupingAtLoc(nativeVillageB, 0, 0.90, 0.60);
/*================================================================================================================*/
      int nativeVillageC = 0;
      int nativeVillageTypeC = rmRandInt(1,5);

      nativeVillageC = rmCreateGrouping("Native village C "+i, nativeName+nativeVillageTypeC);
      rmSetGroupingMinDistance(nativeVillageC, 0.0);
      rmSetGroupingMaxDistance(nativeVillageC, 0.0);
      rmAddGroupingConstraint(nativeVillageC, avoidImpassableLand);
      rmAddGroupingToClass(nativeVillageC, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillageC, rmClassID("importantItem"));
      
      rmPlaceGroupingAtLoc(nativeVillageC, 0, 0.40, 0.40);
      rmPlaceGroupingAtLoc(nativeVillageC, 0, 0.60, 0.60);  	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.59);
/*================================================================================================================*/
// ************************ PLACE THE TCID AND THE STARTING UNITS AND STARTING RESOURCES: *********************** //
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
	{
		
		// TEST OF MARCIN'S STARTING UNITS STUFF:
		// PLACING THE TCID AND THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING THE RESOURCES:
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE SOME RANDOM TREES: ************************************** //
/*================================================================================================================*/
        int Trees1ID=rmCreateObjectDef("The Random Trees 1");
        rmAddObjectDefItem(Trees1ID, "TreeTexasDirt", rmRandInt(12,15), 10.0);
		//rmAddObjectDefItem(Trees1ID, "TreeSaguenay", 1, 0.0);
        rmSetObjectDefMinDistance(Trees1ID, 0.0);
        rmSetObjectDefMaxDistance(Trees1ID, 0.0);
        rmAddObjectDefConstraint(Trees1ID, avoidTrees);
        rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.325, 0.825);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.825, 0.325);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.675, 0.175);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.175, 0.675);
		
		int Trees2ID=rmCreateObjectDef("The Random Trees 2");
        rmAddObjectDefItem(Trees2ID, "TreeTexasDirt", rmRandInt(12,15), 10.0);
		//rmAddObjectDefItem(Trees2ID, "TreeSaguenay", 1, 0.0);
        rmSetObjectDefMinDistance(Trees2ID, 0.0);
        rmSetObjectDefMaxDistance(Trees2ID, 0.0);
        rmAddObjectDefConstraint(Trees2ID, avoidTrees);
        rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.3, 0.3);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.7, 0.7);
				
		int Trees3ID=rmCreateObjectDef("The Random Trees 3");
        rmAddObjectDefItem(Trees3ID, "TreeTexasDirt", rmRandInt(6,8), 6.0);
		//rmAddObjectDefItem(Trees3ID, "TreeSaguenay", 1, 0.0);
        rmSetObjectDefMinDistance(Trees3ID, 0.0);
        rmSetObjectDefMaxDistance(Trees3ID, 0.0);
        rmAddObjectDefConstraint(Trees3ID, avoidTrees);
        rmPlaceObjectDefAtLoc(Trees3ID, 0, 0.56, 0.56);
		rmPlaceObjectDefAtLoc(Trees3ID, 0, 0.44, 0.44);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE COWS HERDS: ************************************** //
/*================================================================================================================*/		
        int Cow1ID=rmCreateObjectDef("The Cow Herds 1");
        rmAddObjectDefItem(Cow1ID, "cow", rmRandInt(5,7), 5.0);
		rmSetObjectDefMinDistance(Cow1ID, 0.0);
        rmSetObjectDefMaxDistance(Cow1ID, 0.0);
        rmAddObjectDefConstraint(Cow1ID, avoidCow);
        rmPlaceObjectDefAtLoc(Cow1ID, 0, 0.06, 0.65);
		rmPlaceObjectDefAtLoc(Cow1ID, 0, 0.65, 0.06);
		rmPlaceObjectDefAtLoc(Cow1ID, 0, 0.35, 0.94);
		rmPlaceObjectDefAtLoc(Cow1ID, 0, 0.94, 0.35);
		
		int Cow2ID=rmCreateObjectDef("The Cow Herds 2");
        rmAddObjectDefItem(Cow2ID, "cow", rmRandInt(5,7), 5.0);
		rmSetObjectDefMinDistance(Cow2ID, 0.0);
        rmSetObjectDefMaxDistance(Cow2ID, 0.0);
        rmAddObjectDefConstraint(Cow2ID, avoidCow);
        rmPlaceObjectDefAtLoc(Cow2ID, 0, 0.35, 0.35);
		rmPlaceObjectDefAtLoc(Cow2ID, 0, 0.65, 0.65);
		//rmPlaceObjectDefAtLoc(Cow2ID, 0, 0.35, 0.94);
		//rmPlaceObjectDefAtLoc(Cow2ID, 0, 0.94, 0.35);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //
/*================================================================================================================*/
        int Berries1ID=rmCreateObjectDef("The Berries 1");
        rmAddObjectDefItem(Berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(Berries1ID, 0.0);
        rmSetObjectDefMaxDistance(Berries1ID, 0.0);
        rmAddObjectDefConstraint(Berries1ID, avoidFruits);
        rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.115, 0.225);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.225, 0.115);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.875, 0.775);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.775, 0.875);	
/*----------------------------------------------------------------------------------------------------------------*/
        int Berries2ID=rmCreateObjectDef("The Berries 2");
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(Berries2ID, 0.0);
        rmSetObjectDefMaxDistance(Berries2ID, 0.0);
        rmAddObjectDefConstraint(Berries2ID, avoidFruits);
        rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.95, 0.40);
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.40, 0.95);
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.05, 0.60);
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.60, 0.05);
/*----------------------------------------------------------------------------------------------------------------*/
        int Berries3ID=rmCreateObjectDef("The Berries 3");
        rmAddObjectDefItem(Berries3ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(Berries3ID, 0.0);
        rmSetObjectDefMaxDistance(Berries3ID, 0.0);
        rmAddObjectDefConstraint(Berries3ID, avoidFruits);
        rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.35, 0.45);
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.45, 0.35);
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.55, 0.65);
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.65, 0.55);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE GOLD MINES: *************************************** //
/*================================================================================================================*/
        int Gold1ID=rmCreateObjectDef("The Gold Mines 1");
        rmAddObjectDefItem(Gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(Gold1ID, 0.0);
        rmSetObjectDefMaxDistance(Gold1ID, 0.0);
        rmAddObjectDefConstraint(Gold1ID, avoidGold);
        rmPlaceObjectDefAtLoc(Gold1ID, 0, 0.1, 0.6);
		rmPlaceObjectDefAtLoc(Gold1ID, 0, 0.6, 0.1);
		rmPlaceObjectDefAtLoc(Gold1ID, 0, 0.4, 0.9);
		rmPlaceObjectDefAtLoc(Gold1ID, 0, 0.9, 0.4);

        int Gold2ID=rmCreateObjectDef("The Gold Mines 2");
        rmAddObjectDefItem(Gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(Gold2ID, 0.0);
        rmSetObjectDefMaxDistance(Gold2ID, 0.0);
        rmAddObjectDefConstraint(Gold2ID, avoidGold);
        rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.3, 0.4);
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.4, 0.3);
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.6, 0.7);
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.7, 0.6);
		
		int Gold3ID=rmCreateObjectDef("The Gold Mines 3");
        rmAddObjectDefItem(Gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(Gold3ID, 0.0);
        rmSetObjectDefMaxDistance(Gold3ID, 0.0);
        rmAddObjectDefConstraint(Gold3ID, avoidGold);
        rmPlaceObjectDefAtLoc(Gold3ID, 0, 0.165, 0.165);
		rmPlaceObjectDefAtLoc(Gold3ID, 0, 0.835, 0.835);
		//rmPlaceObjectDefAtLoc(Gold3ID, 0, 0.6, 0.7);
		//rmPlaceObjectDefAtLoc(Gold3ID, 0, 0.7, 0.6);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE DEERS: ****************************************** //
/*================================================================================================================*/
        int Deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(Deer1ID, "deer", rmRandInt(7,9), 6.0);
		rmSetObjectDefCreateHerd(Deer1ID, true);
		rmSetObjectDefMinDistance(Deer1ID, 0.0);
        rmSetObjectDefMaxDistance(Deer1ID, 0.0);
        rmAddObjectDefConstraint(Deer1ID, avoidDeer);
        rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.05, 0.5);
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.5, 0.05);
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.5, 0.95);
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.95, 0.5);

        int Deer2ID=rmCreateObjectDef("The Deer Herds 2");
        rmAddObjectDefItem(Deer2ID, "deer", rmRandInt(7,9), 6.0);
		rmSetObjectDefCreateHerd(Deer2ID, true);
		rmSetObjectDefMinDistance(Deer2ID, 0.0);
        rmSetObjectDefMaxDistance(Deer2ID, 0.0);
        rmAddObjectDefConstraint(Deer2ID, avoidDeer);
        rmPlaceObjectDefAtLoc(Deer2ID, 0, 0.20, 0.35);
		rmPlaceObjectDefAtLoc(Deer2ID, 0, 0.35, 0.20);
		rmPlaceObjectDefAtLoc(Deer2ID, 0, 0.65, 0.8);
		rmPlaceObjectDefAtLoc(Deer2ID, 0, 0.8, 0.65);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/
        int Nugget1ID=rmCreateObjectDef("The Nugget 1");
        rmAddObjectDefItem(Nugget1ID, "Nugget", 1.0, 0.0);
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(Nugget1ID, 0.0);
        rmSetObjectDefMaxDistance(Nugget1ID, 0.0);
		rmAddObjectDefToClass(Nugget1ID, rmClassID("classNugget"));
        rmAddObjectDefConstraint(Nugget1ID, avoidNugget);
        rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.10, 0.70);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.70, 0.10);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.30, 0.90);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.90, 0.30);

        int Nugget2ID=rmCreateObjectDef("The Nugget 2");
        rmAddObjectDefItem(Nugget2ID, "Nugget", 1.0, 0.0);
		rmSetObjectDefCreateHerd(Nugget2ID, true);
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(Nugget2ID, 0.0);
        rmSetObjectDefMaxDistance(Nugget2ID, 0.0);
		rmAddObjectDefToClass(Nugget2ID, rmClassID("classNugget"));
        rmAddObjectDefConstraint(Nugget2ID, avoidNugget);
        rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.35, 0.50);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.50, 0.35);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.50, 0.65);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.65, 0.50);

        int Nugget3ID=rmCreateObjectDef("The Nugget 3");
        rmAddObjectDefItem(Nugget3ID, "Nugget", 1.0, 0.0);
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(Nugget3ID, 0.0);
        rmSetObjectDefMaxDistance(Nugget3ID, 0.0);
		rmAddObjectDefToClass(Nugget3ID, rmClassID("classNugget"));
        rmAddObjectDefConstraint(Nugget3ID, avoidNugget);
        rmPlaceObjectDefAtLoc(Nugget3ID, 0, 0.10, 0.30);
		rmPlaceObjectDefAtLoc(Nugget3ID, 0, 0.30, 0.10);
		rmPlaceObjectDefAtLoc(Nugget3ID, 0, 0.70, 0.90);
		rmPlaceObjectDefAtLoc(Nugget3ID, 0, 0.90, 0.70);

        int Nugget4ID=rmCreateObjectDef("The Nugget 4");
        rmAddObjectDefItem(Nugget4ID, "Nugget", 1.0, 0.0);
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(Nugget4ID, 0.0);
        rmSetObjectDefMaxDistance(Nugget4ID, 0.0);
		rmAddObjectDefToClass(Nugget4ID, rmClassID("classNugget"));
        rmAddObjectDefConstraint(Nugget4ID, avoidNugget);
        rmPlaceObjectDefAtLoc(Nugget4ID, 0, 0.05, 0.55);
		rmPlaceObjectDefAtLoc(Nugget4ID, 0, 0.55, 0.05);
		rmPlaceObjectDefAtLoc(Nugget4ID, 0, 0.95, 0.45);
		rmPlaceObjectDefAtLoc(Nugget4ID, 0, 0.45, 0.95);

        int Nugget5ID=rmCreateObjectDef("The Nugget 5");
        rmAddObjectDefItem(Nugget5ID, "Nugget", 1.0, 0.0);
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(Nugget5ID, 0.0);
        rmSetObjectDefMaxDistance(Nugget5ID, 0.0);
		rmAddObjectDefToClass(Nugget5ID, rmClassID("classNugget"));
        rmAddObjectDefConstraint(Nugget5ID, avoidNugget);
        rmPlaceObjectDefAtLoc(Nugget5ID, 0, 0.25, 0.35);
		rmPlaceObjectDefAtLoc(Nugget5ID, 0, 0.35, 0.25);
		rmPlaceObjectDefAtLoc(Nugget5ID, 0, 0.65, 0.75);
		rmPlaceObjectDefAtLoc(Nugget5ID, 0, 0.75, 0.65);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE PERCHING VULTURES: ********************************** //
/*================================================================================================================*/
	    int vultureID=rmCreateObjectDef("perching vultures");
	    int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 15.0);
	    rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, 0.0);
	    rmAddObjectDefConstraint(vultureID, avoidVultures);
	    rmPlaceObjectDefAtLoc(vultureID, 0, 0.15, 0.35);
        rmPlaceObjectDefAtLoc(vultureID, 0, 0.35, 0.15);	
        rmPlaceObjectDefAtLoc(vultureID, 0, 0.65, 0.85);	
        rmPlaceObjectDefAtLoc(vultureID, 0, 0.85, 0.65);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE EAGLES NEST: ************************************** //
/*================================================================================================================*/
        int eagleID=rmCreateObjectDef("The eagles nest");
	    int avoidEaglesNest=rmCreateTypeDistanceConstraint("avoid eagles nest", "EaglesNest", 10.0);
	    rmAddObjectDefItem(eagleID, "EaglesNest", 1, 0.0);
	    rmSetObjectDefMinDistance(eagleID, 0.0);
	    rmSetObjectDefMaxDistance(eagleID, 0.0);
	    rmAddObjectDefConstraint(eagleID, avoidEaglesNest);
	    rmPlaceObjectDefAtLoc(eagleID, 0, 0.125, 0.725);
        rmPlaceObjectDefAtLoc(eagleID, 0, 0.725, 0.125);	
        rmPlaceObjectDefAtLoc(eagleID, 0, 0.25, 0.85);	
        rmPlaceObjectDefAtLoc(eagleID, 0, 0.85, 0.25);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE BIG DECORATIVE THINGS: ********************************* //
/*================================================================================================================*/
	    int bigDecorationID=rmCreateObjectDef("Big Texas Things");
	    int avoidBigDecoration=rmCreateTypeDistanceConstraint("avoid big decorations", "BigPropTexas", 15.0);
	    rmAddObjectDefItem(bigDecorationID, "BigPropTexas", 1, 0.0);
	    rmSetObjectDefMinDistance(bigDecorationID, 0.0);
	    rmSetObjectDefMaxDistance(bigDecorationID, 0.0);
	    rmAddObjectDefConstraint(bigDecorationID, avoidBigDecoration);
	    rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.375, 0.8);
        rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.8, 0.375);
        rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.1, 0.65);
        rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.65, 0.1);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.35, 0.90);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.90, 0.35);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.1, 0.55);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.55, 0.1);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.05, 0.45);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.45, 0.05);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.55, 0.95);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.95, 0.55);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FORESTS: ***************************************** //
/*================================================================================================================*/
        int Forest1ID=rmCreateArea("The Forest 1");
		rmSetAreaWarnFailure(Forest1ID, false);
		rmSetAreaSize(Forest1ID, 0.03, 0.03);
		rmSetAreaForestType(Forest1ID, "texas forest dirt");
		rmSetAreaForestDensity(Forest1ID, 1.0);
		rmSetAreaForestClumpiness(Forest1ID, 1.0);		
		rmSetAreaForestUnderbrush(Forest1ID, 0.0);
		rmAddAreaToClass(Forest1ID, rmClassID("classForest"));
		rmSetAreaCoherence(Forest1ID, 1.0);
		rmSetAreaSmoothDistance(Forest1ID, 10);
		rmAddAreaConstraint(Forest1ID, forestConstraint);
		rmSetAreaLocation(Forest1ID, 0.2, 0.5);
		rmBuildArea(Forest1ID);
		
		int Forest2ID=rmCreateArea("The Forest 2");
		rmSetAreaWarnFailure(Forest2ID, false);
		rmSetAreaSize(Forest2ID, 0.03, 0.03);
		rmSetAreaForestType(Forest2ID, "texas forest dirt");
		rmSetAreaForestDensity(Forest2ID, 1.0);
		rmSetAreaForestClumpiness(Forest2ID, 1.0);		
		rmSetAreaForestUnderbrush(Forest2ID, 0.0);
		rmAddAreaToClass(Forest2ID, rmClassID("classForest"));
		rmSetAreaCoherence(Forest2ID, 1.0);
		rmSetAreaSmoothDistance(Forest2ID, 10);
		rmAddAreaConstraint(Forest2ID, forestConstraint);
		rmSetAreaLocation(Forest2ID, 0.5, 0.2);
		rmBuildArea(Forest2ID);
		
		int Forest3ID=rmCreateArea("The Forest 3");
		rmSetAreaWarnFailure(Forest3ID, false);
		rmSetAreaSize(Forest3ID, 0.03, 0.03);
		rmSetAreaForestType(Forest3ID, "texas forest dirt");
		rmSetAreaForestDensity(Forest3ID, 1.0);
		rmSetAreaForestClumpiness(Forest3ID, 1.0);		
		rmSetAreaForestUnderbrush(Forest3ID, 0.0);
		rmAddAreaToClass(Forest3ID, rmClassID("classForest"));
		rmSetAreaCoherence(Forest3ID, 1.0);
		rmSetAreaSmoothDistance(Forest3ID, 10);
		rmAddAreaConstraint(Forest3ID, forestConstraint);
		rmSetAreaLocation(Forest3ID, 0.5, 0.8);
		rmBuildArea(Forest3ID);
		
		int Forest4ID=rmCreateArea("The Forest 4");
		rmSetAreaWarnFailure(Forest4ID, false);
		rmSetAreaSize(Forest4ID, 0.03, 0.03);
		rmSetAreaForestType(Forest4ID, "texas forest dirt");
		rmSetAreaForestDensity(Forest4ID, 1.0);
		rmSetAreaForestClumpiness(Forest4ID, 1.0);		
		rmSetAreaForestUnderbrush(Forest4ID, 0.0);
		rmAddAreaToClass(Forest4ID, rmClassID("classForest"));
		rmSetAreaCoherence(Forest4ID, 1.0);
		rmSetAreaSmoothDistance(Forest4ID, 10);
		rmAddAreaConstraint(Forest4ID, forestConstraint);
		rmSetAreaLocation(Forest4ID, 0.8, 0.5);
		rmBuildArea(Forest4ID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.99);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //
/*================================================================================================================*/
        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishBass", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
} 
/*================================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ******************************************* //
/*================================================================================================================*/ 




		




















