/*===============================================================================================================*/
// ************************************ THESE ARE THE INFORMATIONS OF THE MAP: ********************************* //
/*===============================================================================================================*/
// SUNNY ISLAND:
// CREATED BY DANY:
// AUGUST 2007:
/*===============================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*===============================================================================================================*/

include "mercenaries.xs";
void main(void)
{

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*===============================================================================================================*/
// *************************************** DEFINE THE CARIB NATIVES: ******************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
	
		int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		
/*---------------------------------------------------------------------------------------------------------------*/		

        if (rmAllocateSubCivs(4) == true)
    {
		subCiv0=rmGetCivID("Caribs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Caribs");
		
		subCiv1=rmGetCivID("Caribs");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Caribs");
		
		subCiv2=rmGetCivID("Caribs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Caribs");
		
		subCiv3=rmGetCivID("Caribs");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Caribs");
	}
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*===============================================================================================================*/
// **************************************** DEFINE THE MAP VARIATIONS: ***************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
	
	    // MAP VARIATIONS: 
	    // 1 - FOUR CARIBS, NEXT TO THE BIG MOUNTAIN AND AT THE ENDS OF THE 2 LONG PENINSULES: 
	    // 2 - FOUR CARIBS, AT THE ENDS OF THE 2 LONG PENINSULAS, AND 2 ON SE END OF ISLAND:
        // 3 - SIX CARIBS, NEXT TO THE MOUNTAIN, 2 ON THE LONG PENINSULA, AND 2 ON SE END OF ISLAND: 
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    // THE WHICH VARIATION:
		int whichVariation=-1;
	    whichVariation = rmRandInt(1,3);
	
/*---------------------------------------------------------------------------------------------------------------*/	
	
	    // THE LINE BELOW CAN BE UNCOMMENTED TO FORCE THE VARIATION TO THE NUMBER INDICATED, FOR TESTING:
	    // whichVariation = 3; 

	    rmEchoInfo("Map Variation: "+whichVariation);
	
	    chooseMercs();

	    if ( cNumberNonGaiaPlayers > 7 ) //IF 8 PLAYER GAME, USE ONLY VARIATION #2 SO MAP BUILDS MORE QUICKLY:
	{
		whichVariation = 2;
	}
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*===============================================================================================================*/   
// ***************************************** SET THE SIZE OF THE MAP: ****************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
    
	    int playerTiles=23500;
	
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(614, 614);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*===============================================================================================================*/   
// *************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    // SET SEA LEVEL:
	    rmSetSeaLevel(1.0);          
	    
		// SET SEA TYPE:
		rmSetSeaType("caribbean coast");
	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("caribbean grass");
	    
		// SET MAP TYPE:
		rmSetMapType("caribbean");
	    rmSetMapType("grass");
	    rmSetMapType("water");
	    
		// SET LIGHTING:
		rmSetLightingSet("caribbean");

	    // INITIALIZE MAP:
	    rmTerrainInitialize("water");
		
		// CHOOSE THE MERCS:
		chooseMercs();
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*===============================================================================================================*/		
// ************************************* MISC VARIABLES FOR USE LATER: ***************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
	
	    int numTries = -1;
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*===============================================================================================================*/   
// *************************** DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ********************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        
		int classPlayer=rmDefineClass("player");
	    int classIsland=rmDefineClass("island");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("natives");
	    rmDefineClass("classSocket");
	    rmDefineClass("canyon");
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*===============================================================================================================*/   
// ******************************************* DEFINE THE CONSTRAINTS: ***************************************** //
// ************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: *********************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        
		// CREATE AN EDGE OF MAP CONSTRAINT:
	    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.45), rmDegreesToRadians(0), rmDegreesToRadians(360));

	    // PLAYER AREA CONSTRAINT:
	    int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 25.0);
	    int longPlayerConstraint=rmCreateClassDistanceConstraint("long stay away from players", classPlayer, 60.0);
	    
		int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
	    int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
	    int nearWaterDock = rmCreateTerrainDistanceConstraint("near water for Dock", "Water", true, 0.0);
	    
		// TC AVOIDANCE:
		int avoidTC=rmCreateTypeDistanceConstraint("stay away from TC", "TownCenter", 24.0);    //Originally 20.0 -- This adjustment, as well as changing the rmSetObjectDefMaxDistance to 12.0, has corrected the problem of nomad sometimes not placing CW for each player.
	    int avoidTP=rmCreateTypeDistanceConstraint("stay away from Trading Post Sockets", "SocketTradeRoute", 14.0);  // JSB 1-11-05 - Just added, to try to prevent things from stomping on TPs.
	    int avoidCW=rmCreateTypeDistanceConstraint("stay away from CW", "CoveredWagon", 24.0);
	    
		// LAND AVOIDANCE:
		int avoidLand = rmCreateTerrainDistanceConstraint("ship avoid land", "land", true, 15.0);

	    // BONUS AREA CONSTRAINT:  
	    int islandConstraint=rmCreateClassDistanceConstraint("islands avoid each other", classIsland, 55.0);

	    // SEAFOOD AVOIDANCE:
	    int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fishMahi", 30.0);			// was 50.0
	    int fishVsFishTarponID=rmCreateTypeDistanceConstraint("fish v fish2", "fishTarpon", 20.0);  // was 40.0 
	    int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);			
	    int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "HumpbackWhale", 2.0);	//Was 8.0
	    int fishVsWhaleID=rmCreateTypeDistanceConstraint("fish v whale", "HumpbackWhale", 35.0);    //Was 34.0 -- This is for trying to keep fish out of "whale bay".
	    int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 17.0);   // Was 18.0.  This is to keep whales from swimming inside of land.
	    
		// FOREST AVOIDANCE:
		int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
	    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 40.0);
	    
		// RESOURCE AVOIDANCE:
		int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
	    
		// COIN AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "minegold", 85.0);	// 85.0 seems the best for event minegold distribution.  This number tells minegolds how far they should try to avoid each other.  Useful for spreading them out more evenly.
	    
		// BERRIES AVOIDANCE:
		int avoidRandomBerries=rmCreateTypeDistanceConstraint("avoid random berries", "berrybush", 75.0);	//Attempting to spread them out more evenly.
	    
		// TURKEYS AVOIDANCE:
		int avoidRandomTurkeys=rmCreateTypeDistanceConstraint("avoid random turkeys", "turkey", 50.0);	//Attempting to spread them out more evenly.
	    
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 6.0);
		
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "abstractNugget", 54.0);  //Was 60.0 -- attempting to get more nuggets in south half of isle.
	    
		// SHEEP AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 120.0);  //Added sheep 11-28-05 JSB

	    // AVOID IMPASSABLE LAND:
	    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 5.0);
	    int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	    int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 14.0);  //This one is used in one place: for helping place FFA TC's better.

	    // CONSTRAINT TO AVOID WATER:
	    int avoidWater2 = rmCreateTerrainDistanceConstraint("avoid water short", "Land", false, 2.0);   //I added this one so I could experiment with it.
	    int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 8.0);
	    int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
	    int avoidWater40 = rmCreateTerrainDistanceConstraint("avoid water super long", "Land", false, 40.0);  //Added this one too.
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 18.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 22); //Was 15, but made larger so ships don't sometimes stomp each other when arriving from HC.
	    rmAddClosestPointConstraint(avoidWater8);  //was originally 8
	    
		// TRADE ROUTE AVOIDANCE:
		int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
	    
		// SOCKET AVOIDANCE:
		int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 10.0);
	    
		// IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 50.0);
	    
		// DECORATION AVOIDANCE:
		int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0);

	    // THE FOLLOWING IS A PIE CONSTRAINT:
		// DEFINED IN A LARGE "MAJORITY OF THE PIE PLATE" AREA:
        // TO MAKE WATER SPAWN FLAGS PLACE INSIDE IT:
        // ( IT EXCLUDES THE WEST BAY, WHERE I DO NOT WANT THE FLAGS: )
	    int circleConstraint=rmCreatePieConstraint("semi-circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(50), rmDegreesToRadians(290));  //rmZFractionToMeters(0.47)- this number defines how far out from .5, .5 the center of the pie sections go. 

	    // REMOVED BY ENSEMBLE:
		// int flagEdgeConstraint = rmCreatePieConstraint("flags away from edge of map", 0.5, 0.5, rmGetMapXSize()-200, rmGetMapXSize()-100, 0, 0, 0);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*===============================================================================================================*/   
// ************************************* DEFINE AND PLACE THE BIG ISLAND: ************************************** //
/*===============================================================================================================*/
	
        int IslandLoc = 1;								

	    int bigIslandID=rmCreateArea("big lone island");
	    
		rmSetAreaSize(bigIslandID, 0.35, 0.35);	
		// Defines island's size.  .40, .40 looks about right.
	    
		rmSetAreaCoherence(bigIslandID, 0.77);	
		// Determines raggedness of island's coastline.  
		// Lower the number, more the blobby.
	    
		rmSetAreaBaseHeight(bigIslandID, 2.0);
	    rmSetAreaSmoothDistance(bigIslandID, 20);
	    rmSetAreaMix(bigIslandID, "caribbean grass");
	    rmAddAreaToClass(bigIslandID, classIsland);
	    rmAddAreaConstraint(bigIslandID, islandConstraint);
	    rmSetAreaObeyWorldCircleConstraint(bigIslandID, false);
	    rmSetAreaElevationType(bigIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(bigIslandID, 4.0);
	    rmSetAreaElevationMinFrequency(bigIslandID, 0.09);
	    rmSetAreaElevationOctaves(bigIslandID, 3);
	    rmSetAreaElevationPersistence(bigIslandID, 0.2);
	    rmSetAreaElevationNoiseBias(bigIslandID, 1);
	    
		// ADD AREA INFLUENCE SEGMENT:
		//rmAddAreaInfluenceSegment(bigIslandID, 0.69, 0.68, 0.76, 0.51); // Segment 1 - short top, left, right:
	    //rmAddAreaInfluenceSegment(bigIslandID, 0.56, 0.78, 0.75, 0.30); // Segment 2 - long top:  
	    //rmAddAreaInfluenceSegment(bigIslandID, 0.22, 0.67, 0.58, 0.20); // Segment 3 - long lower:
	    //rmAddAreaInfluenceSegment(bigIslandID, 0.20, 0.44, 0.36, 0.21); // Segment 4 - short lower bit:

        rmAddAreaInfluenceSegment(bigIslandID, 0.575, 0.725, 0.775, 0.525); // Segment 1 - short top, left, right:
	    rmAddAreaInfluenceSegment(bigIslandID, 0.370, 0.75, 0.60, 0.50); // Segment 2 - long top:  
	    rmAddAreaInfluenceSegment(bigIslandID, 0.270, 0.65, 0.50, 0.40); // Segment 3 - long lower:
	    rmAddAreaInfluenceSegment(bigIslandID, 0.275, 0.425, 0.475, 0.225); // Segment 4 - short lower bit: 
	    	    	
	    rmSetAreaWarnFailure(bigIslandID, false);

	    if (IslandLoc == 1)
	    rmSetAreaLocation(bigIslandID, .5, .5);		
		//Put the big island in exact middle of map.
	    rmBuildArea(bigIslandID);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*===============================================================================================================*/   
// ******************************************* SET UP PLAYER LOCATIONS: **************************************** // 	
/*===============================================================================================================*/
	
//        -- EACH TEAM ALWAYS PLACED ALONG A LINE: ONE TEAM IN NE, OTHER IN SW:
		
/*---------------------------------------------------------------------------------------------------------------*/
		
	
	    float teamStartLoc = rmRandFloat(0.0, 1.0);  
		// THIS CHOOSES A NUMBER RANDOMLY BETWEEN 0 AND 1:
        // USED TO PICK WHETHER TEAM 1 IS ON TOP OR BOTTOM:
		
/*---------------------------------------------------------------------------------------------------------------*/		
	    
		//float teamStartLoc = rmRandFloat(0.2, 0.4);    
		// TEMPORARILY FORCE FLOAT TO BE .4 OR LOWER, SO TEAM 0 WILL BE IN THE NORTH:
		
/*---------------------------------------------------------------------------------------------------------------*/		

		    if (cNumberTeams == 2 )
			
		{
			// TEAM 0 STARTS ON TOP:
			if (teamStartLoc > 0.5)
			{
			rmSetPlacementTeam(0);
			//rmPlacePlayersLine(0.28, 0.54, 0.35, 0.29, 0.0, 0.2); // TEAM 0 IS IN THE SOUTH: 
			rmPlacePlayersLine(0.55, 0.75, 0.75, 0.55, 0.0, 0.0);
			rmSetPlacementTeam(1);
			//rmPlacePlayersLine(0.65, 0.64, 0.715, 0.36, 0.0, 0.2); // TEAM 1 IS IN THE NORTH:
			rmPlacePlayersLine(0.25, 0.45, 0.45, 0.25, 0.0, 0.0);
			}
			else
			{
			rmSetPlacementTeam(0);
			//rmPlacePlayersLine(0.65, 0.64, 0.715, 0.36, 0.0, 0.2); // TEAM 0 IS IN THE NORTH:
			rmPlacePlayersLine(0.55, 0.75, 0.75, 0.55, 0.0, 0.0);
			rmSetPlacementTeam(1);
			//rmPlacePlayersLine(0.28, 0.54, 0.35, 0.29, 0.0, 0.2); // TEAM 1 IS IN THE SOUTH:
			rmPlacePlayersLine(0.25, 0.45, 0.45, 0.25, 0.0, 0.0);
			}
		}

/*---------------------------------------------------------------------------------------------------------------*/		
	        
			// OTHERWISE IT'S A FREE-FOR-ALL: 
		    // SO JUST PLACE EVERYONE IN ONE BIG ARC AROUND THE CENTER ISLAND:
	
	        else
			
	   {
  		    rmSetPlacementSection(0.04, 0.82);
		    rmPlacePlayersCircular(0.22, 0.23, 0.0);
	   }	
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*===============================================================================================================*/   
// ******************************************** SET UP PLAYER AREAS: ******************************************* //	
/*===============================================================================================================*/

	    float playerFraction=rmAreaTilesToFraction(100);
	    for(i=1; <cNumberPlayers)
	{
        // CREATE THE PLAYER'S AREA:
        int id=rmCreateArea("Player"+i);
        
		// SET PLAYER AREA:
		rmSetPlayerArea(i, id);
        
		// SET AREA SIZE:
		rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
	}

	    // BUILD THE AREAS: 
	    rmBuildAllAreas();
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*===============================================================================================================*/
// ********************************** CLEAR OUT CONSTRAINTS FOR GOOD MEASURE: ********************************** //
/*===============================================================================================================*/

        rmClearClosestPointConstraints();   
		
		// FROM ENSEMBLE SCRIPTER:
		// THIS WAS IN THE CARIBBEAN SCRIPT I STARTED WITH:
        // NOT SURE WHAT IT DOES SO AFRAID TO AXE IT:
		
		// FROM DANY:
		// FROM WHAT I UNDERSTAND OF IT:
		// IT PERMIT TO HAVE THE 2 FLAGS ON THE MAP:
		// WITHOUT IT...THERE IS JUST ONE FLAG:
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.51);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("caribs"))
	{  
		int caribs1VillageID = -1;
		caribs1VillageID = rmCreateGrouping("caribs village 1", "native carib village 1");
		rmSetGroupingMinDistance(caribs1VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs1VillageID, 0.0);
		rmAddGroupingToClass(caribs1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(caribs1VillageID, 0, 0.225, 0.625);
	} 
	
	    if (subCiv1 == rmGetCivID("caribs"))
	{  
		int caribs2VillageID = -1;
		caribs2VillageID = rmCreateGrouping("caribs village 2", "native carib village 1");
		rmSetGroupingMinDistance(caribs2VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs2VillageID, 0.0);
		rmAddGroupingToClass(caribs2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(caribs2VillageID, 0, 0.375, 0.775);
	} 
	
	    if (subCiv2 == rmGetCivID("caribs"))
	{  
		int caribs3VillageID = -1;
		caribs3VillageID = rmCreateGrouping("caribs village 3", "native carib village 1");
		rmSetGroupingMinDistance(caribs3VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs3VillageID, 0.0);
		rmAddGroupingToClass(caribs3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(caribs3VillageID, 0, 0.625, 0.525);
	} 
	
	    if (subCiv3 == rmGetCivID("caribs"))
	{  
		int caribs4VillageID = -1;
		caribs4VillageID = rmCreateGrouping("caribs village 4", "native carib village 1");
		rmSetGroupingMinDistance(caribs4VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs4VillageID, 0.0);
		rmAddGroupingToClass(caribs4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(caribs4VillageID, 0, 0.475, 0.375);
	} 

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*===============================================================================================================*/   
// *********************************** DEFINE AND PLACE THE MOUNTAIN IN CENTER: ******************************** //
/*===============================================================================================================*/

        // NOTES:
		// ALWAYS CREATE A MOUNTAIN IN CENTER OF ISLAND:
		
		// FROM DANY:
		// FROM WHAT I UNDERSTAND:
		// MOUNTAIN TO CLOSE TO WATER WILL CAUSE THE GRAPHICS
        // OF THE MOUNTAIN TO DEFORMED:

/*---------------------------------------------------------------------------------------------------------------*/
   
	    numTries = 1;
	    for(i=0; <numTries)
		
	{
		int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa"+i);
		
		// SET AREA SIZE:
		//rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(1100), rmAreaTilesToFraction(1100));
        rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(2000), rmAreaTilesToFraction(2000));  
		// First # is minimum square meters of material it will use to build.  
		// Second # is maximum.  
		// Currently I have them both set to the same 
		// because I want a certain size mountain every time.
		
		rmSetAreaWarnFailure(smallMesaID, false);
		rmSetAreaCliffType(smallMesaID, "Caribbean");
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID, rmRandInt(6, 8), 1.0, 1.0);  //was rmRandInt(6, 8)
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(smallMesaID, 0.85);
				
		// ADD AREA INFLUENCE SEGMENT:
		//rmAddAreaInfluenceSegment(smallMesaID, 0.48, 0.43, 0.5, 0.40);  //Bottom - Original segment
		//rmAddAreaInfluenceSegment(smallMesaID, 0.46, 0.40, 0.53, 0.38); //Right
		//rmAddAreaInfluenceSegment(smallMesaID, 0.53, 0.45, 0.53, 0.38); //Top - Original segment
		//rmAddAreaInfluenceSegment(smallMesaID, 0.53, 0.45, 0.48, 0.43); //Left
						
		// SET AREA LOCATION:
		rmSetAreaLocation(smallMesaID, 0.435, 0.565); 
		rmBuildArea(smallMesaID);
	}

	    // SPECIAL AREA CONSTRAINT AND USE IT TO MAKE RESOURCES AVOID THE BIG MTN IN CENTER:
		int smallMesaConstraint = rmCreateAreaDistanceConstraint("avoid Small Mesa", smallMesaID, 4.0);
		
/*===============================================================================================================*/   
// ************************************ DEFINE AND PLACE THE TRADE ROUTE: ************************************** //
/*===============================================================================================================*/

        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 6.0);

	    int tradeRouteID = rmCreateTradeRoute();
	    rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.275, 0.725);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.575, 0.425);

	    bool placedTradeRouteA = rmBuildTradeRoute(tradeRouteID, "dirt");
	    if(placedTradeRouteA == false)
		rmEchoError("Failed to place trade route 1");

	    rmPlaceObjectDefAtLoc(socketID, 0, 0.275, 0.725);
	    //rmPlaceObjectDefAtLoc(socketID, 0, 0.50, 0.50);
	    rmPlaceObjectDefAtLoc(socketID, 0, 0.575, 0.425);		

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*===============================================================================================================*/   

	    // DEFINE THE STARTING TCID:
		int TCID = rmCreateObjectDef("player TC");
	    if ( rmGetNomadStart())
		rmAddObjectDefItem(TCID, "coveredWagon", 1, 0);
	    else
		rmAddObjectDefItem(TCID, "townCenter", 1, 0);

	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 0.0);  // Originally 10.0 -- JSB -- Allows TC placement spot to float a bit along the lines I tell them to place. 
	    rmAddObjectDefConstraint(TCID, avoidImpassableLand);
	    rmAddObjectDefConstraint(TCID, avoidTC);
	    rmAddObjectDefConstraint(TCID, avoidCW);
    	
	    // DEFINE THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 9.0);
	    rmSetObjectDefMaxDistance(startingUnits, 18.0);
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
	    rmAddObjectDefConstraint(startingUnits, avoidImpassableLand);

	    // DEFINE THE PLAYER GOLD: 
	    int playerGoldID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(playerGoldID, "minegold", 1, 0);
	    rmSetObjectDefMinDistance(playerGoldID, 12.0);
	    rmSetObjectDefMaxDistance(playerGoldID, 20.0);
	    rmAddObjectDefConstraint(playerGoldID, avoidAll);
        rmAddObjectDefConstraint(playerGoldID, avoidImpassableLand);

	    // DEFINE THE PLAYER CRATE: ( MOSTLY FOOD: )
	    int playerCrateID=rmCreateObjectDef("starting crates");
	    rmAddObjectDefItem(playerCrateID, "crateOfFood", rmRandInt(3,4), 4.0);
	    rmAddObjectDefItem(playerCrateID, "crateOfWood", 1, 6.0);
	    rmAddObjectDefItem(playerCrateID, "crateOfCoin", 1, 7.0);
	    rmSetObjectDefMinDistance(playerCrateID, 6);
	    rmSetObjectDefMaxDistance(playerCrateID, 10);
	    rmAddObjectDefConstraint(playerCrateID, avoidAll);
	    rmAddObjectDefConstraint(playerCrateID, shortAvoidImpassableLand);

	    // DEFINE THE PLAYER BERRIES:
	    int playerBerriesID=rmCreateObjectDef("player berries");
	    rmAddObjectDefItem(playerBerriesID, "berrybush", rmRandInt(4,6), 4.0);	//(X,X) - number of objects.  The last # is the range of distance around the center point that the objects will place.  Low means tight, higher means more widely scattered.
        rmSetObjectDefMinDistance(playerBerriesID, 21);
        rmSetObjectDefMaxDistance(playerBerriesID, 26);		
	    rmAddObjectDefConstraint(playerBerriesID, avoidAll);
        rmAddObjectDefConstraint(playerBerriesID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(playerBerriesID, true);

	    // DEFINE THE PLAYER TURKEY:
	    int playerTurkeyID=rmCreateObjectDef("player turkeys");
        rmAddObjectDefItem(playerTurkeyID, "turkey", rmRandInt(6,7), 4.0);	//(X,X) - number of objects.  The last # is the range of distance around the center point that the objects will place.  Low means tight, higher means more widely scattered.
        rmSetObjectDefMinDistance(playerTurkeyID, 14);
	    rmSetObjectDefMaxDistance(playerTurkeyID, 19);	
	    rmAddObjectDefConstraint(playerTurkeyID, avoidAll);
        rmAddObjectDefConstraint(playerTurkeyID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(playerTurkeyID, true);

	    // DEFINE THE STARTING TREES:
	    int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeCaribbean", 1, 0.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidAll);    //This was just added to try to keep these trees from stomping on CW's.
	    rmSetObjectDefMinDistance(StartAreaTreeID, 13.0);	//changed from 12.0 
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 20.0);	//Changed from 19.0

	    // DEFINE THE WATER SPAWN POINT:
		int waterSpawnPointID = 0;
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*===============================================================================================================*/   
// ***************** PLACE THE STARTING TCID AND THE STARTING UNITS AND THE STARTING RESOURCES: **************** //	  
/*===============================================================================================================*/

	    for(i=1; <cNumberPlayers)
   {
	    // PLACE THE TCID:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));				
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		// PLACE THE PLAYER GOLD:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));   
		
		// PLACE THE PLAYER GOLD:
		rmPlaceObjectDefAtLoc(playerBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc))); 
		
		// PLACE THE PLAYER TURKEY:
		rmPlaceObjectDefAtLoc(playerTurkeyID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));  										
		
		// PLACE THE PLAYER CRATE:
		rmPlaceObjectDefAtLoc(playerCrateID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE WATER SPAWN POINTS FOR THE PLAYERS:
		waterSpawnPointID=rmCreateObjectDef("colony ship "+i);
		rmAddObjectDefItem(waterSpawnPointID, "HomeCityWaterSpawnFlag", 1, 10.0);  // ...Flag", 1, 1.0); - the first number is the number of flags.  The next number is the float distance.
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		rmAddClosestPointConstraint(circleConstraint);
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
		rmPlaceObjectDefAtLoc(waterSpawnPointID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		
		// CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
   }
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*===============================================================================================================*/   
// ************************** DEFINE AND PLACE SCATTERED RESOURCES: ( THE FORESTS: ) *************************** //
/*===============================================================================================================*/

	    // THE SCATTERED FORESTS:
        int forestTreeID = 0;
        numTries=10*cNumberNonGaiaPlayers;
        int failCount=0;
        for (i=0; <numTries)
    {   
        int forest=rmCreateArea("forest "+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(400));
        rmSetAreaForestType(forest, "caribbean palm forest");
        rmSetAreaForestDensity(forest, 0.6);
        rmSetAreaForestClumpiness(forest, 0.4);
        rmSetAreaForestUnderbrush(forest, 0.0);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 5);
        rmSetAreaMinBlobDistance(forest, 16.0);
        rmSetAreaMaxBlobDistance(forest, 40.0);
        rmSetAreaCoherence(forest, 0.4);
        rmSetAreaSmoothDistance(forest, 10);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
		rmAddAreaConstraint(forest, avoidCloseNatives);
		rmAddAreaConstraint(forest, avoidSocket);
        rmAddAreaConstraint(forest, shortAvoidImpassableLand); 
		rmAddAreaConstraint(forest, smallMesaConstraint); 
		rmAddAreaConstraint(forest, avoidTC);
		rmAddAreaConstraint(forest, avoidCW);
        rmAddAreaConstraint(forest, avoidTradeRoute); 
        if(rmBuildArea(forest)==false)
      {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    }
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*===============================================================================================================*/
// ********************************* DEFINE AND PLACE THE SCATTERED MINES: ************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int goldID = rmCreateObjectDef("random gold");
	    rmAddObjectDefItem(goldID, "minegold", 1, 0);
	    rmSetObjectDefMinDistance(goldID, 0.0);
	    rmSetObjectDefMaxDistance(goldID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(goldID, avoidTC);
	    rmAddObjectDefConstraint(goldID, avoidCW);
	    rmAddObjectDefConstraint(goldID, avoidAll);
		rmAddObjectDefConstraint(goldID, avoidSocket);
		rmAddObjectDefConstraint(goldID, avoidCloseNatives);
	    rmAddObjectDefConstraint(goldID, avoidCoin);
        rmAddObjectDefConstraint(goldID, avoidImpassableLand);
	    rmAddObjectDefConstraint(goldID, smallMesaConstraint);
	    rmPlaceObjectDefInArea(goldID, 0, bigIslandID, cNumberNonGaiaPlayers*3);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.76);
/*===============================================================================================================*/
// ********************************* DEFINE AND PLACE THE SCATTERED BERRIES: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int berriesID=rmCreateObjectDef("random berries");
	    rmAddObjectDefItem(berriesID, "berrybush", rmRandInt(5,8), 6.0);  
	    rmSetObjectDefMinDistance(berriesID, 0.0);
	    rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(berriesID, avoidTC);
	    rmAddObjectDefConstraint(berriesID, avoidTP);   
	    rmAddObjectDefConstraint(berriesID, avoidCW);
	    rmAddObjectDefConstraint(berriesID, avoidAll);
		rmAddObjectDefConstraint(berriesID, avoidCloseNatives);
		rmAddObjectDefConstraint(berriesID, avoidSocket);
	    rmAddObjectDefConstraint(berriesID, avoidRandomBerries);
	    rmAddObjectDefConstraint(berriesID, avoidImpassableLand);
	    rmAddObjectDefConstraint(berriesID, smallMesaConstraint);
	    rmPlaceObjectDefInArea(berriesID, 0, bigIslandID, cNumberNonGaiaPlayers*4);   

 /*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.77);
/*===============================================================================================================*/
// ****************************** DEFINE AND PLACE JUST A FEW SCATTERED TURKEYS: ******************************* //		
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int turkeyID=rmCreateObjectDef("random turkeys");
	    rmAddObjectDefItem(turkeyID, "turkey", rmRandInt(3,5), 5.0); 
	    rmSetObjectDefMinDistance(turkeyID, 0.0);
	    rmSetObjectDefMaxDistance(turkeyID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(turkeyID, avoidTC);
	    rmAddObjectDefConstraint(turkeyID, avoidCW);
	    rmAddObjectDefConstraint(turkeyID, avoidRandomTurkeys);
		rmAddObjectDefConstraint(turkeyID, avoidSocket);
	    //rmAddObjectDefConstraint(turkeyID, avoidAll);
		rmAddObjectDefConstraint(turkeyID, avoidCloseNatives);
	    //rmAddObjectDefConstraint(turkeyID, avoidRandomBerries);
	    rmAddObjectDefConstraint(turkeyID, avoidImpassableLand);
	    rmAddObjectDefConstraint(turkeyID, smallMesaConstraint);
	    rmPlaceObjectDefInArea(turkeyID, 0, bigIslandID, cNumberNonGaiaPlayers*5);   


/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*===============================================================================================================*/   
// ************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // THE EASIER NUGGETS:
	    int nugget1= rmCreateObjectDef("nugget easy"); 
	    rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMaxDistance(nugget1, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget1, shortAvoidImpassableLand);
	    rmAddObjectDefConstraint(nugget1, avoidNugget);
	    rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
	    rmAddObjectDefConstraint(nugget1, avoidTC);
	    rmAddObjectDefConstraint(nugget1, avoidCW);
	    rmAddObjectDefConstraint(nugget1, avoidAll);
		rmAddObjectDefConstraint(nugget1, avoidCloseNatives);
		rmAddObjectDefConstraint(nugget1, avoidSocket);
	    rmAddObjectDefConstraint(nugget1, avoidWater20);
	    rmAddObjectDefConstraint(nugget1, smallMesaConstraint);
	    rmAddObjectDefConstraint(nugget1, playerEdgeConstraint);
	    rmPlaceObjectDefInArea(nugget1, 0, bigIslandID, cNumberNonGaiaPlayers*rmRandInt(3,4));
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE TOUGHER NUGGETS:
	    int nugget2= rmCreateObjectDef("nugget hard"); 
	    rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2, 0.0);
	    rmSetNuggetDifficulty(3, 3);
	    rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget2, shortAvoidImpassableLand);
	    rmAddObjectDefConstraint(nugget2, avoidNugget);
	    rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
	    rmAddObjectDefConstraint(nugget2, avoidAll);
		rmAddObjectDefConstraint(nugget2, avoidCloseNatives);
		rmAddObjectDefConstraint(nugget2, avoidSocket);
	    rmAddObjectDefConstraint(nugget2, avoidWater20);
	    rmAddObjectDefConstraint(nugget2, smallMesaConstraint);
	    rmAddObjectDefConstraint(nugget2, playerEdgeConstraint);
	    rmPlaceObjectDefInArea(nugget2, 0, bigIslandID, cNumberNonGaiaPlayers);
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.81);
/*===============================================================================================================*/   
// *************************************** DEFINE AND PLACE THE SHEEP: ***************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int sheepID=rmCreateObjectDef("sheep");
	    rmAddObjectDefItem(sheepID, "sheep", 2, 4.0);
	    rmSetObjectDefMinDistance(sheepID, 0.0);
	    rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(sheepID, avoidSheep);
	    rmAddObjectDefConstraint(sheepID, avoidAll);
		rmAddObjectDefConstraint(sheepID, avoidCloseNatives);
	    rmAddObjectDefConstraint(sheepID, avoidSocket);
	    rmAddObjectDefConstraint(sheepID, avoidTradeRoute);
	    rmAddObjectDefConstraint(sheepID, avoidTC);
	    rmAddObjectDefConstraint(sheepID, avoidCW);
	    rmAddObjectDefConstraint(sheepID, longPlayerConstraint);
	    rmAddObjectDefConstraint(sheepID, smallMesaConstraint);
	    rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
	    rmPlaceObjectDefAtLoc(sheepID, 0, 0.46, 0.48, cNumberNonGaiaPlayers*1);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*===============================================================================================================*/   
// ********************** DEFINE AND PLACE WHALES AS MUCH IN BIG WEST BAY ONLY POSSIBLE: *********************** //
/*===============================================================================================================*/

	    int whaleID=rmCreateObjectDef("whale");
	    rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 0.0);
	    rmSetObjectDefMinDistance(whaleID, 0.0);
	    rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.28)); 
		//Distance whales will be placed from the starting spot (below)
	    rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
	    rmAddObjectDefConstraint(whaleID, whaleLand);
	    //rmPlaceObjectDefAtLoc(whaleID, 0, 0.75, 0.25, cNumberNonGaiaPlayers*2 + rmRandInt(1,2));  //Was .43, .67.0 -- The whales will be placed from this spot. 1 per player, plus 1 or 2 more.
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.65, 0.35, cNumberNonGaiaPlayers*1.5 ); //+ rmRandInt(1,2));  //Was .43, .67.0 -- The whales will be placed from this spot. 1 per player, plus 1 or 2 more.
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*===============================================================================================================*/   
// *********************** PLACE RANDOM FISH EVERYWHERE, BUT RESTRAINED TO AVOID WHALES: *********************** //
/*===============================================================================================================*/

	    // FISH MAHI:
		int fishID=rmCreateObjectDef("fish Mahi");
	    rmAddObjectDefItem(fishID, "FishMahi", 1, 0.0);
	    rmSetObjectDefMinDistance(fishID, 0.0);
	    rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(fishID, fishVsFishID);
	    rmAddObjectDefConstraint(fishID, fishVsWhaleID);
	    rmAddObjectDefConstraint(fishID, fishLand);
	    rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 24*cNumberNonGaiaPlayers);
		
/*---------------------------------------------------------------------------------------------------------------*/		
/*
	    // FISH TARPON:
		int fish2ID=rmCreateObjectDef("fish Tarpon");
	    rmAddObjectDefItem(fish2ID, "FishTarpon", 1, 0.0);
	    rmSetObjectDefMinDistance(fish2ID, 0.0);
	    rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(fish2ID, fishVsFishTarponID);
	    rmAddObjectDefConstraint(fish2ID, fishVsWhaleID);
	    rmAddObjectDefConstraint(fish2ID, fishLand);
	    rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 9*cNumberNonGaiaPlayers);

	    if (cNumberNonGaiaPlayers <5)		// IF LESS THAN 5 PLAYERS, PLACE EXTRA FISH:
	{
		rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);	
	}
*/	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*===============================================================================================================*/   
// ************************************ DEFINE AND PLACE THE RANDOM TREES: ************************************* //
/*===============================================================================================================*/

	    int randomTreeID=rmCreateObjectDef("random tree");
	    rmAddObjectDefItem(randomTreeID, "treeCaribbean", 1, 0.0);
	    rmSetObjectDefMinDistance(randomTreeID, 0.0);
	    rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
	    rmAddObjectDefConstraint(randomTreeID, avoidTC);
	    rmAddObjectDefConstraint(randomTreeID, avoidCW);
	    rmAddObjectDefConstraint(randomTreeID, avoidAll);
        rmAddObjectDefConstraint(randomTreeID, avoidSocket);
        rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);   		
	    rmAddObjectDefConstraint(randomTreeID, smallMesaConstraint);
	    rmPlaceObjectDefInArea(randomTreeID, 0, bigIslandID, 8*cNumberNonGaiaPlayers);   //Scatter 8 random trees per player.
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/
