/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/

// THE CAMPECHE WAR:
// CREATED BY DANY:
// OCTOBER 2007:

/*================================================================================================================*/
// *********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ********************************** //
/*================================================================================================================*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
// *********************************** THESE ARE THE MAP VARIATION VARIABLES: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // MAP VARIATION VARIABLE:
	    int whichVariation=-1;
	    whichVariation = rmRandInt(1,2);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ***************************************** CHOOSE THE NATIVE TRIBES: ****************************************** //
/*================================================================================================================*/
   
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/		

        if ( whichVariation == 1 ) 
	
	{	
		subCiv0=rmGetCivID("Aztecs");
		rmEchoInfo("subCiv0 is Aztecs "+subCiv0);
			 
		subCiv1=rmGetCivID("Aztecs");
		rmEchoInfo("subCiv1 is Aztecs "+subCiv1);
		
		subCiv2=rmGetCivID("Aztecs");
		rmEchoInfo("subCiv2 is Aztecs "+subCiv2);
			 
		subCiv3=rmGetCivID("Aztecs");
		rmEchoInfo("subCiv3 is Aztecs "+subCiv3);
		
	}
        else
    {
	    subCiv0=rmGetCivID("Maya");
		rmEchoInfo("subCiv0 is Maya "+subCiv0);
			 
		subCiv1=rmGetCivID("Maya");
		rmEchoInfo("subCiv1 is Maya "+subCiv1);
		
		subCiv2=rmGetCivID("Maya");
		rmEchoInfo("subCiv2 is Maya "+subCiv2);
			 
		subCiv3=rmGetCivID("Maya");
		rmEchoInfo("subCiv3 is Maya "+subCiv3);
	}	
	
	    rmSetSubCiv(0, "Aztecs", true);
	    rmSetSubCiv(1, "Maya", true);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
		
		int playerTiles=22500;
	    
		int size=1.7*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    int longSide=1.4*size;   
		
		rmEchoInfo("Map size="+size+"m x "+longSide+"m");
	    rmSetMapSize(longSide, size);
		rmSetMapSize(714, 510);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** PICKS THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/

	    // SET MAP ELEVATION PARAMETERS:
		rmSetMapElevationParameters(cElevTurbulence, 0.05, 10, 0.4, 7.0);
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);
	
	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(4.0);
		
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	    
        // SET SEA TYPE:
	    rmSetSeaType("yucatan Coast");
	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("yucatan_grass");
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("amazon\ground2_ama", 6.0);
		
		// SET LIGHTING:
		rmSetLightingSet("yucatan");
			    
		// SET MAP TYPE:
		rmSetMapType("yucatan");
	    rmSetMapType("tropical");
	    rmSetMapType("water");
			    
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(2.0);
		
		// CHOOSE MERCS:
		chooseMercs();
		
        // SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*================================================================================================================*/

	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("classHill");
	    rmDefineClass("classPatch");
	    rmDefineClass("corner");
	    rmDefineClass("starting settlement");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("classNugget");
	    rmDefineClass("natives");
	    rmDefineClass("classCliff");
		rmDefineClass("classSocket");
		rmDefineClass("classTrees");
		int classIsland=rmDefineClass("island");
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*================================================================================================================*/
  
	// MAP EDGE CONSTRAINTS:
	//int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
	int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(8), rmZTilesToFraction(8), 1.0-rmXTilesToFraction(8), 1.0-rmZTilesToFraction(8), 0.01);
	int longplayerEdgeConstraint=rmCreateBoxConstraint("long player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
	int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 60.0);

	// CARDINAL DIRECTIONS:
	int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

	// ISLAND AVOIDANCE:
	int islandConstraint=rmCreateClassDistanceConstraint("islands avoid each other", classIsland, 5.0);
	int islandCloseConstraint=rmCreateClassDistanceConstraint("close avoid island", classIsland, 3.0);
	int islandVeryCloseConstraint=rmCreateClassDistanceConstraint("very close avoid island", classIsland, 1.0);
	
	// FLAG AVOIDANCE:
	int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 20.0);
	int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 10.0);
    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
    //int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-180, rmGetMapXSize()-40, 0, 0, 0);
 
	
	// FISHES AND WHALES AVOIDANCE: 
	int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
    int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "Beluga", 35.0);
    int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
    int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 25.0);
	
	// TREES AVOIDANCE:
	int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 15.0);
	int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 8.0);
	int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 3.0);
	int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
	int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
	int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);
		
	// PLAYER CONSTRAINTS:
	int playerConstraint=rmCreateClassDistanceConstraint("stuff avoid players", classPlayer, 20.0);
	int playerCloseConstraint=rmCreateClassDistanceConstraint("close avoid players", classPlayer, 10.0);
	int playerMediumConstraint=rmCreateClassDistanceConstraint("medium avoid players", classPlayer, 30.0);
	
	
	int mediumPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players medium", classPlayer, 15.0);
	int shortPlayerConstraint=rmCreateClassDistanceConstraint("short stay away from players", classPlayer, 5.0);
	int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
	
	int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
	int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
	int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 10.0);
	int forestVeryCloseConstraint=rmCreateClassDistanceConstraint("very close vs. forest", rmClassID("classForest"), 5.0);
	
	int forestMediumConstraint=rmCreateClassDistanceConstraint("medium vs. forest", rmClassID("classForest"), 30.0);
	int forestFarConstraint=rmCreateClassDistanceConstraint("far vs. forest", rmClassID("classForest"), 60.0);
	
	
	int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
	int shortAvoidResource=rmCreateTypeDistanceConstraint("resource avoid resource short", "resource", 5.0);
	
    // COIN AVOIDANCE: 	
	int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoid coin", "gold", 20.0);
	int avoidCloseCoin=rmCreateTypeDistanceConstraint("Close avoid coin", "gold", 10.0);
	int avoidVeryCloseCoin=rmCreateTypeDistanceConstraint("Very Close avoid coin", "gold", 5.0);
	int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium avoid coin", "gold", 30.0);
	int avoidFarCoin=rmCreateTypeDistanceConstraint("far avoid coin", "gold", 60.0);
	int avoidVeryFarCoin=rmCreateTypeDistanceConstraint("very far avoid coin", "gold", 90.0);
	int avoidSuperFarCoin=rmCreateTypeDistanceConstraint("super far avoid coin", "gold", 120.0);
	
	int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 10.0);
	   
	// AVOID IMPASSABLE LAND:
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
	int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
	int hillConstraint=rmCreateClassDistanceConstraint("hill vs. hill", rmClassID("classHill"), 10.0);
	int shortHillConstraint=rmCreateClassDistanceConstraint("patches vs. hill", rmClassID("classHill"), 5.0);
	int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
	
	// CLIFFS AVOIDANCE:
	int avoidCliffs=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 20.0);
	int avoidCloseCliffs=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 10.0);
	int avoidVeryCloseCliffs=rmCreateClassDistanceConstraint("very close vs. cliff", rmClassID("classCliff"), 5.0);
	int avoidMediumCliffs=rmCreateClassDistanceConstraint("medium close vs. cliff", rmClassID("classCliff"), 30.0);
	int avoidFarCliffs=rmCreateClassDistanceConstraint("far vs. cliff", rmClassID("classCliff"), 60.0);
	int avoidVeryFarCliffs=rmCreateClassDistanceConstraint("very far vs. cliff", rmClassID("classCliff"), 90.0);
	int avoidSuperFarCliffs=rmCreateClassDistanceConstraint("super far vs. cliff", rmClassID("classCliff"), 120.0);
	
	int shortAvoidCliffs=rmCreateClassDistanceConstraint("short cliff vs. cliff", rmClassID("classCliff"), 5.0);
	
	int avoidSilver=rmCreateTypeDistanceConstraint("gold avoid gold", "Mine", 50.0);
	int mediumAvoidSilver=rmCreateTypeDistanceConstraint("medium gold avoid gold", "Mine", 30.0);
	//int avoidTrees=rmCreateTypeDistanceConstraint("avoid trees", "TreeGreatPlains", 60.0);
	int shortAvoidTrees=rmCreateTypeDistanceConstraint("short avoid trees", "TreePampas", 30.0);
	int deerAvoidDeer=rmCreateTypeDistanceConstraint("deer avoid deer", "rhea", 50.0);
	
	
	// NUGGET AVOIDANCE:
	int avoidNuggets=rmCreateClassDistanceConstraint("nugget vs. nugget", rmClassID("classNugget"), 20.0);
	int avoidNuggetFar=rmCreateClassDistanceConstraint("nugget vs. nugget far", rmClassID("classNugget"), 70.0);
	
	// NUGGET AVOIDANCE:
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 15.0);
	int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 8.0);
	int avoidVeryCloseNugget=rmCreateTypeDistanceConstraint("very close avoid nugget", "AbstractNugget", 3.0);
	int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium avoid nugget", "AbstractNugget", 30.0);
	int avoidFarNugget=rmCreateTypeDistanceConstraint("far avoid nugget", "AbstractNugget", 60.0);
	int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far avoid nugget", "AbstractNugget", 90.0);
	int avoidSuperFarNugget=rmCreateTypeDistanceConstraint("super far avoid nugget", "AbstractNugget", 120.0);
		
	//int avoidTobacco=rmCreateTypeDistanceConstraint("avoid tobacco", "tobacco", 40.0);
	int avoidWater = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 10.0);

	// SPECIFY TRUE SO CONSTRAINT STAYS OUTSIDE OF CIRCLE (I.E. INSIDE CORNERS)
	int cornerConstraint0=rmCreateCornerConstraint("in corner 0", 0, true);
	int cornerConstraint1=rmCreateCornerConstraint("in corner 1", 1, true);
	int cornerConstraint2=rmCreateCornerConstraint("in corner 2", 2, true);
	int cornerConstraint3=rmCreateCornerConstraint("in corner 3", 3, true);
	int insideCircleConstraint=rmCreateCornerConstraint("inside circle", -1, false);
	int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));


	// STARTING UNITS AVOIDANCE:
	int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 15.0);
	int avoidCloseStartingUnits=rmCreateClassDistanceConstraint("close avoid starting units", rmClassID("startingUnit"), 8.0);
	int avoidMediumStartingUnits=rmCreateClassDistanceConstraint("medium avoid starting units", rmClassID("startingUnit"), 25.0);
	
	
	int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), rmXFractionToMeters(0.3));
	
	// NATIVES AVOIDANCE:
	int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
	int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 8.0);
	int avoidVeryCloseNatives=rmCreateClassDistanceConstraint("very close avoids natives", rmClassID("natives"), 5.0);
	int avoidMediumNatives=rmCreateClassDistanceConstraint("medium avoids natives", rmClassID("natives"), 25.0);
	int avoidFarNatives=rmCreateClassDistanceConstraint("far avoids natives", rmClassID("natives"), 50.0);
	int avoidVeryFarNatives=rmCreateClassDistanceConstraint("very far avoids natives", rmClassID("natives"), 75.0);
	int avoidSuperFarNatives=rmCreateClassDistanceConstraint("super far avoids natives", rmClassID("natives"), 100.0);
	
	int shortAvoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other short", rmClassID("importantItem"), 10);
	int farAvoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives alot", rmClassID("natives"), 80.0);
	
	// CAPYBARA AVOIDANCE:
	int avoidCapybara=rmCreateTypeDistanceConstraint("stuff avoids capybara", "capybara", 20.0);
	int avoidCloseCapybara=rmCreateTypeDistanceConstraint("close avoids capybara", "capybara", 10.0);
	int avoidVeryCloseCapybara=rmCreateTypeDistanceConstraint("very close avoids capybara", "capybara", 5.0);
	int avoidMediumCapybara=rmCreateTypeDistanceConstraint("medium avoids capybara", "capybara", 30.0);
	int avoidFarCapybara=rmCreateTypeDistanceConstraint("far avoids capybara", "capybara", 60.0);
	int avoidVeryFarCapybara=rmCreateTypeDistanceConstraint("very far avoids capybara", "capybara", 90.0);
	int avoidSuperFarCapybara=rmCreateTypeDistanceConstraint("super far avoids capybara", "capybara", 120.0);
	
	// DEER HERDS AVOIDANCE:
	int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 20.0);
	int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 10.0);
	int avoidVeryCloseDeer=rmCreateTypeDistanceConstraint("very close avoids deer", "deer", 5.0);
	int avoidMediumDeer=rmCreateTypeDistanceConstraint("medium avoids deer", "deer", 30.0);
	int avoidFarDeer=rmCreateTypeDistanceConstraint("far avoids deer", "deer", 60.0);
	int avoidVeryFarDeer=rmCreateTypeDistanceConstraint("very far avoids deer", "deer", 90.0);
	int avoidSuperFarDeer=rmCreateTypeDistanceConstraint("super far avoids deer", "deer", 120.0);
	
	// BERRYBUSH AVOIDANCE:
	int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids berrybush", "BerryBush", 25.0);
	int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids berrybush", "BerryBush", 15.0);
	int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoids berrybush", "BerryBush", 8.0);
	int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoids berrybush", "BerryBush", 35.0);
	int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoids berrybush", "BerryBush", 60.0);
	int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoids berrybush", "BerryBush", 90.0);
	

	// DECORATION AVOIDANCE:
	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 7.0);

	// TRADE ROUTE AVOIDANCE:
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 15.0);
	int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 8.0);
	int avoidVeryCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("very close trade route", 3.0);
	int avoidMediumTradeRoute = rmCreateTradeRouteDistanceConstraint("medium trade route", 25.0);
	int avoidFarTradeRoute = rmCreateTradeRouteDistanceConstraint("far trade route", 50.0);
	int avoidVeryFarTradeRoute = rmCreateTradeRouteDistanceConstraint("very far trade route", 75.0);
	int avoidSuperFarTradeRoute = rmCreateTradeRouteDistanceConstraint("super far trade route", 100.0);
		
	int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);
	int avoidTradeRouteSockets=rmCreateTypeDistanceConstraint("avoid trade route sockets", "sockettraderoute", 15.0);
	int avoidTradeRouteSocketsFar=rmCreateTypeDistanceConstraint("avoid trade route sockets far", "sockettraderoute", 40.0);
	int avoidMineSockets=rmCreateTypeDistanceConstraint("avoid mine sockets", "mine", 10.0);
	int shortAvoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route short", 5.0);
	
	// SOCKET AVOIDANCE:
	int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 15.0);
    int avoidCloseSocket = rmCreateClassDistanceConstraint("close avoid socket", rmClassID("classSocket"), 8.0);
    int avoidVeryCloseSocket = rmCreateClassDistanceConstraint("very close avoid socket", rmClassID("classSocket"), 3.0);
	int avoidMediumSocket = rmCreateClassDistanceConstraint("medium avoid socket", rmClassID("classSocket"), 30.0);
	int avoidFarSocket = rmCreateClassDistanceConstraint("far close avoid socket", rmClassID("classSocket"), 60.0);
	int avoidVeryFarSocket = rmCreateClassDistanceConstraint("very far avoid socket", rmClassID("classSocket"), 90.0);
	int avoidSuperFarSocket = rmCreateClassDistanceConstraint("super far avoid socket", rmClassID("classSocket"), 120.0);
	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ******************************************* DEFINE SOME OBJECTS: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------*/
    
// DONE DEFINING SOME OBJECTS:
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ******************************************** BUILD A NORTH AREA: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int northIslandID = rmCreateArea("north island");
		rmAddAreaToClass(northIslandID, classIsland);
	    rmSetAreaLocation(northIslandID, 0.90, 0.50); 
	    rmSetAreaWarnFailure(northIslandID, false);
	    rmSetAreaSize(northIslandID, 0.4, 0.4);
	    rmSetAreaCoherence(northIslandID, 1.0);

	    rmSetAreaElevationType(northIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(northIslandID, 3.0);
	    rmSetAreaBaseHeight(northIslandID, 4.0);
	    rmSetAreaElevationMinFrequency(northIslandID, 0.07);
	    rmSetAreaElevationOctaves(northIslandID, 4);
	    rmSetAreaElevationPersistence(northIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(northIslandID, 1);
   
	    rmSetAreaObeyWorldCircleConstraint(northIslandID, false);
	    //rmSetAreaMix(northIslandID, "rockies_grass");
		rmSetAreaMix(northIslandID, "yucatan_grass");
	    //rmSetAreaMix(northIslandID, "amazon grass");
		
		rmBuildAllAreas();
		
		// ADD ISLAND CONSTRAINTS:
        int northIslandConstraint=rmCreateAreaConstraint("north Island", northIslandID);

/*================================================================================================================*/   
// ******************************************** BUILD A SOUTH AREA: ********************************************* //
/*================================================================================================================*/
   
        int southIslandID = rmCreateArea("south island");
		rmAddAreaToClass(southIslandID, classIsland);
        rmSetAreaLocation(southIslandID, 0.10, 0.50); 
        rmSetAreaWarnFailure(southIslandID, false);
        rmSetAreaSize(southIslandID, 0.415, 0.415);
        rmSetAreaCoherence(southIslandID, 1.0);

	    rmSetAreaElevationType(southIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(southIslandID, 5.0);
        rmSetAreaBaseHeight(southIslandID, 3.0);
        rmSetAreaElevationMinFrequency(southIslandID, 0.07);
        rmSetAreaElevationOctaves(southIslandID, 4);
        rmSetAreaElevationPersistence(southIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(southIslandID, 1); 
        //rmAddAreaTerrainLayer(southIslandID, "andes\ground10_and", 0, 5);
        //rmAddAreaTerrainLayer(southIslandID, "andes\ground07_and", 3, 8);
        //rmAddAreaTerrainLayer(southIslandID, "andes\ground4_and", 6, 8);
   
	    rmSetAreaObeyWorldCircleConstraint(southIslandID, false);
		rmSetAreaMix(southIslandID, "yucatan_grass");
	    //rmSetAreaMix(southIslandID, "rockies_snow");
		//rmSetAreaMix(southIslandID, "rockies_grass");

        rmBuildAllAreas();
		
		// ADD ISLAND CONSTRAINTS:
        int southIslandConstraint=rmCreateAreaConstraint("south Island", southIslandID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ***************************** DEFINE AND PLACE THE TRADE ROUTE AND THE SOCKETS: ****************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ********************************************* PLACE THE PLAYERS ********************************************** //
/*================================================================================================================*/
// *********************************** SET UP THE PLAYER STARTING LOCATIONS: ************************************ //
// ************************************ RECTANGULAR AT FAR ENDS OF THE MAP: ************************************* //
/*================================================================================================================*/

/*----------------------------------------------------------------------------------------------------------------*/

        if(rmRandFloat(0,1) > 0.50)
	    {
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.20, 0.60, 0.20, 0.10, 0.0, 0.0);
			
			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.80, 0.10, 0.80, 0.60, 0.0, 0.0);
		}
		    else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.80, 0.10, 0.80, 0.60, 0.0, 0.0);
	
			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.20, 0.60, 0.20, 0.10, 0.0, 0.0);
		}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(2750);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
	    
		// SET AREA MIX:
		//rmSetAreaMix(id, "pampas_grass");
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); 
        //rmAddAreaConstraint(id, playerEdgeConstraint);
        //rmAddAreaConstraint(id, avoidWater);
	    //rmAddAreaConstraint(id, longAvoidImpassableLand);		
	    
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
	    // SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
	    
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
	    // BUILD THE AREAS:
        rmBuildAllAreas();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE TRADE ROUTE: ************************************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // SOCKET DEFINITION:
	    int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 8.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // TRADE ROUTE 1:
		int tradeRoute1ID = rmCreateTradeRoute();
	    
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.50, 0.995);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.50, 0.005);
	
	    bool placedTradeRoute1 = rmBuildTradeRoute(tradeRoute1ID, "dirt");
	    if(placedTradeRoute1 == false)
		rmEchoError("Failed to place trade route one");

/*----------------------------------------------------------------------------------------------------------------*/		

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute1ID);
	    vector socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.50);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1); 

	    socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.975);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1); 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE CENTRAL POND: ************************************* //
/*================================================================================================================*/

	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 20.0);
        int pondCloseConstraint=rmCreateClassDistanceConstraint("close avoid the pond", rmClassID("pond"), 10.0);
        
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// THE WEST POND:
		int smallPondID=rmCreateArea("small pond 1");
		rmSetAreaSize(smallPondID, rmAreaTilesToFraction(4250), rmAreaTilesToFraction(4250));
		rmSetAreaWaterType(smallPondID, "Amazon River Basin");
		rmSetAreaBaseHeight(smallPondID, 4);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1.0);
		rmSetAreaMaxBlobDistance(smallPondID, 1.0);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.65);
		rmSetAreaSmoothDistance(smallPondID, 5);
		//rmAddAreaConstraint(smallPondID, playerConstraint);
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.2, 0.5); 
		rmBuildArea(smallPondID);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE EAST POND:
		int smallPond2ID=rmCreateArea("small pond 2");
		rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(4250), rmAreaTilesToFraction(4250));
		rmSetAreaWaterType(smallPond2ID, "Amazon River Basin");
		rmSetAreaBaseHeight(smallPond2ID, 4);
		rmSetAreaMinBlobs(smallPond2ID, 1);
		rmSetAreaMaxBlobs(smallPond2ID, 1);
		rmSetAreaMinBlobDistance(smallPond2ID, 1.0);
		rmSetAreaMaxBlobDistance(smallPond2ID, 1.0);
		rmAddAreaToClass(smallPond2ID, pondClass);
		rmSetAreaCoherence(smallPond2ID, 0.65);
		rmSetAreaSmoothDistance(smallPond2ID, 5);
		//rmAddAreaConstraint(smallPond2ID, playerConstraint);
		rmSetAreaWarnFailure(smallPond2ID, false);
		rmSetAreaLocation(smallPond2ID, 0.8, 0.5); 
		rmBuildArea(smallPond2ID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.525);
/*================================================================================================================*/
// ************ DEFINE AND PLACE THE STARTING TCID AND THE STARTING UNITS AND THE STARTING RESOURCES: *********** //	
/*================================================================================================================*/

        rmClearClosestPointConstraints();
		
/*----------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE THE STARTING TCID:
        int TCfloat = -1;
	    if (cNumberNonGaiaPlayers <= 4)
		TCfloat = 0;
	    else 
		TCfloat = 0;

        int startingTCID= rmCreateObjectDef("startingTC");
	    if (rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 5.0);
	}
		else
	{
        rmAddObjectDefItem(startingTCID, "townCenter", 1, 5.0);
	}
	    rmSetObjectDefMinDistance(startingTCID, 0);
	    rmSetObjectDefMaxDistance(startingTCID, TCfloat);
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	    //rmAddObjectDefConstraint(startingTCID, avoidWater);
	    		
/*----------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
		rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    //rmAddObjectDefConstraint(startingUnits, avoidAll);
		rmAddObjectDefConstraint(startingUnits, avoidCloseStartingUnits);

/*---------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE STARTING BERRYBUSH:
		int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", 3, 5.0);
		rmAddObjectDefToClass(StartBerriesID, rmClassID("startingUnit"));
	    //rmSetObjectDefCreateHerd(StartBerriesID, true);
	    rmSetObjectDefMinDistance(StartBerriesID, 15);
	    rmSetObjectDefMaxDistance(StartBerriesID, 25);
	    rmAddObjectDefConstraint(StartBerriesID, avoidStartingUnits);
	    rmAddObjectDefConstraint(StartBerriesID, avoidMediumFruits);
	    		
/*----------------------------------------------------------------------------------------------------------------*/		

   	    // DEFINE THE STARTING SILVER:
		int startSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(startSilverID, "mine", 1, 0);
	    rmAddObjectDefToClass(startSilverID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(startSilverID, 16.0);
	    rmSetObjectDefMaxDistance(startSilverID, 26.0);
	    rmAddObjectDefConstraint(startSilverID, avoidStartingUnits);
		rmAddObjectDefConstraint(startSilverID, avoidMediumCoin);
		
/*-----------------------------------------------------------------------------------------------------------------*/		
		
        // DEFINE THE PLAYER NUGGET:
		int playerNuggetID= rmCreateObjectDef("player nugget"); 
	    rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
		rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(playerNuggetID, avoidMediumNugget);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidCloseStartingUnits);
  	    rmSetObjectDefMinDistance(playerNuggetID, 17.0);
	    rmSetObjectDefMaxDistance(playerNuggetID, 27.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // DEFINE THE STARTING TREE:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeYucatan", 3, 6.0);
		rmAddObjectDefToClass(StartAreaTreeID, rmClassID("classTrees"));
	    rmSetObjectDefMinDistance(StartAreaTreeID, 20);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 35);
		rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseStartingUnits);
		rmAddObjectDefConstraint(StartAreaTreeID, avoidMediumTrees);
		
		//WATER HC ARRIVAL POINT:

        int waterFlagID = 0;
        for(i=1; <cNumberPlayers)
    {
        waterFlagID=rmCreateObjectDef("HC water flag "+i);
        rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		//rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
	}	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ***************** PLACE THE STARTING TCID AND THE STARTING UNITS AND THE STARTING RESOURCES: ***************** //
/*================================================================================================================*/

// JOHN'S SWEET SOLUTION:
// FOR PLACING STUFF AROUND THE TC:
// REGARDLESS OF WHERE THE PLAYER START AREA ACTUALLY IS:

/*----------------------------------------------------------------------------------------------------------------*/

	    for(i=1; <cNumberPlayers)
	{
	
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLocation=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
			
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
				
		// PLACE THE STARTING SILVER:
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE PLAYER NUGGET:
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		// PLACE THE STARTING TREE:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));
	    rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
 
    }
        rmClearClosestPointConstraints();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.575);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NATIVE TRIBES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	
		int AztecsVillageAID = -1;
		int AztecsVillageType = rmRandInt(1,3);
		
		if ( whichVariation == 1 )
	{	
		AztecsVillageAID = rmCreateGrouping("Aztecs village A", "native aztec village "+AztecsVillageType);
	}
        else
    {		
		AztecsVillageAID = rmCreateGrouping("Mayas village A", "native maya village "+AztecsVillageType);
	}	
		rmSetGroupingMinDistance(AztecsVillageAID, 0.0);
		rmSetGroupingMaxDistance(AztecsVillageAID, 0.0);
		rmAddGroupingToClass(AztecsVillageAID, rmClassID("natives"));
		rmAddGroupingConstraint(AztecsVillageAID, avoidNatives);
		rmPlaceGroupingAtLoc(AztecsVillageAID, 0, 0.40, 0.95);
	 
	
/*----------------------------------------------------------------------------------------------------------------*/
        
		int AztecsVillageBID = -1;
		AztecsVillageType = rmRandInt(1,3);
		
		if ( whichVariation == 1 )
	{	
		AztecsVillageBID = rmCreateGrouping("Aztecs village B", "native aztec village "+AztecsVillageType);
	}
        else
    {		
		AztecsVillageBID = rmCreateGrouping("Mayas village 2", "native maya village "+AztecsVillageType);
	}	
		rmSetGroupingMinDistance(AztecsVillageBID, 0.0);
		rmSetGroupingMaxDistance(AztecsVillageBID, 0.0);
		rmAddGroupingToClass(AztecsVillageBID, rmClassID("natives"));
		rmAddGroupingConstraint(AztecsVillageBID, avoidNatives);
		rmPlaceGroupingAtLoc(AztecsVillageBID, 0, 0.60, 0.95);
		
/*----------------------------------------------------------------------------------------------------------------*/
        
		int AztecsVillageCID = -1;
		AztecsVillageType = rmRandInt(1,3);
		
		if ( whichVariation == 1 )
	{	
		AztecsVillageCID = rmCreateGrouping("Aztecs village C", "native aztec village "+AztecsVillageType);
	}
        else
    {		
		AztecsVillageCID = rmCreateGrouping("Mayas village C", "native maya village "+AztecsVillageType);
	}	
		rmSetGroupingMinDistance(AztecsVillageCID, 0.0);
		rmSetGroupingMaxDistance(AztecsVillageCID, 0.0);
		rmAddGroupingToClass(AztecsVillageCID, rmClassID("natives"));
		rmAddGroupingConstraint(AztecsVillageCID, avoidNatives);
		rmPlaceGroupingAtLoc(AztecsVillageCID, 0, 0.40, 0.05); 
		
/*----------------------------------------------------------------------------------------------------------------*/

        int AztecsVillageDID = -1;
		AztecsVillageType = rmRandInt(1,3);
		
		if ( whichVariation == 1 )
	{	
		AztecsVillageDID = rmCreateGrouping("Aztecs village D", "native aztec village "+AztecsVillageType);
	}
        else
    {		
		AztecsVillageDID = rmCreateGrouping("Mayas village D", "native maya village "+AztecsVillageType);
	}	
		rmSetGroupingMinDistance(AztecsVillageDID, 0.0);
		rmSetGroupingMaxDistance(AztecsVillageDID, 0.0);
		rmAddGroupingToClass(AztecsVillageDID, rmClassID("natives"));
		rmAddGroupingConstraint(AztecsVillageDID, avoidNatives);
		rmPlaceGroupingAtLoc(AztecsVillageDID, 0, 0.60, 0.05); 

/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE CLIFF AREA: ************************************** //
/*================================================================================================================*/
    
		int failCount = -1;
	    int numTries=cNumberNonGaiaPlayers*0.5;
	
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// THE WEST CLIFF 1:
		
		int cliffID=rmCreateArea("cliff 1");
	    rmSetAreaSize(cliffID, rmAreaTilesToFraction(1250), rmAreaTilesToFraction(1250));
		rmSetAreaWarnFailure(cliffID, false);
		rmSetAreaCliffType(cliffID, "Amazon");
        //rmSetAreaMix(cliffID, "rockies_grass_snow");
		rmAddAreaToClass(cliffID, rmClassID("classCliff"));
        //rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
		//rmSetAreaCliffEdge(cliffID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliffID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(cliffID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaCliffHeight(cliffID, 7, 1.0, 1.0);
		rmSetAreaMinBlobs(cliffID, 1);
		rmSetAreaMaxBlobs(cliffID, 1);
		rmSetAreaMinBlobDistance(cliffID, 1.0);
		rmSetAreaMaxBlobDistance(cliffID, 1.0);
		rmSetAreaLocation(cliffID, 0.375, 0.70); 
		rmSetAreaCoherence(cliffID, 0.65);
		rmSetAreaSmoothDistance(cliffID, 10);
		rmAddAreaConstraint(cliffID, playerConstraint);
		rmAddAreaConstraint(cliffID, avoidNatives); 
		//rmAddAreaConstraint(cliffID, northIslandID);
		rmSetAreaObeyWorldCircleConstraint(cliffID, false);
		rmBuildArea(cliffID);
		
		// THE WEST CLIFF 2:
		
		cliffID=rmCreateArea("cliff 11");
	    rmSetAreaSize(cliffID, rmAreaTilesToFraction(1250), rmAreaTilesToFraction(1250));
		rmSetAreaWarnFailure(cliffID, false);
		rmSetAreaCliffType(cliffID, "Amazon");
        //rmSetAreaMix(cliffID, "rockies_grass_snow");
		rmAddAreaToClass(cliffID, rmClassID("classCliff"));
        //rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
		//rmSetAreaCliffEdge(cliffID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliffID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(cliffID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaCliffHeight(cliffID, 7, 1.0, 1.0);
		rmSetAreaMinBlobs(cliffID, 1);
		rmSetAreaMaxBlobs(cliffID, 1);
		rmSetAreaMinBlobDistance(cliffID, 1.0);
		rmSetAreaMaxBlobDistance(cliffID, 1.0);
		rmSetAreaLocation(cliffID, 0.375, 0.30); 
		rmSetAreaCoherence(cliffID, 0.65);
		rmSetAreaSmoothDistance(cliffID, 10);
		rmAddAreaConstraint(cliffID, playerConstraint);
		rmAddAreaConstraint(cliffID, avoidNatives); 
		//rmAddAreaConstraint(cliffID, northIslandID);
		rmSetAreaObeyWorldCircleConstraint(cliffID, false);
		rmBuildArea(cliffID);


/*----------------------------------------------------------------------------------------------------------------*/
/*
        int oreID=rmCreateObjectDef("The gold Mine 1");
        rmAddObjectDefItem(oreID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(oreID, 0.0);
        rmSetObjectDefMaxDistance(oreID, 0.0);
        //rmAddObjectDefConstraint(oreID, avoidCoin);
	    
		rmPlaceObjectDefAtLoc(oreID, 0, 0.245, 0.755);
        rmPlaceObjectDefAtLoc(oreID, 0, 0.245, 0.725); 
        rmPlaceObjectDefAtLoc(oreID, 0, 0.245, 0.785);
        rmPlaceObjectDefAtLoc(oreID, 0, 0.215, 0.755); 
        rmPlaceObjectDefAtLoc(oreID, 0, 0.275, 0.755); 
*/
/*----------------------------------------------------------------------------------------------------------------*/

        // THE EAST CLIFF:

		int cliff2ID=rmCreateArea("cliff 2");
	    rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(1250), rmAreaTilesToFraction(1250));
		rmSetAreaWarnFailure(cliff2ID, false);
		rmSetAreaCliffType(cliff2ID, "Amazon");
        //rmSetAreaMix(cliff2ID, "rockies_grass_snow");
		rmAddAreaToClass(cliff2ID, rmClassID("classCliff"));
        //rmSetAreaCliffPainting(cliff2ID, false, true, true, 1.5, true);
		//rmSetAreaCliffEdge(cliff2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff2ID, 1, 1.0, 0.1, 1.0, 0);
		//rmSetAreaCliffHeight(cliff2ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaCliffHeight(cliff2ID, 7, 1.0, 1.0);
		rmSetAreaMinBlobs(cliff2ID, 1);
		rmSetAreaMaxBlobs(cliff2ID, 1);
		rmSetAreaMinBlobDistance(cliff2ID, 1.0);
		rmSetAreaMaxBlobDistance(cliff2ID, 1.0);
		rmSetAreaLocation(cliff2ID, 0.65, 0.70); 
		rmSetAreaCoherence(cliff2ID, 0.65);
		rmSetAreaSmoothDistance(cliff2ID, 10);
		rmAddAreaConstraint(cliff2ID, playerConstraint);
		rmAddAreaConstraint(cliff2ID, avoidNatives); 
		//rmAddAreaConstraint(cliff2ID, northIslandID);
		rmSetAreaObeyWorldCircleConstraint(cliff2ID, false);
		rmBuildArea(cliff2ID);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
        cliff2ID=rmCreateArea("cliff 22");
	    rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(1250), rmAreaTilesToFraction(1250));
		rmSetAreaWarnFailure(cliff2ID, false);
		rmSetAreaCliffType(cliff2ID, "Amazon");
        //rmSetAreaMix(cliff2ID, "rockies_grass_snow");
		rmAddAreaToClass(cliff2ID, rmClassID("classCliff"));
        //rmSetAreaCliffPainting(cliff2ID, false, true, true, 1.5, true);
		//rmSetAreaCliffEdge(cliff2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff2ID, 1, 1.0, 0.1, 1.0, 0);
		//rmSetAreaCliffHeight(cliff2ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaCliffHeight(cliff2ID, 7, 1.0, 1.0);
		rmSetAreaMinBlobs(cliff2ID, 1);
		rmSetAreaMaxBlobs(cliff2ID, 1);
		rmSetAreaMinBlobDistance(cliff2ID, 1.0);
		rmSetAreaMaxBlobDistance(cliff2ID, 1.0);
		rmSetAreaLocation(cliff2ID, 0.65, 0.30); 
		rmSetAreaCoherence(cliff2ID, 0.65);
		rmSetAreaSmoothDistance(cliff2ID, 10);
		rmAddAreaConstraint(cliff2ID, playerConstraint);
		rmAddAreaConstraint(cliff2ID, avoidNatives); 
		//rmAddAreaConstraint(cliff2ID, northIslandID);
		rmSetAreaObeyWorldCircleConstraint(cliff2ID, false);
		rmBuildArea(cliff2ID);

/*----------------------------------------------------------------------------------------------------------------*/
/*
        oreID=rmCreateObjectDef("The gold Mine 2");
        rmAddObjectDefItem(oreID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(oreID, 0.0);
        rmSetObjectDefMaxDistance(oreID, 0.0);
        //rmAddObjectDefConstraint(oreID, avoidCoin);
	    rmPlaceObjectDefAtLoc(oreID, 0, 0.755, 0.245);
        rmPlaceObjectDefAtLoc(oreID, 0, 0.755, 0.275);
        rmPlaceObjectDefAtLoc(oreID, 0, 0.755, 0.215);
        rmPlaceObjectDefAtLoc(oreID, 0, 0.785, 0.245);
        rmPlaceObjectDefAtLoc(oreID, 0, 0.725, 0.245);    		
*/
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE FOREST AREAS: ************************************** //
/*================================================================================================================*/

	        int forestTreeID = 0;

	        if (cNumberNonGaiaPlayers <=2)
		    numTries=6*cNumberNonGaiaPlayers;
	        else
		    numTries=3*cNumberNonGaiaPlayers;
	        
			failCount=0;
	        
/*----------------------------------------------------------------------------------------------------------------*/			
			
			for (i=0; <numTries)
   {   
			int forestID=rmCreateArea("forestID"+i, southIslandID);
			rmSetAreaWarnFailure(forestID, false);
			rmSetAreaSize(forestID, rmAreaTilesToFraction(175), rmAreaTilesToFraction(250));
			rmSetAreaForestType(forestID, "Yucatan forest");
			rmSetAreaForestDensity(forestID, 0.75);
			rmSetAreaForestClumpiness(forestID, 0.25);		
			rmSetAreaForestUnderbrush(forestID, 0.25);
			rmSetAreaMinBlobs(forestID, 1);
			rmSetAreaMaxBlobs(forestID, 4);						
			rmSetAreaMinBlobDistance(forestID, 5.0);
			rmSetAreaMaxBlobDistance(forestID, 20.0);
			rmSetAreaCoherence(forestID, 0.4);
			rmSetAreaSmoothDistance(forestID, 10);
			rmAddAreaToClass(forestID, rmClassID("classForest"));
			rmAddAreaConstraint(forestID, forestMediumConstraint);  
			//rmAddAreaConstraint(forestID, avoidCloseTradeRoute);
			//rmAddAreaConstraint(forestID, avoidCinematicBlock);
			rmAddAreaConstraint(forestID, pondCloseConstraint);
			//rmAddAreaConstraint(forestID, avoidCloseImportantItem);
			rmAddAreaConstraint(forestID, playerCloseConstraint);
			rmAddAreaConstraint(forestID, playerEdgeConstraint);
			rmAddAreaConstraint(forestID, avoidCloseCliffs);
			rmAddAreaConstraint(forestID, avoidAll);
			if(rmBuildArea(forestID)==false)
		{
			// Stop trying once we fail 5 times in a row.
			failCount++;
			if(failCount==10)
			break;
		}
			else
			failCount=0; 
   }
   
/*----------------------------------------------------------------------------------------------------------------*/
	        
			int forestTreeNorthID = 0;
			
			if (cNumberNonGaiaPlayers <=2)
			numTries=6*cNumberNonGaiaPlayers;
			else
			numTries=3*cNumberNonGaiaPlayers;  
	        
			failCount=0;
			
/*----------------------------------------------------------------------------------------------------------------*/			
			
	        for (i=0; <numTries)
	{   
			int forestnorthID=rmCreateArea("forestNorthID"+i, northIslandID);
			rmSetAreaWarnFailure(forestnorthID, false);
			rmSetAreaSize(forestnorthID, rmAreaTilesToFraction(175), rmAreaTilesToFraction(250));
			rmSetAreaForestType(forestnorthID, "Yucatan forest");
			rmSetAreaForestDensity(forestnorthID, 0.75);
			rmSetAreaForestClumpiness(forestnorthID, 0.25);		
			rmSetAreaForestUnderbrush(forestnorthID, 0.25);
			rmSetAreaMinBlobs(forestnorthID, 1);
			rmSetAreaMaxBlobs(forestnorthID, 4);						
			rmSetAreaMinBlobDistance(forestnorthID, 5.0);
			rmSetAreaMaxBlobDistance(forestnorthID, 20.0);
			rmSetAreaCoherence(forestnorthID, 0.4);
			rmSetAreaSmoothDistance(forestnorthID, 10);
			rmAddAreaToClass(forestnorthID, rmClassID("classForest"));
			
			rmAddAreaConstraint(forestnorthID, forestMediumConstraint);  
			//rmAddAreaConstraint(forestnorthID, avoidCloseTradeRoute);
			//rmAddAreaConstraint(forestnorthID, avoidCinematicBlock);
			rmAddAreaConstraint(forestnorthID, pondCloseConstraint);
			rmAddAreaConstraint(forestnorthID, playerCloseConstraint);
			rmAddAreaConstraint(forestnorthID, playerEdgeConstraint);
			rmAddAreaConstraint(forestnorthID, avoidCloseCliffs);
			rmAddAreaConstraint(forestnorthID, avoidAll);
			
			if(rmBuildArea(forestnorthID)==false)
		{
			// Stop trying once we fail 5 times in a row.
			failCount++;
			if(failCount==10)
			break;
		}
			else
			failCount=0; 
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NORTHERN NUGGET: ************************************ //
/*================================================================================================================*/
	    
        int nuggeteasy3ID= rmCreateObjectDef("nugget easy north" ); 
	    rmAddObjectDefItem(nuggeteasy3ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nuggeteasy3ID, 0.0);
	    rmSetObjectDefMaxDistance(nuggeteasy3ID, rmXFractionToMeters(0.5));
  	    
		rmAddObjectDefConstraint(nuggeteasy3ID, avoidFarNugget);
		rmAddObjectDefConstraint(nuggeteasy3ID, pondCloseConstraint);
		rmAddObjectDefConstraint(nuggeteasy3ID, avoidCloseCliffs);
  	    rmAddObjectDefConstraint(nuggeteasy3ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(nuggeteasy3ID, playerCloseConstraint);
		rmAddObjectDefConstraint(nuggeteasy3ID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nuggeteasy3ID, northIslandConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(nuggeteasy3ID, 0, 0.5, 0.5, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nuggeteasy3ID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);

/*----------------------------------------------------------------------------------------------------------------*/

        int nuggeteasy4ID= rmCreateObjectDef("nugget easy south" ); 
	    rmAddObjectDefItem(nuggeteasy4ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nuggeteasy4ID, 0.0);
	    rmSetObjectDefMaxDistance(nuggeteasy4ID, rmXFractionToMeters(0.5));
  	    
		rmAddObjectDefConstraint(nuggeteasy4ID, avoidFarNugget);
		rmAddObjectDefConstraint(nuggeteasy4ID, pondCloseConstraint);
		rmAddObjectDefConstraint(nuggeteasy4ID, avoidCloseCliffs);
  	    rmAddObjectDefConstraint(nuggeteasy4ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(nuggeteasy4ID, playerCloseConstraint);
		rmAddObjectDefConstraint(nuggeteasy4ID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nuggeteasy4ID, southIslandConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(nuggeteasy4ID, 0, 0.5, 0.5, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nuggeteasy4ID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);			
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE COIN RESOURCES: ************************************* //
/*================================================================================================================*/
		
		// COIN RESOURCES:

	    int coinType = rmRandInt(1,10);   
	    int coinID = -1;
		
		if (cNumberNonGaiaPlayers <= 2)
        int coinCount = cNumberNonGaiaPlayers*4;	
		else
		coinCount = cNumberNonGaiaPlayers*2;	
	    
		rmEchoInfo("coin count = "+coinCount);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // THE NORTHERN COIN:
		for(i=0; < coinCount)
	{
		coinID = rmCreateObjectDef("coin 1"+i);
		rmAddObjectDefItem(coinID, "mine", 1, 0);
		rmSetObjectDefMinDistance(coinID, 0.0);
		rmSetObjectDefMaxDistance(coinID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(coinID, pondCloseConstraint);
		rmAddObjectDefConstraint(coinID, avoidCloseCliffs);
		rmAddObjectDefConstraint(coinID, forestCloseConstraint);
	    rmAddObjectDefConstraint(coinID, northIslandConstraint);
		rmAddObjectDefConstraint(coinID, avoidMediumCoin);
		rmAddObjectDefConstraint(coinID, avoidNugget);
		rmAddObjectDefConstraint(coinID, playerCloseConstraint);
		rmAddObjectDefConstraint(coinID, playerEdgeConstraint);
	
     	rmPlaceObjectDefAtLoc(coinID, 0, 0.5, 0.5);
	}

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN COIN:
		for(i=0; < coinCount)
	{
		int coin2ID = rmCreateObjectDef("coin 2"+i);
		rmAddObjectDefItem(coin2ID, "mine", 1, 0);
		rmSetObjectDefMinDistance(coin2ID, 0.0);
		rmSetObjectDefMaxDistance(coin2ID, rmXFractionToMeters(0.45));
		
		rmAddObjectDefConstraint(coin2ID, pondCloseConstraint);
		rmAddObjectDefConstraint(coin2ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(coin2ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(coin2ID, southIslandConstraint);
		rmAddObjectDefConstraint(coin2ID, avoidMediumCoin);
		rmAddObjectDefConstraint(coin2ID, avoidNugget);
		rmAddObjectDefConstraint(coin2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(coin2ID, playerEdgeConstraint);     
		
		rmPlaceObjectDefAtLoc(coin2ID, 0, 0.5, 0.5);
	}	
	
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE CAPYBARA HERDS: ************************************** //
/*================================================================================================================*/
		
		// THE NORTHERN CAPYBARA HERDS:
		int capybaraID=rmCreateObjectDef("Capybara 1");
	    rmAddObjectDefItem(capybaraID, "capybara", 5, 5.0);
	    rmSetObjectDefMinDistance(capybaraID, 0.0);
	    rmSetObjectDefMaxDistance(capybaraID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(capybaraID, avoidFarCapybara);
	    rmAddObjectDefConstraint(capybaraID, pondCloseConstraint);
		rmAddObjectDefConstraint(capybaraID, forestCloseConstraint);
		rmAddObjectDefConstraint(capybaraID, northIslandConstraint);
		rmAddObjectDefConstraint(capybaraID, avoidMediumCoin);
		rmAddObjectDefConstraint(capybaraID, avoidNugget);
		rmAddObjectDefConstraint(capybaraID, avoidCloseCliffs);
	    rmAddObjectDefConstraint(capybaraID, playerCloseConstraint);
	    rmAddObjectDefConstraint(capybaraID, playerEdgeConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(capybaraID, 0, 0.5, 0.5, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(capybaraID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN CAPYBARA HERDS:
		int capybara2ID=rmCreateObjectDef("capybara 2");
	    rmAddObjectDefItem(capybara2ID, "capybara", 5, 5.0);
	    rmSetObjectDefMinDistance(capybara2ID, 0.0);
	    rmSetObjectDefMaxDistance(capybara2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(capybara2ID, avoidFarCapybara);
	    rmAddObjectDefConstraint(capybara2ID, pondCloseConstraint);
		rmAddObjectDefConstraint(capybara2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(capybara2ID, southIslandConstraint);
		rmAddObjectDefConstraint(capybara2ID, avoidMediumCoin);
		rmAddObjectDefConstraint(capybara2ID, avoidNugget);
		rmAddObjectDefConstraint(capybara2ID, avoidCloseCliffs);
	    rmAddObjectDefConstraint(capybara2ID, playerCloseConstraint);
	    rmAddObjectDefConstraint(capybara2ID, playerEdgeConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(capybara2ID, 0, 0.5, 0.5, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(capybara2ID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);		
		
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.825);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE DEER HERDS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*================================================================================================================*/

        // THE NORTHERN DEER HERDS:
		int deerID=rmCreateObjectDef("The Northern Deer Herds");
	    rmAddObjectDefItem(deerID, "deer", rmRandInt(7,8), 6.0);
        rmSetObjectDefMinDistance(deerID, 0.0);
        rmSetObjectDefMaxDistance(deerID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(deerID, avoidFarDeer);
		rmAddObjectDefConstraint(deerID, avoidMediumCapybara);
		rmAddObjectDefConstraint(deerID, pondCloseConstraint);
		rmAddObjectDefConstraint(deerID, avoidCloseCliffs);
        rmAddObjectDefConstraint(deerID, forestCloseConstraint);
	    rmAddObjectDefConstraint(deerID, northIslandConstraint);
		rmAddObjectDefConstraint(deerID, avoidCloseCoin);
		rmAddObjectDefConstraint(deerID, avoidCloseNugget);
		rmAddObjectDefConstraint(deerID, playerCloseConstraint);
		rmAddObjectDefConstraint(deerID, playerEdgeConstraint);

        rmSetObjectDefCreateHerd(deerID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(deerID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(deerID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*----------------------------------------------------------------------------------------------------------------*/
        
		// THE SOUTHERN DEER HERDS:
		int deer2ID=rmCreateObjectDef("The Southern Deer Herds");
	    rmAddObjectDefItem(deer2ID, "deer", rmRandInt(7,8), 6.0);
        rmSetObjectDefMinDistance(deer2ID, 0.0);
        rmSetObjectDefMaxDistance(deer2ID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(deer2ID, avoidFarDeer);
		rmAddObjectDefConstraint(deer2ID, avoidMediumCapybara);
		rmAddObjectDefConstraint(deer2ID, pondCloseConstraint);
		rmAddObjectDefConstraint(deer2ID, avoidCloseCliffs);
        rmAddObjectDefConstraint(deer2ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(deer2ID, southIslandConstraint);
		rmAddObjectDefConstraint(deer2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(deer2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(deer2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(deer2ID, playerEdgeConstraint);

        rmSetObjectDefCreateHerd(deer2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //		
/*================================================================================================================*/

        // THE NORTHERN BERRYBUSH:
		int BerriesID=rmCreateObjectDef("The Northern Berrybush");
        rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(BerriesID, 0.0);
        rmSetObjectDefMaxDistance(BerriesID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(BerriesID, avoidFarFruits);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCapybara);
		rmAddObjectDefConstraint(BerriesID, avoidCloseDeer);
		rmAddObjectDefConstraint(BerriesID, pondCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCliffs);
		rmAddObjectDefConstraint(BerriesID, northIslandConstraint);
        rmAddObjectDefConstraint(BerriesID, forestCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, playerCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCoin);
		rmAddObjectDefConstraint(BerriesID, avoidCloseNugget);
		rmAddObjectDefConstraint(BerriesID, playerEdgeConstraint);
		    
		rmSetObjectDefCreateHerd(BerriesID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN BERRYBUSH:
		int Berries2ID=rmCreateObjectDef("The Southern Berrybush");
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(Berries2ID, 0.0);
        rmSetObjectDefMaxDistance(Berries2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(Berries2ID, avoidFarFruits);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCapybara);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseDeer);
		rmAddObjectDefConstraint(Berries2ID, pondCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(Berries2ID, southIslandConstraint);
        rmAddObjectDefConstraint(Berries2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Berries2ID, playerEdgeConstraint);
		        
		rmSetObjectDefCreateHerd(Berries2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.875);
/*================================================================================================================*/
// ************************************ DEFINE THE OUTER ISLANDS BERRYBUSH: ************************************* //		
/*================================================================================================================*/
		
        // THE OUTER ISLANDS BERRYBUSH:
		int Berries3ID=rmCreateObjectDef("The Outer Islands Berrybush");
        rmAddObjectDefItem(Berries3ID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(Berries3ID, 0.0);
        rmSetObjectDefMaxDistance(Berries3ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(Berries3ID, islandVeryCloseConstraint);
		rmAddObjectDefConstraint(Berries3ID, avoidCloseNatives);
		rmAddObjectDefConstraint(Berries3ID, avoidFarFruits);
		rmAddObjectDefConstraint(Berries3ID, avoidCloseSocket);
		rmAddObjectDefConstraint(Berries3ID, avoidVeryCloseTradeRoute);
		rmAddObjectDefConstraint(Berries3ID, playerEdgeConstraint);
		    
		rmSetObjectDefCreateHerd(Berries3ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4.0);
		else
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);	

/*================================================================================================================*/
// ************************************ DEFINE THE OUTER ISLANDS GOLDMINES: ************************************* //		
/*================================================================================================================*/
		
        // THE OUTER ISLANDS GOLD MINES:
		int goldID=rmCreateObjectDef("The Outer Islands Goldmines");
        rmAddObjectDefItem(goldID, "minegold", 1.0, 0.0);
        rmSetObjectDefMinDistance(goldID, 0.0);
        rmSetObjectDefMaxDistance(goldID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(goldID, islandVeryCloseConstraint);
		rmAddObjectDefConstraint(goldID, avoidCloseNatives);
		rmAddObjectDefConstraint(goldID, avoidCloseSocket);
		rmAddObjectDefConstraint(goldID, avoidVeryCloseTradeRoute);
		rmAddObjectDefConstraint(goldID, avoidCloseFruits);
		rmAddObjectDefConstraint(goldID, avoidFarCoin);
		rmAddObjectDefConstraint(goldID, playerEdgeConstraint);
		    
		rmSetObjectDefCreateHerd(goldID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(goldID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(goldID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*================================================================================================================*/		

        int randomTree3ID=rmCreateObjectDef("The Random Center Trees");
		rmAddObjectDefItem(randomTree3ID, "TreeYucatan", 1, 0.0);
		rmAddObjectDefToClass(randomTree3ID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTree3ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree3ID, rmXFractionToMeters(0.5));
		
		
		rmAddObjectDefConstraint(randomTree3ID, avoidVeryCloseTradeRoute);
		rmAddObjectDefConstraint(randomTree3ID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTree3ID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTree3ID, islandVeryCloseConstraint);
		rmAddObjectDefConstraint(randomTree3ID, avoidVeryCloseCoin);
		rmAddObjectDefConstraint(randomTree3ID, avoidVeryCloseFruits);
		rmAddObjectDefConstraint(randomTree3ID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTree3ID, playerEdgeConstraint);
   	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTree3ID, 0, 0.5, 0.5, 24*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTree3ID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers); 
        		
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE RANDOM NORTHERN TREES:
		int randomTreeID=rmCreateObjectDef("The Random Northern Trees");
		rmAddObjectDefItem(randomTreeID, "TreeYucatan", 1, 0.0);
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseDeer);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseCapybara);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCliffs);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseFruits);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, northIslandConstraint);
		rmAddObjectDefConstraint(randomTreeID, forestVeryCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint); 
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, pondCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);  

/*----------------------------------------------------------------------------------------------------------------*/
        // THE RANDOM NORTHERN TREES:
		int randomTree2ID=rmCreateObjectDef("The Random Southern Trees");
		rmAddObjectDefItem(randomTree2ID, "TreeYucatan", 1, 0.0);
		rmAddObjectDefToClass(randomTree2ID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTree2ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseDeer);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseCapybara);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseFruits);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseTradeRoute);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTree2ID, southIslandConstraint);
		rmAddObjectDefConstraint(randomTree2ID, forestVeryCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, playerEdgeConstraint); 
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTree2ID, pondCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseCoin);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers); 
        
		
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.925);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FISHSALMON: *************************************** //
/*================================================================================================================*/
   
        // THE NORTHERN FISHES:
		int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
		rmAddObjectDefConstraint(fishID, northIslandConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*10.0);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*5.0);

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN FISHES:
		int fish2ID=rmCreateObjectDef("fish 2");
        rmAddObjectDefItem(fish2ID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fish2ID, 0.0);
        rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish2ID, fishVsFishID);
        rmAddObjectDefConstraint(fish2ID, fishLand);
		rmAddObjectDefConstraint(fish2ID, southIslandConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*10.0);
		else
		rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*5.0);

/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/   
// ******************************* DEFINE AND PLACE THE FAST COIN -- WHALES: ************************************ //	 
/*================================================================================================================*/

	    // THE NORTHERN WHALES:
		int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "Beluga", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
		rmAddObjectDefConstraint(whaleID, northIslandConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		else
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.75);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN WHALES:
		int whale2ID=rmCreateObjectDef("whale 2");
        rmAddObjectDefItem(whale2ID, "Beluga", 1, 9.0);
        rmSetObjectDefMinDistance(whale2ID, 0.0);
        rmSetObjectDefMaxDistance(whale2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whale2ID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whale2ID, whaleLand);
		rmAddObjectDefConstraint(whale2ID, southIslandConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(whale2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		else
		rmPlaceObjectDefAtLoc(whale2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.75);
		
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.975);
/*================================================================================================================*/   
// ********************** DEFINE AND PLACE SOME RANDOM EAGLE TREE AND RANDOM VULTURE TREE: ********************** //
/*================================================================================================================*/

	    // THE PROP EAGLES ROCKS:
		int avoidEagles=rmCreateTypeDistanceConstraint("avoids Eagles", "PropEaglesRocks", 40.0);
	    
	    int randomEagleTreeID=rmCreateObjectDef("random eagle rock");
	    rmAddObjectDefItem(randomEagleTreeID, "PropEaglesRocks", 1, 3.0);
	    rmAddObjectDefItem(randomEagleTreeID, "UnderbrushPampas", rmRandInt(4,6), 3.0);
	    rmSetObjectDefMinDistance(randomEagleTreeID, 0.0);
	    rmSetObjectDefMaxDistance(randomEagleTreeID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(randomEagleTreeID, avoidCloseCliffs);
	    rmAddObjectDefConstraint(randomEagleTreeID, pondCloseConstraint);
	    rmAddObjectDefConstraint(randomEagleTreeID, playerCloseConstraint);
	    rmAddObjectDefConstraint(randomEagleTreeID, avoidEagles);
	    rmAddObjectDefConstraint(randomEagleTreeID, playerEdgeConstraint);
		rmAddObjectDefConstraint(randomEagleTreeID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomEagleTreeID, avoidCloseFruits);
		rmAddObjectDefConstraint(randomEagleTreeID, avoidCloseDeer);
		rmAddObjectDefConstraint(randomEagleTreeID, avoidCloseCapybara);
		rmAddObjectDefConstraint(randomEagleTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomEagleTreeID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomEagleTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomEagleTreeID, avoidCloseSocket);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // THE PROP VULTURE PERCHING:
		int avoidVultures=rmCreateTypeDistanceConstraint("avoids Vultures", "PropVulturePerching", 40.0);
		
		int randomVultureTreeID=rmCreateObjectDef("random vulture tree");
	    rmAddObjectDefItem(randomVultureTreeID, "PropVulturePerching", 1, 3.0);
	    rmAddObjectDefItem(randomVultureTreeID, "UnderbrushPampas", rmRandInt(4,6), 3.0);
	    rmSetObjectDefMinDistance(randomVultureTreeID, 0.0);
	    rmSetObjectDefMaxDistance(randomVultureTreeID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseCliffs);
	    rmAddObjectDefConstraint(randomVultureTreeID, pondCloseConstraint);
	    rmAddObjectDefConstraint(randomVultureTreeID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomVultureTreeID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(randomVultureTreeID, avoidEagles);
		rmAddObjectDefConstraint(randomVultureTreeID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseFruits);
		rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseDeer);
		rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseCapybara);
		rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseNugget);
	    rmAddObjectDefConstraint(randomVultureTreeID, avoidVultures);
	    rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomVultureTreeID, avoidCloseSocket);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomVultureTreeID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomVultureTreeID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/




