/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// THE CARIBBEAN WAR:
// CREATED BY DANY:
// MARCH 2007:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/    
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// *********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // DEFINE THE CARIB NATIVES:
	    int subCiv0=-1;
        int subCiv1=-1;
        		
		if (rmAllocateSubCivs(12) == true)
   {
		subCiv0=rmGetCivID("Caribs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Caribs");

		subCiv1=rmGetCivID("Caribs");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Caribs"); 
	}	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/	
// ***************************************** SET THE SIZE OF THE MAP: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	    int playerTiles=25000;
	
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ************************************ DEFINE THE PARAMETERS OF THE MAP: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	    // SET THE MAP ELEVATION PARAMETERS: // if terrain is initialize:
		rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
	    
		// SET THE MAP ELEVATION HEIGHT BLEND: // if terrain is initialize:
		rmSetMapElevationHeightBlend(1);
		
		// SET THE SEA LEVEL: // if terrain or water is initialize:
	    rmSetSeaLevel(1.0);          
	    
		// SET THE SEA TYPE: // if terrain or water is initialize:
		rmSetSeaType("caribbean coast");
		
		// ENABLE LOCAL WATER: // if terrain is initialize:
		rmEnableLocalWater(false);
	    
		// SET THE BASE TERRAIN MIX: // if terrain or water is initialize:
		rmSetBaseTerrainMix("caribbean grass");
	    
	    // INITIALIZATION OF MAP WITH THE WATER: // if terrain is initialize:
	    // rmTerrainInitialize("water");
		
		// INITIALIZATION OF THE MAP WITH A TERRAIN: // if terrain is initialize:
		rmTerrainInitialize("caribbean\ground1_crb", 5.0);
		
		// SET THE LIGHTING: // if terrain or water is initialize:
		rmSetLightingSet("caribbean");
		
		// SET THE MAP TYPE: // if terrain or water is initialize:
		rmSetMapType("caribbean");
		rmSetMapType("water");
	    rmSetMapType("grass");
	    		
		// SET WORLD CIRCLE CONSTRAINT: // if terrain is initialize:
		rmSetWorldCircleConstraint(true);
		
		// CHOOSES THE MERCS: // if terrain or water is initialize:
		chooseMercs();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE SOME CLASSES: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int classPlayer=rmDefineClass("player");
		rmDefineClass("classSocket");
		rmDefineClass("natives");
		rmDefineClass("classForest");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// **************************************** DEFINE THE CONSTRAINTS: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // CREATE AN EDGE OF MAP CONSTRAINT:
	    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.45), rmDegreesToRadians(0), rmDegreesToRadians(360));

	    // PLAYER AREA CONSTRAINT:
	    int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 25.0);
		int avoidTC=rmCreateTypeDistanceConstraint("stay away from TC", "TownCenter", 24.0);    //Originally 20.0 -- This adjustment, as well as changing the rmSetObjectDefMaxDistance to 12.0, has corrected the problem of nomad sometimes not placing CW for each player.
	    int avoidTP=rmCreateTypeDistanceConstraint("stay away from Trading Post Sockets", "SocketTradeRoute", 14.0);  // JSB 1-11-05 - Just added, to try to prevent things from stomping on TPs.
	    int avoidCW=rmCreateTypeDistanceConstraint("stay away from CW", "CoveredWagon", 24.0);
		
		// SEA FOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fishMahi", 10.0);			// was 50.0
	    int fishVsFishTarponID=rmCreateTypeDistanceConstraint("fish v fish2", "fishTarpon", 20.0);  // was 40.0 
	    int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);			
	    int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "HumpbackWhale", 2.0);	//Was 8.0
	    int fishVsWhaleID=rmCreateTypeDistanceConstraint("fish v whale", "HumpbackWhale", 5.0);    //Was 34.0 -- This is for trying to keep fish out of "whale bay".
	    int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 17.0);   // Was 18.0.  This is to keep whales from swimming inside of land.
	    		
		// FOREST AVOIDANCE:
		int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
	    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 15.0);
	    		
		// AVOID IMPASSABLE LAND:
	    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 5.0);
		int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	    int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 14.0);  //This one is used in one place: for helping place FFA TC's better.
		
		// AVOID DECORATIONS:
		int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0);
		
		// CONSTRAINT TO AVOID WATER:
	    //int avoidWater2 = rmCreateTerrainDistanceConstraint("avoid water short", "Land", false, 2.0);   //I added this one so I could experiment with it.
	    int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 8.0);
	    //int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
	    //int avoidWater40 = rmCreateTerrainDistanceConstraint("avoid water super long", "Land", false, 40.0);  //Added this one too.
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 18.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 22); //Was 15, but made larger so ships don't sometimes stomp each other when arriving from HC.
	    rmAddClosestPointConstraint(avoidWater8);  //was originally 8
		
		// UNITS AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("trees avoids natives", rmClassID("natives"), 5.0);
		
		// NUGGETS AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 15.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("lake avoid nugget", "AbstractNugget", 5.0);
	
		// TREES AVOIDANCE:
		int avoidTree=rmCreateTypeDistanceConstraint("stuff avoid tree", "treeCaribbean", 5.0);
		int avoidCloseTree=rmCreateTypeDistanceConstraint("lake avoid tree", "treeCaribbean", 10.0);
		
		// GOLD MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 5.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("forest avoid gold", "minegold", 10.0);
		
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoid deer", "deer", 5.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("forest avoid deer", "deer", 10.0);
		
		// SHEEP AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoid sheep", "sheep", 5.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("trees avoid sheep", "sheep", 10.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "berrybush", 5.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("forest avoid fruits", "berrybush", 10.0);
		
		// V.P. AVOIDANCE:
		int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
	    int avoidSocket = rmCreateClassDistanceConstraint("stuff avoid socket", rmClassID("classSocket"), 10.0);
	    				
		// The following is a Pie constraint, defined in a large "majority of the pie plate" area, to make sure Water spawn flags place inside it.  (It excludes the west bay, where I do not want the flags.)
	    int circleConstraint=rmCreatePieConstraint("semi-circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(50), rmDegreesToRadians(290));  //rmZFractionToMeters(0.47)- this number defines how far out from .5, .5 the center of the pie sections go. 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// *************************************** SET UP THE PLAYER LOCATIONS: ***************************************** //
/*================================================================================================================*/
         //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(0);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(1,0.775,0.775);

        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(1);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(2,0.225,0.225); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
        float playerFraction = rmAreaTilesToFraction(100);
        
		for(i = 0; < cNumberNonGaiaPlayers)
   {
        // CREATE THE AREA:
        int id = rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
	    rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
	    rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint);
	   
	    // SET AREA TERRAIN TYPE:
		rmSetAreaTerrainType(id, "caribbean\ground1_crb");
	    
		// SET AREA MIX:
		//rmSetAreaMix(id, "caribbean grass"); // added by me as a possibility:
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD THE AREAS:
        rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ********************************** CLEAR OUT CONSTRAINTS FOR GOOD MEASURE: *********************************** //
/*================================================================================================================*/
        rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE TRADE ROUTE: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NATIVES: **************************************** //
/*================================================================================================================*/  
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv0 == rmGetCivID("caribs"))
	{  
		int caribs1VillageID = -1;
		caribs1VillageID = rmCreateGrouping("caribs village 1", "native carib village 1");
		rmSetGroupingMinDistance(caribs1VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs1VillageID, 0.0);
		//rmAddGroupingConstraint(caribs1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(caribs1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs1VillageID, avoidNatives);
		//rmAddGroupingConstraint(caribs1VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(caribs1VillageID, 0, 0.25, 0.75);
	} 
	
	if (subCiv1 == rmGetCivID("caribs"))
	{  
		int caribs2VillageID = -1;
		caribs2VillageID = rmCreateGrouping("caribs village 2", "native carib village 1");
		rmSetGroupingMinDistance(caribs2VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs2VillageID, 0.0);
		//rmAddGroupingConstraint(caribs2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(caribs2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs2VillageID, avoidNatives);
		//rmAddGroupingConstraint(caribs2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(caribs2VillageID, 0, 0.75, 0.25);
	} 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE MIDDLE REGION: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*
        int regionClass=rmDefineClass("region");
		int region1ID=rmCreateArea("The Region 1");
		int avoidRegion = rmCreateClassDistanceConstraint("stuff avoid region", rmClassID("region"), 3.0);
		
		rmSetAreaSize(region1ID, 0.1, 0.1);
        rmSetAreaWarnFailure(region1ID, false);
        rmSetAreaSmoothDistance(region1ID, 10);
	    rmSetAreaMix(region1ID, "texas_grass");
	    rmSetAreaElevationType(region1ID, cElevTurbulence);
        rmSetAreaElevationVariation(region1ID, 6.0);
        rmSetAreaBaseHeight(region1ID, 5);
        rmSetAreaElevationMinFrequency(region1ID, 0.05);
        rmSetAreaElevationOctaves(region1ID, 3);
        rmSetAreaElevationPersistence(region1ID, 0.3);      
        rmSetAreaElevationNoiseBias(region1ID, 0.5);
        rmSetAreaElevationEdgeFalloffDist(region1ID, 20.0);
	    rmSetAreaCoherence(region1ID, 0.9);
	    rmSetAreaLocation(region1ID, 0.5, 0.5);
        //rmSetAreaEdgeFilling(region1ID, 5);
	    rmSetAreaHeightBlend(region1ID, 1);
	    rmSetAreaObeyWorldCircleConstraint(region1ID, false);
	    rmAddAreaToClass(region1ID, rmClassID("region"));
	    rmBuildArea(region1ID);	
*/		
/*================================================================================================================*/
// ***************************** DEFINE AND PLACE THE TREES AROUND THE MIDDLE LAKE: ***************************** //		
/*================================================================================================================*/
		int tree1ID= rmCreateObjectDef("The Trees 1"); 
	    rmAddObjectDefItem(tree1ID, "treeCaribbean", 1, 0.0);
	    rmSetObjectDefMinDistance(tree1ID, 0.0);
	    rmSetObjectDefMaxDistance(tree1ID, 0.0);
  	    rmAddObjectDefConstraint(tree1ID, avoidCloseTree);
  	    rmPlaceObjectDefAtLoc(tree1ID, 0, 0.325, 0.325);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.675, 0.675);   
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.325, 0.675);   
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.675, 0.325); 
		
		int tree2ID= rmCreateObjectDef("The Trees 2"); 
	    rmAddObjectDefItem(tree2ID, "treeCaribbean", 1, 0.0);
	    rmSetObjectDefMinDistance(tree2ID, 0.0);
	    rmSetObjectDefMaxDistance(tree2ID, 0.0);
  	    rmAddObjectDefConstraint(tree2ID, avoidCloseTree);
  	    rmPlaceObjectDefAtLoc(tree2ID, 0, 0.425, 0.725);
        rmPlaceObjectDefAtLoc(tree2ID, 0, 0.725, 0.425);   
        rmPlaceObjectDefAtLoc(tree2ID, 0, 0.575, 0.725);   
        rmPlaceObjectDefAtLoc(tree2ID, 0, 0.725, 0.575);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.275, 0.575);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.575, 0.275);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.275, 0.425);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.425, 0.275);
		
		int tree3ID= rmCreateObjectDef("The Trees 3"); 
	    rmAddObjectDefItem(tree3ID, "treeCaribbean", 1, 0.0);
	    rmSetObjectDefMinDistance(tree3ID, 0.0);
	    rmSetObjectDefMaxDistance(tree3ID, 0.0);
  	    rmAddObjectDefConstraint(tree3ID, avoidCloseTree);
  	    rmPlaceObjectDefAtLoc(tree3ID, 0, 0.25, 0.50);
        rmPlaceObjectDefAtLoc(tree3ID, 0, 0.50, 0.25);   
        rmPlaceObjectDefAtLoc(tree3ID, 0, 0.50, 0.75);   
        rmPlaceObjectDefAtLoc(tree3ID, 0, 0.75, 0.50);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.7, 0.625);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.625, 0.7);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.30, 0.375);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.375, 0.30);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.375, 0.7);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.7, 0.375);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.625, 0.70);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.70, 0.625);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.625, 0.30);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.30, 0.625);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NATIVES TREES: ************************************** //
/*================================================================================================================*/
        
		int tree4ID= rmCreateObjectDef("The Trees 4"); 
	    rmAddObjectDefItem(tree4ID, "treeCaribbean", rmRandInt(6,9), 8.0);
		rmSetObjectDefMinDistance(tree4ID, 0.0);
	    rmSetObjectDefMaxDistance(tree4ID, 0.0);
  	    rmAddObjectDefConstraint(tree4ID, avoidTree);
		rmAddObjectDefConstraint(tree4ID, avoidCloseNatives);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.2, 0.7);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.3, 0.7);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.2, 0.8);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.3, 0.8);
		
		int tree5ID= rmCreateObjectDef("The Trees 5"); 
	    rmAddObjectDefItem(tree5ID, "treeCaribbean", rmRandInt(6,9), 8.0);
		rmSetObjectDefMinDistance(tree5ID, 0.0);
	    rmSetObjectDefMaxDistance(tree5ID, 0.0);
  	    rmAddObjectDefConstraint(tree5ID, avoidTree);
		rmAddObjectDefConstraint(tree5ID, avoidCloseNatives);
		rmPlaceObjectDefAtLoc(tree5ID, 0, 0.7, 0.2);
		rmPlaceObjectDefAtLoc(tree5ID, 0, 0.7, 0.3);
		rmPlaceObjectDefAtLoc(tree5ID, 0, 0.8, 0.2);
		rmPlaceObjectDefAtLoc(tree5ID, 0, 0.8, 0.3);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE NATIVES GOLD MINES: *********************************** //
/*================================================================================================================*/
        int gold1ID= rmCreateObjectDef("The Gold Mine 1"); 
	    rmAddObjectDefItem(gold1ID, "minegold", 1.0, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
	    rmSetObjectDefMaxDistance(gold1ID, 0.0);
  	    rmAddObjectDefConstraint(gold1ID, avoidGold);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.15, 0.75);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.75, 0.15);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.85, 0.25);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.25, 0.85);
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE DEERS OF THE NATIVES: *********************************** //
/*================================================================================================================*/		
		int deer1ID= rmCreateObjectDef("The Deer Herds 1"); 
	    rmAddObjectDefItem(deer1ID, "deer", rmRandInt(6,9), 7.0);
		rmSetObjectDefMinDistance(deer1ID, 0.0);
	    rmSetObjectDefMaxDistance(deer1ID, 0.0);
		rmSetObjectDefCreateHerd(deer1ID, true);
  	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.35, 0.75);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.75, 0.35);
		//rmPlaceObjectDefAtLoc(deer1ID, 0, 0.85, 0.25);
		//rmPlaceObjectDefAtLoc(deer1ID, 0, 0.25, 0.85);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS: ****************************************** //
/*================================================================================================================*/
        int nugget3ID= rmCreateObjectDef("The Nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1.0, 0.0);
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
  	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.25, 0.65);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.65, 0.25);
		//rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.85, 0.25);
		//rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.25, 0.85);		
/*================================================================================================================*/
// ***************************** DEFINE AND PLACE THE LAKE IN THE MIDDLE OF THE MAP: **************************** //
/*================================================================================================================*/		
		
		int lakeClass=rmDefineClass("lake");
        int lakeConstraint=rmCreateClassDistanceConstraint("lake vs. lake", rmClassID("lake"), 20.0);
        int Lake1ID=rmCreateArea("small lake 1");
		
		rmSetAreaSize(Lake1ID, 0.15, 0.15);
        rmSetAreaWarnFailure(Lake1ID, false);
        rmSetAreaSmoothDistance(Lake1ID, 10);		
		rmSetAreaWaterType(Lake1ID, "Caribbean Coast");
		//rmSetAreaElevationType(Lake1ID, cElevTurbulence);
		//rmSetAreaElevationVariation(Lake1ID, 6.0);
		rmSetAreaBaseHeight(Lake1ID, 5.0);
		//rmSetAreaElevationMinFrequency(Lake1ID, 0.05);
        //rmSetAreaElevationOctaves(Lake1ID, 3);
        //rmSetAreaElevationPersistence(Lake1ID, 0.3);      
        //rmSetAreaElevationNoiseBias(Lake1ID, 0.5);
        //rmSetAreaElevationEdgeFalloffDist(Lake1ID, 20.0);
		rmSetAreaCoherence(Lake1ID, 0.9);
		rmAddAreaToClass(Lake1ID, lakeClass);
		rmSetAreaLocation(Lake1ID, 0.50, 0.50);
		//rmSetAreaEdgeFilling(Lake1ID, 5);
		rmSetAreaHeightBlend(Lake1ID, 1);
	    rmSetAreaObeyWorldCircleConstraint(Lake1ID, false);
		rmAddAreaConstraint(Lake1ID, avoidCloseTree);
        //rmAddAreaConstraint(Lake1ID, avoidClose2Tree); 		
		rmBuildArea(Lake1ID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ************************************** DEFINE THE PLAYER STARTING STUFF ************************************** //
// ********************************** PLACE PLAYER TCS AND STARTING GOLD MINES: ********************************* //
/*================================================================================================================*/
        int TCID = rmCreateObjectDef("player TC");
	    if ( rmGetNomadStart())
		rmAddObjectDefItem(TCID, "coveredWagon", 1, 0);
	    else
		rmAddObjectDefItem(TCID, "townCenter", 1, 0);

	    // PREPARE TO PLACE TCS:
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    // rmSetObjectDefMaxDistance(TCID, 12.0);  // Originally 10.0 -- JSB -- Allows TC placement spot to float a bit along the lines I tell them to place. 
	       rmSetObjectDefMaxDistance(TCID, 0.0); 
		rmAddObjectDefConstraint(TCID, avoidImpassableLand);
	    rmAddObjectDefConstraint(TCID, avoidTC);
	    rmAddObjectDefConstraint(TCID, avoidCW);
    	
	    // PREPARE TO PLACE EXPLORERS, EXPLORER'S DOG, EXPLORER'S TAUN TAUN, ETC:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 9.0);
	    rmSetObjectDefMaxDistance(startingUnits, 18.0);
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
	    rmAddObjectDefConstraint(startingUnits, avoidImpassableLand);

	    // PREPARE TO PLACE PLAYER STARTING MINES: 
	    int playerGoldID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(playerGoldID, "minegold", 1, 0);
	    rmSetObjectDefMinDistance(playerGoldID, 12.0);
	    rmSetObjectDefMaxDistance(playerGoldID, 20.0);
	    rmAddObjectDefConstraint(playerGoldID, avoidAll);
        rmAddObjectDefConstraint(playerGoldID, avoidImpassableLand);

		// PREPARE TO PLACE PLAYER STARTING CRATES (MOSTLY FOOD)
	    int playerCrateID=rmCreateObjectDef("starting crates");
	    rmAddObjectDefItem(playerCrateID, "crateOfFood", rmRandInt(3,4), 4.0);
	    rmAddObjectDefItem(playerCrateID, "crateOfWood", 1, 6.0);
	    rmAddObjectDefItem(playerCrateID, "crateOfCoin", 1, 7.0);
	    rmSetObjectDefMinDistance(playerCrateID, 6);
	    rmSetObjectDefMaxDistance(playerCrateID, 10);
	    rmAddObjectDefConstraint(playerCrateID, avoidAll);
	    rmAddObjectDefConstraint(playerCrateID, shortAvoidImpassableLand);

	    // PREPARE TO PLACE PLAYER STARTING BERRIES:
	    int playerBerriesID=rmCreateObjectDef("player berries");
	    rmAddObjectDefItem(playerBerriesID, "berrybush", rmRandInt(4,6), 4.0);	//(X,X) - number of objects.  The last # is the range of distance around the center point that the objects will place.  Low means tight, higher means more widely scattered.
        rmSetObjectDefMinDistance(playerBerriesID, 21);
        rmSetObjectDefMaxDistance(playerBerriesID, 26);		
	    rmAddObjectDefConstraint(playerBerriesID, avoidAll);
        rmAddObjectDefConstraint(playerBerriesID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(playerBerriesID, true);

	    // PREPARE TO PLACE PLLAYER STARTING TURKEYS:
	    int playerTurkeyID=rmCreateObjectDef("player turkeys");
        rmAddObjectDefItem(playerTurkeyID, "turkey", rmRandInt(6,7), 4.0);	//(X,X) - number of objects.  The last # is the range of distance around the center point that the objects will place.  Low means tight, higher means more widely scattered.
        rmSetObjectDefMinDistance(playerTurkeyID, 14);
	    rmSetObjectDefMaxDistance(playerTurkeyID, 19);	
	    rmAddObjectDefConstraint(playerTurkeyID, avoidAll);
        rmAddObjectDefConstraint(playerTurkeyID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(playerTurkeyID, true);

	    // PREPARE TO PLACE PLAYER STARTING TREES:
	    int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeCaribbean", 1, 0.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidAll);    //This was just added to try to keep these trees from stomping on CW's.
	    rmSetObjectDefMinDistance(StartAreaTreeID, 13.0);	//changed from 12.0 
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 20.0);	//Changed from 19.0

	    // DEFINE WATER SPAWN POINT:
		int waterSpawnPointID = 0;
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************* PLACE HOME CITY WATER SPAWN FLAG: ************************************** //
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
   {
	    // PLACE TC AND STARTING UNITS:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));				
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));   
		rmPlaceObjectDefAtLoc(playerBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc))); 
		rmPlaceObjectDefAtLoc(playerTurkeyID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));  										
		rmPlaceObjectDefAtLoc(playerCrateID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

		// PLACE PLAYER STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE WATER SPAWN POINTS FOR THE PLAYERS:
		waterSpawnPointID=rmCreateObjectDef("colony ship "+i);
		rmAddObjectDefItem(waterSpawnPointID, "HomeCityWaterSpawnFlag", 1, 10.0);  // ...Flag", 1, 1.0); - the first number is the number of flags.  The next number is the float distance.
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		rmAddClosestPointConstraint(circleConstraint);
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
		rmPlaceObjectDefAtLoc(waterSpawnPointID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		
		// CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE MIDDLE LAKE: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 1: **************************************** //
/*================================================================================================================*/
        int nugget1ID= rmCreateObjectDef("The Nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
  	    rmAddObjectDefConstraint(nugget1ID, avoidCloseNugget);
  	    rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.15, 0.45);
        rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.45, 0.15);   
        rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.55, 0.85);   
        rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.85, 0.55); 
/*================================================================================================================*/
// ***************************** DEFINE AND PLACE THE TREES OF THE NUGGET 1: ************************************ //
/*================================================================================================================*/
        int tree6ID= rmCreateObjectDef("The Trees 6"); 
	    rmAddObjectDefItem(tree6ID, "treeCaribbean", rmRandInt(6,9), 8.0);
		rmSetObjectDefMinDistance(tree6ID, 0.0);
	    rmSetObjectDefMaxDistance(tree6ID, 0.0);
  	    rmAddObjectDefConstraint(tree6ID, avoidTree);
		rmAddObjectDefConstraint(tree6ID, avoidCloseNugget);
		rmPlaceObjectDefAtLoc(tree6ID, 0, 0.10, 0.40);
		rmPlaceObjectDefAtLoc(tree6ID, 0, 0.20, 0.40);
		rmPlaceObjectDefAtLoc(tree6ID, 0, 0.10, 0.50);
		rmPlaceObjectDefAtLoc(tree6ID, 0, 0.20, 0.50); 

        int tree7ID= rmCreateObjectDef("The Trees 7"); 
	    rmAddObjectDefItem(tree7ID, "treeCaribbean", rmRandInt(6,9), 8.0);
		rmSetObjectDefMinDistance(tree7ID, 0.0);
	    rmSetObjectDefMaxDistance(tree7ID, 0.0);
  	    rmAddObjectDefConstraint(tree7ID, avoidTree);
		rmAddObjectDefConstraint(tree7ID, avoidCloseNugget);
		rmPlaceObjectDefAtLoc(tree7ID, 0, 0.40, 0.10);
		rmPlaceObjectDefAtLoc(tree7ID, 0, 0.40, 0.20);
		rmPlaceObjectDefAtLoc(tree7ID, 0, 0.50, 0.10);
		rmPlaceObjectDefAtLoc(tree7ID, 0, 0.50, 0.20);

        int tree8ID= rmCreateObjectDef("The Trees 8"); 
	    rmAddObjectDefItem(tree8ID, "treeCaribbean", rmRandInt(6,9), 8.0);
		rmSetObjectDefMinDistance(tree8ID, 0.0);
	    rmSetObjectDefMaxDistance(tree8ID, 0.0);
  	    rmAddObjectDefConstraint(tree8ID, avoidTree);
		rmAddObjectDefConstraint(tree8ID, avoidCloseNugget);
		rmPlaceObjectDefAtLoc(tree8ID, 0, 0.50, 0.90);
		rmPlaceObjectDefAtLoc(tree8ID, 0, 0.60, 0.90);
		rmPlaceObjectDefAtLoc(tree8ID, 0, 0.50, 0.80);
		rmPlaceObjectDefAtLoc(tree8ID, 0, 0.60, 0.80); 

        int tree9ID= rmCreateObjectDef("The Trees 9"); 
	    rmAddObjectDefItem(tree9ID, "treeCaribbean", rmRandInt(6,9), 8.0);
		rmSetObjectDefMinDistance(tree9ID, 0.0);
	    rmSetObjectDefMaxDistance(tree9ID, 0.0);
  	    rmAddObjectDefConstraint(tree9ID, avoidTree);
		rmAddObjectDefConstraint(tree9ID, avoidCloseNugget);
		rmPlaceObjectDefAtLoc(tree9ID, 0, 0.90, 0.50);
		rmPlaceObjectDefAtLoc(tree9ID, 0, 0.90, 0.60);
		rmPlaceObjectDefAtLoc(tree9ID, 0, 0.80, 0.50);
		rmPlaceObjectDefAtLoc(tree9ID, 0, 0.80, 0.60);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// **************************** DEFINE AND PLACE THE GOLD MINES OF THE NUGGET 1 : ******************************* //
/*================================================================================================================*/
        int gold2ID= rmCreateObjectDef("The Gold Mine 2"); 
	    rmAddObjectDefItem(gold2ID, "minegold", 1.0, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
	    rmSetObjectDefMaxDistance(gold2ID, 0.0);
  	    rmAddObjectDefConstraint(gold2ID, avoidGold);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.05, 0.45);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.15, 0.35);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.45, 0.05);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.35, 0.15);

        int gold4ID= rmCreateObjectDef("The Gold Mine 4"); 
	    rmAddObjectDefItem(gold4ID, "minegold", 1.0, 0.0);
		rmSetObjectDefMinDistance(gold4ID, 0.0);
	    rmSetObjectDefMaxDistance(gold4ID, 0.0);
  	    rmAddObjectDefConstraint(gold4ID, avoidGold);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.95, 0.55);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.85, 0.65);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.55, 0.95);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.65, 0.85);
/*================================================================================================================*/		
// ******************************* DEFINE AND PLACE THE DEERS OF THE NUGGET 1: ********************************** //
/*================================================================================================================*/		
		int deer2ID= rmCreateObjectDef("The Deer Herds 2"); 
	    rmAddObjectDefItem(deer2ID, "deer", rmRandInt(6,9), 7.0);
		rmSetObjectDefMinDistance(deer2ID, 0.0);
	    rmSetObjectDefMaxDistance(deer2ID, 0.0);
		rmSetObjectDefCreateHerd(deer2ID, true);
  	    rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.15, 0.55);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.55, 0.15);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.85, 0.45);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.45, 0.85);	
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE FRUITS OF THE NUGGET 1: ********************************* //
/*================================================================================================================*/		
		int fruits1ID= rmCreateObjectDef("The BerryBush 1"); 
	    rmAddObjectDefItem(fruits1ID, "berrybush", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(fruits1ID, 0.0);
	    rmSetObjectDefMaxDistance(fruits1ID, 0.0);
  	    rmAddObjectDefConstraint(fruits1ID, avoidFruits);
		rmPlaceObjectDefAtLoc(fruits1ID, 0, 0.235, 0.435);
		rmPlaceObjectDefAtLoc(fruits1ID, 0, 0.435, 0.235);
		rmPlaceObjectDefAtLoc(fruits1ID, 0, 0.775, 0.55);
		rmPlaceObjectDefAtLoc(fruits1ID, 0, 0.55, 0.775);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE NUGGETS 2: *************************************** //
/*================================================================================================================*/		
		int nugget2ID= rmCreateObjectDef("The Nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
  	    rmAddObjectDefConstraint(nugget2ID, avoidCloseNugget);
  	    rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.175, 0.175);
        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.3, 0.3);   
        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.825, 0.825);   
        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.7, 0.7);
		
		int nugget4ID= rmCreateObjectDef("The Nugget 4"); 
	    rmAddObjectDefItem(nugget4ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget4ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget4ID, 0.0);
  	    rmAddObjectDefConstraint(nugget4ID, avoidCloseNugget);
  	    rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.725, 0.085);
        rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.085, 0.725);   
        rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.275, 0.915);   
        rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.915, 0.275);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE TREES FOR THE FORESTS: ********************************** //        
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int tree10ID= rmCreateObjectDef("The Trees 10"); 
	    rmAddObjectDefItem(tree10ID, "treeCaribbean", rmRandInt(15,25), 15.0);
		rmSetObjectDefMinDistance(tree10ID, 0.0);
	    rmSetObjectDefMaxDistance(tree10ID, 0.0);
  	    rmAddObjectDefConstraint(tree10ID, avoidTree);
		rmAddObjectDefConstraint(tree10ID, avoidCloseNugget);
		rmPlaceObjectDefAtLoc(tree10ID, 0, 0.15, 0.65);
		rmPlaceObjectDefAtLoc(tree10ID, 0, 0.65, 0.15);
		rmPlaceObjectDefAtLoc(tree10ID, 0, 0.35, 0.85);
		rmPlaceObjectDefAtLoc(tree10ID, 0, 0.85, 0.35);	

        int tree11ID= rmCreateObjectDef("The Trees 11"); 
	    rmAddObjectDefItem(tree11ID, "treeCaribbean", rmRandInt(10,15), 10.0);
		rmSetObjectDefMinDistance(tree11ID, 0.0);
	    rmSetObjectDefMaxDistance(tree11ID, 0.0);
  	    rmAddObjectDefConstraint(tree11ID, avoidTree);
		rmAddObjectDefConstraint(tree11ID, avoidCloseNugget);
		rmPlaceObjectDefAtLoc(tree11ID, 0, 0.05, 0.55);
		rmPlaceObjectDefAtLoc(tree11ID, 0, 0.55, 0.05);
		rmPlaceObjectDefAtLoc(tree11ID, 0, 0.45, 0.95);
		rmPlaceObjectDefAtLoc(tree11ID, 0, 0.95, 0.45);	

        int tree12ID= rmCreateObjectDef("The Trees 12"); 
	    rmAddObjectDefItem(tree12ID, "treeCaribbean", rmRandInt(8,12), 8.0);
		rmSetObjectDefMinDistance(tree12ID, 0.0);
	    rmSetObjectDefMaxDistance(tree12ID, 0.0);
  	    rmAddObjectDefConstraint(tree12ID, avoidTree);
		rmAddObjectDefConstraint(tree12ID, avoidCloseNugget);
		rmPlaceObjectDefAtLoc(tree12ID, 0, 0.225, 0.55);
		rmPlaceObjectDefAtLoc(tree12ID, 0, 0.55, 0.225);
		rmPlaceObjectDefAtLoc(tree12ID, 0, 0.45, 0.775);
		rmPlaceObjectDefAtLoc(tree12ID, 0, 0.775, 0.45);

        int tree13ID= rmCreateObjectDef("The Trees 13"); 
	    rmAddObjectDefItem(tree13ID, "treeCaribbean", rmRandInt(6,9), 6.0);
		rmSetObjectDefMinDistance(tree13ID, 0.0);
	    rmSetObjectDefMaxDistance(tree13ID, 0.0);
  	    rmAddObjectDefConstraint(tree13ID, avoidTree);
		rmAddObjectDefConstraint(tree13ID, avoidCloseNugget);
		rmPlaceObjectDefAtLoc(tree13ID, 0, 0.125, 0.225);
		rmPlaceObjectDefAtLoc(tree13ID, 0, 0.225, 0.125);
		rmPlaceObjectDefAtLoc(tree13ID, 0, 0.775, 0.875);
		rmPlaceObjectDefAtLoc(tree13ID, 0, 0.875, 0.775);

        int tree14ID= rmCreateObjectDef("The Trees 14"); 
	    rmAddObjectDefItem(tree14ID, "treeCaribbean", rmRandInt(6,9), 6.0);
		rmSetObjectDefMinDistance(tree14ID, 0.0);
	    rmSetObjectDefMaxDistance(tree14ID, 0.0);
  	    rmAddObjectDefConstraint(tree14ID, avoidTree);
		rmAddObjectDefConstraint(tree14ID, avoidCloseNugget);
		rmPlaceObjectDefAtLoc(tree14ID, 0, 0.25, 0.35);
		rmPlaceObjectDefAtLoc(tree14ID, 0, 0.35, 0.25);
		rmPlaceObjectDefAtLoc(tree14ID, 0, 0.65, 0.75);
		rmPlaceObjectDefAtLoc(tree14ID, 0, 0.75, 0.65);			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE SHEEPS: ***************************************** //
/*================================================================================================================*/
        int sheep1ID= rmCreateObjectDef("The Sheeps 1"); 
	    rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(5,9), 4.0);
		rmSetObjectDefMinDistance(sheep1ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep1ID, 0.0);
  	    rmAddObjectDefConstraint(sheep1ID, avoidSheep);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.65, 0.05);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.05, 0.65);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.95, 0.35);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.35, 0.95);	

        int sheep2ID= rmCreateObjectDef("The Sheeps 2"); 
	    rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(5,9), 4.0);
		rmSetObjectDefMinDistance(sheep2ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep2ID, 0.0);
  	    rmAddObjectDefConstraint(sheep2ID, avoidSheep);
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.35, 0.05);
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.05, 0.35);
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.95, 0.65);
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.65, 0.95);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FRUITS: ***************************************** //
/*================================================================================================================*/
        int fruits2ID= rmCreateObjectDef("The Fruits 2"); 
	    rmAddObjectDefItem(fruits2ID, "berrybush", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(fruits2ID, 0.0);
	    rmSetObjectDefMaxDistance(fruits2ID, 0.0);
  	    rmAddObjectDefConstraint(fruits2ID, avoidFruits);
		rmPlaceObjectDefAtLoc(fruits2ID, 0, 0.075, 0.3);
		rmPlaceObjectDefAtLoc(fruits2ID, 0, 0.3, 0.075);
		rmPlaceObjectDefAtLoc(fruits2ID, 0, 0.915, 0.7);
		rmPlaceObjectDefAtLoc(fruits2ID, 0, 0.7, 0.915);			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
//  ******************* DEFINE AND PLACE THE WHALES AS MUCH IN BIG WEST BAY ONLY AS POSSIBLE: ******************* //
/*================================================================================================================*/
	    int whaleID=rmCreateObjectDef("whale");
	    rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 0.0);
	    rmSetObjectDefMinDistance(whaleID, 0.0);
	    rmSetObjectDefMaxDistance(whaleID, 0.0);		
	    rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
	    rmAddObjectDefConstraint(whaleID, whaleLand);
	    rmPlaceObjectDefAtLoc(whaleID, 0, 0.575, 0.575);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.425, 0.425);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.425, 0.575);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.575, 0.425);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //
/*================================================================================================================*/
        int fishID=rmCreateObjectDef("fish Mahi");
	    rmAddObjectDefItem(fishID, "FishMahi", 3, 9.0);
	    rmSetObjectDefMinDistance(fishID, 0.0);
	    rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(fishID, fishVsFishID);
	    rmAddObjectDefConstraint(fishID, fishVsWhaleID);
	    rmAddObjectDefConstraint(fishID, fishLand);
	    rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}  
/*================================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*================================================================================================================*/



   


		
		
		


		
		
	
	
