/*================================================================================================================*/
// ********************************* THESE ARE THE INFORMATIONS OF THE MAP: ************************************* //
/*================================================================================================================*/

// TEST_002:
// CREATED BY DANY:
// OCTOBER 2007:

/*===============================================================================================================*/
// ******************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*===============================================================================================================*/

include "mercenaries.xs";
void main(void)
{

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/	

	    int whichVariation=-1;
	    whichVariation = rmRandInt(1,2);
	
/*----------------------------------------------------------------------------------------------------------------*/

	    int whichNative=rmRandInt(1,4);
		
	    if ( whichNative > 1 )
	{
		subCiv0=rmGetCivID("Iroquois");
		rmEchoInfo("subCiv0 is Iroquois "+subCiv0);

		subCiv1=rmGetCivID("Iroquois");
		rmEchoInfo("subCiv1 is Iroquois "+subCiv1);
		
		subCiv2=rmGetCivID("Iroquois");
		rmEchoInfo("subCiv2 is Iroquois "+subCiv2);
		
		subCiv3=rmGetCivID("Iroquois");
		rmEchoInfo("subCiv3 is Iroquois "+subCiv3);
	}
	    else
	{
		subCiv0=rmGetCivID("Cherokee");
		rmEchoInfo("subCiv0 is Cherokee "+subCiv0);

		subCiv1=rmGetCivID("Cherokee");
		rmEchoInfo("subCiv1 is Cherokee "+subCiv1);
		
		subCiv2=rmGetCivID("Cherokee");
		rmEchoInfo("subCiv2 is Cherokee "+subCiv2);
		
		subCiv3=rmGetCivID("Cherokee");
		rmEchoInfo("subCiv3 is Cherokee "+subCiv3);
	}

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// ********************************************* PICKS THE MAP SIZE: ******************************************** //		
/*----------------------------------------------------------------------------------------------------------------*/

   	    int playerTiles=25000;
        
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(632, 632);
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ************************************* DEFINE THE PARAMETERS OF THE MAP: ************************************** //
/*================================================================================================================*/
   
        // PICKS DEFAULT TERRAIN AND WATER:
        rmSetSeaType("new england coast");
	
	    // SOME MAP TURBULENCE:
	    // SET MAP ELEVATION PARAMETERS:
		rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);  // LIKE TEXAS FOR THE MOMENT:
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(0.2);

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(4.0);
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
        
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("water");
	   
        // SET MAP TYPE:
        rmSetMapType("newEngland");
	    rmSetMapType("water");
	    rmSetMapType("grass");
		
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(2.0);
	    
		// SET LIGHTING:
		rmSetLightingSet("new england");
		
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
		
		// CHOOSE THE MERCS:
	    chooseMercs();
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.125);
/*================================================================================================================*/
// ******************************************* DEFINE SOME CLASSES: ********************************************* //
// ************************************ THESE ARE USED LATER FOR CONSTRAINTS: *********************************** //
/*================================================================================================================*/
   
        int classPlayer=rmDefineClass("player");
        rmDefineClass("classCliff");
        rmDefineClass("classWall");
        int classbigContinent=rmDefineClass("big continent");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("socketClass");
	    rmDefineClass("nuggets");
		rmDefineClass("natives");
		rmDefineClass("classTrees");
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************ //
/*================================================================================================================*/
   
    // MAP EDGE CONSTRAINTS:
    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
    
    // PLAYER CONSTRAINTS:
    int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 15.0);
    int playerCloseConstraint=rmCreateClassDistanceConstraint("close vs. player", classPlayer, 8.0);
        
    // CARDINAL DIRECTIONS:
	int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(180));
	int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(270), rmDegreesToRadians(45));
	
    // RESOURCE AVOIDANCE:
    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 30.0);
    int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 10.0);
	
	// SHEEP AVOIDANCE:
	int avoidDeer=rmCreateTypeDistanceConstraint("food avoids food", "deer", 45.0);
	int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids food", "deer", 8.0);
	int avoidMediumDeer=rmCreateTypeDistanceConstraint("medium avoids food", "deer", 25.0);
	
	// BERRYBUSH AVOIDANCE:
	int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids berrybush", "BerryBush", 25.0);
	int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids berrybush", "BerryBush", 15.0);
	int avoidVeryFruits=rmCreateTypeDistanceConstraint("very close avoids berrybush", "BerryBush", 8.0);
	int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoids berrybush", "BerryBush", 35.0);
	int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoids berrybush", "BerryBush", 60.0);
	int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoids berrybush", "BerryBush", 90.0);
	
	// COIN AVOIDANCE:
	int avoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 15);
	int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoids coin", "gold", 8);
	int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium avoids coin", "gold", 35);
	int avoidFarCoin=rmCreateTypeDistanceConstraint("far avoids coin", "gold", 50);
	int avoidVeryFarCoin=rmCreateTypeDistanceConstraint("very far avoids coin", "gold", 90);
    
	// NUGGET AVOIDANCE:
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 35.0);
	int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 8.0);
	int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far avoid nugget", "AbstractNugget", 75.0);
    int avoidPlayerNugget=rmCreateTypeDistanceConstraint("player nugget avoid nugget", "AbstractNugget", 20.0);
    int avoidNuggetSmall=rmCreateTypeDistanceConstraint("nugget avoid nugget small", "AbstractNugget", 10.0);

    // AVOID IMPASSABLE LAND:
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
	int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close impassable land", "Land", false, 5.0);
	
	// CLIFFS AVOIDANCE:
	int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 15.0);
	int avoidCloseCliffs=rmCreateClassDistanceConstraint("close stuff vs. cliff", rmClassID("classCliff"), 8.0);
	int avoidVeryCloseCliffs=rmCreateClassDistanceConstraint("very close stuff vs. cliff", rmClassID("classCliff"), 2.0);
	int avoidMediumCliffs=rmCreateClassDistanceConstraint("medium stuff vs. cliff", rmClassID("classCliff"), 25.0);
	int avoidFarCliffs=rmCreateClassDistanceConstraint("far stuff vs. cliff", rmClassID("classCliff"), 50.0);
	int avoidVeryFarCliffs=rmCreateClassDistanceConstraint("very far stuff vs. cliff", rmClassID("classCliff"), 75.0);
		
	// WALL AVOIDANCE:
	int wallConstraint=rmCreateClassDistanceConstraint("wall vs. wall", rmClassID("classWall"), 40.0);
	
	// SHEEP AVOIDANCE:
	int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 15.0);
	int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 8.0);
	int avoidVeryFarSheep=rmCreateTypeDistanceConstraint("very far avoids sheep", "sheep", 75.0);
    	
	// TREES AVOIDANCE:
	int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 15.0);
	int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 8.0);
	int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 3.0);
	int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
	int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
	int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);

    // UNIT AVOIDANCE:
    int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 25.0);
    int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 8.0);

    // DECORATION AVOIDANCE:
    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

    // VP AVOIDANCE:
	// TRADE ROUTE AVOIDANCE:
    int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 12.0);
	int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 6.0);
   
    // IMPORTANT ITEM AVOIDANCE:
	int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 30.0);
	
	// SOCKET AVOIDANCE:
	int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 12.0);
	int avoidCloseSocket=rmCreateClassDistanceConstraint("close avoid sockets", rmClassID("socketClass"), 6.0);
	
	// NATIVES AVOIDANCE:
	int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
	int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 8.0);
	int avoidVeryCloseNatives=rmCreateClassDistanceConstraint("very close avoids natives", rmClassID("natives"), 2.0);
	int avoidMediumNatives=rmCreateClassDistanceConstraint("medium avoids natives", rmClassID("natives"), 25.0);
	int avoidFarNatives=rmCreateClassDistanceConstraint("far avoids natives", rmClassID("natives"), 50.0);
	int avoidVeryFarNatives=rmCreateClassDistanceConstraint("very far avoids natives", rmClassID("natives"), 75.0);

    // CONSTRAINT TO AVOID WATER:
    int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
    int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water 15", "Land", false, 15.0);
    int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
	int avoidWater25 = rmCreateTerrainDistanceConstraint("avoid water medium 25", "Land", false, 25.0);
    int avoidWater30 = rmCreateTerrainDistanceConstraint("avoid water mid-long", "Land", false, 30.0);
    int avoidWater40 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 40.0);

    // NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
	int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

	// CIRCLE CONSTRAINT:
	int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.175);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE BIG CONTINENT: ***************************************** //
/*================================================================================================================*/

	    // BUILD UP BIG CONTINENT - CALLED, UNORIGINALLY ENOUGH, "BIG CONTINENT":
        int bigContinentID=rmCreateArea("big continent");
        rmSetAreaSize(bigContinentID, 0.55, 0.55);		// 0.65, 0.65
        rmSetAreaWarnFailure(bigContinentID, false);
        rmAddAreaConstraint(bigContinentID, playerConstraint);
        rmAddAreaToClass(bigContinentID, classbigContinent);
        rmSetAreaSmoothDistance(bigContinentID, 25);
	    rmSetAreaMix(bigContinentID, "newengland_grass");
        rmSetAreaElevationType(bigContinentID, cElevTurbulence);
        rmSetAreaElevationVariation(bigContinentID, 4.0);
        rmSetAreaBaseHeight(bigContinentID, 6.0);
        rmSetAreaElevationMinFrequency(bigContinentID, 0.09);
        rmSetAreaElevationOctaves(bigContinentID, 3);
        rmSetAreaElevationPersistence(bigContinentID, 0.2);      
	    rmSetAreaCoherence(bigContinentID, 1.0);
	    //rmSetAreaLocation(bigContinentID, 0.5, 0.85);
		rmSetAreaLocation(bigContinentID, 0.675, 0.675);
        rmSetAreaEdgeFilling(bigContinentID, 5);
	    rmSetAreaObeyWorldCircleConstraint(bigContinentID, false);
	    rmBuildArea(bigContinentID);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ******************** BUILD UP SMALL CONTINENT SPURS CALLED "SMALL CONTINENT SPUR 1 & 2": ********************* //
/*================================================================================================================*/

        int smallContinent1ID=rmCreateArea("small continent spur 1");
        //rmSetAreaSize(smallContinent1ID, 0.2, 0.2);
		rmSetAreaSize(smallContinent1ID, 0.225, 0.225);
        rmSetAreaWarnFailure(smallContinent1ID, false);
        rmAddAreaConstraint(smallContinent1ID, playerConstraint);
        rmAddAreaToClass(smallContinent1ID, classbigContinent);
        rmSetAreaSmoothDistance(smallContinent1ID, 25);
	    rmSetAreaMix(smallContinent1ID, "newengland_grass");
		//rmSetAreaMix(smallContinent1ID, "rockies_snow");
        rmSetAreaElevationType(smallContinent1ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallContinent1ID, 4.0);
        rmSetAreaBaseHeight(smallContinent1ID, 6.0);
        rmSetAreaElevationMinFrequency(smallContinent1ID, 0.09);
        rmSetAreaElevationOctaves(smallContinent1ID, 3);
        rmSetAreaElevationPersistence(smallContinent1ID, 0.2);      
	    rmSetAreaCoherence(smallContinent1ID, 0.85);
	    //rmSetAreaLocation(smallContinent1ID, 0.8, 0.6);
		rmSetAreaLocation(smallContinent1ID, 0.70, 0.30);
        //rmSetAreaEdgeFilling(smallContinent1ID, 5);
        rmSetAreaObeyWorldCircleConstraint(smallContinent1ID, false);
	    rmBuildArea(smallContinent1ID);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.225);
/*================================================================================================================*/   
// ********************* BUILD UP SMALL CONTINENT SPURS CALLED "SMALL CONTINENT SPUR 1 & 2": ******************** //
/*================================================================================================================*/

        int smallContinent2ID=rmCreateArea("small continent spur 2");
        //rmSetAreaSize(smallContinent2ID, 0.2, 0.2);
		rmSetAreaSize(smallContinent2ID, 0.225, 0.225);
        rmSetAreaWarnFailure(smallContinent2ID, false);
        rmAddAreaConstraint(smallContinent2ID, playerConstraint);
        rmAddAreaToClass(smallContinent2ID, classbigContinent);
        rmSetAreaSmoothDistance(smallContinent2ID, 25);
	    rmSetAreaMix(smallContinent2ID, "newengland_grass");
		//rmSetAreaMix(smallContinent2ID, "texas_dirt");
        rmSetAreaElevationType(smallContinent2ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallContinent2ID, 4.0);
        rmSetAreaBaseHeight(smallContinent2ID, 6.0);
        rmSetAreaElevationMinFrequency(smallContinent2ID, 0.09);
        rmSetAreaElevationOctaves(smallContinent2ID, 3);
        rmSetAreaElevationPersistence(smallContinent2ID, 0.2);      
	    rmSetAreaCoherence(smallContinent2ID, 0.85);
	    //rmSetAreaLocation(smallContinent2ID, 0.2, 0.6);
		rmSetAreaLocation(smallContinent2ID, 0.30, 0.70);
        //rmSetAreaEdgeFilling(smallContinent2ID, 5);
        rmSetAreaObeyWorldCircleConstraint(smallContinent2ID, false);
	    rmBuildArea(smallContinent2ID);
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// *************************************** SET UP THE PLAYER LOCATIONS: ***************************************** //	
/*================================================================================================================*/

	    if ( whichVariation == 1 )
	{
		rmSetPlacementTeam(0);
		rmPlacePlayersLine(0.225, 0.625, 0.375, 0.775, 0.0, 0.0);
		
		rmSetPlacementTeam(1);
		rmPlacePlayersLine(0.625, 0.225, 0.775, 0.375, 0.0, 0.0);
	}
	    else
	{
	   rmSetPlacementTeam(0);
	   rmPlacePlayersLine(0.625, 0.225, 0.775, 0.375, 0.0, 0.0); 
	   
	   rmSetPlacementTeam(1);
	   rmPlacePlayersLine(0.225, 0.625, 0.375, 0.775, 0.0, 0.0);
	}
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(1750);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
      
	    // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		// rmAddAreaConstraint(id, playerConstraint); 
        // rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
	
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "texas_dirt");
		
		//rmSetAreaMix(id, "rockies_grass");
	
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "rockies\groundsnow1_roc");
	
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");
    
		// SET AREA BASE HEIGHT:
		//rmSetAreaBaseHeight(id, 18.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.325);
/*================================================================================================================*/   
   // Placement order
   // Trade route -> Lakes -> Natives -> Secrets -> Cliffs -> Nuggets
   // Text
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE TRADE ROUTES: ************************************* //   
/*================================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // CLEAR OUT CONSTRAINS FOR GOOD MEASURE:
        rmClearClosestPointConstraints();
   
/*----------------------------------------------------------------------------------------------------------------*/   

	    // SOCKET DEFINITION:
	    int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 8.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // TRADE ROUTE 1:
		int tradeRoute1ID = rmCreateTradeRoute();
	    rmAddTradeRouteWaypoint(tradeRoute1ID, 0.835, 0.835);
		//rmAddTradeRouteWaypoint(tradeRoute1ID, 0.725, 0.725);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.40, 0.40);
	
	    bool placedTradeRoute1 = rmBuildTradeRoute(tradeRoute1ID, "dirt");
	    if(placedTradeRoute1 == false)
		rmEchoError("Failed to place trade route one");

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute1ID);
	    vector socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);

	    socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.50);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.975);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
  
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// ******************************* DEFINE AND PLACE THE NATIVE AMERICAN TRIBES: ********************************* //
/*================================================================================================================*/

        float NativeVillageLoc = rmRandFloat(0,1);
     
        // IROQUOIS ARE ALWAYS ON THE MAINLAND:
        int iroquoisVillageAID = -1;
        int iroquoisVillageType = rmRandInt(1,3);
        if ( whichNative > 1 )
   {
		iroquoisVillageAID = rmCreateGrouping("iroquois village A", "native iroquois village "+iroquoisVillageType);
   }
        else
   {
	   	iroquoisVillageAID = rmCreateGrouping("cherokee village A", "native cherokee village "+iroquoisVillageType);
   }
        rmSetGroupingMinDistance(iroquoisVillageAID, 0.0);
        rmSetGroupingMaxDistance(iroquoisVillageAID, 0.0);
        rmAddGroupingConstraint(iroquoisVillageAID, avoidImpassableLand);
        rmAddGroupingToClass(iroquoisVillageAID, rmClassID("natives"));
        rmAddGroupingConstraint(iroquoisVillageAID, avoidTradeRoute);

		rmPlaceGroupingAtLoc(iroquoisVillageAID, 0, 0.80, 0.20); // used to be 0.3 DAL

/*----------------------------------------------------------------------------------------------------------------*/
	
	    int iroquoisVillageBID = -1;
	    iroquoisVillageType = rmRandInt(1,3);
	    if ( whichNative > 1 )
	{
		iroquoisVillageBID = rmCreateGrouping("iroquois village B", "native iroquois village "+iroquoisVillageType);
	}
	    else
	{
		iroquoisVillageBID = rmCreateGrouping("cherokee village B", "native cherokee village "+iroquoisVillageType);
	}
	    rmSetGroupingMinDistance(iroquoisVillageBID, 0.0);
	    rmSetGroupingMaxDistance(iroquoisVillageBID, 0.0);
	    rmAddGroupingConstraint(iroquoisVillageBID, avoidImpassableLand);
	    rmAddGroupingToClass(iroquoisVillageBID, rmClassID("natives"));
	    rmAddGroupingConstraint(iroquoisVillageBID, avoidTradeRoute);
	
	    rmPlaceGroupingAtLoc(iroquoisVillageBID, 0, 0.20, 0.80); // used to be 0.7 DAL
	
/*----------------------------------------------------------------------------------------------------------------*/
	
	    int iroquoisVillageCID = -1;
	    iroquoisVillageType = rmRandInt(1,3);
	    if ( whichNative > 1 )
	{
		iroquoisVillageCID = rmCreateGrouping("iroquois village C", "native iroquois village "+iroquoisVillageType);
	}
	    else
	{
		iroquoisVillageCID = rmCreateGrouping("cherokee village C", "native cherokee village "+iroquoisVillageType);
	}
	    rmSetGroupingMinDistance(iroquoisVillageCID, 0.0);
	    rmSetGroupingMaxDistance(iroquoisVillageCID, 0.0);
	    rmAddGroupingConstraint(iroquoisVillageCID, avoidImpassableLand);
	    rmAddGroupingToClass(iroquoisVillageCID, rmClassID("natives"));
	    rmAddGroupingConstraint(iroquoisVillageCID, avoidTradeRoute);
	
	    rmPlaceGroupingAtLoc(iroquoisVillageCID, 0, 0.50, 0.90); // used to be 0.7 DAL
		
/*----------------------------------------------------------------------------------------------------------------*/
	
	    int iroquoisVillageDID = -1;
	    iroquoisVillageType = rmRandInt(1,3);
	    if ( whichNative > 1 )
	{
		iroquoisVillageDID = rmCreateGrouping("iroquois village D", "native iroquois village "+iroquoisVillageType);
	}
	    else
	{
		iroquoisVillageDID = rmCreateGrouping("cherokee village D", "native cherokee village "+iroquoisVillageType);
	}
	    rmSetGroupingMinDistance(iroquoisVillageDID, 0.0);
	    rmSetGroupingMaxDistance(iroquoisVillageDID, 0.0);
	    rmAddGroupingConstraint(iroquoisVillageDID, avoidImpassableLand);
	    rmAddGroupingToClass(iroquoisVillageDID, rmClassID("natives"));
	    rmAddGroupingConstraint(iroquoisVillageDID, avoidTradeRoute);
	
	    rmPlaceGroupingAtLoc(iroquoisVillageDID, 0, 0.90, 0.50); // used to be 0.7 DAL		
	   	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// ************************* DEFINE THE TCID AND THE STARTING UNITS AND THE RESOURCES: ************************** // 	
/*================================================================================================================*/

        // DEFINE THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);

	    // DEFINE THE TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	   	rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 0.0);
		rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE VARIABLES NEEDED FOR THE PLAYER GOLD:
		int silverType = -1;
	    int playerGoldID = -1;

	    // DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeNewEngland", 5, 8.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 15.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 30.0);
		rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	    // DEFINE THE BERRYBUSH:
		int StartBerryBushID=rmCreateObjectDef("starting BerryBush");
	    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 5.0);
		rmAddObjectDefToClass(StartBerryBushID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(StartBerryBushID, 20.0);
	    rmSetObjectDefMaxDistance(StartBerryBushID, 25.0);
		rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
		rmAddObjectDefConstraint(StartBerryBushID, avoidFruits);

	    // DEFINE THE PLAYER NUGGETS:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 25.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 27.5);
	    rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	    rmAddObjectDefConstraint(playerNuggetID, avoidPlayerNugget);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    // rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

	    // DEFINE THE VARIABLE NEEDED FOR THE WATER FLAG:
		int waterFlagID=-1;
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.475);
/*================================================================================================================*/   
// ************************** PLACE THE TCID AND THE STARTING UNITS AND THE RESOURCES: ************************** // 	
/*================================================================================================================*/
	
	    for(i=1; <cNumberPlayers)
	{
		rmClearClosestPointConstraints();
		
		// PLACE THE TCID AND THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// EVERYONE GETS ONE ORE GROUPING CLOSE BY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		//rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
	}
        else
    {		
		rmAddObjectDefItem(playerGoldID, "minegold", 1, 0.0);
	}	
		
		// rmAddGroupingToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefToClass(playerGoldID, rmClassID("startingUnit"));
		rmAddObjectDefConstraint(playerGoldID, avoidMediumCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING STARTING PRONGHORNS:
		/*
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		*/
		
		// PLACE THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// DEFINE THE WATER FLAG:
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		// PLACE THE WATER FLAG:
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		
		rmClearClosestPointConstraints();
	}

/*================================================================================================================*/   
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/

	    // THE WEST NUGGETS:
		int nuggetID= rmCreateObjectDef("The West Nuggets"); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nuggetID, avoidCloseImpassableLand);
  	    rmAddObjectDefConstraint(nuggetID, avoidVeryFarNugget);
	    rmAddObjectDefConstraint(nuggetID, playerCloseConstraint);
		rmAddObjectDefConstraint(nuggetID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nuggetID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(nuggetID, avoidCloseSocket);
		rmAddObjectDefConstraint(nuggetID, avoidCloseNatives);
  	    rmAddObjectDefConstraint(nuggetID, avoidAll);
  	    rmAddObjectDefConstraint(nuggetID, avoidWater20);
	    rmAddObjectDefConstraint(nuggetID, Westward);
	    rmSetNuggetDifficulty(2, 3);
	    rmPlaceObjectDefInArea(nuggetID, 0, bigContinentID, cNumberNonGaiaPlayers*3);
		
/*----------------------------------------------------------------------------------------------------------------*/
		
		// THE EAST NUGGETS:
		int nugget2ID= rmCreateObjectDef("The East Nuggets"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget2ID, avoidCloseImpassableLand);
  	    rmAddObjectDefConstraint(nugget2ID, avoidVeryFarNugget);
	    rmAddObjectDefConstraint(nugget2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(nugget2ID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nugget2ID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(nugget2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(nugget2ID, avoidCloseNatives);
  	    rmAddObjectDefConstraint(nugget2ID, avoidAll);
  	    rmAddObjectDefConstraint(nugget2ID, avoidWater20);
	    rmAddObjectDefConstraint(nugget2ID, Eastward);
	    rmSetNuggetDifficulty(2, 3);
	    rmPlaceObjectDefInArea(nugget2ID, 0, bigContinentID, cNumberNonGaiaPlayers*3);
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //
/*================================================================================================================*/
   
        // THE CONSTRAINTS FOR THE FISHES AND THE WHALES:
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 12.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 75.0);
		int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
   
/*----------------------------------------------------------------------------------------------------------------*/   

        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishCod", 3, 6.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);
          
/*----------------------------------------------------------------------------------------------------------------*/   

	    // FAST COIN -- WHALES
	    int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "minkeWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 2.5*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 1.25*cNumberNonGaiaPlayers);
        

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// ****************************** PLACE RESOURCES THAT WE WANT FORESTS TO AVOID: ******************************** //
/*================================================================================================================*/   
 
        // PLACE RESOURCES THAT WE WANT FORESTS TO AVOID:
	    // THESE ARE THE FAST COIN:
	    int silverID = -1;
		int silver2ID = -1;
		
		if (cNumberNonGaiaPlayers<=2)
		int silverCount = cNumberNonGaiaPlayers*2.5;	// 5 per player, plus starting one.
		else
		silverCount = cNumberNonGaiaPlayers*1.5;	// 3 per player, plus starting one.
	    
		rmEchoInfo("silver count = "+silverCount);
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    // THE WESTERN COINS:
		for(i=0; < silverCount)
	{
		silverType = rmRandInt(1,10);
		silverID = rmCreateObjectDef("silver "+i);
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(silverID, "mine", 1, 0.0);
	}
        else
    {		
		rmAddObjectDefItem(silverID, "minegold", 1, 0.0);
	}	
		
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));

		//rmAddObjectDefConstraint(silverID, avoidFastCoin);
		rmAddObjectDefConstraint(silverID, avoidVeryFarCoin);
		rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, Westward);
		rmAddObjectDefConstraint(silverID, avoidCloseNatives);
		rmAddObjectDefConstraint(silverID, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(silverID, avoidCloseSocket);
		rmAddObjectDefConstraint(silverID, playerCloseConstraint);
		rmAddObjectDefConstraint(silverID, playerEdgeConstraint);
		rmAddObjectDefConstraint(silverID, avoidNugget);
		// KEEP SILVER AWAY FROM THE WATER, TO AVOID THE ART PROBLEM WITH THE "CLIFFS"
		rmAddObjectDefConstraint(silverID, avoidWater30);
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }
   
/*----------------------------------------------------------------------------------------------------------------*/

        // THE EASTERN COINS: 
		for(i=0; < silverCount)
	{
		silverType = rmRandInt(1,10);
		silver2ID = rmCreateObjectDef("silver 2"+i);
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(silver2ID, "mine", 1, 0.0);
	}
        else
    {		
		rmAddObjectDefItem(silver2ID, "minegold", 1, 0.0);
	}	
		
		rmSetObjectDefMinDistance(silver2ID, 0.0);
		rmSetObjectDefMaxDistance(silver2ID, rmXFractionToMeters(0.5));

		//rmAddObjectDefConstraint(silver2ID, avoidFastCoin);
		rmAddObjectDefConstraint(silver2ID, avoidVeryFarCoin);
		rmAddObjectDefConstraint(silver2ID, avoidAll);
		rmAddObjectDefConstraint(silver2ID, Eastward);
		rmAddObjectDefConstraint(silver2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(silver2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(silver2ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(silver2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(silver2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(silver2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(silver2ID, avoidNugget);
		// KEEP SILVER AWAY FROM THE WATER, TO AVOID THE ART PROBLEM WITH THE "CLIFFS"
		rmAddObjectDefConstraint(silver2ID, avoidWater30);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.5, 0.5);
   }   

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/   
// **************************************** DEFINE AND PLACE THE FORESTS: *************************************** //   
/*================================================================================================================*/

        int forestTreeID = 0;
		
		if (cNumberNonGaiaPlayers <= 2)
		int numTries=6*cNumberNonGaiaPlayers;
	    else
		numTries=3*cNumberNonGaiaPlayers;
	      
        int failCount=0;
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // THE WESTERN FORESTS:
		for (i=0; <numTries)
   {   
        int forest=rmCreateArea("forest "+i, rmAreaID("big continent"));
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(200), rmAreaTilesToFraction(250));
        rmSetAreaForestType(forest, "new england forest");
        rmSetAreaForestDensity(forest, 1.0);
        rmSetAreaForestClumpiness(forest, 0.9);
        rmSetAreaForestUnderbrush(forest, 0.0);
        rmSetAreaCoherence(forest, 0.4);
        rmSetAreaSmoothDistance(forest, 10);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
		rmAddAreaConstraint(forest, Westward);
		rmAddAreaConstraint(forest, avoidCloseNatives);
		rmAddAreaConstraint(forest, avoidCloseNugget);
		rmAddAreaConstraint(forest, avoidCoin);
		rmAddAreaConstraint(forest, avoidWater20);
		rmAddAreaConstraint(forest, playerEdgeConstraint);
        rmAddAreaConstraint(forest, avoidImpassableLand); 
        rmAddAreaConstraint(forest, avoidTradeRoute);
	    rmAddAreaConstraint(forest, playerCloseConstraint);
		rmAddAreaConstraint(forest, avoidSocket);
        if(rmBuildArea(forest)==false)
      {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
   } 
   
/*----------------------------------------------------------------------------------------------------------------*/
        
        // THE EASTERN FORESTS:
		for (i=0; <numTries)
   {   
        int forest2=rmCreateArea("forest 2"+i, rmAreaID("big continent"));
        rmSetAreaWarnFailure(forest2, false);
        rmSetAreaSize(forest2, rmAreaTilesToFraction(200), rmAreaTilesToFraction(250));
        rmSetAreaForestType(forest2, "new england forest");
        rmSetAreaForestDensity(forest2, 1.0);
        rmSetAreaForestClumpiness(forest2, 0.9);
        rmSetAreaForestUnderbrush(forest2, 0.0);
        rmSetAreaCoherence(forest2, 0.4);
        rmSetAreaSmoothDistance(forest2, 10);
        rmAddAreaToClass(forest2, rmClassID("classForest")); 
        rmAddAreaConstraint(forest2, forestConstraint);
        rmAddAreaConstraint(forest2, avoidAll);
		rmAddAreaConstraint(forest2, Eastward);
		rmAddAreaConstraint(forest2, avoidCloseNatives);
		rmAddAreaConstraint(forest2, avoidCloseNugget);
		rmAddAreaConstraint(forest2, avoidCoin);
		rmAddAreaConstraint(forest2, avoidWater20);
		rmAddAreaConstraint(forest2, playerEdgeConstraint);
        rmAddAreaConstraint(forest2, avoidImpassableLand); 
        rmAddAreaConstraint(forest2, avoidTradeRoute);
	    rmAddAreaConstraint(forest2, playerCloseConstraint);
		rmAddAreaConstraint(forest2, avoidSocket);
        if(rmBuildArea(forest2)==false)
      {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
   }    
 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE DEER HERDS: ************************************** //   
/*================================================================================================================*/

        // THE WESTERN DEER HERDS:
		int deerID=rmCreateObjectDef("deer herd 1");
	    int bonusChance=rmRandFloat(0, 1);
   
	    if(bonusChance<0.5)
        rmAddObjectDefItem(deerID, "deer", rmRandInt(6,8), 4.0);
        else
        rmAddObjectDefItem(deerID, "deer", rmRandInt(7,9), 6.0);

        rmSetObjectDefMinDistance(deerID, 0.0);
        rmSetObjectDefMaxDistance(deerID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(deerID, avoidDeer);
	    rmAddObjectDefConstraint(deerID, avoidAll);
		rmAddObjectDefConstraint(deerID, Westward);
		rmAddObjectDefConstraint(deerID, avoidNatives);
		rmAddObjectDefConstraint(deerID, avoidCloseCoin);
		rmAddObjectDefConstraint(deerID, avoidCloseNugget);
		rmAddObjectDefConstraint(deerID, avoidWater20);
		rmAddObjectDefConstraint(deerID, avoidCloseNatives);
	    rmAddObjectDefConstraint(deerID, avoidCloseSocket);
	    rmAddObjectDefConstraint(deerID, avoidCloseTradeRoute);
        rmAddObjectDefConstraint(deerID, avoidImpassableLand);
        rmAddObjectDefConstraint(deerID, playerCloseConstraint);
	    rmSetObjectDefCreateHerd(deerID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefInArea(deerID, 0, bigContinentID, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefInArea(deerID, 0, bigContinentID, cNumberNonGaiaPlayers*1.0);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE EASTERN DEER HERDS:
		int deer2ID=rmCreateObjectDef("deer herd 2");
	    bonusChance=rmRandFloat(0, 1);
   
	    if(bonusChance<0.5)
        rmAddObjectDefItem(deer2ID, "deer", rmRandInt(6,8), 4.0);
        else
        rmAddObjectDefItem(deer2ID, "deer", rmRandInt(7,9), 6.0);

        rmSetObjectDefMinDistance(deer2ID, 0.0);
        rmSetObjectDefMaxDistance(deer2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(deer2ID, avoidDeer);
	    rmAddObjectDefConstraint(deer2ID, avoidAll);
		rmAddObjectDefConstraint(deer2ID, Eastward);
		rmAddObjectDefConstraint(deer2ID, avoidNatives);
		rmAddObjectDefConstraint(deer2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(deer2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(deer2ID, avoidWater20);
		rmAddObjectDefConstraint(deer2ID, avoidCloseNatives);
	    rmAddObjectDefConstraint(deer2ID, avoidCloseSocket);
	    rmAddObjectDefConstraint(deer2ID, avoidCloseTradeRoute);
        rmAddObjectDefConstraint(deer2ID, avoidImpassableLand);
        rmAddObjectDefConstraint(deer2ID, playerCloseConstraint);
	    rmSetObjectDefCreateHerd(deer2ID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefInArea(deer2ID, 0, bigContinentID, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefInArea(deer2ID, 0, bigContinentID, cNumberNonGaiaPlayers*1.0);
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*===============================================================================================================*/
// ************************************* DEFINE AND PLACE THE SHEEP HERDS: ************************************** //	
/*================================================================================================================*/

	    // THE WESTERN SHEEP HERDS:
		int sheepID=rmCreateObjectDef("sheep");
	    rmAddObjectDefItem(sheepID, "sheep", 2, 4.0);
	    rmSetObjectDefMinDistance(sheepID, 0.0);
	    rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(sheepID, avoidVeryFarSheep);
	    rmAddObjectDefConstraint(sheepID, avoidAll);
		rmAddObjectDefConstraint(sheepID, Westward);
		rmAddObjectDefConstraint(sheepID, avoidNatives);
		rmAddObjectDefConstraint(sheepID, avoidCloseCoin);
		rmAddObjectDefConstraint(sheepID, avoidCloseNugget);
		rmAddObjectDefConstraint(sheepID, avoidCloseNatives);
	    rmAddObjectDefConstraint(sheepID, avoidCloseSocket);
	    rmAddObjectDefConstraint(sheepID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(sheepID, playerCloseConstraint);
	    rmAddObjectDefConstraint(sheepID, avoidWater20);
	    rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
		
		rmSetObjectDefCreateHerd(sheepID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE EASTERN SHEEP HERDS:
		int sheep2ID=rmCreateObjectDef("sheep 2");
	    rmAddObjectDefItem(sheep2ID, "sheep", 2, 4.0);
	    rmSetObjectDefMinDistance(sheep2ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep2ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(sheep2ID, avoidVeryFarSheep);
	    rmAddObjectDefConstraint(sheep2ID, avoidAll);
		rmAddObjectDefConstraint(sheep2ID, Eastward);
		rmAddObjectDefConstraint(sheep2ID, avoidNatives);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseNatives);
	    rmAddObjectDefConstraint(sheep2ID, avoidCloseSocket);
	    rmAddObjectDefConstraint(sheep2ID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(sheep2ID, playerCloseConstraint);
	    rmAddObjectDefConstraint(sheep2ID, avoidWater20);
	    rmAddObjectDefConstraint(sheep2ID, avoidImpassableLand);
		
		rmSetObjectDefCreateHerd(sheep2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);		
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// ********************************** SILLY ROCK WALLS CAN GET PLACED LAST: ************************************* //
// ****************************************** MAY NOT PLACE AT ALL: ********************************************* //
/*================================================================================================================*/

		int stoneWallType = -1;
	    int stoneWallID = -1;
	    int stoneWallCount = cNumberNonGaiaPlayers*2;	
	    rmEchoInfo("stoneWall count = "+stoneWallCount);

	    for(i=0; < stoneWallCount)
	{
		stoneWallType = rmRandInt(1,4);
        stoneWallID = rmCreateGrouping("stone wall "+i, "ne_rockwall "+stoneWallType);
		rmAddGroupingToClass(stoneWallID, rmClassID("classWall"));
        rmSetGroupingMinDistance(stoneWallID, 0.0);
        rmSetGroupingMaxDistance(stoneWallID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(stoneWallID, avoidMediumCoin);
		rmAddGroupingConstraint(stoneWallID, avoidCoin);
		rmAddGroupingConstraint(stoneWallID, avoidNugget);
		rmAddGroupingConstraint(stoneWallID, forestConstraint);
		rmAddGroupingConstraint(stoneWallID, avoidImpassableLand);
		rmAddGroupingConstraint(stoneWallID, avoidCloseTradeRoute);
		rmAddGroupingConstraint(stoneWallID, avoidCloseSocket);
		rmAddGroupingConstraint(stoneWallID, wallConstraint);
		rmAddGroupingConstraint(stoneWallID, avoidWater20);
		rmAddGroupingConstraint(stoneWallID, playerConstraint);
		rmAddGroupingConstraint(stoneWallID, playerEdgeConstraint);
		rmAddGroupingConstraint(stoneWallID, avoidCloseNatives);
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.5, 0.5);
   }
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*===============================================================================================================*/
// ************************** DEFINE AND PLACE SOME RANDOM NORTHERN AND SOUTHERN CLIFFS: ************************ //
/*================================================================================================================*/

		numTries = -1;
	    failCount = -1;
		
		if (cNumberNonGaiaPlayers<=2)
		numTries=cNumberNonGaiaPlayers*6;
		else
		numTries=cNumberNonGaiaPlayers*3;
	    failCount=0;
		
/*----------------------------------------------------------------------------------------------------------------*/		
	    
		// THE WESTERN CLIFFS:
		for(i=0; <numTries)
{	
		int Cliff1ID=rmCreateArea("The Cliff 1"+i);
	    rmSetAreaSize(Cliff1ID, 0.001, 0.001);
		rmSetAreaWarnFailure(Cliff1ID, false);
		rmSetAreaCliffType(Cliff1ID, "New England");
		rmAddAreaToClass(Cliff1ID, rmClassID("classCliff"));		
		//rmSetAreaCliffEdge(Cliff1ID, 1, 0.6, 0.1, 1.0, 0);
        rmSetAreaCliffEdge(Cliff1ID, 1, 1.0, 0.1, 1.0, 0);		
		rmSetAreaCliffPainting(Cliff1ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(Cliff1ID, 6, 1.0, 1.0);
		rmSetAreaHeightBlend(Cliff1ID, 1.0);
		rmSetAreaMix(Cliff1ID, "newengland_grass");
		//rmAddAreaTerrainLayer(Cliff1ID, "new_england\ground4_ne", 0, 2);
        rmSetAreaSmoothDistance(Cliff1ID, 15);
		rmSetAreaCoherence(Cliff1ID, 0.85);
		
		rmAddAreaConstraint(Cliff1ID, avoidImportantItem);
		rmAddAreaConstraint(Cliff1ID, avoidCloseTradeRoute);
		rmAddAreaConstraint(Cliff1ID, avoidCloseSocket);
		rmAddAreaConstraint(Cliff1ID, playerEdgeConstraint);
		rmAddAreaConstraint(Cliff1ID, avoidImpassableLand);
		rmAddAreaConstraint(Cliff1ID, avoidAll);
		rmAddAreaConstraint(Cliff1ID, avoidMediumNatives);
		rmAddAreaConstraint(Cliff1ID, wallConstraint);
		rmAddAreaConstraint(Cliff1ID, avoidWater25);
		rmAddAreaConstraint(Cliff1ID, avoidCloseDeer);
		rmAddAreaConstraint(Cliff1ID, avoidCloseSheep);
		rmAddAreaConstraint(Cliff1ID, avoidCoin);
		rmAddAreaConstraint(Cliff1ID, avoidNugget);
		rmAddAreaConstraint(Cliff1ID, forestCloseConstraint);
		rmAddAreaConstraint(Cliff1ID, avoidVeryFarCliffs);
		rmAddAreaConstraint(Cliff1ID, Westward);
		rmAddAreaConstraint(Cliff1ID, playerCloseConstraint);
	
		if(rmBuildArea(Cliff1ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	}
	
/*----------------------------------------------------------------------------------------------------------------*/		

		// THE EASTERN CLIFFS:
		for(i=0; <numTries)
	{	
		int Cliff2ID=rmCreateArea("The Cliff 2"+i);
	    rmSetAreaSize(Cliff2ID, 0.0015, 0.0015);
		rmSetAreaWarnFailure(Cliff2ID, false);
		rmSetAreaCliffType(Cliff2ID, "New England");
		rmAddAreaToClass(Cliff2ID, rmClassID("classCliff"));		
		//rmSetAreaCliffEdge(Cliff2ID, 1, 0.6, 0.1, 1.0, 0);
        rmSetAreaCliffEdge(Cliff2ID, 1, 1.0, 0.1, 1.0, 0);			
		rmSetAreaCliffPainting(Cliff2ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(Cliff2ID, 6, 1.0, 1.0);
		rmSetAreaHeightBlend(Cliff2ID, 1.0);
		rmSetAreaMix(Cliff2ID, "newengland_grass");
		//rmAddAreaTerrainLayer(Cliff2ID, "new_england\ground4_ne", 0, 2);
        rmSetAreaSmoothDistance(Cliff2ID, 15);
		rmSetAreaCoherence(Cliff2ID, 0.85);
		
		rmAddAreaConstraint(Cliff2ID, avoidImportantItem);
		rmAddAreaConstraint(Cliff2ID, avoidCloseTradeRoute);
		rmAddAreaConstraint(Cliff2ID, avoidCloseSocket);
		rmAddAreaConstraint(Cliff2ID, playerEdgeConstraint);
		rmAddAreaConstraint(Cliff2ID, avoidImpassableLand);
		rmAddAreaConstraint(Cliff2ID, avoidAll);
		rmAddAreaConstraint(Cliff2ID, avoidMediumNatives);
		rmAddAreaConstraint(Cliff2ID, wallConstraint);
		rmAddAreaConstraint(Cliff2ID, avoidWater25);
		rmAddAreaConstraint(Cliff2ID, avoidCloseDeer);
		rmAddAreaConstraint(Cliff2ID, avoidCloseSheep);
		rmAddAreaConstraint(Cliff2ID, avoidCoin);
		rmAddAreaConstraint(Cliff2ID, avoidNugget);
		rmAddAreaConstraint(Cliff2ID, forestCloseConstraint);
		rmAddAreaConstraint(Cliff2ID, avoidVeryFarCliffs);
		rmAddAreaConstraint(Cliff2ID, Eastward);
		rmAddAreaConstraint(Cliff2ID, playerCloseConstraint);
	
				
		if(rmBuildArea(Cliff2ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
		
	}
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE WEST SIDE OF THE BIGCONTINENT:
		int randomTreeID=rmCreateObjectDef("The Random Trees 1");
		rmAddObjectDefItem(randomTreeID, "TreeNewEngland", 1, 0.0);
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint); 
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, Westward);
		rmAddObjectDefConstraint(randomTreeID, wallConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCliffs);
		rmAddObjectDefConstraint(randomTreeID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseDeer);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSheep);
		rmAddObjectDefConstraint(randomTreeID, avoidWater15);
		rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
		rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 40*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE EAST SIDE OF THE BIGCONTINENT:
		int randomTree2ID=rmCreateObjectDef("The Random Trees 2");
		rmAddObjectDefItem(randomTree2ID, "TreeNewEngland", 1, 0.0);
		rmAddObjectDefToClass(randomTree2ID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTree2ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTree2ID, playerEdgeConstraint); 
	    rmAddObjectDefConstraint(randomTree2ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTree2ID, avoidAll);
		rmAddObjectDefConstraint(randomTree2ID, Eastward);
		rmAddObjectDefConstraint(randomTree2ID, wallConstraint);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(randomTree2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseDeer);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseSheep);
		rmAddObjectDefConstraint(randomTree2ID, avoidWater15);
		rmAddObjectDefConstraint(randomTree2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(randomTree2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 40*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //		
/*================================================================================================================*/

        // THE WESTERN BERRYBUSH:
		int BerriesID=rmCreateObjectDef("The Berries 1");
        rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(BerriesID, 0.0);
        rmSetObjectDefMaxDistance(BerriesID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(BerriesID, avoidVeryFarFruits);
		rmAddObjectDefConstraint(BerriesID, Westward);
        rmAddObjectDefConstraint(BerriesID, avoidAll);
		rmAddObjectDefConstraint(BerriesID, avoidCloseTrees);
		rmAddObjectDefConstraint(BerriesID, wallConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidCloseNatives);
		rmAddObjectDefConstraint(BerriesID, avoidMediumDeer);
		rmAddObjectDefConstraint(BerriesID, forestCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, playerCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCoin);
		rmAddObjectDefConstraint(BerriesID, avoidNugget);
		rmAddObjectDefConstraint(BerriesID, avoidSocket);
		rmAddObjectDefConstraint(BerriesID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(BerriesID, avoidImpassableLand);
		rmAddObjectDefConstraint(BerriesID, playerEdgeConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidImportantItem);
		rmAddObjectDefConstraint(BerriesID, avoidWater20);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCliffs);
		        
		rmSetObjectDefCreateHerd(BerriesID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE EASTERN BERRYBUSH:
		int Berries2ID=rmCreateObjectDef("The Berries 2");
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(Berries2ID, 0.0);
        rmSetObjectDefMaxDistance(Berries2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(Berries2ID, avoidVeryFarFruits);
		rmAddObjectDefConstraint(Berries2ID, Eastward);
        rmAddObjectDefConstraint(Berries2ID, avoidAll);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseTrees);
		rmAddObjectDefConstraint(Berries2ID, wallConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(Berries2ID, avoidMediumDeer);
		rmAddObjectDefConstraint(Berries2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(Berries2ID, avoidNugget);
		rmAddObjectDefConstraint(Berries2ID, avoidSocket);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(Berries2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(Berries2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidImportantItem);
		rmAddObjectDefConstraint(Berries2ID, avoidWater20);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCliffs);
		        
		rmSetObjectDefCreateHerd(Berries2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);		
 
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/
