/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAPS: *********************************** //
/*================================================================================================================*/
// THE HOCHELAGA WAR:
// CREATED BY DANY:
// APRIL 2007:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
        int subCiv4=-1;
        int subCiv5=-1;
		
		if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Iroquois");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Iroquois");

		subCiv1=rmGetCivID("Iroquois");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Iroquois"); 

		subCiv2=rmGetCivID("Iroquois");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Iroquois");

		subCiv4=rmGetCivID("Iroquois");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Iroquois");

		subCiv5=rmGetCivID("Iroquois");
        if (subCiv5 >= 0)
        rmSetSubCiv(5, "Iroquois");
   }		
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/

        int playerTiles=17500;
   
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(530, 530);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ************************************* DEFINE THE VARIATIONS OF THE MAP: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// **************************************** PICKS THE MAP PARAMETERS: ******************************************* //
/*================================================================================================================*/

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(1.0);

        // SET THE MAP ELEVATION PARAMETERS:
		// rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	    rmSetMapElevationParameters(cElevTurbulence, 0.05, 6, 0.7, 8.0); // FROM GREAT LAKES:
		
		// SET THE MAP ELEVATION HEIGHT BLEND: // FROM GREAT LAKES:
		rmSetMapElevationHeightBlend(1);
	
	    // SET THE SEA TYPE:
		rmSetSeaType("great lakes"); // FROM GREAT LAKES:
        
		// ENABLE THE LOCAL WATER: 
		rmEnableLocalWater(false);
	    
		// SET THE BASE TERRAIN MIX:
		rmSetBaseTerrainMix("greatlakes_grass"); // FROM GREAT LAKES:
    
	    // SET THE TERRAIN INITIALIZATION:
		rmTerrainInitialize("great_lakes\ground_grass1_gl", 1.0); // FROM GREAT LAKES:
	
	    // SET THE MAP TYPE:
	    rmSetMapType("greatlakes"); // FROM GREAT LAKES:
	    rmSetMapType("water");
	    rmSetMapType("grass");
        
		// SET THE LIGHTING:
		rmSetLightingSet("Great Lakes"); // FROM GREAT LAKES:
	    
		// SET WORLD CIRCLE CONSTRAINT: (MAKE THE CORNERS:)
		rmSetWorldCircleConstraint(true);

	    // CHOOSE THE MERCS:
	    chooseMercs();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
   
        int classPlayer=rmDefineClass("player");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
	    rmDefineClass("nuggets");
	    rmDefineClass("socketClass");
		rmDefineClass("classHillArea");
	    rmDefineClass("classSmallHillArea");
	    rmDefineClass("classCliff");
		rmDefineClass("natives");

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		// MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
        
        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
                
		// FOREST AVOIDANCE:(RESOURCE AVOIDANCE)
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
		
		// AVOID THE HILLY AREAS:
	    int avoidHills = rmCreateClassDistanceConstraint("avoid Hills", rmClassID("classHillArea"), 15.0);
	    int avoidHillsLarge = rmCreateClassDistanceConstraint("avoid Hills by a lot", rmClassID("classHillArea"), 20.0);
	    int avoidSmallHills = rmCreateClassDistanceConstraint("avoid Small Hills", rmClassID("classSmallHillArea"), 20.0);
	    int avoidCloseHills = rmCreateClassDistanceConstraint("avoid Small Hills by a little", rmClassID("classHillArea"), 5.0);

                
		// START RESOURCE AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
        
		// SILVER MINES AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoid coin", "mine", 50.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "mine", 2.0);
        
		// NUGGET AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "AbstractNugget", 15.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 2.0);
		int avoidPlayerNugget=rmCreateTypeDistanceConstraint("player nugget avoid nugget", "AbstractNugget", 25.0);
                       
		// DEER AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 50.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
        
		// MOOSE AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidMoose=rmCreateTypeDistanceConstraint("moose avoids moose", "moose", 50.0);
		int avoidCloseMoose=rmCreateTypeDistanceConstraint("close avoids moose", "moose", 2.0);
		
		// RHEA AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidRhea=rmCreateTypeDistanceConstraint("rhea avoids rhea", "rhea", 50.0);
		int avoidCloseRhea=rmCreateTypeDistanceConstraint("close avoids rhea", "rhea", 2.0);
		
		// SHEEP AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 50.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 2.0);
		
		// FRUITS AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
        
		// SEA FOOD AVOIDANCE:(RESOURCE AVOIDANCE)
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 15.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 18.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	    
		// AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
        int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close impassable land", "Land", false, 5.0);
                
		// DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

        // STARTING UNITS AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

        // NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("forest avoids natives", rmClassID("natives"), 5.0);
				
		// TRADE ROUTE AVOIDANCE:
        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 2.0);
	    int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 5.0);
	    
		// IMPORTANT ITEM AVOIDANCE:(VP AVOIDANCE)
		int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 50.0);
        
		// CONSTRAINTS TO AVOID WATER:
        int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 8.0);

        // CARDINAL DIRECTIONS CONSTRAINTS (HANDY!)
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

        // SHIPS VS. SHIPS:
        int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 15.0);

        // NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	    int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

	    // CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
    	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ****************************************** CREATE THE 2 BAY AREAS: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ****************************** DEFINE AND PLACE THE TWO GLORIOUS TRADE ROUTES: ******************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // DEFINE AND PLACE TRADE ROUTE 1:
		int tradeRouteID = rmCreateTradeRoute();
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 12.0);

		rmAddTradeRouteWaypoint(tradeRouteID, 0.25, 0.910);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.30, 0.90);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.40, 0.80);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.70);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.60, 0.60);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.50);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.40, 0.40);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.30);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.60, 0.20);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.70, 0.10);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.725, 0.0720);
		
        bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
  
	    // ADD THE SOCKETS ALONG THE TRADE ROUTE:
        vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.05);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.35);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.65);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.95);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// ************************************** SET UP PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if(cNumberNonGaiaPlayers == 2)
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.775,0.775);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.225,0.225);
	}  
		else
    {		
		//rmSetPlacementTeam(0);
		//rmPlacePlayer(1,0.8,0.8);
		//rmPlacePlayer(2,0.8,0.2);
		//rmSetPlacementTeam(1);
		//rmPlacePlayer(3,0.2,0.2);
        //rmPlacePlayer(4,0.2,0.8);
	}  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        float playerFraction = rmAreaTilesToFraction(100);
        
		for(i = 0; < cNumberNonGaiaPlayers)
   {
        // CREATE THE AREA:
        int id = rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
	    rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
	    rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); // removed by me for now:
        //rmAddAreaConstraint(id, playerEdgeConstraint); // removed by me for now:
	   
	    // SET AREA TERRAIN TYPE:
		rmSetAreaTerrainType(id, "great_lakes\ground_grass1_gl");		
	    
		// SET AREA MIX:
		// rmSetAreaMix(id, "greatlakes_grass"); // added by me as a possiblity:
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD THE AREAS:
        rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.1, 0.7);
	}	
		if (subCiv1 == rmGetCivID("iroquois"))
		
	{
        int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.9, 0.3);
	}	
	
	    if (subCiv2 == rmGetCivID("iroquois"))
	{	
		int iroquois3VillageID = -1;
		iroquois3VillageID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.7, 0.5);
	}	
	
	    if (subCiv3 == rmGetCivID("iroquois"))
	{	
		int iroquois4VillageID = -1;
		iroquois4VillageID = rmCreateGrouping("iroquois village 4", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois4VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois4VillageID, 0.0);
		rmAddGroupingToClass(iroquois4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.3, 0.5);
	}	
	
	    if (subCiv4 == rmGetCivID("iroquois"))
	{	
		int iroquois5VillageID = -1;
		iroquois5VillageID = rmCreateGrouping("iroquois village 5", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois5VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois5VillageID, 0.0);
		rmAddGroupingToClass(iroquois5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois5VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois5VillageID, 0, 0.6, 0.060);
	}	
	
	    if (subCiv5 == rmGetCivID("iroquois"))
	{	
		int iroquois6VillageID = -1;
		iroquois6VillageID = rmCreateGrouping("iroquois village 6", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois6VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois6VillageID, 0.0);
		rmAddGroupingToClass(iroquois6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois6VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois6VillageID, 0, 0.4, 0.940);
	}	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.56);
/*================================================================================================================*/

// *********************************** DEFINE AND PLACE THE TRADE ROUTE HACK: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.56);
/*================================================================================================================*/
// **************************************** ADDING A LAKE IN THE MIDDLE: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
// ************************** DEFINE AND PLACE HILL 2 IS THE LEFT CENTRAL "CLIFFY" HILL: ************************ //
/*================================================================================================================*/

	    int centralValley1ID=rmCreateArea("center valley 1");
	    rmSetAreaMix(centralValley1ID, "greatlakes_grass");
	    rmSetAreaTerrainType(centralValley1ID, "great_lakes\ground_grass1_gl");
	    rmSetAreaSize(centralValley1ID, 0.035, 0.035);
	    rmSetAreaWarnFailure(centralValley1ID, false);
	    rmSetAreaSmoothDistance(centralValley1ID, 5);
	    rmSetAreaCliffType(centralValley1ID, "New England");
	    rmSetAreaCliffEdge(centralValley1ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(centralValley1ID, 8, 1.0, 1.0);
	    rmSetAreaCoherence(centralValley1ID, 0.95);
	    rmSetAreaHeightBlend(centralValley1ID, 1);
	    if ( cNumberTeams == 2 )
	{
		rmAddAreaCliffWaypoint(centralValley1ID, 0.25, 0.75);
		rmAddAreaCliffWaypoint(centralValley1ID, 0.40, 0.60);
	}
	    else
	{
		rmAddAreaCliffWaypoint(centralValley1ID, 0.25, 0.75);
		rmAddAreaCliffWaypoint(centralValley1ID, 0.40, 0.60);
	}
	    rmSetAreaCliffPainting(centralValley1ID, true, false, true);
	    rmAddAreaToClass(centralValley1ID, rmClassID("classHillArea"));
	    rmBuildArea(centralValley1ID);

/*================================================================================================================*/
		
		int centralValley2ID=rmCreateArea("center valley 2");
	    rmSetAreaMix(centralValley2ID, "greatlakes_grass");
	    rmSetAreaTerrainType(centralValley1ID, "great_lakes\ground_grass1_gl");
	    rmSetAreaSize(centralValley2ID, 0.035, 0.035);
	    rmSetAreaWarnFailure(centralValley2ID, false);
	    rmSetAreaSmoothDistance(centralValley2ID, 5);
	    rmSetAreaCliffType(centralValley2ID, "New England");
	    rmSetAreaCliffEdge(centralValley2ID, 1, 1.0, 0.1, 1.0, 0);
	    rmSetAreaCliffHeight(centralValley2ID, 8, 2.0, 0.5);
	    rmSetAreaCoherence(centralValley2ID, 0.95);
	    rmSetAreaHeightBlend(centralValley2ID, 1);
	    if ( cNumberTeams == 2 )
	{
		rmAddAreaCliffWaypoint(centralValley2ID, 0.75, 0.25);
		rmAddAreaCliffWaypoint(centralValley2ID, 0.60, 0.40);
	}
	    else
	{
		rmAddAreaCliffWaypoint(centralValley2ID, 0.75, 0.25);
		rmAddAreaCliffWaypoint(centralValley2ID, 0.60, 0.40);
	}
	    rmSetAreaCliffPainting(centralValley2ID, true, false, true);
	    rmAddAreaToClass(centralValley2ID, rmClassID("classHillArea"));
	    rmBuildArea(centralValley2ID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ******************************** DEFINE THE STARTING TCID AND STARTING UNITS: ******************************** //
/*================================================================================================================*/
 
        // DEFINE THE STARTING UNIT:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);

	    // DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));

	    // DEFINE THE PLAYER GOLD:
		int silverType = -1;
	    int playerGoldID = -1;

	    // DEFINE THE STARTING TREE:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeGreatLakes", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 10.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	    // DEFINE THE STARTING DEER:
		int StartDeerID=rmCreateObjectDef("starting deer");
	    rmAddObjectDefItem(StartDeerID, "deer", 1, 0.0);
	    rmSetObjectDefMinDistance(StartDeerID, 10.0);
	    rmSetObjectDefMaxDistance(StartDeerID, 15.0);
	    rmAddObjectDefConstraint(StartDeerID, avoidStartingUnitsSmall);

	    // DEFINE THE STARTING BERRYBUSH:
		int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 5.0);
	    rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
	    rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
	    rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 30.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	    rmAddObjectDefConstraint(playerNuggetID, avoidPlayerNugget);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

/*	    // DEFINE THE WATER FLAG:
		int waterFlagID=-1;
*/	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ********************** PLACE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************** //
/*================================================================================================================*/

	    for(i=1; <cNumberPlayers)
	{
		rmClearClosestPointConstraints();
		
		// PLACE THE STARTING UNITS AND A TC:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// EVERYONE GETS ONE ORE MINE CLOSE BY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING PRONGHORNS:
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

/*		// PLACE THE WATER FLAG:
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		//rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		//rmAddClosestPointConstraint(Eastward);
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		rmClearClosestPointConstraints();
*/		
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE SILVER MINES ON THE MAP: ******************************** //
/*================================================================================================================*/

		int silver1ID = rmCreateObjectDef("silver 1");
		rmAddObjectDefItem(silver1ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver1ID, 0.0);
		rmSetObjectDefMaxDistance(silver1ID, 0.0);
		rmAddObjectDefConstraint(silver1ID, avoidCoin);
		
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.85, 0.425);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.425, 0.85);
		
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.10, 0.60);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.575, 0.125);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		int silver2ID = rmCreateObjectDef("silver 2");
		rmAddObjectDefItem(silver2ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver2ID, 0.0);
		rmSetObjectDefMaxDistance(silver2ID, 0.0);
		//rmAddObjectDefConstraint(silver2ID, avoidCoin);
		
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.375, 0.625);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.325, 0.675);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.275, 0.725);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.625, 0.375);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.675, 0.325);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.725, 0.275);
		
/*----------------------------------------------------------------------------------------------------------------*/
        
        int silver3ID = rmCreateObjectDef("silver 3");
		rmAddObjectDefItem(silver3ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver3ID, 0.0);
		rmSetObjectDefMaxDistance(silver3ID, 0.0);
		//rmAddObjectDefConstraint(silver3ID, avoidCoin);
		
		rmPlaceObjectDefAtLoc(silver3ID, 0, 0.165, 0.165);
		rmPlaceObjectDefAtLoc(silver3ID, 0, 0.835, 0.835);
		rmPlaceObjectDefAtLoc(silver3ID, 0, 0.275, 0.275);
		rmPlaceObjectDefAtLoc(silver3ID, 0, 0.725, 0.725);		
		
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE NUGGETS ON THE MAP: *********************************** //
/*================================================================================================================*/
        
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
  	    rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.45, 0.95);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.95, 0.45);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.05, 0.55);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.65, 0.05);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
  	    rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.86, 0.36);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.225, 0.85);

        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.675, 0.175);
        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.175, 0.675);	

        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.475, 0.425);
        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.425, 0.475);

        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.525, 0.575);
        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.575, 0.525);

/*----------------------------------------------------------------------------------------------------------------*/
        
		int nugget3ID= rmCreateObjectDef("nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
  	    rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.10, 0.30);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.30, 0.10);
		
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.70, 0.90);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.90, 0.70);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int nugget4ID= rmCreateObjectDef("nugget 4"); 
	    rmAddObjectDefItem(nugget4ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget4ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget4ID, 0.0);
	    rmAddObjectDefConstraint(nugget4ID, avoidNugget);
  	    rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.35, 0.25);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.475, 0.775);
		
		//rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.70, 0.90);
		//rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.90, 0.70);
		
/*----------------------------------------------------------------------------------------------------------------*/

    	int nugget5ID= rmCreateObjectDef("nugget 5"); 
	    rmAddObjectDefItem(nugget5ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget5ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget5ID, 0.0);
	    rmAddObjectDefConstraint(nugget5ID, avoidNugget);
  	    rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.26, 0.45);	
			
	
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE RHEA: ****************************************** //
/*================================================================================================================*/ 
/*	   
        int rheaID=rmCreateObjectDef("rhea flock"+i);
        rmAddObjectDefItem(rheaID, "rhea", rmRandInt(8,10), 10.0);
        rmSetObjectDefMinDistance(rheaID, 0.0);
        rmSetObjectDefMaxDistance(rheaID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(rheaID, avoidHills);
		rmAddObjectDefConstraint(rheaID, avoidCloseNugget);
	    rmAddObjectDefConstraint(rheaID, avoidAll);
		rmAddObjectDefConstraint(rheaID, avoidCloseCoin);
        rmAddObjectDefConstraint(rheaID, avoidCloseImpassableLand);
        rmAddObjectDefConstraint(rheaID, avoidStartingUnits);
	    rmAddObjectDefConstraint(rheaID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(rheaID, avoidSocket);
	    rmAddObjectDefConstraint(rheaID, avoidCloseNatives);
        rmSetObjectDefCreateHerd(rheaID, true);
	    rmPlaceObjectDefAtLoc(rheaID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
*/

/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE MOOSES: ***************************************** //
/*================================================================================================================*/
        
        int moose1ID=rmCreateObjectDef("The Moose Herds 1");
        rmAddObjectDefItem(moose1ID, "moose", rmRandInt(5,7), 6.0);
        rmSetObjectDefMinDistance(moose1ID, 0.0);
        rmSetObjectDefMaxDistance(moose1ID, 0.0);
	    rmAddObjectDefConstraint(moose1ID, avoidMoose);
		rmSetObjectDefCreateHerd(moose1ID, true);
	    
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.675, 0.85);
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.85, 0.675);
		
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.15, 0.325);
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.315, 0.15);
		
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.46, 0.675);
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.625, 0.225);
				
 		
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE DEER: ****************************************** //
/*================================================================================================================*/ 
	   
        int deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(deer1ID, "deer", rmRandInt(8,10), 6.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.185, 0.825);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.825, 0.185);
		
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.05, 0.50);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.50, 0.05);
		
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.95, 0.50);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.50, 0.95);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int deer2ID=rmCreateObjectDef("The Deer Herds 2");
        rmAddObjectDefItem(deer2ID, "deer", rmRandInt(8,10), 6.0);
        rmSetObjectDefMinDistance(deer2ID, 0.0);
        rmSetObjectDefMaxDistance(deer2ID, 0.0);
	    rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer2ID, true);
	    
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.575, 0.725);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.725, 0.575);

        rmPlaceObjectDefAtLoc(deer2ID, 0, 0.35, 0.50);	

/*----------------------------------------------------------------------------------------------------------------*/

        int deer3ID=rmCreateObjectDef("The Deer Herds 3");
        rmAddObjectDefItem(deer3ID, "deer", rmRandInt(8,10), 6.0);
        rmSetObjectDefMinDistance(deer3ID, 0.0);
        rmSetObjectDefMaxDistance(deer3ID, 0.0);
	    rmAddObjectDefConstraint(deer3ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer3ID, true);
	    
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.405, 0.315);		
		
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //
/*================================================================================================================*/
        
		int berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,7), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.425, 0.725);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.575, 0.275);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.475, 0.525);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.525, 0.475);

/*----------------------------------------------------------------------------------------------------------------*/

        int berries2ID = rmCreateObjectDef("The Berries 2");
		rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,7), 4.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidFruits);
				
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.275, 0.575);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.725, 0.425);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.95, 0.35);
		//rmPlaceObjectDefAtLoc(berries2ID, 0, 0.55, 0.30);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int berries3ID = rmCreateObjectDef("The Berries 3");
		rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(3,7), 4.0);
		rmSetObjectDefMinDistance(berries3ID, 0.0);
		rmSetObjectDefMaxDistance(berries3ID, 0.0);
		rmAddObjectDefConstraint(berries3ID, avoidFruits);
				
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.5, 0.65);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.65, 0.55);		
		
/*----------------------------------------------------------------------------------------------------------------*/

        int berries4ID = rmCreateObjectDef("The Berries 4");
		rmAddObjectDefItem(berries4ID, "berrybush", rmRandInt(3,7), 4.0);
		rmSetObjectDefMinDistance(berries4ID, 0.0);
		rmSetObjectDefMaxDistance(berries4ID, 0.0);
		rmAddObjectDefConstraint(berries4ID, avoidFruits);
				
		rmPlaceObjectDefAtLoc(berries4ID, 0, 0.425, 0.275);
		rmPlaceObjectDefAtLoc(berries4ID, 0, 0.3, 0.425);

/*----------------------------------------------------------------------------------------------------------------*/

        int berries5ID = rmCreateObjectDef("The Berries 5");
		rmAddObjectDefItem(berries5ID, "berrybush", rmRandInt(3,7), 4.0);
		rmSetObjectDefMinDistance(berries5ID, 0.0);
		rmSetObjectDefMaxDistance(berries5ID, 0.0);
		rmAddObjectDefConstraint(berries5ID, avoidFruits);
				
		rmPlaceObjectDefAtLoc(berries5ID, 0, 0.125, 0.225);
		rmPlaceObjectDefAtLoc(berries5ID, 0, 0.225, 0.125);	

        rmPlaceObjectDefAtLoc(berries5ID, 0, 0.875, 0.775);
		rmPlaceObjectDefAtLoc(berries5ID, 0, 0.775, 0.875);				
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE SHEEPS: **************************************** //
/*================================================================================================================*/
        
		int sheep1ID = rmCreateObjectDef("The Sheep Herds 1");
		rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(5,9), 4.0);
		rmSetObjectDefMinDistance(sheep1ID, 0.0);
		rmSetObjectDefMaxDistance(sheep1ID, 0.0);
		rmAddObjectDefConstraint(sheep1ID, avoidSheep);
		
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.05, 0.40);
	    rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.40, 0.05);
		
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.60, 0.95);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.95, 0.60);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		int sheep2ID = rmCreateObjectDef("The Sheep Herds 2");
		rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(5,9), 4.0);
		rmSetObjectDefMinDistance(sheep2ID, 0.0);
		rmSetObjectDefMaxDistance(sheep2ID, 0.0);
		rmAddObjectDefConstraint(sheep2ID, avoidSheep);
		
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.375, 0.775);
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.825, 0.325);
		
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.14, 0.76);
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.76, 0.14);
		
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE DECORATIONS OF THE MAP: ********************************* //		
/*================================================================================================================*/
        
		// DEFINE AND PLACE THE PERCHING VULTURES:
	    int vultureID=rmCreateObjectDef("perching vultures");
	    int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 25.0);
	    rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, 0.0);
	    rmAddObjectDefConstraint(vultureID, avoidVultures);
		
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.9, 0.4);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.375, 0.875);
		
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.350, 0.450);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.50, 0.35);
		
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE EAGLE TREE: ************************************** //		
/*================================================================================================================*/
        
		int randomEagleTreeID=rmCreateObjectDef("random eagle tree");
        int avoidEagles=rmCreateTypeDistanceConstraint("avoids Eagles", "EaglesNest", 10.0);
        rmAddObjectDefItem(randomEagleTreeID, "EaglesNest", 1, 0.0);
	    rmSetObjectDefMinDistance(randomEagleTreeID, 0.0);
	    rmSetObjectDefMaxDistance(randomEagleTreeID, 0.0);
	    rmAddObjectDefConstraint(randomEagleTreeID, avoidEagles);
	    
		rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.3, 0.2);
		rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.8, 0.7);
		rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.25, 0.55);
		rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.75, 0.45);
		
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE KING FISHER: ************************************** //
/*================================================================================================================*/

        /*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE EAGLE TREE: ************************************** //		
/*================================================================================================================*/
        
		int Kingfisher1ID=rmCreateObjectDef("The King Fisher Tree");
        int avoidKingFisher=rmCreateTypeDistanceConstraint("avoids KingFisher", "PropKingfisher", 10.0);
        rmAddObjectDefItem(Kingfisher1ID, "Propkingfisher", 1, 0.0);
	    rmSetObjectDefMinDistance(Kingfisher1ID, 0.0);
	    rmSetObjectDefMaxDistance(Kingfisher1ID, 0.0);
	    rmAddObjectDefConstraint(Kingfisher1ID, avoidEagles);
	    
		rmPlaceObjectDefAtLoc(Kingfisher1ID, 0, 0.65, 0.75);
		rmPlaceObjectDefAtLoc(Kingfisher1ID, 0, 0.25, 0.40);
		//rmPlaceObjectDefAtLoc(Kingfisher1ID, 0, 0.25, 0.55);
		//rmPlaceObjectDefAtLoc(Kingfisher1ID, 0, 0.75, 0.45);
				
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE LARGE FORESTS: ************************************* //
/*================================================================================================================*/
// NOT FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
         		 
		 int forest1ID = -1;
         forest1ID=rmCreateArea("forest 1");
         rmSetAreaWarnFailure(forest1ID, false);
         rmSetAreaSize(forest1ID, 0.025, 0.025);
         rmSetAreaForestType(forest1ID, "great lakes forest");
         rmSetAreaForestDensity(forest1ID, 1.0);
         rmSetAreaForestClumpiness(forest1ID, 0.0);
         rmSetAreaForestUnderbrush(forest1ID, 0.0);
         rmSetAreaMinBlobs(forest1ID, 1);
         rmSetAreaMaxBlobs(forest1ID, 1);
         rmSetAreaMinBlobDistance(forest1ID, 1.0);
         rmSetAreaMaxBlobDistance(forest1ID, 1.0);
         rmSetAreaCoherence(forest1ID, 1.0);
         rmSetAreaSmoothDistance(forest1ID, 10);
         rmAddAreaToClass(forest1ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest1ID, forestConstraint);
		 rmSetAreaLocation(forest1ID, 0.55, 0.85); 
         rmBuildArea(forest1ID);
		 
		 int forest2ID = -1;
         forest2ID=rmCreateArea("forest 2");
         rmSetAreaWarnFailure(forest2ID, false);
         rmSetAreaSize(forest2ID, 0.025, 0.025);
         rmSetAreaForestType(forest2ID, "great lakes forest");
         rmSetAreaForestDensity(forest2ID, 1.0);
         rmSetAreaForestClumpiness(forest2ID, 0.0);
         rmSetAreaForestUnderbrush(forest2ID, 0.0);
         rmSetAreaMinBlobs(forest2ID, 1);
         rmSetAreaMaxBlobs(forest2ID, 1);
         rmSetAreaMinBlobDistance(forest2ID, 1.0);
         rmSetAreaMaxBlobDistance(forest2ID, 1.0);
         rmSetAreaCoherence(forest2ID, 1.0);
         rmSetAreaSmoothDistance(forest2ID, 10);
         rmAddAreaToClass(forest2ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest2ID, forestConstraint);
		 rmSetAreaLocation(forest2ID, 0.85, 0.55); 
         rmBuildArea(forest2ID);
		 
         int forest3ID = -1;
         forest3ID=rmCreateArea("forest 3");
         rmSetAreaWarnFailure(forest3ID, false);
         rmSetAreaSize(forest3ID, 0.025, 0.025);
         rmSetAreaForestType(forest3ID, "great lakes forest");
         rmSetAreaForestDensity(forest3ID, 1.0);
         rmSetAreaForestClumpiness(forest3ID, 0.0);
         rmSetAreaForestUnderbrush(forest3ID, 0.0);
         rmSetAreaMinBlobs(forest3ID, 1);
         rmSetAreaMaxBlobs(forest3ID, 1);
         rmSetAreaMinBlobDistance(forest3ID, 1.0);
         rmSetAreaMaxBlobDistance(forest3ID, 1.0);
         rmSetAreaCoherence(forest3ID, 1.0);
         rmSetAreaSmoothDistance(forest3ID, 10);
         rmAddAreaToClass(forest3ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest3ID, forestConstraint);
		 rmSetAreaLocation(forest3ID, 0.15, 0.45); 
         rmBuildArea(forest3ID);
		 
		 int forest4ID = -1;
         forest4ID=rmCreateArea("forest 4");
         rmSetAreaWarnFailure(forest4ID, false);
         rmSetAreaSize(forest4ID, 0.025, 0.025);
         rmSetAreaForestType(forest4ID, "great lakes forest");
         rmSetAreaForestDensity(forest4ID, 1.0);
         rmSetAreaForestClumpiness(forest4ID, 0.0);
         rmSetAreaForestUnderbrush(forest4ID, 0.0);
         rmSetAreaMinBlobs(forest4ID, 1);
         rmSetAreaMaxBlobs(forest4ID, 1);
         rmSetAreaMinBlobDistance(forest4ID, 1.0);
         rmSetAreaMaxBlobDistance(forest4ID, 1.0);
         rmSetAreaCoherence(forest4ID, 1.0);
         rmSetAreaSmoothDistance(forest4ID, 10);
         rmAddAreaToClass(forest4ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest4ID, forestConstraint);
		 rmSetAreaLocation(forest4ID, 0.45, 0.15); 
         rmBuildArea(forest4ID);
		 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE SMALL FORESTS: ************************************* //
/*================================================================================================================*/
// NOT FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
         		 
		 int forest5ID = -1;
         forest5ID=rmCreateArea("forest 5");
         rmSetAreaWarnFailure(forest5ID, false);
         rmSetAreaSize(forest5ID, 0.005, 0.005);
         rmSetAreaForestType(forest5ID, "great lakes forest");
         rmSetAreaForestDensity(forest5ID, 1.0);
         rmSetAreaForestClumpiness(forest5ID, 0.0);
         rmSetAreaForestUnderbrush(forest5ID, 0.0);
         rmSetAreaMinBlobs(forest5ID, 1);
         rmSetAreaMaxBlobs(forest5ID, 1);
         rmSetAreaMinBlobDistance(forest5ID, 1.0);
         rmSetAreaMaxBlobDistance(forest5ID, 1.0);
         rmSetAreaCoherence(forest5ID, 1.0);
         rmSetAreaSmoothDistance(forest5ID, 10);
         rmAddAreaToClass(forest5ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest5ID, forestConstraint);
		 rmSetAreaLocation(forest5ID, 0.20, 0.60); 
         rmBuildArea(forest5ID);
		 
		 int forest6ID = -1;
         forest6ID=rmCreateArea("forest 6");
         rmSetAreaWarnFailure(forest6ID, false);
         rmSetAreaSize(forest6ID, 0.005, 0.005);
         rmSetAreaForestType(forest6ID, "great lakes forest");
         rmSetAreaForestDensity(forest6ID, 1.0);
         rmSetAreaForestClumpiness(forest6ID, 0.0);
         rmSetAreaForestUnderbrush(forest6ID, 0.0);
         rmSetAreaMinBlobs(forest6ID, 1);
         rmSetAreaMaxBlobs(forest6ID, 1);
         rmSetAreaMinBlobDistance(forest6ID, 1.0);
         rmSetAreaMaxBlobDistance(forest6ID, 1.0);
         rmSetAreaCoherence(forest6ID, 1.0);
         rmSetAreaSmoothDistance(forest6ID, 10);
         rmAddAreaToClass(forest6ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest6ID, forestConstraint);
		 rmSetAreaLocation(forest6ID, 0.80, 0.40); 
         rmBuildArea(forest6ID);
		 
         int forest7ID = -1;
         forest7ID=rmCreateArea("forest 7");
         rmSetAreaWarnFailure(forest7ID, false);
         rmSetAreaSize(forest7ID, 0.01, 0.01);
         rmSetAreaForestType(forest7ID, "great lakes forest");
         rmSetAreaForestDensity(forest7ID, 1.0);
         rmSetAreaForestClumpiness(forest7ID, 0.0);
         rmSetAreaForestUnderbrush(forest7ID, 0.0);
         rmSetAreaMinBlobs(forest7ID, 1);
         rmSetAreaMaxBlobs(forest7ID, 1);
         rmSetAreaMinBlobDistance(forest7ID, 1.0);
         rmSetAreaMaxBlobDistance(forest7ID, 1.0);
         rmSetAreaCoherence(forest7ID, 1.0);
         rmSetAreaSmoothDistance(forest7ID, 10);
         rmAddAreaToClass(forest7ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest7ID, forestConstraint);
		 rmSetAreaLocation(forest7ID, 0.66, 0.66); 
         rmBuildArea(forest7ID);
		 
		 int forest8ID = -1;
         forest8ID=rmCreateArea("forest 8");
         rmSetAreaWarnFailure(forest8ID, false);
         rmSetAreaSize(forest8ID, 0.01, 0.01);
         rmSetAreaForestType(forest8ID, "great lakes forest");
         rmSetAreaForestDensity(forest8ID, 1.0);
         rmSetAreaForestClumpiness(forest8ID, 0.0);
         rmSetAreaForestUnderbrush(forest8ID, 0.0);
         rmSetAreaMinBlobs(forest8ID, 1);
         rmSetAreaMaxBlobs(forest8ID, 1);
         rmSetAreaMinBlobDistance(forest8ID, 1.0);
         rmSetAreaMaxBlobDistance(forest8ID, 1.0);
         rmSetAreaCoherence(forest8ID, 1.0);
         rmSetAreaSmoothDistance(forest8ID, 10);
         rmAddAreaToClass(forest8ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest8ID, forestConstraint);
		 rmSetAreaLocation(forest8ID, 0.335, 0.335); 
         rmBuildArea(forest8ID);		 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// ***************************************** THIS IS THE END OF THE MAP: **************************************** //
/*================================================================================================================*/




















































