/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/
// THE OTHER ENEMY:
// CREATED BY DANY:
// DECEMBER 2006:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   int subCiv0=-1;
   int subCiv1=-1;
   int subCiv2=-1;
   int subCiv3=-1;
   int subCiv4=-1;
   int subCiv5=-1;
   int subCiv6=-1;
   
     if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Iroquois");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Iroquois");

		subCiv1=rmGetCivID("Iroquois");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Iroquois"); 

		subCiv2=rmGetCivID("Iroquois");
      if (subCiv2 >= 0)
         rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
      if (subCiv3 >= 0)
         rmSetSubCiv(3, "Iroquois");
		 
		 subCiv4=rmGetCivID("Iroquois");
      if (subCiv4 >= 0)
         rmSetSubCiv(4, "Iroquois");

		subCiv5=rmGetCivID("Iroquois");
      if (subCiv5 >= 0)
         rmSetSubCiv(5, "Iroquois");
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
      int playerTiles=25000;
      
	  int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
      rmEchoInfo("Map size="+size+"m x "+size+"m");
      rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
      // PICKS A DEFAULT WATER HEIGHT:
      rmSetSeaLevel(0.0);

      // PICKS DEFAULT TERRAIN AND WATER:
	  // DAL rmSetAreaMix(westDesertID, "texas_dirt");
	  
	  // SET MAP ELEVATION PARAMETERS:
	  rmSetMapElevationParameters(cElevTurbulence, 0.02, 3, 0.5, 8.0);
	  
	  // SET BASE TERRAIN MIX:
	  rmSetBaseTerrainMix("rockies_snow");
	  
	  // TERRAIN INITIALIZE:
	  rmTerrainInitialize("rockies\groundsnow1_roc", 12);	
	  
	  // SET LIGHTING: // THIS IS PUT AFTER THE TERRAIN IS INITIALIZE:
	  rmSetLightingSet("rockies");
	  
	  // SET THE MAP TYPE:
	  rmSetMapType("rockies");
	  rmSetMapType("land");
	  
	  // SET WORLD CIRCLE CONSTRAINT:
	  rmSetWorldCircleConstraint(true);
	  
	  // REMOVED BY ENSEMBLE:
	  // rmSetMapType("grass");

	  // CHOOSE THE MERCS:
	  chooseMercs();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
      int classPlayer=rmDefineClass("player");
      rmDefineClass("startingUnit");
	  rmDefineClass("socketClass");
	  rmDefineClass("importantItem");
	  rmDefineClass("classForest");
	  rmDefineClass("nuggets");
	  rmDefineClass("classHillArea");
	  rmDefineClass("classSmallHillArea");
	  rmDefineClass("natives");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ******************************************** DEFINE THE CONSTRAINTS: ***************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
      // MAP EDGE CONSTRAINTS:
	  int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
	  int forestEdgeConstraint=rmCreatePieConstraint("forest edge of map", 0.5, 0.5, 0, rmGetMapXSize()-30, 0, 0, 0);
	 
	
	  // PLAYER CONSTRAINTS:
	  int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 10.0);
	  int shortPlayerConstraint=rmCreateClassDistanceConstraint("short stay away from players", classPlayer, 5.0);
	 
	  // RESOURCE AVOIDANCE: (THE FOREST AVOIDANCE)
	  int forestConstraint=rmCreateClassDistanceConstraint("forest vs. things", rmClassID("classForest"), 8.0);
      int forestVsForestConstraint=rmCreateClassDistanceConstraint("forest vs. other forests", rmClassID("classForest"), 20.0);
	  if ( cNumberNonGaiaPlayers < 3 )
	  {
		  forestVsForestConstraint=rmCreateClassDistanceConstraint("forest vs. other forests smaller", rmClassID("classForest"), 10.0);
	  }
	  int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 15.0);
	 	  
	  // RESOURCES AVOIDANCE: (STUFFS AND ANIMALS)
	  int avoidNuggets=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("nuggets"), 30.0);
	  
	  // RESOURCES AVOIDANCE: (TREES)
	  int avoidTrees=rmCreateTypeDistanceConstraint("stuffs avoids trees", ("TreeRockiesSnow"), 5.0);
	  int treesAvoidTrees=rmCreateTypeDistanceConstraint("trees avoids trees", ("TreeRockiesSnow"), 10.0);
	
	  // COIN AVOIDANCE:
	  int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.10));
	  int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoids coin", "gold", 10.0);
	  int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
	  	  
	  // ENEMY AVOIDANCE:
      int avoidHQ=rmCreateTypeDistanceConstraint("stuff avoids towncenter", ("TownCenter"), 12.0);
	  int closeAvoidHQ=rmCreateTypeDistanceConstraint("close stuff avoids towncenter", ("TownCenter"), 6.0);
	  
	  // NATIVES AVOIDANCE:
	  int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 3.0);
	  int closeAvoidNatives=rmCreateClassDistanceConstraint("close stuff avoids natives", rmClassID("natives"), 2.0);
      int avoidCloseNatives=rmCreateClassDistanceConstraint("Gift avoids natives", rmClassID("natives"), 1.0);
 
	  
	   // MUSKETEERS AVOIDANCE:
      int avoidMusket=rmCreateTypeDistanceConstraint("stuff avoids musketeers", ("Musketeer"), 12.0);
	  int closeAvoidMusket=rmCreateTypeDistanceConstraint("close stuff avoids musketeers", ("Musketeer"), 6.0);
		
      // OUTPOST AVOIDANCE:
	  int avoidOutpost=rmCreateTypeDistanceConstraint("stuffs avoids outpost", "Outpost", 10.0);	
		
      // BERRIES AVOIDANCE:
	  int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 10.0);
	  int avoidFarResource=rmCreateTypeDistanceConstraint("far resource no overlap", "resource", 10.0);
	  int startresourceAvoidFarResource=rmCreateTypeDistanceConstraint("resource avoids resource", "resource", 25.0);
      int avoidFruits=rmCreateTypeDistanceConstraint("stuffs avoids berries", "berrybush", 8.0);

      // DEERS AVOIDANCE:
	  int avoidDeer=rmCreateTypeDistanceConstraint("stuffs avoids deers", "deer", 8.0);		  
	
       // AVOID IMPASSABLE LAND:
      int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 8.0);
      int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 4.0);
      	  	
	  // UNIT AVOIDANCE:
      int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 15.0);
      int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
	  
	  // DECORATION AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

	  // AVOID THE HILLY AREAS:
	  int avoidHills = rmCreateClassDistanceConstraint("avoid Hills", rmClassID("classHillArea"), 5.0);
	  int avoidHillsLarge = rmCreateClassDistanceConstraint("avoid Hills by a lot", rmClassID("classHillArea"), 20.0);
	  int avoidSmallHills = rmCreateClassDistanceConstraint("avoid Small Hills", rmClassID("classSmallHillArea"), 20.0);
	  int avoidSmallHillsSmall = rmCreateClassDistanceConstraint("avoid Small Hills by a little", rmClassID("classSmallHillArea"), 2.0);
	  
      // VP AVOIDANCE:
      int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 4.0);
      int avoidImportantItem=rmCreateClassDistanceConstraint("important stuff avoids each other", rmClassID("importantItem"), 25.0);
	  int avoidImportantItemForest=rmCreateClassDistanceConstraint("important stuff avoids each forest", rmClassID("importantItem"), 10.0);

	  int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);
	  
	  // CIRCLE CONSTRAINT:
	  int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// ******************************************** DEFINE THE AREAS: *********************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/	  
// ************************************** SET UP PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
   if ( cNumberTeams > 2 )
   {
		rmSetTeamSpacingModifier(0.75);
		rmSetPlacementSection(0.15, 0.85); // 0.5
		rmPlacePlayersCircular(0.35, 0.35, 0);
   }
   else
   {
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.12, 0.38);
		if ( cNumberNonGaiaPlayers == 2 )
		{
			rmSetPlacementSection(0.20, 0.25);
		}
		rmPlacePlayersCircular(0.35, 0.35, 0);
		
		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.62, 0.88);
		if ( cNumberNonGaiaPlayers == 2 )
		{
			rmSetPlacementSection(0.70, 0.75);
		}
		rmPlacePlayersCircular(0.35, 0.35, 0);
   }
	//	rmPlacePlayersCircular(0.45, 0.45, rmDegreesToRadians(5.0));
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/	  
// ******************************************* SET UP PLAYER AREAS: ********************************************* //
/*================================================================================================================*/
      float playerFraction=rmAreaTilesToFraction(100);
      for(i=1; <cNumberPlayers)
   {
      // CREATE THE AREA:
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
      
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD AREA CONSTRAINT:
	  rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, playerEdgeConstraint); 
	  rmAddAreaConstraint(id, avoidTradeRoute); 
      
	  // SET AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
      
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
   }
      // BUILD THE AREA:
	  rmBuildArea(id);
	  
	  // Build the areas.
      //rmBuildAllAreas();
/*================================================================================================================*/
// ************************************* HILL 2 IS THE CENTRAL "CLIFFY" HILL: *********************************** //
/*================================================================================================================*/
	int centralValleyID=rmCreateArea("center valley");
	rmSetAreaMix(centralValleyID, "rockies_grass");
	rmSetAreaTerrainType(centralValleyID, "rockies\ground4_roc");
	rmAddAreaTerrainLayer(centralValleyID, "rockies\groundsnow6_roc", 0, 2);
	rmAddAreaTerrainLayer(centralValleyID, "rockies\groundsnow7_roc", 2, 5);
	rmAddAreaTerrainLayer(centralValleyID, "rockies\groundsnow8_roc", 5, 8);
	//rmSetAreaSize(centralValleyID, 0.18, 0.18);
	rmSetAreaSize(centralValleyID, 0.25, 0.25);
	rmSetAreaWarnFailure(centralValleyID, false);
	rmSetAreaSmoothDistance(centralValleyID, 12);
	rmSetAreaCliffType(centralValleyID, "rocky mountain2");
	rmSetAreaCliffEdge(centralValleyID, 1, 1.0, 0.0, 0.0, 0);
	rmSetAreaCliffHeight(centralValleyID, -8, 2.0, 0.3);
	rmSetAreaCoherence(centralValleyID, 0.8);
	rmSetAreaHeightBlend(centralValleyID, 1);
	if ( cNumberTeams == 2 )
	{
		//rmAddAreaCliffWaypoint(centralValleyID, 0.5, 0.2);
		rmAddAreaCliffWaypoint(centralValleyID, 0.5, 0.3);
		rmAddAreaCliffWaypoint(centralValleyID, 0.5, 0.7);
		//rmAddAreaCliffRandomWaypoints(centralValleyID, 0.5, 0.8, 8, 20.0);
	}
	else
	{
		rmAddAreaCliffWaypoint(centralValleyID, 0.5, 0.35);
		rmAddAreaCliffRandomWaypoints(centralValleyID, 0.5, 0.65, 8, 20.0);
	}
	rmSetAreaCliffPainting(centralValleyID, true, false, true);
	rmAddAreaToClass(centralValleyID, rmClassID("classHillArea"));
	rmBuildArea(centralValleyID);	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/	  
// **************************************** DEFINE THE PLACEMENT ORDER: ***************************************** //
/*================================================================================================================*/
   // PLACEMENT ORDER:
   // TRADE ROUTE -> NATIVES -> SECRETS -> NUGGETS -> ??
/*================================================================================================================*/
// ***************************************** DEFINE THE TRADE ROUTES: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE AND PLACE THE FOUR TRADE ROUTES: ********************************** //
/*================================================================================================================*/
	int tradeRouteID = rmCreateTradeRoute();
		
	//rmAddTradeRouteWaypoint(tradeRouteID, 0.8, 1.0);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.45, 0.70);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.45, 0.55);
	
	bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
    if(placedTradeRoute == false)
	rmEchoError("Failed to place trade route #1");
/*----------------------------------------------------------------------------------------------------------------*/
	int tradeRouteID2 = rmCreateTradeRoute();
	
	//rmAddTradeRouteWaypoint(tradeRouteID2, 0.2, 0.0);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.55, 0.70);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.55, 0.55);
		
	bool placedTradeRoute2 = rmBuildTradeRoute(tradeRouteID2, "carolinas\trade_route");
	if(placedTradeRoute2 == false)
	rmEchoError("Failed to place trade route #2");
/*================================================================================================================*/
    int tradeRouteID3 = rmCreateTradeRoute();
	
	//rmAddTradeRouteWaypoint(tradeRouteID3, 0.2, 0.0);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.45, 0.45);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.45, 0.25);
		
	bool placedTradeRoute3 = rmBuildTradeRoute(tradeRouteID3, "carolinas\trade_route");
	if(placedTradeRoute3 == false)
	rmEchoError("Failed to place trade route #3");	
/*================================================================================================================*/
    int tradeRouteID4 = rmCreateTradeRoute();
	
	//rmAddTradeRouteWaypoint(tradeRouteID4, 0.2, 0.0);
	rmAddTradeRouteWaypoint(tradeRouteID4, 0.60, 0.45);
	rmAddTradeRouteWaypoint(tradeRouteID4, 0.60, 0.25);
		
	bool placedTradeRoute4 = rmBuildTradeRoute(tradeRouteID4, "carolinas\trade_route");
	if(placedTradeRoute4 == false)
	rmEchoError("Failed to place trade route #4");	
/*----------------------------------------------------------------------------------------------------------------*/
	// Trade sockets
   int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
   rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
   rmSetObjectDefAllowOverlap(socketID, true);
   rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
   rmSetObjectDefMinDistance(socketID, 0.0);
   rmSetObjectDefMaxDistance(socketID, 6.0);
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************** add the meeting poles along the trade route. ****************************** //
/*----------------------------------------------------------------------------------------------------------------*/
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
   vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.15);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.85);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   
   rmClearClosestPointConstraints();
/*----------------------------------------------------------------------------------------------------------------*/
   // change the trade route for the new sockets
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID2);
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.15);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.85);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   rmClearClosestPointConstraints();
/*================================================================================================================*/
   // change the trade route for the new sockets
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID3);
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3, 0.15);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3, 0.85);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   rmClearClosestPointConstraints(); 
/*================================================================================================================*/
   // change the trade route for the new sockets
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID4);
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.15);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.85);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   rmClearClosestPointConstraints();      
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/	  
// *************************************** DEFINE THE NATIVE AMERICANS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
       if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois1VillageID, rmXFractionToMeters(0.5));
		//rmAddGroupingConstraint(iroquois1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois1VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.10, 0.60);
	} 

	if (subCiv1 == rmGetCivID("iroquois"))
	{  
		int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois2VillageID, rmXFractionToMeters(0.5));
		//rmAddGroupingConstraint(iroquois2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.70, 0.15);
	} 

	if (subCiv2 == rmGetCivID("iroquois"))
	{  
		int iroquois3VillageID = -1;
		iroquois3VillageID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois3VillageID, rmXFractionToMeters(0.5));
		//rmAddGroupingConstraint(iroquois3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois3VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois3VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.925, 0.35);
	}

	if (subCiv3 == rmGetCivID("iroquois"))
	{  
		int iroquois4VillageID = -1;
		iroquois4VillageID = rmCreateGrouping("iroquois village 4", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois4VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois4VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois4VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois4VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois4VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.335, 0.9);
	} 
	
	    if (subCiv4 == rmGetCivID("iroquois"))
	{  
		int iroquois5VillageID = -1;
		iroquois5VillageID = rmCreateGrouping("iroquois village 5", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois5VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois5VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois5VillageID, rmXFractionToMeters(0.5));
		//rmAddGroupingConstraint(iroquois5VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois5VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois5VillageID, avoidSocket);
		//rmPlaceGroupingAtLoc(iroquois5VillageID, 0, 0.5, 0.06);
		rmPlaceGroupingAtLoc(iroquois5VillageID, 0, 0.20, 0.17);
	} 

	    if (subCiv5 == rmGetCivID("iroquois"))
	{  
		int iroquois6VillageID = -1;
		iroquois6VillageID = rmCreateGrouping("iroquois village 6", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois6VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois6VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois6VillageID, rmXFractionToMeters(0.5));
		//rmAddGroupingConstraint(iroquois6VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois6VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois6VillageID, avoidSocket);
		rmPlaceGroupingAtLoc(iroquois6VillageID, 0, 0.70, 0.9);
	} 
/*================================================================================================================*/
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/	  
// ****************************** DEFINE THE STARTING TCID AND STARTING UNITS: ********************************** //
/*================================================================================================================*/
   	  // DEFINE THE STARTING TCID:
	  int startingTCID= rmCreateObjectDef("startingTC");
	  if ( rmGetNomadStart())
	  {
		  rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	  }
	  else
	  {
		  rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	  }
	  rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	  rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
	  rmSetObjectDefMinDistance(startingTCID, 0.0);
	  rmSetObjectDefMaxDistance(startingTCID, 16.0);

      // DEFINE THE STARTING UNITS:
	  int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	  rmSetObjectDefMinDistance(startingUnits, 5.0);
	  rmSetObjectDefMaxDistance(startingUnits, 8.0);
	  rmAddObjectDefConstraint(startingUnits, avoidStartingUnitsSmall);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/	  
// ************************************** DEFINE THE STARTING RESOURCES: **************************************** //	
/*================================================================================================================*/
	  // DEFINE THE STARTING TREES:
	  int StartAreaTreeID=rmCreateObjectDef("starting trees");
	  rmAddObjectDefItem(StartAreaTreeID, "TreeRockiesSnow", 1, 0.0);
	  rmSetObjectDefMinDistance(StartAreaTreeID, 12.0);
	  rmSetObjectDefMaxDistance(StartAreaTreeID, 20.0);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
	  
	  // DEFINE THE STARTING BERRIES:
	  int StartBerriesID=rmCreateObjectDef("starting berries");
	  rmAddObjectDefItem(StartBerriesID, "berrybush", 3, 5.0);
	  rmSetObjectDefMinDistance(StartBerriesID, 14);
	  rmSetObjectDefMaxDistance(StartBerriesID, 18);
	  rmAddObjectDefConstraint(StartBerriesID, avoidStartResource);
	  //rmAddObjectDefConstraint(StartBerriesID, shortAvoidImpassableLand);
	  rmAddObjectDefConstraint(StartBerriesID, avoidStartingUnitsSmall);
	  rmAddObjectDefConstraint(StartBerriesID, shortPlayerConstraint);
	  
	  // DEFINE THE STARTING FARBERRIES:
	  int FarBerriesID=rmCreateObjectDef("starting Far Berries");
	  rmAddObjectDefItem(FarBerriesID, "berrybush", 3, 5.0);
	  rmSetObjectDefMinDistance(FarBerriesID, 22);
	  rmSetObjectDefMaxDistance(FarBerriesID, 26);
	  rmAddObjectDefConstraint(FarBerriesID, avoidFarResource);
	  rmAddObjectDefConstraint(FarBerriesID, startresourceAvoidFarResource);
	  //rmAddObjectDefConstraint(FarBerriesID, shortAvoidImpassableLand);
	  rmAddObjectDefConstraint(FarBerriesID, avoidStartingUnitsSmall);
	  rmAddObjectDefConstraint(FarBerriesID, shortPlayerConstraint);

	  // DEFINE THE STARTING BIGHORNS:
	  int StartBighornID=rmCreateObjectDef("starting bighorn");
	  rmAddObjectDefItem(StartBighornID, "bighornsheep", 5, 4.0);
	  rmSetObjectDefMinDistance(StartBighornID, 9.0);
	  rmSetObjectDefMaxDistance(StartBighornID, 13.0);
	  rmSetObjectDefCreateHerd(StartBighornID, true);
	  rmAddObjectDefConstraint(StartBighornID, avoidStartingUnitsSmall);

	  // DEFINE THE PLAYER NUGGETS:
	  int playerNuggetID=rmCreateObjectDef("player nugget");
	  rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	  rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
	  rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
      rmSetObjectDefMinDistance(playerNuggetID, 30.0);
      rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	  rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	  rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
	  rmAddObjectDefConstraint(playerNuggetID, avoidNuggets);
	  rmAddObjectDefConstraint(playerNuggetID, forestEdgeConstraint);	// Pushing the nuggets away from the cliffs at the edge.
	  rmAddObjectDefConstraint(playerNuggetID, circleConstraint);

	  // DEFINE THE SILVER MINES:
	  int playerGoldID=rmCreateObjectDef("player silver ore");
	  int silverType = rmRandInt(1,10);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/	  
// ********************* PLACING THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************* //
/*================================================================================================================*/
 	    for(i=1; <cNumberPlayers)
	{
		// PLACING THE STARTING TCID AND STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		// vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
		// rmSetHomeCityGatherPoint(i, closestPoint);
		
		// PLACING THE STARTING BERRIES:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(FarBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// EVERYONE GETS TWO ORE GROUPINGS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddGroupingToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidCoin);
		rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING STARTING PRONGHORNS:
		rmPlaceObjectDefAtLoc(StartBighornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		// rmPlaceObjectDefAtLoc(StartBighornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		// rmPlaceObjectDefAtLoc(StartBighornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		// rmPlaceObjectDefAtLoc(StartBighornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE SILVER MINES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/	  
// ************************************** DEFINE AND PLACE THE FORESTS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FORESTS NUMBER 1: ************************************ //
/*================================================================================================================*/
      int forestTreeID = 0;
      int numTries=0.5*cNumberNonGaiaPlayers;
      int failCount=0;

      for (i=0; <numTries)
   {   
      int forest=rmCreateArea("forest "+i);
	  rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
      //rmSetAreaForestType(forest, "new england forest");
	  rmSetAreaForestType(forest, "rockies snow forest");
      rmSetAreaForestDensity(forest, 1.0);
      rmSetAreaForestClumpiness(forest, 1.0);
      rmSetAreaForestUnderbrush(forest, 0.0);
      rmSetAreaCoherence(forest, 0.4);
      rmSetAreaSmoothDistance(forest, 10);
      rmAddAreaToClass(forest, rmClassID("classForest")); 
      //rmAddAreaConstraint(forest, forestConstraint);
      //rmAddAreaConstraint(forest, avoidAll);
      //rmAddAreaConstraint(forest, avoidImpassableLand); 
      //rmAddAreaConstraint(forest, avoidTradeRoute);
	  //rmAddAreaConstraint(forest, avoidStartingUnits);
	  //rmAddAreaConstraint(forest, avoidSocket);
	  rmAddAreaConstraint(forest, avoidCoin);
	  rmAddAreaConstraint(forest, avoidHills);
	  rmAddAreaConstraint(forest, avoidNatives);
	  //rmAddAreaConstraint(forest, avoidSheep);
	  rmSetAreaLocation(forest, 0.25, 0.25); 
	  if(rmBuildArea(forest)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
      }
         else
         failCount=0; 
   } 
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FORESTS NUMBER 2: ************************************ //
/*================================================================================================================*/
      //int forestTreeID = 0;
      //int numTries=6*cNumberNonGaiaPlayers;
      failCount=0;

      for (i=0; <numTries)
   {   
      int forest2=rmCreateArea("forest 2"+i);
      rmSetAreaWarnFailure(forest2, false);
      rmSetAreaSize(forest2, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
      //rmSetAreaForestType(forest2, "new england forest");
	  rmSetAreaForestType(forest2, "rockies snow forest");
      rmSetAreaForestDensity(forest2, 1.0);
      rmSetAreaForestClumpiness(forest2, 1.0);
      rmSetAreaForestUnderbrush(forest2, 0.0);
      rmSetAreaCoherence(forest2, 0.4);
      rmSetAreaSmoothDistance(forest2, 10);
      rmAddAreaToClass(forest2, rmClassID("classForest")); 
      rmAddAreaConstraint(forest2, forestConstraint);
      //rmAddAreaConstraint(forest2, avoidAll);
      //rmAddAreaConstraint(forest2, avoidImpassableLand); 
      //rmAddAreaConstraint(forest2, avoidTradeRoute);
	  //rmAddAreaConstraint(forest2, avoidStartingUnits);
	  //rmAddAreaConstraint(forest2, avoidSocket);
	  rmAddAreaConstraint(forest2, avoidCoin);
	  //rmAddAreaConstraint(forest2, avoidNatives);
	  //rmAddAreaConstraint(forest2, avoidSheep);
	  rmSetAreaLocation(forest2, 0.20, 0.70); 
	  if(rmBuildArea(forest2)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
      }
         else
         failCount=0; 
   } 
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FORESTS NUMBER 3: ************************************ //
/*================================================================================================================*/
      //int forestTreeID = 0;
      //int numTries=6*cNumberNonGaiaPlayers;
      failCount=0;

      for (i=0; <numTries)
   {   
      int forest3=rmCreateArea("forest 3"+i);
      rmSetAreaWarnFailure(forest3, false);
      rmSetAreaSize(forest3, rmAreaTilesToFraction(300), rmAreaTilesToFraction(300));
      //rmSetAreaForestType(forest3, "new england forest");
	  rmSetAreaForestType(forest3, "rockies forest");
      rmSetAreaForestDensity(forest3, 1.0);
      rmSetAreaForestClumpiness(forest3, 1.0);
      rmSetAreaForestUnderbrush(forest3, 0.0);
      rmSetAreaCoherence(forest3, 0.4);
      rmSetAreaSmoothDistance(forest3, 10);
      rmAddAreaToClass(forest3, rmClassID("classForest")); 
      rmAddAreaConstraint(forest3, forestConstraint);
      //rmAddAreaConstraint(forest3, avoidAll);
      //rmAddAreaConstraint(forest3, avoidImpassableLand); 
      rmAddAreaConstraint(forest3, avoidTradeRoute);
	  //rmAddAreaConstraint(forest3, avoidStartingUnits);
	  rmAddAreaConstraint(forest3, avoidSocket);
	  rmAddAreaConstraint(forest3, avoidCoin);
	  //rmAddAreaConstraint(forest3, avoidNatives);
	  //rmAddAreaConstraint(forest3, avoidSheep);
	  rmSetAreaLocation(forest3, 0.5, 0.80); 
	  if(rmBuildArea(forest3)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
      }
         else
         failCount=0; 
   } 
   
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FORESTS NUMBER 4: ************************************ //
/*================================================================================================================*/
      //int forestTreeID = 0;
      //int numTries=6*cNumberNonGaiaPlayers;
      failCount=0;

      for (i=0; <numTries)
   {   
      int forest4=rmCreateArea("forest 4"+i);
      rmSetAreaWarnFailure(forest4, false);
      rmSetAreaSize(forest4, rmAreaTilesToFraction(300), rmAreaTilesToFraction(300));
      //rmSetAreaForestType(forest4, "new england forest");
	  rmSetAreaForestType(forest4, "rockies forest");
      rmSetAreaForestDensity(forest4, 1.0);
      rmSetAreaForestClumpiness(forest4, 1.0);
      rmSetAreaForestUnderbrush(forest4, 0.0);
      rmSetAreaCoherence(forest4, 0.4);
      rmSetAreaSmoothDistance(forest4, 10);
      rmAddAreaToClass(forest4, rmClassID("classForest")); 
      rmAddAreaConstraint(forest4, forestConstraint);
      //rmAddAreaConstraint(forest4, avoidAll);
      //rmAddAreaConstraint(forest4, avoidImpassableLand); 
      rmAddAreaConstraint(forest4, avoidTradeRoute);
	  //rmAddAreaConstraint(forest4, avoidStartingUnits);
	  rmAddAreaConstraint(forest4, avoidSocket);
	  rmAddAreaConstraint(forest4, avoidCoin);
	  //rmAddAreaConstraint(forest4, avoidNatives);
	  //rmAddAreaConstraint(forest4, avoidSheep);
	  rmSetAreaLocation(forest4, 0.5, 0.20); 
	  if(rmBuildArea(forest4)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
      }
         else
         failCount=0; 
   } 
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FORESTS NUMBER 5: ************************************ //
/*================================================================================================================*/
      //int forestTreeID = 0;
      //int numTries=6*cNumberNonGaiaPlayers;
      failCount=0;

      for (i=0; <numTries)
   {   
      int forest5=rmCreateArea("forest 5"+i);
      rmSetAreaWarnFailure(forest5, false);
      rmSetAreaSize(forest5, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
      //rmSetAreaForestType(forest5, "new england forest");
	  rmSetAreaForestType(forest5, "rockies snow forest");
      rmSetAreaForestDensity(forest5, 1.0);
      rmSetAreaForestClumpiness(forest5, 1.0);
      rmSetAreaForestUnderbrush(forest5, 0.0);
      rmSetAreaCoherence(forest5, 0.4);
      rmSetAreaSmoothDistance(forest5, 10);
      rmAddAreaToClass(forest5, rmClassID("classForest")); 
      rmAddAreaConstraint(forest5, forestConstraint);
      //rmAddAreaConstraint(forest5, avoidAll);
      //rmAddAreaConstraint(forest5, avoidImpassableLand); 
      //rmAddAreaConstraint(forest5, avoidTradeRoute);
	  //rmAddAreaConstraint(forest5, avoidStartingUnits);
	  //rmAddAreaConstraint(forest5, avoidSocket);
	  rmAddAreaConstraint(forest5, avoidCoin);
	  rmAddAreaConstraint(forest5, avoidHills);
	  //rmAddAreaConstraint(forest5, avoidNatives);
	  //rmAddAreaConstraint(forest5, avoidSheep);
	  rmSetAreaLocation(forest5, 0.75, 0.35); 
	  if(rmBuildArea(forest5)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
      }
         else
         failCount=0; 
   }  
/*================================================================================================================*/
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FORESTS NUMBER 6: ************************************ //
/*================================================================================================================*/
      //int forestTreeID = 0;
      //int numTries=6*cNumberNonGaiaPlayers;
      failCount=0;

      for (i=0; <numTries)
   {   
      int forest6=rmCreateArea("forest 6"+i);
      rmSetAreaWarnFailure(forest6, false);
      rmSetAreaSize(forest6, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
      //rmSetAreaForestType(forest6, "rockies forest");
	  rmSetAreaForestType(forest6, "rockies snow forest");
      rmSetAreaForestDensity(forest6, 1.0);
      rmSetAreaForestClumpiness(forest6, 1.0);
      rmSetAreaForestUnderbrush(forest6, 0.0);
      rmSetAreaCoherence(forest6, 0.4);
      rmSetAreaSmoothDistance(forest6, 10);
      rmAddAreaToClass(forest6, rmClassID("classForest")); 
      rmAddAreaConstraint(forest6, forestConstraint);
      //rmAddAreaConstraint(forest6, avoidAll);
      //rmAddAreaConstraint(forest6, avoidImpassableLand); 
      //rmAddAreaConstraint(forest6, avoidTradeRoute);
	  rmAddAreaConstraint(forest6, avoidHills);
	  rmAddAreaConstraint(forest6, avoidFruits);
	  rmAddAreaConstraint(forest6, avoidCoin);
	  //rmAddAreaConstraint(forest6, avoidNatives);
	  rmAddAreaConstraint(forest6, avoidDeer);
	  rmSetAreaLocation(forest6, 0.75, 0.75); 
	  if(rmBuildArea(forest6)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
      }
         else
         failCount=0; 
   }      
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ***************************** BIGHORN - TWO GROUPS (ONE ON EACH SIDE PER PLAYER) ***************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ********************************* PRONGHORN SHEEP DOWN IN THE (CENTER) VALLEY: ******************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    // DEER HERD 1:
	int deerID=rmCreateObjectDef("deer herd 1");
	rmAddObjectDefItem(deerID, "deer", rmRandInt(7,9), 6);
	rmSetObjectDefMinDistance(deerID, 0.0);
	rmSetObjectDefMaxDistance(deerID, 0.0);
	rmAddObjectDefConstraint(deerID, avoidDeer);
	rmSetObjectDefCreateHerd(deerID, true);
	rmPlaceObjectDefAtLoc(deerID, 0, 0.175, 0.60);
	rmPlaceObjectDefAtLoc(deerID, 0, 0.90, 0.275);
	rmPlaceObjectDefAtLoc(deerID, 0, 0.75, 0.175);
	rmPlaceObjectDefAtLoc(deerID, 0, 0.275, 0.9);
	rmPlaceObjectDefAtLoc(deerID, 0, 0.26, 0.12);
	rmPlaceObjectDefAtLoc(deerID, 0, 0.75, 0.875);
	
	// NUGGET 1:
	int nuggetID=rmCreateObjectDef("nugget 1");
	rmAddObjectDefItem(nuggetID, "nugget", 1, 0.0);
	rmSetObjectDefMinDistance(nuggetID, 0.0);
	rmSetObjectDefMaxDistance(nuggetID, 0.0);
	rmAddObjectDefConstraint(nuggetID, avoidDeer);
	rmPlaceObjectDefAtLoc(nuggetID, 0, 0.175, 0.55);
	rmPlaceObjectDefAtLoc(nuggetID, 0, 0.85, 0.275);
	rmPlaceObjectDefAtLoc(nuggetID, 0, 0.65, 0.08);
	rmPlaceObjectDefAtLoc(nuggetID, 0, 0.285, 0.85);
	rmPlaceObjectDefAtLoc(nuggetID, 0, 0.31, 0.10);
	rmPlaceObjectDefAtLoc(nuggetID, 0, 0.60, 0.95);
	
	// SILVER MINE:
	int silver9ID=rmCreateObjectDef("Silver 9");
	rmAddObjectDefItem(silver9ID, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(silver9ID, 0.0);
	rmSetObjectDefMaxDistance(silver9ID, 0.0);
	rmAddObjectDefConstraint(silver9ID, avoidCoin);
	rmPlaceObjectDefAtLoc(silver9ID, 0, 0.225, 0.55);
	rmPlaceObjectDefAtLoc(silver9ID, 0, 0.925, 0.40);
	rmPlaceObjectDefAtLoc(silver9ID, 0, 0.80, 0.16);
	rmPlaceObjectDefAtLoc(silver9ID, 0, 0.395, 0.925);
	rmPlaceObjectDefAtLoc(silver9ID, 0, 0.35, 0.10);
	rmPlaceObjectDefAtLoc(silver9ID, 0, 0.64, 0.9);
	
	// BERRIES:
	int berries5ID=rmCreateObjectDef("Berries 5");
	rmAddObjectDefItem(berries5ID, "berrybush", 3, 4.0);
	rmSetObjectDefMinDistance(berries5ID, 0.0);
	rmSetObjectDefMaxDistance(berries5ID, 0.0);
	rmAddObjectDefConstraint(berries5ID, avoidFruits);
	rmPlaceObjectDefAtLoc(berries5ID, 0, 0.10, 0.65);
	rmPlaceObjectDefAtLoc(berries5ID, 0, 0.875, 0.40);
	rmPlaceObjectDefAtLoc(berries5ID, 0, 0.60, 0.06);
	rmPlaceObjectDefAtLoc(berries5ID, 0, 0.40, 0.94);
	rmPlaceObjectDefAtLoc(berries5ID, 0, 0.14, 0.21);
	rmPlaceObjectDefAtLoc(berries5ID, 0, 0.80, 0.825);
	
	
	
	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE DOMESTIC ANIMALS: ************************************ //   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    //int BaseID=rmCreateObjectDef("The TownCenter");
	int BaseID=rmCreateObjectDef("The FortFrontier");
	//rmAddObjectDefItem(BaseID, "TownCenter", 1, 0.0);
	rmAddObjectDefItem(BaseID, "FortFrontier", 1, 0.0);
	rmSetObjectDefMinDistance(BaseID, 0.0);
	rmSetObjectDefMaxDistance(BaseID, 0.0);
	rmAddObjectDefConstraint(BaseID, avoidHQ);
	rmPlaceObjectDefAtLoc(BaseID, 0, 0.5, 0.5);
		
	int outpost1ID=rmCreateObjectDef("The Outpost1");
	rmAddObjectDefItem(outpost1ID, "Outpost", 1, 0.0);
	//rmAddObjectDefItem(outpost1ID, "mine", 1, 10.0);
	rmSetObjectDefMinDistance(outpost1ID, 0.0);
	rmSetObjectDefMaxDistance(outpost1ID, 0.0);
	rmAddObjectDefConstraint(outpost1ID, avoidHQ);
	rmPlaceObjectDefAtLoc(outpost1ID, 0, 0.5, 0.55);
	
	int silver1ID=rmCreateObjectDef("Silver 1");
	rmAddObjectDefItem(silver1ID, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(silver1ID, 0.0);
	rmSetObjectDefMaxDistance(silver1ID, 0.0);
	rmAddObjectDefConstraint(silver1ID, avoidCoin);
	rmAddObjectDefConstraint(silver1ID, avoidHQ);
	rmPlaceObjectDefAtLoc(silver1ID, 0, 0.50, 0.60);
	
	int outpost2ID=rmCreateObjectDef("The Outpost2");
	rmAddObjectDefItem(outpost2ID, "Outpost", 1, 0.0);
	//rmAddObjectDefItem(outpost2ID, "mine", 1, 10.0);
	rmSetObjectDefMinDistance(outpost2ID, 0.0);
	rmSetObjectDefMaxDistance(outpost2ID, 0.0);
	rmAddObjectDefConstraint(outpost2ID, avoidHQ);
	rmPlaceObjectDefAtLoc(outpost2ID, 0, 0.5, 0.45);
	
	int silver2ID=rmCreateObjectDef("Silver 2");
	rmAddObjectDefItem(silver2ID, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(silver2ID, 0.0);
	rmSetObjectDefMaxDistance(silver2ID, 0.0);
	rmAddObjectDefConstraint(silver2ID, avoidCoin);
	rmAddObjectDefConstraint(silver2ID, avoidHQ);
	rmPlaceObjectDefAtLoc(silver2ID, 0, 0.50, 0.40);
	
	int outpost3ID=rmCreateObjectDef("The Outpost3");
	rmAddObjectDefItem(outpost3ID, "Outpost", 1, 0.0);
	//rmAddObjectDefItem(outpost3ID, "mine", 1, 10.0);
	rmSetObjectDefMinDistance(outpost3ID, 0.0);
	rmSetObjectDefMaxDistance(outpost3ID, 0.0);
	rmAddObjectDefConstraint(outpost3ID, avoidHQ);
	rmPlaceObjectDefAtLoc(outpost3ID, 0, 0.45, 0.5);
	
	int silver3ID=rmCreateObjectDef("Silver 3");
	rmAddObjectDefItem(silver3ID, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(silver3ID, 0.0);
	rmSetObjectDefMaxDistance(silver3ID, 0.0);
	rmAddObjectDefConstraint(silver3ID, avoidHQ);
	rmPlaceObjectDefAtLoc(silver3ID, 0, 0.40, 0.5);
	
	int outpost4ID=rmCreateObjectDef("The Outpost4");
	rmAddObjectDefItem(outpost4ID, "Outpost", 1, 0.0);
	//rmAddObjectDefItem(outpost4ID, "mine", 1, 10.0);
	rmSetObjectDefMinDistance(outpost4ID, 0.0);
	rmSetObjectDefMaxDistance(outpost4ID, 0.0);
	rmAddObjectDefConstraint(outpost4ID, avoidHQ);
	rmPlaceObjectDefAtLoc(outpost4ID, 0, 0.55, 0.5);
	
	int silver4ID=rmCreateObjectDef("Silver 4");
	rmAddObjectDefItem(silver4ID, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(silver4ID, 0.0);
	rmSetObjectDefMaxDistance(silver4ID, 0.0);
	rmAddObjectDefConstraint(silver4ID, avoidHQ);
	rmPlaceObjectDefAtLoc(silver4ID, 0, 0.60, 0.5);
	
	int explorerID=rmCreateObjectDef("The Explorer");
	rmAddObjectDefItem(explorerID, "Explorer", 1, 4.0);
	rmSetObjectDefMinDistance(explorerID, 8.0);
	rmSetObjectDefMaxDistance(explorerID, 12.0);
	rmAddObjectDefConstraint(explorerID, closeAvoidHQ);
	rmPlaceObjectDefAtLoc(explorerID, 0, 0.525, 0.525);
	
	int soldier1ID=rmCreateObjectDef("Musketeers 1");
	rmAddObjectDefItem(soldier1ID, "Musketeer", rmRandInt(15,20), 8.0);
	rmSetObjectDefMinDistance(soldier1ID, 0.0);
	rmSetObjectDefMaxDistance(soldier1ID, 0.0);
	rmAddObjectDefConstraint(soldier1ID, avoidMusket);
	rmAddObjectDefConstraint(soldier1ID, avoidSocket);
	rmPlaceObjectDefAtLoc(soldier1ID, 0, 0.40, 0.60);
	
	int soldier2ID=rmCreateObjectDef("Musketeers 2");
	rmAddObjectDefItem(soldier2ID, "Musketeer", rmRandInt(15,20), 8.0);
	rmSetObjectDefMinDistance(soldier2ID, 0.0);
	rmSetObjectDefMaxDistance(soldier2ID, 0.0);
	rmAddObjectDefConstraint(soldier2ID, avoidMusket);
	rmAddObjectDefConstraint(soldier2ID, avoidSocket);
	rmPlaceObjectDefAtLoc(soldier2ID, 0, 0.60, 0.60);
	
	int soldier3ID=rmCreateObjectDef("Musketeers 3");
	rmAddObjectDefItem(soldier3ID, "Musketeer", rmRandInt(15,20), 8.0);
	rmSetObjectDefMinDistance(soldier3ID, 0.0);
	rmSetObjectDefMaxDistance(soldier3ID, 0.0);
	rmAddObjectDefConstraint(soldier3ID, avoidMusket);
	rmAddObjectDefConstraint(soldier3ID, avoidSocket);
	rmPlaceObjectDefAtLoc(soldier3ID, 0, 0.40, 0.40);
	
	int soldier4ID=rmCreateObjectDef("Musketeers 4");
	rmAddObjectDefItem(soldier4ID, "Musketeer", rmRandInt(15,20), 8.0);
	rmSetObjectDefMinDistance(soldier4ID, 0.0);
	rmSetObjectDefMaxDistance(soldier4ID, 0.0);
	rmAddObjectDefConstraint(soldier4ID, avoidMusket);
	rmAddObjectDefConstraint(soldier4ID, avoidSocket);
	rmPlaceObjectDefAtLoc(soldier4ID, 0, 0.60, 0.40);
	
	int berries1ID=rmCreateObjectDef("Berries 1");
	rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
	rmSetObjectDefMinDistance(berries1ID, 0.0);
	rmSetObjectDefMaxDistance(berries1ID, 0.0);
	rmAddObjectDefConstraint(berries1ID, avoidFruits);
	rmPlaceObjectDefAtLoc(berries1ID, 0, 0.40, 0.45);
	
	int berries2ID=rmCreateObjectDef("Berries 2");
	rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
	rmSetObjectDefMinDistance(berries2ID, 0.0);
	rmSetObjectDefMaxDistance(berries2ID, 0.0);
	rmAddObjectDefConstraint(berries2ID, avoidFruits);
	rmPlaceObjectDefAtLoc(berries2ID, 0, 0.60, 0.45);
	
	int berries3ID=rmCreateObjectDef("Berries 3");
	rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(3,5), 4.0);
	rmSetObjectDefMinDistance(berries3ID, 0.0);
	rmSetObjectDefMaxDistance(berries3ID, 0.0);
	rmAddObjectDefConstraint(berries3ID, avoidFruits);
	rmPlaceObjectDefAtLoc(berries3ID, 0, 0.40, 0.55);
	
	int berries4ID=rmCreateObjectDef("Berries 4");
	rmAddObjectDefItem(berries4ID, "berrybush", rmRandInt(3,5), 4.0);
	rmSetObjectDefMinDistance(berries4ID, 0.0);
	rmSetObjectDefMaxDistance(berries4ID, 0.0);
	rmAddObjectDefConstraint(berries4ID, avoidFruits);
	rmPlaceObjectDefAtLoc(berries4ID, 0, 0.60, 0.55);
	
	int outpost5ID=rmCreateObjectDef("Outpost 5");
	rmAddObjectDefItem(outpost5ID, "Outpost", 1, 0.0);
	rmSetObjectDefMinDistance(outpost5ID, 0.0);
	rmSetObjectDefMaxDistance(outpost5ID, 0.0);
	rmAddObjectDefConstraint(outpost5ID, avoidOutpost);
	rmPlaceObjectDefAtLoc(outpost5ID, 0, 0.40, 0.65);
	
	int outpost6ID=rmCreateObjectDef("Outpost 6");
	rmAddObjectDefItem(outpost6ID, "Outpost", 1, 0.0);
	rmSetObjectDefMinDistance(outpost6ID, 0.0);
	rmSetObjectDefMaxDistance(outpost6ID, 0.0);
	rmAddObjectDefConstraint(outpost6ID, avoidOutpost);
	rmPlaceObjectDefAtLoc(outpost6ID, 0, 0.60, 0.65);
	
	int outpost7ID=rmCreateObjectDef("Outpost 7");
	rmAddObjectDefItem(outpost7ID, "Outpost", 1, 0.0);
	rmSetObjectDefMinDistance(outpost7ID, 0.0);
	rmSetObjectDefMaxDistance(outpost7ID, 0.0);
	rmAddObjectDefConstraint(outpost7ID, avoidOutpost);
	rmPlaceObjectDefAtLoc(outpost7ID, 0, 0.40, 0.35);
	
	int outpost8ID=rmCreateObjectDef("Outpost 8");
	rmAddObjectDefItem(outpost8ID, "Outpost", 1, 0.0);
	rmSetObjectDefMinDistance(outpost8ID, 0.0);
	rmSetObjectDefMaxDistance(outpost8ID, 0.0);
	rmAddObjectDefConstraint(outpost8ID, avoidOutpost);
	rmPlaceObjectDefAtLoc(outpost8ID, 0, 0.60, 0.35);
	
	int outpost9ID=rmCreateObjectDef("Outpost 9");
	rmAddObjectDefItem(outpost9ID, "Outpost", 1, 0.0);
	rmSetObjectDefMinDistance(outpost9ID, 0.0);
	rmSetObjectDefMaxDistance(outpost9ID, 0.0);
	rmAddObjectDefConstraint(outpost9ID, avoidOutpost);
	rmPlaceObjectDefAtLoc(outpost9ID, 0, 0.50, 0.35);
	
	int outpost10ID=rmCreateObjectDef("Outpost 10");
	rmAddObjectDefItem(outpost10ID, "Outpost", 1, 0.0);
	rmSetObjectDefMinDistance(outpost10ID, 0.0);
	rmSetObjectDefMaxDistance(outpost10ID, 0.0);
	rmAddObjectDefConstraint(outpost10ID, avoidOutpost);
	rmPlaceObjectDefAtLoc(outpost10ID, 0, 0.50, 0.65);
	
	int soldier5ID=rmCreateObjectDef("Musketeers 5");
	rmAddObjectDefItem(soldier5ID, "Musketeer", rmRandInt(15,20), 8.0);
	rmSetObjectDefMinDistance(soldier5ID, 0.0);
	rmSetObjectDefMaxDistance(soldier5ID, 0.0);
	rmAddObjectDefConstraint(soldier5ID, avoidMusket);
	rmAddObjectDefConstraint(soldier5ID, avoidSocket);
	rmPlaceObjectDefAtLoc(soldier5ID, 0, 0.40, 0.70);
	
	int soldier6ID=rmCreateObjectDef("Musketeers 6");
	rmAddObjectDefItem(soldier6ID, "Musketeer", rmRandInt(15,20), 8.0);
	rmSetObjectDefMinDistance(soldier6ID, 0.0);
	rmSetObjectDefMaxDistance(soldier6ID, 0.0);
	rmAddObjectDefConstraint(soldier6ID, avoidMusket);
	rmAddObjectDefConstraint(soldier6ID, avoidSocket);
	rmPlaceObjectDefAtLoc(soldier6ID, 0, 0.50, 0.70);
	
	int soldier7ID=rmCreateObjectDef("Musketeers 7");
	rmAddObjectDefItem(soldier7ID, "Musketeer", rmRandInt(15,20), 8.0);
	rmSetObjectDefMinDistance(soldier7ID, 0.0);
	rmSetObjectDefMaxDistance(soldier7ID, 0.0);
	rmAddObjectDefConstraint(soldier7ID, avoidMusket);
	rmAddObjectDefConstraint(soldier7ID, avoidSocket);
	rmPlaceObjectDefAtLoc(soldier7ID, 0, 0.60, 0.70);
	
	int soldier8ID=rmCreateObjectDef("Musketeers 8");
	rmAddObjectDefItem(soldier8ID, "Musketeer", rmRandInt(15,20), 8.0);
	rmSetObjectDefMinDistance(soldier8ID, 0.0);
	rmSetObjectDefMaxDistance(soldier8ID, 0.0);
	rmAddObjectDefConstraint(soldier8ID, avoidMusket);
	rmAddObjectDefConstraint(soldier8ID, avoidSocket);
	rmPlaceObjectDefAtLoc(soldier8ID, 0, 0.40, 0.30);
	
	int soldier9ID=rmCreateObjectDef("Musketeers 9");
	rmAddObjectDefItem(soldier9ID, "Musketeer", rmRandInt(15,20), 8.0);
	rmSetObjectDefMinDistance(soldier9ID, 0.0);
	rmSetObjectDefMaxDistance(soldier9ID, 0.0);
	rmAddObjectDefConstraint(soldier9ID, avoidMusket);
	rmAddObjectDefConstraint(soldier9ID, avoidSocket);
	rmPlaceObjectDefAtLoc(soldier9ID, 0, 0.50, 0.30);
	
	int soldier10ID=rmCreateObjectDef("Musketeers 10");
	rmAddObjectDefItem(soldier10ID, "Musketeer", rmRandInt(15,20), 8.0);
	rmSetObjectDefMinDistance(soldier10ID, 0.0);
	rmSetObjectDefMaxDistance(soldier10ID, 0.0);
	rmAddObjectDefConstraint(soldier10ID, avoidMusket);
	rmAddObjectDefConstraint(soldier10ID, avoidSocket);
	rmPlaceObjectDefAtLoc(soldier10ID, 0, 0.60, 0.30);
	
	int silver5ID=rmCreateObjectDef("Silver 5");
	rmAddObjectDefItem(silver5ID, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(silver5ID, 0.0);
	rmSetObjectDefMaxDistance(silver5ID, 0.0);
	rmAddObjectDefConstraint(silver5ID, avoidCoin);
	rmAddObjectDefConstraint(silver5ID, avoidHQ);
	rmPlaceObjectDefAtLoc(silver5ID, 0, 0.60, 0.225);
	
	int silver6ID=rmCreateObjectDef("Silver 6");
	rmAddObjectDefItem(silver6ID, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(silver6ID, 0.0);
	rmSetObjectDefMaxDistance(silver6ID, 0.0);
	rmAddObjectDefConstraint(silver6ID, avoidCoin);
	rmAddObjectDefConstraint(silver6ID, avoidHQ);
	rmPlaceObjectDefAtLoc(silver6ID, 0, 0.40, 0.225);
	
	int silver7ID=rmCreateObjectDef("Silver 7");
	rmAddObjectDefItem(silver7ID, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(silver7ID, 0.0);
	rmSetObjectDefMaxDistance(silver7ID, 0.0);
	rmAddObjectDefConstraint(silver7ID, avoidCoin);
	rmAddObjectDefConstraint(silver7ID, avoidHQ);
	rmPlaceObjectDefAtLoc(silver7ID, 0, 0.40, 0.75);
	
	int silver8ID=rmCreateObjectDef("Silver 8");
	rmAddObjectDefItem(silver8ID, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(silver8ID, 0.0);
	rmSetObjectDefMaxDistance(silver8ID, 0.0);
	rmAddObjectDefConstraint(silver8ID, avoidCoin);
	rmAddObjectDefConstraint(silver8ID, avoidHQ);
	rmPlaceObjectDefAtLoc(silver8ID, 0, 0.60, 0.75);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************* DEFINE AND PLACE THE NUGGETS - MOSTLY IN THE MIDDLE SECTION: *********************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE RANDOM TREES: ************************************* //   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    int tree1ID=rmCreateObjectDef("Trees 1");
	rmAddObjectDefItem(tree1ID, "TreeRockies", rmRandInt(8,10), 8.0);
	rmSetObjectDefMinDistance(tree1ID, 0.0);
	rmSetObjectDefMaxDistance(tree1ID, 0.0);
	rmAddObjectDefConstraint(tree1ID, avoidTrees);
	rmAddObjectDefConstraint(tree1ID, treesAvoidTrees);
	rmPlaceObjectDefAtLoc(tree1ID, 0, 0.08, 0.525);
	
	int tree2ID=rmCreateObjectDef("Trees 2");
	rmAddObjectDefItem(tree2ID, "TreeRockies", rmRandInt(8,10), 8.0);
	rmSetObjectDefMinDistance(tree2ID, 0.0);
	rmSetObjectDefMaxDistance(tree2ID, 0.0);
	rmAddObjectDefConstraint(tree2ID, avoidTrees);
	rmAddObjectDefConstraint(tree2ID, treesAvoidTrees);
	rmPlaceObjectDefAtLoc(tree2ID, 0, 0.525, 0.06);
	
	int tree3ID=rmCreateObjectDef("Trees 3");
	//rmAddObjectDefItem(tree3ID, "TreeRockies", 1, 2.0);
	rmAddObjectDefItem(tree3ID, "TreeRockies", rmRandInt(8,10), 8.0);
	rmSetObjectDefMinDistance(tree3ID, 0.0);
	rmSetObjectDefMaxDistance(tree3ID, 0.0);
	rmAddObjectDefConstraint(tree3ID, avoidTrees);
	rmAddObjectDefConstraint(tree3ID, treesAvoidTrees);
	rmPlaceObjectDefAtLoc(tree3ID, 0, 0.89, 0.45);
	
	int tree4ID=rmCreateObjectDef("Trees 4");
	//rmAddObjectDefItem(tree4ID, "TreeRockies", 1, 2.0);
	rmAddObjectDefItem(tree4ID, "TreeRockies", rmRandInt(8,10), 8.0);
	rmSetObjectDefMinDistance(tree4ID, 0.0);
	rmSetObjectDefMaxDistance(tree4ID, 0.0);
	rmAddObjectDefConstraint(tree4ID, avoidTrees);
	rmAddObjectDefConstraint(tree4ID, treesAvoidTrees);
	rmPlaceObjectDefAtLoc(tree4ID, 0, 0.215, 0.85);
	
	int tree5ID=rmCreateObjectDef("Trees 5");
	//rmAddObjectDefItem(tree5ID, "TreeRockies", 1, 2.0);
	rmAddObjectDefItem(tree5ID, "TreeRockies", rmRandInt(8,10), 8.0);
	rmSetObjectDefMinDistance(tree5ID, 0.0);
	rmSetObjectDefMaxDistance(tree5ID, 0.0);
	rmAddObjectDefConstraint(tree5ID, avoidTrees);
	rmAddObjectDefConstraint(tree5ID, treesAvoidTrees);
	rmPlaceObjectDefAtLoc(tree5ID, 0, 0.11, 0.27);
	
	int tree6ID=rmCreateObjectDef("Trees 6");
	//rmAddObjectDefItem(tree6ID, "TreeRockies", 1, 0.0);
	rmAddObjectDefItem(tree6ID, "TreeRockies", rmRandInt(8,10), 8.0);
	rmSetObjectDefMinDistance(tree6ID, 0.0);
	rmSetObjectDefMaxDistance(tree6ID, 0.0);
	rmAddObjectDefConstraint(tree6ID, avoidTrees);
	rmAddObjectDefConstraint(tree6ID, treesAvoidTrees);
	rmPlaceObjectDefAtLoc(tree6ID, 0, 0.55, 0.9375);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}
/*================================================================================================================*/
// **************************************** THIS IS THE END OF THE MAP: ***************************************** //
/*================================================================================================================*/	    


	  
	  
	  

	


	  
