/*===============================================================================================================*/
// ********************************* THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*===============================================================================================================*/

// THE PENINSULA:
// CREATED BY DANY:
// AUGUST 2007:

/*===============================================================================================================*/
// ******************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*===============================================================================================================*/

include "mercenaries.xs";
void main(void)
{

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*===============================================================================================================*/
// *************************************** CHOOSE THE NATIVES TRIBES: ****************************************** //
/*===============================================================================================================*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		
/*---------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(4) == true)
	
	{
		subCiv0=rmGetCivID("Maya");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Maya");
				
		subCiv1=rmGetCivID("Maya");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Maya");
		
		subCiv2=rmGetCivID("Maya");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Maya");

		subCiv3=rmGetCivID("Maya");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Maya");
    }
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*===============================================================================================================*/
// **************************************** PICKS THE MAP SIZE: ************************************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        float playerTiles=17500;
        		
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(530, 530);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.06);
/*===============================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ***************************************** //    
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(4);

        // SET SEA TYPE: 
        rmSetSeaType("yucatan Coast");
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
        
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("water", 4);
   
	    // SET MAP TYPE:
		rmSetMapType("yucatan");
	    rmSetMapType("tropical");
	    rmSetMapType("water");
	    
		// MAP LIGHTING:
        rmSetLightingSet("yucatan");

	    // SET WIND MAGNITUDE:
	    rmSetWindMagnitude(2);
	    
		// DEFINE THE CORNERS:
		rmSetWorldCircleConstraint(true);

	    // CHOOSE THE MERCS:
		chooseMercs();
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*===============================================================================================================*/		
// ******************************************* DEFINE SOME CLASSES: ******************************************** //
// *********************************** THESE ARE USED LATER FOR CONSTRAINTS: *********************************** //
/*===============================================================================================================*/ 
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("classGold");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("classForest2");
        rmDefineClass("importantItem");
        rmDefineClass("classCliff");
        rmDefineClass("classNatives");
        rmDefineClass("classNuggets");
		rmDefineClass("classSocket");
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*===============================================================================================================*/		
// ****************************************** DEFINE THE CONSTRAINTS: ****************************************** //
// ****************************** USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ***************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
    
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
        //  int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 24.0);

        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
        int avoidCW=rmCreateTypeDistanceConstraint("stuff vs CW", "CoveredWagon", 20.0);
        // int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
     
        // SEA FOOD AVOIDANCE:
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
        //int fishVsFish2ID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "AbstractWhale", 10.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 18.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
        
		// FOREST AVOIDANCE:
		int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
		int forestConstraintClose=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 3.0);
        
        int forestConstraintSmall=rmCreateClassDistanceConstraint("forest2 vs. forest2", rmClassID("classForest2"), 12.0);
        int forestConstraintSmallClose=rmCreateClassDistanceConstraint("close forest2 vs. forest2", rmClassID("classForest2"), 3.0);
        
		// RESOURCE AVOIDANCE:
		int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
        int avoidFood=rmCreateTypeDistanceConstraint("food avoids food", "huntable", 40.0);
        int avoidCloseFood=rmCreateTypeDistanceConstraint("close avoids food", "huntable", 3.0);
        		
		// SILVER MINES AVOIDANCE:
		int smallAvoidCoin=rmCreateTypeDistanceConstraint("smallavoid coin", "gold", 30.0);
        int tinyAvoidCoin=rmCreateTypeDistanceConstraint("tinyAvoid coin", "gold", 10.0);
        int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 50.0);
        int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "gold", 3.0);
        
		// STARTING RESOURCE AND STARTING UNITS AVOIDANCE:
		int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
        int avoidStartUnits=rmCreateClassDistanceConstraint("stuff avoid start res", rmClassID("startingUnit"), 2.0);
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
        		
        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 3.0);
        int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
        int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
        
		// CLIFF AVOIDANCE:
		int avoidCliff=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 6.0);
        int avoidCloseCliff=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 3.0);
        int smallavoidCliff=rmCreateClassDistanceConstraint("small vs. cliff", rmClassID("classCliff"), 6.0);
        int mediumavoidCliff=rmCreateClassDistanceConstraint("medium vs. cliff", rmClassID("classCliff"), 12.0);
        int largeAvoidCliff=rmCreateClassDistanceConstraint("large vs. cliff", rmClassID("classCliff"), 18.0);
        int cliffAvoidCliff=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 20.0);
        int cliffFarAvoidCliff=rmCreateClassDistanceConstraint("big cliff vs. cliff", rmClassID("classCliff"), 40.0);
        int avoidFakeLand=rmCreateTerrainDistanceConstraint("avoid passable land", "Land", false, 4.0);

   
	    // CONSTRAINT TO AVOID WATER:
        int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
        int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 8.0);
        int avoidWater12 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 12.0);
        int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
        // int oceanConstraint=rmCreateBoxConstraint("land stay away from edges", 0.13, 0, 0.87, 1);

        /*// CARDINAL DIRECTIONS:
        int NorthEward=rmCreatePieConstraint("northMapConstraint", 0.75, 0.75, 0, rmZFractionToMeters(0.3), rmDegreesToRadians(355), rmDegreesToRadians(85));
        int SouthWward=rmCreatePieConstraint("southMapConstraint", 0.25, 0.25, 0, rmZFractionToMeters(0.3), rmDegreesToRadians(175), rmDegreesToRadians(275));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
	    */
   
        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 3.0);

        // VP AVOIDANCE:
        // TRADE ROUTE AVOIDANCE:
		int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
        int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);
		
		// TRADE ROUTE AVOIDANCE:
        // VP AVOIDANCE:
        //int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 5.0);
        //int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route long", 20.0);
  		
		// SOCKET AVOIDANCE:
		int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 10.0);
 		int avoidCloseSocket = rmCreateClassDistanceConstraint("close avoid socket", rmClassID("classSocket"), 5.0);
        
		// IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("avoid natives, trade etc", rmClassID("importantItem"), 3.0);
        int forestAvoidImportantItem=rmCreateClassDistanceConstraint("forest avoid items", rmClassID("importantItem"), 15.0);
       	int avoidImportantItemSmall=rmCreateClassDistanceConstraint("important item small avoidance", rmClassID("importantItem"), 10.0);
        
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("classNatives"), 30.0);
        int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("classNatives"), 5.0);
        
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget vs nugget", "abstractnugget", 60.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close vs nugget", "abstractnugget", 3.0);
		int avoidNuggets=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("classNuggets"), 40.0);
        int nuggetAvoidNugget=rmCreateClassDistanceConstraint("nugget avoids nugget", rmClassID("classNuggets"), 20.0);
        
		// TC AVOIDANCE:
		int avoidTC=rmCreateTypeDistanceConstraint("objects avoid TC", "towncenter", 25.0);
        int tcAvoidTC=rmCreateTypeDistanceConstraint("Towncenter avoid TC", "towncenter", 20.0);
        int avoidTCTiny=rmCreateTypeDistanceConstraint("objects avoid TC small", "towncenter", 10.0);
        
		// FLAG AVOIDANCE:
		int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
        int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 15.0);
        int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
        int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
        
		// EDGE AVOIDANCE:
		int tcAvoidEdgeConstraint=rmCreatePieConstraint("towncenter avoid edge of map",  0.5, 0.5, 0, rmGetMapXSize()-30, 0, 0, 0);
        int nuggetAvoidEdgeConstraint=rmCreatePieConstraint("nugget avoid edge of map",  0.5, 0.5, 0, rmGetMapXSize()-5, 0, 0, 0);
        int coinAvoidEdgeConstraint=rmCreatePieConstraint("coin avoid edge of map",  0.5, 0.5, 0, rmGetMapXSize()-7, 0, 0, 0);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*===============================================================================================================*/		
// ******************************************** DEFINE THE OBJECTS: ******************************************** //
/*===============================================================================================================*/

   // THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER:
   // THE OBJECTS DEFINED:
   // DONE DEFINING THESE OBJECTS:

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*===============================================================================================================*/
// *********************************** DEFINE AND PLACE THE BIG CONTINENT: ************************************* //
/*===============================================================================================================*/		
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        
		int bigContinentID = rmCreateArea("big visible continent");
        
		// SET AREA LOCATION:
		rmSetAreaLocation(bigContinentID, 0.5, 0.5); 
        
		rmSetAreaWarnFailure(bigContinentID, false);
        
		// SET AREA SIZE:
		rmSetAreaSize(bigContinentID, 0.6, 0.6);
		        
		// ADD AREA INFLUENCE POINT:
		rmAddAreaInfluencePoint(bigContinentID, 0.85, 0.85);
        rmAddAreaInfluencePoint(bigContinentID, 0.15, 0.15);
        
		rmSetAreaElevationType(bigContinentID, cElevTurbulence);
        rmSetAreaElevationVariation(bigContinentID, 4.0);
        
		// SET AREA BASE HEIGHT:
		rmSetAreaBaseHeight(bigContinentID, 5.0);
        
		rmSetAreaElevationMinFrequency(bigContinentID, 0.09);
        rmSetAreaElevationOctaves(bigContinentID, 3);
        rmSetAreaElevationPersistence(bigContinentID, 0.2); // 0.7
	    rmSetAreaElevationNoiseBias(bigContinentID, 1); 
	    
		// SET AREA MIX:
		rmSetAreaMix(bigContinentID, "yucatan_grass");
        
		// SET AREA OBEY WORLD CIRCLE CONSTRAINT:
		rmSetAreaObeyWorldCircleConstraint(bigContinentID, false);
        
		// SET AREA COHERENCE:
  	    //rmSetAreaCoherence(bigContinentID, 0.7);
		rmSetAreaCoherence(bigContinentID, 0.75);
        
		rmSetAreaSmoothDistance(bigContinentID, 12);

        // BUILD AREA:
		rmBuildArea(bigContinentID);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*===============================================================================================================*/
// ****************************** SET UP PLAYER STARTING LOCATIONS ALONG THE RIVER: **************************** //
// *********************************** THESE ARE USED TO PLACE STARTING TC'S: ********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	    int teamOneCount = rmGetNumberPlayersOnTeam(1);
		
		if ( cNumberTeams == 2 ) // && teamZeroCount == teamOneCount)
	{

		rmSetPlacementTeam(0);
		rmSetTeamSpacingModifier(0.50);
		rmPlacePlayersLine(0.15, 0.35, 0.35, 0.15, 0, 0.0);

		rmSetPlacementTeam(1);
		rmSetTeamSpacingModifier(0.50);
		//rmPlacePlayersLine(0.675, 0.825, 0.825, 0.675, 0, 0.0);
		rmPlacePlayersLine(0.85, 0.65, 0.65, 0.85, 0, 0.0);
	
	}

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*===============================================================================================================*/
// ******************************************* SET UP PLAYER AREAS: ******************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
 
        float playerFraction=rmAreaTilesToFraction(100);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
      
	    // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
		
		// SET AREA COHERENCE:
		//rmSetAreaCoherence(id, 0.7);
      
	    // ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA TERRAIN TYPE:
		// rmSetAreaTerrainType(id, "carolina\marshflats");
        
		// SET AREA BASE HEIGHT:
		// rmSetAreaBaseHeight(id, 8.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // Build the areas.
        rmBuildAllAreas();
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*===============================================================================================================*/   
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        
		if (subCiv0 == rmGetCivID("Maya"))
	{  
		int maya1VillageID = -1;
		maya1VillageID = rmCreateGrouping("maya village 1", "native maya village 1");
		rmSetGroupingMinDistance(maya1VillageID, 0.0);
		rmSetGroupingMaxDistance(maya1VillageID, 0.0);
		rmAddGroupingToClass(maya1VillageID, rmClassID("classNatives"));
		rmAddGroupingConstraint(maya1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(maya1VillageID, 0, 0.50, 0.30);
	}  
	
/*---------------------------------------------------------------------------------------------------------------*/
        
        if (subCiv1 == rmGetCivID("Maya"))
		
	{	
	    int maya2VillageID = -1;
		maya2VillageID = rmCreateGrouping("maya village 2", "native maya village 1");
		rmSetGroupingMinDistance(maya2VillageID, 0.0);
		rmSetGroupingMaxDistance(maya2VillageID, 0.0);
		rmAddGroupingToClass(maya2VillageID, rmClassID("classNatives"));
		rmAddGroupingConstraint(maya2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(maya2VillageID, 0, 0.30, 0.50);
	}	

/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv2 == rmGetCivID("Maya"))
	{  
		int maya3VillageID = -1;
		maya3VillageID = rmCreateGrouping("maya village 3", "native maya village 1");
		rmSetGroupingMinDistance(maya3VillageID, 0.0);
		rmSetGroupingMaxDistance(maya3VillageID, 0.0);
		rmAddGroupingToClass(maya3VillageID, rmClassID("classNatives"));
		rmAddGroupingConstraint(maya3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(maya3VillageID, 0, 0.50, 0.70);
	} 

/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv3 == rmGetCivID("Maya"))
	{  
		int maya4VillageID = -1;
		maya4VillageID = rmCreateGrouping("maya village 4", "native maya village 1");
		rmSetGroupingMinDistance(maya4VillageID, 0.0);
		rmSetGroupingMaxDistance(maya4VillageID, 0.0);
		rmAddGroupingToClass(maya4VillageID, rmClassID("classNatives"));
		rmAddGroupingConstraint(maya4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(maya4VillageID, 0, 0.70, 0.50);
	} 	
   
/*===============================================================================================================*/		
// ********************************** CLEAR OUT CONSTRAINTS FOR GOOD MEASURE: ********************************** //
/*===============================================================================================================*/

        // CLEAR OUT CONSTRAINTS FOR GOOD MEASURE:
		rmClearClosestPointConstraints();

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*===============================================================================================================*/		
// **************************************** DEFINE THE PLACEMENT ORDER: **************************************** //
/*===============================================================================================================*/

        // DEFINE THE PLACEMENT ORDER:
        // Trade route -> River (none on this map) -> Natives -> Secrets -> Cliffs -> Nuggets
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*===============================================================================================================*/
//************************************* DEFINE AND PLACE THE TRADE ROUTE: ************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 6.0);

	    int tradeRouteID = rmCreateTradeRoute();
	    rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.340, 0.660);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.660, 0.340);

	    bool placedTradeRouteA = rmBuildTradeRoute(tradeRouteID, "dirt");
	    if(placedTradeRouteA == false)
		rmEchoError("Failed to place trade route 1");

	    rmPlaceObjectDefAtLoc(socketID, 0, 0.340, 0.660);
	    //rmPlaceObjectDefAtLoc(socketID, 0, 0.50, 0.50);
	    rmPlaceObjectDefAtLoc(socketID, 0, 0.660, 0.340); 

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*===============================================================================================================*/
// **************************************** BUILD THE 2 INVISIBLE ISLANDS: ************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // BUILD AN INVISIBLE NORTH ISLAND AREA:
        int northIslandID = rmCreateArea("north east invisible island");
        //rmSetAreaWarnFailure(northIslandID, false);
        //rmSetAreaLocation(northIslandID, 0.5, 0.75); 
		rmSetAreaLocation(northIslandID, 0.7, 0.7); 
        rmSetAreaWarnFailure(northIslandID, false);
        rmSetAreaSize(northIslandID, 0.225, 0.225);
        rmSetAreaCoherence(northIslandID, 1.0);
        //rmSetAreaTerrainType(northIslandID, "texas\ground4_tex");
		
/*---------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/		

        // BUILD AN INVISIBLE SOUTH ISLAND AREA:
        int southIslandID = rmCreateArea("south west invisible island");
        //rmSetAreaLocation(southIslandID, 0.5, 0.25);
        rmSetAreaLocation(southIslandID, 0.3, 0.3); 		
        rmSetAreaWarnFailure(southIslandID, false);
        rmSetAreaSize(southIslandID, 0.225, 0.225);
        rmSetAreaCoherence(southIslandID, 1.0);
        //rmSetAreaTerrainType(southIslandID, "rockies\groundsnow1_roc");
		
/*---------------------------------------------------------------------------------------------------------------*/		

        // BUILD THE NORTH AND SOUTH INVISIBLE ISLANDS:
		rmBuildAllAreas();
		
/*---------------------------------------------------------------------------------------------------------------*/		

        // DEFINE THE CONSTRAINTS FOR THE NORTH AND SOUTH INVISIBLE ISLAND:
		int northeastConstraint=rmCreateAreaConstraint("NE", northIslandID);
        int southwestConstraint=rmCreateAreaConstraint("SW", southIslandID);
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*===============================================================================================================*/
//********************************************** STARTING RESOURCES: ******************************************* //
/*===============================================================================================================*/
  
        // PLAYER STARTING TC, NATIVES, AND RESOURCES:
		
/*---------------------------------------------------------------------------------------------------------------*/		

        // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints(); // CLEAR FOR WATERFLAG PLACEMENT:
		
/*---------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE THE TC FLOATING:
		int TCfloat = -1;
        if (cNumberTeams == 2 && cNumberNonGaiaPlayers <= 4)
	    TCfloat = 0;
        else 
	    TCfloat = 0;
		
/*---------------------------------------------------------------------------------------------------------------*/		
        
		// DEFINE THE STARTING TCID:
		int TCID = rmCreateObjectDef("player TC");
        if ( rmGetNomadStart())
   {
	    rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
   }
        else
   {
	    rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
   }
        rmSetObjectDefMinDistance(TCID, 0.0);
        rmSetObjectDefMaxDistance(TCID, TCfloat);
        rmAddObjectDefConstraint(TCID, avoidTradeRoute);
        rmAddObjectDefConstraint(TCID, avoidWater8); 
        rmAddObjectDefConstraint(TCID, tcAvoidTC);
        rmAddObjectDefConstraint(TCID, tcAvoidEdgeConstraint);
        //rmPlaceObjectDefPerPlayer(TCID, true);
		
/*---------------------------------------------------------------------------------------------------------------*/		
 
        // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
        rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
        rmAddObjectDefConstraint(startingUnits, avoidAll);
        rmAddObjectDefConstraint(startingUnits, avoidImpassableLand);
        rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
        //rmPlaceObjectDefPerPlayer(startingUnits, true);
        //rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

/*---------------------------------------------------------------------------------------------------------------*/      
        
		// DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player silver");
        rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
        rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
        rmSetObjectDefMinDistance(playerSilverID, 15.0);
        rmSetObjectDefMaxDistance(playerSilverID, 25.0);
        rmAddObjectDefConstraint(playerSilverID, avoidAll);
        rmAddObjectDefToClass(playerSilverID, rmClassID("classGold"));
        rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);
        //rmPlaceObjectDefPerPlayer(playerSilverID, true);
        //rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

/*---------------------------------------------------------------------------------------------------------------*/		
		
        // DEFINE THE PLAYER SILVER2:
		int playerSilver2ID = rmCreateObjectDef("player silver2");
        rmAddObjectDefItem(playerSilver2ID, "mine", 1, 0);
        rmAddObjectDefConstraint(playerSilver2ID, avoidTradeRoute);
        rmSetObjectDefMinDistance(playerSilver2ID, 35.0);
        rmSetObjectDefMaxDistance(playerSilver2ID, 45.0);
        rmAddObjectDefConstraint(playerSilver2ID, avoidAll);
        rmAddObjectDefConstraint(playerSilver2ID, tinyAvoidCoin);
        rmAddObjectDefToClass(playerSilver2ID, rmClassID("classGold"));
        rmAddObjectDefConstraint(playerSilver2ID, avoidImpassableLand);
        //rmPlaceObjectDefPerPlayer(playerSilver2ID, true);
        //rmPlaceObjectDefAtLoc(playerSilver2ID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

/*---------------------------------------------------------------------------------------------------------------*/        
		
		// DEFINE THE PLAYER TREE:
		int playerTreeID=rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, "TreeYucatan", 6, 8.0);
        rmSetObjectDefMinDistance(playerTreeID, 5);
        rmSetObjectDefMaxDistance(playerTreeID, 10);
        rmAddObjectDefConstraint(playerTreeID, avoidAll);
        rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
        //rmPlaceObjectDefPerPlayer(playerTreeID, false, rmRandInt(3,5));
        //rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

/*---------------------------------------------------------------------------------------------------------------*/		
		
        // DEFINE THE PLAYER BERRY:
		int playerBerryID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerBerryID, "berryBush", rmRandInt(2,3), 5.0);
        rmSetObjectDefMinDistance(playerBerryID, 8);
        rmSetObjectDefMaxDistance(playerBerryID, 15);
        rmAddObjectDefConstraint(playerBerryID, avoidAll);
        rmAddObjectDefConstraint(playerBerryID, avoidImpassableLand);
        rmAddObjectDefToClass(playerBerryID, rmClassID("startingUnit"));
        //rmPlaceObjectDefPerPlayer(playerBerryID, false);
        //rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

/*---------------------------------------------------------------------------------------------------------------*/
		
        // DEFINE THE WATER FLAG:
		int waterFlagID=rmCreateObjectDef("HC water flag "+i);
        rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
        rmAddClosestPointConstraint(flagEdgeConstraint);
        rmAddClosestPointConstraint(flagVsFlag);
        rmAddClosestPointConstraint(flagLand);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*===============================================================================================================*/
// **************************** JOHN'S SWEET SOLUTION TO PLACING STUFF AROUND THE TC: ************************** //
// ********************* REGARDLESS OF WHERE THE PLAYER START AREA ACTUALLY IS, YAY!!!!!!: ********************* //
/*===============================================================================================================*/

        for(i=1; <cNumberPlayers)
   {
/*---------------------------------------------------------------------------------------------------------------*/   

	    // PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
	    vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	    	    
	    // PLACE THE STARTING UNITS:
	    rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	   
/*---------------------------------------------------------------------------------------------------------------*/	   
	    
		// PLACE THE PLAYER SILVER:
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
		// PLACE THE PLAYER SILVER2:
		rmPlaceObjectDefAtLoc(playerSilver2ID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
    	// PLACE THE PLAYER TREE:
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
		// PLACE THE PLAYER BERRY:
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
		// PLACE THE WATER FLAG:
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
	   
   }
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*===============================================================================================================*/
// ******************************************* THE VARIABLES NEEDED: ******************************************* //  
/*===============================================================================================================*/
   
        int numTries = -1;
        int failCount = -1;
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.71);
/*===============================================================================================================*/
// *********************************** DEFINE AND PLACE CLIFFS THEN NUGGETS: *********************************** //
/*===============================================================================================================*/

        numTries=cNumberNonGaiaPlayers+1;
        failCount=0;
        for(i=0; <numTries)
   {
        int cliffID=rmCreateArea("cliff"+i);
	    rmSetAreaSize(cliffID, rmAreaTilesToFraction(30), rmAreaTilesToFraction(45));
        rmSetAreaWarnFailure(cliffID, false);
	    rmSetAreaCliffType(cliffID, "Amazon");
        int edgeRand=rmRandInt(0,100);
        rmSetAreaCliffEdge(cliffID, 1, 1);
        rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliffID, 6, 2.0, 0.5);
        rmSetAreaHeightBlend(cliffID, 1);
        rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliffID, cliffFarAvoidCliff);
        rmAddAreaConstraint(cliffID, avoidTradeRoute);
        rmAddAreaConstraint(cliffID, avoidImportantItem);
        rmAddAreaConstraint(cliffID, avoidWater12);
	    rmAddAreaConstraint(cliffID, tinyAvoidCoin);
	    rmAddAreaConstraint(cliffID, avoidCloseNatives);
		rmAddAreaConstraint(cliffID, avoidCloseSocket);
		rmAddAreaConstraint(cliffID, avoidTC);
	    rmAddAreaConstraint(cliffID, avoidCW);
	    rmAddAreaConstraint(cliffID, avoidStartUnits);	  
        rmSetAreaSmoothDistance(cliffID, 10);
        rmSetAreaCoherence(cliffID, 0.25);

        if(rmBuildArea(cliffID)==false)
      {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==6)
        break;
      }
        else
        failCount=0;
   }

/*---------------------------------------------------------------------------------------------------------------*/   

        // ANOTHER CLIFF:

        numTries=cNumberNonGaiaPlayers*2;
        failCount=0;
        for(i=0; <numTries)
   {
        int cliff2ID=rmCreateArea("cliff small tall "+i);
        rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(90));
        rmSetAreaWarnFailure(cliff2ID, false);
        rmSetAreaCliffType(cliff2ID, "Amazon");
        edgeRand=rmRandInt(0,100);
        rmSetAreaCliffEdge(cliff2ID, 1, 1);
        rmSetAreaCliffPainting(cliff2ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff2ID, 6, 2.0, 0.5);
        rmSetAreaHeightBlend(cliff2ID, 1);
        rmAddAreaTerrainLayer(cliff2ID, "Amazon\ground2_ama", 0, 2);
        rmAddAreaToClass(cliff2ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff2ID, cliffAvoidCliff);
        rmAddAreaConstraint(cliff2ID, avoidTradeRoute);
        rmAddAreaConstraint(cliff2ID, avoidImportantItem);
        rmAddAreaConstraint(cliff2ID, avoidWater12);
	    rmAddAreaConstraint(cliff2ID, tinyAvoidCoin);
		rmAddAreaConstraint(cliff2ID, avoidCloseNatives);
		rmAddAreaConstraint(cliff2ID, avoidCloseSocket);
	    rmAddAreaConstraint(cliff2ID, avoidTC);
	    rmAddAreaConstraint(cliff2ID, avoidCW);
	    rmAddAreaConstraint(cliff2ID, avoidStartUnits);
        rmSetAreaSmoothDistance(cliff2ID, 10);
        rmSetAreaCoherence(cliff2ID, 0.25);

        if(rmBuildArea(cliff2ID)==false)
      {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==6)
        break;
      }
        else
        failCount=0;
   }
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*===============================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: *************************************** //    
/*===============================================================================================================*/

        // THE NUGGET EASY:
		int nugget1= rmCreateObjectDef("nugget easy"); 
        rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
        rmSetNuggetDifficulty(1, 1);
        rmAddObjectDefConstraint(nugget1, shortAvoidImpassableLand);
        rmAddObjectDefConstraint(nugget1, avoidNugget);
        rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
        rmAddObjectDefConstraint(nugget1, avoidAll);
		rmAddObjectDefConstraint(nugget1, avoidCloseSocket);
		rmAddObjectDefConstraint(nugget1, avoidCloseNatives);
        rmAddObjectDefConstraint(nugget1, nuggetAvoidEdgeConstraint);
        rmAddObjectDefToClass(nugget1, rmClassID("classNuggets"));
        rmSetObjectDefMinDistance(nugget1, 20.0);
        rmSetObjectDefMaxDistance(nugget1, 40.0);
        rmPlaceObjectDefPerPlayer(nugget1, false, 2);
		
/*---------------------------------------------------------------------------------------------------------------*/		

        // THE NUGGET MEDIUM: 
		int nugget2= rmCreateObjectDef("nugget medium"); 
        rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
        rmSetNuggetDifficulty(2, 2);
        rmSetObjectDefMinDistance(nugget2, 0.0);
        rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(nugget2, shortAvoidImpassableLand);
        rmAddObjectDefConstraint(nugget2, avoidNugget);
        rmAddObjectDefConstraint(nugget2, avoidTC);
        rmAddObjectDefConstraint(nugget2, avoidCW);
        rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
        rmAddObjectDefConstraint(nugget2, avoidAll);
		rmAddObjectDefConstraint(nugget2, avoidCloseSocket);
		rmAddObjectDefConstraint(nugget2, avoidCloseNatives);
        rmAddObjectDefConstraint(nugget2, avoidWater12);
        rmAddObjectDefConstraint(nugget2, nuggetAvoidEdgeConstraint);
        rmAddObjectDefToClass(nugget2, rmClassID("classNuggets"));
        rmSetObjectDefMinDistance(nugget2, 60.0);
        rmSetObjectDefMaxDistance(nugget2, 100.0);
        rmPlaceObjectDefPerPlayer(nugget2, false, 2);
		
/*---------------------------------------------------------------------------------------------------------------*/		

        // THE NUGGET HARD:
		int nugget3= rmCreateObjectDef("nugget hard"); 
        rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
        rmSetNuggetDifficulty(3, 3);
        rmSetObjectDefMinDistance(nugget3, 0.0);
        rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(nugget3, shortAvoidImpassableLand);
        rmAddObjectDefConstraint(nugget3, avoidNugget);
        rmAddObjectDefConstraint(nugget3, avoidTC);
        rmAddObjectDefConstraint(nugget3, avoidCW);
        rmAddObjectDefConstraint(nugget3, avoidTradeRoute);
        rmAddObjectDefConstraint(nugget3, avoidAll);
		rmAddObjectDefConstraint(nugget3, avoidCloseSocket);
		rmAddObjectDefConstraint(nugget3, avoidCloseNatives);
        rmAddObjectDefConstraint(nugget3, avoidWater12);
        rmAddObjectDefConstraint(nugget3, nuggetAvoidEdgeConstraint);
        rmAddObjectDefToClass(nugget3, rmClassID("classNuggets"));
        rmPlaceObjectDefAtLoc(nugget3, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
		
/*---------------------------------------------------------------------------------------------------------------*/		

        // THE NUGGET NUTS:
		int nugget4= rmCreateObjectDef("nugget nuts"); 
        rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
        rmSetNuggetDifficulty(4, 4);
        rmSetObjectDefMinDistance(nugget4, 0.0);
        rmSetObjectDefMaxDistance(nugget4, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(nugget4, shortAvoidImpassableLand);
        rmAddObjectDefConstraint(nugget4, avoidNugget);
        rmAddObjectDefConstraint(nugget4, avoidTC);
        rmAddObjectDefConstraint(nugget4, avoidCW);
        rmAddObjectDefConstraint(nugget4, avoidTradeRoute);
        rmAddObjectDefConstraint(nugget4, avoidAll);
		rmAddObjectDefConstraint(nugget4, avoidCloseSocket);
		rmAddObjectDefConstraint(nugget4, avoidCloseNatives);
		//rmAddObjectDefConstraint(nugget4, avoidCloseAll);
        rmAddObjectDefConstraint(nugget4, avoidWater12);
        rmAddObjectDefConstraint(nugget4, nuggetAvoidEdgeConstraint);
        rmAddObjectDefToClass(nugget4, rmClassID("classNuggets"));
        rmPlaceObjectDefAtLoc(nugget4, 0, 0.5, 0.5, rmRandInt(0,3));
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*===============================================================================================================*/
// ************************************** PLACE FISH IN BOTH WATER BODIES: ************************************* //
/*===============================================================================================================*/

        int fishID=rmCreateObjectDef("NE fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 1.0, 0.5, 12*cNumberNonGaiaPlayers);

        int whaleID=rmCreateObjectDef(" NE whale");
        rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        rmPlaceObjectDefAtLoc(whaleID, 0, 1.0, 0.5, 2*cNumberNonGaiaPlayers);
   
/*---------------------------------------------------------------------------------------------------------------*/   

        int fish2ID=rmCreateObjectDef("SE fish");
        rmAddObjectDefItem(fish2ID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fish2ID, 0.0);
        rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish2ID, fishVsFishID);
        rmAddObjectDefConstraint(fish2ID, fishLand);
        rmPlaceObjectDefAtLoc(fish2ID, 0, 0.0, 0.5, 12*cNumberNonGaiaPlayers);

        int whale2ID=rmCreateObjectDef("SE whale");
        rmAddObjectDefItem(whale2ID, "HumpbackWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whale2ID, 0.0);
        rmSetObjectDefMaxDistance(whale2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whale2ID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whale2ID, whaleLand);
        rmPlaceObjectDefAtLoc(whale2ID, 0, 0.0, 0.5, 2*cNumberNonGaiaPlayers);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*===============================================================================================================*/
//  ************************* PLACE RESOURCES THAT WE WANT FORESTS TO AVOID:( COIN ): ************************** //
/*===============================================================================================================*/

        int silverID = -1;
        int silverCount = (cNumberNonGaiaPlayers*2 + rmRandInt(4,6));
        rmEchoInfo("silver count = "+silverCount);

        for(i=0; < silverCount)
   {
	    silverID = rmCreateObjectDef("silver "+i);
	    rmAddObjectDefItem(silverID, "mine", 1, 0.0);
	    rmSetObjectDefMinDistance(silverID, 0.0);
	    rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(silverID, avoidCoin);
	    rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, avoidCloseNugget);
		rmAddObjectDefConstraint(silverID, avoidCloseNatives);
		rmAddObjectDefConstraint(silverID, avoidCloseSocket);
	    rmAddObjectDefConstraint(silverID, avoidTC);
	    rmAddObjectDefConstraint(silverID, avoidCW);
	    rmAddObjectDefConstraint(silverID, avoidImportantItem);
	    rmAddObjectDefConstraint(silverID, avoidImpassableLand);
	    rmAddObjectDefConstraint(silverID, avoidTradeRoute);
	    rmAddObjectDefConstraint(silverID, coinAvoidEdgeConstraint);
	    rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*===============================================================================================================*/
// **************************************** DEFINE AND PLACE THE FORESTS: ************************************** //
/*===============================================================================================================*/

        int forestTreeID = 0;
        numTries=6*cNumberNonGaiaPlayers;
        failCount=0;
        for (i=0; <numTries)

{

	    if(cNumberNonGaiaPlayers > 2)
    {   
        int forest=rmCreateArea("forest"+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(500));
        rmSetAreaForestType(forest, "Yucatan forest");
        rmSetAreaForestDensity(forest, .7);
        rmSetAreaForestClumpiness(forest, 0.0);
		rmSetAreaForestUnderbrush(forest, 0.0);
        rmSetAreaMinBlobs(forest, 3);
        rmSetAreaMaxBlobs(forest, 5);
        rmSetAreaMinBlobDistance(forest, 8.0);  // 12
        rmSetAreaMaxBlobDistance(forest, 16.0);  // 24
        rmSetAreaCoherence(forest, 0.4);
        rmSetAreaSmoothDistance(forest, 10);
	    rmAddAreaToClass(forest, rmClassID("classForest"));
        rmAddAreaConstraint(forest, forestConstraint);
		rmAddAreaConstraint(forest, avoidAll);
		rmAddAreaConstraint(forest, avoidCloseNatives);
		rmAddAreaConstraint(forest, avoidCloseSocket);
		rmAddAreaConstraint(forest, avoidTC);
		rmAddAreaConstraint(forest, tinyAvoidCoin);
		rmAddAreaConstraint(forest, avoidImportantItem);
        rmAddAreaConstraint(forest, avoidCliff);
        rmAddAreaConstraint(forest, avoidWater4); 
        rmAddAreaConstraint(forest, avoidTradeRoute); 
        rmAddAreaConstraint(forest, avoidTCTiny);
		if(rmBuildArea(forest)==false)
	 {
		// Stop trying once we fail 3 times in a row.
		failCount++;
		if(failCount==6)
		break;
	 } 
		else 
		failCount=0; 
   }
/*---------------------------------------------------------------------------------------------------------------*/
	    else
/*---------------------------------------------------------------------------------------------------------------*/
   {
        numTries=10*cNumberNonGaiaPlayers;
	    int forest2=rmCreateArea("forest2"+i);
	    rmSetAreaWarnFailure(forest2, false);
	    rmSetAreaSize(forest2, rmAreaTilesToFraction(100), rmAreaTilesToFraction(375));
	    rmSetAreaForestType(forest2, "Yucatan forest");
	    rmSetAreaForestDensity(forest2, .7);
	    rmSetAreaForestClumpiness(forest2, 0.0);
	    rmSetAreaForestUnderbrush(forest, 0.0);
	    rmSetAreaMinBlobs(forest2, 2);
	    rmSetAreaMaxBlobs(forest2, 3);
	    rmSetAreaMinBlobDistance(forest2, 4.0);  // 8
	    rmSetAreaMaxBlobDistance(forest2, 9.0);  // 16
	    rmSetAreaCoherence(forest2, 0.4);
	    rmSetAreaSmoothDistance(forest2, 10);
	    rmAddAreaToClass(forest2, rmClassID("classForest2"));
	    rmAddAreaConstraint(forest2, forestConstraintSmall);
	    rmAddAreaConstraint(forest2, avoidAll);
		rmAddAreaConstraint(forest2, avoidCloseSocket);
		rmAddAreaConstraint(forest2, avoidCloseNatives);
		rmAddAreaConstraint(forest2, avoidTC);
	    rmAddAreaConstraint(forest2, tinyAvoidCoin);
	    rmAddAreaConstraint(forest2, forestAvoidImportantItem);
	    rmAddAreaConstraint(forest2, avoidCliff);
	    rmAddAreaConstraint(forest2, avoidWater4); 
	    rmAddAreaConstraint(forest2, avoidTradeRoute); 
	    if(rmBuildArea(forest2)==false)
	 {
		// Stop trying once we fail 3 times in a row.
		failCount++;
		if(failCount==5)
		break;
	 }
	    else
		failCount=0; 
	}

}
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*===============================================================================================================*/
// ************************** RESOURCES THAT CAN BE PLACED AFTER FORESTS:( HUNTING: ) ************************** //
/*===============================================================================================================*/

	    int tapirCount = rmRandInt(4,6);
	    int capyCount = rmRandInt(6,8);

        int tapirID=rmCreateObjectDef("NW tapir crash");
        rmAddObjectDefItem(tapirID, "tapir", tapirCount, 2.0);
        rmSetObjectDefMinDistance(tapirID, 0.0);
        rmSetObjectDefMaxDistance(tapirID, rmXFractionToMeters(0.4));
        rmAddObjectDefConstraint(tapirID, avoidFood);
        rmAddObjectDefConstraint(tapirID, avoidImpassableLand);
        rmAddObjectDefConstraint(tapirID, avoidCloseCliff);
		rmAddObjectDefConstraint(tapirID, avoidCloseCoin);
		rmAddObjectDefConstraint(tapirID, avoidCloseSocket);
		rmAddObjectDefConstraint(tapirID, avoidCloseNatives);
		rmAddObjectDefConstraint(tapirID, avoidCloseNugget);
		//rmAddObjectDefConstraint(tapirID, avoidAll);
        rmAddObjectDefConstraint(tapirID, avoidAll);
		rmAddObjectDefConstraint(tapirID, avoidTC);
	    rmAddObjectDefConstraint(tapirID, northeastConstraint);
        rmSetObjectDefCreateHerd(tapirID, true);
        rmPlaceObjectDefAtLoc(tapirID, 0, 0.5, 0.5, tapirCount*0.5*cNumberNonGaiaPlayers);

	    int tapir2ID=rmCreateObjectDef("SE tapir crash");
        rmAddObjectDefItem(tapir2ID, "tapir", tapirCount, 2.0);
        rmSetObjectDefMinDistance(tapir2ID, 0.0);
        rmSetObjectDefMaxDistance(tapir2ID, rmXFractionToMeters(0.4));
        rmAddObjectDefConstraint(tapir2ID, avoidFood);
        rmAddObjectDefConstraint(tapir2ID, avoidImpassableLand);
        rmAddObjectDefConstraint(tapir2ID, avoidCloseCliff);
		rmAddObjectDefConstraint(tapir2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(tapir2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(tapir2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(tapir2ID, avoidCloseNugget);
        rmAddObjectDefConstraint(tapir2ID, avoidAll);
		rmAddObjectDefConstraint(tapir2ID, avoidTC);
	    rmAddObjectDefConstraint(tapir2ID, southwestConstraint);
        rmSetObjectDefCreateHerd(tapir2ID, true);
        rmPlaceObjectDefAtLoc(tapir2ID, 0, 0.5, 0.5, tapirCount*0.5*cNumberNonGaiaPlayers);
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    int capybaraID=rmCreateObjectDef("NW capybara pack");
        rmAddObjectDefItem(capybaraID, "capybara", capyCount, 2.0);
        rmSetObjectDefMinDistance(capybaraID, 0.0);
        rmSetObjectDefMaxDistance(capybaraID, rmXFractionToMeters(0.4));
        rmAddObjectDefConstraint(capybaraID, avoidFood);
        rmAddObjectDefConstraint(capybaraID, avoidImpassableLand);
        rmAddObjectDefConstraint(capybaraID, avoidCloseCliff);
		rmAddObjectDefConstraint(capybaraID, avoidCloseSocket);
		rmAddObjectDefConstraint(capybaraID, avoidCloseCoin);
		rmAddObjectDefConstraint(capybaraID, avoidCloseNatives);
		rmAddObjectDefConstraint(capybaraID, avoidCloseNugget);
        rmAddObjectDefConstraint(capybaraID, avoidAll);
		rmAddObjectDefConstraint(capybaraID, avoidTC);
	    rmAddObjectDefConstraint(capybaraID, northeastConstraint);
        rmSetObjectDefCreateHerd(capybaraID, true);
	    rmPlaceObjectDefAtLoc(capybaraID, 0, 0.5, 0.5, capyCount*2*cNumberNonGaiaPlayers);

	    int capybara2ID=rmCreateObjectDef("SE capybara pack");
        rmAddObjectDefItem(capybara2ID, "capybara", capyCount, 2.0);
        rmSetObjectDefMinDistance(capybara2ID, 0.0);
        rmSetObjectDefMaxDistance(capybara2ID, rmXFractionToMeters(0.4));
        rmAddObjectDefConstraint(capybara2ID, avoidFood);
        rmAddObjectDefConstraint(capybara2ID, avoidImpassableLand);
        rmAddObjectDefConstraint(capybara2ID, avoidCloseCliff);
		rmAddObjectDefConstraint(capybara2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(capybara2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(capybara2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(capybara2ID, avoidCloseNugget);
        rmAddObjectDefConstraint(capybara2ID, avoidAll);
		rmAddObjectDefConstraint(capybara2ID, avoidTC);
	    rmAddObjectDefConstraint(capybara2ID, southwestConstraint);
        rmSetObjectDefCreateHerd(capybara2ID, true);
	    rmPlaceObjectDefAtLoc(capybara2ID, 0, 0.5, 0.5, capyCount*2*cNumberNonGaiaPlayers);
	
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: *********************************** //
/*===============================================================================================================*/

        int randomTreeID=rmCreateObjectDef("random tree");
        rmAddObjectDefItem(randomTreeID, "TreeYucatan", rmRandInt(3,7), 5.0);
        rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(randomTreeID, avoidCloseFood);
		rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, forestConstraintClose);
		rmAddObjectDefConstraint(randomTreeID, forestConstraintSmallClose);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
        rmAddObjectDefConstraint(randomTreeID, avoidResource);
        rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
        rmAddObjectDefConstraint(randomTreeID, avoidCloseCliff);
		rmAddObjectDefConstraint(randomTreeID, avoidTC);
        rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 35*cNumberNonGaiaPlayers);
 
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.96);
/*===============================================================================================================*/
 
   // Define and place decorations: rocks and grass and stuff 
/*
   rmSetMapClusteringPlacementParams(0.0, 0.2, 1.0, cClusterLand);
   rmSetMapClusteringObjectParams(0, 2, 0.5);
   rmPlaceMapClusters("amazon\ground3_am", "OpenbrushAmazon");
*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		