/*===============================================================================================================*/
// ******************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************* //
/*===============================================================================================================*/

// THE SAGUENAY LAKES:
// CREATED BY DANY:
// AUGUST 2007:

/*===============================================================================================================*/
// *********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ********************************* //
/*===============================================================================================================*/

include "mercenaries.xs";
void main(void)
{

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*===============================================================================================================*/   
// ****************************************** DEFINE THE VARIATIONS: ******************************************* //
/*===============================================================================================================*/

	// VARIATIONS: THE NATIVE TRIBES HAVE 3 VARIATIONS: 
	// ( THE IROQUOIS...THE CREES...THE CHEROKEES: )
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*===============================================================================================================*/   
// ******************************************* PICKS THE MAP SIZE: ********************************************* //
/*===============================================================================================================*/
 
        int playerTiles=17500;		
        
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(530, 530);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*===============================================================================================================*/   
// **************************************** PICKS THE MAP PARAMETERS: ****************************************** //
/*===============================================================================================================*/
	
	    // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(1.0);

	    // PICKS DEFAULT TERRAIN AND WATER:
	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("saguenay tundra");
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("saguenay\ground1_sag",10);
		
	    // SET MAP TYPE:
		rmSetMapType("saguenay");
	    rmSetMapType("water");
	    rmSetMapType("grass");
		
		// SET LIGHTING:
		  rmSetLightingSet("saguenay");
		
	    // MAKE THE CORNERS:
	    rmSetWorldCircleConstraint(true);

	    // CHOOSES THE MERCS:
	    chooseMercs();
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*===============================================================================================================*/   
// ************************************** SET UP THE NATIVE TRIBES: ******************************************** //
/*===============================================================================================================*/

        int whichNative = rmRandInt(1,6);
		
/*---------------------------------------------------------------------------------------------------------------*/		
		
        int subCiv0 = -1;
        int subCiv1 = -1;
        string nativeName = "";
		
/*---------------------------------------------------------------------------------------------------------------*/

	    if (whichNative < 3)
	{
        subCiv0 = rmGetCivID("Iroquois");
        rmEchoInfo("subCiv0 is Iroquois "+subCiv0);
        subCiv1 = rmGetCivID("Iroquois");
        rmEchoInfo("subCiv1 is Iroquois "+subCiv1);
        rmSetSubCiv(0, "Iroquois", true);
        rmSetSubCiv(1, "Iroquois", true);
        nativeName = "native Iroquois village ";
	}
	
/*---------------------------------------------------------------------------------------------------------------*/
	
	    else if (whichNative == 3)
	{
        subCiv0 = rmGetCivID("Cree");
        rmEchoInfo("subCiv0 is Cree "+subCiv0);
        subCiv1 = rmGetCivID("Cree");
        rmEchoInfo("subCiv1 is Cree"+subCiv1);
        rmSetSubCiv(0, "Cree", true);
        rmSetSubCiv(1, "Cree", true);
        nativeName = "native Cree village ";
   }
   
/*---------------------------------------------------------------------------------------------------------------*/
   
        else
   {
        subCiv0 = rmGetCivID("Cherokee");
        rmEchoInfo("subCiv0 is Cherokee "+subCiv0);
        subCiv1 = rmGetCivID("Cherokee");
        rmEchoInfo("subCiv1 is Cherokee "+subCiv1);
        rmSetSubCiv(0, "Cherokee", true);
        rmSetSubCiv(1, "Cherokee", true);
        nativeName = "native Cherokee village ";
   }
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*===============================================================================================================*/   
// *************************** DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ********************** //
/*===============================================================================================================*/
 
        int classPlayer=rmDefineClass("player");
        rmDefineClass("classHill");
        rmDefineClass("classPatch");
		rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
	    rmDefineClass("classCliff");
	    rmDefineClass("classMountain");
		rmDefineClass("classSocket");

	    int classCliff = rmDefineClass("Cliffs");
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*===============================================================================================================*/   
// ******************************************* DEFINE THE CONSTRAINTS: ***************************************** //
// ************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: *********************** //
/*===============================================================================================================*/
  
        // MAP EDGE CONSTRAINTS:
        //int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
	    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.43), rmDegreesToRadians(0), rmDegreesToRadians(360));
	    int coinEdgeConstraint=rmCreateBoxConstraint("coin edge of map", rmXTilesToFraction(19), rmZTilesToFraction(19), 1.0-rmXTilesToFraction(19), 1.0-rmZTilesToFraction(19), 2.0);
        
		// THE FOLLOWING IS A PIE CONSTRAINT:
		// DEFINED IN A LARGE "MAJORITY OF THE PIE PLATE" AREA:
		// TO MAKE SURE WATER SPAWN FLAGS PLACE INSIDE IT:
		// ( IT EXCLUDES THE WEST BAY, WHERE I DO NOT WANT THE FLAGS: )
	    int circleConstraint=rmCreatePieConstraint("semi-circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(50), rmDegreesToRadians(290));  
		//rmZFractionToMeters(0.47)- this number defines how far out from .5, .5 the center of the pie sections go. 
		
		// CARDINAL DIRECTIONS:

	    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	    int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
	    int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	    int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));

	    // FLAG AVOIDANCE:
		int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 20.0);
		int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 10.0);
        int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
          		
		// PLAYER CONSTRAINTS:
	    int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 20.0);
	    int longPlayerConstraint=rmCreateClassDistanceConstraint("stay far away from players", classPlayer, 50.0);
 
        // NATURE AVOIDANCE:
	    int avoidForest=rmCreateClassDistanceConstraint("forest avoids forest", rmClassID("classForest"), 10.0);
	    int avoidCloseForest=rmCreateClassDistanceConstraint("close avoids forest", rmClassID("classForest"), 5.0);
	   	int avoidForestFar=rmCreateClassDistanceConstraint("forest avoids forest far", rmClassID("classForest"), 40.0);
	    
		int avoidTrees=rmCreateTypeDistanceConstraint("stuff avoids trees", "TreeSaguenay", 6.0);
	    int avoidCloseTrees=rmCreateTypeDistanceConstraint("close avoids trees", "TreeSaguenay", 3.0);
	    		
		int avoidturkey=rmCreateTypeDistanceConstraint("avoids turkey", "turkey", 45.0);
		
		int avoidFruits=rmCreateTypeDistanceConstraint("avoid random berries", "berrybush", 15.0);
		int fruitsAvoidFruits=rmCreateTypeDistanceConstraint("berries avoids random berries", "berrybush", 50.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoid berries", "berrybush", 5.0);
	    
		int avoiddeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 45.0);
	    int avoidclosedeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 5.0);
	    int avoiddeerFar=rmCreateTypeDistanceConstraint("deer avoids deer Far", "deer", 65.0);
		
		int avoidCows=rmCreateTypeDistanceConstraint("stuff avoids cows", "cow", 15.0);
	    int avoidcloseCows=rmCreateTypeDistanceConstraint("close avoids cows", "cow", 5.0);
	    int avoidCowsFar=rmCreateTypeDistanceConstraint("cows avoids cows Far", "cow", 65.0);
	    
		int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 45.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "gold", 5.0);
	    int avoidCoinFar=rmCreateTypeDistanceConstraint("avoid coin far", "gold", 75.0);
		
		// GOLD MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
		   
        // AVOID IMPASSABLE LAND:
	    int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
	    int avoidCloseImpassableLand = rmCreateTerrainDistanceConstraint("close avoid impassable land", "Land", false, 5.0);
		int mediumShortAvoidImpassableLand = rmCreateTerrainDistanceConstraint("mediumshort avoid impassable land", "Land", false, 10.0);
	    int shortAvoidImpassableLand = rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	    int mediumAvoidImpassableLand = rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 12.0);
	    int longAvoidImpassableLand = rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 20.0);

		// CLIFF AVOIDANCE:
		int avoidCliff = rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 12.0);
		int avoidCloseCliff = rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 5.0);
	    int cliffAvoidCliff = rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 30.0);
	   		
        // UNIT AVOIDANCE:
	    // int avoidHuari=rmCreateTypeDistanceConstraint("avoid Huari", "huariStronghold", 20.0); // REMOVED BY ME: 
	    
		// TOWNCENTER AVOIDANCE:
		int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 20.0);
	    int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 40.0);
	    int avoidTownCenterSupaFar=rmCreateTypeDistanceConstraint("avoid Town Center Supa Far", "townCenter", 50.0);
        
		// IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 60.0);
        int avoidCloseImportantItem=rmCreateClassDistanceConstraint("close avoid important item", rmClassID("importantItem"), 60.0);
       	int shortAvoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other by a bit", rmClassID("importantItem"), 10.0);
        
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 10.0);
        int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 5.0);
       	int avoidNativesFar=rmCreateClassDistanceConstraint("stuff avoids natives far", rmClassID("natives"), 45.0);
	    		
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 15.0);
	    int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 5.0);
	
        // TRADE ROUTE AVOIDANCE:
        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 5.0);
        int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route long", 20.0);
  		
		// SOCKET AVOIDANCE:
		int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 10.0);
 		int avoidCloseSocket = rmCreateClassDistanceConstraint("close avoid socket", rmClassID("classSocket"), 5.0);
 		
		// DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);
		int avoidCloseAll=rmCreateTypeDistanceConstraint("close avoid all", "all", 3.0);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*===============================================================================================================*/   
// ****************************************** DEFINE THE OBJECTS: ********************************************** //
// ************************ THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER: ************************* //
/*===============================================================================================================*/

	// THE ONLY OBJECT DEFINED FOR NOW: 
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	
	// DONE DEFINING THE OBJECTS:
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*===============================================================================================================*/   
// ********************************** DEFINE THE SET UP STARTING LOCATIONS: ************************************ //
/*===============================================================================================================*/

        int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	    int teamOneCount = rmGetNumberPlayersOnTeam(1);
		
		if ( cNumberTeams == 2 ) // && teamZeroCount == teamOneCount)
	{

		rmSetPlacementTeam(0);
		rmSetTeamSpacingModifier(0.50);
		rmPlacePlayersLine(0.15, 0.35, 0.35, 0.15, 0, 0.0);

		rmSetPlacementTeam(1);
		rmSetTeamSpacingModifier(0.50);
		rmPlacePlayersLine(0.65, 0.85, 0.85, 0.65, 0, 0.0);
	
	}
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*===============================================================================================================*/   
// ******************************** BUILD 2 AREAS: A NORTH AND A SOUTH AREA: *********************************** //
/*===============================================================================================================*/
/*	
	    // BUILD A NORTH AREA:
	    int eastIslandID = rmCreateArea("east island");
	    rmSetAreaLocation(eastIslandID, 0.15, 0.85); 
	    rmSetAreaWarnFailure(eastIslandID, false);
	    rmSetAreaSize(eastIslandID, 0.60, 0.60);
	    rmSetAreaCoherence(eastIslandID, 1.0);

	    rmSetAreaElevationType(eastIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(eastIslandID, 5.0);
	    rmSetAreaBaseHeight(eastIslandID, 4.0);
	    rmSetAreaElevationMinFrequency(eastIslandID, 0.07);
	    rmSetAreaElevationOctaves(eastIslandID, 4);
	    rmSetAreaElevationPersistence(eastIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(eastIslandID, 1);
   
	    rmSetAreaObeyWorldCircleConstraint(eastIslandID, false);
	    // rmSetAreaMix(eastIslandID, "nwt_grass1");
		   rmSetAreaMix(eastIslandID, "saguenay tundra");
		rmBuildArea(eastIslandID);
*/
/*---------------------------------------------------------------------------------------------------------------*/
/*
        // BUILD A SOUTH AREA:
	    int westIslandID = rmCreateArea("west island");
	    //rmSetAreaLocation(westIslandID, 0, 0.5);
	    rmSetAreaLocation(westIslandID, 0.75, 0.25);
	    rmSetAreaWarnFailure(westIslandID, false);
	    rmSetAreaSize(westIslandID, 0.60, 0.60);
	    rmSetAreaCoherence(westIslandID, 1.0);

	    rmSetAreaElevationType(westIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(westIslandID, 5.0);
	    rmSetAreaBaseHeight(westIslandID, 4.0);
	    rmSetAreaElevationMinFrequency(westIslandID, 0.07);
	    rmSetAreaElevationOctaves(westIslandID, 4);
	    rmSetAreaElevationPersistence(westIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(westIslandID, 1); 
	    //rmAddAreaTerrainLayer(westIslandID, "NWterritory\ground_grass1_nwt", 3, 12); // REMOVED BY ME FOR NOW:
   
	    rmSetAreaObeyWorldCircleConstraint(westIslandID, false);
	    // rmSetAreaMix(westIslandID, "nwt_grass1");
	       rmSetAreaMix(westIslandID, "saguenay tundra");
	    //rmSetAreaMix(westIslandID, "rockies_grass");
	    rmBuildArea(westIslandID);
*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*===============================================================================================================*/   
// ********************************** DEFINE AND PLACE THE LAKE IN THE MIDDLE: ********************************** //
/*================================================================================================================*/
        
		int lakeClass=rmDefineClass("lake");
	    int lakeConstraint=rmCreateClassDistanceConstraint("lake vs. lake", rmClassID("lake"), 20.0);
		int avoidCloseLake=rmCreateClassDistanceConstraint("close vs. lake", rmClassID("lake"), 5.0);
		
/*---------------------------------------------------------------------------------------------------------------*/
		

        int smallLakeID=rmCreateArea("small lake");
		rmSetAreaSize(smallLakeID, rmAreaTilesToFraction(2250), rmAreaTilesToFraction(2250));
		rmSetAreaWaterType(smallLakeID, "saguenay lake");
		rmSetAreaBaseHeight(smallLakeID, 4.0);
		rmAddAreaToClass(smallLakeID, lakeClass);
		rmAddAreaConstraint(smallLakeID, playerConstraint);
		//rmAddAreaConstraint(smallLakeID, avoidTradeRoute);
		rmSetAreaLocation(smallLakeID, 0.375, 0.375);
		rmSetAreaCoherence(smallLakeID, 0.75);
		rmSetAreaWarnFailure(smallLakeID, false);
		rmBuildArea(smallLakeID);
		
/*---------------------------------------------------------------------------------------------------------------*/
		
		
		int smallLake2ID=rmCreateArea("small lake 2");
		rmSetAreaSize(smallLake2ID, rmAreaTilesToFraction(2250), rmAreaTilesToFraction(2250));
		rmSetAreaWaterType(smallLake2ID, "saguenay lake");
		rmSetAreaBaseHeight(smallLake2ID, 4.0);
		rmAddAreaToClass(smallLake2ID, lakeClass);
		rmAddAreaConstraint(smallLake2ID, playerConstraint);
		//rmAddAreaConstraint(smallLake2ID, avoidTradeRoute);
		rmSetAreaLocation(smallLake2ID, 0.625, 0.625);
		rmSetAreaCoherence(smallLake2ID, 0.75);
		rmSetAreaWarnFailure(smallLake2ID, false);
		rmBuildArea(smallLake2ID);
	
/*---------------------------------------------------------------------------------------------------------------*/

        // rmBuildAllAreas(); // THIS WAS REMOVED BY ME:
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*===============================================================================================================*/   
// **************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*===============================================================================================================*/

        float playerFraction = rmAreaTilesToFraction(100);
        for(i = 0; < cNumberNonGaiaPlayers)
   {
        // CREATE THE AREA:
        int id = rmCreateArea("Player"+i);
      
	    // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
	    rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint);
	    
		// SET AREA TERRAIN TYPE:
		// rmSetAreaTerrainType(id, "NWterritory\ground_grass1_nwt");
	       rmSetAreaTerrainType(id, "saguenay\ground1_sag");
	            
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*===============================================================================================================*/   
// ****************************************** DEFINE THE VARIABLES: ******************************************** //
/*===============================================================================================================*/

       int failCount = -1;
       int numTries = cNumberNonGaiaPlayers+2;
	   
/*===============================================================================================================*/	   
 
   // Place Natives
      int nativeVillageA = 0;
      int nativeVillageTypeA = rmRandInt(1,5);
      
      nativeVillageA = rmCreateGrouping("Native village A "+i, nativeName+nativeVillageTypeA);
      rmSetGroupingMinDistance(nativeVillageA, 0.0);
      rmSetGroupingMaxDistance(nativeVillageA, 0.0);
      rmAddGroupingConstraint(nativeVillageA, avoidImpassableLand);
      rmAddGroupingToClass(nativeVillageA, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillageA, rmClassID("importantItem"));
      if (cNumberTeams > 2 || teamZeroCount > teamOneCount || teamOneCount > teamZeroCount)
      {
         rmPlaceGroupingAtLoc(nativeVillageA, 0, 0.515, 0.115);
      }
      else
      {
         rmPlaceGroupingAtLoc(nativeVillageA, 0, 0.515, 0.115);
      }

      int nativeVillageB = 0;
      int nativeVillageTypeB = rmRandInt(1,5);

      nativeVillageB = rmCreateGrouping("Native village B "+i, nativeName+nativeVillageTypeB);
      rmSetGroupingMinDistance(nativeVillageB, 0.0);
      rmSetGroupingMaxDistance(nativeVillageB, 0.0);
      rmAddGroupingConstraint(nativeVillageB, avoidImpassableLand);
      rmAddGroupingToClass(nativeVillageB, rmClassID("natives"));
      rmAddGroupingToClass(nativeVillageB, rmClassID("importantItem"));
      if (cNumberTeams > 2 || teamZeroCount > teamOneCount || teamOneCount > teamZeroCount)
      {
         rmPlaceGroupingAtLoc(nativeVillageB, 0, 0.485, 0.885);
      }
      else
      {
         rmPlaceGroupingAtLoc(nativeVillageB, 0, 0.485, 0.885);
      }

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*===============================================================================================================*/
// ******************* DEFINE THE STARTING TCID AND THE STARTING UNITS AND STARTING RESOURCES: ***************** //
/*===============================================================================================================*/
	
        rmClearClosestPointConstraints();
        
		// DEFINE THE STARTING TCID:
		int TCfloat = 0;
   
	    int TCID = rmCreateObjectDef("Player TC");

	    if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	}
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, TCfloat);

/*---------------------------------------------------------------------------------------------------------------*/
        
		int waterSpawnPointID = 0;

/*---------------------------------------------------------------------------------------------------------------*/

	    int playerSilverID = rmCreateObjectDef("player mine");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	    rmAddObjectDefConstraint(playerSilverID, avoidTownCenter);
	    rmSetObjectDefMinDistance(playerSilverID, 15.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 20.0);
        rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);
        rmAddObjectDefConstraint(playerSilverID, coinEdgeConstraint);
   
        // DEFINE THE PLAYER BERRIES:
	    int playerBerriesID=rmCreateObjectDef("player berries");
	    rmAddObjectDefItem(playerBerriesID, "berrybush", rmRandInt(4,6), 4.0);
        rmSetObjectDefMinDistance(playerBerriesID, 21);
        rmSetObjectDefMaxDistance(playerBerriesID, 26);		
	    rmAddObjectDefConstraint(playerBerriesID, avoidTownCenter);
		//rmAddObjectDefConstraint(playerBerriesID, avoidAll);
		//rmAddObjectDefConstraint(playerBerriesID, coinEdgeconstraint);
        rmAddObjectDefConstraint(playerBerriesID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(playerBerriesID, true);

	    // DEFINE THE PLAYER TURKEY:
		int playerturkeyID=rmCreateObjectDef("player turkey");
        rmAddObjectDefItem(playerturkeyID, "turkey", rmRandInt(8,10), 10.0);
        rmSetObjectDefMinDistance(playerturkeyID, 10);
        rmSetObjectDefMaxDistance(playerturkeyID, 18);
        rmAddObjectDefConstraint(playerturkeyID, avoidAll);
        rmAddObjectDefConstraint(playerturkeyID, avoidImpassableLand);
        rmAddObjectDefConstraint(playerturkeyID, avoidCliff);
        rmSetObjectDefCreateHerd(playerturkeyID, true);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID= rmCreateObjectDef("player nugget"); 
	    rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidAll);
	    rmAddObjectDefConstraint(playerNuggetID, avoidCliff);
	    rmAddObjectDefConstraint(playerNuggetID, playerEdgeConstraint);
	    rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	    rmSetObjectDefMaxDistance(playerNuggetID, 30.0);

	    // DEFINE THE PLAYER TREE:
		int playerTreeID = rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, "TreeSaguenay", rmRandInt(5,10), 8.0);
        rmSetObjectDefMinDistance(playerTreeID, 15);
        rmSetObjectDefMaxDistance(playerTreeID, 20);
        rmAddObjectDefConstraint(playerTreeID, avoidAll);
        rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
	
/*===============================================================================================================*/
// ******************* PLACE THE STARTING TCID AND THE STARTING UNITS AND STARTING RESOURCES: ****************** //
/*===============================================================================================================*/

	    for(i = 1; < cNumberPlayers)
		
   {
   	
	    // PLACE THE STARTING TCID:
	    rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
			
	    // PLACE THE STARTING UNITS:
	    rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	
	    // PLACE THE PLAYER SILVER:
	    rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	
	    // PLACE THE PLAYER BERRIES:
	    rmPlaceObjectDefAtLoc(playerBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc))); 
	
	    // PLACE THE PLAYER TREE:
	    rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	
	    // PLACE THE PLAYER TURKEY:
	    rmPlaceObjectDefAtLoc(playerturkeyID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	
	    // PLACE THE PLAYER NUGGET:
	    rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
         
		// PLACE WATER SPAWN POINTS FOR THE PLAYERS:
		waterSpawnPointID=rmCreateObjectDef("colony ship "+i);
		rmAddObjectDefItem(waterSpawnPointID, "HomeCityWaterSpawnFlag", 1, 10.0);  // ...Flag", 1, 1.0); - the first number is the number of flags.  The next number is the float distance.
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		rmAddClosestPointConstraint(circleConstraint);
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
		rmPlaceObjectDefAtLoc(waterSpawnPointID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
			
		// CLEAR CLOSEST POINT CONSTRAINTS AS A GOOG MEASURE:
        rmClearClosestPointConstraints();
   }
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*===============================================================================================================*/   
// ************************************** DEFINE AND PLACE THE 4 CLIFFS: *************************************** //
/*===============================================================================================================*/

            // CLIFF NUMBER 1:
		    int cliffID=rmCreateArea("cliff");
            rmSetAreaSize(cliffID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
            rmSetAreaWarnFailure(cliffID, false);
	        rmSetAreaCliffType(cliffID, "New England");
		    rmSetAreaCliffEdge(cliffID, 2, 0.4, 0.1, 1.0, 0);
		    //rmSetAreaCliffEdge(cliffID, 1, 1.0, 0.1, 1.0, 0);
		    rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
            rmSetAreaCliffHeight(cliffID, -6, 1.0, 1.0);
            rmSetAreaHeightBlend(cliffID, 1);
            rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
            rmAddAreaConstraint(cliffID, avoidCliff);
	        rmSetAreaMinBlobs(cliffID, 1);
            rmSetAreaMaxBlobs(cliffID, 1);
            rmSetAreaMinBlobDistance(cliffID, 1);
            rmSetAreaMaxBlobDistance(cliffID, 1);
            rmSetAreaSmoothDistance(cliffID, 10);
            rmSetAreaCoherence(cliffID, 0.75);
		    rmSetAreaLocation(cliffID, 0.20, 0.60);
		    rmBuildArea(cliffID);
		
/*---------------------------------------------------------------------------------------------------------------*/
        
		// CLIFF NUMBER 2:
		int cliff2ID=rmCreateArea("cliff 2");
        rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
        rmSetAreaWarnFailure(cliff2ID, false);
	    rmSetAreaCliffType(cliff2ID, "New England");
		rmSetAreaCliffEdge(cliff2ID, 2, 0.4, 0.1, 1.0, 0);
		//rmSetAreaCliffEdge(cliff2ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff2ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff2ID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff2ID, 1);
        rmAddAreaToClass(cliff2ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff2ID, avoidCliff);
	    rmSetAreaMinBlobs(cliff2ID, 1);
        rmSetAreaMaxBlobs(cliff2ID, 1);
        rmSetAreaMinBlobDistance(cliff2ID, 1);
        rmSetAreaMaxBlobDistance(cliff2ID, 1);
        rmSetAreaSmoothDistance(cliff2ID, 10);
        rmSetAreaCoherence(cliff2ID, 0.75);
		rmSetAreaLocation(cliff2ID, 0.60, 0.20);
		rmBuildArea(cliff2ID);

/*---------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 3:
		int cliff3ID=rmCreateArea("cliff 3");
        rmSetAreaSize(cliff3ID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
        rmSetAreaWarnFailure(cliff3ID, false);
	    rmSetAreaCliffType(cliff3ID, "New England");
		rmSetAreaCliffEdge(cliff3ID, 2, 0.4, 0.1, 1.0, 0);
		//rmSetAreaCliffEdge(cliff3ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff3ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff3ID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff3ID, 1);
        rmAddAreaToClass(cliff3ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff3ID, avoidCliff);
	    rmSetAreaMinBlobs(cliff3ID, 1);
        rmSetAreaMaxBlobs(cliff3ID, 1);
        rmSetAreaMinBlobDistance(cliff3ID, 1);
        rmSetAreaMaxBlobDistance(cliff3ID, 1);
        rmSetAreaSmoothDistance(cliff3ID, 10);
        rmSetAreaCoherence(cliff3ID, 0.75);
		rmSetAreaLocation(cliff3ID, 0.40, 0.80);
		rmBuildArea(cliff3ID);
		
/*---------------------------------------------------------------------------------------------------------------*/		

        // CLIFF NUMBER 4:
		int cliff4ID=rmCreateArea("cliff 4");
        rmSetAreaSize(cliff4ID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
        rmSetAreaWarnFailure(cliff4ID, false);
	    rmSetAreaCliffType(cliff4ID, "New England");
		rmSetAreaCliffEdge(cliff4ID, 2, 0.4, 0.1, 1.0, 0);
		//rmSetAreaCliffEdge(cliff4ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff4ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff4ID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff4ID, 1);
        rmAddAreaToClass(cliff4ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff4ID, avoidCliff);
	    rmSetAreaMinBlobs(cliff4ID, 1);
        rmSetAreaMaxBlobs(cliff4ID, 1);
        rmSetAreaMinBlobDistance(cliff4ID, 1);
        rmSetAreaMaxBlobDistance(cliff4ID, 1);
        rmSetAreaSmoothDistance(cliff4ID, 10);
        rmSetAreaCoherence(cliff4ID, 0.75);
		rmSetAreaLocation(cliff4ID, 0.80, 0.40);
		rmBuildArea(cliff4ID);	
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*===============================================================================================================*/   
// ************************************ DEFINE AND PLACE THE TRADE ROUTE: ************************************** //
/*===============================================================================================================*/

        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 6.0);

	    int tradeRouteID = rmCreateTradeRoute();
	    rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	    rmAddTradeRouteWaypoint(tradeRouteID, 1.0, 0.0);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.0, 1.0);

	    bool placedTradeRouteA = rmBuildTradeRoute(tradeRouteID, "dirt");
	    if(placedTradeRouteA == false)
		rmEchoError("Failed to place trade route 1");

	    rmPlaceObjectDefAtLoc(socketID, 0, 0.25, 0.75);
	    rmPlaceObjectDefAtLoc(socketID, 0, 0.50, 0.50);
	    rmPlaceObjectDefAtLoc(socketID, 0, 0.75, 0.25);
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*===============================================================================================================*/   
// **************************************** DEFINE AND PLACE THE NUGGETS: ************************************** //
/*===============================================================================================================*/

	    // THE NUGGETS EASY 1:
		int nuggeteasyID= rmCreateObjectDef("nugget easy 1"); 
	    rmAddObjectDefItem(nuggeteasyID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nuggeteasyID, 0.0);
	    rmSetObjectDefMaxDistance(nuggeteasyID, rmXFractionToMeters(0.5));
  	    rmAddObjectDefConstraint(nuggeteasyID, avoidNugget);
  	    rmAddObjectDefConstraint(nuggeteasyID, avoidTownCenter);
	    rmAddObjectDefConstraint(nuggeteasyID, avoidCloseCliff);
		rmAddObjectDefConstraint(nuggeteasyID, avoidCloseLake);
		rmAddObjectDefConstraint(nuggeteasyID, avoidCloseSocket);
  	    rmAddObjectDefConstraint(nuggeteasyID, avoidAll);
  	    rmAddObjectDefConstraint(nuggeteasyID, avoidImpassableLand);
	    rmAddObjectDefConstraint(nuggeteasyID, playerEdgeConstraint);
	    rmPlaceObjectDefAtLoc(nuggeteasyID, 0, 0.5, 0.5, cNumberNonGaiaPlayers/2);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS EASY 2:
		int nuggeteasy2ID= rmCreateObjectDef("nugget easy 2"); 
	    rmAddObjectDefItem(nuggeteasy2ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nuggeteasy2ID, 0.0);
	    rmSetObjectDefMaxDistance(nuggeteasy2ID, 0.0);
  	    rmAddObjectDefConstraint(nuggeteasy2ID, avoidNugget);
  	    
	    rmPlaceObjectDefAtLoc(nuggeteasy2ID, 0, 0.45, 0.15);
		rmPlaceObjectDefAtLoc(nuggeteasy2ID, 0, 0.65, 0.05);
		rmPlaceObjectDefAtLoc(nuggeteasy2ID, 0, 0.55, 0.85);
		rmPlaceObjectDefAtLoc(nuggeteasy2ID, 0, 0.35, 0.95);
				
/*---------------------------------------------------------------------------------------------------------------*/

	    // THE NUGGETS MEDIUM NORTH:
		int nuggetmediumNorthID= rmCreateObjectDef("nugget medium north"); 
	    rmAddObjectDefItem(nuggetmediumNorthID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nuggetmediumNorthID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetmediumNorthID, rmXFractionToMeters(0.5));
  	    rmAddObjectDefConstraint(nuggetmediumNorthID, avoidNugget);
  	    rmAddObjectDefConstraint(nuggetmediumNorthID, avoidTownCenter);
	    rmAddObjectDefConstraint(nuggetmediumNorthID, avoidCloseCliff);
		rmAddObjectDefConstraint(nuggetmediumNorthID, avoidCloseLake);
		rmAddObjectDefConstraint(nuggetmediumNorthID, avoidCloseSocket);
  	    rmAddObjectDefConstraint(nuggetmediumNorthID, avoidAll);
  	    rmAddObjectDefConstraint(nuggetmediumNorthID, avoidImpassableLand);
	    rmAddObjectDefConstraint(nuggetmediumNorthID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(nuggetmediumNorthID, Northward);
	    rmPlaceObjectDefAtLoc(nuggetmediumNorthID, 0, 0.5, 0.5, 3);
		
/*---------------------------------------------------------------------------------------------------------------*/

	    // THE NUGGETS MEDIUM SOUTH:
		int nuggetmediumSouthID= rmCreateObjectDef("nugget medium south"); 
	    rmAddObjectDefItem(nuggetmediumSouthID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nuggetmediumSouthID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetmediumSouthID, rmXFractionToMeters(0.5));
  	    rmAddObjectDefConstraint(nuggetmediumSouthID, avoidNugget);
  	    rmAddObjectDefConstraint(nuggetmediumSouthID, avoidTownCenter);
	    rmAddObjectDefConstraint(nuggetmediumSouthID, avoidCloseCliff);
		rmAddObjectDefConstraint(nuggetmediumSouthID, avoidCloseLake);
		rmAddObjectDefConstraint(nuggetmediumSouthID, avoidCloseSocket);
  	    rmAddObjectDefConstraint(nuggetmediumSouthID, avoidAll);
  	    rmAddObjectDefConstraint(nuggetmediumSouthID, avoidImpassableLand);
	    rmAddObjectDefConstraint(nuggetmediumSouthID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(nuggetmediumSouthID, Southward);
	    rmPlaceObjectDefAtLoc(nuggetmediumSouthID, 0, 0.5, 0.5, 3);
		
/*---------------------------------------------------------------------------------------------------------------*/
		
        // THE NUGGETS HARD:
	    int nuggethardID= rmCreateObjectDef("nugget hard"); 
		rmAddObjectDefItem(nuggethardID, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(3, 3);
		rmSetObjectDefMinDistance(nuggethardID, 0.0);
		rmSetObjectDefMaxDistance(nuggethardID, rmXFractionToMeters(0.5));
  		rmAddObjectDefConstraint(nuggethardID, avoidNugget);
  		rmAddObjectDefConstraint(nuggethardID, avoidTownCenter);
		rmAddObjectDefConstraint(nuggethardID, avoidCloseCliff);
		rmAddObjectDefConstraint(nuggethardID, avoidCloseLake);
		rmAddObjectDefConstraint(nuggethardID, avoidCloseSocket);
  		rmAddObjectDefConstraint(nuggethardID, avoidAll);
		rmAddObjectDefConstraint(nuggethardID, playerEdgeConstraint);
  		rmAddObjectDefConstraint(nuggethardID, avoidImpassableLand);
		rmPlaceObjectDefAtLoc(nuggethardID, 0, 0.5, 0.5, cNumberNonGaiaPlayers/2);
		
/*---------------------------------------------------------------------------------------------------------------*/

	    if(rmRandFloat(0,1) < 0.50) // ONLY PLACES MORE HARD NUGGETS 50% OF THE TIME:
		
		{
		int nuggethard2ID= rmCreateObjectDef("nugget hard2"); 
		rmAddObjectDefItem(nuggethard2ID, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(3, 3);
		rmSetObjectDefMinDistance(nuggethard2ID, 0.0);
		rmSetObjectDefMaxDistance(nuggethard2ID, rmXFractionToMeters(0.5));
  		rmAddObjectDefConstraint(nuggethard2ID, avoidNugget);
  		rmAddObjectDefConstraint(nuggethard2ID, avoidTownCenter);
		rmAddObjectDefConstraint(nuggethard2ID, avoidCloseCliff);
		rmAddObjectDefConstraint(nuggethard2ID, avoidCloseLake);
		rmAddObjectDefConstraint(nuggethard2ID, avoidCloseSocket);
  		rmAddObjectDefConstraint(nuggethard2ID, avoidAll);
  		rmAddObjectDefConstraint(nuggethard2ID, avoidImpassableLand);
        rmAddObjectDefConstraint(nuggethard2ID, playerEdgeConstraint);
		rmPlaceObjectDefAtLoc(nuggethard2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers/2);
		}
	    
		else if (rmRandFloat(0,1) < 0.25)  // ONLY TRY TO PLACE NUTS 25% OF THE TIME:
		
		{
		int nuggetnutsID= rmCreateObjectDef("nugget nuts"); 
		rmAddObjectDefItem(nuggetnutsID, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(4, 4);
		rmSetObjectDefMinDistance(nuggetnutsID, 0.0);
		rmSetObjectDefMaxDistance(nuggetnutsID, rmXFractionToMeters(0.5));
  		rmAddObjectDefConstraint(nuggetnutsID, avoidNugget);
  		rmAddObjectDefConstraint(nuggetnutsID, avoidTownCenter);
		rmAddObjectDefConstraint(nuggetnutsID, avoidCloseCliff);
		rmAddObjectDefConstraint(nuggetnutsID, avoidCloseLake);
		rmAddObjectDefConstraint(nuggetnutsID, avoidCloseSocket);
  		rmAddObjectDefConstraint(nuggetnutsID, avoidAll);
  		rmAddObjectDefConstraint(nuggetnutsID, avoidImpassableLand);
        rmAddObjectDefConstraint(nuggetnutsID, playerEdgeConstraint);
		rmPlaceObjectDefAtLoc(nuggetnutsID, 0, 0.5, 0.5, 2);
		}

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*===============================================================================================================*/   
// ************************************* DEFINE AND PLACE THE SILVER MINES: ************************************ //
/*===============================================================================================================*/
 
	    int silverType = -1;
	    int silverCount = (cNumberNonGaiaPlayers*1.5 + rmRandInt(1,2));
	    //if (cNumberNonGaiaPlayers > 5)
		if (cNumberNonGaiaPlayers <= 4)
		silverCount = silverCount - 5;
	    rmEchoInfo("silver count = "+silverCount);

	    for(i=0; < silverCount)
	{
        int silverID = rmCreateObjectDef("silverEast "+i);
        rmAddObjectDefItem(silverID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silverID, 0.0);
        rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(silverID, avoidCoin);
        rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, avoidCloseCliff);
		rmAddObjectDefConstraint(silverID, avoidSocket);
		rmAddObjectDefConstraint(silverID, avoidCloseLake);
        rmAddObjectDefConstraint(silverID, avoidTownCenterFar);
        rmAddObjectDefConstraint(silverID, avoidNatives);
        rmAddObjectDefConstraint(silverID, avoidImpassableLand);
        rmAddObjectDefConstraint(silverID, coinEdgeConstraint);
        rmAddObjectDefConstraint(silverID, Eastward);
        //rmAddObjectDefConstraint(silverID, eastIslandID);
        rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }

	    for(i=0; < silverCount)
	{
        int silverWestID = rmCreateObjectDef("silverWest "+i);
        rmAddObjectDefItem(silverWestID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silverWestID, 0.0);
        rmSetObjectDefMaxDistance(silverWestID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(silverWestID, avoidCoin);
        rmAddObjectDefConstraint(silverWestID, avoidAll);
		rmAddObjectDefConstraint(silverWestID, avoidCloseCliff);
		rmAddObjectDefConstraint(silverWestID, avoidSocket);
		rmAddObjectDefConstraint(silverWestID, avoidCloseLake);
        rmAddObjectDefConstraint(silverWestID, avoidTownCenterFar);
        rmAddObjectDefConstraint(silverWestID, avoidNatives);
        rmAddObjectDefConstraint(silverWestID, avoidImpassableLand);
        rmAddObjectDefConstraint(silverWestID, Westward);
        //rmAddObjectDefConstraint(silverWestID, westIslandID);
        rmAddObjectDefConstraint(silverWestID, coinEdgeConstraint);
        rmPlaceObjectDefAtLoc(silverWestID, 0, 0.5, 0.5);
   }

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*===============================================================================================================*/   
// ************************ DEFINE AND PLACE THE SILVER MINES TO FILL IN LARGE GAPS: *************************** //
/*===============================================================================================================*/

	    silverCount = 2;
	    for(i=0; < silverCount)
	{
	    int silverEastRandomID = rmCreateObjectDef("silverEastRandom "+i);
	    rmAddObjectDefItem(silverEastRandomID, "mine", 1, 0.0);
	    rmSetObjectDefMinDistance(silverEastRandomID, 0.0);
	    rmSetObjectDefMaxDistance(silverEastRandomID, rmXFractionToMeters(0.2));
	    rmAddObjectDefConstraint(silverEastRandomID, avoidCoinFar);
	    rmAddObjectDefConstraint(silverEastRandomID, avoidAll);
		rmAddObjectDefConstraint(silverEastRandomID, avoidCloseCliff);
		rmAddObjectDefConstraint(silverEastRandomID, avoidSocket);
		rmAddObjectDefConstraint(silverEastRandomID, avoidCloseLake);
	    rmAddObjectDefConstraint(silverEastRandomID, avoidNativesFar);
	    rmAddObjectDefConstraint(silverEastRandomID, longAvoidImpassableLand);
	    rmAddObjectDefConstraint(silverEastRandomID, coinEdgeConstraint);
        rmAddObjectDefConstraint(silverEastRandomID, Eastward);
	    rmPlaceObjectDefAtLoc(silverEastRandomID, 0, 0.5, 0.5);
	}

/*---------------------------------------------------------------------------------------------------------------*/
	    
		silverCount = 2;
	    for(i=0; < silverCount)
	{
        int silverWestRandomID = rmCreateObjectDef("silverWestRandom "+i);
        rmAddObjectDefItem(silverWestRandomID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silverWestRandomID, 0.0);
        rmSetObjectDefMaxDistance(silverWestRandomID, rmXFractionToMeters(0.2));
        rmAddObjectDefConstraint(silverWestRandomID, avoidCoinFar);
        rmAddObjectDefConstraint(silverWestRandomID, avoidAll);
		rmAddObjectDefConstraint(silverWestRandomID, avoidCloseCliff);
		rmAddObjectDefConstraint(silverWestRandomID, avoidSocket);
		rmAddObjectDefConstraint(silverWestRandomID, avoidCloseLake);
        rmAddObjectDefConstraint(silverWestRandomID, avoidNativesFar);
        rmAddObjectDefConstraint(silverWestRandomID, longAvoidImpassableLand);
        rmAddObjectDefConstraint(silverWestRandomID, coinEdgeConstraint);
        rmAddObjectDefConstraint(silverWestRandomID, Westward);
        rmPlaceObjectDefAtLoc(silverWestRandomID, 0, 0.5, 0.5);
   }
   
/*===============================================================================================================*/
// ********************************* DEFINE AND PLACE THE SCATTERED BERRIES: *********************************** //		
/*===============================================================================================================*/
	
	    // DEFINE AND PLACE SOME RANDOM BERRIES:
		int berriesID=rmCreateObjectDef("The Fruits Berries");
	    rmAddObjectDefItem(berriesID, "berrybush", rmRandInt(3,5), 4.0);  
	    rmSetObjectDefMinDistance(berriesID, 0.0);
	    rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(berriesID, avoidCoinFar);
	    rmAddObjectDefConstraint(berriesID, avoidCloseCliff);   
	    rmAddObjectDefConstraint(berriesID, avoidCloseLake);
	    rmAddObjectDefConstraint(berriesID, avoidAll);
		rmAddObjectDefConstraint(berriesID, playerConstraint);
		rmAddObjectDefConstraint(berriesID, avoidGold);
		rmAddObjectDefConstraint(berriesID, avoidCoin);
	    rmAddObjectDefConstraint(berriesID, fruitsAvoidFruits);
	    rmAddObjectDefConstraint(berriesID, avoidImpassableLand);
	    rmAddObjectDefConstraint(berriesID, avoidCloseSocket);
		rmAddObjectDefConstraint(berriesID, playerEdgeConstraint);
		rmAddObjectDefConstraint(berriesID, avoidCloseNatives);
	    
		rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE SOME FIXED BERRIES NEAR TCS:
		int berries2ID=rmCreateObjectDef("The Fruits Berries 2");
	    rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(5,7), 4.0);  
	    rmSetObjectDefMinDistance(berries2ID, 0.0);
	    rmSetObjectDefMaxDistance(berries2ID, 0.0);
	    rmAddObjectDefConstraint(berries2ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.135, 0.235);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.235, 0.135);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.765, 0.865);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.865, 0.765);
				
/*===============================================================================================================*/
// **************************************** DEFINE THE RANDOM COWS: ******************************************** //
/*===============================================================================================================*/
		
		int RandomCowsID=rmCreateObjectDef("The Random Cows");
        rmAddObjectDefItem(RandomCowsID, "cow", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(RandomCowsID, 0.0);
        rmSetObjectDefMaxDistance(RandomCowsID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(RandomCowsID, avoidCoinFar);
		rmAddObjectDefConstraint(RandomCowsID, avoidTownCenterFar);
	    rmAddObjectDefConstraint(RandomCowsID, avoidCloseCliff);   
	    rmAddObjectDefConstraint(RandomCowsID, avoidCloseLake);
	    rmAddObjectDefConstraint(RandomCowsID, avoidAll);
		rmAddObjectDefConstraint(RandomCowsID, avoidCows);
		rmAddObjectDefConstraint(RandomCowsID, playerConstraint);
		rmAddObjectDefConstraint(RandomCowsID, avoidGold);
		rmAddObjectDefConstraint(RandomCowsID, avoidCoin);
	    rmAddObjectDefConstraint(RandomCowsID, avoidFruits);
	    rmAddObjectDefConstraint(RandomCowsID, avoidImpassableLand);
	    rmAddObjectDefConstraint(RandomCowsID, avoidCloseSocket);
		rmAddObjectDefConstraint(RandomCowsID, playerEdgeConstraint);
		rmAddObjectDefConstraint(RandomCowsID, avoidCloseNatives);
		
		rmPlaceObjectDefAtLoc(RandomCowsID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*===============================================================================================================*/   
// ************************************ DEFINE AND PLACE THE FOREST AREAS: ************************************* //
/*===============================================================================================================*/

	        if (cNumberNonGaiaPlayers <= 4)
		    numTries=3*cNumberNonGaiaPlayers;
	        else
		    numTries=4*cNumberNonGaiaPlayers;
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int forestID=rmCreateArea("forestID"+i);
			rmSetAreaWarnFailure(forestID, false);
			rmSetAreaSize(forestID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(350));
			rmSetAreaForestType(forestID, "saguenay forest");
			rmSetAreaForestDensity(forestID, 0.7);
			rmSetAreaForestClumpiness(forestID, 0.6);		
			rmSetAreaForestUnderbrush(forestID, 0.6);
			rmSetAreaMinBlobs(forestID, 1);
			rmSetAreaMaxBlobs(forestID, 10);						
			rmSetAreaMinBlobDistance(forestID, 5.0);
			rmSetAreaMaxBlobDistance(forestID, 20.0);
			rmSetAreaCoherence(forestID, 0.4);
			rmSetAreaSmoothDistance(forestID, 10);
			rmAddAreaToClass(forestID, rmClassID("classForest"));
			rmAddAreaConstraint(forestID, avoidForest);  
			rmAddAreaConstraint(forestID, shortAvoidImportantItem);
			rmAddAreaConstraint(forestID, playerConstraint);
			rmAddAreaConstraint(forestID, avoidCloseCliff);
			rmAddAreaConstraint(forestID, avoidCloseSocket);
			rmAddAreaConstraint(forestID, avoidCloseLake);
			rmAddAreaConstraint(forestID, avoidAll);
			if(rmBuildArea(forestID)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==10)
					break;
			}
			else
				failCount=0; 
		}
		
/*---------------------------------------------------------------------------------------------------------------*/		

	        if (cNumberNonGaiaPlayers <= 4)
		    numTries=3*cNumberNonGaiaPlayers;
	        else
		    numTries=4*cNumberNonGaiaPlayers; 
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int forestEastID=rmCreateArea("forestEastID"+i);
			rmSetAreaWarnFailure(forestEastID, false);
			rmSetAreaSize(forestEastID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(350));
			rmSetAreaForestType(forestEastID, "saguenay forest");
			rmSetAreaForestDensity(forestEastID, 0.7);
			rmSetAreaForestClumpiness(forestEastID, 0.6);		
			rmSetAreaForestUnderbrush(forestEastID, 0.6);
			rmSetAreaMinBlobs(forestEastID, 2);
			rmSetAreaMaxBlobs(forestEastID, 10);						
			rmSetAreaMinBlobDistance(forestEastID, 5.0);
			rmSetAreaMaxBlobDistance(forestEastID, 20.0);
			rmSetAreaCoherence(forestEastID, 0.4);
			rmSetAreaSmoothDistance(forestEastID, 10);
			rmAddAreaToClass(forestEastID, rmClassID("classForest"));
			rmAddAreaConstraint(forestEastID, avoidForest);  
			rmAddAreaConstraint(forestEastID, shortAvoidImportantItem);
			rmAddAreaConstraint(forestEastID, playerConstraint);
			rmAddAreaConstraint(forestEastID, avoidCloseCliff);
			rmAddAreaConstraint(forestEastID, avoidCloseLake);
			rmAddAreaConstraint(forestEastID, avoidCloseSocket);
			rmAddAreaConstraint(forestEastID, avoidAll);
			if(rmBuildArea(forestEastID)==false)
		{
			// Stop trying once we fail 5 times in a row.
			failCount++;
			if(failCount==10)
			break;
		}
			else
			failCount=0; 
		}
		
/*---------------------------------------------------------------------------------------------------------------*/		

	        numTries=6*cNumberNonGaiaPlayers;  
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int forestRandomID=rmCreateArea("forestRandomID"+i);
			rmSetAreaWarnFailure(forestRandomID, false);
			rmSetAreaSize(forestRandomID, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
			rmSetAreaForestType(forestRandomID, "saguenay forest");
			rmSetAreaForestDensity(forestRandomID, 0.6);
			rmSetAreaForestClumpiness(forestRandomID, 0.5);		
			rmSetAreaForestUnderbrush(forestRandomID, 0.4);
			rmSetAreaMinBlobs(forestRandomID, 2);
			rmSetAreaMaxBlobs(forestRandomID, 6);						
			rmSetAreaMinBlobDistance(forestRandomID, 5.0);
			rmSetAreaMaxBlobDistance(forestRandomID, 15.0);
			rmSetAreaCoherence(forestRandomID, 0.4);
			rmSetAreaSmoothDistance(forestRandomID, 10);
			rmAddAreaToClass(forestRandomID, rmClassID("classForest"));
			rmAddAreaConstraint(forestRandomID, avoidForestFar); 
			rmAddAreaConstraint(forestRandomID, shortAvoidImportantItem);
			rmAddAreaConstraint(forestRandomID, playerConstraint);
			rmAddAreaConstraint(forestRandomID, avoidCloseCliff);
			rmAddAreaConstraint(forestRandomID, avoidCloseLake);
			rmAddAreaConstraint(forestRandomID, avoidCloseSocket);
			rmAddAreaConstraint(forestRandomID, avoidAll);
			if(rmBuildArea(forestRandomID)==false)
		{
			// Stop trying once we fail 5 times in a row.
			failCount++;
			if(failCount==10)
			break;
		}
			else
			failCount=0; 
		}

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*===============================================================================================================*/   
// **************************** DEFINE THE RESOURCES THAT CAN BE PLACE AFTER THE FORESTS: ********************** //
/*===============================================================================================================*/

	    // TEXT:
	

	    // RESOURCES THAT CAN BE PLACED AFTER FORESTS:


	    // TEXT:
	
/*---------------------------------------------------------------------------------------------------------------*/
	
	    if (cNumberNonGaiaPlayers<=4)
		{int deerCount =2.0*cNumberNonGaiaPlayers;}
	    else
		{deerCount =1.0*cNumberNonGaiaPlayers;}

	    rmEchoInfo("deer count = "+deerCount);
		
/*---------------------------------------------------------------------------------------------------------------*/		
	
	    for (i=0; <deerCount)
	{
	    int deerEastID = rmCreateObjectDef("deer east herd " +i);
	    rmAddObjectDefItem(deerEastID, "deer", rmRandInt(8,10), 6);
	    rmSetObjectDefMinDistance(deerEastID, 0.0);
	    rmSetObjectDefMaxDistance(deerEastID, rmXFractionToMeters(0.8));
	    rmAddObjectDefConstraint(deerEastID, avoiddeer);
	    rmAddObjectDefConstraint(deerEastID, avoidturkey);
	    rmAddObjectDefConstraint(deerEastID, avoidAll);
		rmAddObjectDefConstraint(deerEastID, avoidNugget);
		rmAddObjectDefConstraint(deerEastID, avoidCloseSocket);
		rmAddObjectDefConstraint(deerEastID, avoidCloseLake);
	    rmAddObjectDefConstraint(deerEastID, avoidNativesFar);
	    rmAddObjectDefConstraint(deerEastID, avoidCloseCliff);
	    rmAddObjectDefConstraint(deerEastID, Northward);
	    rmSetObjectDefCreateHerd(deerEastID, true);
	
	    rmPlaceObjectDefAtLoc(deerEastID, 0, 0.5, 0.5);
	}

/*---------------------------------------------------------------------------------------------------------------*/
	
	    for (i=0; <deerCount)
	{
	    int deerWestID = rmCreateObjectDef("deer west herd " +i);
	    rmAddObjectDefItem(deerWestID, "deer", rmRandInt(8,10), 6);
	    rmSetObjectDefMinDistance(deerWestID, 0.0);
	    rmSetObjectDefMaxDistance(deerWestID, rmXFractionToMeters(0.8));
	    rmAddObjectDefConstraint(deerWestID, avoiddeer);
	    rmAddObjectDefConstraint(deerWestID, avoidturkey);
	    rmAddObjectDefConstraint(deerWestID, avoidAll);
		rmAddObjectDefConstraint(deerWestID, avoidNugget);
		rmAddObjectDefConstraint(deerWestID, avoidCloseSocket);
		rmAddObjectDefConstraint(deerWestID, avoidCloseLake);
		rmAddObjectDefConstraint(deerWestID, avoidCloseCliff);
	    rmAddObjectDefConstraint(deerWestID, avoidNativesFar);
	    rmAddObjectDefConstraint(deerWestID, Southward);
	    rmSetObjectDefCreateHerd(deerWestID, true);
	    rmPlaceObjectDefAtLoc(deerWestID, 0, 0.5, 0.5);
	}

/*---------------------------------------------------------------------------------------------------------------*/	

	        if (cNumberNonGaiaPlayers == 4)
	{
	        deerCount =4;
		    for (i=0; <deerCount)
		{
			int deerRandomID = rmCreateObjectDef("deer random herd " +i);
			rmAddObjectDefItem(deerRandomID, "deer", rmRandInt(3,6), 6);
			rmSetObjectDefMinDistance(deerRandomID, 0.0);
			rmSetObjectDefMaxDistance(deerRandomID, rmXFractionToMeters(0.8));
			rmAddObjectDefConstraint(deerRandomID, avoiddeerFar);
			rmAddObjectDefConstraint(deerRandomID, avoidturkey);
			rmAddObjectDefConstraint(deerRandomID, avoidAll);
			rmAddObjectDefConstraint(deerRandomID, avoidNugget);
			rmAddObjectDefConstraint(deerRandomID, avoidCloseSocket);
			rmAddObjectDefConstraint(deerRandomID, avoidCloseLake);
			rmAddObjectDefConstraint(deerRandomID, avoidCloseCliff);
			rmAddObjectDefConstraint(deerRandomID, avoidNativesFar);
			rmSetObjectDefCreateHerd(deerRandomID, true);
			rmPlaceObjectDefAtLoc(deerRandomID, 0, 0.5, 0.5);
		}
	}

/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE GOLD MINES: *************************************** //
/*===============================================================================================================*/
        					
		// THE GOLD MINE NUMBER 1:
		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.80, 0.40);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.40, 0.80);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.60, 0.20);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.20, 0.60); 
		
/*===============================================================================================================*/
// ********************************** DEFINE AND PLACE THE EAGLES NESTS: *************************************** //
/*===============================================================================================================*/

	    // EAGLES NEST -- ADD FOUR SOMEWHERE:
		
		int avoidEagles=rmCreateTypeDistanceConstraint("avoids Eagles", "EaglesNest", 40.0);
		int avoidCloseEagles=rmCreateTypeDistanceConstraint("close avoids Eagles", "EaglesNest", 5.0);

	    int randomEagleTreeID=rmCreateObjectDef("random eagle tree");
	    rmAddObjectDefItem(randomEagleTreeID, "EaglesNest", 1, 0.0);
	    rmSetObjectDefMinDistance(randomEagleTreeID, 0.0);
	    rmSetObjectDefMaxDistance(randomEagleTreeID, 0.0);
	    rmAddObjectDefConstraint(randomEagleTreeID, avoidEagles);
	    
		rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.075, 0.475);	
        rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.475, 0.075);
		rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.525, 0.925);		
		rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.925, 0.525);		
		
/*===============================================================================================================*/
// ********************************** DEFINE AND PLACE THE PERCHING VULTURES: ********************************** //
/*===============================================================================================================*/

        // PERCHING VULTURES - ADD FOUR SOMEWHERE:
	    
	    int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 30.0);
	    int avoidCloseVultures=rmCreateTypeDistanceConstraint("close other vultures", "PropVulturePerching", 5.0);
	    		
		int vultureID=rmCreateObjectDef("perching vultures");
		rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, 0.0);
	    rmAddObjectDefConstraint(vultureID, avoidVultures);
	    	    
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.275, 0.525);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.525, 0.275);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.725, 0.475);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.475, 0.725);

/*==============================================================================================================*/
// *********************************** DEFINE AND PLACE THE FISHES: ******************************************* //
/*==============================================================================================================*/

        // DEFINE THE FISH AND WHALES CONSTRAINTS:
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 8.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 4.0);
        //int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 25.0);
        //int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	
/*---------------------------------------------------------------------------------------------------------------*/		

        // FISHBASS -- FOOD:
		int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishBass", 3, 6.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.625, 0.625, cNumberNonGaiaPlayers*5);
		
/*---------------------------------------------------------------------------------------------------------------*/	
	    
		// FISHBASS -- FOOD:
		int fish2ID=rmCreateObjectDef("fish 2");
        rmAddObjectDefItem(fish2ID, "FishBass", 3, 6.0);
        rmSetObjectDefMinDistance(fish2ID, 0.0);
        rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish2ID, fishVsFishID);
        rmAddObjectDefConstraint(fish2ID, fishLand);
        rmPlaceObjectDefAtLoc(fish2ID, 0, 0.375, 0.375, cNumberNonGaiaPlayers*5);
		
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE RANDOM TREES:	************************************ //
/*===============================================================================================================*/	
        
		// THE RANDOM TREES:
		int RandomTreesID = rmCreateObjectDef("The Random Trees");
		rmAddObjectDefItem(RandomTreesID, "TreeSaguenay", rmRandInt(3,5), 5);
		rmSetObjectDefMinDistance(RandomTreesID, 0.0);
		rmSetObjectDefMaxDistance(RandomTreesID, rmXFractionToMeters(0.5));
		
		
        // DEFINE THE CONSTRAINTS:
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseFruits);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseVultures);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseEagles);
		rmAddObjectDefConstraint(RandomTreesID, playerConstraint);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseAll);
		rmAddObjectDefConstraint(RandomTreesID, avoidTownCenter);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseTrees);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseCoin);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseGold);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseNatives);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseImpassableLand);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseCliff);
		rmAddObjectDefConstraint(RandomTreesID, avoidclosedeer);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseNugget);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseImportantItem);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseSocket);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseLake);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseForest);
  				
        rmPlaceObjectDefAtLoc(RandomTreesID, 0, 0.5, 0.5, 50*cNumberNonGaiaPlayers);		
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ******************************************* //
/*===============================================================================================================*/  
   
	
