/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/
// THE SPANISH WAR:
// CREATED BY DANY:
// JUNE 2007:
/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// *********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
        		
		if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Aztecs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Aztecs");

		subCiv1=rmGetCivID("Aztecs");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Aztecs"); 

		subCiv2=rmGetCivID("Aztecs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Aztecs");

		subCiv3=rmGetCivID("Aztecs");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Aztecs");
	}	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************* PICKS THE MAP SIZE: ********************************************** //
/*================================================================================================================*/

        int playerTiles=17500;
		
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(530, 530);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** DEFINE THE MAP PARAMETERS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // SET MAP ELEVATION PARAMETERS:
		// rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	    rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.2, 3.0); 

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(1.0);

        // SET THE SEA TYPE:
		rmSetSeaType("new england coast");
        
		// ENABLE THE LOCAL WATER:
		rmEnableLocalWater(false);
	    
		// SET THE BASE TERRAIN MIX:
		rmSetBaseTerrainMix("patagonia_grass");
        
		// SET THE INITIALIZATION OF THE TERRAIN:
		rmTerrainInitialize("patagonia\ground_dirt1_pat", 4.0);
	    
		// SET THE MAP TYPE:
		rmSetMapType("patagonia");
	    rmSetMapType("water");
	    rmSetMapType("grass");
   
        // SET THE LIGHTING:
		rmSetLightingSet("patagonia");
	    
		// SET THE WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);

	    // CHOOSE MERCS:
	    chooseMercs();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*================================================================================================================*/
        
		int classPlayer=rmDefineClass("player");
        rmDefineClass("classCliff");
        rmDefineClass("classPatch");
        int classbigContinent=rmDefineClass("big continent");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("classWestForest");
        rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("bay");
	    rmDefineClass("nuggets");
	    rmDefineClass("socketClass");
		rmDefineClass("natives");	

	    int lakeClass=rmDefineClass("lake");
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
        int longPlayerConstraint=rmCreateClassDistanceConstraint("continent stays away from players", classPlayer, 24.0);

        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
        int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
        int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 30.0);
        int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
		
		// Cardinal Directions
	    //int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	    //int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	    //int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	    //int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
	
        // BONUS AREA CONSTRAINTS:
        int bigContinentConstraint=rmCreateClassDistanceConstraint("avoid bonus island", classbigContinent, 20.0);

        // RESOURCE AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
        int westForestConstraint=rmCreateClassDistanceConstraint("west forest vs. forest", rmClassID("classWestForest"), 35.0);
        int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
        int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 40.0);
        
		
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 15.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 5.0);
        int avoidPlayerNugget=rmCreateTypeDistanceConstraint("player nugget avoid nugget", "AbstractNugget", 25.0);
        
		int avoidBighornSheep=rmCreateTypeDistanceConstraint("bighorn avoids bighorn", "deer", 35.0);
        int avoidMoose=rmCreateTypeDistanceConstraint("moose avoids moose", "Moose", 35.0);
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 15.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 18.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	    int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 60.0);
	    int avoidFastCoinForest=rmCreateTypeDistanceConstraint("forests avoid fast coin", "gold", 10.0);

        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
        int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
        
		// CLIFFS AVOIDANCE:
		int avoidCliffs=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 30.0);
		int avoidCloseCliffs=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 5.0);
		
		// DECORATIONS AVOIDANCE:
		int avoidDeco1=rmCreateTypeDistanceConstraint("stuff avoids deco1", "PropEaglesRocks", 5.0);        
        int avoidCloseDeco1=rmCreateTypeDistanceConstraint("close avoids deco1", "PropEaglesRocks", 2.0);
		
		// HORSE AVOIDANCE:
		int avoidHorse=rmCreateTypeDistanceConstraint("stuff avoids horse", "Horse", 5.0);
		int avoidCloseHorse=rmCreateTypeDistanceConstraint("close avoids horse", "Horse", 2.0);
		
		// VULTURE AVOIDANCE:
		int avoidVulture=rmCreateTypeDistanceConstraint("stuff avoids vulture", "PropVulturePerching", 5.0);
		int avoidCloseVulture=rmCreateTypeDistanceConstraint("close avoids vulture", "PropVulturePerching", 2.0);
		
		int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);

	    int avoidLake=rmCreateClassDistanceConstraint("lake vs stuff", lakeClass, 30.0);

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
		
		// GOLD MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
		
		// RHEAS AVOIDANCE:
		int avoidRhea=rmCreateTypeDistanceConstraint("stuff avoid rhea", "rhea", 10.0);
		int avoidCloseRhea=rmCreateTypeDistanceConstraint("close avoid rhea", "rhea", 2.0);
		
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
		
		// SHEEPS AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoid sheep", "sheep", 10.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoid sheep", "sheep", 2.0);
		
		// NATIVES AVOID NATIVES:
	    int avoidNatives = rmCreateClassDistanceConstraint("avoid Natives", rmClassID("natives"), 10.0);
	    int avoidCloseNatives = rmCreateClassDistanceConstraint("close avoid Natives", rmClassID("natives"), 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
		
        // STARTING UNITS AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

        // TRADE ROUTE AVOIDANCE:
        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 5.0);
	    
		int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 10.0);
		int avoidCloseSocket=rmCreateClassDistanceConstraint("close avoid sockets", rmClassID("socketClass"), 5.0);
	    
		
		int avoidSocketCliff=rmCreateClassDistanceConstraint("cliffs avoid sockets by a lot", rmClassID("socketClass"), 10.0);
	    int avoidSocketPlayer=rmCreateClassDistanceConstraint("cliffs avoid sockets by a lot more", rmClassID("socketClass"), 15.0);
        int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 50.0);
        int secretsAvoidSecrets = rmCreateClassDistanceConstraint("secrets avoid secrets", rmClassID("secrets"), 60.0);
        
        // CONSTRAINT TO AVOID WATER:
        int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 8.0);

        // CARDINAL DIRECTIONS CONSTRAINTS:
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

        // SHIPS VS. SHIPS:
        int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 15.0);

        // NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	    int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

	    // CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

	    // AVOID BEACH:
		// int avoidBeach = rmCreateAreaDistanceConstraint("stay away from InnerLandID", InnerLandID, 4);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE PONDS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // PONDS O' FUN:
	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 25.0);

/*---------------------------------------------------------------------------------------------------------------*/
        
        int smallPond1ID=rmCreateArea("small pond 1");
        rmSetAreaSize(smallPond1ID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
        rmSetAreaWaterType(smallPond1ID, "hudson bay");
        rmSetAreaBaseHeight(smallPond1ID, 4);
        rmSetAreaMinBlobs(smallPond1ID, 1);
        rmSetAreaMaxBlobs(smallPond1ID, 1);
        rmSetAreaMinBlobDistance(smallPond1ID, 1.0);
        rmSetAreaMaxBlobDistance(smallPond1ID, 1.0);
        rmAddAreaToClass(smallPond1ID, pondClass);
        rmSetAreaCoherence(smallPond1ID, 0.95);
        rmSetAreaSmoothDistance(smallPond1ID, 5);
        rmAddAreaConstraint(smallPond1ID, pondConstraint);
        rmSetAreaWarnFailure(smallPond1ID, false);
		rmSetAreaLocation(smallPond1ID, 0.20, 0.50);
        rmBuildArea(smallPond1ID);
		
/*---------------------------------------------------------------------------------------------------------------*/

        int smallPond2ID=rmCreateArea("small pond 2");
        rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
        rmSetAreaWaterType(smallPond2ID, "hudson bay");
        rmSetAreaBaseHeight(smallPond2ID, 4);
        rmSetAreaMinBlobs(smallPond2ID, 1);
        rmSetAreaMaxBlobs(smallPond2ID, 1);
        rmSetAreaMinBlobDistance(smallPond2ID, 1.0);
        rmSetAreaMaxBlobDistance(smallPond2ID, 1.0);
        rmAddAreaToClass(smallPond2ID, pondClass);
        rmSetAreaCoherence(smallPond2ID, 0.95);
        rmSetAreaSmoothDistance(smallPond2ID, 5);
        rmAddAreaConstraint(smallPond2ID, pondConstraint);
        rmSetAreaWarnFailure(smallPond2ID, false);
		rmSetAreaLocation(smallPond2ID, 0.50, 0.20);
        rmBuildArea(smallPond2ID);

/*---------------------------------------------------------------------------------------------------------------*/

        int smallPond3ID=rmCreateArea("small pond 3");
        rmSetAreaSize(smallPond3ID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
        rmSetAreaWaterType(smallPond3ID, "hudson bay");
        rmSetAreaBaseHeight(smallPond3ID, 4);
        rmSetAreaMinBlobs(smallPond3ID, 1);
        rmSetAreaMaxBlobs(smallPond3ID, 1);
        rmSetAreaMinBlobDistance(smallPond3ID, 1.0);
        rmSetAreaMaxBlobDistance(smallPond3ID, 1.0);
        rmAddAreaToClass(smallPond3ID, pondClass);
        rmSetAreaCoherence(smallPond3ID, 0.95);
        rmSetAreaSmoothDistance(smallPond3ID, 5);
        rmAddAreaConstraint(smallPond3ID, pondConstraint);
        rmSetAreaWarnFailure(smallPond3ID, false);
		rmSetAreaLocation(smallPond3ID, 0.80, 0.50);
        rmBuildArea(smallPond3ID);

/*---------------------------------------------------------------------------------------------------------------*/

        int smallPond4ID=rmCreateArea("small pond 4");
        rmSetAreaSize(smallPond4ID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
        rmSetAreaWaterType(smallPond4ID, "hudson bay");
        rmSetAreaBaseHeight(smallPond4ID, 4);
        rmSetAreaMinBlobs(smallPond4ID, 1);
        rmSetAreaMaxBlobs(smallPond4ID, 1);
        rmSetAreaMinBlobDistance(smallPond4ID, 1.0);
        rmSetAreaMaxBlobDistance(smallPond4ID, 1.0);
        rmAddAreaToClass(smallPond4ID, pondClass);
        rmSetAreaCoherence(smallPond4ID, 0.95);
        rmSetAreaSmoothDistance(smallPond4ID, 5);
        rmAddAreaConstraint(smallPond4ID, pondConstraint);
        rmSetAreaWarnFailure(smallPond4ID, false);
		rmSetAreaLocation(smallPond4ID, 0.50, 0.80);
        rmBuildArea(smallPond4ID);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE CLIFFS: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
         
        int cliffID=rmCreateArea("cliff");
        rmSetAreaSize(cliffID, rmAreaTilesToFraction(2500), rmAreaTilesToFraction(2500));
        rmSetAreaWarnFailure(cliffID, false);
        rmSetAreaCliffType(cliffID, "Patagonia");
        // rmSetAreaCliffEdge(cliffID, 2, 0.3, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliffID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliffID, 8, 1.0, 1.0);
        rmSetAreaHeightBlend(cliffID, 1);
        rmSetAreaObeyWorldCircleConstraint(cliffID, false);
        rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
	    rmSetAreaMix(cliffID, "patagonia_dirt");
		
		rmSetAreaMinBlobs(cliffID, 1);
        rmSetAreaMaxBlobs(cliffID, 1);
        rmSetAreaMinBlobDistance(cliffID, 1.0);
        rmSetAreaMaxBlobDistance(cliffID, 1.0);
        rmSetAreaSmoothDistance(cliffID, 5);
        rmSetAreaCoherence(cliffID, 0.95);		// higher = tries to make round
        
		rmAddAreaConstraint(cliffID, avoidCliffs);
		
		rmSetAreaLocation(cliffID, 0.50, 0.50);
	            
		rmBuildArea(cliffID);

/*================================================================================================================*/
// **************************************** DEFINE THE PLACEMENT ORDER: ***************************************** //
// ************************* TRADE ROUTE -> PLAYER AREAS -> LAKE -> CLIFFS -> NUGGETS: ************************** //
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE TWO GLORIOUS TRADE ROUTES: ****************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	  int tradeRouteID = rmCreateTradeRoute();
      int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRouteID, 0.30, 0.70);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.70, 0.30);
	  
      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route");
	  
/*================================================================================================================*/  
	  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 1.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// *********************************** SET UP THE PLAYER STARTING LOCATIONS: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		if(cNumberNonGaiaPlayers == 2)
	
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.775,0.775);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.225,0.225);
	}  
		else
    {		
		//rmSetPlacementTeam(0);
		//rmPlacePlayer(1,0.8,0.8);
		//rmPlacePlayer(2,0.8,0.2);
		//rmSetPlacementTeam(1);
		//rmPlacePlayer(3,0.2,0.2);
        //rmPlacePlayer(4,0.2,0.8);
	} 
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ****************************************** SET UP THE PLAYER AREAS: ****************************************** //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(100);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
	    
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(i, avoidSocketPlayer);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		// rmAddAreaConstraint(id, playerConstraint); 
        // rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ***************** DEFINE THE STARTING TCID AND THE STARTING UNITS AND THE STARTING RESOURCES: **************** //   
/*================================================================================================================*/

        // DEFINE THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);

	    // DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));

	    // DEFINE THE VARIABLES FOR THE PLAYER SILVER MINE:
		int silverType = -1;
	    int playerGoldID = -1;

	    int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreePatagoniaDirt", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 10.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	    // DEFINE THE STARTING DEERS:
		int StartDeerID=rmCreateObjectDef("starting deer");
	    rmAddObjectDefItem(StartDeerID, "deer", 1, 0.0);
	    rmSetObjectDefMinDistance(StartDeerID, 10.0);
	    rmSetObjectDefMaxDistance(StartDeerID, 15.0);
	    rmAddObjectDefConstraint(StartDeerID, avoidStartingUnitsSmall);

	    // DEFINE THE STARTING BERRYBUSH:
		int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 2, 4.0);
	    rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
	    rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
	    rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 30.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	    rmAddObjectDefConstraint(playerNuggetID, avoidPlayerNugget);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.53);
/*================================================================================================================*/
// ****************** PLACE THE STARTING TCID AND THE STARTING UNITS AND THE STARTING RESOURCES: **************** //
/*================================================================================================================*/

	    for(i=1; <cNumberPlayers)
	{
		rmClearClosestPointConstraints();
		
		// PLACE THE STARTING TCID AND THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// DEFINE THE PLAYER SILVER MINE:
		// EVERYONE GETS ONE ORE MINE CLOSE BY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		
		// PLACE THE PLAYER GOLD:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING PRONGHORNS:
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		rmClearClosestPointConstraints();
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.54);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NATIVE TRIBES: ************************************** //
/*================================================================================================================*/

        if (subCiv0 == rmGetCivID("aztecs"))
	{  
		int aztecs1VillageID = -1;
		aztecs1VillageID = rmCreateGrouping("aztecs village 1", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs1VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs1VillageID, 0.0);
		rmAddGroupingToClass(aztecs1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs1VillageID, 0, 0.2, 0.8);
	} 
	
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv1 == rmGetCivID("aztecs"))
	{  
		int aztecs2VillageID = -1;
		aztecs2VillageID = rmCreateGrouping("aztecs village 2", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs2VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs2VillageID, 0.0);
		rmAddGroupingToClass(aztecs2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs2VillageID, 0, 0.8, 0.2);
    }
	
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv2 == rmGetCivID("aztecs"))
	{  
		int aztecs3VillageID = -1;
		aztecs3VillageID = rmCreateGrouping("aztecs village 3", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs3VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs3VillageID, 0.0);
		rmAddGroupingToClass(aztecs3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs3VillageID, 0, 0.35, 0.35);
    }	
	
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv3 == rmGetCivID("aztecs"))
	{  
		int aztecs4VillageID = -1;
		aztecs4VillageID = rmCreateGrouping("aztecs village 4", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs4VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs4VillageID, 0.0);
		rmAddGroupingToClass(aztecs4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs4VillageID, 0, 0.65, 0.65);
    }    	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE TREASURES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 1:
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.125, 0.425);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.125, 0.575);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.275, 0.425);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.275, 0.575);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.425, 0.125);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.575, 0.125);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.425, 0.275);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.575, 0.275);
		
/*================================================================================================================*/

        // THE NUGGETS NUMBER 2:
		int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.425, 0.725);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.425, 0.875);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.575, 0.725);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.575, 0.875);
		
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.725, 0.425);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.875, 0.425);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.725, 0.575);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.875, 0.575);		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE COIN RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE GOLD MINE NUMBER 1:
		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.35, 0.55);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.55, 0.35);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.65, 0.45);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.45, 0.65);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.6, 0.6);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.4, 0.4);
		
/*================================================================================================================*/
        
        // THE GOLD MINE NUMBER 2:
		int gold2ID = rmCreateObjectDef("gold 2");
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.10, 0.50);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.50, 0.10);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.50, 0.90);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.90, 0.50);
		
/*================================================================================================================*/

        // THE GOLD MINE NUMBER 3:
		int gold3ID = rmCreateObjectDef("gold 3");
		rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
		rmSetObjectDefMaxDistance(gold3ID, 0.0);
		rmAddObjectDefConstraint(gold3ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.165, 0.165);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.835, 0.835);
		
/*================================================================================================================*/
        
		// THE GOLD MINE NUMBER 4:
		int gold4ID = rmCreateObjectDef("gold 4");
		rmAddObjectDefItem(gold4ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold4ID, 0.0);
		rmSetObjectDefMaxDistance(gold4ID, 0.0);
		rmAddObjectDefConstraint(gold4ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.565, 0.465);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.435, 0.535);		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		int berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.20, 0.40);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.40, 0.20);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.20, 0.60);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.60, 0.20);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.40, 0.80);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.80, 0.40);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.80, 0.60);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.60, 0.80);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int berries2ID = rmCreateObjectDef("The Berries 2");
		rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.125, 0.225);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.225, 0.125);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.775, 0.875);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.875, 0.775);
		
/*----------------------------------------------------------------------------------------------------------------*/
        
		int berries3ID = rmCreateObjectDef("The Berries 3");
		rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries3ID, 0.0);
		rmSetObjectDefMaxDistance(berries3ID, 0.0);
		rmAddObjectDefConstraint(berries3ID, avoidFruits);		
		
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.475, 0.565);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.510, 0.435);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE RHEAS: ***************************************** //
/*================================================================================================================*/

        // DEFINE AND PLACE THE RHEA FLOCK 1:
		int rhea1ID=rmCreateObjectDef("rhea flock 1");
        rmAddObjectDefItem(rhea1ID, "rhea", rmRandInt(8,10), 10.0);
        rmSetObjectDefMinDistance(rhea1ID, 0.0);
        rmSetObjectDefMaxDistance(rhea1ID, 0.0);
	    rmAddObjectDefConstraint(rhea1ID, avoidRhea);
        rmSetObjectDefCreateHerd(rhea1ID, true);
	    
		rmPlaceObjectDefAtLoc(rhea1ID, 0, 0.10, 0.70);
        rmPlaceObjectDefAtLoc(rhea1ID, 0, 0.70, 0.10);
		
		rmPlaceObjectDefAtLoc(rhea1ID, 0, 0.30, 0.90);
		rmPlaceObjectDefAtLoc(rhea1ID, 0, 0.90, 0.30);
		
/*================================================================================================================*/

        // DEFINE AND PLACE THE RHEA FLOCK 2:
		int rhea2ID=rmCreateObjectDef("rhea flock 2");
        rmAddObjectDefItem(rhea2ID, "rhea", rmRandInt(5,7), 8.0);
        rmSetObjectDefMinDistance(rhea2ID, 0.0);
        rmSetObjectDefMaxDistance(rhea2ID, 0.0);
	    rmAddObjectDefConstraint(rhea2ID, avoidRhea);
        rmSetObjectDefCreateHerd(rhea2ID, true);
	    
		rmPlaceObjectDefAtLoc(rhea2ID, 0, 0.30, 0.30);
        rmPlaceObjectDefAtLoc(rhea2ID, 0, 0.70, 0.70);
		
		//rmPlaceObjectDefAtLoc(rhea2ID, 0, 0.30, 0.90);
		//rmPlaceObjectDefAtLoc(rhea2ID, 0, 0.90, 0.30);		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE SHEEPS: ***************************************** //
/*================================================================================================================*/		
		
        // DEFINE AND PLACE THE SHEEPS 1:
		int sheep1ID=rmCreateObjectDef("sheep 1");
	    rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(5,9), 8.0);
	    rmSetObjectDefMinDistance(sheep1ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep1ID, 0.0);
	    rmAddObjectDefConstraint(sheep1ID, avoidSheep);
	    
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.10, 0.30);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.30, 0.10);
		
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.70, 0.90);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.90, 0.70);
		
/*================================================================================================================*/
		
		// DEFINE AND PLACE THE SHEEPS 2:
		int sheep2ID=rmCreateObjectDef("sheep 2");
	    rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(5,9), 8.0);
	    rmSetObjectDefMinDistance(sheep2ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep2ID, 0.0);
	    rmAddObjectDefConstraint(sheep2ID, avoidSheep);
	    
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.20, 0.70);
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.70, 0.20);
		
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.30, 0.80);
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.80, 0.30);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE DEER HERDS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(deer1ID, "deer", rmRandInt(7,12), 8.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.55, 0.65);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.65, 0.55);
		
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.35, 0.45);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.45, 0.35);			
						
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE FISHES AND THE WALES: ********************************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE THE FISHSALMON:
		int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 6.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.20, 0.50, 5*cNumberNonGaiaPlayers);
		rmPlaceObjectDefAtLoc(fishID, 0, 0.50, 0.20, 5*cNumberNonGaiaPlayers);
		rmPlaceObjectDefAtLoc(fishID, 0, 0.50, 0.80, 5*cNumberNonGaiaPlayers);
		rmPlaceObjectDefAtLoc(fishID, 0, 0.80, 0.50, 5*cNumberNonGaiaPlayers);

/*================================================================================================================*/		
/*		
	    // FAST COIN -- WHALES (REASONABLE IN PATAGONIA, RIGHT?)
	    int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "beluga", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.20, 0.50, 0.5*cNumberNonGaiaPlayers);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.50, 0.20, 0.5*cNumberNonGaiaPlayers);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.50, 0.80, 0.5*cNumberNonGaiaPlayers);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.80, 0.50, 0.5*cNumberNonGaiaPlayers);
*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*===============================================================================================================*/
// **************************************** DEFINE AND PLACE THE FORESTS: ************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
				
		int forestTreeID = 0;
        int numTries=8*cNumberNonGaiaPlayers;
        int failCount=0;
	    
		for (i=0; <numTries)
    {   
        int forest=rmCreateArea("The Forest 1"+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
        rmSetAreaForestType(forest, "patagonia forest");
		rmSetAreaForestDensity(forest, 0.85);
        rmSetAreaForestClumpiness(forest, 0.10);
        rmSetAreaForestUnderbrush(forest, 0.6);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 2);
        rmSetAreaMinBlobDistance(forest, 1);
        rmSetAreaMaxBlobDistance(forest, 2);
        rmSetAreaCoherence(forest, 0.25);
        rmSetAreaSmoothDistance(forest, 10);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
		rmAddAreaConstraint(forest, avoidCloseCliffs);
        //rmAddAreaConstraint(forest, avoidRegion);
		rmAddAreaConstraint(forest, avoidCloseNatives);
        rmAddAreaConstraint(forest, avoidImpassableLand); 
        rmAddAreaConstraint(forest, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest, avoidCloseSocket);
		//rmAddAreaConstraint(forest, avoidNuggetSmall);
		rmAddAreaConstraint(forest, Northward);
		 
        if(rmBuildArea(forest)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    }  

/*---------------------------------------------------------------------------------------------------------------*/

        for (i=0; <numTries)
    {   
        int forest2=rmCreateArea("The Forest 2"+i);
        rmSetAreaWarnFailure(forest2, false);
        rmSetAreaSize(forest2, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
        rmSetAreaForestType(forest2, "patagonia forest");
		rmSetAreaForestDensity(forest2, 0.85);
        rmSetAreaForestClumpiness(forest2, 0.10);
        rmSetAreaForestUnderbrush(forest2, 0.6);
        rmSetAreaMinBlobs(forest2, 1);
        rmSetAreaMaxBlobs(forest2, 2);
        rmSetAreaMinBlobDistance(forest2, 1);
        rmSetAreaMaxBlobDistance(forest2, 2);
        rmSetAreaCoherence(forest2, 0.25);
        rmSetAreaSmoothDistance(forest2, 10);
        rmAddAreaToClass(forest2, rmClassID("classForest")); 
        rmAddAreaConstraint(forest2, forestConstraint);
        rmAddAreaConstraint(forest2, avoidAll);
		rmAddAreaConstraint(forest2, avoidCloseCliffs);
		rmAddAreaConstraint(forest2, playerConstraint);
		rmAddAreaConstraint(forest2, avoidCloseSocket);
        //rmAddAreaConstraint(forest2, avoidRegion);
		rmAddAreaConstraint(forest2, avoidCloseNatives);
        rmAddAreaConstraint(forest2, avoidImpassableLand); 
        rmAddAreaConstraint(forest2, avoidCloseTradeRoute);
		//rmAddAreaConstraint(forest2, avoidNuggetSmall);
		rmAddAreaConstraint(forest2, Southward);
		 
        if(rmBuildArea(forest2)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    } 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE SOME PROPEAGLESROCKS: ************************************* //
/*================================================================================================================*/
        
		int deco1ID=rmCreateObjectDef("The ProEaglesRocks 1");
	    rmAddObjectDefItem(deco1ID, "PropEaglesRocks", 1.0, 0.0);
		rmSetObjectDefMinDistance(deco1ID, 0.0);
	    rmSetObjectDefMaxDistance(deco1ID, 0.0);
	    rmAddObjectDefConstraint(deco1ID, avoidDeco1);
        
		rmPlaceObjectDefAtLoc(deco1ID, 0, 0.25, 0.65);
        rmPlaceObjectDefAtLoc(deco1ID, 0, 0.65, 0.25);	
        
		rmPlaceObjectDefAtLoc(deco1ID, 0, 0.35, 0.75);	
        rmPlaceObjectDefAtLoc(deco1ID, 0, 0.75, 0.35);

/*================================================================================================================*/
// *********************************** DEFINE AND PLACE SOME PERCHING VULTURES: ********************************* //
/*================================================================================================================*/
	    int vultureID=rmCreateObjectDef("perching vultures");
	    rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, 0.0);
	    rmAddObjectDefConstraint(vultureID, avoidVulture);
        
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.05, 0.50);
        rmPlaceObjectDefAtLoc(vultureID, 0, 0.50, 0.05);	
        
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.50, 0.95);	
        rmPlaceObjectDefAtLoc(vultureID, 0, 0.95, 0.50);
		
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE SOME HORSES: ****************************************** //
/*================================================================================================================*/
        
		int horse1ID=rmCreateObjectDef("The Horses 1");
	    rmAddObjectDefItem(horse1ID, "Horse", rmRandInt(5,9), 8);
		rmSetObjectDefCreateHerd(horse1ID, true);
	    rmSetObjectDefMinDistance(horse1ID, 0.0);
	    rmSetObjectDefMaxDistance(horse1ID, 0.0);
	    rmAddObjectDefConstraint(horse1ID, avoidHorse);
        
		rmPlaceObjectDefAtLoc(horse1ID, 0, 0.25, 0.75);
        rmPlaceObjectDefAtLoc(horse1ID, 0, 0.75, 0.25);	
        
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ***************************************** // 
/*===============================================================================================================*/




