/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/
// THE TADOUSSAC WAR:
// CREATED BY DANY:
// APRIL 2007:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/

        int playerTiles=17500;		
        
		int size=2.1*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(530, 530);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ****************************************** PICKS THE MAP PARAMETERS: ***************************************** //
/*================================================================================================================*/
	    	
	    // SET THE MAP ELEVATION PARAMETERS: 
		// rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	       rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.3, 2.0); // FROM SAGUENAY:
		
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1.0);
	
	    // SET THE SEA TYPE:
		rmSetSeaType("hudson bay"); // FROM SAGUENAY:
	    
		// ENABLE THE LOCAL WATER:
		rmEnableLocalWater(false); // FROM SAGUENAY:
	
		// PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(1.0); // FROM SAGUENAY:		
		
	    // PICKS DEFAULT TERRAIN AND WATER:
	    rmSetBaseTerrainMix("saguenay tundra"); // FROM SAGUENAY:
	
	    // THE TERRAIN INITIALIZATION:
	    rmTerrainInitialize("saguenay\ground1_sag",10); // FROM SAGUENAY:
	
	    // SET THE MAP TYPE:
		rmSetMapType("saguenay"); // FROM SAGUENAY:
		rmSetMapType("water"); // FROM SAGUENAY:
	    rmSetMapType("grass"); // FROM SAGUENAY:
	            
		// SET THE LIGHTING:
		rmSetLightingSet("saguenay"); // FROM SAGUENAY:

	    // MAKE THE CORNERS:
	    rmSetWorldCircleConstraint(true);

	    // CHOOSE THE MERCS:
	    chooseMercs();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** SET UP THE NATIVE TRIBES: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		
		if (rmAllocateSubCivs(4) == true)
		
   {
		subCiv0=rmGetCivID("Iroquois");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Iroquois");

		subCiv1=rmGetCivID("Iroquois");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Iroquois"); 

		subCiv2=rmGetCivID("Iroquois");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Iroquois");
		
   }
   
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // TEXT:
		// THESE ARE THE MOST COMMON CLASSES:
		int classPlayer=rmDefineClass("player");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
		rmDefineClass("classCliff");
		rmDefineClass("socketClass");
	    		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ******************************************* DEFINE THE CONSTRAINTS: ****************************************** //
// ************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
	    int coinEdgeConstraint=rmCreateBoxConstraint("coin edge of map", rmXTilesToFraction(19), rmZTilesToFraction(19), 1.0-rmXTilesToFraction(19), 1.0-rmZTilesToFraction(19), 2.0);

	
	    // CARDINAL DIRECTIONS:
	    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	    int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
	    int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	    int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));

	    // PLAYER CONSTRAINTS:
	    int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 20.0);
		int playerCloseConstraint=rmCreateClassDistanceConstraint("trees away from players", classPlayer, 10.0);
		
		// NATURE AVOIDANCE:
	    int avoidForest=rmCreateClassDistanceConstraint("forest avoids forest", rmClassID("classForest"), 10.0);
        int avoidCloseForest=rmCreateClassDistanceConstraint("trees avoids forest", rmClassID("classForest"), 5.0);
		  		  
		  
		// AVOID IMPASSABLE LAND:
	    int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
		int avoidCloseImpassableLand = rmCreateTerrainDistanceConstraint("close avoid impassable land", "Land", false, 2.0);
		
		// FORESTS AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("stuff vs. forest", rmClassID("classForest"), 10.0);
		int forestCloseConstraint=rmCreateClassDistanceConstraint("trees vs. forest", rmClassID("classForest"), 2.0);
		
		// TREES AVOIDANCE:
		int avoidTree=rmCreateTypeDistanceConstraint("stuff avoid tree", "TreeSaguenay", 5.0);
		int avoidCloseTree=rmCreateTypeDistanceConstraint("lake avoid tree", "TreeSaguenay", 2.0);
		int avoidFarTree=rmCreateTypeDistanceConstraint("forest avoid tree", "TreeSaguenay", 15.0);
        		
		// CLIFF AVOIDANCE:(IMPASSABLE LAND)
		int avoidCliff = rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 12.0);
	    int cliffAvoidCliff = rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 30.0);
			
		// UNIT AVOIDANCE:
	    int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "TownCenter", 10.0);
	    
        // IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
        int avoidCloseImportantItem=rmCreateClassDistanceConstraint("close secrets etc avoid each other", rmClassID("importantItem"), 2.0);
        
		// SEA FOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "abstractFish", 5.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "humpbackWhale", 25.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
	    		
		// NATIVES AVOIDANCE:
        int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 10.0);
        int avoidCloseNatives=rmCreateClassDistanceConstraint("trees avoids natives", rmClassID("natives"), 2.0);
        
		// NUGGETS AVOIDANCE:
	    int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 10.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("trees avoid nugget", "AbstractNugget", 2.0);
		
		// SILVER MINES AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("stuff coin avoids coin", "mine", 5.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("trees coin avoids coin", "mine", 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("berry vs berry", "berryBush", 5.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("trees vs berry", "berryBush", 2.0);
		
		// DEERS AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 5.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("trees avoids deer", "deer", 2.0);
		
		// MOOSES AVOIDANCE:
		int avoidMoose=rmCreateTypeDistanceConstraint("moose avoids moose", "moose", 5.0);
		int avoidCloseMoose=rmCreateTypeDistanceConstraint("trees avoids moose", "moose", 2.0);
		
		// SHEEPS AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids Sheep", "sheep", 5.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("trees avoids sheep", "sheep", 2.0);
		
		// DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 2.0);
		
		// VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 4.0);
        int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 1.0);
        
	    // SOCKET AVOIDANCE:
		int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);
        int avoidCloseSocket=rmCreateClassDistanceConstraint("close socket avoidance", rmClassID("socketClass"), 2.0);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ********************************************* DEFINE THE OBJECTS: ******************************************** //
// ************************* THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE TWO SMALL POND: ************************************ //
/*================================================================================================================*/

	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 8.0);
		int pondCloseConstraint=rmCreateClassDistanceConstraint("trees avoid the pond", rmClassID("pond"), 2.0);
        int smallPondID=rmCreateArea("small pond");
	
		rmSetAreaSize(smallPondID, 0.035, 0.035);
		rmSetAreaWaterType(smallPondID, "saguenay lake");
		rmSetAreaBaseHeight(smallPondID, 4);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1.0);
		rmSetAreaMaxBlobDistance(smallPondID, 1.0);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.9);
		rmSetAreaSmoothDistance(smallPondID, 5);
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.625, 0.625); 
		rmBuildArea(smallPondID);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int smallPond2ID=rmCreateArea("small pond 2");
        rmSetAreaSize(smallPond2ID, 0.035, 0.035);
		rmSetAreaWaterType(smallPond2ID, "saguenay lake");
		rmSetAreaBaseHeight(smallPond2ID, 4);
		rmSetAreaMinBlobs(smallPond2ID, 1);
		rmSetAreaMaxBlobs(smallPond2ID, 1);
		rmSetAreaMinBlobDistance(smallPond2ID, 1.0);
		rmSetAreaMaxBlobDistance(smallPond2ID, 1.0);
		rmAddAreaToClass(smallPond2ID, pondClass);
		rmSetAreaCoherence(smallPond2ID, 0.9);
		rmSetAreaSmoothDistance(smallPond2ID, 5);
		rmSetAreaWarnFailure(smallPond2ID, false);
		rmSetAreaLocation(smallPond2ID, 0.375, 0.375); 
		rmBuildArea(smallPond2ID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/		
// ******************************** DEFINE AND PLACE THE TRADE ROUTE NUMBER 1: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	    int tradeRouteID = rmCreateTradeRoute();
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
        rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 12.0);
				
        rmAddTradeRouteWaypoint(tradeRouteID, 0.05, 0.35); // ok
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.10, 0.40); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.10, 0.50); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.10, 0.60); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.15, 0.65); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.20, 0.70); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.30, 0.70); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.35, 0.65); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.40, 0.60); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.45, 0.55); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.50); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.55, 0.45); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.60, 0.40); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.65, 0.35); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.70, 0.30); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.80, 0.30); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.85, 0.35); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.90, 0.40); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.90, 0.50); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.90, 0.60); // ok
		rmAddTradeRouteWaypoint(tradeRouteID, 0.95, 0.65); // ok
		
		bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
				
	    // ADD THE SOCKETS ALONG THE TRADE ROUTE:
        vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.02);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.20);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);	
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.40);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.60);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.80);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.98);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        // CLEAR THE CLOSEST POINT CONSTRAINT:
		rmClearClosestPointConstraints();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/		
// ************************************** SET UP PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
 
          if(cNumberNonGaiaPlayers == 2)
		{  
		  rmSetPlacementTeam(0);
		  rmPlacePlayer(1,0.775,0.775);
		  rmSetPlacementTeam(1);
		  rmPlacePlayer(2,0.225,0.225);
		}  
		  else
        {		
		  // TEXT:
		  // IT IS DISABLE BY ME...ONLY A 2 PLAYERS MAP:
		  //rmSetPlacementTeam(0);
		  //rmPlacePlayer(1,0.8,0.8);
		  //rmPlacePlayer(2,0.8,0.2);
		  //rmSetPlacementTeam(1);
		  //rmPlacePlayer(3,0.2,0.2);
          //rmPlacePlayer(4,0.2,0.8);
		} 
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        float playerFraction = rmAreaTilesToFraction(100);
        
		for(i = 0; < cNumberNonGaiaPlayers)
   {
        // CREATE THE AREA:
        int id = rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
		
		// ADD AREA TO CLASS:
	    rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
	    rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); // removed by me for now:
        //rmAddAreaConstraint(id, playerEdgeConstraint); // removed by me for now:
	   
	    // SET AREA TERRAIN TYPE:
		// rmSetAreaTerrainType(id, "saguenay\ground1_sag"); // added by me as a possibility:
        	    
		// SET AREA MIX:
		// rmSetAreaMix(id, "saguenay tundra"); // added by me as a possiblity:
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD THE AREAS:
        rmBuildAllAreas();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/		
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.2, 0.8);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.8, 0.2);
		
		int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.6, 0.9);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.4, 0.1);
	} 
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/		
// ************************** DEFINE AND PLACE THE RESOURCES AROUND THE NATIVES TRIBES: ************************* //
/*================================================================================================================*/
        
		// DEFINE AND PLACE THE BERRYBUSH:
		int berries1ID= rmCreateObjectDef("Random Berries 1"); 
	    rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidFruits);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.20, 0.75); 
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.80, 0.15); 
        rmPlaceObjectDefAtLoc(berries1ID, 0, 0.60, 0.85);
        rmPlaceObjectDefAtLoc(berries1ID, 0, 0.40, 0.05);

        // DEFINE AND PLACE THE SILVER MINES:
		int silver1ID = rmCreateObjectDef("silver 1");
	    rmAddObjectDefItem(silver1ID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silver1ID, 0.0);
        rmSetObjectDefMaxDistance(silver1ID, 0.0);
		rmAddObjectDefConstraint(silver1ID, avoidCoin);
        rmPlaceObjectDefAtLoc(silver1ID, 0, 0.20, 0.85);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.80, 0.25);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.60, 0.95);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.40, 0.15);
		
		// DEFINE AND PLACE THE NUGGETS:
		int nugget1= rmCreateObjectDef("nugget easy 1"); 
	    rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1, 0.0);
	    rmSetObjectDefMaxDistance(nugget1, 0.0);
		rmSetNuggetDifficulty(1, 4);
		rmAddObjectDefConstraint(nugget1, avoidNugget);
        
		rmPlaceObjectDefAtLoc(nugget1, 0, 0.15, 0.80); 
		rmPlaceObjectDefAtLoc(nugget1, 0, 0.75, 0.20);
        rmPlaceObjectDefAtLoc(nugget1, 0, 0.55, 0.90);
        rmPlaceObjectDefAtLoc(nugget1, 0, 0.35, 0.10);
        
		rmPlaceObjectDefAtLoc(nugget1, 0, 0.25, 0.80);
        rmPlaceObjectDefAtLoc(nugget1, 0, 0.85, 0.20);
        rmPlaceObjectDefAtLoc(nugget1, 0, 0.65, 0.90);
        rmPlaceObjectDefAtLoc(nugget1, 0, 0.45, 0.10);
  			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ********************************** DEFINE THE PLAYER STARTING RESOURCES: ************************************* //
/*================================================================================================================*/

        // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
        
		// DEFINE THE TCID:
		   
	    int TCID = rmCreateObjectDef("Player TC");

	    if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	}
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 0.0);

/*----------------------------------------------------------------------------------------------------------------*/
	    
		// DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player mine");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	    rmAddObjectDefConstraint(playerSilverID, avoidTownCenter);
	    rmSetObjectDefMinDistance(playerSilverID, 15.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 20.0);
        rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);
        rmAddObjectDefConstraint(playerSilverID, coinEdgeConstraint);

	    // DEFINE THE PLAYER BERRYBUSH:
		int playerberriesID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerberriesID, "berrybush", rmRandInt(3,5), 4.0);
        rmSetObjectDefMinDistance(playerberriesID, 14);
        rmSetObjectDefMaxDistance(playerberriesID, 20);
        rmAddObjectDefConstraint(playerberriesID, avoidAll);
        rmAddObjectDefConstraint(playerberriesID, avoidImpassableLand);
        rmAddObjectDefConstraint(playerberriesID, avoidTownCenter);
        		
		// DEFINE THE PLAYER TURKEY:
		int playerturkeyID=rmCreateObjectDef("player turkey");
        rmAddObjectDefItem(playerturkeyID, "turkey", rmRandInt(8,10), 10.0);
        rmSetObjectDefMinDistance(playerturkeyID, 10);
        rmSetObjectDefMaxDistance(playerturkeyID, 18);
        rmAddObjectDefConstraint(playerturkeyID, avoidAll);
        rmAddObjectDefConstraint(playerturkeyID, avoidImpassableLand);
        //rmAddObjectDefConstraint(playerturkeyID, avoidCliff);
        rmSetObjectDefCreateHerd(playerturkeyID, true);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID= rmCreateObjectDef("player nugget"); 
	    rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidAll);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidCliff);
	    rmAddObjectDefConstraint(playerNuggetID, playerEdgeConstraint);
	    rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	    rmSetObjectDefMaxDistance(playerNuggetID, 30.0);

	    // DEFINE THE PLAYER TREE: 
		int playerTreeID = rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, "TreeSaguenay", rmRandInt(5,10), 8.0);
        rmSetObjectDefMinDistance(playerTreeID, 15);
        rmSetObjectDefMaxDistance(playerTreeID, 20);
        rmAddObjectDefConstraint(playerTreeID, avoidAll);
        rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
		
/*----------------------------------------------------------------------------------------------------------------*/
	    
		// DEFINE THE WATER FLAG:
		int waterFlagID=rmCreateObjectDef("HC water flag "+i);
	    rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
        //rmAddClosestPointConstraint(flagEdgeConstraint);
	    rmAddClosestPointConstraint(flagVsFlag);
	    //rmAddClosestPointConstraint(bigContinentConstraint);
	    rmAddClosestPointConstraint(fishLand);		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// *********************************** PLACE THE PLAYER STARTING RESOURCES: ************************************* //
/*================================================================================================================*/ 		

	    for(i = 1; < cNumberPlayers)
   
 {
		
		// PLACE THE TCID:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
		vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));
					    
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

    	// PLACE THE PLAYER SILVER:
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
	    
		// PLACE THE PLAYER TREE:
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
	    
		// PLACE THE TURKEY:
		rmPlaceObjectDefAtLoc(playerturkeyID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
	    
		// PLACE THE BERRIES:
		rmPlaceObjectDefAtLoc(playerberriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
	    		
		// PLACE THE PLAYER NUGGET:
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        
		// PLACE THE WATER FLAG:
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));

}			
/*----------------------------------------------------------------------------------------------------------------*/		
		// TEXT:
		// IF YOU PUT IT BEFORE THIS LAST } YOU DONT HAVE THE SECOND FLAG:
		// CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE DEERS ON THE MAP: ************************************ //
/*================================================================================================================*/
        
		int deer1ID= rmCreateObjectDef("Random Deer 1"); 
	    rmAddObjectDefItem(deer1ID, "deer", rmRandInt(7,9), 5.0);
		rmSetObjectDefCreateHerd(deer1ID, true);
		rmSetObjectDefMinDistance(deer1ID, 0.0);
		rmSetObjectDefMaxDistance(deer1ID, 0.0);
		rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.10, 0.70); 
        rmPlaceObjectDefAtLoc(deer1ID, 0, 0.90, 0.30); 			
        
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.45, 0.65); 	
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.55, 0.35); 	
		
		
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.80, 0.55);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.175, 0.47);
		
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.65, 0.45);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.35, 0.55);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE SILVER MINES ON THE MAP: ******************************** // 
/*================================================================================================================*/
        
		// DEFINE AND PLACE THE SILVER MINES:
		int silver2ID = rmCreateObjectDef("silver 2");
	    rmAddObjectDefItem(silver2ID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silver2ID, 0.0);
        rmSetObjectDefMaxDistance(silver2ID, 0.0);
		rmAddObjectDefConstraint(silver2ID, avoidCoin);
        rmPlaceObjectDefAtLoc(silver2ID, 0, 0.05, 0.50);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.95, 0.50);
		
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.25, 0.675);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.75, 0.35);
		
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.50, 0.30);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.375, 0.675);
		
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.21, 0.415);
		
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.40, 0.965);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.60, 0.035);
		
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.475, 0.475);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.525, 0.525);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE NUGGETS ON THE MAP: *********************************** //
/*================================================================================================================*/
        
        // DEFINE AND PLACE THE NUGGETS:
		int nugget2= rmCreateObjectDef("nugget easy 2"); 
	    rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2, 0.0);
	    rmSetObjectDefMaxDistance(nugget2, 0.0);
		rmSetNuggetDifficulty(1, 4);
		rmAddObjectDefConstraint(nugget2, avoidNugget);
        
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.05, 0.55); 
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.05, 0.45);
        
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.95, 0.55);
        rmPlaceObjectDefAtLoc(nugget2, 0, 0.95, 0.45);
		
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.20, 0.65);
        rmPlaceObjectDefAtLoc(nugget2, 0, 0.30, 0.65);
		
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.775, 0.35);
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.725, 0.35);
		
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.525, 0.325);
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.475, 0.275);
		
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.46, 0.60);
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.47, 0.70);
		
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.75, 0.55);
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.85, 0.55);
		
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.135, 0.47);
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.215, 0.47);
		
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.55, 0.065);
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.65, 0.065);
		
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.35, 0.935);
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.45, 0.935);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************* PLACE SOME EXTRA TREES ON THE MAP: ************************************* //
/*================================================================================================================*/
        
		int tree2ID= rmCreateObjectDef("The Trees 2"); 
	    rmAddObjectDefItem(tree2ID, "TreeSaguenay", rmRandInt(7,9), 6.0);
		rmSetObjectDefMinDistance(tree2ID, 0.0);
		rmSetObjectDefMaxDistance(tree2ID, 0.0);
	    rmAddObjectDefConstraint(tree2ID, avoidCloseTree);
				
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.065, 0.65); 
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.11, 0.75); 
		
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.925, 0.35); 
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.875, 0.25);
		
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE BERRYBUSH ON THE MAP: ********************************** //
/*================================================================================================================*/
        
		// DEFINE AND PLACE THE BERRYBUSH:
		int berries2ID= rmCreateObjectDef("Random Berries 2"); 
	    rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidFruits);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.75, 0.32); 
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.45, 0.25); 
        rmPlaceObjectDefAtLoc(berries2ID, 0, 0.80, 0.60);
        rmPlaceObjectDefAtLoc(berries2ID, 0, 0.175, 0.425);	
        rmPlaceObjectDefAtLoc(berries2ID, 0, 0.60, 0.065);
        rmPlaceObjectDefAtLoc(berries2ID, 0, 0.40, 0.935);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.485, 0.55);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.50, 0.45);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.225, 0.115);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.875, 0.775);

/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE MOOSE ON THE MAP: ************************************** //
/*================================================================================================================*/
       
    	int mooseID=rmCreateObjectDef("moose herd");
	    rmAddObjectDefItem(mooseID, "moose", rmRandInt(4,5), 5.0);
        rmSetObjectDefMinDistance(mooseID, 0.0);
        rmSetObjectDefMaxDistance(mooseID, 0.0);
        rmAddObjectDefConstraint(mooseID, avoidMoose);
        rmSetObjectDefCreateHerd(mooseID, true);
	
	    rmPlaceObjectDefAtLoc(mooseID, 0, 0.55, 0.485);
        rmPlaceObjectDefAtLoc(mooseID, 0, 0.45, 0.50);
        rmPlaceObjectDefAtLoc(mooseID, 0, 0.125, 0.215);
        rmPlaceObjectDefAtLoc(mooseID, 0, 0.775, 0.875);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE SHEEP ON THE MAP: ************************************** //
/*================================================================================================================*/
        
		int sheepID=rmCreateObjectDef("The sheep herd");
	    rmAddObjectDefItem(sheepID, "sheep", rmRandInt(4,5), 5.0);
        rmSetObjectDefMinDistance(sheepID, 0.0);
        rmSetObjectDefMaxDistance(sheepID, 0.0);
        rmAddObjectDefConstraint(sheepID, avoidSheep);
        rmSetObjectDefCreateHerd(sheepID, true);
	
	    rmPlaceObjectDefAtLoc(sheepID, 0, 0.40, 0.20);
        rmPlaceObjectDefAtLoc(sheepID, 0, 0.70, 0.10);
        rmPlaceObjectDefAtLoc(sheepID, 0, 0.60, 0.80);
        rmPlaceObjectDefAtLoc(sheepID, 0, 0.30, 0.90);
        rmPlaceObjectDefAtLoc(sheepID, 0, 0.10, 0.30);
        rmPlaceObjectDefAtLoc(sheepID, 0, 0.90, 0.70);			
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE TREES ON THE MAP: *********************************** //
/*================================================================================================================*/
// ******************************************** PLACE SOME EXTRA TREES: ***************************************** //
/*================================================================================================================*/
        
		int tree3ID= rmCreateObjectDef("The Trees 3"); 
	    rmAddObjectDefItem(tree3ID, "TreeSaguenay", 1.0, 0.0);
		rmSetObjectDefMinDistance(tree3ID, 0.0);
		rmSetObjectDefMaxDistance(tree3ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(tree3ID, avoidCloseTree);
		rmAddObjectDefConstraint(tree3ID, avoidAll);
		rmAddObjectDefConstraint(tree3ID, avoidCloseNatives);
		rmAddObjectDefConstraint(tree3ID, avoidCloseCoin);
		rmAddObjectDefConstraint(tree3ID, avoidCloseFruits);
		rmAddObjectDefConstraint(tree3ID, avoidCloseSheep);
		rmAddObjectDefConstraint(tree3ID, avoidCloseDeer);
		rmAddObjectDefConstraint(tree3ID, avoidCloseMoose);
		rmAddObjectDefConstraint(tree3ID, avoidCloseNugget);
		rmAddObjectDefConstraint(tree3ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(tree3ID, avoidCloseSocket);
		rmAddObjectDefConstraint(tree3ID, avoidCloseImpassableLand);
		rmAddObjectDefConstraint(tree3ID, playerCloseConstraint);
		rmAddObjectDefConstraint(tree3ID, pondCloseConstraint);
		
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.5, 0.5, 35);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ******************************** DEFINE THE FISHES AND THE WALES ON THE MAP: ********************************* //
/*================================================================================================================*/

        // DEFINE AND PLACE THE TARPON:
		int fish2ID=rmCreateObjectDef("tarpon");
        rmAddObjectDefItem(fish2ID, "FishTarpon", 3, 9.0);
        rmSetObjectDefMinDistance(fish2ID, 0.0);
        rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish2ID, fishVsFishID);
        rmAddObjectDefConstraint(fish2ID, fishLand);
        rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

	    // DEFINE AND PLACE THE HUMPBACKWHALE:
		int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "humpbackWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, 0.0);
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.625, 0.625);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.375, 0.375);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FORESTS: **************************************** //
/*================================================================================================================*/
// NOT FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
         		 
		 int forest1ID = -1;
         forest1ID=rmCreateArea("forest 1");
         rmSetAreaWarnFailure(forest1ID, false);
         rmSetAreaSize(forest1ID, 0.035, 0.035);
         rmSetAreaForestType(forest1ID, "saguenay forest");
		 rmSetAreaForestDensity(forest1ID, 0.9);
         rmSetAreaForestClumpiness(forest1ID, 0.0);
         rmSetAreaForestUnderbrush(forest1ID, 0.0);
         rmSetAreaMinBlobs(forest1ID, 1);
         rmSetAreaMaxBlobs(forest1ID, 1);
         rmSetAreaMinBlobDistance(forest1ID, 1.0);
         rmSetAreaMaxBlobDistance(forest1ID, 1.0);
         rmSetAreaCoherence(forest1ID, 1.0);
         rmSetAreaSmoothDistance(forest1ID, 10);
         rmAddAreaToClass(forest1ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest1ID, forestConstraint);
		 rmSetAreaLocation(forest1ID, 0.40, 0.80); 
         rmBuildArea(forest1ID);
		 
		 int forest2ID = -1;
         forest2ID=rmCreateArea("forest 2");
         rmSetAreaWarnFailure(forest2ID, false);
         rmSetAreaSize(forest2ID, 0.035, 0.035);
         rmSetAreaForestType(forest2ID, "saguenay forest");
         rmSetAreaForestDensity(forest2ID, 0.9);
         rmSetAreaForestClumpiness(forest2ID, 0.0);
         rmSetAreaForestUnderbrush(forest2ID, 0.0);
         rmSetAreaMinBlobs(forest2ID, 1);
         rmSetAreaMaxBlobs(forest2ID, 1);
         rmSetAreaMinBlobDistance(forest2ID, 1.0);
         rmSetAreaMaxBlobDistance(forest2ID, 1.0);
         rmSetAreaCoherence(forest2ID, 1.0);
         rmSetAreaSmoothDistance(forest2ID, 10);
         rmAddAreaToClass(forest2ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest2ID, forestConstraint);
		 rmSetAreaLocation(forest2ID, 0.60, 0.20); 
         rmBuildArea(forest2ID);
		 
		  int forest3ID = -1;
         forest3ID=rmCreateArea("forest 3");
         rmSetAreaWarnFailure(forest3ID, false);
         rmSetAreaSize(forest3ID, 0.015, 0.015);
         rmSetAreaForestType(forest3ID, "saguenay forest");
         rmSetAreaForestDensity(forest3ID, 0.9);
         rmSetAreaForestClumpiness(forest3ID, 0.0);
         rmSetAreaForestUnderbrush(forest3ID, 0.0);
         rmSetAreaMinBlobs(forest3ID, 1);
         rmSetAreaMaxBlobs(forest3ID, 1);
         rmSetAreaMinBlobDistance(forest3ID, 1.0);
         rmSetAreaMaxBlobDistance(forest3ID, 1.0);
         rmSetAreaCoherence(forest3ID, 1.0);
         rmSetAreaSmoothDistance(forest3ID, 10);
         rmAddAreaToClass(forest3ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest3ID, forestConstraint);
		 rmSetAreaLocation(forest3ID, 0.75, 0.45); 
         rmBuildArea(forest3ID);
		 
		 int forest4ID = -1;
         forest4ID=rmCreateArea("forest 4");
         rmSetAreaWarnFailure(forest4ID, false);
         rmSetAreaSize(forest4ID, 0.015, 0.015);
         rmSetAreaForestType(forest4ID, "saguenay forest");
         rmSetAreaForestDensity(forest4ID, 0.9);
         rmSetAreaForestClumpiness(forest4ID, 0.0);
         rmSetAreaForestUnderbrush(forest4ID, 0.0);
         rmSetAreaMinBlobs(forest4ID, 1);
         rmSetAreaMaxBlobs(forest4ID, 1);
         rmSetAreaMinBlobDistance(forest4ID, 1.0);
         rmSetAreaMaxBlobDistance(forest4ID, 1.0);
         rmSetAreaCoherence(forest4ID, 1.0);
         rmSetAreaSmoothDistance(forest4ID, 10);
         rmAddAreaToClass(forest4ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest4ID, forestConstraint);
		 rmSetAreaLocation(forest4ID, 0.25, 0.55); 
         rmBuildArea(forest4ID);
		 
		 int forest5ID = -1;
         forest5ID=rmCreateArea("forest 5");
         rmSetAreaWarnFailure(forest5ID, false);
         rmSetAreaSize(forest5ID, 0.006, 0.006);
         rmSetAreaForestType(forest5ID, "saguenay forest");
         rmSetAreaForestDensity(forest5ID, 0.9);
         rmSetAreaForestClumpiness(forest5ID, 0.0);
         rmSetAreaForestUnderbrush(forest5ID, 0.0);
         rmSetAreaMinBlobs(forest5ID, 1);
         rmSetAreaMaxBlobs(forest5ID, 1);
         rmSetAreaMinBlobDistance(forest5ID, 1.0);
         rmSetAreaMaxBlobDistance(forest5ID, 1.0);
         rmSetAreaCoherence(forest5ID, 1.0);
         rmSetAreaSmoothDistance(forest5ID, 10);
         rmAddAreaToClass(forest5ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest5ID, forestConstraint);
		 rmSetAreaLocation(forest5ID, 0.175, 0.35); 
         rmBuildArea(forest5ID);
		 
		 int forest6ID = -1;
         forest6ID=rmCreateArea("forest 6");
         rmSetAreaWarnFailure(forest6ID, false);
         rmSetAreaSize(forest6ID, 0.006, 0.006);
         rmSetAreaForestType(forest6ID, "saguenay forest");
         rmSetAreaForestDensity(forest6ID, 0.9);
         rmSetAreaForestClumpiness(forest6ID, 0.0);
         rmSetAreaForestUnderbrush(forest6ID, 0.0);
         rmSetAreaMinBlobs(forest6ID, 1);
         rmSetAreaMaxBlobs(forest6ID, 1);
         rmSetAreaMinBlobDistance(forest6ID, 1.0);
         rmSetAreaMaxBlobDistance(forest6ID, 1.0);
         rmSetAreaCoherence(forest6ID, 1.0);
         rmSetAreaSmoothDistance(forest6ID, 10);
         rmAddAreaToClass(forest6ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest6ID, forestConstraint);
		 rmSetAreaLocation(forest6ID, 0.825, 0.65); 
         rmBuildArea(forest6ID);
	 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}
/*================================================================================================================*/
// **************************************** THIS IS THE END OF THE MAP: ***************************************** //
/*================================================================================================================*/
