/*================================================================================================================*/
// ************************************ THESE ARE THE INFORMATIONS OF THE MAP: ********************************** //
/*================================================================================================================*/
// THE BRAZILIAN WAR:
// CREATED BY DANY:
// APRIL 2007:
/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOWN MAP SCRIPT: *********************************** //
/*================================================================================================================*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ***************************** CHOOSES WHICH NATIVE TRIBES WILL APPEAR ON THE MAP: **************************** //
/*================================================================================================================*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
        int subCiv4=-1;
        int subCiv5=-1;

        if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Aztecs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Aztecs");

		subCiv1=rmGetCivID("Aztecs");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Aztecs"); 

		subCiv2=rmGetCivID("Aztecs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Aztecs");

		subCiv3=rmGetCivID("Aztecs");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Aztecs");

		subCiv4=rmGetCivID("Aztecs");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Aztecs");

		subCiv5=rmGetCivID("Aztecs");
        if (subCiv5 >= 0)
        rmSetSubCiv(5, "Aztecs");
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/

        int playerTiles=17500;
   
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(530, 530);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/

        // SET THE MAP LIGHTING:
        rmSetLightingSet("yucatan");

	    // SET THE WIND MAGNITUDE OF THE MAP:
		// rmSetWindMagnitude(3); // REMOVED BY ENSEMBLE:
	    rmSetWindMagnitude(2);

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(4);

        // PICKS THE DEFAULT TERRAIN AND WATER:
        
		// SET THE SEA TYPE:
		rmSetSeaType("yucatan Coast");
   
        // ENABLE THE LOCAL WATER: 
        rmEnableLocalWater(false);
        
		// SET THE TERRAIN INITIALIZATION:
		rmTerrainInitialize("water", 4);
	
	    // SET THE MAP TYPE:
	    rmSetMapType("yucatan");
	    rmSetMapType("tropical");
	    rmSetMapType("water");
	    
		// MAKE THE CORNERS:
		rmSetWorldCircleConstraint(true);

	    // CHOOSE THE MERCS:
		chooseMercs();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ******************************************** DEFINE SOME CLASSES: ******************************************** // 
// *********************************** THESE ARE USED LATER FOR CONSTRAINTS: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		int classPlayer=rmDefineClass("player");
        rmDefineClass("classGold");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("classForest2");
        rmDefineClass("importantItem");
        rmDefineClass("classCliff");
        rmDefineClass("classNatives");
        rmDefineClass("classNuggets");
		rmDefineClass("classIsland");
		rmDefineClass("center");
		int canyon=rmDefineClass("canyon");
				
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ******************************************* DEFINE THE CONSTRAINTS: ****************************************** //
// ****************************** USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ****************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
        // THE LINE BELOW WAS REMOVED BY ENSEMBLE:
		//int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 24.0);
        
		//int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(80), rmZTilesToFraction(80), 1.0-rmXTilesToFraction(80), 1.0-rmZTilesToFraction(80), 0.01);
          int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(0), rmXTilesToFraction(0), 1.0-rmXTilesToFraction(0), 1.0-rmZTilesToFraction(0));

        //int avoidIsland=rmCreateClassDistanceConstraint("continent from islands", rmClassID("classIsland"), 24.0);
        //int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
 		
		// THE LINE BELOW WAS REMOVED BY ENSEMBLE:        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
        int avoidCW=rmCreateTypeDistanceConstraint("stuff vs CW", "CoveredWagon", 20.0);
        // THE LINE BELOW WAS REMOVED BY ENSEMBLE:
		// int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
	    
        // CANYONS AVOIDANCE:		
		int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 8.0);
		int avoidCloseCanyons=rmCreateClassDistanceConstraint("close avoid canyons", rmClassID("canyon"), 2.0);
	     
        // NATURE AVOIDANCE:(NATURE AVOIDANCE)  
   
        // SEAFOOD AVOIDANCE:(NATURE AVOIDANCE)
        //int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
        // THE LINE BELOW WAS REMOVED BY ENSEMBLE:
		//int fishVsFish2ID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
        //int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "AbstractWhale", 10.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 18.0);
        //int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
   
        // FOREST AVOIDANCE:(NATURE AVOIDANCE)
		int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
        int forestConstraintSmall=rmCreateClassDistanceConstraint("forest2 vs. forest2", rmClassID("classForest2"), 12.0);
   
        // RESOURCE AVOIDANCE:(NATURE AVOIDANCE)
		int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
        
		// FOOD AVOIDANCE:(NATURE AVOIDANCE)
		int avoidFood=rmCreateTypeDistanceConstraint("food avoids food", "huntable", 40.0);
		
		// CENTER AVOIDANCE:
		int avoidCenter=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 2.0);
	        
		// COIN AVOIDANCE:(NATURE AVOIDANCE)
		//int smallAvoidCoin=rmCreateTypeDistanceConstraint("smallavoid coin", "gold", 30.0);
        //int tinyAvoidCoin=rmCreateTypeDistanceConstraint("tinyAvoid coin", "gold", 10.0);
        //int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 50.0);
		
		// SILVER MINES AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
        
        
		// START RESOURCE AVOIDANCE:(NATURE AVOIDANCE)
		int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
        
		// START UNITS AVOIDANCE:(NATURE AVOIDANCE)
		int avoidStartUnits=rmCreateClassDistanceConstraint("stuff avoid start res", rmClassID("startingUnit"), 2.0);

        // IMPASSABLE LAND AVOIDANCE:(IMPASSABLE LAND AVOIDANCE)
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
        int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
        int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
        
		// CLIFF AVOIDANCE:(IMPASSABLE LAND AVOIDANCE)
		int avoidCliff=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 6.0);
        int smallavoidCliff=rmCreateClassDistanceConstraint("small vs. cliff", rmClassID("classCliff"), 6.0);
        int mediumavoidCliff=rmCreateClassDistanceConstraint("medium vs. cliff", rmClassID("classCliff"), 12.0);
        int largeAvoidCliff=rmCreateClassDistanceConstraint("large vs. cliff", rmClassID("classCliff"), 18.0);
        int cliffAvoidCliff=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 20.0);
        int cliffFarAvoidCliff=rmCreateClassDistanceConstraint("big cliff vs. cliff", rmClassID("classCliff"), 40.0);
        
		// FAKE LAND AVOIDANCE:(IMPASSABLE LAND AVOIDANCE)
		int avoidFakeLand=rmCreateTerrainDistanceConstraint("avoid passable land", "Land", false, 4.0);
   
	    // CONSTRAINT TO AVOID WATER:
        int avoidWater2 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 2.0);
        int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 8.0);
        int avoidWater12 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 12.0);
        int nearWater20 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 20.0);
		int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water far", "Land", false, 15.0);
            
	   
	   // CONSTRAINT TO AVOID WATER:
	   // THE LINE BELOW WAS REMOVED BY ENSEMBLE:
	   // int oceanConstraint=rmCreateBoxConstraint("land stay away from edges", 0.13, 0, 0.87, 1);

/*      
        // THESE LINES BELOW WERE REMOVED BY ENSEMBLE:
		// CARDINAL DIRECTIONS:
        int NorthEward=rmCreatePieConstraint("northMapConstraint", 0.75, 0.75, 0, rmZFractionToMeters(0.3), rmDegreesToRadians(355), rmDegreesToRadians(85));
        int SouthWward=rmCreatePieConstraint("southMapConstraint", 0.25, 0.25, 0, rmZFractionToMeters(0.3), rmDegreesToRadians(175), rmDegreesToRadians(275));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
*/
   
        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

        // VP AVOIDANCE:(VP AVOIDANCE)
        
		// TRADE ROUTE AVOIDANCE:(VP AVOIDANCE)
		int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
        int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);
        
		// IMPORTANT ITEM AVOIDANCE:(VP AVOIDANCE)
		int avoidImportantItem=rmCreateClassDistanceConstraint("avoid natives, trade etc", rmClassID("importantItem"), 10.0);
        int forestAvoidImportantItem=rmCreateClassDistanceConstraint("forest avoid items", rmClassID("importantItem"), 15.0);
        
		// NUGGET AVOIDANCE:(VP AVOIDANCE)
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget vs nugget", "abstractnugget", 10.0);
		
		// FRUITS AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
		
		// DEER AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
		
		// MOOSE AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidMoose=rmCreateTypeDistanceConstraint("moose avoids moose", "moose", 10.0);
		int avoidCloseMoose=rmCreateTypeDistanceConstraint("close avoids moose", "moose", 2.0);
               
        // SHEEP AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 10.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 2.0);
		
		// TURKEY AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidTurkey=rmCreateTypeDistanceConstraint("turkey avoids turkey", "turkey", 10.0);
		int avoidCloseTurkey=rmCreateTypeDistanceConstraint("close avoids turkey", "turkey", 2.0);
				
		// UNIT AVOIDANCE:(UNIT AVOIDANCE)
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
        int avoidImportantItemSmall=rmCreateClassDistanceConstraint("important item small avoidance", rmClassID("importantItem"), 10.0);
        
		// NATIVES AVOIDANCE:(UNIT AVOIDANCE)
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("classNatives"), 8.0);
        int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("classNatives"), 2.0);
       
		// NUGGETS:(UNIT AVOIDANCE)
		int avoidNuggets=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("classNuggets"), 40.0);
        int nuggetAvoidNugget=rmCreateClassDistanceConstraint("nugget avoids nugget", rmClassID("classNuggets"), 20.0);
        
		// TOWNCENTER AVOIDANCE:(UNIT AVOIDANCE)
		int avoidTC=rmCreateTypeDistanceConstraint("objects avoid TC", "towncenter", 25.0);
        int tcAvoidTC=rmCreateTypeDistanceConstraint("Towncenter avoid TC", "towncenter", 20.0);
        int avoidTCTiny=rmCreateTypeDistanceConstraint("objects avoid TC small", "towncenter", 10.0);
        
		// FLAG AVOIDANCE:(UNIT AVOIDANCE)
		int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
        int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 15.0);
        int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
        int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
        
		// EDGE AVOIDANCE BY UNITS:(UNIT AVOIDANCE)
		int tcAvoidEdgeConstraint=rmCreatePieConstraint("towncenter avoid edge of map",  0.5, 0.5, 0, rmGetMapXSize()-30, 0, 0, 0);
        int nuggetAvoidEdgeConstraint=rmCreatePieConstraint("nugget avoid edge of map",  0.5, 0.5, 0, rmGetMapXSize()-5, 0, 0, 0);
        int coinAvoidEdgeConstraint=rmCreatePieConstraint("coin avoid edge of map",  0.5, 0.5, 0, rmGetMapXSize()-7, 0, 0, 0);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ******************************************** DEFINE THE OBJECTS: ********************************************* //
// ************************* THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE A CENTER AREA: **************************************** //
/*================================================================================================================*/

		int center3ID=rmCreateArea("center 3");
	    rmSetAreaSize(center3ID, 0.325, 0.325);
	    rmSetAreaLocation(center3ID, 0.51, 0.51);
	    rmSetAreaCoherence(center3ID, 1.0);
	    rmAddAreaToClass(center3ID, rmClassID("center"));
		//rmSetAreaMix(center3ID, "rockies_snow");
		rmAddAreaConstraint(center3ID, nearWater20);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE BIG CONTINENT: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		int bigContinentID = rmCreateArea("big visible continent");
        rmSetAreaLocation(bigContinentID, 0.5, 0.5); 
        rmSetAreaWarnFailure(bigContinentID, false);
        rmSetAreaSize(bigContinentID, 0.6, 0.6);
        //rmAddAreaInfluencePoint(bigContinentID, 0.5, 1);
        //rmAddAreaInfluencePoint(bigContinentID, 0.5, 0);
		rmAddAreaInfluencePoint(bigContinentID, 1.0, 1.0);
        rmAddAreaInfluencePoint(bigContinentID, 0.0, 0.0);
        rmSetAreaElevationType(bigContinentID, cElevTurbulence);
        rmSetAreaElevationVariation(bigContinentID, 4.0);
        rmSetAreaBaseHeight(bigContinentID, 5.0);
        rmSetAreaElevationMinFrequency(bigContinentID, 0.09);
        rmSetAreaElevationOctaves(bigContinentID, 3);
        rmSetAreaElevationPersistence(bigContinentID, 0.2); // 0.7
	    rmSetAreaElevationNoiseBias(bigContinentID, 1); 
	    rmSetAreaMix(bigContinentID, "yucatan_grass");
        rmSetAreaObeyWorldCircleConstraint(bigContinentID, false);
        rmSetAreaCoherence(bigContinentID, 0.825);
        rmSetAreaSmoothDistance(bigContinentID, 12);
		rmAddAreaConstraint(bigContinentID, avoidCenter);
		
		rmBuildArea(bigContinentID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// **************************** SET UP THE PLAYER STARTING LOCATIONS ALONG THE RIVER: *************************** //
// ********************************* THESE ARE USED TO PLACE THE STARTING TC'S: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

    if(cNumberNonGaiaPlayers == 2)
	
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.775,0.775);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.225,0.225);
	}  
		else
    {		
		//rmSetPlacementTeam(0);
		//rmPlacePlayer(1,0.8,0.8);
		//rmPlacePlayer(2,0.8,0.2);
		//rmSetPlacementTeam(1);
		//rmPlacePlayer(3,0.2,0.2);
        //rmPlacePlayer(4,0.2,0.8);
	} 
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
        
		float playerFraction=rmAreaTilesToFraction(100);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "carolina\marshflats");
        
		// SET AREA BASE HEIGHT:
		// rmSetAreaBaseHeight(id, 8.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// *********************************** CLEAR OUT CONSTRAINTS FOR GOOD MEASURE: ********************************** //
/*================================================================================================================*/

        rmClearClosestPointConstraints();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.51);
/*================================================================================================================*/

        // PLACEMENT ORDER:
        // TRADE ROUTE -> RIVER (NONE ON THIS MAP) -> NATIVES -> SECRETS -> CLIFFS -> NUGGETS:

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.52);
/*================================================================================================================*/
//************************************** DEFINE AND PLACE THE TRADE ROUTE: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ****************************************** BUILD INVISIBLE ISLANDS ******************************************* //
/*================================================================================================================*/ 
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		// BUILD AN INVISIBLE NORTH ISLAND AREA:
        int northIslandID = rmCreateArea("north east invisible island");
		rmAddAreaToClass(northIslandID, rmClassID("classIsland"));
        //rmSetAreaWarnFailure(northIslandID, false); // REMOVED BY ENSEMBLE:
        rmSetAreaLocation(northIslandID, 0.775, 0.775); 
        rmSetAreaWarnFailure(northIslandID, false);
        rmSetAreaSize(northIslandID, 0.15, 0.15);
        rmSetAreaCoherence(northIslandID, 1.0);
        //rmSetAreaTerrainType(northIslandID, "texas\ground4_tex"); // REMOVED BY ENSEMBLE:

        // BUILD AN INVISIBLE SOUTH ISLAND AREA:.
        int southIslandID = rmCreateArea("south west invisible island");
		rmAddAreaToClass(southIslandID, rmClassID("classIsland"));
        rmSetAreaLocation(southIslandID, 0.225, 0.225); 
        rmSetAreaWarnFailure(southIslandID, false);
        rmSetAreaSize(southIslandID, 0.15, 0.15);
        rmSetAreaCoherence(southIslandID, 1.0);
        //rmSetAreaTerrainType(southIslandID, "texas\ground4_tex"); // REMOVED BY ENSEMBLE:

        // BUILD ALL AREAS:
		rmBuildAllAreas();

        // DEFINE THE CONSTRAINTS OF NORTHISLAND AND SOUTHISLAND:
		int northeastConstraint=rmCreateAreaConstraint("NE", northIslandID);
        int southwestConstraint=rmCreateAreaConstraint("SW", southIslandID);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************** DEFINE THE STARTING RESOURCES: **************************************** //
/*================================================================================================================*/  
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints(); // CLEAR FOR WATERFLAG PLACEMENT: 
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // DEFINE THE STARTING TCID:
		int TCID = rmCreateObjectDef("player TC");
        if ( rmGetNomadStart())
   {
	    rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
   }
        else
   {
	    rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
   }
        rmSetObjectDefMinDistance(TCID, 0.0);
        rmSetObjectDefMaxDistance(TCID, 0.0);
        rmAddObjectDefConstraint(TCID, avoidTradeRoute);
        rmAddObjectDefConstraint(TCID, avoidWater8); 
        rmAddObjectDefConstraint(TCID, tcAvoidTC);
        rmAddObjectDefConstraint(TCID, tcAvoidEdgeConstraint);
        //rmPlaceObjectDefPerPlayer(TCID, true);
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
        rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
        rmAddObjectDefConstraint(startingUnits, avoidAll);
        rmAddObjectDefConstraint(startingUnits, avoidImpassableLand);
        rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
        //rmPlaceObjectDefPerPlayer(startingUnits, true);
        //rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE WATER FLAG:
		int waterFlagID=rmCreateObjectDef("HC water flag "+i);
        rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
        rmAddClosestPointConstraint(flagEdgeConstraint);
        rmAddClosestPointConstraint(flagVsFlag);
        rmAddClosestPointConstraint(flagLand);		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************** PLACE THE STARTING RESOURCES: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		for(i=1; <cNumberPlayers)
 
 {
	    
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
	    vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

		// PLACE THE WATER FLAG:
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		
}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/

        if (subCiv0 == rmGetCivID("aztecs"))
	{  
		int aztecs1VillageID = -1;
		aztecs1VillageID = rmCreateGrouping("aztecs village 1", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs1VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs1VillageID, 0.0);
		rmAddGroupingToClass(aztecs1VillageID, rmClassID("classNatives"));
		rmAddGroupingConstraint(aztecs1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs1VillageID, 0, 0.35, 0.65);
	} 
	
	    if (subCiv1 == rmGetCivID("aztecs"))
	{  
		int aztecs2VillageID = -1;
		aztecs2VillageID = rmCreateGrouping("aztecs village 2", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs2VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs2VillageID, 0.0);
		rmAddGroupingToClass(aztecs2VillageID, rmClassID("classNatives"));
		rmAddGroupingConstraint(aztecs2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs2VillageID, 0, 0.65, 0.35);
	} 
	
	    if (subCiv2 == rmGetCivID("aztecs"))
	{  
		int aztecs3VillageID = -1;
		aztecs3VillageID = rmCreateGrouping("aztecs village 3", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs3VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs3VillageID, 0.0);
		rmAddGroupingToClass(aztecs3VillageID, rmClassID("classNatives"));
		rmAddGroupingConstraint(aztecs3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs3VillageID, 0, 0.575, 0.75);
	} 
	
	    if (subCiv3 == rmGetCivID("aztecs"))
	{  
		int aztecs4VillageID = -1;
		aztecs4VillageID = rmCreateGrouping("aztecs village 4", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs4VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs4VillageID, 0.0);
		rmAddGroupingToClass(aztecs4VillageID, rmClassID("classNatives"));
		rmAddGroupingConstraint(aztecs4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs4VillageID, 0, 0.75, 0.575);
	} 
        
		if (subCiv4 == rmGetCivID("aztecs"))
	{  
		int aztecs5VillageID = -1;
		aztecs5VillageID = rmCreateGrouping("aztecs village 5", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs5VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs5VillageID, 0.0);
		rmAddGroupingToClass(aztecs5VillageID, rmClassID("classNatives"));
		rmAddGroupingConstraint(aztecs5VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs5VillageID, 0, 0.25, 0.425);
	} 
	
	    if (subCiv5 == rmGetCivID("aztecs"))
	{  
		int aztecs6VillageID = -1;
		aztecs6VillageID = rmCreateGrouping("aztecs village 6", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs6VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs6VillageID, 0.0);
		rmAddGroupingToClass(aztecs6VillageID, rmClassID("classNatives"));
		rmAddGroupingConstraint(aztecs6VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs6VillageID, 0, 0.425, 0.25);
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE NUGGETS ON THE MAP: *********************************** //
/*================================================================================================================*/
        
		// DEFINE AND PLACE NUGGETS NUMBER 1:
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		rmAddObjectDefConstraint(nugget1ID, avoidWater2);
  	    rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.20, 0.55);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.55, 0.20);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.80, 0.45);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.45, 0.80);
			
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE NUGGETS NUMBER 2:
		int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmAddObjectDefConstraint(nugget2ID, avoidWater2);
  	    rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.40, 0.50);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.50, 0.40);
		
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.50, 0.60);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.60, 0.50);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE NUGGETS NUMBER 3:
		int nugget3ID= rmCreateObjectDef("nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmAddObjectDefConstraint(nugget3ID, avoidWater2);
  	    rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.15, 0.30);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.30, 0.15);
		
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.70, 0.85);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.85, 0.70);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE NUGGETS NUMBER 4:
		int nugget4ID= rmCreateObjectDef("nugget 4"); 
	    rmAddObjectDefItem(nugget4ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget4ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget4ID, 0.0);
	    rmAddObjectDefConstraint(nugget4ID, avoidNugget);
		rmAddObjectDefConstraint(nugget4ID, avoidWater2);
  	    rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.36, 0.56);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.56, 0.36);
		
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.44, 0.64);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.64, 0.44);		
		
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //
/*================================================================================================================*/
        
		int berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.20, 0.20);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.80, 0.80);
		
		//rmPlaceObjectDefAtLoc(berries1ID, 0, 0.475, 0.525);
		//rmPlaceObjectDefAtLoc(berries1ID, 0, 0.525, 0.475);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int berries2ID = rmCreateObjectDef("The Berries 2");
		rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.30, 0.60);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.60, 0.30);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.40, 0.70);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.70, 0.40);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int berries3ID = rmCreateObjectDef("The Berries 3");
		rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries3ID, 0.0);
		rmSetObjectDefMaxDistance(berries3ID, 0.0);
		rmAddObjectDefConstraint(berries3ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.125, 0.225);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.225, 0.125);
		
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.775, 0.875);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.875, 0.775);	

/*----------------------------------------------------------------------------------------------------------------*/

        int berries4ID = rmCreateObjectDef("The Berries 4");
		rmAddObjectDefItem(berries4ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries4ID, 0.0);
		rmSetObjectDefMaxDistance(berries4ID, 0.0);
		rmAddObjectDefConstraint(berries4ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries4ID, 0, 0.55, 0.50);
		rmPlaceObjectDefAtLoc(berries4ID, 0, 0.50, 0.55);
		
		rmPlaceObjectDefAtLoc(berries4ID, 0, 0.49, 0.45);
		rmPlaceObjectDefAtLoc(berries4ID, 0, 0.45, 0.49);			
		

/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE DEER: ****************************************** //
/*================================================================================================================*/ 
	   
        int deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(deer1ID, "capybara", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.275, 0.275);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.725, 0.725);
		
		//rmPlaceObjectDefAtLoc(deer1ID, 0, 0.05, 0.50);
		//rmPlaceObjectDefAtLoc(deer1ID, 0, 0.50, 0.05);
		
		//rmPlaceObjectDefAtLoc(deer1ID, 0, 0.95, 0.50);
		//rmPlaceObjectDefAtLoc(deer1ID, 0, 0.50, 0.95);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int deer2ID=rmCreateObjectDef("The Deer Herds 2");
        rmAddObjectDefItem(deer2ID, "capybara", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer2ID, 0.0);
        rmSetObjectDefMaxDistance(deer2ID, 0.0);
	    rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer2ID, true);
	    
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.55, 0.60);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.60, 0.55);
		
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.45, 0.40);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.40, 0.45);
				

/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE MOOSES: ***************************************** //
/*================================================================================================================*/
        
        int moose1ID=rmCreateObjectDef("The Moose Herds 1");
        rmAddObjectDefItem(moose1ID, "tapir", rmRandInt(5,7), 5.0);
        rmSetObjectDefMinDistance(moose1ID, 0.0);
        rmSetObjectDefMaxDistance(moose1ID, 0.0);
	    rmAddObjectDefConstraint(moose1ID, avoidMoose);
		rmSetObjectDefCreateHerd(moose1ID, true);
	    
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.25, 0.35);
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.35, 0.25);
		
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.65, 0.75);
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.75, 0.65);
		
		//rmPlaceObjectDefAtLoc(moose1ID, 0, 0.46, 0.675);
		//rmPlaceObjectDefAtLoc(moose1ID, 0, 0.625, 0.225);

/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE SHEEPS: **************************************** //
/*================================================================================================================*/
        
		int sheep1ID = rmCreateObjectDef("The Sheep Herds 1");
		rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(5,9), 4.0);
		rmSetObjectDefMinDistance(sheep1ID, 0.0);
		rmSetObjectDefMaxDistance(sheep1ID, 0.0);
		rmAddObjectDefConstraint(sheep1ID, avoidSheep);
		
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.20, 0.45);
	    rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.45, 0.20);
		
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.80, 0.55);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.55, 0.80);		

/*----------------------------------------------------------------------------------------------------------------*/
		
        int sheep2ID = rmCreateObjectDef("The Sheep Herds 2");
		rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(5,9), 4.0);
		rmSetObjectDefMinDistance(sheep2ID, 0.0);
		rmSetObjectDefMaxDistance(sheep2ID, 0.0);
		rmAddObjectDefConstraint(sheep2ID, avoidSheep);
		
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.425, 0.75);
	    rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.75, 0.425);
		
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.24, 0.56);
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.56, 0.24);	

/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE TURKEYS: ****************************************** //
/*================================================================================================================*/
		
		int turkey1ID = rmCreateObjectDef("The Turkeys 1");
		rmAddObjectDefItem(turkey1ID, "capybara", rmRandInt(5,9), 4.0);
		rmSetObjectDefMinDistance(turkey1ID, 0.0);
		rmSetObjectDefMaxDistance(turkey1ID, 0.0);
		rmAddObjectDefConstraint(turkey1ID, avoidTurkey);
		
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.15, 0.25);
	    rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.25, 0.15);
		
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.75, 0.85);
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.85, 0.75);	
			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.76);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE SOME SMALL MESAS: *************************************** //
/*================================================================================================================*/
        
		// DEFINE AND PLACE SMALL MESA NUMBER 1: 
		int smallCliff1Height=rmRandInt(0,10);
		int smallMesa1ID=rmCreateArea("small mesa 1");
		rmSetAreaSize(smallMesa1ID, 0.009, 0.009);
		rmSetAreaWarnFailure(smallMesa1ID, false);
		rmSetAreaCliffType(smallMesa1ID, "Amazon");
		rmAddAreaToClass(smallMesa1ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(smallMesa1ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa1ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaMinBlobs(smallMesa1ID, 1);
		rmSetAreaMaxBlobs(smallMesa1ID, 1);
		rmSetAreaMinBlobDistance(smallMesa1ID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesa1ID, 1.0);
		rmSetAreaCoherence(smallMesa1ID, 1.0);
		rmAddAreaConstraint(smallMesa1ID, avoidCloseNatives);
		rmSetAreaLocation(smallMesa1ID, 0.50, 0.70); 
	    rmBuildArea(smallMesa1ID);
		
		// DEFINE AND PLACE SMALL MESA NUMBER 2: 
		int smallCliff2Height=rmRandInt(0,10);
		int smallMesa2ID=rmCreateArea("small mesa 2");
		rmSetAreaSize(smallMesa2ID, 0.009, 0.009);
		rmSetAreaWarnFailure(smallMesa2ID, false);
		rmSetAreaCliffType(smallMesa2ID, "Amazon");
		rmAddAreaToClass(smallMesa2ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(smallMesa2ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa2ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaMinBlobs(smallMesa2ID, 1);
		rmSetAreaMaxBlobs(smallMesa2ID, 1);
		rmSetAreaMinBlobDistance(smallMesa2ID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesa2ID, 1.0);
		rmSetAreaCoherence(smallMesa2ID, 1.0);
		rmAddAreaConstraint(smallMesa2ID, avoidCloseNatives);
		rmSetAreaLocation(smallMesa2ID, 0.30, 0.50); 
	    rmBuildArea(smallMesa2ID);
		
		// DEFINE AND PLACE SMALL MESA NUMBER 3: 
		int smallCliff3Height=rmRandInt(0,10);
		int smallMesa3ID=rmCreateArea("small mesa 3");
		rmSetAreaSize(smallMesa3ID, 0.009, 0.009);
		rmSetAreaWarnFailure(smallMesa3ID, false);
		rmSetAreaCliffType(smallMesa3ID, "Amazon");
		rmAddAreaToClass(smallMesa3ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(smallMesa3ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa3ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaMinBlobs(smallMesa3ID, 1);
		rmSetAreaMaxBlobs(smallMesa3ID, 1);
		rmSetAreaMinBlobDistance(smallMesa3ID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesa3ID, 1.0);
		rmSetAreaCoherence(smallMesa3ID, 1.0);
		rmAddAreaConstraint(smallMesa3ID, avoidCloseNatives);
		rmSetAreaLocation(smallMesa3ID, 0.50, 0.30); 
	    rmBuildArea(smallMesa3ID);
		
		// DEFINE AND PLACE SMALL MESA NUMBER 4: 
		int smallCliff4Height=rmRandInt(0,10);
		int smallMesa4ID=rmCreateArea("small mesa 4");
		rmSetAreaSize(smallMesa4ID, 0.009, 0.009);
		rmSetAreaWarnFailure(smallMesa4ID, false);
		rmSetAreaCliffType(smallMesa4ID, "Amazon");
		rmAddAreaToClass(smallMesa4ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(smallMesa4ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa4ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaMinBlobs(smallMesa4ID, 1);
		rmSetAreaMaxBlobs(smallMesa4ID, 1);
		rmSetAreaMinBlobDistance(smallMesa4ID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesa4ID, 1.0);
		rmSetAreaCoherence(smallMesa4ID, 1.0);
		rmAddAreaConstraint(smallMesa4ID, avoidCloseNatives);
		rmSetAreaLocation(smallMesa4ID, 0.70, 0.50); 
	    rmBuildArea(smallMesa4ID);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE SOME VERY SMALL MESAS ************************************* //
/*================================================================================================================*/
        
        // DEFINE AND PLACE SMALL MESA NUMBER 5: 
		int smallCliff5Height=rmRandInt(0,10);
		int smallMesa5ID=rmCreateArea("small mesa 5");
		rmSetAreaSize(smallMesa5ID, 0.0025, 0.0025);
		rmSetAreaWarnFailure(smallMesa5ID, false);
		rmSetAreaCliffType(smallMesa5ID, "Amazon");
		rmAddAreaToClass(smallMesa5ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(smallMesa5ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa5ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaMinBlobs(smallMesa5ID, 1);
		rmSetAreaMaxBlobs(smallMesa5ID, 1);
		rmSetAreaMinBlobDistance(smallMesa5ID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesa5ID, 1.0);
		rmSetAreaCoherence(smallMesa5ID, 1.0);
		rmSetAreaLocation(smallMesa5ID, 0.45, 0.55); 
	    rmBuildArea(smallMesa5ID);

        // DEFINE AND PLACE SMALL MESA NUMBER 6: 
		int smallCliff6Height=rmRandInt(0,10);
		int smallMesa6ID=rmCreateArea("small mesa 6");
		rmSetAreaSize(smallMesa6ID, 0.0025, 0.0025);
		rmSetAreaWarnFailure(smallMesa6ID, false);
		rmSetAreaCliffType(smallMesa6ID, "Amazon");
		rmAddAreaToClass(smallMesa6ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(smallMesa6ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa6ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaMinBlobs(smallMesa6ID, 1);
		rmSetAreaMaxBlobs(smallMesa6ID, 1);
		rmSetAreaMinBlobDistance(smallMesa6ID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesa6ID, 1.0);
		rmSetAreaCoherence(smallMesa6ID, 1.0);
		rmSetAreaLocation(smallMesa6ID, 0.55, 0.45); 
	    rmBuildArea(smallMesa6ID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.81);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE GOLD MINES ON THE MAP: ********************************* //
/*================================================================================================================*/

		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
		rmAddObjectDefConstraint(gold1ID, avoidWater2);
		
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.25, 0.65);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.65, 0.25);
		
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.35, 0.75);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.75, 0.35);
		
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.165, 0.165);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.835, 0.835);
		
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.55, 0.55);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.45, 0.45);
		
/*----------------------------------------------------------------------------------------------------------------*/
        
        int gold2ID = rmCreateObjectDef("gold 2");
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
		rmAddObjectDefConstraint(gold2ID, avoidWater2);
		
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.20, 0.35);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.35, 0.20);
		
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.65, 0.80);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.80, 0.65);
		
		//rmPlaceObjectDefAtLoc(gold2ID, 0, 0.165, 0.165);
		//rmPlaceObjectDefAtLoc(gold2ID, 0, 0.835, 0.835);
		
		//rmPlaceObjectDefAtLoc(gold2ID, 0, 0.55, 0.55);
		//rmPlaceObjectDefAtLoc(gold2ID, 0, 0.45, 0.45);

/*----------------------------------------------------------------------------------------------------------------*/

        int gold3ID = rmCreateObjectDef("gold 3");
		rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
		rmSetObjectDefMaxDistance(gold3ID, 0.0);
		rmAddObjectDefConstraint(gold3ID, avoidGold);
		rmAddObjectDefConstraint(gold3ID, avoidWater2);
		
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.175, 0.225);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.260, 0.225);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.75, 0.80);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.825, 0.775);
				
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE WOOD RESOURCES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/      
        
		int randomTreeID=rmCreateObjectDef("random tree");
        rmAddObjectDefItem(randomTreeID, "TreeYucatan", rmRandInt(10,15), 10.0);
        rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, 0.0);
        rmAddObjectDefConstraint(randomTreeID, avoidWater2);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
        
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5);
		
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.4, 0.6);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.6, 0.4);
		
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.1, 0.3);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.2, 0.3);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.2, 0.4);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.2, 0.5);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.2, 0.6);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.3, 0.7);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.4, 0.8);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.8);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.6, 0.8);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.7, 0.8);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.3, 0.1);
		
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.9, 0.7);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.3, 0.2);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.4, 0.2);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.2);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.6, 0.2);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.7, 0.3);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.8, 0.4);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.8, 0.5);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.8, 0.6);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.8, 0.7);
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.7, 0.9);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE LARGE FORESTS: ************************************* //
/*================================================================================================================*/
// NOT FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
         		 
		 int forest1ID = -1;
         forest1ID=rmCreateArea("forest 1");
         rmSetAreaWarnFailure(forest1ID, false);
         rmSetAreaSize(forest1ID, 0.0225, 0.0225);
         rmSetAreaForestType(forest1ID, "Yucatan forest");
         rmSetAreaForestDensity(forest1ID, 1.0);
         rmSetAreaForestClumpiness(forest1ID, 0.0);
         rmSetAreaForestUnderbrush(forest1ID, 0.0);
         rmSetAreaMinBlobs(forest1ID, 1);
         rmSetAreaMaxBlobs(forest1ID, 1);
         rmSetAreaMinBlobDistance(forest1ID, 1.0);
         rmSetAreaMaxBlobDistance(forest1ID, 1.0);
         rmSetAreaCoherence(forest1ID, 1.0);
         rmSetAreaSmoothDistance(forest1ID, 10);
         rmAddAreaToClass(forest1ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest1ID, forestConstraint);
		 rmAddAreaConstraint(forest1ID, avoidCloseNatives);
		 rmAddAreaConstraint(forest1ID, avoidCloseDeer);
		 rmAddAreaConstraint(forest1ID, avoidCloseMoose);
		 rmSetAreaLocation(forest1ID, 0.65, 0.65); 
         rmBuildArea(forest1ID);
		 
		 int forest2ID = -1;
         forest2ID=rmCreateArea("forest 2");
         rmSetAreaWarnFailure(forest2ID, false);
         rmSetAreaSize(forest2ID, 0.0225, 0.0225);
         rmSetAreaForestType(forest2ID, "Yucatan forest");
         rmSetAreaForestDensity(forest2ID, 1.0);
         rmSetAreaForestClumpiness(forest2ID, 0.0);
         rmSetAreaForestUnderbrush(forest2ID, 0.0);
         rmSetAreaMinBlobs(forest2ID, 1);
         rmSetAreaMaxBlobs(forest2ID, 1);
         rmSetAreaMinBlobDistance(forest2ID, 1.0);
         rmSetAreaMaxBlobDistance(forest2ID, 1.0);
         rmSetAreaCoherence(forest2ID, 1.0);
         rmSetAreaSmoothDistance(forest2ID, 10);
         rmAddAreaToClass(forest2ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest2ID, forestConstraint);
		 rmAddAreaConstraint(forest2ID, avoidCloseNatives);
		 rmAddAreaConstraint(forest2ID, avoidCloseDeer);
		 rmAddAreaConstraint(forest2ID, avoidCloseMoose);
		 rmSetAreaLocation(forest2ID, 0.35, 0.35); 
         rmBuildArea(forest2ID);
		 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE FISHES AND THE WHALES: ********************************* //
/*================================================================================================================*/
        
		// DEFINE THE CONSTRAINTS:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "FishSalmon", 8.0);
		int fish2VsFish2ID=rmCreateTypeDistanceConstraint("fish2 v fish2", "FishSalmon", 8.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "HumpbackWhale", 25.0);

        // DEFINE AND PLACE THE FISHES: 
		int fishID=rmCreateObjectDef("fish 1");
        rmAddObjectDefItem(fishID, "FishSalmon", 2, 5.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.0, 15*cNumberNonGaiaPlayers);
		
		// DEFINE AND PLACE THE FISHES: 
		int fish2ID=rmCreateObjectDef("fish 2");
        rmAddObjectDefItem(fish2ID, "FishSalmon", 2, 5.0);
        rmSetObjectDefMinDistance(fish2ID, 0.0);
        rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish2ID, fish2VsFish2ID);
        rmAddObjectDefConstraint(fish2ID, fishLand);
        rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 1.0,15*cNumberNonGaiaPlayers);

	    // DEFINE AND PLACE THE FAST COIN -- WHALES:
	    int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, 0.0);
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.05, 0.50);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.185, 0.815); 
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.50, 0.930);

        rmPlaceObjectDefAtLoc(whaleID, 0, 0.50, 0.05); 		
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.815, 0.185); 
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.930, 0.50); 
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ****************************************** // 
/*================================================================================================================*/












