/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// THE WEST PRAIRIES:
// CREATED BY DANY:
// APRIL 2007:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
        int subCiv4=-1;
        int subCiv5=-1;
		
		if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Cherokee");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cherokee");

		subCiv1=rmGetCivID("Cherokee");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cherokee"); 

		subCiv2=rmGetCivID("Cherokee");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Cherokee");

		subCiv3=rmGetCivID("Cherokee");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Cherokee");

		subCiv4=rmGetCivID("Cherokee");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Cherokee");

		subCiv5=rmGetCivID("Cherokee");
        if (subCiv5 >= 0)
        rmSetSubCiv(5, "Cherokee");
   }		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
	
	    int playerTiles=17500;
        		
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(530, 530);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ****************************************** PICKS THE MAP PARAMETERS: ***************************************** //
/*================================================================================================================*/

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(0.0);

        // SET MAP ELEVATION PARAMETERS:
		rmSetMapElevationParameters(cElevTurbulence, 0.02, 7, 0.5, 8.0);
	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("great plains drygrass");
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("yukon\ground1_yuk", 5);
	
	    // SET THE LIGHTING:
	    rmSetLightingSet("great plains");
	
	    // SET MAP TYPE:
		rmSetMapType("greatPlains");
	    rmSetMapType("land");
		rmSetMapType("grass");
	    
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
	    rmDefineClass("classPatch");
	    rmDefineClass("starting settlement");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("natives");	
	    rmDefineClass("classHillArea");
	    rmDefineClass("socketClass");
		rmDefineClass("nuggets");
		int canyon=rmDefineClass("canyon");
		rmDefineClass("region");

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ******************************************* DEFINE CONSTRAINTS: ********************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);

        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 10.0);
		
		// Cardinal Directions
	    int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	    int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	    int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
		
		// FOREST AVOIDANCE:
		int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 25.0);
       		
		// CANYONS AVOIDANCE:		
		int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 8.0);
		int avoidCloseCanyons=rmCreateClassDistanceConstraint("close avoid canyons", rmClassID("canyon"), 2.0);
		
		// REGIONS AVOIDANCE:
		int avoidRegion=rmCreateClassDistanceConstraint("stay away from region", rmClassID("region"), 8.0);
	    int avoidCloseRegion=rmCreateClassDistanceConstraint("close away from region", rmClassID("region"), 2.0);
	    	   	         
        // UNIT AVOIDANCE - FOR THINGS THAT AREN'T IN THE STARTING RESOURCES:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
		
		// AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
		
		// DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
       		
		// VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
        int avoidTradeRouteSmall = rmCreateTradeRouteDistanceConstraint("trade route small", 4.0);
        // int avoidTradeRoutePlayer = rmCreateTradeRouteDistanceConstraint("trade route player", 30.0);
        int avoidImportantItem=rmCreateClassDistanceConstraint("important stuff avoids each other", rmClassID("importantItem"), 15.0);

	    int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);
	    int avoidSocketMore=rmCreateClassDistanceConstraint("bigger socket avoidance", rmClassID("socketClass"), 15.0);

        // NATIVES AVOIDANCE:
	    int avoidNatives = rmCreateClassDistanceConstraint("avoid Natives", rmClassID("natives"), 10.0);
	    int avoidCloseNatives = rmCreateClassDistanceConstraint("nuggets avoid Natives", rmClassID("natives"), 2.0);

		// SILVER MINES AVOIDANCE:(RESOURCE AVOIDANCE)
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
		
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "AbstractNugget", 10.0);
        int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nuggets", "AbstractNugget", 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
		
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
		
		// BISON AVOIDANCE:
		int avoidBison=rmCreateTypeDistanceConstraint("stuff avoids bison", "bison", 10.0);
		int avoidCloseBison=rmCreateTypeDistanceConstraint("close avoids bison", "bison", 2.0);
		
		// VULTURE AVOIDANCE:
		int avoidVulture=rmCreateTypeDistanceConstraint("stuff avoids vulture", "PropVulturePerching", 10.0);
		int avoidCloseVulture=rmCreateTypeDistanceConstraint("close avoids vulture", "PropVulturePerching", 2.0);
		
		// GEYSER AVOIDANCE:
		//int avoidGeyser=rmCreateTypeDistanceConstraint("stuff avoids geyser", "BigProp_geyser", 10.0);
		//int avoidCloseGeyser=rmCreateTypeDistanceConstraint("close avoids geyser", "BigProp_geyser", 2.0);
				
		// TREE AVOIDANCE:
		int avoidTree=rmCreateTypeDistanceConstraint("stuff avoids tree", "TreeGreatPlains", 10.0);
		int avoidCloseTree=rmCreateTypeDistanceConstraint("close avoids tree", "TreeGreatPlains", 2.0);
						        		
		// SEAFOOD AVOIDANCE:(NATURE AVOIDANCE)
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 4.0);
        //int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "AbstractWhale", 10.0);
        //int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 18.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
		
		// FLAG AVOIDANCE:(UNIT AVOIDANCE)
		int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
        int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 15.0);
        int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
        int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE REGION AREAS: ************************************* //
/*================================================================================================================*/

		int region1ID=rmCreateArea("region 1");
	    rmSetAreaSize(region1ID, 0.03, 0.03);
	    rmSetAreaLocation(region1ID, 0.51, 0.51);
	    rmSetAreaCoherence(region1ID, 1.0);
	    rmAddAreaToClass(region1ID, rmClassID("region"));
		//rmSetAreaMix(region1ID, "rockies_snow");
		rmAddAreaConstraint(region1ID, avoidRegion); 
        rmAddAreaConstraint(region1ID, avoidCloseRegion);
		rmSetAreaLocation(region1ID, 0.20, 0.50);
        rmBuildArea(region1ID);	

        int region2ID=rmCreateArea("region 2");
	    rmSetAreaSize(region2ID, 0.03, 0.03);
	    rmSetAreaLocation(region2ID, 0.51, 0.51);
	    rmSetAreaCoherence(region2ID, 1.0);
	    rmAddAreaToClass(region2ID, rmClassID("region"));
		//rmSetAreaMix(region2ID, "rockies_snow");
		rmAddAreaConstraint(region2ID, avoidRegion); 
        rmAddAreaConstraint(region2ID, avoidCloseRegion);
		rmSetAreaLocation(region2ID, 0.50, 0.20);
        rmBuildArea(region2ID);	

        int region3ID=rmCreateArea("region 3");
	    rmSetAreaSize(region3ID, 0.03, 0.03);
	    rmSetAreaLocation(region3ID, 0.51, 0.51);
	    rmSetAreaCoherence(region3ID, 1.0);
	    rmAddAreaToClass(region3ID, rmClassID("region"));
		//rmSetAreaMix(region3ID, "rockies_snow");
		rmAddAreaConstraint(region3ID, avoidRegion); 
        rmAddAreaConstraint(region3ID, avoidCloseRegion);
		rmSetAreaLocation(region3ID, 0.50, 0.80);
        rmBuildArea(region3ID);	

        int region4ID=rmCreateArea("region 4");
	    rmSetAreaSize(region4ID, 0.03, 0.03);
	    rmSetAreaLocation(region4ID, 0.51, 0.51);
	    rmSetAreaCoherence(region4ID, 1.0);
	    rmAddAreaToClass(region4ID, rmClassID("region"));
		//rmSetAreaMix(region4ID, "rockies_snow");
		rmAddAreaConstraint(region4ID, avoidRegion); 
        rmAddAreaConstraint(region4ID, avoidCloseRegion);
		rmSetAreaLocation(region4ID, 0.80, 0.50);
        rmBuildArea(region4ID);			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE 2 TRADE ROUTE: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	  int tradeRouteID = rmCreateTradeRoute();
      int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRouteID, 0.025, 0.60);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.40, 0.975);
	  
      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 1.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 2:
	  int tradeRoute2ID = rmCreateTradeRoute();
      socketID=rmCreateObjectDef("sockets to dock Trade Posts north");
      rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.60, 0.025);
	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.975, 0.40);
	  
      placedTradeRoute = rmBuildTradeRoute(tradeRoute2ID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 2:
      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.50);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 1.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************** SET UP PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
        if(cNumberNonGaiaPlayers == 2)
	
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.775,0.775);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.225,0.225);
	}  
		else
    {		
		//rmSetPlacementTeam(0);
		//rmPlacePlayer(1,0.8,0.8);
		//rmPlacePlayer(2,0.8,0.2);
		//rmSetPlacementTeam(1);
		//rmPlacePlayer(3,0.2,0.2);
        //rmPlacePlayer(4,0.2,0.8);
	}   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ******************************************** SET UP PLAYER AREAS: ******************************************** //
/*================================================================================================================*/
        
		float playerFraction=rmAreaTilesToFraction(100);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "carolina\marshflats");
        
		// SET AREA BASE HEIGHT:
		// rmSetAreaBaseHeight(id, 8.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE SOME SMALL MESAS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE AND PLACE SMALL MESA NUMBER 1: 
		int smallCliff1Height=rmRandInt(0,10);
		int smallMesa1ID=rmCreateArea("small mesa 1");
		rmSetAreaSize(smallMesa1ID, 0.03, 0.03);
		rmSetAreaWarnFailure(smallMesa1ID, false);
		rmSetAreaCliffType(smallMesa1ID, "Great Plains");
		rmAddAreaToClass(smallMesa1ID, rmClassID("canyon"));	
		// rmSetAreaCliffEdge(smallMesa1ID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(smallMesa1ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa1ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaMinBlobs(smallMesa1ID, 1);
		rmSetAreaMaxBlobs(smallMesa1ID, 1);
		rmSetAreaMinBlobDistance(smallMesa1ID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesa1ID, 1.0);
		rmSetAreaCoherence(smallMesa1ID, 1.0);
		rmAddAreaConstraint(smallMesa1ID, avoidCloseNatives);
		rmSetAreaLocation(smallMesa1ID, 0.20, 0.50); 
	    rmBuildArea(smallMesa1ID);
		
		// DEFINE AND PLACE SMALL MESA NUMBER 2: 
		int smallCliff2Height=rmRandInt(0,10);
		int smallMesa2ID=rmCreateArea("small mesa 2");
		rmSetAreaSize(smallMesa2ID, 0.03, 0.03);
		rmSetAreaWarnFailure(smallMesa2ID, false);
		rmSetAreaCliffType(smallMesa2ID, "Great Plains");
		rmAddAreaToClass(smallMesa2ID, rmClassID("canyon"));	
		// rmSetAreaCliffEdge(smallMesa2ID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(smallMesa2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa2ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaMinBlobs(smallMesa2ID, 1);
		rmSetAreaMaxBlobs(smallMesa2ID, 1);
		rmSetAreaMinBlobDistance(smallMesa2ID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesa2ID, 1.0);
		rmSetAreaCoherence(smallMesa2ID, 1.0);
		rmAddAreaConstraint(smallMesa2ID, avoidCloseNatives);
		rmSetAreaLocation(smallMesa2ID, 0.50, 0.20); 
	    rmBuildArea(smallMesa2ID);
		
		// DEFINE AND PLACE SMALL MESA NUMBER 3: 
		int smallCliff3Height=rmRandInt(0,10);
		int smallMesa3ID=rmCreateArea("small mesa 3");
		rmSetAreaSize(smallMesa3ID, 0.03, 0.03);
		rmSetAreaWarnFailure(smallMesa3ID, false);
		rmSetAreaCliffType(smallMesa3ID, "Great Plains");
		rmAddAreaToClass(smallMesa3ID, rmClassID("canyon"));	
		// rmSetAreaCliffEdge(smallMesa3ID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(smallMesa3ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa3ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaMinBlobs(smallMesa3ID, 1);
		rmSetAreaMaxBlobs(smallMesa3ID, 1);
		rmSetAreaMinBlobDistance(smallMesa3ID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesa3ID, 1.0);
		rmSetAreaCoherence(smallMesa3ID, 1.0);
		rmAddAreaConstraint(smallMesa3ID, avoidCloseNatives);
		rmSetAreaLocation(smallMesa3ID, 0.50, 0.80); 
	    rmBuildArea(smallMesa3ID);
		
		// DEFINE AND PLACE SMALL MESA NUMBER 4: 
		int smallCliff4Height=rmRandInt(0,10);
		int smallMesa4ID=rmCreateArea("small mesa 4");
		rmSetAreaSize(smallMesa4ID, 0.03, 0.03);
		rmSetAreaWarnFailure(smallMesa4ID, false);
		rmSetAreaCliffType(smallMesa4ID, "Great Plains");
		rmAddAreaToClass(smallMesa4ID, rmClassID("canyon"));	
		// rmSetAreaCliffEdge(smallMesa4ID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(smallMesa4ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa4ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaMinBlobs(smallMesa4ID, 1);
		rmSetAreaMaxBlobs(smallMesa4ID, 1);
		rmSetAreaMinBlobDistance(smallMesa4ID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesa4ID, 1.0);
		rmSetAreaCoherence(smallMesa4ID, 1.0);
		rmAddAreaConstraint(smallMesa4ID, avoidCloseNatives);
		rmSetAreaLocation(smallMesa4ID, 0.80, 0.50); 
	    rmBuildArea(smallMesa4ID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// *************************** DEFINE AND PLACE THE POND TO THE CENTER OF THE MAP: ****************************** //
/*================================================================================================================*/

        // DEFINE THE CENTRAL POND:
	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 20.0);
        int smallPondID=rmCreateArea("small pond");
	    
	
		rmSetAreaSize(smallPondID, rmAreaTilesToFraction(4500), rmAreaTilesToFraction(4500));
		// rmSetAreaWaterType(smallPondID, "great plains pond");
		   rmSetAreaWaterType(smallPondID, "great lakes");
		rmSetAreaBaseHeight(smallPondID, 4);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1.0);
		rmSetAreaMaxBlobDistance(smallPondID, 1.0);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.95);
		rmSetAreaSmoothDistance(smallPondID, 5);
		//rmAddAreaConstraint(smallPondID, playerConstraint);
		//rmAddAreaConstraint(smallPondID, avoidTradeRoute);
		//rmAddAreaConstraint(smallPondID, avoidImportantItem);
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.5, 0.5); 
		rmBuildArea(smallPondID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.51);
/*================================================================================================================*/
/*----------------------------------------------------------------------------------------------------------------*/		

        // PLACEMENT ORDER OF NON-TRADE ROUTE STUFF:
        // NATIVES -> SECRETS -> NUGGETS -> SMALL PONDS: (WHEE)

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.52);
/*================================================================================================================*/
// ****************************** DEFINE THE STARTING UNITS AND STARTING TCID: ********************************** //
/*================================================================================================================*/     
	
	    // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints(); // CLEAR FOR WATERFLAG PLACEMENT: 
		
		// DEFINE THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 7.0);
	    rmSetObjectDefMaxDistance(startingUnits, 12.0);

	    // DEFINE THE STARTING TCID:
		int startingTCID = rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 0.0);
	    rmAddObjectDefConstraint(startingTCID, avoidTradeRouteSmall);

	    //rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
		
/*================================================================================================================*/
// ************************************** DEFINE THE STARTING RESOURCES: **************************************** //
/*================================================================================================================*/
	    
		// DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeGreatPlains", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 12.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 18.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
		rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseGold);
		rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseFruits);

	    // DEFINE THE STARTING BISON:
		int StartBisonID=rmCreateObjectDef("starting bison");
	    rmAddObjectDefItem(StartBisonID, "Bison", 4, 4.0);
	    rmSetObjectDefMinDistance(StartBisonID, 10.0);
	    rmSetObjectDefMaxDistance(StartBisonID, 12.0);
	    rmSetObjectDefCreateHerd(StartBisonID, true);
	    rmAddObjectDefConstraint(StartBisonID, avoidStartingUnitsSmall);
		
		// DEFINE THE STARTING BERRYBUSH:
		int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", 4, 4.0);
	    rmSetObjectDefMinDistance(StartBerriesID, 0.0);
	    rmSetObjectDefMaxDistance(StartBerriesID, 0.0);
	    rmAddObjectDefConstraint(StartBerriesID, avoidFruits);
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, 0.775, 0.725);
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, 0.225, 0.175);
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, 0.775, 0.825);
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, 0.225, 0.275);
		
		// DEFINE THE STARTING GOLDMINES:
		int StartGoldID=rmCreateObjectDef("starting goldmines");
	    rmAddObjectDefItem(StartGoldID, "minegold", 1, 0.0);
	    rmSetObjectDefMinDistance(StartGoldID, 0.0);
	    rmSetObjectDefMaxDistance(StartGoldID, 0.0);
	    rmAddObjectDefConstraint(StartGoldID, avoidGold);
		rmPlaceObjectDefAtLoc(StartGoldID, 0, 0.725, 0.775);
		rmPlaceObjectDefAtLoc(StartGoldID, 0, 0.825, 0.775);
		rmPlaceObjectDefAtLoc(StartGoldID, 0, 0.175, 0.225);
		rmPlaceObjectDefAtLoc(StartGoldID, 0, 0.275, 0.225);
		
	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerNuggetID, 28.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	    rmAddObjectDefConstraint(playerNuggetID, avoidCloseFruits);
	    rmAddObjectDefConstraint(playerNuggetID, avoidCloseGold);
	    //rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);
	
/*	    // VARIABLE FOR THE PLAYER GOLD:
		int silverType = -1;
	    int playerGoldID = -1;
*/	

/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE WATER FLAG:
		int waterFlagID=rmCreateObjectDef("HC water flag "+i);
        rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
        //rmAddClosestPointConstraint(flagEdgeConstraint);
        rmAddClosestPointConstraint(flagVsFlag);
        rmAddClosestPointConstraint(flagLand);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.53);
/*================================================================================================================*/
// ********************** PLACE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************** //	
/*================================================================================================================*/

 	    for(i=1; <cNumberPlayers)
	{
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
	    vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
						
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
				
/*		
        // DEFINE THE PLAYER GOLD:
		// EVERYONE GETS TWO ORE OBJECTDEFS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		
		// PLACE THE TWO GOLD MINES:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));*/

		// PLACING STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING BISONS:
		rmPlaceObjectDefAtLoc(StartBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGET:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));


        // PLACE THE WATER FLAG:
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));

	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.54);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE NATIVE AMERICANS: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("cherokee"))
	{  
		int cherokee1VillageID = -1;
		cherokee1VillageID = rmCreateGrouping("cherokee village 1", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee1VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee1VillageID, 0.0);
		rmAddGroupingToClass(cherokee1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee1VillageID, 0, 0.65, 0.65);
	}     

/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv1 == rmGetCivID("cherokee"))
	{  
		int cherokee2VillageID = -1;
		cherokee2VillageID = rmCreateGrouping("cherokee village 2", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee2VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee2VillageID, 0.0);
		rmAddGroupingToClass(cherokee2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee2VillageID, 0, 0.35, 0.35);
	}  

/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv2 == rmGetCivID("cherokee"))
	{  
		int cherokee3VillageID = -1;
		cherokee3VillageID = rmCreateGrouping("cherokee village 3", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee3VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee3VillageID, 0.0);
		rmAddGroupingToClass(cherokee3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee3VillageID, 0, 0.35, 0.65);
	}  

/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv3 == rmGetCivID("cherokee"))
	{  
		int cherokee4VillageID = -1;
		cherokee4VillageID = rmCreateGrouping("cherokee village 4", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee4VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee4VillageID, 0.0);
		rmAddGroupingToClass(cherokee4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee4VillageID, 0, 0.65, 0.35);
	}     	  	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE NUGGETS ON THE MAP: *********************************** //
/*================================================================================================================*/
        
		// DEFINE AND PLACE NUGGETS NUMBER 1:
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		
		rmSetNuggetDifficulty(1, 3);
	    rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.17, 0.50);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.23, 0.50);
		
		rmSetNuggetDifficulty(1, 4);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.47, 0.20);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.53, 0.20);
		
		rmSetNuggetDifficulty(1, 2);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.47, 0.80);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.53, 0.80);
		
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.77, 0.50);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.83, 0.50);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE NUGGETS NUMBER 2:
		int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.30, 0.60);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.60, 0.30);

        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.40, 0.70);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.70, 0.40);

/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE NUGGETS NUMBER 3:
		int nugget3ID= rmCreateObjectDef("nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.30, 0.40);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.40, 0.30);

        rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.60, 0.70);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.70, 0.60);

/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE NUGGETS NUMBER 4:
		int nugget4ID= rmCreateObjectDef("nugget 4"); 
	    rmAddObjectDefItem(nugget4ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget4ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget4ID, 0.0);
	    rmAddObjectDefConstraint(nugget4ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.125, 0.775);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.775, 0.125);

        rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.225, 0.875);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.875, 0.225);	

/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE NUGGETS NUMBER 5:
		int nugget5ID= rmCreateObjectDef("nugget 5"); 
	    rmAddObjectDefItem(nugget5ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget5ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget5ID, 0.0);
	    rmAddObjectDefConstraint(nugget5ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.10, 0.40);
		rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.40, 0.10);

        rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.60, 0.90);
		rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.90, 0.60);				
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE GOLD MINES ON THE MAP: ********************************* //
/*================================================================================================================*/

		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.20, 0.50);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.50, 0.20);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.50, 0.80);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.80, 0.50);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int gold2ID = rmCreateObjectDef("gold 2");
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.26, 0.74);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.74, 0.26);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int gold3ID = rmCreateObjectDef("gold 3");
		rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
		rmSetObjectDefMaxDistance(gold3ID, 0.0);
		rmAddObjectDefConstraint(gold3ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.080, 0.725);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.725, 0.080);
		
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.275, 0.915);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.915, 0.275);	

/*----------------------------------------------------------------------------------------------------------------*/

        int gold4ID = rmCreateObjectDef("gold 4");
		rmAddObjectDefItem(gold4ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold4ID, 0.0);
		rmSetObjectDefMaxDistance(gold4ID, 0.0);
		rmAddObjectDefConstraint(gold4ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.05, 0.45);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.45, 0.05);
		
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.55, 0.95);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.95, 0.55);			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //
/*================================================================================================================*/
        
		int berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.80, 0.53);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.20, 0.53);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.50, 0.23);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.50, 0.83);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int berries2ID = rmCreateObjectDef("The Berries 2");
		rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.50, 0.675);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.675, 0.50);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.325, 0.50);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.50, 0.325);	

/*----------------------------------------------------------------------------------------------------------------*/
        
		int berries3ID = rmCreateObjectDef("The Berries 3");
		rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries3ID, 0.0);
		rmSetObjectDefMaxDistance(berries3ID, 0.0);
		rmAddObjectDefConstraint(berries3ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.125, 0.225);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.225, 0.125);
		
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.775, 0.875);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.875, 0.775);	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE DEER: ****************************************** //
/*================================================================================================================*/ 
	   
        int deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(deer1ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.50, 0.77);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.80, 0.47);
		
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.50, 0.17);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.20, 0.47);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE BISONS: **************************************** //
/*================================================================================================================*/ 
	   
        int bison1ID=rmCreateObjectDef("The Bison Herds 1");
        rmAddObjectDefItem(bison1ID, "bison", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(bison1ID, 0.0);
        rmSetObjectDefMaxDistance(bison1ID, 0.0);
	    rmAddObjectDefConstraint(bison1ID, avoidBison);
		rmSetObjectDefCreateHerd(bison1ID, true);
	    
		rmPlaceObjectDefAtLoc(bison1ID, 0, 0.30, 0.70);
		rmPlaceObjectDefAtLoc(bison1ID, 0, 0.70, 0.30);
		
		//rmPlaceObjectDefAtLoc(bison1ID, 0, 0.50, 0.17);
		//rmPlaceObjectDefAtLoc(bison1ID, 0, 0.20, 0.47);

/*----------------------------------------------------------------------------------------------------------------*/

        int bison2ID=rmCreateObjectDef("The Bison Herds 2");
        rmAddObjectDefItem(bison2ID, "bison", rmRandInt(9,15), 8.0);
        rmSetObjectDefMinDistance(bison2ID, 0.0);
        rmSetObjectDefMaxDistance(bison2ID, 0.0);
	    rmAddObjectDefConstraint(bison2ID, avoidBison);
		rmSetObjectDefCreateHerd(bison2ID, true);
	    
		rmPlaceObjectDefAtLoc(bison2ID, 0, 0.15, 0.35);
		rmPlaceObjectDefAtLoc(bison2ID, 0, 0.35, 0.15);
		
		rmPlaceObjectDefAtLoc(bison2ID, 0, 0.65, 0.85);
		rmPlaceObjectDefAtLoc(bison2ID, 0, 0.85, 0.65);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE TREES: **************************************** //
/*================================================================================================================*/
		
		int trees1ID = rmCreateObjectDef("The Trees 1");
		rmAddObjectDefItem(trees1ID, "TreeGreatPlains", rmRandInt(5,7), 5.0);
		rmSetObjectDefMinDistance(trees1ID, 0.0);
		rmSetObjectDefMaxDistance(trees1ID, 0.0);
		rmAddObjectDefConstraint(trees1ID, avoidCloseTree);
		
		rmPlaceObjectDefAtLoc(trees1ID, 0, 0.17, 0.53);
		rmPlaceObjectDefAtLoc(trees1ID, 0, 0.23, 0.53);
		rmPlaceObjectDefAtLoc(trees1ID, 0, 0.17, 0.47);
		rmPlaceObjectDefAtLoc(trees1ID, 0, 0.23, 0.47);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
        int trees2ID = rmCreateObjectDef("The Trees 2");
		rmAddObjectDefItem(trees2ID, "TreeGreatPlains", rmRandInt(5,7), 5.0);
		rmSetObjectDefMinDistance(trees2ID, 0.0);
		rmSetObjectDefMaxDistance(trees2ID, 0.0);
		rmAddObjectDefConstraint(trees2ID, avoidCloseTree);
		
		rmPlaceObjectDefAtLoc(trees2ID, 0, 0.47, 0.23);
		rmPlaceObjectDefAtLoc(trees2ID, 0, 0.53, 0.23);
		rmPlaceObjectDefAtLoc(trees2ID, 0, 0.47, 0.17);
		rmPlaceObjectDefAtLoc(trees2ID, 0, 0.53, 0.17);	

/*----------------------------------------------------------------------------------------------------------------*/

        int trees3ID = rmCreateObjectDef("The Trees 3");
		rmAddObjectDefItem(trees3ID, "TreeGreatPlains", rmRandInt(5,7), 5.0);
		rmSetObjectDefMinDistance(trees3ID, 0.0);
		rmSetObjectDefMaxDistance(trees3ID, 0.0);
		rmAddObjectDefConstraint(trees3ID, avoidCloseTree);
		
		rmPlaceObjectDefAtLoc(trees3ID, 0, 0.47, 0.83);
		rmPlaceObjectDefAtLoc(trees3ID, 0, 0.53, 0.83);
		rmPlaceObjectDefAtLoc(trees3ID, 0, 0.47, 0.77);
		rmPlaceObjectDefAtLoc(trees3ID, 0, 0.53, 0.77);			
		
/*----------------------------------------------------------------------------------------------------------------*/

        int trees4ID = rmCreateObjectDef("The Trees 4");
		rmAddObjectDefItem(trees4ID, "TreeGreatPlains", rmRandInt(5,7), 5.0);
		rmSetObjectDefMinDistance(trees4ID, 0.0);
		rmSetObjectDefMaxDistance(trees4ID, 0.0);
		rmAddObjectDefConstraint(trees4ID, avoidCloseTree);
		
		rmPlaceObjectDefAtLoc(trees4ID, 0, 0.77, 0.53);
		rmPlaceObjectDefAtLoc(trees4ID, 0, 0.83, 0.53);
		rmPlaceObjectDefAtLoc(trees4ID, 0, 0.77, 0.47);
		rmPlaceObjectDefAtLoc(trees4ID, 0, 0.83, 0.47);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// **************************** DEFINE THE PERCHING VULTURES - ADD A COUPLE SOMEWHERE: ************************** //
/*================================================================================================================*/

	    int vultureID=rmCreateObjectDef("perching vultures");
	    rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, 0.0);
	    rmAddObjectDefConstraint(vultureID, avoidVulture);
	    
	    rmPlaceObjectDefAtLoc(vultureID, 0, 0.40, 0.90);
        rmPlaceObjectDefAtLoc(vultureID, 0, 0.90, 0.40);
        
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.10, 0.60);
        rmPlaceObjectDefAtLoc(vultureID, 0, 0.60, 0.10);

        rmPlaceObjectDefAtLoc(vultureID, 0, 0.30, 0.30);
        rmPlaceObjectDefAtLoc(vultureID, 0, 0.70, 0.70);
		
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE A COUPLE OF GEYSERS: ************************************* //
/*================================================================================================================*/

   	    int geyserID=rmCreateGrouping("Geysers", "prop_geyser");
	    rmSetGroupingMinDistance(geyserID, 0.0);
	    rmSetGroupingMaxDistance(geyserID, 0.0);
	    //rmAddGroupingConstraint(geyserID, avoidGeyser);
	    
	    rmPlaceGroupingAtLoc(geyserID, 0, 0.025, 0.525);
        rmPlaceGroupingAtLoc(geyserID, 0, 0.525, 0.025);
        rmPlaceGroupingAtLoc(geyserID, 0, 0.325, 0.825);
        rmPlaceGroupingAtLoc(geyserID, 0, 0.825, 0.325);		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/		
// ************************************** DEFINE AND PLACE THE FORESTS: ***************************************** //
/*================================================================================================================*/

        int forestTreeID = 0;
        int numTries=8*cNumberNonGaiaPlayers;
        int failCount=0;
        
		for (i=0; <numTries)
   {   
		int forest=rmCreateArea("The Forest 1 "+i);
		rmSetAreaWarnFailure(forest, false);
		rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
		rmSetAreaForestType(forest, "great plains forest");
		rmSetAreaForestDensity(forest, 0.9);
		rmSetAreaForestClumpiness(forest, 0.8);
		rmSetAreaForestUnderbrush(forest, 0.0);
		rmSetAreaCoherence(forest, 0.5);
		rmAddAreaToClass(forest, rmClassID("classForest")); 
		rmAddAreaConstraint(forest, forestConstraint);
		rmAddAreaConstraint(forest, playerConstraint);
		rmAddAreaConstraint(forest, avoidImportantItem);
		rmAddAreaConstraint(forest, avoidImpassableLand); 
		rmAddAreaConstraint(forest, avoidTradeRoute);
		rmAddAreaConstraint(forest, avoidSocket);
		rmAddAreaConstraint(forest, avoidRegion);
		rmAddAreaConstraint(forest, avoidAll);
		rmAddAreaConstraint(forest, Northward);
		rmAddAreaConstraint(forest, avoidCloseNugget);
		rmAddAreaConstraint(forest, avoidCloseGold);
		rmAddAreaConstraint(forest, avoidCloseNatives);
		rmAddAreaConstraint(forest, avoidStartingUnits);
		if(rmBuildArea(forest)==false)
		{
		// STOP TRYING ONCE WE FAIL 10 TIMES IN A ROW:
		failCount++;
		if(failCount==10)
		break;
		}
		else
		failCount=0; 
   }	

/*----------------------------------------------------------------------------------------------------------------*/

        for (i=0; <numTries)
   {   
		int forest2=rmCreateArea("The Forest 2 "+i);
		rmSetAreaWarnFailure(forest2, false);
		rmSetAreaSize(forest2, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
		rmSetAreaForestType(forest2, "great plains forest");
		rmSetAreaForestDensity(forest2, 0.9);
		rmSetAreaForestClumpiness(forest2, 0.8);
		rmSetAreaForestUnderbrush(forest2, 0.0);
		rmSetAreaCoherence(forest2, 0.5);
		rmAddAreaToClass(forest2, rmClassID("classForest")); 
		rmAddAreaConstraint(forest2, forestConstraint);
		rmAddAreaConstraint(forest2, playerConstraint);
		rmAddAreaConstraint(forest2, avoidImportantItem);
		rmAddAreaConstraint(forest2, avoidImpassableLand); 
		rmAddAreaConstraint(forest2, avoidTradeRoute);
		rmAddAreaConstraint(forest2, avoidSocket);
		rmAddAreaConstraint(forest2, avoidRegion);
		rmAddAreaConstraint(forest2, avoidAll);
		rmAddAreaConstraint(forest2, Southward);
		rmAddAreaConstraint(forest2, avoidCloseNugget);
		rmAddAreaConstraint(forest2, avoidCloseGold);
		rmAddAreaConstraint(forest2, avoidCloseNatives);
		rmAddAreaConstraint(forest2, avoidStartingUnits);
		if(rmBuildArea(forest2)==false)
		{
		// STOP TRYING ONCE WE FAIL 10 TIMES IN A ROW:
		failCount++;
		if(failCount==10)
		break;
		}
		else
		failCount=0; 
   }	   
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //
/*================================================================================================================*/
		
        // DEFINE AND PLACE THE FISHES: 
		int fish1ID=rmCreateObjectDef("fish 1");
        rmAddObjectDefItem(fish1ID, "FishBass", 2, 5.0);
        rmSetObjectDefMinDistance(fish1ID, 0.0);
        rmSetObjectDefMaxDistance(fish1ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish1ID, fishVsFishID);
        rmAddObjectDefConstraint(fish1ID, fishLand);
        rmPlaceObjectDefAtLoc(fish1ID, 0, 0.5, 0.5,15*cNumberNonGaiaPlayers);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ****************************************** // 
/*================================================================================================================*/



























