/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// THE WILD WEST:
// CREATED BY DANY:
// FEBRUARY 2007:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs"; 
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
        int subCiv4=-1;
/*----------------------------------------------------------------------------------------------------------------*/
        if (rmAllocateSubCivs(5) == true)
   {
		subCiv0=rmGetCivID("Cherokee");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cherokee");

		subCiv1=rmGetCivID("Cherokee");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cherokee"); 

		subCiv2=rmGetCivID("Cherokee");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Cherokee");

		subCiv3=rmGetCivID("Cherokee");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Cherokee");

		subCiv4=rmGetCivID("Cherokee");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Cherokee");
   }	
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
	    int playerTiles=25000;
   
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(0.0);

        // SET MAP ELEVATION PARAMETERS:
	    rmSetMapElevationParameters(cElevTurbulence, 0.02, 7, 0.5, 8.0);
	    
		// PICKS THE DEFAULT TERRAIN:
		rmSetBaseTerrainMix("great plains drygrass");
	    
		// SET THE TERRAIN INITIALIZATION:
		rmTerrainInitialize("yukon\ground1_yuk", 5);
	    
		// SET THE LIGHTING:
		rmSetLightingSet("great plains");
	    
		// SET MAP TYPE:
		rmSetMapType("greatPlains");
	    rmSetMapType("land");
	    rmSetMapType("grass");
		
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("natives");	
	    rmDefineClass("socketClass");
	    rmDefineClass("nuggets");
		rmDefineClass("classCliff");
		rmDefineClass("bay");
		rmDefineClass("regions");
		rmDefineClass("regions2");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*================================================================================================================*/
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);

        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 10.0);
		
		// REGION AVOIDANCE:
		int regionConstraint=rmCreateClassDistanceConstraint("region avoid region", rmClassID("regions"), 20.0);
        int avoidRegion=rmCreateClassDistanceConstraint("stuff avoid region", rmClassID("regions"), 10.0);
		int region2Constraint=rmCreateClassDistanceConstraint("region2 avoid region2", rmClassID("regions2"), 20.0);
        int avoidRegion2=rmCreateClassDistanceConstraint("stuff avoid region2", rmClassID("regions2"), 10.0);
   
        // SEAFOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 15.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
   		
		// FOREST AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 25.0);
        
        // AVOID START RESOURCE:
		int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
   	
		// BISON AVOIDANCE:
		int avoidBison=rmCreateTypeDistanceConstraint("bison avoids food", "bison", 40.0);
        
		// PRONGHORN AVOIDANCE:
		int avoidPronghorn=rmCreateTypeDistanceConstraint("pronghorn avoids food", "pronghorn", 35.0);
	    
		// COIN AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("stuffs avoids coin", "mine", 15.0);
		int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "mine", 25.0);
	    int avoidStartingCoin=rmCreateTypeDistanceConstraint("starting coin avoids coin", "mine", 22.0);
		
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("stuffs avoid nugget", "AbstractNugget", 10.0);
		int nuggetAvoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 20.0);
        int avoidPlayerNugget=rmCreateTypeDistanceConstraint("player nugget avoid nugget", "AbstractNugget", 20.0);
  				
		// FRUIT AVOIDANCE:
	    int avoidFruit=rmCreateTypeDistanceConstraint("stuff avoids fruit", "berrybush", 5.0);
	    int fruitAvoidFruit=rmCreateTypeDistanceConstraint("fruit avoids fruit", "berrybush", 10.0);
		
		// DEER AVOIDANCE:
	    int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 15.0);
	    int deerAvoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 25.0);
		
		// SHEEP AVOIDANCE:
	    int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 10.0);
	    int sheepAvoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 20.0);
		
		
		// AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
       
	   // UNIT AVOIDANCE: - FOR THINGS THAT AREN'T IN THE STARTING RESOURCES:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

        // VP avoidance
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
                
		// AVOID IMPORTANT ITEM:
		int avoidImportantItem=rmCreateClassDistanceConstraint("important stuff avoids each other", rmClassID("importantItem"), 15.0);
        int avoidImportantItemSmall=rmCreateClassDistanceConstraint("important stuff avoids each other closely", rmClassID("importantItem"), 8.0);

		
		// AVOID SOCKET:
		int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);
	    
		 // CONSTRAINT TO AVOID WATER:
        int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
        int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
        int avoidWater40 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 40.0);

	    // NATIVES AVOIDANCE:
		int avoidNatives = rmCreateClassDistanceConstraint("stuff avoid Natives", rmClassID("natives"), 10.0);
	    int avoidNativesFar = rmCreateClassDistanceConstraint("stuff avoid Natives Far", rmClassID("natives"), 20.0);
	    
	    // CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************************* DEFINE THE TRADE ROUTE PLACEMENT: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	  int tradeRouteID = rmCreateTradeRoute();
      int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRouteID, 0.8, 0.5);
	  //rmAddTradeRouteWaypoint(tradeRouteID, 0.9, 0.4);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.8, 0.2);
	  //rmAddTradeRouteWaypoint(tradeRouteID, 0.6, 0.1);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.2);
	  //rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.2, 0.3, 10, 4);

      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

     // socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.25);
     // rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	 // socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.75);
      //rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 1.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ********************************************* DEFINE THE AREAS: ********************************************** //
/*================================================================================================================*/
        // 1: SET UP PLAYER STARTING LOCATIONS:
        // 2: SET UP PLAYER AREAS:		
/*================================================================================================================*/
// ************************************ 1: SET UP PLAYER STARTING LOCATIONS: ************************************ //
/*================================================================================================================*/
          //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(0);
		  
          //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(1,0.75,0.75);

          //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(1);
		  
          //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(2,0.250,0.250);
/*================================================================================================================*/
// ****************************************** 2: SET UP PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
        // FLOAT PLAYER FRACTION:
		float playerFraction=rmAreaTilesToFraction(100);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        // ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        // SET AREA MIN BLOBS:
		rmSetAreaMinBlobs(id, 1);
        // SET AREA MAX BLOBS:
		rmSetAreaMaxBlobs(id, 1);
        // ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
	    // SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        // SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD ALL THE AREAS:
        rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ****************************************** DEFINE SOME AREAS: ************************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE REGION E1: **************************************** //
/*================================================================================================================*/
        int smallRegionE1ID=rmCreateArea("Small Region E1");
        //rmSetAreaSize(smallRegionE1ID, 0.41, 0.42);	
        rmSetAreaSize(smallRegionE1ID, 0.02, 0.02);			
        rmSetAreaSmoothDistance(smallRegionE1ID, 40);
		rmAddAreaToClass(smallRegionE1ID, rmClassID("regions"));
        rmAddAreaConstraint(smallRegionE1ID, regionConstraint);
        rmSetAreaMix(smallRegionE1ID, "great plains grass");
        rmSetAreaElevationType(smallRegionE1ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallRegionE1ID, 2.0);
        //rmSetAreaBaseHeight(smallRegionE1ID, 1.0);
		rmSetAreaBaseHeight(smallRegionE1ID, 5.0);
        rmSetAreaElevationMinFrequency(smallRegionE1ID, 0.09);
        rmSetAreaElevationOctaves(smallRegionE1ID, 3);
        rmSetAreaElevationPersistence(smallRegionE1ID, 0.5); 
        rmSetAreaCoherence(smallRegionE1ID, 0.65);
		rmSetAreaLocation(smallRegionE1ID, 0.10, 0.40);
		rmSetAreaObeyWorldCircleConstraint(smallRegionE1ID, false);//( it put the island near the edge of the map )
        rmBuildArea(smallRegionE1ID);   
/*================================================================================================================*/ 
// ************************************* DEFINE AND PLACE THE REGION E2: **************************************** //
/*================================================================================================================*/
        int smallRegionE2ID=rmCreateArea("Small Region E2");
        //rmSetAreaSize(smallRegionE2ID, 0.41, 0.42);	
        rmSetAreaSize(smallRegionE2ID, 0.02, 0.02);			
        rmSetAreaSmoothDistance(smallRegionE2ID, 40);
		rmAddAreaToClass(smallRegionE2ID, rmClassID("regions"));
        rmAddAreaConstraint(smallRegionE2ID, regionConstraint);
        rmSetAreaMix(smallRegionE2ID, "great plains grass");
        rmSetAreaElevationType(smallRegionE2ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallRegionE2ID, 2.0);
        //rmSetAreaBaseHeight(smallRegionE2ID, 1.0);
		rmSetAreaBaseHeight(smallRegionE2ID, 5.0);
        rmSetAreaElevationMinFrequency(smallRegionE2ID, 0.09);
        rmSetAreaElevationOctaves(smallRegionE2ID, 3);
        rmSetAreaElevationPersistence(smallRegionE2ID, 0.5); 
        rmSetAreaCoherence(smallRegionE2ID, 0.65);
		rmSetAreaLocation(smallRegionE2ID, 0.40, 0.10);
		rmSetAreaObeyWorldCircleConstraint(smallRegionE2ID, false);//( it put the island near the edge of the map )
        rmBuildArea(smallRegionE2ID);
/*================================================================================================================*/		
// ************************************* DEFINE AND PLACE THE REGION E3: **************************************** //
/*================================================================================================================*/
        int smallRegionE3ID=rmCreateArea("Small Region E3");
        //rmSetAreaSize(smallRegionE3ID, 0.41, 0.42);	
        rmSetAreaSize(smallRegionE3ID, 0.02, 0.02);			
        rmSetAreaSmoothDistance(smallRegionE3ID, 40);
		rmAddAreaToClass(smallRegionE3ID, rmClassID("regions"));
        rmAddAreaConstraint(smallRegionE3ID, regionConstraint);
        rmSetAreaMix(smallRegionE3ID, "great plains grass");
        rmSetAreaElevationType(smallRegionE3ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallRegionE3ID, 2.0);
        //rmSetAreaBaseHeight(smallRegion3ID, 1.0);
		rmSetAreaBaseHeight(smallRegionE3ID, 5.0);
        rmSetAreaElevationMinFrequency(smallRegionE3ID, 0.09);
        rmSetAreaElevationOctaves(smallRegionE3ID, 3);
        rmSetAreaElevationPersistence(smallRegionE3ID, 0.5); 
        rmSetAreaCoherence(smallRegionE3ID, 0.65);
		rmSetAreaLocation(smallRegionE3ID, 0.6, 0.9);
		rmSetAreaObeyWorldCircleConstraint(smallRegionE3ID, false);//( it put the island near the edge of the map )
        rmBuildArea(smallRegionE3ID);	
/*================================================================================================================*/		
// ************************************* DEFINE AND PLACE THE REGION E4: **************************************** //
/*================================================================================================================*/
        int smallRegionE4ID=rmCreateArea("Small Region E4");
        //rmSetAreaSize(smallRegionE4ID, 0.41, 0.42);	
        rmSetAreaSize(smallRegionE4ID, 0.02, 0.02);			
        rmSetAreaSmoothDistance(smallRegionE4ID, 40);
		rmAddAreaToClass(smallRegionE4ID, rmClassID("regions"));
        rmAddAreaConstraint(smallRegionE4ID, regionConstraint);
        rmSetAreaMix(smallRegionE4ID, "great plains grass");
        rmSetAreaElevationType(smallRegionE4ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallRegionE4ID, 2.0);
        //rmSetAreaBaseHeight(smallRegionE4ID, 1.0);
		rmSetAreaBaseHeight(smallRegionE4ID, 5.0);
        rmSetAreaElevationMinFrequency(smallRegionE4ID, 0.09);
        rmSetAreaElevationOctaves(smallRegionE4ID, 3);
        rmSetAreaElevationPersistence(smallRegionE4ID, 0.5); 
        rmSetAreaCoherence(smallRegionE4ID, 0.65);
		rmSetAreaLocation(smallRegionE4ID, 0.9, 0.6);
		rmSetAreaObeyWorldCircleConstraint(smallRegionE4ID, false);//( it put the island near the edge of the map )
        rmBuildArea(smallRegionE4ID);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE REGION CENTER: *************************************** //
/*================================================================================================================*/
        int centerRegionID=rmCreateArea("The Center Region");
        //rmSetAreaSize(centerRegionID, 0.41, 0.42);	
        rmSetAreaSize(centerRegionID, 0.05, 0.05);			
        rmSetAreaSmoothDistance(centerRegionID, 40);
		rmAddAreaToClass(centerRegionID, rmClassID("regions2"));
        rmAddAreaConstraint(centerRegionID, avoidRegion2);
		rmAddAreaConstraint(centerRegionID, region2Constraint);
        rmSetAreaMix(centerRegionID, "great plains grass");
        rmSetAreaElevationType(centerRegionID, cElevTurbulence);
        rmSetAreaElevationVariation(centerRegionID, 2.0);
        //rmSetAreaBaseHeight(centerRegionID, 1.0);
		rmSetAreaBaseHeight(centerRegionID, 6.0);
        rmSetAreaElevationMinFrequency(centerRegionID, 0.09);
        rmSetAreaElevationOctaves(centerRegionID, 3);
        rmSetAreaElevationPersistence(centerRegionID, 0.5); 
        rmSetAreaCoherence(centerRegionID, 0.65);
		rmSetAreaLocation(centerRegionID, 0.60, 0.40);
		rmSetAreaObeyWorldCircleConstraint(centerRegionID, false);//( it put the island near the edge of the map )
        //rmBuildArea(centerRegionID);
        rmBuildArea(centerRegionID);		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
   // PLACEMENT ORDER OF NON-TRADE ROUTE STUFF:
   // NATIVES -> SECRETS -> NUGGETS -> SMALL PONDS (WHEE)
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ********************************* DEFINE THE STARTING TCID AND STARTING UNITS: ******************************* //
/*================================================================================================================*/
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
    rmSetObjectDefMinDistance(startingUnits, 5.0);
    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(startingUnits, avoidAll);

	int startingTCID= rmCreateObjectDef("startingTC");
	if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit")); 
/*================================================================================================================*/
// ************************************* DEFINE THE STARTING BERRYBUSH: ***************************************** //
/*================================================================================================================*/
	int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	rmAddObjectDefItem(StartBerryBushID, "BerryBush", 2, 4.0);
	rmSetObjectDefMinDistance(StartBerryBushID, 12.0);
	rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
	rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
	rmAddObjectDefConstraint(StartBerryBushID, avoidStartResource);
/*================================================================================================================*/
// *************************************** DEFINE THE STARTING RESOURCES: *************************************** //
/*================================================================================================================*/
	int StartAreaTreeID=rmCreateObjectDef("starting trees");
	//rmAddObjectDefItem(StartAreaTreeID, "TreeTexasDirt", 1, 0.0);
	rmAddObjectDefItem(StartAreaTreeID, "TreeGreatPlains", 1, 0.0);
	rmSetObjectDefMinDistance(StartAreaTreeID, 8);
	rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
/*================================================================================================================*/	
// ************************************** DEFINE THE STARTING PRONGHORN: **************************************** //
/*================================================================================================================*/
    int StartPronghornID=rmCreateObjectDef("starting pronghorn");
	rmAddObjectDefItem(StartPronghornID, "pronghorn", rmRandInt(6,9), 10.0);
	rmSetObjectDefCreateHerd(StartPronghornID, true);
	rmSetObjectDefMinDistance(StartPronghornID, 5);
	rmSetObjectDefMaxDistance(StartPronghornID, 12);
	rmAddObjectDefConstraint(StartPronghornID, avoidStartResource);
	rmAddObjectDefConstraint(StartPronghornID, avoidStartingUnitsSmall);
/*================================================================================================================*/
// ***************************************** DEFINE THE PLAYER NUGGET: ****************************************** //
/*================================================================================================================*/	
    int playerNuggetID=rmCreateObjectDef("player nugget");
	rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
    rmSetObjectDefMinDistance(playerNuggetID, 30.0);
    rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartResource);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnits);
	rmAddObjectDefConstraint(playerNuggetID, avoidPlayerNugget);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ******************************* PLACE THE STARTING TCID AND THE STARTING UNITS: ****************************** //
/*================================================================================================================*/
        int silverType = -1;
	    int playerGoldID = -1;

 	    for(i=1; <cNumberPlayers)
	{	
		// PLACING THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerryBushID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING PRONGHORN:
		rmPlaceObjectDefAtLoc(StartPronghornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING PLAYER NUGGET:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// EVERYONE GETS TWO ORE GROUPINGS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefConstraint(playerGoldID, avoidStartResource);
		rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnits);
		rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
		rmSetObjectDefMinDistance(playerGoldID, 25.0);
		rmSetObjectDefMaxDistance(playerGoldID, 30.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver further "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefConstraint(playerGoldID, avoidStartResource);
		rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnits);
		rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
		rmSetObjectDefMinDistance(playerGoldID, 40.0);
		rmSetObjectDefMaxDistance(playerGoldID, 50.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}
/*================================================================================================================*/
        // Text
	    int numTries = -1;
	    int failCount = -1;	
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE SMALL POND: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv0 == rmGetCivID("cherokee"))
	{  
		int cherokee1VillageID = -1;
		cherokee1VillageID = rmCreateGrouping("cherokee village 1", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee1VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee1VillageID, 0.0);
		//rmAddGroupingConstraint(cherokee1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokee1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee1VillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokee1VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cherokee1VillageID, 0, 0.45, 0.85);
	} 

	    if (subCiv1 == rmGetCivID("cherokee"))
	{  
		int cherokee2VillageID = -1;
		cherokee2VillageID = rmCreateGrouping("cherokee village 2", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee2VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee2VillageID, 0.0);
		//rmAddGroupingConstraint(cherokee2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokee2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee2VillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokee2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cherokee2VillageID, 0, 0.15, 0.55);
	} 

	    if (subCiv2 == rmGetCivID("cherokee"))
	{  
		int cherokee3VillageID = -1;
		cherokee3VillageID = rmCreateGrouping("cherokee village 3", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee3VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee3VillageID, 0.0);
		//rmAddGroupingConstraint(cherokee3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokee3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee3VillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokee3VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cherokee3VillageID, 0, 0.4, 0.6);
	}

	    if (subCiv3 == rmGetCivID("cherokee"))
	{  
		int cherokee4VillageID = -1;
		cherokee4VillageID = rmCreateGrouping("cherokee village 4", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee4VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee4VillageID, 0.0);
		//rmAddGroupingConstraint(cherokee4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokee4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee4VillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokee4VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cherokee4VillageID, 0, 0.9, 0.4);
	} 
	
	    if (subCiv4 == rmGetCivID("cherokee"))
	{  
		int cherokee5VillageID = -1;
		cherokee5VillageID = rmCreateGrouping("cherokee village 5", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee5VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee5VillageID, 0.0);
		//rmAddGroupingConstraint(cherokee5VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokee5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee5VillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokee5VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cherokee5VillageID, 0, 0.6, 0.1);
	} 
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ************************************** DEFINE AND CREATE AN AREA BAY: **************************************** //
/*================================================================================================================*/
        int bay1ID=rmCreateArea("Bay 1");
        rmSetAreaSize(bay1ID, 0.1, 0.1);
	    rmSetAreaLocation(bay1ID, 0.0, 1.0);
	    rmSetAreaWaterType(bay1ID, "hudson bay");
        rmSetAreaBaseHeight(bay1ID, 1.0); // Was 10
        rmSetAreaMinBlobs(bay1ID, 1);
        rmSetAreaMaxBlobs(bay1ID, 1);
        rmSetAreaMinBlobDistance(bay1ID, 1);
        rmSetAreaMaxBlobDistance(bay1ID, 1);
        rmSetAreaSmoothDistance(bay1ID, 50);
        rmSetAreaCoherence(bay1ID, 0.4);
	    rmAddAreaToClass(bay1ID, rmClassID("bay"));
		rmAddAreaInfluencePoint(bay1ID, 0.2, 0.8);
		rmSetAreaObeyWorldCircleConstraint(bay1ID, false);
		rmAddAreaConstraint(bay1ID, avoidNativesFar);
		rmAddAreaConstraint(bay1ID, avoidCoin);
	    rmBuildArea(bay1ID);
		   
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE NUGGETS: ***************************************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int Nugget1ID=rmCreateObjectDef("The nugget 1");
        rmAddObjectDefItem(Nugget1ID, "nugget", 1, 0.0);
        rmAddObjectDefToClass(Nugget1ID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(Nugget1ID, 0.0);
        rmSetObjectDefMaxDistance(Nugget1ID, 0.0);
        rmAddObjectDefConstraint(Nugget1ID, avoidNugget);
        rmAddObjectDefConstraint(Nugget1ID, nuggetAvoidNugget);
        rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.35, 0.55);
	    rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.45, 0.65);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.25, 0.5);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.5, 0.75);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.10, 0.5);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.5, 0.9);
	    
		int Nugget2ID=rmCreateObjectDef("The nugget 2");
        rmAddObjectDefItem(Nugget2ID, "nugget", 1, 0.0);
        rmAddObjectDefToClass(Nugget2ID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(Nugget2ID, 0.0);
        rmSetObjectDefMaxDistance(Nugget2ID, 0.0);
        rmAddObjectDefConstraint(Nugget2ID, avoidNugget);
        rmAddObjectDefConstraint(Nugget2ID, nuggetAvoidNugget);
        rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.55, 0.05);
	    rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.675, 0.07);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.75, 0.15);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.85, 0.25);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.95, 0.35);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.95, 0.5);
	    
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE GOLD MINES: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    int CoinsID=rmCreateObjectDef("The Coins");
    rmAddObjectDefItem(CoinsID, "mine", 1, 0.0);
    rmSetObjectDefMinDistance(CoinsID, 0.0);
    rmSetObjectDefMaxDistance(CoinsID, 0.0);
    rmAddObjectDefConstraint(CoinsID, avoidCoin);
    rmAddObjectDefConstraint(CoinsID, coinAvoidCoin);
    rmPlaceObjectDefAtLoc(CoinsID, 0, 0.05, 0.55);
	rmPlaceObjectDefAtLoc(CoinsID, 0, 0.25, 0.55);
	rmPlaceObjectDefAtLoc(CoinsID, 0, 0.45, 0.75);
	rmPlaceObjectDefAtLoc(CoinsID, 0, 0.45, 0.95);
	
	int Coins2ID=rmCreateObjectDef("The Coins 2");
    rmAddObjectDefItem(Coins2ID, "mine", 1, 0.0);
    rmSetObjectDefMinDistance(Coins2ID, 0.0);
    rmSetObjectDefMaxDistance(Coins2ID, 0.0);
    rmAddObjectDefConstraint(Coins2ID, avoidCoin);
    rmAddObjectDefConstraint(Coins2ID, coinAvoidCoin);
    rmPlaceObjectDefAtLoc(Coins2ID, 0, 0.5, 0.05);
	rmPlaceObjectDefAtLoc(Coins2ID, 0, 0.7, 0.1);
	rmPlaceObjectDefAtLoc(Coins2ID, 0, 0.9, 0.3);
	rmPlaceObjectDefAtLoc(Coins2ID, 0, 0.95, 0.45);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE BERRIES: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	    int Berries1ID=rmCreateObjectDef("The Berries 1");
        rmAddObjectDefItem(Berries1ID, "berrybush", rmRandInt(3,5), 4.0);
        rmSetObjectDefMinDistance(Berries1ID, 0.0);
        rmSetObjectDefMaxDistance(Berries1ID, 0.0);
        rmAddObjectDefConstraint(Berries1ID, avoidFruit);
        rmAddObjectDefConstraint(Berries1ID, fruitAvoidFruit);
        rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.1, 0.3);
        rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.3, 0.1);	
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.7, 0.9);	
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.9, 0.7);	
		
		int Berries2ID=rmCreateObjectDef("The Berries 2");
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,5), 4.0);
        rmSetObjectDefMinDistance(Berries2ID, 0.0);
        rmSetObjectDefMaxDistance(Berries2ID, 0.0);
        rmAddObjectDefConstraint(Berries2ID, avoidFruit);
        rmAddObjectDefConstraint(Berries2ID, fruitAvoidFruit);
        rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.20, 0.50);
        rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.45, 0.55);	
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.55, 0.80);	
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.65, 0.15);	
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.85, 0.30);	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE DEERS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int Deers1ID=rmCreateObjectDef("The Deers1");
        rmAddObjectDefItem(Deers1ID, "deer", rmRandInt(8,10), 6.0);
        rmSetObjectDefMinDistance(Deers1ID, 0.0);
        rmSetObjectDefMaxDistance(Deers1ID, 0.0);
        rmAddObjectDefConstraint(Deers1ID, avoidDeer);
        rmAddObjectDefConstraint(Deers1ID, deerAvoidDeer);
        rmPlaceObjectDefAtLoc(Deers1ID, 0, 0.3, 0.4);
        rmPlaceObjectDefAtLoc(Deers1ID, 0, 0.4, 0.3); 
		rmPlaceObjectDefAtLoc(Deers1ID, 0, 0.6, 0.7); 
		rmPlaceObjectDefAtLoc(Deers1ID, 0, 0.7, 0.6); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE SHEEPS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int sheepID=rmCreateObjectDef("sheep");
        rmAddObjectDefItem(sheepID, "sheep", rmRandInt(8,10), 6.0);
        rmSetObjectDefMinDistance(sheepID, 0.0);
        rmSetObjectDefMaxDistance(sheepID, 0.0);
        rmAddObjectDefConstraint(sheepID, avoidSheep);
        rmAddObjectDefConstraint(sheepID, sheepAvoidSheep);
        rmPlaceObjectDefAtLoc(sheepID, 0, 0.35, 0.45);
		rmPlaceObjectDefAtLoc(sheepID, 0, 0.55, 0.65);
		rmPlaceObjectDefAtLoc(sheepID, 0, 0.175, 0.175);
		rmPlaceObjectDefAtLoc(sheepID, 0, 0.825, 0.825);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE DECORATIONS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ***************************** DEFINE AND PLACE THE FORESTS: - NORTH AND SOUTH: - ***************************** //
/*================================================================================================================*/
/*	        int forestTreeID = 0;
	
	        numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 below
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int westForest=rmCreateArea("westForest"+i);
			rmSetAreaWarnFailure(westForest, false);
			rmSetAreaSize(westForest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
			rmSetAreaForestType(westForest, "texas forest dirt");
			rmSetAreaForestDensity(westForest, 0.7);
			rmSetAreaForestClumpiness(westForest, 0.4);
			rmSetAreaForestUnderbrush(westForest, 0.0);
			rmSetAreaMinBlobs(westForest, 1);
			rmSetAreaMaxBlobs(westForest, 3);
			rmSetAreaMinBlobDistance(westForest, 5.0);
			rmSetAreaMaxBlobDistance(westForest, 20.0);
			rmSetAreaCoherence(westForest, 0.4);
			rmSetAreaSmoothDistance(westForest, 10);
			//rmAddAreaConstraint(westForest, avoidImportantItem);		   // DAL added, to try and make sure natives got on the map w/o override.
			//rmAddAreaConstraint(westForest, avoidCoin);
			//rmAddAreaConstraint(westForest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			//rmAddAreaConstraint(westForest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			//rmAddAreaConstraint(westForest, Westward);						// DAL adeed, to keep these forests in the west.
			//rmAddAreaConstraint(westForest, avoidTradeRoute);
			//rmAddAreaConstraint(westForest, avoidCliffs);
			//rmAddAreaConstraint(westForest, forestsAvoidBison);
			if(rmBuildArea(westForest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}*/
/*----------------------------------------------------------------------------------------------------------------*/
/*	        numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 above.
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int eastForest=rmCreateArea("eastForest"+i);
			rmSetAreaWarnFailure(eastForest, false);
			rmSetAreaSize(eastForest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
			rmSetAreaForestType(eastForest, "texas forest");
			rmSetAreaForestDensity(eastForest, 0.7);
			rmSetAreaForestClumpiness(eastForest, 0.4);
			rmSetAreaForestUnderbrush(eastForest, 0.0);
			rmSetAreaMinBlobs(eastForest, 1);
			rmSetAreaMaxBlobs(eastForest, 3);
			rmSetAreaMinBlobDistance(eastForest, 5.0);
			rmSetAreaMaxBlobDistance(eastForest, 20.0);
			rmSetAreaCoherence(eastForest, 0.4);
			rmSetAreaSmoothDistance(eastForest, 10);
			//rmAddAreaConstraint(eastForest, avoidImportantItem);			// DAL added, to try and make sure natives got on the map w/o override.
			//rmAddAreaConstraint(eastForest, avoidCoin);
			//rmAddAreaConstraint(eastForest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			//rmAddAreaConstraint(eastForest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			//rmAddAreaConstraint(eastForest, Eastward);						// DAL adeed, to keep these forests in the east.
			//rmAddAreaConstraint(eastForest, avoidTradeRoute);
			//rmAddAreaConstraint(eastForest, avoidCliffs);
			//rmAddAreaConstraint(eastForest, forestsAvoidBison);
			if(rmBuildArea(eastForest)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		} */
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE FORESTS _ NORTH AND SOUTH: ****************************** //
/*================================================================================================================*/ 
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	        int forestTreeID = 0;
	
	        numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 below
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int westForest=rmCreateArea("westForest"+i);
			rmSetAreaWarnFailure(westForest, false);
			rmSetAreaSize(westForest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
			rmSetAreaForestType(westForest, "great plains forest");
			//rmSetAreaForestType(westForest, "texas forest dirt");
			rmSetAreaForestDensity(westForest, 0.7);
			rmSetAreaForestClumpiness(westForest, 0.4);
			rmSetAreaForestUnderbrush(westForest, 0.0);
			rmSetAreaMinBlobs(westForest, 1);
			rmSetAreaMaxBlobs(westForest, 3);
			rmSetAreaMinBlobDistance(westForest, 5.0);
			rmSetAreaMaxBlobDistance(westForest, 20.0);
			rmSetAreaCoherence(westForest, 0.4);
			rmSetAreaSmoothDistance(westForest, 10);
			rmAddAreaConstraint(westForest, avoidTradeRoute);
			rmAddAreaConstraint(westForest, avoidSocket);
			//rmAddAreaConstraint(westForest, avoidCow);
			rmAddAreaConstraint(westForest, avoidFruit);	
			//rmAddAreaConstraint(westForest, avoidNugget);	
			//rmAddAreaConstraint(westForest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			//rmAddAreaConstraint(westForest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			//rmAddAreaConstraint(westForest, Westward);						// DAL adeed, to keep these forests in the west.
			//rmAddAreaConstraint(westForest, avoidGold);
			//rmAddAreaConstraint(westForest, avoidNatives);	
			//rmAddAreaConstraint(westForest, avoidCliffs);
			//rmAddAreaConstraint(westForest, forestsAvoidBison);
			rmSetAreaLocation(westForest, 0.10, 0.40);
			if(rmBuildArea(westForest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}
		
/*================================================================================================================*/
            numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 below
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int west2Forest=rmCreateArea("west2Forest"+i);
			rmSetAreaWarnFailure(west2Forest, false);
			rmSetAreaSize(west2Forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
			//rmSetAreaForestType(west2Forest, "texas forest dirt");
			rmSetAreaForestType(west2Forest, "great plains forest");
			rmSetAreaForestDensity(west2Forest, 0.7);
			rmSetAreaForestClumpiness(west2Forest, 0.4);
			rmSetAreaForestUnderbrush(west2Forest, 0.0);
			rmSetAreaMinBlobs(west2Forest, 1);
			rmSetAreaMaxBlobs(west2Forest, 3);
			rmSetAreaMinBlobDistance(west2Forest, 5.0);
			rmSetAreaMaxBlobDistance(west2Forest, 20.0);
			rmSetAreaCoherence(west2Forest, 0.4);
			rmSetAreaSmoothDistance(west2Forest, 10);
			rmAddAreaConstraint(west2Forest, avoidTradeRoute);
			rmAddAreaConstraint(west2Forest, avoidSocket);
			//rmAddAreaConstraint(west2Forest, avoidImportantItem);		   // DAL added, to try and make sure natives got on the map w/o override.
			//rmAddAreaConstraint(west2Forest, avoidCoin);
			//rmAddAreaConstraint(west2Forest, avoidCow);
			//rmAddAreaConstraint(west2Forest, avoidNugget);	
			//rmAddAreaConstraint(west2Forest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			//rmAddAreaConstraint(west2Forest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			//rmAddAreaConstraint(west2Forest, Westward);						// DAL adeed, to keep these forests in the west.
			//rmAddAreaConstraint(west2Forest, avoidGold);
			rmAddAreaConstraint(west2Forest, avoidFruit);	
			//rmAddAreaConstraint(west2Forest, avoidNatives);	
			//rmAddAreaConstraint(west2Forest, avoidCliffs);
			//rmAddAreaConstraint(west2Forest, forestsAvoidBison);
			rmSetAreaLocation(west2Forest, 0.40, 0.10);
			if(rmBuildArea(west2Forest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}
/*================================================================================================================*/
            numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 below
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int west3Forest=rmCreateArea("west3Forest"+i);
			rmSetAreaWarnFailure(west3Forest, false);
			rmSetAreaSize(west3Forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
			//rmSetAreaForestType(west3Forest, "texas forest dirt");
			rmSetAreaForestType(west3Forest, "great plains forest");
			rmSetAreaForestDensity(west3Forest, 0.7);
			rmSetAreaForestClumpiness(west3Forest, 0.4);
			rmSetAreaForestUnderbrush(west3Forest, 0.0);
			rmSetAreaMinBlobs(west3Forest, 1);
			rmSetAreaMaxBlobs(west3Forest, 3);
			rmSetAreaMinBlobDistance(west3Forest, 5.0);
			rmSetAreaMaxBlobDistance(west3Forest, 20.0);
			rmSetAreaCoherence(west3Forest, 0.4);
			rmSetAreaSmoothDistance(west3Forest, 10);
			rmAddAreaConstraint(west3Forest, avoidTradeRoute);
			rmAddAreaConstraint(west3Forest, avoidSocket);
			//rmAddAreaConstraint(west3Forest, avoidImportantItem);		   // DAL added, to try and make sure natives got on the map w/o override.
			//rmAddAreaConstraint(west3Forest, avoidCoin);
			//rmAddAreaConstraint(west3Forest, avoidCow);
			rmAddAreaConstraint(west3Forest, avoidFruit);	
			//rmAddAreaConstraint(west3Forest, avoidNugget);	
			//rmAddAreaConstraint(west3Forest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			//rmAddAreaConstraint(west3Forest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			//rmAddAreaConstraint(west3Forest, Westward);						// DAL adeed, to keep these forests in the west.
			//rmAddAreaConstraint(west3Forest, avoidGold);
			//rmAddAreaConstraint(west3Forest, avoidNatives);	
			//rmAddAreaConstraint(west3Forest, avoidCliffs);
			//rmAddAreaConstraint(west3Forest, forestsAvoidBison);
			rmSetAreaLocation(west3Forest, 0.60, 0.90);
			if(rmBuildArea(west3Forest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}
/*================================================================================================================*/
            numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 below
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int west4Forest=rmCreateArea("west4Forest"+i);
			rmSetAreaWarnFailure(west4Forest, false);
			rmSetAreaSize(west4Forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
			//rmSetAreaForestType(west4Forest, "texas forest dirt");
			rmSetAreaForestType(west4Forest, "great plains forest");
			rmSetAreaForestDensity(west4Forest, 0.7);
			rmSetAreaForestClumpiness(west4Forest, 0.4);
			rmSetAreaForestUnderbrush(west4Forest, 0.0);
			rmSetAreaMinBlobs(west4Forest, 1);
			rmSetAreaMaxBlobs(west4Forest, 3);
			rmSetAreaMinBlobDistance(west4Forest, 5.0);
			rmSetAreaMaxBlobDistance(west4Forest, 20.0);
			rmSetAreaCoherence(west4Forest, 0.4);
			rmSetAreaSmoothDistance(west4Forest, 10);
			rmAddAreaConstraint(west4Forest, avoidTradeRoute);
			rmAddAreaConstraint(west4Forest, avoidSocket);
			//rmAddAreaConstraint(west4Forest, avoidImportantItem);		   // DAL added, to try and make sure natives got on the map w/o override.
			//rmAddAreaConstraint(west4Forest, avoidCoin);
			//rmAddAreaConstraint(west4Forest, avoidCow);
			//rmAddAreaConstraint(west4Forest, avoidNugget);	
			//rmAddAreaConstraint(west4Forest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			//rmAddAreaConstraint(west4Forest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			rmAddAreaConstraint(west4Forest, avoidFruit);						// DAL adeed, to keep these forests in the west.
			//rmAddAreaConstraint(west4Forest, avoidGold);
			//rmAddAreaConstraint(west4Forest, avoidNatives);	
			//rmAddAreaConstraint(west4Forest, avoidCliffs);
			//rmAddAreaConstraint(west4Forest, forestsAvoidBison);
			rmSetAreaLocation(west4Forest, 0.90, 0.60);
			if(rmBuildArea(west4Forest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}
/*================================================================================================================*/		
            numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 above.
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int centerForest=rmCreateArea("centerForest"+i);
			rmSetAreaWarnFailure(centerForest, false);
			// rmSetAreaSize(centerForest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
			   // rmSetAreaSize(centerForest, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
			rmSetAreaSize(centerForest, 0.035, 0.035);	   
			//rmSetAreaForestType(centerForest, "texas forest dirt");
			rmSetAreaForestType(centerForest, "great plains forest");
			rmSetAreaForestDensity(centerForest, 0.7);
			rmSetAreaForestClumpiness(centerForest, 0.4);
			rmSetAreaForestUnderbrush(centerForest, 0.0);
			rmSetAreaMinBlobs(centerForest, 1);
			rmSetAreaMaxBlobs(centerForest, 1);
			rmSetAreaMinBlobDistance(centerForest, 1.0);
			rmSetAreaMaxBlobDistance(centerForest, 1.0);
			rmSetAreaCoherence(centerForest, 0.4);
			rmSetAreaSmoothDistance(centerForest, 10);
			rmAddAreaConstraint(centerForest, avoidTradeRoute);
			rmAddAreaConstraint(centerForest, avoidSocket);
			//rmAddAreaConstraint(centerForest, avoidNugget);		// DAL adeed, to keep forests away from the player.
			//rmAddAreaConstraint(centerForest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			//rmAddAreaConstraint(centerForest, avoidNatives);						// DAL adeed, to keep these forests in the east.
			//rmAddAreaConstraint(centerForest, avoidGold);
			//rmAddAreaConstraint(centerForest, avoidCow);
			//rmAddAreaConstraint(centerForest, forestsAvoidBison);
			rmSetAreaLocation(centerForest, 0.60, 0.40);
			if(rmBuildArea(centerForest)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		} 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //
/*================================================================================================================*/
        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE FAST COIN -- WHALES: *********************************** //
/*================================================================================================================*/	 
	    int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "beluga", 2, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
} 
/*================================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*================================================================================================================*/ 
		























		
         
		
		
		
		
		
		
		