/*================================================================================================================*/
// THESE ARE THE INFORMATIONS OF THE MAP:
/*================================================================================================================*/
// THE YUCATAN WAR:
// CREATED BY DANY:
// DECEMBER 2006:
/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/
       int subCiv0=-1;
       int subCiv1=-1;
       int subCiv2=-1;
       int subCiv3=-1;
   
       if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Aztecs");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Aztecs");

		subCiv1=rmGetCivID("Aztecs");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Aztecs"); 

		subCiv2=rmGetCivID("Aztecs");
      if (subCiv2 >= 0)
         rmSetSubCiv(2, "Aztecs");
		 
		 subCiv3=rmGetCivID("Aztecs");
      if (subCiv3 >= 0)
         rmSetSubCiv(3, "Aztecs");
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ****************************************** PICKS THE MAP SIZE: *********************************************** //
/*================================================================================================================*/
	  int playerTiles=20000;
		 
	  if (cNumberNonGaiaPlayers >4)
		playerTiles = 15000;
	  if (cNumberNonGaiaPlayers >6)
		playerTiles = 10000;				 
	
	  int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	  rmEchoInfo("Map size="+size+"m x "+size+"m");
	  rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// *************************************** DEFINE THE MAP PARAMETERS: ******************************************* //
/*================================================================================================================*/	
	  // SET THE WIND MAGNITUDE:
	  rmSetWindMagnitude(2);
	  
	  // SET THE MAP ELEVATION PARAMETERS:
	  //rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	  rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
      rmSetMapElevationHeightBlend(1);
	
	  // PICKS A DEFAULT WATER HEIGHT:
	  rmSetSeaLevel(4.0);
	  
	  // PICKS A LIGHTING:
	  rmSetLightingSet("yucatan");


      // PICKS THE DEFAULT WATER:
	  rmSetSeaType("yucatan Coast");
	  rmEnableLocalWater(false);
	   
      // SET THE BASE TERRAIN MIX:
      rmSetBaseTerrainMix("yucatan_grass");
	  
	  // DEFINE THE TERRAIN INITIALIZATION:
	  rmTerrainInitialize("amazon\ground5_ama", 5.0);
	  	  
	  // SET THE MAP TYPE:
	  rmSetMapType("yucatan");
	  rmSetMapType("tropical");
	  rmSetMapType("water");
	  
	  // CHOOSE MERCS:
	  chooseMercs();

	  // CORNER CONSTRAINT:
	  rmSetWorldCircleConstraint(true);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************ DEFINE SOME CLASSES. THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*================================================================================================================*/      
	  int classPlayer=rmDefineClass("player");
      rmDefineClass("startingUnit");
	  rmDefineClass("classForest");
	  rmDefineClass("classCliff");
	  rmDefineClass("nuggets");
	  rmDefineClass("natives");
	  rmDefineClass("importantItem");
	  rmDefineClass("classSocket");
	  int lakeClass=rmDefineClass("lake");
	  int canyon=rmDefineClass("canyon");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHERS: ************************* //
/*================================================================================================================*/
      // MAP EDGE CONSTRAINT:
	  int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
      	  
	  // CARDINAL DIRECTIONS FOR EACH 90 DEGREES:
      int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(0), rmDegreesToRadians(90));
      int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(180), rmDegreesToRadians(270));
      int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(90), rmDegreesToRadians(180));
      int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(270), rmDegreesToRadians(360));
  	  
	  // CREATE BOX CONSTRAINT:
	  int Westconstraint = rmCreateBoxConstraint("stay in East Box", 0, 1.0, 0.4, 0.6); 
	  int Eastconstraint = rmCreateBoxConstraint("stay in West Box", 1.0, 0.0, 0.6, 0.4); 
	   	  
	  // PLAYER CONSTRAINTS:
      int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 40.0);
	  int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay close to players", classPlayer, 10.0);
	  int avoidTC=rmCreateTypeDistanceConstraint("stay away from TC", "TownCenter", 40.0);    
	  //int avoidTP=rmCreateTypeDistanceConstraint("stay away from Trading Post Sockets", "SocketTradeRoute", 14.0);  
	  int avoidCW=rmCreateTypeDistanceConstraint("stay away from CW", "CoveredWagon", 40.0);
	  
      // RANDOM BERRIES AVOIDANCE:
	  int avoidRandomBerries=rmCreateTypeDistanceConstraint("avoid random berries", "berrybush", 15.0);	
	  
	  // CANYON AVOIDANCE:
	  int canyonConstraint=rmCreateClassDistanceConstraint("canyons start away from each other", canyon, 35.0);
      int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 35.0);
      int shortAvoidCanyons=rmCreateClassDistanceConstraint("short avoid canyons", rmClassID("canyon"), 15.0);
	  	  
	  // STARTING AVOIDANCE:
      int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
      int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
      int avoidStartingUnitsLarge=rmCreateClassDistanceConstraint("objects avoid starting units large", rmClassID("startingUnit"), 50.0);
  	  	  
	  // SHIPS VS. SHIPS:
      int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 5.0);
	  
	  // FLAG AVOIDANCE:
	  int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 18.0);
	  int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 22); 
	  int flagEdgeConstraint = rmCreatePieConstraint("flags away from edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
      	  
	  // SEAFOOD AVOIDANCE:
	  int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
      //int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 15.0);
      int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
      //int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 15.0);
      
      // NATIVES AVOIDANCE:
	  int avoidNatives=rmCreateClassDistanceConstraint("avoid natives", rmClassID("natives"), 15.0);
	  int shortAvoidNatives=rmCreateClassDistanceConstraint("short avoid natives", rmClassID("natives"), 6.0);
	  int nativesAvoidNatives=rmCreateClassDistanceConstraint("natives avoids natives", rmClassID("natives"), 45);
	  
	  // LAKE AVOIDANCE:
	  int avoidLake=rmCreateClassDistanceConstraint("lake vs stuff", lakeClass, 12.0);
	  
	  // GOLD AVOIDANCE:
	  int avoidMoney=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 15.0);
	  int moneyAvoidMoney=rmCreateTypeDistanceConstraint("avoid gold coin", "minegold", 45.0);
	  
	  // DEER AVOIDANCE:
	  int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
	  int deerAvoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 60.0);
	  
	  // COIN AVOIDANCE:
	  int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "mine", 10.0);
      int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "mine", 35.0);
	  
	  // FRUITS AVOIDANCE:
	  int avoidFruits=rmCreateTypeDistanceConstraint("stuffs avoids berries", "berrybush", 12.0);
	  int fruitsAvoidFruits=rmCreateTypeDistanceConstraint("berries avoids berries", "berrybush", 40.0);
	  
	  // NUGGET AVOIDANCE:
	  int avoidNugget=rmCreateClassDistanceConstraint("stuff avoid nugget", rmClassID("nuggets"), 10.0);
	  int nuggetAvoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("nuggets"), 60.0);
	  
	  // SHEEP AVOIDANCE:
	  int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 10.0);
	  int sheepAvoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 40.0);
	  
	  // TURKEYS AVOIDANCE:
	  int avoidRandomTurkeys=rmCreateTypeDistanceConstraint("avoid random turkeys", "turkey", 10.0);
	  	  
      // WATER AVOIDANCE:
	  int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 8.0);
	  	  
	  // DECORATION AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);
	  
	  // FOREST AVOIDANCE:
	  int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 12.0);
	   
	  // IMPASSABLE LAND AVOIDANCE:
      int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "land", false, 10.0);
       
	  // CLIFFS AVOIDANCE:
	  int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 10.0);
	  int cliffsAvoidCliffs=rmCreateClassDistanceConstraint("cliffs vs. cliffs", rmClassID("classCliff"), 30.0);
      
      // TRADE ROUTE AVOIDANCE:
	  int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
	  
	  // SOCKET AVOIDANCE:
	  int avoidSockets = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 10.0);
	  
	  // IMPORTANT AVOIDANCE:
	  int avoidImportantItem = rmCreateClassDistanceConstraint("stuff avoid important stuff", rmClassID("importantItem"), 10.0);
	  	  
	  // CIRCLE CONSTRAINT:
	  int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE TRADE ROUTE: ************************************* //	  
/*================================================================================================================*/
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	  int tradeRouteID = rmCreateTradeRoute();
      int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRouteID, 0.45, 0.025);
	  //rmAddTradeRouteWaypoint(tradeRouteID, 0.975, 0.55);
	  rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.975, 0.55, 10, 4);

      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.05);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.35);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.65);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.925);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
    	if (subCiv0 == rmGetCivID("aztecs"))
	{  
		int aztecsVillageID = -1;
		aztecsVillageID = rmCreateGrouping("aztecs village 1", "native aztec village 1");
		rmSetGroupingMinDistance(aztecsVillageID, 0.0);
		//rmSetGroupingMaxDistance(aztecsVillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(aztecsVillageID, 0.0);
		//rmAddGroupingConstraint(aztecsVillageID, avoidImpassableLand);
		rmAddGroupingToClass(aztecsVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecsVillageID, avoidNatives);
		//rmAddGroupingConstraint(aztecsVillageID, nativesAvoidNatives);
		//rmAddGroupingConstraint(aztecsVillageID, avoidLake);
		//rmAddGroupingConstraint(aztecsVillageID, Northward);
		//rmAddGroupingConstraint(aztecsVillageID, playerConstraint);
		rmPlaceGroupingAtLoc(aztecsVillageID, 0, 0.4, 0.35);
	} 

	    if (subCiv1 == rmGetCivID("aztecs"))
	{  
		int aztecs2VillageID = -1;
		aztecs2VillageID = rmCreateGrouping("aztecs village 2", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs2VillageID, 0.0);
		//rmSetGroupingMaxDistance(aztecs2VillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(aztecs2VillageID, 0.0);
		//rmAddGroupingConstraint(aztecs2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(aztecs2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs2VillageID, avoidNatives);
		//rmAddGroupingConstraint(aztecs2VillageID, nativesAvoidNatives);
		//rmAddGroupingConstraint(aztecs2VillageID, Westward);
		//rmAddGroupingConstraint(aztecs2VillageID, playerConstraint);
		//rmAddGroupingConstraint(aztecs2VillageID, avoidLake);
		rmPlaceGroupingAtLoc(aztecs2VillageID, 0, 0.6, 0.55);
	} 

	    if (subCiv2 == rmGetCivID("aztecs"))
	{  
		int aztecs3VillageID = -1;
		aztecs3VillageID = rmCreateGrouping("aztecs village 3", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs3VillageID, 0.0);
		//rmSetGroupingMaxDistance(aztecs3VillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(aztecs3VillageID, 0.0);
		//rmAddGroupingConstraint(aztecs3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(aztecs3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs3VillageID, avoidNatives);
		//rmAddGroupingConstraint(aztecs3VillageID, nativesAvoidNatives);
		//rmAddGroupingConstraint(aztecs3VillageID, Eastward);
		//rmAddGroupingConstraint(aztecs3VillageID, playerConstraint);
		//rmAddGroupingConstraint(aztecs3VillageID, avoidLake);
		rmPlaceGroupingAtLoc(aztecs3VillageID, 0, 0.1, 0.45);
	}	 

        if (subCiv3 == rmGetCivID("aztecs"))
	{  
		int aztecs4VillageID = -1;
		aztecs4VillageID = rmCreateGrouping("aztecs village 4", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs4VillageID, 0.0);
		//rmSetGroupingMaxDistance(aztecs4VillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(aztecs4VillageID, 0.0);
		//rmAddGroupingConstraint(aztecs4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(aztecs4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs4VillageID, avoidNatives);
		//rmAddGroupingConstraint(aztecs4VillageID, nativesAvoidNatives);
		//rmAddGroupingConstraint(aztecs4VillageID, Southward);
		//rmAddGroupingConstraint(aztecs4VillageID, playerConstraint);
		//rmAddGroupingConstraint(aztecs4VillageID, avoidLake);
		rmPlaceGroupingAtLoc(aztecs4VillageID, 0, 0.5, 0.9);
	}
/*================================================================================================================*/
    rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ********************************** SET UP THE PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
	    if ( cNumberTeams == 2 )
	{
		rmSetPlacementTeam(0);
		//rmSetPlacementSection(0.15, 0.35);
		rmSetPlacementSection(0.10, 0.20);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.13, 0.37);
		}
		// rmPlacePlayersCircular(0.35, 0.40, 0.0);
		   rmPlacePlayersCircular(0.36, 0.37, 0.0);


		rmSetPlacementTeam(1);
		//rmSetPlacementSection(0.65, 0.85);
		rmSetPlacementSection(0.60, 0.70);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.63, 0.87);
		}
		// rmPlacePlayersCircular(0.35, 0.40, 0.0);
		   rmPlacePlayersCircular(0.36, 0.37, 0.0);
	}
	else
	{
  		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.40, 0.42, 0.0);
	}  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ******************************************* SET UP PLAYER AREAS: ********************************************* //
/*================================================================================================================*/
      float playerFraction=rmAreaTilesToFraction(100);
/*----------------------------------------------------------------------------------------------------------------*/   
      for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
   {
      // CREATE THE AREA:
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
      
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET THE BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
	        	  
	  // ADD CONSTRAINTS:
	  rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, playerEdgeConstraint); 
      
	  // SET THE LOCATION:
	  rmSetAreaLocPlayer(id, i);
	  
	  // SET TYPE:
	  //rmSetAreaTerrainType(id, "texas\ground2"); // FROM TEXAS:
	  rmSetAreaMix(id, "yucatan_grass");
      
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
   }
      // BUILD THE AREAS:
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// **************************** DEFINE THE STARTING TCID AND THE STARTING UNITS: ******************************** //
/*================================================================================================================*/
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	rmSetObjectDefMinDistance(startingUnits, 5.0);
	rmSetObjectDefMaxDistance(startingUnits, 10.0);
	rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(startingUnits, avoidAll);

	int startingTCID =  rmCreateObjectDef("startingTC");
	if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(startingTCID, avoidTC);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERAYION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ************************************* DEFINE THE STARTING RESOURCES: ***************************************** //
/*================================================================================================================*/
	// DEFINE THE STARTING SILVER MINES:
	int silverType = -1;
	int playerGoldID = -1;

	// DEFINE THE STARTING TREES:
	int StartAreaTreeID = rmCreateObjectDef("starting trees");
	rmAddObjectDefItem(StartAreaTreeID, "TreeYucatan", 1, 0.0);
	rmSetObjectDefMinDistance(StartAreaTreeID, 10.0);
	rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
	//rmAddObjectDefConstraint(StartAreaTreeID, avoidNatives);
	
	// DEFINE THE STARTING BERRYBUSH:
	int StartBerryBushID = rmCreateObjectDef("starting BerryBush");
	rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 5.0);
	rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
	rmSetObjectDefMaxDistance(StartBerryBushID, 15.0);
	rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
	//rmAddObjectDefConstraint(StartBerryBushID, avoidNatives);
    
	// DEFINE THE PLAYER NUGGET:
	int playerNuggetID = rmCreateObjectDef("player nugget");
	rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
    rmSetObjectDefMinDistance(playerNuggetID, 30.0);
    rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	//rmAddObjectDefConstraint(playerNuggetID, avoidNatives);

	// DEFINE THE WATER FLAG:
	int waterFlagID = -1;
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERAYION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ****************************** PLACE THE STARTING TCID AND THE STARTING UNITS: ******************************* //
/*================================================================================================================*/
    	for(i = 1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/		
	{
/*----------------------------------------------------------------------------------------------------------------*/	
		rmClearClosestPointConstraints();
/*----------------------------------------------------------------------------------------------------------------*/		
		// PLACE THE STARTING TCID AND STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*================================================================================================================*/
// ************************************** PLACE THE STARTING RESOURCES: ***************************************** //
/*================================================================================================================*/
		// EVERYONE GETS ONE ORE GROUPING CLOSE BY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		//rmAddObjectDefConstraint(playerGoldID, avoidNatives);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

        // PLACING THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING THE WATER FLAG:
		waterFlagID = rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		rmClearClosestPointConstraints();
/*----------------------------------------------------------------------------------------------------------------*/
   }
/*================================================================================================================*/
   rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE LAKE IN THE MIDDLE: *********************************** //
/*================================================================================================================*/
            int smallLakeID=rmCreateArea("small lake");
			rmSetAreaSize(smallLakeID, rmAreaTilesToFraction(3500), rmAreaTilesToFraction(3500));
			rmSetAreaWaterType(smallLakeID, "yucatan coast");
			//rmSetAreaBaseHeight(smallLakeID, 2.0);
			rmSetAreaBaseHeight(smallLakeID, 1.0);
			rmAddAreaToClass(smallLakeID, lakeClass);
			//rmAddAreaConstraint(smallLakeID, playerConstraint);
			rmAddAreaConstraint(smallLakeID, avoidNatives);
			rmSetAreaCoherence(smallLakeID, 0.3);
			rmSetAreaWarnFailure(smallLakeID, false);
			rmSetAreaLocation(smallLakeID, 0.25, 0.75);
			//rmSetAreaLocation(smallLakeID, 0.1, 0.9);
			rmBuildArea(smallLakeID);
/*================================================================================================================*/
  rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE SMALL ROCK SPIRES: ************************************ //
/*================================================================================================================*/
    //int canyon=rmDefineClass("canyon");
   
    //int canyonConstraint=rmCreateClassDistanceConstraint("canyons start away from each other", canyon, 5.0);
    //int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 35.0);
    //int shortAvoidCanyons=rmCreateClassDistanceConstraint("short avoid canyons", rmClassID("canyon"), 15.0);
	
    int failCount=0;
    int numTries=cNumberNonGaiaPlayers*3;
    for(i=0; <numTries)
  {
	int smallMesaID=rmCreateArea("small mesa"+i);
	rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(50));  
	rmSetAreaWarnFailure(smallMesaID, false);
	rmSetAreaCliffType(smallMesaID, "Amazon");
	rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	
	rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
	rmSetAreaCliffHeight(smallMesaID, rmRandInt(6,9), 1.0, 1.0);
	//rmSetAreaMinBlobs(smallMesaID, 1);
	//rmSetAreaMaxBlobs(smallMesaID, 1);
	//rmSetAreaMinBlobDistance(smallMesaID, 1.0);
	//rmSetAreaMaxBlobDistance(smallMesaID, 1.0);
	rmSetAreaCoherence(smallMesaID, 0.3);
	rmAddAreaConstraint(smallMesaID, avoidCanyons);
	rmAddAreaConstraint(smallMesaID, canyonConstraint);
	rmAddAreaConstraint(smallMesaID, playerConstraint); 
	rmAddAreaConstraint(smallMesaID, avoidNatives);
	rmAddAreaConstraint(smallMesaID, avoidImportantItem); 
	rmAddAreaConstraint(smallMesaID, avoidSockets);
	rmAddAreaConstraint(smallMesaID, avoidTradeRoute);
	rmAddAreaConstraint(smallMesaID, avoidCoin);
	rmAddAreaConstraint(smallMesaID, avoidDeer);
	rmAddAreaConstraint(smallMesaID, avoidNugget);
	rmAddAreaConstraint(smallMesaID, avoidRandomTurkeys);
	rmAddAreaConstraint(smallMesaID, avoidMoney);
	rmAddAreaConstraint(smallMesaID, avoidRandomBerries);
	rmAddAreaConstraint(smallMesaID, avoidLake);
	rmAddAreaConstraint(smallMesaID, avoidSheep);
	rmAddAreaConstraint(smallMesaID, playerEdgeConstraint);
	if(rmBuildArea(smallMesaID)==false)
	{
		// Stop trying once we fail 3 times in a row.
		failCount++;
		if(failCount==20)
			break;
	}
	    else
		failCount=0;
  }
/*================================================================================================================*/
   rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FORESTS: **************************************** //
/*================================================================================================================*/
	     // SCATTERED FORESTS:
         int forestTreeID = 0;
         numTries=8*cNumberNonGaiaPlayers;
         failCount=0;
         for (i=0; <numTries)
      {   
         int forest=rmCreateArea("forest "+i);
         rmSetAreaWarnFailure(forest, false);
         rmSetAreaSize(forest, rmAreaTilesToFraction(125), rmAreaTilesToFraction(200));
         rmSetAreaForestType(forest, "Yucatan forest");
         rmSetAreaForestDensity(forest, 0.6);
         rmSetAreaForestClumpiness(forest, 0.4);
         rmSetAreaForestUnderbrush(forest, 0.0);
         rmSetAreaMinBlobs(forest, 3);
         rmSetAreaMaxBlobs(forest, 5);
         rmSetAreaMinBlobDistance(forest, 8.0);
         rmSetAreaMaxBlobDistance(forest, 16.0);
         rmSetAreaCoherence(forest, 0.4);
         rmSetAreaSmoothDistance(forest, 10);
         rmAddAreaToClass(forest, rmClassID("classForest")); 
         rmAddAreaConstraint(forest, forestConstraint);
         rmAddAreaConstraint(forest, avoidAll);
		 rmAddAreaConstraint(forest, avoidSheep);
		 rmAddAreaConstraint(forest, avoidRandomBerries);
		 rmAddAreaConstraint(forest, avoidNugget);
		 rmAddAreaConstraint(forest, avoidMoney);
		 rmAddAreaConstraint(forest, avoidRandomTurkeys);
		 rmAddAreaConstraint(forest, playerEdgeConstraint);
		 rmAddAreaConstraint(forest, playerConstraint);
		 rmAddAreaConstraint(forest, avoidLake);
		 rmAddAreaConstraint(forest, avoidSockets);
         rmAddAreaConstraint(forest, avoidImpassableLand); 
		 rmAddAreaConstraint(forest, avoidDeer); 
		 rmAddAreaConstraint(forest, avoidNatives);
		 //rmAddAreaConstraint(forest, avoidCW);
         rmAddAreaConstraint(forest, avoidTradeRoute); 
         if(rmBuildArea(forest)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
            else
            failCount=0; 
      }  
/*================================================================================================================*/
   rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE SHEEPS: ****************************************** //
/*================================================================================================================*/
      int sheepID=rmCreateObjectDef("sheep");
	  //rmAddObjectDefItem(sheepID, "sheep", 2, 4.0);
	  rmAddObjectDefItem(sheepID, "sheep", rmRandInt(4,6), 10.0);
	  rmSetObjectDefMinDistance(sheepID, 0.0);
	  rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(sheepID, avoidSheep);
	  rmAddObjectDefConstraint(sheepID, sheepAvoidSheep);
	  rmAddObjectDefConstraint(sheepID, avoidAll);
	  rmAddObjectDefConstraint(sheepID, playerEdgeConstraint);
	  rmAddObjectDefConstraint(sheepID, avoidRandomBerries);
      rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
      rmAddObjectDefConstraint(sheepID, avoidStartingUnits);
	  rmAddObjectDefConstraint(sheepID, avoidCW);
	  rmAddObjectDefConstraint(sheepID, avoidTC);
	  rmAddObjectDefConstraint(sheepID, Southward);
	  rmAddObjectDefConstraint(sheepID, avoidNugget);
	  rmAddObjectDefConstraint(sheepID, avoidTradeRoute);
	  rmAddObjectDefConstraint(sheepID, avoidSockets);
	  rmAddObjectDefConstraint(sheepID, shortAvoidNatives);
	  rmAddObjectDefConstraint(sheepID, avoidCoin);
	  rmAddObjectDefConstraint(sheepID, avoidLake);
	  //rmAddObjectDefConstraint(sheepID, avoidCanyons);
	  //rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	    rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, 3);
		
		 int sheep2ID=rmCreateObjectDef("sheep 2");
	  //rmAddObjectDefItem(sheep2ID, "sheep", 2, 4.0);
	  rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(4,6), 10.0);
	  rmSetObjectDefMinDistance(sheep2ID, 0.0);
	  rmSetObjectDefMaxDistance(sheep2ID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(sheep2ID, avoidSheep);
	  rmAddObjectDefConstraint(sheep2ID, sheepAvoidSheep);
	  rmAddObjectDefConstraint(sheep2ID, avoidAll);
	  rmAddObjectDefConstraint(sheep2ID, playerEdgeConstraint);
	  rmAddObjectDefConstraint(sheep2ID, avoidRandomBerries);
      rmAddObjectDefConstraint(sheep2ID, avoidImpassableLand);
      rmAddObjectDefConstraint(sheep2ID, avoidStartingUnits);
	  rmAddObjectDefConstraint(sheep2ID, avoidCW);
	  rmAddObjectDefConstraint(sheep2ID, Northward);
	  rmAddObjectDefConstraint(sheep2ID, avoidTC);
	  rmAddObjectDefConstraint(sheep2ID, avoidNugget);
	  rmAddObjectDefConstraint(sheep2ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(sheep2ID, avoidSockets);
	  rmAddObjectDefConstraint(sheep2ID, shortAvoidNatives);
	  rmAddObjectDefConstraint(sheep2ID, avoidCoin);
	  rmAddObjectDefConstraint(sheep2ID, avoidLake);
	  //rmAddObjectDefConstraint(sheep2ID, avoidCanyons);
	  //rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	    rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, 3);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.76);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE TURKEYS: ***************************************** //
/*================================================================================================================*/
	  int turkeyID=rmCreateObjectDef("random turkeys");
	  rmAddObjectDefItem(turkeyID, "turkey", rmRandInt(3,5), 5.0);
	  rmSetObjectDefMinDistance(turkeyID, 0.0);
	  rmSetObjectDefMaxDistance(turkeyID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(turkeyID, shortAvoidNatives);
	  rmAddObjectDefConstraint(turkeyID, avoidTC);
	  rmAddObjectDefConstraint(turkeyID, avoidRandomTurkeys);
	  rmAddObjectDefConstraint(turkeyID, avoidAll);
	  rmAddObjectDefConstraint(turkeyID, avoidLake);
	  rmAddObjectDefConstraint(turkeyID, avoidSheep);
	  rmAddObjectDefConstraint(turkeyID, avoidCoin);
	  rmAddObjectDefConstraint(turkeyID, playerEdgeConstraint);
	  //rmAddObjectDefConstraint(turkeyID, avoidTurkey);
	  rmAddObjectDefConstraint(turkeyID, avoidNugget);
	  rmAddObjectDefConstraint(turkeyID, avoidTradeRoute);
	  rmAddObjectDefConstraint(turkeyID, avoidSockets);
	  rmAddObjectDefConstraint(turkeyID, avoidRandomBerries);
	  rmAddObjectDefConstraint(turkeyID, avoidImpassableLand);
	  rmAddObjectDefConstraint(turkeyID, Northward);
	  //rmPlaceObjectDefInArea(turkeyID, 0, bigIslandID, cNumberNonGaiaPlayers*5); 
	  //rmPlaceObjectDefAtLoc(turkeyID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	    rmPlaceObjectDefAtLoc(turkeyID, 0, 0.5, 0.5, 5);
		
	  int turkey2ID=rmCreateObjectDef("random turkeys 2");
	  rmAddObjectDefItem(turkey2ID, "turkey", rmRandInt(3,5), 5.0);
	  rmSetObjectDefMinDistance(turkey2ID, 0.0);
	  rmSetObjectDefMaxDistance(turkey2ID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(turkey2ID, shortAvoidNatives);
	  rmAddObjectDefConstraint(turkey2ID, avoidTC);
	  rmAddObjectDefConstraint(turkey2ID, avoidRandomTurkeys);
	  rmAddObjectDefConstraint(turkey2ID, avoidAll);
	  rmAddObjectDefConstraint(turkey2ID, avoidLake);
	  rmAddObjectDefConstraint(turkey2ID, avoidSheep);
	  rmAddObjectDefConstraint(turkey2ID, avoidCoin);
	  rmAddObjectDefConstraint(turkey2ID, playerEdgeConstraint);
	  //rmAddObjectDefConstraint(turkey2ID, avoidTurkey);
	  rmAddObjectDefConstraint(turkey2ID, avoidNugget);
	  rmAddObjectDefConstraint(turkey2ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(turkey2ID, avoidSockets);
	  rmAddObjectDefConstraint(turkey2ID, avoidRandomBerries);
	  rmAddObjectDefConstraint(turkey2ID, avoidImpassableLand);
	  rmAddObjectDefConstraint(turkey2ID, Southward);
	  //rmPlaceObjectDefInArea(turkey2ID, 0, bigIslandID, cNumberNonGaiaPlayers*5); 
	  //rmPlaceObjectDefAtLoc(turkey2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	    rmPlaceObjectDefAtLoc(turkey2ID, 0, 0.5, 0.5, 5);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.77);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE SCATTERED BERRIES: ************************************ //
/*================================================================================================================*/
      // RANDOM BERRIES AVOIDANCE:
	  //int avoidRandomBerries=rmCreateTypeDistanceConstraint("avoid random berries", "berrybush", 75.0);	
	
	  
	  int berriesID=rmCreateObjectDef("random berries");
	  rmAddObjectDefItem(berriesID, "berrybush", rmRandInt(5,8), 6.0); 
	  rmSetObjectDefMinDistance(berriesID, 0.0);
	  rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(berriesID, avoidTC);
	  rmAddObjectDefConstraint(berriesID, shortAvoidNatives);   
	  rmAddObjectDefConstraint(berriesID, avoidCW);
	  rmAddObjectDefConstraint(berriesID, avoidAll);
	  rmAddObjectDefConstraint(berriesID, Westward);
	  rmAddObjectDefConstraint(berriesID, playerEdgeConstraint);
	  rmAddObjectDefConstraint(berriesID, avoidLake);
	  rmAddObjectDefConstraint(berriesID, avoidTradeRoute);
	  rmAddObjectDefConstraint(berriesID, avoidSockets);
	  rmAddObjectDefConstraint(berriesID, avoidRandomBerries);
	  rmAddObjectDefConstraint(berriesID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(berriesID, avoidCanyons);
	  //rmPlaceObjectDefInArea(berriesID, 0, bigIslandID, cNumberNonGaiaPlayers*4);
      //rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	  rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, 3);
	  
	  int berries2ID=rmCreateObjectDef("random berries 2");
	  rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(5,8), 6.0); 
	  rmSetObjectDefMinDistance(berries2ID, 0.0);
	  rmSetObjectDefMaxDistance(berries2ID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(berries2ID, avoidTC);
	  rmAddObjectDefConstraint(berries2ID, shortAvoidNatives);   
	  rmAddObjectDefConstraint(berries2ID, avoidCW);
	  rmAddObjectDefConstraint(berries2ID, avoidAll);
	  rmAddObjectDefConstraint(berries2ID, Eastward);
	  rmAddObjectDefConstraint(berries2ID, playerEdgeConstraint);
	  rmAddObjectDefConstraint(berries2ID, avoidLake);
	  rmAddObjectDefConstraint(berries2ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(berries2ID, avoidSockets);
	  rmAddObjectDefConstraint(berries2ID, avoidRandomBerries);
	  rmAddObjectDefConstraint(berries2ID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(berries2ID, avoidCanyons);
	  //rmPlaceObjectDefInArea(berries2ID, 0, bigIslandID, cNumberNonGaiaPlayers*4);
      //rmPlaceObjectDefAtLoc(berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	  rmPlaceObjectDefAtLoc(berries2ID, 0, 0.5, 0.5, 3);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.78);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/
	  int NuggetID= rmCreateObjectDef("nugget easy"); 
	  rmAddObjectDefItem(NuggetID, "Nugget", 1, 0.0);
	  rmAddObjectDefToClass(NuggetID, rmClassID("nuggets"));
	  rmSetObjectDefMinDistance(NuggetID, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmSetObjectDefMaxDistance(NuggetID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(NuggetID, avoidImpassableLand);
	  rmAddObjectDefConstraint(NuggetID, avoidNugget);
	  rmAddObjectDefConstraint(NuggetID, nuggetAvoidNugget);
	  rmAddObjectDefConstraint(NuggetID, avoidTradeRoute);
	  rmAddObjectDefConstraint(NuggetID, avoidTC);
	  rmAddObjectDefConstraint(NuggetID, shortAvoidNatives);
	  rmAddObjectDefConstraint(NuggetID, avoidAll);
	  rmAddObjectDefConstraint(NuggetID, playerEdgeConstraint);
	  rmAddObjectDefConstraint(NuggetID, avoidLake);
	  rmAddObjectDefConstraint(NuggetID, avoidRandomBerries);
	  rmAddObjectDefConstraint(NuggetID, avoidSockets);
	  rmAddObjectDefConstraint(NuggetID, playerConstraint);
	  //rmPlaceObjectDefInArea(NuggetID, 0, bigIslandID, cNumberNonGaiaPlayers*rmRandInt(3,4));
	  //rmPlaceObjectDefAtLoc(NuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
	  rmPlaceObjectDefAtLoc(NuggetID, 0, 0.5, 0.5, 7);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE SCATTERED GOLD MINES: ********************************* //
/*================================================================================================================*/
	  // GOLD AVOIDANCE:
	  //int avoidMoney=rmCreateTypeDistanceConstraint("avoid coin", "minegold", 85.0);	
	  
	  int goldID = rmCreateObjectDef("random gold");
	  rmAddObjectDefItem(goldID, "minegold", 1, 0);
	  rmSetObjectDefMinDistance(goldID, 0.0);
	  rmSetObjectDefMaxDistance(goldID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(goldID, Eastward);
	  rmAddObjectDefConstraint(goldID, playerConstraint);
	  rmAddObjectDefConstraint(goldID, avoidAll);
	  rmAddObjectDefConstraint(goldID, shortAvoidNatives);
	  rmAddObjectDefConstraint(goldID, avoidLake);
	  rmAddObjectDefConstraint(goldID, playerEdgeConstraint);
	  rmAddObjectDefConstraint(goldID, avoidMoney);
	  rmAddObjectDefConstraint(goldID, moneyAvoidMoney);
      rmAddObjectDefConstraint(goldID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(goldID, avoidCanyons);
	  //rmPlaceObjectDefInArea(goldID, 0, bigIslandID, cNumberNonGaiaPlayers*3);
	  //rmPlaceObjectDefAtLoc(goldID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	  rmPlaceObjectDefAtLoc(goldID, 0, 0.5, 0.5, 3);
	  
	  int gold2ID = rmCreateObjectDef("random gold 2");
	  rmAddObjectDefItem(gold2ID, "minegold", 1, 0);
	  rmSetObjectDefMinDistance(gold2ID, 0.0);
	  rmSetObjectDefMaxDistance(gold2ID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(gold2ID, Westward);
	  rmAddObjectDefConstraint(gold2ID, playerConstraint);
	  rmAddObjectDefConstraint(gold2ID, avoidAll);
	  rmAddObjectDefConstraint(gold2ID, shortAvoidNatives);
	  rmAddObjectDefConstraint(gold2ID, avoidLake);
	  rmAddObjectDefConstraint(gold2ID, playerEdgeConstraint);
	  rmAddObjectDefConstraint(gold2ID, avoidMoney);
	  rmAddObjectDefConstraint(gold2ID, moneyAvoidMoney);
      rmAddObjectDefConstraint(gold2ID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(gold2ID, avoidCanyons);
	  //rmPlaceObjectDefInArea(gold2ID, 0, bigIslandID, cNumberNonGaiaPlayers*3);
	  //rmPlaceObjectDefAtLoc(gold2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	  rmPlaceObjectDefAtLoc(gold2ID, 0, 0.5, 0.5, 3);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE DEERS: **************************************** //
/*================================================================================================================*/   
	//int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
	//int deerAvoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 40.0);
		
	int deerID=rmCreateObjectDef("deer herd");
	rmAddObjectDefItem(deerID, "deer", rmRandInt(3,5), 10.0);
	rmSetObjectDefMinDistance(deerID, 0.0);
	rmSetObjectDefMaxDistance(deerID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(deerID, avoidDeer);
	rmAddObjectDefConstraint(deerID, avoidAll);
	rmAddObjectDefConstraint(deerID, shortAvoidNatives);
	rmAddObjectDefConstraint(deerID, Westward);
	rmAddObjectDefConstraint(deerID, avoidLake);
	rmAddObjectDefConstraint(deerID, avoidSockets);
	rmAddObjectDefConstraint(deerID, playerEdgeConstraint);
	rmAddObjectDefConstraint(deerID, avoidImpassableLand);
	rmAddObjectDefConstraint(deerID, playerConstraint);
	rmSetObjectDefCreateHerd(deerID, true);
	rmPlaceObjectDefAtLoc(deerID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	rmPlaceObjectDefAtLoc(deerID, 0, 0.5, 0.5, 3);
	
	int deer2ID=rmCreateObjectDef("deer herd 2");
	rmAddObjectDefItem(deer2ID, "deer", rmRandInt(3,5), 10.0);
	rmSetObjectDefMinDistance(deer2ID, 0.0);
	rmSetObjectDefMaxDistance(deer2ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(deer2ID, avoidDeer);
	rmAddObjectDefConstraint(deer2ID, avoidAll);
	rmAddObjectDefConstraint(deer2ID, shortAvoidNatives);
	rmAddObjectDefConstraint(deer2ID, Eastward);
	rmAddObjectDefConstraint(deer2ID, avoidLake);
	rmAddObjectDefConstraint(deer2ID, avoidSockets);
	rmAddObjectDefConstraint(deer2ID, playerEdgeConstraint);
	rmAddObjectDefConstraint(deer2ID, avoidImpassableLand);
	rmAddObjectDefConstraint(deer2ID, playerConstraint);
	rmSetObjectDefCreateHerd(deer2ID, true);
	//rmPlaceObjectDefAtLoc(deer2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	rmPlaceObjectDefAtLoc(deer2ID, 0, 0.5, 0.5, 3);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //
/*================================================================================================================*/
       int fishID=rmCreateObjectDef("sardine");
       rmAddObjectDefItem(fishID, "FishSardine", 3, 4.0);
       rmSetObjectDefMinDistance(fishID, 0.0);
       rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
       rmAddObjectDefConstraint(fishID, fishVsFishID);
       rmAddObjectDefConstraint(fishID, fishLand);
       rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

       int fish2ID=rmCreateObjectDef("tarpon");
       rmAddObjectDefItem(fish2ID, "FishTarpon", 3, 4.0);
       rmSetObjectDefMinDistance(fish2ID, 0.0);
       rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
       rmAddObjectDefConstraint(fish2ID, fishVsFishID);
       rmAddObjectDefConstraint(fish2ID, fishLand);
       rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

/*	   int whaleID=rmCreateObjectDef("whale");
       rmAddObjectDefItem(whaleID, "humpbackWhale", 1, 9.0);
       rmSetObjectDefMinDistance(whaleID, 0.0);
       rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
       rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
       rmAddObjectDefConstraint(whaleID, whaleLand);
       //rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
	   rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 2);*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE RANDOM TREES: ************************************* //
/*================================================================================================================*/
      int randomTreeID=rmCreateObjectDef("random tree");
      rmAddObjectDefItem(randomTreeID, "TreeYucatan", 1, 0.0);
      rmSetObjectDefMinDistance(randomTreeID, 0.0);
      rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
      //rmAddObjectDefConstraint(randomTreeID, avoidTradeRoute);
      //rmAddObjectDefConstraint(randomTreeID, avoidImportantItem);
      //rmAddObjectDefConstraint(randomTreeID, avoidMoney);
      //rmAddObjectDefConstraint(randomTreeID, avoidDeer);
      //rmAddObjectDefConstraint(randomTreeID, avoidRandomBerries);
      rmAddObjectDefConstraint(randomTreeID, shortAvoidNatives);
      //rmAddObjectDefConstraint(randomTreeID, avoidNugget);
      rmAddObjectDefConstraint(randomTreeID, avoidSockets);
      //rmAddObjectDefConstraint(randomTreeID, avoidAll);
      rmAddObjectDefConstraint(randomTreeID, avoidLake);
      //rmAddObjectDefConstraint(randomTreeID, avoidRandomTurkeys);
      rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint);
      rmAddObjectDefConstraint(randomTreeID, shortPlayerConstraint);
      rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}  
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************** THIS IS THE END OF THE MAP: ******************************************* //
/*----------------------------------------------------------------------------------------------------------------*/