/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// CREATED BY DANY:
// DECEMBER 2006:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int subCiv0=-1;
      int subCiv1=-1;
	  int subCiv2=-1;
      int subCiv3=-1;
	  
	   if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Iroquois");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Iroquois");

		subCiv1=rmGetCivID("Iroquois");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Iroquois"); 
		 
		 subCiv2=rmGetCivID("Iroquois");
      if (subCiv2 >= 0)
         rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
      if (subCiv3 >= 0)
         rmSetSubCiv(3, "Iroquois");
   }		 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
      // PICKS THE MAP SIZE:
	  int playerTiles=25000;
      
	  if (cNumberNonGaiaPlayers >4)
		playerTiles = 20000;

      int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
      rmEchoInfo("Map size="+size+"m x "+size+"m");
      rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// **************************************** PICKS THE MAP PARAMETERS: ******************************************* //
/*================================================================================================================*/
	  // PICKS DEFAULT TERRAIN AND WATER:
      rmSetSeaType("new england coast");
	
	  // SOME MAP TURBULENCE:
	  rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);  // Like Texas for the moment.
	  rmSetMapElevationHeightBlend(0.2);

      // PICKS A DEFAULT WATER HEIGHT:
      rmSetSeaLevel(4.0);
      rmEnableLocalWater(false);
      
	  // TERRAIN INITIALIZE:
	  rmTerrainInitialize("water");
	  
	  // SET THE MAP TYPE:
	  rmSetMapType("newEngland");
	  rmSetMapType("water");
	  rmSetMapType("grass");
	  
	  // SET THE WIND MAGNITUDE:
	  rmSetWindMagnitude(2.0);
	  
	  // SET THE LIGHTING:
	  rmSetLightingSet("new england");
	  
	  // SET THE WORLD CIRCLE CONSTRAINT:
	  rmSetWorldCircleConstraint(true);

	  // CHOOSE THE MERCS:
	  chooseMercs();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/   
// ************************** DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int classPlayer=rmDefineClass("player");
	  rmDefineClass("startingUnit");
	  int classbigContinent=rmDefineClass("big continent");
	  rmDefineClass("importantItem");
	  rmDefineClass("classSocket");
	  rmDefineClass("nuggets");
	  rmDefineClass("canyon");
	  rmDefineClass("classForest");
	  rmDefineClass("natives");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ******************************************* DEFINE THE CONSTRAINTS: ****************************************** //
// *************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: *********************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      // MAP EDGE CONSTRAINTS:
      int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
      	  
	  // PLAYER CONSTRAINTS:
      int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 10.0);
	  int longPlayerConstraint=rmCreateClassDistanceConstraint("continent stays away from players", classPlayer, 12.0);
      
	  // BONUS AREA CONSTRAINT:
      //int bigContinentConstraint=rmCreateClassDistanceConstraint("avoid bonus island", classbigContinent, 25.0);
	  int bigContinentConstraint=rmCreateClassDistanceConstraint("avoid bonus island", classbigContinent, 45.0);
	  
	  // RESOURCE AVOIDANCE:
      int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
      
	  // ANIMALS AVOIDANCE:
	  int avoidDeer=rmCreateTypeDistanceConstraint("stuffs avoids food", "deer", 6.0);
	  int deerAvoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 40.0);
	  int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 6.0);
	  int sheepAvoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 40.0);
	  
	  // COIN AVOIDANCE:
	  int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 30.0);
      int avoidCoin=rmCreateTypeDistanceConstraint("stuffs avoids coin", "minegold", 6.0);
	  int coinAvoidCoin=rmCreateTypeDistanceConstraint("gold avoids gold", "minegold", 40);
      
	  // NUGGET AVOIDANCE:
	  int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "Nugget", 8.0);
	  int nuggetAvoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 35.0);
      int avoidPlayerNugget=rmCreateTypeDistanceConstraint("player nugget avoid nugget", "AbstractNugget", 20.0);
      int avoidNuggetSmall=rmCreateTypeDistanceConstraint("nugget avoid nugget small", "AbstractNugget", 10.0);
      
	  // RANDOM BERRIES AVOIDANCE:
	  int avoidFruits=rmCreateTypeDistanceConstraint("stuffs avoid berries", "berrybush", 6.0);
      int fruitAvoidFruits=rmCreateTypeDistanceConstraint("berries avoid berries", "berrybush", 40.0);		  
	  
	  // AVOID IMPASSABLE LAND:
	  int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 8.0);
	  int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 6.0);
	 	  
	  // UNIT AVOIDANCE:
      int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 8.0);
      int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 2.0);
	  
	  // NATIVES AVOIDANCE:
	  int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 6.0);
	  
	  // DECORATION AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
	  
	  // VP AVOIDANCE:
      int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
      int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("classSocket"), 6.0);

	  // IMPORTANT ITEM AVOIDANCE:
	  int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 4.0);
	 	  
	  // NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
	  int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	  int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	  int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

	  // CONSTRAINT TO AVOID WATER:
      int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
	  int avoidWater8 = rmCreateTerrainDistanceConstraint("tree avoid water", "Land", false, 8.0);
      int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water 15", "Land", false, 15.0);
      int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
      int avoidWater30 = rmCreateTerrainDistanceConstraint("avoid water mid-long", "Land", false, 30.0);
      int avoidWater40 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 40.0);

	  // SEAFOOD AVOIDANCE:
	  int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	  
	  
	  // CIRCLE CONSTRAINT:
	  int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// *************************************** DEFINE THE AREAS OF THE MAP: ***************************************** //
/*================================================================================================================*/
/*================================================================================================================*/   
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE BIG CONTINENT: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	  // Build up big continent - called, unoriginally enough, "big continent"
      int bigContinentID=rmCreateArea("big continent");
      rmSetAreaSize(bigContinentID, 0.52, 0.52);		// 0.65, 0.65
      rmSetAreaWarnFailure(bigContinentID, false);
      rmAddAreaConstraint(bigContinentID, longPlayerConstraint);
      rmAddAreaToClass(bigContinentID, classbigContinent);
      rmSetAreaSmoothDistance(bigContinentID, 25);
	  rmSetAreaMix(bigContinentID, "newengland_grass");
      rmSetAreaElevationType(bigContinentID, cElevTurbulence);
      rmSetAreaElevationVariation(bigContinentID, 2.0);
      rmSetAreaBaseHeight(bigContinentID, 6.0);
      rmSetAreaElevationMinFrequency(bigContinentID, 0.09);
      rmSetAreaElevationOctaves(bigContinentID, 3);
      rmSetAreaElevationPersistence(bigContinentID, 0.2);      
	  rmSetAreaCoherence(bigContinentID, 0.5);
	  //rmSetAreaLocation(bigContinentID, 0.5, 0.85);
	  rmSetAreaLocation(bigContinentID, 0.2, 0.5);
      rmSetAreaEdgeFilling(bigContinentID, 5);
	  rmSetAreaObeyWorldCircleConstraint(bigContinentID, false);
	  rmBuildArea(bigContinentID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// ****************************** DEFINE AND PLACE THE SMALL CONTINENT SPURS 1: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	  // Build up small continent spurs called "small continent spur 1 & 2"
      int smallContinent1ID=rmCreateArea("small continent spur 1");
      rmSetAreaSize(smallContinent1ID, 0.2, 0.2);
      rmSetAreaWarnFailure(smallContinent1ID, false);
      rmAddAreaConstraint(smallContinent1ID, longPlayerConstraint);
      rmAddAreaToClass(smallContinent1ID, classbigContinent);
      rmSetAreaSmoothDistance(smallContinent1ID, 25);
	  rmSetAreaMix(smallContinent1ID, "newengland_grass");
	  //rmSetAreaMix(smallContinent1ID, "texas_grass");
      rmSetAreaElevationType(smallContinent1ID, cElevTurbulence);
      rmSetAreaElevationVariation(smallContinent1ID, 2.0);
      rmSetAreaBaseHeight(smallContinent1ID, 6.0);
      rmSetAreaElevationMinFrequency(smallContinent1ID, 0.09);
      rmSetAreaElevationOctaves(smallContinent1ID, 3);
      rmSetAreaElevationPersistence(smallContinent1ID, 0.2);      
	  rmSetAreaCoherence(smallContinent1ID, 0.5);
	  rmSetAreaLocation(smallContinent1ID, 0.3, 0.8);
      rmSetAreaEdgeFilling(smallContinent1ID, 5);
      rmSetAreaObeyWorldCircleConstraint(smallContinent1ID, false);
	  rmBuildArea(smallContinent1ID);
/*================================================================================================================*/   
// ******************************* DEFINE AND BUILD THE SMALL CONTINENT SPURS 2: ******************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	  // Build up small continent spurs called "small continent spur 1 & 2"
      int smallContinent2ID=rmCreateArea("small continent spur 2");
      rmSetAreaSize(smallContinent2ID, 0.2, 0.2);
      rmSetAreaWarnFailure(smallContinent2ID, false);
      rmAddAreaConstraint(smallContinent2ID, longPlayerConstraint);
      rmAddAreaToClass(smallContinent2ID, classbigContinent);
      rmSetAreaSmoothDistance(smallContinent2ID, 25);
	  rmSetAreaMix(smallContinent2ID, "newengland_grass");
	  //rmSetAreaMix(smallContinent2ID, "great plains drygrass");
      rmSetAreaElevationType(smallContinent2ID, cElevTurbulence);
      rmSetAreaElevationVariation(smallContinent2ID, 2.0);
      rmSetAreaBaseHeight(smallContinent2ID, 6.0);
      rmSetAreaElevationMinFrequency(smallContinent2ID, 0.09);
      rmSetAreaElevationOctaves(smallContinent2ID, 3);
      rmSetAreaElevationPersistence(smallContinent2ID, 0.2);      
	  rmSetAreaCoherence(smallContinent2ID, 0.5);
	  //rmSetAreaLocation(smallContinent2ID, 0.2, 0.6);
	  rmSetAreaLocation(smallContinent2ID, 0.3, 0.2);
      rmSetAreaEdgeFilling(smallContinent2ID, 5);
      rmSetAreaObeyWorldCircleConstraint(smallContinent2ID, false);
	  rmBuildArea(smallContinent2ID);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE ISLES OF SHOALS: ************************************** //
/*================================================================================================================*/
      // Isles of Shoals - these are set in specific locations.
      int bonusIslandID1=rmCreateArea("isle of shoals 1");
      rmSetAreaSize(bonusIslandID1, rmAreaTilesToFraction(350), rmAreaTilesToFraction(350));
	  rmSetAreaTerrainType(bonusIslandID1, "new_england\ground1_ne");
      rmSetAreaMix(bonusIslandID1, "newengland_grass");
	  // rmSetAreaMix(bonusIslandID1, "newengland_rock");
      rmSetAreaBaseHeight(bonusIslandID1, 6.0);
      rmSetAreaSmoothDistance(bonusIslandID1, 5);
      rmSetAreaWarnFailure(bonusIslandID1, false);
	  //rmSetAreaMinBlobs(bonusIslandID1, 4);
      //rmSetAreaMaxBlobs(bonusIslandID1, 5);
      //rmSetAreaMinBlobDistance(bonusIslandID1, 8.0);
	  //rmSetAreaMaxBlobDistance(bonusIslandID1, 12.0);
	  rmSetAreaMinBlobs(bonusIslandID1, 1);
      rmSetAreaMaxBlobs(bonusIslandID1, 1);
      rmSetAreaMinBlobDistance(bonusIslandID1, 1.0);
	  rmSetAreaMaxBlobDistance(bonusIslandID1, 1.0);
      rmSetAreaCoherence(bonusIslandID1, 0.50);
      rmAddAreaConstraint(bonusIslandID1, bigContinentConstraint);
      rmAddAreaConstraint(bonusIslandID1, longPlayerConstraint);

	  rmSetAreaLocation(bonusIslandID1, 0.9, 0.5);
      rmBuildArea(bonusIslandID1);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE MOUNTAIN: *************************************** //
/*================================================================================================================*/
	    int numTries = 1;
	    for(i=0; <numTries)
	{
		int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa"+i);
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));  
		rmSetAreaWarnFailure(smallMesaID, false);
		//rmSetAreaCliffType(smallMesaID, "Caribbean");
		rmSetAreaCliffType(smallMesaID, "New England");
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID, rmRandInt(6, 8), 1.0, 1.0);  
		rmSetAreaCoherence(smallMesaID, 0.88);
		rmSetAreaLocation(smallMesaID, 0.35, 0.49); 
		
		rmBuildArea(smallMesaID);
	}

	    // Special AREA CONSTRAINT and use it to make resources avoid the big mtn in center:
		int smallMesaConstraint = rmCreateAreaDistanceConstraint("avoid Small Mesa", smallMesaID, 4.0);	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// *********************************** SET UP THE PLAYERS STARTING LOCATIONS: *********************************** //
/*================================================================================================================*/
	    if ( cNumberTeams == 2 )
	{
		rmSetPlacementTeam(0);
		//rmPlacePlayersLine(0.2, 0.5, 0.2, 0.8, 0.0, 0.2);
		  rmPlacePlayersLine(0.25, 0.2, 0.45, 0.2, 0.0, 0.2);

		rmSetPlacementTeam(1);
		//rmPlacePlayersLine(0.8, 0.5, 0.8, 0.8, 0.0, 0.2);
		  rmPlacePlayersLine(0.25, 0.8, 0.45, 0.8, 0.0, 0.2);
	}
	    else
	{
	   rmSetPlacementSection(0.75, 0.25);
	   rmSetTeamSpacingModifier(0.75);
	   rmPlacePlayersCircular(0.4, 0.4, 0);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
   float playerFraction=rmAreaTilesToFraction(100);
   
   for(i=1; <cNumberPlayers)
   {
      // CREATE THE AREA:
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
      
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA TO MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD AREA CONSTRAINT:
	  // rmAddAreaConstraint(id, playerConstraint); 
      // rmAddAreaConstraint(id, playerEdgeConstraint); 
      
	  // SET AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
      
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
   }
      // BUILD THE AREAS.
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
   // PLACEMENT ORDER:
   // TRADE ROUTE -> LAKES -> NATIVES -> SECRETS -> CLIFFS -> NUGGETS:
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE TRADE ROUTES: ************************************* //
/*================================================================================================================*/
/*================================================================================================================*/	
// ********************************** DEFINE AND PLACE THE 2 TRADE ROUTES: ************************************** //
/*================================================================================================================*/ 
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	  int tradeRouteID = rmCreateTradeRoute();
      int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRouteID, 0.6, 0.320);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.1, 0.320);
	 // rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.1, 0.324, 10, 4);

      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.05);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.95);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 2:
	  int tradeRoute2ID = rmCreateTradeRoute();
      socketID=rmCreateObjectDef("sockets to dock Trade Posts north");
      rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.6, 0.65);
	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.1, 0.65);
	  //rmAddRandomTradeRouteWaypoints(tradeRoute2ID, 0.1, 0.65, 10, 4);

      placedTradeRoute = rmBuildTradeRoute(tradeRoute2ID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 2:
      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.05);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.95);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// **************************************** DEFINE AND PLACE THE LAKES: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/   
// *********************************** DEFINE AND PLACE THE NATIVE AMERICANS: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois1VillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		rmAddGroupingConstraint(iroquois1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois1VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.35, 0.375);
	} 

	if (subCiv1 == rmGetCivID("iroquois"))
	{  
		int iroquoisVillageID = -1;
		iroquoisVillageID = rmCreateGrouping("iroquois village", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquoisVillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquoisVillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(iroquoisVillageID, 0.0);
		rmAddGroupingConstraint(iroquoisVillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquoisVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquoisVillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquoisVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquoisVillageID, 0, 0.35, 0.6);
	} 
	
	if (subCiv2 == rmGetCivID("iroquois"))
	{  
		int iroquois3VillageID = -1;
		iroquois3VillageID = rmCreateGrouping("iroquois3 village", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois3VillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		rmAddGroupingConstraint(iroquois3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois3VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois3VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.35, 0.9);
	}

	if (subCiv3 == rmGetCivID("iroquois"))
	{  
		int iroquois4VillageID = -1;
		iroquois4VillageID = rmCreateGrouping("iroquois4 village", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois4VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois4VillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(iroquois4VillageID, 0.0);
		rmAddGroupingConstraint(iroquois4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois4VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois4VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.35, 0.1);
	} 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// ******************************* DEFINE THE STARTING TCID AND THE STARTING UNITS: ***************************** //
/*================================================================================================================*/
   // Starting Unit placement
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	rmSetObjectDefMinDistance(startingUnits, 5.0);
	rmSetObjectDefMaxDistance(startingUnits, 10.0);
	rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(startingUnits, avoidAll);

	int startingTCID= rmCreateObjectDef("startingTC");
	if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
/*----------------------------------------------------------------------------------------------------------------*/
	int silverType = -1;
	int playerGoldID = -1;

	int StartAreaTreeID=rmCreateObjectDef("starting trees");
	rmAddObjectDefItem(StartAreaTreeID, "TreeNewEngland", 1, 0.0);
	rmSetObjectDefMinDistance(StartAreaTreeID, 10.0);
	rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	int StartBerryBushID=rmCreateObjectDef("starting BerryBush");
	rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 5.0);
	rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
	rmSetObjectDefMaxDistance(StartBerryBushID, 15.0);
	rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);

	int playerNuggetID=rmCreateObjectDef("player nugget");
	rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
    rmSetObjectDefMinDistance(playerNuggetID, 30.0);
    rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	rmAddObjectDefConstraint(playerNuggetID, avoidPlayerNugget);
	rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	// rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

	int waterFlagID=-1;
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/   
// ******************** PLACE THE STARTING TCID AND THE STARTING UNITS AND STARTING RESOURCES: ****************** //
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
	{
		rmClearClosestPointConstraints();
		// Place starting units and a TC!
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Everyone gets one ore grouping close by.
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddGroupingToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// Placing starting trees...
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Nuggets
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Water flag
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		rmClearClosestPointConstraints();
	}
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 1: **************************************** //
/*================================================================================================================*/
	  int nugget1ID= rmCreateObjectDef("nugget 1"); 
	  rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget1ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	  rmAddObjectDefConstraint(nugget1ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.45, 0.55);
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 2: **************************************** //
/*================================================================================================================*/
	  int nugget2ID= rmCreateObjectDef("nugget 2"); 
	  rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget2ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	  rmAddObjectDefConstraint(nugget2ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.25, 0.55);
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 3: **************************************** //
/*================================================================================================================*/
	  int nugget3ID= rmCreateObjectDef("nugget 3"); 
	  rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget3ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	  rmAddObjectDefConstraint(nugget3ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.125, 0.60);	  
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 4: **************************************** //
/*================================================================================================================*/
	  int nugget4ID= rmCreateObjectDef("nugget 4"); 
	  rmAddObjectDefItem(nugget4ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget4ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget4ID, 0.0);
	  rmAddObjectDefConstraint(nugget4ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.125, 0.725);
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 5: **************************************** //
/*================================================================================================================*/
	  int nugget5ID= rmCreateObjectDef("nugget 5"); 
	  rmAddObjectDefItem(nugget5ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget5ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget5ID, 0.0);
	  rmAddObjectDefConstraint(nugget5ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.58, 0.60);	
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 6: **************************************** //
/*================================================================================================================*/
	  int nugget6ID= rmCreateObjectDef("nugget 6"); 
	  rmAddObjectDefItem(nugget6ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget6ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget6ID, 0.0);
	  rmAddObjectDefConstraint(nugget6ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget6ID, 0, 0.56, 0.75);	
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 7: **************************************** //
/*================================================================================================================*/
	  int nugget7ID= rmCreateObjectDef("nugget 7"); 
	  rmAddObjectDefItem(nugget7ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget7ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget7ID, 0.0);
	  rmAddObjectDefConstraint(nugget7ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget7ID, 0, 0.5, 0.9);	  	  
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 8: **************************************** //
/*================================================================================================================*/
	  int nugget8ID= rmCreateObjectDef("nugget 8"); 
	  rmAddObjectDefItem(nugget8ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget8ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget8ID, 0.0);
	  rmAddObjectDefConstraint(nugget8ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget8ID, 0, 0.175, 0.25);	  	
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 9: **************************************** //
/*================================================================================================================*/
	  int nugget9ID= rmCreateObjectDef("nugget 9"); 
	  rmAddObjectDefItem(nugget9ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget9ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget9ID, 0.0);
	  rmAddObjectDefConstraint(nugget9ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget9ID, 0, 0.06, 0.37);	
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 10: **************************************** //
/*================================================================================================================*/
	  int nugget10ID= rmCreateObjectDef("nugget 10"); 
	  rmAddObjectDefItem(nugget10ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget10ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget10ID, 0.0);
	  rmAddObjectDefConstraint(nugget10ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget10ID, 0, 0.44, 0.36);	
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 11: **************************************** //
/*================================================================================================================*/
	  int nugget11ID= rmCreateObjectDef("nugget 11"); 
	  rmAddObjectDefItem(nugget11ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget11ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget11ID, 0.0);
	  rmAddObjectDefConstraint(nugget11ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget11ID, 0, 0.42, 0.3);
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 12: **************************************** //
/*================================================================================================================*/
	  int nugget12ID= rmCreateObjectDef("nugget 12"); 
	  rmAddObjectDefItem(nugget12ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget12ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget12ID, 0.0);
	  rmAddObjectDefConstraint(nugget12ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget12ID, 0, 0.6, 0.36);	 
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 13: **************************************** //
/*================================================================================================================*/
	  int nugget13ID= rmCreateObjectDef("nugget 13"); 
	  rmAddObjectDefItem(nugget13ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget13ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget13ID, 0.0);
	  rmAddObjectDefConstraint(nugget13ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget13ID, 0, 0.3, 0.105);	
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 14: **************************************** //
/*================================================================================================================*/
	  int nugget14ID= rmCreateObjectDef("nugget 14"); 
	  rmAddObjectDefItem(nugget14ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget14ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget14ID, 0.0);
	  rmAddObjectDefConstraint(nugget14ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget14ID, 0, 0.51, 0.05);	
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE NUGGETS 15: **************************************** //
/*================================================================================================================*/
	  int nugget15ID= rmCreateObjectDef("nugget 15"); 
	  rmAddObjectDefItem(nugget15ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget15ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget15ID, 0.0);
	  rmAddObjectDefConstraint(nugget15ID, avoidNugget);
	  rmSetNuggetDifficulty(2, 3);
	  rmPlaceObjectDefAtLoc(nugget15ID, 0, 0.40, 0.68);			  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FORESTS NUMBER 1: ************************************ //
/*================================================================================================================*/
      int forestTreeID = 0;
      int failCount=0;

      for (i=0; <numTries)
   {   
      int forest=rmCreateArea("forest "+i, rmAreaID("big continent"));
      rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
      rmSetAreaForestType(forest, "new england forest");
      rmSetAreaForestDensity(forest, 1.0);
      rmSetAreaForestClumpiness(forest, 0.9);
      rmSetAreaForestUnderbrush(forest, 0.0);
      rmSetAreaCoherence(forest, 0.4);
      rmSetAreaSmoothDistance(forest, 10);
      rmAddAreaToClass(forest, rmClassID("classForest")); 
      rmAddAreaConstraint(forest, forestConstraint);
      rmAddAreaConstraint(forest, avoidAll);
      rmAddAreaConstraint(forest, avoidImpassableLand); 
      rmAddAreaConstraint(forest, avoidTradeRoute);
	  rmAddAreaConstraint(forest, avoidStartingUnits);
	  rmAddAreaConstraint(forest, avoidSocket);
	  rmAddAreaConstraint(forest, avoidCoin);
	  rmSetAreaLocation(forest, 0.55, 0.475); 
	  if(rmBuildArea(forest)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
      }
         else
         failCount=0; 
   } 
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FORESTS NUMBER 2: ************************************ //
/*================================================================================================================*/
      failCount=0;

      for (i=0; <numTries)
   {   
      int forest2=rmCreateArea("forest 2"+i, rmAreaID("big continent"));
      rmSetAreaWarnFailure(forest2, false);
      rmSetAreaSize(forest2, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
      rmSetAreaForestType(forest2, "new england forest");
      rmSetAreaForestDensity(forest2, 1.0);
      rmSetAreaForestClumpiness(forest2, 0.9);
      rmSetAreaForestUnderbrush(forest2, 0.0);
      rmSetAreaCoherence(forest2, 0.4);
      rmSetAreaSmoothDistance(forest2, 10);
      rmAddAreaToClass(forest2, rmClassID("classForest")); 
      rmAddAreaConstraint(forest2, forestConstraint);
      rmAddAreaConstraint(forest2, avoidAll);
      rmAddAreaConstraint(forest2, avoidImpassableLand); 
      rmAddAreaConstraint(forest2, avoidTradeRoute);
	  rmAddAreaConstraint(forest2, avoidStartingUnits);
	  rmAddAreaConstraint(forest2, avoidSocket);
	  rmAddAreaConstraint(forest2, avoidCoin);
	  rmSetAreaLocation(forest2, 0.15, 0.475); 
	  if(rmBuildArea(forest2)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
      }
         else
         failCount=0; 
   } 
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //
/*================================================================================================================*/
   // FISHES AVOIDANCE:
   int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 10.0);
   int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
   int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 25.0);

   // DEFINE AND PLACE THE FISHCOD:
   int fishID=rmCreateObjectDef("fish");
   rmAddObjectDefItem(fishID, "FishCod", 3, 6.0);
   rmSetObjectDefMinDistance(fishID, 0.0);
   rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fishID, fishVsFishID);
   rmAddObjectDefConstraint(fishID, fishLand);
   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*15);

	// DEFINE AND PLACE THE FAST COIN -- WHALES:
	int whaleID=rmCreateObjectDef("whale");
   rmAddObjectDefItem(whaleID, "minkeWhale", 1, 9.0);
   rmSetObjectDefMinDistance(whaleID, 0.0);
   rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
   rmAddObjectDefConstraint(whaleID, whaleLand);
   rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
/*================================================================================================================*/   
/*==================================================================================================================*/
// ********************************** DEFINE AND PLACE THE SCATTERED GOLD MINES 1: ********************************** //
/*==================================================================================================================*/
	  int goldID = rmCreateObjectDef("random gold 1");
	  rmAddObjectDefItem(goldID, "minegold", 1, 0);
	  rmSetObjectDefMinDistance(goldID, 0.0);
	  rmSetObjectDefMaxDistance(goldID, 0.0);
	  rmAddObjectDefConstraint(goldID, avoidCoin);
	  rmPlaceObjectDefAtLoc(goldID, 0, 0.45, 0.05);
/*==================================================================================================================*/
// ********************************** DEFINE AND PLACE THE SCATTERED GOLD MINES 2: ********************************** //
/*==================================================================================================================*/
	  int gold2ID = rmCreateObjectDef("random gold 2");
	  rmAddObjectDefItem(gold2ID, "minegold", 1, 0);
	  rmSetObjectDefMinDistance(gold2ID, 0.0);
	  rmSetObjectDefMaxDistance(gold2ID, 0.0);
	  rmAddObjectDefConstraint(gold2ID, avoidCoin);
	  rmPlaceObjectDefAtLoc(gold2ID, 0, 0.45, 0.95);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE SCATTERED GOLD MINES 3: ******************************** //
/*================================================================================================================*/
	  int gold3ID = rmCreateObjectDef("random gold 3");
	  rmAddObjectDefItem(gold3ID, "minegold", 1, 0);
	  rmSetObjectDefMinDistance(gold3ID, 0.0);
	  rmSetObjectDefMaxDistance(gold3ID, 0.0);
	  rmAddObjectDefConstraint(gold3ID, avoidCoin);
	  rmPlaceObjectDefAtLoc(gold3ID, 0, 0.45, 0.385);	  
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE SCATTERED GOLD MINES 4: ******************************** //
/*================================================================================================================*/
	  int gold4ID = rmCreateObjectDef("random gold 4");
	  rmAddObjectDefItem(gold4ID, "minegold", 1, 0);
	  rmSetObjectDefMinDistance(gold4ID, 0.0);
	  rmSetObjectDefMaxDistance(gold4ID, 0.0);
	  rmAddObjectDefConstraint(gold4ID, avoidCoin);
	  rmPlaceObjectDefAtLoc(gold4ID, 0, 0.45, 0.6);	 
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE SCATTERED GOLD MINES 5: ******************************** //
/*================================================================================================================*/
	  int gold5ID = rmCreateObjectDef("random gold 5");
	  rmAddObjectDefItem(gold5ID, "minegold", 1, 0);
	  rmSetObjectDefMinDistance(gold5ID, 0.0);
	  rmSetObjectDefMaxDistance(gold5ID, 0.0);
	  rmAddObjectDefConstraint(gold5ID, avoidCoin);
	  rmPlaceObjectDefAtLoc(gold5ID, 0, 0.25, 0.6);	  
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE SCATTERED GOLD MINES 6: ******************************** //
/*================================================================================================================*/
	  int gold6ID = rmCreateObjectDef("random gold 6");
	  rmAddObjectDefItem(gold6ID, "minegold", 1, 0);
	  rmSetObjectDefMinDistance(gold6ID, 0.0);
	  rmSetObjectDefMaxDistance(gold6ID, 0.0);
	  rmAddObjectDefConstraint(gold6ID, avoidCoin);
	  rmPlaceObjectDefAtLoc(gold6ID, 0, 0.25, 0.385);
/*================================================================================================================*/	  
// ******************************** DEFINE AND PLACE THE SCATTERED GOLD MINES 7: ******************************** //
/*================================================================================================================*/
	  int gold7ID = rmCreateObjectDef("random gold 7");
	  rmAddObjectDefItem(gold7ID, "minegold", 1, 0);
	  rmSetObjectDefMinDistance(gold7ID, 0.0);
	  rmSetObjectDefMaxDistance(gold7ID, 0.0);
	  rmAddObjectDefConstraint(gold7ID, avoidCoin);
	  rmAddObjectDefConstraint(gold7ID, avoidWater4);
	  rmPlaceObjectDefAtLoc(gold7ID, 0, 0.90, 0.50);	
/*================================================================================================================*/	  
// ******************************** DEFINE AND PLACE THE SCATTERED GOLD MINES 8: ******************************** //
/*================================================================================================================*/
	  int gold8ID = rmCreateObjectDef("random gold 8");
	  rmAddObjectDefItem(gold8ID, "minegold", 1, 0);
	  rmSetObjectDefMinDistance(gold8ID, 0.0);
	  rmSetObjectDefMaxDistance(gold8ID, 0.0);
	  rmAddObjectDefConstraint(gold8ID, avoidCoin);
	  rmPlaceObjectDefAtLoc(gold8ID, 0, 0.65, 0.475);		  
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE SCATTERED GOLD MINES 9: ******************************** //
/*================================================================================================================*/
	  int gold9ID = rmCreateObjectDef("random gold 9");
	  rmAddObjectDefItem(gold9ID, "minegold", 1, 0);
	  rmSetObjectDefMinDistance(gold9ID, 0.0);
	  rmSetObjectDefMaxDistance(gold9ID, 0.0);
	  rmAddObjectDefConstraint(gold9ID, avoidCoin);
	  rmPlaceObjectDefAtLoc(gold9ID, 0, 0.05, 0.5);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE BERRIES 1: **************************************** //
/*================================================================================================================*/
      int berries1ID=rmCreateObjectDef("random berries 1");
	  rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(5,8), 6.0); 
	  rmSetObjectDefMinDistance(berries1ID, 0.0);
	  rmSetObjectDefMaxDistance(berries1ID, 0.0);
	  rmAddObjectDefConstraint(berries1ID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berries1ID, 0, 0.5, 0.95);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE BERRIES 2: **************************************** //
/*================================================================================================================*/
      int berries2ID=rmCreateObjectDef("random berries 2");
	  rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(5,8), 6.0); 
	  rmSetObjectDefMinDistance(berries2ID, 0.0);
	  rmSetObjectDefMaxDistance(berries2ID, 0.0);
	  rmAddObjectDefConstraint(berries2ID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berries2ID, 0, 0.475, 0.1);	  
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE BERRIES 3: **************************************** //
/*================================================================================================================*/
      int berries3ID=rmCreateObjectDef("random berries 3");
	  rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(5,8), 6.0); 
	  rmSetObjectDefMinDistance(berries3ID, 0.0);
	  rmSetObjectDefMaxDistance(berries3ID, 0.0);
	  rmAddObjectDefConstraint(berries3ID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berries3ID, 0, 0.475, 0.385);	 
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE BERRIES 4: **************************************** //
/*================================================================================================================*/
      int berries4ID=rmCreateObjectDef("random berries 4");
	  rmAddObjectDefItem(berries4ID, "berrybush", rmRandInt(5,8), 6.0); 
	  rmSetObjectDefMinDistance(berries4ID, 0.0);
	  rmSetObjectDefMaxDistance(berries4ID, 0.0);
	  rmAddObjectDefConstraint(berries4ID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berries4ID, 0, 0.175, 0.6);	
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE BERRIES 5: **************************************** //
/*================================================================================================================*/
      int berries5ID=rmCreateObjectDef("random berries 5");
	  rmAddObjectDefItem(berries5ID, "berrybush", rmRandInt(5,8), 6.0); 
	  rmSetObjectDefMinDistance(berries5ID, 0.0);
	  rmSetObjectDefMaxDistance(berries5ID, 0.0);
	  rmAddObjectDefConstraint(berries5ID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berries5ID, 0, 0.175, 0.35);
/*================================================================================================================*/	  
// ************************************* DEFINE AND PLACE THE BERRIES 6: **************************************** //
/*================================================================================================================*/
      int berries6ID=rmCreateObjectDef("random berries 6");
	  rmAddObjectDefItem(berries6ID, "berrybush", rmRandInt(5,8), 6.0); 
	  rmSetObjectDefMinDistance(berries6ID, 0.0);
	  rmSetObjectDefMaxDistance(berries6ID, 0.0);
	  rmAddObjectDefConstraint(berries6ID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berries6ID, 0, 0.175, 0.70);
/*================================================================================================================*/	  
// ************************************* DEFINE AND PLACE THE BERRIES 7: **************************************** //
/*================================================================================================================*/
      int berries7ID=rmCreateObjectDef("random berries 7");
	  rmAddObjectDefItem(berries7ID, "berrybush", rmRandInt(5,8), 6.0); 
	  rmSetObjectDefMinDistance(berries7ID, 0.0);
	  rmSetObjectDefMaxDistance(berries7ID, 0.0);
	  rmAddObjectDefConstraint(berries7ID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berries7ID, 0, 0.125, 0.25);
/*================================================================================================================*/	  
// ************************************* DEFINE AND PLACE THE BERRIES 8: **************************************** //
/*================================================================================================================*/
      int berries8ID=rmCreateObjectDef("random berries 8");
	  rmAddObjectDefItem(berries8ID, "berrybush", rmRandInt(5,8), 6.0); 
	  rmSetObjectDefMinDistance(berries8ID, 0.0);
	  rmSetObjectDefMaxDistance(berries8ID, 0.0);
	  rmAddObjectDefConstraint(berries8ID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berries8ID, 0, 0.5, 0.6);	
/*================================================================================================================*/	  
// ************************************* DEFINE AND PLACE THE BERRIES 9: **************************************** //
/*================================================================================================================*/
      int berries9ID=rmCreateObjectDef("random berries 9");
	  rmAddObjectDefItem(berries9ID, "berrybush", rmRandInt(5,8), 6.0); 
	  rmSetObjectDefMinDistance(berries9ID, 0.0);
	  rmSetObjectDefMaxDistance(berries9ID, 0.0);
	  rmAddObjectDefConstraint(berries9ID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berries9ID, 0, 0.575, 0.7);	  
/*================================================================================================================*/	  
// ************************************* DEFINE AND PLACE THE BERRIES 10: **************************************** //
/*================================================================================================================*/
      int berries10ID=rmCreateObjectDef("random berries 10");
	  rmAddObjectDefItem(berries10ID, "berrybush", rmRandInt(5,8), 6.0); 
	  rmSetObjectDefMinDistance(berries10ID, 0.0);
	  rmSetObjectDefMaxDistance(berries10ID, 0.0);
	  rmAddObjectDefConstraint(berries10ID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berries10ID, 0, 0.55, 0.25);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE SHEEPS 1: **************************************** //
/*================================================================================================================*/
	  int sheepID=rmCreateObjectDef("sheep");
	  rmAddObjectDefItem(sheepID, "sheep", rmRandInt(5,8), 6.0);
	  rmSetObjectDefMinDistance(sheepID, 0.0);
	  rmSetObjectDefMaxDistance(sheepID, 0.0);
	  rmAddObjectDefConstraint(sheepID, avoidSheep);
	  rmAddObjectDefConstraint(sheepID, sheepAvoidSheep);
	  rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.7);	  
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE SHEEPS 2: **************************************** //
/*================================================================================================================*/
	  int sheep2ID=rmCreateObjectDef("sheep 2");
	  rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(5,8), 6.0);
	  rmSetObjectDefMinDistance(sheep2ID, 0.0);
	  rmSetObjectDefMaxDistance(sheep2ID, 0.0);
	  rmAddObjectDefConstraint(sheep2ID, avoidSheep);
	  rmAddObjectDefConstraint(sheep2ID, sheepAvoidSheep);
	  rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.25, 0.7);	  
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE SHEEPS 3: **************************************** //
/*================================================================================================================*/
	  int sheep3ID=rmCreateObjectDef("sheep 3");
	  rmAddObjectDefItem(sheep3ID, "sheep", rmRandInt(5,8), 6.0);
	  rmSetObjectDefMinDistance(sheep3ID, 0.0);
	  rmSetObjectDefMaxDistance(sheep3ID, 0.0);
	  rmAddObjectDefConstraint(sheep3ID, avoidSheep);
	  rmAddObjectDefConstraint(sheep3ID, sheepAvoidSheep);
	  rmPlaceObjectDefAtLoc(sheep3ID, 0, 0.25, 0.275);	  	  
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE SHEEPS 4 **************************************** //
/*================================================================================================================*/
	  int sheep4ID=rmCreateObjectDef("sheep 4");
	  rmAddObjectDefItem(sheep4ID, "sheep", rmRandInt(5,8), 6.0);
	  rmSetObjectDefMinDistance(sheep4ID, 0.0);
	  rmSetObjectDefMaxDistance(sheep4ID, 0.0);
	  rmAddObjectDefConstraint(sheep4ID, avoidSheep);
	  rmAddObjectDefConstraint(sheep4ID, sheepAvoidSheep);
	  rmPlaceObjectDefAtLoc(sheep4ID, 0, 0.5, 0.275);
/*================================================================================================================*/   
// ***************************************** DEFINE AND PLACE THE DEERS 1: **************************************** //
/*================================================================================================================*/
      int deerID=rmCreateObjectDef("deer herd");
	  rmAddObjectDefItem(deerID, "deer", rmRandInt(6,8), 4.0);
      rmSetObjectDefMinDistance(deerID, 0.0);
      rmSetObjectDefMaxDistance(deerID, 0.0);
      rmAddObjectDefConstraint(deerID, avoidDeer);
	  rmSetObjectDefCreateHerd(deerID, true);
	  rmPlaceObjectDefAtLoc(deerID, 0, 0.2, 0.15);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE DEERS 2: **************************************** //
/*================================================================================================================*/
      int deer2ID=rmCreateObjectDef("deer herd 2");
	  rmAddObjectDefItem(deer2ID, "deer", rmRandInt(6,8), 4.0);
      rmSetObjectDefMinDistance(deer2ID, 0.0);
      rmSetObjectDefMaxDistance(deer2ID, 0.0);
      rmAddObjectDefConstraint(deer2ID, avoidDeer);
	  rmSetObjectDefCreateHerd(deer2ID, true);
	  rmPlaceObjectDefAtLoc(deer2ID, 0, 0.425, 0.10);	 
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE DEERS 3: **************************************** //
/*================================================================================================================*/
      int deer3ID=rmCreateObjectDef("deer herd 3");
	  rmAddObjectDefItem(deer3ID, "deer", rmRandInt(6,8), 4.0);
      rmSetObjectDefMinDistance(deer3ID, 0.0);
      rmSetObjectDefMaxDistance(deer3ID, 0.0);
      rmAddObjectDefConstraint(deer3ID, avoidDeer);
	  rmSetObjectDefCreateHerd(deer3ID, true);
	  rmPlaceObjectDefAtLoc(deer3ID, 0, 0.285, 0.40);	
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE DEERS 4: **************************************** //
/*================================================================================================================*/
      int deer4ID=rmCreateObjectDef("deer herd 4");
	  rmAddObjectDefItem(deer4ID, "deer", rmRandInt(6,8), 4.0);
      rmSetObjectDefMinDistance(deer4ID, 0.0);
      rmSetObjectDefMaxDistance(deer4ID, 0.0);
      rmAddObjectDefConstraint(deer4ID, avoidDeer);
	  rmSetObjectDefCreateHerd(deer4ID, true);
	  rmPlaceObjectDefAtLoc(deer4ID, 0, 0.35, 0.275);
/*===============================================================================================================*/	  
// **************************************** DEFINE AND PLACE THE DEERS 5: *************************************** //
/*===============================================================================================================*/
      int deer5ID=rmCreateObjectDef("deer herd 5");
	  rmAddObjectDefItem(deer5ID, "deer", rmRandInt(6,8), 4.0);
      rmSetObjectDefMinDistance(deer5ID, 0.0);
      rmSetObjectDefMaxDistance(deer5ID, 0.0);
      rmAddObjectDefConstraint(deer5ID, avoidDeer);
	  rmSetObjectDefCreateHerd(deer5ID, true);
	  rmPlaceObjectDefAtLoc(deer5ID, 0, 0.35, 0.70);	 	  
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE DEERS 6: *************************************** //
/*===============================================================================================================*/
      int deer6ID=rmCreateObjectDef("deer herd 6");
	  rmAddObjectDefItem(deer6ID, "deer", rmRandInt(6,8), 4.0);
      rmSetObjectDefMinDistance(deer6ID, 0.0);
      rmSetObjectDefMaxDistance(deer6ID, 0.0);
      rmAddObjectDefConstraint(deer6ID, avoidDeer);
	  rmSetObjectDefCreateHerd(deer6ID, true);
	  rmPlaceObjectDefAtLoc(deer6ID, 0, 0.40, 0.60);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE DEERS 7: *************************************** //
/*===============================================================================================================*/
      int deer7ID=rmCreateObjectDef("deer herd 7");
	  rmAddObjectDefItem(deer7ID, "deer", rmRandInt(6,8), 4.0);
      rmSetObjectDefMinDistance(deer7ID, 0.0);
      rmSetObjectDefMaxDistance(deer7ID, 0.0);
      rmAddObjectDefConstraint(deer7ID, avoidDeer);
	  rmSetObjectDefCreateHerd(deer7ID, true);
	  rmPlaceObjectDefAtLoc(deer7ID, 0, 0.40, 0.40);	  
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE DEERS 8: *************************************** //
/*===============================================================================================================*/
      int deer8ID=rmCreateObjectDef("deer herd 8");
	  rmAddObjectDefItem(deer8ID, "deer", rmRandInt(6,8), 4.0);
      rmSetObjectDefMinDistance(deer8ID, 0.0);
      rmSetObjectDefMaxDistance(deer8ID, 0.0);
      rmAddObjectDefConstraint(deer8ID, avoidDeer);
	  rmSetObjectDefCreateHerd(deer8ID, true);
	  rmPlaceObjectDefAtLoc(deer8ID, 0, 0.65, 0.50);	
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE DEERS 9: *************************************** //
/*===============================================================================================================*/
      int deer9ID=rmCreateObjectDef("deer herd 9");
	  rmAddObjectDefItem(deer9ID, "deer", rmRandInt(6,8), 4.0);
      rmSetObjectDefMinDistance(deer9ID, 0.0);
      rmSetObjectDefMaxDistance(deer9ID, 0.0);
      rmAddObjectDefConstraint(deer9ID, avoidDeer);
	  rmSetObjectDefCreateHerd(deer9ID, true);
	  rmPlaceObjectDefAtLoc(deer9ID, 0, 0.05, 0.6);	  
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE DEERS 10: *************************************** //
/*===============================================================================================================*/
      int deer10ID=rmCreateObjectDef("deer herd 10");
	  rmAddObjectDefItem(deer10ID, "deer", rmRandInt(6,8), 4.0);
      rmSetObjectDefMinDistance(deer10ID, 0.0);
      rmSetObjectDefMaxDistance(deer10ID, 0.0);
      rmAddObjectDefConstraint(deer10ID, avoidDeer);
	  rmSetObjectDefCreateHerd(deer10ID, true);
	  rmPlaceObjectDefAtLoc(deer10ID, 0, 0.45, 0.90);
/*================================================================================================================*/	  
// ************************************ DEFINE AND PLACE THE RANDOM TREES: ************************************** //
/*================================================================================================================*/
	  int randomTreeID=rmCreateObjectDef("random tree");
	  rmAddObjectDefItem(randomTreeID, "TreeNewEngland", rmRandInt(12,18), 8.0);
	  rmSetObjectDefMinDistance(randomTreeID, 0.0);
	  rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
	  rmAddObjectDefConstraint(randomTreeID, playerConstraint);
	  rmAddObjectDefConstraint(randomTreeID, avoidNugget);
	  rmAddObjectDefConstraint(randomTreeID, avoidFruits);
	  rmAddObjectDefConstraint(randomTreeID, avoidDeer);
	  rmAddObjectDefConstraint(randomTreeID, avoidAll);
	  rmAddObjectDefConstraint(randomTreeID, avoidNatives);
	  rmAddObjectDefConstraint(randomTreeID, avoidSheep);
	  rmAddObjectDefConstraint(randomTreeID, avoidCoin);
	  rmAddObjectDefConstraint(randomTreeID, avoidWater20);
	  rmAddObjectDefConstraint(randomTreeID, avoidSocket);
	  rmAddObjectDefConstraint(randomTreeID, avoidTradeRoute);
	  rmAddObjectDefConstraint(randomTreeID, smallMesaConstraint);
	  rmPlaceObjectDefInArea(randomTreeID, 0, smallContinent1ID, 10); 
      rmPlaceObjectDefInArea(randomTreeID, 0, smallContinent2ID, 10);   	  
/*================================================================================================================*/	  
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}
/*================================================================================================================*/
// **************************************** THIS IS THE END OF THE MAP: ***************************************** //
/*================================================================================================================*/
     
