/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// AZTECS COUNTRY:
// CREATED BY DANY:
// JANUARY 2007:
/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
/*----------------------------------------------------------------------------------------------------------------*/   
        if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Tupi");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Tupi");

		subCiv1=rmGetCivID("Tupi");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Tupi"); 

		subCiv2=rmGetCivID("Tupi");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Tupi");

		subCiv3=rmGetCivID("Aztecs");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Aztecs");
   }		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
      float handedness = rmRandFloat(0.0, 1.0);
	  // > 0.5 is ocean to SE
	  // < 0.5 is ocean to NE
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.06);   
/*================================================================================================================*/   
// ********************************************* PICKS THE MAP SIZE: ******************************************** //
/*================================================================================================================*/
	  int playerTiles = 25000;
	  
	  if (cNumberNonGaiaPlayers >4)
		   playerTiles = 23000;
	  if (cNumberNonGaiaPlayers >6)
		   playerTiles = 21000;			

      int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
      rmEchoInfo("Map size="+size+"m x "+size+"m");
      rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// ***************************************** DEFINE THE MAP PARAMETERS: ***************************************** //
/*================================================================================================================*/
      // PICKS A DEFAULT WATER HEIGHT:
      rmSetSeaLevel(3);

      // SET THE SEA TYPE:
      // rmSetSeaType("atlantic coast");
	     rmSetSeaType("Amazon River Basin");
	        
	  // ENABLE LOCAL WATER:
	  rmEnableLocalWater(false);
      
	  // TERRAIN INITIALIZE:
	  rmTerrainInitialize("water");
	  
	  // SET THE MAP TYPE:
	  rmSetMapType("amazonia");
	  rmSetMapType("tropical");
	  rmSetMapType("water");
	  //rmSetMapType("carolina");
	  //rmSetMapType("water");
	  //rmSetMapType("grass");
      
	  // SET THE LIGHTING:
	  // rmSetLightingSet("carolina");
	     rmSetLightingSet("amazon");
	  
	  // SET THE WORLD CIRCLE CONSTRAINT:
	  rmSetWorldCircleConstraint(true);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/   
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
	  int classPlayer=rmDefineClass("player");
      rmDefineClass("classCliff");
      int classbigContinent=rmDefineClass("big continent");
      rmDefineClass("corner");
      rmDefineClass("startingUnit");
      rmDefineClass("classForest");
      rmDefineClass("importantItem");
	  rmDefineClass("secrets");
	  rmDefineClass("flag");
	  rmDefineClass("classInvis");
	  rmDefineClass("canyon");
	  rmDefineClass("natives");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
      // MAP EDGE CONSTRAINTS:
      int longPlayerConstraint=rmCreateClassDistanceConstraint("continent stays away from players", classPlayer, rmXFractionToMeters(0.15));
	  //	rmEchoInfo("long player constraint = "+rmXFractionToMeters(0.15));

      // PLAYERS CONSTRAINTS:
      int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 20.0);
   
	  int TCvsTC=rmCreateTypeDistanceConstraint("TC avoid same", "TownCenter", 50.0);
      int CWvsCW=rmCreateTypeDistanceConstraint("CW avoid same", "CoveredWagon", 50.0);
	  int forestvsTC=rmCreateTypeDistanceConstraint("forest vs. TC", "TownCenter", 20.0);
	  int forestvsCW=rmCreateTypeDistanceConstraint("forest vs. CW", "CoveredWagon", 20.0);
	  int avoidTC=rmCreateTypeDistanceConstraint("stuff vs TC", "TownCenter", 20.0);
	  int shortAvoidTC=rmCreateTypeDistanceConstraint("stuff less vs TC", "TownCenter", 20.0);
	  int avoidCW=rmCreateTypeDistanceConstraint("stuff vs CW", "CoveredWagon", 60.0);

      int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
      int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
	  
	  // Cardinal Directions
      int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
      int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
      int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(80), rmDegreesToRadians(190));
      int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(260), rmDegreesToRadians(10));

      
	  // INVIS AVOIDANCE:
	  int invisConstraint=rmCreateClassDistanceConstraint("continent avoid invis continent", rmClassID("classInvis"), rmXFractionToMeters(0.15));
	  if (cNumberNonGaiaPlayers >6)
	  invisConstraint=rmCreateClassDistanceConstraint("continent avoid invis continent large map", rmClassID("classInvis"), rmXFractionToMeters(0.20));

      // BONUS AREA CONSTRAINT:
      int bigContinentConstraint=rmCreateClassDistanceConstraint("avoid bonus island", classbigContinent, 20.0);
	  
	  // CANYON AVOIDANCE:
      int avoidCanyon=rmCreateClassDistanceConstraint("avoid canyon", rmClassID("Canyon"), 12.0);

      // UNITS AVOIDANCE:
	  int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 8.0);
	  
	  // TREES AVOIDANCE:
	  int avoidTree=rmCreateTypeDistanceConstraint("stuff avoids tree", "TreeCarolinaGrass", 4.0);
	  int treeAvoidTree=rmCreateTypeDistanceConstraint("tree avoids tree", "TreeCarolinaGrass", 8.0);
	  
	  // GOLD AVOIDANCE:
	  int avoidGold=rmCreateTypeDistanceConstraint("stuff avoids gold", "minegold", 4.0);
	  int goldAvoidGold=rmCreateTypeDistanceConstraint("gold avoids gold", "minegold", 8.0);
	  
	  // COW AVOIDANCE:
	  int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 4.0);
	  int cowAvoidCow=rmCreateTypeDistanceConstraint("cow avoids cow", "cow", 8.0);
	  
	  // RESOURCE AVOIDANCE:
      int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
      int avoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 10.0);
      int avoidBerries=rmCreateTypeDistanceConstraint("berry vs berry", "berryBush", 10.0);
	  int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 10.0);
	  int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 15.0);
      
	  // NUGGET AVOIDANCE:
	  int avoidNugget=rmCreateTypeDistanceConstraint("stuffs avoids nugget", "abstractNugget", 6.0);
	  int nuggetAvoidNugget=rmCreateTypeDistanceConstraint("nugget avoids nugget", "abstractNugget", 12.0);

      // IMPASSABLE LAND AVOIDANCE:
      int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
      int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 12.0);
	  if (cNumberNonGaiaPlayers < 3)
	  longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land small map", "Land", false, 12.0);
      int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
      int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "abstractFish", 10.0);
      int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "humpbackWhale", 45.0);
      int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
      int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	  int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
	  int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

      // UNIT AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0);

      // IMPORTANT OBJECT AVOIDANCE:
      int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
	  int nativeAvoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route socket", "socketTradeRoute", 20.0);
      int avoidImportantItem=rmCreateClassDistanceConstraint("sockets avoid each other", rmClassID("importantItem"), 12.0);
      int silverAvoidImportantItem=rmCreateClassDistanceConstraint("silver avoids sockets", rmClassID("importantItem"), 12.0);

      // CONSTRAINT TO AVOID WATER:
      int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water short", "Land", false, 8.0);
      int avoidWater16 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 16.0);
	  int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 20.0);
	 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/	  
// ************************************ IF ONLY 2 PLAYERS PLACE AS 2 POINTS: ************************************ //
/*================================================================================================================*/
		if ( cNumberTeams == 2 )
	{
		rmSetPlacementTeam(0);
		// rmSetPlacementSection(0.0, 0.15);
		   rmSetPlacementSection(0.90, 0.00);
		rmPlacePlayersCircular(0.35, 0.40, 0.0);

		rmSetPlacementTeam(1);
		// rmSetPlacementSection(0.55, 0.70);
		   rmSetPlacementSection(0.35, 0.45);
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
	}
	else
	{
  		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.40, 0.42, 0.0);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// **************************************** SET UP THE PLAYER AREAS: ******************************************** //
/*================================================================================================================*/
      float playerFraction=rmAreaTilesToFraction(1000);
/*----------------------------------------------------------------------------------------------------------------*/	  
      for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
   {
      // CREATE THE AREA:
	  int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
	  rmSetPlayerArea(i, id);
	  
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
      
	  // SET THE SIZE:
	  rmSetAreaSize(id, playerFraction, playerFraction);
	  
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD AREA CONSTRAINT:
	  rmAddAreaConstraint(id, playerConstraint);
	  rmAddAreaConstraint(id, avoidWater20);
      
	  // SET AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
	  
	  // SET AREA COHERENCE:
	  rmSetAreaCoherence(id, 0.9);
   }
/*----------------------------------------------------------------------------------------------------------------*/   
      // BUILD THE AREAS:
	  rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// ******************** INVISIBLE CONTINENT ADDED TO HAVE BIG CONTINENT AVOID PLAYER AREAS: ********************* //
/*================================================================================================================*/
      int invisContinentID=rmCreateArea("invisible continent for constraint");
	  rmSetAreaSize(invisContinentID, 0.01, 0.01);
      rmSetAreaWarnFailure(invisContinentID, false);

	  if(handedness < 0.5) // NE ocean
	  {
	  //rmSetAreaLocation(invisContinentID, 0.99, 0.5);
	  //rmAddAreaInfluenceSegment(invisContinentID, 0.95, 0.30, 0.99, 0.5);
	  //rmAddAreaInfluenceSegment(invisContinentID, 0.99, 0.5, 0.95, 0.70);
	  rmSetAreaLocation(invisContinentID, 0.20, 0.20);
	  rmAddAreaInfluenceSegment(invisContinentID, 0.1, 0.4, 0.20, 0.20);
	  rmAddAreaInfluenceSegment(invisContinentID, 0.20, 0.20, 0.4, 0.1);
	  }
	  else
	  {			
	  //rmSetAreaLocation(invisContinentID, 0.99, 0.5);
	  //rmAddAreaInfluenceSegment(invisContinentID, 0.95, 0.30, 0.99, 0.5);
	  //rmAddAreaInfluenceSegment(invisContinentID, 0.99, 0.5, 0.95, 0.70);
	  rmSetAreaLocation(invisContinentID, 0.20, 0.20);
	  rmAddAreaInfluenceSegment(invisContinentID, 0.2, 0.2, 0.1, 0.4);
	  rmAddAreaInfluenceSegment(invisContinentID, 0.2, 0.2, 0.4, 0.1);
	  }
	  
	  rmAddAreaToClass(invisContinentID, rmClassID("classInvis"));
	  rmSetAreaCoherence(invisContinentID, 0.8);
      //rmSetAreaBaseHeight(invisContinentID, 3);
      //rmSetAreaMix(invisContinentID, "carolina_grass");

      // BUILD THE AREAS:
      rmBuildArea(invisContinentID);
/*================================================================================================================*/   
/*================================================================================================================*/	  
// ***************************************** BUILD THE BIG CONTINENT: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int bigContinentID = -1;
	  bigContinentID=rmCreateArea("big continent");
	  rmSetAreaSize(bigContinentID, 0.40, 0.47); // 0.38 0.47
	  rmSetAreaWarnFailure(bigContinentID, false);
      rmAddAreaConstraint(bigContinentID, invisConstraint);
	  //rmAddAreaConstraint(bigContinentID, avoidCanyon);
      rmAddAreaToClass(bigContinentID, classbigContinent);

    /*  rmSetAreaMinBlobs(bigContinentID, 10);
      rmSetAreaMaxBlobs(bigContinentID, 10);
      rmSetAreaMinBlobDistance(bigContinentID, rmXFractionToMeters(0.1));
      rmSetAreaMaxBlobDistance(bigContinentID, rmXFractionToMeters(0.4));*/

      rmSetAreaSmoothDistance(bigContinentID, 50);
	  // rmSetAreaMix(bigContinentID, "carolina_grass");
	     rmSetAreaMix(bigContinentID, "amazon grass");
      rmSetAreaElevationType(bigContinentID, cElevTurbulence);
      rmSetAreaElevationVariation(bigContinentID, 4.0);
      rmSetAreaBaseHeight(bigContinentID, 3.5);
      rmSetAreaElevationMinFrequency(bigContinentID, 0.09);
      rmSetAreaElevationOctaves(bigContinentID, 3);
      rmSetAreaElevationPersistence(bigContinentID, 0.2);
	  rmSetAreaElevationNoiseBias(bigContinentID, 1);
		
      rmSetAreaCoherence(bigContinentID, 0.15);
/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** CHOOSE RIGHT OR LEFT-HANDED CONTINENT: *********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
      if(handedness < 0.5) // NE ocean
	  {
      //rmSetAreaLocation(bigContinentID, 0.25, 0.5);
	  rmSetAreaLocation(bigContinentID, 0.60, 0.60);
	  //rmAddAreaInfluenceSegment(bigContinentID, 0.5, 0.0, 0.5, 1.0); 
	  //rmAddAreaInfluenceSegment(bigContinentID, 0.0, 0.5, 0.4, 0.5);
	  rmAddAreaInfluenceSegment(bigContinentID, 0.6, 0.6, 0.8, 0.2); 
	  rmAddAreaInfluenceSegment(bigContinentID, 0.6, 0.6, 0.2, 0.8);
	  	  
	  }
      else // NE ocean
	  {
       //rmSetAreaLocation(bigContinentID, 0.25, 0.5);
	   //rmAddAreaInfluenceSegment(bigContinentID, 0.5, 0.0, 0.5, 1.0); 
	   //rmAddAreaInfluenceSegment(bigContinentID, 0.0, 0.5, 0.4, 0.5);
	   rmSetAreaLocation(bigContinentID, 0.60, 0.60);
	   rmAddAreaInfluenceSegment(bigContinentID, 0.6, 0.6, 0.2, 0.8); 
	   rmAddAreaInfluenceSegment(bigContinentID, 0.6, 0.6, 0.8, 0.2);
       }
/*----------------------------------------------------------------------------------------------------------------*/	  
	  rmSetAreaEdgeFilling(bigContinentID, 10);
		
      rmSetAreaObeyWorldCircleConstraint(bigContinentID, false);

	  rmBuildArea(bigContinentID);
/*================================================================================================================*/
// ********************************************* MOUNTAIN IN CENTER ********************************************* //
/*================================================================================================================*/
	    int numTries = 1;
	    for(i=0; <numTries)
	{
		int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa 1"+i);
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(2250), rmAreaTilesToFraction(2250));  //First # is minimum square meters of material it will use to build.  Second # is maximum.  Currently I have them both set to the same because I want a certain size mountain every time.
		rmSetAreaWarnFailure(smallMesaID, false);
		// rmSetAreaCliffType(smallMesaID, "Bayou");
		   rmSetAreaCliffType(smallMesaID, "Amazon");
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		// rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(smallMesaID, 2, 0.4, 0.1, 1.0, 0);
		// rmSetAreaCliffHeight(smallMesaID, rmRandInt(6, 8), 1.0, 1.0);  //was rmRandInt(6, 8)
		   rmSetAreaCliffHeight(smallMesaID, -8, 1.0, 1.0);  //was rmRandInt(6, 8)
		rmSetAreaCoherence(smallMesaID, 0.88);
		// rmSetAreaLocation(smallMesaID, 0.40, 0.50); 
		   rmSetAreaLocation(smallMesaID, 0.70, 0.70); 
		rmAddAreaInfluencePoint(smallMesaID, 0.65, 0.7); // ADDED BY ME:
		rmAddAreaInfluencePoint(smallMesaID, 0.7, 0.65); // ADDED BY ME:
		rmAddAreaInfluencePoint(smallMesaID, 0.75, 0.7); // ADDED BY ME:
	    rmAddAreaInfluencePoint(smallMesaID, 0.7, 0.75); // ADDED BY ME:
	/*	rmAddAreaInfluenceSegment(smallMesaID, 0.65, 0.85, 0.85, 0.65);  //Bottom - Original segment
		rmAddAreaInfluenceSegment(smallMesaID, 0.85, 0.65, 0.6, 0.4);
		rmAddAreaInfluenceSegment(smallMesaID, 0.6, 0.4, 0.4, 0.6);
		rmAddAreaInfluenceSegment(smallMesaID, 0.4, 0.6, 0.65, 0.85); //Right*/
		
		rmBuildArea(smallMesaID);
	}

	    // SPECIAL AREA CONSTRAINT AND USE IT TO MAKE RESOURCES AVOID THE BIG MTN IN THE CENTER:
		int smallMesaConstraint = rmCreateAreaDistanceConstraint("avoid Small Mesa", smallMesaID, 4.0);
		
		int gold1ID= rmCreateObjectDef("Gold Mines 1"); 
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
		rmAddObjectDefConstraint(gold1ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.7, 0.7);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.75, 0.7);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.65, 0.7);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.7, 0.75);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.7, 0.65);

        for(i=0; <numTries)
	{
		int smallCliff2Height=rmRandInt(0,10);
		int smallMesa2ID=rmCreateArea("small mesa 2"+i);
		rmSetAreaSize(smallMesa2ID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(600));  
		rmSetAreaWarnFailure(smallMesa2ID, false);
		// rmSetAreaCliffType(smallMesa2ID, "Bayou");
		   rmSetAreaCliffType(smallMesa2ID, "Amazon");
		rmAddAreaToClass(smallMesa2ID, rmClassID("canyon"));	
		// rmSetAreaCliffEdge(smallMesa2ID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(smallMesa2ID, 2, 0.4, 0.1, 1.0, 0);
		// rmSetAreaCliffHeight(smallMesa2ID, rmRandInt(6, 8), 1.0, 1.0); 
		   rmSetAreaCliffHeight(smallMesa2ID, -8, 1.0, 1.0); 
		rmSetAreaCoherence(smallMesa2ID, 0.88);
		rmAddAreaConstraint(smallMesa2ID, avoidWater20);
		rmSetAreaLocation(smallMesa2ID, 0.5, 0.5); 
		rmBuildArea(smallMesa2ID);
	}	

        int gold2ID= rmCreateObjectDef("Gold Mines 2"); 
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
		rmAddObjectDefConstraint(gold2ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.5, 0.5);	
	
/*	    for(i=0; <numTries)
	{
		int smallCliff3Height=rmRandInt(0,10);
		int smallMesa3ID=rmCreateArea("small mesa 3"+i);
		rmSetAreaSize(smallMesa3ID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));  
		rmSetAreaWarnFailure(smallMesa3ID, false);
		rmSetAreaCliffType(smallMesa3ID, "Bayou");
		rmAddAreaToClass(smallMesa3ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(smallMesa3ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa3ID, rmRandInt(6, 8), 1.0, 1.0); 
		rmSetAreaCoherence(smallMesa3ID, 0.88);
		rmSetAreaLocation(smallMesa3ID, 0.15, 0.30); 
		rmBuildArea(smallMesa3ID);
	}	*/

/*        for(i=0; <numTries)
	{
		int smallCliff4Height=rmRandInt(0,10);
		int smallMesa4ID=rmCreateArea("small mesa 4"+i);
		rmSetAreaSize(smallMesa4ID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));  
		rmSetAreaWarnFailure(smallMesa4ID, false);
		rmSetAreaCliffType(smallMesa4ID, "Bayou");
		rmAddAreaToClass(smallMesa4ID, rmClassID("canyon"));	
		rmSetAreaCliffEdge(smallMesa4ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa4ID, rmRandInt(6, 8), 1.0, 1.0); 
		rmSetAreaCoherence(smallMesa4ID, 0.88);
		rmSetAreaLocation(smallMesa4ID, 0.125, 0.65); 
		rmBuildArea(smallMesa4ID);
	}	*/	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// *********************************** DEFINE AND PLACE THE TRADE ROUTES: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// *********************************** DEFINE THE PLAYER STARTING RESOURCES: ************************************ //
/*================================================================================================================*/
	  // PLACE TC OR CW NOW: FIND LOCATION LATER TO PLACE OTHER RESOURCES:

	  // DEFINE THE TCID:
	  int TCID = rmCreateObjectDef("player TC");
	  if ( rmGetNomadStart())
		  rmAddObjectDefItem(TCID, "coveredWagon", 1, 0);
	  else
		  rmAddObjectDefItem(TCID, "townCenter", 1, 0);
	  rmSetObjectDefMinDistance(TCID, 0.0);
	  rmSetObjectDefMaxDistance(TCID, 20.0);
	  rmAddObjectDefConstraint(TCID, avoidTradeRoute);
      rmAddObjectDefConstraint(TCID, TCvsTC);
      rmAddObjectDefConstraint(TCID, CWvsCW);
      rmAddObjectDefConstraint(TCID, avoidImpassableLand);
	  for(i=1; <cNumberPlayers)
	{
	  rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

	}

	  // DEFINE THE STARTING UNITS:
	  int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
      rmSetObjectDefMinDistance(startingUnits, 6.0);
      rmSetObjectDefMaxDistance(startingUnits, 10.0);
	  rmAddObjectDefConstraint(startingUnits, avoidAll);
      rmAddObjectDefConstraint(startingUnits, shortAvoidImpassableLand);
/*----------------------------------------------------------------------------------------------------------------*/
	  // DEFINE THE PLAYER SILVER MINES:
	  int playerSilverID = rmCreateObjectDef("player silver");
	  rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	  rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	  rmSetObjectDefMinDistance(playerSilverID, 18.0);
	  rmSetObjectDefMaxDistance(playerSilverID, 22.0);
	  rmAddObjectDefConstraint(playerSilverID, avoidAll);
      rmAddObjectDefConstraint(playerSilverID, shortAvoidImpassableLand);

	  // DEFINE THE PLAYER CRATES:
	  int playerCrateID=rmCreateObjectDef("bonus starting crates");
      rmAddObjectDefItem(playerCrateID, "crateOfFood", rmRandInt(2,3), 4.0);
      rmAddObjectDefItem(playerCrateID, "crateOfWood", rmRandInt(1,3), 4.0);
      rmAddObjectDefItem(playerCrateID, "crateOfCoin", 1, 4.0);
      rmSetObjectDefMinDistance(playerCrateID, 6);
      rmSetObjectDefMaxDistance(playerCrateID, 10);
	  rmAddObjectDefConstraint(playerCrateID, avoidAll);
      rmAddObjectDefConstraint(playerCrateID, shortAvoidImpassableLand);

	  // DEFINE THE PLAYER BERRIES:
	  int playerBerryID=rmCreateObjectDef("player berries");
      rmAddObjectDefItem(playerBerryID, "berryBush", rmRandInt(2,3), 2.0);
      rmSetObjectDefMinDistance(playerBerryID, 10);
      rmSetObjectDefMaxDistance(playerBerryID, 15);
	  rmAddObjectDefConstraint(playerBerryID, avoidAll);
	  //rmAddObjectDefConstraint(playerBerryID, avoidNatives);
	  rmAddObjectDefConstraint(playerBerryID, smallMesaConstraint);
      rmAddObjectDefConstraint(playerBerryID, shortAvoidImpassableLand);

	  // DEFINE THE FAR BERRIES:
	  int farBerriesID=rmCreateObjectDef("far berries");
      rmAddObjectDefItem(farBerriesID, "berryBush", rmRandInt(5,8), 4.0);
      rmSetObjectDefMinDistance(farBerriesID, 30);
      rmSetObjectDefMaxDistance(farBerriesID, 40);
	  rmAddObjectDefConstraint(farBerriesID, avoidAll);
	  rmAddObjectDefConstraint(farBerriesID, smallMesaConstraint);
	  rmAddObjectDefConstraint(farBerriesID, avoidNatives);
	  rmAddObjectDefConstraint(farBerriesID, avoidTC);
	  rmAddObjectDefConstraint(farBerriesID, avoidCW);
	  rmAddObjectDefConstraint(farBerriesID, avoidBerries);
      rmAddObjectDefConstraint(farBerriesID, avoidImpassableLand);

	  // DEFINE THE PLAYER TREE:
	  int playerTreeID=rmCreateObjectDef("player trees");
      // rmAddObjectDefItem(playerTreeID, "TreeCarolinaGrass", 1, 0.0);
	     rmAddObjectDefItem(playerTreeID, "TreeAmazon", rmRandInt(2,3), 10.0);
      rmSetObjectDefMinDistance(playerTreeID, 8);
      rmSetObjectDefMaxDistance(playerTreeID, 12);
	  rmAddObjectDefConstraint(playerTreeID, avoidAll);
      rmAddObjectDefConstraint(playerTreeID, shortAvoidImpassableLand);
	  
	  // DEFINE THE FAR PLAYER TREE:
	  int farPlayerTreeID=rmCreateObjectDef("far player trees");
      // rmAddObjectDefItem(farPlayerTreeID, "TreeCarolinaGrass", 1, 0.0);
	     rmAddObjectDefItem(farPlayerTreeID, "TreeAmazon", rmRandInt(2,3), 10.0);
      rmSetObjectDefMinDistance(farPlayerTreeID, 20);
      rmSetObjectDefMaxDistance(farPlayerTreeID, 35);
	  rmAddObjectDefConstraint(farPlayerTreeID, avoidAll);
      rmAddObjectDefConstraint(farPlayerTreeID, shortAvoidImpassableLand);

	  // DEFINE THE WATER FLAG:
	  int waterFlagID=rmCreateObjectDef("HC water flag "+i);
	  rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
      rmAddClosestPointConstraint(flagEdgeConstraint);
	  rmAddClosestPointConstraint(flagVsFlag);
	  rmAddClosestPointConstraint(bigContinentConstraint);
	  rmAddClosestPointConstraint(fishLand);
	 
      // DEFINE THE NUGGETS EASY PER PLAYER:
	  int nugget1= rmCreateObjectDef("nugget easy"); 
	  rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmAddObjectDefConstraint(nugget1, shortAvoidImpassableLand);
  	  rmAddObjectDefConstraint(nugget1, avoidNugget);
  	  rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
  	  rmAddObjectDefConstraint(nugget1, avoidAll);
	  rmAddObjectDefConstraint(nugget1, avoidCanyon);
	  rmAddObjectDefConstraint(nugget1, avoidNatives);
	  rmSetObjectDefMinDistance(nugget1, 40.0);
	  rmSetObjectDefMaxDistance(nugget1, 50.0);

	  // DEFINE THE NUGGETS MEDIUM PER PLAYER:
	  int nugget2= rmCreateObjectDef("nugget medium"); 
	  rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(2, 2);
	  rmSetObjectDefMinDistance(nugget2, 0.0);
	  rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(nugget2, shortAvoidImpassableLand);
  	  rmAddObjectDefConstraint(nugget2, avoidNugget);
  	  rmAddObjectDefConstraint(nugget2, avoidTC);
  	  rmAddObjectDefConstraint(nugget2, avoidCW);
  	  rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
  	  rmAddObjectDefConstraint(nugget2, avoidAll);
	  rmAddObjectDefConstraint(nugget2, avoidCanyon);
	  rmAddObjectDefConstraint(nugget2, avoidNatives);
  	  rmAddObjectDefConstraint(nugget2, avoidWater20);
	  rmSetObjectDefMinDistance(nugget2, 55.0);
	  rmSetObjectDefMaxDistance(nugget2, 60.0);
      
	  // DEFINE THE NEAR DEERS:
	  int nearDeerID=rmCreateObjectDef("deer herds near town");
      // rmAddObjectDefItem(nearDeerID, "deer", rmRandInt(8,10), 10.0);
	     rmAddObjectDefItem(nearDeerID, "turkey", rmRandInt(8,10), 10.0);
      rmSetObjectDefMinDistance(nearDeerID, 30);
      rmSetObjectDefMaxDistance(nearDeerID, 40);
      rmAddObjectDefConstraint(nearDeerID, avoidDeer);
	  rmAddObjectDefConstraint(nearDeerID, avoidAll);
	  rmAddObjectDefConstraint(nearDeerID, avoidBerries);
	  rmAddObjectDefConstraint(nearDeerID, avoidGold);
	  rmAddObjectDefConstraint(nearDeerID, avoidNatives);
	  rmAddObjectDefConstraint(nearDeerID, avoidCanyon);
	  rmAddObjectDefConstraint(nearDeerID, avoidWater8);
      rmAddObjectDefConstraint(nearDeerID, avoidImpassableLand);
      rmSetObjectDefCreateHerd(nearDeerID, true);

	  // DEFINE THE FAR DEERS:
	  int farDeerID=rmCreateObjectDef("deer herds far away");
	  
	  int bonusChance=rmRandFloat(0, 1);
      if(bonusChance<0.5)   
      // rmAddObjectDefItem(farDeerID, "deer", rmRandInt(8,10), 10.0);
	     rmAddObjectDefItem(farDeerID, "tapir", rmRandInt(8,10), 10.0);
      else
      // rmAddObjectDefItem(farDeerID, "deer", rmRandInt(12,16), 10.0);
	     rmAddObjectDefItem(farDeerID, "capybara", rmRandInt(12,16), 10.0);
      
	  rmSetObjectDefMinDistance(farDeerID, 60);
      rmSetObjectDefMaxDistance(farDeerID, 70);
      rmAddObjectDefConstraint(farDeerID, avoidDeer);
	  rmAddObjectDefConstraint(farDeerID, avoidAll);
	  rmAddObjectDefConstraint(farDeerID, avoidBerries);
	  rmAddObjectDefConstraint(farDeerID, avoidGold);
	  rmAddObjectDefConstraint(farDeerID, avoidNatives);
	  rmAddObjectDefConstraint(farDeerID, avoidCanyon);
	  rmAddObjectDefConstraint(farDeerID, avoidWater8);
	  rmAddObjectDefConstraint(farDeerID, avoidTC);
	  rmAddObjectDefConstraint(farDeerID, avoidCW);
      rmAddObjectDefConstraint(farDeerID, avoidImpassableLand);
      rmSetObjectDefCreateHerd(farDeerID, true);
	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// *********************************** DEFINE AND PLACE THE NATIVE AMERICANS: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      if (subCiv0 == rmGetCivID("Tupi"))
	{  
		int tupi1VillageID = -1;
		tupi1VillageID = rmCreateGrouping("tupi village 1", "native tupi village 1");
		rmSetGroupingMinDistance(tupi1VillageID, 0.0);
		rmSetGroupingMaxDistance(tupi1VillageID, 0.0);
		rmAddGroupingToClass(tupi1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(tupi1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(tupi1VillageID, 0, 0.5, 0.71);
	}
	
	  if (subCiv1 == rmGetCivID("Tupi"))
	{  
		int tupi2VillageID = -1;
		tupi2VillageID = rmCreateGrouping("tupi village 2", "native tupi village 1");
		rmSetGroupingMinDistance(tupi2VillageID, 0.0);
		rmSetGroupingMaxDistance(tupi2VillageID, 0.0);
		rmAddGroupingToClass(tupi2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(tupi2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(tupi2VillageID, 0, 0.73, 0.49);
	}
	
	  if (subCiv2 == rmGetCivID("Tupi"))
	{  
		int tupi3VillageID = -1;
		tupi3VillageID = rmCreateGrouping("tupi village 3", "native tupi village 1");
		rmSetGroupingMinDistance(tupi3VillageID, 0.0);
		rmSetGroupingMaxDistance(tupi3VillageID, 0.0);
		rmAddGroupingToClass(tupi3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(tupi3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(tupi3VillageID, 0, 0.825, 0.80);
	}
	
/*	  if (subCiv3 == rmGetCivID("aztecs"))
	{  
		int aztecs4VillageID = -1;
		aztecs4VillageID = rmCreateGrouping("aztecs village 4", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs4VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs4VillageID, 0.0);
		rmAddGroupingToClass(aztecs4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs4VillageID, 0, 0.50, 0.35);
	}*/

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// ********************************** DEFINE AND PLACE THE FAR SILVER MINES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //
/*================================================================================================================*/
      int fishID=rmCreateObjectDef("sardine");
      rmAddObjectDefItem(fishID, "FishSardine", 3, 4.0);
      rmSetObjectDefMinDistance(fishID, 0.0);
      rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(fishID, fishVsFishID);
      rmAddObjectDefConstraint(fishID, fishLand);
      rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);

      int fish2ID=rmCreateObjectDef("tarpon");
      rmAddObjectDefItem(fish2ID, "FishTarpon", 3, 4.0);
      rmSetObjectDefMinDistance(fish2ID, 0.0);
      rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(fish2ID, fishVsFishID);
      rmAddObjectDefConstraint(fish2ID, fishLand);
      rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);

	  int whaleID=rmCreateObjectDef("whale");
      rmAddObjectDefItem(whaleID, "humpbackWhale", 1, 9.0);
      rmSetObjectDefMinDistance(whaleID, 0.0);
      rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
      rmAddObjectDefConstraint(whaleID, whaleLand);
      rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// ************************************* PLACE PLAYER STARTING RESOURCES: *************************************** //
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
	
	{
		
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		if (rmGetNomadStart() == false)
		
		rmPlaceObjectDefAtLoc(playerCrateID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farPlayerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
				
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(farBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(nugget2, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		rmPlaceObjectDefAtLoc(nearDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(farDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
	
	}

	    rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE RESOURCES 1: **************************************** //
/*================================================================================================================*/
		int berries1ID= rmCreateObjectDef("The Berries 1"); 
		rmAddObjectDefItem(berries1ID, "berryBush", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidBerries);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.5, 0.77);

        int cow1ID= rmCreateObjectDef("The big Cows 1"); 
		rmAddObjectDefItem(cow1ID, "cow", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(cow1ID, 0.0);
		rmSetObjectDefMaxDistance(cow1ID, 0.0);
		rmAddObjectDefConstraint(cow1ID, avoidCow);
		rmAddObjectDefConstraint(cow1ID, cowAvoidCow);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.55, 0.81);		
		
		int nugget5= rmCreateObjectDef("The Nugget 1"); 
	    rmAddObjectDefItem(nugget5, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nugget5, 0.0);
	    rmSetObjectDefMaxDistance(nugget5, 0.0);
	    rmAddObjectDefConstraint(nugget5, avoidNugget);
  	    rmAddObjectDefConstraint(nugget5, nuggetAvoidNugget);
  	    rmPlaceObjectDefAtLoc(nugget5, 0, 0.49, 0.63);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE RESOURCES 2: ***************************************** //
/*================================================================================================================*/        		
		int berries2ID= rmCreateObjectDef("The Berries 2"); 
		rmAddObjectDefItem(berries2ID, "berryBush", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidBerries);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.76, 0.86);
		
		int cow2ID= rmCreateObjectDef("The big Cows 2"); 
		rmAddObjectDefItem(cow2ID, "cow", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(cow2ID, 0.0);
		rmSetObjectDefMaxDistance(cow2ID, 0.0);
		rmAddObjectDefConstraint(cow2ID, avoidCow);
		rmAddObjectDefConstraint(cow2ID, cowAvoidCow);
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.75, 0.4);
        rmPlaceObjectDefAtLoc(cow2ID, 0, 0.9, 0.5);
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.58, 0.56);
		
		int cow3ID= rmCreateObjectDef("The big Cows 3"); 
		rmAddObjectDefItem(cow3ID, "cow", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(cow3ID, 0.0);
		rmSetObjectDefMaxDistance(cow3ID, 0.0);
		rmAddObjectDefConstraint(cow3ID, avoidCow);
		rmAddObjectDefConstraint(cow3ID, cowAvoidCow);
		rmPlaceObjectDefAtLoc(cow3ID, 0, 0.9, 0.5);
		rmPlaceObjectDefAtLoc(cow3ID, 0, 0.22, 0.68);
		rmPlaceObjectDefAtLoc(cow3ID, 0, 0.68, 0.22);
		
		int cow4ID= rmCreateObjectDef("The big Cows 4"); 
		rmAddObjectDefItem(cow4ID, "cow", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(cow4ID, 0.0);
		rmSetObjectDefMaxDistance(cow4ID, 0.0);
		rmAddObjectDefConstraint(cow4ID, avoidCow);
		rmAddObjectDefConstraint(cow4ID, cowAvoidCow);
		rmPlaceObjectDefAtLoc(cow4ID, 0, 0.59, 0.56);
		
		int berries4ID= rmCreateObjectDef("The Berries 4"); 
		rmAddObjectDefItem(berries4ID, "berryBush", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(berries4ID, 0.0);
		rmSetObjectDefMaxDistance(berries4ID, 0.0);
		rmAddObjectDefConstraint(berries4ID, avoidBerries);
		rmPlaceObjectDefAtLoc(berries4ID, 0, 0.62, 0.52);
		
		int berries5ID= rmCreateObjectDef("The Berries 5"); 
		rmAddObjectDefItem(berries5ID, "berryBush", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(berries5ID, 0.0);
		rmSetObjectDefMaxDistance(berries5ID, 0.0);
		rmAddObjectDefConstraint(berries5ID, avoidBerries);
		rmPlaceObjectDefAtLoc(berries5ID, 0, 0.4, 0.95);
		
		
		int nugget6= rmCreateObjectDef("The Nugget 2"); 
	    rmAddObjectDefItem(nugget6, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nugget6, 0.0);
	    rmSetObjectDefMaxDistance(nugget6, 0.0);
	    rmAddObjectDefConstraint(nugget6, avoidNugget);
  	    rmAddObjectDefConstraint(nugget6, nuggetAvoidNugget);
  	    rmPlaceObjectDefAtLoc(nugget6, 0, 0.9, 0.70);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE RESOURCES 3: ***************************************** //
/*================================================================================================================*/
        int berries3ID= rmCreateObjectDef("The Berries 3"); 
		rmAddObjectDefItem(berries3ID, "berryBush", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(berries3ID, 0.0);
		rmSetObjectDefMaxDistance(berries3ID, 0.0);
		rmAddObjectDefConstraint(berries3ID, avoidBerries);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.72, 0.42);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.20, 0.70);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.70, 0.20);
		
	
		int nugget7= rmCreateObjectDef("The Nugget 3"); 
	    rmAddObjectDefItem(nugget7, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget7, 0.0);
	    rmSetObjectDefMaxDistance(nugget7, 0.0);
	    rmAddObjectDefConstraint(nugget7, avoidNugget);
  	    rmAddObjectDefConstraint(nugget7, nuggetAvoidNugget);
  	    rmPlaceObjectDefAtLoc(nugget7, 0, 0.8, 0.55);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE RESOURCES 4: ***************************************** //
/*================================================================================================================*/
 		int deer1ID= rmCreateObjectDef("The Deers 1"); 
		rmAddObjectDefItem(deer1ID, "deer", rmRandInt(6,9), 5.0);
		rmSetObjectDefMinDistance(deer1ID, 0.0);
		rmSetObjectDefMaxDistance(deer1ID, 0.0);
		rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.70, 0.90);
		
		int deer2ID= rmCreateObjectDef("The Deers 2"); 
		rmAddObjectDefItem(deer2ID, "deer", rmRandInt(6,9), 5.0);
		rmSetObjectDefMinDistance(deer2ID, 0.0);
		rmSetObjectDefMaxDistance(deer2ID, 0.0);
		rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.5, 0.95);
		
		int deer3ID= rmCreateObjectDef("The Deers 3"); 
		rmAddObjectDefItem(deer3ID, "deer", rmRandInt(6,9), 5.0);
		rmSetObjectDefMinDistance(deer3ID, 0.0);
		rmSetObjectDefMaxDistance(deer3ID, 0.0);
		rmAddObjectDefConstraint(deer3ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.95, 0.5);
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.13, 0.70);
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.70, 0.13);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE RANDOM GOLD MINES: ************************************ //
/*================================================================================================================*/
		int gold3ID= rmCreateObjectDef("Gold Mines 3"); 
		rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
		rmSetObjectDefMaxDistance(gold3ID, 0.0);
		rmAddObjectDefConstraint(gold3ID, avoidGold);
		rmAddObjectDefConstraint(gold3ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.93, 0.34);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.93, 0.44);
        rmPlaceObjectDefAtLoc(gold3ID, 0, 0.60, 0.35);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.42, 0.75);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.42, 0.90);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.32, 0.65);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.30, 0.70);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.24, 0.85);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.1, 0.725);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.725, 0.1);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE RANDOM TREES: ************************************* //
/*================================================================================================================*/
		int treeID= rmCreateObjectDef("The Trees"); 
		rmAddObjectDefItem(treeID, "TreeAmazon", rmRandInt(15,21), 12.0);
		rmSetObjectDefMinDistance(treeID, 0.0);
		rmSetObjectDefMaxDistance(treeID, 0.0);
		rmAddObjectDefConstraint(treeID, shortAvoidImpassableLand);
  		rmAddObjectDefConstraint(treeID, avoidTree);
		rmAddObjectDefConstraint(treeID, treeAvoidTree);
  		//rmAddObjectDefConstraint(treeID, avoidGold);
  		rmAddObjectDefConstraint(treeID, avoidAll);
		//rmAddObjectDefConstraint(treeID, avoidBerries);
		//rmAddObjectDefConstraint(treeID, avoidNugget);
		//rmAddObjectDefConstraint(treeID, avoidCanyon);
		//rmAddObjectDefConstraint(treeID, avoidNatives);
  		rmAddObjectDefConstraint(treeID, avoidWater20);
		rmPlaceObjectDefAtLoc(treeID, 0, 0.16, 0.75);
        rmPlaceObjectDefAtLoc(treeID, 0, 0.75, 0.16);
        rmPlaceObjectDefAtLoc(treeID, 0, 0.55, 0.36);
		rmPlaceObjectDefAtLoc(treeID, 0, 0.36, 0.55);

        int tree2ID= rmCreateObjectDef("The Trees 2");
        int bonusChance2=rmRandFloat(0, 1);
        if(bonusChance2<0.5)   
        rmAddObjectDefItem(tree2ID, "Nugget", 1, 0.0);
	    else 
        rmAddObjectDefItem(tree2ID, "Moose", 3, 4.0);
		rmSetObjectDefMinDistance(tree2ID, 0.0);
		rmSetObjectDefMaxDistance(tree2ID, 0.0);
		rmAddObjectDefConstraint(tree2ID, avoidTree);
		rmAddObjectDefConstraint(tree2ID, treeAvoidTree);
		rmAddObjectDefConstraint(tree2ID, avoidWater16);
  		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.56, 0.60);
		
		int tree3ID= rmCreateObjectDef("The Trees 3"); 
		int bonusChance1=rmRandFloat(0, 1);
        if(bonusChance1 <0.50)
        rmAddObjectDefItem(tree3ID, "Nugget", 1, 0.0);
		else
		rmAddObjectDefItem(tree3ID, "berryBush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(tree3ID, 0.0);
		rmSetObjectDefMaxDistance(tree3ID, 0.0);
		rmAddObjectDefConstraint(tree3ID, avoidTree);
		rmAddObjectDefConstraint(tree3ID, treeAvoidTree);
		rmAddObjectDefConstraint(tree3ID, avoidWater16);
  		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.39, 0.46);
		
		int tree4ID= rmCreateObjectDef("The Trees 4"); 
		int bonusChance3=rmRandFloat(0, 1);
        if(bonusChance3 <0.50)
        rmAddObjectDefItem(tree4ID, "Nugget", 1, 0.0);
		else
		rmAddObjectDefItem(tree4ID, "berryBush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(tree4ID, 0.0);
		rmSetObjectDefMaxDistance(tree4ID, 0.0);
		rmAddObjectDefConstraint(tree4ID, avoidTree);
		rmAddObjectDefConstraint(tree4ID, treeAvoidTree);
		rmAddObjectDefConstraint(tree4ID, avoidWater16);
  		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.47, 0.38);
        
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/   
// ********************************** DEFINE AND PLACE THE FOREST NUMBER 1A: ************************************ //         
/*================================================================================================================*/
		 int forestTreeID = 0;
         numTries=0.5*cNumberNonGaiaPlayers;
         int failCount=0;
         for (i=0; <numTries)
      {   
         int forest=rmCreateArea("forest "+i, rmAreaID("big continent"));
		 rmSetAreaWarnFailure(forest, false);
         rmSetAreaSize(forest, rmAreaTilesToFraction(350), rmAreaTilesToFraction(350));
         // rmSetAreaForestType(forest, "carolina pine forest");
		    rmSetAreaForestType(forest, "amazon rain forest");
         // rmSetAreaForestDensity(forest, 0.8);
		    rmSetAreaForestDensity(forest, 1.0);
         // rmSetAreaForestClumpiness(forest, 0.6);
		    rmSetAreaForestClumpiness(forest, 1.0);
         rmSetAreaForestUnderbrush(forest, 0.0);
         /* rmSetAreaMinBlobs(forest, 1);
         rmSetAreaMaxBlobs(forest, 5);
         rmSetAreaMinBlobDistance(forest, 16.0);
         rmSetAreaMaxBlobDistance(forest, 70.0); */
         rmSetAreaCoherence(forest, 0.4);
		 rmSetAreaSmoothDistance(forest, 0);
         rmAddAreaToClass(forest, rmClassID("classForest")); 
         rmAddAreaConstraint(forest, forestConstraint);
         rmAddAreaConstraint(forest, avoidCanyon);
		 rmAddAreaConstraint(forest, avoidNatives);
		 rmAddAreaConstraint(forest, avoidBerries);
		 rmAddAreaConstraint(forest, avoidGold);
		 //rmSetAreaLocation(forest, 0.45, 0.75); // ok
         rmSetAreaLocation(forest, 0.60, 0.90); 		 
         if(rmBuildArea(forest)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
      } 
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FOREST NUMBER 1B: ************************************ //         
/*================================================================================================================*/
		 for (i=0; <numTries)
      {   
         int forest12=rmCreateArea("forest 12"+i, rmAreaID("big continent"));
		 rmSetAreaWarnFailure(forest12, false);
         rmSetAreaSize(forest12, rmAreaTilesToFraction(350), rmAreaTilesToFraction(350));
         // rmSetAreaForestType(forest12, "carolina pine forest");
		    rmSetAreaForestType(forest12, "amazon rain forest");
         rmSetAreaForestDensity(forest12, 0.8);
         rmSetAreaForestClumpiness(forest12, 0.6);
         rmSetAreaForestUnderbrush(forest12, 0.0);
         rmSetAreaCoherence(forest12, 0.4);
         rmSetAreaSmoothDistance(forest12, 0);
         rmAddAreaToClass(forest12, rmClassID("classForest")); 
         rmAddAreaConstraint(forest12, forestConstraint);
         rmAddAreaConstraint(forest12, avoidCanyon);
		 rmAddAreaConstraint(forest12, avoidNatives);
		 rmAddAreaConstraint(forest12, avoidBerries);
		 rmAddAreaConstraint(forest12, avoidGold);
		 rmSetAreaLocation(forest12, 0.90, 0.60); // ok
         
		 if(rmBuildArea(forest12)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
      }		  
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE FOREST NUMBER 2: ************************************ //         
/*================================================================================================================*/
		 for (i=0; <numTries)
      {   
         int forest2=rmCreateArea("forest 2"+i, rmAreaID("big continent"));
		 rmSetAreaWarnFailure(forest2, false);
         rmSetAreaSize(forest2, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
         // rmSetAreaForestType(forest2, "carolina pine forest");
		    rmSetAreaForestType(forest2, "amazon rain forest");
         rmSetAreaForestDensity(forest2, 0.8);
         rmSetAreaForestClumpiness(forest2, 0.6);
         rmSetAreaForestUnderbrush(forest2, 0.0);
         rmSetAreaCoherence(forest2, 0.4);
         rmSetAreaSmoothDistance(forest2, 0);
         rmAddAreaToClass(forest2, rmClassID("classForest")); 
         rmAddAreaConstraint(forest2, forestConstraint);
         rmAddAreaConstraint(forest2, avoidCanyon);
		 rmAddAreaConstraint(forest2, avoidNatives);
		 rmAddAreaConstraint(forest2, avoidBerries);
		 rmAddAreaConstraint(forest2, avoidGold);
		 rmSetAreaLocation(forest2, 0.85, 0.45); // ok
         
		 if(rmBuildArea(forest2)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
      }	 
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE FOREST NUMBER 3: ************************************ //         
/*================================================================================================================*/
		 for (i=0; <numTries)
      {   
         int forest3=rmCreateArea("forest 3"+i, rmAreaID("big continent"));
		 rmSetAreaWarnFailure(forest3, false);
         rmSetAreaSize(forest3, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
         // rmSetAreaForestType(forest3, "carolina pine forest");
		    rmSetAreaForestType(forest3, "amazon rain forest");
         rmSetAreaForestDensity(forest3, 0.8);
         rmSetAreaForestClumpiness(forest3, 0.6);
         rmSetAreaForestUnderbrush(forest3, 0.0);
         rmSetAreaCoherence(forest3, 0.4);
         rmSetAreaSmoothDistance(forest3, 0);
         rmAddAreaToClass(forest3, rmClassID("classForest")); 
         rmAddAreaConstraint(forest3, forestConstraint);
         rmAddAreaConstraint(forest3, avoidCanyon);
		 rmAddAreaConstraint(forest3, avoidNatives);
		 rmAddAreaConstraint(forest3, avoidBerries);
		 rmAddAreaConstraint(forest3, avoidGold);
		 rmSetAreaLocation(forest3, 0.45, 0.85); // ok
         
		 if(rmBuildArea(forest3)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
      }	 
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FOREST NUMBER 4A: ************************************ //         
/*================================================================================================================*/
		 for (i=0; <numTries)
      {   
         int forest41=rmCreateArea("forest 41"+i, rmAreaID("big continent"));
		 rmSetAreaWarnFailure(forest41, false);
         rmSetAreaSize(forest41, rmAreaTilesToFraction(350), rmAreaTilesToFraction(350));
         // rmSetAreaForestType(forest41, "carolina pine forest");
		    rmSetAreaForestType(forest41, "amazon rain forest");
         rmSetAreaForestDensity(forest41, 0.8);
         rmSetAreaForestClumpiness(forest41, 0.6);
         rmSetAreaForestUnderbrush(forest41, 0.0);
         rmSetAreaCoherence(forest41, 0.4);
         rmSetAreaSmoothDistance(forest41, 0);
         rmAddAreaToClass(forest41, rmClassID("classForest")); 
         rmAddAreaConstraint(forest41, forestConstraint);
         rmAddAreaConstraint(forest41, avoidCanyon);
		 rmAddAreaConstraint(forest41, avoidNatives);
		 rmAddAreaConstraint(forest41, avoidBerries);
		 rmAddAreaConstraint(forest41, avoidGold);
		 rmSetAreaLocation(forest41, 0.65, 0.45); // ok
         
		 if(rmBuildArea(forest41)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
      }	 
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FOREST NUMBER 4B: ************************************ //         
/*================================================================================================================*/
		 for (i=0; <numTries)
      {   
         int forest42=rmCreateArea("forest 42"+i, rmAreaID("big continent"));
		 rmSetAreaWarnFailure(forest42, false);
         rmSetAreaSize(forest42, rmAreaTilesToFraction(350), rmAreaTilesToFraction(350));
         // rmSetAreaForestType(forest42, "carolina pine forest");
		    rmSetAreaForestType(forest42, "amazon rain forest");
         rmSetAreaForestDensity(forest42, 0.8);
         rmSetAreaForestClumpiness(forest42, 0.6);
         rmSetAreaForestUnderbrush(forest42, 0.0);
         rmSetAreaCoherence(forest42, 0.4);
         rmSetAreaSmoothDistance(forest42, 0);
         rmAddAreaToClass(forest42, rmClassID("classForest")); 
         rmAddAreaConstraint(forest42, forestConstraint);
         rmAddAreaConstraint(forest42, avoidCanyon);
		 rmAddAreaConstraint(forest42, avoidNatives);
		 rmAddAreaConstraint(forest42, avoidBerries);
		 rmAddAreaConstraint(forest42, avoidGold);
		 rmSetAreaLocation(forest42, 0.40, 0.65); // ok
         
		 if(rmBuildArea(forest42)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
      }	 	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}  
/*================================================================================================================*/
// **************************************** THIS IS THE END OF THE MAP: ***************************************** //  
/*================================================================================================================*/
   	  