/*================================================================================================================*/
// ************************************** THESE ARE THE INFOS OF THE MAP: *************************************** //
/*================================================================================================================*/
// TUPI TERRITORY:
// CREATED BY DANY:
// AUGUST 2007:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
        int subCiv4=-1;
        int subCiv5=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/		

	// CHOOSE WHICH VARIATION TO USE: 1=SOUTHEAST TRADE ROUTE, 2=NORTHWEST TRADE ROUTE:
	int whichMap=rmRandInt(1,2);
	// int whichMap=2;

	// ARE THERE EXTRA MEETING POLES:
	int extraPoles=rmRandInt(1,2);
	extraPoles=1;
	// int extraPoles=2;
	
/*----------------------------------------------------------------------------------------------------------------*/	

        if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Tupi");
		rmEchoInfo("subCiv0 is Tupi "+subCiv0);
		if (subCiv0 >= 0)
		rmSetSubCiv(0, "Tupi");

		subCiv1=rmGetCivID("Tupi");
		rmEchoInfo("subCiv1 is Tupi "+subCiv1);
		if (subCiv1 >= 0)
		rmSetSubCiv(1, "Tupi");

		subCiv2=rmGetCivID("Tupi");
		rmEchoInfo("subCiv2 is Tupi "+subCiv2);
		if (subCiv2 >= 0)
		rmSetSubCiv(2, "Tupi");
		
		subCiv3=rmGetCivID("Tupi");
		rmEchoInfo("subCiv3 is Tupi "+subCiv3);
		if (subCiv3 >= 0)
		rmSetSubCiv(3, "Tupi");
		
		subCiv4=rmGetCivID("Tupi");
		rmEchoInfo("subCiv4 is Tupi "+subCiv4);
		if (subCiv4 >= 0)
		rmSetSubCiv(4, "Tupi");
		
		subCiv5=rmGetCivID("Tupi");
		rmEchoInfo("subCiv5 is Tupi "+subCiv5);
		if (subCiv5 >= 0)
		rmSetSubCiv(5, "Tupi");
   }
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/

	    int playerTiles=17500;
        
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(size, size);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** DEFINE THE MAP PARAMETERS: ***************************************** //
/*================================================================================================================*/

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(3.0); // FROM AMAZONIA:
		
		// SET THE SEA TYPE:
		rmSetSeaType("Amazon River Basin"); // FROM AMAZONIA:

        // SET MAP ELEVATION PARAMETERS:
	    rmSetMapElevationParameters(cElevTurbulence, 0.04, 4, 0.4, 6.0); // FROM AMAZONIA:
	
	    // SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("amazon grass"); // FROM AMAZONIA:
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("amazon\groundforest_ama", 5); // FROM AMAZONIA:
	    
		// SET LIGHTING:
		rmSetLightingSet("amazon"); // FROM AMAZONIA:
	    
		// SET MAP TYPE:
		rmSetMapType("amazonia"); // FROM AMAZONIA:
	    rmSetMapType("tropical"); // FROM AMAZONIA:
	    rmSetMapType("water"); // FROM AMAZONIA:
	    
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/

	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("classPatch");
	    rmDefineClass("starting settlement");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("natives");	
	    rmDefineClass("classHillArea");
	    rmDefineClass("socketClass");
	    rmDefineClass("nuggets");
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
   
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);

        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 10.0);
        int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
        int nuggetPlayerConstraint=rmCreateClassDistanceConstraint("nuggets stay away from players a lot", classPlayer, 40.0);

        // Cardinal Directions
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.55, 0.55, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.45, 0.45, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.45, 0.55, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.55, 0.45, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
		
		// DEFINE THE SEAFOOD:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 6.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 4.0);
        	   		
		// RESOURCE AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 25.0);
        int coinForestConstraint=rmCreateClassDistanceConstraint("coin vs. forest", rmClassID("classForest"), 15.0);
        
		// DEFINE THE FOOD AVOIDANCE:
		int avoidCapybara=rmCreateTypeDistanceConstraint("stuff avoids Capybara", "capybara", 15.0);
		int capybaraAvoidCapybara=rmCreateTypeDistanceConstraint("Capybara avoids Capybara", "capybara", 45.0);
        int avoidTapir=rmCreateTypeDistanceConstraint("stuff avoids Tapir", "tapir", 15.0);
		int tapirAvoidTapir=rmCreateTypeDistanceConstraint("Tapir avoids Tapir", "tapir", 45.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids Fruits", "berrybush", 15.0);
		int fruitsAvoidFruits=rmCreateTypeDistanceConstraint("Fruits avoids Fruits", "berrybush", 60.0);
	    
		// COINS AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
	    int avoidStartingCoin=rmCreateTypeDistanceConstraint("starting coin avoids coin", "gold", 22.0);
        
		// NUGGETS AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 40.0);
        int avoidNuggetSmall=rmCreateTypeDistanceConstraint("avoid nuggets by a little", "AbstractNugget", 10.0);

	    int avoidFastCoin=-1;
	    if (cNumberNonGaiaPlayers >6)
	{
		avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.12));
	}
	    else if (cNumberNonGaiaPlayers >4)
	{
		avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.14));
	}
	    else
	{
		avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.16));
	}

        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
        int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
        int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);

        // UNIT AVOIDANCE - FOR THINGS THAT AREN'T IN THE STARTING RESOURCES:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
        int avoidTradeRouteSmall = rmCreateTradeRouteDistanceConstraint("trade route small", 4.0);
        
		// IMPORTANT ITEM AVOIDANCE:
        int avoidImportantItem=rmCreateClassDistanceConstraint("important stuff avoids each other", rmClassID("importantItem"), 15.0);

	    // SOCKETS AVOIDANCE:
		int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);
	    int avoidSocketMore=rmCreateClassDistanceConstraint("bigger socket avoidance", rmClassID("socketClass"), 15.0);

        // CONSTRAINT TO AVOID WATER:
        int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
        int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
        int avoidWater40 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 40.0);

	    // AVOID THE HILLY AREAS:
	    int avoidHills = rmCreateClassDistanceConstraint("avoid Hills", rmClassID("classHillArea"), 5.0);
	
	    // NATIVES AVOID NATIVES:
	    int avoidNatives = rmCreateClassDistanceConstraint("avoid Natives", rmClassID("natives"), 15.0);
	    int avoidNativesNuggets = rmCreateClassDistanceConstraint("nuggets avoid Natives", rmClassID("natives"), 10.0);

	    // CIRCLE CONSTRAINTS:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ************************************ DEFINE THE TRADE ROUTE PLACEMENT: *************************************** //
/*================================================================================================================*/

        int tradeRouteID = rmCreateTradeRoute();

        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 8.0);

	    if ( whichMap == 1 )
	{
		rmAddTradeRouteWaypoint(tradeRouteID, 0.05, 0.3);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.1, 0.6, 10, 4);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.2, 0.8, 10, 4);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.4, 0.9, 10, 4);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.7, 0.95, 20, 4);
	}
	    else
	{
		rmAddTradeRouteWaypoint(tradeRouteID, 0.3, 0.05);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.6, 0.1, 10, 4);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.8, 0.2, 10, 4);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.9, 0.4, 10, 4);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.95, 0.7, 20, 4);
	}

	   // rmAddRandomTradeRouteWaypoints(tradeRouteID, 1.0, 0.5, 20, 4);

        bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
  
	    // ADD THE SOCKETS ALONG THE TRADE ROUTE:
        vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.1);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.9);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

	    if ( extraPoles > 1 )
	{
	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.35);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.65);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ********************************************* DEFINE THE AREAS: ********************************************** //
/*================================================================================================================*/
// ************************************** SET UP PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
	
		if ( whichMap == 1 )
					
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.775,0.775);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.225,0.225);
	}  
		else
    {		
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.225,0.225);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.775,0.775);
	} 
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ******************************************* SET UP PLAYER AREAS: ********************************************* //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(100);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
	    rmAddAreaConstraint(id, avoidTradeRoute); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
   
        // BUILD THE AREAS:
        rmBuildAllAreas();
   
/*================================================================================================================*/
// ********************************** DEFINE SOME VARIABLES NEEDED LATER: *************************************** //
/*================================================================================================================*/

	    int numTries = -1;
	    int failCount = -1;

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NORTHWEST HILLS: ************************************ //
/*================================================================================================================*/

        int hillNorthwestID=rmCreateArea("northwest hills");
        int avoidNW = rmCreateAreaDistanceConstraint("avoid nw", hillNorthwestID, 3.0);

        rmSetAreaSize(hillNorthwestID, 0.2, 0.2);
        rmSetAreaWarnFailure(hillNorthwestID, false);
        rmSetAreaSmoothDistance(hillNorthwestID, 10);
	    // rmSetAreaMix(hillNorthwestID, "great plains grass");
		   rmSetAreaMix(hillNorthwestID, "amazon grass");
	    // rmAddAreaTerrainLayer(hillNorthwestID, "great_plains\ground8_gp", 0, 4);
        // rmAddAreaTerrainLayer(hillNorthwestID, "great_plains\ground1_gp", 4, 10);
        rmSetAreaElevationType(hillNorthwestID, cElevTurbulence);
        rmSetAreaElevationVariation(hillNorthwestID, 6.0);
        rmSetAreaBaseHeight(hillNorthwestID, 5);
        rmSetAreaElevationMinFrequency(hillNorthwestID, 0.05);
        rmSetAreaElevationOctaves(hillNorthwestID, 3);
        rmSetAreaElevationPersistence(hillNorthwestID, 0.3);      
        rmSetAreaElevationNoiseBias(hillNorthwestID, 0.5);
        rmSetAreaElevationEdgeFalloffDist(hillNorthwestID, 20.0);
	    rmSetAreaCoherence(hillNorthwestID, 0.9);
	    rmSetAreaLocation(hillNorthwestID, 0.5, 0.9);
        rmSetAreaEdgeFilling(hillNorthwestID, 5);
	    rmAddAreaInfluenceSegment(hillNorthwestID, 0.1, 0.95, 0.9, 0.95);
	    rmSetAreaHeightBlend(hillNorthwestID, 1);
	    rmSetAreaObeyWorldCircleConstraint(hillNorthwestID, false);
	    rmAddAreaToClass(hillNorthwestID, rmClassID("classHillArea"));
	    rmBuildArea(hillNorthwestID);
		
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE SOUTHEAST HILLS: *********************************** //
/*================================================================================================================*/

        int hillSoutheastID=rmCreateArea("southeast hills");
        int avoidSE = rmCreateAreaDistanceConstraint("avoid se", hillSoutheastID, 3.0);

        rmSetAreaSize(hillSoutheastID, 0.2, 0.2);
        rmSetAreaWarnFailure(hillSoutheastID, false);
        rmSetAreaSmoothDistance(hillSoutheastID, 10);
	    // rmSetAreaMix(hillSoutheastID, "great plains grass");
		   rmSetAreaMix(hillSoutheastID, "amazon grass");
	    // rmAddAreaTerrainLayer(hillSoutheastID, "great_plains\ground8_gp", 0, 4);
        // rmAddAreaTerrainLayer(hillSoutheastID, "great_plains\ground1_gp", 4, 10);
        rmSetAreaElevationType(hillSoutheastID, cElevTurbulence);
        rmSetAreaElevationVariation(hillSoutheastID, 6.0);
        rmSetAreaBaseHeight(hillSoutheastID, 5);
        rmSetAreaElevationMinFrequency(hillSoutheastID, 0.05);
        rmSetAreaElevationOctaves(hillSoutheastID, 3);
        rmSetAreaElevationPersistence(hillSoutheastID, 0.3);
        rmSetAreaElevationNoiseBias(hillSoutheastID, 0.5);
        rmSetAreaElevationEdgeFalloffDist(hillSoutheastID, 20.0);
	    rmSetAreaCoherence(hillSoutheastID, 0.9);
	    rmSetAreaLocation(hillSoutheastID, 0.5, 0.1);
        rmSetAreaEdgeFilling(hillSoutheastID, 5);
	    rmAddAreaInfluenceSegment(hillSoutheastID, 0.1, 0.05, 0.9, 0.05);
	    rmSetAreaHeightBlend(hillSoutheastID, 1);
	    rmSetAreaObeyWorldCircleConstraint(hillSoutheastID, false);
	    rmAddAreaToClass(hillSoutheastID, rmClassID("classHillArea"));
	    rmBuildArea(hillSoutheastID);
		
/*================================================================================================================*/
// *********************************** THESE LINES WERE REMOVED BY ENSEMBLE: *********************************** //		
/*===============================================================================================================*/

        // Build the areas.
        // rmBuildAllAreas();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/

        // Placement order of non-trade route stuff
        // Natives -> Secrets -> Nuggets -> Small Ponds (whee)

/*================================================================================================================*/
// ****************************** DEFINE THE STARTING UNITS AND STARTING RESOURCES: ***************************** //		
/*================================================================================================================*/

        // DEFINE THE STARTING UNITS AND STARTING TCID:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 7.0);
	    rmSetObjectDefMaxDistance(startingUnits, 12.0);

	    int startingTCID = rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 9.0);
	    rmAddObjectDefConstraint(startingTCID, avoidTradeRouteSmall);

	    // rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);

	    // DEFINE THE STARTING TREES:
	    int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    // rmAddObjectDefItem(StartAreaTreeID, "TreeGreatPlains", 1, 0.0);
		   rmAddObjectDefItem(StartAreaTreeID, "TreeAmazon", rmRandInt(10,15), 0.0); // FROM AMAZONIA:
	    rmSetObjectDefMinDistance(StartAreaTreeID, 12.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 18.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	    // DEFINE THE STARTING TURKEYS:
		int StartTurkeyID=rmCreateObjectDef("starting turkey");
	    rmAddObjectDefItem(StartTurkeyID, "turkey", rmRandInt(5,8), 10.0); // FROM AMAZONIA:
	    rmSetObjectDefMinDistance(StartTurkeyID, 10.0);
	    rmSetObjectDefMaxDistance(StartTurkeyID, 12.0);
	    rmSetObjectDefCreateHerd(StartTurkeyID, true);
	    rmAddObjectDefConstraint(StartTurkeyID, avoidStartingUnitsSmall);
		
		// DEFINE THE STARTING BERRYBUSH:
		int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", rmRandInt(3,5), 6.0); // FROM AMAZONIA:
	    rmSetObjectDefMinDistance(StartBerriesID, 16.0);
	    rmSetObjectDefMaxDistance(StartBerriesID, 18.0);
	    rmSetObjectDefCreateHerd(StartBerriesID, true);
	    rmAddObjectDefConstraint(StartBerriesID, avoidStartingUnitsSmall);
		
		// DEFINE THE STARTING FARBERRYBUSH:
		int StartFarBerriesID=rmCreateObjectDef("starting far berries");
	    rmAddObjectDefItem(StartFarBerriesID, "berrybush", rmRandInt(3,5), 6.0); // FROM AMAZONIA:
	    rmSetObjectDefMinDistance(StartFarBerriesID, 20.0);
	    rmSetObjectDefMaxDistance(StartFarBerriesID, 22.0);
	    rmSetObjectDefCreateHerd(StartFarBerriesID, true);
	    rmAddObjectDefConstraint(StartFarBerriesID, avoidStartingUnitsSmall);
		rmAddObjectDefConstraint(StartFarBerriesID, avoidFruits);

	    // DEFINE THE PLAYER NUGGETS:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerNuggetID, 28.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNativesNuggets);
	    rmAddObjectDefConstraint(playerNuggetID, avoidTradeRouteSmall);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    // rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

	
	    // DEFINE THE VARIABLES FOR THE PLAYER GOLD: 
	    int silverType = -1;
	    int playerGoldID = -1;
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ******************************* PLACE THE STARTING UNITS AND STARTING RESOURCES: ***************************** //		
/*================================================================================================================*/

 	    for(i=1; <cNumberPlayers)
	{
		// PLACE THE STARTING TCID AND THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		// vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
		// rmSetHomeCityGatherPoint(i, closestPoint);

		// EVERYONE GETS TWO ORE OBJECTDEFS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		
		// PLACE TWO GOLD MINES:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING TURKEYS:
		rmPlaceObjectDefAtLoc(StartTurkeyID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartFarBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGET:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ****************************** DEFINE AND PLACE THE NATIVE AMERICANS TRIBES: ********************************* //
/*================================================================================================================*/

        float NativeVillageLoc = rmRandFloat(0,1); //

        if (subCiv0 == rmGetCivID("Tupi"))
   {  
        int tupiVillageAID = -1;
        int tupiVillageType = rmRandInt(1,5);
        tupiVillageAID = rmCreateGrouping("tupi village A", "native tupi village "+tupiVillageType);
		rmSetGroupingMinDistance(tupiVillageAID, 0.0);
        rmSetGroupingMaxDistance(tupiVillageAID, 0.0);
        //rmAddGroupingConstraint(tupiVillageAID, avoidImpassableLand);
        //rmAddGroupingToClass(tupiVillageAID, rmClassID("importantItem"));
        rmAddGroupingToClass(tupiVillageAID, rmClassID("natives"));
        rmAddGroupingConstraint(tupiVillageAID, avoidNatives);
        //rmAddGroupingConstraint(tupiVillageAID, avoidTradeRoute);
	    //rmAddGroupingConstraint(tupiVillageAID, avoidStartingUnits);
		if ( whichMap == 1 )
		{
			rmPlaceGroupingAtLoc(tupiVillageAID, 0, 0.3, 0.5);
		}
		else
		{
			rmPlaceGroupingAtLoc(tupiVillageAID, 0, 0.5, 0.3);
		}
	}
	
/*----------------------------------------------------------------------------------------------------------------*/	

        if (subCiv1 == rmGetCivID("Tupi"))
   {   
        int tupi1VillageAID = -1;
        int tupi1VillageType = rmRandInt(1,5);
        tupi1VillageAID = rmCreateGrouping("tupi village A1", "native tupi village "+tupiVillageType);
		rmSetGroupingMinDistance(tupi1VillageAID, 0.0);
        rmSetGroupingMaxDistance(tupi1VillageAID, 0.0);
        //rmAddGroupingConstraint(tupi1VillageAID, avoidImpassableLand);
        //rmAddGroupingToClass(tupi1VillageAID, rmClassID("importantItem"));
        rmAddGroupingToClass(tupi1VillageAID, rmClassID("natives"));
        rmAddGroupingConstraint(tupi1VillageAID, avoidNatives);
        //rmAddGroupingConstraint(tupi1VillageAID, avoidTradeRoute);
	    //rmAddGroupingConstraint(tupi1VillageAID, avoidStartingUnits);
		if ( whichMap == 1 )
		{
			rmPlaceGroupingAtLoc(tupi1VillageAID, 0, 0.7, 0.5); 
		}
		else
		{
			rmPlaceGroupingAtLoc(tupi1VillageAID, 0, 0.5, 0.7); 
		}
	}

/*----------------------------------------------------------------------------------------------------------------*/	
   
	    if(subCiv2 == rmGetCivID("Tupi"))
   {   
        int tupi2VillageID = -1;
        tupiVillageType = rmRandInt(1,5);
        tupi2VillageID = rmCreateGrouping("tupi village 2", "native tupi village "+tupiVillageType);
		rmSetGroupingMinDistance(tupi2VillageID, 0.0);
        rmSetGroupingMaxDistance(tupi2VillageID, 0.0);
        //rmAddGroupingConstraint(tupi2VillageID, avoidImpassableLand);
        //rmAddGroupingToClass(tupi2VillageID, rmClassID("importantItem"));
        rmAddGroupingToClass(tupi2VillageID, rmClassID("natives"));
        rmAddGroupingConstraint(tupi2VillageID, avoidNatives);
		//rmAddGroupingConstraint(tupi2VillageID, avoidTradeRoute);
		//rmAddGroupingConstraint(tupi2VillageID, avoidStartingUnits);
		if ( extraPoles == 1 )
		{
			if ( whichMap == 1 )
			{
				rmPlaceGroupingAtLoc(tupi2VillageID, 0, 0.175, 0.425);
			}
			else
			{
				rmPlaceGroupingAtLoc(tupi2VillageID, 0, 0.425, 0.175);
			}
		}
   }
   
/*----------------------------------------------------------------------------------------------------------------*/ 

	    if(subCiv3 == rmGetCivID("Tupi"))
   {   
        int tupiVillageBID = -1;
        tupiVillageType = rmRandInt(1,5);
        tupiVillageBID = rmCreateGrouping("tupi village B", "native tupi village "+tupiVillageType);
		rmSetGroupingMinDistance(tupiVillageBID, 0.0);
        rmSetGroupingMaxDistance(tupiVillageBID, 0.0);
        //rmAddGroupingConstraint(tupiVillageBID, avoidImpassableLand);
        //rmAddGroupingToClass(tupiVillageBID, rmClassID("importantItem"));
        rmAddGroupingToClass(tupiVillageBID, rmClassID("natives"));
        rmAddGroupingConstraint(tupiVillageBID, avoidNatives);
	    //rmAddGroupingConstraint(tupiVillageBID, avoidTradeRoute);
	    //rmAddGroupingConstraint(tupiVillageBID, avoidStartingUnits);
		if ( whichMap == 1 )
		{
			rmPlaceGroupingAtLoc(tupiVillageBID, 0, 0.825, 0.575);
		}
		else
		{
			rmPlaceGroupingAtLoc(tupiVillageBID, 0, 0.575, 0.825);
		}
   }

/*----------------------------------------------------------------------------------------------------------------*/   
   
	    if(subCiv4 == rmGetCivID("Tupi"))
   {
        int tupi3VillageID = -1;
        tupiVillageType = rmRandInt(1,5);
        tupi3VillageID = rmCreateGrouping("tupi village 3", "native tupi village "+tupiVillageType);
		rmSetGroupingMinDistance(tupi3VillageID, 0.0);
	    rmSetGroupingMaxDistance(tupi3VillageID, 0.0);
        //rmAddGroupingConstraint(tupi3VillageID, avoidImpassableLand);
        //rmAddGroupingToClass(tupi3VillageID, rmClassID("importantItem"));
        rmAddGroupingToClass(tupi3VillageID, rmClassID("natives"));
        rmAddGroupingConstraint(tupi3VillageID, avoidNatives);
        //rmAddGroupingConstraint(tupi3VillageID, avoidTradeRoute);
	    //rmAddGroupingConstraint(tupi3VillageID, avoidStartingUnits);
		if ( extraPoles == 1 )
		{
			if ( whichMap == 1 )
			{
				rmPlaceGroupingAtLoc(tupi3VillageID, 0, 0.3, 0.7);
			}
			else
			{
				rmPlaceGroupingAtLoc(tupi3VillageID, 0, 0.7, 0.3);
			}
		}
	
	}

/*----------------------------------------------------------------------------------------------------------------*/
	
        if (subCiv5 == rmGetCivID("Tupi"))
   {   
        int tupi3VillageBID = -1;
        tupiVillageType = rmRandInt(1,5);
        tupi3VillageBID = rmCreateGrouping("tupi village B3", "native tupi village "+tupiVillageType);
		rmSetGroupingMinDistance(tupi3VillageBID, 0.0);
        rmSetGroupingMaxDistance(tupi3VillageBID, 0.0);
        //rmAddGroupingConstraint(tupi3VillageBID, avoidImpassableLand);
        //rmAddGroupingToClass(tupi3VillageBID, rmClassID("importantItem"));
        rmAddGroupingToClass(tupi3VillageBID, rmClassID("natives"));
        rmAddGroupingConstraint(tupi3VillageBID, avoidNatives);
        //rmAddGroupingConstraint(tupi3VillageBID, avoidTradeRoute);
	    //rmAddGroupingConstraint(tupi3VillageBID, avoidStartingUnits);

		if ( whichMap == 1 )
		{
			rmPlaceGroupingAtLoc(tupi3VillageBID, 0, 0.7, 0.3);
		}
		else
		{
			rmPlaceGroupingAtLoc(tupi3VillageBID, 0, 0.3, 0.7);
		}
   }

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ****************************************** DEFINE AND PLACE NUGGETS: ***************************************** //
/*================================================================================================================*/

	    int nuggetID= rmCreateObjectDef("nugget"); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nuggetID, shortAvoidImpassableLand);
  	    rmAddObjectDefConstraint(nuggetID, avoidNugget);
		rmAddObjectDefConstraint(nuggetID, avoidNatives);
	    rmAddObjectDefConstraint(nuggetID, nuggetPlayerConstraint);
  	    rmAddObjectDefConstraint(nuggetID, playerConstraint);
  	    rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
	    rmAddObjectDefConstraint(nuggetID, avoidSocketMore);
	    rmAddObjectDefConstraint(nuggetID, avoidNativesNuggets);
	    rmAddObjectDefConstraint(nuggetID, circleConstraint);
  	    rmAddObjectDefConstraint(nuggetID, avoidAll);
	    rmSetNuggetDifficulty(1, 3);
	    rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE PONDS O' FUN: *************************************** //
/*================================================================================================================*/

	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 25.0);

/*---------------------------------------------------------------------------------------------------------------*/
        
        int smallPondID=rmCreateArea("small pond");
        rmSetAreaSize(smallPondID, rmAreaTilesToFraction(1750), rmAreaTilesToFraction(1750));
        rmSetAreaWaterType(smallPondID, "Yucatan Coast");
        rmSetAreaBaseHeight(smallPondID, 4);
        rmSetAreaMinBlobs(smallPondID, 1);
        rmSetAreaMaxBlobs(smallPondID, 1);
        rmSetAreaMinBlobDistance(smallPondID, 1.0);
        rmSetAreaMaxBlobDistance(smallPondID, 1.0);
        rmAddAreaToClass(smallPondID, pondClass);
		rmAddAreaConstraint(smallPondID, avoidNatives);
        rmSetAreaCoherence(smallPondID, 0.95);
        rmSetAreaSmoothDistance(smallPondID, 5);
        rmAddAreaConstraint(smallPondID, pondConstraint);
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.50, 0.50);
        rmBuildArea(smallPondID);  

/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE FISHES AND THE WALES: ********************************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE THE FISHSALMON:
		int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishBass", 3, 6.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.50, 0.50, 5*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE RESOURCES: **************************************** //
// ************************* FAST COIN - THREE EXTRA PER PLAYER BEYOND STARTING RESOURCES: ********************** //
/*================================================================================================================*/

	    int silverID = -1;
	    int silverCount = (cNumberNonGaiaPlayers*3);
	    rmEchoInfo("silver count = "+silverCount);

	    for(i=0; < silverCount)
	{
		silverType = rmRandInt(1,10);
		silverID = rmCreateObjectDef("silver "+i);
		rmAddObjectDefItem(silverID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID, avoidFastCoin);
		rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID, avoidTradeRoute);
		rmAddObjectDefConstraint(silverID, avoidSocket);
		rmAddObjectDefConstraint(silverID, avoidNatives);
		rmAddObjectDefConstraint(silverID, coinForestConstraint);
		rmAddObjectDefConstraint(silverID, avoidStartingUnits);
		rmAddObjectDefConstraint(silverID, avoidNuggetSmall);
		int result = rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
		if(result == 0)
			break;
   }
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE CAPYBARAS: *************************************** //
/*================================================================================================================*/
	
        int capybaraID=rmCreateObjectDef("capybara herd");
        rmAddObjectDefItem(capybaraID, "capybara", rmRandInt(12,16), 12.0); // FROM AMAZONIA:
        rmSetObjectDefMinDistance(capybaraID, 0.0);
        rmSetObjectDefMaxDistance(capybaraID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(capybaraID, avoidCapybara);
	    rmAddObjectDefConstraint(capybaraID, avoidAll);
		rmAddObjectDefConstraint(capybaraID, avoidNatives);
        rmAddObjectDefConstraint(capybaraID, avoidImpassableLand);
	    rmAddObjectDefConstraint(capybaraID, avoidTradeRoute);
	    rmAddObjectDefConstraint(capybaraID, avoidSocket);
	    rmAddObjectDefConstraint(capybaraID, avoidStartingUnits);
	    rmAddObjectDefConstraint(capybaraID, avoidNuggetSmall);
        rmSetObjectDefCreateHerd(capybaraID, true);
	    rmPlaceObjectDefAtLoc(capybaraID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE TAPIRS: ***************************************** //
/*================================================================================================================*/
	
        int tapirID=rmCreateObjectDef("tapir herd");
        rmAddObjectDefItem(tapirID, "tapir", rmRandInt(6,9), 10.0); // FROM AMAZONIA:
        rmSetObjectDefMinDistance(tapirID, 0.0);
        rmSetObjectDefMaxDistance(tapirID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(tapirID, avoidCapybara);
        rmAddObjectDefConstraint(tapirID, tapirAvoidTapir);
	    rmAddObjectDefConstraint(tapirID, avoidAll);
		rmAddObjectDefConstraint(tapirID, avoidNatives);
        rmAddObjectDefConstraint(tapirID, avoidImpassableLand);
	    rmAddObjectDefConstraint(tapirID, avoidTradeRoute);
	    rmAddObjectDefConstraint(tapirID, avoidSocket);
	    rmAddObjectDefConstraint(tapirID, avoidStartingUnits);
	    rmAddObjectDefConstraint(tapirID, avoidNuggetSmall);
        rmSetObjectDefCreateHerd(tapirID, true);
	    rmPlaceObjectDefAtLoc(tapirID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE SE TREE: *************************************** //
/*================================================================================================================*/	
	
        int seConstraint = rmCreateAreaConstraint("se", hillSoutheastID);
        int heightConstraint = rmCreateMaxHeightConstraint("tree height", 6.0);
        int lowForestClass = rmDefineClass("low forest");
        int lowForestConstraint = rmCreateClassDistanceConstraint("low forest", lowForestClass, 4.0);

        // RANDOM TREES:
        int count = 0;
        int maxCount = 20 * cNumberNonGaiaPlayers;
        int maxFailCount = 10 * cNumberNonGaiaPlayers;
        failCount = 0;
        for(i=1; <10)
   {
		int treeArea = rmCreateArea("se tree"+i);
		rmSetAreaSize(treeArea, 0.001, 0.003);
		rmSetAreaForestType(treeArea, "amazon rain forest"); // FROM AMAZONIA:
		rmSetAreaForestDensity(treeArea, 0.8);
		rmSetAreaForestClumpiness(treeArea, 0.1);
		rmAddAreaConstraint(treeArea, seConstraint);
		rmAddAreaConstraint(treeArea, lowForestConstraint);
		rmAddAreaConstraint(treeArea, heightConstraint);
		rmAddAreaConstraint(treeArea, avoidImpassableLand);
		rmAddAreaConstraint(treeArea, avoidTradeRoute);
		rmAddAreaConstraint(treeArea, avoidSocket);
		rmAddAreaConstraint(treeArea, avoidNatives);
		rmAddAreaConstraint(treeArea, avoidStartingUnits);
		rmAddAreaConstraint(treeArea, avoidAll);
		rmAddAreaToClass(treeArea, lowForestClass);
		rmAddAreaConstraint(treeArea, avoidNuggetSmall);
		rmSetAreaWarnFailure(treeArea, false);
		bool ok = rmBuildArea(treeArea);
		if(ok)
		{
			count++;
			if(count > maxCount)
			break;
		}
		else
		{
			failCount++;
			if(failCount > maxFailCount)
			break;
		}
   }
   
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE NW TREE: ***************************************** //
/*================================================================================================================*/

        int nwConstraint = rmCreateAreaConstraint("nw", hillNorthwestID);
        int maxAreas = 5 * cNumberNonGaiaPlayers;
        int maxFails = 5 * cNumberNonGaiaPlayers;
        count = 0;
        failCount = 0;
        for(i=1; <10)
   {
        treeArea = rmCreateArea("nw tree"+i);
        rmSetAreaSize(treeArea, 0.001, 0.003);
	    rmSetAreaForestType(treeArea, "amazon rain forest"); // FROM AMAZONIA:
	    rmSetAreaForestDensity(treeArea, 0.8);
	    rmSetAreaForestClumpiness(treeArea, 0.1);
	    rmAddAreaConstraint(treeArea, nwConstraint);
	    rmAddAreaConstraint(treeArea, lowForestConstraint);
	    rmAddAreaConstraint(treeArea, heightConstraint);
		rmAddAreaConstraint(treeArea, avoidImpassableLand);
		rmAddAreaConstraint(treeArea, avoidTradeRoute);
		rmAddAreaConstraint(treeArea, avoidSocket);
		rmAddAreaConstraint(treeArea, avoidNatives);
		rmAddAreaConstraint(treeArea, avoidStartingUnits);
		rmAddAreaConstraint(treeArea, avoidAll);
		rmAddAreaConstraint(treeArea, avoidNuggetSmall);
	    rmAddAreaToClass(treeArea, lowForestClass);
	    rmSetAreaWarnFailure(treeArea, false);
        ok = rmBuildArea(treeArea);
        if(ok)
      {
        count++;
        if(count > maxCount)
            break;
      }
        else
      {
        failCount++;
        if(failCount > maxFailCount)
        break;
      }
   }
   
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE CENTER FOREST: ************************************** //
/*================================================================================================================*/

        // MINI-FORESTS OUT ON THE PLAINS (MOSTLY)
        int forestTreeID = 0;
        numTries=5*cNumberNonGaiaPlayers;
        failCount=0;
        for (i=0; <numTries)
   {   
		int forest=rmCreateArea("center forest "+i);
		rmSetAreaWarnFailure(forest, false);
		rmSetAreaSize(forest, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
		rmSetAreaForestType(forest, "amazon rain forest"); // FROM AMAZONIA:
		rmSetAreaForestDensity(forest, 0.9);
		rmSetAreaForestClumpiness(forest, 0.8);
		rmSetAreaForestUnderbrush(forest, 0.0);
		rmSetAreaCoherence(forest, 0.5);
		// rmSetAreaSmoothDistance(forest, 10);
		rmAddAreaToClass(forest, rmClassID("classForest")); 
		// rmAddAreaConstraint(forest, lowForestConstraint);
		rmAddAreaConstraint(forest, forestConstraint);
		rmAddAreaConstraint(forest, playerConstraint);
		rmAddAreaConstraint(forest, avoidImportantItem);
		rmAddAreaConstraint(forest, avoidImpassableLand); 
		rmAddAreaConstraint(forest, avoidTradeRoute);
		rmAddAreaConstraint(forest, avoidSocket);
		rmAddAreaConstraint(forest, avoidNatives);
		rmAddAreaConstraint(forest, avoidHills);
		rmAddAreaConstraint(forest, avoidNuggetSmall);
		// rmAddAreaConstraint(forest, avoidFastCoin);
		rmAddAreaConstraint(forest, avoidStartingUnits);
		if(rmBuildArea(forest)==false)
		{
			// Stop trying once we fail 10 times in a row.
			failCount++;
			if(failCount==10)
			break;
		}
		else
			failCount=0; 
   }
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE PERCHING VULTURES: ************************************ //
/*================================================================================================================*/

	    // PERCHING VULTURES - ADD A COUPLE SOMEWHERE:
	    int vultureID=rmCreateObjectDef("perching vultures");
	    rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(vultureID, avoidNW);
	    rmAddObjectDefConstraint(vultureID, avoidSE);
	    rmAddObjectDefConstraint(vultureID, avoidCapybara);
		rmAddObjectDefConstraint(vultureID, avoidTapir);
	    rmAddObjectDefConstraint(vultureID, avoidAll);
		rmAddObjectDefConstraint(vultureID, avoidNatives);
	    rmAddObjectDefConstraint(vultureID, avoidNuggetSmall);
	    rmAddObjectDefConstraint(vultureID, avoidImpassableLand);
	    rmAddObjectDefConstraint(vultureID, avoidTradeRoute);
	    rmAddObjectDefConstraint(vultureID, avoidSocket);
	    rmAddObjectDefConstraint(vultureID, avoidStartingUnits);
	    rmAddObjectDefConstraint(vultureID, circleConstraint);
	    rmAddObjectDefConstraint(vultureID, playerConstraint);
	    rmPlaceObjectDefAtLoc(vultureID, 0, 0.5, 0.5, 2);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ****************************** DEFINE AND PLACE A COUPLE OF RANDOM BERRYBUSH: ******************************** //
/*================================================================================================================*/

	    int RandomBerriesID=rmCreateObjectDef("random berries");
        rmAddObjectDefItem(RandomBerriesID, "berrybush", rmRandInt(3,5), 10.0); // FROM ME
        rmSetObjectDefMinDistance(RandomBerriesID, 0.0);
        rmSetObjectDefMaxDistance(RandomBerriesID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(RandomBerriesID, avoidCapybara);
        rmAddObjectDefConstraint(RandomBerriesID, avoidTapir);
		rmAddObjectDefConstraint(RandomBerriesID, avoidFruits);
		rmAddObjectDefConstraint(RandomBerriesID, fruitsAvoidFruits);
	    rmAddObjectDefConstraint(RandomBerriesID, avoidAll);
		rmAddObjectDefConstraint(RandomBerriesID, avoidNatives);
        rmAddObjectDefConstraint(RandomBerriesID, avoidImpassableLand);
	    rmAddObjectDefConstraint(RandomBerriesID, avoidTradeRoute);
	    rmAddObjectDefConstraint(RandomBerriesID, avoidSocket);
	    rmAddObjectDefConstraint(RandomBerriesID, avoidStartingUnits);
	    rmAddObjectDefConstraint(RandomBerriesID, avoidNuggetSmall);
        rmSetObjectDefCreateHerd(RandomBerriesID, true);
	    rmPlaceObjectDefAtLoc(RandomBerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ******************************************* //
/*================================================================================================================*/  
