// Team Archipelago TWC
// by RF_Gandalf
// A Random map script for AOE3: The War Chiefs

include "mercenaries.xs";

void main(void)
{
// Text
   rmSetStatusText("",0.01);

// Set up for variables
   string seaType = "";
   string baseType = "";
   string forestType = "";
   string treeType = "";
   string deerType = "";
   string deer2Type = "";
   string sheepType = "";
   string centerHerdType = "";
   string fishType = "";
   string fish2Type = "";
   string whaleType = "";
   string native1Name = "";
   string native2Name = "";
   string mineType = "";
   string propType = "";
   string brushType = "";

// Pick pattern for trees, terrain, features, etc.
   int patternChance = rmRandInt(1,29);   
   int variantChance = rmRandInt(1,2);
   int lightingChance = rmRandInt(1,2);
   int axisChance = rmRandInt(1,2);
   int playerSide = rmRandInt(1,2);   
   int positionChance = rmRandInt(1,2);   
   int distChance = rmRandInt(1,6);
   int sectionChance = rmRandInt(1,12);
   int directionChance = rmRandInt(1,2);
   int nativePattern = -1;
   int sheepChance = rmRandInt(1,2);
   int tropical = 0;
   int arctic = 0;
   int placeBerries = 1;
   int noHeight = 0;
   int nativeChoice = rmRandInt(1,2);
   int baseHeight = rmRandInt(1,2);
   int twoChoice = rmRandInt(1,2);
   int threeChoice = rmRandInt(1,3);
   int fourChoice = rmRandInt(1,4);
   int fiveChoice = rmRandInt(1,5);
   int sixChoice = rmRandInt(1,6);
   int extraNativeIs = 0;
   int forestCoverUp = 0;
   int lowForest = 0;
   int cacheChance = rmRandInt(1,2);
   int cacheType = 0;
   int llamaCache = 0;
   int berryCache = 0;
   int campfireCache = 0;
   int centeredBigIsland = 0;
   int eBigIs = 0;
   int wBigIs = 0;
   int nBigIs = 0;
   int sBigIs = 0;
   int eEdgeIs = 0;
   int wEdgeIs = 0;
   int nEdgeIs = 0;
   int sEdgeIs = 0;
   int vultures = 0;
   int eagles = 0;
   int eaglerock = 0;
   int kingfishers = 0;
   int underbrush = 0;
   int texasProp = 0;
   mineType = "mine";

// Text
   rmSetStatusText("",0.05);

// Picks the map size
   int playerTiles=43000;  
   if (cNumberNonGaiaPlayers == 8)
	playerTiles = 26000;
   else if (cNumberNonGaiaPlayers == 7)
	playerTiles = 29000;  
   else if (cNumberNonGaiaPlayers == 6)
	playerTiles = 32000;
   else if (cNumberNonGaiaPlayers == 5)
	playerTiles = 35000;  
   else if (cNumberNonGaiaPlayers == 4)
	playerTiles = 37500;
   else if (cNumberNonGaiaPlayers == 3)
	playerTiles = 40000; 

   int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles/0.8);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   int mapDimension = rmRandInt(0,2);
   int longSide = size*1.1;

   if (mapDimension == 0)
      rmSetMapSize(size, size);
   else if (mapDimension == 1)
      rmSetMapSize(longSide, size);
   else if (mapDimension == 2)
      rmSetMapSize(size, longSide);

   rmSetSeaLevel(0.0);

// Select terrain pattern details

// patternChance = 5; 

   if (patternChance == 1) // NE
   { 
      rmSetSeaType("new england coast");
      rmSetMapType("newEngland");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("constantinople");
	else
	   rmSetLightingSet("new england");
      baseType = "newengland_grass";
      seaType = "new england coast";
	forestType = "new england forest";
	treeType = "TreeNewEngland";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "moose";         
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "deer";        
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      fishType = "FishCod"; 
      fish2Type = "FishSalmon";
      whaleType = "minkeWhale";
	if (rmRandInt(1,2) == 1)  
	   mineType = "MineTin";
	cacheType = 1;
	if (rmRandInt(1,3) == 3)
	   berryCache = 1;
      nativePattern = 40;
	eagles = 1;
   }
   else if (patternChance == 2) // carolina
   {
      rmSetSeaType("atlantic coast");
      rmSetMapType("carolina");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("312b_washington");
	else
	   rmSetLightingSet("carolina");
      baseType = "carolina_grass";
      seaType = "atlantic coast";
	forestType = "carolina pine forest";
	treeType = "TreeCarolinaGrass";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "turkey";        
	}
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
      fishType = "FishSardine";
      fish2Type = "FishCod";
      whaleType = "humpbackWhale";
	if (rmRandInt(1,2) == 1)
	   mineType = "MineTin";
	cacheType = 1;
	if (rmRandInt(1,3) == 3)
	   berryCache = 1;
	noHeight = 1;
	if (nativeChoice == 1)
	   nativePattern = 3;
	else
	   nativePattern = 40;
	eagles = 1;
   }
   else if (patternChance == 3) // bayou
   {
      rmSetSeaType("yucatan Coast");
      rmSetMapType("bayou");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("berlin dusk");
	else
         rmSetLightingSet("bayou");

      baseType = "bayou_grass";
      seaType = "yucatan Coast";
	forestType = "bayou swamp forest";
	treeType = "TreeBayou";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "turkey";        
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      fishType = "FishSardine";
      fish2Type = "FishCod";
      whaleType = "humpbackWhale";
	if (rmRandInt(1,2) == 1)
	   mineType = "MineTin";
	cacheType = 3;
	if (rmRandInt(1,3) == 3)
	   berryCache = 1;
	if (nativeChoice == 1)
	   nativePattern = 3;
	else
	   nativePattern = 21;
	eagles = 1;
	underbrush = 1;
      brushType = "UnderbrushCarolinasMarsh";
   }
   else if (patternChance == 4) // great lakes green
   {
      if (variantChance == 1)
	{
         rmSetSeaType("great lakes");
	   seaType = "great lakes";
	}
      else
	{
	   seaType = "new england coast";
	   rmSetSeaType("new england coast");
	}
      rmSetMapType("greatlakes");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("constantinople");
	else
         rmSetLightingSet("Great Lakes");

      baseType = "greatlakes_grass";
	forestType = "great lakes forest";
	treeType = "TreeGreatLakes";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "bison";
         centerHerdType = "moose";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "moose";        
	}   
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
      fishType = "FishSardine";
      fish2Type = "FishCod";
      whaleType = "minkeWhale";
	if (rmRandInt(1,2) == 1)
	   mineType = "MineTin";
	cacheType = 1;
	if (rmRandInt(1,3) == 3)
	   berryCache = 1;
	if (fiveChoice == 1)
	   nativePattern = 4;
	else if (fiveChoice == 2)
	   nativePattern = 5;
	else if (fiveChoice == 3)
	   nativePattern = 40;
	else if (fiveChoice == 4)
	   nativePattern = 22;
	else
	   nativePattern = 40;
	eagles = 1;
   }
   else if (patternChance == 5) // great lakes winter
   {
      rmSetSeaType("great lakes");
      rmSetMapType("greatlakes");
      rmSetMapType("snow");
	if (lightingChance == 1)
	   rmSetLightingSet("308b_caribbeanlight");
	else
         rmSetLightingSet("Great Lakes Winter");
      baseType = "greatlakes_snow";
      seaType = "great lakes";
	forestType = "great lakes forest snow";
	treeType = "TreeGreatLakesSnow";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "elk";
	}
      else 
	{     
         deerType = "bison";
         deer2Type = "deer";
         centerHerdType = "moose";       
	}      
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
      fishType = "FishSalmon";
      fish2Type = "FishCod";
      whaleType = "minkeWhale";
	if (rmRandInt(1,2) == 1)
	   mineType = "MineTin";
	cacheType = 1;
      placeBerries = 0;
	noHeight = 1;
	if (fiveChoice == 1)
	   nativePattern = 4;
	else if (fiveChoice == 2)
	   nativePattern = 5;
	else if (fiveChoice == 3)
	   nativePattern = 40;
	else if (fiveChoice == 4)
	   nativePattern = 22;
	else
	   nativePattern = 5;
	eagles = 1;
   }
   else if (patternChance == 6) // saguenay
   {
      rmSetSeaType("hudson bay");
      rmSetMapType("saguenay");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("lisbon");
	else
         rmSetLightingSet("saguenay");
      baseType = "saguenay grass";
      seaType = "hudson bay";
	forestType = "saguenay forest";
	treeType = "TreeSaguenay";
      if (variantChance == 1)
	{
         deerType = "caribou";
         deer2Type = "moose";
         centerHerdType = "caribou";
	}
      else 
	{     
         deerType = "caribou";
         deer2Type = "caribou";
         centerHerdType = "moose";       
	}
      sheepType = "sheep";
      fishType = "FishSalmon";
      fish2Type = "FishCod";
      whaleType = "beluga";
	if (rmRandInt(1,2) == 1)
	   mineType = "MineTin";
	else
	   mineType = "MineCopper";
	cacheType = 1;
	if (threeChoice == 1)
	   nativePattern = 5;
	else if (threeChoice == 2)
	   nativePattern = 6;
	else if (threeChoice == 3)
	   nativePattern = 16;
	eagles = 1;
   }
   else if (patternChance == 7) // yukon
   {
      rmSetSeaType("great lakes ice");
      rmSetMapType("yukon");
      rmSetMapType("snow");
	if (lightingChance == 1)
	   rmSetLightingSet("305b");
	else
         rmSetLightingSet("yukon");
      baseType = "yukon snow";
      seaType = "great lakes ice";
	forestType = "yukon snow forest";
	treeType = "TreeYukonSnow";
      if (variantChance == 1)
	{
         deerType = "caribou";
         deer2Type = "muskOx";
         centerHerdType = "muskOx";
	}
      else 
	{     
         deerType = "muskOx";
         deer2Type = "caribou";
         centerHerdType = "caribou";       
	}
      sheepChance = 0;
      fishType = "FishSalmon";
      fish2Type = "FishCod";
      whaleType = "beluga";
	if (rmRandInt(1,2) == 1)
	   mineType = "minegold";
	cacheType = 1;
      placeBerries = 0;
	arctic = 1;
	noHeight = 1;
	if (fiveChoice == 1)
	   nativePattern = 5;
	else if (fiveChoice == 2)
	   nativePattern = 6;
	else if (fiveChoice == 3)
	   nativePattern = 8;
	else if (fiveChoice == 4)
	   nativePattern = 27;
	else
	   nativePattern = 28;
	eagles = 1;
   }
   else if (patternChance == 8) // rockies
   {
      rmSetSeaType("great lakes");
      rmSetMapType("rockies");
      rmSetMapType("snow");
	if (lightingChance == 1)
	   rmSetLightingSet("305b");
	else
         rmSetLightingSet("rockies");
      baseType = "rockies_grass";
      seaType = "great lakes";
	forestType = "rockies forest";
	treeType = "TreeRockies";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "elk";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "elk";
         deer2Type = "bighornsheep";
         centerHerdType = "deer";
	}   
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
      fishType = "FishSalmon";
      fish2Type = "FishCod";
      whaleType = "humpbackWhale";
	cacheType = 2;
	nativeChoice = rmRandInt(1,5);
	if (nativeChoice == 1)
	   nativePattern = 23;
	else if (nativeChoice == 2)
	   nativePattern = 29;
	else if (nativeChoice == 3)
	   nativePattern = 19;
	else if (nativeChoice == 4)
	   nativePattern = 8;
	else if (nativeChoice == 5)
	   nativePattern = 28;
	eagles = 1;
	underbrush = 1;
      brushType = "UnderbrushRockies";
   }
   else if (patternChance == 9) // great plains 1
   {
      rmSetSeaType("Yucatan coast");
      rmSetMapType("greatPlains");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("ottoman morning");
	else
         rmSetLightingSet("great plains");
      baseType = "great plains grass"; 
      seaType = "Yucatan coast";
	forestType = "great plains forest";
	treeType = "TreeGreatPlains";
      if (variantChance == 1)
	{
         deerType = "bison";
         deer2Type = "pronghorn";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "elk";
	} 
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
      fishType = "FishSardine";
      fish2Type = "FishCod";
      whaleType = "minkeWhale";
	cacheType = 2;
	nativeChoice = rmRandInt(1,5);
	if (nativeChoice == 1)
	   nativePattern = 23;
	else if (nativeChoice == 2)
	   nativePattern = 29;
	else if (nativeChoice == 3)
	   nativePattern = 19;
	else if (nativeChoice == 4)
	   nativePattern = 8;
	else if (nativeChoice == 5)
	   nativePattern = 28;
	vultures = 1;
	underbrush = 1;
      brushType = "underbrushGreatPlains"; 
   }
   else if (patternChance == 10) // great plains 2
   {
      rmSetSeaType("Yucatan coast");
      rmSetMapType("greatPlains");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("spc14abuffalo");
	else
         rmSetLightingSet("great plains");
      baseType = "great plains drygrass";
      seaType = "Yucatan coast";
	forestType = "great plains forest";
	treeType = "TreeGreatPlains";
      if (variantChance == 1)
	{
         deerType = "bison";
         deer2Type = "pronghorn";
         centerHerdType = "bison";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "deer";
	}
      sheepType = "cow";
      fishType = "FishSardine";
      fish2Type = "FishCod";
      whaleType = "humpbackWhale";
	cacheType = 2;
	forestCoverUp = 1;
	lowForest = rmRandInt(0,1);
	nativeChoice = rmRandInt(1,5);
	if (nativeChoice == 1)
	   nativePattern = 30;
	else if (nativeChoice == 2)
	   nativePattern = 29;
	else if (nativeChoice == 3)
	   nativePattern = 32;
	else if (nativeChoice == 4)
	   nativePattern = 8;
	else if (nativeChoice == 5)
	   nativePattern = 28;
	if (rmRandInt(1,2) == 1)
	   texasProp = 1;
	else
	   eaglerock = 1;
	underbrush = 1;
      brushType = "underbrushGreatPlains"; 
   }
   else if (patternChance == 11) // texas grass
   {  
      rmSetSeaType("Atlantic Coast");
      rmSetMapType("texas");
	rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("pampas");
	else
         rmSetLightingSet("texas");
      baseType = "texas_grass";
      seaType = "Atlantic Coast";
	forestType = "texas forest";
	treeType = "TreeTexas";
      if (variantChance == 1)
	{
         deerType = "bison";
         deer2Type = "deer";
         centerHerdType = "bison";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "deer";
	}
      sheepType = "cow";
      fishType = "FishSardine";
      fish2Type = "FishCod";
      whaleType = "humpbackWhale";
	cacheType = 2;
	noHeight = 1;
	lowForest = rmRandInt(0,1);
	nativeChoice = rmRandInt(1,6);
	if (nativeChoice == 1)
	   nativePattern = 30;
	else if (nativeChoice == 2)
	   nativePattern = 29;
	else if (nativeChoice == 3)
	   nativePattern = 32;
	else if (nativeChoice == 4)
	   nativePattern = 19;
	else if (nativeChoice == 5)
	   nativePattern = 20;
	else
	   nativePattern = 9;
	if (rmRandInt(1,2) == 1)
	   texasProp = 1;
	else
	   vultures = 1;	
	underbrush = 1;
      brushType = "underbrushTexasGrass"; 
   }
   else if (patternChance == 12) // texas desert
   { 
      rmSetSeaType("Atlantic Coast");
      rmSetMapType("texas");
	rmSetMapType("grass");
      if (lightingChance == 1)
         rmSetLightingSet("seville");
      else
         rmSetLightingSet("texas");
      baseType = "texas_dirt";
      seaType = "Atlantic Coast";
	forestType = "texas forest dirt";
	treeType = "TreeTexasDirt";
      if (variantChance == 1)
	{
         deerType = "bison";
         deer2Type = "pronghorn";
         centerHerdType = "pronghorn";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bison";
	}
      sheepType = "cow";
      fishType = "FishSardine";
      fish2Type = "FishCod";
      whaleType = "humpbackWhale";
	cacheType = 2;
	noHeight = 1;
	lowForest = rmRandInt(0,1);
	nativeChoice = rmRandInt(1,6);
	if (nativeChoice == 1)
	   nativePattern = 30;
	else if (nativeChoice == 2)
	   nativePattern = 29;
	else if (nativeChoice == 3)
	   nativePattern = 32;
	else if (nativeChoice == 4)
	   nativePattern = 31;
	else if (nativeChoice == 5)
	   nativePattern = 38;
	else
	   nativePattern = 39;
	if (rmRandInt(1,2) == 1)
	   texasProp = 1;
	else
	   eaglerock = 1;
	underbrush = 1;
	brushType = "UnderbrushDesert";
   }
   else if (patternChance == 13) // sonora
   {  
      rmSetSeaType("caribbean coast");
      rmSetMapType("sonora");
	rmSetMapType("grass");
   	if (lightingChance == 1)
         rmSetLightingSet("sonora");
	else
         rmSetLightingSet("pampas");
      baseType = "sonora_dirt";
      seaType = "caribbean coast";
	forestType = "sonora forest";
	treeType = "TreeSonora";
      if (variantChance == 1)
	{
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bighornsheep";         
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bighornsheep";
         centerHerdType = "bison";         
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      fishType = "FishSardine";
      fish2Type = "FishMahi";
      whaleType = "humpbackWhale";
	if (rmRandInt(1,2) == 1)
	   cacheType = 2;
	else
   	   cacheType = 3;
	noHeight = 1;
	lowForest = 1;
	if (fiveChoice == 1)
	   nativePattern = 10;
	else if (fiveChoice == 2)
	   nativePattern = 31;
	else if (fiveChoice == 3)
	   nativePattern = 32;
	else if (fiveChoice == 4)
	   nativePattern = 33;
	else
	   nativePattern = 37;
	eaglerock = 1;
	underbrush = 1;
	brushType = "UnderbrushDesert";
   }
   else if (patternChance == 14) // yucatan
   {
      rmSetSeaType("yucatan Coast");
      rmSetMapType("yucatan");
      rmSetMapType("tropical");
	if (lightingChance == 1)
	   rmSetLightingSet("311b");
	else
         rmSetLightingSet("yucatan");
      baseType = "yucatan_grass";
      seaType = "yucatan Coast";
	forestType = "yucatan forest";
	treeType = "TreeYucatan";
      if (variantChance == 1)
      {
         deerType = "tapir";
         deer2Type = "turkey";
         centerHerdType = "capybara";
      }
      else
	{
         deerType = "capybara";
         deer2Type = "turkey";
         centerHerdType = "tapir";
	}
      sheepChance = 0;
      tropical = 1;
      fishType = "FishTarpon";
      fish2Type = "FishMahi";
      whaleType = "humpbackWhale";
	cacheType = 5;
	if (rmRandInt(1,3) < 3)
	   berryCache = 1;
	nativeChoice = rmRandInt(1,3);
	if (nativeChoice == 1)
	   nativePattern = 12;
	else if (nativeChoice == 2)
	   nativePattern = 35;
	else if (nativeChoice == 3)
	   nativePattern = 36;
	kingfishers = 1;
   }
   else if (patternChance == 15) // caribbean
   {
      rmSetSeaType("caribbean coast");
      rmSetMapType("caribbean");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("301a_malta");
	else
         rmSetLightingSet("caribbean");
      baseType = "caribbean grass";
      seaType = "caribbean coast";
	forestType = "caribbean palm forest";
	treeType = "TreeCaribbean";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "tapir";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "tapir";
         centerHerdType = "deer";
	}
      sheepChance = 0;
      tropical = 1;
      fishType = "FishTarpon";
      fish2Type = "FishMahi";
      whaleType = "humpbackWhale";
	cacheType = 3;
	noHeight = 1;
	if (fiveChoice == 1)
	   nativePattern = 12;
	else if (fiveChoice == 2)
	   nativePattern = 13;
	else if (fiveChoice == 3)
	   nativePattern = 18;
	else if (fiveChoice == 4)
	   nativePattern = 36;
	else
	   nativePattern = 42;
	kingfishers = 1;
   }
   else if (patternChance == 16) // amazon
   {
      rmSetSeaType("yucatan coast");
      rmSetMapType("amazonia");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("323b_inca");
	else
         rmSetLightingSet("amazon");
      baseType = "amazon grass";
      seaType = "yucatan Coast";
	forestType = "amazon rain forest";
	treeType = "TreeAmazon";
      if (variantChance == 1)
      {
         deerType = "tapir";
         deer2Type = "tapir";
         centerHerdType = "capybara";
      }
      else
	{
         deerType = "capybara";
         deer2Type = "tapir";
         centerHerdType = "capybara";
	}
      sheepChance = 0;
      tropical = 1;
      fishType = "FishMahi";
      fish2Type = "FishTarpon";
      whaleType = "humpbackWhale";
	cacheType = 3;
	if (fiveChoice == 1)
	   nativePattern = 13;
	else if (fiveChoice == 2)
	   nativePattern = 14;
	else if (fiveChoice == 3)
	   nativePattern = 15;
	else if (fiveChoice == 4)
	   nativePattern = 18;
	else
	   nativePattern = 26;
	kingfishers = 1;
   }
   else if (patternChance == 17) // pampas
   {
      rmSetSeaType("caribbean coast");
      rmSetMapType("pampas");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("texas");
	else
         rmSetLightingSet("pampas");
      baseType = "pampas_grass";
      seaType = "caribbean coast";
	forestType = "pampas forest";
	treeType = "TreePampas";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "rhea";
         centerHerdType = "rhea";
	}
      else 
	{     
         deerType = "rhea";
         deer2Type = "deer";
         centerHerdType = "rhea";
	}
      sheepType = "llama";
      fishType = "FishMahi";
      fish2Type = "FishTarpon";
      whaleType = "humpbackWhale";
	cacheType = 3;
	lowForest = rmRandInt(0,1);
	noHeight = 1;
	if (rmRandInt(1,3) < 3)
	   llamaCache = 1;
	if (threeChoice == 1)
	   nativePattern = 14;
	else if (threeChoice == 2)
	   nativePattern = 25;
	else
	   nativePattern = 26;
	vultures = 1;
	underbrush = 1;
      brushType = "UnderbrushPampas";
   }
   else if (patternChance == 18) // patagonia
   {
      rmSetSeaType("hudson bay");
      rmSetMapType("patagonia");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("paris day");
	else
         rmSetLightingSet("patagonia");
      baseType = "patagonia_grass";
      seaType = "hudson bay";
	forestType = "patagonia forest";
	treeType = "TreePatagoniaDirt";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "rhea";
         centerHerdType = "rhea";
	}
      else 
	{     
         deerType = "rhea";
         deer2Type = "deer";
         centerHerdType = "rhea";
	}
      sheepType = "llama";
      fishType = "FishSalmon";
      fish2Type = "FishSardine";
      whaleType = "minkeWhale";
	cacheType = 1;

	if (rmRandInt(1,3) < 3)
	   llamaCache = 1;
	if (rmRandInt(1,3) < 3)
	   berryCache = 1;
	if (fiveChoice == 1)
	   nativePattern = 14;
	else if (fiveChoice == 2)
	   nativePattern = 15;
	else if (fiveChoice == 3)
	   nativePattern = 24;
	else if (fiveChoice == 4)
	   nativePattern = 25;
	else
	   nativePattern = 26;
	eagles = 1;
   }
   else if (patternChance == 19) // nwt
   {
      rmSetSeaType("Northwest Territory Water");   
      rmSetMapType("northwestTerritory");
      rmSetMapType("grass");
	if (lightingChance == 2)
	   rmSetLightingSet("nwterritory");
	else
         rmSetLightingSet("saguenay");
      baseType = "nwt_grass1";
      seaType = "Northwest Territory Water";
	if (twoChoice == 1)
	{
	   forestType = "NW Territory Birch Forest";
   	   treeType = "TreeGreatLakes";
	}
	else
	{ 
	   forestType = "NW Territory Forest";
	   treeType = "TreeGreatPlains";   
	}
      if (variantChance == 1)
	{
         deerType = "elk";
         deer2Type = "moose";
         centerHerdType = "moose";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "elk";
	} 
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      fish2Type = "FishSalmon";
      fishType = "FishCod";
      whaleType = "humpbackWhale";
	cacheType = 1;
	if (rmRandInt(1,3) == 3)
	   berryCache = 1;
	if (fourChoice == 1)
	   nativePattern = 27;
	else if (fourChoice == 2)
	   nativePattern = 28;
	else if (fourChoice == 3)
	   nativePattern = 7;
	else
	   nativePattern = 6;
	kingfishers = 1;
   }
   else if (patternChance == 20) // yukon tundra
   {
      rmSetSeaType("hudson bay");
      rmSetMapType("yukon");
      rmSetMapType("snow");
	if (lightingChance == 1)
         rmSetLightingSet("seville morning");
	else
         rmSetLightingSet("yukon");
      baseType = "yukon grass";
      seaType = "hudson bay";
	forestType = "yukon forest";
	treeType = "TreeYukon";
      if (variantChance == 1)
	{
         deerType = "muskOx";
         deer2Type = "caribou";
         centerHerdType = "caribou";
	}
      else 
	{  
         deerType = "caribou"; 
         deer2Type = "caribou";
         centerHerdType = "muskOx";
	}
      sheepChance = 0;
      fishType = "FishSalmon";
      fish2Type = "FishCod";
      whaleType = "minkeWhale";
	cacheType = 1;
	arctic = 1;
      placeBerries = 0;
	if (threeChoice == 1)
	   nativePattern = 5;
	else if (threeChoice == 2)
	   nativePattern = 6;
	else if (threeChoice == 3)
	   nativePattern = 16;
	eagles = 1;
   }
   else if (patternChance == 21) // painted desert
   {   
      rmSetSeaType("Atlantic Coast");
      rmSetMapType("sonora");
	rmSetMapType("grass");
      if (lightingChance == 1)
         rmSetLightingSet("seville");
      else
         rmSetLightingSet("pampas");
	if (twoChoice == 1)
         baseType = "painteddesert_groundmix_2";
	else
         baseType = "painteddesert_groundmix_1";
      seaType = "Atlantic Coast";
	forestType = "painteddesert forest";
	treeType = "TreePaintedDesert";
      if (variantChance == 1)
	{
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bighornsheep";         
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bighornsheep";
         centerHerdType = "bison";         
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      fishType = "FishSardine";
      fish2Type = "FishMahi";
      whaleType = "humpbackWhale";
	mineType = "MineCopper";
	cacheType = 3;
	lowForest = rmRandInt(0,1);
	noHeight = 1;
	if (fiveChoice == 1)
	   nativePattern = 30;
	else if (fiveChoice == 2)
	   nativePattern = 31;
	else if (fiveChoice == 3)
	   nativePattern = 32;
	else if (fiveChoice == 4)
	   nativePattern = 33;
	else
	   nativePattern = 37;
	eaglerock = 1;
   }
   else if (patternChance == 22) // andes
   {
      rmSetSeaType("california coast");
      rmSetMapType("andes");
      rmSetMapType("grass");
	if (lightingChance == 1)
         rmSetLightingSet("greatplainstest");
	else
	   rmSetLightingSet("andes");
      baseType = "andes_grass_a";
      seaType = "california coast";
	forestType = "andes forest";
	treeType = "TreeAndes";
      if (variantChance == 1)
	{
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "rhea";
	}
      else 
	{     
         deerType = "guanaco";
         deer2Type = "rhea";
         centerHerdType = "guanaco";
	}
      sheepType = "llama";
      fishType = "FishSardine";
      fish2Type = "FishCod";
      whaleType = "humpbackWhale";
	cacheType = 5;
	if (rmRandInt(1,3) < 3)
	   llamaCache = 1;
	if (rmRandInt(1,3) < 3)
	   berryCache = 1;
      tropical = 1;
	if (fiveChoice == 1)
	   nativePattern = 14;
	else if (fiveChoice == 2)
	   nativePattern = 24;
	else if (fiveChoice == 3)
	   nativePattern = 25;
	else if (fiveChoice == 4)
	   nativePattern = 26;
	else
	   nativePattern = 34;
	vultures = 1;
   }
   else if (patternChance == 23) // central araucania
   {
      rmSetSeaType("Araucania Central Coast");
      rmSetMapType("araucania");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("Araucania Central");
	else
         rmSetLightingSet("new england");
	if (twoChoice == 1)
	{ 
         baseType = "araucania_grass_b";
	   forestCoverUp = 1;
	}
	else
         baseType = "araucania_grass_d";
      seaType = "Araucania Central Coast";
	forestType = "Araucania Forest";
	treeType = "TreeAraucania";
      if (variantChance == 1)
	{
         deerType = "guanaco";
         deer2Type = "deer";
         centerHerdType = "guanaco"; 
	}
      else 
	{     
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "guanaco";
	} 
      sheepType = "llama";
      fishType = "FishCod";
      fish2Type = "FishSalmon";
      whaleType = "humpbackWhale";
	mineType = "MineCopper";
	cacheType = 5;
      llamaCache = 1;
	if (rmRandInt(1,3) < 3) 
	   berryCache = 1;
      tropical = 1;
	if (fiveChoice == 1)
	   nativePattern = 14;
	else if (fiveChoice == 2)
	   nativePattern = 25;
	else if (fiveChoice == 3)
	   nativePattern = 25;
	else if (fiveChoice == 4)
	   nativePattern = 18;
	else
	   nativePattern = 11;
	kingfishers = 1;
   }
   else if (patternChance == 24) // north araucania
   {
      rmSetSeaType("Araucania North Coast");
      rmSetMapType("araucania");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("NthAraucaniaLight");
	else
         rmSetLightingSet("constantinople");  
      baseType = "araucania_north_grass_b";  
      seaType = "Araucania North Coast";
	forestType =  "North Araucania Forest";
	treeType = "TreeAraucania";
      if (variantChance == 1)
	{
         deerType = "guanaco";
         deer2Type = "deer";
         centerHerdType = "guanaco"; 
	}
      else 
	{     
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "guanaco";
	} 
      sheepType = "llama";
      fishType = "FishCod";
      fish2Type = "FishSardine";
      whaleType = "humpbackWhale";
	mineType = "MineCopper";
	lowForest = rmRandInt(0,1);
	if (rmRandInt(1,2) == 1)
	   cacheType = 5;
	else
	   cacheType = 4;
	if (rmRandInt(1,3) < 3)
	   llamaCache = 1;
	if (fiveChoice == 1)
	   nativePattern = 14;
	else if (fiveChoice == 2)
	   nativePattern = 24;
	else if (fiveChoice == 3)
	   nativePattern = 25;
	else if (fiveChoice == 4)
	   nativePattern = 26;
	else
	   nativePattern = 34;
	vultures = 1;
   }
   else if (patternChance == 25) // south araucania
   {
      rmSetSeaType("Araucania Southern Coast");
      rmSetMapType("araucania");
      rmSetMapType("grass");
	if (lightingChance == 2)
	   rmSetLightingSet("SthAraucaniaLight");
	else
	   rmSetLightingSet("303a_boston");     
      baseType = "araucania_snow_c";
      seaType = "Araucania Southern Coast";
	forestType = "Patagonia Snow Forest";
	treeType = "TreePatagoniaSnow";
      if (variantChance == 1)
	{
         deerType = "guanaco";
         deer2Type = "deer";
         centerHerdType = "guanaco"; 
	}
      else 
	{     
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "deer";
	} 
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "llama";
      fish2Type = "FishCod";
      fishType = "FishSalmon";
      whaleType = "humpbackWhale";
	mineType = "MineCopper";
	if (rmRandInt(1,2) == 1)
	   cacheType = 5;
	else
	   cacheType = 4;
      placeBerries = 0;
	if (fourChoice == 1)
	   nativePattern = 14;
	else if (fourChoice == 2)
	   nativePattern = 25;
	else if (fourChoice == 3)
	   nativePattern = 26;
	else
	   nativePattern = 11;
	eagles = 1;
   }
   else if (patternChance == 26) // california green
   {
      rmSetSeaType("california coast");   
      rmSetMapType("california");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("california");
	else
         rmSetLightingSet("new england");  
      baseType = "california_grass";
      seaType = "california coast";
	if (fourChoice < 3)
	{ 
	   forestType = "california redwood forest";
	   treeType = "TreeRedwood";
	}
	else 
	{ 
	   forestType = "California pine forest";
	   treeType = "TreePonderosaPine";
	}
      if (variantChance == 1)
	{
         deerType = "elk";
         deer2Type = "deer";
         centerHerdType = "elk";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "elk";
         centerHerdType = "elk";
	} 
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      fish2Type = "FishCod";
      fishType = "FishSalmon";
      whaleType = "humpbackWhale";
	if (rmRandInt(1,2) == 1)
	   mineType = "mine";
	else
	   mineType = "minegold";
	cacheType = 4;
	if (twoChoice == 1)
	   nativePattern = 27;
	else
	   nativePattern = 28;
	eagles = 1;
   }
   else if (patternChance == 27) // california desert
   {
      rmSetSeaType("california coast");   
      rmSetMapType("california");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("california");
	else
         rmSetLightingSet("new england");  
      baseType = "california_desert2";
      seaType = "california coast";
	if (fourChoice < 3)
	{ 
	   forestType = "California Desert Forest";
	   treeType = "TreeSonora";
	}
	else 
	{ 
	   forestType = "california madrone forest";
	   treeType = "TreeMadrone";
	}
      if (variantChance == 1)
	{
         deerType = "elk";
         deer2Type = "pronghorn";
         centerHerdType = "elk";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "elk";
         centerHerdType = "deer";
	} 
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      fish2Type = "FishMahi";
      fishType = "FishSardine";
      whaleType = "humpbackWhale";
	lowForest = rmRandInt(0,1);
	if (rmRandInt(1,2) == 1)
	   mineType = "mine";
	else
	   mineType = "minegold";
	cacheType = 4;
	if (twoChoice == 1)
	   nativePattern = 27;
	else
	   nativePattern = 43;
	vultures = 1;
	underbrush = 1;
	brushType = "UnderbrushDesert";
   }
   else if (patternChance == 28) // palm desert
   {   
      rmSetSeaType("Atlantic Coast");
      rmSetMapType("sonora");
	rmSetMapType("grass");
      if (lightingChance == 1)
         rmSetLightingSet("seville");
      else
         rmSetLightingSet("pampas");
	if (twoChoice == 1)
	{
         baseType = "texas_dirt";
	}
	else
	{
         baseType = "sonora_dirt";
	}
      seaType = "Atlantic Coast";
	forestType = "caribbean palm forest";
	treeType = "TreeCaribbean";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "turkey";
	}
      fishType = "FishSardine";
      fish2Type = "FishMahi";
      whaleType = "minkeWhale";
      sheepType = "cow";
	cacheType = 5;
	noHeight = 1;
	forestCoverUp = 1;
	lowForest = rmRandInt(0,1);
	if (fourChoice == 1)
	   nativePattern = 33;
	else if (fourChoice == 2)
	   nativePattern = 35;
	else if (fourChoice == 3)
	   nativePattern = 35;
	else 
	   nativePattern = 36;
	vultures = 1;
	underbrush = 1;
	brushType = "UnderbrushPampas";
   }
   else if (patternChance == 29) // atacama
   {
      rmSetSeaType("Araucania North Coast");
      rmSetMapType("araucania");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("NthAraucaniaLight");
	else
         rmSetLightingSet("constantinople");
      baseType = "araucania_north_grass_a";
      seaType = "Araucania North Coast";
	forestType = "sonora forest";
	treeType = "TreeSonora";
      if (variantChance == 1)
	{
         deerType = "guanaco";
         deer2Type = "deer";
         centerHerdType = "guanaco"; 
	}
      else 
	{     
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "guanaco";
	} 
      sheepType = "llama";
      fishType = "FishMahi";
      fish2Type = "FishSardine";
      whaleType = "humpbackWhale";
	mineType = "MineCopper";
	if (rmRandInt(1,2) == 1)
	   cacheType = 5;
	else
	   cacheType = 4;
      placeBerries = 0;
	forestCoverUp = 1;
	lowForest = 1;
	noHeight = 1;
	if (rmRandInt(1,4) < 4)
	   llamaCache = 1;
	if (fiveChoice == 1)
	   nativePattern = 14;
	else if (fiveChoice == 2)
	   nativePattern = 24;
	else if (fiveChoice == 3)
	   nativePattern = 25;
	else if (fiveChoice == 4)
	   nativePattern = 26;
	else
	   nativePattern = 18;
	vultures = 1;
	underbrush = 1;
	brushType = "UnderbrushPampas"; 
   }

// Native patterns
  if (nativePattern == 1)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Iroquois");
      native2Name = "native iroquois village ";
  }
  else if (nativePattern == 2)
  {
      rmSetSubCiv(0, "Comanche");
      native1Name = "native comanche village ";
      rmSetSubCiv(1, "Lakota");
      native2Name = "native lakota village ";
  }
  else if (nativePattern == 3)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Seminoles");
      native2Name = "native seminole village ";
  }
  else if (nativePattern == 4)
  {
      rmSetSubCiv(0, "Cheyenne");
      native1Name = "native cheyenne village ";
      rmSetSubCiv(1, "Huron");
      native2Name = "native huron village ";
  }
  else if (nativePattern == 5)
  {
      rmSetSubCiv(0, "Huron");
      native1Name = "native huron village ";
      rmSetSubCiv(1, "Cree");
      native2Name = "native cree village ";
  }
  else if (nativePattern == 6)
  {
      rmSetSubCiv(0, "Nootka");
      native1Name = "native nootka village ";
      rmSetSubCiv(1, "Cree");
      native2Name = "native cree village ";
  }
  else if (nativePattern == 7)
  {
      rmSetSubCiv(0, "Nootka");
      native1Name = "native nootka village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 8)
  {
      rmSetSubCiv(0, "Cree");
      native1Name = "native cree village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 9)
  {
      rmSetSubCiv(0, "Seminoles");
      native1Name = "native seminole village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 10)
  {
      rmSetSubCiv(0, "Zapotec");
      native1Name = "native zapotec village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 11)
  {
      rmSetSubCiv(0, "Mapuche");
      native1Name = "native mapuche village ";
      rmSetSubCiv(1, "Maya");
      native2Name = "native maya village ";
  }
  else if (nativePattern == 12)
  {
      rmSetSubCiv(0, "Caribs");
      native1Name = "native carib village ";
      rmSetSubCiv(1, "Maya");
      native2Name = "native maya village ";
  }
  else if (nativePattern == 13)
  {
      rmSetSubCiv(0, "Caribs");
      native1Name = "native carib village ";
      rmSetSubCiv(1, "Tupi");
      native2Name = "native tupi village ";
  }
  else if (nativePattern == 14)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Tupi");
      native2Name = "native tupi village ";
  }
  else if (nativePattern == 15)
  {
      rmSetSubCiv(0, "Maya");
      native1Name = "native maya village ";
      rmSetSubCiv(1, "Tupi");
      native2Name = "native tupi village ";
  }
  else if (nativePattern == 16)
  {
      rmSetSubCiv(0, "Nootka");
      native1Name = "native nootka village ";
      rmSetSubCiv(1, "Huron");
      native2Name = "native huron village ";
  }
  else if (nativePattern == 17)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Aztecs");
      native2Name = "native aztec village ";
  }
  else if (nativePattern == 18)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Caribs");
      native2Name = "native carib village ";
  }
  else if (nativePattern == 19)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 20)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 21)
  {
      rmSetSubCiv(0, "Seminoles");
      native1Name = "native seminole village ";
      rmSetSubCiv(1, "Huron");
      native2Name = "native huron village ";
  }
  else if (nativePattern == 22)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Cree");
      native2Name = "native cree village ";
  }
  else if (nativePattern == 23)
  {
      rmSetSubCiv(0, "Comanche");
      native1Name = "native comanche village ";
      rmSetSubCiv(1, "Cree");
      native2Name = "native cree village ";
  }
  else if (nativePattern == 24)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Maya");
      native2Name = "native maya village ";
  }
  else if (nativePattern == 25)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Mapuche");
      native2Name = "native mapuche village ";
  }
  else if (nativePattern == 26)
  {
      rmSetSubCiv(0, "Tupi");
      native1Name = "native tupi village ";
      rmSetSubCiv(1, "Mapuche");
      native2Name = "native mapuche village ";
  }
  else if (nativePattern == 27)
  {
      rmSetSubCiv(0, "Klamath");
      native1Name = "native klamath village ";
      rmSetSubCiv(1, "Nootka");
      native2Name = "native nootka village ";
  }
  else if (nativePattern == 28)
  {
      rmSetSubCiv(0, "Klamath");
      native1Name = "native klamath village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 29)
  {
      rmSetSubCiv(0, "Comanche");
      native1Name = "native comanche village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 30)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 31)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Navajo");
      native2Name = "native navajo village ";
  }
  else if (nativePattern == 32)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 33)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 34)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 35)
  {
      rmSetSubCiv(0, "Maya");
      native1Name = "native maya village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 36)
  {
      rmSetSubCiv(0, "Caribs");
      native1Name = "native carib village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 37)
  {
      rmSetSubCiv(0, "Navajo");
      native1Name = "native navajo village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 38)
  {
      rmSetSubCiv(0, "Navajo");
      native1Name = "native navajo village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 39)
  {
      rmSetSubCiv(0, "Navajo");
      native1Name = "native navajo village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 40)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Huron");
      native2Name = "native huron village ";
  }
  else if (nativePattern == 41)
  {
      rmSetSubCiv(0, "Lakota");
      native1Name = "native lakota village ";
      rmSetSubCiv(1, "Huron");
      native2Name = "native huron village ";
  }
  else if (nativePattern == 42)
  {
      rmSetSubCiv(0, "Caribs");
      native1Name = "native carib village ";
      rmSetSubCiv(1, "Seminoles");
      native2Name = "native seminole village ";
  }
  else if (nativePattern == 43)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Klamath");
      native2Name = "native klamath village ";
  }

// Precipitation
   if ((patternChance == 14) || (patternChance == 16)) // yucatan, amazon    
      if (lightingChance == 2)
         rmSetGlobalRain( 0.5 );
   if (patternChance == 7) // yukon
      rmSetGlobalSnow( 1.0 );
   if ((patternChance == 5) || (patternChance == 20) || (patternChance == 25)) // gl winter, yukon tundra, s araucania 
      if (lightingChance == 2)    
         rmSetGlobalSnow( 0.7 );
   if (patternChance == 8) // rockies
      if (lightingChance == 2)
         rmSetGlobalSnow( 0.5 );

   if (patternChance == 19) // nwt
   {
	// Make it rain
	rmSetGlobalRain( 1.0 );
	rmSetGlobalStormLength(1.0, 0.0);

	// Sets up the rain triggers 
	rmCreateTrigger("ChangeRain1");
	rmSwitchToTrigger(rmTriggerID("ChangeRain1"));
	rmSetTriggerActive(true);
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", 30);
	rmAddTriggerEffect("Render Rain");
	rmSetTriggerEffectParamFloat("Percent", 0.3);

	rmCreateTrigger("ChangeRain2");
	rmSwitchToTrigger(rmTriggerID("ChangeRain2"));
	rmSetTriggerActive(true);
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", 60);
	rmAddTriggerEffect("Render Rain");
	rmSetTriggerEffectParamFloat("Percent", 1.0);

	rmCreateTrigger("ChangeRain3");
	rmSwitchToTrigger(rmTriggerID("ChangeRain3"));
	rmSetTriggerActive(true);
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", 60);
	rmAddTriggerEffect("Render Rain");
	rmSetTriggerEffectParamFloat("Percent", 0.3);

	rmCreateTrigger("ChangeRain4");
	rmSwitchToTrigger(rmTriggerID("ChangeRain4"));
	rmSetTriggerActive(true);
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", 75);
	rmAddTriggerEffect("Render Rain");
	rmSetTriggerEffectParamFloat("Percent", 0.0);
   }

   rmTerrainInitialize("water");
   rmSetMapType("water");
   rmSetWorldCircleConstraint(true);
   rmSetWindMagnitude(2.0);
   chooseMercs();

// Define some classes.
   int classPlayer=rmDefineClass("player");
   rmDefineClass("startingUnit");
   rmDefineClass("classForest");
   rmDefineClass("importantItem");
   rmDefineClass("natives");
   rmDefineClass("nuggets");
   rmDefineClass("center");
   rmDefineClass("socketClass");
   rmDefineClass("classFish");
   int classHuntable=rmDefineClass("huntableFood");   
   int classHerdable=rmDefineClass("herdableFood"); 
   int classMines=rmDefineClass("all mines"); 
   int classCenterIsland=rmDefineClass("center island");
   int classBonusIsland=rmDefineClass("bonus island");
   int classSettlementIsland=rmDefineClass("settlement island");
   int classNativeIsland=rmDefineClass("native island");
   int classGoldIsland=rmDefineClass("gold island");
   int islandsX=rmDefineClass("islandsX");
   int islandsY=rmDefineClass("islandsY");
   int islandsZ=rmDefineClass("islandsZ");
   int teamClass=rmDefineClass("teamClass"); 

// Text
   rmSetStatusText("",0.10);

// -------------Define constraints
   // Map edge constraints
   int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(16), rmZTilesToFraction(16), 1.0-rmXTilesToFraction(16), 1.0-rmZTilesToFraction(16), 0.01);
   int teamEdgeConstraint=rmCreateBoxConstraint("team edge of map", rmXTilesToFraction(16), rmZTilesToFraction(16), 1.0-rmXTilesToFraction(16), 1.0-rmZTilesToFraction(16), 0.01);
   int shortEdgeConstraint=rmCreatePieConstraint("short axis edge of map", 0.5, 0.5, 0, size*0.48, rmDegreesToRadians(0), rmDegreesToRadians(360));
   int circleEdgeConstraint=rmCreatePieConstraint("circle edge Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.46), rmDegreesToRadians(0), rmDegreesToRadians(360));
   int circleEdgeConstraint2=rmCreatePieConstraint("circle edge Constraint 2", 0.5, 0.5, 0, rmXFractionToMeters(0.46), rmDegreesToRadians(0), rmDegreesToRadians(360));

   // Center constraints
   int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 30.0);
   int centerConstraintShort=rmCreateClassDistanceConstraint("stay away from center short", rmClassID("center"), 12.0);
   int centerConstraintFar=rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), 70.0);
   int centralExtraLandConstraint=rmCreatePieConstraint("circle Constraint for extra land", 0.5, 0.5, 0, rmZFractionToMeters(0.17), rmDegreesToRadians(0), rmDegreesToRadians(360));
   int centralExtraLandConstraint2=rmCreatePieConstraint("2nd circle Constraint for extra land", 0.5, 0.5, 0, rmZFractionToMeters(0.13), rmDegreesToRadians(0), rmDegreesToRadians(360));

   // Player constraints
   int playerConstraintShort=rmCreateClassDistanceConstraint("short stay away from players", classPlayer, 15.0);
   int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 45.0);
   int mediumPlayerConstraint=rmCreateClassDistanceConstraint("medium stay away from players", classPlayer, 25.0);
   int nuggetPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 60.0);
   int farPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players more", classPlayer, 85.0);
   int fartherPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players the most", classPlayer, 105.0);
   int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 75.0);
   int avoidTC=rmCreateTypeDistanceConstraint("stuff vs TC", "TownCenter", 40.0);

   float constraintChance = rmRandFloat(0,1);
   int constraintNum = 0;
   if(constraintChance < 0.25)
      constraintNum = 27;
   else if(constraintChance < 0.5)
      constraintNum = 30;
   else if(constraintChance < 0.75)
      constraintNum = 32;
   else 
      constraintNum = 34;
   int playerLandConstraint=rmCreateClassDistanceConstraint("players land stay away from players", classPlayer, constraintNum); 

   // Nature avoidance
   int forestConstraint2=rmCreateClassDistanceConstraint("forest v forest2", rmClassID("classForest"), 10.0);
   int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 17.0);
   int avoidCoin=rmCreateClassDistanceConstraint("avoid coin", rmClassID("all mines"), 10.0);
   int coinAvoidCoin=rmCreateClassDistanceConstraint("coin avoids coin", rmClassID("all mines"), 35.0);
   int longAvoidCoin=rmCreateClassDistanceConstraint("long avoid coin", rmClassID("all mines"), 90.0);
   int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
   int avoidSheep=rmCreateClassDistanceConstraint("sheep avoids sheep etc", rmClassID("herdableFood"), 45.0);
   int huntableConstraint=rmCreateClassDistanceConstraint("huntable constraint", rmClassID("huntableFood"), 35.0);

   // Avoid impassable land, certain features
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
   int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
   int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 18.0);
   int avoidWater10 = rmCreateTerrainDistanceConstraint("avoid water mid-long", "Land", false, 10.0);
   int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water mid-longer", "Land", false, 15.0);
   int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water a little more", "Land", false, 20.0);
   int rockVsLand = rmCreateTerrainDistanceConstraint("rock v. land", "land", true, 2.0);
   int nearWater = rmCreateTerrainMaxDistanceConstraint("stay near Water", "Water", true, 5.0);
   int avoidLand4 = rmCreateTerrainDistanceConstraint("avoid land by 4", "land", true, 4.0);
   int nearShore=rmCreateTerrainMaxDistanceConstraint("stay near shore", "land", true, 5.0);

   // Unit avoidance
   int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
   int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 10.0);
   int avoidStartingUnitsLong=rmCreateClassDistanceConstraint("long avoid starting units", rmClassID("startingUnit"), 45.0);
   int avoidImportantItem=rmCreateClassDistanceConstraint("things avoid each other", rmClassID("importantItem"), 10.0);
   int avoidImportantItemSmall=rmCreateClassDistanceConstraint("important item small avoidance", rmClassID("importantItem"), 7.0);
   int avoidImportantItemMed=rmCreateClassDistanceConstraint("things avoid each other med", rmClassID("importantItem"), 35.0);
   int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 60.0);
   int avoidNativesLong=rmCreateClassDistanceConstraint("stuff avoids natives longer", rmClassID("natives"), 90.0);
   int avoidNativesShort=rmCreateClassDistanceConstraint("stuff avoids natives shorter", rmClassID("natives"), 15.0);
   int avoidNugget=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("nuggets"), 40.0);
   int avoidNuggetSmall=rmCreateTypeDistanceConstraint("avoid nuggets by a little", "AbstractNugget", 10.0);
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

   // Trade route avoidance.
   int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
   int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 10.0);

   // Water spawn point avoidance.
   int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 5.0);
   int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 40);
   int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-30, rmGetMapXSize()-5, 0, 0, 0);

   // Center constraint
   int avoidCenter=rmCreateClassDistanceConstraint("avoid the center", rmClassID("center"), 30.0);
 
   // Island constraints
   float constraintChance2 = rmRandFloat(0,1);
   int constraintNum2 = 0;
   if(constraintChance2 < 0.33)
      constraintNum2 = 26;
   else if(constraintChance2 < 0.66)
      constraintNum2 = 29;
   else 
      constraintNum2 = 32;
   float constraintChance3 = rmRandFloat(0,1);
   int constraintNum3 = 0;
   if(constraintChance3 < 0.33)
      constraintNum3 = 27;
   else if(constraintChance3 < 0.66)
      constraintNum3 = 30;
   else
      constraintNum3 = 32;

   int settlementIslandConstraint=rmCreateClassDistanceConstraint("avoid settlement islands", classSettlementIsland, constraintNum3); 
   int centerIslandConstraint=rmCreateClassDistanceConstraint("avoid center island", classCenterIsland, constraintNum2);
   int nativeIslandConstraint=rmCreateClassDistanceConstraint("avoid native island", classNativeIsland, constraintNum3);
   int nativeIslandConstraintLarge=rmCreateClassDistanceConstraint("avoid native island large", classNativeIsland, rmXFractionToMeters(0.28));
   int islandsXvsY=rmCreateClassDistanceConstraint("island X avoids Y", islandsY, rmRandInt(27,32));
   int islandsYvsX=rmCreateClassDistanceConstraint("island Y avoids X", islandsX, rmRandInt(27,32));
   int islandsXYvsZ=rmCreateClassDistanceConstraint("islands Y and X avoid Z", islandsZ, rmRandInt(27,32));
   int islandsZvsX=rmCreateClassDistanceConstraint("island Z avoids X", islandsX, rmRandInt(27,32));
   int islandsZvsY=rmCreateClassDistanceConstraint("island Z avoids Y", islandsY, rmRandInt(27,32));

   // Team constraints
   int teamConstraint=rmCreateClassDistanceConstraint("team constraint", teamClass, 60.0);
   int avoidTeamLands=rmCreateClassDistanceConstraint("avoid team lands", rmClassID("teamClass"), 2.0);
   int landAvoidTeamLands=rmCreateClassDistanceConstraint("land avoids team lands", rmClassID("teamClass"), constraintNum);

   // Cardinal Directions - "quadrants" of the map.
   int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.75, 0, rmZFractionToMeters(0.22), rmDegreesToRadians(0), rmDegreesToRadians(360));
   int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.25, 0, rmZFractionToMeters(0.22), rmDegreesToRadians(0), rmDegreesToRadians(360));
   int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.75, 0.5, 0, rmZFractionToMeters(0.22), rmDegreesToRadians(0), rmDegreesToRadians(360));
   int Westward=rmCreatePieConstraint("westMapConstraint", 0.25, 0.5, 0, rmZFractionToMeters(0.22), rmDegreesToRadians(0), rmDegreesToRadians(360));

// ---------------------------------------------------------------------------------------End constraints

// Text
   rmSetStatusText("",0.15);

// NATIVE AMERICANS - defined
   // Village A 
   int villageAID = -1;
   int whichNative = rmRandInt(1,2);
   int villageType = rmRandInt(1,5);
   if (whichNative == 1)
	   villageAID = rmCreateGrouping("village A", native1Name+villageType);
   else if (whichNative == 2)
	   villageAID = rmCreateGrouping("village A", native2Name+villageType);
   rmAddGroupingToClass(villageAID, rmClassID("natives"));
   rmAddGroupingToClass(villageAID, rmClassID("importantItem"));
   rmSetGroupingMinDistance(villageAID, 45.0);
   rmSetGroupingMaxDistance(villageAID, 75.0);
   rmAddGroupingConstraint(villageAID, avoidImpassableLand);
   rmAddGroupingConstraint(villageAID, avoidTradeRoute);
   rmAddGroupingConstraint(villageAID, avoidSocket);
   rmAddGroupingConstraint(villageAID, avoidWater15);
   rmAddGroupingConstraint(villageAID, avoidNatives);
   rmAddGroupingConstraint(villageAID, avoidTC);

   // Village D - opposite type from A 
   int villageDID = -1;
   villageType = rmRandInt(1,5);
   if (whichNative == 2)
	   villageDID = rmCreateGrouping("village D", native1Name+villageType);
   else if (whichNative == 1)
	   villageDID = rmCreateGrouping("village D", native2Name+villageType);
   rmAddGroupingToClass(villageDID, rmClassID("natives"));
   rmAddGroupingToClass(villageDID, rmClassID("importantItem"));
   rmSetGroupingMinDistance(villageDID, 0.0);
   rmSetGroupingMaxDistance(villageDID, rmXFractionToMeters(0.05));
   rmAddGroupingConstraint(villageDID, avoidImpassableLand);
   rmAddGroupingConstraint(villageDID, avoidTradeRoute);
   rmAddGroupingConstraint(villageDID, avoidSocket);
   rmAddGroupingConstraint(villageDID, avoidWater15);
   rmAddGroupingConstraint(villageDID, avoidNativesLong);
   rmAddGroupingConstraint(villageDID, playerConstraint);

// Center area
   int centerArea=rmCreateArea("TheCenter");
   rmSetAreaSize(centerArea, 0.08, 0.1);
   rmSetAreaLocation(centerArea, 0.5, 0.5);
   rmAddAreaToClass(centerArea, rmClassID("center")); 

// Text
   rmSetStatusText("",0.20);

// Set up player starting locations
   int fiveChance = rmRandInt(1,5);
   int threeChance = rmRandInt(1,3);
   int twoChance = rmRandInt(1,2);

   if (cNumberNonGaiaPlayers == 2)
   {   
	 sectionChance = rmRandInt(1,21);  
	 distChance = rmRandInt(1,3);
	 if (sectionChance == 1) // opposite, across axis 1
	 {
	    axisChance = 2;
          rmSetPlacementSection(0.0, 0.5);
	    if (fiveChance == 1)
		 eBigIs = 1;
	    else if (fiveChance == 2)
	 	 wBigIs = 1;
	    else if (fiveChance == 3)
	 	 eEdgeIs = 1;
	    else if (fiveChance == 4)
	 	 wEdgeIs = 1;
	    else if (fiveChance == 5)
	    {
		 if (rmRandInt(1,3) == 1)
		    directionChance = 0;
		 else
	       { 
		    if (rmRandInt(1,2) == 1)
		       directionChance = 1;
		    else
                   directionChance = 2;
		 }
	    }
	 }
	 else if (sectionChance == 2) // opposite, across axis 2
	 {
	    axisChance = 1;
          rmSetPlacementSection(0.25, 0.75);
	    if (fiveChance == 1)
		 nBigIs = 1;
	    else if (fiveChance == 2)
	 	 sBigIs = 1;
	    else if (fiveChance == 3)
	 	 nEdgeIs = 1;
	    else if (fiveChance == 4)
	 	 sEdgeIs = 1;
	    else if (fiveChance == 5)
	    {
		 if (rmRandInt(1,3) == 1)
		    directionChance = 0;
		 else
	       { 
		    if (rmRandInt(1,2) == 1)
		       directionChance = 1;
		    else
                   directionChance = 2;
		 }
	    }
	 }
	 else if (sectionChance < 5) // 3,4 East side of map
	 {
	    if (sectionChance == 3)
             rmSetPlacementSection(0.1, 0.4);
	    if (sectionChance == 4)
             rmSetPlacementSection(0.15, 0.35);
	    if (threeChance == 1)
		 wBigIs = 1;
	    else if (threeChance == 2)
	 	 wEdgeIs = 1;
	    else if (threeChance == 3)
	    {
		 if (rmRandInt(1,3) == 1)
		 {
		    directionChance = 0;
		    axisChance = 1;
		 }
		 else
		 {
		    axisChance = 2;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 1;
		    else
                   directionChance = 0;
		 }
	    }
	 }
	 else if (sectionChance < 7) // 5,6 W side of map
	 {
	    if (sectionChance == 5)
             rmSetPlacementSection(0.6, 0.9);
	    if (sectionChance == 6)
             rmSetPlacementSection(0.65, 0.85);
	    if (threeChance == 1)
		 eBigIs = 1;
	    else if (threeChance == 2)
	 	 eEdgeIs = 1;
	    else if (threeChance == 3)
	    {
		 if (rmRandInt(1,3) == 1)
		 {
		    directionChance = 0;
		    axisChance = 1;
		 }
		 else
		 {
		    axisChance = 2;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 2;
		    else
                   directionChance = 0;
		 }
	    }
	 }
	 else if (sectionChance < 9) // 7,8 S side of map
	 {
	    if (sectionChance == 7)
             rmSetPlacementSection(0.35, 0.65);
	    if (sectionChance == 8)
             rmSetPlacementSection(0.4, 0.6);
	    if (threeChance == 1)
		 nBigIs = 1;
	    else if (threeChance == 2)
	 	 nEdgeIs = 1;
	    else if (threeChance == 3)
	    {
		 if (rmRandInt(1,3) == 1)
		 {
		    directionChance = 0;
		    axisChance = 2;
		 }
		 else
		 {
		    axisChance = 1;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 2;
		    else
                   directionChance = 0;
		 }
	    }
	 }
	 else if (sectionChance < 11) // 9,10 N side of map
	 {
	    if (sectionChance == 9)
             rmSetPlacementSection(0.85, 0.15);
	    if (sectionChance == 10)
             rmSetPlacementSection(0.9, 0.1);
	    if (threeChance == 1)
		 sBigIs = 1;
	    else if (threeChance == 2)
	 	 sEdgeIs = 1;
	    else if (threeChance == 3)
	    {
		 if (rmRandInt(1,3) == 1)
		 {
		    directionChance = 0;
		    axisChance = 2;
		 }
		 else
		 {
		    axisChance = 1;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 1;
		    else
                   directionChance = 0;
		 }
	    }
	 }
	 else if (sectionChance == 11) // next 4 same side, 0.4 of map
	 {
          rmSetPlacementSection(0.05, 0.45); // E
	    if (threeChance == 1)
		 wBigIs = 1;
	    else if (threeChance == 2)
	 	 wEdgeIs = 1;
	    else if (threeChance == 3)
	    {
		 if (rmRandInt(1,2) == 1)
		 {
		    directionChance = 0;
		    axisChance = 2;
		 }
		 else
		 {
		    axisChance = 2;
		    directionChance = 1;
		 }
	    }
	 }
	 else if (sectionChance == 12)
	 {
          rmSetPlacementSection(0.55, 0.95); // W
	    if (threeChance == 1)
		 eBigIs = 1;
	    else if (threeChance == 2)
	 	 eEdgeIs = 1;
	    else if (threeChance == 3)
	    {
		 if (rmRandInt(1,2) == 1)
		 {
		    directionChance = 0;
		    axisChance = 2;
		 }
		 else
		 {
		    axisChance = 2;
  	          directionChance = 2;
		 }
	    }
	 }
	 else if (sectionChance == 13)
	 {
          rmSetPlacementSection(0.3, 0.7); // S
	    if (threeChance == 1)
		 nBigIs = 1;
	    else if (threeChance == 2)
	 	 nEdgeIs = 1;
	    else if (threeChance == 3)
	    {
		 if (rmRandInt(1,2) == 1)
		 {
		    directionChance = 0;
		    axisChance = 1;
		 }
		 else
		 {
		    axisChance = 1;
		    directionChance = 2;
		 }
	    }
	 }
	 else if (sectionChance == 14)
	 {
          rmSetPlacementSection(0.8, 0.2); // N
	    if (threeChance == 1)
		 sBigIs = 1;
	    else if (threeChance == 2)
	 	 sEdgeIs = 1;
	    else if (threeChance == 3)
	    {
		 if (rmRandInt(1,2) == 1)
		 {
		    directionChance = 0;
		    axisChance = 1;
		 }
		 else
		 {
		    axisChance = 1;
		    directionChance = 1;
		 }
          }
	 }
	 else if (sectionChance == 15) // opposite, not on axis
	 {
             rmSetPlacementSection(0.1, 0.6);
		 if (rmRandInt(1,4) == 1)
		 {
		    directionChance = 0;
		    axisChance = 1;
		 }
		 else
		 {
		    axisChance = 2;
		    if (rmRandInt(1,3) == 1)
		       directionChance = 0;
		    else
		    {
		       if (rmRandInt(1,2) == 1)
		          directionChance = 1;
		       else
                      directionChance = 2;
		    }
		 }
	 }
	 else if (sectionChance == 16) // opposite, not on axis
	 {
             rmSetPlacementSection(0.4, 0.9);
		 if (rmRandInt(1,4) == 1)
		 {
		    directionChance = 0;
		    axisChance = 1;
		 }
		 else
		 {
		    axisChance = 2;
		    if (rmRandInt(1,3) == 1)
		       directionChance = 0;
		    else
		    {
		       if (rmRandInt(1,2) == 1)
		          directionChance = 1;
		       else
                      directionChance = 2;
		    }
		 }
	 }
	 else if (sectionChance == 17) // opposite, not on axis
	 {
             rmSetPlacementSection(0.15, 0.65);
		 if (rmRandInt(1,4) == 1)
		 {
		    directionChance = 0;
		    axisChance = 2;
		 }
		 else
		 {
		    axisChance = 1;
		    if (rmRandInt(1,3) == 1)
		       directionChance = 0;
		    else
		    {
		       if (rmRandInt(1,2) == 1)
		          directionChance = 1;
		       else
                      directionChance = 2;
		    }
		 }
	 }
	 else if (sectionChance == 18) // opposite, not on axis
	 {
             rmSetPlacementSection(0.35, 0.85);
		 if (rmRandInt(1,4) == 1)
		 {
		    directionChance = 0;
		    axisChance = 2;
		 }
		 else
		 {
		    axisChance = 1;
		    if (rmRandInt(1,3) == 1)
		       directionChance = 0;
		    else
		    {
		       if (rmRandInt(1,2) == 1)
		          directionChance = 1;
		       else
                      directionChance = 2;
		    }
		 }
	 }
	 else if (sectionChance == 19) // asymmetric
	 {
          rmSetPlacementSection(0.2, 0.4);
	    if (threeChance == 1)
		 wBigIs = 1;
	    else if (threeChance == 2)
	 	 wEdgeIs = 1;
	    else if (threeChance == 3)
	    {
  	       directionChance = 1;
		 axisChance = 2;
	    }
	 }
	 else if (sectionChance == 20) // asymmetric
	 {
          rmSetPlacementSection(0.6, 0.8);
	    if (threeChance == 1)
		 eBigIs = 1;
	    else if (threeChance == 2)
	 	 eEdgeIs = 1;
	    else if (threeChance == 3)
	    {
  	       directionChance = 2;
		 axisChance = 2;
	    }
	 }
	 else if (sectionChance == 21) // asymmetric
	 {
             rmSetPlacementSection(0.0, 0.7);
		 axisChance = 2;
		 if (rmRandInt(1,2) == 1)
		 {
		    directionChance = 0;
		 }
		 else
		 {
		    directionChance = 1;
		 }
	 }
	    if (distChance == 1)
	       rmPlacePlayersCircular(0.32, 0.33, 0.0);
	    else if (distChance == 2)
	       rmPlacePlayersCircular(0.33, 0.34, 0.0);
	    else if (distChance == 3)
	       rmPlacePlayersCircular(0.34, 0.35, 0.0);
   }
   else if (cNumberTeams == 3)  
   {
	 sectionChance = rmRandInt(1,15);
	 if (sectionChance == 1) // east - next 4 0.5 circ
	 {
          rmSetPlacementSection(0.0, 0.5);
	    if (threeChance == 1)
		 wBigIs = 1;
	    else if (threeChance == 2)
	 	 wEdgeIs = 1;
	    else if (threeChance == 3)
	    {
		 if (rmRandInt(1,3) == 1)
		 {
		    axisChance = 1;
		    directionChance = 0;
             }
		 else
		 {
		    axisChance = 2;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 0;
		    else
  	             directionChance = 1;
		 }
	    }
	 }
	 else if (sectionChance == 2) // south 
	 {
          rmSetPlacementSection(0.25, 0.75);
	    if (threeChance == 1)
		 nBigIs = 1;
	    else if (threeChance == 2)
	 	 nEdgeIs = 1;
	    else if (threeChance == 3)
	    {
		 if (rmRandInt(1,3) == 1)
		 {
		    axisChance = 2;
		    directionChance = 0;
             }
		 else
		 {
		    axisChance = 1;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 0;
		    else
  	             directionChance = 2;
		 }
	    }
	 }
	 else if (sectionChance == 3) // west
	 {
          rmSetPlacementSection(0.5, 0.0);
	    if (threeChance == 1)
		 eBigIs = 1;
	    else if (threeChance == 2)
	 	 eEdgeIs = 1;
	    else if (threeChance == 3)
	    {
		 if (rmRandInt(1,3) == 1)
		 {
		    axisChance = 1;
		    directionChance = 0;
             }
		 else
		 {
		    axisChance = 2;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 0;
		    else
  	             directionChance = 2;
		 }
	    }
	 }
	 else if (sectionChance == 4) // north
	 {
          rmSetPlacementSection(0.75, 0.25);
	    if (threeChance == 1)
		 sBigIs = 1;
	    else if (threeChance == 2)
	 	 sEdgeIs = 1;
	    else if (threeChance == 3)
	    {
		 if (rmRandInt(1,3) == 1)
		 {
		    axisChance = 2;
		    directionChance = 0;
             }
		 else
		 {
		    axisChance = 1;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 0;
		    else
  	             directionChance = 1;
		 }
	    }
	 }
	 else if (sectionChance == 5) // east - next 4 0.6 circ 
	 {
          rmSetPlacementSection(0.95, 0.55);
	    if (threeChance == 1)
		 wBigIs = 1;
	    else if (threeChance == 2)
	 	 wEdgeIs = 1;
	    else if (threeChance == 3)
	    {		
		 if (rmRandInt(1,3) == 1)
		 {
		    axisChance = 1;
		    directionChance = 0;
             }
		 else
		 {
		    axisChance = 2;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 0;
		    else
  	             directionChance = 1;
		 }
	    }
	 }
	 else if (sectionChance == 6) // south 
	 {
          rmSetPlacementSection(0.15, 0.85);
	    if (threeChance == 1)
		 nBigIs = 1;
	    else if (threeChance == 2)
	 	 nEdgeIs = 1;
	    else if (threeChance == 3)
	    {	
             if (rmRandInt(1,3) == 1)
		 {
		    axisChance = 2;
		    directionChance = 0;
             }
		 else
		 {
		    axisChance = 1;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 0;
		    else
  	             directionChance = 2;
		 }
	    }
	 }
	 else if (sectionChance == 7) // west
	 {
          rmSetPlacementSection(0.4, 0.1);
	    if (threeChance == 1)
		 eBigIs = 1;
	    else if (threeChance == 2)
	 	 eEdgeIs = 1;
	    else if (threeChance == 3)
	    {	
		 if (rmRandInt(1,3) == 1)
		 {
		    axisChance = 1;
		    directionChance = 0;
             }
		 else
		 {
		    axisChance = 2;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 0;
		    else
  	             directionChance = 2;
		 }
	    }
	 }
	 else if (sectionChance == 8) // north
	 {
          rmSetPlacementSection(0.65, 0.35);
	    if (threeChance == 1)
		 sBigIs = 1;
	    else if (threeChance == 2)
	 	 sEdgeIs = 1;
	    else if (threeChance == 3)
	    {
		 if (rmRandInt(1,3) == 1)
		 {
		    axisChance = 2;
		    directionChance = 0;
             }
		 else
		 {
		    axisChance = 1;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 0;
		    else
  	             directionChance = 1;
		 }
	    }
	 }
	 else if (sectionChance == 9) // east - next 4 0.6 circ, not on axis
	 {
          rmSetPlacementSection(0.00, 0.60);
	    if (twoChance == 1)
		 wBigIs = 1;
	    else if (twoChance == 2)
	    {
		 if (rmRandInt(1,3) == 1)
		 {
		    axisChance = 1;
		    directionChance = 0;
             }
		 else
		 {
		    axisChance = 2;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 0;
		    else
  	             directionChance = 1;
		 }
	    }
	 }
	 else if (sectionChance == 10) // south 
	 {
          rmSetPlacementSection(0.25, 0.85);
	    if (twoChance == 1)
		 nBigIs = 1;
	    else if (twoChance == 2)
	    {
		 if (rmRandInt(1,3) == 1)
		 {
		    axisChance = 2;
		    directionChance = 0;
             }
		 else
		 {
		    axisChance = 1;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 0;
		    else
  	             directionChance = 2;
		 }
	    }
	 }
	 else if (sectionChance == 11) // west
	 {
          rmSetPlacementSection(0.50, 0.10);
	    if (twoChance == 1)
		 eBigIs = 1;
	    else if (twoChance == 2)
	    {
		 if (rmRandInt(1,3) == 1)
		 {
		    axisChance = 1;
		    directionChance = 0;
             }
		 else
		 {
		    axisChance = 2;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 0;
		    else
  	             directionChance = 2;
		 }
	    }
	 }
	 else if (sectionChance == 12) // north
	 {
          rmSetPlacementSection(0.75, 0.35);
	    if (twoChance == 1)
		 sBigIs = 1;
	    else if (twoChance == 2)
	    {
		 if (rmRandInt(1,3) == 1)
		 {
		    axisChance = 2;
		    directionChance = 0;
             }
		 else
		 {
		    axisChance = 1;
		    if (rmRandInt(1,2) == 1)
		       directionChance = 0;
		    else
  	             directionChance = 1;
		 }
	    }
	 }
	 else   // chance 13, 14, 15 whole circular
	 {
	    directionChance = 0;	
	 }
	    if (distChance == 1)
	       rmPlacePlayersCircular(0.31, 0.32, 0.0);
	    else if (distChance == 2)
	       rmPlacePlayersCircular(0.32, 0.33, 0.0);
	    else if (distChance == 3)
	       rmPlacePlayersCircular(0.33, 0.34, 0.0);
	    else if (distChance == 4)
	       rmPlacePlayersCircular(0.34, 0.35, 0.0);
	    else if (distChance == 5)
	       rmPlacePlayersCircular(0.35, 0.36, 0.0);
	    else if (distChance == 6)
	       rmPlacePlayersCircular(0.36, 0.37, 0.0);
   }    
   else 
   {
      if (cNumberTeams == 2)
      {
        if (cNumberNonGaiaPlayers < 5) // 2 teams, 3 or 4 players   
        {
	    directionChance = 0;
          if (axisChance == 1)
          {
	      if (sectionChance == 9)
	      {
		    sBigIs = 1;
	      }
	      if (sectionChance == 10)
	      {
		    sEdgeIs = 1;
	      }
	      if (sectionChance == 11)
	      {
		    nBigIs = 1;
	      }
	      if (sectionChance == 12)
	      {
		    nEdgeIs = 1;
	      }

           if (playerSide == 1)
	  	  rmSetPlacementTeam(0);
           else if (playerSide == 2)
	        rmSetPlacementTeam(1);

	     if (sectionChance == 1)
	       rmSetPlacementSection(0.21, 0.29);
	     else if (sectionChance == 2)
             rmSetPlacementSection(0.18, 0.32);
	     else if (sectionChance == 3)
             rmSetPlacementSection(0.19, 0.31);
	     else if (sectionChance == 4)
             rmSetPlacementSection(0.2, 0.3);
	     else if (sectionChance == 5)
             rmSetPlacementSection(0.1, 0.23); // toward CC
	     else if (sectionChance == 6)
             rmSetPlacementSection(0.11, 0.21); // toward CC
	     else if (sectionChance == 7)
             rmSetPlacementSection(0.31, 0.4); // toward C
	     else if (sectionChance == 8)
             rmSetPlacementSection(0.27, 0.39); // toward C
	     else if (sectionChance == 9)
             rmSetPlacementSection(0.12, 0.26); // toward N
	     else if (sectionChance == 10)
		 rmSetPlacementSection(0.10, 0.22); // toward N
	     else if (sectionChance == 11)
		 rmSetPlacementSection(0.28, 0.38); // toward S
	     else if (sectionChance == 12)
             rmSetPlacementSection(0.27, 0.40); // toward S

 	     if (distChance == 1)
  	        rmPlacePlayersCircular(0.31, 0.32, 0.0);
  	     else if (distChance == 2)
      	  rmPlacePlayersCircular(0.32, 0.33, 0.0);
 	     else if (distChance == 3)
              rmPlacePlayersCircular(0.33, 0.34, 0.0);
	     else if (distChance == 4)
	        rmPlacePlayersCircular(0.34, 0.35, 0.0);
           else if (distChance == 5)
              rmPlacePlayersCircular(0.35, 0.36, 0.0);
	     else if (distChance == 6)
	        rmPlacePlayersCircular(0.36, 0.37, 0.0);

	     if (playerSide == 1) 
		  rmSetPlacementTeam(1);
  	     else if (playerSide == 2)
	        rmSetPlacementTeam(0);
	     
	     if (sectionChance == 1)
             rmSetPlacementSection(0.71, 0.79);
	     else if (sectionChance == 2)
             rmSetPlacementSection(0.68, 0.82);
	     else if (sectionChance == 3)
             rmSetPlacementSection(0.69, 0.81);
	     else if (sectionChance == 4)
             rmSetPlacementSection(0.7, 0.8);
	     else if (sectionChance == 5)
             rmSetPlacementSection(0.60, 0.73); // cc
	     else if (sectionChance == 6)
             rmSetPlacementSection(0.61, 0.71); // cc
	     else if (sectionChance == 7)
             rmSetPlacementSection(0.81, 0.90); // c
	     else if (sectionChance == 8)
             rmSetPlacementSection(0.77, 0.89); // c
	     else if (sectionChance == 9)
             rmSetPlacementSection(0.74, 0.88); // n
	     else if (sectionChance == 10)
             rmSetPlacementSection(0.78, 0.90); // n
	     else if (sectionChance == 11)
             rmSetPlacementSection(0.62, 0.72); // s
	     else if (sectionChance == 12)
             rmSetPlacementSection(0.60, 0.73); // s

 	     if (distChance == 1)
  	        rmPlacePlayersCircular(0.31, 0.32, 0.0);
  	     else if (distChance == 2)
      	  rmPlacePlayersCircular(0.32, 0.33, 0.0);
 	     else if (distChance == 3)
              rmPlacePlayersCircular(0.33, 0.34, 0.0);
	     else if (distChance == 4)
	        rmPlacePlayersCircular(0.34, 0.35, 0.0);
           else if (distChance == 5)
              rmPlacePlayersCircular(0.35, 0.36, 0.0);
	     else if (distChance == 6)
	        rmPlacePlayersCircular(0.36, 0.37, 0.0);
         }
         else if (axisChance == 2)
         {
	      if (sectionChance == 9)
	      {
		    wBigIs = 1;
	      }
	      if (sectionChance == 10)
	      {
		    wEdgeIs = 1;
	      }
	      if (sectionChance == 11)
	      {
		    eBigIs = 1;
	      }
	      if (sectionChance == 12)
	      {
		    eEdgeIs = 1;
	      }

	    if (playerSide == 1)
		 rmSetPlacementTeam(0);
          else if (playerSide == 2)
		 rmSetPlacementTeam(1);

	    if (sectionChance == 1)
             rmSetPlacementSection(0.46, 0.54);
	    else if (sectionChance == 2)
             rmSetPlacementSection(0.43, 0.57);
	    else if (sectionChance == 3)
             rmSetPlacementSection(0.44, 0.56);
	    else if (sectionChance == 4)
             rmSetPlacementSection(0.45, 0.55);
	    else if (sectionChance == 5)
             rmSetPlacementSection(0.35, 0.48); // toward CC
	    else if (sectionChance == 6)
             rmSetPlacementSection(0.36, 0.46); // toward CC
	    else if (sectionChance == 7)
             rmSetPlacementSection(0.56, 0.65); // toward C
	    else if (sectionChance == 8)
             rmSetPlacementSection(0.52, 0.64); // toward C
	    else if (sectionChance == 9)
             rmSetPlacementSection(0.37, 0.51); // toward E
	    else if (sectionChance == 10)
             rmSetPlacementSection(0.40, 0.52); // toward E
	    else if (sectionChance == 11)
             rmSetPlacementSection(0.52, 0.62); // toward W
	    else if (sectionChance == 12)
             rmSetPlacementSection(0.52, 0.65); // toward W

 	     if (distChance == 1)
  	        rmPlacePlayersCircular(0.31, 0.32, 0.0);
  	     else if (distChance == 2)
      	  rmPlacePlayersCircular(0.32, 0.33, 0.0);
 	     else if (distChance == 3)
              rmPlacePlayersCircular(0.33, 0.34, 0.0);
	     else if (distChance == 4)
	        rmPlacePlayersCircular(0.34, 0.35, 0.0);
           else if (distChance == 5)
              rmPlacePlayersCircular(0.35, 0.36, 0.0);
	     else if (distChance == 6)
	        rmPlacePlayersCircular(0.36, 0.37, 0.0);

	    if (playerSide == 1)
		 rmSetPlacementTeam(1);
          else if (playerSide == 2)
		 rmSetPlacementTeam(0);
	    
	    if (sectionChance == 1)
             rmSetPlacementSection(0.96, 0.04);
	    else if (sectionChance == 2)
             rmSetPlacementSection(0.93, 0.07);
	    else if (sectionChance == 3)
             rmSetPlacementSection(0.94, 0.06);
	    else if (sectionChance == 4)
             rmSetPlacementSection(0.95, 0.05);
	    else if (sectionChance == 5)
             rmSetPlacementSection(0.85, 0.98); // toward CC
	    else if (sectionChance == 6)
             rmSetPlacementSection(0.86, 0.96); // toward CC
	    else if (sectionChance == 7)
             rmSetPlacementSection(0.06, 0.15); // toward C
	    else if (sectionChance == 8)
             rmSetPlacementSection(0.02, 0.14); // toward C
	    else if (sectionChance == 9)
             rmSetPlacementSection(0.99, 0.13); // toward E
	    else if (sectionChance == 10)
             rmSetPlacementSection(0.98, 0.10); // toward E
	    else if (sectionChance == 11)
             rmSetPlacementSection(0.88, 0.98); // toward W
	    else if (sectionChance == 12)
             rmSetPlacementSection(0.85, 0.98); // toward W

 	     if (distChance == 1)
  	        rmPlacePlayersCircular(0.31, 0.32, 0.0);
  	     else if (distChance == 2)
      	  rmPlacePlayersCircular(0.32, 0.33, 0.0);
 	     else if (distChance == 3)
              rmPlacePlayersCircular(0.33, 0.34, 0.0);
	     else if (distChance == 4)
	        rmPlacePlayersCircular(0.34, 0.35, 0.0);
           else if (distChance == 5)
              rmPlacePlayersCircular(0.35, 0.36, 0.0);
	     else if (distChance == 6)
	        rmPlacePlayersCircular(0.36, 0.37, 0.0);
         }	  
        }
        else if (cNumberNonGaiaPlayers < 7) // for 2 teams, for 5-6 players  
        {
	       directionChance = 0;
             if (axisChance == 1)
             { 
	        if (sectionChance == 9)
	        {
	          if (twoChance == 1)
		     sBigIs = 1;
	          else if (twoChance == 2)
	 	     sEdgeIs = 1;
	        }
	        if (sectionChance == 10)
	        {
	          if (twoChance == 1)
		     sBigIs = 1;
	          else if (twoChance == 2)
	 	     sEdgeIs = 1;
	        }
	        if (sectionChance == 11)
	        {
	          if (twoChance == 1)
		     nBigIs = 1;
	          else if (twoChance == 2)
	 	     nEdgeIs = 1;
	        }
	        if (sectionChance == 12)
	        {
	          if (twoChance == 1)
		     nBigIs = 1;
	          else if (twoChance == 2)
	 	     nEdgeIs = 1;
	        }
 
             if (playerSide == 1)
	  	    rmSetPlacementTeam(0);
             else if (playerSide == 2)
		    rmSetPlacementTeam(1);

	       if (sectionChance == 1)
                rmSetPlacementSection(0.16, 0.35);
	       else if (sectionChance == 2)
                rmSetPlacementSection(0.17, 0.33);
	       else if (sectionChance == 3)
                rmSetPlacementSection(0.15, 0.35);
	       else if (sectionChance == 4)
                rmSetPlacementSection(0.16, 0.34);
	       else if (sectionChance == 5)
                rmSetPlacementSection(0.09, 0.24); // toward CC
	       else if (sectionChance == 6)
                rmSetPlacementSection(0.09, 0.27); // toward CC
	       else if (sectionChance == 7)
                rmSetPlacementSection(0.16, 0.34); // toward C
	       else if (sectionChance == 8)
                rmSetPlacementSection(0.21, 0.41); // toward C
	       else if (sectionChance == 9)
                rmSetPlacementSection(0.12, 0.32); // toward N
	       else if (sectionChance == 10)
	  	    rmSetPlacementSection(0.09, 0.25); // toward N
	       else if (sectionChance == 11)
                rmSetPlacementSection(0.18, 0.38); // toward S
	       else if (sectionChance == 12)
                rmSetPlacementSection(0.25, 0.42); // toward S

             if (distChance == 1)
                rmPlacePlayersCircular(0.31, 0.32, 0.0);
             else if (distChance == 2)
                rmPlacePlayersCircular(0.32, 0.33, 0.0);
        	 else if (distChance == 3)
         	    rmPlacePlayersCircular(0.33, 0.34, 0.0);
		 else if (distChance == 4)
	          rmPlacePlayersCircular(0.35, 0.36, 0.0);
      	 else if (distChance == 5)
	   	    rmPlacePlayersCircular(0.36, 0.37, 0.0);
		 else if (distChance == 6)
	          rmPlacePlayersCircular(0.37, 0.38, 0.0);

	       if (playerSide == 1)
		    rmSetPlacementTeam(1);
             else if (playerSide == 2)
		    rmSetPlacementTeam(0);

	       if (sectionChance == 1)
                rmSetPlacementSection(0.66, 0.85);
	       else if (sectionChance == 2)
                rmSetPlacementSection(0.67, 0.83);
	       else if (sectionChance == 3)
                rmSetPlacementSection(0.65, 0.85);
	       else if (sectionChance == 4)
                rmSetPlacementSection(0.66, 0.84);
	       else if (sectionChance == 5)
                rmSetPlacementSection(0.59, 0.74); // cc
	       else if (sectionChance == 6)
                rmSetPlacementSection(0.59, 0.77); // cc
	       else if (sectionChance == 7)
                rmSetPlacementSection(0.66, 0.84); // c
	       else if (sectionChance == 8)
                rmSetPlacementSection(0.71, 0.91); // c
	       else if (sectionChance == 9)
                rmSetPlacementSection(0.68, 0.88); // n
	       else if (sectionChance == 10)
                rmSetPlacementSection(0.75, 0.91); // n
	       else if (sectionChance == 11)
                rmSetPlacementSection(0.62, 0.82); // s
	       else if (sectionChance == 12)
                rmSetPlacementSection(0.58, 0.75); // s

             if (distChance == 1)
                rmPlacePlayersCircular(0.31, 0.32, 0.0);
             else if (distChance == 2)
                rmPlacePlayersCircular(0.32, 0.33, 0.0);
        	 else if (distChance == 3)
         	    rmPlacePlayersCircular(0.33, 0.34, 0.0);
		 else if (distChance == 4)
	          rmPlacePlayersCircular(0.35, 0.36, 0.0);
      	 else if (distChance == 5)
	   	    rmPlacePlayersCircular(0.36, 0.37, 0.0);
		 else if (distChance == 6)
	          rmPlacePlayersCircular(0.37, 0.38, 0.0);
             }
             else if (axisChance == 2)
             {
	        if (sectionChance == 9)
	        {
	          if (twoChance == 1)
		     wBigIs = 1;
	          else if (twoChance == 2)
	 	     wEdgeIs = 1;
	        }
	        if (sectionChance == 10)
	        {
	          if (twoChance == 1)
		     wBigIs = 1;
	          else if (twoChance == 2)
	 	     wEdgeIs = 1;
	        }
	        if (sectionChance == 11)
	        {
	          if (twoChance == 1)
		     eBigIs = 1;
	          else if (twoChance == 2)
	 	     eEdgeIs = 1;
	        }
	        if (sectionChance == 12)
	        {
	          if (twoChance == 1)
		     eBigIs = 1;
	          else if (twoChance == 2)
	 	     eEdgeIs = 1;
	        }

	       if (playerSide == 1)
		    rmSetPlacementTeam(0);
             else if (playerSide == 2)
		    rmSetPlacementTeam(1);

	       if (sectionChance == 1)
                rmSetPlacementSection(0.41, 0.60);
	       else if (sectionChance == 2)
                rmSetPlacementSection(0.42, 0.58);
	       else if (sectionChance == 3)
                rmSetPlacementSection(0.40, 0.60);
	       else if (sectionChance == 4)
                rmSetPlacementSection(0.41, 0.59);
	       else if (sectionChance == 5)
                rmSetPlacementSection(0.35, 0.54); // toward CC
	       else if (sectionChance == 6)
                rmSetPlacementSection(0.36, 0.52); // toward CC
	       else if (sectionChance == 7)
                rmSetPlacementSection(0.44, 0.63); // toward C
	       else if (sectionChance == 8)
                rmSetPlacementSection(0.46, 0.66); // toward C
	       else if (sectionChance == 9)
                rmSetPlacementSection(0.36, 0.57); // toward E
	       else if (sectionChance == 10)
                rmSetPlacementSection(0.33, 0.48); // toward E
	       else if (sectionChance == 11)
                rmSetPlacementSection(0.43, 0.63); // toward W
	       else if (sectionChance == 12)
                rmSetPlacementSection(0.49, 0.65); // toward W

             if (distChance == 1)
                rmPlacePlayersCircular(0.31, 0.32, 0.0);
             else if (distChance == 2)
                rmPlacePlayersCircular(0.32, 0.33, 0.0);
        	 else if (distChance == 3)
         	    rmPlacePlayersCircular(0.33, 0.34, 0.0);
		 else if (distChance == 4)
	          rmPlacePlayersCircular(0.35, 0.36, 0.0);
      	 else if (distChance == 5)
	   	    rmPlacePlayersCircular(0.36, 0.37, 0.0);
		 else if (distChance == 6)
	          rmPlacePlayersCircular(0.37, 0.38, 0.0);
   
	       if (playerSide == 1)
	   	    rmSetPlacementTeam(1);
             else if (playerSide == 2)
		    rmSetPlacementTeam(0);

	       if (sectionChance == 1)
                rmSetPlacementSection(0.91, 0.10);
	       else if (sectionChance == 2)
                rmSetPlacementSection(0.92, 0.08);
	       else if (sectionChance == 3)
                rmSetPlacementSection(0.90, 0.10);
   	       else if (sectionChance == 4)
                rmSetPlacementSection(0.91, 0.09);
	       else if (sectionChance == 5)
                rmSetPlacementSection(0.85, 0.04); // toward CC
	       else if (sectionChance == 6)
                rmSetPlacementSection(0.86, 0.02); // toward CC
	       else if (sectionChance == 7)
                rmSetPlacementSection(0.94, 0.15); // toward C
	       else if (sectionChance == 8)
                rmSetPlacementSection(0.96, 0.16); // toward C
	       else if (sectionChance == 9)
                rmSetPlacementSection(0.93, 0.14); // toward E
	       else if (sectionChance == 10)
                rmSetPlacementSection(0.02, 0.17); // toward E
	       else if (sectionChance == 11)
                rmSetPlacementSection(0.87, 0.07); // toward W
	       else if (sectionChance == 12)
                rmSetPlacementSection(0.85, 0.01); // toward W

             if (distChance == 1)
                rmPlacePlayersCircular(0.31, 0.32, 0.0);
             else if (distChance == 2)
                rmPlacePlayersCircular(0.32, 0.33, 0.0);
        	 else if (distChance == 3)
         	    rmPlacePlayersCircular(0.33, 0.34, 0.0);
		 else if (distChance == 4)
	          rmPlacePlayersCircular(0.35, 0.36, 0.0);
      	 else if (distChance == 5)
	   	    rmPlacePlayersCircular(0.36, 0.37, 0.0);
		 else if (distChance == 6)
	          rmPlacePlayersCircular(0.37, 0.38, 0.0);
	       } 
        }
        else  // for 2 teams, for 7-8 players 	
        {
		 distChance = rmRandInt(1,7); 
             directionChance = 0;
             if (axisChance == 1)
             { 
	        if (sectionChance == 9)
	        {
	          if (twoChance == 1)
		     sBigIs = 1;
	          else if (twoChance == 2)
	 	     sEdgeIs = 1;
	        }
	        if (sectionChance == 10)
	        {
	          if (twoChance == 1)
		     sBigIs = 1;
	          else if (twoChance == 2)
	 	     sEdgeIs = 1;
	        }
	        if (sectionChance == 11)
	        {
	          if (twoChance == 1)
		     nBigIs = 1;
	          else if (twoChance == 2)
	 	     nEdgeIs = 1;
	        }
	        if (sectionChance == 12)
	        {
	          if (twoChance == 1)
		     nBigIs = 1;
	          else if (twoChance == 2)
	 	     nEdgeIs = 1;
	        }
 
             if (playerSide == 1)
	  	    rmSetPlacementTeam(0);
             else if (playerSide == 2)
		    rmSetPlacementTeam(1);

	       if (sectionChance == 1)
                rmSetPlacementSection(0.13, 0.37);
	       else if (sectionChance == 2)
                rmSetPlacementSection(0.14, 0.36);
	       else if (sectionChance == 3)
                rmSetPlacementSection(0.14, 0.35);
	       else if (sectionChance == 4)
                rmSetPlacementSection(0.16, 0.34);
	       else if (sectionChance == 5)
                rmSetPlacementSection(0.1, 0.30); // toward CC
	       else if (sectionChance == 6)
                rmSetPlacementSection(0.09, 0.31); // toward CC
	       else if (sectionChance == 7)
                rmSetPlacementSection(0.17, 0.4); // toward C
	       else if (sectionChance == 8)
                rmSetPlacementSection(0.22, 0.41); // toward C
	       else if (sectionChance == 9)
                rmSetPlacementSection(0.11, 0.29); // toward N
	       else if (sectionChance == 10)
	  	    rmSetPlacementSection(0.09, 0.29); // toward N
	       else if (sectionChance == 11)
                rmSetPlacementSection(0.20, 0.40); // toward S
	       else if (sectionChance == 12)
                rmSetPlacementSection(0.24, 0.42); // toward S

             if (distChance == 1)
                rmPlacePlayersCircular(0.31, 0.32, 0.0);
             else if (distChance == 2)
                rmPlacePlayersCircular(0.32, 0.33, 0.0);
        	 else if (distChance == 3)
         	    rmPlacePlayersCircular(0.33, 0.34, 0.0);
		 else if (distChance == 4)
	          rmPlacePlayersCircular(0.34, 0.35, 0.0);
      	 else if (distChance == 5)
	   	    rmPlacePlayersCircular(0.36, 0.37, 0.0);
		 else if (distChance == 6)
	          rmPlacePlayersCircular(0.37, 0.38, 0.0);
	       else if (distChance == 7)
         	    rmPlacePlayersCircular(0.38, 0.39, 0.0);

	       if (playerSide == 1)
		    rmSetPlacementTeam(1);
             else if (playerSide == 2)
		    rmSetPlacementTeam(0);

	       if (sectionChance == 1)
                rmSetPlacementSection(0.63, 0.87);
	       else if (sectionChance == 2)
                rmSetPlacementSection(0.64, 0.86);
	       else if (sectionChance == 3)
                rmSetPlacementSection(0.64, 0.85);
	       else if (sectionChance == 4)
                rmSetPlacementSection(0.66, 0.84);
	       else if (sectionChance == 5)
                rmSetPlacementSection(0.60, 0.80); // cc
	       else if (sectionChance == 6)
                rmSetPlacementSection(0.59, 0.81); // cc
	       else if (sectionChance == 7)
                rmSetPlacementSection(0.67, 0.90); // c
	       else if (sectionChance == 8)
                rmSetPlacementSection(0.72, 0.91); // c
	       else if (sectionChance == 9)
                rmSetPlacementSection(0.71, 0.89); // n
	       else if (sectionChance == 10)
                rmSetPlacementSection(0.71, 0.91); // n
	       else if (sectionChance == 11)
                rmSetPlacementSection(0.60, 0.80); // s
	       else if (sectionChance == 12)
                rmSetPlacementSection(0.58, 0.76); // s

             if (distChance == 1)
                rmPlacePlayersCircular(0.31, 0.32, 0.0);
             else if (distChance == 2)
                rmPlacePlayersCircular(0.32, 0.33, 0.0);
        	 else if (distChance == 3)
         	    rmPlacePlayersCircular(0.33, 0.34, 0.0);
		 else if (distChance == 4)
	          rmPlacePlayersCircular(0.34, 0.35, 0.0);
      	 else if (distChance == 5)
	   	    rmPlacePlayersCircular(0.36, 0.37, 0.0);
		 else if (distChance == 6)
	          rmPlacePlayersCircular(0.37, 0.38, 0.0);
	       else if (distChance == 7)
         	    rmPlacePlayersCircular(0.38, 0.39, 0.0);
             }
             else if (axisChance == 2)
             {
	        if (sectionChance == 9)
	        {
	          if (twoChance == 1)
		     wBigIs = 1;
	          else if (twoChance == 2)
	 	     wEdgeIs = 1;
	        }
	        if (sectionChance == 10)
	        {
	          if (twoChance == 1)
		     wBigIs = 1;
	          else if (twoChance == 2)
	 	     wEdgeIs = 1;
	        }
	        if (sectionChance == 11)
	        {
	          if (twoChance == 1)
		     eBigIs = 1;
	          else if (twoChance == 2)
	 	     eEdgeIs = 1;
	        }
	        if (sectionChance == 12)
	        {
	          if (twoChance == 1)
		     eBigIs = 1;
	          else if (twoChance == 2)
	 	     eEdgeIs = 1;
	        }

	       if (playerSide == 1)
		    rmSetPlacementTeam(0);
             else if (playerSide == 2)
		    rmSetPlacementTeam(1);

	       if (sectionChance == 1)
                rmSetPlacementSection(0.38, 0.62);
	       else if (sectionChance == 2)
                rmSetPlacementSection(0.39, 0.62);
	       else if (sectionChance == 3)
                rmSetPlacementSection(0.40, 0.60);
	       else if (sectionChance == 4)
                rmSetPlacementSection(0.41, 0.59);
	       else if (sectionChance == 5)
                rmSetPlacementSection(0.35, 0.54); // toward CC
	       else if (sectionChance == 6)
                rmSetPlacementSection(0.34, 0.56); // toward CC
	       else if (sectionChance == 7)
                rmSetPlacementSection(0.42, 0.65); // toward C
	       else if (sectionChance == 8)
                rmSetPlacementSection(0.46, 0.66); // toward C
	       else if (sectionChance == 9)
                rmSetPlacementSection(0.36, 0.57); // toward E
	       else if (sectionChance == 10)
                rmSetPlacementSection(0.33, 0.51); // toward E
	       else if (sectionChance == 11)
                rmSetPlacementSection(0.44, 0.62); // toward W
	       else if (sectionChance == 12)
                rmSetPlacementSection(0.42, 0.65); // toward W

             if (distChance == 1)
                rmPlacePlayersCircular(0.31, 0.32, 0.0);
             else if (distChance == 2)
                rmPlacePlayersCircular(0.32, 0.33, 0.0);
        	 else if (distChance == 3)
         	    rmPlacePlayersCircular(0.33, 0.34, 0.0);
		 else if (distChance == 4)
	          rmPlacePlayersCircular(0.34, 0.35, 0.0);
      	 else if (distChance == 5)
	   	    rmPlacePlayersCircular(0.36, 0.37, 0.0);
		 else if (distChance == 6)
	          rmPlacePlayersCircular(0.37, 0.38, 0.0);
	       else if (distChance == 7)
         	    rmPlacePlayersCircular(0.38, 0.39, 0.0);
   
	       if (playerSide == 1)
	   	    rmSetPlacementTeam(1);
             else if (playerSide == 2)
		    rmSetPlacementTeam(0);

	       if (sectionChance == 1)
                rmSetPlacementSection(0.88, 0.12);
	       else if (sectionChance == 2)
                rmSetPlacementSection(0.89, 0.12);
	       else if (sectionChance == 3)
                rmSetPlacementSection(0.90, 0.10);
   	       else if (sectionChance == 4)
                rmSetPlacementSection(0.91, 0.09);
	       else if (sectionChance == 5)
                rmSetPlacementSection(0.85, 0.04); // toward CC
	       else if (sectionChance == 6)
                rmSetPlacementSection(0.84, 0.06); // toward CC
	       else if (sectionChance == 7)
                rmSetPlacementSection(0.92, 0.15); // toward C
	       else if (sectionChance == 8)
                rmSetPlacementSection(0.96, 0.16); // toward C
	       else if (sectionChance == 9)
                rmSetPlacementSection(0.93, 0.14); // toward E
	       else if (sectionChance == 10)
                rmSetPlacementSection(0.99, 0.17); // toward E
	       else if (sectionChance == 11)
                rmSetPlacementSection(0.88, 0.06); // toward W
	       else if (sectionChance == 12)
                rmSetPlacementSection(0.85, 0.08); // toward W

             if (distChance == 1)
                rmPlacePlayersCircular(0.31, 0.32, 0.0);
             else if (distChance == 2)
                rmPlacePlayersCircular(0.32, 0.33, 0.0);
        	 else if (distChance == 3)
         	    rmPlacePlayersCircular(0.33, 0.34, 0.0);
		 else if (distChance == 4)
	          rmPlacePlayersCircular(0.34, 0.35, 0.0);
      	 else if (distChance == 5)
	   	    rmPlacePlayersCircular(0.36, 0.37, 0.0);
		 else if (distChance == 6)
	          rmPlacePlayersCircular(0.37, 0.38, 0.0);
	       else if (distChance == 7)
         	    rmPlacePlayersCircular(0.38, 0.39, 0.0);
	       } 
        }
	}
      else  // for FFA for over 3 teams
      {
	   sectionChance = rmRandInt(1,5);
	   if (sectionChance > 4) // another chance at circular placement
	   {
            directionChance = 0;
            if (cNumberNonGaiaPlayers < 6) //FFA 4 or 5 pl
            {
               if (distChance == 1)
                  rmPlacePlayersCircular(0.31, 0.32, 0.0);
      	   else if (distChance == 2)
                  rmPlacePlayersCircular(0.32, 0.33, 0.0);
		   else if (distChance == 3)
         	      rmPlacePlayersCircular(0.33, 0.34, 0.0);
      	   else if (distChance == 4)
	            rmPlacePlayersCircular(0.34, 0.35, 0.0);
		   else if (distChance == 5)
	   	      rmPlacePlayersCircular(0.36, 0.37, 0.0);
               else if (distChance == 6)
	            rmPlacePlayersCircular(0.37, 0.38, 0.0);
            }
            else  // over 5 FFA 
            { 
 	         if (distChance == 1)
                  rmPlacePlayersCircular(0.31, 0.32, 0.0);
	         else if (distChance == 2)
	            rmPlacePlayersCircular(0.32, 0.33, 0.0);
	         else if (distChance == 3)
	            rmPlacePlayersCircular(0.34, 0.35, 0.0);
	         else if (distChance == 4)
	            rmPlacePlayersCircular(0.36, 0.37, 0.0);
	         else if (distChance == 5)
	            rmPlacePlayersCircular(0.38, 0.39, 0.0);
	         else if (distChance == 6)
	            rmPlacePlayersCircular(0.39, 0.40, 0.0);
            }
	   }
         else 
         {
	      if (sectionChance == 1) // 0.7 of map, gap to E	
		{
		    if (threeChance == 1)
			eBigIs = 1;
		    else if (threeChance == 2)
		    {
		       axisChance = 1;
		       directionChance = 0;
		    }
		    else
	          {
		       axisChance = 2;		     
		       if (rmRandInt(1,3) == 1)
		          directionChance = 0;
		       else
                      directionChance = 2;
		    }
                rmSetPlacementSection(0.39, 0.11);
		}
	      else if (sectionChance == 2) // 0.7 of map, gap to W
            {
		    if (threeChance == 1)
			wBigIs = 1;
		    else if (threeChance == 2)
		   {
		      axisChance = 1;
		      directionChance = 0;
		   }
		   else
	         {
		      axisChance = 2;		     
		      if (rmRandInt(1,3) == 1)
		         directionChance = 0;
		      else
                     directionChance = 1;
		   }
               rmSetPlacementSection(0.89, 0.61);
		}
            else if (sectionChance == 3) // 0.7 of map, gap to S
            {	
		    if (threeChance == 1)
			sBigIs = 1;
		    else if (threeChance == 2)
		   {
		      axisChance = 2;
		      directionChance = 0;
		   }
		   else
	         {
		      axisChance = 1;		     
		      if (rmRandInt(1,3) == 1)
		         directionChance = 0;
		      else
                     directionChance = 1;
		   }
               rmSetPlacementSection(0.64, 0.36);
            }
            else if (sectionChance == 4) // 0.7 of map, gap to N
            {	
		    if (threeChance == 1)
			nBigIs = 1;
		    else if (threeChance == 2)
		   {
		      axisChance = 2;
		      directionChance = 0;
		   }
		   else
	         {
		      axisChance = 1;		     
		      if (rmRandInt(1,3) == 1)
		         directionChance = 0;
		      else
                     directionChance = 2;
               }
               rmSetPlacementSection(0.14, 0.86);
            }  
		if (cNumberNonGaiaPlayers < 6)
		{
               if (distChance == 1)
                  rmPlacePlayersCircular(0.31, 0.32, 0.0);
      	   else if (distChance == 2)
                  rmPlacePlayersCircular(0.32, 0.33, 0.0);
		   else if (distChance == 3)
         	      rmPlacePlayersCircular(0.33, 0.34, 0.0);
      	   else if (distChance == 4)
	            rmPlacePlayersCircular(0.34, 0.35, 0.0);
		   else if (distChance == 5)
	   	      rmPlacePlayersCircular(0.36, 0.37, 0.0);
               else if (distChance == 6)
	            rmPlacePlayersCircular(0.37, 0.38, 0.0);
		}
		else
		{
 	         if (distChance == 1)
                  rmPlacePlayersCircular(0.32, 0.33, 0.0);
	         else if (distChance == 2)
	            rmPlacePlayersCircular(0.33, 0.34, 0.0);
	         else if (distChance == 3)
	            rmPlacePlayersCircular(0.34, 0.35, 0.0);
	         else if (distChance == 4)
	            rmPlacePlayersCircular(0.36, 0.37, 0.0);
	         else if (distChance == 5)
	            rmPlacePlayersCircular(0.38, 0.39, 0.0);
	         else if (distChance == 6)
	            rmPlacePlayersCircular(0.40, 0.41, 0.0);
		}
         }
      }
   }

// Text
   rmSetStatusText("",0.25);

// Build team areas.
   int teamZeroCount = rmGetNumberPlayersOnTeam(0);
   int teamOneCount = rmGetNumberPlayersOnTeam(1);
   float islandFraction=0.18/cNumberTeams;  // for teams > 2 
   float landFraction = rmRandFloat(0.12,0.14);  // for teams = 2
   if (cNumberTeams == 2)
   {
      if (cNumberNonGaiaPlayers == 3)
	   landFraction=rmRandFloat(0.12,0.14);
      if (cNumberNonGaiaPlayers == 4)
	   landFraction=rmRandFloat(0.13,0.16);
      if (cNumberNonGaiaPlayers == 5)
	   landFraction=rmRandFloat(0.13,0.16);
      if (cNumberNonGaiaPlayers == 6)  
	   landFraction=rmRandFloat(0.14,0.16);
      if (cNumberNonGaiaPlayers > 6)
	   landFraction=rmRandFloat(0.17,0.19);

	islandFraction=landFraction/cNumberTeams;
   }
 
   for(i=0; <cNumberTeams)  
   {
      int teamID=rmCreateArea("team"+i);
      rmSetAreaSize(teamID, islandFraction, islandFraction);
      rmSetAreaWarnFailure(teamID, false);
      rmSetAreaMix(teamID, baseType);
      rmSetAreaSmoothDistance(teamID, 15);
	rmSetAreaCoherence(teamID, 0.9);
      rmSetAreaElevationVariation(teamID, 1.0);
      rmSetAreaElevationMinFrequency(teamID, 0.09);
      rmSetAreaElevationOctaves(teamID, 3);
      rmSetAreaElevationPersistence(teamID, 0.2);
	rmSetAreaElevationNoiseBias(teamID, 1); 
      rmAddAreaToClass(teamID, teamClass);
	rmSetAreaElevationEdgeFalloffDist(teamID, 15.0); 
	if (noHeight == 1)
         rmSetAreaBaseHeight(teamID, 1.0);
	else
         rmSetAreaBaseHeight(teamID, baseHeight);
      rmSetAreaHeightBlend(teamID, 2);
      rmAddAreaConstraint(teamID, avoidCenter);
      rmAddAreaConstraint(teamID, teamConstraint);
      rmAddAreaConstraint(teamID, teamEdgeConstraint);  
      rmAddAreaConstraint(teamID, shortEdgeConstraint);   
      rmSetAreaLocTeam(teamID, i);
   }

// Set up player areas.
   float playerFraction=rmAreaTilesToFraction(7000 + cNumberNonGaiaPlayers*150);
   float randomIslandChance=rmRandFloat(0,1);

   for(i=1; <cNumberPlayers)
   {
      int id=rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, 0.97*playerFraction, 1.03*playerFraction);
      rmAddAreaToClass(id, classPlayer);
	if (noHeight == 1)
         rmSetAreaBaseHeight(id, 1.0);
	else
         rmSetAreaBaseHeight(id, baseHeight);
      rmSetAreaHeightBlend(id, 2);
      rmSetAreaSmoothDistance(id, 20);
	rmSetAreaCoherence(id, 0.9);
      rmSetAreaElevationVariation(id, 1.0);
      rmSetAreaElevationMinFrequency(id, 0.09);
      rmSetAreaElevationOctaves(id, 3);
      rmSetAreaElevationPersistence(id, 0.2);
	rmSetAreaElevationNoiseBias(id, 1);
      if (cNumberTeams > 2)
         rmAddAreaConstraint(id, playerLandConstraint);
	rmAddAreaConstraint(id, playerEdgeConstraint);
      rmAddAreaConstraint(id, shortEdgeConstraint);   
      rmSetAreaLocPlayer(id, i);
      rmSetAreaMix(id, baseType);
   }

// Big or Center Island
   int bigIslandID=rmCreateArea("big island");
   rmSetAreaSize(bigIslandID, rmAreaTilesToFraction(5000 + cNumberNonGaiaPlayers*700), rmAreaTilesToFraction(5500 + cNumberNonGaiaPlayers*800));
   if (wBigIs == 1)
   {
      rmSetAreaLocation(bigIslandID, 0.28, 0.5);
      rmAddAreaInfluenceSegment(bigIslandID, 0.12, 0.5, 0.44, 0.5);
   }
   else if (wEdgeIs == 1)
   {
      rmSetAreaLocation(bigIslandID, 0.2, 0.5);
      rmAddAreaInfluenceSegment(bigIslandID, 0.19, 0.5, 0.28, 0.69);
      rmAddAreaInfluenceSegment(bigIslandID, 0.19, 0.5, 0.28, 0.31);
   }
   else if (eBigIs == 1)
   {
      rmSetAreaLocation(bigIslandID, 0.72, 0.5);
      rmAddAreaInfluenceSegment(bigIslandID, 0.56, 0.5, 0.88, 0.5);
   } 
   else if (eEdgeIs == 1)
   {
      rmSetAreaLocation(bigIslandID, 0.81, 0.5);
      rmAddAreaInfluenceSegment(bigIslandID, 0.82, 0.5, 0.72, 0.69);
      rmAddAreaInfluenceSegment(bigIslandID, 0.82, 0.5, 0.72, 0.31);
   } 
   else if (sBigIs == 1)
   {
      rmSetAreaLocation(bigIslandID, 0.5, 0.28);
      rmAddAreaInfluenceSegment(bigIslandID, 0.5, 0.12, 0.5, 0.44);
   }
   else if (sEdgeIs == 1)
   {
      rmSetAreaLocation(bigIslandID, 0.5, 0.2);
      rmAddAreaInfluenceSegment(bigIslandID, 0.5, 0.19, 0.69, 0.28);
      rmAddAreaInfluenceSegment(bigIslandID, 0.5, 0.19, 0.31, 0.28);
   }
   else if (nBigIs == 1)
   {
      rmSetAreaLocation(bigIslandID, 0.5, 0.72);
      rmAddAreaInfluenceSegment(bigIslandID, 0.5, 0.88, 0.5, 0.56);
   }
   else if (nEdgeIs == 1)
   {
      rmSetAreaLocation(bigIslandID, 0.5, 0.8);
      rmAddAreaInfluenceSegment(bigIslandID, 0.5, 0.81, 0.69, 0.72);
      rmAddAreaInfluenceSegment(bigIslandID, 0.5, 0.81, 0.31, 0.72);
   } 
   else
   {
      centeredBigIsland = 1;
      rmSetAreaLocation(bigIslandID, 0.5, 0.5);
      if (axisChance == 1)
      {
	   if (directionChance == 1)
           rmAddAreaInfluenceSegment(bigIslandID, 0.5, 0.28, 0.5, 0.55);           
	   else if (directionChance == 2)
           rmAddAreaInfluenceSegment(bigIslandID, 0.5, 0.72, 0.5, 0.45);
	   else if (directionChance == 0)
           rmAddAreaInfluenceSegment(bigIslandID, 0.5, 0.38, 0.5, 0.62);
	   if (variantChance == 1)
           rmAddAreaInfluenceSegment(bigIslandID, 0.45, 0.5, 0.5, 0.5);  
	   else
           rmAddAreaInfluenceSegment(bigIslandID, 0.55, 0.5, 0.5, 0.5);  
      }
      else if (axisChance == 2)
      {
	   if (directionChance == 1)
           rmAddAreaInfluenceSegment(bigIslandID, 0.55, 0.5, 0.28, 0.5);
	   else if (directionChance == 2)
           rmAddAreaInfluenceSegment(bigIslandID, 0.45, 0.5, 0.72, 0.5);
	   else if (directionChance == 0)
           rmAddAreaInfluenceSegment(bigIslandID, 0.38, 0.5, 0.62, 0.5);
	   if (variantChance == 1)
           rmAddAreaInfluenceSegment(bigIslandID, 0.5, 0.45, 0.5, 0.5);  
	   else
           rmAddAreaInfluenceSegment(bigIslandID, 0.5, 0.55, 0.5, 0.5);  
      }
   }
   rmSetAreaMix(bigIslandID, baseType);
   rmSetAreaWarnFailure(bigIslandID, false);
   rmAddAreaConstraint(bigIslandID, playerConstraint);
   rmAddAreaConstraint(bigIslandID, landAvoidTeamLands);  
   rmAddAreaToClass(bigIslandID, classSettlementIsland);
   rmAddAreaToClass(bigIslandID, classCenterIsland);
   rmAddAreaToClass(bigIslandID, classGoldIsland);
   rmSetAreaCoherence(bigIslandID, 0.5);
   rmSetAreaSmoothDistance(bigIslandID, 12);
   rmSetAreaHeightBlend(bigIslandID, 2);
   rmSetAreaBaseHeight(bigIslandID, baseHeight);

   rmBuildAllAreas();

// Extra Big Island Land
   int extraCount=cNumberNonGaiaPlayers + 2;  // num players plus some extra
   if (cNumberNonGaiaPlayers > 6)
      extraCount=cNumberNonGaiaPlayers + 1;
  
   for(i=0; <extraCount)
   {
      int extraLandID=rmCreateArea("extraland"+i);
      rmSetAreaSize(extraLandID, rmAreaTilesToFraction(500 + cNumberNonGaiaPlayers*100), rmAreaTilesToFraction(600 + cNumberNonGaiaPlayers*120));
      rmSetAreaMix(extraLandID, baseType);
      rmSetAreaWarnFailure(extraLandID, false);
	if ((eBigIs == 1) || (eEdgeIs == 1))
  	   rmAddAreaConstraint(extraLandID, Eastward);
	else if ((wBigIs == 1) || (wEdgeIs == 1))
  	   rmAddAreaConstraint(extraLandID, Westward);
	else if ((nBigIs == 1) || (nEdgeIs == 1))
  	   rmAddAreaConstraint(extraLandID, Northward);
	else if ((sBigIs == 1) || (sEdgeIs == 1))
  	   rmAddAreaConstraint(extraLandID, Southward);
	else
	{
      if (cNumberNonGaiaPlayers > 5)
         rmAddAreaConstraint(extraLandID, centralExtraLandConstraint2);
	else	
         rmAddAreaConstraint(extraLandID, centralExtraLandConstraint);
	}
      rmAddAreaConstraint(extraLandID, playerConstraint); 
      rmAddAreaConstraint(extraLandID, landAvoidTeamLands);
      rmAddAreaConstraint(extraLandID, playerEdgeConstraint);  
      rmAddAreaToClass(extraLandID, classCenterIsland);
      rmAddAreaToClass(extraLandID, classGoldIsland);
      rmSetAreaCoherence(extraLandID, 0.55);
      rmSetAreaSmoothDistance(extraLandID, 20);
      rmSetAreaHeightBlend(extraLandID, 2);
      rmSetAreaBaseHeight(extraLandID, baseHeight);
      rmBuildArea(extraLandID);
   }

// Text
   rmSetStatusText("",0.30);

// Trade Route
int tradeRouteID = rmCreateTradeRoute();
if (wBigIs == 1)
{
   rmAddTradeRouteWaypoint(tradeRouteID, 0.13, 0.5);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.24, 0.525);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.34, 0.475);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.43, 0.5);
}
else if (eBigIs == 1)
{
   rmAddTradeRouteWaypoint(tradeRouteID, 0.85, 0.5);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.76, 0.525);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.66, 0.475);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.57, 0.5);
}
else if (wEdgeIs == 1)
{
   rmAddTradeRouteWaypoint(tradeRouteID, 0.27, 0.68);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.2, 0.53);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.2, 0.47);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.27, 0.32);
}
else if (eEdgeIs == 1)
{
   rmAddTradeRouteWaypoint(tradeRouteID, 0.73, 0.68);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.81, 0.53);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.81, 0.47);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.73, 0.32);
}
else if (sBigIs == 1)
{
   rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.13);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.52, 0.24);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.48, 0.34);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.43);
}
else if (nBigIs == 1)
{
   rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.87);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.52, 0.76);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.48, 0.66);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.57);
}
else if (sEdgeIs == 1)
{
   rmAddTradeRouteWaypoint(tradeRouteID, 0.68, 0.27);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.53, 0.2);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.47, 0.2);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.32, 0.27);
}
else if (nEdgeIs == 1)
{
   rmAddTradeRouteWaypoint(tradeRouteID, 0.68, 0.73);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.53, 0.81);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.47, 0.81);
   rmAddTradeRouteWaypoint(tradeRouteID, 0.32, 0.73);
}
else
{
   if (axisChance == 1) 
   {
	if (directionChance == 1)
	{
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.53);
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.475, 0.48);
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.525, 0.35);
	   rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.3);
	}
	else if (directionChance == 2)
	{
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.47);
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.475, 0.52);
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.525, 0.65);
	   rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.7);
	}
	else if (directionChance == 0)
	{
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.39);
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.525, 0.44);
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.475, 0.56);
	   rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.61);
	}
   }
   else if (axisChance == 2) 
   {
	if (directionChance == 1)
	{
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.53, 0.5);
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.48, 0.525);
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.35, 0.475);
	   rmAddTradeRouteWaypoint(tradeRouteID, 0.3, 0.5);
	}
	else if (directionChance == 2)
	{
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.47, 0.5);
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.52, 0.475);
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.65, 0.525);
	   rmAddTradeRouteWaypoint(tradeRouteID, 0.7, 0.5);
	}
	else if (directionChance == 0)
	{
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.39, 0.5);
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.44, 0.475);
  	   rmAddTradeRouteWaypoint(tradeRouteID, 0.56, 0.525);
	   rmAddTradeRouteWaypoint(tradeRouteID, 0.61, 0.5);
	}
   }
}
rmBuildTradeRoute(tradeRouteID, "carolinas\trade_route");	

// Trade sockets
   int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
   rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
   rmSetObjectDefAllowOverlap(socketID, true);
   rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
   rmSetObjectDefMinDistance(socketID, 0.0);
   rmSetObjectDefMaxDistance(socketID, 6.0);

   // add the meeting poles along the trade route.
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
   vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.1);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   if(cNumberNonGaiaPlayers > 4)
   {
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.9);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

// Starting TCs and units 		
   int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
   rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
   rmAddObjectDefToClass(startingUnits, rmClassID("importantItem"));
   rmSetObjectDefMinDistance(startingUnits, 5.0);
   rmSetObjectDefMaxDistance(startingUnits, 10.0);
   rmAddObjectDefConstraint(startingUnits, avoidAll);

   int startingTCID= rmCreateObjectDef("startingTC");
   rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
   rmAddObjectDefToClass(startingTCID, rmClassID("importantItem"));
   rmSetObjectDefMaxDistance(startingTCID, 10.0);
   rmAddObjectDefConstraint(startingTCID, avoidAll);
   rmAddObjectDefConstraint(startingTCID, longAvoidImpassableLand);               
   if ( rmGetNomadStart())
   {
	rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
   }
   else
   {
      rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
   }

   int startingWood= rmCreateObjectDef("startingWood");
   rmAddObjectDefToClass(startingWood, rmClassID("importantItem"));
   rmSetObjectDefMinDistance(startingWood, 6.0);
   rmSetObjectDefMaxDistance(startingWood, 9.0);
   rmAddObjectDefConstraint(startingWood, avoidAll);
   rmAddObjectDefItem(startingWood, "CrateOfWood", 2, 0.0);

   for(i=1; <cNumberPlayers)
   {	
      rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startingWood, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

// Text
   rmSetStatusText("",0.35);

// Player Mines
   int silverType = -1;
   silverType = rmRandInt(1,10);
   int playerGoldID=rmCreateObjectDef("player silver closer");
   rmAddObjectDefItem(playerGoldID, mineType, 1, 0.0);
   rmAddObjectDefToClass(playerGoldID, rmClassID("all mines"));
   rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerGoldID, avoidSocket); 
   rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(playerGoldID, avoidAll);
   rmAddObjectDefConstraint(playerGoldID, avoidWater10);
   rmSetObjectDefMinDistance(playerGoldID, 12.0);
   rmSetObjectDefMaxDistance(playerGoldID, 24.0);
   rmPlaceObjectDefPerPlayer(playerGoldID, false, 1);

   silverType = rmRandInt(1,10);
   int GoldMediumID=rmCreateObjectDef("player silver med");
   rmAddObjectDefItem(GoldMediumID, mineType, 1, 0.0);
   rmAddObjectDefToClass(GoldMediumID, rmClassID("all mines"));
   rmAddObjectDefConstraint(GoldMediumID, avoidTradeRoute);
   rmAddObjectDefConstraint(GoldMediumID, avoidSocket);
   rmAddObjectDefConstraint(GoldMediumID, coinAvoidCoin);
   rmAddObjectDefConstraint(GoldMediumID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(GoldMediumID, avoidTC);
   rmAddObjectDefConstraint(GoldMediumID, avoidAll);
   rmAddObjectDefConstraint(GoldMediumID, avoidWater10);
   rmSetObjectDefMinDistance(GoldMediumID, 45.0);
   rmSetObjectDefMaxDistance(GoldMediumID, 70.0);
   rmPlaceObjectDefPerPlayer(GoldMediumID, false, 1);

// Player Nuggets
   int playerNuggetID=rmCreateObjectDef("player nugget");
   rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
   rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
   rmAddObjectDefToClass(playerNuggetID, rmClassID("importantItem"));
   rmSetObjectDefMinDistance(playerNuggetID, 35.0);
   rmSetObjectDefMaxDistance(playerNuggetID, 55.0);
   rmAddObjectDefConstraint(playerNuggetID, avoidAll);
   rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerNuggetID, avoidSocket);
   rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
   rmAddObjectDefConstraint(playerNuggetID, avoidNativesShort);
   rmAddObjectDefConstraint(playerNuggetID, avoidWater10);

   for(i=1; <cNumberPlayers)
   {
 	rmSetNuggetDifficulty(1, 1);
	rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
 	rmSetNuggetDifficulty(2, 2);
	rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
 	rmSetNuggetDifficulty(3, 3);
	rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceGroupingAtLoc(villageAID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

// Random Nuggets
   int nuggetID= rmCreateObjectDef("nugget"); 
   rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
   rmAddObjectDefToClass(nuggetID, rmClassID("nuggets"));
   rmAddObjectDefToClass(nuggetID, rmClassID("importantItem"));
   rmSetObjectDefMinDistance(nuggetID, 0.0);
   rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.1));
   rmAddObjectDefConstraint(nuggetID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(nuggetID, avoidNugget);
   rmAddObjectDefConstraint(nuggetID, avoidStartingUnits);
   rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
   rmAddObjectDefConstraint(nuggetID, avoidSocket);
   rmAddObjectDefConstraint(nuggetID, avoidAll);
   rmAddObjectDefConstraint(nuggetID, farPlayerConstraint);
   rmAddObjectDefConstraint(nuggetID, avoidWater10);

// Start area trees 
   int StartAreaTreeID=rmCreateObjectDef("starting trees");
   rmAddObjectDefItem(StartAreaTreeID, treeType, 1, 0.0);
   rmSetObjectDefMinDistance(StartAreaTreeID, 8);
   rmSetObjectDefMaxDistance(StartAreaTreeID, 12);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidAll);
   rmPlaceObjectDefPerPlayer(StartAreaTreeID, false, 4);

// Mines - other
   silverType = rmRandInt(1,10);
   int extraGoldID = rmCreateObjectDef("possible gold mines");
   if (rmRandInt(1,2) == 1)
      rmAddObjectDefItem(extraGoldID, "minegold", 1, 0.0);
   else
      rmAddObjectDefItem(extraGoldID, mineType, 1, 0.0);
   rmAddObjectDefToClass(extraGoldID, rmClassID("all mines"));
   rmAddObjectDefToClass(extraGoldID, rmClassID("importantItem"));
   rmAddObjectDefConstraint(extraGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(extraGoldID, avoidSocket);
   rmAddObjectDefConstraint(extraGoldID, longAvoidCoin);
   rmAddObjectDefConstraint(extraGoldID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(extraGoldID, avoidWater15);
   rmAddObjectDefConstraint(extraGoldID, avoidAll);
   rmSetObjectDefMinDistance(extraGoldID, 10.0);
   rmSetObjectDefMaxDistance(extraGoldID, 75.0);

   silverType = rmRandInt(1,10);
   int extraSilverID = rmCreateObjectDef("extra silver mines");
   rmAddObjectDefItem(extraSilverID, mineType, 1, 0.0);
   rmAddObjectDefToClass(extraSilverID, rmClassID("all mines"));
   rmAddObjectDefToClass(extraSilverID, rmClassID("importantItem"));
   rmAddObjectDefConstraint(extraSilverID, avoidTradeRoute);
   rmAddObjectDefConstraint(extraSilverID, avoidSocket);
   rmAddObjectDefConstraint(extraSilverID, longAvoidCoin);
   rmAddObjectDefConstraint(extraSilverID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(extraSilverID, avoidWater10);
   rmAddObjectDefConstraint(extraSilverID, avoidAll);
   rmSetObjectDefMinDistance(extraSilverID, 10.0);
   rmSetObjectDefMaxDistance(extraSilverID, 75.0);

// Berries
   int berryNum = rmRandInt(2,5);
   int StartBerryBushID=rmCreateObjectDef("starting berry bush");
   rmAddObjectDefItem(StartBerryBushID, "BerryBush", rmRandInt(2,4), 4.0);
   rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
   rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
   rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(StartBerryBushID, avoidAll);
   if (placeBerries == 1)
      rmPlaceObjectDefPerPlayer(StartBerryBushID, false, 1);
   if (tropical == 1)
      rmPlaceObjectDefPerPlayer(StartBerryBushID, false, 1);

// Start area huntable
   int deerNum = rmRandInt(4, 6);
   int startPronghornID=rmCreateObjectDef("starting pronghorn");
   rmAddObjectDefItem(startPronghornID, deerType, deerNum, 4.0);
   rmAddObjectDefToClass(startPronghornID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(startPronghornID, 16);
   rmSetObjectDefMaxDistance(startPronghornID, 22);
   rmAddObjectDefConstraint(startPronghornID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(startPronghornID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(startPronghornID, avoidAll);
   rmSetObjectDefCreateHerd(startPronghornID, true);
   rmPlaceObjectDefPerPlayer(startPronghornID, false, 1);

// Extra tree clumps near players - to ensure fair access to wood
   int extraTreesID=rmCreateObjectDef("extra trees");
   rmAddObjectDefItem(extraTreesID, treeType, 7, 7.0);
   rmSetObjectDefMinDistance(extraTreesID, 16);
   rmSetObjectDefMaxDistance(extraTreesID, 20);
   rmAddObjectDefConstraint(extraTreesID, avoidAll);
   rmAddObjectDefConstraint(extraTreesID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(extraTreesID, avoidCoin);
   rmAddObjectDefConstraint(extraTreesID, avoidSocket);
   rmAddObjectDefConstraint(extraTreesID, avoidTradeRoute);
   rmPlaceObjectDefPerPlayer(extraTreesID, false, 1);

// Second huntable
   int deer2Num = rmRandInt(4, 7);
   int farPronghornID=rmCreateObjectDef("far pronghorn");
   rmAddObjectDefItem(farPronghornID, deer2Type, deer2Num, 4.0);
   rmAddObjectDefToClass(farPronghornID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(farPronghornID, 48.0);
   rmSetObjectDefMaxDistance(farPronghornID, 75.0);
   rmAddObjectDefConstraint(farPronghornID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(farPronghornID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(farPronghornID, avoidNativesShort);
   rmAddObjectDefConstraint(farPronghornID, huntableConstraint);
   rmAddObjectDefConstraint(farPronghornID, avoidAll);
   rmAddObjectDefConstraint(farPronghornID, avoidTC);
   rmSetObjectDefCreateHerd(farPronghornID, true);
   rmPlaceObjectDefPerPlayer(farPronghornID, false, 1);

   rmSetObjectDefMinDistance(farPronghornID, 75.0);
   rmSetObjectDefMaxDistance(farPronghornID, 95.0);
   rmPlaceObjectDefPerPlayer(farPronghornID, false, 1);

// Sheep etc
   int sheepID=rmCreateObjectDef("herdable animal");
   rmAddObjectDefItem(sheepID, sheepType, 2, 4.0);
   rmAddObjectDefToClass(sheepID, rmClassID("herdableFood"));
   rmAddObjectDefConstraint(sheepID, avoidSheep);
   rmAddObjectDefConstraint(sheepID, avoidAll);
   rmAddObjectDefConstraint(sheepID, avoidTC);
   rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
   if (sheepChance > 0)
   {
      for(i=1; <cNumberPlayers)
	{
         rmPlaceObjectDefInArea(sheepID, 0, rmAreaID("player"+i), rmRandInt(1,3));
	}
   }

// Big island huntable
   deer2Num = rmRandInt(4, 7);
   int huntableID=rmCreateObjectDef("huntable 1");
   rmAddObjectDefItem(huntableID, centerHerdType, deer2Num, 5.0);
   rmAddObjectDefToClass(huntableID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(huntableID, 42.0);
   rmSetObjectDefMaxDistance(huntableID, 65.0);
   rmAddObjectDefConstraint(huntableID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(huntableID, avoidNativesShort);
   rmAddObjectDefConstraint(huntableID, huntableConstraint);
   rmAddObjectDefConstraint(huntableID, avoidAll);
   rmSetObjectDefCreateHerd(huntableID, true);

// More island animals
   int centralHerdID=rmCreateObjectDef("central herd");  
   rmAddObjectDefItem(centralHerdID, deerType, rmRandInt(2,3), 4.0);
   rmAddObjectDefToClass(centralHerdID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(centralHerdID, 0);
   rmSetObjectDefMaxDistance(centralHerdID, rmXFractionToMeters(0.1));
   rmAddObjectDefConstraint(centralHerdID, avoidTradeRoute);
   rmAddObjectDefConstraint(centralHerdID, avoidImportantItem);
   rmAddObjectDefConstraint(centralHerdID, avoidWater10);
   rmAddObjectDefConstraint(centralHerdID, longPlayerConstraint);
   rmAddObjectDefConstraint(centralHerdID, huntableConstraint);

// Big island objects placement
   rmSetGroupingMinDistance(villageAID, 0.0);
   rmSetGroupingMaxDistance(villageAID, rmXFractionToMeters(0.05));
   if (cNumberNonGaiaPlayers > 4)
   {
	if (rmRandInt(1,2) == 1)
         rmPlaceGroupingInArea(villageDID, 0, rmAreaID("big island"), 1);
	else
         rmPlaceGroupingInArea(villageAID, 0, rmAreaID("big island"), 1);
	if (rmRandInt(1,2) == 1)
         rmPlaceGroupingInArea(villageDID, 0, rmAreaID("big island"), 1);
	else
         rmPlaceGroupingInArea(villageAID, 0, rmAreaID("big island"), 1);
   }
   else 
   {
	if (rmRandInt(1,2) == 1)
         rmPlaceGroupingInArea(villageDID, 0, rmAreaID("big island"), 1);
	else
         rmPlaceGroupingInArea(villageAID, 0, rmAreaID("big island"), 1);
   }
   rmPlaceObjectDefInArea(extraGoldID, 0, rmAreaID("big island"), 1);
   rmPlaceObjectDefInArea(huntableID, 0, rmAreaID("big island"), 2);
   rmSetNuggetDifficulty(3, 3);
   rmPlaceObjectDefInArea(nuggetID, 0, rmAreaID("big island"), 1);
   if (cNumberNonGaiaPlayers > 3)
      rmPlaceObjectDefInArea(nuggetID, 0, rmAreaID("big island"), 1);
   rmSetNuggetDifficulty(4, 4);
   rmPlaceObjectDefInArea(nuggetID, 0, rmAreaID("big island"), 1);
   rmPlaceObjectDefInArea(centralHerdID, 0, rmAreaID("big island"), 1);
   if (cNumberNonGaiaPlayers > 4)
      rmPlaceObjectDefInArea(centralHerdID, 0, rmAreaID("big island"), 1);
   if (cNumberNonGaiaPlayers > 4)
      rmPlaceObjectDefInArea(extraGoldID, 0, rmAreaID("big island"), 1);
   if (sheepChance > 0)
      rmPlaceObjectDefInArea(sheepID, 0, rmAreaID("big island"), cNumberNonGaiaPlayers);

// Text
   rmSetStatusText("",0.40);

// Native Islands 
   int chanceSetup = 0;
   int constraintChance4 = 0;
   if (cNumberNonGaiaPlayers > 5)
      extraNativeIs = 1;
   else if (cNumberNonGaiaPlayers == 5)
   {
	if (rmRandInt(1,2) > 1)
	   extraNativeIs = 1;
   }
   else if (cNumberNonGaiaPlayers == 4)
   {
	if (rmRandInt(1,3) > 1)
	   extraNativeIs = 1;
   }

   int nativeIsland1ID=rmCreateArea("native island 1");
   rmSetAreaSize(nativeIsland1ID, rmAreaTilesToFraction(2700 + cNumberNonGaiaPlayers*200), rmAreaTilesToFraction(3200 + cNumberNonGaiaPlayers*220));
   rmSetAreaMix(nativeIsland1ID, baseType);
   rmAddAreaConstraint(nativeIsland1ID, centerIslandConstraint);
   if (mapDimension == 1)
      rmAddAreaConstraint(nativeIsland1ID, circleEdgeConstraint);
   else
      rmAddAreaConstraint(nativeIsland1ID, circleEdgeConstraint2);
   rmAddAreaConstraint(nativeIsland1ID, playerConstraint);
   rmAddAreaConstraint(nativeIsland1ID, landAvoidTeamLands);
   if  (centeredBigIsland == 1) 
      rmAddAreaConstraint(nativeIsland1ID, nativeIslandConstraintLarge);
   else
      rmAddAreaConstraint(nativeIsland1ID, nativeIslandConstraint);
   rmAddAreaToClass(nativeIsland1ID, classSettlementIsland);
   rmAddAreaToClass(nativeIsland1ID, classNativeIsland);
   rmAddAreaToClass(nativeIsland1ID, classGoldIsland);
   rmSetAreaCoherence(nativeIsland1ID, 0.35);
   rmSetAreaSmoothDistance(nativeIsland1ID, 12);
   rmSetAreaHeightBlend(nativeIsland1ID, 2);
   rmSetAreaBaseHeight(nativeIsland1ID, baseHeight);
   rmBuildArea(nativeIsland1ID);

   int nativeIsland2ID=rmCreateArea("native island 2");
   rmSetAreaSize(nativeIsland2ID, rmAreaTilesToFraction(2700 + cNumberNonGaiaPlayers*150), rmAreaTilesToFraction(3200 + cNumberNonGaiaPlayers*200));
   rmSetAreaMix(nativeIsland2ID, baseType);
   rmAddAreaConstraint(nativeIsland2ID, settlementIslandConstraint);
   rmAddAreaConstraint(nativeIsland2ID, centerIslandConstraint);
   rmAddAreaConstraint(nativeIsland2ID, playerConstraint);
   rmAddAreaConstraint(nativeIsland2ID, landAvoidTeamLands);
   if  (centeredBigIsland == 1) 
      rmAddAreaConstraint(nativeIsland2ID, nativeIslandConstraintLarge);
   else
      rmAddAreaConstraint(nativeIsland2ID, nativeIslandConstraint);
   if (mapDimension == 1)
      rmAddAreaConstraint(nativeIsland2ID, circleEdgeConstraint);
   else
      rmAddAreaConstraint(nativeIsland2ID, circleEdgeConstraint2);
   rmAddAreaToClass(nativeIsland2ID, classSettlementIsland);
   rmAddAreaToClass(nativeIsland2ID, classNativeIsland);
   rmAddAreaToClass(nativeIsland2ID, classGoldIsland);
   rmSetAreaCoherence(nativeIsland2ID, 0.4);
   rmSetAreaSmoothDistance(nativeIsland2ID, 12);
   rmSetAreaHeightBlend(nativeIsland2ID, 2);
   rmSetAreaBaseHeight(nativeIsland2ID, baseHeight);
   rmBuildArea(nativeIsland2ID);

if (extraNativeIs == 1)
{
   int nativeIsland3ID=rmCreateArea("native island 3");
   rmSetAreaSize(nativeIsland3ID, rmAreaTilesToFraction(2600 + cNumberNonGaiaPlayers*150), rmAreaTilesToFraction(3000 + cNumberNonGaiaPlayers*200));
   rmSetAreaMix(nativeIsland3ID, baseType);
   rmAddAreaConstraint(nativeIsland3ID, settlementIslandConstraint);
   rmAddAreaConstraint(nativeIsland3ID, centerIslandConstraint);
   rmAddAreaConstraint(nativeIsland3ID, playerConstraint);
   rmAddAreaConstraint(nativeIsland3ID, landAvoidTeamLands);
   rmAddAreaConstraint(nativeIsland3ID, nativeIslandConstraint); 
   if (mapDimension == 1)
      rmAddAreaConstraint(nativeIsland3ID, circleEdgeConstraint);
   else
      rmAddAreaConstraint(nativeIsland3ID, circleEdgeConstraint2);
   rmAddAreaConstraint(nativeIsland3ID, centerIslandConstraint);
   rmAddAreaToClass(nativeIsland3ID, classSettlementIsland);
   rmAddAreaToClass(nativeIsland3ID, classNativeIsland);
   rmAddAreaToClass(nativeIsland3ID, classGoldIsland);
   rmSetAreaCoherence(nativeIsland3ID, 0.4);
   rmSetAreaSmoothDistance(nativeIsland3ID, 12);
   rmSetAreaHeightBlend(nativeIsland3ID, 2);
   rmSetAreaBaseHeight(nativeIsland3ID, baseHeight);
   rmBuildArea(nativeIsland3ID);
}

// Native Island Objects placement
   rmPlaceGroupingInArea(villageDID, 0, rmAreaID("native island 1"), 1);
   rmPlaceGroupingInArea(villageDID, 0, rmAreaID("native island 2"), 1);
   rmPlaceObjectDefInArea(centralHerdID, 0, rmAreaID("native island 1"), 1);
   rmPlaceObjectDefInArea(centralHerdID, 0, rmAreaID("native island 2"), 1);
   if (extraNativeIs == 1)
   {
	if (rmRandInt(1,2) == 1)
         rmPlaceGroupingInArea(villageDID, 0, rmAreaID("native island 3"), 1);
	else
         rmPlaceGroupingInArea(villageAID, 0, rmAreaID("native island 3"), 1);
      rmPlaceObjectDefInArea(centralHerdID, 0, rmAreaID("native island 3"), 1);
   }

// Text
   rmSetStatusText("",0.45);
     
// More Islands/land - may merge with big island or each other
   int numIslands = cNumberNonGaiaPlayers - 1;
   if (cNumberNonGaiaPlayers > 4)
      numIslands = cNumberNonGaiaPlayers - 2;
   if (cNumberNonGaiaPlayers > 6)
      numIslands = cNumberNonGaiaPlayers - 3;

   for(i=0; <numIslands)
   {
      int settlementIslandID=rmCreateArea("settlement island"+i);
      rmSetAreaSize(settlementIslandID, rmAreaTilesToFraction(2500 + cNumberNonGaiaPlayers*250), rmAreaTilesToFraction(3000 + cNumberNonGaiaPlayers*300));
      rmSetAreaMix(settlementIslandID, baseType); 
      rmSetAreaWarnFailure(settlementIslandID, false);
      constraintChance4 = rmRandFloat(0.0,1.0);
	if (cNumberNonGaiaPlayers < 5)
	{
         if (constraintChance4 > 0.5)
            rmAddAreaConstraint(settlementIslandID, settlementIslandConstraint);
	}
	else 	if (cNumberNonGaiaPlayers < 7)
	{
         if (constraintChance4 > 0.5)
            rmAddAreaConstraint(settlementIslandID, settlementIslandConstraint); 
	}
	else 	
	{
         if (constraintChance4 > 0.3)
            rmAddAreaConstraint(settlementIslandID, settlementIslandConstraint); 
	}

      chanceSetup = rmRandFloat(0.0,1.0);
	if (cNumberNonGaiaPlayers < 5)
	{
         if (chanceSetup < 0.4)
            rmAddAreaConstraint(settlementIslandID, centerIslandConstraint);
	}
	else if (cNumberNonGaiaPlayers < 7)
	{
         if (chanceSetup < 0.6)
            rmAddAreaConstraint(settlementIslandID, centerIslandConstraint);
	}
	else 
	{	
         if (chanceSetup < 0.7)
            rmAddAreaConstraint(settlementIslandID, centerIslandConstraint);
	}

      rmAddAreaConstraint(settlementIslandID, playerConstraint);
      rmAddAreaConstraint(settlementIslandID, landAvoidTeamLands); 
      if (mapDimension == 1)
         rmAddAreaConstraint(settlementIslandID, circleEdgeConstraint);
      else
         rmAddAreaConstraint(settlementIslandID, circleEdgeConstraint2);
	if (rmRandInt(1,3) > 1)
         rmAddAreaConstraint(settlementIslandID, nativeIslandConstraint);
      rmAddAreaToClass(settlementIslandID, classSettlementIsland);
      rmAddAreaToClass(settlementIslandID, classGoldIsland);
      rmSetAreaCoherence(settlementIslandID, 0.35);
      rmSetAreaSmoothDistance(settlementIslandID, 12);
      rmSetAreaHeightBlend(settlementIslandID, 2);
      rmSetAreaBaseHeight(settlementIslandID, baseHeight);
      rmBuildArea(settlementIslandID);
	
   // Settlement Island Objects placement
	if (cNumberNonGaiaPlayers == 4)
	{
         if (rmRandInt(1,5) == 5)
	   {
		if (rmRandInt(1,2) == 1)
               rmPlaceGroupingInArea(villageDID, 0, rmAreaID("settlement island"+i), 1);
		else
               rmPlaceGroupingInArea(villageAID, 0, rmAreaID("settlement island"+i), 1);
	   }
	}
	if (cNumberNonGaiaPlayers > 4)
	{
         if (rmRandInt(1,4) == 1)
	   {
		if (rmRandInt(1,2) == 1)
               rmPlaceGroupingInArea(villageDID, 0, rmAreaID("settlement island"+i), 1);
		else
               rmPlaceGroupingInArea(villageAID, 0, rmAreaID("settlement island"+i), 1);
	   }
	}
      rmSetNuggetDifficulty(3, 3);
      rmPlaceObjectDefInArea(nuggetID, 0, rmAreaID("settlement island"+i), 1);
      if (rmRandInt(1,4) > 1)
         rmPlaceObjectDefInArea(centralHerdID, 0, rmAreaID("settlement island"+i), 1);
   }

// Text
   rmSetStatusText("",0.50);

// Bonus Resource Islands - can merge with other extra islands.
   int bonusCount=cNumberNonGaiaPlayers + 1;  // num players plus some extra
   if (cNumberNonGaiaPlayers > 5)
      bonusCount=cNumberNonGaiaPlayers + 1;
  
   for(i=0; <bonusCount)
   {
      int bonusIslandID=rmCreateArea("bonus island"+i);
      rmSetAreaSize(bonusIslandID, rmAreaTilesToFraction(1700 + cNumberNonGaiaPlayers*150), rmAreaTilesToFraction(2100 + cNumberNonGaiaPlayers*200));
      rmSetAreaMix(bonusIslandID, baseType);
      rmSetAreaWarnFailure(bonusIslandID, false);
      if (mapDimension == 1)
         rmAddAreaConstraint(bonusIslandID, circleEdgeConstraint);
      else
         rmAddAreaConstraint(bonusIslandID, circleEdgeConstraint2);
      if (rmRandInt(1,3) == 1)
        rmAddAreaConstraint(bonusIslandID, settlementIslandConstraint); 
	if (cNumberNonGaiaPlayers > 5)
	{
         if (rmRandInt(1,10) > 4)
            rmAddAreaConstraint(bonusIslandID, centerIslandConstraint);
	}
	else
	{
         if (rmRandInt(1,2) > 1)
            rmAddAreaConstraint(bonusIslandID, centerIslandConstraint);
	}
      if (rmRandInt(1,2) == 1)
         rmAddAreaConstraint(bonusIslandID, nativeIslandConstraint);
      rmAddAreaConstraint(bonusIslandID, landAvoidTeamLands); 
      rmAddAreaConstraint(bonusIslandID, playerConstraint); 
      rmAddAreaToClass(bonusIslandID, classBonusIsland);
      rmAddAreaToClass(bonusIslandID, classGoldIsland);
      rmSetAreaCoherence(bonusIslandID, 0.55);
      rmSetAreaSmoothDistance(bonusIslandID, 20);
      rmSetAreaHeightBlend(bonusIslandID, 2);
      rmSetAreaBaseHeight(bonusIslandID, baseHeight);

      // Island avoidance determination
      randomIslandChance=rmRandFloat(0.0, 1.0);
      if(randomIslandChance < 0.33)
      {
         rmAddAreaToClass(bonusIslandID, islandsX);
         rmAddAreaConstraint(bonusIslandID, islandsXvsY);
         rmAddAreaConstraint(bonusIslandID, islandsXYvsZ);
      }
      else if(randomIslandChance < 0.66)        
      {
         rmAddAreaToClass(bonusIslandID, islandsY);
         rmAddAreaConstraint(bonusIslandID, islandsYvsX);
         rmAddAreaConstraint(bonusIslandID, islandsXYvsZ);
      }
      else
      {
         rmAddAreaToClass(bonusIslandID, islandsZ);
         rmAddAreaConstraint(bonusIslandID, islandsZvsX);
         rmAddAreaConstraint(bonusIslandID, islandsZvsY); 
      }
      rmBuildArea(bonusIslandID);

	// Bonus Island Objects
      rmPlaceObjectDefInArea(centralHerdID, 0, rmAreaID("bonus island"+i), 1);
      if (rmRandInt(1,2) == 1)
	{
         rmSetNuggetDifficulty(2, 3);
         rmPlaceObjectDefInArea(nuggetID, 0, rmAreaID("bonus island"+i), 1);
	}
   }

// Text
   rmSetStatusText("",0.55);

// Caches and bonus objects  
   // Campfire cache
   int campfireID=rmCreateObjectDef("campfire cache");
   if (rmRandInt(1,2) == 1)
   {
      rmAddObjectDefItem(campfireID, "Campfire", 1, 0.0);
      rmAddObjectDefItem(campfireID, "TanningRack", 1, 4.0);
   }
   else
   {
      if (rmRandInt(1,2) == 1)
	   rmAddObjectDefItem(campfireID, "SPCSignalFire", 1, 0.0);
	else
	   rmAddObjectDefItem(campfireID, "SPCSignalFireLit", 1, 0.0);
   }
   if (rmRandInt(1,2) == 1)
      rmAddObjectDefItem(campfireID, "CrateOfWood", rmRandInt(2,3), 4.0);
   else
	rmAddObjectDefItem(campfireID, "CrateOfWoodLarge", 1, 4.0);
   rmAddObjectDefToClass(campfireID, rmClassID("importantItem"));
   rmAddObjectDefConstraint(campfireID, avoidTradeRoute);
   rmAddObjectDefConstraint(campfireID, avoidImportantItemMed);
   rmAddObjectDefConstraint(campfireID, avoidWater10);
   rmAddObjectDefConstraint(campfireID, fartherPlayerConstraint);
   if (rmRandInt(1,5) < 5)
	campfireCache = 1;

   // House cache
   int houseCacheID=rmCreateObjectDef("house cache");
   if (cacheType == 1) // northern
   {
      rmAddObjectDefItem(houseCacheID, "NativeHouseIroquois", 1, 0.0);
      rmAddObjectDefItem(houseCacheID, "Campfire", 1, 4.0);
   }
   else if (cacheType == 2) // plains
   {
	rmAddObjectDefItem(houseCacheID, "Teepee", 1, 6.0);
      rmAddObjectDefItem(houseCacheID, "Campfire", 1, 5.0);
   }
   else if (cacheType == 3) // southern
   {
	rmAddObjectDefItem(houseCacheID, "NativeHouseCarib", 2, 6.0);
	if (rmRandInt(1,2) == 1)
	   rmAddObjectDefItem(houseCacheID, "Skulls", rmRandInt(1,2), 5.0);
   }	
   else if (cacheType == 4) // leanto
   {
      rmAddObjectDefItem(houseCacheID, "LeanTo", 2, 6.0);
	if (rmRandInt(1,2) == 1)
	   rmAddObjectDefItem(houseCacheID, "Skulls", rmRandInt(1,2), 5.0);
   }
   else if (cacheType == 5) // meso
	rmAddObjectDefItem(houseCacheID, "NativeHouseAztec", 1, 4.0);
   if (cacheType < 5)
   {
	if (threeChoice > 1)
	   rmAddObjectDefItem(houseCacheID, "TanningRack", 1, 4.0);
   }
   if (rmRandInt(1,2) == 1) 	    
      rmAddObjectDefItem(houseCacheID, "CrateOfFood", rmRandInt(2,3), 5.0);
   else
	rmAddObjectDefItem(houseCacheID, "CrateOfFoodLarge", 1, 5.0);
   rmAddObjectDefToClass(houseCacheID, rmClassID("importantItem"));
   rmAddObjectDefConstraint(houseCacheID, avoidTradeRoute);
   rmAddObjectDefConstraint(houseCacheID, avoidImportantItemMed);
   rmAddObjectDefConstraint(houseCacheID, avoidWater10);
   rmAddObjectDefConstraint(houseCacheID, fartherPlayerConstraint);
   rmPlaceObjectDefInRandomAreaOfClass(houseCacheID, 0, classCenterIsland, rmRandInt(1,2)); 
   rmPlaceObjectDefInRandomAreaOfClass(houseCacheID, 0, classGoldIsland, 1);
   if (cNumberNonGaiaPlayers > 2)
      rmPlaceObjectDefInRandomAreaOfClass(houseCacheID, 0, classSettlementIsland, 1);
   if (cNumberNonGaiaPlayers > 3)
      rmPlaceObjectDefInRandomAreaOfClass(houseCacheID, 0, classSettlementIsland, 1);
   if (cNumberNonGaiaPlayers > 4)
      rmPlaceObjectDefInRandomAreaOfClass(houseCacheID, 0, classGoldIsland, 1);

   // Mural cache
   int muralCacheID=rmCreateObjectDef("mural cache");
   rmAddObjectDefItem(muralCacheID, "SPCAztecMural", 1, 0.0);
   rmAddObjectDefItem(muralCacheID, "CrateOfCoin", 1, 4.0);
   rmAddObjectDefToClass(muralCacheID, rmClassID("importantItem"));
   rmAddObjectDefConstraint(muralCacheID, avoidTradeRoute);
   rmAddObjectDefConstraint(muralCacheID, avoidImportantItemMed);
   rmAddObjectDefConstraint(muralCacheID, avoidWater10);
   rmAddObjectDefConstraint(muralCacheID, fartherPlayerConstraint);
   if ((patternChance == 13) || (patternChance == 14) || (patternChance == 15) || (patternChance == 28)) // yucatan, sonora, palm desert, caribbean 
      rmPlaceObjectDefInRandomAreaOfClass(muralCacheID, 0, classGoldIsland, 1); 

   // Arctic cache
   int arcticCacheID=rmCreateObjectDef("arctic cache");
   rmAddObjectDefItem(arcticCacheID, "Inuksuk", 1, 0.0);
   rmAddObjectDefItem(arcticCacheID, "CrateOfCoin", 2, 6.0);
   rmAddObjectDefToClass(arcticCacheID, rmClassID("importantItem"));
   rmAddObjectDefConstraint(arcticCacheID, avoidTradeRoute);
   rmAddObjectDefConstraint(arcticCacheID, avoidImportantItemMed);
   rmAddObjectDefConstraint(arcticCacheID, avoidWater10);
   rmAddObjectDefConstraint(arcticCacheID, fartherPlayerConstraint);
   if (arctic == 1)
   {
      rmPlaceObjectDefInRandomAreaOfClass(arcticCacheID, 0, classCenterIsland, 1);
      rmPlaceObjectDefInRandomAreaOfClass(arcticCacheID, 0, classGoldIsland, 1);
   }

   // Inca outpost cache
   int incaCacheID=rmCreateObjectDef("inca cache");
   rmAddObjectDefItem(incaCacheID, "SPCIncaOutpost", 1, 0.0);
   rmAddObjectDefItem(incaCacheID, "CrateOfCoin", 2, 4.0);
   rmAddObjectDefToClass(incaCacheID, rmClassID("importantItem"));
   rmAddObjectDefConstraint(incaCacheID, avoidTradeRoute);
   rmAddObjectDefConstraint(incaCacheID, avoidImportantItemMed);
   rmAddObjectDefConstraint(incaCacheID, avoidWater10);
   rmAddObjectDefConstraint(incaCacheID, fartherPlayerConstraint);
   if ((patternChance == 16) || (patternChance == 22) || (patternChance == 23) || (patternChance == 24) || (patternChance == 29))  // amazon, andes, atacama, central and north araucania 
   {
      rmPlaceObjectDefInRandomAreaOfClass(incaCacheID, 0, classCenterIsland, 1);
      rmPlaceObjectDefInRandomAreaOfClass(incaCacheID, 0, classSettlementIsland, 1);
      if (cNumberNonGaiaPlayers > 4)
      {
         rmPlaceObjectDefInRandomAreaOfClass(incaCacheID, 0, classSettlementIsland, 1);
	}	
   }

   if (berryCache == 1) // Berry patches
   {
         int berryPatchType = rmRandInt(1,4);
         int berryPatch = 0;
         berryPatch = rmCreateGrouping("Berry patch", "BerryPatch "+berryPatchType);
         rmSetGroupingMinDistance(berryPatch, 0.0);
         rmSetGroupingMaxDistance(berryPatch, 12.0);
         rmAddGroupingToClass(berryPatch, rmClassID("importantItem"));
         rmAddGroupingConstraint(berryPatch, avoidAll);
         rmAddGroupingConstraint(berryPatch, avoidWater10);
         rmAddGroupingConstraint(berryPatch, avoidImportantItemMed);
	   rmPlaceGroupingInArea(berryPatch, 0, rmAreaID("big island"), 1);
	   if (rmRandInt(1,3) == 1)
	      rmPlaceGroupingInArea(berryPatch, 0, rmAreaID("big island"), 1);
	   if (rmRandInt(1,2) == 1)
	      rmPlaceGroupingInArea(berryPatch, 0, rmAreaID("native island 2"), 1);
	   if (rmRandInt(1,2) == 1)
	      rmPlaceGroupingInArea(berryPatch, 0, rmAreaID("native island 1"), 1);
         for(i=0; <numIslands)
         {
	      if (rmRandInt(1,2) == 1)  
	         rmPlaceGroupingInArea(berryPatch, 0, rmAreaID("settlement island"+i), 1);
	   }
   }

   if (llamaCache == 1) // Herdable pen
   {        
         int herdablePenType = rmRandInt(1,4);
         int herdablePen = 0;
         herdablePen = rmCreateGrouping("Herdable Pen", "Araucania_HerdablePen "+herdablePenType);
         rmSetGroupingMinDistance(herdablePen, 0.0);
         rmSetGroupingMaxDistance(herdablePen, 20.0);
         rmAddGroupingToClass(herdablePen, rmClassID("importantItem"));
         rmAddGroupingConstraint(herdablePen, avoidImportantItemMed);
         rmAddGroupingConstraint(herdablePen, avoidAll);
         rmAddGroupingConstraint(herdablePen, avoidWater10);
	   rmPlaceGroupingInArea(herdablePen, 0, rmAreaID("big island"), 1);
         if (cNumberNonGaiaPlayers > 4)
         { 
	      if (rmRandInt(1,3) > 1)
	         rmPlaceGroupingInArea(herdablePen, 0, rmAreaID("big island"), 1);
	   }
	   if (rmRandInt(1,2) == 1)
	      rmPlaceGroupingInArea(herdablePen, 0, rmAreaID("native island 2"), 1);
	   if (rmRandInt(1,2) == 1)
	      rmPlaceGroupingInArea(herdablePen, 0, rmAreaID("native island 1"), 1);
         for(i=0; <numIslands)
         {
	      if (rmRandInt(1,2) == 1) 
	         rmPlaceGroupingInArea(herdablePen, 0, rmAreaID("settlement island"+i), 1);
	   }
	   if (berryCache == 1)
	      campfireCache = 0;
   }

   if (campfireCache == 1) 
   {
      rmPlaceObjectDefInRandomAreaOfClass(campfireID, 0, classCenterIsland, 1);
	rmPlaceObjectDefInRandomAreaOfClass(campfireID, 0, classSettlementIsland, 1);
      rmPlaceObjectDefInRandomAreaOfClass(campfireID, 0, classBonusIsland, 1);
	if (rmRandInt(1,2) == 1)
	   rmPlaceObjectDefInRandomAreaOfClass(campfireID, 0, classBonusIsland, 1);
	if (rmRandInt(1,2) == 1)
	   rmPlaceObjectDefInRandomAreaOfClass(campfireID, 0, classSettlementIsland, 1);
      if (cNumberNonGaiaPlayers > 4)
      {
	   rmPlaceObjectDefInRandomAreaOfClass(campfireID, 0, classCenterIsland, 1);
	   rmPlaceObjectDefInRandomAreaOfClass(campfireID, 0, classSettlementIsland, 1);
	}
      if (cNumberNonGaiaPlayers > 6)
      {
	   rmPlaceObjectDefInRandomAreaOfClass(campfireID, 0, classCenterIsland, 1);
	   rmPlaceObjectDefInRandomAreaOfClass(campfireID, 0, classSettlementIsland, 1);
	}
   }

// Additional Island Mines
   rmPlaceObjectDefInRandomAreaOfClass(extraGoldID, 0, classSettlementIsland, 1);
   if (cNumberNonGaiaPlayers > 3)
      rmPlaceObjectDefInRandomAreaOfClass(extraGoldID, 0, classBonusIsland, 1);
   rmPlaceObjectDefInRandomAreaOfClass(extraGoldID, 0, classGoldIsland, 1);
   rmPlaceObjectDefInRandomAreaOfClass(extraGoldID, 0, classGoldIsland, 1);
   rmPlaceObjectDefInRandomAreaOfClass(extraSilverID, 0, classGoldIsland, 1);
   rmPlaceObjectDefInRandomAreaOfClass(extraSilverID, 0, classGoldIsland, 1);
   if (cNumberNonGaiaPlayers > 4)
   {
      rmPlaceObjectDefInRandomAreaOfClass(extraSilverID, 0, classGoldIsland, 1);
      rmPlaceObjectDefInRandomAreaOfClass(extraSilverID, 0, classBonusIsland, 1);
   }
   if (cNumberNonGaiaPlayers > 6)
   {
      rmPlaceObjectDefInRandomAreaOfClass(extraSilverID, 0, classGoldIsland, 1);
      rmPlaceObjectDefInRandomAreaOfClass(extraSilverID, 0, classBonusIsland, 1);
   }

// Forests
// Large player forests.
   int failCount = 0;
   int forestID = 0;
   for(i=1; <cNumberPlayers)
   {
      for(j=0; <4)      
      {
         failCount=0;
         forestID=rmCreateArea("player"+i+"forest"+j, rmAreaID("player"+i));
	   if (lowForest == 1)
            rmSetAreaSize(forestID, rmAreaTilesToFraction(180), rmAreaTilesToFraction(250));
	   else
            rmSetAreaSize(forestID, rmAreaTilesToFraction(300), rmAreaTilesToFraction(340));
         rmSetAreaWarnFailure(forestID, false);
         rmSetAreaForestType(forestID, forestType);
         rmSetAreaForestDensity(forestID, rmRandFloat(0.7, 1.0));
         rmSetAreaForestClumpiness(forestID, rmRandFloat(0.5, 0.9));
         rmSetAreaForestUnderbrush(forestID, rmRandFloat(0.0, 0.5));
         rmSetAreaCoherence(forestID, rmRandFloat(0.5, 0.8));
         rmAddAreaConstraint(forestID, avoidStartingUnits);
         rmAddAreaConstraint(forestID, avoidImportantItem);
         rmAddAreaConstraint(forestID, avoidNativesShort);
         rmAddAreaConstraint(forestID, avoidWater10);
         rmAddAreaConstraint(forestID, avoidAll);
         rmAddAreaConstraint(forestID, forestConstraint);
         rmAddAreaConstraint(forestID, shortAvoidImpassableLand);
         rmAddAreaToClass(forestID, rmClassID("classForest")); 
         rmSetAreaMinBlobs(forestID, 1);
         rmSetAreaMaxBlobs(forestID, 3);
         rmSetAreaMinBlobDistance(forestID, 10.0);
         rmSetAreaMaxBlobDistance(forestID, 15.0);
         rmSetAreaSmoothDistance(forestID, rmRandInt(10,20));
         rmSetAreaBaseHeight(forestID, rmRandFloat(2.0, 4.0));
         rmSetAreaHeightBlend(forestID, 1);
         if(rmBuildArea(forestID)==false)
         {
         // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==3)
               break;
         }
         else
            failCount=0;

	   if (forestCoverUp == 1)
	   {
      	int coverForestPatchID = rmCreateArea("cover forest patch"+i+j, rmAreaID("player"+i+"forest"+j));   
      	rmSetAreaWarnFailure(coverForestPatchID, false);
		if (lowForest == 1)
         	   rmSetAreaSize(coverForestPatchID, rmAreaTilesToFraction(280), rmAreaTilesToFraction(280));
		else
         	   rmSetAreaSize(coverForestPatchID, rmAreaTilesToFraction(360), rmAreaTilesToFraction(360));
      	rmSetAreaCoherence(coverForestPatchID, 0.99);
      	rmSetAreaMix(coverForestPatchID, baseType);
      	rmBuildArea(coverForestPatchID);
	   }
	}
   }

// Team forests
   int numForest = 1;
   if (cNumberTeams > 2)
      numForest = 6;
   else
   {
      for(j=0; <cNumberTeams)   
      {
	   if (j==0)
	      numForest = 6*teamZeroCount;
	   else if (j==1)
	      numForest = 6*teamOneCount;
	}
   }

   for(j=0; <cNumberTeams)  
   { 
      for(k=0; <numForest)
      {
         failCount=0;
         forestID=rmCreateArea(("first team"+j+"forest"+k), rmAreaID("team"+j));
	   if (lowForest == 1)
            rmSetAreaSize(forestID, rmAreaTilesToFraction(120), rmAreaTilesToFraction(180));
	   else
            rmSetAreaSize(forestID, rmAreaTilesToFraction(150), rmAreaTilesToFraction(230));
         rmSetAreaWarnFailure(forestID, false);
         rmSetAreaForestType(forestID, forestType);
         rmSetAreaForestDensity(forestID, rmRandFloat(0.7, 1.0));
         rmSetAreaForestClumpiness(forestID, rmRandFloat(0.5, 0.9));
         rmSetAreaForestUnderbrush(forestID, rmRandFloat(0.0, 0.5));
         rmSetAreaCoherence(forestID, rmRandFloat(0.4, 0.7));
         rmAddAreaConstraint(forestID, avoidStartingUnitsLong);
         rmAddAreaConstraint(forestID, avoidImportantItem);
         rmAddAreaConstraint(forestID, avoidNativesShort);
         rmAddAreaConstraint(forestID, avoidWater10);
         rmAddAreaConstraint(forestID, avoidAll);
         rmAddAreaConstraint(forestID, forestConstraint);
         rmAddAreaConstraint(forestID, shortAvoidImpassableLand);
         rmAddAreaToClass(forestID, rmClassID("classForest")); 
         rmSetAreaMinBlobs(forestID, 1);
         rmSetAreaMaxBlobs(forestID, 4);
         rmSetAreaMinBlobDistance(forestID, 12.0);
         rmSetAreaMaxBlobDistance(forestID, 20.0);
         rmSetAreaSmoothDistance(forestID, rmRandInt(10,20));
         rmSetAreaBaseHeight(forestID, rmRandFloat(3.0, 4.0));
         rmSetAreaHeightBlend(forestID, 1);
         if(rmBuildArea(forestID)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==3)
               break;
         }
         else
            failCount=0;

	   if (forestCoverUp == 1)
	   {
         int coverForestPatch2ID = rmCreateArea(("cover forest patch two"+j+k), rmAreaID("first team"+j+"forest"+k));   
         rmSetAreaWarnFailure(coverForestPatch2ID, false);
	   if (lowForest == 1)
            rmSetAreaSize(coverForestPatch2ID, rmAreaTilesToFraction(200), rmAreaTilesToFraction(200));
	   else
            rmSetAreaSize(coverForestPatch2ID, rmAreaTilesToFraction(245), rmAreaTilesToFraction(250));
         rmSetAreaCoherence(coverForestPatch2ID, 0.99);
         rmSetAreaMix(coverForestPatch2ID, baseType);
         rmBuildArea(coverForestPatch2ID);
   	   }
      }
   }

// Text
   rmSetStatusText("",0.60);

// Big island forests
   int forestNo = rmRandInt(5,6);
   if (cNumberNonGaiaPlayers > 5)
     forestNo = rmRandInt(7,8);
   else if (cNumberNonGaiaPlayers > 3)
     forestNo = rmRandInt(6,7);
   int forestCount=rmRandInt(7, 8);
   if (lowForest == 1)
   {
	if (cNumberNonGaiaPlayers > 5)
         forestCount=rmRandInt(4, 5);
	else
         forestCount=rmRandInt(3, 4);
   }

   for(i=0; < forestNo)
   {
         forestID=rmCreateArea("big island forest"+i, rmAreaID("big island"));
         rmAddAreaToClass(forestID, rmClassID("classForest"));
	   if (lowForest == 1)
            rmSetAreaSize(forestID, rmAreaTilesToFraction(120), rmAreaTilesToFraction(160));
	   else 
            rmSetAreaSize(forestID, rmAreaTilesToFraction(145), rmAreaTilesToFraction(175));
         rmSetAreaWarnFailure(forestID, false);
         rmSetAreaForestType(forestID, forestType);
         rmSetAreaForestDensity(forestID, rmRandFloat(0.7, 1.0));
         rmSetAreaForestClumpiness(forestID, rmRandFloat(0.5, 0.9));
         rmSetAreaForestUnderbrush(forestID, rmRandFloat(0.0, 0.5));
         rmSetAreaCoherence(forestID, rmRandFloat(0.4, 0.7));
         rmAddAreaConstraint(forestID, avoidImportantItem);
         rmAddAreaConstraint(forestID, avoidAll);
         rmAddAreaConstraint(forestID, avoidWater10);
         rmAddAreaConstraint(forestID, forestConstraint2);
         rmAddAreaConstraint(forestID, avoidTradeRoute);
         rmAddAreaConstraint(forestID, avoidSocket);
         rmAddAreaConstraint(forestID, avoidNativesShort);
         rmAddAreaConstraint(forestID, shortAvoidImpassableLand); 
         if(rmRandFloat(0.0, 1.0)<0.4)
            rmSetAreaBaseHeight(forestID, rmRandFloat(3.0, 4.0)); 
         rmBuildArea(forestID);

	   if (forestCoverUp == 1)
	   {
         int coverForestPatch4ID = rmCreateArea(("big island forest cover"+i), rmAreaID("big island forest"+i));   
         rmSetAreaWarnFailure(coverForestPatch4ID, false);
	   if (lowForest == 1)
            rmSetAreaSize(coverForestPatch4ID, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
	   else 
            rmSetAreaSize(coverForestPatch4ID, rmAreaTilesToFraction(190), rmAreaTilesToFraction(190));
         rmSetAreaCoherence(coverForestPatch4ID, 0.99);
         rmSetAreaMix(coverForestPatch4ID, baseType);
         rmBuildArea(coverForestPatch4ID);
   	   }
   }

// Text
   rmSetStatusText("",0.65);

// Settlement island forests
   for(i=0; <numIslands)
   {
      forestCount=rmRandInt(3,4);
      if (lowForest == 1)
         forestCount=2;
      for(j=0; <forestCount)
      {
         forestID=rmCreateArea("settlement island"+i+"forest"+j, rmAreaID("settlement island"+i));
         rmAddAreaToClass(forestID, rmClassID("classForest")); 
         rmSetAreaSize(forestID, rmAreaTilesToFraction(140), rmAreaTilesToFraction(185));
         rmSetAreaWarnFailure(forestID, false);
         rmSetAreaForestType(forestID, forestType);
         rmSetAreaForestDensity(forestID, rmRandFloat(0.7, 1.0));
         rmSetAreaForestClumpiness(forestID, rmRandFloat(0.5, 0.9));
         rmSetAreaForestUnderbrush(forestID, rmRandFloat(0.0, 0.5));
         rmSetAreaCoherence(forestID, rmRandFloat(0.4, 0.7));
         rmAddAreaConstraint(forestID, avoidAll);
         rmAddAreaConstraint(forestID, avoidImportantItem);
         rmAddAreaConstraint(forestID, avoidWater10);
         rmAddAreaConstraint(forestID, forestConstraint2);
         rmAddAreaConstraint(forestID, avoidTradeRoute);
         rmAddAreaConstraint(forestID, avoidSocket);
         rmAddAreaConstraint(forestID, avoidNativesShort);
         rmAddAreaConstraint(forestID, shortAvoidImpassableLand); 
         rmBuildArea(forestID);

	   if (forestCoverUp == 1)
	   {
         int coverForestPatch5ID = rmCreateArea(("5th forest cover"+i+j), rmAreaID("settlement island"+i+"forest"+j));   
         rmSetAreaWarnFailure(coverForestPatch5ID, false);
         rmSetAreaSize(coverForestPatch5ID, rmAreaTilesToFraction(200), rmAreaTilesToFraction(200));
         rmSetAreaCoherence(coverForestPatch5ID, 0.99);
         rmSetAreaMix(coverForestPatch5ID, baseType);
         rmBuildArea(coverForestPatch5ID);
   	   }
      }
   }

// Text
   rmSetStatusText("",0.70);

// Native island forests
   int natForest = rmRandInt(2,4);
   if (lowForest == 1)
      natForest=2;
   for(i=0; < natForest)
   {
         forestID=rmCreateArea("native island 1 forest"+i, rmAreaID("native island 1"));
         rmAddAreaToClass(forestID, rmClassID("classForest"));  
         rmSetAreaSize(forestID, rmAreaTilesToFraction(150), rmAreaTilesToFraction(180));
         rmSetAreaWarnFailure(forestID, false);
         rmSetAreaForestType(forestID, forestType);
         rmSetAreaForestDensity(forestID, rmRandFloat(0.7, 1.0));
         rmSetAreaForestClumpiness(forestID, rmRandFloat(0.5, 0.9));
         rmSetAreaForestUnderbrush(forestID, rmRandFloat(0.0, 0.5));
         rmSetAreaCoherence(forestID, rmRandFloat(0.4, 0.7));
         rmAddAreaConstraint(forestID, avoidImportantItem);
         rmAddAreaConstraint(forestID, avoidNativesShort);
         rmAddAreaConstraint(forestID, avoidAll);
         rmAddAreaConstraint(forestID, avoidWater10);
         rmAddAreaConstraint(forestID, forestConstraint2);
         rmAddAreaConstraint(forestID, shortAvoidImpassableLand);
         rmBuildArea(forestID);

	   if (forestCoverUp == 1)
	   {
         int coverForestPatch6ID = rmCreateArea(("6th forest cover"+i), rmAreaID("native island 1 forest"+i));   
         rmSetAreaWarnFailure(coverForestPatch6ID, false);
         rmSetAreaSize(coverForestPatch6ID, rmAreaTilesToFraction(200), rmAreaTilesToFraction(200));
         rmSetAreaCoherence(coverForestPatch6ID, 0.99);
         rmSetAreaMix(coverForestPatch6ID, baseType);
         rmBuildArea(coverForestPatch6ID);
   	   }
   }

   natForest = rmRandInt(2,4);
   if (lowForest == 1)
      natForest=2;

   for(i=0; < natForest)
   {
         forestID=rmCreateArea("native island 2 forest"+i, rmAreaID("native island 2")); 
         rmAddAreaToClass(forestID, rmClassID("classForest")); 
         rmSetAreaSize(forestID, rmAreaTilesToFraction(150), rmAreaTilesToFraction(180));
         rmSetAreaWarnFailure(forestID, false);
         rmSetAreaForestType(forestID, forestType);
         rmSetAreaForestDensity(forestID, rmRandFloat(0.7, 1.0));
         rmSetAreaForestClumpiness(forestID, rmRandFloat(0.5, 0.9));
         rmSetAreaForestUnderbrush(forestID, rmRandFloat(0.0, 0.5));
         rmSetAreaCoherence(forestID, rmRandFloat(0.4, 0.7));
         rmAddAreaConstraint(forestID, avoidImportantItem);
         rmAddAreaConstraint(forestID, avoidNativesShort);
         rmAddAreaConstraint(forestID, avoidAll);
         rmAddAreaConstraint(forestID, avoidWater10);
         rmAddAreaConstraint(forestID, forestConstraint2);
         rmAddAreaConstraint(forestID, shortAvoidImpassableLand);
         rmBuildArea(forestID);

	   if (forestCoverUp == 1)
	   {
         int coverForestPatch7ID = rmCreateArea(("7th forest cover"+i), rmAreaID("native island 2 forest"+i));   
         rmSetAreaWarnFailure(coverForestPatch7ID, false);
         rmSetAreaSize(coverForestPatch7ID, rmAreaTilesToFraction(200), rmAreaTilesToFraction(200));
         rmSetAreaCoherence(coverForestPatch7ID, 0.99);
         rmSetAreaMix(coverForestPatch7ID, baseType);
         rmBuildArea(coverForestPatch7ID);
	   }
   }

   natForest = rmRandInt(2,4);
   if (lowForest == 1)
      natForest=2;

   if (extraNativeIs == 1)
   {
      for(i=1; < natForest)
      {
         forestID=rmCreateArea("native island 3 forest"+i, rmAreaID("native island 3")); 
         rmAddAreaToClass(forestID, rmClassID("classForest")); 
         rmSetAreaSize(forestID, rmAreaTilesToFraction(120), rmAreaTilesToFraction(150));
         rmSetAreaWarnFailure(forestID, false);
         rmSetAreaForestType(forestID, forestType);
         rmSetAreaForestDensity(forestID, rmRandFloat(0.7, 1.0));
         rmSetAreaForestClumpiness(forestID, rmRandFloat(0.5, 0.9));
         rmSetAreaForestUnderbrush(forestID, rmRandFloat(0.0, 0.5));
         rmSetAreaCoherence(forestID, rmRandFloat(0.4, 0.7));
         rmAddAreaConstraint(forestID, avoidImportantItem);
         rmAddAreaConstraint(forestID, avoidNativesShort);
         rmAddAreaConstraint(forestID, avoidAll);
         rmAddAreaConstraint(forestID, avoidWater10);
         rmAddAreaConstraint(forestID, forestConstraint2);
         rmAddAreaConstraint(forestID, shortAvoidImpassableLand);
         rmBuildArea(forestID);

	   if (forestCoverUp == 1)
	   {
         int coverForestPatch8ID = rmCreateArea(("8th forest cover"+i), rmAreaID("native island 3 forest"+i));   
         rmSetAreaWarnFailure(coverForestPatch8ID, false);
         rmSetAreaSize(coverForestPatch8ID, rmAreaTilesToFraction(170), rmAreaTilesToFraction(170));
         rmSetAreaCoherence(coverForestPatch8ID, 0.99);
         rmSetAreaMix(coverForestPatch8ID, baseType);
         rmBuildArea(coverForestPatch8ID);
	   }
      }
   }

// Text
   rmSetStatusText("",0.75);

// Bonus island forests.
   for(i=0; <bonusCount)
   {
      forestCount=rmRandInt(2, 3);
      if (lowForest == 1)
         forestCount=rmRandInt(1,2);
      for(j=0; <forestCount)
      {
         int bonusForestID=rmCreateArea("bonus"+i+"forest"+j, rmAreaID("bonus island"+i));
         rmAddAreaToClass(bonusForestID, rmClassID("classForest"));  
	   rmSetAreaSize(bonusForestID, rmAreaTilesToFraction(110), rmAreaTilesToFraction(140));
         rmSetAreaWarnFailure(bonusForestID, false);
         rmSetAreaForestType(bonusForestID, forestType);
         rmSetAreaForestDensity(bonusForestID, rmRandFloat(0.7, 1.0));
         rmSetAreaForestClumpiness(bonusForestID, rmRandFloat(0.5, 0.9));
         rmSetAreaForestUnderbrush(bonusForestID, rmRandFloat(0.0, 0.5));
         rmSetAreaCoherence(bonusForestID, rmRandFloat(0.4, 0.7));
         rmAddAreaConstraint(bonusForestID, avoidImportantItem);
         rmAddAreaConstraint(bonusForestID, avoidNativesShort);
         rmAddAreaConstraint(bonusForestID, avoidAll);
         rmAddAreaConstraint(bonusForestID, forestConstraint2);
         rmAddAreaConstraint(bonusForestID, avoidTradeRoute);
         rmAddAreaConstraint(bonusForestID, avoidSocket);
         rmAddAreaConstraint(bonusForestID, shortAvoidImpassableLand);
         rmBuildArea(bonusForestID);

	   if (forestCoverUp == 1)
	   {
         int coverForestPatch9ID = rmCreateArea(("9th forest cover"+i+j), rmAreaID("bonus"+i+"forest"+j));   
         rmSetAreaWarnFailure(coverForestPatch9ID, false);
         rmSetAreaSize(coverForestPatch9ID, rmAreaTilesToFraction(160), rmAreaTilesToFraction(160));
         rmSetAreaCoherence(coverForestPatch9ID, 0.99);
         rmSetAreaMix(coverForestPatch9ID, baseType);
         rmBuildArea(coverForestPatch9ID);
	   }
      }
   }

// Text
   rmSetStatusText("",0.80);

// Trees
   int randomTreeID=rmCreateObjectDef("random tree");
   rmAddObjectDefItem(randomTreeID, treeType, 1, 0.0);
   rmSetObjectDefMinDistance(randomTreeID, 8);
   rmSetObjectDefMaxDistance(randomTreeID, 15);
   rmAddObjectDefConstraint(randomTreeID, avoidStartingUnits);
   rmAddObjectDefConstraint(randomTreeID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(randomTreeID, avoidTradeRoute);
   rmAddObjectDefConstraint(randomTreeID, avoidAll);
   rmAddObjectDefConstraint(randomTreeID, avoidWater10);
   if (cNumberTeams > 2)
   {
      for(i=0; <cNumberTeams)
         rmPlaceObjectDefInArea(randomTreeID, 0, rmAreaID("team"+i), 15);
   }
   else
   {
      for(i=1; <cNumberPlayers)
         rmPlaceObjectDefInArea(randomTreeID, 0, rmAreaID("Player"+i), 6);
   }
   rmPlaceObjectDefInArea(randomTreeID, 0, rmAreaID("big island"), rmRandInt(6,10));
   for(i=0; <numIslands)
      rmPlaceObjectDefInArea(randomTreeID, 0, rmAreaID("settlement island"+i), rmRandInt(2,4));
   for(i=0; <bonusCount)
      rmPlaceObjectDefInArea(randomTreeID, 0, rmAreaID("bonus island"+i), rmRandInt(2,4));
   for(i=0; <extraCount)
      rmPlaceObjectDefInArea(randomTreeID, 0, rmAreaID("extraland"+i), 2);
   rmPlaceObjectDefInArea(randomTreeID, 0, rmAreaID("native island 1"), 3);
   rmPlaceObjectDefInArea(randomTreeID, 0, rmAreaID("native island 2"), 3);
   if (extraNativeIs == 1)
      rmPlaceObjectDefInArea(randomTreeID, 0, rmAreaID("native island 3"), 3);

// Spanish shpwreck
   int avoidWreck=rmCreateTypeDistanceConstraint("avoids wreck", "SPCSpanishShipRuins", 100.0);
   int shipRuinsID=rmCreateObjectDef("island ship ruins");
   rmAddObjectDefItem(shipRuinsID, "SPCSpanishShipRuins", 1, 0);
   rmSetObjectDefMinDistance(shipRuinsID, 0.0);
   rmSetObjectDefMaxDistance(shipRuinsID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(shipRuinsID, fartherPlayerConstraint);
   rmAddObjectDefConstraint(shipRuinsID, nearWater);
   rmAddObjectDefConstraint(shipRuinsID, avoidWreck);
   rmAddObjectDefConstraint(shipRuinsID, avoidImportantItemMed);
   if (sixChoice == 1)
      rmPlaceObjectDefInArea(shipRuinsID, 0, rmAreaID("native island 1"));
   else if (sixChoice == 2)
      rmPlaceObjectDefInArea(shipRuinsID, 0, rmAreaID("native island 2"));
   else if (sixChoice == 3)
      rmPlaceObjectDefInRandomAreaOfClass(shipRuinsID, 0, classSettlementIsland, 1);
   else 
	rmPlaceObjectDefInArea(shipRuinsID, 0, rmAreaID("big island"));
   if (cNumberNonGaiaPlayers > 3)
   {
      if (sixChoice == 4)
         rmPlaceObjectDefInArea(shipRuinsID, 0, rmAreaID("native island 1"));
      else if (sixChoice == 5)
         rmPlaceObjectDefInArea(shipRuinsID, 0, rmAreaID("native island 2"));
      else if (sixChoice == 6)
	   rmPlaceObjectDefInRandomAreaOfClass(shipRuinsID, 0, classSettlementIsland, 1);
      else 
	   rmPlaceObjectDefInArea(shipRuinsID, 0, rmAreaID("big island"));
   }

// Text
   rmSetStatusText("",0.85);

// Deco
   if (eaglerock == 1)
	propType = "PropEaglesRocks";
   else if (eagles == 1)
	propType = "EaglesNest";
   else if (vultures == 1)
	propType = "PropVulturePerching";
   else if (kingfishers == 1)
	propType = "PropKingfisher";
   else if (texasProp == 1)
	propType = "BigPropTexas";

   int avoidProp=rmCreateTypeDistanceConstraint("avoids prop", propType, 90.0);
   int specialPropID=rmCreateObjectDef("special prop");
   rmAddObjectDefItem(specialPropID, propType, 1, 0.0);
   rmSetObjectDefMinDistance(specialPropID, 0.0);
   rmSetObjectDefMaxDistance(specialPropID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(specialPropID, avoidAll);
   rmAddObjectDefConstraint(specialPropID, avoidSocket);
   rmAddObjectDefConstraint(specialPropID, avoidTradeRoute);
   rmAddObjectDefConstraint(specialPropID, avoidProp);
   rmAddObjectDefConstraint(specialPropID, shortAvoidImpassableLand);
   if ((vultures == 1) || (eaglerock == 1)) 
	rmAddObjectDefConstraint(specialPropID, avoidWater20);
   else
	rmAddObjectDefConstraint(specialPropID, avoidWater10);
   rmAddObjectDefConstraint(specialPropID, avoidImportantItem);
   rmAddObjectDefConstraint(specialPropID, longPlayerConstraint);
   rmPlaceObjectDefAtLoc(specialPropID, 0, 0.5, 0.5, (cNumberNonGaiaPlayers + 1));

   if (underbrush == 1)
   {
	int avoidBrush=rmCreateTypeDistanceConstraint("avoids brush", brushType, 30.0);
	int decoUnderbrushID=rmCreateObjectDef("underbrush");
	rmAddObjectDefItem(decoUnderbrushID, brushType, rmRandInt(2,4), 4.0);
	rmSetObjectDefMinDistance(decoUnderbrushID, 0.0);
	rmSetObjectDefMaxDistance(decoUnderbrushID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(decoUnderbrushID, avoidAll);
      rmAddObjectDefConstraint(decoUnderbrushID, avoidWater10);
	rmAddObjectDefConstraint(decoUnderbrushID, avoidImpassableLand);
	rmAddObjectDefConstraint(decoUnderbrushID, avoidStartingUnits);
	rmAddObjectDefConstraint(decoUnderbrushID, avoidBrush);
	rmAddObjectDefConstraint(decoUnderbrushID, avoidTradeRoute);
      rmPlaceObjectDefAtLoc(decoUnderbrushID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);
   }

// Water Flag
   int waterFlagID=-1;
   for(i=1; <cNumberPlayers)
   {
      rmClearClosestPointConstraints();
      waterFlagID=rmCreateObjectDef("HC water flag "+i);
      rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 3.0);
      rmAddObjectDefItem(waterFlagID, fishType, 1, 2.0);
      rmAddClosestPointConstraint(flagEdgeConstraint);
      rmAddClosestPointConstraint(flagVsFlag);
      rmAddClosestPointConstraint(flagLand);
      vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
      vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));
      rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
      rmClearClosestPointConstraints();
   }

// Text
   rmSetStatusText("",0.90);

// Fish
   int fishVsFishID=rmCreateClassDistanceConstraint("fish v fish", rmClassID("classFish"), rmRandInt(23,27));
   int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 5.0);
   int fishID=rmCreateObjectDef("fish");
   rmAddObjectDefItem(fishID, fishType, 2, 5.0);
   rmAddObjectDefToClass(fishID, rmClassID("classFish"));
   rmSetObjectDefMinDistance(fishID, 0.0);
   rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fishID, fishVsFishID);
   rmAddObjectDefConstraint(fishID, fishLand);
   if (cNumberNonGaiaPlayers < 4)
      rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*12);
   else if (cNumberNonGaiaPlayers < 6)
      rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*10);
   else
      rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*9);

   int fishVsFish2ID=rmCreateClassDistanceConstraint("another fish v fish", rmClassID("classFish"), rmRandInt(18,22));
   int fish2ID=rmCreateObjectDef("second type fish");
   int fishLand2 = rmCreateTerrainDistanceConstraint("second fish land", "land", true, 3.0);
   rmAddObjectDefItem(fish2ID, fish2Type, 1, 5.0);
   rmAddObjectDefToClass(fish2ID, rmClassID("classFish"));
   rmSetObjectDefMinDistance(fish2ID, 0.0);
   rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fish2ID, fishVsFish2ID);
   rmAddObjectDefConstraint(fish2ID, fishLand2);
   if (cNumberNonGaiaPlayers < 4)
      rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*16);
   else if (cNumberNonGaiaPlayers < 6)
      rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*14);
   else if (cNumberNonGaiaPlayers == 6)
      rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*13);
   else
      rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*12);

// Text
   rmSetStatusText("",0.95);

// Whales
   int whaleID=rmCreateObjectDef("whale");
   int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 19.0);
   int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", whaleType, 65.0);
   rmAddObjectDefItem(whaleID, whaleType, 1, 5.0);
   rmSetObjectDefMinDistance(whaleID, 0.0);
   rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(1.0));
   rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
   rmAddObjectDefConstraint(whaleID, whaleLand);
   if (cNumberNonGaiaPlayers == 2)
      rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 7*cNumberNonGaiaPlayers);
   else if (cNumberNonGaiaPlayers < 5)
      rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);
   else
      rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);

// Text
   rmSetStatusText("",0.99);
}  
