// Transcontinental TWC
// a random map for AOE3: TWC
// by RF_Gandalf

include "mercenaries.xs";

void main(void)
{  
   // Text
   rmSetStatusText("",0.01);

// Set up for variables
   string baseType = "";
   string patchMixType = "";
   string pondType = "";
   string cliffType = "";
   string forestType = "";
   string riverType = "";
   string treeType = "";
   string deerType = "";
   string deer2Type = "";
   string sheepType = "";
   string centerHerdType = "";
   string fishType = "";
   string lakeFishType = "";
   string whaleType = "";
   string oceanType = "";
   string native1Name = "";
   string native2Name = "";

// Pick pattern for trees, terrain, features, etc.
   int patternChance = rmRandInt(1,28);   
   int variantChance = rmRandInt(1,2);
   int lightingChance = rmRandInt(1,2);
   int trPattern = rmRandInt(1,10);
   if (rmRandInt(1,5) < 3)
	trPattern = rmRandInt(5,10); // to make up for restrictions in some features
   int socketPattern = rmRandInt(1,2);   
   int nativeSetup = rmRandInt(0,17);
   if (cNumberNonGaiaPlayers > 4)
   {
	if (nativeSetup == 9)
         nativeSetup = rmRandInt(11,17);
	if (nativeSetup == 10)
         nativeSetup = rmRandInt(0,8);
   }	 
   int nativePattern = -1;
   int nativeNumber = rmRandInt(2,6);
   int endPosition = rmRandInt(1,3);
   int sidePosition = rmRandInt(1,3);
   int sheepChance = rmRandInt(1,2);
   int featureChance = rmRandInt(1,10);
   int cliffChance = rmRandInt(1,10);
   int makeCliffs = -1; 
   int cliffVariety = rmRandInt(0,5);
   int bareCliffs = -1;
   int noCliffForest = -1;
   int makeLake = -1;
   int lakePattern = rmRandInt(1,2);
   int makeLakefish = -1; 
   int makePonds = -1;
   int morePonds = -1;
   int makeIce = -1;
   int makeRiver = -1;
   int centerMt = -1;
   int forestMt = -1;
   int mtForest = -1;
   int makeCentralHighlands = -1;
   int makeCentralCanyon = -1;
   int makeValley = -1;
   int vultures = -1;
   int eagles = -1;
   int eaglerock = -1;
   int kingfishers = -1;
   int underbrush = -1;
   int texasProp = -1;
   int geyserProp = -1;
   int plainsMap = -1;
   int hillTrees = -1;
   int placeBerries = 1;
   int baseHt = -1;
   int tropicalMap = -1;
   int reducedForest = -1;
   int bonusForest = -1;
   int mtPattern = rmRandInt(1,4);
   int numMt = -1;
   int clearCenter = -1;
   int clearCenterChance = -1;
   int makeCentralForestPatch = -1;
   int forestDist = rmRandInt(12,18);
   int circChance = rmRandInt(1,5);
   int placeCircular = -1;
   int axisChance = rmRandInt(1,2);
   int playerSide = rmRandInt(1,2);   
   int makeBarrierRange = -1;
   int barrierPattern = -1;
   int makeMtRange = -1;
   int mtRangePattern = -1;
   int gapPattern = rmRandInt(1,3);
   int coastPatch = -1;
   int twoChoice = rmRandInt(1,2);
   int threeChoice = rmRandInt(1,3);
   int fourChoice = rmRandInt(1,4);
   int fiveChoice = rmRandInt(1,5);
   int sixChoice = rmRandInt(1,6);
   int placeGold = rmRandInt(1,5);
   int makePatchMix = -1;
   int forestCoverUp = -1;

// Picks the map size
   int playerTiles = 20000;
   if (cNumberNonGaiaPlayers == 8)
	playerTiles = 14000;
   else if (cNumberNonGaiaPlayers == 7)
	playerTiles = 14500;
   else if (cNumberNonGaiaPlayers == 6)
	playerTiles = 15750;
   else if (cNumberNonGaiaPlayers == 5)
	playerTiles = 16500;
   else if (cNumberNonGaiaPlayers == 4)
	playerTiles = 17500;
   else if (cNumberNonGaiaPlayers == 3)
	playerTiles = 18500;

   int size=1.95*sqrt(cNumberNonGaiaPlayers*playerTiles);
   int longSide=2.35*size; 
   if (axisChance == 2) 
      rmSetMapSize(size, longSide);
   else if (axisChance == 1)    
      rmSetMapSize(longSide, size);
   
// Elevation
   rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
   rmSetMapElevationHeightBlend(1.0);
   rmSetSeaLevel(0.0);
	
   // Text
   rmSetStatusText("",0.05);

// Pick terrain patterns and features 
/*  can use these in single player to select favorite features - 
    but restore map from the zip file for use in multiplayer 
    to ensure files are exactly the same  */ 
//  trPattern = 4;
//  variantChance = 2;
//  cliffChance = 8;
//  lightingChance = 1;
//  mtPattern = 1;
//  patternChance = 27;
//  twoChoice = 2;
//  featureChance = 9;

  if (patternChance == 1) // NE
  {  
      rmSetSeaType("new england coast");
      rmSetMapType("newEngland");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("paris");
	else
	   rmSetLightingSet("new england");
      baseHt = rmRandFloat(1,3);
      baseType = "newengland_grass";
      oceanType = "new england coast";
	forestType = "new england forest";
	riverType = "Amazon River";
      cliffType = "New England Inland Grass";
	pondType = "new england lake";
	treeType = "TreeNewEngland";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "moose";         
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "turkey";        
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      fishType = "FishCod";
      lakeFishType = "FishSalmon";
      whaleType = "minkeWhale";
      hillTrees = rmRandInt(0,1);
	makePonds = rmRandInt(1,10);
      if (featureChance == 1)
	{
	   makeLake = 1;
	   lakePattern = rmRandInt(1,3);
	}
	else if (featureChance == 2)
	{
	   makePonds = 1;	   	
	   morePonds = 1;
	}
	else if (featureChance == 3)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
	else if (featureChance < 6)
	{
	   makeCentralHighlands = 1;
	   makeCliffs = 2;
         mtForest = 1;
	}
	else if (featureChance == 6)
	{
	   makeCentralCanyon = 1;
	   makeCliffs = 2;
         mtForest = 1;
	}
      else if (featureChance == 7)
	{
	   forestMt = 1;
	   cliffChance = 0;
	}
      else if (featureChance == 8)
	{
	   makeBarrierRange = 1;
	}
      else if (featureChance > 8)
	{
	   if (axisChance == 1)
	   {
	      makeRiver = 1;
	      makePonds = 0;
	      clearCenterChance = 0;
	   }
	   else
	   {
	      makeBarrierRange = 1;
	   }
	}
	if (cliffChance > 2)
         makeCliffs = 1;
	if ((makeRiver == 1) || (forestMt == 1) || (makeLake == 1))  
	   bonusForest = 0;
	else 
	   bonusForest = rmRandInt(1,3);
      nativePattern = 40;
      if (rmRandInt(1,2) == 1)
	   kingfishers = 1;
	else
	   eagles = 1;
   }
   else if (patternChance == 2) // carolina
   {
      rmSetSeaType("atlantic coast");
      rmSetMapType("carolina");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("312b_washington");
	else
	   rmSetLightingSet("carolina");
      baseHt = 1;
      baseType = "carolina_grass";
      oceanType = "atlantic coast";
	forestType = "carolina pine forest";
	riverType = "Amazon River";
      cliffType = "Carolina Inland";
	treeType = "TreeCarolinaGrass";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "turkey";        
	}   
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
      fishType = "FishSardine";
      lakeFishType = "FishBass";
      whaleType = "humpbackWhale";
      hillTrees = rmRandInt(0,1);
	if (featureChance == 1)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
	else if (featureChance < 4)
	{
	   makeCentralHighlands = 1;
	   cliffChance = 0;
         mtForest = 1;
	}
      else if (featureChance < 6)
	{
	   forestMt = 1;
	   cliffChance = 0;
	}
      else if (featureChance < 9)
	{
	   makeBarrierRange = 1;
	}
      else if (featureChance > 8)
	{
	   if (axisChance == 1)
	   {
	      makeRiver = 1;
	      makePonds = 0;
	      clearCenterChance = 0;
	   }
	   else
	   {
	      forestMt = 1;
	      cliffChance = 0;
	   }
	}
	if (cliffChance > 7)
         makeCliffs = 1;
	if ((makeRiver == 1) || (forestMt == 1) || (makeLake == 1))  
	   bonusForest = 0;
	else 
	   bonusForest = rmRandInt(1,3);
	if (twoChoice == 1)
	   nativePattern = 40;
	else
	   nativePattern = 3;
      if (rmRandInt(1,2) == 1)
	   kingfishers = 1;
	else
	   eagles = 1;
   }
   else if (patternChance == 3) // bayou
   {
      rmSetSeaType("yucatan Coast");
      rmSetMapType("bayou");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("paris");
	else
         rmSetLightingSet("bayou");
      baseHt = 1;
      baseType = "bayou_grass";
      oceanType = "yucatan Coast";
      cliffType = "Bayou";
	forestType = "bayou swamp forest";
      pondType = "bayou";
	treeType = "TreeBayou";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "turkey";        
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      fishType = "FishSardine";
      lakeFishType = "FishBass";
      whaleType = "humpbackWhale";
      makeCliffs = 0;
	if (fourChoice == 1)
	   makeCliffs = 1;
	else
	   morePonds = 1;

	if (featureChance < 3)
	   makeValley = 1;	   	
	else if (featureChance == 3)
	   makeBarrierRange = 1;
	else if (featureChance < 6)
	   forestMt = 1;
	else 
	{
         makeLake = 1;
         lakePattern = rmRandInt(2,4);
      }
	if (twoChoice == 1)
	   nativePattern = 3;
	else
	   nativePattern = 21;
      if (rmRandInt(1,2) == 1)
	   kingfishers = 1;
	else
	   eagles = 1;
   }
   else if (patternChance == 4) // great lakes
   {
      if (variantChance == 1)
	{
         rmSetSeaType("great lakes");
         oceanType = "great lakes";
	}
      else
	{
	   rmSetSeaType("new england coast");
         oceanType = "new england coast";
	}
      rmSetMapType("greatlakes");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("constantinople");
	else
         rmSetLightingSet("Great Lakes");
      baseHt = rmRandFloat(1,2);
      baseType = "greatlakes_grass";
	forestType = "great lakes forest";
	riverType = "Amazon River";
      cliffType = "New England Inland Grass";
      pondType = "great lakes";
	treeType = "TreeGreatLakes";
	variantChance = rmRandInt(1,2);
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "bison";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "moose";        
	}   
      sheepType = "sheep";
      fishType = "FishSalmon";
      lakeFishType = "FishSalmon";
      whaleType = "minkeWhale";
      hillTrees = rmRandInt(0,1);
      if (featureChance == 3)
	   makeBarrierRange = 1;
      else if (featureChance < 3)
	{
	   makeLake = 1;
	   lakePattern = rmRandInt(1,4);
	}
	else if (featureChance == 4)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
	else if (featureChance == 5)
	{
	   makeCentralHighlands = 1;
	   cliffChance = 0;
         mtForest = 1;
	}
	else if (featureChance == 6)
	{
	   makeCentralCanyon = 1;
	   cliffChance = 0;
         mtForest = 1;
	}
      else if (featureChance < 9)
	{
	   forestMt = 1;
	   cliffChance = 0;
	}
      else if (featureChance > 8)
	{
	   if (axisChance == 1)
	   {
	      makeRiver = 1;
	      clearCenterChance = 0;
	   }
	   else
	   {
	      makeValley = 1;	   	
	      hillTrees = 0;
	   }
	}
	if (cliffChance >6)
         makeCliffs = 1;
	if ((makeRiver == 1) || (forestMt == 1) || (makeLake == 1))  
	   bonusForest = 0;
	else 
	   bonusForest = rmRandInt(1,3);
	if (fiveChoice == 1)
	   nativePattern = 4;
	else if (fiveChoice == 2)
	   nativePattern = 5;
	else if (fiveChoice == 3)
	   nativePattern = 40;
	else if (fiveChoice == 4)
	   nativePattern = 22;
	else
	   nativePattern = 40;
      if (rmRandInt(1,2) == 1)
	   kingfishers = 1;
	else
	   eagles = 1;
   }
   else if (patternChance == 5) // great lakes winter
   {
      rmSetSeaType("great lakes ice");
      rmSetMapType("greatlakes");
      rmSetMapType("snow");
	if (lightingChance == 1)
	   rmSetLightingSet("308b_caribbeanlight");
	else
         rmSetLightingSet("Great Lakes Winter");
      baseHt = 1;
      baseType = "greatlakes_snow";
      oceanType = "great lakes ice";
	forestType = "great lakes forest snow";
	riverType = "Yukon River";
      pondType = "great lakes ice";
	treeType = "TreeGreatLakesSnow";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "elk";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "bison";
         centerHerdType = "moose";       
	}      
      sheepType = "sheep";
      fishType = "FishSalmon";
      lakeFishType = "FishSalmon";
      whaleType = "minkeWhale";
      placeBerries = 0;
      hillTrees = rmRandInt(0,1);
	if (featureChance == 1)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
      else if (featureChance < 4)
	{
	   makeLake = 1;
	   lakePattern = rmRandInt(1,4); 
	}
	else if (featureChance < 7)
	   makeIce = 1;
	else if (featureChance < 9)
	   forestMt = 1;
      else if (featureChance > 8)
	{
	   if (axisChance == 1)
	      makeRiver = 1;
	   else
	      makeMtRange = 1;
	}
	if ((makeRiver == 1) || (forestMt == 1) || (makeIce == 1) || (makeMtRange == 1) || (makeLake == 1))  
	   bonusForest = 0;
	else 
	   bonusForest = rmRandInt(1,2);
	if (fiveChoice == 1)
	   nativePattern = 4;
	else if (fiveChoice == 2)
	   nativePattern = 5;
	else if (fiveChoice == 3)
	   nativePattern = 40;
	else if (fiveChoice == 4)
	   nativePattern = 22;
	else
	   nativePattern = 5;
	eagles = 1;
   }
   else if (patternChance == 6) // saguenay
   {
      rmSetSeaType("hudson bay");
      rmSetMapType("saguenay");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("lisbon");
	else
         rmSetLightingSet("saguenay");
      baseHt = rmRandFloat(1,2);
      baseType = "saguenay grass";
      oceanType = "hudson bay";
	forestType = "saguenay forest";
      pondType = "saguenay lake";
	treeType = "TreeSaguenay";
      if (variantChance == 1)
	{
         deerType = "caribou";
         deer2Type = "moose";
         centerHerdType = "caribou";
	}
      else 
	{     
         deerType = "caribou";
         deer2Type = "caribou";
         centerHerdType = "moose";       
	}
      sheepType = "sheep";
      fishType = "FishSalmon";
      lakeFishType = "FishSalmon";
      whaleType = "beluga";
	makePonds = rmRandInt(1,3);
      if (featureChance < 6)
	{
	   makeLake = 1;
	   lakePattern = rmRandInt(1,4);  
	}
	else 
	{
	   makePonds = 1;	   	
	   morePonds = 1;
	}
	if (threeChoice == 1)
	   nativePattern = 5;
	else if (threeChoice == 2)
	   nativePattern = 6;
	else if (threeChoice == 3)
	   nativePattern = 16;
      if (rmRandInt(1,2) == 1)
	   kingfishers = 1;
	else
	   eagles = 1;
   }
   else if (patternChance == 7) // yukon
   {
      rmSetSeaType("great lakes ice");
      rmSetMapType("yukon");
      rmSetMapType("snow");
	if (lightingChance == 1)
	   rmSetLightingSet("305b");
	else
         rmSetLightingSet("yukon");
      baseHt = 0;
      baseType = "yukon snow";
      oceanType = "great lakes ice";
	forestType = "yukon snow forest";
	riverType = "Yukon River";
      cliffType = "rocky mountain2";
	treeType = "TreeYukonSnow";
      if (variantChance == 1)
	{
         deerType = "caribou";
         deer2Type = "muskOx";
         centerHerdType = "bighornsheep";
	}
      else 
	{     
         deerType = "muskOx";
         deer2Type = "caribou";
         centerHerdType = "caribou";       
	}
      sheepChance = 0;
      fishType = "FishSalmon";
      lakeFishType = "FishSalmon";
      whaleType = "beluga";
      placeBerries = 0;
      hillTrees = rmRandInt(0,1);
	clearCenterChance = 3;
	if (featureChance < 4)
	   makeMtRange = 1;
      else if (featureChance == 4)
	{
	   centerMt = 1;
	   cliffVariety = rmRandInt(1,5);
	}
	else if (featureChance == 5)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
	else if (featureChance < 9)
	{
	   makeIce = 1;
	   cliffChance = 0;
	}
      else if (featureChance > 8)
	{
	   if (axisChance == 1)
	   {
	      makeRiver = 1;
	      makePonds = 0;
	      clearCenterChance = 0;
	   }
	   else
	   {
	      makeIce = 1;
	      cliffChance = 0;
	   }
	}
	if (cliffChance > 2)
         makeCliffs = 1;
	if (fiveChoice == 1)
	   nativePattern = 5;
	else if (fiveChoice == 2)
	   nativePattern = 6;
	else if (fiveChoice == 3)
	   nativePattern = 8;
	else if (fiveChoice == 4)
	   nativePattern = 27;
	else
	   nativePattern = 28;
	eagles = 1;
   }
   else if (patternChance == 8) // rockies
   {
      rmSetSeaType("great lakes");
      rmSetMapType("rockies");
      rmSetMapType("snow");
	if (lightingChance == 1)
	   rmSetLightingSet("ottoman morning");
	else
         rmSetLightingSet("rockies");
      baseHt = rmRandFloat(1,3);
      baseType = "rockies_grass";
      oceanType = "great lakes";
	forestType = "rockies forest";
      cliffType = "rocky mountain2";
	treeType = "TreeRockies";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "elk";
         centerHerdType = "bighornsheep";
	}
      else 
	{     
         deerType = "elk";
         deer2Type = "elk";
         centerHerdType = "bighornsheep";
	}   
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
      fishType = "FishSalmon";
      whaleType = "beluga";
      hillTrees = 1;
      reducedForest = 1;
      if (featureChance < 3)
	   centerMt = 1;
	else if (featureChance < 6)
	   makeCentralHighlands = 1;
	else
	   makeMtRange = 1;
	if (fiveChoice == 1)
	   nativePattern = 23;
	else if (fiveChoice == 2)
	   nativePattern = 29;
	else if (fiveChoice == 3)
	   nativePattern = 19;
	else if (fiveChoice == 4)
	   nativePattern = 8;
	else if (fiveChoice == 5)
	   nativePattern = 28;
	eagles = 1;
   }
   else if (patternChance == 9) // great plains 1
   {
      rmSetSeaType("yucatan Coast");
      rmSetMapType("greatPlains");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("ottoman morning");
	else
         rmSetLightingSet("great plains");  
      baseHt = 1;
      baseType = "great plains grass"; 
      oceanType = "yucatan Coast";
	forestType = "great plains forest";
	riverType = "Amazon River";
      cliffType = "Great Plains";
      pondType = "great plains pond";
	treeType = "TreeGreatPlains";
      if (variantChance == 1)
	{
         deerType = "bison";
         deer2Type = "pronghorn";
         centerHerdType = "bison";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "elk";
	} 
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
      fishType = "FishCod";
      lakeFishType = "FishBass";
      whaleType = "minkeWhale";
      plainsMap = 1;
	makePonds = rmRandInt(1,10);
	clearCenterChance = 2;
      if (featureChance == 1)
	{
	   makePonds = 1;	   	
	   morePonds = 1;
	}
      else if (featureChance == 2)
	   makeLake = 1;
	else if (featureChance == 3)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
	else if (featureChance == 4)
	{
	   makeCentralHighlands = 1;
	   cliffChance = 0;
         mtForest = 1;
	}
      else if (featureChance == 5)
         makeBarrierRange = 1;
      else if (featureChance > 6)
	{
	   if (axisChance == 1)
	   {
	      makeRiver = 1;
	      makePonds = 0;
	      clearCenterChance = 0;
	   }
	   else
	   {
	      makeCentralCanyon = 1;
	      cliffChance = 0;
            mtForest = 1;
	   }
	}
	if (cliffChance > 7)
         makeCliffs = 1;
	if (rmRandInt(1,3) > 1)
	{ 
	   bareCliffs = 1;
	   noCliffForest = 1;
	}
	if (fiveChoice == 1)
	   nativePattern = 23;
	else if (fiveChoice == 2)
	   nativePattern = 29;
	else if (fiveChoice == 3)
	   nativePattern = 19;
	else if (fiveChoice == 4)
	   nativePattern = 8;
	else
	   nativePattern = 28;
      if (rmRandInt(1,2) == 1)
	   eaglerock = 1;
	else
	   geyserProp = 1;
      vultures = 1;
   }
   else if (patternChance == 10) // great plains 2
   {
      rmSetSeaType("yucatan Coast");
      rmSetMapType("greatPlains");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("spc14abuffalo");
	else
         rmSetLightingSet("great plains");
      baseHt = 1;
      baseType = "great plains drygrass";
      oceanType = "yucatan Coast";
	forestType = "great plains forest";
      cliffType = "Great Plains";
      pondType = "great plains pond";
	treeType = "TreeGreatPlains";
      if (variantChance == 1)
	{
         deerType = "bison";
         deer2Type = "pronghorn";
         centerHerdType = "bison";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bison";
	}
      sheepType = "cow";
      fishType = "FishCod";
      lakeFishType = "FishBass";
      whaleType = "humpbackWhale";
	makePonds = rmRandInt(1,10);
	forestCoverUp = 1;
	clearCenterChance = 1;
      if (featureChance == 1)
	{
	   makePonds = 1;	   	
	   morePonds = 1;
	}
      else if (featureChance == 2)
	   makeLake = 1;
	else if (featureChance < 5)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
	else if (featureChance < 7)
	{
	   makeCentralCanyon = 1;
	   cliffChance = 0;
         mtForest = 1;
	}
	else if (featureChance < 9)
	{
	   makeCentralHighlands = 1;
	   cliffChance = 0;
         mtForest = 1;
	}
      else if (featureChance == 10)
	{
	   makeBarrierRange = 1;
	}
	if (cliffChance > 7) 
         makeCliffs = 1;
	if (rmRandInt(1,3) > 1)
	{ 
	   bareCliffs = 1;
	   noCliffForest = 1;
	}
	if (fiveChoice == 1)
	   nativePattern = 30;
	else if (fiveChoice == 2)
	   nativePattern = 29;
	else if (fiveChoice == 3)
	   nativePattern = 32;
	else if (fiveChoice == 4)
	   nativePattern = 8;
	else if (fiveChoice == 5)
	   nativePattern = 28;
      if (rmRandInt(1,2) == 1)
	   vultures = 1;
	else
	   geyserProp = 1;
      plainsMap = 1;
   }
   else if (patternChance == 11) // texas grass
   {   
      rmSetSeaType("yucatan Coast");
      rmSetMapType("texas");
	rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("pampas");
	else
         rmSetLightingSet("texas");
      baseHt = 1;
      baseType = "texas_grass";
      oceanType = "yucatan Coast";
	forestType = "texas forest";
	riverType = "Amazon River";
      cliffType = "Texas Grass";
	pondType = "texas pond";
	treeType = "TreeTexas";
      if (variantChance == 1)
	{
         deerType = "bison";
         deer2Type = "deer";
         centerHerdType = "bison";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bison";
	}
      sheepType = "cow";
      fishType = "FishSardine";
      lakeFishType = "FishBass";
      whaleType = "humpbackWhale";
	if (cliffChance > 3)
         makeCliffs = 1;
	makePonds = rmRandInt(1,10);
	clearCenterChance = 2;
      if (featureChance == 1)
	{
	   makePonds = 1;	   	
	   morePonds = 1;
	}
	else if (featureChance == 2)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
      else if (featureChance < 5)
	   makeLake = 1;
	else if (featureChance == 5)
	{
	   makeCentralHighlands = 1;
	   makeCliffs = 2;
         mtForest = 1;
	}
      else if (featureChance > 6)
	{
	   if (axisChance == 1)
	   {
	      makeRiver = 1;
	      makePonds = 0;
	      clearCenterChance = 0;
	   }
	   else 
	   {
	      makeCentralCanyon = 1;
	      cliffChance = 0;
            mtForest = 1;
	   }
	}
	if (sixChoice == 1)
	   nativePattern = 30;
	else if (sixChoice == 2)
	   nativePattern = 29;
	else if (sixChoice == 3)
	   nativePattern = 32;
	else if (sixChoice == 4)
	   nativePattern = 19;
	else if (sixChoice == 5)
	   nativePattern = 20;
	else
	   nativePattern = 9;
	if (rmRandInt(1,2)==1)
	   vultures = 1;
	else
   	   texasProp = 1;
   }
   else if (patternChance == 12) // texas desert
   {   
      rmSetSeaType("yucatan Coast");
      rmSetMapType("texas");
	rmSetMapType("grass");
	if (featureChance > 8)
	{
	   if (axisChance == 1)
	      rmSetLightingSet("pampas");
	   else
	   {
	      if (lightingChance == 1)
	         rmSetLightingSet("seville");
	      else
               rmSetLightingSet("texas");
	   }
	}
	else
	{
         if (lightingChance == 1)
	      rmSetLightingSet("seville");
	   else
            rmSetLightingSet("texas");
	}
      baseHt = rmRandFloat(1,3);
	if (lightingChance == 1)
	{
	   baseType = "texas_dirt";
	   coastPatch = 1;
	}
	else
         baseType = "texas_grass";
      oceanType = "yucatan Coast";
	forestType = "texas forest dirt";
	riverType = "Pampas River";
      cliffType = "Texas";
	pondType = "texas pond";
	treeType = "TreeTexasDirt";
      if (variantChance == 1)
	{
         deerType = "bison";
         deer2Type = "pronghorn";
         centerHerdType = "pronghorn";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bison";
	}
      sheepType = "cow";
      fishType = "FishSardine";
      whaleType = "humpbackWhale";
	makePonds = rmRandInt(1,15);
	reducedForest = rmRandInt(0,1);
      clearCenterChance = 1;
      makeCliffs = 1;
      if (featureChance < 3)
	{
	   makeCentralCanyon = 1;
	   cliffChance = 0;
         mtForest = 1;
	}
	else if (featureChance <5)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
	else if (featureChance < 8)
	{
	   makeCentralHighlands = 1;
	   makeCliffs = 2;
         mtForest = 1;
	}
      else if (featureChance == 8)
	   makeBarrierRange = 1;
      else if (featureChance > 8)
	{
	   if (axisChance == 1)
	   {
	      makeRiver = 1;
	      makePonds = 0;
	      clearCenterChance = 0;
	   }
	}
	if (sixChoice == 1)
	   nativePattern = 30;
	else if (sixChoice == 2)
	   nativePattern = 29;
	else if (sixChoice == 3)
	   nativePattern = 32;
	else if (sixChoice == 4)
	   nativePattern = 31;
	else if (sixChoice == 5)
	   nativePattern = 38;
	else
	   nativePattern = 39;
	texasProp = 1;
	if (rmRandInt(1,2)==1)
	   vultures = 1;
   }
   else if (patternChance == 13) // sonora
   {   
      rmSetSeaType("great lakes");
      rmSetMapType("sonora");
	rmSetMapType("grass");
	if (featureChance == 6)
	   rmSetLightingSet("pampas");
	else
	{
   	   if (lightingChance == 1)
            rmSetLightingSet("sonora");
	   else
            rmSetLightingSet("pampas");
	}
      baseHt = 1;
      baseType = "sonora_dirt";
      oceanType = "great lakes";
	forestType = "sonora forest";
	riverType = "Pampas River";
      cliffType = "Sonora";
      cliffVariety = 6;
	treeType = "TreeSonora";
      if (variantChance == 1)
	{
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bighornsheep";         
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bighornsheep";
         centerHerdType = "bison";         
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      fishType = "FishMahi";
      whaleType = "humpbackWhale";
	reducedForest = rmRandInt(0,1);
      if (featureChance < 4)
	{
	   makeCentralCanyon = 1;
         mtForest = 1;
	}
	else if (featureChance == 4)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
	else if (featureChance < 7)
	{
	   makeCentralHighlands = 1;
         mtForest = 1;
	}
      else if (featureChance == 7)
	   makeBarrierRange = 1;
      else if (featureChance > 8)
	{
	   if (axisChance == 1)
	   {
	      makeRiver = 1;
	      makePonds = 0;
	      clearCenterChance = 0;
	   }
	   else
	      makeBarrierRange = 1;
	}
      makeCliffs = 1;
	if (fiveChoice == 1)
	   nativePattern = 10;
	else if (fiveChoice == 2)
	   nativePattern = 31;
	else if (fiveChoice == 3)
	   nativePattern = 32;
	else if (fiveChoice == 4)
	   nativePattern = 33;
	else
	   nativePattern = 37;
      if (rmRandInt(1,2) == 1)
	   vultures = 1;
	else
	   eaglerock = 1;
   }
   else if (patternChance == 14) // yucatan
   {
      rmSetSeaType("yucatan Coast");
      rmSetMapType("yucatan");
      rmSetMapType("tropical");
	if (lightingChance == 1)
	   rmSetLightingSet("311b");
	else
         rmSetLightingSet("yucatan");
      baseHt = 1;
      baseType = "yucatan_grass";
      oceanType = "yucatan Coast";
	forestType = "yucatan forest";
	riverType = "Amazon River";
      cliffType = "Amazon";
      pondType = "Amazon River Basin";
	treeType = "TreeYucatan";
      if (variantChance == 1)
      {
         deerType = "tapir";
         deer2Type = "capybara";
         centerHerdType = "turkey";
      }
      else
	{
         deerType = "capybara";
         deer2Type = "turkey";
         centerHerdType = "tapir";
	}
      sheepChance = 0;
      tropicalMap = 1;
      fishType = "FishTarpon";
      lakeFishType = "FishBass";
      whaleType = "humpbackWhale";
      hillTrees = rmRandInt(0,1);
      if (featureChance == 1)
	   makeBarrierRange = 1;
      else if (featureChance == 2)
	   makeLake = 1;
	else if (featureChance == 3)
	   makeValley = 1;	   	
	else if (featureChance < 6)
	{
	   makeCentralHighlands = 1;
	   cliffChance = 0;
         mtForest = 1;
	}
      else if (featureChance < 8)
	{
	   forestMt = 1;
	   cliffChance = 0;
	}
      else if (featureChance > 8)
	{
	   if (axisChance == 1)
	   {
	      makeRiver = 1;
	      makePonds = 0;
	      clearCenterChance = 0;
	   }
	   else
	      makePonds = 1;
	}
	if (cliffChance > 7)
         makeCliffs = 1;
	if ((makeRiver == 1) || (forestMt == 1) || (makeLake == 1))  
	   bonusForest = 0;
	else 
	   bonusForest = rmRandInt(1,2);
	if (threeChoice == 1)
	   nativePattern = 12;
	else if (threeChoice == 2)
	   nativePattern = 35;
	else if (threeChoice == 3)
	   nativePattern = 36;
	kingfishers = 1;
   }
   else if (patternChance == 15) // caribbean
   {
      rmSetSeaType("caribbean coast");
      rmSetMapType("caribbean");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("301a_malta");
	else
         rmSetLightingSet("caribbean");
      baseHt = 0;
      baseType = "caribbean grass";
      oceanType = "caribbean coast";
	forestType = "caribbean palm forest";
      cliffType = "Caribbean";
      pondType = "caribbean coast";
	treeType = "TreeCaribbean";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "tapir";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "tapir";
         centerHerdType = "deer";
	}
      sheepChance = 0;
      tropicalMap = 1;
      fishType = "FishMahi";
      lakeFishType = "FishTarpon";
      whaleType = "humpbackWhale";
      if (featureChance < 3)
	   makeLake = 1;
	else if (featureChance < 5)
         makeBarrierRange = 1;
	else if (featureChance < 7)
	   makeValley = 1;
	else if (featureChance < 9)
	   makeCentralHighlands = 1;
	if (cliffChance > 7)
         makeCliffs = 1;
	if (makeLake == 1)  
	   bonusForest = 0;
	else 
	   bonusForest = rmRandInt(1,2);
	if (fiveChoice == 1)
	   nativePattern = 12;
	else if (fiveChoice == 2)
	   nativePattern = 13;
	else if (fiveChoice == 3)
	   nativePattern = 18;
	else if (fiveChoice == 4)
	   nativePattern = 36;
	else
	   nativePattern = 42;
      kingfishers = 1;
   }
   else if (patternChance == 16) // amazon
   {
      rmSetSeaType("yucatan coast");
      rmSetMapType("amazonia");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("323b_inca");
	else
         rmSetLightingSet("amazon");
      baseHt = 1;
      baseType = "amazon grass";
      oceanType = "yucatan Coast";
	forestType = "amazon rain forest";
	riverType = "Amazon River";
      cliffType = "Amazon";
      pondType = "Amazon River Basin";
	treeType = "TreeAmazon";
      if (variantChance == 1)
      {
         deerType = "tapir";
         deer2Type = "tapir";
         centerHerdType = "capybara";
      }
      else
	{
         deerType = "capybara";
         deer2Type = "tapir";
         centerHerdType = "capybara";
	}
      sheepChance = 0;
      tropicalMap = 1;
      fishType = "FishTarpon";
      lakeFishType = "FishTarpon";
      whaleType = "humpbackWhale";
      if (featureChance == 1)
	   makeLake = 1;
	else if (featureChance == 2)
         makeBarrierRange = 1;
	else if (featureChance == 3)
	   makeValley = 1;	   	
	else if (featureChance == 4)
	{
	   makeCentralHighlands = 1;
	   cliffChance = 0;
         mtForest = 1;
	}
      else 
	{
	   if (axisChance == 1)
	   {
	      makeRiver = 1;
	      makePonds = 0;
	      clearCenterChance = 0;
	   }
	   else
	   {
		if (featureChance > 8)
		{
	   	   makeCentralHighlands = 1;
	   	   cliffChance = 0;
         	   mtForest = 1;
		}
		else
		{
	         forestMt = 1;
	         cliffChance = 0;
		}
	   }
	}
	if (cliffChance > 7)
         makeCliffs = 1;
	if ((makeRiver == 1) || (forestMt == 1) || (makeLake == 1))  
	   bonusForest = 0;
	else 
	   bonusForest = rmRandInt(1,2);
	if (fiveChoice == 1)
	   nativePattern = 13;
	else if (fiveChoice == 2)
	   nativePattern = 14;
	else if (fiveChoice == 3)
	   nativePattern = 15;
	else if (fiveChoice == 4)
	   nativePattern = 18;
	else
	   nativePattern = 26;
	kingfishers = 1;
   }
   else if (patternChance == 17) // pampas
   {
      rmSetSeaType("yucatan coast");
      rmSetMapType("pampas");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("texas");
	else
         rmSetLightingSet("pampas");
      baseHt = 1;
	baseType = "pampas_grass";
	coastPatch = 1;
      oceanType = "yucatan coast";
	forestType = "pampas forest";
	treeType = "TreePampas";
	riverType = "Pampas River";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "rhea";
         centerHerdType = "rhea";
	}
      else 
	{     
         deerType = "rhea";
         deer2Type = "deer";
         centerHerdType = "rhea";
	}
      sheepType = "llama";
      fishType = "FishMahi";
      whaleType = "humpbackWhale";
	clearCenterChance = 2;
      if (axisChance == 1)
	{
	   makeRiver = 1;
	   clearCenterChance = 0;
	}
	if (threeChoice == 1)
	   nativePattern = 14;
	else if (threeChoice == 2)
	   nativePattern = 25;
	else
	   nativePattern = 26;
      if (rmRandInt(1,2) == 1)
	   vultures = 1;
	else
	   eagles = 1;
   }
   else if (patternChance == 18) // patagonia
   {
      rmSetSeaType("hudson bay");
      rmSetMapType("patagonia");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("paris day");
	else
         rmSetLightingSet("patagonia");
      baseHt = rmRandFloat(1,3);
      baseType = "patagonia_grass";
	patchMixType = "patagonia_dirt";
	makePatchMix = 1;
      oceanType = "hudson bay";
	forestType = "patagonia forest";
      cliffType = "Patagonia";
      pondType = "hudson bay";
	treeType = "TreePatagoniaDirt";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "rhea";
         centerHerdType = "rhea";
	}
      else 
	{     
         deerType = "rhea";
         deer2Type = "deer";
         centerHerdType = "rhea";
	}
      sheepType = "llama";
      fishType = "FishSardine";
      lakeFishType = "FishSalmon";
      whaleType = "minkeWhale";
      hillTrees = rmRandInt(0,1);
	if (cliffChance < 6)
         makeCliffs = 1;
	makePonds = rmRandInt(1,10);
      if (featureChance < 3)
	{
	   makeLake = 1;
	   lakePattern = rmRandInt(1,4);  
	}
	else if (featureChance < 5)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
	else if (featureChance < 7)
	{
	   makeCentralHighlands = 1;
	   makeCliffs = 2;
         mtForest = 1;
   	   clearCenterChance = 2;
	}
	else if (featureChance < 9)
	{
	   makeCentralCanyon = 1;
	   makeCliffs = 2;
         mtForest = 1;
	}
	else 
	   makeBarrierRange = 1;
	if (fiveChoice == 1)
	   nativePattern = 14;
	else if (fiveChoice == 2)
	   nativePattern = 15;
	else if (fiveChoice == 3)
	   nativePattern = 24;
	else if (fiveChoice == 4)
	   nativePattern = 25;
	else
	   nativePattern = 26;
      if (rmRandInt(1,2) == 1)
	   kingfishers = 1;
	else
	   eagles = 1;
   }
   else if (patternChance == 19) // andes
   {
      rmSetSeaType("california coast");
      rmSetMapType("andes");
      rmSetMapType("grass");
	if (lightingChance == 1)
         rmSetLightingSet("greatplainstest");
	else
	   rmSetLightingSet("andes");
      baseHt = rmRandFloat(1,3);
      baseType = "andes_grass_a";
	patchMixType = "andes_grass_b";
	makePatchMix = 1;
      oceanType = "california coast";
	forestType = "andes forest";
	cliffType = "Andes";
	pondType = "california coast";
	treeType = "TreeAndes";
      if (variantChance == 1)
	{
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "rhea";
	}
      else 
	{     
         deerType = "guanaco";
         deer2Type = "rhea";
         centerHerdType = "guanaco";
	}
      sheepType = "llama";
      fishType = "FishSardine";
      lakeFishType = "FishSalmon";
      whaleType = "humpbackWhale";
	if (cliffChance < 8)
         makeCliffs = 1;
      if (featureChance < 3)
	{
	   makeLake = 1;
	   lakePattern = rmRandInt(1,4);  
	}
	else if (featureChance < 5)
	{
	   makeValley = 1;	   	
	}
	else if (featureChance < 7)
	{
	   makeCentralHighlands = 1;
	   makeCliffs = 2;
         mtForest = 1;
   	   clearCenterChance = 2;
	}
	else if (featureChance < 9)
	{
	   makeCentralCanyon = 1;
	   makeCliffs = 2;
         mtForest = 1;
	}
	else if (featureChance == 9)
	   makeBarrierRange = 1;
      tropicalMap = 1;
	if (fiveChoice == 1)
	   nativePattern = 14;
	else if (fiveChoice == 2)
	   nativePattern = 24;
	else if (fiveChoice == 3)
	   nativePattern = 25;
	else if (fiveChoice == 4)
	   nativePattern = 26;
	else
	   nativePattern = 34;
      if (rmRandInt(1,2) == 1)
	   vultures = 1;
	else
	   eagles = 1;
   }
   else if (patternChance == 20) // yukon tundra
   {
      rmSetSeaType("hudson bay");
      rmSetMapType("yukon");
      rmSetMapType("snow");
	if (lightingChance == 1)
         rmSetLightingSet("seville morning");
	else
         rmSetLightingSet("yukon");
      baseHt = 1;
      baseType = "yukon grass";
      oceanType = "hudson bay";
	forestType = "yukon forest";
	riverType = "Yukon River";
      cliffType = "rocky mountain2";
	if (rmRandInt(1,2) == 1)
         pondType = "hudson bay";
	else  
         pondType = "great lakes ice";
	treeType = "TreeYukon";
      if (variantChance == 1)
	{
	   if (featureChance > 2)
	   {
		if (axisChance == 1)
		{
		   makeRiver = 1; 
               deerType = "muskOx";
               deer2Type = "caribou";
               centerHerdType = "caribou";
		}
	      else
	      {
		   if (rmRandInt(1,2) == 1)
		   {
                  deerType = "muskOx";
                  deer2Type = "caribou";
                  centerHerdType = "bighornsheep";
		   }
		   else
		   {
                  deerType = "caribou";
                  deer2Type = "muskOx";
                  centerHerdType = "bighornsheep";
		   }
		   if (featureChance < 7)
		   {
	            makeMtRange = 1;
		   }
		   else
		   {
	            centerMt = 1;
	            clearCenterChance = 3;
		   }
	      }
	   }
	   else 
	   {
		makeIce = 1;
            deerType = "muskOx";
            deer2Type = "caribou";
            centerHerdType = "caribou";
	   	clearCenterChance = 3;
	   }
	}
      else 
	{
         deerType = "caribou"; 
         deer2Type = "muskOx";
         centerHerdType = "caribou"; 
	   if (featureChance < 3)
	   {
	      makeMtRange = 1;
	   }
	   else
	   {  
	      clearCenterChance = 3;
            if (featureChance < 7)
		   makeIce = 1;
	      else 	
	      {
	   	   makeLake = 1;
	   	   lakePattern = rmRandInt(1,4); 
		}
	   }     
	}
      sheepChance = 0;
      fishType = "FishSalmon";
      lakeFishType = "FishSalmon";
      whaleType = "beluga";
      placeBerries = 0;
      hillTrees = 0;
	reducedForest = rmRandInt(0,1);
	if (threeChoice == 1)
	   nativePattern = 5;
	else if (threeChoice == 2)
	   nativePattern = 6;
	else if (threeChoice == 3)
	   nativePattern = 16;
	eagles = 1;
   }
   else if (patternChance == 21) // painted desert
   {   
      rmSetSeaType("Lisbon");
      rmSetMapType("sonora");
	rmSetMapType("grass");
      if (lightingChance == 1)
         rmSetLightingSet("seville");
      else
         rmSetLightingSet("pampas");
	if (twoChoice == 1)
         baseType = "painteddesert_groundmix_2";
	else
         baseType = "painteddesert_groundmix_1";
      oceanType = "Lisbon";
	forestType = "painteddesert forest";
      cliffType = "Painteddesert";
	pondType = "texas pond";
	treeType = "TreePaintedDesert";
      if (variantChance == 1)
	{
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bighornsheep";         
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bighornsheep";
         centerHerdType = "bison";         
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      fishType = "FishSardine";
      lakeFishType = "FishBass";
      whaleType = "humpbackWhale";
	reducedForest = rmRandInt(0,1);
      if (featureChance < 3)
	{
	   makeCentralCanyon = 1;
         mtForest = 1;
	}
	else if (featureChance < 6)
	{
	   makeCentralHighlands = 1;
         mtForest = 0;
	}
      else if (featureChance < 8)
	   makeBarrierRange = 1;
      else if (featureChance > 7)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
      makeCliffs = 1;
	if (fiveChoice == 1)
	   nativePattern = 30;
	else if (fiveChoice == 2)
	   nativePattern = 31;
	else if (fiveChoice == 3)
	   nativePattern = 32;
	else if (fiveChoice == 4)
	   nativePattern = 33;
	else
	   nativePattern = 37;
      if (rmRandInt(1,2) == 1)
	   eaglerock = 1;
	else
	   vultures = 1;
   }
   else if (patternChance == 22) // nwt
   {
      rmSetSeaType("Northwest Territory Water");   
      rmSetMapType("northwestTerritory");
      rmSetMapType("grass");
	if (lightingChance == 2)
	   rmSetLightingSet("nwterritory");
	else
         rmSetLightingSet("saguenay");
      baseType = "nwt_grass1";
      oceanType = "Northwest Territory Water";
	if (twoChoice == 1)
	{
	   forestType = "NW Territory Birch Forest";
   	   treeType = "TreeGreatLakes";
	}
	else
	{ 
	   forestType = "NW Territory Forest";
	   treeType = "TreeGreatPlains";   
	}
	riverType = "Northwest Territory Water";
	cliffType = "Araucania Central";    
	pondType = "Northwest Territory Water";
      if (variantChance == 1)
	{
         deerType = "elk";
         deer2Type = "moose";
         centerHerdType = "moose";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "elk";
	} 
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      lakeFishType = "FishSalmon";
      fishType = "FishSalmon";
      whaleType = "humpbackWhale";
      hillTrees = rmRandInt(0,1);
	if (cliffChance < 6)
         makeCliffs = 1;
      if (featureChance < 4)
	{
	   makeLake = 1;
	   makePonds = rmRandInt(1,3);
	   lakePattern = rmRandInt(1,4);  
	}
	else if (featureChance == 4)
	{
	   makeCentralHighlands = 1;
         mtForest = 1;
	}
      else if (featureChance == 5)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
      else if (featureChance == 6)
	{
         forestMt = 1;
	}
      else if (featureChance > 6)
	{
	   if (axisChance == 1)
	   {
	      makeRiver = 1;
	      clearCenterChance = 0;
	   }
	   else
	   {
	      makePonds = 1;	   	
	      morePonds = 1;
	   }
      }
	if ((makeRiver == 1) || (forestMt == 1) || (makeLake == 1))  
	   bonusForest = 0;
	else 
	   bonusForest = rmRandInt(1,2);
	if (fourChoice == 1)
	   nativePattern = 27;
	else if (fourChoice == 2)
	   nativePattern = 28;
	else if (fourChoice == 3)
	   nativePattern = 7;
	else
	   nativePattern = 6;
      if (rmRandInt(1,2) == 1)
	   kingfishers = 1;
	else
	   eagles = 1;
   }
   else if (patternChance == 23) // california green
   {
      rmSetSeaType("california coast");   
      rmSetMapType("california");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("california");
	else
         rmSetLightingSet("new england");  
      baseType = "california_grass";
	if (twoChoice == 1)
	   patchMixType = "california_grassrocks"; 
	else
	   patchMixType = "california_snowground5"; 
	makePatchMix = 1;
      oceanType = "california coast";
	if (fourChoice < 3)
	{ 
	   forestType = "california redwood forest";
	   treeType = "TreeRedwood";
	}
	else 
	{ 
	   forestType = "California pine forest";
	   treeType = "TreePonderosaPine";
	}
	riverType = "Andes River";
	cliffType = "California";    
      if (variantChance == 1)
	{
         deerType = "elk";
         deer2Type = "deer";
         centerHerdType = "elk";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "elk";
         centerHerdType = "elk";
	} 
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      fishType = "FishCod";
      lakeFishType = "FishSalmon";
      whaleType = "humpbackWhale";
      hillTrees = rmRandInt(0,1);
      if (featureChance == 1)
	   makeBarrierRange = 1;
	else if (featureChance < 4)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}	   	
	else if (featureChance < 6)
	{
	   makeCentralHighlands = 1;
	   cliffChance = 0;
         mtForest = 1;
	}
      else if (featureChance < 7)
	{
	   forestMt = 1;
	   cliffChance = 0;
	}
      else if (featureChance > 8)
	{
	   if (axisChance == 1)
	   {
	      makeRiver = 1;
	      makePonds = 0;
	      clearCenterChance = 0;
	   }
	   else
	   {
	      makeLake = 1;
	      pondType = "california coast";
	   }
	}
	if ((makeRiver == 1) || (forestMt == 1) || (makeBarrierRange == 1) || (makeLake == 1))  
	   bonusForest = 0;
	else 
	   bonusForest = rmRandInt(1,2);
	if (cliffChance > 5)
         makeCliffs = 1;
	if (sixChoice < 4)
	   nativePattern = 27;
	else
	   nativePattern = 28;
	eagles = 1;
   }
   else if (patternChance == 24) // california desert
   {
      rmSetSeaType("california coast");   
      rmSetMapType("california");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("california");
	else
         rmSetLightingSet("307a_beach");  
      baseType = "california_desert2";
	patchMixType = "california_desert";
	makePatchMix = 1;
      oceanType = "california coast";
	cliffType = "California";  
	if (fourChoice < 3)
	{ 
	   forestType = "California Desert Forest";
	   treeType = "TreeSonora";
	}
	else 
	{ 
	   forestType = "california madrone forest";
	   treeType = "TreeMadrone";
	}
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "pronghorn";
         centerHerdType = "elk";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "elk";
         centerHerdType = "deer";
	} 
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      fishType = "FishMahi";
      lakeFishType = "FishBass";
      whaleType = "humpbackWhale";
	hillTrees = rmRandInt(0,1);
	reducedForest = rmRandInt(0,1);
	clearCenterChance = 2;
	if (featureChance < 3)
	{
	   makeCentralHighlands = 1;
	   cliffChance = 0;
	}
      else if (featureChance < 5)
	{
	   makeCentralCanyon = 1;
	   cliffChance = 0;
	}
      else if (featureChance == 5)
	{
	   forestMt = 1;
	   cliffChance = 0;
	}
	else if (featureChance < 8)
	{
	   makeValley = 1;	   	
	   hillTrees = 0;
	}
	if (twoChoice == 1)
	   nativePattern = 27;
	else
	   nativePattern = 43;
	vultures = 1;
   }
   else if (patternChance == 25) // central araucania
   {
      rmSetSeaType("Araucania Central Coast");
      rmSetMapType("araucania");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("Araucania Central");
	else
         rmSetLightingSet("new england");
      baseType = "araucania_grass_b";
	patchMixType = "araucania_grass_d";
	makePatchMix = 1;
      oceanType = "california coast";
	forestType = "Araucania Forest";
	riverType = "Andes River";
	cliffType = "Araucania Central"; 
	pondType =  "california coast"; 
	treeType = "TreeAraucania";
      if (variantChance == 1)
	{
         deerType = "guanaco";
         deer2Type = "deer";
         centerHerdType = "guanaco"; 
	}
      else 
	{     
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "guanaco";
	} 
      sheepType = "llama";
      fishType = "FishCod";
      lakeFishType = "FishSalmon";
      whaleType = "humpbackWhale";
      tropicalMap = 1;
      makeCliffs = 2;
	forestCoverUp = 1;
	clearCenterChance = 0;
      if (featureChance == 1)
	{
         makeLake = 1;
	}
	else if (featureChance < 4)
	{
	   makeCentralHighlands = 1;
	   makeCliffs = 2;
	   clearCenterChance = 2;
	}
	else if (featureChance < 5)	
	{
	   makeCentralCanyon = 1;
	   makeCliffs = 2;
	}
	else if (featureChance < 7)
	{
	   makeValley = 1;
	}
      else if (featureChance == 7)
	   makeBarrierRange = 1;
	else if (featureChance > 8)	
	{
	   if (axisChance == 1)
	      makeRiver = 1;
	   else
	   {
	      forestMt = 1;
	      makeCliffs = 1;
	   }
	}
	if ((makeRiver == 1) || (forestMt == 1) || (makeBarrierRange == 1) || (makeLake == 1))  
	   bonusForest = 0;
	else 
	   bonusForest = rmRandInt(1,2);
	if (fiveChoice == 1)
	   nativePattern = 14;
	else if (fiveChoice == 2)
	   nativePattern = 25;
	else if (fiveChoice == 3)
	   nativePattern = 25;
	else if (fiveChoice == 4)
	   nativePattern = 18;
	else
	   nativePattern = 11;
      if (rmRandInt(1,2) == 1)
	   kingfishers = 1;
	else
	   eagles = 1;
   }
   else if (patternChance == 26) // south araucania
   {
      rmSetSeaType("Araucania Southern Coast");
      rmSetMapType("araucania");
      rmSetMapType("grass");
	if (lightingChance == 2)
	   rmSetLightingSet("SthAraucaniaLight");
	else
	   rmSetLightingSet("303a_boston");     
      baseType = "araucania_snow_c";
	patchMixType = "araucania_snow_a";
	makePatchMix = 1;
      oceanType = "Araucania Southern Coast";
	forestType = "Patagonia Snow Forest";
	riverType = "Yukon River";  
      cliffType = "Araucania South";
	treeType = "TreePatagoniaSnow";
	if (twoChoice == 1)
	   pondType = "great lakes ice";  
	else
	   pondType = "Araucania Southern Coast"; 
      if (variantChance == 1)
	{
         deerType = "guanaco";
         deer2Type = "deer";
         centerHerdType = "guanaco"; 
	}
      else 
	{     
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "deer";
	} 
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "llama";
      fishType = "FishCod";
      lakeFishType = "FishSalmon";
      whaleType = "humpbackWhale";
      hillTrees = rmRandInt(0,1);
      placeBerries = 0;
      makeCliffs = 2;
	reducedForest = rmRandInt(0,1);
	noCliffForest = 1;	
	if (featureChance == 1)
	   makeLake = 1;
	else if (featureChance == 2)
	   makeMtRange = 1;
	else if (featureChance == 3)
	{
	   makeCentralHighlands = 1;
	   hillTrees = 0;
	   clearCenterChance = 2;
	}
	else if (featureChance == 4)	
	{
	   makeCentralCanyon = 1;
	   makeCliffs = 2;
	   hillTrees = 0;
	}
	else if (featureChance == 5)
	{
         makeBarrierRange = 1;
	}	
	else if (featureChance < 8)
	{
	   makeIce = 1;
	   hillTrees = 0;
	   cliffChance = 0;
	}
	else if (featureChance == 8)
	{
	   makeValley = 1;
	   hillTrees = 0;
	}
	else if (featureChance > 8)	
	{
	   if (axisChance == 1)
	      makeRiver = 1;
	   else
	   {
	      centerMt = 1;
	      hillTrees = 0;
	   }
	}
	if (cliffChance == 0)
	   makeCliffs = 0;
	if (fourChoice < 3)
	   nativePattern = 14;
	else 
	   nativePattern = 26;
	eagles = 1;
   }
   else if (patternChance == 27) // north araucania
   {
      rmSetSeaType("Araucania North Coast");
      rmSetMapType("araucania");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("NthAraucaniaLight");
	else
         rmSetLightingSet("constantinople");  
      baseType = "araucania_north_grass_a";  
	if (twoChoice == 1)
	   patchMixType = "araucania_north_dirt_a"; 
	else
	   patchMixType = "araucania_north_grass_b"; 
	makePatchMix = 1;
      oceanType = "Araucania North Coast";
	forestType =  "North Araucania Forest";
	riverType = "Pampas River";
	cliffType = "Araucania North";
	treeType = "TreeAraucania";
      if (variantChance == 1)
	{
         deerType = "guanaco";
         deer2Type = "deer";
         centerHerdType = "guanaco"; 
	}
      else 
	{     
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "guanaco";
	} 
      sheepType = "llama";
      lakeFishType = "FishMoonBass";
      fishType = "FishSardine";
      whaleType = "humpbackWhale";
	clearCenterChance = 2;
	reducedForest = rmRandInt(0,1);
	forestCoverUp = 1;
	makeCliffs = 1;
	if (featureChance < 3)
	{
	   makeCentralHighlands = 1;
	   makeCliffs = 2;
	}
	else if (featureChance < 5)	
	{
	   makeCentralCanyon = 1;
	   makeCliffs = 2;
	}
	else if (featureChance == 5)
         makeBarrierRange = 1;
	else if (featureChance == 8)
	{
	   makeValley = 1;
	   makeCliffs = 2;
	}
	else if (featureChance > 8)	
	{
	   if (axisChance == 1)
	      makeRiver = 1;
	}
	if (fiveChoice == 1)
	   nativePattern = 14;
	else if (fiveChoice == 2)
	   nativePattern = 24;
	else if (fiveChoice == 3)
	   nativePattern = 25;
	else if (fiveChoice == 4)
	   nativePattern = 26;
	else
	   nativePattern = 34;
	vultures = 1;
   }
   else if (patternChance == 28) // palm desert
   {   
      rmSetMapType("sonora");
	rmSetMapType("grass");
      if (lightingChance == 1)
         rmSetLightingSet("seville");
      else
         rmSetLightingSet("pampas");
	if (twoChoice == 1)
	{
         rmSetSeaType("yucatan coast");
         baseType = "texas_dirt";
         cliffType = "Texas";
         oceanType = "yucatan coast";
	   coastPatch = 1;
	}
	else
	{
         rmSetSeaType("great lakes");
         baseType = "sonora_dirt";
	   cliffType = "Sonora";
         oceanType = "great lakes";
	}
	forestType = "caribbean palm forest";
	riverType = "Pampas River";
	treeType = "TreeCaribbean";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "turkey";
	}
      fishType = "FishMahi";
      lakeFishType = "FishBass";
      whaleType = "minkeWhale";
      sheepType = "cow";
	forestCoverUp = 1;
	reducedForest = rmRandInt(0,1);
      clearCenterChance = 1;
      makeCliffs = 1;
      if (featureChance < 3)
	{
	   makeCentralCanyon = 1;
	   cliffChance = 0;
         mtForest = 1;
	}
	else if (featureChance <5)
	{
	   makeValley = 1;
	   makeCliffs = 2;	   	
	   hillTrees = 0;
	}
	else if (featureChance < 7)
	{
	   makeCentralHighlands = 1;
	   makeCliffs = 2;
         mtForest = 1;
	}
      else if (featureChance == 8)
	   makeBarrierRange = 1;
      else if (featureChance > 8)
	{
	   if (axisChance == 1)
	   {
	      makeRiver = 1;
	      clearCenterChance = 0;
	   }
	}
	if (fourChoice == 1)
	   nativePattern = 33;
	else if (fourChoice == 2)
	   nativePattern = 35;
	else if (fourChoice == 3)
	   nativePattern = 35;
	else 
	   nativePattern = 36;
	texasProp = 1;
	if (rmRandInt(1,2)==1)
	   vultures = 1;
   }

   if (clearCenterChance == 1)
      clearCenter = rmRandInt(1,2);
   if (clearCenterChance == 2)
      clearCenter = rmRandInt(1,4);
   if (clearCenterChance == 3)
      clearCenter = rmRandInt(1,10);
   if (clearCenter > 1)
	clearCenter = 0;

   rmSetBaseTerrainMix(baseType);
   rmTerrainInitialize("yukon\ground1_yuk", 1); 
   rmEnableLocalWater(false);
   rmSetMapType("land");
   rmSetWorldCircleConstraint(true);
   rmSetWindMagnitude(2.0);   
   chooseMercs();

// Native patterns
  if (nativePattern == 1)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Iroquois");
      native2Name = "native iroquois village ";
  }
  else if (nativePattern == 2)
  {
      rmSetSubCiv(0, "Comanche");
      native1Name = "native comanche village ";
      rmSetSubCiv(1, "Lakota");
      native2Name = "native lakota village ";
  }
  else if (nativePattern == 3)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Seminoles");
      native2Name = "native seminole village ";
  }
  else if (nativePattern == 4)
  {
      rmSetSubCiv(0, "Cheyenne");
      native1Name = "native cheyenne village ";
      rmSetSubCiv(1, "Huron");
      native2Name = "native huron village ";
  }
  else if (nativePattern == 5)
  {
      rmSetSubCiv(0, "Huron");
      native1Name = "native huron village ";
      rmSetSubCiv(1, "Cree");
      native2Name = "native cree village ";
  }
  else if (nativePattern == 6)
  {
      rmSetSubCiv(0, "Nootka");
      native1Name = "native nootka village ";
      rmSetSubCiv(1, "Cree");
      native2Name = "native cree village ";
  }
  else if (nativePattern == 7)
  {
      rmSetSubCiv(0, "Nootka");
      native1Name = "native nootka village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 8)
  {
      rmSetSubCiv(0, "Cree");
      native1Name = "native cree village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 9)
  {
      rmSetSubCiv(0, "Seminoles");
      native1Name = "native seminole village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 10)
  {
      rmSetSubCiv(0, "Zapotec");
      native1Name = "native zapotec village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 11)
  {
      rmSetSubCiv(0, "Mapuche");
      native1Name = "native mapuche village ";
      rmSetSubCiv(1, "Maya");
      native2Name = "native maya village ";
  }
  else if (nativePattern == 12)
  {
      rmSetSubCiv(0, "Caribs");
      native1Name = "native carib village ";
      rmSetSubCiv(1, "Maya");
      native2Name = "native maya village ";
  }
  else if (nativePattern == 13)
  {
      rmSetSubCiv(0, "Caribs");
      native1Name = "native carib village ";
      rmSetSubCiv(1, "Tupi");
      native2Name = "native tupi village ";
  }
  else if (nativePattern == 14)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Tupi");
      native2Name = "native tupi village ";
  }
  else if (nativePattern == 15)
  {
      rmSetSubCiv(0, "Maya");
      native1Name = "native maya village ";
      rmSetSubCiv(1, "Tupi");
      native2Name = "native tupi village ";
  }
  else if (nativePattern == 16)
  {
      rmSetSubCiv(0, "Nootka");
      native1Name = "native nootka village ";
      rmSetSubCiv(1, "Huron");
      native2Name = "native huron village ";
  }
  else if (nativePattern == 17)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Aztecs");
      native2Name = "native aztec village ";
  }
  else if (nativePattern == 18)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Caribs");
      native2Name = "native carib village ";
  }
  else if (nativePattern == 19)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 20)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 21)
  {
      rmSetSubCiv(0, "Seminoles");
      native1Name = "native seminole village ";
      rmSetSubCiv(1, "Huron");
      native2Name = "native huron village ";
  }
  else if (nativePattern == 22)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Cree");
      native2Name = "native cree village ";
  }
  else if (nativePattern == 23)
  {
      rmSetSubCiv(0, "Comanche");
      native1Name = "native comanche village ";
      rmSetSubCiv(1, "Cree");
      native2Name = "native cree village ";
  }
  else if (nativePattern == 24)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Maya");
      native2Name = "native maya village ";
  }
  else if (nativePattern == 25)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Mapuche");
      native2Name = "native mapuche village ";
  }
  else if (nativePattern == 26)
  {
      rmSetSubCiv(0, "Tupi");
      native1Name = "native tupi village ";
      rmSetSubCiv(1, "Mapuche");
      native2Name = "native mapuche village ";
  }
  else if (nativePattern == 27)
  {
      rmSetSubCiv(0, "Klamath");
      native1Name = "native klamath village ";
      rmSetSubCiv(1, "Nootka");
      native2Name = "native nootka village ";
  }
  else if (nativePattern == 28)
  {
      rmSetSubCiv(0, "Klamath");
      native1Name = "native klamath village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 29)
  {
      rmSetSubCiv(0, "Comanche");
      native1Name = "native comanche village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 30)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 31)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Navajo");
      native2Name = "native navajo village ";
  }
  else if (nativePattern == 32)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 33)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 34)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 35)
  {
      rmSetSubCiv(0, "Maya");
      native1Name = "native maya village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 36)
  {
      rmSetSubCiv(0, "Caribs");
      native1Name = "native carib village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 37)
  {
      rmSetSubCiv(0, "Navajo");
      native1Name = "native navajo village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 38)
  {
      rmSetSubCiv(0, "Navajo");
      native1Name = "native navajo village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 39)
  {
      rmSetSubCiv(0, "Navajo");
      native1Name = "native navajo village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 40)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Huron");
      native2Name = "native huron village ";
  }
  else if (nativePattern == 41)
  {
      rmSetSubCiv(0, "Lakota");
      native1Name = "native lakota village ";
      rmSetSubCiv(1, "Huron");
      native2Name = "native huron village ";
  }
  else if (nativePattern == 42)
  {
      rmSetSubCiv(0, "Caribs");
      native1Name = "native carib village ";
      rmSetSubCiv(1, "Seminoles");
      native2Name = "native seminole village ";
  }
  else if (nativePattern == 43)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Klamath");
      native2Name = "native klamath village ";
  }

// Precipitation
   if (patternChance == 16) // amazon
      if (lightingChance == 2)
         rmSetGlobalRain( 1.0 );
   if (patternChance == 7) // yukon
      if (lightingChance == 2)
         rmSetGlobalSnow( 0.8 );
   if (patternChance == 5) // great lakes winter
      rmSetGlobalSnow( 0.7 );
   if (patternChance == 8) // rockies
      if (lightingChance == 2)
         rmSetGlobalSnow( 0.5 );
   if (patternChance == 14) // yucatan
      if (lightingChance == 2)
         rmSetGlobalRain( 0.7 );
   if (patternChance == 20) // yukon tundra
      if (lightingChance == 2)         
         rmSetGlobalSnow( 0.7 );

// Define some classes.
   int classPlayer=rmDefineClass("player");
   int lakeClass=rmDefineClass("lake");
   rmDefineClass("classHill");
   rmDefineClass("classPatch");
   rmDefineClass("starting settlement");
   rmDefineClass("startingUnit");
   rmDefineClass("classForest");
   rmDefineClass("importantItem");
   rmDefineClass("natives");
   rmDefineClass("classCliff");
   rmDefineClass("classCliff2");
   rmDefineClass("classMountain");
   rmDefineClass("classValley");
   rmDefineClass("center");
   rmDefineClass("classNugget");
   rmDefineClass("socketClass");
   rmDefineClass("classIce");
   rmDefineClass("classSea");
   rmDefineClass("classClearing"); 
   int classHuntable=rmDefineClass("huntableFood");   
   int classHerdable=rmDefineClass("herdableFood"); 
   int canyon=rmDefineClass("canyon");
   int classProp=rmDefineClass("allProps");

   // Text
   rmSetStatusText("",0.10);

// -------------Define constraints
   // Map edge constraints
   int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10), 0.01);
   int secondEdgeConstraint=rmCreateBoxConstraint("avoid edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
   int circleConstraintMt=rmCreatePieConstraint("circle Constraint for mts", 0.5, 0.5, 0, size*0.38, rmDegreesToRadians(0), rmDegreesToRadians(360));

   // Center constraints
   int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 30.0);
   int centerConstraintShort=rmCreateClassDistanceConstraint("stay away from center short", rmClassID("center"), 12.0);
   int centerConstraintFar=rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), 70.0);
   int centerConstraintForest=rmCreateClassDistanceConstraint("stay away from center forest", rmClassID("center"), 0.24*size);
   int centerConstraintForest2=rmCreateClassDistanceConstraint("stay away from center forest 2", rmClassID("center"), 0.24*size);
   int centerConstraintForest3=rmCreateClassDistanceConstraint("stay away from center forest 3", rmClassID("center"), 0.24*size);

   // Player constraints
   int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 15.0);
   int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 40.0);
   int mediumPlayerConstraint=rmCreateClassDistanceConstraint("medium stay away from players", classPlayer, 25.0);
   int nuggetPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 60.0);
   int farPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players more", classPlayer, 85.0);
   int fartherPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players the most", classPlayer, 105.0);
   int enormousPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players for asymmetric starts", classPlayer, 130.0);
   int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 70.0); 

   // Nature avoidance
   int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
   int shortForestConstraint=rmCreateClassDistanceConstraint("patch vs. forest", rmClassID("classForest"), 15.0);
   int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), forestDist);
   int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
   int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 10.0);
   int shortAvoidSilver=rmCreateTypeDistanceConstraint("short gold avoid gold", "Mine", 20.0);
   int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
   int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
   int avoidSheep=rmCreateClassDistanceConstraint("sheep avoids sheep etc", rmClassID("herdableFood"), 45.0);
   int huntableConstraint=rmCreateClassDistanceConstraint("huntable constraint", rmClassID("huntableFood"), 35.0);
   int longHuntableConstraint=rmCreateClassDistanceConstraint("long huntable constraint", rmClassID("huntableFood"), 55.0);
   int forestsAvoidBison=rmCreateClassDistanceConstraint("forest avoids bison", rmClassID("huntableFood"), 15.0);
   int avoidDucks=rmCreateTypeDistanceConstraint("avoids ducks", "DuckFamily", 50.0);

   // Avoid impassable land, certain features
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
   int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
   int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 18.0);
   int hillConstraint=rmCreateClassDistanceConstraint("hill vs. hill", rmClassID("classHill"), 15.0);
   int shortHillConstraint=rmCreateClassDistanceConstraint("patches vs. hill", rmClassID("classHill"), 5.0);
   int longHillConstraint=rmCreateClassDistanceConstraint("far from hill", rmClassID("classHill"), 35.0);
   int medHillConstraint=rmCreateClassDistanceConstraint("medium from hill", rmClassID("classHill"), 28.0);
   int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 8.0);
   int avoidCliffs2=rmCreateClassDistanceConstraint("stuff vs. cliff2", rmClassID("classCliff2"), 15.0);
   int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 12.0);
   int avoidCliff20=rmCreateClassDistanceConstraint("avoid cliffs 20", rmClassID("classCliff"), 20.0);
   int avoidCliffsShort=rmCreateClassDistanceConstraint("stuff vs. cliff short", rmClassID("classCliff"), 7.0);
   int cliffsAvoidCliffs=rmCreateClassDistanceConstraint("cliffs vs. cliffs", rmClassID("classCliff"), 30.0);
   int avoidMts=rmCreateClassDistanceConstraint("stuff vs. mts", rmClassID("classMountain"), 15.0);
   int avoidValley=rmCreateClassDistanceConstraint("stuff vs. valleys", rmClassID("classValley"), 15.0);
   int avoidWater10 = rmCreateTerrainDistanceConstraint("avoid water mid-long", "Land", false, 10.0);
   int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water mid-longer", "Land", false, 15.0);
   int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water a little more", "Land", false, 20.0);
   int avoidWater30 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 30.0);
   int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 35.0);
   int shortAvoidCanyons=rmCreateClassDistanceConstraint("short avoid canyons", rmClassID("canyon"), 15.0);
   int nearShore=rmCreateTerrainMaxDistanceConstraint("tree v. water", "land", true, 14.0);
   int avoidLakes=rmCreateClassDistanceConstraint("stuff vs.lakes", rmClassID("lake"), 12.0);
   int avoidLakesFar=rmCreateClassDistanceConstraint("stuff vs.lakes far", rmClassID("lake"), 55.0);
   int avoidIce=rmCreateClassDistanceConstraint("stuff vs.ice", rmClassID("classIce"), 12.0);
   int avoidSea=rmCreateClassDistanceConstraint("stuff vs.sea", rmClassID("classSea"), 25.0);
   int avoidClearing=rmCreateClassDistanceConstraint("avoid clearings", rmClassID("classClearing"), 10.0);  
  
   // Unit avoidance
   int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
   int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 10.0);
   int avoidImportantItem=rmCreateClassDistanceConstraint("things avoid each other", rmClassID("importantItem"), 10.0);
   int avoidImportantItemSmall=rmCreateClassDistanceConstraint("important item small avoidance", rmClassID("importantItem"), 7.0);
   int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 60.0);
   int avoidNativesMed=rmCreateClassDistanceConstraint("stuff avoids natives medium", rmClassID("natives"), 35.0);
   int avoidNativesShort=rmCreateClassDistanceConstraint("stuff avoids natives shorter", rmClassID("natives"), 15.0);
   int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget", rmClassID("classNugget"), 42.0);
   int avoidNuggetMed=rmCreateClassDistanceConstraint("nugget vs. nugget med", rmClassID("classNugget"), 50.0);
   int avoidNuggetLong=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 70.0);
   int avoidNuggetSmall=rmCreateTypeDistanceConstraint("avoid nuggets by a little", "AbstractNugget", 10.0);
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
   int avoidAllProps=rmCreateClassDistanceConstraint("props avoid each other", rmClassID("allProps"), 65.0);


   // Trade route avoidance.
   int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
   int avoidTradeRouteCliff = rmCreateTradeRouteDistanceConstraint("trade route cliff", 10.0);
   int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 12.0);

   // Water Flag constraint
   int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 25);
   int flagLand = rmCreateTerrainDistanceConstraint("flag land", "land", true, 25.0);
// ---------------------------------------------------------------------------------------
// Set up of trade routes for special situations
   threeChoice = rmRandInt(1,3);
   int routeRestrict = 0;
   if ((centerMt == 1) || (forestMt == 1))
   {
      if (mtPattern == 1)
	   routeRestrict = 1;
   }

   if ((makeLake == 1) || (makeIce == 1) || (makeBarrierRange == 1)) 
      routeRestrict = 1;

   if (routeRestrict == 1)
   {
	if ((trPattern == 5) || (trPattern == 6) || (trPattern == 8)) 
	{
	   if (rmRandInt(1,7) < 5)
	      trPattern = rmRandInt(1,4);
	   else
	   {
		if (threeChoice == 1)
		   trPattern = 7;
		else if (threeChoice == 2)
		   trPattern = 9;
		else if (threeChoice == 3)
		{
		   trPattern = 10;
 		   lakePattern = rmRandInt(1,2);
		}
	   }
	}
   }

   if ((makeRiver == 1) || (makeMtRange == 1) || (lakePattern > 2))
      trPattern = rmRandInt(1,4);

   // Text
   rmSetStatusText("",0.15);

// Set up player starting locations
if (cNumberTeams == 2)
{
   if (cNumberNonGaiaPlayers == 2)
   {
      if (axisChance == 1)
	{
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.22, 0.23);
	   }
	   else
	   {
            rmSetPlacementSection(0.77, 0.78);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.27, 0.28);
	   }
	   else
	   {
            rmSetPlacementSection(0.72, 0.73);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);
	}
	else if (axisChance == 2)
	{
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.02, 0.03);
	   }
	   else
	   {
	      rmSetPlacementSection(0.46, 0.47);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.96, 0.97);
	   }
	   else
	   {
	      rmSetPlacementSection(0.52, 0.53);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);
	}
   }
   else if (cNumberNonGaiaPlayers < 5)
   {
      if (axisChance == 1)
	{
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.18, 0.32);
	   }
	   else
	   {
	      rmSetPlacementSection(0.68, 0.82);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.18, 0.32);
	   }
	   else
	   {
	      rmSetPlacementSection(0.68, 0.82);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);
	}
	else if (axisChance == 2)
	{
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.93, 0.07);
	   }
	   else
	   {
	      rmSetPlacementSection(0.43, 0.57);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.93, 0.07);
	   }
	   else
	   {
	      rmSetPlacementSection(0.43, 0.57);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);
	}
   }
   else if (cNumberNonGaiaPlayers < 7)
   {
      if (axisChance == 1)
	{
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.14, 0.36);
	   }
	   else
	   {
	      rmSetPlacementSection(0.64, 0.86);
	   }
	   rmPlacePlayersCircular(0.38, 0.39, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.14, 0.36);
	   }
	   else
	   {
	      rmSetPlacementSection(0.64, 0.86);
	   }
	   rmPlacePlayersCircular(0.38, 0.39, 0.0);
	}
	else if (axisChance == 2)
	{
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.89, 0.11);
	   }
	   else
	   {
	      rmSetPlacementSection(0.39, 0.61);
	   }
	   rmPlacePlayersCircular(0.38, 0.39, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.89, 0.11);
	   }
	   else
	   {
	      rmSetPlacementSection(0.39, 0.61);
	   }
	   rmPlacePlayersCircular(0.38, 0.39, 0.0);
	}
   }
   else
   {
      if (axisChance == 1)
	{
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.13, 0.37);
	   }
	   else
	   {
	      rmSetPlacementSection(0.63, 0.87);
	   }
	   rmPlacePlayersCircular(0.39, 0.4, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.13, 0.37);
	   }
	   else
	   {
	      rmSetPlacementSection(0.63, 0.87);
	   }
	   rmPlacePlayersCircular(0.39, 0.4, 0.0);
	}
	else if (axisChance == 2)
	{
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.88, 0.12);
	   }
	   else
	   {
	      rmSetPlacementSection(0.38, 0.62);
	   }
	   rmPlacePlayersCircular(0.39, 0.4, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.88, 0.12);
	   }
	   else
	   {
	      rmSetPlacementSection(0.38, 0.62);
	   }
	   rmPlacePlayersCircular(0.39, 0.4, 0.0);
	}
   }
}
else if (cNumberTeams > 2)
   rmPlacePlayersSquare(0.38, 0.0, 0.0);

// Coast patches
if (coastPatch == 1)
{
   // First coast patch area
   int coastPatch1ID=rmCreateArea("coast patch 1");
   rmAddAreaToClass(coastPatch1ID, rmClassID("classPatch"));
   rmSetAreaSize(coastPatch1ID, 0.09, 0.09);
   if (axisChance == 2)
   {
      rmSetAreaLocation(coastPatch1ID, 0.5, 0.93);
      rmAddAreaInfluenceSegment(coastPatch1ID, 0.0, 0.91, 1.0, 0.91);
   }
   else if (axisChance == 1)
   {
      rmSetAreaLocation(coastPatch1ID, 0.93, 0.5);
      rmAddAreaInfluenceSegment(coastPatch1ID, 0.91, 0.0, 0.91, 1.0);
   }
   if (patternChance == 17) // Pampas
   {
      rmSetAreaTerrainType(coastPatch1ID, "pampas\ground4_pam");
      rmAddAreaTerrainLayer(coastPatch1ID, "pampas\ground5_pam", 0, 3);
      rmAddAreaTerrainLayer(coastPatch1ID, "pampas\ground6_pam", 3, 6);
   }
   if (patternChance == 12) // Texas desert
   {
      rmSetAreaTerrainType(coastPatch1ID, "texas\ground6_tex");
      rmAddAreaTerrainLayer(coastPatch1ID, "texas\ground3_tex", 0, 6);
      rmAddAreaTerrainLayer(coastPatch1ID, "texas\ground2_tex", 6, 12);
   }
   if (patternChance == 28) // palm desert
   {
      rmSetAreaTerrainType(coastPatch1ID, "texas\ground6_tex");
      rmAddAreaTerrainLayer(coastPatch1ID, "texas\ground3_tex", 0, 6);
      rmAddAreaTerrainLayer(coastPatch1ID, "texas\ground2_tex", 6, 12);
   }
   rmSetAreaBaseHeight(coastPatch1ID, baseHt); 
   rmSetAreaMinBlobs(coastPatch1ID, 8);
   rmSetAreaMaxBlobs(coastPatch1ID, 10);
   rmSetAreaMinBlobDistance(coastPatch1ID, 10);
   rmSetAreaMaxBlobDistance(coastPatch1ID, 30);
   rmSetAreaSmoothDistance(coastPatch1ID, 25);
   rmSetAreaCoherence(coastPatch1ID, 0.8);
   rmBuildArea(coastPatch1ID);

   // Second coast patch area
   int coastPatch2ID=rmCreateArea("coast patch 2");
   rmAddAreaToClass(coastPatch2ID, rmClassID("classPatch"));
   rmSetAreaSize(coastPatch2ID, 0.09, 0.09);
   if (axisChance == 2)
   {
      rmSetAreaLocation(coastPatch2ID, 0.5, 0.07);
      rmAddAreaInfluenceSegment(coastPatch2ID, 0.0, 0.09, 1.0, 0.09);
   }
   else if (axisChance == 1)
   {
      rmSetAreaLocation(coastPatch2ID, 0.07, 0.5);
      rmAddAreaInfluenceSegment(coastPatch2ID, 0.09, 0.0, 0.09, 1.0);
   }
   if (patternChance == 17) // Pampas
   {
      rmSetAreaTerrainType(coastPatch2ID, "pampas\ground4_pam");
      rmAddAreaTerrainLayer(coastPatch2ID, "pampas\ground5_pam", 0, 3);
      rmAddAreaTerrainLayer(coastPatch2ID, "pampas\ground6_pam", 3, 6);
   }
   if (patternChance == 12) // Texas desert
   {
      rmSetAreaTerrainType(coastPatch2ID, "texas\ground6_tex");
      rmAddAreaTerrainLayer(coastPatch2ID, "texas\ground3_tex", 0, 6);
      rmAddAreaTerrainLayer(coastPatch2ID, "texas\ground2_tex", 6, 12);
   }
   if (patternChance == 28) // palm desert
   {
      rmSetAreaTerrainType(coastPatch2ID, "texas\ground6_tex");
      rmAddAreaTerrainLayer(coastPatch2ID, "texas\ground3_tex", 0, 6);
      rmAddAreaTerrainLayer(coastPatch2ID, "texas\ground2_tex", 6, 12);
   }
   rmSetAreaBaseHeight(coastPatch2ID, baseHt); 
   rmSetAreaMinBlobs(coastPatch2ID, 8);
   rmSetAreaMaxBlobs(coastPatch2ID, 10);
   rmSetAreaMinBlobDistance(coastPatch2ID, 10);
   rmSetAreaMaxBlobDistance(coastPatch2ID, 30);
   rmSetAreaSmoothDistance(coastPatch2ID, 25);
   rmSetAreaCoherence(coastPatch2ID, 0.8);
   rmBuildArea(coastPatch2ID);
}

   // Text
   rmSetStatusText("",0.20);

// First water area
   int sea1ID=rmCreateArea("first sea");
   rmAddAreaToClass(sea1ID, rmClassID("classSea"));
   rmSetAreaSize(sea1ID, 0.077, 0.077);
   if (axisChance == 2)
   {
      rmSetAreaLocation(sea1ID, 0.5, 0.97);
      rmAddAreaInfluenceSegment(sea1ID, 0.0, 0.95, 1.0, 0.95);
   }
   else if (axisChance == 1)
   {
      rmSetAreaLocation(sea1ID, 0.97, 0.5);
      rmAddAreaInfluenceSegment(sea1ID, 0.95, 0.0, 0.95, 1.0);
   }
   rmSetAreaWaterType(sea1ID, oceanType);
   rmSetAreaBaseHeight(sea1ID, 0.0); 
   rmSetAreaMinBlobs(sea1ID, 8);
   rmSetAreaMaxBlobs(sea1ID, 10);
   rmSetAreaMinBlobDistance(sea1ID, 10);
   rmSetAreaMaxBlobDistance(sea1ID, 30);
   rmSetAreaSmoothDistance(sea1ID, 20);
   rmSetAreaCoherence(sea1ID, 0.8);
   rmSetAreaEdgeFilling(sea1ID, 2);
   rmAddAreaConstraint(sea1ID, playerConstraint); 
   rmSetAreaObeyWorldCircleConstraint(sea1ID, false);
   rmBuildArea(sea1ID);

// Second water area
   int sea2ID=rmCreateArea("second sea");
   rmAddAreaToClass(sea2ID, rmClassID("classSea"));
   rmSetAreaSize(sea2ID, 0.077, 0.077);
   if (axisChance == 2)
   {
      rmSetAreaLocation(sea2ID, 0.5, 0.03);
      rmAddAreaInfluenceSegment(sea2ID, 0.0, 0.05, 1.0, 0.05);
   }
   else if (axisChance == 1)
   {
      rmSetAreaLocation(sea2ID, 0.03, 0.5);
      rmAddAreaInfluenceSegment(sea2ID, 0.05, 0.0, 0.05, 1.0);
   }
   rmSetAreaWaterType(sea2ID, oceanType);
   rmSetAreaBaseHeight(sea2ID, 0.0); 
   rmSetAreaMinBlobs(sea2ID, 8);
   rmSetAreaMaxBlobs(sea2ID, 10);
   rmSetAreaMinBlobDistance(sea2ID, 10);
   rmSetAreaMaxBlobDistance(sea2ID, 30);
   rmSetAreaSmoothDistance(sea2ID, 20);
   rmSetAreaCoherence(sea2ID, 0.8);
   rmSetAreaEdgeFilling(sea2ID, 2);
   rmAddAreaConstraint(sea2ID, playerConstraint); 
   rmSetAreaObeyWorldCircleConstraint(sea2ID, false);
   rmBuildArea(sea2ID);
	
// Set up player areas.
   float playerFraction=rmAreaTilesToFraction(120);
   for(i=1; <cNumberPlayers)
   {
      int id=rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, longAvoidImpassableLand);
      rmAddAreaConstraint(id, playerEdgeConstraint); 
      rmAddAreaConstraint(id, avoidWater20); 
      rmSetAreaLocPlayer(id, i);
      rmSetAreaMix(id, baseType);
      rmSetAreaWarnFailure(id, false);
   }
   rmBuildAllAreas();

   // Text
   rmSetStatusText("",0.25);

// River
   if (makeRiver == 1)  
   {
      int riverWidthChance = rmRandInt(1,3);
      int rivermin = -1;
      int rivermax = -1;
      int shallowPattern = rmRandInt(1,6);

      if (riverWidthChance == 1)
      {
	   rivermin = 8;
	   rivermax = 10;
      }
      else if (riverWidthChance == 2)
      {
         rivermin = 9;
	   rivermax = 11;
      }
      else
      {
         rivermin = 11;
	   rivermax = 14;
      }

	int singleRiver = rmRiverCreate(-1, riverType, 30, 10, rivermin, rivermax); 
	if (axisChance == 1)
	   rmRiverSetConnections(singleRiver, 0.5, 0.0, 0.5, 1.0);
	else
	   rmRiverSetConnections(singleRiver, 0.0, 0.5, 1.0, 0.5);

	if (shallowPattern == 6) // single larger centered 
	{
	   rmRiverSetShallowRadius(singleRiver, rmRandInt(15, 21));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.18, 0.22));
	}
	else
	{
	 if (shallowPattern < 3) // .4 and .6 crossings for 1 and 2
	 {	
	   rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.11, 0.12)); 

	   rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.29, 0.29));
	 }
	 if (shallowPattern < 4) // end crossings, for 2-3
	 {
	   if (shallowPattern >1)
	   {	
	      rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(singleRiver, rmRandFloat(0.03, 0.04)); 

	      rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(singleRiver, rmRandFloat(0.37, 0.38));
	   }
	 }
	 if (shallowPattern > 3) // end crossings for 4, 5
	 {	
	   rmRiverSetShallowRadius(singleRiver, rmRandInt(8, 13));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.05, 0.06)); 

	   rmRiverSetShallowRadius(singleRiver, rmRandInt(8, 13));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.34, 0.35));
	 }
	 if (shallowPattern > 2) // center for patterns 3, 4
	 {
	   if (shallowPattern < 5)
	   {	
	      rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(singleRiver, rmRandFloat(0.18, 0.22));
	   }
	 }
	}
	rmRiverSetBankNoiseParams(singleRiver, 0.07, 2, 1.5, 10.0, 0.667, 3.0); 
	rmRiverBuild(singleRiver);
   }

   // Text
   rmSetStatusText("",0.30);

// Central barrier range
   if (makeBarrierRange == 1)
   {
	barrierPattern = rmRandInt(1,5);
      hillTrees = 0;
   } 

if ((barrierPattern == 1) || (barrierPattern == 2))  // Center 1 part barrier range, 2/5 chance
{
   int barrierCID=rmCreateArea("barrier center single"); 
   rmSetAreaWarnFailure(barrierCID, false);
   rmSetAreaCliffType(barrierCID, cliffType);
   rmAddAreaToClass(barrierCID, rmClassID("classCliff"));
   rmAddAreaConstraint(barrierCID, playerEdgeConstraint);
   if (cNumberNonGaiaPlayers > 6) 
      rmSetAreaSize(barrierCID, 0.08, 0.085);
   else if (cNumberNonGaiaPlayers > 3) 
      rmSetAreaSize(barrierCID, 0.087, 0.095);
   else
      rmSetAreaSize(barrierCID, 0.105, 0.11);
   rmSetAreaLocation(barrierCID, 0.5, 0.5);
   if (axisChance == 1) 
      rmAddAreaInfluenceSegment(barrierCID, 0.5, 0.08, 0.5, 0.92); 
   else
      rmAddAreaInfluenceSegment(barrierCID, 0.08, 0.5, 0.92, 0.5); 
   if (rmRandInt(1,2) == 1)
      rmSetAreaCliffEdge(barrierCID, 4, 0.235, 0.05, 0.6, 0);
   else
      rmSetAreaCliffEdge(barrierCID, 5, 0.19, 0.05, 0.6, 0);
   rmSetAreaMinBlobs(barrierCID, 5);
   rmSetAreaMaxBlobs(barrierCID, 7);
   rmSetAreaMinBlobDistance(barrierCID, 20.0);
   rmSetAreaMaxBlobDistance(barrierCID, 30.0);
   rmSetAreaCliffPainting(barrierCID, false, true, true, 1.5, true); 
   if ((patternChance == 3) || (patternChance == 14)) 
      rmSetAreaCliffHeight(barrierCID, rmRandInt(4,6), 1.0, 1.0);
   else
      rmSetAreaCliffHeight(barrierCID, rmRandInt(8,9), 1.0, 1.0);
   rmSetAreaCoherence(barrierCID, 0.8);
   rmSetAreaSmoothDistance(barrierCID, 5);
   rmSetAreaHeightBlend(barrierCID, 2);
   rmBuildArea(barrierCID);
}
else if (barrierPattern > 2)   // Center 2 part barrier range, 3/5 chance
{
   int barrier1ID=rmCreateArea("barrier 1"); // south mt
   rmSetAreaWarnFailure(barrier1ID, false); 
   rmSetAreaCliffType(barrier1ID, cliffType);
   rmAddAreaToClass(barrier1ID, rmClassID("classCliff"));
   rmAddAreaConstraint(barrier1ID, avoidCliff20);
   rmAddAreaConstraint(barrier1ID, playerEdgeConstraint);
   if (gapPattern == 1)
   {
      if (cNumberNonGaiaPlayers > 6) 
         rmSetAreaSize(barrier1ID, 0.031, 0.033);
	else  if (cNumberNonGaiaPlayers < 4)
         rmSetAreaSize(barrier1ID, 0.043, 0.045);
      else
         rmSetAreaSize(barrier1ID, 0.036, 0.038);
      if (axisChance == 1)
      { 
         rmSetAreaLocation(barrier1ID, 0.5, 0.25);
         rmAddAreaInfluenceSegment(barrier1ID, 0.5, 0.09, 0.5, 0.51);
	}
	else
	{
         rmSetAreaLocation(barrier1ID, 0.25, 0.5);
         rmAddAreaInfluenceSegment(barrier1ID, 0.09, 0.5, 0.51, 0.5);
	}
      rmSetAreaCliffEdge(barrier1ID, 3, 0.325, 0.05, 1.0, 0); 
   }
   else if (gapPattern == 2)
   {
	endPosition = rmRandInt(2,3);
      if (cNumberNonGaiaPlayers < 4)
         rmSetAreaSize(barrier1ID, 0.026, 0.027);
	else
         rmSetAreaSize(barrier1ID, 0.021, 0.023);
      if (axisChance == 1)
      {
         rmSetAreaLocation(barrier1ID, 0.5, 0.16);
         rmAddAreaInfluenceSegment(barrier1ID, 0.5, 0.09, 0.5, 0.26);
	}
	else
	{
         rmSetAreaLocation(barrier1ID, 0.16, 0.5);
         rmAddAreaInfluenceSegment(barrier1ID, 0.09, 0.5, 0.26, 0.5);
	}
      rmSetAreaCliffEdge(barrier1ID, 2, 0.47, 0.05, 1.0, 1); 
   }
   else if (gapPattern == 3)
   {
	endPosition = rmRandInt(2,3);
      if (cNumberNonGaiaPlayers < 4)
         rmSetAreaSize(barrier1ID, 0.081, 0.083);
      else if (cNumberNonGaiaPlayers > 6) 
         rmSetAreaSize(barrier1ID, 0.067, 0.069); 
	else
         rmSetAreaSize(barrier1ID, 0.073, 0.075);
      if (axisChance == 1)
      {
         rmSetAreaLocation(barrier1ID, 0.5, 0.25);
         rmAddAreaInfluenceSegment(barrier1ID, 0.5, 0.09, 0.5, 0.71);
	}
	else
	{
         rmSetAreaLocation(barrier1ID, 0.25, 0.5);
         rmAddAreaInfluenceSegment(barrier1ID, 0.09, 0.5, 0.71, 0.5);
	}
	if (rmRandInt(1,2) == 1)
         rmSetAreaCliffEdge(barrier1ID, 4, 0.235, 0.05, 1.0, 0);
	else
         rmSetAreaCliffEdge(barrier1ID, 3, 0.325, 0.05, 1.0, 0); 
   }
   rmSetAreaMinBlobs(barrier1ID, 3);
   rmSetAreaMaxBlobs(barrier1ID, 5);
   rmSetAreaMinBlobDistance(barrier1ID, 10.0);
   rmSetAreaMaxBlobDistance(barrier1ID, 14.0);
   rmSetAreaCliffPainting(barrier1ID, false, true, true, 1.5, true);
   if ((patternChance == 3) || (patternChance == 14)) 
      rmSetAreaCliffHeight(barrier1ID, rmRandInt(4,6), 1.0, 1.0);
   else
      rmSetAreaCliffHeight(barrier1ID, rmRandInt(8,9), 1.0, 1.0);
   rmSetAreaCoherence(barrier1ID, 0.9);
   rmSetAreaSmoothDistance(barrier1ID, 5);
   rmSetAreaHeightBlend(barrier1ID, 2);

   int barrier2ID=rmCreateArea("barrier 2"); // north mt
   rmSetAreaWarnFailure(barrier2ID, false); 
   rmSetAreaCliffType(barrier2ID, cliffType);
   rmAddAreaToClass(barrier2ID, rmClassID("classCliff"));
   rmAddAreaConstraint(barrier2ID, avoidCliff20);
   rmAddAreaConstraint(barrier2ID, avoidTradeRouteCliff);
   rmAddAreaConstraint(barrier2ID, playerEdgeConstraint);
   if (gapPattern == 1)
   {
      if (cNumberNonGaiaPlayers > 6) 
         rmSetAreaSize(barrier2ID, 0.031, 0.033);
	else if (cNumberNonGaiaPlayers < 4)
         rmSetAreaSize(barrier2ID, 0.043, 0.045);
      else
         rmSetAreaSize(barrier2ID, 0.036, 0.038);
      if (axisChance == 1)
      {
         rmSetAreaLocation(barrier2ID, 0.5, 0.75);
         rmAddAreaInfluenceSegment(barrier2ID, 0.5, 0.91, 0.5, 0.49);
	}
	else
	{
         rmSetAreaLocation(barrier2ID, 0.75, 0.5);
         rmAddAreaInfluenceSegment(barrier2ID, 0.91, 0.5, 0.49, 0.5);
	}
      rmSetAreaCliffEdge(barrier2ID, 3, 0.325, 0.05, 0.6, 0); 
   }
   else if (gapPattern == 2)
   {
      if (cNumberNonGaiaPlayers < 4)
         rmSetAreaSize(barrier2ID, 0.081, 0.083);
      else if (cNumberNonGaiaPlayers > 6) 
         rmSetAreaSize(barrier2ID, 0.067, 0.069); 
	else
         rmSetAreaSize(barrier2ID, 0.073, 0.075);
      if (axisChance == 1)
      {
         rmSetAreaLocation(barrier2ID, 0.5, 0.75);
         rmAddAreaInfluenceSegment(barrier2ID, 0.5, 0.91, 0.5, 0.29);
	}
	else
	{
         rmSetAreaLocation(barrier2ID, 0.55, 0.5);
         rmAddAreaInfluenceSegment(barrier2ID, 0.91, 0.5, 0.29, 0.5);
	}
	if (rmRandInt(1,2) == 1)
         rmSetAreaCliffEdge(barrier2ID, 4, 0.235, 0.05, 1.0, 0);
	else
         rmSetAreaCliffEdge(barrier2ID, 3, 0.325, 0.05, 0.6, 0); 
   }
   else if (gapPattern == 3)
   {
      if (cNumberNonGaiaPlayers < 4)
         rmSetAreaSize(barrier2ID, 0.026, 0.027);
	else
         rmSetAreaSize(barrier2ID, 0.021, 0.023);
      if (axisChance == 1)
      {
         rmSetAreaLocation(barrier2ID, 0.5, 0.84);
         rmAddAreaInfluenceSegment(barrier2ID, 0.5, 0.91, 0.5, 0.72);
	}
	else
	{
         rmSetAreaLocation(barrier2ID, 0.84, 0.5);
         rmAddAreaInfluenceSegment(barrier2ID, 0.91, 0.5, 0.72, 0.5);
	}
      rmSetAreaCliffEdge(barrier2ID, 2, 0.47, 0.05, 1.0, 1); 
   }
   rmSetAreaMinBlobs(barrier2ID, 4);
   rmSetAreaMaxBlobs(barrier2ID, 8);
   rmSetAreaMinBlobDistance(barrier2ID, 10.0);
   rmSetAreaMaxBlobDistance(barrier2ID, 14.0);
   rmSetAreaCliffPainting(barrier2ID, false, true, true, 1.5, true);
   if ((patternChance == 3) || (patternChance == 14)) 
      rmSetAreaCliffHeight(barrier2ID, rmRandInt(4,6), 1.0, 1.0);
   else
      rmSetAreaCliffHeight(barrier2ID, rmRandInt(8,9), 1.0, 1.0);
   rmSetAreaCoherence(barrier2ID, 0.9);
   rmSetAreaSmoothDistance(barrier2ID, 5);
   rmSetAreaHeightBlend(barrier2ID, 2);

   if (gapPattern == 3)
   {
      rmBuildArea(barrier2ID);
      rmBuildArea(barrier1ID);
   }
   else if (gapPattern == 2)
   {
      rmBuildArea(barrier1ID);
      rmBuildArea(barrier2ID);
   }
   else if (gapPattern == 1)
   {
      if (rmRandInt(1,2) == 1)
      {
         rmBuildArea(barrier2ID);
         rmBuildArea(barrier1ID);
      }
      else 
      {
         rmBuildArea(barrier1ID);
         rmBuildArea(barrier2ID);
      }
   }
}

// Alpine Peaks
if (makeMtRange == 1)
{
   // Define ridge size
   int radius = size * 0.5;
   int baseRidgeSize = radius * radius * 0.15;
   int midRidgeSize = radius * radius * 0.1;
   int innerRidgeSize = radius * radius * 0.04;
   int midRidgeSize2 = midRidgeSize * 0.65;
   int innerRidgeSize2 = innerRidgeSize * 0.65;
   mtRangePattern = rmRandInt(1,5);

   // snow base
   int mountainCsnowID = rmCreateArea("mountain center single snow"); 
   rmSetAreaLocation(mountainCsnowID, 0.5, 0.5); 
   if (axisChance == 1) 
      rmAddAreaInfluenceSegment(mountainCsnowID, 0.5, 0.0, 0.5, 1.0); 
   else
      rmAddAreaInfluenceSegment(mountainCsnowID, 0.0, 0.5, 1.0, 0.5); 
   rmSetAreaWarnFailure(mountainCsnowID, false);
   rmSetAreaSize(mountainCsnowID, rmAreaTilesToFraction(baseRidgeSize), rmAreaTilesToFraction(baseRidgeSize));
   rmSetAreaBaseHeight(mountainCsnowID, 5.0);
   rmSetAreaElevationType(mountainCsnowID, cElevTurbulence);
   rmSetAreaElevationVariation(mountainCsnowID, rmRandInt(2,3));
   rmSetAreaHeightBlend(mountainCsnowID, 1);
   rmSetAreaCoherence(mountainCsnowID, rmRandFloat(0.7,0.8));
   rmSetAreaSmoothDistance(mountainCsnowID, rmRandInt(8,12));
   if (patternChance == 20)  // Yukon Tundra
   {
      rmSetAreaTerrainType(mountainCsnowID, "yukon\ground1_yuk");
      rmAddAreaTerrainLayer(mountainCsnowID, "yukon\ground5_yuk", 0, 3);
      rmAddAreaTerrainLayer(mountainCsnowID, "yukon\ground4_yuk", 3, 6);
      rmAddAreaTerrainLayer(mountainCsnowID, "yukon\ground8_yuk", 6, 9);
   }
   if (patternChance == 19) // Andes
   {
      rmSetAreaTerrainType(mountainCsnowID, "rockies\groundsnow1_roc");
      rmAddAreaTerrainLayer(mountainCsnowID, "patagonia\ground_snow1_pat", 0, 4);
      rmAddAreaTerrainLayer(mountainCsnowID, "patagonia\ground_snow2_pat", 4, 7);
      rmAddAreaTerrainLayer(mountainCsnowID, "patagonia\ground_snow2_pat", 7, 10);
   }
   if (patternChance == 8) // Rockies
   {
      rmSetAreaTerrainType(mountainCsnowID, "rockies\groundsnow1_roc");
      rmAddAreaTerrainLayer(mountainCsnowID, "rockies\groundsnow8_roc", 0, 3);
      rmAddAreaTerrainLayer(mountainCsnowID, "rockies\groundsnow7_roc", 3, 6);
      rmAddAreaTerrainLayer(mountainCsnowID, "rockies\groundsnow6_roc", 6, 9);
   }
   if (patternChance == 26) // S. Araucania
   {
      rmSetAreaTerrainType(mountainCsnowID, "rockies\groundsnow1_roc");
      rmAddAreaTerrainLayer(mountainCsnowID, "patagonia\ground_snow1_pat", 0, 4);
      rmAddAreaTerrainLayer(mountainCsnowID, "patagonia\ground_snow2_pat", 4, 7);
      rmAddAreaTerrainLayer(mountainCsnowID, "patagonia\ground_snow2_pat", 7, 10);
   }
   rmBuildArea(mountainCsnowID);
} 

if ((mtRangePattern == 1) || (mtRangePattern == 2))  // Center 1 part barrier range, 2/5 chance
{ 
   // tree area 
   int mountainCTreeID = rmCreateArea("mountain center single trees");
   rmSetAreaSize(mountainCTreeID, rmAreaTilesToFraction(midRidgeSize), rmAreaTilesToFraction(midRidgeSize));
   rmSetAreaLocation(mountainCTreeID, 0.5, 0.5);
   if (axisChance == 1) 
      rmAddAreaInfluenceSegment(mountainCTreeID, 0.5, 0.085, 0.5, 0.915); 
   else
      rmAddAreaInfluenceSegment(mountainCTreeID, 0.085, 0.5, 0.915, 0.5); 
   rmSetAreaCoherence(mountainCTreeID, 0.8); 
   rmSetAreaBaseHeight(mountainCTreeID, 8);
   rmSetAreaElevationType(mountainCTreeID, cElevTurbulence);
   rmSetAreaElevationVariation(mountainCTreeID, 3.0);
   rmSetAreaHeightBlend(mountainCTreeID, 1.5);
   rmSetAreaWarnFailure(mountainCTreeID, false);
   rmSetAreaTerrainType(mountainCTreeID, "great_lakes\groundforestsnow_gl");
   rmBuildArea(mountainCTreeID);

   // peaks
   int mountainCPeaksID = rmCreateArea("mountain center single peaks");
   rmSetAreaSize(mountainCPeaksID, rmAreaTilesToFraction(innerRidgeSize), rmAreaTilesToFraction(innerRidgeSize));
   rmAddAreaToClass(mountainCPeaksID, rmClassID("classMountain"));
   rmSetAreaLocation(mountainCPeaksID, 0.5, 0.5);
   if (axisChance == 1) 
      rmAddAreaInfluenceSegment(mountainCPeaksID, 0.5, 0.09, 0.5, 0.91); 
   else
      rmAddAreaInfluenceSegment(mountainCPeaksID, 0.09, 0.5, 0.91, 0.5); 
   rmSetAreaCoherence(mountainCPeaksID, 0.8); 
   rmSetAreaBaseHeight(mountainCPeaksID, 15);
   rmSetAreaElevationType(mountainCPeaksID, cElevTurbulence);
   rmSetAreaElevationVariation(mountainCPeaksID, 14.0);
   rmSetAreaHeightBlend(mountainCPeaksID, 1);
   rmSetAreaWarnFailure(mountainCPeaksID, false);
   rmSetAreaTerrainType(mountainCPeaksID, "patagonia\ground_glacier_pat");
   rmBuildArea(mountainCPeaksID);
}
else if (mtRangePattern > 2)  // two part barrier
{ 
   // tree area S mt
   int mountainSTreeID = rmCreateArea("mountain S trees");
   rmSetAreaSize(mountainSTreeID, rmAreaTilesToFraction(midRidgeSize2), rmAreaTilesToFraction(midRidgeSize2));
   if (axisChance == 1)
   { 
      rmSetAreaLocation(mountainSTreeID, 0.5, 0.25);
      rmAddAreaInfluenceSegment(mountainSTreeID, 0.5, 0.08, 0.5, 0.485);
   }
   else
   {
      rmSetAreaLocation(mountainSTreeID, 0.25, 0.5);
      rmAddAreaInfluenceSegment(mountainSTreeID, 0.08, 0.5, 0.485, 0.5);
   }
   rmSetAreaCoherence(mountainSTreeID, 0.8); 
   rmSetAreaBaseHeight(mountainSTreeID, 8);
   rmSetAreaElevationType(mountainSTreeID, cElevTurbulence);
   rmSetAreaElevationVariation(mountainSTreeID, 3.0);
   rmSetAreaHeightBlend(mountainSTreeID, 1.5);
   rmSetAreaWarnFailure(mountainSTreeID, false);
   rmSetAreaTerrainType(mountainSTreeID, "great_lakes\groundforestsnow_gl");
   rmBuildArea(mountainSTreeID);

   // peaks S mt
   int mountainSPeaksID = rmCreateArea("mountain S peaks");
   rmSetAreaSize(mountainSPeaksID, rmAreaTilesToFraction(innerRidgeSize2), rmAreaTilesToFraction(innerRidgeSize2));
   rmAddAreaToClass(mountainSPeaksID, rmClassID("classMountain"));
   if (axisChance == 1)
   { 
      rmSetAreaLocation(mountainSPeaksID, 0.5, 0.25);
      rmAddAreaInfluenceSegment(mountainSPeaksID, 0.5, 0.095, 0.5, 0.465);
   }
   else
   {
      rmSetAreaLocation(mountainSPeaksID, 0.25, 0.5);
      rmAddAreaInfluenceSegment(mountainSPeaksID, 0.095, 0.5, 0.465, 0.5);
   }
   rmSetAreaCoherence(mountainSPeaksID, 0.8); 
   rmSetAreaBaseHeight(mountainSPeaksID, 15);
   rmSetAreaElevationType(mountainSPeaksID, cElevTurbulence);
   rmSetAreaElevationVariation(mountainSPeaksID, 14.0);
   rmSetAreaHeightBlend(mountainSPeaksID, 1);
   rmSetAreaWarnFailure(mountainSPeaksID, false);
   rmSetAreaTerrainType(mountainSPeaksID, "patagonia\ground_glacier_pat");
   rmBuildArea(mountainSPeaksID);

   // tree area N mt
   int mountainNTreeID = rmCreateArea("mountain N trees");
   rmSetAreaSize(mountainNTreeID, rmAreaTilesToFraction(midRidgeSize2), rmAreaTilesToFraction(midRidgeSize2));
   if (axisChance == 1)
   {
      rmSetAreaLocation(mountainNTreeID, 0.5, 0.75); 
      rmAddAreaInfluenceSegment(mountainNTreeID, 0.5, 0.92, 0.5, 0.515); 
   }
   else
   {
      rmSetAreaLocation(mountainNTreeID, 0.75, 0.5);    
      rmAddAreaInfluenceSegment(mountainNTreeID, 0.92, 0.5, 0.515, 0.5);  
   }
   rmSetAreaCoherence(mountainNTreeID, 0.8); 
   rmSetAreaBaseHeight(mountainNTreeID, 8);
   rmSetAreaElevationType(mountainNTreeID, cElevTurbulence);
   rmSetAreaElevationVariation(mountainNTreeID, 3.0);
   rmSetAreaHeightBlend(mountainNTreeID, 1.5);
   rmSetAreaWarnFailure(mountainNTreeID, false);
   rmSetAreaTerrainType(mountainNTreeID, "great_lakes\groundforestsnow_gl");
   rmBuildArea(mountainNTreeID);

   // peaks N mt
   int mountainNPeaksID = rmCreateArea("mountain N peaks");
   rmSetAreaSize(mountainNPeaksID, rmAreaTilesToFraction(innerRidgeSize2), rmAreaTilesToFraction(innerRidgeSize2));
   rmAddAreaToClass(mountainNPeaksID, rmClassID("classMountain"));
   rmAddAreaConstraint(mountainNPeaksID, avoidMts);
   if (axisChance == 1) 
   {
      rmSetAreaLocation(mountainNPeaksID, 0.5, 0.75);      
      rmAddAreaInfluenceSegment(mountainNPeaksID, 0.5, 0.905, 0.5, 0.535); 
   } 
   else
   {
      rmSetAreaLocation(mountainNPeaksID, 0.75, 0.5);
      rmAddAreaInfluenceSegment(mountainNPeaksID, 0.905, 0.5, 0.535, 0.5); 
   }
   rmSetAreaCoherence(mountainNPeaksID, 0.8); 
   rmSetAreaBaseHeight(mountainNPeaksID, 15);
   rmSetAreaElevationType(mountainNPeaksID, cElevTurbulence);
   rmSetAreaElevationVariation(mountainNPeaksID, 14.0);
   rmSetAreaHeightBlend(mountainNPeaksID, 1);
   rmSetAreaWarnFailure(mountainNPeaksID, false);
   rmSetAreaTerrainType(mountainNPeaksID, "patagonia\ground_glacier_pat");
   rmBuildArea(mountainNPeaksID);
}

// Place ridge trees
if (makeMtRange == 1)
{
   int ridgeTree = rmCreateObjectDef("ridge trees");
   int numTrees = size/2;
   if ((patternChance == 20) || (patternChance == 7))  
      rmAddObjectDefItem(ridgeTree , "TreeYukon", 1, 0.0);
   else       
      rmAddObjectDefItem(ridgeTree , "TreeRockiesSnow", 1, 0.0);
   rmPlaceObjectDefInArea(ridgeTree , 0, mountainCsnowID, numTrees);
   if (mtRangePattern < 3)  
   {
      rmPlaceObjectDefInArea(ridgeTree , 0, mountainCTreeID, numTrees);
   }
   if (mtRangePattern > 2)  
   {
      numTrees = size/4;
      rmPlaceObjectDefInArea(ridgeTree , 0, mountainSTreeID, numTrees);
      rmPlaceObjectDefInArea(ridgeTree , 0, mountainNTreeID, numTrees);
   }
}

// Centered valley
   if (makeValley == 1)
   {
	   fourChoice = rmRandInt(1,4);
	   int valleyID=rmCreateArea("valley"+i);
         rmSetAreaWarnFailure(valleyID, false); 
	   rmSetAreaCliffType(valleyID, cliffType);
	   rmAddAreaToClass(valleyID, rmClassID("classCliff"));
	   rmAddAreaToClass(valleyID, rmClassID("classValley"));
	   rmSetAreaSize(valleyID, 0.07, 0.085);
         if (cNumberNonGaiaPlayers > 6) 
      	rmSetAreaSize(valleyID, 0.07, 0.075);
   	   else if (cNumberNonGaiaPlayers > 3) 
            rmSetAreaSize(valleyID, 0.08, 0.085);
         else
            rmSetAreaSize(valleyID, 0.085, 0.09);
	   rmSetAreaLocation(valleyID, 0.5, 0.5);
   	   if (axisChance == 1)
	   {
		if (fourChoice == 1)
		{ 
         	   rmAddAreaInfluenceSegment(valleyID, 0.4, 0.0, 0.6, 1.0); 
         	   rmAddAreaInfluenceSegment(valleyID, 0.6, 0.0, 0.4, 1.0); 
		}
		if (fourChoice == 2)
		{ 
         	   rmAddAreaInfluenceSegment(valleyID, 0.5, 0.0, 0.6, 1.0); 
         	   rmAddAreaInfluenceSegment(valleyID, 0.5, 0.5, 0.4, 1.0); 
		}
		if (fourChoice == 3)
		{ 
         	   rmAddAreaInfluenceSegment(valleyID, 0.4, 0.0, 0.5, 0.5); 
         	   rmAddAreaInfluenceSegment(valleyID, 0.6, 0.0, 0.5, 1.0); 
		}
		else
         	   rmAddAreaInfluenceSegment(valleyID, 0.5, 0.0, 0.5, 1.0); 
	   }
	   else
	   {
		if (fourChoice == 1)
		{ 
         	   rmAddAreaInfluenceSegment(valleyID, 0.0, 0.4, 1.0, 0.6); 
         	   rmAddAreaInfluenceSegment(valleyID, 0.0, 0.6, 1.0, 0.4);
		}
		if (fourChoice == 2)
		{ 
         	   rmAddAreaInfluenceSegment(valleyID, 0.0, 0.4, 0.5, 0.5); 
         	   rmAddAreaInfluenceSegment(valleyID, 0.0, 0.6, 1.0, 0.5);
		}
		if (fourChoice == 3)
		{ 
         	   rmAddAreaInfluenceSegment(valleyID, 0.0, 0.5, 1.0, 0.6); 
         	   rmAddAreaInfluenceSegment(valleyID, 0.5, 0.5, 1.0, 0.4);
		}
		else
         	   rmAddAreaInfluenceSegment(valleyID, 0.0, 0.5, 1.0, 0.5);        	     
	   }

         if (rmRandInt(1,3) == 1)
	      rmSetAreaCliffEdge(valleyID, 6, 0.11, 0.15, 1.0, 0);
	   else
	   {
		if (rmRandInt(1,2) == 1) 
	         rmSetAreaCliffEdge(valleyID, 8, 0.09, 0.1, 1.0, 0);
		else
	         rmSetAreaCliffEdge(valleyID, 7, 0.10, 0.15, 1.0, 0);
	   }
         rmSetAreaCliffPainting(valleyID, false, true, true, 1.5);
	   rmSetAreaMinBlobs(valleyID, 4);
	   rmSetAreaMaxBlobs(valleyID, 6);
	   rmSetAreaMinBlobDistance(valleyID, 16.0);
	   rmSetAreaMaxBlobDistance(valleyID, 20.0);
	   rmSetAreaCoherence(valleyID, rmRandFloat(0.4,0.8));
	   rmSetAreaSmoothDistance(valleyID, rmRandInt(10,20));  
   	   if ((patternChance == 3) || (patternChance == 15)) 
            rmSetAreaCliffHeight(valleyID, rmRandInt(-6,-5), 1.0, 1.0);
	   else
	      rmSetAreaCliffHeight(valleyID, rmRandInt(-7,-6), 1.0, 1.0);
	   rmSetAreaHeightBlend(valleyID, 2);
	   rmAddAreaConstraint(valleyID, cliffsAvoidCliffs);
         rmAddAreaConstraint(valleyID, avoidImportantItem);
	   rmAddAreaConstraint(valleyID, avoidTradeRoute);
         rmAddAreaConstraint(valleyID, avoidNatives);
	   rmAddAreaConstraint(valleyID, avoidWater20);
	   rmAddAreaConstraint(valleyID, avoidSocket);
 	   rmBuildArea(valleyID);
   }

// Center Highland or Canyon
   int makeCentralCliffArea = -1;
   if (makeCentralHighlands == 1)
	makeCentralCliffArea = 1;
   if (makeCentralCanyon == 1)
 	makeCentralCliffArea = 1;
   int highlandSize = rmRandInt(1,3);

   if (makeCentralCliffArea == 1)
   {
      int edgeChance = rmRandInt(1,3);
      reducedForest = 1;
      int centerHighlandsID=rmCreateArea("center highlands");
      rmSetAreaLocation(centerHighlandsID, 0.5, 0.5);
	if (highlandSize == 1)
         rmSetAreaSize(centerHighlandsID, 0.049, 0.05);
	else if (highlandSize == 2)
         rmSetAreaSize(centerHighlandsID, 0.059, 0.06);
	else if (highlandSize == 3)
         rmSetAreaSize(centerHighlandsID, 0.069, 0.07);
	if (clearCenter == 1)
	{
	   if (rmRandInt(0,1) == 1)
            rmAddAreaToClass(centerHighlandsID, rmClassID("center"));
	}
      rmAddAreaToClass(centerHighlandsID, rmClassID("classCliff2"));
      if (patternChance == 12)
	{
         rmSetAreaMix(centerHighlandsID, "texas_dirt");
	   rmSetAreaCliffPainting(centerHighlandsID, true, true, true, 1.5, true);
	}
      else if (patternChance == 8)
	{
	   rmSetAreaTerrainType(centerHighlandsID, "rockies\groundsnow1_roc");
	   rmSetAreaCliffPainting(centerHighlandsID, true, true, true, 1.5, true);
	}
	else
	{ 
         rmSetAreaMix(centerHighlandsID, baseType);
	   rmSetAreaCliffPainting(centerHighlandsID, false, true, true, 1.5, true);
	}
      rmSetAreaCliffType(centerHighlandsID, cliffType);
	if (edgeChance == 1)
         rmSetAreaCliffEdge(centerHighlandsID, 3, 0.29, 0.1, 0.5, 0);
	else if (edgeChance == 2)
         rmSetAreaCliffEdge(centerHighlandsID, 4, 0.21, 0.1, 0.5, 0);
	else if (edgeChance == 3)
         rmSetAreaCliffEdge(centerHighlandsID, 2, 0.45, 0.1, 0.5, 0);

	if (makeCentralHighlands == 1)
	   rmSetAreaCliffHeight(centerHighlandsID, rmRandInt(6,8), 1.0, 0.5);
	else if (makeCentralCanyon == 1)
	   rmSetAreaCliffHeight(centerHighlandsID, -8, 1.0, 0.5);
      rmSetAreaSmoothDistance(centerHighlandsID, 12);
      rmSetAreaCoherence(centerHighlandsID, 0.5);
	rmSetAreaHeightBlend(centerHighlandsID, 1.0);
      rmAddAreaConstraint(centerHighlandsID, avoidTradeRoute);
      rmAddAreaConstraint(centerHighlandsID, avoidSocket);
      rmBuildArea(centerHighlandsID);
      makeLake = 0;
   }

// Trade Routes
variantChance = rmRandInt(1,2);
if (trPattern == 2) // 2 opposite inner semicircular routes
{
   // first route
   int tradeRouteID = rmCreateTradeRoute();
   if (axisChance == 1) 
   {	
	rmAddTradeRouteWaypoint(tradeRouteID, 0.54, 1.0);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.67, 0.65);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.7, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.67, 0.35);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.54, 0.0);
   }
   else 
   {	
	rmAddTradeRouteWaypoint(tradeRouteID, 0.0, 0.54);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.35, 0.67);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.7);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.65, 0.67);
	rmAddTradeRouteWaypoint(tradeRouteID, 1.0, 0.54);
   }
   rmBuildTradeRoute(tradeRouteID, "dirt");

   // second route
   int tradeRouteID2 = rmCreateTradeRoute();
   if (axisChance == 1) 
   {
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.46, 0.0);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.33, 0.35);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.3, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.33, 0.65);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.46, 1.0);
   }
   else
   {
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.0, 0.46);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.35, 0.33);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.5, 0.3);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.65, 0.33);
	rmAddTradeRouteWaypoint(tradeRouteID2, 1.0, 0.46);
   }
   rmBuildTradeRoute(tradeRouteID2, "carolinas\trade_route");	
}
else if (trPattern == 5)  // one single diagonal route
{
   int tradeRouteID5 = rmCreateTradeRoute();
   if (axisChance == 1) 
   {
	if (variantChance == 1)
	{	
   	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.3, 0.0);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.4, 0.4);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.5, 0.5);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.6, 0.6);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.7, 1.0);
	}
	else if (variantChance == 2)
	{	
   	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.3, 1.0);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.4, 0.6);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.5, 0.5);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.6, 0.4);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.7, 0.0);
	}
   }
   else 
   {
	if (variantChance == 1)
	{	
   	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.0, 0.3);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.4, 0.4);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.5, 0.5);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.6, 0.6);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 1.0, 0.7);
	}
	else if (variantChance == 2)
	{	
   	   rmAddTradeRouteWaypoint(tradeRouteID5, 1.0, 0.3);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.6, 0.4);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.5, 0.5);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.4, 0.6);
	   rmAddTradeRouteWaypoint(tradeRouteID5, 0.0, 0.7);
	}
   }
   rmBuildTradeRoute(tradeRouteID5, "dirt");
}
else if (trPattern == 4)  // two side-to-side
{
   int tradeRouteID4 = rmCreateTradeRoute();
   if (axisChance == 1) 
   {
	rmAddTradeRouteWaypoint(tradeRouteID4, 0.67, 1.0);
	rmAddTradeRouteWaypoint(tradeRouteID4, 0.62, 0.78);
	rmAddTradeRouteWaypoint(tradeRouteID4, 0.62, 0.7);
	if (variantChance == 1)
	{
	   rmAddTradeRouteWaypoint(tradeRouteID4, 0.67, 0.55);
	   rmAddTradeRouteWaypoint(tradeRouteID4, 0.67, 0.45);
	}
	else
	{
	   rmAddTradeRouteWaypoint(tradeRouteID4, 0.64, 0.55);
	   rmAddTradeRouteWaypoint(tradeRouteID4, 0.64, 0.45);
	}
	rmAddTradeRouteWaypoint(tradeRouteID4, 0.62, 0.3);
	rmAddTradeRouteWaypoint(tradeRouteID4, 0.62, 0.22);
	rmAddTradeRouteWaypoint(tradeRouteID4, 0.67, 0.0);
   }
   else if (axisChance == 2) 
   {
	rmAddTradeRouteWaypoint(tradeRouteID4, 1.0, 0.67);
	rmAddTradeRouteWaypoint(tradeRouteID4, 0.78, 0.63);
	rmAddTradeRouteWaypoint(tradeRouteID4, 0.7, 0.62);
	if (variantChance == 1)
	{
	   rmAddTradeRouteWaypoint(tradeRouteID4, 0.53, 0.67);
	   rmAddTradeRouteWaypoint(tradeRouteID4, 0.47, 0.67);
	}
	else
	{
	   rmAddTradeRouteWaypoint(tradeRouteID4, 0.55, 0.65);
	   rmAddTradeRouteWaypoint(tradeRouteID4, 0.45, 0.65);
	}
	rmAddTradeRouteWaypoint(tradeRouteID4, 0.3, 0.62);
	rmAddTradeRouteWaypoint(tradeRouteID4, 0.22, 0.63);
	rmAddTradeRouteWaypoint(tradeRouteID4, 0.0, 0.67);
   }
   rmBuildTradeRoute(tradeRouteID4, "carolinas\trade_route");

   int tradeRouteID4A = rmCreateTradeRoute();
   if (axisChance == 1) 
   {
      rmAddTradeRouteWaypoint(tradeRouteID4A, 0.33, 1.0);
	rmAddTradeRouteWaypoint(tradeRouteID4A, 0.38, 0.78);
	rmAddTradeRouteWaypoint(tradeRouteID4A, 0.38, 0.7);
	if (variantChance == 1)
	{
	   rmAddTradeRouteWaypoint(tradeRouteID4A, 0.33, 0.55);
	   rmAddTradeRouteWaypoint(tradeRouteID4A, 0.33, 0.45);
	}
	else
	{
	   rmAddTradeRouteWaypoint(tradeRouteID4A, 0.36, 0.55);
	   rmAddTradeRouteWaypoint(tradeRouteID4A, 0.36, 0.45);
	}
	rmAddTradeRouteWaypoint(tradeRouteID4A, 0.38, 0.3);
	rmAddTradeRouteWaypoint(tradeRouteID4A, 0.38, 0.22);
      rmAddTradeRouteWaypoint(tradeRouteID4A, 0.33, 0.0);
   }
   else if (axisChance == 2) 
   {
	rmAddTradeRouteWaypoint(tradeRouteID4A, 1.0, 0.33);
	rmAddTradeRouteWaypoint(tradeRouteID4A, 0.78, 0.37);
	rmAddTradeRouteWaypoint(tradeRouteID4A, 0.7, 0.38);
	if (variantChance == 1)
	{
	   rmAddTradeRouteWaypoint(tradeRouteID4A, 0.53, 0.33);
	   rmAddTradeRouteWaypoint(tradeRouteID4A, 0.47, 0.33);
	}
	else
	{
	   rmAddTradeRouteWaypoint(tradeRouteID4A, 0.55, 0.35);
	   rmAddTradeRouteWaypoint(tradeRouteID4A, 0.45, 0.35);
	}
	rmAddTradeRouteWaypoint(tradeRouteID4A, 0.3, 0.38);
	rmAddTradeRouteWaypoint(tradeRouteID4A, 0.22, 0.37);
	rmAddTradeRouteWaypoint(tradeRouteID4A, 0.0, 0.33);
   }
   rmBuildTradeRoute(tradeRouteID4A, "dirt");
}
else if (trPattern == 3)  // two opposite parabolas
{
   int tradeRouteID3 = rmCreateTradeRoute();
   if (axisChance == 1) 
   {
	if (variantChance == 1)
	   rmAddTradeRouteWaypoint(tradeRouteID3, 0.75, 1.0);
	else
	   rmAddTradeRouteWaypoint(tradeRouteID3, 0.85, 1.0);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.7, 0.88);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.61, 0.62);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.585, 0.51);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.585, 0.49);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.61, 0.38);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.7, 0.11);
	if (variantChance == 1)
	   rmAddTradeRouteWaypoint(tradeRouteID3, 0.75, 0.0);
	else
	   rmAddTradeRouteWaypoint(tradeRouteID3, 0.85, 0.0);
   }
   else if (axisChance == 2) 
   {
	if (variantChance == 1)
	   rmAddTradeRouteWaypoint(tradeRouteID3, 1.0, 0.75);
	else
	   rmAddTradeRouteWaypoint(tradeRouteID3, 1.0, 0.85);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.88, 0.7);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.62, 0.61);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.51, 0.585);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.49, 0.585);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.38, 0.61);
	rmAddTradeRouteWaypoint(tradeRouteID3, 0.12, 0.7);
	if (variantChance == 1)
	   rmAddTradeRouteWaypoint(tradeRouteID3, 0.0, 0.75);
	else
	   rmAddTradeRouteWaypoint(tradeRouteID3, 0.0, 0.85);
   }
   rmBuildTradeRoute(tradeRouteID3, "carolinas\trade_route");

   int tradeRouteID3A = rmCreateTradeRoute();
   if (axisChance == 1) 
   {
	if (variantChance == 1)
         rmAddTradeRouteWaypoint(tradeRouteID3A, 0.25, 1.0);
	else
         rmAddTradeRouteWaypoint(tradeRouteID3A, 0.15, 1.0);
      rmAddTradeRouteWaypoint(tradeRouteID3A, 0.3, 0.88);
	rmAddTradeRouteWaypoint(tradeRouteID3A, 0.39, 0.62);
      rmAddTradeRouteWaypoint(tradeRouteID3A, 0.415, 0.51);
      rmAddTradeRouteWaypoint(tradeRouteID3A, 0.415, 0.49);
	rmAddTradeRouteWaypoint(tradeRouteID3A, 0.39, 0.38);
      rmAddTradeRouteWaypoint(tradeRouteID3A, 0.3, 0.12);
	if (variantChance == 1)
         rmAddTradeRouteWaypoint(tradeRouteID3A, 0.25, 0.0);
	else
         rmAddTradeRouteWaypoint(tradeRouteID3A, 0.15, 0.0);
   }
   else if (axisChance == 2) 
   {
	if (variantChance == 1)
	   rmAddTradeRouteWaypoint(tradeRouteID3A, 1.0, 0.25);
	else
	   rmAddTradeRouteWaypoint(tradeRouteID3A, 1.0, 0.15);
	rmAddTradeRouteWaypoint(tradeRouteID3A, 0.88, 0.3);
	rmAddTradeRouteWaypoint(tradeRouteID3A, 0.62, 0.39);
	rmAddTradeRouteWaypoint(tradeRouteID3A, 0.51, 0.415);
	rmAddTradeRouteWaypoint(tradeRouteID3A, 0.49, 0.415);
	rmAddTradeRouteWaypoint(tradeRouteID3A, 0.38, 0.39);
	rmAddTradeRouteWaypoint(tradeRouteID3A, 0.12, 0.3);
	if (variantChance == 1)
	   rmAddTradeRouteWaypoint(tradeRouteID3A, 0.0, 0.25);
	else
	   rmAddTradeRouteWaypoint(tradeRouteID3A, 0.0, 0.15);
   }
   rmBuildTradeRoute(tradeRouteID3A, "dirt");
}
else if (trPattern == 6)  // one center
{
   int tradeRouteID6 = rmCreateTradeRoute();
   if (axisChance == 1) 
   {
	rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 0.0);
	rmAddTradeRouteWaypoint(tradeRouteID6, 0.48, 0.2);
	rmAddTradeRouteWaypoint(tradeRouteID6, 0.52, 0.35);
	rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID6, 0.48, 0.55);
	rmAddTradeRouteWaypoint(tradeRouteID6, 0.52, 0.8);
	rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 1.0);
   }
   else
   {
	rmAddTradeRouteWaypoint(tradeRouteID6, 0.0, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID6, 0.2, 0.48);
	rmAddTradeRouteWaypoint(tradeRouteID6, 0.35, 0.52);
	rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID6, 0.65, 0.48);
	rmAddTradeRouteWaypoint(tradeRouteID6, 0.8, 0.52);
	rmAddTradeRouteWaypoint(tradeRouteID6, 1.0, 0.5);
   }
   rmBuildTradeRoute(tradeRouteID6, "carolinas\trade_route");	
}
else if (trPattern == 7) // 2 end-to-end edge routes
{
   // first route
   int tradeRouteID7 = rmCreateTradeRoute();
   if (axisChance == 1) 
   {
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.12, 0.05);
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.25, 0.15);	
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.4, 0.18);	
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.45, 0.15);	
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.5, 0.11);	
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.55, 0.15);	
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.6, 0.18);
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.75, 0.15);	
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.88, 0.05);
   }
   else 
   {
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.05, 0.11);	
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.15, 0.25);
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.18, 0.4);
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.15, 0.45);
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.11, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.15, 0.55);
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.18, 0.6);
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.15, 0.75);
	rmAddTradeRouteWaypoint(tradeRouteID7, 0.05, 0.88);
   }
   rmBuildTradeRoute(tradeRouteID7, "dirt");

   // second route
   int tradeRouteID7A = rmCreateTradeRoute();
   if (axisChance == 1) 
   {
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.12, 0.95);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.25, 0.85);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.4, 0.82);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.45, 0.89);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.5, 0.85);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.55, 0.89);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.6, 0.82);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.75, 0.85);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.88, 0.95);
   }
   else
   {
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.95, 0.12);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.85, 0.25);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.82, 0.4);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.85, 0.45);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.89, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.85, 0.55);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.82, 0.6);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.85, 0.75);
	rmAddTradeRouteWaypoint(tradeRouteID7A, 0.95, 0.88);
   }
   rmBuildTradeRoute(tradeRouteID7A, "carolinas\trade_route");	
}
else if (trPattern == 8)  // 3 side-to-side routes
{
   int tradeRouteID8 = rmCreateTradeRoute(); // center
   if (axisChance == 1) 
   {
	rmAddTradeRouteWaypoint(tradeRouteID8, 0.5, 0.0);
	rmAddTradeRouteWaypoint(tradeRouteID8, 0.485, 0.2);
	rmAddTradeRouteWaypoint(tradeRouteID8, 0.52, 0.3);
	rmAddTradeRouteWaypoint(tradeRouteID8, 0.5, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID8, 0.48, 0.7);
	rmAddTradeRouteWaypoint(tradeRouteID8, 0.515, 0.8);
	rmAddTradeRouteWaypoint(tradeRouteID8, 0.5, 1.0);
   }
   else
   {
	rmAddTradeRouteWaypoint(tradeRouteID8, 0.0, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID8, 0.2, 0.485);
	rmAddTradeRouteWaypoint(tradeRouteID8, 0.3, 0.52);
	rmAddTradeRouteWaypoint(tradeRouteID8, 0.5, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID8, 0.7, 0.48);
	rmAddTradeRouteWaypoint(tradeRouteID8, 0.8, 0.515);
	rmAddTradeRouteWaypoint(tradeRouteID8, 1.0, 0.5);
   }
   rmBuildTradeRoute(tradeRouteID8, "carolinas\trade_route");

   int tradeRouteID8A = rmCreateTradeRoute();
   if (axisChance == 1) 
   {
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.67, 1.0);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.64, 0.8);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.64, 0.75);
      rmAddTradeRouteWaypoint(tradeRouteID8A, 0.65, 0.6);
      rmAddTradeRouteWaypoint(tradeRouteID8A, 0.66, 0.55);
      rmAddTradeRouteWaypoint(tradeRouteID8A, 0.67, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.68, 0.45);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.69, 0.4);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.7, 0.25);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.7, 0.2);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.67, 0.0);
   }
   else if (axisChance == 2) 
   {
	rmAddTradeRouteWaypoint(tradeRouteID8A, 1.0, 0.67);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.8, 0.64);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.75, 0.64);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.6, 0.65);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.55, 0.66);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.5, 0.67);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.45, 0.68);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.4, 0.69);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.25, 0.7);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.2, 0.7);
	rmAddTradeRouteWaypoint(tradeRouteID8A, 0.0, 0.67);
   }
   rmBuildTradeRoute(tradeRouteID8A, "carolinas\trade_route");

   int tradeRouteID8B = rmCreateTradeRoute();
   if (axisChance == 1) 
   {
      rmAddTradeRouteWaypoint(tradeRouteID8B, 0.33, 0.0);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.36, 0.2);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.36, 0.25);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.35, 0.4);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.34, 0.45);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.33, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.32, 0.55);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.31, 0.6);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.3, 0.75);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.3, 0.8);
      rmAddTradeRouteWaypoint(tradeRouteID8B, 0.33, 1.0);
   }
   else if (axisChance == 2) 
   {
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.0, 0.33);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.2, 0.36);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.25, 0.36);
      rmAddTradeRouteWaypoint(tradeRouteID8B, 0.4, 0.35);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.45, 0.34);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.5, 0.33);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.55, 0.32);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.6, 0.31);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.75, 0.3);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 0.8, 0.3);
	rmAddTradeRouteWaypoint(tradeRouteID8B, 1.0, 0.33);
   }
   rmBuildTradeRoute(tradeRouteID8B, "dirt");
}
else if (trPattern == 9) // 2 doglegs - horizontal and vertical legs
{
   int tradeRouteID9 = rmCreateTradeRoute();
   if (axisChance == 2)
   { 
      rmAddTradeRouteWaypoint(tradeRouteID9, 1.0, 0.75); 
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.85, 0.7); 
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.7, 0.68); 
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.5, 0.7);  
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.4, 0.68);
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.3, 0.66); 
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.15, 0.64);
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.18, 0.5); 
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.15, 0.33);
   }
   else
   { 
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.75, 1.0);
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.7, 0.85);
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.68, 0.7);
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.7, 0.5);
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.68, 0.4);
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.66, 0.3);
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.64, 0.15);
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.5, 0.18); 
      rmAddTradeRouteWaypoint(tradeRouteID9, 0.33, 0.15); 
   }
   rmBuildTradeRoute(tradeRouteID9, "carolinas\trade_route");

   // second route
   int tradeRouteID9A = rmCreateTradeRoute();
   if (axisChance == 2)
   { 
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.0, 0.25);
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.15, 0.3); 
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.3, 0.32);   
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.5, 0.3);
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.6, 0.32);
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.7, 0.34);   
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.85, 0.36);  
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.82, 0.5); 
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.85, 0.67);
   }
   else
   {
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.25, 0.0);
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.3, 0.15); 
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.32, 0.3);   
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.3, 0.5);
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.32, 0.6);
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.34, 0.7);   
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.36, 0.85);  
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.5, 0.82); 
      rmAddTradeRouteWaypoint(tradeRouteID9A, 0.67, 0.85);  
   }
   rmBuildTradeRoute(tradeRouteID9A, "dirt");
}
else if (trPattern == 10)  // one ring route
{
   int tradeRouteID10 = rmCreateTradeRoute();
   rmAddTradeRouteWaypoint(tradeRouteID10, 0.24, 0.508);
   rmAddTradeRouteWaypoint(tradeRouteID10, 0.27, 0.75);
   rmAddTradeRouteWaypoint(tradeRouteID10, 0.47, 0.83);
   rmAddTradeRouteWaypoint(tradeRouteID10, 0.53, 0.83);
   rmAddTradeRouteWaypoint(tradeRouteID10, 0.73, 0.75);
   rmAddTradeRouteWaypoint(tradeRouteID10, 0.76, 0.5);
   rmAddTradeRouteWaypoint(tradeRouteID10, 0.73, 0.25);
   rmAddTradeRouteWaypoint(tradeRouteID10, 0.53, 0.17);
   rmAddTradeRouteWaypoint(tradeRouteID10, 0.47, 0.17);
   rmAddTradeRouteWaypoint(tradeRouteID10, 0.27, 0.25);
   rmAddTradeRouteWaypoint(tradeRouteID10, 0.24, 0.492);
   rmBuildTradeRoute(tradeRouteID10, "dirt");
}
else if (trPattern == 1)  // 2 'semicircular' middle routes
{
   int tradeRouteID1 = rmCreateTradeRoute();
   int tradeRouteID1A = rmCreateTradeRoute();
   if (axisChance == 2)
   {
      rmAddTradeRouteWaypoint(tradeRouteID1, 0.0, 0.59);
      rmAddTradeRouteWaypoint(tradeRouteID1, 0.25, 0.74);
      rmAddTradeRouteWaypoint(tradeRouteID1, 0.5, 0.78);
      rmAddTradeRouteWaypoint(tradeRouteID1, 0.75, 0.74);
      rmAddTradeRouteWaypoint(tradeRouteID1, 1.0, 0.59);
      rmBuildTradeRoute(tradeRouteID1, "carolinas\trade_route");	

      rmAddTradeRouteWaypoint(tradeRouteID1A, 1.0, 0.41);
      rmAddTradeRouteWaypoint(tradeRouteID1A, 0.75, 0.26);
      rmAddTradeRouteWaypoint(tradeRouteID1A, 0.5, 0.22);
      rmAddTradeRouteWaypoint(tradeRouteID1A, 0.25, 0.26);
      rmAddTradeRouteWaypoint(tradeRouteID1A, 0.0, 0.41);
      rmBuildTradeRoute(tradeRouteID1A, "dirt");
   }
   else if (axisChance == 1)
   {	
      rmAddTradeRouteWaypoint(tradeRouteID1, 0.59, 1.0);
      rmAddTradeRouteWaypoint(tradeRouteID1, 0.74, 0.75);
      rmAddTradeRouteWaypoint(tradeRouteID1, 0.78, 0.5);
      rmAddTradeRouteWaypoint(tradeRouteID1, 0.74, 0.25);
      rmAddTradeRouteWaypoint(tradeRouteID1, 0.59, 0.0);
      rmBuildTradeRoute(tradeRouteID1, "carolinas\trade_route");	

      rmAddTradeRouteWaypoint(tradeRouteID1A, 0.41, 0.0);
      rmAddTradeRouteWaypoint(tradeRouteID1A, 0.26, 0.25);
      rmAddTradeRouteWaypoint(tradeRouteID1A, 0.22, 0.5);
      rmAddTradeRouteWaypoint(tradeRouteID1A, 0.26, 0.75);
      rmAddTradeRouteWaypoint(tradeRouteID1A, 0.41, 1.0);
      rmBuildTradeRoute(tradeRouteID1A, "dirt");
   }
}

   // Text
   rmSetStatusText("",0.35);

// Trade sockets
   int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
   rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
   rmSetObjectDefAllowOverlap(socketID, true);
   rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
   rmSetObjectDefMinDistance(socketID, 0.0);
   rmSetObjectDefMaxDistance(socketID, 7.0);
   variantChance = rmRandInt(1,2);

if (trPattern == 2) // 2 opposite inner semicircular routes
{
   // add the meeting poles along the trade route.
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
   vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.17);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   if (socketPattern == 1)
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.83);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   // change the trade route for the new sockets
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID2);
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.83);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   if (socketPattern == 1)
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.17);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
}
else if (trPattern == 5) // single diagonal
{
   if (socketPattern == 1)
   {
	if (variantChance == 1) // 6 sockets
	{
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID5);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.09);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.25);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.41);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.59);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.75);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.91);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else // 5 sockets
	{
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID5);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.1);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.28);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.72);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.9);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }
   else if (socketPattern == 2)
   {
	if (variantChance == 1) // 4 sockets
	{	
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID5);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.15);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.35);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.65);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.85);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else // 3 sockets
	{	
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID5);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.18);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID5, 0.82);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }
}
else if (trPattern == 4) //  2 side-to-side
{
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID4);
   if (socketPattern == 1) // 3 sockets per route
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.12);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.88);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   else  // 2 sockets per route
   {
	if (variantChance == 1)
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.23);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.77);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.32);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.68);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }

   // change the trade route for the new sockets
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID4A);
   if (socketPattern == 1)  // 3 sockets per route
   {
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4A, 0.88);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4A, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
  
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4A, 0.12);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   else  // 2 sockets per route
   {
	if (variantChance == 1)
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4A, 0.23);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4A, 0.77);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4A, 0.68);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4A, 0.32);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }
}
else if (trPattern == 3) //  2 parabolas
{
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID3);
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3, 0.17);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   if (socketPattern == 1)
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3, 0.83);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   // change the trade route for the new sockets
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID3A);
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3A, 0.83);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   if (socketPattern == 1)
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3A, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3A, 0.17);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
}
else if (trPattern == 6) // one center route
{
   if (socketPattern == 1)  // 6 sockets 
   {
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID6);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.09);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.25);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.41);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.59);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.75);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.91);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   else if (socketPattern == 2)  // 5 sockets 
   {
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID6);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.12);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.31);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.69);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.88);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
}
else if (trPattern == 7) // 2 side end-to-end routes
{
   // add the meeting poles along the trade route.
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID7);
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.21);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   if (socketPattern == 1) // 3 per route
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   else // 4 per route
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.4);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.6);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.79);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   // change the trade route for the new sockets
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID7A);
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.79);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   if (socketPattern == 1) // 3 per route
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   else // 4 per route
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.4);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.6);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.21);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
}
else if (trPattern == 8) // 3 side to side routes
{ 
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID8); // center route
   if (cNumberNonGaiaPlayers < 4) 
   {
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID8);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8, 0.25);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8, 0.75);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   else
   {
      if (variantChance == 1)  // 3 sockets 
      {
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID8);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8, 0.1);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8, 0.9);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
      else if (variantChance == 2)  // 4 sockets 
      {
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID8);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8, 0.07);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8, 0.33);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8, 0.67);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8, 0.93);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
      }
   }   
   variantChance = rmRandInt(1,2);
   // change the trade route for the new sockets
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID8A);
   if (socketPattern == 1) // 3 sockets per route
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8A, 0.12);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8A, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8A, 0.88);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   else  // 2 sockets per route
   {
	if (variantChance == 1)
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8A, 0.17);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8A, 0.83);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8A, 0.3);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8A, 0.7);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }

   // change the trade route for the new sockets
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID8B);
   if (socketPattern == 1) // 3 sockets per route
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8B, 0.12);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8B, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8B, 0.88);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   else  // 2 sockets per route
   {
	if (variantChance == 1)
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8B, 0.17);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8B, 0.83);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8B, 0.3);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID8B, 0.7);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }
}
else if (trPattern == 9) //  2 outer semicircles
{
   if (socketPattern == 1) // 6 sockets
   { 
      if (variantChance == 1)
	{
          rmSetObjectDefTradeRouteID(socketID, tradeRouteID9);
          socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9, 0.13);
          rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

          socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9, 0.42);
          rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

          socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9, 0.85);
          rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

          // change the trade route for the new sockets
          rmSetObjectDefTradeRouteID(socketID, tradeRouteID9A);
          socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9A, 0.13);
          rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

          socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9A, 0.42);
          rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
 
          socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9A, 0.85);
          rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	 }
	 else
	 {
          rmSetObjectDefTradeRouteID(socketID, tradeRouteID9);
          socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9, 0.22);
          rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

          socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9, 0.5);
          rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

          socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9, 0.78);
          rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

          // change the trade route for the new sockets
          rmSetObjectDefTradeRouteID(socketID, tradeRouteID9A);
          socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9A, 0.22);
          rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

          socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9A, 0.5);
          rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

          socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9A, 0.78);
          rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	 }
   }
   else if (socketPattern == 2) // 8 sockets
   { 
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID9);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9, 0.12);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9, 0.37);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9, 0.62);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9, 0.87);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      // change the trade route for the new sockets
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID9A);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9A, 0.12);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9A, 0.37);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9A, 0.62);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID9A, 0.87);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
}
else if(trPattern == 10) // ring
{
   if (socketPattern == 1) // 6 sockets
   {
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID10);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.005);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.167);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
  
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.333);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.505);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.667);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.833);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   else if (socketPattern == 2)
   {
	if (variantChance == 1) // 8 sockets
	{
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID10);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.063);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.188);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.313);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.438);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.563);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.688);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.813);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.938);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else // 4 sockets
	{
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID10);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.167);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
  
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.333);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.667);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID10, 0.833);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }
}
else if (trPattern == 1) //  2 middle semicircles
{
   if (socketPattern == 1) // 3 per route
   { 
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID1);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1, 0.1);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1, 0.9);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      // change the trade route for the new sockets
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID1A);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1A, 0.1);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1A, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1A, 0.9);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   if (socketPattern == 2)  
   { 
	if (variantChance == 1) // 4 per route
	{
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID1);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1, 0.1);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1, 0.35);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1, 0.6);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1, 0.85);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      // change the trade route for the new sockets
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID1A);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1A, 0.1);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1A, 0.35);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1A, 0.6);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1A, 0.85);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else  // 2 per route
	{
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID1);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1, 0.28);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1, 0.72);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      // change the trade route for the new sockets
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID1A);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1A, 0.28);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID1A, 0.72);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }
}

   //Text
   rmSetStatusText("",0.40);

// Starting TCs and units 	
   int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
   rmSetObjectDefMinDistance(startingUnits, 5.0);
   rmSetObjectDefMaxDistance(startingUnits, 10.0);
   rmAddObjectDefConstraint(startingUnits, avoidAll);
   rmAddObjectDefConstraint(startingUnits, avoidWater10);

   int startingTCID= rmCreateObjectDef("startingTC");
   rmSetObjectDefMaxDistance(startingTCID, 18.0);
   rmAddObjectDefConstraint(startingTCID, avoidAll);
   rmAddObjectDefConstraint(startingTCID, avoidWater20);
   rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
   rmAddObjectDefConstraint(startingTCID, longAvoidImpassableLand );                
   if ( rmGetNomadStart())
   {
	rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
   }
   else
   {
      rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
   }

   int waterFlagID=rmCreateObjectDef("HC water flag "+i);
   rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
   rmAddClosestPointConstraint(playerEdgeConstraint);
   rmAddClosestPointConstraint(flagVsFlag);
   rmAddClosestPointConstraint(flagLand);

   for(i=1; <cNumberPlayers)
   {	
      rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

	vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
	vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));
      rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
   }
   rmClearClosestPointConstraints();

// Central features & patches, per map or variant
   // Center area
   int centerArea=rmCreateArea("TheCenter");
   rmSetAreaSize(centerArea, 0.2, 0.2);
   rmSetAreaLocation(centerArea, 0.5, 0.5);
   rmAddAreaToClass(centerArea, rmClassID("center")); 

   // Texas desert
   if (patternChance == 12)
   {
      if (lightingChance == 2)
 	{
         int desertID = rmCreateArea("desert");
         rmSetAreaLocation(desertID, 0.5, 0.5); 
         rmSetAreaWarnFailure(desertID, false);
         rmSetAreaSize(desertID, 0.7, 0.75);
         rmSetAreaCoherence(desertID, rmRandFloat(0.7, 0.9));
         rmSetAreaTerrainType(desertID, "texas\ground4_tex");
         rmAddAreaTerrainLayer(desertID, "texas\ground1_tex", 0, 4);
         rmAddAreaTerrainLayer(desertID, "texas\ground2_tex", 4, 8);
         rmAddAreaTerrainLayer(desertID, "texas\ground3_tex", 8, 12);
         rmSetAreaMix(desertID, "texas_dirt");
         rmBuildArea(desertID);
	}
   }

   // Center mountains
   if (centerMt == 1) // non-forest hills
   {
      reducedForest = 1;
      if (mtPattern == 1)
 	   numMt = 1;
      else if (mtPattern == 2)
 	   numMt = 3;	   
      else
 	   numMt = cNumberNonGaiaPlayers + rmRandInt(2,4);

	for (i=0; <numMt)   
      { 
         int mtPatchID = rmCreateArea("mt patch"+i); 
         rmAddAreaToClass(mtPatchID, rmClassID("classHill"));
         rmAddAreaToClass(mtPatchID, rmClassID("classPatch"));
	   if (clearCenter == 1)
	   {
	      if (rmRandInt(0,1) == 1)
	         rmAddAreaToClass(mtPatchID, rmClassID("center"));
	   }
 	   if (patternChance == 8) // Rockies
	   {
            rmSetAreaTerrainType(mtPatchID, "rockies\groundsnow1_roc");
            rmAddAreaTerrainLayer(mtPatchID, "rockies\groundsnow8_roc", 0, 3);
            rmAddAreaTerrainLayer(mtPatchID, "rockies\groundsnow7_roc", 3, 5);
            rmAddAreaTerrainLayer(mtPatchID, "rockies\groundsnow6_roc", 5, 7);
	   }
	   if (patternChance == 20)  // Yukon Tundra
	   {
            rmSetAreaTerrainType(mtPatchID, "yukon\ground1_yuk");
            rmAddAreaTerrainLayer(mtPatchID, "yukon\ground5_yuk", 0, 2);
            rmAddAreaTerrainLayer(mtPatchID, "yukon\ground4_yuk", 2, 4);
            rmAddAreaTerrainLayer(mtPatchID, "yukon\ground8_yuk", 4, 6);
	   }
	   if (patternChance == 19) // Andes
	   {
            rmSetAreaTerrainType(mtPatchID, "rockies\groundsnow1_roc");
            rmAddAreaTerrainLayer(mtPatchID, "patagonia\ground_snow1_pat", 0, 4);
            rmAddAreaTerrainLayer(mtPatchID, "patagonia\ground_snow2_pat", 4, 7);
            rmAddAreaTerrainLayer(mtPatchID, "patagonia\ground_snow2_pat", 7, 10);
	   }
 	   if (patternChance == 7) // Yukon
	   {
            rmSetAreaTerrainType(mtPatchID, "rockies\groundsnow1_roc");
	   }
         rmSetAreaWarnFailure(mtPatchID, false);

 	   if (mtPattern == 1)
	   {
            rmSetAreaSize(mtPatchID, 0.04, 0.045);
            rmSetAreaLocation(mtPatchID, 0.5, 0.5);
		if (variantChance == 1)
		{
               rmSetAreaMinBlobs(mtPatchID, 5);
               rmSetAreaMaxBlobs(mtPatchID, 8);
               rmSetAreaMinBlobDistance(mtPatchID, 30.0);
               rmSetAreaMaxBlobDistance(mtPatchID, 45.0);
		}
	   }
 	   if (mtPattern == 2)
	   {
            rmSetAreaSize(mtPatchID, 0.018, 0.025);
		if (variantChance == 1)
		{
               rmSetAreaMinBlobs(mtPatchID, 5);
               rmSetAreaMaxBlobs(mtPatchID, 8);
               rmSetAreaMinBlobDistance(mtPatchID, 26.0);
               rmSetAreaMaxBlobDistance(mtPatchID, 40.0);
		}
	   }
	   else if (mtPattern == 3)
	   {
            rmSetAreaMinBlobs(mtPatchID, 4);
            rmSetAreaMaxBlobs(mtPatchID, 6);
            rmSetAreaMinBlobDistance(mtPatchID, 15.0);
            rmSetAreaMaxBlobDistance(mtPatchID, 20.0);
            rmSetAreaSize(mtPatchID, rmAreaTilesToFraction(1100), rmAreaTilesToFraction(1500));
	   }
	   else if (mtPattern == 4)
	   {
            rmSetAreaMinBlobs(mtPatchID, 1);
            rmSetAreaMaxBlobs(mtPatchID, 3);
            rmSetAreaMinBlobDistance(mtPatchID, 30.0);
            rmSetAreaMaxBlobDistance(mtPatchID, 40.0);
            rmSetAreaSize(mtPatchID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1400));
	   }
         rmSetAreaElevationType(mtPatchID, cElevTurbulence);
	   rmSetAreaElevationVariation(mtPatchID, rmRandInt(2,3));
	   rmSetAreaCoherence(mtPatchID, rmRandFloat(0.4,0.8));
	   rmSetAreaBaseHeight(mtPatchID, rmRandInt(8,10));
	   rmSetAreaElevationPersistence(mtPatchID, rmRandFloat(0.5,0.8));
	   rmSetAreaHeightBlend(mtPatchID, rmRandFloat(1.0,2.2));
         rmSetAreaSmoothDistance(mtPatchID, rmRandInt(8,15));
         rmAddAreaConstraint(mtPatchID, avoidTradeRoute);
         rmAddAreaConstraint(mtPatchID, avoidSocket);
         rmAddAreaConstraint(mtPatchID, medHillConstraint);
         rmAddAreaConstraint(mtPatchID, circleConstraintMt);
         rmAddAreaConstraint(mtPatchID, farPlayerConstraint);
         rmBuildArea(mtPatchID);
      }
   }
  
   if (forestMt == 1) // green hill forest
   {
      reducedForest = 1;
      if (mtPattern == 1)
 	   numMt = 1;
      else if (mtPattern == 2)
 	   numMt = 3;	   
      else
 	   numMt = cNumberNonGaiaPlayers + rmRandInt(2,4);

	for (i=0; <numMt)   
      { 	
         int hillPatchID = rmCreateArea("green hill"+i); 
         rmAddAreaToClass(hillPatchID, rmClassID("classHill"));
         rmAddAreaToClass(hillPatchID, rmClassID("classPatch"));
         rmSetAreaWarnFailure(hillPatchID, false);
         rmSetAreaForestType(hillPatchID, forestType);
         rmSetAreaForestDensity(hillPatchID, rmRandFloat(0.3, 0.5));
         rmSetAreaForestClumpiness(hillPatchID, rmRandFloat(0.5, 0.8));
         rmSetAreaForestUnderbrush(hillPatchID, rmRandFloat(0.0, 0.3));
 	   if (mtPattern == 1)
	   {
            rmSetAreaSize(hillPatchID, 0.04, 0.045);
            rmSetAreaLocation(hillPatchID, 0.5, 0.5);
		if (variantChance == 1)
		{
               rmSetAreaMinBlobs(hillPatchID, 6);
               rmSetAreaMaxBlobs(hillPatchID, 10);
               rmSetAreaMinBlobDistance(hillPatchID, 45.0);
               rmSetAreaMaxBlobDistance(hillPatchID, 65.0);
		}
	   }
 	   else if (mtPattern == 2)
	   {
            rmSetAreaSize(hillPatchID, 0.015, 0.024);
		if (variantChance == 1)
		{
               rmSetAreaMinBlobs(hillPatchID, 6);
               rmSetAreaMaxBlobs(hillPatchID, 14);
               rmSetAreaMinBlobDistance(hillPatchID, 26.0);
               rmSetAreaMaxBlobDistance(hillPatchID, 40.0);
		}
	   }
	   else if (mtPattern == 3)
	   {
            rmSetAreaMinBlobs(hillPatchID, 4);
            rmSetAreaMaxBlobs(hillPatchID, 6);
            rmSetAreaMinBlobDistance(hillPatchID, 25.0);
            rmSetAreaMaxBlobDistance(hillPatchID, 40.0);
            rmSetAreaSize(hillPatchID, rmAreaTilesToFraction(1100), rmAreaTilesToFraction(1500));
	   }
	   else if (mtPattern == 4)
	   {
            rmSetAreaMinBlobs(hillPatchID, 1);
            rmSetAreaMaxBlobs(hillPatchID, 3);
            rmSetAreaMinBlobDistance(hillPatchID, 20.0);
            rmSetAreaMaxBlobDistance(hillPatchID, 30.0);
            rmSetAreaSize(hillPatchID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1400));
	   }
         rmSetAreaElevationType(hillPatchID, cElevTurbulence);
         rmSetAreaElevationVariation(hillPatchID, rmRandInt(2,3));
	   rmSetAreaElevationPersistence(hillPatchID, rmRandFloat(0.5,0.8));
         rmSetAreaCoherence(hillPatchID, rmRandFloat(0.4,0.8));
         rmSetAreaBaseHeight(hillPatchID, rmRandInt(7,10));
	   rmSetAreaHeightBlend(hillPatchID, rmRandFloat(1.0,2.2));
         rmSetAreaSmoothDistance(hillPatchID,, rmRandInt(8,15));
         rmAddAreaConstraint(hillPatchID, avoidTradeRoute);
         rmAddAreaConstraint(hillPatchID, avoidSocket);
         rmAddAreaConstraint(hillPatchID, longHillConstraint);
         rmAddAreaConstraint(hillPatchID, circleConstraintMt);
         rmAddAreaConstraint(hillPatchID, farPlayerConstraint);
         rmBuildArea(hillPatchID);
	}  
   }

   // Snow patch for Rockies, central highlands
   if (patternChance == 8)  // Rockies
   {
	if (makeCentralCliffArea == 1)  
	{
         int snowPatch2ID = rmCreateArea("snow patch 2"); 
         rmAddAreaToClass(snowPatch2ID, rmClassID("classHill"));
         rmAddAreaToClass(snowPatch2ID, rmClassID("classPatch"));
         rmSetAreaLocation(snowPatch2ID, 0.5, 0.5); 
         rmSetAreaWarnFailure(snowPatch2ID, false);
	   if (highlandSize == 1)
            rmSetAreaSize(snowPatch2ID, 0.075, 0.075);
	   else if (highlandSize == 2)
            rmSetAreaSize(snowPatch2ID, 0.085, 0.085);
	   else if (highlandSize == 3)
            rmSetAreaSize(snowPatch2ID, 0.095, 0.095);
         rmSetAreaElevationType(snowPatch2ID, cElevTurbulence);
	   rmSetAreaElevationVariation(snowPatch2ID, rmRandInt(2, 3));
	   rmSetAreaCoherence(snowPatch2ID, 0.8);
	   if (rmRandInt(1,3) == 3)
            rmSetAreaSmoothDistance(snowPatch2ID, rmRandInt(12, 20));
         rmSetAreaTerrainType(snowPatch2ID, "rockies\groundsnow1_roc");
         rmAddAreaTerrainLayer(snowPatch2ID, "rockies\groundsnow8_roc", 0, 3);
         rmAddAreaTerrainLayer(snowPatch2ID, "rockies\groundsnow7_roc", 3, 6);
         rmAddAreaTerrainLayer(snowPatch2ID, "rockies\groundsnow6_roc", 6, 10);
         rmBuildArea(snowPatch2ID); 
	}
   }

   // Ice patch - Great Lakes Winter, Yukon, Yukon Tundra, S.Araucania
   if (makeIce == 1)
   {
      nativeNumber = 2;
      int icePatchID = rmCreateArea("ice patch"); 
      rmAddAreaToClass(icePatchID, rmClassID("classIce"));
      rmAddAreaToClass(icePatchID, rmClassID("center"));
	if (variantChance == 2)
	   rmAddAreaToClass(icePatchID, rmClassID("classHill"));
      rmSetAreaLocation(icePatchID, 0.5, 0.5); 
      rmSetAreaWarnFailure(icePatchID, false);
      rmSetAreaSize(icePatchID, 0.035, 0.05);
      rmSetAreaCoherence(icePatchID, rmRandFloat(0.6,0.9));
      rmSetAreaMix(icePatchID, "great_lakes_ice");
      rmSetAreaBaseHeight(icePatchID, 1.0);
      rmSetAreaElevationVariation(icePatchID, 0.0);
      rmAddAreaConstraint(icePatchID, avoidTradeRoute);
      rmAddAreaConstraint(icePatchID, avoidSocket);
      rmBuildArea(icePatchID); 
	
	int iceHole = rmRandInt(1,2); 
	if (iceHole == 1)
	{
         int waterPatchID = rmCreateArea("water patch", rmAreaID("ice patch")); 
         rmAddAreaToClass(waterPatchID, rmClassID("classPatch"));
         rmSetAreaWarnFailure(waterPatchID, false);
         rmSetAreaSize(waterPatchID, 0.009, 0.024);
         rmSetAreaCoherence(waterPatchID, rmRandFloat(0.2,0.8));
         rmSetAreaWaterType(waterPatchID, "great lakes ice");
         rmSetAreaBaseHeight(waterPatchID, 1.0);
         rmBuildArea(waterPatchID); 
	}
   }

   // Center lake      
   if (makeLake == 1)
   {
      nativeNumber = 2;
	endPosition = 3;
	int smalllakeID=rmCreateArea("small lake");
      rmSetAreaLocation(smalllakeID, 0.5, 0.5);
      rmSetAreaBaseHeight(smalllakeID, baseHt);
	if (lakePattern == 1)
	{
	   if (patternChance == 3)
	   {
            rmSetAreaSize(smalllakeID, 0.055, 0.075);
		if (trPattern < 5)
		{
   		   if (axisChance == 1) 
      	      rmAddAreaInfluenceSegment(smalllakeID, 0.5, 0.25, 0.5, 0.75); 
   		   else
      	      rmAddAreaInfluenceSegment(smalllakeID, 0.25, 0.5, 0.75, 0.5); 
		}
	   }
	   else
         rmSetAreaSize(smalllakeID, 0.035, 0.04);
         rmSetAreaWaterType(smalllakeID, pondType);
         rmSetAreaMinBlobs(smalllakeID, 1);
         rmSetAreaMaxBlobs(smalllakeID, 4);
         rmSetAreaMinBlobDistance(smalllakeID, 15.0);
         rmSetAreaMaxBlobDistance(smalllakeID, 30.0);
         rmSetAreaCoherence(smalllakeID, rmRandFloat(0.4,0.8));
	}
	else if (lakePattern == 2)
	{
	   if (patternChance == 3)
	   {
            rmSetAreaSize(smalllakeID, 0.055, 0.075);
		if (trPattern < 5)
		{
   		   if (axisChance == 1) 
      	      rmAddAreaInfluenceSegment(smalllakeID, 0.5, 0.25, 0.5, 0.75); 
   		   else
      	      rmAddAreaInfluenceSegment(smalllakeID, 0.25, 0.5, 0.75, 0.5); 
		}
	   }
	   else
         rmSetAreaSize(smalllakeID, 0.045, 0.05);
         rmSetAreaWaterType(smalllakeID, pondType);
         rmSetAreaMinBlobs(smalllakeID, 5);
         rmSetAreaMaxBlobs(smalllakeID, 12);
         rmSetAreaMinBlobDistance(smalllakeID, 25.0);
         rmSetAreaMaxBlobDistance(smalllakeID, 35.0);
         rmSetAreaCoherence(smalllakeID, rmRandFloat(0.4,0.6));
	}
	else if (lakePattern > 2)
	{
         rmSetAreaSize(smalllakeID, 0.08, 0.085);
   	   if (axisChance == 1) 
      	rmAddAreaInfluenceSegment(smalllakeID, 0.5, 0.15, 0.5, 0.85); 
   	   else
      	rmAddAreaInfluenceSegment(smalllakeID, 0.15, 0.5, 0.85, 0.5); 
	   if (patternChance == 6)
            rmSetAreaWaterType(smalllakeID, "hudson bay");
	   else
            rmSetAreaWaterType(smalllakeID, pondType);
         rmSetAreaMinBlobs(smalllakeID, 3);
         rmSetAreaMaxBlobs(smalllakeID, 8);
         rmSetAreaMinBlobDistance(smalllakeID, 18.0);
         rmSetAreaMaxBlobDistance(smalllakeID, 24.0);
         rmSetAreaCoherence(smalllakeID, rmRandFloat(0.7,0.8));
	}
      rmAddAreaToClass(smalllakeID, lakeClass);
      rmAddAreaConstraint(smalllakeID, playerConstraint);
      rmAddAreaConstraint(smalllakeID, avoidTradeRoute);
      rmAddAreaConstraint(smalllakeID, avoidSocket);
      rmAddAreaConstraint(smalllakeID, avoidWater20);
      rmSetAreaWarnFailure(smalllakeID, false);
      rmBuildArea(smalllakeID);
   }

   // Dirt patches for Sonora
   if (patternChance == 13)
   {
	for (i=0; <cNumberNonGaiaPlayers*6)   
      {
		int dirtPatch=rmCreateArea("open dirt patch "+i);
		rmSetAreaWarnFailure(dirtPatch, false);
		rmSetAreaSize(dirtPatch, rmAreaTilesToFraction(150), rmAreaTilesToFraction(200));
		rmSetAreaTerrainType(dirtPatch, "sonora\ground7_son");
		rmAddAreaToClass(dirtPatch, rmClassID("classPatch"));
		rmSetAreaMinBlobs(dirtPatch, 1);
		rmSetAreaMaxBlobs(dirtPatch, 5);
		rmSetAreaMinBlobDistance(dirtPatch, 16.0);
		rmSetAreaMaxBlobDistance(dirtPatch, 40.0);
		rmSetAreaCoherence(dirtPatch, 0.0);
		rmSetAreaSmoothDistance(dirtPatch, 10);
		rmAddAreaConstraint(dirtPatch, shortAvoidImpassableLand);
		rmAddAreaConstraint(dirtPatch, patchConstraint);
		rmBuildArea(dirtPatch); 
      }
   }

   // Snow patches for Yukon Tundra
   if (patternChance == 20)
   { 
      for(i=1; <cNumberPlayers*6)
      {
      int patchAID=rmCreateArea("PatchA"+i);
      rmSetAreaSize(patchAID, rmAreaTilesToFraction(175), rmAreaTilesToFraction(250));
      rmAddAreaToClass(patchAID, rmClassID("classPatch"));
      rmSetAreaTerrainType(patchAID, "yukon\ground1_yuk");
      rmAddAreaTerrainLayer(patchAID, "yukon\ground5_yuk", 0, 2);
      rmAddAreaTerrainLayer(patchAID, "yukon\ground4_yuk", 2, 3);
      rmAddAreaTerrainLayer(patchAID, "yukon\ground8_yuk", 3, 4);
      rmSetAreaWarnFailure(patchAID, false);
      rmSetAreaMinBlobs(patchAID, 2);
      rmSetAreaMaxBlobs(patchAID, 3);
      rmSetAreaMinBlobDistance(patchAID, 10.0);
      rmSetAreaMaxBlobDistance(patchAID, 20.0);
      rmSetAreaCoherence(patchAID, 0.3);
      rmAddAreaConstraint(patchAID, playerConstraint);
      rmAddAreaConstraint(patchAID, shortAvoidImpassableLand);
      rmAddAreaConstraint(patchAID, patchConstraint);
      rmAddAreaConstraint(patchAID, avoidIce);
      rmSetAreaWarnFailure(patchAID, false);
      rmBuildArea(patchAID);
      }
   }

   // Text
   rmSetStatusText("",0.45);

// NATIVE AMERICANS
   // Village A 
   int villageAID = -1;
   int whichNative = rmRandInt(1,2);
   int villageType = rmRandInt(1,5);

   if (whichNative == 1)
	   villageAID = rmCreateGrouping("village A", native1Name+villageType);
   else if (whichNative == 2)
	   villageAID = rmCreateGrouping("village A", native2Name+villageType);
   rmAddGroupingToClass(villageAID, rmClassID("natives"));
   rmAddGroupingToClass(villageAID, rmClassID("importantItem"));
   rmSetGroupingMinDistance(villageAID, 0.0);
   rmSetGroupingMaxDistance(villageAID, size*0.1);
   rmAddGroupingConstraint(villageAID, avoidImpassableLand);
   rmAddGroupingConstraint(villageAID, avoidTradeRoute);
   rmAddGroupingConstraint(villageAID, avoidWater10);
   rmAddGroupingConstraint(villageAID, avoidNativesMed);
   rmAddGroupingConstraint(villageAID, playerConstraint);
   rmAddGroupingConstraint(villageAID, avoidIce);
   rmAddGroupingConstraint(villageAID, avoidMts);

   // Village D - opposite type from A 
   int villageDID = -1;
   villageType = rmRandInt(1,5);

   if (whichNative == 2)
	   villageDID = rmCreateGrouping("village D", native1Name+villageType);
   else if (whichNative == 1)
	   villageDID = rmCreateGrouping("village D", native2Name+villageType);
   rmAddGroupingToClass(villageDID, rmClassID("natives"));
   rmAddGroupingToClass(villageDID, rmClassID("importantItem"));
   rmSetGroupingMinDistance(villageDID, 0.0);
   rmSetGroupingMaxDistance(villageDID, size*0.06);
   rmAddGroupingConstraint(villageDID, avoidImpassableLand);
   rmAddGroupingConstraint(villageDID, avoidTradeRoute);
   rmAddGroupingConstraint(villageDID, avoidWater10);
   rmAddGroupingConstraint(villageDID, avoidNativesMed);
   rmAddGroupingConstraint(villageDID, playerConstraint);
   rmAddGroupingConstraint(villageDID, avoidIce);
   rmAddGroupingConstraint(villageDID, avoidMts);
   if (mtPattern > 2)
      rmAddGroupingConstraint(villageDID, shortHillConstraint);

   // Village B - randomly same or opposite village A
   int villageBID = -1;	
   villageType = rmRandInt(1,5);
   whichNative = rmRandInt(1,2);

   if (whichNative == 1)
	   villageBID = rmCreateGrouping("village B", native1Name+villageType);
   else if (whichNative == 2)
	   villageBID = rmCreateGrouping("village B", native2Name+villageType);
   rmAddGroupingToClass(villageBID, rmClassID("importantItem"));
   rmAddGroupingToClass(villageBID, rmClassID("natives"));
   rmSetGroupingMinDistance(villageBID, 0.0);
   rmSetGroupingMaxDistance(villageBID, size*0.1);
   rmAddGroupingConstraint(villageBID, avoidImpassableLand);
   rmAddGroupingConstraint(villageBID, avoidTradeRoute);
   rmAddGroupingConstraint(villageBID, avoidWater15);
   rmAddGroupingConstraint(villageBID, avoidNatives);
   rmAddGroupingConstraint(villageBID, playerConstraint);
   rmAddGroupingConstraint(villageBID, avoidMts);

   // Village C // appears in center, variable, randomly same or opposite A and B
   int villageCID = -1;	
   villageType = rmRandInt(1,5);
   whichNative = rmRandInt(1,2);

   if (whichNative == 1)
	   villageCID = rmCreateGrouping("village C", native1Name+villageType);
   else if (whichNative == 2)
	   villageCID = rmCreateGrouping("village C", native2Name+villageType);
   rmAddGroupingToClass(villageCID, rmClassID("importantItem"));
   rmAddGroupingToClass(villageCID, rmClassID("natives"));
   rmSetGroupingMinDistance(villageCID, 0.0);
   rmSetGroupingMaxDistance(villageCID, size*0.08);
   rmAddGroupingConstraint(villageCID, avoidImpassableLand);
   rmAddGroupingConstraint(villageCID, avoidWater10);
   rmAddGroupingConstraint(villageCID, avoidTradeRoute);
   rmAddGroupingConstraint(villageCID, avoidNatives);
   rmAddGroupingConstraint(villageCID, playerConstraint);
   rmAddGroupingConstraint(villageCID, avoidMts);
   if (mtPattern > 2)
      rmAddGroupingConstraint(villageCID, shortHillConstraint);

// Setup of placement of Native Americans for special situations
   if ((makeRiver == 1) || (makeMtRange == 1))  
   {
	if (cNumberNonGaiaPlayers > 4)
	{
	   if (rmRandInt(1,9) == 9)
   	      nativeSetup = 6;
	   else
	   {
	      if (rmRandInt(1,8) == 8)
   	         nativeSetup = 8;
		else
               nativeSetup = rmRandInt(11,17);
	   }
	}
	else
	{
	   if (rmRandInt(1,11) == 11)
   	      nativeSetup = 6;
	   else
            nativeSetup = rmRandInt(8,17);
	}   
   }

   if (lakePattern > 2)
   {
	if (rmRandInt(1,10) == 1)
	   nativeSetup = 6;
	else
	   nativeSetup = rmRandInt(9,17);
   }

   if ((makeLake == 1) || (makeIce == 1))
   {
      if (nativeSetup == 8)
         nativeSetup = rmRandInt(9,17);
   }	     

// Placement of Native Americans
   if ((nativeSetup == 13) || (nativeSetup == 17))  
   {
      if (axisChance == 2)
	{
  	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageAID, 0, 0.79, 0.36);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.21, 0.36);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.79, 0.64);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.21, 0.64);
		   if (nativeSetup == 17)
		   {	
			rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.4);
			rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.6);
		   }
  
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageAID, 0, 0.67, 0.4);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.33, 0.4);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.67, 0.6);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.33, 0.6);
		   if (nativeSetup == 17)
		   {	
			rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.34);
			rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.66);
		   }
	      }
      }
	else if (axisChance == 1)
	{
	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageAID, 0, 0.4, 0.79);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.4, 0.21);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.6, 0.79);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.6, 0.21);
		   if (nativeSetup == 17)
		   {	
			rmPlaceGroupingAtLoc(villageDID, 0, 0.33, 0.5);
			rmPlaceGroupingAtLoc(villageDID, 0, 0.67, 0.5);
		   }
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageAID, 0, 0.37, 0.71);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.37, 0.29);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.63, 0.71);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.63, 0.29);
		   if (nativeSetup == 17)
		   {	
			rmPlaceGroupingAtLoc(villageDID, 0, 0.4, 0.5);
			rmPlaceGroupingAtLoc(villageDID, 0, 0.6, 0.5);
		   }
	      }	   
	}
   } 
   else if (nativeSetup == 14)
   {
      if (axisChance == 2)
	{
  	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageAID, 0, 0.79, 0.38);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.21, 0.38);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.79, 0.62);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.21, 0.62);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageAID, 0, 0.67, 0.4);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.33, 0.4);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.67, 0.6);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.33, 0.6);
	      }
      }
	else if (axisChance == 1)
	{
	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageDID, 0, 0.4, 0.79);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.4, 0.21);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.6, 0.79);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.6, 0.21);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageDID, 0, 0.38, 0.71);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.38, 0.29);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.62, 0.71);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.62, 0.29);
	      }
	}
   } 
   else if (nativeSetup > 14) // 15 AND 16
   {
	if (nativeSetup == 15)
	{
	   if (axisChance == 1)
	   {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.4, 0.51);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.6, 0.49);

         }
   	   else
	   {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.51, 0.6);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.49, 0.4);
	   }
	}
	rmAddGroupingConstraint(villageAID, avoidWater20);
	rmAddGroupingConstraint(villageDID, avoidWater20);
      if (axisChance == 2)
	{
  	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageAID, 0, 0.85, 0.135);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.15, 0.135);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.15, 0.865);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.85, 0.865);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageAID, 0, 0.85, 0.135);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.15, 0.135);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.15, 0.865);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.85, 0.865);
	      }
      }
	else if (axisChance == 1)
	{
	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageDID, 0, 0.135, 0.85);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.135, 0.15);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.865, 0.15);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.865, 0.85);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageAID, 0, 0.135, 0.85);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.135, 0.15);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.865, 0.15);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.865, 0.85);
	      }
	}
   } 
   else if (nativeSetup < 4)
   {
      if (axisChance == 1)
	{
	   if (endPosition == 1)
            rmPlaceGroupingAtLoc(villageAID, 0, 0.505, 0.73);
	   else if (endPosition == 2)
            rmPlaceGroupingAtLoc(villageAID, 0, 0.495, 0.82);
	   else
            rmPlaceGroupingAtLoc(villageAID, 0, 0.505, 0.91);
	}	 
      else
	{
	   if (endPosition == 1)
            rmPlaceGroupingAtLoc(villageAID, 0, 0.73, 0.505);
	   else if (endPosition == 2)
            rmPlaceGroupingAtLoc(villageAID, 0, 0.82, 0.495);
	   else
            rmPlaceGroupingAtLoc(villageAID, 0, 0.91, 0.505);
	}
         
      if (axisChance == 1)
	{
	   if (endPosition == 1)
            rmPlaceGroupingAtLoc(villageBID, 0, 0.495, 0.27);
	   else if (endPosition == 2)
            rmPlaceGroupingAtLoc(villageBID, 0, 0.505, 0.18);
	   else
            rmPlaceGroupingAtLoc(villageBID, 0, 0.495, 0.10);
	}
      else
	{
	   if (endPosition == 1)
            rmPlaceGroupingAtLoc(villageBID, 0, 0.27, 0.495);
	   else if (endPosition == 2)
            rmPlaceGroupingAtLoc(villageBID, 0, 0.18, 0.505);
	   else
            rmPlaceGroupingAtLoc(villageBID, 0, 0.10, 0.495);
	}
	if (nativeSetup < 2)
	{
         if (nativeNumber > 2)
            rmPlaceGroupingAtLoc(villageCID, 0, 0.5, 0.5);
	}
	else 
	{
	   rmSetGroupingMaxDistance(villageCID, size*0.1);
         if (nativeNumber > 2)
	   {
		if (axisChance == 1)
		{
               rmPlaceGroupingAtLoc(villageCID, 0, 0.465, 0.5);
               rmPlaceGroupingAtLoc(villageCID, 0, 0.535, 0.5);
	      }
		else
		{
               rmPlaceGroupingAtLoc(villageCID, 0, 0.5, 0.535);
               rmPlaceGroupingAtLoc(villageCID, 0, 0.5, 0.465);
	      }
	   }
	}
   }
   else if (nativeSetup > 5)
   {
	if (nativeSetup == 7)
	{
         if (axisChance == 1)
	   {
	      if (endPosition == 1)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.495, 0.75); 
	      else if (endPosition == 2)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.505, 0.84); 
	      else
               rmPlaceGroupingAtLoc(villageDID, 0, 0.495, 0.93); 
	   }
         else
	   {
	      if (endPosition == 1)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.75, 0.495);
	      else if (endPosition == 2)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.84, 0.505);
	      else
              rmPlaceGroupingAtLoc(villageDID, 0, 0.93, 0.495);
	   }
            
         if (axisChance == 1)
	   {
	      if (endPosition == 1)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.505, 0.25);
	      else if (endPosition == 2)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.495, 0.16);
	      else
               rmPlaceGroupingAtLoc(villageDID, 0, 0.505, 0.08);
	   }            
         else
	   {
	      if (endPosition == 1)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.25, 0.505);
	      else if (endPosition == 2)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.16, 0.495);
	      else
               rmPlaceGroupingAtLoc(villageDID, 0, 0.08, 0.505);
	   }          
	}
	if (nativeSetup == 8)
	{
   	      rmSetGroupingMaxDistance(villageDID, size*0.1);
		if (axisChance == 1)
		{
               rmPlaceGroupingAtLoc(villageDID, 0, 0.465, 0.49);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.535, 0.51);
	      }
		else
		{
               rmPlaceGroupingAtLoc(villageDID, 0, 0.49, 0.535);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.51, 0.465);
	      }
	}
	if (nativeSetup == 11)
	{
		if (axisChance == 1)
		{
               rmPlaceGroupingAtLoc(villageBID, 0, 0.39, 0.5);
               rmPlaceGroupingAtLoc(villageBID, 0, 0.61, 0.5);
	      }
		else
		{
               rmPlaceGroupingAtLoc(villageBID, 0, 0.5, 0.39);
               rmPlaceGroupingAtLoc(villageBID, 0, 0.5, 0.61);
	      }
	}
	if (nativeSetup == 12)
	{
         if (axisChance == 2)
   	   {
  	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageDID, 0, 0.79, 0.38);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.21, 0.38);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.79, 0.62);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.21, 0.62);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageDID, 0, 0.67, 0.4);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.33, 0.4);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.67, 0.6);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.33, 0.6);
	      }
         }
	   else if (axisChance == 1)
	   {
	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageDID, 0, 0.4, 0.79);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.4, 0.21);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.6, 0.79);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.6, 0.21);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageDID, 0, 0.38, 0.71);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.38, 0.29);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.62, 0.71);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.62, 0.29);
	      }
	   }
	}
      for(i=1; <cNumberPlayers) 
      {
         rmSetGroupingMinDistance(villageAID, 65.0);
         rmSetGroupingMaxDistance(villageAID, 90.0);           
	   rmPlaceGroupingAtLoc(villageAID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	   if (nativeSetup == 9)
	   {
            rmSetGroupingMinDistance(villageDID, 65.0);
            rmSetGroupingMaxDistance(villageDID, 90.0);      
		rmPlaceGroupingAtLoc(villageDID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	   }
	   if (nativeSetup == 10)
		rmPlaceGroupingAtLoc(villageAID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      }
   }
   else if (nativeSetup > 3) // setup 4 and 5
   {
      if (axisChance == 1)
	{
	   if (endPosition == 1)
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.52, 0.75);
		rmPlaceGroupingAtLoc(villageAID, 0, 0.48, 0.25);
	   }
	   else if (endPosition == 2)
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.48, 0.84);
            rmPlaceGroupingAtLoc(villageAID, 0, 0.52, 0.16);
	   }
	   else
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.52, 0.93);
		rmPlaceGroupingAtLoc(villageAID, 0, 0.48, 0.08);
	   }
	}          
      else
	{
	   if (endPosition == 1)
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.75, 0.52);
	      rmPlaceGroupingAtLoc(villageAID, 0, 0.25, 0.48);
	   }
	   else if (endPosition == 2)
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.84, 0.52);
		rmPlaceGroupingAtLoc(villageAID, 0, 0.16, 0.48);
	   }
	   else
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.93, 0.48);
		rmPlaceGroupingAtLoc(villageAID, 0, 0.08, 0.52);
	   }
	}       
         
	if (nativeSetup == 4)
	{
	   if (axisChance == 1)
	   {

            rmPlaceGroupingAtLoc(villageDID, 0, 0.415, 0.5);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.585, 0.5);
         }
   	   else
	   {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.51, 0.585);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.49, 0.415);
	   }
	}
	if (nativeSetup == 5)
	{	
   	   rmSetGroupingMaxDistance(villageDID, size*0.1);
         if (axisChance == 1)
	   {
            if (sidePosition == 1)
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.7, 0.5);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.3, 0.5);
	      }
	      else if (sidePosition == 2)
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.74, 0.5);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.26, 0.5);
	      }
	      else
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.78, 0.5);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.22, 0.5);
		}
         }
	   else
	   {
            if (endPosition == 1)
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.7);
		rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.3);
	      }	   
	      else if (endPosition == 2)
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.74);
		rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.26);
	      }
	      else
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.78);
		rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.22); 
            }
	   }
	}  
   }

   // Text
   rmSetStatusText("",0.50);

// Player Nuggets
   int playerNuggetID=rmCreateObjectDef("player nugget");
   rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
   rmAddObjectDefToClass(playerNuggetID, rmClassID("classNugget"));
   rmSetObjectDefMinDistance(playerNuggetID, 35.0);
   rmSetObjectDefMaxDistance(playerNuggetID, 45.0);
   rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerNuggetID, avoidSocket);
   rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
   rmAddObjectDefConstraint(playerNuggetID, avoidWater10);
   for(i=1; <cNumberPlayers)
   {
 	rmSetNuggetDifficulty(1, 1);
	rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

// More Ponds for Bayou      
   if (patternChance == 3)
   {
	for (i=0; <cNumberNonGaiaPlayers*3)   
      {
	   int smallPond2ID=rmCreateArea("bigger small pond"+i);
	   rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(340), rmAreaTilesToFraction(500));
         rmSetAreaWaterType(smallPond2ID, pondType);
         rmSetAreaBaseHeight(smallPond2ID, baseHt);
         rmSetAreaMinBlobs(smallPond2ID, 3);
         rmSetAreaMaxBlobs(smallPond2ID, 5);
         rmSetAreaMinBlobDistance(smallPond2ID, 14.0);
         rmSetAreaMaxBlobDistance(smallPond2ID, 28.0);
         rmAddAreaToClass(smallPond2ID, lakeClass);
         rmAddAreaConstraint(smallPond2ID, avoidLakes);
         rmAddAreaConstraint(smallPond2ID, avoidCliffs);
         rmAddAreaConstraint(smallPond2ID, avoidCliffs2);
         rmAddAreaConstraint(smallPond2ID, avoidValley);
         rmAddAreaConstraint(smallPond2ID, avoidNativesShort);
         rmAddAreaConstraint(smallPond2ID, playerConstraint);
         rmAddAreaConstraint(smallPond2ID, patchConstraint);
         rmAddAreaConstraint(smallPond2ID, avoidTradeRoute);
         rmAddAreaConstraint(smallPond2ID, avoidSocket);
         rmAddAreaConstraint(smallPond2ID, avoidAll);
         rmAddAreaConstraint(smallPond2ID, avoidSea);
         rmAddAreaConstraint(smallPond2ID, avoidWater20);
         rmSetAreaCoherence(smallPond2ID, 0.2);
         rmSetAreaWarnFailure(smallPond2ID, false);
         rmBuildArea(smallPond2ID);
      }
	for (i=0; <cNumberNonGaiaPlayers*6)   
      {
	   int smallPondID=rmCreateArea("small pond"+i);
	   rmSetAreaSize(smallPondID, rmAreaTilesToFraction(180), rmAreaTilesToFraction(240));
         rmSetAreaWaterType(smallPondID, pondType);
         rmSetAreaBaseHeight(smallPondID, baseHt);
         rmSetAreaMinBlobs(smallPondID, 2);
         rmSetAreaMaxBlobs(smallPondID, 4);
         rmSetAreaMinBlobDistance(smallPondID, 6.0);
         rmSetAreaMaxBlobDistance(smallPondID, 12.0);
         rmAddAreaToClass(smallPondID, lakeClass);
         rmAddAreaConstraint(smallPondID, avoidLakes);
         rmAddAreaConstraint(smallPondID, avoidCliffs);
         rmAddAreaConstraint(smallPondID, avoidCliffs2);
         rmAddAreaConstraint(smallPondID, avoidValley);
         rmAddAreaConstraint(smallPondID, avoidNativesShort);
         rmAddAreaConstraint(smallPondID, playerConstraint);
         rmAddAreaConstraint(smallPondID, patchConstraint);
         rmAddAreaConstraint(smallPondID, avoidTradeRoute);
         rmAddAreaConstraint(smallPondID, avoidSocket);
         rmAddAreaConstraint(smallPondID, avoidAll);
         rmAddAreaConstraint(smallPondID, avoidSea);
         rmAddAreaConstraint(smallPondID, avoidWater20);
         rmSetAreaCoherence(smallPondID, rmRandFloat(0.2,0.8));
         rmSetAreaWarnFailure(smallPondID, false);
         rmBuildArea(smallPondID);
      }
   }

   // Text
   rmSetStatusText("",0.55);

// Cliffs
   int cliffHt = -1;
   int failCount=0;
   int numTries=cNumberNonGaiaPlayers*14;
   int anotherChance = -1;
   anotherChance = rmRandInt(0,1);

   if (makeCliffs == 2)
   {
     if (anotherChance == 1)
        makeCliffs = 1;
     else
        makeCliffs = 0;
   } 

   if (makeCentralCliffArea == 1)
   {
	numTries=cNumberNonGaiaPlayers*8;
	cliffVariety = rmRandInt(1,5);
   }

   if (makeCliffs == 1)
   { 
	if ((patternChance == 13) || (patternChance == 21))   // for Sonora or Painted Desert only
	{
	   // bigger mesas
	   for(i=0; <numTries)
	   {
		int cliffHeight=rmRandInt(0,10);
		int mesaID=rmCreateArea("mesa"+i);
		rmSetAreaSize(mesaID, rmAreaTilesToFraction(25), rmAreaTilesToFraction(160)); 
		rmSetAreaWarnFailure(mesaID, false);
		rmSetAreaCliffType(mesaID, cliffType);
		rmAddAreaToClass(mesaID, rmClassID("canyon"));
		rmAddAreaToClass(mesaID, rmClassID("classCliff"));	
		rmSetAreaCliffEdge(mesaID, 1, 1.0, 0.1, 1.0, 0);
		if (cliffHeight <= 7)
		  rmSetAreaCliffHeight(mesaID, rmRandInt(5,9), 1.0, 1.0);
		else
		  rmSetAreaCliffHeight(mesaID, -10, 1.0, 1.0);
		rmAddAreaConstraint(mesaID, avoidCanyons);
		rmAddAreaConstraint(mesaID, avoidCliffs);
		rmAddAreaConstraint(mesaID, avoidCliffs2);
		rmSetAreaMinBlobs(mesaID, 3);
		rmSetAreaMaxBlobs(mesaID, 5);
		rmSetAreaMinBlobDistance(mesaID, 3.0);
		rmSetAreaMaxBlobDistance(mesaID, 5.0);
		rmSetAreaCoherence(mesaID, 0.5);
		rmAddAreaConstraint(mesaID, playerConstraint); 
		rmAddAreaConstraint(mesaID, avoidSocket);
		rmAddAreaConstraint(mesaID, avoidNativesShort);
		rmAddAreaConstraint(mesaID, avoidWater20);
		rmAddAreaConstraint(mesaID, avoidTradeRoute);
		rmAddAreaConstraint(mesaID, shortAvoidSilver);
		if(rmBuildArea(mesaID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==2)
				break;
		}
		else
			failCount=0;
	   }
	// smaller mesas
      if (makeCentralCliffArea == 1)
	   numTries=cNumberNonGaiaPlayers*12;
      else
	   numTries=cNumberNonGaiaPlayers*18;

	   for(i=0; <numTries)
	   {
		int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa"+i);
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(4), rmAreaTilesToFraction(8));  
		rmSetAreaWarnFailure(smallMesaID, false);
		rmSetAreaCliffType(smallMesaID, cliffType);
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));
		rmAddAreaToClass(smallMesaID, rmClassID("classCliff"));	
		rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID, rmRandInt(5,8), 1.0, 1.0);
		rmAddAreaConstraint(smallMesaID, shortAvoidCanyons);
		rmAddAreaConstraint(smallMesaID, avoidCliffs);
		rmAddAreaConstraint(smallMesaID, avoidCliffs2);
		rmSetAreaMinBlobs(smallMesaID, 3);
		rmSetAreaMaxBlobs(smallMesaID, 5);
		rmSetAreaMinBlobDistance(smallMesaID, 3.0);
		rmSetAreaMaxBlobDistance(smallMesaID, 5.0);
		rmSetAreaCoherence(smallMesaID, 0.3);
		rmAddAreaConstraint(smallMesaID, mediumPlayerConstraint); 
		rmAddAreaConstraint(smallMesaID, avoidNativesShort); 
		rmAddAreaConstraint(smallMesaID, avoidSocket);
		rmAddAreaConstraint(smallMesaID, avoidWater10);
		rmAddAreaConstraint(smallMesaID, avoidTradeRoute);
		rmAddAreaConstraint(smallMesaID, shortAvoidSilver);
		if(rmBuildArea(smallMesaID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==20)
				break;
		}
		else
			failCount=0;
	   }
	}
	else if (cliffVariety == 0) // a little like AOM Anatolia
	{
	   int gorgeHt = rmRandInt(-7,-4);
	   numTries = 2;
	   if (cNumberNonGaiaPlayers > 5)
	      numTries = 3;

	   for(i=0; <numTries)
	   {
	   int gorgeID=rmCreateArea("gorge"+i);
         rmSetAreaWarnFailure(gorgeID, false); 
	   rmSetAreaSize(gorgeID, rmAreaTilesToFraction(1500), rmAreaTilesToFraction(1800));
	   rmSetAreaCliffType(gorgeID, cliffType);
	   rmAddAreaToClass(gorgeID, rmClassID("classCliff"));
	   rmSetAreaMinBlobs(gorgeID, 4);
	   rmSetAreaMaxBlobs(gorgeID, 6);
	   if (rmRandInt(1,3) == 1)
	      rmSetAreaCliffEdge(gorgeID, 6, 0.10, 0.2, 1.0, 0);
	   else
	   {
		if (rmRandInt(1,2) == 1) 
	         rmSetAreaCliffEdge(gorgeID, 5, 0.15, 0.15, 1.0, 0);
		else
	         rmSetAreaCliffEdge(gorgeID, 4, 0.17, 0.15, 1.0, 0);
	   }		
	   rmSetAreaCliffPainting(gorgeID, false, true, true, 1.5);  
	   rmSetAreaMinBlobDistance(gorgeID, 16.0);
	   rmSetAreaMaxBlobDistance(gorgeID, 20.0);
	   rmSetAreaCoherence(gorgeID, rmRandFloat(0.0,0.2));
	   rmSetAreaSmoothDistance(gorgeID, rmRandInt(10,20));
	   rmSetAreaCliffHeight(gorgeID, gorgeHt, 1.0, 1.0);
	   rmSetAreaHeightBlend(gorgeID, 2);
	   rmAddAreaConstraint(gorgeID, cliffsAvoidCliffs);
	   rmAddAreaConstraint(gorgeID, avoidCliffs2);
         rmAddAreaConstraint(gorgeID, avoidImportantItem);
	   rmAddAreaConstraint(gorgeID, avoidTradeRoute);
         rmAddAreaConstraint(gorgeID, avoidNatives);
	   rmAddAreaConstraint(gorgeID, avoidWater20);
	   rmAddAreaConstraint(gorgeID, avoidSocket);
	   rmAddAreaConstraint(gorgeID, avoidStartingUnits);
	   rmAddAreaConstraint(gorgeID, fartherPlayerConstraint);
	   rmAddAreaConstraint(gorgeID, secondEdgeConstraint);
	   rmAddAreaConstraint(gorgeID, longHillConstraint);
 	   rmBuildArea(gorgeID);
	   }
      }
      else // all other maps with cliffs
      {
         int numCliffs = cNumberNonGaiaPlayers + rmRandInt(4,7);
   	   if ((makeLake == 1) || (makeIce == 1) || (makeValley == 1) || (makeBarrierRange == 1) || (makeCentralCliffArea == 1))
	      numCliffs = cNumberNonGaiaPlayers + rmRandInt(2,6);

         for (i=0; <numCliffs)
         {
		cliffHt = rmRandInt(5,7);    
		int bigCliffID=rmCreateArea("big cliff" +i);
		rmSetAreaWarnFailure(bigCliffID, false);
		rmSetAreaCliffType(bigCliffID, cliffType);
		rmAddAreaToClass(bigCliffID, rmClassID("classCliff"));
		if (cliffVariety == 1) // like Patagonia
		{
   	         rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(550), rmAreaTilesToFraction(750));
      	   rmSetAreaCliffEdge(bigCliffID, 2, 0.35, 0.1, 1.0, 0);
		   if (bareCliffs == 1)
			rmSetAreaCliffPainting(bigCliffID, true, true, true, 1.5, true);
		   else
      	      rmSetAreaCliffPainting(bigCliffID, false, true, true, 1.5, true);
		   rmSetAreaCliffHeight(bigCliffID, 7, 2.0, 0.5);
		   rmSetAreaCoherence(bigCliffID, 0.5);
		   rmSetAreaSmoothDistance(bigCliffID, rmRandInt(5,10));
		   rmSetAreaHeightBlend(bigCliffID, 1.0);
		   rmSetAreaMinBlobs(bigCliffID, 4);
	  	   rmSetAreaMaxBlobs(bigCliffID, 6);
		   rmSetAreaMinBlobDistance(bigCliffID, 10.0);
		   rmSetAreaMaxBlobDistance(bigCliffID, 18.0);
		}
		else if (cliffVariety == 2) // smaller, kinda like in Sudden Death from AOM
		{
   	         rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(280), rmAreaTilesToFraction(400));
		   rmSetAreaCliffEdge(bigCliffID, 1, 0.6, 0.1, 1.0, 0);
		   if (bareCliffs == 1)
			rmSetAreaCliffPainting(bigCliffID, true, true, true, 1.5, true);
		   else
      	      rmSetAreaCliffPainting(bigCliffID, false, true, true, 1.5, true);
		   rmSetAreaCliffHeight(bigCliffID, cliffHt, 1.0, 1.0);
		   rmSetAreaCoherence(bigCliffID, rmRandFloat(0.4, 0.9));
		   rmSetAreaSmoothDistance(bigCliffID, 10);
		   rmSetAreaHeightBlend(bigCliffID, 2.0);
		   rmSetAreaMinBlobs(bigCliffID, 1);
	  	   rmSetAreaMaxBlobs(bigCliffID, 3);
		   rmSetAreaMinBlobDistance(bigCliffID, 5.0);
		   rmSetAreaMaxBlobDistance(bigCliffID, 10);
		}
		else
		{
		   if (plainsMap == 1)
		   {
			if (cliffVariety == 3)  // odd ridges for selected maps
			{
   	         	   rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(450));
		   	   rmAddAreaToClass(bigCliffID, rmClassID("classCliff"));
		   	   if (rmRandInt(1,2) == 1)
 	            	rmSetAreaCliffEdge(bigCliffID, 2, 0.36, 0.1, 1.0, 0);
		   	   else
 	            	rmSetAreaCliffEdge(bigCliffID, 3, 0.26, 0.08, 1.0, 0);
		         if (bareCliffs == 1)
			      rmSetAreaCliffPainting(bigCliffID, true, true, true, 1.5, true);
		         else
      	            rmSetAreaCliffPainting(bigCliffID, false, true, true, 1.5, true);
		   	   rmSetAreaCliffHeight(bigCliffID, cliffHt, 2.0, 1.0);
		  	   rmSetAreaCoherence(bigCliffID, rmRandFloat(0.3, 0.5));
		   	   rmSetAreaSmoothDistance(bigCliffID, 5);
		   	   rmSetAreaHeightBlend(bigCliffID, 1.0);
	  	   	   rmSetAreaMinBlobs(bigCliffID, 2);
		   	   rmSetAreaMaxBlobs(bigCliffID, 2);
		   	   rmSetAreaMinBlobDistance(bigCliffID, 100.0);
		   	   rmSetAreaMaxBlobDistance(bigCliffID, 130.0);
			}
			else if (cliffVariety == 4)  // smooth rock domes for plains maps
			{
   	         	   rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(200), rmAreaTilesToFraction(400));
		   	   rmAddAreaToClass(bigCliffID, rmClassID("classCliff"));
		   	   rmSetAreaCliffEdge(bigCliffID, 1, 0.005, 0.01, 1.0, 0);
		         if (bareCliffs == 1)
			      rmSetAreaCliffPainting(bigCliffID, true, true, true, 1.5, true);
		         else
      	            rmSetAreaCliffPainting(bigCliffID, false, true, true, 1.5, true);
		   	   rmSetAreaCliffHeight(bigCliffID, rmRandInt(7,8), 2.0, 1.0);
		   	   rmSetAreaCoherence(bigCliffID, rmRandFloat(0.3, 0.5));
		   	   rmSetAreaSmoothDistance(bigCliffID, 20);
		   	   rmSetAreaHeightBlend(bigCliffID, 1.0);
	     		}
		      else  // kinda random, kinda like Texas or NE
		      {
   	               rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(400), rmAreaTilesToFraction(700));
		         rmSetAreaCliffEdge(bigCliffID, 1, 0.6, 0.1, 1.0, 0);
		         if (bareCliffs == 1)
			      rmSetAreaCliffPainting(bigCliffID, true, true, true, 1.5, true);
		         else
      	            rmSetAreaCliffPainting(bigCliffID, false, true, true, 1.5, true);
		         rmSetAreaCliffHeight(bigCliffID, cliffHt, 2.0, 1.0);
  		         rmSetAreaCoherence(bigCliffID, rmRandFloat(0.4, 0.9));
		         rmSetAreaSmoothDistance(bigCliffID, 15);
		         rmSetAreaHeightBlend(bigCliffID, 1.0);
		         rmSetAreaMinBlobs(bigCliffID, 3);
		         rmSetAreaMaxBlobs(bigCliffID, 5);
		         rmSetAreaMinBlobDistance(bigCliffID, 10.0);
		         rmSetAreaMaxBlobDistance(bigCliffID, 18.0);
		      }
		   }
		   else if ((patternChance == 11) || (patternChance == 12) || (patternChance == 18) || (patternChance == 19)) 
		   { 
			if (cliffVariety < 5)  // odd ridges for selected maps
			{
   	         	   rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(450));
		   	   rmAddAreaToClass(bigCliffID, rmClassID("classCliff"));
		   	   if (rmRandInt(1,2) == 1)
 	            	rmSetAreaCliffEdge(bigCliffID, 2, 0.36, 0.1, 1.0, 0);
		   	   else
 	            	rmSetAreaCliffEdge(bigCliffID, 3, 0.26, 0.08, 1.0, 0);
		         if (bareCliffs == 1)
			      rmSetAreaCliffPainting(bigCliffID, true, true, true, 1.5, true);
		         else
      	            rmSetAreaCliffPainting(bigCliffID, false, true, true, 1.5, true);
		   	   rmSetAreaCliffHeight(bigCliffID, cliffHt, 2.0, 1.0);
		  	   rmSetAreaCoherence(bigCliffID, rmRandFloat(0.3, 0.5));
		   	   rmSetAreaSmoothDistance(bigCliffID, 5);
		   	   rmSetAreaHeightBlend(bigCliffID, 1.0);
	  	   	   rmSetAreaMinBlobs(bigCliffID, 2);
		   	   rmSetAreaMaxBlobs(bigCliffID, 2);
		   	   rmSetAreaMinBlobDistance(bigCliffID, 100.0);
		   	   rmSetAreaMaxBlobDistance(bigCliffID, 130.0);
			}
		      else  // kinda random, kinda like Texas or NE
		      {
   	               rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(400), rmAreaTilesToFraction(700));
		         rmSetAreaCliffEdge(bigCliffID, 1, 0.6, 0.1, 1.0, 0);
		         if (bareCliffs == 1)
			      rmSetAreaCliffPainting(bigCliffID, true, true, true, 1.5, true);
		         else
      	            rmSetAreaCliffPainting(bigCliffID, false, true, true, 1.5, true);
		         rmSetAreaCliffHeight(bigCliffID, cliffHt, 2.0, 1.0);
  		         rmSetAreaCoherence(bigCliffID, rmRandFloat(0.4, 0.9));
		         rmSetAreaSmoothDistance(bigCliffID, 15);
		         rmSetAreaHeightBlend(bigCliffID, 1.0);
		         rmSetAreaMinBlobs(bigCliffID, 3);
		         rmSetAreaMaxBlobs(bigCliffID, 5);
		         rmSetAreaMinBlobDistance(bigCliffID, 10.0);
		         rmSetAreaMaxBlobDistance(bigCliffID, 18.0);
		      }
		   }
		   else  // kinda random, kinda like Texas or NE
		   {
   	            rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(400), rmAreaTilesToFraction(700));
		      rmSetAreaCliffEdge(bigCliffID, 1, 0.6, 0.1, 1.0, 0);
		      if (bareCliffs == 1)
			   rmSetAreaCliffPainting(bigCliffID, true, true, true, 1.5, true);
		      else
      	         rmSetAreaCliffPainting(bigCliffID, false, true, true, 1.5, true);
		      rmSetAreaCliffHeight(bigCliffID, cliffHt, 2.0, 1.0);
		      rmSetAreaCoherence(bigCliffID, rmRandFloat(0.4, 0.9));
		      rmSetAreaSmoothDistance(bigCliffID, 15);
		      rmSetAreaHeightBlend(bigCliffID, 1.0);
		      rmSetAreaMinBlobs(bigCliffID, 3);
		      rmSetAreaMaxBlobs(bigCliffID, 5);
		      rmSetAreaMinBlobDistance(bigCliffID, 10.0);
		      rmSetAreaMaxBlobDistance(bigCliffID, 18.0);
		   }
	      }
		rmAddAreaConstraint(bigCliffID, avoidImportantItem);
		rmAddAreaConstraint(bigCliffID, avoidTradeRoute);
            rmAddAreaConstraint(bigCliffID, avoidNatives);
	      rmAddAreaConstraint(bigCliffID, avoidWater20);
	      rmAddAreaConstraint(bigCliffID, avoidCliffs2);
	      rmAddAreaConstraint(bigCliffID, cliffsAvoidCliffs);
	      rmAddAreaConstraint(bigCliffID, avoidSocket);
	      rmAddAreaConstraint(bigCliffID, avoidStartingUnits);
	      rmAddAreaConstraint(bigCliffID, longPlayerConstraint);
	      rmAddAreaConstraint(bigCliffID, longHillConstraint);
		rmBuildArea(bigCliffID);
         }
      }
   }

   // Random ponds
   int pondNum = cNumberNonGaiaPlayers*3;
   if (cNumberNonGaiaPlayers > 5)
      pondNum = cNumberNonGaiaPlayers*2;
   else if (cNumberNonGaiaPlayers > 3)
      pondNum = cNumberNonGaiaPlayers*2.5;

   if (morePonds == 1)
   {
      if (cNumberNonGaiaPlayers == 2)
          pondNum = 8;
      if (cNumberNonGaiaPlayers == 3)
         pondNum = 10;
      if (cNumberNonGaiaPlayers == 4)
         pondNum = 12;
      if (cNumberNonGaiaPlayers == 5)
         pondNum = 13;
      if (cNumberNonGaiaPlayers > 5)
         pondNum = cNumberNonGaiaPlayers*2.5;
   }

   if (makePonds == 1)
   {
	for (i=0; <pondNum)   
      {
	   int pondID=rmCreateArea("random pond"+i);
	   rmSetAreaSize(pondID, rmAreaTilesToFraction(300), rmAreaTilesToFraction(550));
         rmSetAreaWaterType(pondID, pondType);
         rmSetAreaBaseHeight(pondID, baseHt);
         rmSetAreaMinBlobs(pondID, 1);
         rmSetAreaMaxBlobs(pondID, 5);
         rmSetAreaMinBlobDistance(pondID, 12.0);
         rmSetAreaMaxBlobDistance(pondID, 35.0);
         rmAddAreaToClass(pondID, lakeClass);
         rmAddAreaConstraint(pondID, avoidLakesFar);
         rmAddAreaConstraint(pondID, longPlayerConstraint);
         rmAddAreaConstraint(pondID, playerEdgeConstraint);
         rmAddAreaConstraint(pondID, avoidTradeRoute);
         rmAddAreaConstraint(pondID, avoidSocket);
         rmAddAreaConstraint(pondID, avoidCliffs);
         rmAddAreaConstraint(pondID, avoidCliffs2);
         rmAddAreaConstraint(pondID, avoidAll);
         rmAddAreaConstraint(pondID, avoidSea);
         rmAddAreaConstraint(pondID, avoidWater20);
         rmAddAreaConstraint(pondID, patchConstraint);
         rmAddAreaConstraint(pondID, avoidNativesShort);
         rmAddAreaConstraint(pondID, medHillConstraint);
         rmSetAreaCoherence(pondID, rmRandFloat(0.1,0.7));
         rmSetAreaWarnFailure(pondID, false);
         rmBuildArea(pondID);
      }
   }

   // Text
   rmSetStatusText("",0.60);

// Random Nuggets
   int nugget2= rmCreateObjectDef("nugget medium"); 
   rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(2, 2);
   rmAddObjectDefToClass(nugget2, rmClassID("classNugget"));
   rmSetObjectDefMinDistance(nugget2, 60.0);
   rmSetObjectDefMaxDistance(nugget2, 110.0);
   rmAddObjectDefConstraint(nugget2, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(nugget2, avoidSocket);
   rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget2, nuggetPlayerConstraint);
   rmAddObjectDefConstraint(nugget2, avoidNuggetMed);
   rmAddObjectDefConstraint(nugget2, playerEdgeConstraint);
   rmAddObjectDefConstraint(nugget2, avoidWater10);
   rmAddObjectDefConstraint(nugget2, avoidAll);
   rmAddObjectDefConstraint(nugget2, avoidIce);
   rmPlaceObjectDefPerPlayer(nugget2, false, 1);

   rmPlaceObjectDefAtLoc(nugget2, 0, 0.5, 0.5, 1);

   int nugget3= rmCreateObjectDef("nugget hard"); 
   rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(3, 3);
   rmAddObjectDefToClass(nugget3, rmClassID("classNugget"));
   rmSetObjectDefMinDistance(nugget3, 80.0);
   rmSetObjectDefMaxDistance(nugget3, size*0.6);
   rmAddObjectDefConstraint(nugget3, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(nugget3, avoidSocket);
   rmAddObjectDefConstraint(nugget3, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget3, farPlayerConstraint);
   rmAddObjectDefConstraint(nugget3, avoidNuggetLong);
   rmAddObjectDefConstraint(nugget3, playerEdgeConstraint);
   rmAddObjectDefConstraint(nugget3, avoidWater10);
   rmAddObjectDefConstraint(nugget3, avoidAll);
   rmAddObjectDefConstraint(nugget3, avoidIce);
   rmPlaceObjectDefPerPlayer(nugget3, false, 1);

   rmPlaceObjectDefAtLoc(nugget3, 0, 0.5, 0.5, 2);

   rmAddObjectDefConstraint(nugget3, fartherPlayerConstraint);
   rmSetNuggetDifficulty(2, 3);
   rmPlaceObjectDefPerPlayer(nugget3, false, 1);

   int nugget4= rmCreateObjectDef("nugget nuts"); 
   rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(4, 4);
   rmAddObjectDefToClass(nugget4, rmClassID("classNugget"));
   rmSetObjectDefMinDistance(nugget4, 85.0);
   rmSetObjectDefMaxDistance(nugget4, size*0.4);
   rmAddObjectDefConstraint(nugget4, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(nugget4, avoidSocket);
   rmAddObjectDefConstraint(nugget4, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget4, fartherPlayerConstraint);
   rmAddObjectDefConstraint(nugget4, avoidNuggetLong);
   rmAddObjectDefConstraint(nugget4, playerEdgeConstraint);
   rmAddObjectDefConstraint(nugget4, avoidWater10);
   rmAddObjectDefConstraint(nugget4, avoidAll);
   rmAddObjectDefConstraint(nugget4, avoidIce);
   rmPlaceObjectDefPerPlayer(nugget4, false, 1);

   rmSetObjectDefMaxDistance(nugget4, size*0.3);
   rmPlaceObjectDefAtLoc(nugget4, 0, 0.5, 0.5, 1);

// more resources
   // start area trees 
   int StartAreaTreeID=rmCreateObjectDef("starting trees");
   rmAddObjectDefItem(StartAreaTreeID, treeType, 1, 0.0);
   rmSetObjectDefMinDistance(StartAreaTreeID, 8);
   rmSetObjectDefMaxDistance(StartAreaTreeID, 12);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidAll);
   rmPlaceObjectDefPerPlayer(StartAreaTreeID, false, 3);

   // berry bushes
   int berryNum = rmRandInt(2,5);
   int StartBerryBushID=rmCreateObjectDef("starting berry bush");
   rmAddObjectDefItem(StartBerryBushID, "BerryBush", rmRandInt(2,4), 4.0);
   rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
   rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
   rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
   if (placeBerries == 1)
      rmPlaceObjectDefPerPlayer(StartBerryBushID, false, 1);
   if (tropicalMap == 1)
      rmPlaceObjectDefPerPlayer(StartBerryBushID, false, 1);
   rmSetObjectDefMinDistance(StartBerryBushID, 70.0);
   rmSetObjectDefMaxDistance(StartBerryBushID, 85.0);
   if (tropicalMap == 1)
      rmPlaceObjectDefPerPlayer(StartBerryBushID, false, 1);

   // Text
   rmSetStatusText("",0.65);

   // start area huntable
   int deerNum = rmRandInt(5, 8);
   int startPronghornID=rmCreateObjectDef("starting pronghorn");
   rmAddObjectDefItem(startPronghornID, deerType, deerNum, 5.0);
   rmAddObjectDefToClass(startPronghornID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(startPronghornID, 16);
   rmSetObjectDefMaxDistance(startPronghornID, 22);
   rmAddObjectDefConstraint(startPronghornID, avoidStartResource);
   rmAddObjectDefConstraint(startPronghornID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(startPronghornID, avoidAll);
   rmSetObjectDefCreateHerd(startPronghornID, true);
   rmPlaceObjectDefPerPlayer(startPronghornID, false, 1);

   // second huntable
   int deer2Num = rmRandInt(4, 8);
   int farPronghornID=rmCreateObjectDef("far pronghorn");
   rmAddObjectDefItem(farPronghornID, deer2Type, deer2Num, 5.0);
   rmAddObjectDefToClass(farPronghornID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(farPronghornID, 42.0);
   rmSetObjectDefMaxDistance(farPronghornID, 60.0);
   rmAddObjectDefConstraint(farPronghornID, avoidStartResource);
   rmAddObjectDefConstraint(farPronghornID, mediumPlayerConstraint);
   rmAddObjectDefConstraint(farPronghornID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(farPronghornID, avoidNativesShort);
   rmAddObjectDefConstraint(farPronghornID, huntableConstraint);
   rmAddObjectDefConstraint(farPronghornID, avoidAll);
   rmSetObjectDefCreateHerd(farPronghornID, true);
   if (sheepChance == 0)
      rmPlaceObjectDefPerPlayer(farPronghornID, false, 2);
   else
      rmPlaceObjectDefPerPlayer(farPronghornID, false, 1);

   // additional second huntable for low player numbers
   if (cNumberNonGaiaPlayers < 4)
   {
      rmAddObjectDefConstraint(farPronghornID, fartherPlayerConstraint);
      rmSetObjectDefMinDistance(farPronghornID, rmXFractionToMeters(0.25));
      rmSetObjectDefMaxDistance(farPronghornID, rmXFractionToMeters(0.38));
      rmPlaceObjectDefPerPlayer(farPronghornID, false, 1);
   }

// Silver mines - players
   int silverType = -1;
   silverType = rmRandInt(1,10);
   int playerGoldID=rmCreateObjectDef("player silver closer");
   rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerGoldID, avoidSocket);
   rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(playerGoldID, avoidAll);
   rmAddObjectDefConstraint(playerGoldID, avoidWater10);
   rmSetObjectDefMinDistance(playerGoldID, 18.0);
   rmSetObjectDefMaxDistance(playerGoldID, 23.0);
   rmPlaceObjectDefPerPlayer(playerGoldID, false, 1);

   rmAddObjectDefConstraint(playerGoldID, playerConstraint);
   rmSetObjectDefMinDistance(playerGoldID, 50.0);
   rmSetObjectDefMaxDistance(playerGoldID, 60.0);
   rmPlaceObjectDefPerPlayer(playerGoldID, false, 1);

   silverType = rmRandInt(1,10);
   int GoldMediumID=rmCreateObjectDef("player silver med");
   rmAddObjectDefItem(GoldMediumID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(GoldMediumID, avoidTradeRoute);
   rmAddObjectDefConstraint(GoldMediumID, avoidSocket);
   rmAddObjectDefConstraint(GoldMediumID, coinAvoidCoin);
   rmAddObjectDefConstraint(GoldMediumID, shortAvoidCanyons);
   rmAddObjectDefConstraint(GoldMediumID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(GoldMediumID, farPlayerConstraint);
   rmAddObjectDefConstraint(GoldMediumID, avoidAll);
   rmAddObjectDefConstraint(GoldMediumID, avoidWater10);
   rmSetObjectDefMinDistance(GoldMediumID, 85.0);
   rmSetObjectDefMaxDistance(GoldMediumID, 100.0);
   rmPlaceObjectDefPerPlayer(GoldMediumID, false, 1);

   // Text
   rmSetStatusText("",0.70);

// Extra tree clumps near players - to ensure fair access to wood
   int extraTreesID=rmCreateObjectDef("extra trees");
   rmAddObjectDefItem(extraTreesID, treeType, 4, 5.0);
   rmSetObjectDefMinDistance(extraTreesID, 14);
   rmSetObjectDefMaxDistance(extraTreesID, 18);
   rmAddObjectDefConstraint(extraTreesID, avoidAll);
   rmAddObjectDefConstraint(extraTreesID, avoidCoin);
   rmAddObjectDefConstraint(extraTreesID, avoidSocket);
   rmAddObjectDefConstraint(extraTreesID, avoidTradeRoute);
   for(i=1; <cNumberPlayers)
      rmPlaceObjectDefInArea(extraTreesID, 0, rmAreaID("player"+i), 2);

   int extraTrees2ID=rmCreateObjectDef("more extra trees");
   rmAddObjectDefItem(extraTrees2ID, treeType, 5, 6.0);
   rmSetObjectDefMinDistance(extraTrees2ID, 18);
   rmSetObjectDefMaxDistance(extraTrees2ID, 28);
   rmAddObjectDefConstraint(extraTrees2ID, avoidAll);
   rmAddObjectDefConstraint(extraTrees2ID, avoidCoin);
   rmAddObjectDefConstraint(extraTrees2ID, avoidSocket);
   rmAddObjectDefConstraint(extraTrees2ID, avoidTradeRoute);
   for(i=1; <cNumberPlayers)
      rmPlaceObjectDefInArea(extraTrees2ID, 0, rmAreaID("player"+i), 2);

// Central forests for highlands, canyons
   int coverForestPatchID = 0;
   if (clearCenter < 1)
	makeCentralForestPatch = 1; 
   if (clearCenter == 1)
   {
	if (makeCentralCanyon == 1)
	   makeCentralForestPatch = 1; 
   }
   if (mtForest < 1)
	makeCentralForestPatch = 0; 
   if (makeCentralCliffArea == 1) // forest for central highlands or canyons
   {
      if (makeCentralForestPatch == 1)
      {  
          numTries=2*cNumberNonGaiaPlayers;
          for (i=0; <numTries)
          { 
             int forestPatchID = rmCreateArea("forest patch"+i, rmAreaID("center highlands"));
             rmAddAreaToClass(forestPatchID, rmClassID("classForest"));
             rmSetAreaWarnFailure(forestPatchID, false);
             rmSetAreaSize(forestPatchID, rmAreaTilesToFraction(80), rmAreaTilesToFraction(150));
             rmSetAreaCoherence(forestPatchID, 0.6);
        	 if (patternChance == 8)
	      	rmSetAreaForestType(forestPatchID, "rockies snow forest");
		 else 
      	      rmSetAreaForestType(forestPatchID, forestType);
             rmSetAreaForestDensity(forestPatchID, 0.6);
             rmSetAreaForestClumpiness(forestPatchID, 0.9);
             rmSetAreaForestUnderbrush(forestPatchID, 0.2);
             rmSetAreaCoherence(forestPatchID, 0.4);
             rmSetAreaSmoothDistance(forestPatchID, 10);
             rmAddAreaConstraint(forestPatchID, avoidAll);
             rmAddAreaConstraint(forestPatchID, avoidTradeRoute);
	       rmAddAreaConstraint(forestPatchID, avoidSocket);
	       rmAddAreaConstraint(forestPatchID, avoidNativesShort);
             rmBuildArea(forestPatchID);

	       if (forestCoverUp == 1)
	       {
                coverForestPatchID = rmCreateArea("central forest patch"+i, rmAreaID("forest patch"+i));   
                rmSetAreaWarnFailure(coverForestPatchID, false);
                rmSetAreaSize(coverForestPatchID, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
                rmSetAreaCoherence(coverForestPatchID, 0.99);
		    rmSetAreaMix(coverForestPatchID, baseType);
	          rmBuildArea(coverForestPatchID);
	       }
	   }
      }       
   }
   else if (patternChance == 8) // for 1 central mt on Rockies
   {
	if (numMt == 1)
	{
         numTries=2*cNumberNonGaiaPlayers;
    	   if (cNumberNonGaiaPlayers > 4)
	       numTries=cNumberNonGaiaPlayers + 2;
         for (i=0; <numTries)
         { 
         int snowForestPatchID = rmCreateArea("snow forest patch"+i, rmAreaID("mt patch"+0));
         rmAddAreaToClass(snowForestPatchID, rmClassID("classForest"));
         rmSetAreaWarnFailure(snowForestPatchID, false);
         rmSetAreaSize(snowForestPatchID, rmAreaTilesToFraction(170), rmAreaTilesToFraction(220));
         rmSetAreaCoherence(snowForestPatchID, 0.6);
         rmSetAreaForestType(snowForestPatchID, "rockies snow forest");
         rmSetAreaForestDensity(snowForestPatchID, 1.0);
         rmSetAreaForestClumpiness(snowForestPatchID, 0.9);
         rmSetAreaForestUnderbrush(snowForestPatchID, 0.0);
         rmSetAreaCoherence(snowForestPatchID, 0.4);
         rmSetAreaSmoothDistance(snowForestPatchID, 10);
         rmAddAreaConstraint(snowForestPatchID, avoidAll);
         rmAddAreaConstraint(snowForestPatchID, avoidTradeRoute);
	   rmAddAreaConstraint(snowForestPatchID, avoidSocket);
	   rmAddAreaConstraint(snowForestPatchID, avoidNativesShort);
         rmBuildArea(snowForestPatchID);
         }
	}
   }

// Clearings
   if (bonusForest == 1)
	clearCenter = 0;

   if (clearCenter < 1)
   {
      for (i=0; <cNumberNonGaiaPlayers*3)   
      {
	   int forestClearing=rmCreateArea("forest clearing "+i);
	   rmSetAreaWarnFailure(forestClearing, false);
	   rmSetAreaSize(forestClearing, rmAreaTilesToFraction(200), rmAreaTilesToFraction(300));
	   rmSetAreaMix(forestClearing, baseType);
	   rmAddAreaToClass(forestClearing, rmClassID("classClearing"));
	   rmSetAreaMinBlobs(forestClearing, 1);
	   rmSetAreaMaxBlobs(forestClearing, 3);
	   rmSetAreaMinBlobDistance(forestClearing, 6.0);
	   rmSetAreaMaxBlobDistance(forestClearing, 16.0);
	   rmSetAreaCoherence(forestClearing, 0.6);
	   rmSetAreaSmoothDistance(forestClearing, 10);
	   rmAddAreaConstraint(forestClearing, shortAvoidImpassableLand);
	   rmAddAreaConstraint(forestClearing, avoidClearing);
	   rmAddAreaConstraint(forestClearing, farPlayerConstraint);
	   rmAddAreaConstraint(forestClearing, patchConstraint);
	   rmBuildArea(forestClearing); 
      }
   }

   // Text
   rmSetStatusText("",0.75);

// Main forests
   int forestChance = -1;
   numTries=21*cNumberNonGaiaPlayers;
   if (cNumberNonGaiaPlayers > 3)
      numTries=19*cNumberNonGaiaPlayers;  
   if (cNumberNonGaiaPlayers > 5)
      numTries=17*cNumberNonGaiaPlayers;  
   if (cNumberNonGaiaPlayers > 7)
      numTries=15*cNumberNonGaiaPlayers; 

   if (bonusForest == 1)
   {
      numTries=24*cNumberNonGaiaPlayers;
      if (cNumberNonGaiaPlayers > 3)
         numTries=22*cNumberNonGaiaPlayers;  
      if (cNumberNonGaiaPlayers > 5)
         numTries=19*cNumberNonGaiaPlayers;  
      if (cNumberNonGaiaPlayers > 7)
         numTries=17*cNumberNonGaiaPlayers;    
   }

   if (reducedForest == 1)
   {
      numTries=19*cNumberNonGaiaPlayers;
      if (cNumberNonGaiaPlayers > 3)
         numTries=17*cNumberNonGaiaPlayers;  
      if (cNumberNonGaiaPlayers > 5)
         numTries=14*cNumberNonGaiaPlayers;  
      if (cNumberNonGaiaPlayers > 7)
         numTries=12*cNumberNonGaiaPlayers;    
   }

   if (clearCenter == 1)
   {
      numTries=18*cNumberNonGaiaPlayers;
      if (cNumberNonGaiaPlayers > 3)
         numTries=16*cNumberNonGaiaPlayers;  
      if (cNumberNonGaiaPlayers > 5)
         numTries=13*cNumberNonGaiaPlayers;  
      if (cNumberNonGaiaPlayers > 7)
         numTries=11*cNumberNonGaiaPlayers;   
   }

   failCount=0;
   for (i=0; <numTries)
   {
      forestChance = rmRandInt(1,4);
      int forest=rmCreateArea("forest "+i);
      rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(300));
      rmSetAreaForestType(forest, forestType);
      rmSetAreaForestDensity(forest, rmRandFloat(0.7, 1.0));
      rmSetAreaForestClumpiness(forest, rmRandFloat(0.5, 0.9));
      rmSetAreaForestUnderbrush(forest, rmRandFloat(0.0, 0.5));
      rmSetAreaCoherence(forest, rmRandFloat(0.4, 0.7));
      rmSetAreaSmoothDistance(forest, rmRandInt(10,20));
      if (forestChance == 3)
      {
		rmSetAreaMinBlobs(forest, 1);
		rmSetAreaMaxBlobs(forest, 3);					
		rmSetAreaMinBlobDistance(forest, 12.0);
		rmSetAreaMaxBlobDistance(forest, 24.0);
	}
      if (forestChance == 4)
      {
		rmSetAreaMinBlobs(forest, 3);
		rmSetAreaMaxBlobs(forest, 5);					
		rmSetAreaMinBlobDistance(forest, 16.0);
		rmSetAreaMaxBlobDistance(forest, 28.0);
		rmSetAreaSmoothDistance(forest, 120);
	}
      rmAddAreaToClass(forest, rmClassID("classForest")); 
	rmAddAreaConstraint(forest, mediumPlayerConstraint);
      rmAddAreaConstraint(forest, forestConstraint);
      rmAddAreaConstraint(forest, avoidAll); 
	rmAddAreaConstraint(forest, avoidCoin);  
	rmAddAreaConstraint(forest, avoidMts);
      rmAddAreaConstraint(forest, avoidImpassableLand); 
      rmAddAreaConstraint(forest, avoidTradeRoute);
	rmAddAreaConstraint(forest, avoidStartingUnits);
	rmAddAreaConstraint(forest, avoidSocket);
	rmAddAreaConstraint(forest, avoidNativesShort);
	rmAddAreaConstraint(forest, hillConstraint);
	rmAddAreaConstraint(forest, avoidClearing);
	if (patternChance == 12)
	   rmAddAreaConstraint(forest, avoidSea);
	if (noCliffForest == 1)
	   rmAddAreaConstraint(forest, avoidCliffsShort);
      if (clearCenter == 1)
	{
	   if (cNumberNonGaiaPlayers > 3)
	   {
		if (rmRandInt(1,2) == 1) 
	         rmAddAreaConstraint(forest, centerConstraintForest);
		else
		   rmAddAreaConstraint(forest, centerConstraintForest2);
	   }
	   else
	   {
		if (rmRandInt(1,2) == 1) 
	         rmAddAreaConstraint(forest, centerConstraintForest3);
		else
		   rmAddAreaConstraint(forest, centerConstraintForest2);
	   }
	}
      else
	{
	   if (makeCentralCliffArea == 1)
   	      rmAddAreaConstraint(forest, centerConstraintShort);
	}
	if (hillTrees == 1)
	{
	   if (rmRandInt(1,3) > 1)
            rmSetAreaBaseHeight(forest, rmRandFloat(3.5, 5.0));
	}
      if(rmBuildArea(forest)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
            break;
      }
      else
         failCount=0; 

	   if (forestCoverUp == 1)
	   {
            coverForestPatchID = rmCreateArea("cover forest patch"+i, rmAreaID("forest "+i));   
            rmSetAreaWarnFailure(coverForestPatchID, false);
            rmSetAreaSize(coverForestPatchID, rmAreaTilesToFraction(340), rmAreaTilesToFraction(340));
            rmSetAreaCoherence(coverForestPatchID, 0.99);
		rmSetAreaMix(coverForestPatchID, baseType);
	      rmBuildArea(coverForestPatchID);
	   }
   } 

   // Text
   rmSetStatusText("",0.80);

// Extra silver mines - more central.
   silverType = rmRandInt(1,10);
   int extraGoldID = rmCreateObjectDef("extra silver "+i);
   if (placeGold == 5)
      rmAddObjectDefItem(extraGoldID, "minegold", 1, 0);
   else
      rmAddObjectDefItem(extraGoldID, "mine", 1, 0.0);
   rmAddObjectDefToClass(extraGoldID, rmClassID("importantItem"));
   rmAddObjectDefConstraint(extraGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(extraGoldID, avoidSocket);
   rmAddObjectDefConstraint(extraGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(extraGoldID, shortAvoidCanyons);
   rmAddObjectDefConstraint(extraGoldID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(extraGoldID, avoidWater10);
   rmAddObjectDefConstraint(extraGoldID, avoidMts);
   rmAddObjectDefConstraint(extraGoldID, avoidAll);
   rmSetObjectDefMinDistance(extraGoldID, 0.0);
   if (makeIce == 1)
   {
      rmSetObjectDefMaxDistance(extraGoldID, 115.0);
      rmAddObjectDefConstraint(extraGoldID, avoidIce);
      rmAddObjectDefConstraint(extraGoldID, centerConstraintFar);
   }
   else if (makeLake == 1)
   {
      rmSetObjectDefMaxDistance(extraGoldID, 115.0);
	rmAddObjectDefConstraint(extraGoldID, centerConstraintFar);
   }
   else
      rmSetObjectDefMaxDistance(extraGoldID, 90.0);
   rmPlaceObjectDefAtLoc(extraGoldID, 0, 0.5, 0.5, rmRandInt(1,2));
   if (cNumberNonGaiaPlayers > 4)
      rmPlaceObjectDefAtLoc(extraGoldID, 0, 0.5, 0.5, 1);
   if (axisChance == 1)
   {
      rmPlaceObjectDefAtLoc(extraGoldID, 0, 0.49, 0.78, 1);
      rmPlaceObjectDefAtLoc(extraGoldID, 0, 0.51, 0.22, 1);
   }
   else
   {
      rmPlaceObjectDefAtLoc(extraGoldID, 0, 0.78, 0.51, 1);
      rmPlaceObjectDefAtLoc(extraGoldID, 0, 0.22, 0.49, 1);
   }

   silverType = rmRandInt(1,10);
   int GoldFarID=rmCreateObjectDef("player silver far");
   if (placeGold == 1)
      rmAddObjectDefItem(GoldFarID, "minegold", 1, 0);
   else
      rmAddObjectDefItem(GoldFarID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(GoldFarID, avoidTradeRoute);
   rmAddObjectDefConstraint(GoldFarID, avoidSocket);
   rmAddObjectDefConstraint(GoldFarID, coinAvoidCoin);
   rmAddObjectDefConstraint(GoldFarID, shortAvoidCanyons);
   rmAddObjectDefConstraint(GoldFarID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(GoldFarID, avoidAll);
   rmAddObjectDefConstraint(GoldFarID, fartherPlayerConstraint);
   rmAddObjectDefConstraint(GoldFarID, centerConstraintFar);
   rmAddObjectDefConstraint(GoldFarID, avoidWater10);
   rmAddObjectDefConstraint(GoldFarID, avoidIce);
   rmSetObjectDefMinDistance(GoldFarID, 125.0);
   rmSetObjectDefMaxDistance(GoldFarID, 170.0);
   if (rmRandInt(1,3) == 1)
      rmPlaceObjectDefPerPlayer(GoldFarID, false, 2);
   else
      rmPlaceObjectDefPerPlayer(GoldFarID, false, 1);

// sheep etc
   if (sheepChance > 0)
   {
      int sheepID=rmCreateObjectDef("herdable animal");
      rmAddObjectDefItem(sheepID, sheepType, 2, 4.0);
      rmAddObjectDefToClass(sheepID, rmClassID("herdableFood"));
      rmSetObjectDefMinDistance(sheepID, 40.0);
      rmSetObjectDefMaxDistance(sheepID, 0.25*longSide);
      rmAddObjectDefConstraint(sheepID, avoidSheep);
      rmAddObjectDefConstraint(sheepID, avoidAll);
      rmAddObjectDefConstraint(sheepID, playerConstraint);
      rmAddObjectDefConstraint(sheepID, avoidCliffs);
      rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
      rmPlaceObjectDefPerPlayer(sheepID, false, 2);

      rmAddObjectDefConstraint(sheepID, farPlayerConstraint);
      rmSetObjectDefMaxDistance(sheepID, 0.35*longSide);
      if (rmRandInt(1,2) == 1)
         rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
      else 
         rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3); 
   }

   // Text
   rmSetStatusText("",0.85);

// Central herds
   int centralHerdID=rmCreateObjectDef("central herd");  
   rmAddObjectDefItem(centralHerdID, centerHerdType, rmRandInt(7,9), 6.0);
   rmAddObjectDefToClass(centralHerdID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(centralHerdID, 0.05*size);
   rmSetObjectDefMaxDistance(centralHerdID, 0.15*size);
   rmAddObjectDefConstraint(centralHerdID, avoidTradeRoute);
   rmAddObjectDefConstraint(centralHerdID, avoidImportantItem);
   rmAddObjectDefConstraint(centralHerdID, avoidWater10);
   rmAddObjectDefConstraint(centralHerdID, avoidIce);
   rmAddObjectDefConstraint(centralHerdID, farPlayerConstraint);
   rmAddObjectDefConstraint(centralHerdID, longHuntableConstraint);
   rmAddObjectDefConstraint(centralHerdID, avoidMts);
   rmSetObjectDefCreateHerd(centralHerdID, true);
   rmPlaceObjectDefAtLoc(centralHerdID, 0, 0.5, 0.5, 2);
   // additional of central herd type
   rmAddObjectDefConstraint(centralHerdID, fartherPlayerConstraint);
   rmSetObjectDefMinDistance(centralHerdID, 0.15*size);
   rmSetObjectDefMaxDistance(centralHerdID, 0.3*size);
   rmPlaceObjectDefPerPlayer(centralHerdID, false, 1);

// far huntable
   int farHuntableID=rmCreateObjectDef("far huntable");
   rmAddObjectDefItem(farHuntableID, deerType, rmRandInt(5,9), 6.0);
   rmAddObjectDefToClass(farHuntableID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(farHuntableID, 0.2*size);
   rmSetObjectDefMaxDistance(farHuntableID, 0.3*size);
   rmAddObjectDefConstraint(farHuntableID, avoidTradeRoute);
   rmAddObjectDefConstraint(farHuntableID, avoidImportantItem);
   rmAddObjectDefConstraint(farHuntableID, avoidWater10);
   rmAddObjectDefConstraint(farHuntableID, fartherPlayerConstraint);
   rmAddObjectDefConstraint(farHuntableID, longHuntableConstraint);
   rmAddObjectDefConstraint(farHuntableID, avoidAll);
   rmAddObjectDefConstraint(farHuntableID, avoidMts);
   rmAddObjectDefConstraint(farHuntableID, avoidIce);
   rmSetObjectDefCreateHerd(farHuntableID, true);
   rmPlaceObjectDefPerPlayer(farHuntableID, false, 1);

// Lone elk
   int loneElkID=rmCreateObjectDef("lone elk");
   threeChoice = rmRandInt(1,3);
   if (threeChoice == 1)
      rmAddObjectDefItem(loneElkID, centerHerdType, rmRandInt(1,2), 3.0);
   else if (threeChoice == 2)
      rmAddObjectDefItem(loneElkID, deer2Type, rmRandInt(1,2), 3.0);
   else
      rmAddObjectDefItem(loneElkID, deerType, rmRandInt(1,2), 3.0);
   rmAddObjectDefToClass(loneElkID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(loneElkID, 70.0);
   rmSetObjectDefMaxDistance(loneElkID, 0.4*size);
   rmAddObjectDefConstraint(loneElkID, longPlayerConstraint);
   rmAddObjectDefConstraint(loneElkID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(loneElkID, avoidNativesShort);
   rmAddObjectDefConstraint(loneElkID, huntableConstraint);
   rmAddObjectDefConstraint(loneElkID, avoidAll);
   rmSetObjectDefCreateHerd(loneElkID, true);
   rmPlaceObjectDefPerPlayer(loneElkID, false, 2);

   // Text
   rmSetStatusText("",0.90);

// Random trees
   int StragglerTreeID=rmCreateObjectDef("stragglers");
   rmAddObjectDefItem(StragglerTreeID, treeType, 1, 0.0);
   rmAddObjectDefConstraint(StragglerTreeID, avoidAll);
   rmAddObjectDefConstraint(StragglerTreeID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(StragglerTreeID, hillConstraint);
   rmAddObjectDefConstraint(StragglerTreeID, avoidCoin);
   rmAddObjectDefConstraint(StragglerTreeID, patchConstraint);
   rmAddObjectDefConstraint(StragglerTreeID, avoidWater10);
   rmAddObjectDefConstraint(StragglerTreeID, avoidMts);
   rmSetObjectDefMinDistance(StragglerTreeID, 10.0);
   rmSetObjectDefMaxDistance(StragglerTreeID, rmXFractionToMeters(0.5));
   for(i=0; <cNumberNonGaiaPlayers*16)
      rmPlaceObjectDefAtLoc(StragglerTreeID, 0, 0.5, 0.5);
   if ((bonusForest == 1) || (tropicalMap == 1)) 
   {
      for(i=0; <cNumberNonGaiaPlayers*9)
         rmPlaceObjectDefAtLoc(StragglerTreeID, 0, 0.5, 0.5);
   }

// Fish
   int fishNum = cNumberNonGaiaPlayers * rmRandInt(3,5);
   if (cNumberNonGaiaPlayers > 3)
	fishNum = cNumberNonGaiaPlayers * rmRandInt(2,3);
   int fishID=rmCreateObjectDef("fish");
   int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 22.0);
   int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
   rmAddObjectDefItem(fishID, fishType, 1, 5.0);
   rmAddObjectDefConstraint(fishID, fishVsFishID);
   rmAddObjectDefConstraint(fishID, fishLand);
   rmSetObjectDefMinDistance(fishID, 0.0);
   rmSetObjectDefMaxDistance(fishID, 0.25*size);

   for(i=0; <fishNum)
   { 
      rmPlaceObjectDefInArea(fishID, 0, rmAreaID("first sea"), rmRandInt(1,2));
      rmPlaceObjectDefInArea(fishID, 0, rmAreaID("second sea"), rmRandInt(1,2));
   }
   rmPlaceObjectDefInArea(fishID, 0, rmAreaID("first sea"), 2);
   rmPlaceObjectDefInArea(fishID, 0, rmAreaID("second sea"), 2);

   if (makeRiver == 1) // fish for the 'amazon river' 
   {
      if ((patternChance == 1) || (patternChance == 2) || (patternChance == 4) || (patternChance == 9) || (patternChance == 11) || (patternChance == 14) || (patternChance == 16)) 
	   makeLakefish = 1;
   } 

   if (makeLake == 1)
      makeLakefish = 1; 

   if (makeLakefish == 1)
   {
      int lakeFishID=rmCreateObjectDef("lake fish");
      rmAddObjectDefItem(lakeFishID, lakeFishType, 1, 5.0);
      rmSetObjectDefMinDistance(lakeFishID, 0.0);
      rmSetObjectDefMaxDistance(lakeFishID, 25.0);
	if(makeLake == 1)
	{
         rmAddObjectDefConstraint(lakeFishID, fishLand);
	   if (lakePattern < 3)	
            rmPlaceObjectDefInArea(lakeFishID, 0, rmAreaID("small lake"), cNumberNonGaiaPlayers + rmRandInt(2,5));
	   else
            rmPlaceObjectDefInArea(lakeFishID, 0, rmAreaID("small lake"), cNumberNonGaiaPlayers + rmRandInt(6,8));
	}
	else
	{
         rmSetObjectDefMaxDistance(lakeFishID, 45.0);
	   rmPlaceObjectDefAtLoc(lakeFishID, 0, 0.5, 0.2, rmRandInt(1,3)); 
	   rmPlaceObjectDefAtLoc(lakeFishID, 0, 0.5, 0.4, rmRandInt(1,3)); 
	   rmPlaceObjectDefAtLoc(lakeFishID, 0, 0.5, 0.6, rmRandInt(1,3)); 
	   rmPlaceObjectDefAtLoc(lakeFishID, 0, 0.5, 0.8, rmRandInt(1,3)); 
	} 
   }

// Whales
   int whaleNum = cNumberNonGaiaPlayers + rmRandInt(1,3);
   int whaleID=rmCreateObjectDef("whale");
   int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 18.0);
   int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", whaleType, 40.0);
   rmAddObjectDefItem(whaleID, whaleType, 1, 5.0);
//   rmSetObjectDefMinDistance(whaleID, 0.0);
//   rmSetObjectDefMaxDistance(whaleID, 0.25*size);

   rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
   rmAddObjectDefConstraint(whaleID, whaleLand);
   rmAddObjectDefConstraint(whaleID, centerConstraintFar);
   rmPlaceObjectDefInArea(whaleID, 0, rmAreaID("first sea"), whaleNum);
   rmPlaceObjectDefInArea(whaleID, 0, rmAreaID("second sea"), whaleNum);

   // Text
   rmSetStatusText("",0.95);

// Deco
   // Patches using mixes
   if (makePatchMix == 1)
   {
      for (i=0; <cNumberNonGaiaPlayers*8)   
      {
	   int colorPatch=rmCreateArea("color patch "+i);
	   rmSetAreaWarnFailure(colorPatch, false);
	   rmSetAreaSize(colorPatch, rmAreaTilesToFraction(250), rmAreaTilesToFraction(400));
         rmSetAreaMix(colorPatch, patchMixType);
	   rmAddAreaToClass(colorPatch, rmClassID("classPatch"));
	   rmSetAreaMinBlobs(colorPatch, 1);
	   rmSetAreaMaxBlobs(colorPatch, 5);
	   rmSetAreaMinBlobDistance(colorPatch, 16.0);
	   rmSetAreaMaxBlobDistance(colorPatch, 36.0);
	   rmSetAreaCoherence(colorPatch, 0.1);
	   rmSetAreaSmoothDistance(colorPatch, 10);
	   rmAddAreaConstraint(colorPatch, shortAvoidImpassableLand);
	   rmAddAreaConstraint(colorPatch, patchConstraint);
	   rmAddAreaConstraint(colorPatch, avoidWater20);
	   rmAddAreaConstraint(colorPatch, shortForestConstraint);
	   rmBuildArea(colorPatch); 
      }

      for (i=0; <cNumberNonGaiaPlayers*12)   
      {
	   int colorPatch2=rmCreateArea("2nd color patch "+i);
	   rmSetAreaWarnFailure(colorPatch2, false);
	   rmSetAreaSize(colorPatch2, rmAreaTilesToFraction(60), rmAreaTilesToFraction(150));
         rmSetAreaMix(colorPatch2, patchMixType);
	   rmAddAreaToClass(colorPatch2, rmClassID("classPatch"));
	   rmSetAreaMinBlobs(colorPatch2, 1);
	   rmSetAreaMaxBlobs(colorPatch2, 3);
	   rmSetAreaMinBlobDistance(colorPatch2, 10.0);
	   rmSetAreaMaxBlobDistance(colorPatch2, 20.0);
	   rmSetAreaCoherence(colorPatch2, 0.1);
	   rmSetAreaSmoothDistance(colorPatch2, 10);
	   rmAddAreaConstraint(colorPatch2, shortAvoidImpassableLand);
	   rmAddAreaConstraint(colorPatch2, patchConstraint);
	   rmAddAreaConstraint(colorPatch2, avoidWater20);
	   rmAddAreaConstraint(colorPatch2, shortForestConstraint);
	   rmBuildArea(colorPatch2); 
      }
   }

   // Dirt patches for Carolina
   if (patternChance == 2)
   {
	if (variantChance == 2)
	{
	   for (i=0; <cNumberNonGaiaPlayers*16)   
         {
		int dirtPatchC=rmCreateArea("carolina dirt patch "+i);
		rmSetAreaWarnFailure(dirtPatchC, false);
		rmSetAreaSize(dirtPatchC, rmAreaTilesToFraction(160), rmAreaTilesToFraction(260));
		rmSetAreaTerrainType(dirtPatchC, "carolina\ground_grass4_car");
		rmAddAreaToClass(dirtPatchC, rmClassID("classPatch"));
		rmSetAreaMinBlobs(dirtPatchC, 3);
		rmSetAreaMaxBlobs(dirtPatchC, 5);
		rmSetAreaMinBlobDistance(dirtPatchC, 16.0);
		rmSetAreaMaxBlobDistance(dirtPatchC, 36.0);
		rmSetAreaCoherence(dirtPatchC, 0.0);
		rmSetAreaSmoothDistance(dirtPatchC, 10);
		rmAddAreaConstraint(dirtPatchC, shortAvoidImpassableLand);
		rmAddAreaConstraint(dirtPatchC, patchConstraint);
	      rmAddAreaConstraint(dirtPatchC, shortForestConstraint);
		rmBuildArea(dirtPatchC); 
	   }
      }
   }

   // Patches for Great Plains 1 - flowers
   if (patternChance == 9)
   {
      for (i=0; <cNumberNonGaiaPlayers*45)   
      {
	   int gpPatch2=rmCreateArea("GP patch "+i);
	   rmSetAreaWarnFailure(gpPatch2, false);
	   rmSetAreaSize(gpPatch2, rmAreaTilesToFraction(50), rmAreaTilesToFraction(90));
	   if (rmRandInt(1,2) == 1)
	      rmSetAreaTerrainType(gpPatch2, "great_lakes\ground_grass4_gl");
	   else
	      rmSetAreaTerrainType(gpPatch2, "great_lakes\ground_grass5_gl");
	   rmAddAreaToClass(gpPatch2, rmClassID("classPatch"));
	   rmSetAreaMinBlobs(gpPatch2, 2);
	   rmSetAreaMaxBlobs(gpPatch2, 4);
	   rmSetAreaMinBlobDistance(gpPatch2, 12.0);
	   rmSetAreaMaxBlobDistance(gpPatch2, 18.0);
	   rmSetAreaCoherence(gpPatch2, 0.1);
	   rmSetAreaSmoothDistance(gpPatch2, 10);
	   rmAddAreaConstraint(gpPatch2, shortAvoidImpassableLand);
	   rmAddAreaConstraint(gpPatch2, patchConstraint);
	   rmAddAreaConstraint(gpPatch2, avoidCliffsShort);
	   rmBuildArea(gpPatch2); 
      }
   }

   // Patches for Great Plains 2 - break up the lines!
   if (patternChance == 10)
   {
      for (i=0; <cNumberNonGaiaPlayers*25)   
      {
	   int gpPatchA=rmCreateArea("GP patch A"+i);
	   rmSetAreaWarnFailure(gpPatchA, false);
	   rmSetAreaSize(gpPatchA, rmAreaTilesToFraction(75), rmAreaTilesToFraction(140));
         rmSetAreaTerrainType(gpPatchA, "great_plains\ground2_gp");
	   rmAddAreaToClass(gpPatchA, rmClassID("classPatch"));
	   rmSetAreaMinBlobs(gpPatchA, 2);
	   rmSetAreaMaxBlobs(gpPatchA, 4);
	   rmSetAreaMinBlobDistance(gpPatchA, 5.0);
	   rmSetAreaMaxBlobDistance(gpPatchA, 12.0);
	   rmSetAreaCoherence(gpPatchA, 0.3);
	   rmSetAreaSmoothDistance(gpPatchA, 10);
	   rmAddAreaConstraint(gpPatchA, shortAvoidImpassableLand);
	   rmAddAreaConstraint(gpPatchA, avoidCliffsShort);
	   rmAddAreaConstraint(gpPatchA, patchConstraint);
	   rmBuildArea(gpPatchA); 
      }
      for (i=0; <cNumberNonGaiaPlayers*20)   // little green patches
      {
	   int gpPatchC=rmCreateArea("GP patch C"+i);
	   rmSetAreaWarnFailure(gpPatchC, false);
	   rmSetAreaSize(gpPatchC, rmAreaTilesToFraction(15), rmAreaTilesToFraction(40));
         rmSetAreaTerrainType(gpPatchC, "great_plains\ground8_gp");
	   rmAddAreaToClass(gpPatchC, rmClassID("classPatch"));
	   rmSetAreaMinBlobs(gpPatchC, 2);
	   rmSetAreaMaxBlobs(gpPatchC, 4);
	   rmSetAreaMinBlobDistance(gpPatchC, 5.0);
	   rmSetAreaMaxBlobDistance(gpPatchC, 10.0);
	   rmSetAreaCoherence(gpPatchC, 0.1);
	   rmSetAreaSmoothDistance(gpPatchC, 10);
	   rmAddAreaConstraint(gpPatchC, shortAvoidImpassableLand);
	   rmAddAreaConstraint(gpPatchC, avoidCliffsShort);
	   rmAddAreaConstraint(gpPatchC, patchConstraint);
	   rmBuildArea(gpPatchC); 
      }
      for (i=0; <cNumberNonGaiaPlayers*25)   
      {
	   int gpPatchD=rmCreateArea("GP patch D"+i);
	   rmSetAreaWarnFailure(gpPatchD, false);
	   rmSetAreaSize(gpPatchD, rmAreaTilesToFraction(50), rmAreaTilesToFraction(70));
         rmSetAreaTerrainType(gpPatchD, "great_plains\ground3_gp");
	   rmAddAreaToClass(gpPatchD, rmClassID("classPatch"));
	   rmSetAreaMinBlobs(gpPatchD, 3);
	   rmSetAreaMaxBlobs(gpPatchD, 5);
	   rmSetAreaMinBlobDistance(gpPatchD, 12.0);
	   rmSetAreaMaxBlobDistance(gpPatchD, 20.0);
	   rmSetAreaCoherence(gpPatchD, 0.1);
	   rmSetAreaSmoothDistance(gpPatchD, 10);
	   rmAddAreaConstraint(gpPatchD, shortAvoidImpassableLand);
	   rmAddAreaConstraint(gpPatchD, avoidCliffsShort);
	   rmAddAreaConstraint(gpPatchD, patchConstraint);
	   rmBuildArea(gpPatchD); 
      }
   }

   if (patternChance == 3) // Bayou
   {	
	if (makeLake == 1)
	{
	int treeClumps = rmRandInt(4,8);
       for(i=1; < treeClumps)
	 {
	   int randomWaterTreeID=rmCreateObjectDef("random tree in water"+i);	
   	   rmAddObjectDefItem(randomWaterTreeID, "treeBayouMarsh", rmRandInt(3,7), 3.0);
	   rmSetObjectDefMinDistance(randomWaterTreeID, 0.0);
	   rmSetObjectDefMaxDistance(randomWaterTreeID, rmXFractionToMeters(0.1));
	   rmPlaceObjectDefInArea(randomWaterTreeID, 0, smalllakeID, rmRandInt(10,12));
	 } 

	int randomTurtlesID=rmCreateObjectDef("random turtles in water");
	rmAddObjectDefItem(randomTurtlesID, "propTurtles", 1, 3.0);
	rmSetObjectDefMinDistance(randomTurtlesID, 0.0);
	rmSetObjectDefMaxDistance(randomTurtlesID, rmXFractionToMeters(0.1));
	rmAddObjectDefConstraint(randomTurtlesID, nearShore);

	int randomWaterRocksID=rmCreateObjectDef("random rocks in water");
	rmAddObjectDefItem(randomWaterRocksID, "underbrushLake", rmRandInt(1,3), 3.0);
	rmSetObjectDefMinDistance(randomWaterRocksID, 0.0);
	rmSetObjectDefMaxDistance(randomWaterRocksID, rmXFractionToMeters(0.1));

	int randomDucksID=rmCreateObjectDef("random ducks in water");
	rmAddObjectDefItem(randomDucksID, "DuckFamily", 1, 0.0);
	rmSetObjectDefMinDistance(randomDucksID, 0.0);
	rmSetObjectDefMaxDistance(randomDucksID, rmXFractionToMeters(0.1));
	rmAddObjectDefConstraint(randomDucksID, avoidDucks);

	rmPlaceObjectDefInArea(randomTurtlesID, 0, smalllakeID, rmRandInt(1,2)); 
	rmPlaceObjectDefInArea(randomWaterRocksID, 0, smalllakeID, rmRandInt(1,2)); 
	rmPlaceObjectDefInArea(randomDucksID, 0, smalllakeID, rmRandInt(1,2)); 

       for (i=0; <cNumberNonGaiaPlayers*10)   
       {
	   rmPlaceObjectDefInRandomAreaOfClass(randomWaterTreeID, 0, lakeClass, rmRandInt(1,2));
	 }
	}
   }

   if (plainsMap == 1)
   {
	int areThereBuffalo=rmRandInt(1, 2);
	int howManyBuffalo=rmRandInt(2, 3);
	if ( areThereBuffalo == 1 )
	{
		int bisonCarcass=rmCreateGrouping("Bison Carcass", "gp_carcass_bison");
		rmSetGroupingMinDistance(bisonCarcass, 0.0);
		rmSetGroupingMaxDistance(bisonCarcass, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(bisonCarcass, avoidImpassableLand);
		rmAddGroupingConstraint(bisonCarcass, playerConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidTradeRoute);
		rmAddGroupingConstraint(bisonCarcass, avoidSocket);
		rmAddGroupingConstraint(bisonCarcass, avoidStartingUnits);
		rmAddGroupingConstraint(bisonCarcass, avoidAll);
		rmAddGroupingConstraint(bisonCarcass, avoidNuggetSmall);
		rmPlaceGroupingAtLoc(bisonCarcass, 0, 0.5, 0.5, howManyBuffalo);
	}

	int grassPatchGroupType=-1;
	int grassPatchGroup=-1;

	for(i=1; <18*cNumberNonGaiaPlayers)
      {
		grassPatchGroupType=rmRandInt(1, 7);
		grassPatchGroup=rmCreateGrouping("Grass Patch Group"+i, "gp_grasspatch0"+grassPatchGroupType);
		rmSetGroupingMinDistance(grassPatchGroup, 0.0);
		rmSetGroupingMaxDistance(grassPatchGroup, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(grassPatchGroup, avoidImpassableLand);
		rmAddGroupingConstraint(grassPatchGroup, playerConstraint);
		rmAddGroupingConstraint(grassPatchGroup, avoidTradeRoute);
		rmAddGroupingConstraint(grassPatchGroup, avoidSocket);
		rmAddGroupingConstraint(grassPatchGroup, avoidNatives);
		rmAddGroupingConstraint(grassPatchGroup, avoidNuggetSmall);
		rmAddGroupingConstraint(grassPatchGroup, playerEdgeConstraint);
		rmAddGroupingConstraint(grassPatchGroup, avoidStartingUnits);
		rmAddGroupingConstraint(grassPatchGroup, avoidAll);
		rmAddGroupingConstraint(grassPatchGroup, avoidCliffs);
		rmPlaceGroupingAtLoc(grassPatchGroup, 0, 0.5, 0.5, 1);
	}

	int flowerPatchGroupType=-1;
	int flowerPatchGroup=-1;

	for(i=1; <15*cNumberNonGaiaPlayers)
      {
		flowerPatchGroupType=rmRandInt(1, 8);
		flowerPatchGroup=rmCreateGrouping("Flower Patch Group"+i, "gp_flower0"+flowerPatchGroupType);
		rmSetGroupingMinDistance(flowerPatchGroup, 0.0);
		rmSetGroupingMaxDistance(flowerPatchGroup, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(flowerPatchGroup, avoidImpassableLand);
		rmAddGroupingConstraint(flowerPatchGroup, playerConstraint);
		rmAddGroupingConstraint(flowerPatchGroup, avoidTradeRoute);
		rmAddGroupingConstraint(flowerPatchGroup, avoidSocket);
		rmAddGroupingConstraint(flowerPatchGroup, avoidNatives);
		rmAddGroupingConstraint(flowerPatchGroup, avoidNuggetSmall);
		rmAddGroupingConstraint(flowerPatchGroup, avoidAll);
		rmAddGroupingConstraint(flowerPatchGroup, avoidCliffs);
		rmAddGroupingConstraint(flowerPatchGroup, playerEdgeConstraint);
		rmAddGroupingConstraint(flowerPatchGroup, avoidStartingUnits);
		rmPlaceGroupingAtLoc(flowerPatchGroup, 0, 0.5, 0.5, 1);
	}
   }

   if (geyserProp == 1)
   {
	int geyserID=rmCreateGrouping("Geysers", "prop_geyser");
      rmAddGroupingToClass(geyserID, rmClassID("allProps"));
	rmSetGroupingMinDistance(geyserID, 0.0);
	rmSetGroupingMaxDistance(geyserID, rmXFractionToMeters(0.5));
	rmAddGroupingConstraint(geyserID, avoidAll);
	rmAddGroupingConstraint(geyserID, avoidImpassableLand);
	rmAddGroupingConstraint(geyserID, avoidTradeRoute);
	rmAddGroupingConstraint(geyserID, avoidSocket);
	rmAddGroupingConstraint(geyserID, avoidNugget);
	rmAddGroupingConstraint(geyserID, avoidCliffs);
	rmAddGroupingConstraint(geyserID, avoidAllProps);
	rmAddGroupingConstraint(geyserID, avoidImportantItem);
	rmAddGroupingConstraint(geyserID, avoidWater20);
	rmAddGroupingConstraint(geyserID, longPlayerConstraint);
	rmPlaceGroupingAtLoc(geyserID, 0, 0.5, 0.5, 2);
   }

   if (texasProp == 1) 
   {
	int bigDecorationID=rmCreateObjectDef("Big Texas Things");
	rmAddObjectDefItem(bigDecorationID, "BigPropTexas", 1, 0.0);
      rmAddObjectDefToClass(bigDecorationID, rmClassID("allProps"));
	rmSetObjectDefMinDistance(bigDecorationID, 0.0);
	rmSetObjectDefMaxDistance(bigDecorationID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bigDecorationID, avoidAll);
	rmAddObjectDefConstraint(bigDecorationID, avoidImportantItem);
	rmAddObjectDefConstraint(bigDecorationID, avoidCoin);
	rmAddObjectDefConstraint(bigDecorationID, avoidImpassableLand);
	rmAddObjectDefConstraint(bigDecorationID, avoidTradeRoute);
	rmAddObjectDefConstraint(bigDecorationID, avoidCliffs);
	rmAddObjectDefConstraint(bigDecorationID, avoidAllProps);
	rmAddObjectDefConstraint(bigDecorationID, avoidWater20);
	rmAddObjectDefConstraint(bigDecorationID, longPlayerConstraint);
	rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.5, 0.5, rmRandInt(3,4));
   }

   if (vultures == 1)
   { 
	int vultureID=rmCreateObjectDef("perching vultures");
	rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
      rmAddObjectDefToClass(vultureID, rmClassID("allProps"));
	rmSetObjectDefMinDistance(vultureID, 0.0);
	rmSetObjectDefMaxDistance(vultureID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(vultureID, avoidAll);
	rmAddObjectDefConstraint(vultureID, avoidImportantItem);
	rmAddObjectDefConstraint(vultureID, avoidCoin);
	rmAddObjectDefConstraint(vultureID, avoidImpassableLand);
	rmAddObjectDefConstraint(vultureID, avoidTradeRoute);
	rmAddObjectDefConstraint(vultureID, avoidCliffs);
	rmAddObjectDefConstraint(vultureID, avoidAllProps);
	rmAddObjectDefConstraint(vultureID, avoidWater20);
	rmAddObjectDefConstraint(vultureID, longPlayerConstraint);
	rmPlaceObjectDefAtLoc(vultureID, 0, 0.5, 0.5, 3);
   }

   if (eagles == 1)
   {
	int randomEagleTreeID=rmCreateObjectDef("random eagle tree");
	rmAddObjectDefItem(randomEagleTreeID, "EaglesNest", 1, 0.0);
      rmAddObjectDefToClass(randomEagleTreeID, rmClassID("allProps"));
	rmSetObjectDefMinDistance(randomEagleTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomEagleTreeID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(randomEagleTreeID, avoidAll);
	rmAddObjectDefConstraint(randomEagleTreeID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(randomEagleTreeID, avoidAllProps);
      rmAddObjectDefConstraint(randomEagleTreeID, avoidImportantItem);
      rmAddObjectDefConstraint(randomEagleTreeID, longPlayerConstraint);
	rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.5, 0.5, 3);
   }

   if (eaglerock == 1)
   {
      int specialPropID=rmCreateObjectDef("eagle rock prop");
      rmAddObjectDefItem(specialPropID, "PropEaglesRocks", 1, 0.0);
      rmAddObjectDefToClass(specialPropID, rmClassID("allProps"));
      rmSetObjectDefMinDistance(specialPropID, 0.0);
      rmSetObjectDefMaxDistance(specialPropID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(specialPropID, avoidAll);
      rmAddObjectDefConstraint(specialPropID, avoidSocket);
      rmAddObjectDefConstraint(specialPropID, avoidTradeRoute);
      rmAddObjectDefConstraint(specialPropID, avoidAllProps);
      rmAddObjectDefConstraint(specialPropID, shortAvoidImpassableLand);
      rmAddObjectDefConstraint(specialPropID, avoidWater20);
      rmAddObjectDefConstraint(specialPropID, avoidImportantItem);
      rmAddObjectDefConstraint(specialPropID, longPlayerConstraint);
      rmPlaceObjectDefAtLoc(specialPropID, 0, 0.5, 0.5, rmRandInt(2,3));
   }

   if (kingfishers == 1)
   { 
      int specialProp2ID=rmCreateObjectDef("kingfisher prop");
      rmAddObjectDefItem(specialProp2ID, "PropKingfisher", 1, 0.0);
      rmAddObjectDefToClass(specialProp2ID, rmClassID("allProps"));
      rmSetObjectDefMinDistance(specialProp2ID, 0.0);
      rmSetObjectDefMaxDistance(specialProp2ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(specialProp2ID, avoidAll);
      rmAddObjectDefConstraint(specialProp2ID, avoidSocket);
      rmAddObjectDefConstraint(specialProp2ID, avoidTradeRoute);
      rmAddObjectDefConstraint(specialProp2ID, avoidAllProps);
      rmAddObjectDefConstraint(specialProp2ID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(specialProp2ID, avoidWater10);
      rmAddObjectDefConstraint(specialProp2ID, avoidImportantItem);
      rmAddObjectDefConstraint(specialProp2ID, longPlayerConstraint);
      rmPlaceObjectDefAtLoc(specialProp2ID, 0, 0.5, 0.5, rmRandInt(2,3));
   }

   if (patternChance == 13) // Sonora
   {
	int buzzardFlockID=rmCreateObjectDef("buzzards");
	rmAddObjectDefItem(buzzardFlockID, "BuzzardFlock", 1, 3.0);
      rmAddObjectDefToClass(buzzardFlockID, rmClassID("allProps"));
	rmSetObjectDefMinDistance(buzzardFlockID, 0.0);
	rmSetObjectDefMaxDistance(buzzardFlockID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(buzzardFlockID, avoidAllProps);
	rmAddObjectDefConstraint(buzzardFlockID, avoidSocket);
	rmAddObjectDefConstraint(buzzardFlockID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(buzzardFlockID, playerConstraint);
	rmPlaceObjectDefAtLoc(buzzardFlockID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
   }

   if (patternChance == 4) // GL
   {
	int avoidGrass=rmCreateTypeDistanceConstraint("avoids grass", "underbrushTexasGrass", 30.0);
   	int Grass=rmCreateObjectDef("grass");
	rmAddObjectDefItem(Grass, "underbrushTexasGrass", 1, 0.0);
	rmSetObjectDefMinDistance(Grass, 0.0);
	rmSetObjectDefMaxDistance(Grass, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(Grass, avoidAll);
	rmAddObjectDefConstraint(Grass, avoidImpassableLand);
	rmAddObjectDefConstraint(Grass, playerConstraint);
	rmPlaceObjectDefAtLoc(Grass, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);
   }
   
   if (patternChance == 17) // Pampas
   {
      for (i=0; <15*cNumberNonGaiaPlayers)
      {
         int pampasPatch=rmCreateArea("pampas patch "+i);
         rmSetAreaWarnFailure(pampasPatch, false);
         rmAddAreaToClass(pampasPatch, rmClassID("classPatch"));
	   rmSetAreaSize(pampasPatch, rmAreaTilesToFraction(150), rmAreaTilesToFraction(500));
	   rmSetAreaTerrainType(pampasPatch, "pampas\ground4_pam");
         rmAddAreaTerrainLayer(pampasPatch, "pampas\ground5_pam", 0, 3);
         rmAddAreaTerrainLayer(pampasPatch, "pampas\ground6_pam", 3, 6);
         rmSetAreaMinBlobs(pampasPatch, 1);
         rmSetAreaMaxBlobs(pampasPatch, 5);
         rmSetAreaMinBlobDistance(pampasPatch, 12.0);
         rmSetAreaMaxBlobDistance(pampasPatch, 36.0);
         rmSetAreaCoherence(pampasPatch, 0.3);
	   rmSetAreaSmoothDistance(pampasPatch, 10);
	   rmAddAreaConstraint(pampasPatch, shortAvoidImpassableLand);
	   rmAddAreaConstraint(pampasPatch, avoidWater20);
	   rmAddAreaConstraint(pampasPatch, patchConstraint);
         rmBuildArea(pampasPatch); 
      }

	int avoidBrush=rmCreateTypeDistanceConstraint("avoids brush", "UnderbrushPampas", 30.0);
	int decoUnderbrushID=rmCreateObjectDef("underbrush");
	rmAddObjectDefItem(decoUnderbrushID, "UnderbrushPampas", rmRandInt(4,6), 3.0);
	rmSetObjectDefMinDistance(decoUnderbrushID, 20.0);
	rmSetObjectDefMaxDistance(decoUnderbrushID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(decoUnderbrushID, avoidAll);
	rmAddObjectDefConstraint(decoUnderbrushID, avoidImpassableLand);
	rmAddObjectDefConstraint(decoUnderbrushID, playerConstraint);
	rmAddObjectDefConstraint(decoUnderbrushID, avoidBrush);
	rmAddObjectDefConstraint(decoUnderbrushID, avoidTradeRoute);
      rmPlaceObjectDefAtLoc(decoUnderbrushID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);
   }

   // Text
   rmSetStatusText("",0.99);

}