
include "mercenaries.xs";

void main(void)
{  
int version = 20061231;
/* 

Dogleg Islands by Jugit. First working beta version made on 10 Feb 2006.
                         First working version made on 12 Feb 2006.
                         First uploadable version made on 22 Feb 2006.
                         First revision completed on 27 Feb 2006.
                         Second revision completed on 9 Mar 2006
                         Third revision completed on 4 May 2006.
                         Fourth revision completed on 31 Dec 2006.
Things revised:

Revision 20060227

Moved any center player's water flags from edge of map nearer to them.
Added native village and extra gold mine to any last odd player's small island.
Changed far silver mines to gold.
Fixed bugs with the water flag and nugget placement for Nomad.
Made a slightly larger difference between the random small or large map.
Added a few more huntables.
Added some eye candy.

Revision 20060309

Made the small map smaller and the large map larger, and added a medium map size. The size is a random pick.
Added some close huntables.
Added bonus islands.
Played with the nugget difficulty, which I couldn't get to work properly.
Added detail text to "dogleg islands.xml".
Added some more eye candy.

Revision 20060504

Fixed herdable pick. Trade sockets now avoid water. Added nuggets to bonus islands.
Added pirates. Added BFG. Randomized mines better. Added another terrain type.
Hopefully fixed nugget difficulty, based them on the map type and added player nuggets.
Added pirate booty on bonus islands (500-1500 coin, food or wood).
Added random wagon(fort, covered, outpost, or factory) and LOS and conversion triggers.
Added bool flags to select game options(use/don't use pirates, bonus islands, etc).

Revision 20061231

Fixed minor constraint problem with crates.
Added more crates of booty for larger maps.
Made map size vary evenly from normal to twice normal.
Resource amounts now range from poor to great.
Added shipwreck(coin source) to one of the bonus islands.
Split special props so you get two instead of only one.
Added rain, thunder and special lighting effects for finding the most herdables on an island. A lot of trouble for just a visual. Enjoy.
Added cherokee war hut with its reward.
Added ship reward for collecting nuggets. Disabled in Nomad start.
Added Ossuary with its cry havoc.
Added triggers to detect the presence of sockets, water flags, pirate ships and nomad units; which don't always place. Better now that forests were removed.
Added berries to bonus islands.
Added bonus island explorer/surgeon/canoe/privateer.
Played with adding sounds.
Added player weak triggers.
Added minimap flare for some triggers.
Added triggers to display messages from natives on resources left on the map.
Added quest sequence.
Added end game cutscene sequence.
Created Lone Wolf option.
Added more map types to get more and different types of nuggets.
Added quest herdable and livestock pen.
Added terrain, natives, etc for war chiefs.
Added small island native trading post socket.
Made all minor native tribes available and random. Only 5 at a time but all different.
Added small island wood factory and a occasional mining camp.
Added experience points for completing quests.
Lost track.

To do:

Check pirate ship movements again, especially after adding lone wolf.
Update index.
Reorder define objects with their placement order.
Update placement order.
Check and update any flags that need it.
Check treeCount and other counts.
Count triggers a final time. Figure out a true trigger count.
Think multiplayer for various triggers like TradingPost.
Check options for quest info.
Find something better than the white buffalo for quest info.
Check that triggers are not set when not used. Like camera if no quests.
Make special end game cutscene loop of island for lone wolf.
Revisit smaller island nuggets.
Check water flag location constraint for all combinations of players and Lone Wolf.
Check and take out constraints that aren't used.
Resolve/consolidate mine avoids.
Check addition of xp new ships for nugget quest like ironclad.
Update landing parties for natives and maybe add explorer wardog or envoy where appropriate.
Redo lost boat(bonusUnitType) sayings.
Check numbers of huntables, herdables, mines, and trees on lone island for 3, 5, and 7 players both lone wolf and not.
Review each quest for fun, completeness, appropriateness, etc.
Eliminate played native civilizations from sub civilizations.
Find something better than treasure tent, especially for natives.
Check logic of choices of the objects on the various map types.
Check numbers and balance use of natives and resources in type section.
Give every humnan player extra wood crates for nomad.
Review necessity of use flags.
Check all possibilities of start messages.
Do a complete check of constraints. Like mining camp(specialprop).

Index

I1.0 Constants and Initialization
     I1.10 Flags
           I1.11 Game flags
           I1.12 Major function flags
           I1.13 Preference flags
           I1.14 Map flags
           I1.15 Misc flags
           I1.16 Player name option flag changes.
     I1.20 Constants
     I1.30 Resource counts.
     I1.40 Island, elbow and player positions.
     I1.50 Pirate ship routes
     I1.60 Identify human players.
     I1.70 Select terrain and associated choices
     I1.80 Start native civilizations.
     I1.90 Define Classes.
I2.0 Constraints
     I2.1 Type Distance Constraints
     I2.2 Terrain Constraints
     I2.3 Class Constraints
     I2.4 Misc Constraints
I3.0 Define Object
     I3.1 Player objects
     I3.2 Define resources
          I3.21 Define mines
          I3.22 Define huntables
          I3.23 Define herdables
          I3.24 Define trees
          I3.25 Define berries
     I3.3 Other objects
     I3.4 Nuggets
     I3.5 Nomad start objects.
     I3.6 Water objects
     I3.7 Bonus island objects.
     I3.8 BFG
     I3.9 Pirate ships.
I4.0 Make islands
     I4.1 Player islands
     I4.2 Elbow islands
     I4.3 Connection islands
I5.0 Position players
     I5.1 Place explorer or covered wagon for Nomad start.
     I5.2 Place Water Flags
     I5.3 Landing party placement
I6.0 Place things
     I6.1 Placement order
     I6.2 Place pirate ships
     I6.3 Place wagon(Fort, Outpost, Covered, or Factory)
     I6.4 Place trade routes
     I6.5 Place Natives
     I6.6 Place Resources
          I6.61 Place mines 
          I6.62 Place huntables 
          I6.63 Place herdables 
          I6.64 Place trees
          I6.65 Place berries
     I6.8 Nuggets
     I6.9 Remaining items.
I7.0 Triggers
     I7.1 Create triggers
     I7.2 Rain triggers
     I7.4 Collect nuggets triggers.
     I7.5 War hut triggers 
     I7.6 Ossuary triggers.
     I7.7 Most herdable triggers.
     I7.8 Start trigger
     I7.9 Resource message triggers.
     I7.10 FPS triggers.
     I7.11 Pirate ship triggers
     I7.12 Wagon and bonus unit triggers
     I7.13 Sound triggers
     I7.14 Miscellanous triggers

I1.0 Start with Constants and Initialization */  rmSetStatusText("",0.01);
 
/* I1.10 Flags. Help troubleshoot, improve the frame rate or make the game more fun for the player.

   I1.11 Game flags: you should only change one flag at a time. Be careful changing more. Some flags changes causes the game to change others.

   Diagnostic Flags */
   
   bool revealMapFlag        = false; // Normal = false. Set to true to reveal the map at the start message.
   bool watchPiratesFlag     = false; // Normal = false. Set to true to be able to watch the pirate ships patrol the islands.
   bool useCountdownFlag     = false; // Normal = false. Used by the game during watchPiratesFlag to countdown the time to the next pirate ship move.
   bool useSpoofChatFlag     = false; // Normal = false. Set to true to display a Chat that duplicates the messages but is retrievable.
   bool showMapTypesFlag     = false; // Normal = false. Set to true to see the various types (map, terrain, etc) in the first message.

// I1.12 Major function flags

   bool useTradeRoutesFlag   = true;  // Normal = true.  Set to false to prevent the creation of trade routes.
   bool useNativesFlag       = true;  // Normal = true.  Set to false to prevent the creation of native villages.
   bool usePiratesFlag       = true;  // Normal = true.  Set to false to prevent the placement and triggers for the pirate ships.
   bool useBonusIslandsFlag  = true;  // Normal = true.  Set to false to prevent the formation of the bonus islands.

// I1.13 Preference flags

   bool displayMessageFlag   = true;  // Normal = true.  Set to false to prevent the display of messages. Like when using Spoofed Chat instead.
   bool useEyeCandyFlag      = true;  // Normal = true.  Set to false to eliminate a lot of the eye candy and improve frame rate about 10%.
   bool useVisualsFlag       = true;  // Normal = true.  Set to false to prevent visuals like changes in lighting and rain that some might not like. 
   bool useBonusCratesFlag   = true;  // Normal = true.  Set to false to prevent the placement of the large crates (pirate booty) on the bonus islands.
   bool useNuggetsFlag       = true;  // Normal = true.  Set to false to prevent the placement of nuggets. Made for useSimpleMapFlag = false.
   bool useBFGFlag           = true;  // Normal = true.  Set to false to prevent the placement of the BFG (Big Fixed Gun).
   bool useAttackMoveFlag    = true;  // Normal = true.  False means pirate ships won't attack as they move along the coast. Game sets false 1/2 the time.
   bool useExpertBonusFlag   = true;  // Normal = true.  True gives you a trickle of resources on expert when out numbered. Makes me less frustrated with Expert.
   bool useMaxResourcesFlag  = false; // Normal = false.  \           True means you get the maximum amount of all resources.
   bool useMinResourcesFlag  = false; // Normal = false.   > Use one. True means you get the minimum amount of all resources.
   bool useMaxTreesFlag      = false; // Normal = false.  /           True uses the maximum amount of trees with the other resources still being random.
   bool useMinTreesFlag      = false; // Normal = false. /            True uses the minimum amount of trees with the other resources still being random.
   bool useHelpFlag          = false; // Normal = false. Set to true to display the possible player names to use at startup. Usually set by using "Help" as name.
   bool useLoneWolfFlag      = false; // Normal = false. Set to true to switch player 1 and any last odd player so you get to be alone on your island.
                                                      // Game sets to true if player 1 name is "Lone Wolf" (set as Nickname in Game Options in Options Menu).
                                                      // and the game always sets to false if there is no last odd player (even number of players).
// I1.14 Map flags

   bool useSimpleMapFlag     = false; // Normal = false. Set to true to create a very simple map (no natives, trade routes, nor bonus islands).
   bool useBasicMapFlag      = false; // Normal = false. Set to true to create a basic map (no bonus islands, pirates, visuals nor eyecandy).
   bool useRegularMapFlag    = false; // Normal = false. Set to true to create a map with bonus islands but no quests or quest related extras.
   bool useTinyMapFlag       = false; // Normal = false. Set to true to only use the smallest possible size map. (1.0)    \
   bool useSmallMapFlag      = false; // Normal = false. Set to true to only use the small size map.             (1.2)     \   Only change one.
   bool useMediumMapFlag     = false; // Normal = false. Set to true to only use a medium size map.              (1.4)      >  If you change more,
   bool useLargeMapFlag      = false; // Normal = false. Set to true to only use the large size map.             (1.6)     /   the largest will be used.
   bool useHugeMapFlag       = false; // Normal = false. Set to true to only use the huge size map.              (1.8)    /
   bool useGiantMapFlag      = false; // Normal = false. Set to true to only use the largest possible size map.  (2.0)   /

// I1.15 Misc flags. Game usually set these. Change with extreme care.

   bool useFullMapFlag       = true;  // Normal = true.  The normal map flag. Game sets to false if another map type (Simple, Basic, or Regular) is used.
   bool useNuggetBonusFlag   = true;  // Normal = true.  True gives you a boat after collecting several nuggets. Game sets to false for nomad.
   bool multiPlayerFlag      = false; // Normal = false. Set to true for multiplayer games. Game will try to set it true for multiplayer.
   bool useBFGwithBaseFlag   = true;  // Normal = true.  Set to false for a plain fixed gun without the base. Game sets false for multiplayer.
   bool useWarChiefsFlag     = false; // Normal = false. Game sets to true if it finds a warchief player name. Not perfect but something.
   bool FFAFlag              = false; // Normal = false. Game sets to true when FFA is chosen in the start screen per the next lines.

// Flag adjustment. The game sets flags based on other flags. Adjust very carefully.

   int players = cNumberNonGaiaPlayers;
   if(players > 2 && rmGetPlayerTeam(3) > 1) FFAFlag = true;

// I1.16 Player name option flag changes.

   if(rmGetPlayerName(1) == "Help") useHelpFlag = true;
   if(rmGetPlayerName(1) == "Simple Map") useSimpleMapFlag = true;
   if(rmGetPlayerName(1) == "Basic Map") useBasicMapFlag = true;
   if(rmGetPlayerName(1) == "Regular Map") useRegularMapFlag = true;
   if(rmGetPlayerName(1) == "Max Resources") useMaxResourcesFlag = true;
   if(rmGetPlayerName(1) == "Min Resources") useMinResourcesFlag = true;
   if(rmGetPlayerName(1) == "Giant Map")  useGiantMapFlag = true;
   if(rmGetPlayerName(1) == "Huge Map")   useHugeMapFlag = true;   // Not in help menu.
   if(rmGetPlayerName(1) == "Large Map")  useLargeMapFlag = true;  // Not in help menu.
   if(rmGetPlayerName(1) == "Medium Map") useMediumMapFlag = true;
   if(rmGetPlayerName(1) == "Small Map")  useSmallMapFlag = true;  // Not in help menu.
   if(rmGetPlayerName(1) == "Tiny Map")   useTinyMapFlag = true; 
   if(rmGetPlayerName(1) == "Lone Wolf")  useLoneWolfFlag = true;
   if(rmGetPlayerName(1) == "Multiplayer") multiPlayerFlag = true;
   if(rmGetPlayerName(1) == "Max Trees") useMaxTreesFlag = true;   // Not in help menu.
   if(rmGetPlayerName(1) == "Min Trees") useMinTreesFlag = true;   // Not in help menu.
   if(rmGetPlayerName(1) == "Show Types") showMapTypesFlag = true; // Not in help menu.
   if(players == 2 || players == 4 || players == 6 || players == 8) useLoneWolfFlag = false;

/* Check if using war chiefs.   # Civ         # Civ            # Civ         #  Civ
                                1 Spanish     4 Portuguese     7 German      15 Iroquois
                                2 British     5 Dutch          8 Ottoman     16 Sioux
                                3 French      6 Russian                      17 Aztec
*/
   for(i=1; <= players) if(rmGetPlayerCiv(i) > 10) useWarChiefsFlag = true;

   if(useSimpleMapFlag == true)
 {
   useBonusIslandsFlag = false; useEyeCandyFlag = false; usePiratesFlag = false; useNativesFlag = false; useTradeRoutesFlag = false;
   useSmallMapFlag = true; useNuggetBonusFlag = false; useVisualsFlag = false; useFullMapFlag = false; 
 }
   if(useBasicMapFlag == true)
 {
   useBonusIslandsFlag = false; usePiratesFlag = false; useNuggetBonusFlag = false; useFullMapFlag = false;
 }
   if(useRegularMapFlag == true) { useBonusCratesFlag = false; useFullMapFlag = false; }

   if(watchPiratesFlag == true)
 {
   revealMapFlag = true; usePiratesFlag = true; useCountdownFlag = true; useTinyMapFlag = true; useAttackMoveFlag = false;
 }
   if(useBonusIslandsFlag == false) 
 { useBFGFlag = false; useBonusCratesFlag = false; useFullMapFlag = false; useNuggetBonusFlag = false;
   if(useSimpleMapFlag == false && useBasicMapFlag == false) useBasicMapFlag = true;  
 }
   if(rmGetNomadStart()) useNuggetBonusFlag = false; 
   if(rmRandInt(1,2) == 2) useAttackMoveFlag = false; // turns it off half the time anyway.

// I1.20 Set constants

   int messageTime = 18000;
   int rainPick = rmRandInt(1,9);
   float mapMultiplier = rmRandFloat(1.0, 2.0); // Varies the size of the map from almost too small to almost too large.
   if(useSimpleMapFlag == true) mapMultiplier = rmRandFloat(1.0, 1.5); // Keep maps smaller for simple map.
   if(useBasicMapFlag == true) mapMultiplier = rmRandFloat(1.0, 1.7); // Keep maps smaller for basic map.
   if(useTinyMapFlag == true) mapMultiplier = 1.0; if(useSmallMapFlag == true) mapMultiplier = 1.2; if(useMediumMapFlag == true) mapMultiplier = 1.4;
   if(useLargeMapFlag == true) mapMultiplier = 1.6; if(useHugeMapFlag == true) mapMultiplier = 1.8; if(useGiantMapFlag == true) mapMultiplier = 2.0;
   string mapSizeName = "tiny"; if(mapMultiplier > 1.1) mapSizeName = "small"; if(mapMultiplier > 1.3) mapSizeName = "medium";
   if(mapMultiplier > 1.5) mapSizeName = "large"; if(mapMultiplier > 1.7) mapSizeName = "huge"; if(mapMultiplier > 1.9) mapSizeName = "giant";
   int pirateMoveTime = rmRandInt(120,240); int pirate1stMoveTime = pirateMoveTime; 
   if(watchPiratesFlag == true) { pirateMoveTime = 100*mapMultiplier; pirate1stMoveTime = 25; }
   int numElbows = 1; int numConnections = 2;
   if(players == 4 || players == 5){ numElbows = 2; numConnections = 4; }
   if(players == 6 || players == 7){ numElbows = 3; numConnections = 6; }
   if(players == 8){ numElbows = 4; numConnections = 8; }
   int size = (250 + 75*players)*mapMultiplier; int playerArea = 2000*mapMultiplier*mapMultiplier; float objectDistance = 50.0*mapMultiplier;
   if(players == 7)  size = 700*mapMultiplier; // Same size as six player map since it is the same just a player in the very open middle.
   int bonusIslandSize = playerArea/2.5; if(players < 3 && mapMultiplier < 1.25) bonusIslandSize = (2.50-mapMultiplier)*bonusIslandSize; // Too small otherwise.
   int islandCount = 4 + players/2 - rmRandInt(0,2);
   if(useFullMapFlag == false) islandCount = islandCount - 1; // Don't need so many islands if not using everything.
   if(useFullMapFlag == true && islandCount < 4 && size < 600) islandCount = 4; // 4 minimum due to all the space needed.
   string word = "Initiate"; string words = "Initiate";
   int incrementAmount = 15000;  if(players < 7) incrementAmount = 10000; if(players < 5) incrementAmount = 5000;
   int ossuaryAmount = 5000 + rmRandInt(0,2)*5000; if(useWarChiefsFlag == false) ossuaryAmount = ossuaryAmount + incrementAmount;
   string nuggetBoatType = "canoe";
   int pick = rmRandInt(1,3);
   if(useWarChiefsFlag == false)
 { int nuggetTotal = rmRandInt(3,6) + rmRandInt(2,4); // Weighs to the middle like dice.
   if(nuggetTotal == 6) nuggetBoatType = "privateer";
   if(nuggetTotal == 7 && pick != 3) nuggetBoatType = "caravel";
   if(nuggetTotal == 7 && pick == 3) nuggetBoatType = "galley";
   if(nuggetTotal == 8 && pick != 3) nuggetBoatType = "galleon";
   if(nuggetTotal == 8 && pick == 3) nuggetBoatType = "fluyt";
   if(nuggetTotal == 9 && pick != 3) nuggetBoatType = "frigate";
   if(nuggetTotal == 9 && pick == 3) nuggetBoatType = "monitor";
   if(nuggetTotal == 10) nuggetBoatType = "xpIronclad";
 }
   if(useWarChiefsFlag == true)
 { nuggetTotal = rmRandInt(3,6) + rmRandInt(3,5); // Weighs to the middle like dice. One more for war chiefs since getting treasures is easier.
   if(nuggetTotal == 7) nuggetBoatType = "privateer";
   if(nuggetTotal == 8 && pick != 3) nuggetBoatType = "caravel";
   if(nuggetTotal == 8 && pick == 3) nuggetBoatType = "galley";
   if(nuggetTotal == 9 && pick != 3) nuggetBoatType = "galleon";
   if(nuggetTotal == 9 && pick == 3) nuggetBoatType = "fluyt";
   if(nuggetTotal == 10 && pick != 3) nuggetBoatType = "frigate";
   if(nuggetTotal == 10 && pick == 3) nuggetBoatType = "monitor";
   if(nuggetTotal == 11) nuggetBoatType = "xpIronclad";
 }
   string nuggetBoatName = nuggetBoatType;
   if(nuggetBoatType == "xpIronclad") nuggetBoatName = "ironclad";
   string questsComplete = "0";

// I1.30 Resource counts. 1 = poor, 2 = okay, 3 = good, 4 = great.

// Old method. Each count is random.

   int gameCount = rmRandInt(1,4); // gameCount+1 is the group size for huntables. About 4.5 extra groups per player.
   int mineCount = rmRandInt(1,4); // 1 =  1.5 silver/copper/tin, 2 = 3 silver/copper/tin, 3 = 1.5 gold, 4 = 3 gold mines extra per player.
   int treeCount = rmRandInt(1,4); // Group size(total groups = 20*players) for random trees.
                                   // The group size for larger clumps of trees is 1+4*treeCount(5, 9, 13, 17).
                                   // There is 1 clump near each player, 2 clumps per player further away and a few clumps on the bonus islands.
   int fishCount = rmRandInt(1,4); // Total fish = fishCount*fishCount(group size)*players*2(two types of fish).
                                   // Total whales = fishCount*players
// New method. One count will be poor, another will be okay, another will be good and the final will be great.

   pick = rmRandInt(1,24); // pick = 13; Uncomment and change this line to pick the set you want.
   if(useMaxTreesFlag == true) pick = rmRandInt(1,6);
   if(useMinTreesFlag == true) pick = rmRandInt(19,24);
   if(pick == 1)  { gameCount = 1; mineCount = 2; treeCount = 4; fishCount = 3; }
   if(pick == 2)  { gameCount = 1; mineCount = 3; treeCount = 4; fishCount = 2; }
   if(pick == 3)  { gameCount = 2; mineCount = 1; treeCount = 4; fishCount = 3; }
   if(pick == 4)  { gameCount = 2; mineCount = 3; treeCount = 4; fishCount = 1; }
   if(pick == 5)  { gameCount = 3; mineCount = 2; treeCount = 4; fishCount = 1; }
   if(pick == 6)  { gameCount = 3; mineCount = 1; treeCount = 4; fishCount = 2; }
   if(pick == 7)  { gameCount = 1; mineCount = 2; treeCount = 3; fishCount = 4; }
   if(pick == 8)  { gameCount = 1; mineCount = 4; treeCount = 3; fishCount = 2; }
   if(pick == 9)  { gameCount = 2; mineCount = 1; treeCount = 3; fishCount = 4; }
   if(pick == 10) { gameCount = 2; mineCount = 4; treeCount = 3; fishCount = 1; }
   if(pick == 11) { gameCount = 4; mineCount = 1; treeCount = 3; fishCount = 2; }
   if(pick == 12) { gameCount = 4; mineCount = 2; treeCount = 3; fishCount = 1; }
   if(pick == 13) { gameCount = 1; mineCount = 3; treeCount = 2; fishCount = 4; }
   if(pick == 14) { gameCount = 1; mineCount = 4; treeCount = 2; fishCount = 3; }
   if(pick == 15) { gameCount = 3; mineCount = 1; treeCount = 2; fishCount = 4; }
   if(pick == 16) { gameCount = 3; mineCount = 4; treeCount = 2; fishCount = 1; }
   if(pick == 17) { gameCount = 4; mineCount = 1; treeCount = 2; fishCount = 3; }
   if(pick == 18) { gameCount = 4; mineCount = 3; treeCount = 2; fishCount = 1; }
   if(pick == 19) { gameCount = 2; mineCount = 4; treeCount = 1; fishCount = 3; }
   if(pick == 20) { gameCount = 2; mineCount = 3; treeCount = 1; fishCount = 4; }
   if(pick == 21) { gameCount = 3; mineCount = 4; treeCount = 1; fishCount = 2; }
   if(pick == 22) { gameCount = 3; mineCount = 2; treeCount = 1; fishCount = 4; }
   if(pick == 23) { gameCount = 4; mineCount = 3; treeCount = 1; fishCount = 2; }
   if(pick == 24) { gameCount = 4; mineCount = 2; treeCount = 1; fishCount = 3; }

   if(useMinResourcesFlag == true) { gameCount = 1; mineCount = 1; treeCount = 1; fishCount = 1; }
   if(useMaxResourcesFlag == true) { gameCount = 4; mineCount = 4; treeCount = 4; fishCount = 4; }

// Use the following lines to manually set the amounts of the various resources. 

//   gameCount = 2; 
//   mineCount = 1;
//   treeCount = 1;
//   fishCount = 4;

// I1.40 Initialize island, elbow and player positions
   float i1x  = 0.0; float i1z  = 0.0; float i2x  = 0.0; float i2z  = 0.0; float i3x  = 0.0; float i3z  = 0.0;
   float i4x  = 0.0; float i4z  = 0.0; float i5x  = 0.0; float i5z  = 0.0; float i6x  = 0.0; float i6z  = 0.0;
   float i7x  = 0.0; float i7z  = 0.0; float i8x  = 0.0; float i8z  = 0.0; float i9x  = 0.0; float i9z  = 0.0;
   float i10x = 0.0; float i10z = 0.0; float i11x = 0.0; float i11z = 0.0; float i12x = 0.0; float i12z = 0.0; float i13x = 0.0; float i13z = 0.0;
   float e1x  = 0.0; float e1z  = 0.0; float e2x  = 0.0; float e2z  = 0.0; float e3x  = 0.0; float e3z  = 0.0; float e4x  = 0.0; float e4z  = 0.0;
   float p1x  = 0.0; float p1z  = 0.0; float p2x  = 0.0; float p2z  = 0.0; float p3x  = 0.0; float p3z  = 0.0; float p4x  = 0.0; float p4z  = 0.0; 
   float p5x  = 0.0; float p5z  = 0.0; float p6x  = 0.0; float p6z  = 0.0; float p7x  = 0.0; float p7z  = 0.0; float p8x  = 0.0; float p8z  = 0.0;

// Set Island positions
   if(players < 4) 
 { i1x = 0.25; i1z = 0.50; i2x = 0.50; i2z = 0.75; i3x = 0.75; i3z = 0.50; i4x = 0.50; i4z = 0.25; }
   if(players == 4 || players == 5) 
 { i1x = 0.20; i1z = 0.50; i2x = 0.35; i2z = 0.76; i3x = 0.65; i3z = 0.76; i4x = 0.80; i4z = 0.50; i5x = 0.65; i5z = 0.24; i6x = 0.35; i6z = 0.24; }
   if(players > 5) 
 { i1x  = 0.15; i1z =  0.50; i2x  = 0.23; i2z  = 0.73; i3x  = 0.44; i3z =  0.84; i4x =  0.67; i4z  = 0.80;
   i5x  = 0.83; i5z =  0.62; i6x  = 0.83; i6z  = 0.38; i7x  = 0.67; i7z =  0.20; i8x =  0.44; i8z  = 0.16; i9x = 0.23; i9z = 0.27;
   i10x = 0.35; i10z = 0.50; i11x = 0.50; i11z = 0.65; i12x = 0.65; i12z = 0.50; i13x = 0.50; i13z = 0.35; }

   pick = rmRandInt(1,8); if(players == 4 || players == 5) pick = rmRandInt(1,12); if(players > 5) pick = rmRandInt(1,18);
// Pick player positions                      1234                     3412                 4123                  2341
   if(players < 4 && pick == 1) { p1x = i1x; p1z = i1z; p2x = i3x; p2z = i3z; p3x = i2x; p3z = i2z; e1x = i4x; e1z = i4z; }
   if(players < 4 && pick == 2) { p1x = i2x; p1z = i2z; p2x = i4x; p2z = i4z; p3x = i1x; p3z = i1z; e1x = i3x; e1z = i3z; }
   if(players < 4 && pick == 3) { p1x = i3x; p1z = i3z; p2x = i1x; p2z = i1z; p3x = i4x; p3z = i4z; e1x = i2x; e1z = i2z; }
   if(players < 4 && pick == 4) { p1x = i4x; p1z = i4z; p2x = i2x; p2z = i2z; p3x = i1x; p3z = i1z; e1x = i3x; e1z = i3z; }
   if(players < 4 && pick == 5) { p1x = i1x; p1z = i1z; p2x = i3x; p2z = i3z; p3x = i4x; p3z = i4z; e1x = i2x; e1z = i2z; }
   if(players < 4 && pick == 6) { p1x = i4x; p1z = i4z; p2x = i2x; p2z = i2z; p3x = i3x; p3z = i3z; e1x = i1x; e1z = i1z; }
   if(players < 4 && pick == 7) { p1x = i3x; p1z = i3z; p2x = i1x; p2z = i1z; p3x = i2x; p3z = i2z; e1x = i4x; e1z = i4z; }
   if(players < 4 && pick == 8) { p1x = i2x; p1z = i2z; p2x = i4x; p2z = i4z; p3x = i1x; p3z = i1z; e1x = i3x; e1z = i3z; }

   if((players == 4 || players == 5) && pick == 1)
 { p1x = i1x; p1z = i1z; p2x = i3x; p2z = i3z; p3x = i4x; p3z = i4z; p4x = i6x; p4z = i6z; e1x = i2x; e1z = i2z; e2x = i5x; e2z = i5z; }
   if((players == 4 || players == 5) && pick == 2)
 { p1x = i2x; p1z = i2z; p2x = i4x; p2z = i4z; p3x = i5x; p3z = i5z; p4x = i1x; p4z = i1z; e1x = i3x; e1z = i3z; e2x = i6x; e2z = i6z; }
   if((players == 4 || players == 5) && pick == 3)
 { p1x = i3x; p1z = i3z; p2x = i5x; p2z = i5z; p3x = i6x; p3z = i6z; p4x = i2x; p4z = i2z; e1x = i4x; e1z = i4z; e2x = i1x; e2z = i1z; }
   if((players == 4 || players == 5) && pick == 4)
 { p1x = i4x; p1z = i4z; p2x = i6x; p2z = i6z; p3x = i1x; p3z = i1z; p4x = i3x; p4z = i3z; e1x = i5x; e1z = i5z; e2x = i2x; e2z = i2z; }
   if((players == 4 || players == 5) && pick == 5)
 { p1x = i5x; p1z = i5z; p2x = i1x; p2z = i1z; p3x = i2x; p3z = i2z; p4x = i4x; p4z = i4z; e1x = i6x; e1z = i6z; e2x = i3x; e2z = i3z; }
   if((players == 4 || players == 5) && pick == 6)
 { p1x = i6x; p1z = i6z; p2x = i2x; p2z = i2z; p3x = i3x; p3z = i3z; p4x = i5x; p4z = i5z; e1x = i1x; e1z = i1z; e2x = i4x; e2z = i4z; }
   if((players == 4 || players == 5) && pick == 7)
 { p1x = i1x; p1z = i1z; p2x = i5x; p2z = i5z; p3x = i4x; p3z = i4z; p4x = i2x; p4z = i2z; e1x = i6x; e1z = i6z; e2x = i3x; e2z = i3z; }
   if((players == 4 || players == 5) && pick == 8)
 { p1x = i2x; p1z = i2z; p2x = i6x; p2z = i6z; p3x = i5x; p3z = i5z; p4x = i3x; p4z = i3z; e1x = i1x; e1z = i1z; e2x = i4x; e2z = i4z; }
   if((players == 4 || players == 5) && pick == 9)
 { p1x = i3x; p1z = i3z; p2x = i1x; p2z = i1z; p3x = i6x; p3z = i6z; p4x = i4x; p4z = i4z; e1x = i2x; e1z = i2z; e2x = i5x; e2z = i5z; }
   if((players == 4 || players == 5) && pick == 10)
 { p1x = i4x; p1z = i4z; p2x = i2x; p2z = i2z; p3x = i1x; p3z = i1z; p4x = i5x; p4z = i5z; e1x = i3x; e1z = i3z; e2x = i6x; e2z = i6z; }
   if((players == 4 || players == 5) && pick == 11)
 { p1x = i5x; p1z = i5z; p2x = i3x; p2z = i3z; p3x = i2x; p3z = i2z; p4x = i6x; p4z = i6z; e1x = i4x; e1z = i4z; e2x = i1x; e2z = i1z; }
   if((players == 4 || players == 5) && pick == 12)
 { p1x = i6x; p1z = i6z; p2x = i4x; p2z = i4z; p3x = i3x; p3z = i3z; p4x = i1x; p4z = i1z; e1x = i5x; e1z = i5z; e2x = i2x; e2z = i2z; }

   if(players == 5) { p5x = 0.5; p5z = 0.5; }

   if(players > 5)
{
   if(pick == 1)
 { p1x =  i1x; p1z =  i1z; p2x =  i3x; p2z =  i3z; p3x =  i4x; p3z = i4z; p4x = i6x; p4z = i6z; p5x = i7x;  p5z = i7z;  p6x =  i9x; p6z =  i9z;
   p7x = i11x; p7z = i11z; p8x = i13x; p8z = i13z; e1x =  i2x; e1z = i2z; e2x = i5x; e2z = i5z; e3x = i8x;  e3z = i8z;  e4x = i12x; e4z = i12z; }
   if(pick == 2)
 { p1x =  i2x; p1z =  i2z; p2x =  i4x; p2z =  i4z; p3x =  i5x; p3z = i5z; p4x = i7x; p4z = i7z; p5x = i8x;  p5z = i8z;  p6x = i1x;  p6z = i1z;
   p7x = i12x; p7z = i12z; p8x = i10x; p8z = i10z; e1x =  i3x; e1z = i3z; e2x = i6x; e2z = i6z; e3x = i9x;  e3z = i9z;  e4x = i11x; e4z = i11z; }
   if(pick == 3)
 { p1x =  i3x; p1z =  i3z; p2x =  i5x; p2z =  i5z; p3x =  i6x; p3z = i6z; p4x = i8x; p4z = i8z; p5x = i9x;  p5z = i9z;  p6x = i2x;  p6z = i2z;
   p7x = i13x; p7z = i13z; p8x = i11x; p8z = i11z; e1x = i4x;  e1z = i4z; e2x = i7x; e2z = i7z; e3x = i1x;  e3z = i1z;  e4x = i10x; e4z = i10z; }
   if(pick == 4)
 { p1x =  i4x; p1z =  i4z; p2x =  i6x; p2z =  i6z; p3x =  i7x; p3z = i7z; p4x = i9x; p4z = i9z; p5x = i1x;  p5z = i1z;  p6x = i3x;  p6z = i3z;
   p7x = i10x; p7z = i10z; p8x = i12x; p8z = i12z; e1x = i5x;  e1z = i5z; e2x = i8x; e2z = i8z; e3x = i2x;  e3z = i2z;  e4x = i13x; e4z = i13z; }
   if(pick == 5)
 { p1x =  i5x; p1z =  i5z; p2x =  i7x; p2z =  i7z; p3x =  i8x; p3z = i8z; p4x = i1x; p4z = i1z; p5x = i2x;  p5z = i2z;  p6x = i4x;  p6z = i4z;
   p7x = i11x; p7z = i11z; p8x = i13x; p8z = i13z; e1x = i6x;  e1z = i6z; e2x = i9x; e2z = i9z; e3x = i3x;  e3z = i3z;  e4x = i12x; e4z = i12z; }
   if(pick == 6)
 { p1x =  i6x; p1z =  i6z; p2x =  i8x; p2z =  i8z; p3x =  i9x; p3z = i9z; p4x = i2x; p4z = i2z; p5x = i3x;  p5z = i3z;  p6x = i5x;  p6z = i5z;
   p7x = i12x; p7z = i12z; p8x = i10x; p8z = i10z; e1x = i7x;  e1z = i7z; e2x = i1x; e2z = i1z; e3x = i4x;  e3z = i4z;  e4x = i13x; e4z = i13z; }
   if(pick == 7)
 { p1x =  i7x; p1z =  i7z; p2x =  i9x; p2z =  i9z; p3x =  i1x; p3z = i1z; p4x = i3x; p4z = i3z; p5x = i4x;  p5z = i4z;  p6x = i6x;  p6z = i6z;
   p7x = i13x; p7z = i13z; p8x = i11x; p8z = i11z; e1x = i8x;  e1z = i8z; e2x = i2x; e2z = i2z; e3x = i5x;  e3z = i5z;  e4x = i10x; e4z = i10z; }
   if(pick == 8)
 { p1x =  i8x; p1z =  i8z; p2x =  i1x; p2z =  i1z; p3x =  i2x; p3z = i2z; p4x = i4x; p4z = i4z; p5x = i5x;  p5z = i5z;  p6x = i7x;  p6z = i7z;
   p7x = i10x; p7z = i10z; p8x = i12x; p8z = i12z; e1x = i9x;  e1z = i9z; e2x = i3x; e2z = i3z; e3x = i6x;  e3z = i6z;  e4x = i11x; e4z = i11z; }
   if(pick == 9)
 { p1x =  i9x; p1z =  i9z; p2x =  i2x; p2z =  i2z; p3x =  i3x; p3z = i3z; p4x = i5x; p4z = i5z; p5x = i6x;  p5z = i6z;  p6x = i8x;  p6z = i8z;
   p7x = i10x; p7z = i10z; p8x = i12x; p8z = i12z; e1x = i1x;  e1z = i1z; e2x = i4x; e2z = i4z; e3x = i7x;  e3z = i7z;  e4x = i13x; e4z = i13z; }
   if(pick == 10)
 { p1x =  i1x; p1z =  i1z; p2x =  i8x; p2z =  i8z; p3x =  i7x; p3z = i7z; p4x = i5x; p4z = i5z; p5x = i4x;  p5z = i4z;  p6x =  i2x; p6z =  i2z;
   p7x = i10x; p7z = i10z; p8x = i12x; p8z = i12z; e1x =  i9x; e1z = i9z; e2x = i6x; e2z = i6z; e3x = i3x;  e3z = i3z;  e4x = i13x; e4z = i13z; }
   if(pick == 11)
 { p1x =  i9x; p1z =  i9z; p2x =  i7x; p2z =  i7z; p3x =  i6x; p3z = i6z; p4x = i4x; p4z = i4z; p5x = i3x;  p5z = i3z;  p6x = i1x;  p6z = i1z;
   p7x = i13x; p7z = i13z; p8x = i11x; p8z = i11z; e1x =  i8x; e1z = i8z; e2x = i5x; e2z = i5z; e3x = i2x;  e3z = i2z;  e4x = i12x; e4z = i12z; }
   if(pick == 12)
 { p1x =  i8x; p1z =  i8z; p2x =  i6x; p2z =  i6z; p3x =  i5x; p3z = i5z; p4x = i3x; p4z = i3z; p5x = i2x;  p5z = i2z;  p6x = i9x;  p6z = i9z;
   p7x = i12x; p7z = i12z; p8x = i10x; p8z = i10z; e1x = i7x;  e1z = i7z; e2x = i4x; e2z = i4z; e3x = i1x;  e3z = i1z;  e4x = i11x; e4z = i11z; }
   if(pick == 13)
 { p1x =  i7x; p1z =  i7z; p2x =  i5x; p2z =  i5z; p3x =  i4x; p3z = i4z; p4x = i2x; p4z = i2z; p5x = i1x;  p5z = i1z;  p6x = i8x;  p6z = i8z;
   p7x = i12x; p7z = i12z; p8x = i10x; p8z = i10z; e1x = i6x;  e1z = i6z; e2x = i3x; e2z = i3z; e3x = i9x;  e3z = i9z;  e4x = i13x; e4z = i13z; }
   if(pick == 14)
 { p1x =  i6x; p1z =  i6z; p2x =  i4x; p2z =  i4z; p3x =  i3x; p3z = i3z; p4x = i1x; p4z = i1z; p5x = i9x;  p5z = i9z;  p6x = i7x;  p6z = i7z;
   p7x = i11x; p7z = i11z; p8x = i13x; p8z = i13z; e1x = i5x;  e1z = i5z; e2x = i2x; e2z = i2z; e3x = i8x;  e3z = i8z;  e4x = i10x; e4z = i10z; }
   if(pick == 15)
 { p1x =  i5x; p1z =  i5z; p2x =  i3x; p2z =  i3z; p3x =  i2x; p3z = i2z; p4x = i9x; p4z = i9z; p5x = i8x;  p5z = i8z;  p6x = i6x;  p6z = i6z;
   p7x = i11x; p7z = i11z; p8x = i13x; p8z = i13z; e1x = i4x;  e1z = i4z; e2x = i1x; e2z = i1z; e3x = i7x;  e3z = i7z;  e4x = i12x; e4z = i12z; }
   if(pick == 16)
 { p1x =  i4x; p1z =  i4z; p2x =  i2x; p2z =  i2z; p3x =  i1x; p3z = i1z; p4x = i8x; p4z = i8z; p5x = i7x;  p5z = i7z;  p6x = i5x;  p6z = i5z;
   p7x = i11x; p7z = i11z; p8x = i13x; p8z = i13z; e1x = i3x;  e1z = i3z; e2x = i9x; e2z = i9z; e3x = i6x;  e3z = i6z;  e4x = i10x; e4z = i10z; }
   if(pick == 17)
 { p1x =  i3x; p1z =  i3z; p2x =  i1x; p2z =  i1z; p3x =  i9x; p3z = i9z; p4x = i7x; p4z = i7z; p5x = i6x;  p5z = i6z;  p6x = i4x;  p6z = i4z;
   p7x = i10x; p7z = i10z; p8x = i12x; p8z = i12z; e1x = i2x;  e1z = i2z; e2x = i8x; e2z = i8z; e3x = i5x;  e3z = i5z;  e4x = i13x; e4z = i13z; }
   if(pick == 18)
 { p1x =  i2x; p1z =  i2z; p2x =  i9x; p2z =  i9z; p3x =  i8x; p3z = i8z; p4x = i6x; p4z = i6z; p5x = i5x;  p5z = i5z;  p6x = i3x;  p6z = i3z;
   p7x = i10x; p7z = i10z; p8x = i12x; p8z = i12z; e1x = i1x;  e1z = i1z; e2x = i7x; e2z = i7z; e3x = i4x;  e3z = i4z;  e4x = i11x; e4z = i11z; }
}
   if(players == 7) { p7x = 0.5; p7z = 0.5; }

// I1.50 Set pirate ship routes

   float offset = rmRandFloat(1.2,2.1)*objectDistance/size;
   int routePick = rmRandInt(1,4);

                  float ps11x = e1x+offset; float ps11z = e1z;  float ps13x = e1x+offset; float ps13z = e1z;
                  float ps12x = p1x+offset; float ps12z = p1z;  float ps14x = p2x+offset; float ps14z = p2z;
                  float ps21x = e2x+offset; float ps21z = e2z;  float ps23x = e2x+offset; float ps23z = e2z;
                  float ps22x = p3x+offset; float ps22z = p3z;  float ps24x = p4x+offset; float ps24z = p4z;
                  float ps31x = e3x+offset; float ps31z = e3z;  float ps33x = e3x+offset; float ps33z = e3z;
                  float ps32x = p5x+offset; float ps32z = p5z;  float ps34x = p6x+offset; float ps34z = p6z;
                  float ps41x = e4x+offset; float ps41z = e4z;  float ps43x = e4x+offset; float ps43z = e4z;
                  float ps42x = p7x+offset; float ps42z = p7z;  float ps44x = p8x+offset; float ps44z = p8z;
   if(routePick == 2)
 { 
                        ps11x = e1x;              ps11z = e1z+offset; ps13x = e1x;              ps13z = e1z+offset;
                        ps12x = p1x;              ps12z = p1z+offset; ps14x = p2x;              ps14z = p2z+offset;
                        ps21x = e2x;              ps21z = e2z+offset; ps23x = e2x;              ps23z = e2z+offset;
                        ps22x = p3x;              ps22z = p3z+offset; ps24x = p4x;              ps24z = p4z+offset;
                        ps31x = e3x;              ps31z = e3z+offset; ps33x = e3x;              ps33z = e3z+offset;
                        ps32x = p5x;              ps32z = p5z+offset; ps34x = p6x;              ps34z = p6z+offset;
                        ps41x = e4x;              ps41z = e4z+offset; ps43x = e4x;              ps43z = e4z+offset;
                        ps42x = p7x;              ps42z = p7z+offset; ps44x = p8x;              ps44z = p8z+offset;
 }
   if(routePick == 3)
 {
                        ps11x = e1x-offset;       ps11z = e1z;        ps13x = e1x-offset;       ps13z = e1z;
                        ps12x = p1x-offset;       ps12z = p1z;        ps14x = p2x-offset;       ps14z = p2z;
                        ps21x = e2x-offset;       ps21z = e2z;        ps23x = e2x-offset;       ps23z = e2z;
                        ps22x = p3x-offset;       ps22z = p3z;        ps24x = p4x-offset;       ps24z = p4z;
                        ps31x = e3x-offset;       ps31z = e3z;        ps33x = e3x-offset;       ps33z = e3z;
                        ps32x = p5x-offset;       ps32z = p5z;        ps34x = p6x-offset;       ps34z = p6z;
                        ps41x = e4x-offset;       ps41z = e4z;        ps43x = e4x-offset;       ps43z = e4z;
                        ps42x = p7x-offset;       ps42z = p7z;        ps44x = p8x-offset;       ps44z = p8z;
 } 
   if(routePick == 4)
 {
                        ps11x = e1x;              ps11z = e1z-offset; ps13x = e1x;              ps13z = e1z-offset;
                        ps12x = p1x;              ps12z = p1z-offset; ps14x = p2x;              ps14z = p2z-offset;
                        ps21x = e2x;              ps21z = e2z-offset; ps23x = e2x;              ps23z = e2z-offset;
                        ps22x = p3x;              ps22z = p3z-offset; ps24x = p4x;              ps24z = p4z-offset;
                        ps31x = e3x;              ps31z = e3z-offset; ps33x = e3x;              ps33z = e3z-offset;
                        ps32x = p5x;              ps32z = p5z-offset; ps34x = p6x;              ps34z = p6z-offset;
                        ps41x = e4x;              ps41z = e4z-offset; ps43x = e4x;              ps43z = e4z-offset;
                        ps42x = p7x;              ps42z = p7z-offset; ps44x = p8x;              ps44z = p8z-offset;
 }              
   if(rmRandInt(1,2) == 2)
 {
   float pstx = ps12x; float pstz = ps12z; ps12x = ps14x; ps12z = ps14z; ps14x = pstx; ps14z = pstz;
         pstx = ps22x;       pstz = ps22z; ps22x = ps24x; ps22z = ps24z; ps24x = pstx; ps24z = pstz;
         pstx = ps32x;       pstz = ps32z; ps32x = ps34x; ps32z = ps34z; ps34x = pstx; ps34z = pstz;
         pstx = ps42x;       pstz = ps42z; ps42x = ps44x; ps42z = ps44z; ps44x = pstx; ps44z = pstz;
 }
// Last odd player routes.

   pick = rmRandInt(1,4);
   offset = 1.1*offset;
   if(players == 3) 
 { 
   if(pick == 1) { ps21x = p3x; ps21z = p3z+offset; ps22x = p3x+offset; ps22z = p3z;
                   ps23x = p3x; ps23z = p3z-offset; ps24x = p3x-offset; ps24z = p3z; }
   if(pick == 2) { ps24x = p3x; ps24z = p3z+offset; ps23x = p3x+offset; ps23z = p3z;
                   ps22x = p3x; ps22z = p3z-offset; ps21x = p3x-offset; ps21z = p3z; }
   if(pick == 3) { ps23x = p3x; ps23z = p3z+offset; ps24x = p3x+offset; ps24z = p3z;
                   ps21x = p3x; ps21z = p3z-offset; ps22x = p3x-offset; ps22z = p3z; }
   if(pick == 4) { ps22x = p3x; ps22z = p3z+offset; ps21x = p3x+offset; ps21z = p3z;
                   ps24x = p3x; ps24z = p3z-offset; ps23x = p3x-offset; ps23z = p3z; }
 }
   if(players == 5) 
 { 
   if(pick == 1) { ps31x = 0.5; ps31z = 0.5+offset; ps32x = 0.5+offset; ps32z = 0.5;
                   ps33x = 0.5; ps33z = 0.5-offset; ps34x = 0.5-offset; ps34z = 0.5; }
   if(pick == 2) { ps34x = 0.5; ps34z = 0.5+offset; ps33x = 0.5+offset; ps33z = 0.5;
                   ps32x = 0.5; ps32z = 0.5-offset; ps31x = 0.5-offset; ps31z = 0.5; }
   if(pick == 3) { ps33x = 0.5; ps33z = 0.5+offset; ps34x = 0.5+offset; ps34z = 0.5;
                   ps31x = 0.5; ps31z = 0.5-offset; ps32x = 0.5-offset; ps32z = 0.5; }
   if(pick == 4) { ps32x = 0.5; ps32z = 0.5+offset; ps31x = 0.5+offset; ps31z = 0.5;
                   ps34x = 0.5; ps34z = 0.5-offset; ps33x = 0.5-offset; ps33z = 0.5; }
 }
   if(players == 7) 
 { 
   if(pick == 1) { ps41x = 0.5; ps41z = 0.5+offset; ps42x = 0.5+offset; ps42z = 0.5;
                   ps43x = 0.5; ps43z = 0.5-offset; ps44x = 0.5-offset; ps44z = 0.5; }
   if(pick == 2) { ps44x = 0.5; ps44z = 0.5+offset; ps43x = 0.5+offset; ps43z = 0.5;
                   ps42x = 0.5; ps42z = 0.5-offset; ps41x = 0.5-offset; ps41z = 0.5; }
   if(pick == 3) { ps43x = 0.5; ps43z = 0.5+offset; ps44x = 0.5+offset; ps44z = 0.5;
                   ps41x = 0.5; ps41z = 0.5-offset; ps42x = 0.5-offset; ps42z = 0.5; }
   if(pick == 4) { ps42x = 0.5; ps42z = 0.5+offset; ps41x = 0.5+offset; ps41z = 0.5;
                   ps44x = 0.5; ps44z = 0.5-offset; ps43x = 0.5-offset; ps43z = 0.5; }
 }
// I1.60 Identify human players. indetx = 1 human, identx = 0 computer.

   int ident0 = 1; int ident2 = 1; int ident3 = 1; int ident4 = 1; int ident5 = 1; int ident6 = 1; int ident7 = 1; int ident8 = 1; int identTotal = 0;
   for(i=2; <= players)
 {
   ident0 = 1;
   if(rmGetPlayerName(i) == "Queen Elizabeth" || rmGetPlayerName(i) == "Maurice of Nassau" || rmGetPlayerName(i) == "Napoleon" || 
   rmGetPlayerName(i) == "Suleiman" || rmGetPlayerName(i) == "Ivan the Terrible" || rmGetPlayerName(i) == "Frederick the Great" ||
   rmGetPlayerName(i) == "Henry the Navigator" || rmGetPlayerName(i) == "Queen Isabella" || rmGetPlayerName(i) == "Hiawatha" || 
   rmGetPlayerName(i) == "Gall" || rmGetPlayerName(i) == "Cuauhtemoc") ident0 = 0;
   if(i == 2) ident2 = ident0; if(i == 3) ident3 = ident0; if(i == 4) ident4 = ident0; if(i == 5) ident5 = ident0;
   if(i == 6) ident6 = ident0; if(i == 7) ident7 = ident0; if(i == 8) ident8 = ident0;
   identTotal = identTotal + ident0;
 } 
   if(identTotal > 0) multiPlayerFlag = true; 
   if(multiPlayerFlag == true && useSimpleMapFlag == false && useBasicMapFlag == false) { useRegularMapFlag = true; useFullMapFlag = false; }
   if(multiPlayerFlag == true) useBFGwithBaseFlag = false;

// Count enemies and allies.

   int allies = 1; int enemies = 0;
   for(i=2; <= players) { if rmGetPlayerTeam(i) == 0) allies = allies + 1; if(rmGetPlayerTeam(i) == 1) enemies = enemies + 1; }

// Give nomad explorers wood. Decided not to but saving the command.

   // int woodAmount = 600; if(rmGetNomadStart()) rmAddPlayerResource(1, "wood", woodAmount);

// Set the map size. 
   rmSetMapSize(size, size);

/* I1.70 Select terrain and associated choices. mapType determines nugget choices, among other things.
   Map Types not used: Carolina, pampas, sonora, saguenay

   AOE
   Tribes       Location                 Used  Huntable      Location                        Used  Whale          Location              Used

   Aztecs       Mexico                     3   BighornSheep  Western US mountain and desert     2  Beluga         Arctic                  1
   Caribs       Caribbean                  3   Bison         Western US                         2  HumpbackWhale  Everywhere but arctic   3
   Cherokee     Oklahoma to Carolina       3   Capybara      South America                      2  MinkeWhale     Everywhere              3
   Comanche     Texas                      3   Caribou       North America                      0
   Cree         Ontario                    3   Deer          Everywhere                         2  Herdable
   Incas        South America West Coast   4   Elk           North America
   Iroquois     Canada US border           4   Moose         North America                      1  Cow            Everywhere              6
   Lakota       Minnesota                  3   MuskOx        Arctic                             1  Llama          Americas (avoid cold?)  5
   Maya         Central America            4   Pronghorn     Wertern US and North Mexico        1  Sheep          Everywhere              5
   Nootka       Vancouver                  2   Rhea          Southeastern South America         2
   Seminoles    Oklahoma to Florida        3   Tapir         South America                      3  Fish
   Tupi         Brazil                     4   Turkey        North America                      2
                                                                                                   FishBass                               1
   TWC                                                                                             FishCod                                3
                                                                                                   FishMahi                               1
   Apache       Texas                      2   Guanaco       South America                         FishMoonBass                           1
   Huron        Canada                     2   Seal          Antarctica(crabeater) California      FishSalmon                             1
   Klamath      Columbia River area        2                                                       FishSardine                            1
   Mapuche      Chile Argentina            1                                                       FishTarpon                             2
   Navajo       New Mexico                 2
   Zapotec      Mexico                     2

   Bird Props             Used

   EagleNest              3
   StartledBirds          2
   KingFisher             4
   PropEaglesRocks        2
   
   Special Props
 
   GroundPropsAm          1
   PropGrassFire          1
   BigPropGeyser          2
   BigPropTexas           1
   Inuksuk                1
   SPCXPMiningCampClone1  3 

*/ 
   pick = rmRandInt(1,6); if(useWarChiefsFlag == true) pick = rmRandInt(1,9);
   int nativeSet = rmRandInt(1,5);
  
   string mapType        = "caribbean";            string zoneType          = "tropical";
   string terrainCoast   = "caribbean coast";      string terrainMix        = "caribbean grass";  string treeType        = "treeCaribbean";
   string lightingType   = "caribbean";            string whaleType         = "HumpbackWhale";    string fishType        = "FishMahi";      
   string herdableType   = "cow";                  string questHerdableType = "llama";            string huntable1Type   = "rhea"; 
   string huntable2Type  = "deer";                 string birdProp          = "EaglesNest";       string specialProp     = "BigPropGeyser";
   string extrasName     = "ShorelineRockSmallNE"; string TCDirt            = "sonora_dirt";

   if(useWarChiefsFlag == true) TCDirt = "california_shoregrass"; // Better looking than sonora_dirt if using TWC anyway.

          string nativeName1 = "aztecs"; string nativeName2 = "caribs"; string nativeName3 = "incas"; string nativeName4 = "maya"; string nativeName5 = "tupi";
if(nativeSet==2){nativeName1 = "tupi";          nativeName2 = "aztecs";        nativeName3 = "caribs";       nativeName4 = "incas";       nativeName5 = "maya"; }
if(nativeSet==3){nativeName1 = "maya";          nativeName2 = "tupi";          nativeName3 = "aztecs";       nativeName4 = "caribs";      nativeName5 = "incas"; }
if(nativeSet==4){nativeName1 = "incas";         nativeName2 = "maya";          nativeName3 = "tupi";         nativeName4 = "aztecs";      nativeName5 = "caribs"; }
if(nativeSet==5){nativeName1 = "caribs";        nativeName2 = "incas";         nativeName3 = "maya";         nativeName4 = "tupi";        nativeName5 = "aztecs"; }

   if(pick == 2)
 { mapType               = "amazonia";               zoneType          = "tropical";
   terrainCoast          = "amazon river basin";     terrainMix        = "amazon grass";            treeType        = "TreeAmazon";
   lightingType          = "amazon";                 whaleType         = "HumpbackWhale";           fishType        = "FishTarpon";
   herdableType          = "llama";                  questHerdableType = "sheep";                   huntable1Type   = "tapir";
   huntable2Type         = "rhea";                   birdProp          = "PropKingfisher";          specialProp     = "GroundPropsAm";
   extrasName            = "RiverRocksSmall";        TCDirt            = "pampas_dirt"; 
 }
// Tribes are the same for picks = 1  - 3.

   if(pick == 3)
 { mapType               = "andes";                  zoneType          = "mountain";
   terrainCoast          = "great lakes";            terrainMix        = "saguenay tundra";         treeType        = "treesaguenay";
   lightingType          = "saguenay";               whaleType         = "HumpbackWhale";           fishType        = "FishBass"; 
   herdableType          = "cow";                    questHerdableType = "sheep";                   huntable1Type   = "capybara"; 
   huntable2Type         = "tapir";                  birdProp          = "StartledBirds";           specialProp     = "PropGrassFire";
   extrasName            = "PropGrassFire";          TCDirt            = "texas_dirt";
 }
// Tribes are the same for picks = 1  - 3.
 
   if(pick == 4)
 { mapType               = "bayou";                  zoneType          = "tropical";
   terrainCoast          = "Yucatan Coast";          terrainMix        = "bayou_grass";             treeType        = "treebayou";
   lightingType          = "bayou";                  whaleType         = "MinkeWhale";              fishType        = "FishSardine";
   herdableType          = "llama";                  questHerdableType = "cow";                     huntable1Type   = "turkey";  
   huntable2Type         = "deer";                   birdProp          = "PropKingfisher";          specialProp     = "BigPropGeyser";
   extrasName            = "ShorelineRockSmallNE";   TCDirt            = "bayou_forest";

   if(useWarChiefsFlag == true) TCDirt = "painteddesert_groundmix_3"; // Better looking than bayou_forest if using TWC anyway.
 
   if(nativeSet==1)  {nativeName1 = "cherokee";  nativeName2 = "comanche";  nativeName3 = "iroquois";  nativeName4 = "lakota";    nativeName5 = "seminoles"; }
   if(nativeSet==2)  {nativeName1 = "seminoles"; nativeName2 = "cherokee";  nativeName3 = "comanche";  nativeName4 = "iroquois";  nativeName5 = "lakota"; }
   if(nativeSet==3)  {nativeName1 = "lakota";    nativeName2 = "seminoles"; nativeName3 = "cherokee";  nativeName4 = "comanche";  nativeName5 = "iroquois"; }
   if(nativeSet==4)  {nativeName1 = "iroquois";  nativeName2 = "lakota";    nativeName3 = "seminoles"; nativeName4 = "cherokee";  nativeName5 = "comanche"; }
   if(nativeSet==5)  {nativeName1 = "comanche";  nativeName2 = "iroquois";  nativeName3 = "lakota";    nativeName4 = "seminoles"; nativeName5 = "cherokee"; } 
 }
   if(pick == 5)
 { mapType               = "yukon";                  zoneType          = "mountain";
   terrainCoast          = "Atlantic Coast";         terrainMix        = "yukon grass";             treeType        = "treeyukon";
   lightingType          = "yukon";                  whaleType         = "Beluga";                  fishType        = "FishSalmon";
   herdableType          = "sheep";                  questHerdableType = "cow";                     huntable1Type   = "muskox";  
   huntable2Type         = "moose";                  birdProp          = "PropEaglesRocks";         specialProp     = "Inuksuk";
   extrasName            = "UnderbrushSnow";         TCDirt            = "yukon snow";
 
   if(nativeSet==1)  {nativeName1 = "cherokee"; nativeName2 = "cree";     nativeName3 = "iroquois"; nativeName4 = "lakota";   nativeName5 = "nootka"; }
   if(nativeSet==2)  {nativeName1 = "nootka";   nativeName2 = "cherokee"; nativeName3 = "cree";     nativeName4 = "iroquois"; nativeName5 = "lakota"; }
   if(nativeSet==3)  {nativeName1 = "lakota";   nativeName2 = "nootka";   nativeName3 = "cherokee"; nativeName4 = "cree";     nativeName5 = "iroquois"; }
   if(nativeSet==4)  {nativeName1 = "iroquois"; nativeName2 = "lakota";   nativeName3 = "nootka";   nativeName4 = "cherokee"; nativeName5 = "cree"; }
   if(nativeSet==5)  {nativeName1 = "cree";     nativeName2 = "iroquois"; nativeName3 = "lakota";   nativeName4 = "nootka";   nativeName5 = "cherokee"; } 
 }
   if(pick == 6)
 { mapType               = "sonora";                 zoneType          = "desert";
   terrainCoast          = "Texas Pond";             terrainMix        = "sonora_dirt";             treeType        = "treesonora";
   lightingType          = "sonora";                 whaleType         = "Beluga";                  fishType        = "FishMoonBass";
   herdableType          = "sheep";                  questHerdableType = "llama";                   huntable1Type   = "BighornSheep";  
   huntable2Type         = "bison";                  birdProp          = "StartledBirds";           specialProp     = "BigPropTexas";
   extrasName            = "ShorelineRockSmallNE";   TCDirt            = "texas_grass";
 
   if(nativeSet==1)  {nativeName1 = "cherokee";  nativeName2 = "comanche";  nativeName3 = "iroquois";  nativeName4 = "lakota";    nativeName5 = "seminoles"; }
   if(nativeSet==2)  {nativeName1 = "seminoles"; nativeName2 = "cherokee";  nativeName3 = "comanche";  nativeName4 = "iroquois";  nativeName5 = "lakota"; }
   if(nativeSet==3)  {nativeName1 = "lakota";    nativeName2 = "seminoles"; nativeName3 = "cherokee";  nativeName4 = "comanche";  nativeName5 = "iroquois"; }
   if(nativeSet==4)  {nativeName1 = "iroquois";  nativeName2 = "lakota";    nativeName3 = "seminoles"; nativeName4 = "cherokee";  nativeName5 = "comanche"; }
   if(nativeSet==5)  {nativeName1 = "comanche";  nativeName2 = "iroquois";  nativeName3 = "lakota";    nativeName4 = "seminoles"; nativeName5 = "cherokee"; } 
 }
   if(pick == 7)
 { mapType               = "california";             zoneType          = "mountain";
   terrainCoast          = "California Coast";       terrainMix        = "california_grass";        treeType         = "treeredwood";
   lightingType          = "california";             whaleType         = "MinkeWhale";              fishType         = "FishCod";
   herdableType          = "cow";                    questHerdableType = "llama";                   huntable1Type    = "turkey"; 
   huntable2Type         = "bison";                  birdProp          = "PropKingfisher";          specialProp      = "SPCXPMiningCampClone1";
   extrasName            = "CrateOfCoin";            TCDirt            = "california_desert0";
 
   if(nativeSet==1)  {nativeName1 = "apache";   nativeName2 = "comanche"; nativeName3 = "klamath";  nativeName4 = "navajo";   nativeName5 = "zapotec"; }
   if(nativeSet==2)  {nativeName1 = "zapotec";  nativeName2 = "apache";   nativeName3 = "comanche"; nativeName4 = "klamath";  nativeName5 = "navajo"; }
   if(nativeSet==3)  {nativeName1 = "navajo";   nativeName2 = "zapotec";  nativeName3 = "apache";   nativeName4 = "comanche"; nativeName5 = "klamath"; }
   if(nativeSet==4)  {nativeName1 = "klamath";  nativeName2 = "navajo";   nativeName3 = "zapotec";  nativeName4 = "apache";   nativeName5 = "comanche"; }
   if(nativeSet==5)  {nativeName1 = "comanche"; nativeName2 = "klamath";  nativeName3 = "navajo";   nativeName4 = "zapotec";  nativeName5 = "apache"; } 
 }
   if(pick == 8)
 { mapType               = "araucania";              zoneType          = "tropical";
   terrainCoast          = "Araucania North Coast";  terrainMix        = "araucania_north_grass_b"; treeType         = "treearaucania";
   lightingType          = "araucaniasouth";         whaleType         = "MinkeWhale";              fishType         = "FishCod";
   herdableType          = "sheep";                  questHerdableType = "cow";                     huntable1Type    = "tapir"; 
   huntable2Type         = "Capybara";               birdProp          = "PropKingfisher";          specialProp      = "SPCXPMiningCampClone1";
   extrasName            = "CrateOfCoin";            TCDirt            = "araucania_north_dirt_a";
 
   if(nativeSet==1)  {nativeName1 = "incas";  nativeName2 = "mapuche";  nativeName3 = "maya";  nativeName4 = "tupi";    nativeName5 = "zapotec"; }
   if(nativeSet==2)  {nativeName1 = "zapotec"; nativeName2 = "incas";  nativeName3 = "mapuche";  nativeName4 = "maya";  nativeName5 = "tupi"; }
   if(nativeSet==3)  {nativeName1 = "tupi";    nativeName2 = "zapotec"; nativeName3 = "incas";  nativeName4 = "mapuche";  nativeName5 = "maya"; }
   if(nativeSet==4)  {nativeName1 = "maya";  nativeName2 = "tupi";    nativeName3 = "zapotec"; nativeName4 = "incas";  nativeName5 = "mapuche"; }
   if(nativeSet==5)  {nativeName1 = "mapuche";  nativeName2 = "maya";  nativeName3 = "tupi";    nativeName4 = "zapotec"; nativeName5 = "incas"; } 
 }
   if(pick == 9)
 { mapType               = "california";             zoneType          = "desert"; // paintedDesert doesn't work nuggets right.
   terrainCoast      = "Northwest Territory Water";  terrainMix     = "painteddesert_groundmix_4";  treeType        = "treepainteddesert";
   lightingType          = "sonora";                 whaleType         = "Beluga";                  fishType        = "FishTarpon";
   herdableType          = "llama";                  questHerdableType = "sheep";                   huntable1Type   = "Pronghorn";  
   huntable2Type         = "BighornSheep";           birdProp          = "PropEaglesRocks";         specialProp     = "SPCXPMiningCampClone1";
   extrasName            = "CrateOfCoin";            TCDirt            = "painteddesert_groundmix_3";
 
   if(nativeSet==1)  {nativeName1 = "cree";    nativeName2 = "huron";   nativeName3 = "klamath"; nativeName4 = "navajo";  nativeName5 = "nootka"; }
   if(nativeSet==2)  {nativeName1 = "nootka";  nativeName2 = "cree";    nativeName3 = "huron";   nativeName4 = "klamath"; nativeName5 = "navajo"; }
   if(nativeSet==3)  {nativeName1 = "navajo";  nativeName2 = "nootka";  nativeName3 = "cree";    nativeName4 = "huron";   nativeName5 = "klamath"; }
   if(nativeSet==4)  {nativeName1 = "klamath"; nativeName2 = "navajo";  nativeName3 = "nootka";  nativeName4 = "cree";    nativeName5 = "huron"; }
   if(nativeSet==5)  {nativeName1 = "huron";   nativeName2 = "klamath"; nativeName3 = "navajo";  nativeName4 = "nootka";  nativeName5 = "cree"; } 
 }
// I1.80 Start native civilizations.

   string villageName1 = "native " + nativeName1 + " village "; string villageName2 = "native " + nativeName2 + " village ";
   string villageName3 = "native " + nativeName3 + " village "; string villageName4 = "native " + nativeName4 + " village ";
   if(nativeName1 == "aztecs") villageName1 = "native aztec village "; if(nativeName1 == "caribs") villageName1 = "native carib village "; 
   if(nativeName2 == "aztecs") villageName2 = "native aztec village "; if(nativeName2 == "caribs") villageName2 = "native carib village "; 
   if(nativeName3 == "aztecs") villageName3 = "native aztec village "; if(nativeName3 == "caribs") villageName3 = "native carib village "; 
   if(nativeName4 == "aztecs") villageName4 = "native aztec village "; if(nativeName4 == "caribs") villageName4 = "native carib village "; 
   if(nativeName1 == "incas") villageName1 = "native inca village ";if(nativeName1 == "seminoles") villageName1 = "native seminole village "; 
   if(nativeName2 == "incas") villageName2 = "native inca village "; if(nativeName2 == "seminoles") villageName2 = "native seminole village "; 
   if(nativeName3 == "incas") villageName3 = "native inca village "; if(nativeName3 == "seminoles") villageName3 = "native seminole village "; 
   if(nativeName4 == "incas") villageName4 = "native inca village "; if(nativeName4 == "seminoles") villageName4 = "native seminole village "; 
   villageName1 = villageName1 + rmRandInt(1,5); villageName2 = villageName2 + rmRandInt(1,5);
   villageName3 = villageName3 + rmRandInt(1,5); villageName4 = villageName4 + rmRandInt(1,5);
   string nativeSocketType = "Socket" + nativeName5;
   if(nativeName5 == "aztecs") nativeSocketType ="SocketAztec"; if(nativeName5 == "seminoles") nativeSocketType ="SocketSeminole";
   if(nativeName5 == "incas")  nativeSocketType ="SocketInca";

   int subCiv0=-1;
   int subCiv1=-1;
   int subCiv2=-1;
   int subCiv3=-1;
   int subCiv4=-1;

   if(rmAllocateSubCivs(5) == true)
 {
   subCiv0=rmGetCivID(nativeName1); if (subCiv0 >= 0) rmSetSubCiv(0, nativeName1);
   subCiv1=rmGetCivID(nativeName2); if (subCiv1 >= 0) rmSetSubCiv(1, nativeName2);
   subCiv2=rmGetCivID(nativeName3); if (subCiv2 >= 0) rmSetSubCiv(2, nativeName3);
   subCiv3=rmGetCivID(nativeName4); if (subCiv3 >= 0) rmSetSubCiv(3, nativeName4);
   subCiv4=rmGetCivID(nativeName5); if (subCiv4 >= 0) rmSetSubCiv(4, nativeName5);
 }
   pick = rmRandInt(1,3); string crateType = "CrateofFoodLarge"; if(pick == 2) crateType = "CrateofWoodLarge"; if(pick == 3) crateType = "CrateofCoinLarge";
   string crateName = "food"; if(crateType == "CrateofWoodLarge") crateName = "wood"; if(crateType == "CrateofCoinLarge") crateName = "coin";
   string siteCrateType = "CrateofWoodLarge"; string siteCrateName = "wood";
   if(crateType == "CrateofWoodLarge") { siteCrateType = "CrateofCoinLarge"; siteCrateName = "coin"; }
   pick = rmRandInt(1,4); string wagonType = "fortwagon"; string wagonName = "fort wagon";
   if(pick == 2) { wagonType = "coveredwagon"; wagonName = "covered wagon"; if(rmGetPlayerCiv(1) > 10) wagonName = "town travois"; }
   if(pick == 3 && rmGetPlayerCiv(1) < 10) { wagonType = "outpostwagon"; wagonName = "outpost wagon"; }
   if(pick == 3 && rmGetPlayerCiv(1) > 10) { wagonType = "WarHutTravois"; wagonName = "war hut travois"; }
   if(pick == 4 && rmGetPlayerCiv(1) < 10) { wagonType = "factorywagon"; wagonName = "factory wagon"; }
   if(pick == 4 && rmGetPlayerCiv(1) > 10) { wagonType = "FarmTravois"; wagonName = "farm travois"; }
   if(useWarChiefsFlag == true && rmGetPlayerCiv(1) < 10 && wagonType == "fortwagon") { wagonType = "factorywagon"; wagonName = "factory wagon"; }
   if(useWarChiefsFlag == true && rmGetPlayerCiv(1) > 10 && wagonType == "fortwagon") { wagonType = "FarmTravois"; wagonName = "farm travois"; }
   pick = rmRandInt(1,6); if(rmGetNomadStart() == true) pick = rmRandInt(1,5); // 2nd random pick is to prevent a 2nd surgeon on nomad start map.
   string bonusUnitType = "explorer"; string bonusUnitName = "explorer"; if(pick > 2 && nuggetBoatType != "privateer") bonusUnitType = "privateer";
   if(pick == 5) bonusUnitType = "canoe"; if(pick == 6) bonusUnitType = "surgeon";
   bonusUnitName = bonusUnitType;
   if(pick < 3 && rmGetPlayerCiv(1) > 10) bonusUnitName = "warchief";
   if(pick < 3 && rmGetPlayerCiv(1) == 15) bonusUnitType = "xpIroquoisWarchief";
   if(pick < 3 && rmGetPlayerCiv(1) == 16) bonusUnitType = "xpLakotaWarchief";
   if(pick < 3 && rmGetPlayerCiv(1) == 17) bonusUnitType = "xpAztecWarchief";
   if(bonusUnitType == "surgeon" && rmGetPlayerCiv(1) > 10) { bonusUnitType = "xpMedicineMan"; bonusUnitName = "medicine man"; }
   pick = rmRandInt(1,3);
   if(bonusUnitType == "caravel" && useWarChiefsFlag == true && pick == 3) { bonusUnitType = "xpTlalocCanoe"; bonusUnitName = "tlaloc canoe"; }
   if(bonusUnitType == "canoe" && useWarChiefsFlag == true && pick == 3) { bonusUnitType = "SPCXPFlatBoat"; bonusUnitName = "flat boat"; }
   if(bonusUnitType == "privateer" && useWarChiefsFlag == true && pick == 3) { bonusUnitType = "xpWarCanoe"; bonusUnitName = "war canoe"; }
   string mineType = "mineCopper";
   if(useWarChiefsFlag == false || (useWarChiefsFlag == true && rmRandInt(1,3) == 3)) mineType = "mine";

   rmSetSeaLevel(0.0);
   rmSetSeaType(terrainCoast);
   rmSetBaseTerrainMix(terrainMix);
   rmSetMapType("water");
   rmSetMapType(zoneType);
   rmSetMapType(mapType);
   rmSetLightingSet(lightingType);

// rmSetWorldCircleConstraint(true);

// Init map.
   rmTerrainInitialize("water");

// Elevation
   rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
   rmSetMapElevationHeightBlend(0.2); 
   rmTerrainInitialize("water");
   rmSetWorldCircleConstraint(true);
   rmSetWindMagnitude(rmRandFloat(0.0,10.0));
   
   chooseMercs();

// I1.90 Define some classes.
   int classKeyLand=rmDefineClass("keyLand");
   int classPlayerLand=rmDefineClass("playerLand");
   int classMainLand=rmDefineClass("mainLand");
   rmDefineClass("classSocket");
   rmDefineClass("natives");
   rmDefineClass("classBFG");

/* I2.0 Constraints */  rmSetStatusText("",0.1);

// -------------Define constraints

// I2.1 Type Distance Constraints

   int avoidTC15=rmCreateTypeDistanceConstraint("stay 15 away from TC", "TownCenter", 15.0);
   int avoidTC30=rmCreateTypeDistanceConstraint("stay 30 away from TC", "TownCenter", 30.0);
   int avoidTCFar=rmCreateTypeDistanceConstraint("stay far away from TC", "TownCenter", 3*objectDistance);
   int avoidCW15=rmCreateTypeDistanceConstraint("stay 15 away from CW", "CoveredWagon", 15.0);
   int avoidCW=rmCreateTypeDistanceConstraint("stay away from CW", "CoveredWagon", objectDistance);
   int avoidCWFar=rmCreateTypeDistanceConstraint("stay far away from CW", "CoveredWagon", 3*objectDistance);
   int avoidFlag = rmCreateTypeDistanceConstraint("avoid flag", "HomeCityWaterSpawnFlag", 20);
   int avoidFlagFar = rmCreateTypeDistanceConstraint("avoid flag far", "HomeCityWaterSpawnFlag", 2*objectDistance);
   int avoidSilver=rmCreateTypeDistanceConstraint("avoid silver mine", "mine", 10.0);
   int avoidMine10=rmCreateTypeDistanceConstraint("avoid mine by 10", mineType, 10.0);
   int avoidMine=rmCreateTypeDistanceConstraint("avoid mine", mineType, 0.5*objectDistance);
   int avoidGold=rmCreateTypeDistanceConstraint("avoid gold mine", "minegold", 0.5*objectDistance);
   int avoidGold30=rmCreateTypeDistanceConstraint("avoid gold mine by 30", "minegold", 30.0);
   int avoidFarGold=rmCreateTypeDistanceConstraint("avoid far gold mine", "minegold", 2*objectDistance);
   int avoidFish=rmCreateTypeDistanceConstraint("avoid fish", fishType, 0.5*objectDistance);
   int avoidNugget=rmCreateTypeDistanceConstraint("avoid nugget", "abstractNugget", 10.0);
   int avoidNuggetFar=rmCreateTypeDistanceConstraint("avoid nugget far", "abstractNugget", 50.0);
   int nuggetAvoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "abstractNugget", 20.0);
   int avoidWhaleVar=rmCreateTypeDistanceConstraint("avoid whale var", whaleType, (5-fishCount)*objectDistance); // Less whales means farther apart.
   int avoidWhale20=rmCreateTypeDistanceConstraint("avoid whale by 20", whaleType, 20.0);
   int avoidHuntable1=rmCreateTypeDistanceConstraint("avoid huntable 1", huntable1Type, 0.4*objectDistance);
   int avoidHuntable2=rmCreateTypeDistanceConstraint("avoid huntable 2", huntable2Type, 0.4*objectDistance);
   int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", herdableType, 20.0);
   int avoidRocks=rmCreateTypeDistanceConstraint("avoid rocks", "ShorelineRockBigNE", 4.0);
   int avoidDucks=rmCreateTypeDistanceConstraint("avoid ducks", "DuckFamily", 4.0);
   int avoidPlants=rmCreateTypeDistanceConstraint("avoid plants", "PlantsBay", 4.0);
   int avoidCratesLong=rmCreateTypeDistanceConstraint("avoid crates long", crateType, 75.0);
   int avoidCrates=rmCreateTypeDistanceConstraint("avoid crates", crateType, 10.0);
   int avoidWagon=rmCreateTypeDistanceConstraint("avoid wagon", wagonType, 10.0);
   int avoidSpecialProp=rmCreateTypeDistanceConstraint("avoid special prop", specialProp, 15.0);
   int avoidBirdProp=rmCreateTypeDistanceConstraint("avoid tree prop", birdProp, 10.0);
   int avoidTree=rmCreateTypeDistanceConstraint("avoid trees", "tree", 4.0);
   int avoidTreeFar=rmCreateTypeDistanceConstraint("avoid trees far", "tree", objectDistance);
   int avoidWarHut=rmCreateTypeDistanceConstraint("avoid war hut", "SPCCherokeeWarHut", 15.0);
   int avoidOssuary=rmCreateTypeDistanceConstraint("avoid ossuary", "SPCOssuary", 15.0);
   int avoidExplorerFar=rmCreateTypeDistanceConstraint("avoid explorer far", "explorer", 3*objectDistance);
   int avoidExplorer=rmCreateTypeDistanceConstraint("avoid explorer", "explorer", objectDistance);
   int avoidBerriesLong=rmCreateTypeDistanceConstraint("avoid berries long", "berryBush", 75.0);
   int avoidBonusWagonFar=rmCreateTypeDistanceConstraint("avoid bonus wagon far", wagonType, 3*objectDistance);
   int avoidLivestockPen=rmCreateTypeDistanceConstraint("avoid livestock pen", "LivestockPen", 15.0);
   int avoidFactory=rmCreateTypeDistanceConstraint("avoid factory", "Factory", 15.0);

// I2.2 Terrain Constraints
   int avoidLand8 = rmCreateTerrainDistanceConstraint("avoid land by 8", "land", true, 8.0);
   int avoidLand12 = rmCreateTerrainDistanceConstraint("avoid land by 12", "land", true, 12.0);
   int avoidLand20 = rmCreateTerrainDistanceConstraint("avoid land by 20", "land", true, 20.0);
   int avoidWater = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 5.0);
   int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water by 8", "Land", false, 8.0);
   int nearShore=rmCreateTerrainMaxDistanceConstraint("stay near shore", "land", true, 15.0);
   int nearWater=rmCreateTerrainMaxDistanceConstraint("stay near Water", "Water", true, 5.0);
// I2.3 Class Constaints
   int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 6.0);
   int avoidBFG=rmCreateClassDistanceConstraint("stuff avoids BFG", rmClassID("classBFG"), 10.0);
   int avoidKeyLand = rmCreateClassDistanceConstraint("avoid player and elbow islands", classKeyLand, 10.0);
   int avoidPlayerLand = rmCreateClassDistanceConstraint("avoid player islands", classPlayerLand, objectDistance);
   int avoidMainLand = rmCreateClassDistanceConstraint("avoid main land", classMainLand, 30.0);
   int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("classSocket"), 15.0);
// I2.4 Misc Constraints
   int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
   int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-30, rmGetMapXSize()-10, 0, 0, 0);

// End of constraints -----------------------------------:)

/* I3.0 Define Objects */  rmSetStatusText("",0.15);

// I3.1 Player objects
// Player Trees	
   int treeID=rmCreateObjectDef("player trees"); rmAddObjectDefItem(treeID, treeType, 1+4*treeCount, 9.0);
   rmSetObjectDefMinDistance(treeID, 17.0); rmSetObjectDefMaxDistance(treeID, 0.5*objectDistance);
   rmAddObjectDefConstraint(treeID, avoidTradeRoute);
// Player Mines
   int playerMineID = rmCreateObjectDef("player mine");
   rmAddObjectDefItem(playerMineID, mineType, 1, 0);
   rmSetObjectDefMinDistance(playerMineID, 18.0); rmSetObjectDefMaxDistance(playerMineID, 0.55*objectDistance);
   rmAddObjectDefConstraint(playerMineID, avoidCW15); rmAddObjectDefConstraint(playerMineID, avoidMine10);
   rmAddObjectDefConstraint(playerMineID, avoidMine);
   rmAddObjectDefConstraint(playerMineID, avoidGold); rmAddObjectDefConstraint(playerMineID, avoidWater);
   rmAddObjectDefConstraint(playerMineID, avoidTradeRoute);
// Player Huntables	
   int closeHuntableID=rmCreateObjectDef("close huntable herd"); rmAddObjectDefItem(closeHuntableID, huntable1Type, gameCount+1, 5.0);
   rmSetObjectDefMinDistance(closeHuntableID, 15.0); rmSetObjectDefMaxDistance(closeHuntableID, 0.5*objectDistance);
   rmAddObjectDefConstraint(closeHuntableID, avoidHuntable1); rmAddObjectDefConstraint(closeHuntableID, avoidHuntable2);
   rmSetObjectDefCreateHerd(closeHuntableID, true);
// Island livestock pen
   int livestockPenID = rmCreateObjectDef("livestock pen"); rmAddObjectDefItem(livestockPenID, "LivestockPen", 1, 0.0);
   rmSetObjectDefMinDistance(livestockPenID, 0.0); rmSetObjectDefMaxDistance(livestockPenID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(livestockPenID, avoidMainLand); rmAddObjectDefConstraint(livestockPenID, avoidWater8);
   rmAddObjectDefConstraint(livestockPenID, avoidWarHut); rmAddObjectDefConstraint(livestockPenID, avoidOssuary);
   rmAddObjectDefConstraint(livestockPenID, avoidBFG);
// Island Factory
   int factoryID = rmCreateObjectDef("factory"); rmAddObjectDefItem(factoryID, "Factory", 1, 0.0);
   rmSetObjectDefMinDistance(factoryID, 0.0); rmSetObjectDefMaxDistance(factoryID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(factoryID, avoidMainLand); rmAddObjectDefConstraint(factoryID, avoidWater8);
   rmAddObjectDefConstraint(factoryID, avoidWarHut); rmAddObjectDefConstraint(factoryID, avoidOssuary);
   rmAddObjectDefConstraint(factoryID, avoidBFG); rmAddObjectDefConstraint(factoryID, avoidLivestockPen);
   rmAddObjectDefConstraint(factoryID, avoidSocket); 
// Bison carcass grouping. Using this to get some bird eye candy.
   int groupID = rmCreateGrouping("grouping object", "gp_carcass_bison");
   rmSetGroupingMinDistance(groupID, 15.0);
   rmSetGroupingMaxDistance(groupID, 25.0);
   rmAddGroupingConstraint(groupID, avoidTradeRoute);
// Quest object. Used to show the quests when selected.
   int questID=rmCreateObjectDef("quest object"); rmAddObjectDefItem(questID, "SPCWhiteBuffalo", 1, 0.0);
   if(rmGetNomadStart() == false) { rmSetObjectDefMinDistance(questID, 12.0); rmSetObjectDefMaxDistance(questID, 17.0); }
   if(rmGetNomadStart() == true)  { rmSetObjectDefMinDistance(questID,  0.0); rmSetObjectDefMaxDistance(questID,  7.0); }
// Treasure item. Used to show the quests when selected.
   string treasureItem = "SPCTentLarge"; string treasureItemName = "tent";
   int treasureItemID=rmCreateObjectDef("treasure item"); rmAddObjectDefItem(treasureItemID, treasureItem, 1, 0.0);
   if(rmGetNomadStart() == false) { rmSetObjectDefMinDistance(treasureItemID, 12.0); rmSetObjectDefMaxDistance(treasureItemID, 17.0); }
   if(rmGetNomadStart() == true)  { rmSetObjectDefMinDistance(treasureItemID,  0.0); rmSetObjectDefMaxDistance(treasureItemID,  7.0); }
// Eagle. Used for end game cinematic.
   int eagleID=rmCreateObjectDef("eagle"); rmAddObjectDefItem(eagleID, "Eagle", 1, 0.0);
   rmSetObjectDefMinDistance(eagleID, 0.0); rmSetObjectDefMaxDistance(eagleID, 5.0);

// I3.2 Define Resources

// I3.21 Define mines

// I3.22 Define huntables

// I3.23 Define herdables

// Herdable 
   int herdableCount = rmRandInt(2,3); int herdableGroups = rmRandInt(1,2);
   int herdableID=rmCreateObjectDef("herdable"); rmAddObjectDefItem(herdableID, herdableType, herdableCount, 5.0);
   rmSetObjectDefMinDistance(herdableID, 20.0); rmSetObjectDefMaxDistance(herdableID, objectDistance);
   rmAddObjectDefConstraint(herdableID, avoidTC30); rmAddObjectDefConstraint(herdableID, avoidExplorer);
   rmAddObjectDefConstraint(herdableID, avoidCW);

// Player 1 quest herdable
   int questHerdableID = rmCreateObjectDef("quest herdable"); rmAddObjectDefItem(questHerdableID, questHerdableType, 1, 0.0);
   rmSetObjectDefMinDistance(questHerdableID, 10.0); rmSetObjectDefMaxDistance(questHerdableID, 12.0);

// Livestock pen herdables
   int penHerdableID = rmCreateObjectDef("pen herdable"); rmAddObjectDefItem(penHerdableID, herdableType, 1, 0.0);

// I3.24 Define trees

// I3.25 Define berries

   int berryCount = rmRandInt(2,5);
   int berryID=rmCreateObjectDef("berries"); rmAddObjectDefItem(berryID, "berryBush", berryCount, 3.0);
   rmSetObjectDefMinDistance(berryID, 15); rmSetObjectDefMaxDistance(berryID, 0.5*objectDistance);
   rmAddObjectDefConstraint(berryID, avoidTradeRoute); rmAddObjectDefConstraint(berryID, avoidWarHut);
   rmAddObjectDefConstraint(berryID, avoidOssuary);

// I3.3 Other objects
// Extra trees	
   int XTreeID=rmCreateObjectDef("extra trees"); rmAddObjectDefItem(XTreeID, treeType, 1+4*treeCount, 9.0);
   rmSetObjectDefMinDistance(XTreeID, 0.0); rmSetObjectDefMaxDistance(XTreeID, objectDistance);
   rmAddObjectDefConstraint(XTreeID, avoidWater); rmAddObjectDefConstraint(XTreeID, avoidTradeRoute);

// Factory tree

   int factoryTreeID=rmCreateObjectDef("factory tree"); rmAddObjectDefItem(factoryTreeID, treeType, 1, 0.0);

// Campfire

   int campfireID=rmCreateObjectDef("campfire"); rmAddObjectDefItem(campfireID, "Campfire", 1, 0.0);

// Tanningrack

   int tanningrackID=rmCreateObjectDef("tanningrack"); rmAddObjectDefItem(tanningrackID, "TanningRack", 1, 0.0);

// Native villagers

   int nativeVillagerID=rmCreateObjectDef("native villager"); rmAddObjectDefItem(nativeVillagerID, "NativeVillagers", 1, 0.0);

// Native house cherokee

   int nativeHouseID=rmCreateObjectDef("native house"); rmAddObjectDefItem(nativeHouseID, "NativeHouseCherokee", 1, 0.0);

// Tent

   string tentType = "SPCTentLarge";
   if(useWarChiefsFlag == true) tentType = "TeePee";
   int tentID=rmCreateObjectDef("tent"); rmAddObjectDefItem(tentID, tentType, 1, 0.0);

// Other mines
   int mineID = rmCreateObjectDef("random mine");
   rmAddObjectDefItem(mineID, mineType, 1, 0);
   rmSetObjectDefMinDistance(mineID, 0.0); rmSetObjectDefMaxDistance(mineID, objectDistance);
   rmAddObjectDefConstraint(mineID, avoidTC30); rmAddObjectDefConstraint(mineID, avoidCW15);
   rmAddObjectDefConstraint(mineID, avoidMine);
   rmAddObjectDefConstraint(mineID, avoidGold); rmAddObjectDefConstraint(mineID, avoidWater);
   rmAddObjectDefConstraint(mineID, avoidTradeRoute); rmAddObjectDefConstraint(mineID, avoidNatives);
   int goldID = rmCreateObjectDef("random gold mine"); rmAddObjectDefItem(goldID, "minegold", 1, 0);
   rmSetObjectDefMinDistance(goldID, 0.0); rmSetObjectDefMaxDistance(goldID, objectDistance);
   rmAddObjectDefConstraint(goldID, avoidTC30); rmAddObjectDefConstraint(goldID, avoidCW15);
   rmAddObjectDefConstraint(goldID, avoidMine);
   rmAddObjectDefConstraint(goldID, avoidGold); rmAddObjectDefConstraint(goldID, avoidWater);
   rmAddObjectDefConstraint(goldID, avoidTradeRoute); rmAddObjectDefConstraint(goldID, avoidNatives);
   int bonusMineID = rmCreateObjectDef("bonus gold mine"); rmAddObjectDefItem(bonusMineID, "minegold", 1, 0);
   rmSetObjectDefMinDistance(bonusMineID, 0.0); rmSetObjectDefMaxDistance(bonusMineID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(bonusMineID, avoidMainLand); rmAddObjectDefConstraint(bonusMineID, avoidFarGold);
   rmAddObjectDefConstraint(bonusMineID, avoidWater); rmAddObjectDefConstraint(bonusMineID, avoidWarHut);
   rmAddObjectDefConstraint(bonusMineID, avoidOssuary);
// Other Huntables	
   int huntable1ID=rmCreateObjectDef("huntable 1 herd"); rmAddObjectDefItem(huntable1ID, huntable1Type, gameCount+1, 10.0);
   rmSetObjectDefMinDistance(huntable1ID, 0.0); rmSetObjectDefMaxDistance(huntable1ID, objectDistance);
   rmAddObjectDefConstraint(huntable1ID, avoidHuntable1); rmAddObjectDefConstraint(huntable1ID, avoidHuntable2);
   rmSetObjectDefCreateHerd(huntable1ID, true);
   int huntable2ID=rmCreateObjectDef("huntable 2 herd"); rmAddObjectDefItem(huntable2ID, huntable2Type, gameCount+1, 10.0);
   rmSetObjectDefMinDistance(huntable2ID, 0.0); rmSetObjectDefMaxDistance(huntable2ID, objectDistance);
   rmAddObjectDefConstraint(huntable2ID, avoidHuntable1); rmAddObjectDefConstraint(huntable2ID, avoidHuntable2);
   rmSetObjectDefCreateHerd(huntable2ID, true); 
// Random trees
   int randomTreeID=rmCreateObjectDef("random tree"); rmAddObjectDefItem(randomTreeID, treeType, treeCount, 7.0);
   rmSetObjectDefMinDistance(randomTreeID, 0.0); rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(randomTreeID, avoidTradeRoute);
   rmAddObjectDefConstraint(randomTreeID, avoidNatives);
// I3.4 Nuggets
   int nuggetID=rmCreateObjectDef("nugget"); rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
   rmSetObjectDefMinDistance(nuggetID, 0.0); rmSetObjectDefMaxDistance(nuggetID, objectDistance);
   rmAddObjectDefConstraint(nuggetID, nuggetAvoidNugget); rmAddObjectDefConstraint(nuggetID, avoidTC30);
   rmAddObjectDefConstraint(nuggetID, avoidSilver); rmAddObjectDefConstraint(nuggetID, avoidGold);
   rmAddObjectDefConstraint(nuggetID, avoidTradeRoute); rmAddObjectDefConstraint(nuggetID, avoidWater);
   rmAddObjectDefConstraint(nuggetID, avoidNatives);
// Bonus Nuggets
   int bonusNuggetID=rmCreateObjectDef("bonus nugget"); rmAddObjectDefItem(bonusNuggetID, "Nugget", 1, 0.0);
   rmSetObjectDefMinDistance(bonusNuggetID, 0.0); rmSetObjectDefMaxDistance(bonusNuggetID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(bonusNuggetID, avoidNuggetFar); rmAddObjectDefConstraint(bonusNuggetID, avoidMainLand);
   rmAddObjectDefConstraint(bonusNuggetID, avoidSilver); rmAddObjectDefConstraint(bonusNuggetID, avoidGold);
   rmAddObjectDefConstraint(bonusNuggetID, avoidWater); rmAddObjectDefConstraint(bonusNuggetID, avoidWagon);
   rmAddObjectDefConstraint(bonusNuggetID, avoidWarHut); rmAddObjectDefConstraint(bonusNuggetID, avoidOssuary);
   rmAddObjectDefConstraint(bonusNuggetID, avoidFactory); rmAddObjectDefConstraint(bonusNuggetID, avoidSpecialProp);
   rmAddObjectDefConstraint(bonusNuggetID, avoidBirdProp); 
// I3.5 Nomad start objects.
// Explorer
   int explorerID = rmCreateObjectDef("explorer"); rmAddObjectDefItem(explorerID, "explorer", 1, 0);
   rmSetObjectDefMinDistance(explorerID, 0.0); rmSetObjectDefMaxDistance(explorerID, 15.0);
   if(useWarChiefsFlag == true)
 {
// Aztec warchief
   int aztecWarchiefID = rmCreateObjectDef("aztec warchief"); rmAddObjectDefItem(aztecWarchiefID, "xpAztecWarchief", 1, 0);
   rmSetObjectDefMinDistance(aztecWarchiefID, 0.0); rmSetObjectDefMaxDistance(aztecWarchiefID, 15.0);
// Iroquois warchief
   int iroquoisWarchiefID = rmCreateObjectDef("iroquois warchief"); rmAddObjectDefItem(iroquoisWarchiefID, "xpIroquoisWarchief", 1, 0);
   rmSetObjectDefMinDistance(iroquoisWarchiefID, 0.0); rmSetObjectDefMaxDistance(iroquoisWarchiefID, 15.0);
// Sioux warchief
   int siouxWarchiefID = rmCreateObjectDef("sioux warchief"); rmAddObjectDefItem(siouxWarchiefID, "xpLakotaWarchief", 1, 0);
   rmSetObjectDefMinDistance(siouxWarchiefID, 0.0); rmSetObjectDefMaxDistance(siouxWarchiefID, 15.0);
 }
// Settler
   int settlerID = rmCreateObjectDef("settler"); rmAddObjectDefItem(settlerID, "Settler", 2, 5.0);
   rmSetObjectDefMinDistance(settlerID, 0.0); rmSetObjectDefMaxDistance(settlerID, 15.0);
// Mercenary
   int mercCount = 2; if(useWarChiefsFlag == true) mercCount = 1; 
   int mercenaryID = rmCreateObjectDef("mercenary");
   if(rmGetPlayerCiv(1) < 10) rmAddObjectDefItem(mercenaryID, "mercjaeger", mercCount, 5.0);
   if(rmGetPlayerCiv(1) > 10) rmAddObjectDefItem(mercenaryID, "xpWarRifle", 1, 5.0);
   rmSetObjectDefMinDistance(mercenaryID, 0.0); rmSetObjectDefMaxDistance(mercenaryID, 15.0);
// Surgeon
   int surgeonID = rmCreateObjectDef("surgeon");
   if(rmGetPlayerCiv(1) < 10) rmAddObjectDefItem(surgeonID, "surgeon", 1, 5.0);
   if(rmGetPlayerCiv(1) > 10) rmAddObjectDefItem(surgeonID, "xpMedicineMan", 1, 5.0);
   rmSetObjectDefMinDistance(surgeonID, 0.0); rmSetObjectDefMaxDistance(surgeonID, 15.0);
// Caravel
   int caravelID = rmCreateObjectDef("caravel"); rmAddObjectDefItem(caravelID, "caravel", 1, 0);
   rmSetObjectDefMinDistance(caravelID, 0.0); rmSetObjectDefMaxDistance(caravelID, 20.0);
// Covered Wagon
   int coveredWagonID = rmCreateObjectDef("covered wagon"); rmAddObjectDefItem(coveredWagonID, "coveredwagon", 1, 0);
   rmSetObjectDefMinDistance(coveredWagonID, 0.0); rmSetObjectDefMaxDistance(coveredWagonID, 15.0);
// Nomad wood
   int woodID = rmCreateObjectDef("nomad wood"); rmAddObjectDefItem(woodID, "CrateOfWood", 1, 0);
   rmSetObjectDefMinDistance(woodID, 15.0); rmSetObjectDefMaxDistance(woodID, objectDistance);
   rmAddObjectDefConstraint(woodID, avoidWater);
// Special Prop extras.
   int extrasID = rmCreateObjectDef("special prop extra"); rmAddObjectDefItem(extrasID, extrasName, 1, 0);
// Special Prop extras.
   string goldWagonType = "SPCWagonGold"; if(useWarChiefsFlag == true) goldWagonType = "SPCXPJeffWagonCoin"; 
   int wagonGoldID = rmCreateObjectDef("gold wagon"); rmAddObjectDefItem(wagonGoldID, goldWagonType, 1, 0); // Try: SPCXPJeffWagonCoin or SPCWagonGold
// Bird prop XP
   int XPID = rmCreateObjectDef("XP"); rmAddObjectDefItem(XPID, "CrateofXP", 1, 0);
// I3.6 Water objects
// Water Flag Fish (Supposedly helps AI decide to fish when fish are by their water flag.)
   int flagFishID=rmCreateObjectDef("flag fish"); rmAddObjectDefItem(flagFishID, fishType, 2, 10.0);
   rmSetObjectDefMinDistance(flagFishID, 0.0); rmSetObjectDefMaxDistance(flagFishID, 10.0);
// Whales
   int whaleID=rmCreateObjectDef("whale"); 
   rmAddObjectDefItem(whaleID, whaleType, 1, 0.0);
   rmSetObjectDefMinDistance(whaleID, 0.0); rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.45));
   rmAddObjectDefConstraint(whaleID, avoidWhaleVar); rmAddObjectDefConstraint(whaleID, avoidLand20);
   rmAddObjectDefConstraint(whaleID, avoidFlag);
// Fish
   int fishID=rmCreateObjectDef("fish"); rmAddObjectDefItem(fishID, fishType, fishCount, 10.0);
   rmSetObjectDefMinDistance(fishID, 0.0); rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fishID, avoidFish); rmAddObjectDefConstraint(fishID, avoidWhale20); 
   rmAddObjectDefConstraint(fishID, avoidLand8);
// Coastal rocks
   int rockID=rmCreateObjectDef("Coastal Rocks"); rmAddObjectDefItem(rockID, "ShorelineRockBigNE", 1, 0);
   rmSetObjectDefMinDistance(rockID, 0.0); rmSetObjectDefMaxDistance(rockID, rmXFractionToMeters(0.4));
   rmAddObjectDefConstraint(rockID, nearShore); rmAddObjectDefConstraint(rockID, avoidWhale20);
   rmAddObjectDefConstraint(rockID, avoidFish);
   rmAddObjectDefConstraint(rockID, avoidLand8);
// Duck family
   int ducksID=rmCreateObjectDef("duck family"); rmAddObjectDefItem(ducksID, "DuckFamily", 1, 0);
   rmSetObjectDefMinDistance(ducksID, 0.0); rmSetObjectDefMaxDistance(ducksID, rmXFractionToMeters(0.4));
   rmAddObjectDefConstraint(ducksID, nearShore); rmAddObjectDefConstraint(ducksID, avoidWhale20);
   rmAddObjectDefConstraint(ducksID, avoidFish);
   rmAddObjectDefConstraint(ducksID, avoidLand8); rmAddObjectDefConstraint(ducksID, avoidRocks);
// Water Plants
   int plantsID=rmCreateObjectDef("water plant"); rmAddObjectDefItem(plantsID, "PlantsBay", 3, 5.0);
   rmSetObjectDefMinDistance(plantsID, 0.0); rmSetObjectDefMaxDistance(plantsID, rmXFractionToMeters(0.4));
   rmAddObjectDefConstraint(plantsID, nearShore); rmAddObjectDefConstraint(plantsID, avoidWhale20);
   rmAddObjectDefConstraint(plantsID, avoidFish);
   rmAddObjectDefConstraint(plantsID, avoidLand8); rmAddObjectDefConstraint(plantsID, avoidRocks);
   rmAddObjectDefConstraint(plantsID, avoidDucks);
// Factory Water Plants
   int factoryPlantsID=rmCreateObjectDef("factory water plant"); rmAddObjectDefItem(factoryPlantsID, "PlantsBay", 3, 5.0);
   rmSetObjectDefMinDistance(factoryPlantsID, 0.0); rmSetObjectDefMaxDistance(factoryPlantsID, 30);
   rmAddObjectDefConstraint(factoryPlantsID, nearShore); rmAddObjectDefConstraint(factoryPlantsID, avoidWhale20);
   rmAddObjectDefConstraint(factoryPlantsID, avoidFish);
   rmAddObjectDefConstraint(factoryPlantsID, avoidLand8); rmAddObjectDefConstraint(factoryPlantsID, avoidRocks);
   rmAddObjectDefConstraint(factoryPlantsID, avoidDucks);
// Factory Turtles
   int turtlesID=rmCreateObjectDef("turtles"); rmAddObjectDefItem(turtlesID, "PropTurtles", 3, 12.0);
   rmSetObjectDefMinDistance(turtlesID, 0.0); rmSetObjectDefMaxDistance(turtlesID, 30);
   rmAddObjectDefConstraint(turtlesID, nearShore); rmAddObjectDefConstraint(turtlesID, avoidWhale20);
   rmAddObjectDefConstraint(turtlesID, avoidFish);
   rmAddObjectDefConstraint(turtlesID, avoidLand8); rmAddObjectDefConstraint(turtlesID, avoidRocks);
   rmAddObjectDefConstraint(turtlesID, avoidDucks);
// Shipwreck
   int shipwreckID=rmCreateObjectDef("shipwreck"); rmAddObjectDefItem(shipwreckID, "IGCShipwreck", 1, 0);
   rmSetObjectDefMinDistance(shipwreckID, 0.0); rmSetObjectDefMaxDistance(shipwreckID, rmXFractionToMeters(0.4));
   rmAddObjectDefConstraint(shipwreckID, nearShore); rmAddObjectDefConstraint(shipwreckID, avoidWhale20);
   rmAddObjectDefConstraint(shipwreckID, avoidFish);
   rmAddObjectDefConstraint(shipwreckID, avoidLand8); rmAddObjectDefConstraint(shipwreckID, avoidRocks);
   rmAddObjectDefConstraint(shipwreckID, avoidDucks); rmAddObjectDefConstraint(shipwreckID, avoidPlants);
// I3.7 Bonus island objects.
// Island Huntable	
   int islandHuntableID=rmCreateObjectDef("island huntable herd"); rmAddObjectDefItem(islandHuntableID, huntable2Type, gameCount+1, 5.0);
   rmSetObjectDefMinDistance(islandHuntableID, 0.0); rmSetObjectDefMaxDistance(islandHuntableID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(islandHuntableID, avoidMainLand); rmSetObjectDefCreateHerd(islandHuntableID, true);
// Bonus island special	prop
   int specialID=rmCreateObjectDef("island special prop"); rmAddObjectDefItem(specialID, specialProp, 1, 0);
   rmSetObjectDefMinDistance(specialID, 0.0); rmSetObjectDefMaxDistance(specialID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(specialID, avoidMainLand); rmAddObjectDefConstraint(specialID, avoidWater);
   rmAddObjectDefConstraint(specialID, avoidGold); rmAddObjectDefConstraint(specialID, avoidWagon);
   rmAddObjectDefConstraint(specialID, avoidNugget); rmAddObjectDefConstraint(specialID, avoidTree); 
   rmAddObjectDefConstraint(specialID, avoidWarHut); rmAddObjectDefConstraint(specialID, avoidOssuary);
   rmAddObjectDefConstraint(specialID, avoidSocket); rmAddObjectDefConstraint(specialID, avoidLivestockPen);
   rmAddObjectDefConstraint(specialID, avoidFactory);
// Bonus island tree prop
   int birdPropID=rmCreateObjectDef("island tree prop"); rmAddObjectDefItem(birdPropID, birdProp, 1, 0);
   rmSetObjectDefMinDistance(birdPropID, 0.0); rmSetObjectDefMaxDistance(birdPropID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(birdPropID, avoidMainLand); rmAddObjectDefConstraint(birdPropID, avoidWater);
   rmAddObjectDefConstraint(birdPropID, avoidGold); rmAddObjectDefConstraint(birdPropID, avoidWagon);
   rmAddObjectDefConstraint(birdPropID, avoidNugget); rmAddObjectDefConstraint(birdPropID, avoidTree);
   rmAddObjectDefConstraint(birdPropID, avoidSpecialProp); rmAddObjectDefConstraint(birdPropID, avoidWarHut);
   rmAddObjectDefConstraint(birdPropID, avoidOssuary); rmAddObjectDefConstraint(birdPropID, avoidSocket);
// Bonus island spanish ship ruins
   int shipRuinsID=rmCreateObjectDef("island ship ruins"); rmAddObjectDefItem(shipRuinsID, "SPCSpanishShipRuins", 1, 0);
   rmSetObjectDefMinDistance(shipRuinsID, 0.0); rmSetObjectDefMaxDistance(shipRuinsID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(shipRuinsID, avoidMainLand); rmAddObjectDefConstraint(shipRuinsID, nearWater);
   rmAddObjectDefConstraint(shipRuinsID, avoidGold); rmAddObjectDefConstraint(shipRuinsID, avoidNugget);
   rmAddObjectDefConstraint(shipRuinsID, avoidWarHut); rmAddObjectDefConstraint(shipRuinsID, avoidOssuary);
 // Bonus island crates
   int crateCount = size/300;
   int crateID=rmCreateObjectDef("bonus island crate"); rmAddObjectDefItem(crateID, crateType, crateCount, 3.0);
   rmSetObjectDefMinDistance(crateID, 0.0); rmSetObjectDefMaxDistance(crateID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(crateID, avoidMainLand); rmAddObjectDefConstraint(crateID, avoidWater);
   rmAddObjectDefConstraint(crateID, avoidGold); rmAddObjectDefConstraint(crateID, avoidNugget);
   rmAddObjectDefConstraint(crateID, avoidCratesLong); rmAddObjectDefConstraint(crateID, avoidWagon);
   rmAddObjectDefConstraint(crateID, avoidSpecialProp); rmAddObjectDefConstraint(crateID, avoidBirdProp);
   rmAddObjectDefConstraint(crateID, avoidWarHut); rmAddObjectDefConstraint(crateID, avoidOssuary); 
// Bonus island trees
   int islandTreeID=rmCreateObjectDef("bonus island trees"); rmAddObjectDefItem(islandTreeID, treeType, 1+4*treeCount, 9.0);
   rmSetObjectDefMinDistance(islandTreeID, 0.0); rmSetObjectDefMaxDistance(islandTreeID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(islandTreeID, avoidMainLand); rmAddObjectDefConstraint(islandTreeID, avoidWater); 
   rmAddObjectDefConstraint(islandTreeID, avoidNugget);
   rmAddObjectDefConstraint(islandTreeID, avoidCrates); rmAddObjectDefConstraint(islandTreeID, avoidWagon);
   rmAddObjectDefConstraint(islandTreeID, avoidSpecialProp); rmAddObjectDefConstraint(islandTreeID, avoidBirdProp);
   rmAddObjectDefConstraint(islandTreeID, avoidTreeFar); rmAddObjectDefConstraint(islandTreeID, avoidWarHut);
   rmAddObjectDefConstraint(islandTreeID, avoidOssuary);
// Bonus Island Berries
   int islandBerryID=rmCreateObjectDef("island berries"); rmAddObjectDefItem(islandBerryID, "berryBush", berryCount, 3.0);
   rmSetObjectDefMinDistance(islandBerryID, 0); rmSetObjectDefMaxDistance(islandBerryID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(islandBerryID, avoidMainLand); rmAddObjectDefConstraint(islandBerryID, avoidWater);
   rmAddObjectDefConstraint(islandBerryID, avoidBerriesLong); rmAddObjectDefConstraint(islandBerryID, avoidFactory);
   rmAddObjectDefConstraint(islandBerryID, avoidWarHut); rmAddObjectDefConstraint(islandBerryID, avoidOssuary);
   rmAddObjectDefConstraint(islandBerryID, avoidLivestockPen); rmAddObjectDefConstraint(islandBerryID, avoidSpecialProp);
// I3.8 BFG
   if(useBFGwithBaseFlag == true)
 {
   int BFGID = rmCreateGrouping("big fixed gun", "FixedGun&Base");
   rmSetGroupingMinDistance(BFGID, 0.0); rmSetGroupingMaxDistance(BFGID, rmXFractionToMeters(0.5));
   rmAddGroupingToClass(BFGID, rmClassID("classBFG"));
   rmAddGroupingConstraint(BFGID, avoidWater); rmAddGroupingConstraint(BFGID, avoidGold);
   rmAddGroupingConstraint(BFGID, avoidNugget); rmAddGroupingConstraint(BFGID, avoidMainLand); 
   rmAddGroupingConstraint(BFGID, avoidTCFar); rmAddGroupingConstraint(BFGID, avoidFlagFar);
   rmAddGroupingConstraint(BFGID, avoidWagon); rmAddGroupingConstraint(BFGID, avoidCrates);
   rmAddGroupingConstraint(BFGID, avoidSpecialProp); rmAddGroupingConstraint(BFGID, avoidBirdProp);
   rmAddGroupingConstraint(BFGID, avoidWarHut); rmAddGroupingConstraint(BFGID, avoidOssuary);
   rmAddGroupingConstraint(BFGID, avoidExplorerFar); rmAddGroupingConstraint(BFGID, avoidCWFar);
   rmAddGroupingConstraint(BFGID, avoidLivestockPen); rmAddGroupingConstraint(BFGID, avoidFactory);
   rmAddGroupingConstraint(BFGID, avoidSocket); 
 }
   if(useBFGwithBaseFlag == false)
 {
   int BFG1ID = rmCreateObjectDef("fixed gun no base"); rmAddObjectDefItem(BFG1ID, "SPCFixedGun", 1, 0);
   rmSetObjectDefMinDistance(BFG1ID, 0.0); rmSetObjectDefMaxDistance(BFG1ID, rmXFractionToMeters(0.5));
   rmAddObjectDefToClass(BFG1ID, rmClassID("classBFG"));
   rmAddObjectDefConstraint(BFG1ID, avoidWater); rmAddObjectDefConstraint(BFG1ID, avoidGold);
   rmAddObjectDefConstraint(BFG1ID, avoidNugget); rmAddObjectDefConstraint(BFG1ID, avoidMainLand);
   rmAddObjectDefConstraint(BFG1ID, avoidTCFar); rmAddObjectDefConstraint(BFG1ID, avoidFlagFar);
   rmAddObjectDefConstraint(BFG1ID, avoidSpecialProp); rmAddObjectDefConstraint(BFG1ID, avoidBirdProp);
   rmAddObjectDefConstraint(BFG1ID, avoidExplorerFar); rmAddObjectDefConstraint(BFG1ID, avoidCWFar);
   rmAddObjectDefConstraint(BFG1ID, avoidSocket); 
 }
// Bonus island unit
   int bonusUnitID=rmCreateObjectDef("bonus unit"); rmAddObjectDefItem(bonusUnitID, bonusUnitType, 1, 0.0);
   rmSetObjectDefMinDistance(bonusUnitID, 0); rmSetObjectDefMaxDistance(bonusUnitID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(bonusUnitID, avoidMainLand); rmAddObjectDefConstraint(bonusUnitID, avoidBonusWagonFar);
   if(bonusUnitName == "explorer" || bonusUnitName == "warchief" || bonusUnitName == "surgeon" || bonusUnitName == "medicine man")
 {
      rmAddObjectDefConstraint(bonusUnitID, avoidWater);
 }
   if(bonusUnitName != "explorer" && bonusUnitName != "warchief" && bonusUnitName != "surgeon" && bonusUnitName != "medicine man")
 { 
   rmAddObjectDefConstraint(bonusUnitID, avoidTCFar);
   rmAddObjectDefConstraint(bonusUnitID, avoidCWFar);
   rmAddObjectDefConstraint(bonusUnitID, avoidExplorerFar); 
 }


// I3.9 Pirate ships.
// Pirate ship one
   int pirate1ID = rmCreateObjectDef("pirate ship one"); rmAddObjectDefItem(pirate1ID, "privateer", 1, 0);
   rmSetObjectDefMinDistance(pirate1ID, 1.5*objectDistance); rmSetObjectDefMaxDistance(pirate1ID, 2*objectDistance);
// Pirate ship two
   int pirate2ID = rmCreateObjectDef("pirate ship two"); rmAddObjectDefItem(pirate2ID, "privateer", 1, 0);
   rmSetObjectDefMinDistance(pirate2ID, 1.5*objectDistance); rmSetObjectDefMaxDistance(pirate2ID, 2*objectDistance);
// Pirate ship three
   int pirate3ID = rmCreateObjectDef("pirate ship three"); rmAddObjectDefItem(pirate3ID, "privateer", 1, 0);
   rmSetObjectDefMinDistance(pirate3ID, 1.5*objectDistance); rmSetObjectDefMaxDistance(pirate3ID, 2*objectDistance);
// Pirate ship four
   int pirate4ID = rmCreateObjectDef("pirate ship four"); rmAddObjectDefItem(pirate4ID, "privateer", 1, 0);
   rmSetObjectDefMinDistance(pirate4ID, 1.5*objectDistance); rmSetObjectDefMaxDistance(pirate4ID, 2*objectDistance);
// War Hut
   int warHutID = rmCreateObjectDef("war hut"); rmAddObjectDefItem(warHutID, "SPCCherokeeWarHut", 1, 0);
   rmSetObjectDefMinDistance(warHutID, 0.0); rmSetObjectDefMaxDistance(warHutID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(warHutID, avoidMainLand); rmAddObjectDefConstraint(warHutID, avoidWater8);
// Bonus wagon
   int wagonID = rmCreateObjectDef("bonus wagon"); rmAddObjectDefItem(wagonID, wagonType, 1, 0.0);
   rmSetObjectDefMinDistance(wagonID, 0.0); rmSetObjectDefMaxDistance(wagonID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(wagonID, avoidMainLand); rmAddObjectDefConstraint(wagonID, avoidWater);
   rmAddObjectDefConstraint(wagonID, avoidGold); rmAddObjectDefConstraint(wagonID, avoidNugget);
   rmAddObjectDefConstraint(wagonID, avoidCrates); rmAddObjectDefConstraint(wagonID, avoidWarHut);
// Ossuary
   int ossuaryID = rmCreateObjectDef("ossuary"); rmAddObjectDefItem(ossuaryID, "SPCOssuary", 1, 0);
   rmSetObjectDefMinDistance(ossuaryID, 0.0); rmSetObjectDefMaxDistance(ossuaryID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(ossuaryID, avoidMainLand); rmAddObjectDefConstraint(ossuaryID, avoidWater);
   rmAddObjectDefConstraint(ossuaryID, avoidWarHut);
// Native socket
   int nativeSocketID = rmCreateObjectDef("native socket"); rmAddObjectDefItem(nativeSocketID, nativeSocketType, 1, 0);
   rmSetObjectDefMinDistance(nativeSocketID, 0.0); rmSetObjectDefMaxDistance(nativeSocketID, rmXFractionToMeters(0.5));
   rmAddObjectDefToClass(nativeSocketID, rmClassID("classSocket"));
   rmAddObjectDefConstraint(nativeSocketID, avoidMainLand); rmAddObjectDefConstraint(nativeSocketID, avoidWater8);
   rmAddObjectDefConstraint(nativeSocketID, avoidWarHut); rmAddObjectDefConstraint(nativeSocketID, avoidOssuary);

/* I4.0 Make islands */  rmSetStatusText("",0.2);

// I4.1 Place player island sets.

   for(i=1; <= players)
  {
   int islandsID=rmCreateArea("island"+i);
   if(i < 3 || (i == 3 && players != 3) || i == 4 || (i == 5 && players != 5) || i == 6 || (i == 7 && players != 7) || i == 8) 
 { rmSetAreaSize(islandsID, rmAreaTilesToFraction(playerArea),  rmAreaTilesToFraction(playerArea)); }
   if((i == 3 && players == 3) || (i == 5 && players == 5) || (i == 7 && players == 7))
 { rmSetAreaSize(islandsID, rmAreaTilesToFraction(1.2*playerArea),  rmAreaTilesToFraction(1.2*playerArea)); }
   rmSetAreaMinBlobs(islandsID, 10); rmSetAreaMaxBlobs(islandsID, 15);
   rmSetAreaMinBlobDistance(islandsID, 8.0); rmSetAreaMaxBlobDistance(islandsID, 10.0);
   rmSetAreaCoherence(islandsID, 0.45); 
   rmSetAreaBaseHeight(islandsID, 0.5);
   rmSetAreaSmoothDistance(islandsID, 20);
   rmSetAreaMix(islandsID, terrainMix);
   rmAddAreaToClass(islandsID, classKeyLand);
   rmAddAreaToClass(islandsID, classPlayerLand);
   rmAddAreaToClass(islandsID, classMainLand);
   rmAddAreaConstraint(islandsID, avoidKeyLand);
   rmSetAreaElevationType(islandsID, cElevTurbulence);
   rmSetAreaElevationVariation(islandsID, 4.0);
   rmSetAreaElevationMinFrequency(islandsID, 0.09);
   rmSetAreaElevationOctaves(islandsID, 3);
   rmSetAreaElevationPersistence(islandsID, 0.2);
   rmSetAreaElevationNoiseBias(islandsID, 1);
   rmSetAreaWarnFailure(islandsID, false);
   if (i == 1) rmSetAreaLocation(islandsID, p1x, p1z); if (i == 2) rmSetAreaLocation(islandsID, p2x, p2z);
   if (i == 3) rmSetAreaLocation(islandsID, p3x, p3z); if (i == 4) rmSetAreaLocation(islandsID, p4x, p4z);
   if (i == 5) rmSetAreaLocation(islandsID, p5x, p5z); if (i == 6) rmSetAreaLocation(islandsID, p6x, p6z);
   if (i == 7) rmSetAreaLocation(islandsID, p7x, p7z); if (i == 8) rmSetAreaLocation(islandsID, p8x, p8z);
  }
// I4.2Place elbow island sets.

   for(i=1; <= numElbows)
  {
   int elbowIslandID=rmCreateArea("elbow island"+i);
   rmSetAreaSize(elbowIslandID, rmAreaTilesToFraction(playerArea),  rmAreaTilesToFraction(playerArea));
   rmSetAreaMinBlobs(elbowIslandID, 10); rmSetAreaMaxBlobs(elbowIslandID, 15);
   rmSetAreaMinBlobDistance(elbowIslandID, 8.0); rmSetAreaMaxBlobDistance(elbowIslandID, 10.0);
   rmSetAreaCoherence(elbowIslandID, 0.45);
   rmSetAreaBaseHeight(elbowIslandID, 4.5);
   rmSetAreaSmoothDistance(elbowIslandID, 20);
   rmSetAreaMix(elbowIslandID, terrainMix);
   rmAddAreaToClass(elbowIslandID, classKeyLand);
   rmAddAreaToClass(elbowIslandID, classMainLand);
   rmAddAreaConstraint(elbowIslandID, avoidKeyLand);
   rmSetAreaElevationType(elbowIslandID, cElevTurbulence);
   rmSetAreaElevationVariation(elbowIslandID, 4.0);
   rmSetAreaElevationMinFrequency(elbowIslandID, 0.09);
   rmSetAreaElevationOctaves(elbowIslandID, 3);
   rmSetAreaElevationPersistence(elbowIslandID, 0.2);
   rmSetAreaElevationNoiseBias(elbowIslandID, 1);
   rmSetAreaWarnFailure(elbowIslandID, false);
   if (i == 1) rmSetAreaLocation(elbowIslandID, e1x, e1z); if (i == 2) rmSetAreaLocation(elbowIslandID, e2x, e2z);
   if (i == 3) rmSetAreaLocation(elbowIslandID, e3x, e3z); if (i == 4) rmSetAreaLocation(elbowIslandID, e4x, e4z);
  }
// I4.3Place connection islands

   for(i=1; <= numConnections)
  {
   int connectIslandID=rmCreateArea("connect island"+i);
   rmSetAreaSize(connectIslandID, rmAreaTilesToFraction(playerArea),  rmAreaTilesToFraction(playerArea));
   rmSetAreaMinBlobs(connectIslandID, 10); rmSetAreaMaxBlobs(connectIslandID, 15);
   rmSetAreaMinBlobDistance(connectIslandID, 8.0); rmSetAreaMaxBlobDistance(connectIslandID, 10.0);
   rmSetAreaCoherence(connectIslandID, 0.45);
   rmSetAreaBaseHeight(connectIslandID, 2.5);
   rmSetAreaSmoothDistance(connectIslandID, 20);
   rmSetAreaMix(connectIslandID, terrainMix);
   rmAddAreaToClass(connectIslandID, classMainLand);
   rmSetAreaElevationType(connectIslandID, cElevTurbulence);
   rmSetAreaElevationVariation(connectIslandID, 4.0);
   rmSetAreaElevationMinFrequency(connectIslandID, 0.09);
   rmSetAreaElevationOctaves(connectIslandID, 3);
   rmSetAreaElevationPersistence(connectIslandID, 0.2);
   rmSetAreaElevationNoiseBias(connectIslandID, 1);
   rmSetAreaWarnFailure(connectIslandID, false);
   if (i == 1) rmSetAreaLocation(connectIslandID, (p1x + e1x)/2, (p1z + e1z)/2);
   if (i == 2) rmSetAreaLocation(connectIslandID, (p2x + e1x)/2, (p2z + e1z)/2);
   if (i == 3) rmSetAreaLocation(connectIslandID, (p3x + e2x)/2, (p3z + e2z)/2);
   if (i == 4) rmSetAreaLocation(connectIslandID, (p4x + e2x)/2, (p4z + e2z)/2);
   if (i == 5) rmSetAreaLocation(connectIslandID, (p5x + e3x)/2, (p5z + e3z)/2);
   if (i == 6) rmSetAreaLocation(connectIslandID, (p6x + e3x)/2, (p6z + e3z)/2);
   if (i == 7) rmSetAreaLocation(connectIslandID, (p7x + e4x)/2, (p7z + e4z)/2);
   if (i == 8) rmSetAreaLocation(connectIslandID, (p8x + e4x)/2, (p8z + e4z)/2);
  }
   rmBuildAllAreas();

// Place bonus islands
   if(useBonusIslandsFlag == true)
 {
   for(i=1; <= islandCount)
  {
   int bonusIslandID=rmCreateArea("bonus island"+i);
   rmSetAreaSize(bonusIslandID, rmAreaTilesToFraction(0.75*bonusIslandSize),  rmAreaTilesToFraction(bonusIslandSize));
   rmSetAreaMinBlobs(bonusIslandID, 10); rmSetAreaMaxBlobs(bonusIslandID, 15);
   rmSetAreaMinBlobDistance(bonusIslandID, 8.0); rmSetAreaMaxBlobDistance(bonusIslandID, 10.0);
   rmSetAreaCoherence(bonusIslandID, 0.45);
   rmSetAreaBaseHeight(bonusIslandID, 1.0);
   rmSetAreaSmoothDistance(bonusIslandID, 20);
   rmSetAreaMix(bonusIslandID, terrainMix);
   rmAddAreaConstraint(bonusIslandID, avoidMainLand);
   rmAddAreaConstraint(bonusIslandID, avoidLand20);
   rmAddAreaConstraint(bonusIslandID, avoidPlayerLand);
   rmSetAreaElevationType(bonusIslandID, cElevTurbulence);
   rmSetAreaElevationVariation(bonusIslandID, 4.0);
   rmSetAreaElevationMinFrequency(bonusIslandID, 0.09);
   rmSetAreaElevationOctaves(bonusIslandID, 3);
   rmSetAreaElevationPersistence(bonusIslandID, 0.2);
   rmSetAreaElevationNoiseBias(bonusIslandID, 1);
   rmSetAreaWarnFailure(bonusIslandID, false);
   rmBuildArea(bonusIslandID);
  }
 }
// Place dirt around town centers.
   if(rmGetNomadStart() == false)
 {
   for(i=1; <= players)
  {
   int playerDirtID=rmCreateArea("player dirt"+i);
   rmSetAreaSize(playerDirtID, rmAreaTilesToFraction(120),  rmAreaTilesToFraction(120));
   rmSetAreaMinBlobs(playerDirtID, 1); rmSetAreaMaxBlobs(playerDirtID, 1);
   rmSetAreaCoherence(playerDirtID, 0.95);
   rmSetAreaBaseHeight(playerDirtID, 2*rmRandInt(0,1));
   rmSetAreaSmoothDistance(playerDirtID, 3);
   rmSetAreaMix(playerDirtID, TCDirt);
   rmSetAreaElevationType(playerDirtID, cElevTurbulence);
   rmSetAreaElevationVariation(playerDirtID, 4.0);
   rmSetAreaElevationMinFrequency(playerDirtID, 0.09);
   rmSetAreaElevationOctaves(playerDirtID, 3);
   rmSetAreaElevationPersistence(playerDirtID, 0.2);
   rmSetAreaElevationNoiseBias(playerDirtID, 1);
   rmSetAreaWarnFailure(playerDirtID, false);
   if (i == 1) rmSetAreaLocation(playerDirtID, p1x, p1z);
   if (i == 2) rmSetAreaLocation(playerDirtID, p2x, p2z);
   if (i == 3) rmSetAreaLocation(playerDirtID, p3x, p3z);
   if (i == 4) rmSetAreaLocation(playerDirtID, p4x, p4z);
   if (i == 5) rmSetAreaLocation(playerDirtID, p5x, p5z);
   if (i == 6) rmSetAreaLocation(playerDirtID, p6x, p6z);
   if (i == 7) rmSetAreaLocation(playerDirtID, p7x, p7z);
   if (i == 8) rmSetAreaLocation(playerDirtID, p8x, p8z);
  }
 }
   rmBuildAllAreas();

// Starting TCs and units

 /* I5.0 Position players */  rmSetStatusText("",0.3);

// Lone wolf switch player 1 and last odd player.
   
   if(useLoneWolfFlag == true)
 {
   float tx = p1x; float tz = p1z;
   if(players == 3) { p1x = p3x; p1z = p3z; p3x = tx; p3z = tz; }
   if(players == 5) { p1x = p5x; p1z = p5z; p5x = tx; p5z = tz; }
   if(players == 7) { p1x = p7x; p1z = p7z; p7x = tx; p7z = tz; }
 }
   if (rmGetNomadStart() == false)
 {
 		
   int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
   rmSetObjectDefMinDistance(startingUnits, 5.0); rmSetObjectDefMaxDistance(startingUnits, 10.0);

   int startingTCID= rmCreateObjectDef("startingTC");                
   rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0); 

   for(i=1; <= players)
   {	
   if(i == 1) { rmPlaceObjectDefAtLoc(startingTCID, 1, p1x, p1z); rmPlaceObjectDefAtLoc(startingUnits, 1, p1x, p1z); }
   if(i == 2) { rmPlaceObjectDefAtLoc(startingTCID, 2, p2x, p2z); rmPlaceObjectDefAtLoc(startingUnits, 2, p2x, p2z); }
   if(i == 3) { rmPlaceObjectDefAtLoc(startingTCID, 3, p3x, p3z); rmPlaceObjectDefAtLoc(startingUnits, 3, p3x, p3z); }
   if(i == 4) { rmPlaceObjectDefAtLoc(startingTCID, 4, p4x, p4z); rmPlaceObjectDefAtLoc(startingUnits, 4, p4x, p4z); }
   if(i == 5) { rmPlaceObjectDefAtLoc(startingTCID, 5, p5x, p5z); rmPlaceObjectDefAtLoc(startingUnits, 5, p5x, p5z); }
   if(i == 6) { rmPlaceObjectDefAtLoc(startingTCID, 6, p6x, p6z); rmPlaceObjectDefAtLoc(startingUnits, 6, p6x, p6z); }
   if(i == 7) { rmPlaceObjectDefAtLoc(startingTCID, 7, p7x, p7z); rmPlaceObjectDefAtLoc(startingUnits, 7, p7x, p7z); }
   if(i == 8) { rmPlaceObjectDefAtLoc(startingTCID, 8, p8x, p8z); rmPlaceObjectDefAtLoc(startingUnits, 8, p8x, p8z); }
   }
 } 
// I5.1 Place explorer or covered wagon for Nomad start.
   if (rmGetNomadStart())
 {
   if(rmGetPlayerCiv(1) < 10) rmPlaceObjectDefAtLoc(explorerID, 1, p1x, p1z);
   if(rmGetPlayerCiv(1) == 15) rmPlaceObjectDefAtLoc(iroquoisWarchiefID, 1, p1x, p1z);
   if(rmGetPlayerCiv(1) == 16) rmPlaceObjectDefAtLoc(siouxWarchiefID, 1, p1x, p1z);
   if(rmGetPlayerCiv(1) == 17) rmPlaceObjectDefAtLoc(aztecWarchiefID, 1, p1x, p1z);
 
   if(ident2 == 1 && rmGetPlayerCiv(2) < 10) rmPlaceObjectDefAtLoc(explorerID, 2, p2x, p2z);
   if(ident2 == 1 && rmGetPlayerCiv(2) == 15) rmPlaceObjectDefAtLoc(iroquoisWarchiefID, 2, p2x, p2z);
   if(ident2 == 1 && rmGetPlayerCiv(2) == 16) rmPlaceObjectDefAtLoc(siouxWarchiefID, 2, p2x, p2z);
   if(ident2 == 1 && rmGetPlayerCiv(2) == 17) rmPlaceObjectDefAtLoc(aztecWarchiefID, 2, p2x, p2z);
   if(ident2 == 0)rmPlaceObjectDefAtLoc(coveredWagonID, 2, p2x, p2z);

   if(players > 2 && ident3 == 1 && rmGetPlayerCiv(3) < 10) rmPlaceObjectDefAtLoc(explorerID, 3, p3x, p3z);
   if(players > 2 && ident3 == 1 && rmGetPlayerCiv(3) == 15) rmPlaceObjectDefAtLoc(iroquoisWarchiefID, 3, p3x, p3z);
   if(players > 2 && ident3 == 1 && rmGetPlayerCiv(3) == 16) rmPlaceObjectDefAtLoc(siouxWarchiefID, 3, p3x, p3z);
   if(players > 2 && ident3 == 1 && rmGetPlayerCiv(3) == 17) rmPlaceObjectDefAtLoc(aztecWarchiefID, 3, p3x, p3z);
   if(players > 2 && ident3 == 0) rmPlaceObjectDefAtLoc(coveredWagonID, 3, p3x, p3z);

   if(players > 3 && ident4 == 1 && rmGetPlayerCiv(4) < 10) rmPlaceObjectDefAtLoc(explorerID, 4, p4x, p4z);
   if(players > 3 && ident4 == 1 && rmGetPlayerCiv(4) == 15) rmPlaceObjectDefAtLoc(iroquoisWarchiefID, 4, p4x, p4z);
   if(players > 3 && ident4 == 1 && rmGetPlayerCiv(4) == 16) rmPlaceObjectDefAtLoc(siouxWarchiefID, 4, p4x, p4z);
   if(players > 3 && ident4 == 1 && rmGetPlayerCiv(4) == 17) rmPlaceObjectDefAtLoc(aztecWarchiefID, 4, p4x, p4z);
   if(players > 3 && ident4 == 0) rmPlaceObjectDefAtLoc(coveredWagonID, 4, p4x, p4z);

   if(players > 4 && ident5 == 1 && rmGetPlayerCiv(5) < 10) rmPlaceObjectDefAtLoc(explorerID, 5, p5x, p5z);
   if(players > 4 && ident5 == 1 && rmGetPlayerCiv(5) == 15) rmPlaceObjectDefAtLoc(iroquoisWarchiefID, 5, p5x, p5z);
   if(players > 4 && ident5 == 1 && rmGetPlayerCiv(5) == 16) rmPlaceObjectDefAtLoc(siouxWarchiefID, 5, p5x, p5z);
   if(players > 4 && ident5 == 1 && rmGetPlayerCiv(5) == 17) rmPlaceObjectDefAtLoc(aztecWarchiefID, 5, p5x, p5z);
   if(players > 4 && ident5 == 0) rmPlaceObjectDefAtLoc(coveredWagonID, 5, p5x, p5z);

   if(players > 5 && ident6 == 1 && rmGetPlayerCiv(6) < 10) rmPlaceObjectDefAtLoc(explorerID, 6, p6x, p6z);
   if(players > 5 && ident6 == 1 && rmGetPlayerCiv(6) == 15) rmPlaceObjectDefAtLoc(iroquoisWarchiefID, 6, p6x, p6z);
   if(players > 5 && ident6 == 1 && rmGetPlayerCiv(6) == 16) rmPlaceObjectDefAtLoc(siouxWarchiefID, 6, p6x, p6z);
   if(players > 5 && ident6 == 1 && rmGetPlayerCiv(6) == 17) rmPlaceObjectDefAtLoc(aztecWarchiefID, 6, p6x, p6z);
   if(players > 5 && ident6 == 0) rmPlaceObjectDefAtLoc(coveredWagonID, 6, p6x, p6z);

   if(players > 6 && ident7 == 1 && rmGetPlayerCiv(7) < 10) rmPlaceObjectDefAtLoc(explorerID, 7, p7x, p7z);
   if(players > 6 && ident7 == 1 && rmGetPlayerCiv(7) == 15) rmPlaceObjectDefAtLoc(iroquoisWarchiefID, 7, p7x, p7z);
   if(players > 6 && ident7 == 1 && rmGetPlayerCiv(7) == 16) rmPlaceObjectDefAtLoc(siouxWarchiefID, 7, p7x, p7z);
   if(players > 6 && ident7 == 1 && rmGetPlayerCiv(7) == 17) rmPlaceObjectDefAtLoc(aztecWarchiefID, 7, p7x, p7z);
   if(players > 6 && ident7 == 0) rmPlaceObjectDefAtLoc(coveredWagonID, 7, p7x, p7z);

   if(players > 7 && ident8 == 1 && rmGetPlayerCiv(8) < 10) rmPlaceObjectDefAtLoc(explorerID, 8, p8x, p8z);
   if(players > 7 && ident8 == 1 && rmGetPlayerCiv(8) == 15) rmPlaceObjectDefAtLoc(iroquoisWarchiefID, 8, p8x, p8z);
   if(players > 7 && ident8 == 1 && rmGetPlayerCiv(8) == 16) rmPlaceObjectDefAtLoc(siouxWarchiefID, 8, p8x, p8z);
   if(players > 7 && ident8 == 1 && rmGetPlayerCiv(8) == 17) rmPlaceObjectDefAtLoc(aztecWarchiefID, 8, p8x, p8z);
   if(players > 7 && ident8 == 0) rmPlaceObjectDefAtLoc(coveredWagonID, 8, p8x, p8z);
 }
// I5.2 Place Water Flags
   int waterFlagID=-1;
   for(i=1; <= players)
   {
   rmClearClosestPointConstraints();
   waterFlagID=rmCreateObjectDef("HC water flag "+i);
   rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
   if((useLoneWolfFlag == false && i == 1) || (useLoneWolfFlag == true && i != 1) || (i > 1 && i < 5) || (i == 5 && players != 5) ||( i < 7 && players != 5)) 
      rmAddClosestPointConstraint(flagEdgeConstraint);
   rmAddClosestPointConstraint(avoidFlag);
   rmAddClosestPointConstraint(avoidLand12);
   if(rmGetNomadStart() == false) vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
   if(rmGetNomadStart())
 {
   if(i == 1 && rmGetPlayerCiv(1) < 10) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(explorerID, i));
   if(i == 1 && rmGetPlayerCiv(1) == 15) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(iroquoisWarchiefID, i));
   if(i == 1 && rmGetPlayerCiv(1) == 16) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(siouxWarchiefID, i));
   if(i == 1 && rmGetPlayerCiv(1) == 17) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(aztecWarchiefID, i));

   if(i == 2 && ident2 == 0) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(coveredWagonID, i));
   if(i == 2 && ident2 == 1) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(explorerID, i));
   if(i == 3 && ident3 == 0) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(coveredWagonID, i));
   if(i == 3 && ident3 == 1) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(explorerID, i));
   if(i == 4 && ident4 == 0) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(coveredWagonID, i));
   if(i == 4 && ident4 == 1) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(explorerID, i));
   if(i == 5 && ident5 == 0) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(coveredWagonID, i));
   if(i == 5 && ident5 == 1) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(explorerID, i));
   if(i == 6 && ident6 == 0) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(coveredWagonID, i));
   if(i == 6 && ident6 == 1) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(explorerID, i));
   if(i == 7 && ident7 == 0) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(coveredWagonID, i));
   if(i == 7 && ident7 == 1) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(explorerID, i));
   if(i == 8 && ident8 == 0) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(coveredWagonID, i));
   if(i == 8 && ident8 == 1) TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(explorerID, i));
 }
   vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));
   rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
   if(i == 1)  vector waterFlag1 = closestPoint; if(i == 2)  vector waterFlag2 = closestPoint;
   if(i == 3)  vector waterFlag3 = closestPoint; if(i == 4)  vector waterFlag4 = closestPoint;
   if(i == 5)  vector waterFlag5 = closestPoint; if(i == 6)  vector waterFlag6 = closestPoint;
   if(i == 7)  vector waterFlag7 = closestPoint; if(i == 8)  vector waterFlag8 = closestPoint;
   rmClearClosestPointConstraints();
   }
// I5.3 Landing party placement
// Place player 1 landing party and caravel and any others
   if (rmGetNomadStart()) 
 {
// Landing party for player 1
   rmPlaceObjectDefAtLoc(settlerID, 1, p1x, p1z);
   rmPlaceObjectDefAtLoc(mercenaryID, 1, p1x, p1z); rmPlaceObjectDefAtLoc(surgeonID, 1, p1x, p1z); 
   rmPlaceObjectDefAtLoc(caravelID, 1, rmXMetersToFraction(xsVectorGetX(waterFlag1)), rmZMetersToFraction(xsVectorGetZ(waterFlag1)));
   if(useLoneWolfFlag == false) { rmPlaceObjectDefAtLoc(woodID, 0, e1x, e1z, 1); rmPlaceObjectDefAtLoc(woodID, 0, (p1x+e1x)/2.0, (p1z+e1z)/2.0, 2); }
   if(useLoneWolfFlag == true) rmPlaceObjectDefAtLoc(woodID, 0, p1x, p1z, 3);
// Landing party for player 2
   if(ident2 == 1) { 
   rmPlaceObjectDefAtLoc(settlerID, 2, p2x, p2z); rmPlaceObjectDefAtLoc(mercenaryID, 2, p2x, p2z); rmPlaceObjectDefAtLoc(surgeonID, 2, p2x, p2z); 
   rmPlaceObjectDefAtLoc(caravelID, 2, rmXMetersToFraction(xsVectorGetX(waterFlag2)), rmZMetersToFraction(xsVectorGetZ(waterFlag2))); }
// Landing party for player 3
   if(players > 2 && ident3 == 1) { rmPlaceObjectDefAtLoc(settlerID, 3, p3x, p3z);
   rmPlaceObjectDefAtLoc(mercenaryID, 3, p3x, p3z); rmPlaceObjectDefAtLoc(surgeonID, 3, p3x, p3z);
   rmPlaceObjectDefAtLoc(caravelID, 3, rmXMetersToFraction(xsVectorGetX(waterFlag3)), rmZMetersToFraction(xsVectorGetZ(waterFlag3))); }
// Landing party for player 4
   if(players > 3 && ident4 == 1) { rmPlaceObjectDefAtLoc(settlerID, 4, p4x, p4z);
   rmPlaceObjectDefAtLoc(mercenaryID, 4, p4x, p4z); rmPlaceObjectDefAtLoc(surgeonID, 4, p4x, p4z); 
   rmPlaceObjectDefAtLoc(caravelID, 4, rmXMetersToFraction(xsVectorGetX(waterFlag4)), rmZMetersToFraction(xsVectorGetZ(waterFlag4))); }
// Landing party for player 5
   if(players > 4 && ident5 == 1) { rmPlaceObjectDefAtLoc(settlerID, 5, p5x, p5z);
   rmPlaceObjectDefAtLoc(mercenaryID, 5, p5x, p5z); rmPlaceObjectDefAtLoc(surgeonID, 5, p5x, p5z); 
   rmPlaceObjectDefAtLoc(caravelID, 5, rmXMetersToFraction(xsVectorGetX(waterFlag5)), rmZMetersToFraction(xsVectorGetZ(waterFlag5))); }
// Landing party for player 6
   if(players > 5 && ident6 == 1) { rmPlaceObjectDefAtLoc(settlerID, 6, p6x, p6z);
   rmPlaceObjectDefAtLoc(mercenaryID, 6, p6x, p6z); rmPlaceObjectDefAtLoc(surgeonID, 6, p6x, p6z); 
   rmPlaceObjectDefAtLoc(caravelID, 6, rmXMetersToFraction(xsVectorGetX(waterFlag6)), rmZMetersToFraction(xsVectorGetZ(waterFlag6))); }
// Landing party for player 7
   if(players > 6 && ident7 == 1) { rmPlaceObjectDefAtLoc(settlerID, 7, p7x, p7z);
   rmPlaceObjectDefAtLoc(mercenaryID, 7, p7x, p7z); rmPlaceObjectDefAtLoc(surgeonID, 7, p7x, p7z); 
   rmPlaceObjectDefAtLoc(caravelID, 7, rmXMetersToFraction(xsVectorGetX(waterFlag7)), rmZMetersToFraction(xsVectorGetZ(waterFlag7))); }
// Landing party for player 8
   if(players > 7 && ident8 == 1) { rmPlaceObjectDefAtLoc(settlerID, 8, p8x, p8z);
   rmPlaceObjectDefAtLoc(mercenaryID, 8, p8x, p8z); rmPlaceObjectDefAtLoc(surgeonID, 8, p8x, p8z); 
   rmPlaceObjectDefAtLoc(caravelID, 8, rmXMetersToFraction(xsVectorGetX(waterFlag8)), rmZMetersToFraction(xsVectorGetZ(waterFlag8))); }
  }
/* I6.0 Place Objects*/  rmSetStatusText("",0.4);

/* I6.1 Placement order. Pirate ships and wagon are put first because the item ID seems to work better.

   Pirate ships, war hut, wagon, Trade routes, natives, mines, huntables, herdable, trees, berries, nuggets, random trees, whales, fish,
   rocks, ducks, water plants, shipwrecks, special item, crates, bison carcass, and the BFG.

   I6.2 Place pirate ships */
   if(usePiratesFlag == true)
 {
// Place pirate ship one
   rmPlaceObjectDefAtLoc(pirate1ID, 0, e1x, e1z);
   int pirate1Select = rmGetUnitPlaced(pirate1ID, 0);
// Place pirate ship two
   if(players > 2) 
  {
   if(players > 3)  rmPlaceObjectDefAtLoc(pirate2ID, 0, e2x, e2z);
   if(players == 3 && useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(pirate2ID, 0, p3x, p3z);
   if(players == 3 && useLoneWolfFlag == true) rmPlaceObjectDefAtLoc(pirate2ID, 0, p1x, p1z);
   int pirate2Select = rmGetUnitPlaced(pirate2ID, 0);
  }
// Place pirate ship three
   if(players > 4) 
  {
   if(players > 5)  rmPlaceObjectDefAtLoc(pirate3ID, 0, e3x, e3z);
   if(players == 5) rmPlaceObjectDefAtLoc(pirate3ID, 0, 0.5, 0.5);
   int pirate3Select = rmGetUnitPlaced(pirate3ID, 0);
  }
// Place pirate ship four
   if(players > 6) 
  {
   if(players > 7)  rmPlaceObjectDefAtLoc(pirate4ID, 0, e4x, e4z);
   if(players == 7) rmPlaceObjectDefAtLoc(pirate4ID, 0, 0.5, 0.5);
   int pirate4Select = rmGetUnitPlaced(pirate4ID, 0);
  }
 }
// Place war hut
   if(useFullMapFlag == true)
 { rmPlaceObjectDefAtLoc(warHutID, 0, 0.5, 0.5);
   vector warHutPosition = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(warHutID, 0));

// Place ossuary
   rmPlaceObjectDefAtLoc(ossuaryID, 0, 0.5, 0.5);

// Place native socket
   rmPlaceObjectDefAtLoc(nativeSocketID, 0, 0.5, 0.5);
   int nativeSocketSelect = rmGetUnitPlaced(nativeSocketID, 0);
   vector nativeSocketPosition = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(nativeSocketID, 0));

// I6.3 Place bonus wagon(Fort, Outpost, Covered, or Factory)
   rmPlaceObjectDefAtLoc(wagonID, 0, 0.5, 0.5, 1);
   int wagonSelect = rmGetUnitPlaced(wagonID, 0);
   vector wagonPosition = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(wagonID, 0));
 
// Bonus island unit.
   rmPlaceObjectDefAtLoc(bonusUnitID, 0, 0.5, 0.5, 1);
   int bonusUnitSelect = rmGetUnitPlaced(bonusUnitID, 0);
   vector bonusUnitPosition = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(bonusUnitID, 0));
 
// Player 1 quest herdable
   rmPlaceObjectDefAtLoc(questHerdableID, 0, p1x, p1z, 1);
   int herdableSelect = rmGetUnitPlaced(questHerdableID, 0);

// Quest livestock pen
   rmPlaceObjectDefAtLoc(livestockPenID, 0, 0.5, 0.5, 1);
   int livestockPenSelect = rmGetUnitPlaced(livestockPenID, 0);
   vector livestockPenPosition = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(livestockPenID, 0));
 
// Island Factory
   rmPlaceObjectDefAtLoc(factoryID, 0, 0.5, 0.5, 1);
   int factorySelect = rmGetUnitPlaced(factoryID, 0);
   vector factoryPosition = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(factoryID, 0));
 }
// Bonus island special props
   if(useBonusIslandsFlag == true && useEyeCandyFlag == true)
 {
   rmPlaceObjectDefAtLoc(specialID, 0, 0.5, 0.5, 1);
   vector specialPosition = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(specialID, 0));
   rmPlaceObjectDefAtLoc(birdPropID, 0, 0.5, 0.5, 1);
   vector birdPropPosition = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(birdPropID, 0));
 }

/* I6.4 Place trade routes */  rmSetStatusText("",0.5);
   if(useTradeRoutesFlag == true)
 {
   int socketID=rmCreateObjectDef("sockets for Trade Posts");
   rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0); rmSetObjectDefAllowOverlap(socketID, true);
   rmSetObjectDefMinDistance(socketID, 0.0); rmSetObjectDefMaxDistance(socketID, 8.0);
   rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
   rmAddObjectDefConstraint(socketID, avoidWater);

   int tradeRoute1ID = rmCreateTradeRoute();
   if(useLoneWolfFlag == false) rmAddTradeRouteWaypoint(tradeRoute1ID, ((7.0*p1x)+e1x)/8.0, ((7.0*p1z)+e1z)/8.0);
   if(useLoneWolfFlag == true && players == 3) rmAddTradeRouteWaypoint(tradeRoute1ID, ((7.0*p3x)+e1x)/8.0, ((7.0*p3z)+e1z)/8.0);
   if(useLoneWolfFlag == true && players == 5) rmAddTradeRouteWaypoint(tradeRoute1ID, ((7.0*p5x)+e1x)/8.0, ((7.0*p5z)+e1z)/8.0);
   if(useLoneWolfFlag == true && players == 7) rmAddTradeRouteWaypoint(tradeRoute1ID, ((7.0*p7x)+e1x)/8.0, ((7.0*p7z)+e1z)/8.0);
   rmAddRandomTradeRouteWaypoints(tradeRoute1ID, e1x, e1z, 8, 10);
   rmAddRandomTradeRouteWaypoints(tradeRoute1ID, ((7.0*p2x)+e1x)/8.0, ((7.0*p2z)+e1z)/8.0, 8, 10);

   bool placedTradeRoute1 = rmBuildTradeRoute(tradeRoute1ID, "dirt");
   if(placedTradeRoute1 == false) rmEchoError("Failed to place trade route one");

// add the meeting sockets along the trade route.
   rmSetObjectDefTradeRouteID(socketID, tradeRoute1ID);
   vector socketLoc = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.05); rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   socketLoc = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.5); rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   socketLoc = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.95); rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   if(players > 3)
  {
   int tradeRoute2ID = rmCreateTradeRoute();
   rmAddTradeRouteWaypoint(tradeRoute2ID, ((7.0*p3x)+e2x)/8.0, ((7.0*p3z)+e2x)/8.0);
   rmAddRandomTradeRouteWaypoints(tradeRoute2ID, e2x, e2z, 8, 10);
   rmAddRandomTradeRouteWaypoints(tradeRoute2ID, ((7.0*p4x)+e2x)/8.0, ((7.0*p4z)+e2x)/8.0, 8, 10);
		
   bool placedTradeRoute2 = rmBuildTradeRoute(tradeRoute2ID, "dirt");
   if(placedTradeRoute2 == false) rmEchoError("Failed to place trade route one");

// add the meeting sockets along the trade route.
   rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);
   socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.05); rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.5); rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.95); rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
  }
   if(players > 5)
  {
   int tradeRoute3ID = rmCreateTradeRoute();
   rmAddTradeRouteWaypoint(tradeRoute3ID, ((7.0*p5x)+e3x)/8.0, ((7.0*p5z)+e3x)/8.0);
   rmAddRandomTradeRouteWaypoints(tradeRoute3ID, e3x, e3z, 8, 10);
   rmAddRandomTradeRouteWaypoints(tradeRoute3ID, ((7.0*p6x)+e3x)/8.0, ((7.0*p6z)+e3x)/8.0, 8, 10);
		
   bool placedTradeRoute3 = rmBuildTradeRoute(tradeRoute3ID, "dirt");
   if(placedTradeRoute3 == false) rmEchoError("Failed to place trade route one");

// add the meeting sockets along the trade route.
   rmSetObjectDefTradeRouteID(socketID, tradeRoute3ID);
   socketLoc = rmGetTradeRouteWayPoint(tradeRoute3ID, 0.05); rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   socketLoc = rmGetTradeRouteWayPoint(tradeRoute3ID, 0.5); rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   socketLoc = rmGetTradeRouteWayPoint(tradeRoute3ID, 0.95); rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
  }
   if(players > 7)
  {
   int tradeRoute4ID = rmCreateTradeRoute();
   rmAddTradeRouteWaypoint(tradeRoute4ID, ((7.0*p7x)+e4x)/8.0, ((7.0*p7z)+e4x)/8.0);
   rmAddRandomTradeRouteWaypoints(tradeRoute4ID, e4x, e4z, 8, 10);
   rmAddRandomTradeRouteWaypoints(tradeRoute4ID, ((7.0*p8x)+e4x)/8.0, ((7.0*p8z)+e4x)/8.0, 8, 10);
		
   bool placedTradeRoute4 = rmBuildTradeRoute(tradeRoute4ID, "dirt");
   if(placedTradeRoute4 == false) rmEchoError("Failed to place trade route one");

// add the meeting sockets along the trade route.
   rmSetObjectDefTradeRouteID(socketID, tradeRoute4ID);
   socketLoc = rmGetTradeRouteWayPoint(tradeRoute4ID, 0.05); rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   socketLoc = rmGetTradeRouteWayPoint(tradeRoute4ID, 0.5); rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   socketLoc = rmGetTradeRouteWayPoint(tradeRoute4ID, 0.95); rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
  }
 }
/* I6.5 Place Natives */  rmSetStatusText("",0.6);

   if(useNativesFlag == true)
{
   if (subCiv0 == rmGetCivID(nativeName1))
  {  
   int nativeVillage1ID = rmCreateGrouping("native 1 city", villageName1);
   rmSetGroupingMinDistance(nativeVillage1ID, 0.0); rmSetGroupingMaxDistance(nativeVillage1ID, 50.0);
   rmAddGroupingToClass(nativeVillage1ID, rmClassID("natives"));
   rmAddGroupingConstraint(nativeVillage1ID, avoidSocket);
   rmAddGroupingConstraint(nativeVillage1ID, avoidTradeRoute); rmAddGroupingConstraint(nativeVillage1ID, avoidTC30);
   rmPlaceGroupingAtLoc(nativeVillage1ID, 0, e1x, e1z);
  }
   if(players > 2)
 {
   if (subCiv1 == rmGetCivID(nativeName2))
  {  
   int nativeVillage2ID = rmCreateGrouping("native 2 city", villageName2);
   rmSetGroupingMinDistance(nativeVillage2ID, 0.0); rmSetGroupingMaxDistance(nativeVillage2ID, 50.0);
   rmAddGroupingToClass(nativeVillage2ID, rmClassID("natives"));
   rmAddGroupingConstraint(nativeVillage2ID, avoidSocket);
   rmAddGroupingConstraint(nativeVillage2ID, avoidTradeRoute); rmAddGroupingConstraint(nativeVillage2ID, avoidTC30);
   if(players != 3)rmPlaceGroupingAtLoc(nativeVillage2ID, 0, e2x, e2z);
   if(players == 3 && useLoneWolfFlag == false) rmPlaceGroupingAtLoc(nativeVillage2ID, 0, p3x, p3z);
   if(players == 3 && useLoneWolfFlag == true) rmPlaceGroupingAtLoc(nativeVillage2ID, 0, p1x, p1z);
  }
 }
   if(players > 4)
 {
   if (subCiv2 == rmGetCivID(nativeName3))
  {  
   int nativeVillage3ID = rmCreateGrouping("native 3 city", villageName3);
   rmSetGroupingMinDistance(nativeVillage3ID, 0.0); rmSetGroupingMaxDistance(nativeVillage3ID, 50.0);
   rmAddGroupingToClass(nativeVillage3ID, rmClassID("natives"));
   rmAddGroupingConstraint(nativeVillage3ID, avoidSocket);
   rmAddGroupingConstraint(nativeVillage3ID, avoidTradeRoute); rmAddGroupingConstraint(nativeVillage3ID, avoidTC30);
   if(players != 5) rmPlaceGroupingAtLoc(nativeVillage3ID, 0, e3x, e3z);
   if(players == 5) rmPlaceGroupingAtLoc(nativeVillage3ID, 0, 0.5, 0.5);
  }
 }
   if(players > 6)
 {
   if (subCiv3 == rmGetCivID(nativeName4))
  {  
   int nativeVillage4ID = rmCreateGrouping("native 4 city", villageName4);
   rmSetGroupingMinDistance(nativeVillage4ID, 0.0); rmSetGroupingMaxDistance(nativeVillage4ID, 50.0);
   rmAddGroupingToClass(nativeVillage4ID, rmClassID("natives"));
   rmAddGroupingConstraint(nativeVillage4ID, avoidSocket);
   rmAddGroupingConstraint(nativeVillage4ID, avoidTradeRoute); rmAddGroupingConstraint(nativeVillage4ID, avoidTC30);
   if(players != 7) rmPlaceGroupingAtLoc(nativeVillage4ID, 0, e4x, e4z);
   if(players == 7) rmPlaceGroupingAtLoc(nativeVillage4ID, 0, 0.5, 0.5);
  }
 }
}
// Player 1 quest object
   if(useFullMapFlag == true)
 { rmPlaceObjectDefAtLoc(questID, 0, p1x, p1z);
   int buffaloSelect = rmGetUnitPlaced(questID, 0);
 }
// Player 1 treasure item
   if(useFullMapFlag == true && rmGetNomadStart() == false)
 { rmPlaceObjectDefAtLoc(treasureItemID, 0, p1x, p1z);
   int treasureItemSelect = rmGetUnitPlaced(treasureItemID, 0);
 }
// Eagle. Used for end game cinematic.
   
   if(useFullMapFlag == true)
  {
   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(eagleID, 0, e1x, e1z);
   if(useLoneWolfFlag == true && players == 3) rmPlaceObjectDefAtLoc(eagleID, 0, p3x, p3z);
   if(useLoneWolfFlag == true && players == 5) rmPlaceObjectDefAtLoc(eagleID, 0, p5x, p5z);
   if(useLoneWolfFlag == true && players == 7) rmPlaceObjectDefAtLoc(eagleID, 0, p7x, p7z);
   int eagleSelect = rmGetUnitPlaced(eagleID, 0);
  }
// I6.6 Place Resources

// I6.61 Place mines 

// Player Mines
   rmPlaceObjectDefAtLoc(playerMineID, 0, p1x, p1z, 1);
   rmPlaceObjectDefAtLoc(playerMineID, 0, p2x, p2z, 1);
   if(players > 2) rmPlaceObjectDefAtLoc(playerMineID, 0, p3x, p3z, 1);
   if(players > 3) rmPlaceObjectDefAtLoc(playerMineID, 0, p4x, p4z, 1);
   if(players > 4) rmPlaceObjectDefAtLoc(playerMineID, 0, p5x, p5z, 1);
   if(players > 5) rmPlaceObjectDefAtLoc(playerMineID, 0, p6x, p6z, 1);
   if(players > 6) rmPlaceObjectDefAtLoc(playerMineID, 0, p7x, p7z, 1);
   if(players > 7) rmPlaceObjectDefAtLoc(playerMineID, 0, p8x, p8z, 1);

// Near mines if minecount is over 1

   if(mineCount > 1)
 {
   rmPlaceObjectDefAtLoc(mineID, 0, p1x, p1z, 1);
   rmPlaceObjectDefAtLoc(mineID, 0, p2x, p2z, 1);
   if(players > 2) rmPlaceObjectDefAtLoc(mineID, 0, p3x, p3z, 1);
   if(players > 3) rmPlaceObjectDefAtLoc(mineID, 0, p4x, p4z, 1);
   if(players > 4) rmPlaceObjectDefAtLoc(mineID, 0, p5x, p5z, 1);
   if(players > 5) rmPlaceObjectDefAtLoc(mineID, 0, p6x, p6z, 1);
   if(players > 6) rmPlaceObjectDefAtLoc(mineID, 0, p7x, p7z, 1);
   if(players > 7) rmPlaceObjectDefAtLoc(mineID, 0, p8x, p8z, 1);
 }
// Other mines
   int minePick = 1; if(mineCount == 2 || mineCount == 4) minePick = 2;
   if(mineCount == 1 || mineCount == 2)
{
// Elbow island mines
   rmPlaceObjectDefAtLoc(mineID, 0, e1x, e1z, minePick);
   if(players > 3) rmPlaceObjectDefAtLoc(mineID, 0, e2x, e2z, minePick);
   if(players > 5) rmPlaceObjectDefAtLoc(mineID, 0, e3x, e3z, minePick);
   if(players > 7) rmPlaceObjectDefAtLoc(mineID, 0, e4x, e4z, minePick);
// Connection island mines
   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(mineID, 0, (p1x+e1x)/2.0, (p1z+e1z)/2.0, minePick);
   if(useLoneWolfFlag == true && players == 3) rmPlaceObjectDefAtLoc(mineID, 0, (p3x+e1x)/2.0, (p3z+e1z)/2.0, minePick);
   if(useLoneWolfFlag == true && players == 5) rmPlaceObjectDefAtLoc(mineID, 0, (p5x+e1x)/2.0, (p5z+e1z)/2.0, minePick);
   if(useLoneWolfFlag == true && players == 7) rmPlaceObjectDefAtLoc(mineID, 0, (p7x+e1x)/2.0, (p7z+e1z)/2.0, minePick);
   rmPlaceObjectDefAtLoc(mineID, 0, (p2x+e1x)/2.0, (p2z+e1z)/2.0, minePick);
   if(players > 3)
 { rmPlaceObjectDefAtLoc(mineID, 0, (p3x+e2x)/2.0, (p3z+e2z)/2.0, minePick); rmPlaceObjectDefAtLoc(mineID, 0, (p4x+e2x)/2.0, (p4z+e2z)/2.0, minePick); }
   if(players > 5)
 { rmPlaceObjectDefAtLoc(mineID, 0, (p5x+e3x)/2.0, (p5z+e3z)/2.0, minePick); rmPlaceObjectDefAtLoc(mineID, 0, (p6x+e3x)/2.0, (p6z+e3z)/2.0, minePick); }
   if(players > 7)
 { rmPlaceObjectDefAtLoc(mineID, 0, (p7x+e4x)/2.0, (p7z+e4z)/2.0, minePick); rmPlaceObjectDefAtLoc(mineID, 0, (p8x+e4x)/2.0, (p8z+e4z)/2.0, minePick); }
}
// Elbow island gold mines.
   if(mineCount == 3 || mineCount == 4)
{
// Elbow islands gold mines
   rmPlaceObjectDefAtLoc(goldID, 0, e1x, e1z, minePick);
   if(players > 3) rmPlaceObjectDefAtLoc(goldID, 0, e2x, e2z, minePick);
   if(players > 5) rmPlaceObjectDefAtLoc(goldID, 0, e3x, e3z, minePick);
   if(players > 7) rmPlaceObjectDefAtLoc(goldID, 0, e4x, e4z, minePick);
// Connection islands with gold mines
   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(goldID, 0, (p1x+e1x)/2.0, (p1z+e1z)/2.0, minePick);
   if(useLoneWolfFlag == true && players == 3) rmPlaceObjectDefAtLoc(goldID, 0, (p3x+e1x)/2.0, (p3z+e1z)/2.0, minePick);
   if(useLoneWolfFlag == true && players == 5) rmPlaceObjectDefAtLoc(goldID, 0, (p5x+e1x)/2.0, (p5z+e1z)/2.0, minePick);
   if(useLoneWolfFlag == true && players == 7) rmPlaceObjectDefAtLoc(goldID, 0, (p7x+e1x)/2.0, (p7z+e1z)/2.0, minePick);
   rmPlaceObjectDefAtLoc(goldID, 0, (p2x+e1x)/2.0, (p2z+e1z)/2.0, minePick);
   if(players > 3)
 { rmPlaceObjectDefAtLoc(goldID, 0, (p3x+e2x)/2.0, (p3z+e2z)/2.0, minePick); rmPlaceObjectDefAtLoc(goldID, 0, (p4x+e2x)/2.0, (p4z+e2z)/2.0, minePick); }
   if(players > 5)
 { rmPlaceObjectDefAtLoc(goldID, 0, (p5x+e3x)/2.0, (p5z+e3z)/2.0, minePick); rmPlaceObjectDefAtLoc(goldID, 0, (p6x+e3x)/2.0, (p6z+e3z)/2.0, minePick); }
   if(players > 7)
 { rmPlaceObjectDefAtLoc(goldID, 0, (p7x+e4x)/2.0, (p7z+e4z)/2.0, minePick); rmPlaceObjectDefAtLoc(goldID, 0, (p8x+e4x)/2.0, (p8z+e4z)/2.0, minePick); }
}
// Last odd player gold mines since no trade route.
   if(players == 3 && useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(goldID, 0, p3x, p3z, 2);
   if(players == 5 && useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(goldID, 0, p5x, p5z, 2);
   if(players == 7 && useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(goldID, 0, p7x, p7z, 2);
   if(useLoneWolfFlag == true && (players == 3 || players == 5 || players == 7)) rmPlaceObjectDefAtLoc(goldID, 0, p1x, p1z, 2);
// Bonus islands mines.
   if(useBonusIslandsFlag == true) rmPlaceObjectDefAtLoc(bonusMineID, 0, 0.5, 0.5, ((islandCount + mineCount)/2)-1);

// I6.62 Place huntables

   rmPlaceObjectDefAtLoc(closeHuntableID, 0, p1x, p1z, 2); rmPlaceObjectDefAtLoc(huntable1ID, 0, p1x, p1z, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, p1x, p1z, 1);
   if(useLoneWolfFlag == true) rmPlaceObjectDefAtLoc(closeHuntableID, 0, p1x, p1z, 3);
   rmPlaceObjectDefAtLoc(closeHuntableID, 0, p2x, p2z, 2); rmPlaceObjectDefAtLoc(huntable1ID, 0, p2x, p2z, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, p2x, p2z, 1);
   if(useLoneWolfFlag == false) { rmPlaceObjectDefAtLoc(huntable1ID, 0, (p1x+e1x)/2.0, (p1z+e1z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, (p1x+e1x)/2.0, (p1z+e1z)/2.0, 1); }
   rmPlaceObjectDefAtLoc(huntable1ID, 0, (p2x+e1x)/2.0, (p2z+e1z)/2.0, 1); rmPlaceObjectDefAtLoc(huntable2ID, 0, (p2x+e1x)/2.0, (p2z+e1z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, e1x, e1z, 1); rmPlaceObjectDefAtLoc(huntable2ID, 0, e1x, e1z, 1);
 
   if(players == 3)
 { rmPlaceObjectDefAtLoc(closeHuntableID, 0, p3x, p3z, 2);
   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(closeHuntableID, 0, p3x, p3z, 3);
   if(useLoneWolfFlag == true) { rmPlaceObjectDefAtLoc(huntable1ID, 0, (p3x+e1x)/2.0, (p3z+e1z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, (p3x+e1x)/2.0, (p3z+e1z)/2.0, 1); }
 }

   if(players > 3)
 { rmPlaceObjectDefAtLoc(closeHuntableID, 0, p3x, p3z, 2); rmPlaceObjectDefAtLoc(huntable1ID, 0, p3x, p3z, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, p3x, p3z, 1);
   rmPlaceObjectDefAtLoc(closeHuntableID, 0, p4x, p4z, 2); rmPlaceObjectDefAtLoc(huntable1ID, 0, p4x, p4z, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, p4x, p4z, 1);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, (p3x+e2x)/2.0, (p3z+e2z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, (p3x+e2x)/2.0, (p3z+e2z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, (p4x+e2x)/2.0, (p4z+e2z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, (p4x+e2x)/2.0, (p4z+e2z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, e2x, e2z, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, e2x, e2z, 1);
 }

   if(players == 5)
 { rmPlaceObjectDefAtLoc(closeHuntableID, 0, p5x, p5z, 2);
   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(closeHuntableID, 0, p5x, p5z, 3);
   if(useLoneWolfFlag == true) { rmPlaceObjectDefAtLoc(huntable1ID, 0, (p5x+e1x)/2.0, (p5z+e1z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, (p5x+e1x)/2.0, (p5z+e1z)/2.0, 1); }
 }
   if(players > 5)
 { rmPlaceObjectDefAtLoc(closeHuntableID, 0, p5x, p5z, 2);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, p5x, p5z, 1); rmPlaceObjectDefAtLoc(huntable2ID, 0, p5x, p5z, 1);
   rmPlaceObjectDefAtLoc(closeHuntableID, 0, p6x, p6z, 2);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, p6x, p6z, 1); rmPlaceObjectDefAtLoc(huntable2ID, 0, p6x, p6z, 1);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, (p5x+e3x)/2.0, (p5z+e3z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, (p5x+e3x)/2.0, (p5z+e3z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, (p6x+e3x)/2.0, (p6z+e3z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, (p6x+e3x)/2.0, (p6z+e3z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, e3x, e3z, 1); rmPlaceObjectDefAtLoc(huntable2ID, 0, e3x, e3z, 1);
 }
   if(players == 7)
 { rmPlaceObjectDefAtLoc(closeHuntableID, 0, p7x, p7z, 2);
   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(closeHuntableID, 0, p7x, p7z, 3);
   if(useLoneWolfFlag == true) { rmPlaceObjectDefAtLoc(huntable1ID, 0, (p7x+e1x)/2.0, (p7z+e1z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, (p7x+e1x)/2.0, (p7z+e1z)/2.0, 1); }
 }
   if(players > 7)
 { rmPlaceObjectDefAtLoc(closeHuntableID, 0, p7x, p7z, 2);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, p7x, p7z, 1); rmPlaceObjectDefAtLoc(huntable2ID, 0, p7x, p7z, 1);
   rmPlaceObjectDefAtLoc(closeHuntableID, 0, p8x, p8z, 2);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, p8x, p8z, 1); rmPlaceObjectDefAtLoc(huntable2ID, 0, p8x, p8z, 1);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, (p7x+e4x)/2.0, (p7z+e4z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, (p7x+e4x)/2.0, (p7z+e4z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, (p8x+e4x)/2.0, (p8z+e4z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable2ID, 0, (p8x+e4x)/2.0, (p8z+e4z)/2.0, 1);
   rmPlaceObjectDefAtLoc(huntable1ID, 0, e4x, e4z, 1); rmPlaceObjectDefAtLoc(huntable2ID, 0, e4x, e4z, 1);
 }
   rmPlaceObjectDefAtLoc(islandHuntableID, 0, 0.5, 0.5, rmRandInt(islandCount/3, islandCount));

// I6.63 Place herdables

   rmPlaceObjectDefAtLoc(herdableID, 0, e1x, e1z, 2*herdableGroups); 
   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(herdableID, 0, (p1x+e1x)/2.0, (p1z+e1z)/2.0, herdableGroups);
   if(useLoneWolfFlag == true && players == 3) rmPlaceObjectDefAtLoc(herdableID, 0, (p3x+e1x)/2.0, (p3z+e1z)/2.0, herdableGroups);
   if(useLoneWolfFlag == true && players == 5) rmPlaceObjectDefAtLoc(herdableID, 0, (p5x+e1x)/2.0, (p5z+e1z)/2.0, herdableGroups);
   if(useLoneWolfFlag == true && players == 7) rmPlaceObjectDefAtLoc(herdableID, 0, (p7x+e1x)/2.0, (p7z+e1z)/2.0, herdableGroups);
   rmPlaceObjectDefAtLoc(herdableID, 0, (p2x+e1x)/2.0, (p2z+e1z)/2.0, herdableGroups);
   if(players == 3 && useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(herdableID, 0, p3x, p3z, 2*herdableGroups);
   if(players == 3 && useLoneWolfFlag == true) rmPlaceObjectDefAtLoc(herdableID, 0, p1x, p1z, 2*herdableGroups); 

   if(players > 3)
 { rmPlaceObjectDefAtLoc(herdableID, 0, e2x, e2z, 2*herdableGroups);
   rmPlaceObjectDefAtLoc(herdableID, 0, (p3x+e2x)/2.0, (p3z+e2z)/2.0, herdableGroups);
   rmPlaceObjectDefAtLoc(herdableID, 0, (p4x+e2x)/2.0, (p4z+e2z)/2.0, herdableGroups);
 }
   if(players == 5 && useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(herdableID, 0, p5x, p5z, 2*herdableGroups);
   if(players == 5 && useLoneWolfFlag == true) rmPlaceObjectDefAtLoc(herdableID, 0, p1x, p1z, 2*herdableGroups);

   if(players > 5)
 { rmPlaceObjectDefAtLoc(herdableID, 0, e3x, e3z, 2*herdableGroups);
   rmPlaceObjectDefAtLoc(herdableID, 0, (p5x+e3x)/2.0, (p5z+e3z)/2.0, herdableGroups);
   rmPlaceObjectDefAtLoc(herdableID, 0, (p6x+e3x)/2.0, (p6z+e3z)/2.0, herdableGroups);
 }
   if(players == 7 && useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(herdableID, 0, p7x, p7z, 2*herdableGroups);
   if(players == 7 && useLoneWolfFlag == true) rmPlaceObjectDefAtLoc(herdableID, 0, p1x, p1z, 2*herdableGroups);

   if(players > 7)
 { rmPlaceObjectDefAtLoc(herdableID, 0, e4x, e4z, 2*herdableGroups);
   rmPlaceObjectDefAtLoc(herdableID, 0, (p7x+e4x)/2.0, (p7z+e4z)/2.0, herdableGroups);
   rmPlaceObjectDefAtLoc(herdableID, 0, (p8x+e4x)/2.0, (p8z+e4z)/2.0, herdableGroups);
 }
// Livestock pen herdables

   if(useFullMapFlag == true)
 {
   rmPlaceObjectDefAtLoc(penHerdableID, 0, rmXMetersToFraction(xsVectorGetX(livestockPenPosition)+8),rmZMetersToFraction(xsVectorGetZ(livestockPenPosition)+8), 1);
   rmPlaceObjectDefAtLoc(penHerdableID, 0, rmXMetersToFraction(xsVectorGetX(livestockPenPosition)-8),rmZMetersToFraction(xsVectorGetZ(livestockPenPosition)+8), 1);
   rmPlaceObjectDefAtLoc(penHerdableID, 0, rmXMetersToFraction(xsVectorGetX(livestockPenPosition)+8),rmZMetersToFraction(xsVectorGetZ(livestockPenPosition)-8), 1);
   rmPlaceObjectDefAtLoc(penHerdableID, 0, rmXMetersToFraction(xsVectorGetX(livestockPenPosition)-8),rmZMetersToFraction(xsVectorGetZ(livestockPenPosition)-8), 1);
 }
// I6.64 Place trees

   rmPlaceObjectDefAtLoc(treeID, 0, p1x, p1z, 2); rmPlaceObjectDefAtLoc(treeID, 0, p2x, p2z, 2);
   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(XTreeID, 0, (p1x+e1x)/2.0, (p1z+e1z)/2.0, 2);
   if(useLoneWolfFlag == true) rmPlaceObjectDefAtLoc(treeID, 0, p1x, p1z, 2);
   rmPlaceObjectDefAtLoc(XTreeID, 0, (p2x+e1x)/2.0, (p2z+e1z)/2.0, 2);
   rmPlaceObjectDefAtLoc(XTreeID, 0, e1x, e1z, 2);

   if(players == 3)
 { rmPlaceObjectDefAtLoc(treeID, 0, p3x, p3z, 2);
   if(useLoneWolfFlag == true) rmPlaceObjectDefAtLoc(XTreeID, 0, (p3x+e1x)/2.0, (p3z+e1z)/2.0, 2);
   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(treeID, 0, p3x, p3z, 3);
 }
   if(players > 3)
 { rmPlaceObjectDefAtLoc(treeID, 0, p3x, p3z, 2); rmPlaceObjectDefAtLoc(XTreeID, 0, (p3x+e2x)/2.0, (p3z+e2z)/2.0, 2);
   rmPlaceObjectDefAtLoc(treeID, 0, p4x, p4z, 2); rmPlaceObjectDefAtLoc(XTreeID, 0, (p4x+e2x)/2.0, (p4z+e2z)/2.0, 2);
   rmPlaceObjectDefAtLoc(XTreeID, 0, e2x, e2z, 2);
 }
   if(players == 5)
 { rmPlaceObjectDefAtLoc(treeID, 0, p5x, p5z, 2);
   if(useLoneWolfFlag == true) rmPlaceObjectDefAtLoc(XTreeID, 0, (p5x+e1x)/2.0, (p5z+e1z)/2.0, 2);
   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(treeID, 0, p5x, p5z, 3);
 }
   if(players > 5)
 { rmPlaceObjectDefAtLoc(treeID, 0, p5x, p5z, 2); rmPlaceObjectDefAtLoc(XTreeID, 0, (p5x+e3x)/2.0, (p5z+e3z)/2.0, 2); 
   rmPlaceObjectDefAtLoc(treeID, 0, p6x, p6z, 2); rmPlaceObjectDefAtLoc(XTreeID, 0, (p6x+e3x)/2.0, (p6z+e3z)/2.0, 2);
   rmPlaceObjectDefAtLoc(XTreeID, 0, e3x, e3z, 2);
 }
   if(players == 7)
 { rmPlaceObjectDefAtLoc(treeID, 0, p7x, p7z, 2);
   if(useLoneWolfFlag == true) rmPlaceObjectDefAtLoc(XTreeID, 0, (p7x+e1x)/2.0, (p7z+e1z)/2.0, 2);
   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(treeID, 0, p7x, p7z, 3);
 }
   if(players > 7)
 { rmPlaceObjectDefAtLoc(treeID, 0, p7x, p7z, 2); rmPlaceObjectDefAtLoc(XTreeID, 0, (p7x+e4x)/2.0, (p7z+e4z)/2.0, 2); 
   rmPlaceObjectDefAtLoc(treeID, 0, p8x, p8z, 2); rmPlaceObjectDefAtLoc(XTreeID, 0, (p8x+e4x)/2.0, (p8z+e4z)/2.0, 2);
   rmPlaceObjectDefAtLoc(XTreeID, 0, e4x, e4z, 2);
 }
// Factory trees

   if(useFullMapFlag == true)
 {
   rmPlaceObjectDefAtLoc(factoryTreeID, 0, rmXMetersToFraction(xsVectorGetX(factoryPosition)-10),rmZMetersToFraction(xsVectorGetZ(factoryPosition)), 1);
   rmPlaceObjectDefAtLoc(factoryTreeID, 0, rmXMetersToFraction(xsVectorGetX(factoryPosition)+8),rmZMetersToFraction(xsVectorGetZ(factoryPosition)+8), 1);
   rmPlaceObjectDefAtLoc(factoryTreeID, 0, rmXMetersToFraction(xsVectorGetX(factoryPosition)-8),rmZMetersToFraction(xsVectorGetZ(factoryPosition)-8), 1);
   rmPlaceObjectDefAtLoc(factoryTreeID, 0, rmXMetersToFraction(xsVectorGetX(factoryPosition)-8),rmZMetersToFraction(xsVectorGetZ(factoryPosition)+8), 1);
   rmPlaceObjectDefAtLoc(factoryTreeID, 0, rmXMetersToFraction(xsVectorGetX(factoryPosition)+8),rmZMetersToFraction(xsVectorGetZ(factoryPosition)-8), 1);

// War hut decorations

   rmPlaceObjectDefAtLoc(campfireID, 0, rmXMetersToFraction(xsVectorGetX(warHutPosition)+9),rmZMetersToFraction(xsVectorGetZ(warHutPosition)), 1);
   rmPlaceObjectDefAtLoc(tanningrackID, 0, rmXMetersToFraction(xsVectorGetX(warHutPosition)),rmZMetersToFraction(xsVectorGetZ(warHutPosition)-12), 1);
   rmPlaceObjectDefAtLoc(nativeVillagerID, 0, rmXMetersToFraction(xsVectorGetX(warHutPosition)-10),rmZMetersToFraction(xsVectorGetZ(warHutPosition)), 1);
   rmPlaceObjectDefAtLoc(nativeHouseID, 0, rmXMetersToFraction(xsVectorGetX(warHutPosition)),rmZMetersToFraction(xsVectorGetZ(warHutPosition)+11), 1);

// Native socket decorations

   rmPlaceObjectDefAtLoc(campfireID, 0, rmXMetersToFraction(xsVectorGetX(nativeSocketPosition)+7),rmZMetersToFraction(xsVectorGetZ(nativeSocketPosition)), 1);
   rmPlaceObjectDefAtLoc(nativeVillagerID, 0, rmXMetersToFraction(xsVectorGetX(nativeSocketPosition)),rmZMetersToFraction(xsVectorGetZ(nativeSocketPosition)-7), 1);
   rmPlaceObjectDefAtLoc(tentID, 0, rmXMetersToFraction(xsVectorGetX(nativeSocketPosition)-10),rmZMetersToFraction(xsVectorGetZ(nativeSocketPosition)), 1);
   rmPlaceObjectDefAtLoc(nativeVillagerID, 0, rmXMetersToFraction(xsVectorGetX(nativeSocketPosition)),rmZMetersToFraction(xsVectorGetZ(nativeSocketPosition)+7), 1);
 }
// I6.65 Place berries

   rmPlaceObjectDefAtLoc(berryID, 0, p1x, p1z);  rmPlaceObjectDefAtLoc(berryID, 0, p2x, p2z); rmPlaceObjectDefAtLoc(berryID, 0, e1x, e1z);
   if(players > 2) rmPlaceObjectDefAtLoc(berryID, 0, p3x, p3z); 
   if(players > 3) { rmPlaceObjectDefAtLoc(berryID, 0, p4x, p4z); rmPlaceObjectDefAtLoc(berryID, 0, e2x, e2z); }
   if(players > 4) rmPlaceObjectDefAtLoc(berryID, 0, p5x, p5z); 
   if(players > 5) { rmPlaceObjectDefAtLoc(berryID, 0, p6x, p6z); rmPlaceObjectDefAtLoc(berryID, 0, e3x, e3z); }
   if(players > 6) rmPlaceObjectDefAtLoc(berryID, 0, p7x, p7z); 
   if(players > 7) { rmPlaceObjectDefAtLoc(berryID, 0, p8x, p8z);rmPlaceObjectDefAtLoc(berryID, 0, e4x, e4z); }

// I6.8 Nuggets
// Nuggets for player areas.

   if(useNuggetsFlag == true)
  {
   int nugCnt = 3; if(useSimpleMapFlag == true && rmGetNomadStart() == false) nugCnt = 2;

// Player nuggets
   rmSetNuggetDifficulty(1, 1);

   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(nuggetID, 0, p1x, p1z, nugCnt);
   if(useLoneWolfFlag == true && (players == 3 || players == 5 || players == 7)) rmPlaceObjectDefAtLoc(nuggetID, 0, p1x, p1z, nugCnt);
   if(useLoneWolfFlag == true && players == 3) rmPlaceObjectDefAtLoc(nuggetID, 0, p3x, p3z, nugCnt);
   if(useLoneWolfFlag == true && players == 5) rmPlaceObjectDefAtLoc(nuggetID, 0, p5x, p5z, nugCnt);
   if(useLoneWolfFlag == true && players == 7) rmPlaceObjectDefAtLoc(nuggetID, 0, p7x, p7z, nugCnt);
   rmPlaceObjectDefAtLoc(nuggetID, 0, p2x, p2z, nugCnt);
   if(players > 3) { rmPlaceObjectDefAtLoc(nuggetID, 0, p3x, p3z, nugCnt); rmPlaceObjectDefAtLoc(nuggetID, 0, p4x, p4z, nugCnt); }
   if(players > 5) { rmPlaceObjectDefAtLoc(nuggetID, 0, p5x, p5z, nugCnt); rmPlaceObjectDefAtLoc(nuggetID, 0, p6x, p6z, nugCnt); }
   if(players > 7) { rmPlaceObjectDefAtLoc(nuggetID, 0, p7x, p7z, nugCnt); rmPlaceObjectDefAtLoc(nuggetID, 0, p8x, p8z, nugCnt); }

// For normal start.
   if(rmGetNomadStart() == false)
 {
// Connection area nuggets
   rmSetNuggetDifficulty(1, 2);
   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(nuggetID, 0, (p1x+e1x)/2, (p1z+e1z)/2.0, nugCnt);
   if(useLoneWolfFlag == true && players == 3) rmPlaceObjectDefAtLoc(nuggetID, 0, (p3x+e1x)/2, (p3z+e1z)/2.0, nugCnt);
   if(useLoneWolfFlag == true && players == 5) rmPlaceObjectDefAtLoc(nuggetID, 0, (p5x+e1x)/2, (p5z+e1z)/2.0, nugCnt);
   if(useLoneWolfFlag == true && players == 7) rmPlaceObjectDefAtLoc(nuggetID, 0, (p7x+e1x)/2, (p7z+e1z)/2.0, nugCnt);
   rmPlaceObjectDefAtLoc(nuggetID, 0, (p2x+e1x)/2.0, (p2z+e1z)/2.0, nugCnt);
   if(players > 3) { rmPlaceObjectDefAtLoc(nuggetID, 0, (p3x+e2x)/2.0, (p3z+e2z)/2.0, nugCnt);
   rmPlaceObjectDefAtLoc(nuggetID, 0, (p4x+e2x)/2.0, (p4z+e2z)/2.0, nugCnt); }
   if(players > 5) { rmPlaceObjectDefAtLoc(nuggetID, 0, (p5x+e3x)/2.0, (p5z+e3z)/2.0, nugCnt);
   rmPlaceObjectDefAtLoc(nuggetID, 0, (p6x+e3x)/2.0, (p6z+e3z)/2.0, nugCnt); }
   if(players > 7) { rmPlaceObjectDefAtLoc(nuggetID, 0, (p7x+e4x)/2.0, (p7z+e4z)/2.0, nugCnt);
   rmPlaceObjectDefAtLoc(nuggetID, 0, (p8x+e4x)/2.0, (p8z+e4z)/2.0, nugCnt); }
// Elbow area nuggets
   rmSetNuggetDifficulty(2, 3);
   rmPlaceObjectDefAtLoc(nuggetID, 0, e1x, e1z, nugCnt);
   if(players > 3) rmPlaceObjectDefAtLoc(nuggetID, 0, e2x, e2z, nugCnt);
   if(players > 5) rmPlaceObjectDefAtLoc(nuggetID, 0, e3x, e3z, nugCnt);
   if(players > 7) rmPlaceObjectDefAtLoc(nuggetID, 0, e4x, e4z, nugCnt);
 }
// For Nomad start.
   if(rmGetNomadStart())
 {
// Connection area nuggets
   rmSetNuggetDifficulty(1, 2);
   if(useLoneWolfFlag == false) rmPlaceObjectDefAtLoc(nuggetID, 0, (p1x+e1x)/2, (p1z+e1z)/2, 2.0*nugCnt);
   if(useLoneWolfFlag == true && players == 3) rmPlaceObjectDefAtLoc(nuggetID, 0, (p3x+e1x)/2, (p3z+e1z)/2, 2.0*nugCnt);
   if(useLoneWolfFlag == true && players == 5) rmPlaceObjectDefAtLoc(nuggetID, 0, (p5x+e1x)/2, (p5z+e1z)/2, 2.0*nugCnt);
   if(useLoneWolfFlag == true && players == 7) rmPlaceObjectDefAtLoc(nuggetID, 0, (p7x+e1x)/2, (p7z+e1z)/2, 2.0*nugCnt);
   rmPlaceObjectDefAtLoc(nuggetID, 0, (p2x+e1x)/2, (p2z+e1z)/2, 2.0*nugCnt); 
   if((ident3 == 1 || ident4 == 1) && players > 3) { rmPlaceObjectDefAtLoc(nuggetID, 0, (p3x+e2x)/2, (p3z+e2z)/2, 2.0*nugCnt);
   rmPlaceObjectDefAtLoc(nuggetID, 0, (p4x+e2x)/2, (p4z+e2z)/2, 2.0*nugCnt); }
   if(ident3 == 0 && ident4 == 0 && players > 3) { rmPlaceObjectDefAtLoc(nuggetID, 0, (p3x+e2x)/2, (p3z+e2z)/2, nugCnt);
   rmPlaceObjectDefAtLoc(nuggetID, 0, (p4x+e2x)/2, (p4z+e2z)/2, nugCnt); }
   if((ident5 == 1 || ident6 == 1) && players > 5) { rmPlaceObjectDefAtLoc(nuggetID, 0, (p5x+e3x)/2, (p5z+e3z)/2, 2.0*nugCnt);
   rmPlaceObjectDefAtLoc(nuggetID, 0, (p6x+e3x)/2, (p6z+e3z)/2, 2.0*nugCnt); }
   if(ident5 == 0 && ident6 == 0 && players > 5) { rmPlaceObjectDefAtLoc(nuggetID, 0, (p5x+e3x)/2, (p5z+e3z)/2, nugCnt);
   rmPlaceObjectDefAtLoc(nuggetID, 0, (p6x+e3x)/2, (p6z+e3z)/2, nugCnt); }
   if((ident7 == 1 || ident8 == 1) && players > 7) { rmPlaceObjectDefAtLoc(nuggetID, 0, (p7x+e4x)/2, (p7z+e4z)/2, 2.0*nugCnt);
   rmPlaceObjectDefAtLoc(nuggetID, 0, (p8x+e4x)/2, (p8z+e4z)/2, 2.0*nugCnt); }
   if(ident7 == 0 && ident8 == 0 && players > 7) { rmPlaceObjectDefAtLoc(nuggetID, 0, (p7x+e4x)/2, (p7z+e4z)/2, nugCnt);
   rmPlaceObjectDefAtLoc(nuggetID, 0, (p8x+e4x)/2, (p8z+e4z)/2, nugCnt); }
// Elbow area nuggets.
   rmSetNuggetDifficulty(2, 3); 
   rmPlaceObjectDefAtLoc(nuggetID, 0, e1x, e1z, 2.0*nugCnt);
   if((ident3 == 1 || ident4 == 1) && players > 3) rmPlaceObjectDefAtLoc(nuggetID, 0, e2x, e2z, 2.0*nugCnt);
   if(ident3 == 0 && ident4 == 0 && players > 3)   rmPlaceObjectDefAtLoc(nuggetID, 0, e2x, e2z, nugCnt);
   if((ident5 == 1 || ident6 == 1) && players > 5) rmPlaceObjectDefAtLoc(nuggetID, 0, e3x, e3z, 2.0*nugCnt);
   if(ident5 == 0 && ident6 == 0 && players > 5)   rmPlaceObjectDefAtLoc(nuggetID, 0, e3x, e3z, nugCnt);
   if((ident7 == 1 || ident8 == 1) && players > 7) rmPlaceObjectDefAtLoc(nuggetID, 0, e4x, e4z, 2.0*nugCnt);
   if(ident7 == 0 && ident8 == 0 && players > 7)   rmPlaceObjectDefAtLoc(nuggetID, 0, e4x, e4z, nugCnt);
 }
// Odd player nugget placement.
   nugCnt = 2.5*nugCnt; // On average as many as others get.
   if(rmGetNomadStart()) nugCnt = 2.0*nugCnt;
   rmSetNuggetDifficulty(1, 3); 
   if(useLoneWolfFlag == false && players == 3) rmPlaceObjectDefAtLoc(nuggetID, 0, p3x, p3z, nugCnt);
   if(useLoneWolfFlag == true && players == 3) rmPlaceObjectDefAtLoc(nuggetID, 0, p1x, p1z, nugCnt);
   if(players == 5) rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, nugCnt);
   if(players == 7) rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, nugCnt);

// Bonus island nugget placement.
   rmSetNuggetDifficulty(1, 4);
   if(useBonusIslandsFlag == true) rmPlaceObjectDefAtLoc(bonusNuggetID, 0, 0.5, 0.5, islandCount);
}
// I6.9 Remaining items.

   rmSetStatusText("",0.7);

// Whales
   rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, fishCount*players);

// Water Flag Fish (Supposedly helps AI decide to fish when fish are by their water flag.)
   rmPlaceObjectDefAtLoc(flagFishID, 0, rmXMetersToFraction(xsVectorGetX(waterFlag1)), rmZMetersToFraction(xsVectorGetZ(waterFlag1)), 1);
   rmPlaceObjectDefAtLoc(flagFishID, 0, rmXMetersToFraction(xsVectorGetX(waterFlag2)), rmZMetersToFraction(xsVectorGetZ(waterFlag2)), 1);
   if(players > 2) rmPlaceObjectDefAtLoc(flagFishID, 0, rmXMetersToFraction(xsVectorGetX(waterFlag3)), rmZMetersToFraction(xsVectorGetZ(waterFlag3)), 1);
   if(players > 3) rmPlaceObjectDefAtLoc(flagFishID, 0, rmXMetersToFraction(xsVectorGetX(waterFlag4)), rmZMetersToFraction(xsVectorGetZ(waterFlag4)), 1);
   if(players > 4) rmPlaceObjectDefAtLoc(flagFishID, 0, rmXMetersToFraction(xsVectorGetX(waterFlag5)), rmZMetersToFraction(xsVectorGetZ(waterFlag5)), 1);
   if(players > 5) rmPlaceObjectDefAtLoc(flagFishID, 0, rmXMetersToFraction(xsVectorGetX(waterFlag6)), rmZMetersToFraction(xsVectorGetZ(waterFlag6)), 1);
   if(players > 6) rmPlaceObjectDefAtLoc(flagFishID, 0, rmXMetersToFraction(xsVectorGetX(waterFlag7)), rmZMetersToFraction(xsVectorGetZ(waterFlag7)), 1);
   if(players > 7) rmPlaceObjectDefAtLoc(flagFishID, 0, rmXMetersToFraction(xsVectorGetX(waterFlag8)), rmZMetersToFraction(xsVectorGetZ(waterFlag8)), 1);

// Fish
   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 2*fishCount*players);

   if(useEyeCandyFlag == true)
  {
// Coastal rocks
   rmPlaceObjectDefAtLoc(rockID, 0, 0.5, 0.5, 4*players);

// Duck family
   rmPlaceObjectDefAtLoc(ducksID, 0, 0.5, 0.5, 4*players);

// Water plants
   rmPlaceObjectDefAtLoc(plantsID, 0, 0.5, 0.5, 4*players);
   if(useFullMapFlag == true) 
 { rmPlaceObjectDefAtLoc(factoryPlantsID, 0, rmXMetersToFraction(xsVectorGetX(factoryPosition)), rmZMetersToFraction(xsVectorGetZ(factoryPosition)), 1);
   rmPlaceObjectDefAtLoc(turtlesID, 0, rmXMetersToFraction(xsVectorGetX(factoryPosition)), rmZMetersToFraction(xsVectorGetZ(factoryPosition)), 1);
 }
// Shipwreck
   rmPlaceObjectDefAtLoc(shipwreckID, 0, 0.5, 0.5, 4*players);
  }
// Bonus island crates
   if(useBonusCratesFlag == true) rmPlaceObjectDefAtLoc(crateID, 0, 0.5, 0.5, islandCount-rmRandInt(1,2));

// Bonus island ship ruins (coin source).
   if(useBonusIslandsFlag == true) rmPlaceObjectDefAtLoc(shipRuinsID, 0, 0.5, 0.5, 1); 

   rmSetStatusText("",0.8);

// Bonus island trees.
   if(useBonusIslandsFlag == true) rmPlaceObjectDefAtLoc(islandTreeID, 0, 0.5, 0.5, 2+islandCount); // Makes for a longer load time.

// Place bison carcass grouping.
   if(useEyeCandyFlag == true) rmPlaceGroupingAtLoc(groupID, 0, p1x, p1z, 1);

// Place BFG
   if(useBFGFlag == true && useBFGwithBaseFlag == true)  rmPlaceGroupingAtLoc(BFGID, 0, 0.5, 0.5);
   if(useBFGFlag == true && useBFGwithBaseFlag == false) rmPlaceObjectDefAtLoc(BFG1ID, 0, 0.5, 0.5);

// Bonus island berries.
   if(useBonusIslandsFlag == true) rmPlaceObjectDefAtLoc(islandBerryID, 0, 0.5, 0.5, islandCount);

// Random trees
   rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 20*players);

// Mining camp coins.

   if(useBonusIslandsFlag == true && useEyeCandyFlag == true)
{
   if(specialProp == "SPCXPMiningCampClone1" || specialProp == "PropGrassFire")
 {
   rmPlaceObjectDefAtLoc(extrasID, 0, rmXMetersToFraction(xsVectorGetX(specialPosition)-6),rmZMetersToFraction(xsVectorGetZ(specialPosition)-2), 1);
   rmPlaceObjectDefAtLoc(extrasID, 0, rmXMetersToFraction(xsVectorGetX(specialPosition)-2),rmZMetersToFraction(xsVectorGetZ(specialPosition)-6), 1);
 }
   if(specialProp != "SPCXPMiningCampClone1" && specialProp != "PropGrassFire")
 {
   rmPlaceObjectDefAtLoc(extrasID, 0, rmXMetersToFraction(xsVectorGetX(specialPosition)+6),rmZMetersToFraction(xsVectorGetZ(specialPosition)+6), 1);
   rmPlaceObjectDefAtLoc(extrasID, 0, rmXMetersToFraction(xsVectorGetX(specialPosition)+6),rmZMetersToFraction(xsVectorGetZ(specialPosition)-6), 1);
   rmPlaceObjectDefAtLoc(extrasID, 0, rmXMetersToFraction(xsVectorGetX(specialPosition)-6),rmZMetersToFraction(xsVectorGetZ(specialPosition)+6), 1);
   rmPlaceObjectDefAtLoc(extrasID, 0, rmXMetersToFraction(xsVectorGetX(specialPosition)-6),rmZMetersToFraction(xsVectorGetZ(specialPosition)-6), 1);
 }
   if(specialProp == "SPCXPMiningCampClone1")
 {
   rmPlaceObjectDefAtLoc(wagonGoldID, 0, rmXMetersToFraction(xsVectorGetX(specialPosition)-8),rmZMetersToFraction(xsVectorGetZ(specialPosition)-8), 1);
 }
   rmPlaceObjectDefAtLoc(XPID, 0, rmXMetersToFraction(xsVectorGetX(birdPropPosition)+6),rmZMetersToFraction(xsVectorGetZ(birdPropPosition)+6), 1);
}
/* I7.0 Triggers */  rmSetStatusText("",0.9);
   string messageText = "initialize";

// I7.1 Create Triggers.                                                                                                              Count

   rmCreateTrigger("StartMessage"); rmCreateTrigger("StartRain"); rmCreateTrigger("StopRain");                                      //  3
   rmCreateTrigger("RainDelay"); rmCreateTrigger("LateRain"); rmCreateTrigger("LessRain");                                          //  3
   rmCreateTrigger("BoltStart"); rmCreateTrigger("BoltEnd"); rmCreateTrigger("BoltDelay1"); rmCreateTrigger("BoltDelay2");          //  4
   rmCreateTrigger("Thunder1"); rmCreateTrigger("Thunder2"); rmCreateTrigger("Wind");                                               //  3
   rmCreateTrigger("WoodMessage1"); rmCreateTrigger("WoodMessage2"); rmCreateTrigger("WoodDelay1"); rmCreateTrigger("WoodDelay2");  //  4
   if(usePiratesFlag == true)
 {
   rmCreateTrigger("Pirate1Leg1"); rmCreateTrigger("Pirate1Leg2"); rmCreateTrigger("Pirate1Leg3"); rmCreateTrigger("Pirate1Leg4");  //  4
   rmCreateTrigger("Pirate2Leg1"); rmCreateTrigger("Pirate2Leg2"); rmCreateTrigger("Pirate2Leg3"); rmCreateTrigger("Pirate2Leg4");  //  4
   rmCreateTrigger("Pirate3Leg1"); rmCreateTrigger("Pirate3Leg2"); rmCreateTrigger("Pirate3Leg3"); rmCreateTrigger("Pirate3Leg4");  //  4
   rmCreateTrigger("Pirate4Leg1"); rmCreateTrigger("Pirate4Leg2"); rmCreateTrigger("Pirate4Leg3"); rmCreateTrigger("Pirate4Leg4");  //  4          33
 }
   if(useFullMapFlag == true)
 {
   rmCreateTrigger("BuffaloMessage");                                                                                               //  1
   rmCreateTrigger("TreeMessage"); rmCreateTrigger("TreeDelay"); rmCreateTrigger("TreeMessage2"); rmCreateTrigger("TreeDelay2");    //  4
   rmCreateTrigger("GoldMessage"); rmCreateTrigger("GoldDelay"); rmCreateTrigger("MineMessage"); rmCreateTrigger("MineDelay");      //  4
   rmCreateTrigger("Game1Message"); rmCreateTrigger("Game1Delay"); rmCreateTrigger("Game1Message2"); rmCreateTrigger("Game1Delay2");//  4
   rmCreateTrigger("Game2Message"); rmCreateTrigger("Game2Delay"); rmCreateTrigger("Game2Message2"); rmCreateTrigger("Game2Delay2");//  4
   rmCreateTrigger("FishMessage"); rmCreateTrigger("FishDelay");                                                                    //  2
   rmCreateTrigger("WhaleMessage"); rmCreateTrigger("WhaleDelay"); rmCreateTrigger("BerryMessage"); rmCreateTrigger("BerryDelay");  //  4
   rmCreateTrigger("HerdMessage"); rmCreateTrigger("DefaultLighting");                                                              //  2
   for(i=1; <= players) { rmCreateTrigger("ConvertToPlayer"+i); rmCreateTrigger("TeamPlayer"+i); }                                  //  4  -  16
   rmCreateTrigger("Team0Message"); rmCreateTrigger("Team1Message");                                                                //  2 
   rmCreateTrigger("WarHutMessage"); rmCreateTrigger("InitializeWarHut");                                                           //  2
   rmCreateTrigger("WarHutDestroyed"); rmCreateTrigger("DoubleCheckWarHut");                                                        //  2
   rmCreateTrigger("MessageSound"); rmCreateTrigger("Sound1"); rmCreateTrigger("Sound2"); rmCreateTrigger("Sound3");                //  4
   rmCreateTrigger("Sound4"); rmCreateTrigger("Sound5"); rmCreateTrigger("Sound6");                                                 //  3          75
   rmCreateTrigger("DelayMusic20"); rmCreateTrigger("DelayMusic30");                                                                //  2
   for(i=1; <= nuggetTotal) rmCreateTrigger("Nugget"+i);                                                                            //  5  -   9
   rmCreateTrigger("OssuaryMessage1"); rmCreateTrigger("OssuaryMessage2");                                                          //  2
   rmCreateTrigger("DoubleCheckOssuary"); rmCreateTrigger("OssuaryDestroyed");rmCreateTrigger("InitializeOssuary");                 //  3
   rmCreateTrigger("OssuaryDelay");                                                                                                 //  1
   rmCreateTrigger("Tribute"); rmCreateTrigger("TributeMessage"); rmCreateTrigger("TributeDelay");                                  //  3
   for(i=1; <= players) { rmCreateTrigger("UnitToPlayer"+i); rmCreateTrigger("PlayerSettlers"+i); }                                 //  4  -  16                                                                                                     //  1
   rmCreateTrigger("PopCountStart"); rmCreateTrigger("DifficultyExpert");                                                           //  2
   rmCreateTrigger("OwnTheWorld"); rmCreateTrigger("OwnTheWorldDelay");                                                             //  2
   rmCreateTrigger("TreesLeft"); rmCreateTrigger("MinesLeft"); rmCreateTrigger("GoldLeft"); rmCreateTrigger("GoldStart");           //  4
   rmCreateTrigger("FishLeft"); rmCreateTrigger("PiratesLeft"); rmCreateTrigger("Credits");                                         //  3
   rmCreateTrigger("TradingPost1"); rmCreateTrigger("TradingPost2"); rmCreateTrigger("TradingPost3");                               //  3
   rmCreateTrigger("QuestStart1"); rmCreateTrigger("QuestStart2"); rmCreateTrigger("QuestStart3");                                  //  3
   rmCreateTrigger("QuestDelay1"); rmCreateTrigger("QuestDelay2");                                                                  //  2
   rmCreateTrigger("Quest11"); rmCreateTrigger("Quest12");rmCreateTrigger("Quest13");                                               //  3 Get Nuggets/wood
   rmCreateTrigger("Quest21"); rmCreateTrigger("Quest22"); rmCreateTrigger("Quest23"); rmCreateTrigger("Quest24");                  //  4 Trading Posts
   rmCreateTrigger("Quest31"); rmCreateTrigger("Quest32");                                                                          //  2 Pirate Loot
   rmCreateTrigger("Quest41"); rmCreateTrigger("Quest42"); rmCreateTrigger("Quest43"); rmCreateTrigger("Quest44");                  //  4 Bonus Units
   rmCreateTrigger("Quest51"); rmCreateTrigger("Quest52"); rmCreateTrigger("Quest53");                                              //  3 Herdables
   rmCreateTrigger("Quest61"); rmCreateTrigger("Quest62");                                                                          //  2 War Hut
   rmCreateTrigger("Quest71"); rmCreateTrigger("Quest72"); rmCreateTrigger("Quest73");                                              //  3 BFG
   rmCreateTrigger("Quest81"); rmCreateTrigger("Quest82");                                                                          //  2 Ossuary
   rmCreateTrigger("Quest911"); rmCreateTrigger("Quest912"); rmCreateTrigger("Quest913"); rmCreateTrigger("Quest92");               //  4 > ossuaryAmount + 5000 resources
   rmCreateTrigger("QuestEnd0"); rmCreateTrigger("QuestEnd1"); rmCreateTrigger("QuestEnd2"); rmCreateTrigger("QuestEnd3");          //  4
   rmCreateTrigger("QuestEnd4"); rmCreateTrigger("QuestEnd5"); rmCreateTrigger("QuestEnd6"); rmCreateTrigger("QuestEnd7");          //  4 
   rmCreateTrigger("QuestEnd8"); rmCreateTrigger("QuestEnd9");                                                                      //  2
   rmCreateTrigger("CratesGone"); rmCreateTrigger("BonusUnitsConverted"); rmCreateTrigger("BonusUnitsConvertedDelay");              //  3
   rmCreateTrigger("BFGConverted"); rmCreateTrigger("PostsComplete"); rmCreateTrigger("WoodComplete");                              //  3
   rmCreateTrigger("EmpireComplete"); rmCreateTrigger("EmpireCompleteDelay");                                                       //  2
   rmCreateTrigger("DominateMap"); rmCreateTrigger("AllQuestsComplete"); rmCreateTrigger("AllQuestsDelay");                         //  3        162
   for(i=2; <= players) rmCreateTrigger("Decimated"+i);                                                                             //  1  -  7
   rmCreateTrigger("Camera1"); rmCreateTrigger("Camera2"); rmCreateTrigger("Camera3"); rmCreateTrigger("Camera4");                  //  4
   rmCreateTrigger("Camera5"); rmCreateTrigger("CameraDelay");                                                                      //  2
   rmCreateTrigger("Win"); rmCreateTrigger("WinDelay1"); rmCreateTrigger("WinDelay2");                                              //  2
   rmCreateTrigger("Buffalo1"); rmCreateTrigger("Buffalo2"); rmCreateTrigger("Buffalo3"); rmCreateTrigger("Buffalo4");              //  4
   rmCreateTrigger("PrivateerSelected1"); rmCreateTrigger("PrivateerSelected2"); rmCreateTrigger("PrivateerDelay");                 //  3
   rmCreateTrigger("CrateMessage1"); rmCreateTrigger("CrateMessage2"); rmCreateTrigger("CrateMessage3");                            //  3
   rmCreateTrigger("CrateMessageDelay"); rmCreateTrigger("NoBFGCheck"); rmCreateTrigger("NoBFGCheckDelay");                         //  3
   rmCreateTrigger("EagleMove1"); rmCreateTrigger("EagleMove2"); rmCreateTrigger("EagleMove3");                                     //  3
   rmCreateTrigger("QuestHerdableMessage1"); rmCreateTrigger("QuestHerdableMessage2"); rmCreateTrigger("QuestHerdableMessage3");    //  3
   rmCreateTrigger("QuestHerdableDelay1"); rmCreateTrigger("QuestHerdableGenerate1"); rmCreateTrigger("QuestHerdableGenerate2");    //  3
   rmCreateTrigger("QuestHerdableGenerate3"); rmCreateTrigger("QuestHerdableGenerate4"); rmCreateTrigger("QuestHerdablesComplete"); //  3
   rmCreateTrigger("QuestHerdableDelay2"); rmCreateTrigger("QuestHerdablesLoop");                                                   //  2
   rmCreateTrigger("LivestockPenMessage1"); rmCreateTrigger("LivestockPenMessage2"); rmCreateTrigger("LivestockPenMessage3");       //  3
   rmCreateTrigger("LivestockPenMessage4"); rmCreateTrigger("LivestockPenMessage5"); rmCreateTrigger("LivestockPenMessage6");       //  3
   rmCreateTrigger("LivestockPenDelay1"); rmCreateTrigger("LivestockPenDelay2"); rmCreateTrigger("LivestockPenConvert");            //  3                                                    //  2
   rmCreateTrigger("HorseMessage"); rmCreateTrigger("HorseDelay");                                                                  //  2
   for(i=0; <= 9) rmCreateTrigger("QuestsDone"+i);                                                                                  // 10
   rmCreateTrigger("QuestsDoneDelay"); rmCreateTrigger("TradingPostControl");                                                       //  2
   for(i=0; <= (nuggetTotal+1)) rmCreateTrigger("TreasureItemMessage"+i); rmCreateTrigger("TreasureItemDelay");                     //  9  -  13
   rmCreateTrigger("TradingPostMessage"); rmCreateTrigger("TradingPostDelay");                                                      //  2
   rmCreateTrigger("FactoryWood"); rmCreateTrigger("FactoryWoodMessage"); rmCreateTrigger("FactoryWoodDelay");                      //  3
   rmCreateTrigger("CampCoin"); rmCreateTrigger("CampCoinMessage"); rmCreateTrigger("CampCoinDelay");                               //  3         238
 }
// Total possible triggers(depending on number of players, start choices and random variables):                                       238 -  268

// I7.8 Start Message trigger

   // Based on; Simple, Basic or Regular, or Full Map. Either FFA, Multiplayer, Lone Wolf and/or Nomad.
 
   if(useFullMapFlag == false)
 {
   string mapName = "Simple"; if(useBasicMapFlag == true) mapName = "Basic"; if(useRegularMapFlag == true) mapName = "Regular";
   if(useSimpleMapFlag == true && FFAFlag == false && multiPlayerFlag == false && rmGetNomadStart() == false && useLoneWolfFlag == false)
   messageText="Dogleg Islands, by Jugit, version " + version + ". Simple Map with no natives, trade routes, pirates, bonus islands nor quests.";
   if(useBasicMapFlag == true && FFAFlag == false && multiPlayerFlag == false && rmGetNomadStart() == false && useLoneWolfFlag == false)
   messageText="Dogleg Islands, by Jugit, version " + version + ". Basic Map with natives and trade routes but no pirates, bonus islands nor quests.";
   if(useRegularMapFlag == true && FFAFlag == false && multiPlayerFlag == false && rmGetNomadStart() == false && useLoneWolfFlag == false)
   messageText="Dogleg Islands, by Jugit, version " + version + ". Regular Map with natives, trade routes, pirates and bonus islands but no quests.";
   if(FFAFlag == false && multiPlayerFlag == false && rmGetNomadStart()== false && useLoneWolfFlag == true)
   messageText="Dogleg Islands, by Jugit, version " + version + ". " + mapName + "You are alone on a smaller island.";
   if(FFAFlag == false && multiPlayerFlag == false && rmGetNomadStart()== true && useLoneWolfFlag  == false)
   messageText="Dogleg Islands. " + mapName + " Map. Human nomad players get a landing party and a caravel. Computer players only get a covered wagon.";
   if(FFAFlag == false && multiPlayerFlag == false && rmGetNomadStart()== true && useLoneWolfFlag  == true)
   messageText="Dogleg Islands. " + mapName + " Map. You are alone on a smaller island. Human/computer nomad players get a landing party/covered wagon.";
   if(FFAFlag == false && multiPlayerFlag == true && rmGetNomadStart() == false && useLoneWolfFlag == false)
   messageText="Dogleg Islands, by Jugit, version " + version + ". " + mapName + " Map. Multiplayer detected. Perhaps a human to contend with.";
   if(FFAFlag == false && multiPlayerFlag == true && rmGetNomadStart() == false && useLoneWolfFlag == true)
   messageText="Dogleg Islands, by Jugit, version " + version + ". " + mapName + " Map. Multiplayer detected. You are alone on a smaller island.";
   if(FFAFlag == false && multiPlayerFlag == true && rmGetNomadStart() == true && useLoneWolfFlag == false)
   messageText="Dogleg Islands, by Jugit, version " + version + ". " + mapName + " Map. Multiplayer detected. Human nomad players get a landing party."; 
   if(FFAFlag == false && multiPlayerFlag == true && rmGetNomadStart() == true && useLoneWolfFlag == true)
   messageText="Dogleg Islands. " + mapName + " Map. Multiplayer mode. You're isolated. Human/computer nomad players get a landing party/covered wagon."; 
   if(FFAFlag == true && multiPlayerFlag == false && rmGetNomadStart() == false && useLoneWolfFlag == false)
   messageText="Dogleg Islands, by Jugit. FFA detected";
   if(FFAFlag == true && multiPlayerFlag == false && rmGetNomadStart() == false && useLoneWolfFlag == true)
   messageText="Dogleg Islands, by Jugit, version " + version + ". " + mapName + " Map. FFA detected";
   if(FFAFlag == true && multiPlayerFlag == false && rmGetNomadStart() == true && useLoneWolfFlag == false)
   messageText="Dogleg Islands. FFA";
   if(FFAFlag == true && multiPlayerFlag == false && rmGetNomadStart() == true && useLoneWolfFlag == true)
   messageText="Dogleg Islands. FFA";
   if(FFAFlag == true && multiPlayerFlag == true && rmGetNomadStart() == false && useLoneWolfFlag == false)
   messageText="Dogleg Islands, by Jugit, version " + version + ". " + mapName + " Map. FFA and Multiplayer detected.";
   if(FFAFlag == true && multiPlayerFlag == true && rmGetNomadStart() == false && useLoneWolfFlag == true)
   messageText="Dogleg Islands, by Jugit, version " + version + ". " + mapName + " Map. FFA and Multiplayer detected. You are alone on a smaller island.";
   if(FFAFlag == true && multiPlayerFlag == true && rmGetNomadStart() == true && useLoneWolfFlag == false)
   messageText="Dogleg Islands. " + mapName + " Map. FFA and Multiplayer detected. Human/computer nomad players get a landing party/covered wagon."; 
   if(FFAFlag == true && multiPlayerFlag == true && rmGetNomadStart() == true && useLoneWolfFlag == true)
   messageText="Dogleg Islands. " + mapName + " Map. FFA and Multiplayer detected. You are isolated. Human nomad players get a landing party.";
}
   // Full Map, Not Lone Wolf, Not Nomad.

   if(useFullMapFlag == true)
{
   messageText = "The";
   if(FFAFlag == true) messageText = "FFA";
   messageText = messageText + " full Dogleg Islands";
   if(rmGetNomadStart() == false) 
 {
   messageText = messageText + ". Natives say it's a ";
   messageText = messageText + mapSizeName + " size map";
 }
   if(useLoneWolfFlag == false && rmGetNomadStart() == false)
 {
   if(useMaxResourcesFlag == false && useMinResourcesFlag == false) 
  {
   messageText = messageText + " with ";
   if(gameCount == 1) messageText = messageText + "poor";
   if(gameCount == 2) messageText = messageText + "okay";
   if(gameCount == 3) messageText = messageText + "good";
   if(gameCount == 4) messageText = messageText + "great";
   messageText = messageText + " hunting, ";
   if(mineCount == 1) messageText = messageText + "poor";
   if(mineCount == 2) messageText = messageText + "okay";
   if(mineCount == 3) messageText = messageText + "good";
   if(mineCount == 4) messageText = messageText + "great";
   messageText = messageText + " mining, ";
   if(treeCount == 1) messageText = messageText + "poor";
   if(treeCount == 2) messageText = messageText + "okay";
   if(treeCount == 3) messageText = messageText + "good";
   if(treeCount == 4) messageText = messageText + "great";
   messageText = messageText + " chopping and ";
   if(fishCount == 1) messageText = messageText + "poor";
   if(fishCount == 2) messageText = messageText + "okay";
   if(fishCount == 3) messageText = messageText + "good";
   if(fishCount == 4) messageText = messageText + "great";
   messageText = messageText + " fishing.     ";
  }
   if(useMaxResourcesFlag == true) messageText = messageText + "plenty of all the resources.";
   if(useMinResourcesFlag == true) messageText = messageText + "limited amounts of each of the resources.";
 }
}
   if(useFullMapFlag == true) 
{
      // Not Lone Wolf, Nomad.

   if(useLoneWolfFlag == false && rmGetNomadStart() == true)
 { messageText = messageText + ". Human nomad players get a landing party and a caravel. Computer players only get a covered wagon."; }

      // Lone Wolf, not Nomad.

   if(useLoneWolfFlag == true && rmGetNomadStart() == false)
 { messageText = messageText + ". You are alone on a smaller island. Click a resource for info."; }

      // Lone Wolf, Nomad.

   if(useLoneWolfFlag == true && rmGetNomadStart() == true)
 { messageText = messageText + ". You are alone on a smaller island. Human/computer nomad players get a landing party/covered wagon."; }

 }
   if(watchPiratesFlag == true) 
  {
   int s11x = 100*ps11x; int s11z = 100*ps11z; int s12x = 100*ps12x; int s12z = 100*ps12z;
   int s13x = 100*ps13x; int s13z = 100*ps13z; int s14x = 100*ps14x; int s14z = 100*ps14z;
   int s21x = 100*ps21x; int s21z = 100*ps21z; int s22x = 100*ps22x; int s22z = 100*ps22z;
   int s23x = 100*ps23x; int s23z = 100*ps23z; int s24x = 100*ps24x; int s24z = 100*ps24z;
   int s31x = 100*ps31x; int s31z = 100*ps31z; int s32x = 100*ps32x; int s32z = 100*ps32z;
   int s33x = 100*ps33x; int s33z = 100*ps33z; int s34x = 100*ps34x; int s34z = 100*ps34z;
   int s41x = 100*ps41x; int s41z = 100*ps41z; int s42x = 100*ps42x; int s42z = 100*ps42z;
   int s43x = 100*ps43x; int s43z = 100*ps43z; int s44x = 100*ps44x; int s44z = 100*ps44z;
   messageText =                               "S1." + s11x + "." + s11z + ",." + s12x + "." + s12z 
                                             + "; ." + s13x + "." + s13z + ",." + s14x + "." + s14z + ". ";
   if(players > 2) messageText = messageText + "S2." + s21x + "." + s21z + ",." + s22x + "." + s22z
                                             + "; ." + s23x + "." + s23z + ",." + s24x + "." + s24z + ". ";
   if(players > 4) messageText = messageText + "S3." + s31x + "." + s31z + ",." + s32x + "." + s32z
                                             + "; ." + s33x + "." + s33z + ",." + s34x + "." + s34z + ". ";
   if(players > 6) messageText = messageText + "S4." + s41x + "." + s41z + ",." + s42x + "." + s42z
                                             + "; ." + s43x + "." + s43z + ",." + s44x + "." + s44z + ". ";
  }
   if(showMapTypesFlag == true) 
 { messageText = "Map Type = " + mapType + ", Lighting = " + lightingType + ", Terrain = " + terrainMix
   + ", Coast = " + terrainCoast + ", Tree = " + treeType + ".";
 }
   if(useHelpFlag == true) 
 { messageText = "Simple Map, ";
   messageText = messageText + "Basic Map, ";
   messageText = messageText + "Regular Map, ";
   messageText = messageText + "Max Resources, ";
   messageText = messageText + "Min Resources, ";
   messageText = messageText + "Giant Map, ";
   messageText = messageText + "Medium Map, ";
   messageText = messageText + "Tiny Map, ";
   messageText = messageText + "Lone Wolf, ";
   messageText = messageText + "Multiplayer.";
 }
   rmSwitchToTrigger(rmTriggerID("StartMessage"));
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 9);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\09 a\Gun.mp3");
   rmAddTriggerEffect("Quest Var Set"); rmSetTriggerEffectParam("QVName", questsComplete); rmSetTriggerEffectParam("Value", "0");

   if(useCountdownFlag == true)
 {
   rmAddTriggerEffect("Counter:Add Timer");
   rmSetTriggerEffectParam("Name","Pirate move");
   rmSetTriggerEffectParamInt("Start",pirate1stMoveTime-5);
   rmSetTriggerEffectParamInt("Stop",1);
   rmSetTriggerEffectParam("Msg","Time to pirates next move");
 }
   if(revealMapFlag == true)
 { 
   rmAddTriggerEffect("Render Fog/Black Map");
   rmSetTriggerEffectParam("Black", "false");
   rmSetTriggerEffectParam("Fog", "false");
 }
   if(useFullMapFlag == true)
 {
   rmAddTriggerEffect("Unit Make Invulnerable"); rmSetTriggerEffectParamInt("DstObject", buffaloSelect); rmSetTriggerEffectParam("Enable", "true");

   if(rmGetNomadStart() == false)
  {
   rmAddTriggerEffect("Unit Make Invulnerable"); rmSetTriggerEffectParamInt("DstObject", treasureItemSelect); rmSetTriggerEffectParam("Enable", "true");
  } 
 }
   messageText = "Friendly natives say that there is no BFG(Big Fixed Gun) on any of the small islands on this map. Probably too small.";
   rmSwitchToTrigger(rmTriggerID("NoBFGCheck"));
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 70); 
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCFixedGun");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerEffect("Quest Var Modify"); rmSetTriggerEffectParam("QVName", questsComplete); 
   rmSetTriggerEffectParam("Oper", "+"); rmSetTriggerEffectParam("Value", "1");
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\menacing thing.mp3");

   rmSwitchToTrigger(rmTriggerID("NoBFGCheckDelay"));
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 80);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("NoBFGCheck"));

// I7.2 Rain triggers

   rmSwitchToTrigger(rmTriggerID("StartRain")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 15);
   rmAddTriggerEffect("Set Lighting"); rmSetTriggerEffectParam("SetName", "308b_caribbeanlight"); rmSetTriggerEffectParamFloat("FadeTime", 15.0);
   if(mapType == "yukon") { rmAddTriggerEffect("Render Snow"); rmSetTriggerEffectParamFloat("Percent", 0.5); }
   if(mapType != "yukon")
 { rmAddTriggerEffect("Render Rain"); rmSetTriggerEffectParamFloat("Percent", 0.5); 
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Thunder1"));
 }
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("StopRain"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Wind"));

   rmSwitchToTrigger(rmTriggerID("StopRain")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", rmRandInt(240,360));
   if(mapType == "yukon") { rmAddTriggerEffect("Render Snow"); rmSetTriggerEffectParamFloat("Percent", 0.0); }
   if(mapType != "yukon") { rmAddTriggerEffect("Render Rain"); rmSetTriggerEffectParamFloat("Percent", 0.0); }
   rmAddTriggerEffect("Set Lighting"); rmSetTriggerEffectParam("SetName", lightingType); rmSetTriggerEffectParamFloat("FadeTime", 15.0);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\crickets.mp3");

   rmSwitchToTrigger(rmTriggerID("RainDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 180);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("StartRain"));

   int lateRainTime = rmRandInt(1800,2400); if(useFullMapFlag == false) lateRainTime = rmRandInt(240,720);
   rmSwitchToTrigger(rmTriggerID("LateRain")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", lateRainTime);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("StartRain"));
 
   rmSwitchToTrigger(rmTriggerID("Thunder1")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", rmRandInt(20,40));
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\thunderstorm.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("BoltStart"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("BoltDelay1"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Thunder2"));

   rmSwitchToTrigger(rmTriggerID("Thunder2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 80);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\thunder.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("BoltDelay2"));

   rmSwitchToTrigger(rmTriggerID("BoltDelay1")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 38);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("BoltStart"));

   rmSwitchToTrigger(rmTriggerID("BoltDelay2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 40);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("BoltStart"));

   rmSwitchToTrigger(rmTriggerID("BoltStart")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 17);
   rmAddTriggerEffect("Set Lighting"); rmSetTriggerEffectParam("SetName", "malta"); rmSetTriggerEffectParamFloat("FadeTime", 1.0);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\thunder2.mp3");
   rmAddTriggerEffect("Shake Camera"); rmSetTriggerEffectParamFloat("Duration", 2.0); rmSetTriggerEffectParamFloat("Strength", 0.25);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("BoltEnd"));

   rmSwitchToTrigger(rmTriggerID("BoltEnd")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 1);
   rmAddTriggerEffect("Set Lighting"); rmSetTriggerEffectParam("SetName", "308b_caribbeanlight"); rmSetTriggerEffectParamFloat("FadeTime", 1.0);

   rmSwitchToTrigger(rmTriggerID("Wind")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", rmRandInt(50,100));
   if(mapType == "yukon") { rmAddTriggerEffect("Render Snow"); rmSetTriggerEffectParamFloat("Percent", 1.0); }
   if(mapType != "yukon") { rmAddTriggerEffect("Render Rain"); rmSetTriggerEffectParamFloat("Percent", 1.0); }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\wind.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LessRain"));

   rmSwitchToTrigger(rmTriggerID("LessRain")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 66);
   if(mapType == "yukon") { rmAddTriggerEffect("Render Snow"); rmSetTriggerEffectParamFloat("Percent", 0.5); }
   if(mapType != "yukon") { rmAddTriggerEffect("Render Rain"); rmSetTriggerEffectParamFloat("Percent", 0.5); }

// Wood messages

   if(rmGetNomadStart())
 {
   messageText = "Friendly natives have scattered some piles of wood around to help nomads get started.";
   rmSwitchToTrigger(rmTriggerID("WoodMessage1")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 180);
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "CrateOfWood"); rmSetTriggerConditionParam("Op", ">"); rmSetTriggerConditionParamInt("Count", 2);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\mumble.mp3");
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmSwitchToTrigger(rmTriggerID("WoodDelay1")); rmSetTriggerActive(true); 
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 360);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("WoodMessage1"));

   rmSwitchToTrigger(rmTriggerID("WoodMessage2")); rmSetTriggerActive(true); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "CrateOfWood");
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("WoodDelay2"));
 
// Wood delay

   rmSwitchToTrigger(rmTriggerID("WoodDelay2")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("WoodMessage2"));
 }
// I7.11 Pirate ship triggers.

   if(usePiratesFlag == true)
 {
// Move pirate ship 1 on leg 1.
   rmSwitchToTrigger(rmTriggerID("Pirate1Leg1")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", pirate1stMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate1Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps11x)+",0,"+rmZFractionToMeters(ps11z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("StartMessage"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate1Leg2"));
   if(useCountdownFlag == true)
 {
   rmAddTriggerEffect("Counter:Add Timer");
   rmSetTriggerEffectParam("Name","Pirate move");
   rmSetTriggerEffectParamInt("Start",pirateMoveTime);
   rmSetTriggerEffectParamInt("Stop",1);
   rmSetTriggerEffectParam("Msg","Time to pirates next move");
 }
// Move pirate ship 1 on leg 2.
   rmSwitchToTrigger(rmTriggerID("Pirate1Leg2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", pirateMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate1Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps12x)+",0,"+rmZFractionToMeters(ps12z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate1Leg3"));
   if(useCountdownFlag == true)
 {
   rmAddTriggerEffect("Counter:Add Timer");
   rmSetTriggerEffectParam("Name","Pirate move");
   rmSetTriggerEffectParamInt("Start",pirateMoveTime);
   rmSetTriggerEffectParamInt("Stop",1);
   rmSetTriggerEffectParam("Msg","Time to pirates next move");
  }
// Move pirate ship 1 on leg 3.
   rmSwitchToTrigger(rmTriggerID("Pirate1Leg3")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", pirateMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate1Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps13x)+",0,"+rmZFractionToMeters(ps13z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate1Leg4"));
   if(useCountdownFlag == true)
 {
   rmAddTriggerEffect("Counter:Add Timer");
   rmSetTriggerEffectParam("Name","Pirate move");
   rmSetTriggerEffectParamInt("Start",pirateMoveTime);
   rmSetTriggerEffectParamInt("Stop",1);
   rmSetTriggerEffectParam("Msg","Time to pirates next move");
 }
// Move pirate ship 1 on leg 4.
   rmSwitchToTrigger(rmTriggerID("Pirate1Leg4")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", pirateMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate1Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps14x)+",0,"+rmZFractionToMeters(ps14z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate1Leg1"));
   if(useCountdownFlag == true)
 {
   rmAddTriggerEffect("Counter:Add Timer");
   rmSetTriggerEffectParam("Name","Pirate move");
   rmSetTriggerEffectParamInt("Start",pirateMoveTime);
   rmSetTriggerEffectParamInt("Stop",1);
   rmSetTriggerEffectParam("Msg","Time to pirates next move");
 }
// Move pirate ship 2 on leg 1.
   if(players > 2)
 {
   rmSwitchToTrigger(rmTriggerID("Pirate2Leg1")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 1+pirate1stMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate2Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps21x)+",0,"+rmZFractionToMeters(ps21z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate2Leg2"));

// Move pirate ship 2 on leg 2.
   rmSwitchToTrigger(rmTriggerID("Pirate2Leg2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", pirateMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate2Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps22x)+",0,"+rmZFractionToMeters(ps22z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate2Leg3"));

// Move pirate ship 2 on leg 3.
   rmSwitchToTrigger(rmTriggerID("Pirate2Leg3")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", pirateMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate2Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps23x)+",0,"+rmZFractionToMeters(ps23z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate2Leg4"));

// Move pirate ship 2 on leg 4.
   rmSwitchToTrigger(rmTriggerID("Pirate2Leg4")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", pirateMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate2Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps24x)+",0,"+rmZFractionToMeters(ps24z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate2Leg1"));
 }
// Move pirate ship 3 on leg 1.
   if(players > 4)
 {
   rmSwitchToTrigger(rmTriggerID("Pirate3Leg1")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 2+pirate1stMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate3Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps31x)+",0,"+rmZFractionToMeters(ps31z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate3Leg2"));

// Move pirate ship 3 on leg 2.
   rmSwitchToTrigger(rmTriggerID("Pirate3Leg2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", pirateMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate3Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps32x)+",0,"+rmZFractionToMeters(ps32z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate3Leg3"));

// Move pirate ship 3 on leg 3.
   rmSwitchToTrigger(rmTriggerID("Pirate3Leg3")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", pirateMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate3Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps33x)+",0,"+rmZFractionToMeters(ps33z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate3Leg4"));

// Move pirate ship 3 on leg 4.
   rmSwitchToTrigger(rmTriggerID("Pirate3Leg4")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", pirateMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate3Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps34x)+",0,"+rmZFractionToMeters(ps34z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate3Leg1"));
 }
// Move pirate ship 4 on leg 1.
   if(players > 6)
 {
   rmSwitchToTrigger(rmTriggerID("Pirate4Leg1")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 3+pirate1stMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate4Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps41x)+",0,"+rmZFractionToMeters(ps41z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate4Leg2"));

// Move pirate ship 4 on leg 2.
   rmSwitchToTrigger(rmTriggerID("Pirate4Leg2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", pirateMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate4Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps42x)+",0,"+rmZFractionToMeters(ps42z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate4Leg3"));

// Move pirate ship 4 on leg 3.
   rmSwitchToTrigger(rmTriggerID("Pirate4Leg3")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", pirateMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate4Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps43x)+",0,"+rmZFractionToMeters(ps43z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate2Leg4"));

// Move pirate ship 4 on leg 4.
   rmSwitchToTrigger(rmTriggerID("Pirate4Leg4")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", pirateMoveTime);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", pirate4Select);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(ps44x)+",0,"+rmZFractionToMeters(ps44z));
   if(useAttackMoveFlag == true) rmSetTriggerEffectParam("AttackMove", "true");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Pirate4Leg1"));
 }
}
// I7.4 Collect nuggets triggers.

   if(useFullMapFlag == true) //x goes to end of file.
{
   if(useNuggetBonusFlag == true)
 {
   messageText = "You collected your first treasure. Get " + (nuggetTotal-1) + " more and a bonus " + nuggetBoatName
   + " will be sent to your water flag. See treasure countdown.";
   rmSwitchToTrigger(rmTriggerID("Nugget"+1)); rmSetTriggerActive(true);
   rmAddTriggerCondition("Number Of Nuggets Collected");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Op", "==");
   rmSetTriggerConditionParamInt("NumberOfNuggets", 1);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   messageText = "Treasures for " + nuggetBoatName + ": " + (nuggetTotal-1);
   rmAddTriggerEffect("FakeCounter Set Text");
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\magic.mp3");
   rmAddTriggerEffect("FadeOutMusic"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("MessageSound"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TreasureItemMessage0"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TreasureItemMessage"+(nuggetTotal+1)));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TreasureItemMessage1"));

   for(i=2; < nuggetTotal)
 {
   rmSwitchToTrigger(rmTriggerID("Nugget"+i)); rmSetTriggerActive(true);
   rmAddTriggerCondition("Number Of Nuggets Collected");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Op", "==");
   rmSetTriggerConditionParamInt("NumberOfNuggets", i);
   messageText = "Treasures for " + nuggetBoatName + ": " + (nuggetTotal-i);
   rmAddTriggerEffect("FakeCounter Set Text");
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\magic.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TreasureItemMessage"+(i-1)));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TreasureItemMessage"+i));
 }
   rmSwitchToTrigger(rmTriggerID("Nugget"+nuggetTotal)); rmSetTriggerActive(true);
   rmAddTriggerCondition("Number Of Nuggets Collected");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Op", "==");
   rmSetTriggerConditionParamInt("NumberOfNuggets", nuggetTotal);
   rmAddTriggerEffect("Unit Create");
   rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ProtoName", nuggetBoatType);
   rmSetTriggerEffectParam("Location", (xsVectorGetX(waterFlag1)+5) + ",0," + (xsVectorGetZ(waterFlag1) + 5));
   messageText = "Good! You collected " + nuggetTotal +  " treasures and 300 XP. Make good use of your new "
   + nuggetBoatName + " near your water flag. See the minimap flare.";
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\magic.mp3");
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Quest Var Modify"); rmSetTriggerEffectParam("QVName", questsComplete); 
   rmSetTriggerEffectParam("Oper", "+"); rmSetTriggerEffectParam("Value", "1");
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "XP"); rmSetTriggerEffectParamInt("Amount", 300);
   messageText = "Treasures for " + nuggetBoatName + ": 0";
   rmAddTriggerEffect("FakeCounter Set Text");
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Flare Minimap");
   rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParamFloat("Duration", 30.0);
   rmSetTriggerEffectParam("Position", (xsVectorGetX(waterFlag1)+5) + ",0," + (xsVectorGetZ(waterFlag1) + 5));
   rmSetTriggerEffectParam("Flash", "true");
   rmAddTriggerEffect("FadeOutMusic"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TreasureItemMessage"+(nuggetTotal-1)));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TreasureItemMessage"+nuggetTotal));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestsDoneDelay"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("MessageSound"));
 } //x end of if(useNuggetBonusFlag == true)
// I7.5 War hut triggers 

   messageText = "Destroy this war hut and recover the resources inside.";
   rmSwitchToTrigger(rmTriggerID("WarHutMessage")); rmSetTriggerActive(true); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCCherokeeWarHut");
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }

   messageText = "Be sure to search the small islands for resources and surprises; but watch out for the BFG (Bid Fixed Gun).";
   rmSwitchToTrigger(rmTriggerID("InitializeWarHut")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", rmRandInt(660, 720));
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\sparkle.mp3");
   rmAddTriggerEffect("FadeOutMusic"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("MessageSound"));

   rmSwitchToTrigger(rmTriggerID("DoubleCheckWarHut")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCCherokeeWarHut");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("WarHutDestroyed"));

   string rewardType = "wood"; pick = rmRandInt(1,3); if(pick == 2) rewardType = "food"; if(pick == 3) rewardType = "gold";
   string rewardName = rewardType; if(rewardType == "gold") rewardName = "coin";
   int rewardAmount = 100*rmRandInt(10,20);
   messageText = "You have destroyed the war hut at the minimap flare and received " + rewardAmount + " " + rewardName
   + ". A quest completed and 200 more XP.";
   rmSwitchToTrigger(rmTriggerID("WarHutDestroyed")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCCherokeeWarHut");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerEffect("Quest Var Modify"); rmSetTriggerEffectParam("QVName", questsComplete); 
   rmSetTriggerEffectParam("Oper", "+"); rmSetTriggerEffectParam("Value", "1");
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "XP"); rmSetTriggerEffectParamInt("Amount", 200);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", rewardType); rmSetTriggerEffectParamInt("Amount", rewardAmount);
   rmAddTriggerEffect("Shake Camera"); rmSetTriggerEffectParamFloat("Duration", 2.0); rmSetTriggerEffectParamFloat("Strength", 0.5);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\03 A\FireShipExplode.mp3");
   rmAddTriggerEffect("Flare Minimap");
   rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParamFloat("Duration", 30.0);
   rmSetTriggerEffectParam("Position", xsVectorGetX(warHutPosition) + ",0," + xsVectorGetZ(warHutPosition));
   rmSetTriggerEffectParam("Flash", "true");

// I7.6 Ossuary triggers.

// Ossuary message one

   messageText = "Natives fear this ossuary. Destroy it and they will reward all players greatly and equally; letting slip the dogs of war.";
   rmSwitchToTrigger(rmTriggerID("OssuaryMessage1")); rmSetTriggerActive(true); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCOssuary");
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("OssuaryDelay"));

// Ossuary delay

   rmSwitchToTrigger(rmTriggerID("OssuaryDelay")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("OssuaryMessage2"));

// Ossuary message two

   messageText = "Pirates built this ossuary to scare the natives. Destroy it and all players will get " + ossuaryAmount + " of all 3 resources.";
   rmSwitchToTrigger(rmTriggerID("OssuaryMessage2")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCOssuary");
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("OssuaryDelay"));

// Check placement of ossuary.

   rmSwitchToTrigger(rmTriggerID("DoubleCheckOssuary")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCOssuary");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("InitializeOssuary"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("OssuaryDestroyed"));

// Initialize ossuary

   word = "afraid"; pick = rmRandInt(1,4); if(pick == 2) word = "terrified"; if(pick == 3) word = "scared"; if(pick == 4) word = "nervous";
   messageText = "Natives are " + word + " of the small island ossuary. Click it for info. Click the buffalo near your TC for quest info.";
   rmSwitchToTrigger(rmTriggerID("InitializeOssuary")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", rmRandInt(860, 980));
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\sparkle.mp3");
   rmAddTriggerEffect("FadeOutMusic"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("MessageSound"));
   if(useVisualsFlag == true && rainPick < 7) { rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("RainDelay")); }

// Ossuary destroyed

   messageText = "The ossuary has been destroyed and all players have received " + ossuaryAmount
   + " each of wood, food and coin. A quest completed and 400 XP.";
   rmSwitchToTrigger(rmTriggerID("OssuaryDestroyed")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCOssuary");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerEffect("Quest Var Modify"); rmSetTriggerEffectParam("QVName", questsComplete); 
   rmSetTriggerEffectParam("Oper", "+"); rmSetTriggerEffectParam("Value", "1");
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "XP"); rmSetTriggerEffectParamInt("Amount", 400);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   for(i=1; <= players)
  {
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", i);
   rmSetTriggerEffectParam("ResName", "wood"); rmSetTriggerEffectParamInt("Amount", ossuaryAmount);
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", i);
   rmSetTriggerEffectParam("ResName", "food"); rmSetTriggerEffectParamInt("Amount", ossuaryAmount);
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", i);
   rmSetTriggerEffectParam("ResName", "gold"); rmSetTriggerEffectParamInt("Amount", ossuaryAmount);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\03 A\FireShipExplode.mp3");
   rmAddTriggerEffect("Shake Camera"); rmSetTriggerEffectParamFloat("Duration", 2.0); rmSetTriggerEffectParamFloat("Strength", 0.5);
  }
// I7.7 Most herdable triggers.

   if(useVisualsFlag == true && useLoneWolfFlag == false  && FFAFlag == false)
 {
   for(i=1; <= players) 
  {
   rmSwitchToTrigger(rmTriggerID("TeamPlayer"+i));
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", i);
   rmSetTriggerConditionParam("ProtoUnit", herdableType);
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 2*herdableGroups*herdableCount);
   if(rmGetPlayerTeam(i) == 0) { rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Team0Message")); }
   if(rmGetPlayerTeam(i) == 1) { rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Team1Message")); }
  }
   messageText = "Your team has";
   if(players < 3) messageText = "You have";
   messageText = messageText + " most of an island's " + herdableType;
   if(herdableType == "sheep") messageText = messageText  + ". ";
   if(herdableType != "sheep") messageText = messageText  + "s. ";
   messageText = messageText  + " At " + 2*herdableGroups + " herds of "
   + herdableCount + " per player. The sun shines bright. Click other resources for info.";

   rmSwitchToTrigger(rmTriggerID("Team0Message")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 2);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Set Lighting"); rmSetTriggerEffectParam("SetName", "seville"); rmSetTriggerEffectParamFloat("FadeTime", 5.0);

   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\sparkle.mp3");
   rmAddTriggerEffect("FadeOutMusic"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Sound1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Team1Message"));
   for(j=1; <= players)
  {
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TeamPlayer"+j));
  }
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Team1Player"));
   if(useVisualsFlag == true && rainPick > 3) 
  {rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("RainDelay"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LateRain")); 
  }

   messageText = "The enemy team";
   if(players < 3) messageText = "Your enemy";
   messageText = messageText + " has most of an island's " + herdableType;
   if(herdableType == "sheep") messageText = messageText  + ". ";
   if(herdableType != "sheep") messageText = messageText  + "s. ";
   messageText = messageText  + " At " + 2*herdableGroups + " herds of "
   + herdableCount + " per player. A dark cloud looms. Click other resources for info.";
   rmSwitchToTrigger(rmTriggerID("Team1Message")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 2);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Set Lighting"); rmSetTriggerEffectParam("SetName", "308b_caribbeanlight"); rmSetTriggerEffectParamFloat("FadeTime", 5.0);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\sparkle.mp3");
   rmAddTriggerEffect("FadeOutMusic"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Team0Message"));
   for(j=1; <= players)
  {
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TeamPlayer"+j));
  }
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Team0Player"));
   rmAddTriggerEffect("FadeOutMusic"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Sound2"));
   if(useVisualsFlag == true) { rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("StartRain")); }
 } // End of most herdables
// White buffalo message trigger.
  
   messageText = "Click on the white buffalo, near your ";
   rmSwitchToTrigger(rmTriggerID("BuffaloMessage"));
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 50);
   string buffaloRevealer = "Initialize";
   rmAddTriggerEffect("Revealer : Create"); rmSetTriggerEffectParamInt("PlayerID", 1); rmSetTriggerEffectParam("RevealerName", buffaloRevealer);
   rmSetTriggerEffectParam("RevealerLoc", rmXFractionToMeters(p1x)+",0,"+rmZFractionToMeters(p1z)); rmSetTriggerEffectParamFloat("RevealerLOS", 22.0);
   if(rmGetNomadStart() == true) // Light up the buffalo for nomad start in case it cannot be seen.
 { messageText = messageText + "start position,"; 
   rmAddTriggerEffect("Revealer : Set Active State"); rmSetTriggerEffectParam("RevealerName", buffaloRevealer);
   rmSetTriggerEffectParam("ActiveState", "true");
 }
   if(rmGetNomadStart() == false) messageText = messageText +  "town center,"; 
   messageText = messageText +  " to display the quest status. You get 200 to 500 XP for finishing each quest.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\shadesarrive.mp3");

// I7.9 Resource message triggers.

   messageText = "Friendly natives say that there ";
   if(treeCount == 1) messageText = messageText + "won't be near enough";
   if(treeCount == 2) messageText = messageText + "won't be quite enough";
   if(treeCount == 3) messageText = messageText + "should be enough";  
   if(treeCount == 4) messageText = messageText + "will be plenty of";
   int percent = 100*(mapMultiplier-1);
   messageText = messageText + " wood to chop on this " + mapSizeName + " (" + percent + " percent of min to max) size map.";
   rmSwitchToTrigger(rmTriggerID("TreeMessage")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", treeType);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\03 A\WoodBreak.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TreeDelay"));

   rmSwitchToTrigger(rmTriggerID("TreeDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TreeMessage2"));

   messageText = "The number of trees(1,2,3or4) in the small clumps indicate the total amount of trees(few to many) to chop on this " + mapSizeName + " map.";
   rmSwitchToTrigger(rmTriggerID("TreeMessage2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", treeType);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\03 A\WoodBreak.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TreeDelay2"));

   rmSwitchToTrigger(rmTriggerID("TreeDelay2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TreeMessage"));

   messageText = "The natives say that there ";
   if(fishCount == 1) messageText = messageText + "won't be very many";
   if(fishCount == 2) messageText = messageText + "might not be enough";
   if(fishCount == 3) messageText = messageText + "should be enough";  
   if(fishCount == 4) messageText = messageText + "great and there will be plenty of";
   messageText = messageText + " fish for food and whales for coin on this " + mapSizeName + " size map.";
   rmSwitchToTrigger(rmTriggerID("FishMessage")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", fishType);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\03 A\BoatWater2.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("FishDelay"));

   rmSwitchToTrigger(rmTriggerID("FishDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("FishMessage"));

   messageText = "The natives say that there ";
   if(fishCount == 1) messageText = messageText + "won't be very many";
   if(fishCount == 2) messageText = messageText + "might not be enough";
   if(fishCount == 3) messageText = messageText + "should be enough";  
   if(fishCount == 4) messageText = messageText + "will be plenty of";
   messageText = messageText + " whales for coin nor fish for food on this " + mapSizeName + " size map.";
   rmSwitchToTrigger(rmTriggerID("WhaleMessage")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", whaleType);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\03 A\BoatWater2.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("WhaleDelay"));

   rmSwitchToTrigger(rmTriggerID("WhaleDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("WhaleMessage"));

   messageText = "The natives say that there ";
   if(berryCount == 2) messageText = messageText + "are only a few";
   if(berryCount == 3) messageText = messageText + "are several";
   if(berryCount == 4) messageText = messageText + "are many";  
   if(berryCount == 5) messageText = messageText + "are plenty of";
   messageText = messageText + " berry bushes to pick while you find other food, on this " + mapSizeName + " size  map.";
   rmSwitchToTrigger(rmTriggerID("BerryMessage")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "berryBush");
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\11 A\Steps2.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("BerryDelay"));

   rmSwitchToTrigger(rmTriggerID("BerryDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("BerryMessage"));
 
   messageText = "Friendly natives say that there ";
   if(gameCount == 1) messageText = messageText + "won't be very many ";
   if(gameCount == 2) messageText = messageText + "might not be enough ";
   if(gameCount == 3) messageText = messageText + "should be enough ";  
   if(gameCount == 4) messageText = messageText + "will be plenty of ";
   messageText = messageText + huntable1Type + " and " + huntable2Type +  " to hunt on this " + mapSizeName + " size map.";
   rmSwitchToTrigger(rmTriggerID("Game1Message")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", huntable1Type);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\09 a\Gun.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Game1Delay"));

   rmSwitchToTrigger(rmTriggerID("Game1Delay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Game1Message2"));

   messageText = "The herd size(2, 3, 4 or 5) of wild game indicate the total amount(few to many) to hunt on this " + mapSizeName + " size map.";
   rmSwitchToTrigger(rmTriggerID("Game1Message2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", huntable1Type);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\09 a\Gun.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Game1Delay2"));

   rmSwitchToTrigger(rmTriggerID("Game1Delay2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Game1Message"));
 
   messageText = "Friendly natives say that there ";
   if(gameCount == 1) messageText = messageText + "won't be very many ";
   if(gameCount == 2) messageText = messageText + "might not be enough ";
   if(gameCount == 3) messageText = messageText + "should be enough ";  
   if(gameCount == 4) messageText = messageText + "will be plenty of ";
   messageText = messageText + huntable2Type + " and " + huntable1Type +  " to hunt on this " + mapSizeName + " size map.";
   rmSwitchToTrigger(rmTriggerID("Game2Message")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", huntable2Type);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\09 a\Gun.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Game2Delay"));

   rmSwitchToTrigger(rmTriggerID("Game2Delay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Game2Message2"));

   messageText = "The herd size(2, 3, 4 or 5) of wild game indicate the total amount(few to many) to hunt on this " + mapSizeName + " size map.";
   rmSwitchToTrigger(rmTriggerID("Game2Message2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", huntable2Type);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\09 a\Gun.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Game2Delay2"));

   rmSwitchToTrigger(rmTriggerID("Game2Delay2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Game2Message"));
 
   messageText = "Natives say there are " + 2*herdableGroups + " herds of " + herdableCount + " " + herdableType;
   if(herdableType == "sheep") messageText = messageText + " ";
   if(herdableType != "sheep") messageText = messageText + "s ";
   messageText = messageText + "per player on this " + mapSizeName + " size map. Click other resources. This message won't repeat.";
   rmSwitchToTrigger(rmTriggerID("HerdMessage")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", herdableType);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\09 a\Gun.mp3");
 
   messageText = "The natives say that there ";
   if(mineCount == 1) messageText = messageText + "won't be very many";
   if(mineCount == 2) messageText = messageText + "might not be enough";
   if(mineCount == 3) messageText = messageText + "should be enough";  
   if(mineCount == 4) messageText = messageText + "will be plenty of";
   messageText = messageText + " mines for making coin on this " + mapSizeName + " size map.";
   rmSwitchToTrigger(rmTriggerID("GoldMessage")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "minegold");
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\19 A\Wind.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("GoldDelay"));

   rmSwitchToTrigger(rmTriggerID("GoldDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("GoldMessage"));

   messageText = "The natives say that there ";
   if(mineCount == 1) messageText = messageText + "won't be very many";
   if(mineCount == 2) messageText = messageText + "might not be enough";
   if(mineCount == 3) messageText = messageText + "should be enough";  
   if(mineCount == 4) messageText = messageText + "will be plenty of";
   messageText = messageText + " mines for making coin on this " + mapSizeName + " size map.";
   rmSwitchToTrigger(rmTriggerID("MineMessage")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", mineType);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\19 A\Wind.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("MineDelay"));

   rmSwitchToTrigger(rmTriggerID("MineDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("MineMessage"));

// I7.12 Wagon and bonus unit triggers

   for(i=1; <= players)
 {
   word = "found"; pick = rmRandInt(1,3); if(pick == 2) word = "discovered"; if(pick == 3) word = "located";
   words = "gives an advantage"; pick = rmRandInt(1,3); if(pick == 2) words = "has obvious benefits"; if(pick == 3) words = "will help its new owner";
   if(i == 1) messageText = "You ";
   if(i != 1 && rmGetPlayerTeam(i) == 0) messageText = "Your ally, " + rmGetPlayerName(i) + ", ";
   if(i != 1 && rmGetPlayerTeam(i) == 1) messageText = "Your enemy, " + rmGetPlayerName(i) + ", ";
   messageText = messageText + word + " a lost " + wagonName + " that " + words + ".";
   if(i == 1) messageText = messageText + " See the minimap flare for its location.";
   rmSwitchToTrigger(rmTriggerID("ConvertToPlayer"+i));
   rmSetTriggerActive(true);
   rmAddTriggerCondition("Units In LOS");
   rmSetTriggerConditionParamInt("SrcObject", wagonSelect);
   rmSetTriggerConditionParamInt("PlayerID", i);
   rmAddTriggerEffect("Convert");
   rmSetTriggerEffectParamInt("SrcObject", wagonSelect);
   rmSetTriggerEffectParamInt("PlayerID", i);
   if(displayMessageFlag == true) 
  { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   for(j=1; <= players)
  {
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("ConvertToPlayer"+j));
  }
   if(i == 1)
  {
   rmAddTriggerEffect("Flare Minimap");
   rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParamFloat("Duration", 30.0);
   rmSetTriggerEffectParam("Position", xsVectorGetX(wagonPosition) + ",0," + xsVectorGetZ(wagonPosition));
   rmSetTriggerEffectParam("Flash", "true");
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\sparkle.mp3");
   rmAddTriggerEffect("FadeOutMusic"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("MessageSound"));
 }
   for(i=1; <= players)
 {
   word = "found"; pick = rmRandInt(1,3); if(pick == 2) word = "discovered"; if(pick == 3) word = "located";
   if(i == 1) messageText = "You ";
   if(i != 1 && rmGetPlayerTeam(i) == 0) messageText = "Your ally, " + rmGetPlayerName(i) + ", ";
   if(i != 1 && rmGetPlayerTeam(i) == 1) messageText = "Your enemy, " + rmGetPlayerName(i) + ", ";
   if(bonusUnitName == "explorer") messageText = messageText + word + " a stranded explorer and he has joined forces with his liberator.";
   if(bonusUnitName == "warchief") messageText = messageText + word + " a stranded warchief and he has joined forces with his liberator.";
   if(bonusUnitName == "canoe") messageText = messageText + word + " a lost canoe and it will help its new owner explore faster.";
   if(bonusUnitName == "surgeon") messageText = messageText + word + " a stranded surgeon and he will heal the forces of his liberator.";
   if(bonusUnitName == "medicine man") messageText = messageText + word + " and helped a lost medicine man who has allied with his liberator.";
   if(bonusUnitName == "privateer") messageText = messageText + word + " and helped a sinking pirate ship that has allied with its savior.";
   if(bonusUnitName == "war canoe") messageText = messageText + word + " and helped a lost war canoe that has allied with its savior.";
   if(bonusUnitName == "flat boat") messageText = messageText + word + " and helped a sinking flat boat that has allied with its savior.";
   if(bonusUnitName == "tlaloc canoe") messageText = messageText + word + " and helped a sinking tlaloc canoe that has allied with its savior.";

   if(i == 1) messageText = messageText + " See the minimap flare.";
   rmSwitchToTrigger(rmTriggerID("UnitToPlayer"+i));
   rmSetTriggerActive(true);
   rmAddTriggerCondition("Units In LOS");
   rmSetTriggerConditionParamInt("SrcObject", bonusUnitSelect);
   rmSetTriggerConditionParamInt("PlayerID", i);
   rmAddTriggerEffect("Convert");
   rmSetTriggerEffectParamInt("SrcObject", bonusUnitSelect);
   rmSetTriggerEffectParamInt("PlayerID", i);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   if(bonusUnitType == "canoe" || bonusUnitType == "privateer") { rmAddTriggerEffect("Sound Filename");
   rmSetTriggerEffectParam("Sound", "\cinematics\03 A\BoatWater3.mp3"); }
   if(i == 1)
  {
   rmAddTriggerEffect("Flare Minimap");
   rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParamFloat("Duration", 30.0);
   rmSetTriggerEffectParam("Position", xsVectorGetX(bonusUnitPosition) + ",0," + xsVectorGetZ(bonusUnitPosition));
   rmSetTriggerEffectParam("Flash", "true");
  }
   for(j=1; <= players)
   {
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("UnitToPlayer"+j));
   }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\sparkle.mp3");
   rmAddTriggerEffect("FadeOutMusic"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("MessageSound"));
  }
// I7.13  Sound triggers

   rmSwitchToTrigger(rmTriggerID("MessageSound")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 3);
   rmAddTriggerEffect("Music Stop");
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\20 B\Music.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("DelayMusic20"));

   rmSwitchToTrigger(rmTriggerID("Sound1")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 3);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\05 B\Music1.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("DefaultLighting"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("DelayMusic20"));

   rmSwitchToTrigger(rmTriggerID("Sound2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 3);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\11 b\Music 2.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("DelayMusic20"));

   rmSwitchToTrigger(rmTriggerID("Sound3")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 3);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\18 A\Music1.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("DelayMusic20"));

   rmSwitchToTrigger(rmTriggerID("Sound4")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 3);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\18 A\Music2.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("DelayMusic30"));

   rmSwitchToTrigger(rmTriggerID("Sound5")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 3);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\12 b\Marching 2.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("DelayMusic20"));

   rmSwitchToTrigger(rmTriggerID("Sound6")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 3);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\17 A\Music.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("DelayMusic30"));

   rmSwitchToTrigger(rmTriggerID("DelayMusic20")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 20);
   rmAddTriggerEffect("Music Play");

   rmSwitchToTrigger(rmTriggerID("DelayMusic30")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Music Play");

// I7.14 Miscellanous triggers

   rmSwitchToTrigger(rmTriggerID("DefaultLighting")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 20);
   rmAddTriggerEffect("Set Lighting"); rmSetTriggerEffectParam("SetName", lightingType); rmSetTriggerEffectParamFloat("FadeTime", 5.0);

// Check difficulty level and grant player 1 extra resources for expert if player's team is outnumbered and if not multiplayer.

   if(multiPlayerFlag == false && useExpertBonusFlag == true && allies < enemies)
 {
   int tribute = 15;
   rmSwitchToTrigger(rmTriggerID("DifficultyExpert")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Difficulty Level");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Level", 3);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TributeMessage"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Tribute"));

   messageText = "Since you are out numbered and playing on Expert, the natives are giving you a trickle of " + tribute + " of each resource every minute.";
   rmSwitchToTrigger(rmTriggerID("TributeMessage")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 60);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
 
   rmSwitchToTrigger(rmTriggerID("Tribute")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 60);
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "wood"); rmSetTriggerEffectParamInt("Amount", tribute);
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "food"); rmSetTriggerEffectParamInt("Amount", tribute);
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "gold"); rmSetTriggerEffectParamInt("Amount", tribute);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\09 a\Natives.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TributeDelay"));

   rmSwitchToTrigger(rmTriggerID("TributeDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 60);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Tribute"));
 }
// Player settler population triggers

   messageText = "By now; you should be taking advantage of any enemy weaknesses and/or bolstering any ally weaknesses.";
   rmSwitchToTrigger(rmTriggerID("PopCountStart")); rmSetTriggerActive(true);
   int weaknessTime = 1380; if(rmGetNomadStart() == true) weaknessTime = 1440;
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", weaknessTime);
   if(displayMessageFlag == true) 
 { rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
 }
   if(useSpoofChatFlag == true)
 { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\sparkle.mp3");
   rmAddTriggerEffect("FadeOutMusic"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Sound5"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("FactoryWood")); 
   for(i=1; <= players)
 { rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("PlayerSettlers"+i));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Decimated"+i));
 }
   for(i=1; <= players)
{
   words = "low on villagers"; pick = rmRandInt(1,3); if(pick == 2) words = "vulnerable"; if(pick == 3) words = "progressing slowly";
   word = "could"; pick = rmRandInt(1,3); if(pick == 2) word = "might"; if(pick == 3) word = "would";
   if(i == 1) messageText = "You are " + words + " and " + word + " be wise do something before an enemy takes advantage.";
   if(i != 1) messageText = "The natives say that " + rmGetPlayerName(i) + " is " + words + ", see minimap flare. It " + word + " be wise to ";
   if(i != 1 && rmGetPlayerTeam(i) == 0) messageText = messageText + "send assistance.";
   if(rmGetPlayerTeam(i) > 0) messageText = messageText + "press the advantage.";
   rmSwitchToTrigger(rmTriggerID("PlayerSettlers"+i)); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30*i); // Seperates triggers in case more than one is true when activated.
   rmAddTriggerCondition("Player Active"); // Should prevent message after player is dead before trigger is activated.
   rmSetTriggerConditionParamInt("PlayerID", i);
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", i);
   rmSetTriggerConditionParam("ProtoUnit", "Settler"); // Covers most players.
   rmSetTriggerConditionParam("Op", "<"); rmSetTriggerConditionParamInt("Count", 40);
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", i);
   rmSetTriggerConditionParam("ProtoUnit", "SettlerNative"); // Covers natives.
   rmSetTriggerConditionParam("Op", "<"); rmSetTriggerConditionParamInt("Count", 40);
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", i);
   rmSetTriggerConditionParam("ProtoUnit", "SettlerWagon"); // For German.
   rmSetTriggerConditionParam("Op", "<"); rmSetTriggerConditionParamInt("Count", 5); // Not sure of this amount.
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", i);
   rmSetTriggerConditionParam("ProtoUnit", "Coureur"); // For French. 
   rmSetTriggerConditionParam("Op", "<"); rmSetTriggerConditionParamInt("Count", 36);
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", i);
   rmSetTriggerConditionParam("ProtoUnit", "FishingBoat"); // In case a player(human?) goes heavy on fishing boats instead of settlers (happened to me).
   rmSetTriggerConditionParam("Op", "<"); rmSetTriggerConditionParamInt("Count", 6); // Not sure of this amount or if it works.

   if(i != 1)
  {
   rmAddTriggerEffect("Flare Minimap");
   rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParamFloat("Duration", 30.0);
   if(i == 2) rmSetTriggerEffectParam("Position", rmXFractionToMeters(p2x) + ",0," + rmZFractionToMeters(p2z));
   if(i == 3) rmSetTriggerEffectParam("Position", rmXFractionToMeters(p3x) + ",0," + rmZFractionToMeters(p3z));
   if(i == 4) rmSetTriggerEffectParam("Position", rmXFractionToMeters(p4x) + ",0," + rmZFractionToMeters(p4z));
   if(i == 5) rmSetTriggerEffectParam("Position", rmXFractionToMeters(p5x) + ",0," + rmZFractionToMeters(p5z));
   if(i == 6) rmSetTriggerEffectParam("Position", rmXFractionToMeters(p6x) + ",0," + rmZFractionToMeters(p6z));
   if(i == 7) rmSetTriggerEffectParam("Position", rmXFractionToMeters(p7x) + ",0," + rmZFractionToMeters(p7z));
   if(i == 8) rmSetTriggerEffectParam("Position", rmXFractionToMeters(p8x) + ",0," + rmZFractionToMeters(p8z));
   rmSetTriggerEffectParam("Flash", "true");
  }
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("FadeOutMusic"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   if(rmGetPlayerTeam(i) == 0) { rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Sound3")); }
   if(rmGetPlayerTeam(i) == 1) { rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Sound4")); }
 }
   messageText = "The natives are worried and say that there are less than " + 5*players + " trees left on the entire map.";
   rmSwitchToTrigger(rmTriggerID("TreesLeft"));
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", treeType);
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 5*players);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\mumble.mp3");

   rmSwitchToTrigger(rmTriggerID("GoldStart")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "minegold");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("GoldLeft"));
 
   messageText = "The natives are worried and say that there are no gold mines left on entire map.";
   rmSwitchToTrigger(rmTriggerID("GoldLeft")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "minegold");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\mumble.mp3");

   messageText = "The natives are worried and say that there are no ";
   if(mineType == "mine") messageText = messageText + "silver";
   if(mineType == "mineCopper") messageText = messageText + "copper";
   messageText = messageText + " mines left on the entire map.";
   rmSwitchToTrigger(rmTriggerID("MinesLeft"));
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", mineType);
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\mumble.mp3");

   messageText = "The natives are worried and say that there are less than " + 2*players + " schools of fish left on the entire map.";
   rmSwitchToTrigger(rmTriggerID("FishLeft"));
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", fishType);
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 2*players);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\mumble.mp3");

   if(usePiratesFlag == true)
 {
   messageText = "Friendly natives are glad to say that all the pirate ships have been destroyed.";
   rmSwitchToTrigger(rmTriggerID("PiratesLeft"));
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "privateer");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\mumble.mp3");
 }

   rmSwitchToTrigger(rmTriggerID("OwnTheWorld")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Player Resource Count"); rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "wood"); rmSetTriggerConditionParam("Op", ">"); rmSetTriggerConditionParamInt("Count", ossuaryAmount + 2*incrementAmount);
   rmAddTriggerCondition("Player Resource Count"); rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "food"); rmSetTriggerConditionParam("Op", ">"); rmSetTriggerConditionParamInt("Count", ossuaryAmount + 2*incrementAmount);
   rmAddTriggerCondition("Player Resource Count"); rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "gold"); rmSetTriggerConditionParam("Op", ">"); rmSetTriggerConditionParamInt("Count", ossuaryAmount + 2*incrementAmount);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("OwnTheWorldDelay"));

   messageText = "Very good! " + rmGetPlayerName(1) + " dominates the map. The white buffalo is yours. Sacrifice it and win. Quest Info is now disabled.";
   rmSwitchToTrigger(rmTriggerID("OwnTheWorldDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 20);
   rmAddTriggerEffect("FadeOutMusic"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\sparkle.mp3");
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   messageText = "Sacrifice the buffalo to win.";
   rmAddTriggerEffect("FakeCounter Set Text");
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Convert");
   rmSetTriggerEffectParamInt("SrcObject", buffaloSelect);
   rmSetTriggerEffectParamInt("PlayerID", 1);
   messageText = "Sacrifice the buffalo to win.";
   rmAddTriggerEffect("FakeCounter Set Text");
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Sound6"));

   messageText = "You survived and prospered. Thanks for playing my random map. I hope you enjoyed it. Created by: Bill Wolpert";
   rmSwitchToTrigger(rmTriggerID("Credits")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Dogleg Islands Credits");
   rmSetTriggerEffectParam("Text", messageText);

   int postReward = rmRandInt(1,2);
   messageText = "You have 1 trading post. Build 5 trading posts and receive a reward.";
   if(useLoneWolfFlag == false) messageText = messageText + " Of course there is only room for 4 on your island.";
   if(useLoneWolfFlag == true) messageText = messageText + " Of course all the other spots are on other islands.";
   rmSwitchToTrigger(rmTriggerID("TradingPost1")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TradingPost");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\whoosh.mp3");

   messageText = "You have 4 trading posts. Build 1 more and receive a ";
   if(postReward == 1) messageText = messageText + "5,000 coin reward.";
   if(postReward == 2) messageText = messageText + "fleet of fireships.";
   if(FFAFlag == false) messageText = messageText +  " Remember allies like to build trading posts.";
   rmSwitchToTrigger(rmTriggerID("TradingPost2")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TradingPost");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 3);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\whoosh.mp3");

   messageText = "Good! You have 5 trading posts. ";
   if(postReward == 1) messageText = messageText +  "You have received your 5,000 coin reward. A quest completed and 500 more XP.";
   if(postReward == 2) messageText = messageText +  "Your fireships are near you water flag. See the minimap flare";
   rmSwitchToTrigger(rmTriggerID("TradingPost3")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TradingPost");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 4);
   rmAddTriggerEffect("Quest Var Modify"); rmSetTriggerEffectParam("QVName", questsComplete); 
   rmSetTriggerEffectParam("Oper", "+"); rmSetTriggerEffectParam("Value", "1");
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "XP"); rmSetTriggerEffectParamInt("Amount", 500);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   if(postReward == 1) 
 {
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "gold"); rmSetTriggerEffectParamInt("Amount", 5000);
 }
   if(postReward == 2) 
 {
   rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 1); rmSetTriggerEffectParam("ProtoName", "SPCFireship");
   rmSetTriggerEffectParam("Location", (xsVectorGetX(waterFlag1)+10) + ",0," + (xsVectorGetZ(waterFlag1)+10));
   rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 1); rmSetTriggerEffectParam("ProtoName", "SPCFireship");
   rmSetTriggerEffectParam("Location", (xsVectorGetX(waterFlag1)-10) + ",0," + (xsVectorGetZ(waterFlag1)-10));
   rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 1); rmSetTriggerEffectParam("ProtoName", "SPCFireship");
   rmSetTriggerEffectParam("Location", (xsVectorGetX(waterFlag1)+10) + ",0," + (xsVectorGetZ(waterFlag1)-10));
   rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 1); rmSetTriggerEffectParam("ProtoName", "SPCFireship");
   rmSetTriggerEffectParam("Location", (xsVectorGetX(waterFlag1)-10) + ",0," + (xsVectorGetZ(waterFlag1)+10));
   rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 1); rmSetTriggerEffectParam("ProtoName", "SPCFireship");
   rmSetTriggerEffectParam("Location", (xsVectorGetX(waterFlag1)) + ",0," + (xsVectorGetZ(waterFlag1)+14));
   rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 1); rmSetTriggerEffectParam("ProtoName", "SPCFireship");
   rmSetTriggerEffectParam("Location", (xsVectorGetX(waterFlag1)+14) + ",0," + (xsVectorGetZ(waterFlag1)));
   rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 1); rmSetTriggerEffectParam("ProtoName", "SPCFireship");
   rmSetTriggerEffectParam("Location", (xsVectorGetX(waterFlag1)) + ",0," + (xsVectorGetZ(waterFlag1)-14));
   rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 1); rmSetTriggerEffectParam("ProtoName", "SPCFireship");
   rmSetTriggerEffectParam("Location", (xsVectorGetX(waterFlag1)-14) + ",0," + (xsVectorGetZ(waterFlag1)));
   rmAddTriggerEffect("Flare Minimap"); rmSetTriggerEffectParamInt("PlayerID", 1); rmSetTriggerEffectParamFloat("Duration", 30.0);
   rmSetTriggerEffectParam("Position", (xsVectorGetX(waterFlag1)) + ",0," + (xsVectorGetZ(waterFlag1)));
   rmSetTriggerEffectParam("Flash", "true");
 }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\whoosh.mp3");
 
 // Quest information triggers.

   messageText = "Clicking the white buffalo starts the quest info sequence. The game clock has stopped. Click OK after reading each quest.";
   rmSwitchToTrigger(rmTriggerID("QuestStart1")); rmSetTriggerActive(true); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo");
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); rmSetTriggerConditionParam("Op", ">"); rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Quest Info Beginning");
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Music Filename"); rmSetTriggerEffectParam("Music", "\dogleg sounds\nevermind.mp3"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\shadesarrive.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestsDoneDelay"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestDelay1"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest11"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest12"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest13"));

   messageText = "Clicking the buffalo starts the quest sequence. You can press pause to quickly end the sequence. Click OK after each quest.";
   rmSwitchToTrigger(rmTriggerID("QuestStart2")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo");
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); rmSetTriggerConditionParam("Op", ">"); rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Quest Info Start Up");
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("PlayNextMusicTrack");
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\shadesarrive.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestsDoneDelay"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestDelay2"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest11"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest12"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest13"));
   messageText = "Each quest status is shown, one at a time, as Info, Started or Complete with a count at the end. Click OK after each quest.";
   rmSwitchToTrigger(rmTriggerID("QuestStart3")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo");
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); rmSetTriggerConditionParam("Op", ">"); rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); rmSetTriggerConditionParam("Op", ">"); rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Quest Info Prologue");
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("PlayNextMusicTrack");
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\shadesarrive.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestsDoneDelay"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestDelay2"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest11"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest12"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest13"));

   messageText = "No quest for this spot.";
   rmSwitchToTrigger(rmTriggerID("Quest11")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   if(useNuggetBonusFlag == true)
 {
   messageText = "Collect " + nuggetTotal + " treasures and receive a bonus "
   + nuggetBoatName + " near your water flag. A treasure countdown is used to show progress.";
   rmAddTriggerCondition("Number Of Nuggets Collected");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Op", "==");
   rmSetTriggerConditionParamInt("NumberOfNuggets", 0);
 }
   if(rmGetNomadStart())
 {
   messageText = "Have your ";
   if(rmGetPlayerCiv(1) < 10) messageText = messageText  + "explorer";
   if(rmGetPlayerCiv(1) > 10) messageText = messageText  + "warchief";
   messageText = messageText  + " and settlers get wood. Then have your ";
   if(rmGetPlayerCiv(1) < 10)messageText = messageText  + "explorer";
   if(rmGetPlayerCiv(1) > 10)messageText = messageText  + "warchief";
   messageText = messageText  + " build a town center. You might need to build a market first.";
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TownCenter");
   rmSetTriggerConditionParam("Op", "==");
   rmSetTriggerConditionParamInt("Count", 0);
 }
   rmAddTriggerEffect("Show SPC Note");
   if(useNuggetBonusFlag == true) rmSetTriggerEffectParam("Title", "Treasure Quest Info");
   if(rmGetNomadStart()) rmSetTriggerEffectParam("Title", "Wood Quest Info");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\magic.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest12"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest13"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest21"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest22"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest23"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest24"));

   rmSwitchToTrigger(rmTriggerID("Quest12")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   if(useNuggetBonusFlag == true)
 {
 //              "------- Maximum message length ---- copy this line and paste it near the line you are testing ---------------------------------"
   messageText = "You started collecting treasures. See/click the treasure countdown/tent to see the treasures needed for your bonus "
   + nuggetBoatName + ".";
   rmAddTriggerCondition("Number Of Nuggets Collected");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("NumberOfNuggets", 0);
   rmAddTriggerCondition("Number Of Nuggets Collected");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("NumberOfNuggets", nuggetTotal);
 }
   if(rmGetNomadStart())
 {
   messageText = "You have gathered wood and started your settlement with a town center; but you need ";
   if(rmGetPlayerCiv(1) < 10) messageText = messageText  + "a capitol";
   if(rmGetPlayerCiv(1) > 10) messageText = messageText  + "3 town centers";
   messageText = messageText  + " to establish your empire.";
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TownCenter");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   if(rmGetPlayerCiv(1) < 10)
  {
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "Capitol");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
  }
   if(rmGetPlayerCiv(1) > 10)
  {
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TownCenter");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 3);
  }
 }
   rmAddTriggerEffect("Show SPC Note");
   if(useNuggetBonusFlag == true) rmSetTriggerEffectParam("Title", "Treasure Quest Started");
   if(rmGetNomadStart()) rmSetTriggerEffectParam("Title", "Wood Quest Started");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\magic.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest11"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest13"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest21"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest22"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest23"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest24"));

   rmSwitchToTrigger(rmTriggerID("Quest13")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   if(useNuggetBonusFlag == true)
 {
   messageText = "You have collected the required number of treasures and received your bonus " + nuggetBoatName + ".";
   rmAddTriggerCondition("Number Of Nuggets Collected");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Op", ">=");
   rmSetTriggerConditionParamInt("NumberOfNuggets", nuggetTotal);
 }
   if(rmGetNomadStart())
 {
   messageText = "You have gathered wood and started your settlement with a town center ";
   if(rmGetPlayerCiv(1) < 10) messageText = messageText + "and erected a capitol";
   if(rmGetPlayerCiv(1) > 10) messageText = messageText + "and erected two more";
   messageText = messageText + ". Your empire is well established.";
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TownCenter");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   if(rmGetPlayerCiv(1) < 10)
  {
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "Capitol");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
  }
   if(rmGetPlayerCiv(1) > 10)
  {
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TownCenter");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 2);
  }
 }
   rmAddTriggerEffect("Show SPC Note"); 
   if(useNuggetBonusFlag == true) rmSetTriggerEffectParam("Title", "Treasure Quest Complete");
   if(rmGetNomadStart()) rmSetTriggerEffectParam("Title", "Wood Quest Complete");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\magic.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest11"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest12"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest21"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest22"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest23"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest24"));
 
   messageText = "Build 5 trading posts and receive a reward (coin or fireships). There is a message notice when 1 and then 4 posts are built.";
   rmSwitchToTrigger(rmTriggerID("Quest21")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances. 
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TradingPost");
   rmSetTriggerConditionParam("Op", "==");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Trading Post Quest Info"); 
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\build.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest22"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest23"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest24"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest31"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest32"));

   messageText = "You have started building your trading posts but you need to build 5 to get your reward (5,000 coin or a fleet of fireships).";
   rmSwitchToTrigger(rmTriggerID("Quest22")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances. 
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TradingPost");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TradingPost");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 4);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Trading Post Quest Started"); 
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\build.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest21"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest23"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest24"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest31"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest32"));

   messageText = "You have constructed 4 trading post and only need 1 more to get your reward (5,000 coin or a fleet of fireships)."; 
   rmSwitchToTrigger(rmTriggerID("Quest23")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TradingPost");
   rmSetTriggerConditionParam("Op", "==");
   rmSetTriggerConditionParamInt("Count", 4);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Trading Post Quest Alert"); 
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\build.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest21"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest22"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest24"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest31"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest32"));

   if(postReward == 1) messageText = "You have already received the 5,000 coin for building 5 trading posts.";
   if(postReward == 2) messageText = "You have already received the fleet of fireships for building 5 trading posts.";
   rmSwitchToTrigger(rmTriggerID("Quest24")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances. 
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TradingPost");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 4);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Trading Post Quest Complete");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   if(postReward == 1) { rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\build.mp3"); }
   if(postReward == 2) { rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\FireShipApproach.mp3"); }
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest21"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest22"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest23"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest31"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest32"));

   if(useBonusCratesFlag == false) messageText = "There is no use trying to search for pirate loot on any small islands on this map.";
   if(useBonusCratesFlag == true) messageText = "Search the small islands for the plunder that the pirates have scattered around (crates of either wood, food or coin).";
   rmSwitchToTrigger(rmTriggerID("Quest31")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", crateType);
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Pirate Booty Quest Info");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\sparkle.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest32"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest41"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest42"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest43"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest44"));

   if(useBonusCratesFlag == true) 
 { messageText = "You have found all the pirate plunder of " + crateName + " on the small islands. On some small maps they don't hide any.";
 }
   rmSwitchToTrigger(rmTriggerID("Quest32")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", crateType);
   rmSetTriggerConditionParam("Op", "==");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Pirate Booty Quest Complete");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\sparkle.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest31"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest41"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest42"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest43"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest44"));

   if(bonusUnitType != "privateer") messageText = "Search on or near the small islands for a lost " + wagonName + " and " 
   + bonusUnitName + " that will join the side that finds them first.";
   if(bonusUnitType == "privateer") messageText = "Search the small islands for a lost " + wagonName + 
   " that will join the side that finds it first and convert/sink all privateers.";
   rmSwitchToTrigger(rmTriggerID("Quest41")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", bonusUnitType);
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", wagonType);
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Lost Unit Quest Info");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\mirrortower.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest42"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest43"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest44"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest51"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest52"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest53"));

   if(bonusUnitType != "privateer") messageText = "The " + bonusUnitName + " has been converted but the " 
   + wagonName + " has not been converted yet.";
   if(bonusUnitType == "privateer") messageText = "All the privateers has been converted and/or sunk but the " 
   + wagonName + " has not been converted yet.";
   rmSwitchToTrigger(rmTriggerID("Quest42")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", bonusUnitType);
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", wagonType);
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Lost Unit Quest Started");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\mirrortower.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest41"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest43"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest44"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest51"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest52"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest53"));

   if(bonusUnitType != "privateer") messageText = "The " + wagonName + " has been converted but the " 
    + bonusUnitName + " has not been converted yet.";
   if(bonusUnitType == "privateer") messageText = "The " + wagonName + 
   " has been converted but not all the privateers have been converted and /or sunk."; 
   rmSwitchToTrigger(rmTriggerID("Quest43")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", bonusUnitType);
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", wagonType);
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Lost Unit Quest Started");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\mirrortower.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest41"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest42"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest44"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest51"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest52"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest53"));

   if(bonusUnitType != "privateer") messageText = "Both the " + bonusUnitName + " and the " 
   + wagonName + " have been converted by someone.";
   if(bonusUnitType == "privateer") messageText = "The " 
   + wagonName + " and all the privateers have been converted and/or sunk by someone.";
   rmSwitchToTrigger(rmTriggerID("Quest44")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", bonusUnitType);
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", wagonType);
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Lost Unit Quest Complete");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\mirrortower.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest41"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest42"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest43"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest51"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest52"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest53"));

   messageText = "Take your quest " + questHerdableType + " to the quest livestock pen located on one of the small islands to get bonus " + questHerdableType;
   if(questHerdableType != "sheep") messageText = messageText + "s";
   messageText = messageText + ".";
   rmSwitchToTrigger(rmTriggerID("Quest51")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "LivestockPen");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Herdable Quest Info");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\heykrios.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest52"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest53"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest61"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest62"));

   messageText = "You took your quest " + questHerdableType + " to the quest livestock pen and are getting bonus " + questHerdableType;
   if(questHerdableType != "sheep") messageText =  messageText + "s";
   messageText = messageText + ". Collect 5 or more to complete this quest.";
   rmSwitchToTrigger(rmTriggerID("Quest52")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "LivestockPen");
   rmSetTriggerConditionParam("Op", "==");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "Horse");
   rmSetTriggerConditionParam("Op", "==");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Herdable Quest Started");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\heykrios.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest51"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest53"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest61"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest62"));

   messageText = "You have collected at least 5 quest " + questHerdableType;
   if(questHerdableType != "sheep") messageText = messageText + "s";
   messageText = messageText + " and have completed this quest.";
   rmSwitchToTrigger(rmTriggerID("Quest53")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "LivestockPen");
   rmSetTriggerConditionParam("Op", "==");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "Horse");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Herdable Quest Complete");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\heykrios.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest51"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest52"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest61"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest62"));

   messageText = "Destroy the war hut located on one of the small islands and receive the resources inside (1000 to 2000 wood, food, or coin).";
   rmSwitchToTrigger(rmTriggerID("Quest61")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCCherokeeWarHut");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "War Hut Quest Info");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\stingfade.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest62"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest71"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest72"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest73"));

   messageText = "The war hut has been destroyed and you have already received the " + rewardAmount + " " + rewardName + " inside.";
   rmSwitchToTrigger(rmTriggerID("Quest62")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances. 
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCCherokeeWarHut");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "War Hut Quest Complete");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\stingfade.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest61"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest71"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest72"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest73"));

   messageText = "There is usually a BFG(Big Fixed Gun) on one of the small islands. Capture it to defend a large area to have a secure location.";
   rmSwitchToTrigger(rmTriggerID("Quest71")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCFixedGun");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "BFG Quest Info");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\menacing thing.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest72"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest73"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest81"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest82"));

   messageText = "You found and converted the BFG (BigFixed Gun) to your control. Defend your new area well.";
   rmSwitchToTrigger(rmTriggerID("Quest72")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "SPCFixedGun");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "BFG Quest Complete");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\menacing thing.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest71"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest73"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest81"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest82"));

   messageText = "There is not a BFG (Big Fixed Gun) on any of the small islands of this map.";
   rmSwitchToTrigger(rmTriggerID("Quest73")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCFixedGun");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "SPCFixedGun");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "BFG Quest Complete");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\menacing thing.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest71"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest72"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest81"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest82"));

   messageText = "Destroy the ossuary located on one of the small islands and all players will receive " + ossuaryAmount + " in food, wood, and coin.";
   rmSwitchToTrigger(rmTriggerID("Quest81")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCOssuary");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Ossuary Quest Info");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\jerrygarcia.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest82"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest911"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest912"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest913"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest92"));

   messageText = "The small island ossuary has been destroyed and all players have received " + ossuaryAmount + " in food, wood, and coin.";
   rmSwitchToTrigger(rmTriggerID("Quest82")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCOssuary");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Ossuary Quest Complete");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\jerrygarcia.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest81"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest911"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest912"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest913"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest92"));

   messageText = "Build your empire, collect over " + (ossuaryAmount + incrementAmount) + " of each resource and dominate the region.";
   rmSwitchToTrigger(rmTriggerID("Quest911")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Resource Count"); 
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "wood");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", ossuaryAmount + incrementAmount); 
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Empire Quest Info");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\boyz.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest912"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest913"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest92"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd0"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd1"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd3"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd4"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd5"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd6"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd7"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd8"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd9"));

   messageText = "Build your empire, collect over " + (ossuaryAmount + incrementAmount) + " of each resource and dominate the region.";
   rmSwitchToTrigger(rmTriggerID("Quest912")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Resource Count"); 
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "food");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", ossuaryAmount + incrementAmount); 
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Empire Quest Info");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\boyz.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest911"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest913"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest92"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd0"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd1"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd3"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd4"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd5"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd6"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd7"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd8"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd9"));

   messageText = "Build your empire, collect over " + (ossuaryAmount + incrementAmount) + " of each resource and dominate the region.";
   rmSwitchToTrigger(rmTriggerID("Quest913")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Player Resource Count"); 
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "gold");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", ossuaryAmount + incrementAmount); 
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Empire Quest Info");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\boyz.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest911"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest912"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest92"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd0"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd1"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd3"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd4"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd5"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd6"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd7"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd8"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd9"));

   messageText = "You have collected over " + (ossuaryAmount + incrementAmount) + " of each resource. Now collect " + (ossuaryAmount + 2*incrementAmount) + " and you can win the game without firing another shot.";
   rmSwitchToTrigger(rmTriggerID("Quest92")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances. 
   rmAddTriggerCondition("Player Resource Count"); 
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "wood");
   rmSetTriggerConditionParam("Op", ">=");
   rmSetTriggerConditionParamInt("Count", ossuaryAmount + incrementAmount);
   rmAddTriggerCondition("Player Resource Count"); 
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "food");
   rmSetTriggerConditionParam("Op", ">=");
   rmSetTriggerConditionParamInt("Count", ossuaryAmount + incrementAmount);
   rmAddTriggerCondition("Player Resource Count"); 
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "gold");
   rmSetTriggerConditionParam("Op", ">=");
   rmSetTriggerConditionParamInt("Count", ossuaryAmount + incrementAmount);
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Empire Quest Complete");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\boyz.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest911"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest912"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Quest913"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd0"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd1"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd3"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd4"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd5"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd6"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd7"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd8"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd9"));

   messageText = "End of quest info sequence. Click the white buffalo again later to repeat. Click OK and DESELECT the buffalo now.";
   rmSwitchToTrigger(rmTriggerID("QuestEnd0")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Quest Var Check"); rmSetTriggerConditionParam("QuestVar", questsComplete);
   rmSetTriggerConditionParam("Op", "=="); rmSetTriggerConditionParam("Value", "0");
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Quest Information Finished");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\low note.mp3");
   rmAddTriggerEffect("Music Filename"); rmSetTriggerEffectParam("Music", "\music\standard\Muptop.mp3"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd3"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd4"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd5"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd6"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd7"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd8"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd9"));

   messageText = "End of quest info sequence. 8 of 9 quests are not complete. Click OK and DESELECT the buffalo now.";
   rmSwitchToTrigger(rmTriggerID("QuestEnd1")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Quest Var Check"); rmSetTriggerConditionParam("QuestVar", questsComplete);
   rmSetTriggerConditionParam("Op", "=="); rmSetTriggerConditionParam("Value", "1");
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Quest Information Finished");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\low note.mp3");
   rmAddTriggerEffect("Music Filename"); rmSetTriggerEffectParam("Music", "\music\standard\Muptop.mp3"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd0"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd3"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd4"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd5"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd6"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd7"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd8"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd9"));

   messageText = "End of quest info sequence. 7 of 9 quests are not complete. Click OK and DESELECT the buffalo now.";
   rmSwitchToTrigger(rmTriggerID("QuestEnd2")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Quest Var Check"); rmSetTriggerConditionParam("QuestVar", questsComplete);
   rmSetTriggerConditionParam("Op", "=="); rmSetTriggerConditionParam("Value", "2");
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Quest Information Finished");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\low note.mp3");
   rmAddTriggerEffect("Music Filename"); rmSetTriggerEffectParam("Music", "\music\standard\Muptop.mp3"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd0"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd3"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd4"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd5"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd6"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd7"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd8"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd9"));

   messageText = "End of quest info sequence. 6 of 9 quests are not complete. Click OK and DESELECT the buffalo now.";
   rmSwitchToTrigger(rmTriggerID("QuestEnd3")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Quest Var Check"); rmSetTriggerConditionParam("QuestVar", questsComplete);
   rmSetTriggerConditionParam("Op", "=="); rmSetTriggerConditionParam("Value", "3");
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Quest Information Finished");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\low note.mp3");
   rmAddTriggerEffect("Music Filename"); rmSetTriggerEffectParam("Music", "\music\standard\Muptop.mp3"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd0"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd4"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd5"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd6"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd7"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd8"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd9"));

   messageText = "End of quest info sequence. 5 of 9 quests are not complete. Click OK and DESELECT the buffalo now.";
   rmSwitchToTrigger(rmTriggerID("QuestEnd4")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Quest Var Check"); rmSetTriggerConditionParam("QuestVar", questsComplete);
   rmSetTriggerConditionParam("Op", "=="); rmSetTriggerConditionParam("Value", "4");
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Quest Information Finished");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\low note.mp3");
   rmAddTriggerEffect("Music Filename"); rmSetTriggerEffectParam("Music", "\music\standard\Muptop.mp3"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd0"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd3"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd5"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd6"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd7"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd8"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd9"));

   messageText = "End of quest info sequence. 4 of 9 quests are not complete. Click OK and DESELECT the buffalo now.";
   rmSwitchToTrigger(rmTriggerID("QuestEnd5")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Quest Var Check"); rmSetTriggerConditionParam("QuestVar", questsComplete);
   rmSetTriggerConditionParam("Op", "=="); rmSetTriggerConditionParam("Value", "5");
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Quest Information Finished");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\low note.mp3");
   rmAddTriggerEffect("Music Filename"); rmSetTriggerEffectParam("Music", "\music\standard\Muptop.mp3"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd0"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd3"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd4"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd6"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd7"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd8"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd9"));

   messageText = "End of quest info sequence. 3 of 9 quests are not complete. Click OK and DESELECT the buffalo now.";
   rmSwitchToTrigger(rmTriggerID("QuestEnd6")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Quest Var Check"); rmSetTriggerConditionParam("QuestVar", questsComplete);
   rmSetTriggerConditionParam("Op", "=="); rmSetTriggerConditionParam("Value", "6");
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Quest Information Finished");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\low note.mp3");
   rmAddTriggerEffect("Music Filename"); rmSetTriggerEffectParam("Music", "\music\standard\Muptop.mp3"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd0"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd3"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd4"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd5"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd7"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd8"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd9"));

   messageText = "End of quest info sequence. 2 of 9 quests remain. Getting close. Click OK and DESELECT the buffalo now.";
   rmSwitchToTrigger(rmTriggerID("QuestEnd7")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Quest Var Check"); rmSetTriggerConditionParam("QuestVar", questsComplete);
   rmSetTriggerConditionParam("Op", "=="); rmSetTriggerConditionParam("Value", "7");
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Quest Information Finished");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\low note.mp3");
   rmAddTriggerEffect("Music Filename"); rmSetTriggerEffectParam("Music", "\music\standard\Muptop.mp3"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd0"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd3"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd4"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd5"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd6"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd8"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd9"));

   messageText = "End of quest info sequence. 1 of 9 quests remain. Almost done. Click OK and DESELECT the buffalo now.";
   rmSwitchToTrigger(rmTriggerID("QuestEnd8")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Quest Var Check"); rmSetTriggerConditionParam("QuestVar", questsComplete);
   rmSetTriggerConditionParam("Op", "=="); rmSetTriggerConditionParam("Value", "8");
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Quest Information Finished");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\low note.mp3");
   rmAddTriggerEffect("Music Filename"); rmSetTriggerEffectParam("Music", "\music\standard\Muptop.mp3"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd0"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd3"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd4"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd5"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd6"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd7"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd9"));

   messageText = "End of quest info sequence. All the quests are finally done. Click OK, review my credit, then DESELECT the buffalo.";
   rmSwitchToTrigger(rmTriggerID("QuestEnd9")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); // Should prevent false occurances.
   rmAddTriggerCondition("Quest Var Check"); rmSetTriggerConditionParam("QuestVar", questsComplete);
   rmSetTriggerConditionParam("Op", "=="); rmSetTriggerConditionParam("Value", "9");
   rmAddTriggerEffect("Show SPC Note"); rmSetTriggerEffectParam("Title", "Quest Information Finished");
   rmSetTriggerEffectParam("Text", messageText);
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\low note.mp3");
   rmAddTriggerEffect("Music Filename"); rmSetTriggerEffectParam("Music", "\music\standard\Muptop.mp3"); rmSetTriggerEffectParamFloat("Duration", 3.0);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd0"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd3"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd4"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd5"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd6"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd7"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestEnd8"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Credits"));

   rmSwitchToTrigger(rmTriggerID("QuestDelay1")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 15);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestStart2"));

   rmSwitchToTrigger(rmTriggerID("QuestDelay2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 15);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestStart3"));

// Player decimated triggers.
   for(i=2; <= players)
 {
   if(rmGetPlayerTeam(i) == 1) messageText = "Your enemy, " + rmGetPlayerName(i) + ", is defeated or decimated. Time to click the buffalo near your TC and review your quests.";
   if(rmGetPlayerTeam(i) == 0) messageText = "Your ally, " + rmGetPlayerName(i) + ", is defeated or decimated. Now might be a good time to review your options.";
   rmSwitchToTrigger(rmTriggerID("Decimated"+i)); rmSetTriggerActive(false);
   rmAddTriggerCondition("Player Unit Count");  rmSetTriggerConditionParamInt("PlayerID", i);
   rmSetTriggerConditionParam("ProtoUnit", "Settler"); // Covers most players.
   rmSetTriggerConditionParam("Op", "<"); rmSetTriggerConditionParamInt("Count", 10);
   rmAddTriggerCondition("Player Unit Count");  rmSetTriggerConditionParamInt("PlayerID", i);
   rmSetTriggerConditionParam("ProtoUnit", "SettlerNative"); // Covers natives.
   rmSetTriggerConditionParam("Op", "<"); rmSetTriggerConditionParamInt("Count", 10);
   rmAddTriggerCondition("Player Unit Count");  rmSetTriggerConditionParamInt("PlayerID", i);
   rmSetTriggerConditionParam("ProtoUnit", "Coureur"); // For French. 
   rmSetTriggerConditionParam("Op", "<"); rmSetTriggerConditionParamInt("Count", 8);

   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\shadesarrive.mp3");
 }
// End of game camera sequence.

   messageText = "Wait and watch for an eagle to fly ";
   if(rmGetNomadStart() == false) messageText = messageText + "to your starting town center.";
   if(rmGetNomadStart() == true)  messageText = messageText + "to where the white buffalo roamed.";
   messageText = messageText + " Then center the view on the eagle and wait for the tour.";
   rmSwitchToTrigger(rmTriggerID("Camera1")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 1);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", eagleSelect);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(p1x)+",0,"+rmZFractionToMeters(p1z));
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\shadesarrive.mp3");

   rmAddTriggerEffect("Counter:Add Timer"); rmSetTriggerEffectParam("Name", "EagleCounter");
   rmSetTriggerEffectParamInt("Start", size/18); rmSetTriggerEffectParamInt("Stop", 0);
   rmSetTriggerEffectParam("Msg", "Time until eagle tour");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove3"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Camera2"));

   rmSwitchToTrigger(rmTriggerID("Camera2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", size/18);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", eagleSelect);
   if(useLoneWolfFlag == false) rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(e1x)+",0,"+rmZFractionToMeters(e1z));
   if(useLoneWolfFlag == true && players == 3) rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(p3x)+",0,"+rmZFractionToMeters(p3z));
   if(useLoneWolfFlag == true && players == 5) rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(p5x)+",0,"+rmZFractionToMeters(p5z));
   if(useLoneWolfFlag == true && players == 7) rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(p7x)+",0,"+rmZFractionToMeters(p7z));
   rmAddTriggerEffect("Cinematic Mode"); rmSetTriggerEffectParam("Enter", "true");
   rmAddTriggerEffect("Camera Follow Unit");
   rmSetTriggerEffectParamInt("DstObject", eagleSelect); rmSetTriggerEffectParam("Enable", "true");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove3"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Camera3"));

   rmSwitchToTrigger(rmTriggerID("Camera3")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", size/18);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", eagleSelect);
   if(useLoneWolfFlag == false) rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(p2x)+",0,"+rmZFractionToMeters(p2z));
   if(useLoneWolfFlag == true) rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(p1x)+",0,"+rmZFractionToMeters(p1z));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove3"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Camera4"));

   rmSwitchToTrigger(rmTriggerID("Camera4")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", size/18);
   rmAddTriggerEffect("Camera Follow Unit"); rmSetTriggerEffectParamInt("DstObject", eagleSelect); rmSetTriggerEffectParam("Enable", "false");
   rmAddTriggerEffect("Cinematic Mode"); rmSetTriggerEffectParam("Enter", "false");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Camera5"));

   messageText = "The game is not over until the eagle stops flapping its wings. You can then select View Postgame or Quit in the game Menu.";
   rmSwitchToTrigger(rmTriggerID("Camera5")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 1);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
      rmAddTriggerEffect("Music Filename"); rmSetTriggerEffectParam("Music", "\dogleg sounds\behold.mp3"); rmSetTriggerEffectParamFloat("Duration", 3.0);

   rmSwitchToTrigger(rmTriggerID("CameraDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 10+size/5);
   rmAddTriggerEffect("Cinematic Mode"); rmSetTriggerEffectParam("Enter", "false");

   int buffaloTime = 20;
   int buffaloDistance = rmRandInt(8,15);
   rmSwitchToTrigger(rmTriggerID("Buffalo1")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", buffaloTime);
   rmAddTriggerEffect("Move To Point"); rmSetTriggerEffectParamInt("SrcObject", buffaloSelect);
   rmSetTriggerEffectParam("DstPoint", (rmXFractionToMeters(p1x) + buffaloDistance)+",0,"+(rmZFractionToMeters(p1z) + buffaloDistance));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Buffalo2"));

   rmSwitchToTrigger(rmTriggerID("Buffalo2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 3*buffaloTime);
   rmAddTriggerEffect("Move To Point"); rmSetTriggerEffectParamInt("SrcObject", buffaloSelect);
   rmSetTriggerEffectParam("DstPoint", (rmXFractionToMeters(p1x) + buffaloDistance)+",0,"+(rmZFractionToMeters(p1z) - buffaloDistance));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Buffalo3"));

   rmSwitchToTrigger(rmTriggerID("Buffalo3")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 4*buffaloTime);
   rmAddTriggerEffect("Move To Point"); rmSetTriggerEffectParamInt("SrcObject", buffaloSelect);
   rmSetTriggerEffectParam("DstPoint", (rmXFractionToMeters(p1x) - buffaloDistance)+",0,"+(rmZFractionToMeters(p1z) - buffaloDistance));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Buffalo4"));

   rmSwitchToTrigger(rmTriggerID("Buffalo4")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 5*buffaloTime);
   rmAddTriggerEffect("Move To Point"); rmSetTriggerEffectParamInt("SrcObject", buffaloSelect);
   rmSetTriggerEffectParam("DstPoint", (rmXFractionToMeters(p1x) - buffaloDistance)+",0,"+(rmZFractionToMeters(p1z) + buffaloDistance));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Buffalo1"));

   rmSwitchToTrigger(rmTriggerID("Win")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 20);
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); rmSetTriggerConditionParam("Op", "<"); rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "SPCWhiteBuffalo"); rmSetTriggerConditionParam("Op", "<"); rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerCondition("Player Resource Count"); rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "wood"); rmSetTriggerConditionParam("Op", ">"); rmSetTriggerConditionParamInt("Count", ossuaryAmount + 2*incrementAmount);
   rmAddTriggerCondition("Player Resource Count"); rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "food"); rmSetTriggerConditionParam("Op", ">"); rmSetTriggerConditionParamInt("Count", ossuaryAmount + 2*incrementAmount);
   rmAddTriggerCondition("Player Resource Count"); rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "gold"); rmSetTriggerConditionParam("Op", ">"); rmSetTriggerConditionParamInt("Count", ossuaryAmount + 2*incrementAmount);

   // Eye candy for cutscene.

     if(useLoneWolfFlag == false)
    { rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("ProtoName", "HotAirBalloon");
      rmSetTriggerEffectParam("Location", rmXFractionToMeters((p1x+e1x)/2)+",0,"+rmZFractionToMeters((p1z+e1z)/2));
      rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("ProtoName", "Rain");
      rmSetTriggerEffectParam("Location", rmXFractionToMeters((p1x+e1x)/2)+",0,"+rmZFractionToMeters((p1z+e1z)/2));
      rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("ProtoName", "SPCTentLarge");
      rmSetTriggerEffectParam("Location", rmXFractionToMeters((p1x+e1x)/2)+",0,"+rmZFractionToMeters((p1z+e1z)/2));
      rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 2); rmSetTriggerEffectParam("ProtoName", "HotAirBalloon");
      rmSetTriggerEffectParam("Location", rmXFractionToMeters((p2x+e1x)/2)+",0,"+rmZFractionToMeters((p2z+e1z)/2));
      rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("ProtoName", "SPCWagonAll");
      rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p2x+e1x)/2) + 9)+",0,"+(rmZFractionToMeters((p2z+e1z)/2) + 9));
      rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("ProtoName", "IGCKnifingScene");
      rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p2x+e1x)/2) - 9)+",0,"+(rmZFractionToMeters((p2z+e1z)/2) - 9));
      rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("ProtoName", "SPCSignalFireLit");
      rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p2x+e1x)/2) + 9)+",0,"+(rmZFractionToMeters((p2z+e1z)/2) - 9));
    }
      if(useLoneWolfFlag == true)
    { rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("ProtoName", "SPCTreasureShip");
      if(players == 3) rmSetTriggerEffectParam("Location", rmXFractionToMeters((p1x+p3x)/2)+",0,"+rmZFractionToMeters((p1z+p3z)/2));
      if(players == 5) rmSetTriggerEffectParam("Location", rmXFractionToMeters((p1x+p5x)/2)+",0,"+rmZFractionToMeters((p1z+p5z)/2));
      if(players == 7) rmSetTriggerEffectParam("Location", rmXFractionToMeters((p1x+p7x)/2)+",0,"+rmZFractionToMeters((p1z+p7z)/2));
      rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("ProtoName", "SPCFireship");
      if(players == 3) rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p1x+p3x)/2)+9)+",0,"+(rmZFractionToMeters((p1z+p3z)/2)+9));
      if(players == 5) rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p1x+p5x)/2)+9)+",0,"+(rmZFractionToMeters((p1z+p5z)/2)+9));
      if(players == 7) rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p1x+p7x)/2)+9)+",0,"+(rmZFractionToMeters((p1z+p7z)/2)+9));
      rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("ProtoName", "PropSwan");
      if(players == 3) rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p1x+p3x)/2)-9)+",0,"+(rmZFractionToMeters((p1z+p3z)/2)-9));
      if(players == 5) rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p1x+p5x)/2)-9)+",0,"+(rmZFractionToMeters((p1z+p5z)/2)-9));
      if(players == 7) rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p1x+p7x)/2)-9)+",0,"+(rmZFractionToMeters((p1z+p7z)/2)-9));
      rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("ProtoName", "IGCFishingBoat");
      if(players == 3) rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p1x+p3x)/2)+9)+",0,"+(rmZFractionToMeters((p1z+p3z)/2)-9));
      if(players == 5) rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p1x+p5x)/2)+9)+",0,"+(rmZFractionToMeters((p1z+p5z)/2)-9));
      if(players == 7) rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p1x+p7x)/2)+9)+",0,"+(rmZFractionToMeters((p1z+p7z)/2)-9));
      rmAddTriggerEffect("Unit Create"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("ProtoName", "SPCDinghy");
      if(players == 3) rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p1x+p3x)/2)-9)+",0,"+(rmZFractionToMeters((p1z+p3z)/2)+9));
      if(players == 5) rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p1x+p5x)/2)-9)+",0,"+(rmZFractionToMeters((p1z+p5z)/2)+9));
      if(players == 7) rmSetTriggerEffectParam("Location", (rmXFractionToMeters((p1x+p7x)/2)-9)+",0,"+(rmZFractionToMeters((p1z+p7z)/2)+9));
    }
   for(i=2; <= players) { if(rmGetPlayerTeam(i) == 1) { rmAddTriggerEffect("Set Player Defeated"); rmSetTriggerEffectParamInt("Player", i); } }
   rmAddTriggerEffect("FakeCounter Clear");
   rmAddTriggerEffect("Set Player Won"); rmSetTriggerEffectParamInt("Player", 1);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove2"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove3"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("WinDelay2"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Camera1"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("CameraDelay"));
 
   rmSwitchToTrigger(rmTriggerID("WinDelay2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", size/5);
   rmAddTriggerEffect("End Game");

   messageText = "All the pirate's hidden caches of " + crateName + " have been found and gathered. A quest completed and 400 more XP(Experience Points).";
   rmSwitchToTrigger(rmTriggerID("CratesGone")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 300);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", crateType);
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\sparkle.mp3");
   rmAddTriggerEffect("Quest Var Modify"); rmSetTriggerEffectParam("QVName", questsComplete); 
   rmSetTriggerEffectParam("Oper", "+"); rmSetTriggerEffectParam("Value", "1");
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "XP"); rmSetTriggerEffectParamInt("Amount", 400);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }

   rmSwitchToTrigger(rmTriggerID("BonusUnitsConverted")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 50);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", bonusUnitType);
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", wagonType);
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("BonusUnitsConvertedDelay"));

   messageText = "Both the lost " + wagonName  + " and the " + bonusUnitName + " have been converted. A quest completed and 300 more XP(Experience Points).";
   rmSwitchToTrigger(rmTriggerID("BonusUnitsConvertedDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Quest Var Modify"); rmSetTriggerEffectParam("QVName", questsComplete); 
   rmSetTriggerEffectParam("Oper", "+"); rmSetTriggerEffectParam("Value", "1");
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "XP"); rmSetTriggerEffectParamInt("Amount", 300);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\mirrortower.mp3");

   messageText = "You gained control of the BFG. A quest completed and 500 XP. See the Remaining Quests counter for the quests you have to do.";
   rmSwitchToTrigger(rmTriggerID("BFGConverted")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 10);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "SPCFixedGun");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerEffect("Quest Var Modify"); rmSetTriggerEffectParam("QVName", questsComplete); 
   rmSetTriggerEffectParam("Oper", "+"); rmSetTriggerEffectParam("Value", "1");
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "XP"); rmSetTriggerEffectParamInt("Amount", 500);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\menacing thing.mp3");

   if(rmGetNomadStart() == true)
 {
   messageText = "You have completed the Wood Quest by building ";
   if(rmGetPlayerCiv(1) < 10) messageText = messageText + "a capitol";
   if(rmGetPlayerCiv(1) > 10) messageText = messageText + "three town centers";
   messageText = messageText + " and have received 300 more XP.";
   rmSwitchToTrigger(rmTriggerID("WoodComplete")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 55);
   if(rmGetPlayerCiv(1) < 10)
  {
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TownCenter");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "Capitol");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
  }
   if(rmGetPlayerCiv(1) > 10)
  {
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "TownCenter");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 2);
  }
   rmAddTriggerEffect("Quest Var Modify"); rmSetTriggerEffectParam("QVName", questsComplete); 
   rmSetTriggerEffectParam("Oper", "+"); rmSetTriggerEffectParam("Value", "1");
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "XP"); rmSetTriggerEffectParamInt("Amount", 300);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\magic.mp3");
 }
   if(bonusUnitType == "Privateer") 
 {
   rmSwitchToTrigger(rmTriggerID("PrivateerSelected1")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", bonusUnitSelect);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "Privateer");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "Privateer");
   rmSetTriggerConditionParam("Op", "==");
   rmSetTriggerConditionParamInt("Count", 1);

   messageText = "There is one other privateer on the map. You must sink it and maybe find the " + wagonName + " to complete the Lost Units Quest.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("PrivateerDelay"));

   rmSwitchToTrigger(rmTriggerID("PrivateerSelected2")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", bonusUnitSelect);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("ProtoUnit", "Privateer");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);
   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "Privateer");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 1);
   messageText = "There are more privateers on the map. You must sink them and maybe find the " + wagonName + " to complete the Lost Units Quest.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("PrivateerDelay"));

   rmSwitchToTrigger(rmTriggerID("PrivateerDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 60);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("PrivateerSelected1"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("PrivateerSelected2"));
 }
   if(useBonusCratesFlag == true)
 {
   messageText = "The pirates have pillaged and hidden crates of " + crateName + " on the small islands. This is the last cache.";
   rmSwitchToTrigger(rmTriggerID("CrateMessage1")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", crateType);
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", crateType); rmSetTriggerConditionParam("Op", "<="); rmSetTriggerConditionParamInt("Count", crateCount);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\01 A\FightingClose.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("CrateMessage2"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("CrateMessageDelay"));

   messageText = "The pirates have pillaged and hidden crates of " + crateName + " on the small islands. There is more on other islands.";
   rmSwitchToTrigger(rmTriggerID("CrateMessage2")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", crateType);
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", crateType); rmSetTriggerConditionParam("Op", ">"); rmSetTriggerConditionParamInt("Count", crateCount);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\01 A\FightingClose.mp3");
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("CrateMessage1"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("CrateMessageDelay"));

   rmSwitchToTrigger(rmTriggerID("CrateMessageDelay")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 55);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("CrateMessage1"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("CrateMessage2"));
 }
// Eagle move 1.
   rmSwitchToTrigger(rmTriggerID("EagleMove1")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 5);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", eagleSelect);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(p1x)+",0,"+rmZFractionToMeters(p1z));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove2"));

// Eagle move 2.
   rmSwitchToTrigger(rmTriggerID("EagleMove2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", size/18);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", eagleSelect);
   if(useLoneWolfFlag == false) rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(e1x)+",0,"+rmZFractionToMeters(e1z));
   if(useLoneWolfFlag == true && players == 3) rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(p3x)+",0,"+rmZFractionToMeters(p3z));
   if(useLoneWolfFlag == true && players == 5) rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(p5x)+",0,"+rmZFractionToMeters(p5z));
   if(useLoneWolfFlag == true && players == 7) rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(p7x)+",0,"+rmZFractionToMeters(p7z));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove3"));

// Eagle move 3.
   rmSwitchToTrigger(rmTriggerID("EagleMove3")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", size/18);
   rmAddTriggerEffect("Move To Point");
   rmSetTriggerEffectParamInt("SrcObject", eagleSelect);
   rmSetTriggerEffectParam("DstPoint", rmXFractionToMeters(p1x)+",0,"+rmZFractionToMeters(p1z));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EagleMove2"));

// Livestock pen triggers
   rmSwitchToTrigger(rmTriggerID("LivestockPenMessage1")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", livestockPenSelect);
   messageText = "Quest livestock pen. Once you have brought your quest " + questHerdableType + " here, a new " 
   + questHerdableType + " will be spawned nearby every few minutes.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenDelay1"));

   rmSwitchToTrigger(rmTriggerID("LivestockPenDelay1")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenMessage1"));

   rmSwitchToTrigger(rmTriggerID("LivestockPenConvert")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Distance to Unit");
   rmSetTriggerConditionParamInt("SrcObject", herdableSelect);
   rmSetTriggerConditionParamInt("DstObject", livestockPenSelect);
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamFloat("Dist", 15.0);
   rmAddTriggerEffect("Convert");
   rmSetTriggerEffectParamInt("SrcObject", livestockPenSelect);
   rmSetTriggerEffectParamInt("PlayerID", 1);
   rmAddTriggerEffect("FakeCounter Set Text");
   messageText = "Quest Herdables: 1 of 5";
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenMessage1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenDelay1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdableMessage1"));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdableMessage2"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdableGenerate1"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenMessage2"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdableMessage3"));

   rmSwitchToTrigger(rmTriggerID("LivestockPenMessage2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", livestockPenSelect);
   messageText = "See the Herdables counter for the current status. There will only be one counter at a time.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("FakeCounter Set Text");
   messageText = "Quest Herdables: 1 of 5";
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");

   rmSwitchToTrigger(rmTriggerID("LivestockPenMessage3")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", livestockPenSelect);
   messageText = "See the Herdables counter for the current status. There will only be one counter at a time.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("FakeCounter Set Text");
   messageText = "Quest Herdables: 2 of 5";
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");

   rmSwitchToTrigger(rmTriggerID("LivestockPenMessage4")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", livestockPenSelect);
   messageText = "See the Herdables counter for the current status. There will only be one counter at a time.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("FakeCounter Set Text");
   messageText = "Quest Herdables: 3 of 5";
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");

   rmSwitchToTrigger(rmTriggerID("LivestockPenMessage5")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", livestockPenSelect);
   messageText = "See the Herdables counter for the current status. There will only be one counter at a time.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("FakeCounter Set Text");
   messageText = "Quest Herdables: 4 of 5";
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");

   rmSwitchToTrigger(rmTriggerID("LivestockPenMessage6")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", livestockPenSelect);
   messageText = "The Herdables Quest hsa been completed but the quest " + questHerdableType + "s will continue to spawn.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("FakeCounter Set Text");
   messageText = "Herdables Quest Complete.";
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenDelay2"));

   rmSwitchToTrigger(rmTriggerID("LivestockPenDelay2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenMessage6"));

   int herdableTime = rmRandInt(120,360);
   rmSwitchToTrigger(rmTriggerID("QuestHerdableGenerate1")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", herdableTime);
   rmAddTriggerEffect("Unit Create");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("ProtoName", questHerdableType);
   rmSetTriggerEffectParam("Location", (xsVectorGetX(livestockPenPosition)+8) + ",0," + (xsVectorGetZ(livestockPenPosition)+8));
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");
   rmAddTriggerEffect("FakeCounter Set Text");
   messageText = "Quest Herdables: 2 of 5";
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenMessage2"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdableGenerate2"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenMessage3"));

   rmSwitchToTrigger(rmTriggerID("QuestHerdableGenerate2")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", herdableTime);
   rmAddTriggerEffect("Unit Create");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("ProtoName", questHerdableType);
   rmSetTriggerEffectParam("Location", (xsVectorGetX(livestockPenPosition)+8) + ",0," + (xsVectorGetZ(livestockPenPosition)+8));
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");
   rmAddTriggerEffect("FakeCounter Set Text");
   messageText = "Quest Herdables: 3 of 5";
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenMessage3"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdableGenerate3"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenMessage4"));

   rmSwitchToTrigger(rmTriggerID("QuestHerdableGenerate3")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", herdableTime);
   rmAddTriggerEffect("Unit Create");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("ProtoName", questHerdableType);
   rmSetTriggerEffectParam("Location", (xsVectorGetX(livestockPenPosition)+8) + ",0," + (xsVectorGetZ(livestockPenPosition)+8));
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");
   rmAddTriggerEffect("FakeCounter Set Text");
   messageText = "Quest Herdables: 4 of 5";
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenMessage4"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdableGenerate4"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenMessage5"));

   rmSwitchToTrigger(rmTriggerID("QuestHerdableGenerate4")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", herdableTime);
   rmAddTriggerEffect("Unit Create");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("ProtoName", questHerdableType);
   rmSetTriggerEffectParam("Location", (xsVectorGetX(livestockPenPosition)+8) + ",0," + (xsVectorGetZ(livestockPenPosition)+8));
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");
   rmAddTriggerEffect("FakeCounter Set Text");
   messageText = "Herdables Quest Complete.";
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenMessage5"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdablesComplete"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("LivestockPenMessage6"));

   rmSwitchToTrigger(rmTriggerID("QuestHerdablesComplete")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   messageText = "The required " + questHerdableType;
   if(questHerdableType != "sheep") messageText = messageText + "s";
   messageText = messageText + " have been spawned and the Herdable Quest is complete. They will continue to spawn and you got 200 more XP.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\heykrios.mp3");
   rmAddTriggerEffect("Quest Var Modify"); rmSetTriggerEffectParam("QVName", questsComplete); 
   rmSetTriggerEffectParam("Oper", "+"); rmSetTriggerEffectParam("Value", "1");
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "XP"); rmSetTriggerEffectParamInt("Amount", 200);
   rmAddTriggerEffect("Unit Create");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("ProtoName", "Horse");
   rmSetTriggerEffectParam("Location", (rmXFractionToMeters(e1x)+10)+",0,"+(rmZFractionToMeters(e1z)+10));
   rmAddTriggerEffect("Disable Trigger"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("StartMessage"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestsDoneDelay"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdablesLoop"));

   rmSwitchToTrigger(rmTriggerID("QuestHerdablesLoop")); rmSetTriggerActive(false); rmSetTriggerLoop(true);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", herdableTime);
   rmAddTriggerEffect("Unit Create");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("ProtoName", questHerdableType);
   rmSetTriggerEffectParam("Location", (xsVectorGetX(livestockPenPosition)+5) + ",0," + (xsVectorGetZ(livestockPenPosition)+5));
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");

// Quest herdable triggers
   rmSwitchToTrigger(rmTriggerID("QuestHerdableMessage1")); rmSetTriggerActive(true); 
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", herdableSelect);
   messageText = "This is a quest " + questHerdableType + ". Don't lose or kill it yet. Take it to the quest livestock pen located on one of the small islands.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdableDelay1"));

   rmSwitchToTrigger(rmTriggerID("QuestHerdableDelay1")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 60);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdableMessage2"));

   rmSwitchToTrigger(rmTriggerID("QuestHerdableMessage2")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", herdableSelect);
   messageText = "This is a quest " + questHerdableType + ". Once it is sent to the quest livestock pen, a new " 
   + questHerdableType + " will be generated nearby every few minutes.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdableDelay1"));

   rmSwitchToTrigger(rmTriggerID("QuestHerdableMessage3")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", herdableSelect); 
   messageText = "This is a quest " + questHerdableType + ". Click on the quest livestock pen to get the Herdable Quest status.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\steps.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdableDelay2"));

   rmSwitchToTrigger(rmTriggerID("QuestHerdableDelay2")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdableMessage3"));

   messageText = "This horse is just a game place holder. Ignore it.";
   rmSwitchToTrigger(rmTriggerID("HorseMessage")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "Horse");
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text",messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  { rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\cinematics\02 A\Horse.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("HorseDelay"));

   rmSwitchToTrigger(rmTriggerID("HorseDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("HorseMessage"));

   rmSwitchToTrigger(rmTriggerID("DominateMap")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Player Resource Count"); 
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "wood");
   rmSetTriggerConditionParam("Op", ">=");
   rmSetTriggerConditionParamInt("Count", ossuaryAmount);
   rmAddTriggerCondition("Player Resource Count"); 
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "food");
   rmSetTriggerConditionParam("Op", ">=");
   rmSetTriggerConditionParamInt("Count", ossuaryAmount);
   rmAddTriggerCondition("Player Resource Count"); 
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "gold");
   rmSetTriggerConditionParam("Op", ">=");
   rmSetTriggerConditionParamInt("Count", ossuaryAmount);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EmpireComplete"));

   rmSwitchToTrigger(rmTriggerID("EmpireComplete")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 20);
   rmAddTriggerCondition("Player Resource Count"); 
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "wood");
   rmSetTriggerConditionParam("Op", ">=");
   rmSetTriggerConditionParamInt("Count", ossuaryAmount + incrementAmount);
   rmAddTriggerCondition("Player Resource Count"); 
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "food");
   rmSetTriggerConditionParam("Op", ">=");
   rmSetTriggerConditionParamInt("Count", ossuaryAmount + incrementAmount);
   rmAddTriggerCondition("Player Resource Count"); 
   rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParam("Resource", "gold");
   rmSetTriggerConditionParam("Op", ">=");
   rmSetTriggerConditionParamInt("Count", ossuaryAmount + incrementAmount);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("EmpireCompleteDelay"));

   messageText = "You have collected " + (ossuaryAmount + incrementAmount) + " of each resource. Now get " + (ossuaryAmount + 2*incrementAmount)
   + " each and you can win the game without firing another shot.";
   rmSwitchToTrigger(rmTriggerID("EmpireCompleteDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 20);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\boyz.mp3");
   rmAddTriggerEffect("Quest Var Modify"); rmSetTriggerEffectParam("QVName", questsComplete); 
   rmSetTriggerEffectParam("Oper", "+"); rmSetTriggerEffectParam("Value", "1");
   rmAddTriggerEffect("Grant Resources"); rmSetTriggerEffectParamInt("PlayerID", 1);
   rmSetTriggerEffectParam("ResName", "XP"); rmSetTriggerEffectParamInt("Amount", 500);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("WinDelay1"));
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestHerdablesLoop"));

   rmSwitchToTrigger(rmTriggerID("WinDelay1")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 20);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("Win"));

   rmSwitchToTrigger(rmTriggerID("AllQuestsComplete")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Quest Var Check"); rmSetTriggerConditionParam("QuestVar", questsComplete);
   rmSetTriggerConditionParam("Op", "=="); rmSetTriggerConditionParam("Value", "9");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("AllQuestsDelay"));

   messageText = "Well done! You have completed all the quests. Your people cheer. Now defeat your remaining enemies?";
   rmSwitchToTrigger(rmTriggerID("AllQuestsDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\crowd.mp3");

   for(i=0; <= 9)
 {
   messageText = "Remaining quests: " + (9-i);
   if(i == 0) messageText = "Click buffalo for quest info.";
   if(i == 9) messageText = "All quest are complete.";
   rmSwitchToTrigger(rmTriggerID("QuestsDone"+i));
   if(i == 0) rmSetTriggerActive(true);
   if(i != 0) rmSetTriggerActive(false);
   rmAddTriggerCondition("Quest Var Check"); rmSetTriggerConditionParam("QuestVar", questsComplete);
   rmSetTriggerConditionParam("Op", "==");
   if(i == 0) rmSetTriggerConditionParam("Value", "0");
   if(i == 1) rmSetTriggerConditionParam("Value", "1");
   if(i == 2) rmSetTriggerConditionParam("Value", "2");
   if(i == 3) rmSetTriggerConditionParam("Value", "3");
   if(i == 4) rmSetTriggerConditionParam("Value", "4");
   if(i == 5) rmSetTriggerConditionParam("Value", "5");
   if(i == 6) rmSetTriggerConditionParam("Value", "6");
   if(i == 7) rmSetTriggerConditionParam("Value", "7");
   if(i == 8) rmSetTriggerConditionParam("Value", "8");
   if(i == 9) rmSetTriggerConditionParam("Value", "9");
   rmAddTriggerEffect("FakeCounter Set Text");
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\shadesarrive.mp3");
 }
   rmSwitchToTrigger(rmTriggerID("QuestsDoneDelay")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 60);
   for(i=1; <= 9) { rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("QuestsDone"+i)); }

   messageText = "The " + nativeName5 + " are pleased that you built a trading post on their small island site and have given you a crate of " + siteCrateName + " near it.";
   rmSwitchToTrigger(rmTriggerID("TradingPostControl")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Player Controls Socket"); rmSetTriggerConditionParamInt("PlayerID", 1);
   rmSetTriggerConditionParamInt("Socket", nativeSocketSelect);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\mumble.mp3");
   rmAddTriggerEffect("Unit Create");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("ProtoName", siteCrateType);
   rmSetTriggerEffectParam("Location", (xsVectorGetX(nativeSocketPosition)+5) + ",0," + xsVectorGetZ(nativeSocketPosition));

// Small island trading post triggers
   rmSwitchToTrigger(rmTriggerID("TradingPostMessage")); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", nativeSocketSelect);
   messageText = "This is a small island native trading post site. Build here to gain this native civilization's alliance.";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\mumble.mp3");
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TradingPostDelay"));

   rmSwitchToTrigger(rmTriggerID("TradingPostDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TradingPostMessage"));

// Treasure item triggers

   if(rmGetNomadStart() == false && useNuggetBonusFlag == true)
 {
   rmSwitchToTrigger(rmTriggerID("TreasureItemMessage"+(nuggetTotal+1))); rmSetTriggerActive(true);
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", treasureItemSelect);
   messageText = "This is the treasure " + treasureItemName + ". If you don't know, click on it to see the status of the treasure hunt for your " + nuggetBoatName + ".";
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   messageText = "Treasures for " + nuggetBoatName + ": " + nuggetTotal;
   rmAddTriggerEffect("FakeCounter Set Text");
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\magic.mp3");
 
   for(i=0; <= nuggetTotal)
  {
   rmSwitchToTrigger(rmTriggerID("TreasureItemMessage"+i)); rmSetTriggerActive(false);
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", treasureItemSelect);
   if(i != nuggetTotal) messageText = "Treasures for " + nuggetBoatName + ": " + (nuggetTotal-i);
   if(i == nuggetTotal) messageText = "The " + nuggetBoatName + " has been delivered.";
   rmAddTriggerEffect("FakeCounter Set Text");
   rmSetTriggerEffectParam("Text", messageText);
   rmAddTriggerEffect("Sound Filename"); rmSetTriggerEffectParam("Sound", "\dogleg sounds\magic.mp3");
   if(i == nuggetTotal) { rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TreasureItemDelay")); }
  }
   rmSwitchToTrigger(rmTriggerID("TreasureItemDelay")); rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("TreasureItemMessage"+nuggetTotal));
 }
   rmSwitchToTrigger(rmTriggerID("FactoryWood")); rmSetTriggerActive(false); rmSetTriggerLoop(true);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 42);
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "CrateOfWood"); rmSetTriggerConditionParam("Op", "<"); rmSetTriggerConditionParamInt("Count", 12);
   rmAddTriggerEffect("Unit Create");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("ProtoName", "CrateOfWood");
   rmSetTriggerEffectParam("Location", xsVectorGetX(factoryPosition) + ",0," + (xsVectorGetZ(factoryPosition)+9));
   rmAddTriggerEffect("Unit Create");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("ProtoName", "CrateOfWood");
   rmSetTriggerEffectParam("Location", xsVectorGetX(factoryPosition) + ",0," + (xsVectorGetZ(factoryPosition)-9));
   rmAddTriggerEffect("Unit Create");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("ProtoName", "CrateOfWood");
   rmSetTriggerEffectParam("Location", (xsVectorGetX(factoryPosition)+9) + ",0," + xsVectorGetZ(factoryPosition));

   messageText = "After awhile, this factory will turn nearby trees, roots, seaweed, driftwood, etc into crates of wood and store them outside.";
   rmSwitchToTrigger(rmTriggerID("FactoryWoodMessage")); 
   rmAddTriggerCondition("Unit Selected");
   rmSetTriggerConditionParamInt("SrcObject", factorySelect);
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("FactoryWoodDelay"));

   rmSwitchToTrigger(rmTriggerID("FactoryWoodDelay")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("FactoryWoodMessage"));

   if(specialProp == "SPCXPMiningCampClone1")
 {
   rmSwitchToTrigger(rmTriggerID("CampCoin")); rmSetTriggerActive(true); rmSetTriggerLoop(true);
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 300);
   rmAddTriggerCondition("Player Unit Count"); rmSetTriggerConditionParamInt("PlayerID", 0);
   rmSetTriggerConditionParam("ProtoUnit", "CrateOfCoin"); rmSetTriggerConditionParam("Op", "<"); rmSetTriggerConditionParamInt("Count", 1);
   rmAddTriggerEffect("Unit Create");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("ProtoName", "CrateOfCoin");
   rmSetTriggerEffectParam("Location", (xsVectorGetX(specialPosition)-6) + ",0," + (xsVectorGetZ(specialPosition)-2));
   rmAddTriggerEffect("Unit Create");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("ProtoName", "CrateOfCoin");
   rmSetTriggerEffectParam("Location", (xsVectorGetX(specialPosition)-2) + ",0," + (xsVectorGetZ(specialPosition)-6));

   messageText = "The miners at this camp aren't very careful and regularly leave crates of coin laying around before they load the wagon.";
   rmSwitchToTrigger(rmTriggerID("CampCoinMessage")); 
   rmAddTriggerCondition("Unit Type Selected"); rmSetTriggerConditionParam("ProtoUnit", "SPCXPMiningCampClone1");
   if(displayMessageFlag == true) 
  {rmAddTriggerEffect("Message"); rmSetTriggerEffectParam("Text", messageText); rmSetTriggerEffectParamInt("Timeout", messageTime);
  }
   if(useSpoofChatFlag == true)
  {rmAddTriggerEffect("Send Spoofed Chat"); rmSetTriggerEffectParamInt("PlayerID", 0); rmSetTriggerEffectParam("Message",messageText);
  }
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("CampCoinDelay"));

   rmSwitchToTrigger(rmTriggerID("CampCoinDelay")); rmSetTriggerActive(false); 
   rmAddTriggerCondition("Timer"); rmSetTriggerConditionParamInt("Param1", 30);
   rmAddTriggerEffect("Fire Event"); rmSetTriggerEffectParamInt("EventID", rmTriggerID("CampCoinMessage"));
 }
 } //x  end of useFullMapFlag
 // "------- Maximum message length ---- copy this line and paste it near the line you are testing ---------------------------------"
 /* Finished */  rmSetStatusText("",0.99);
}  
